/*
 *  ar4Dummy.c: Dummy functions of AR4
 *
 * (C) Copyright:       YOSHIDA Atsushi, 1999
 *  
 */

#include <stdio.h>
#include <sys/param.h>

#define SAPID_AR4_KERNEL
#define USE_SPDSET1 /* may be temporally. */
#include <Sapid/Sapid.h>


#ifndef MAXPATHLEN
#ifdef PATH_MAX
#define MAXPATHLEN PATH_MAX
#else
#define MAXPATHLEN 1024
#endif
#endif  /* ifndef MAXPATHLEN */

char *AR4_DUMMY_lookupFileName(int objectId);

/*
 *  Note: This function supports only spdGetName(). objectId must be an id
 *        of source file, and attrName must be "name".
 */
SpdString spdGetAttrValString(int objectId, SpdString attrName)
{
    int		len;
    int		i;
    static char	name[MAXPATHLEN + 1];
    char	*p;

    if (strcmp(attrName, "name") != 0) {
	fprintf(stderr, "SML::ar4Dummy.c spdGetAttrValString(): "
		"unspported attribute: %s\n", attrName);
	exit(1);
    }

#ifdef DEBUG
    /* This function is never called?! */
    printf("spdGetAttrValString TEST :: call AR4_DUMMY::lookupFileName\n");
#endif
    p = AR4_DUMMY_lookupFileName(objectId);
#ifdef DEBUG
    printf("spdGetAttrValString TEST :: finish AR4_DUMMY::lookupFileName\n");
#endif
    if (p == NULL || strlen(p) > MAXPATHLEN) {
	fprintf(stderr, "SML::ar4Dummy.c spdGetAttrValString(): "
		"Too long path name.\n");
	exit(1);
    }
    strcpy(name, p);
#ifdef DEBUG
    printf("spdGetAttrValString TEST :: name = %s\n", name);
#endif
    return (SpdString)name;
}

/* Warning: This function is copied from AR4/getClassId.c */
SpdClassId spdGetClassId(SpdId objectId)
{
    SpdClassId  classId = SPD_GET_CID_FROM_OBJ_ID(objectId);

    return (spdIsValidClassOrRelationId(classId) ?
            classId : SPD_NON_CID);
}

SpdBoolean spdIsValidClassOrRelationId(SpdClassId classId)
{
    return (SPD_FIRST_CID <= classId && classId <= SPD_LAST_RID);
}


#if 0
SpdClassId spdGetClassId(SpdId objectId)
{
    SpdClassId  classId = SPD_GET_CID_FROM_OBJ_ID(objectId);

    return ((_SAPID_ALL_MODEL_FIRST_CLASS_ID <= classId &&
             classId <= _SAPID_ALL_MODEL_LAST_CLASS_ID) ?
            classId : SAPID_NON_CLASS_ID);
}

SpdClassId spdGetClassId(SpdId id)
{
    spdErrorExit("SML::spdGetClassId() have never implemented.\n"
		 "Contact to developers if you need.\n");

}
#endif
