/*
 *  smuDummy.c: Dummy functions of SMU
 *
 * (C) Copyright:       YOSHIDA Atsushi, 1999
 *  
 */

#define SAPID_AR4_KERNEL
#define USE_SPDSET1 /* may be temporally. */

#include <stdio.h>
#include <Sapid/Sapid.h>

/* for stat() */
#include <sys/types.h>
#include <sys/stat.h>

/*
 * ե̾ͿȳfileId֤
 *  ¸ߤʤSAPID_NON_ID֤
 *
 */

#if 0
static char	file_name[FILENAME_MAX + 1];
static int	file_name_idx;

char	smuDummyGetFileNameChar(void)
{
  return file_name[++file_name_idx];
}
#endif

SpdObjId smuGetFileIdByName(SpdConstString fileName)
{
#if 0
  strcpy(file_name, fileName);
  file_name_idx = -1;
  return smuDummyGetFileIdByName();  /* call back to SML routine. */
#else
  return SMU_DUMMY_smuDummyGetFileIdByName((void *)fileName);  /* call back to SML routine. */
#endif
}

SpdObjId spdConvIdPfileToFile(SpdObjId pfileId)
{
    return pfileId;  /* SML Ǥ p-model ѤƤʤ */
}

/************************************************************************/

/* 
 * Program:             $RCSfile: smuDummy.c,v $  $Revision: 1.2 $
 * 
 * Purpose:
 * 
 * Author:              H.Ohhashi  1999/03/08
 *                      S.Yamamoto  1999/03/08
 * 
 * (C) Copyright:       H.Ohhashi and S.Yamamoto  1999 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: smuDummy.c,v 1.2 2002/05/13 03:33:37 yoshida Exp $";
#endif

#include <stdio.h>
#include <sys/types.h>      /* For stat(). */
#include <sys/stat.h>       /* For stat(). */
#include <Sapid/Sapid.h>

static int spdReadFileInBufSub(SpdObjId file_id, char **buf);

/*
 * ֹfileIdǻꤵ줿եɤ߹ߤΤ˥ץ󤹤롥
 */

FILE *smuOpenSrcFile(SpdObjId fileId)
{
    FILE        *fp;
    char        fileName[FILENAME_MAX + 1];

#ifdef SPD_MY_FSEEK
    static int  is_first_call = TRUE;

    if (is_first_call) {
        int         i;

        is_first_call = FALSE;
        for (i = 0; i < FOPEN_MAX; i++) { 
            spdOpendFile[i].isOpened = FALSE;
        }
    }
#endif /* SPD_MY_FSEEK */

    switch (spdGetClassId(fileId)) {
      case SPD_CID_PFILE:
        fileId = spdConvIdPfileToFile(fileId);
	spdErrorExit("smuOpenSrcFile(): PFILE is Unsupported by SML.\n");
        break;
      case SPD_CID_FILE:
        break;
      default:
        spdErrorExit("smuOpenSrcFile(): %d: Invalid file Id.\n", fileId);
        break;
    }

    sprintf(fileName, "%s/%s/%d", spdGetSDBdir(), SAPID_SRC_DIR, fileId);
    fp = spdFopen(fileName, SPD_FOPEN_RT_MODE);

#ifdef SPD_MY_FSEEK
    spdOpendFile[fileno(fp)].isOpened = TRUE;
    spdOpendFile[fileno(fp)].fileId = fileId;
    DW_MY_FSEEK("SPD_MY_FSEEK: Open: %d: smuOpenSrcFile(%d).\n",
                fileno(fp), fileId);
#endif /* SPD_MY_FSEEK */

    return (fp);
}

/*    
 * ƥե뤫ݤȽꤹ롥
 * ѥ̾Ƭ'/'ξ˥ƥեȤߤʤ
 * Windowsξ'\\'θ롥
 */

SpdBoolean smuIsSystemFileName(SpdString file)
{
    if (file == NULL) {
        return (FALSE);
    }

#ifdef SPD_ON_WINDOWS_FS
    file = spdRemoveDriveName(file);
    return (file[0] == '/' || file[0] == '\\');
#else
    return (file[0] == '/');
#endif
}

/*
 * ƥե뤫ݤȽꤹ롥
 */

SpdBoolean smuIsSystemFile(SpdObjId pfileId)
{
    return (smuIsSystemFileName(spdGetName(pfileId)));
}

/*
 * ƥ줿֥ȤݤȽꤹ롥
 */

#ifdef SAPID_ORIGINAL
SpdBoolean smuIsSystemObject(SpdObjId objectId)
{
    SpdOcc      occ;
    SpdObjId    declId, blockId, pfileId;

    switch (spdGetClassId(objectId)) {
      case SPD_CID_PFILE:
      case SPD_CID_FILE:
        /* .i Υե⥷ƥΥ֥ȤȤ롥 */
        return (smuIsSystemFileName(spdGetName(objectId)) &&
                spdIsFileExtension(spdGetName(objectId), ".i"));
      case SPD_CID_PROGRAM:
        /* programϥƥΥ֥ȤǤϤʤ */ 
        return (FALSE);
      case SPD_CID_TYPE:
        /* int, doubleȤ߹ߤηϥƥΥ֥ȤȤ롥 */
        if (spdGetAttrValInt(objectId, "type") != TYPE_UNKNOWN) {
            return (TRUE);
        }
        /* declarationĴ٤롥 */ 
        declId = spdGetARelObj(objectId, "decl_type", "c-id");
        return (declId == SPD_NON_ID ? TRUE : smuIsSystemObject(declId));
      default:
        occ = spdGetAnOffsetOfObj(objectId);
        /* pblockdefine_optionΥޥϡƥΥ֥ȤȤ롥 */
        if (occ.objectId == SPD_NON_ID || occ.fileId == SPD_NON_ID) {
            return (TRUE);
        }
        blockId = spdGetABlockId(occ.fileId, occ.offset);
        if (blockId != SPD_NON_ID) {
            /* I-modelΥ饹 */
            pfileId = spdGetARelObj(blockId, "file_block", "c-id");
        } else {
            pfileId = occ.fileId;
        }
        return (smuIsSystemFile(pfileId));
    }
}
#endif

/******************************************************************************/

/* 
 * եĹ֤
 * UNIXξϡspdGetFileSize()֤ͤƱ
 * WindowsϡԶڤ"\r\n""\n"ѴĹ
 *
 * %% ʤС饹file°֤٤
 */

int spdGetFileLength(SpdObjId fileId)
{
    /* Temporarily. */
    return (spdGetFileSize(fileId));
}

/* 
 * ե礭(stat()֤st_sizeƱ)֤
 *
 * %% ʤС饹file°֤٤
 */

int spdGetFileSize(SpdObjId fileId)
{
    char            filePath[FILENAME_MAX + 1];
    struct stat     st;

    switch (spdGetClassId(fileId)) {
      case SPD_CID_PFILE:
        fileId = spdConvIdPfileToFile(fileId);
        break;
      case SPD_CID_FILE:
        break;
      default:
        spdErrorExit("spdGetFileSize(): %d: Invalid file Id.\n", fileId);
        break;
    }
    sprintf(filePath, "%s/%s/%d", spdGetSDBdir(), SAPID_SRC_DIR, fileId);
    if (stat(filePath, &st) != 0) {
        spdErrorExit("spdGetFileSize(): %d: Can't stat().\n", fileId);
    }
    return ((int)(st.st_size));
}

/******************************************************************************/

/*
 * եΥʬΥХåեݤƥեɤ߹ࡥ
 * ͤϡɤ߹ʸΥ('\0'ߥ͡ޤޤʤ)
 * 
 * fileIdˤС󡥺ϤȤ٤Ǥ롥fileId
 * ".c" (file饹뤤pfile饹)μֹǤ.
 */

int spdReadFileInBuf(SpdObjId fileId, char **buf)
{
    return (spdReadFileInBufSub(spdConvIdPfileToFile(fileId), buf));
}

/*
 * եΥʬΥХåեݤƥեɤ߹ࡥ
 * ͤɤ߹ʸΥ('\0'ߥ͡ޤޤʤ)
 */

int spdReadFileInBufByName(char *fname, char **buf)
{
    return (spdReadFileInBufSub(smuGetFileIdByName(fname), buf));
}

static int spdReadFileInBufSub(SpdObjId fileId, char **buf)
{
    int             s;
    FILE            *fp;

    s = spdGetFileLength(fileId);
    *buf = spdMalloc(s + 1);
    fp = smuOpenSrcFile(fileId);

#ifdef SPD_ON_WINDOWS_FS
    /* Note, fread() works in text mode in Win32Architecture,
       so we don't check return value of fread(). */
    s = spdFreadChar(*buf, s, fp);
#else   
    if (spdFreadChar(*buf, s, fp) != s) {
        spdErrorExit("spdReadFileInBufSub(): %d: Can't read file.\n", fileId);
    }
#endif

    spdFclose(fp);
    return (s);
}


