/* 
 * Program:             $RCSfile: AR3Sub.h,v $  $Revision: 30.22 $
 * 
 * Purpose:             Access routines ver. 3.
 * 
 * Author:              K.Hayashi  1995/02/20
 * Modified:            S.Yamamoto  1995/02/24
 * 
 * (C) Copyright:       K.Hayashi and S.Yamamoto  1995 - 2003
 *                      This file is a product of the project Sapid.
 */

#if !defined(_AR3SUB_H) && defined(SAPID_AR3_KERNEL)
#define _AR3SUB_H

/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/

/*
 *                      Macros (added by S.Yamamoto 2003/04/07).
 */

#define IVAL_NUM            SPD_MAX(SpdObjIValN, SpdRelIValN)
#define SVAL_NUM            SPD_MAX(SpdObjSValN, SpdRelSValN)
#define SPD_ISVAL_NUM       (IVAL_NUM + SVAL_NUM)
#define SVAL(x)             (IVAL_NUM + (x))

#define SPD_IS_IVAL(x)      ((0 <= (x)) && ((x) < IVAL_NUM))
#define SPD_IS_SVAL(x)      ((SVAL(0) <= (x)) && ((x) < SVAL(SVAL_NUM)))

/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/

/*
 * Number of cache entries for string attributes.
 */

#define SPD_AR_CACHE_SIZE   20
/* #define SPD_AR_CACHE_SIZE   (SPD_MAX(SpdObjSValN, SpdRelSValN) + 1) */

/*
 * SDB accsess routiones.
 */

#define SPD_AID_OBJ_ID      0
#define SPD_AID_REL_ID      0
#define SPD_AID_REL_P_ID    1
#define SPD_AID_REL_C_ID    2
#define SPD_AID_REL_OFFSET  3

/* 
 * Commented by R.Miura 1998/08/14.
 * class_table[]typ (¤classId)
 * ϡidγդ
 *     classId * SPD_ID_SPACE + 0, 1,...
 * ȤȤˤäơidclassIdλФγ任ǲǽˤʤäᡥ
 * 
 * #define Obj_typ    ivalue[1]
 * #define Rel_typ    ivalue[1]
 */

/* 
 * Commented by S.Yamamoto 1998/08/20.
 *
 * #define Obj_length ivalue[1]
 */

#define Obj_id     ivalue[SPD_AID_OBJ_ID]

/* 
 * Commented by R.Miura 1998/08/14.
 * svalue[0]name°ǤȤ򳰤
 * 
 * #define Obj_name   svalue[0]
 */

#define Rel_id     ivalue[SPD_AID_REL_ID]
#define Rel_p_id   ivalue[SPD_AID_REL_P_ID]
#define Rel_c_id   ivalue[SPD_AID_REL_C_ID]
#define Rel_offset ivalue[SPD_AID_REL_OFFSET]

/* Macro name DEFAULT_DB_NUM is better. */
#define DEFAULT_DB_SIZE     (4 * 1024)

#define SAPID_SDB_OBJ_NUM   DEFAULT_DB_SIZE
#define SAPID_SDB_OBJ_INC   DEFAULT_DB_SIZE
#define SAPID_SDB_LINK_NUM  DEFAULT_DB_SIZE
#define SAPID_SDB_LINK_INC  DEFAULT_DB_SIZE

/******************************************************************************/

/*
 * TYP for AR4.
 */

#define C_TYP_OBJ       1
#define C_TYP_REL       2
#define C_TYP_CMP       4

#define C_TYP_OC        (C_TYP_OBJ | C_TYP_CMP)
#define C_TYP_O_        (C_TYP_OBJ)

#define C_TYP_RC        (C_TYP_REL | C_TYP_CMP)
#define C_TYP_R_        (C_TYP_REL)

/******************************************************************************/

#define C_ANY           99

/******************************************************************************/

/*
 * TYP for AR5.
 */

/* TYP for object. */

/* ֥ȤǤ롥 */
#define SAPIDDB_SORT_OBJ                (1 << 0)

/* 
 * ڹ¤ΥΡɤǤ롥롼ȤϢéäȤ1̤ˤéʤ
 */
#define SAPIDDB_SORT_OBJ_TREENODE       ((1 << 2) | SAPIDDB_SORT_OBJ)

/* ƥɽ(offsetlength) */
#define SAPIDDB_SORT_OBJ_TEXT           ((1 << 3) | SAPIDDB_SORT_OBJ)

/* TYP for relationship. */

/* ϢǤ롥 */
#define SAPIDDB_SORT_REL                (1 << 1)

/* طǤ롥Ƥ1ĤǻҤʣ(ڹ¤)*/
#define SAPIDDB_SORT_REL_COMPOSITE      ((1 << 2) | SAPIDDB_SORT_REL)

/* ȴطǤ롥ƤʣФƻҤ1ġ */
#define SAPIDDB_SORT_REL_REFERENCE      ((1 << 3) | SAPIDDB_SORT_REL)

/* бطǤ롥ƤȻҤ11Ǥ롥 */
#define SAPIDDB_SORT_REL_ONE_TO_ONE     ((1 << 4) | SAPIDDB_SORT_REL)

/******************************************************************************/

/* 
 * Macro value, macro name, and readable string.
 * Addeb by S.Yamamoto 2001/03/22.
 */

typedef struct {
    int             value;      /* Macro vaule. */
    SpdConstString  name;       /* Macro name. */
    SpdConstString  str;        /* Readable string (if exist). */

#if defined(SAPID_AR5)
    int             nhash;
    int             shash;
#endif
} SpdValName;

#define SPD_VAL_NAME2(v)        (v), (# v)
#define SPD_VAL_NAME3(v, s)     (v), (# v), (s)

/******************************************************************************/

void spdInitDbInfo(void);
void spdOpenDbInfo(void);
void spdCloseDbInfo(void);

int spdGetDbInfoNumOfObjs(SpdClassId classId);

int spdGetDbInfoMaxId(SpdClassId classId);
void spdSetDbInfoMaxId(SpdClassId classId, SpdObjId id);

int spdGetDbInfoTmpMaxId(SpdClassId classId);
void spdSetDbInfoTmpMaxId(SpdClassId classId, SpdObjId id);

void spdDumpDbInfo(void);

#endif /* !defined(_AR3SUB_H) && defined(SAPID_AR3_KERNEL) */
