/* 
 * Program:             $RCSfile: SapidModelId.h,v $  $Revision: 30.27 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  1999/10/26
 * 
 * (C) Copyright:       S.Yamamoto  1999 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SapidModelId.h,v 30.27 2003/02/20 15:13:01 yamamoto Exp yamamoto $
 */ 

#if !defined(_SAPID_MODEL_ID_H)
#define _SAPID_MODEL_ID_H

#define SPD_FIRST_MID               0

#define SPD_MID_I_MODEL             (SPD_FIRST_MID + 0)     /* Don't change. */
#define SPD_MID_P_MODEL             (SPD_FIRST_MID + 1)     /* Don't change. */
#define SPD_MID_AREA_MODEL          (SPD_FIRST_MID + 2)
#define SPD_MID_B_MODEL             (SPD_FIRST_MID + 3)
#define SPD_MID_D_MODEL             (SPD_FIRST_MID + 4)
#define SPD_MID_SDA_MODEL           (SPD_FIRST_MID + 5)
#define SPD_MID_STMT_MODEL          (SPD_FIRST_MID + 6)
#define SPD_MID_SDA_AREA_MODEL      (SPD_FIRST_MID + 7)
#define SPD_MID_TYPE_VIEW           (SPD_FIRST_MID + 8)
#define SPD_MID_COMMENT_VIEW        (SPD_FIRST_MID + 9)
#define SPD_MID_FLOW_VIEW           (SPD_FIRST_MID + 10)
#define SPD_MID_FCD_VIEW            (SPD_FIRST_MID + 11)
#define SPD_MID_J_MODEL             (SPD_FIRST_MID + 12)

#define SPD_LAST_MID                SPD_MID_J_MODEL

#define SPD_MID_NUM                 (SPD_LAST_MID - SPD_FIRST_MID + 1)

#define SPD_IS_VALID_MID(x) \
        ((SPD_FIRST_MID <= (x)) && ((x) <= SPD_LAST_MID))

/******************************************************************************/

#define SPD_FIRST_CID_I_MODEL       0
#define SPD_LAST_CID_I_MODEL        (SPD_FIRST_CID_I_MODEL + 12)
#define SPD_FIRST_RID_I_MODEL       (SPD_LAST_CID_I_MODEL + 1)
#define SPD_LAST_RID_I_MODEL        (SPD_FIRST_RID_I_MODEL + 30)

#define SPD_FIRST_CID_P_MODEL       (SPD_LAST_RID_I_MODEL + 1)
#define SPD_LAST_CID_P_MODEL        (SPD_FIRST_CID_P_MODEL + 10)
#define SPD_FIRST_RID_P_MODEL       (SPD_LAST_CID_P_MODEL + 1)
#define SPD_LAST_RID_P_MODEL        (SPD_FIRST_RID_P_MODEL + 16)

#define SPD_FIRST_CID_AREA_MODEL    (SPD_LAST_RID_P_MODEL + 1)
#define SPD_LAST_CID_AREA_MODEL     (SPD_FIRST_CID_AREA_MODEL + 2)
#define SPD_FIRST_RID_AREA_MODEL    (SPD_LAST_CID_AREA_MODEL + 1)
#define SPD_LAST_RID_AREA_MODEL     (SPD_FIRST_RID_AREA_MODEL + 14)

#define SPD_FIRST_CID_B_MODEL       (SPD_LAST_RID_AREA_MODEL + 1)
#define SPD_LAST_CID_B_MODEL        (SPD_FIRST_CID_B_MODEL + 1)
#define SPD_FIRST_RID_B_MODEL       (SPD_LAST_CID_B_MODEL + 1)
#define SPD_LAST_RID_B_MODEL        (SPD_FIRST_RID_B_MODEL + 13)

#define SPD_FIRST_CID_D_MODEL       (SPD_LAST_RID_B_MODEL + 1)
#define SPD_LAST_CID_D_MODEL        (SPD_FIRST_CID_D_MODEL + 6)
#define SPD_FIRST_RID_D_MODEL       (SPD_LAST_CID_D_MODEL + 1)
#define SPD_LAST_RID_D_MODEL        (SPD_FIRST_RID_D_MODEL + 12)

#define SPD_FIRST_CID_SDA_MODEL     (SPD_LAST_RID_D_MODEL + 1)
#define SPD_LAST_CID_SDA_MODEL      (SPD_FIRST_CID_SDA_MODEL + 1)
#define SPD_FIRST_RID_SDA_MODEL     (SPD_LAST_CID_SDA_MODEL+1)
#define SPD_LAST_RID_SDA_MODEL      (SPD_FIRST_RID_SDA_MODEL + 5)

#define SPD_FIRST_CID_STMT_MODEL    (SPD_LAST_RID_SDA_MODEL + 1)
#define SPD_LAST_CID_STMT_MODEL     (SPD_FIRST_CID_STMT_MODEL + 0)
#define SPD_FIRST_RID_STMT_MODEL    (SPD_LAST_CID_STMT_MODEL + 1)
#define SPD_LAST_RID_STMT_MODEL     (SPD_FIRST_RID_STMT_MODEL + 10)

#define SPD_FIRST_CID_SA_MODEL      (SPD_LAST_RID_STMT_MODEL + 1)
#define SPD_LAST_CID_SA_MODEL       (SPD_FIRST_CID_SA_MODEL + 0)
#define SPD_FIRST_RID_SA_MODEL      (SPD_LAST_CID_SA_MODEL +1)
#define SPD_LAST_RID_SA_MODEL       (SPD_FIRST_RID_SA_MODEL + 2)

#define SPD_FIRST_CID_TYPE_VIEW     (SPD_LAST_RID_SA_MODEL + 1)
#define SPD_LAST_CID_TYPE_VIEW      (SPD_FIRST_CID_TYPE_VIEW + 1)
#define SPD_FIRST_RID_TYPE_VIEW     (SPD_LAST_CID_TYPE_VIEW + 1)
#define SPD_LAST_RID_TYPE_VIEW      (SPD_FIRST_RID_TYPE_VIEW + 5)

#define SPD_FIRST_CID_COMMENT_VIEW  (SPD_LAST_RID_TYPE_VIEW + 1)
#define SPD_LAST_CID_COMMENT_VIEW   (SPD_FIRST_CID_COMMENT_VIEW + 1)
#define SPD_FIRST_RID_COMMENT_VIEW  (SPD_LAST_CID_COMMENT_VIEW + 1)
#define SPD_LAST_RID_COMMENT_VIEW   (SPD_FIRST_RID_COMMENT_VIEW + 7)

#define SPD_FIRST_CID_FLOW_VIEW     (SPD_LAST_RID_COMMENT_VIEW + 1)
#define SPD_LAST_CID_FLOW_VIEW      (SPD_FIRST_CID_FLOW_VIEW + 7)
#define SPD_FIRST_RID_FLOW_VIEW     (SPD_LAST_CID_FLOW_VIEW + 1)
#define SPD_LAST_RID_FLOW_VIEW      (SPD_FIRST_RID_FLOW_VIEW + 3)

#define SPD_FIRST_CID_FCD_VIEW      (SPD_LAST_RID_FLOW_VIEW + 1)
#define SPD_LAST_CID_FCD_VIEW       (SPD_FIRST_CID_FCD_VIEW + 0)
#define SPD_FIRST_RID_FCD_VIEW      (SPD_LAST_CID_FCD_VIEW + 1)
#define SPD_LAST_RID_FCD_VIEW       (SPD_FIRST_RID_FCD_VIEW + 7)

#define SPD_FIRST_CID_J_MODEL       (SPD_LAST_RID_FCD_VIEW + 1)
#define SPD_LAST_CID_J_MODEL        (SPD_FIRST_CID_J_MODEL + 16)
#define SPD_FIRST_RID_J_MODEL       (SPD_LAST_CID_J_MODEL + 1)
#define SPD_LAST_RID_J_MODEL        (SPD_FIRST_RID_J_MODEL + 51)

/******************************************************************************/

#define SPD_FIRST_CID               SPD_FIRST_CID_I_MODEL
#define SPD_LAST_RID                SPD_LAST_RID_J_MODEL

#define SPD_CRID_NUM_ALL            (SPD_LAST_RID - SPD_FIRST_CID + 1)

/******************************************************************************/

/* Temporarily added by S.Yamamoto 2001/10/07. */
#define SPD_FIRST_CID_IP_MODEL      SPD_FIRST_CID_I_MODEL
#define SPD_LAST_RID_IP_MODEL       SPD_LAST_RID_P_MODEL

#endif /* !defined(_SAPID_MODEL_ID_H) */
