/* 
 * Program:             $RCSfile: AR4_schema.c,v $  $Revision: 31.3 $
 * 
 * Purpose:             
 * 
 * Author:              S.Yamamoto  2000/04/06
 * 
 * (C) Copyright:       S.Yamamoto  2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: AR4_schema.c,v 31.3 2000/05/08 08:49:34 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

/* °μֹ椫°̾롥 */

SpdConstString spdGetAttrName(SpdClassId classId, SpdAttrId attrId)
{
    if (!spdIsValidClassOrRelationId(classId)) {
        spdErrorExit("spdGetAttrName(): %d: Invalid class id.\n");
    }

    if (SPD_IS_IVAL(attrId)) {
        return (class_table[classId].iattr[attrId]);
    } else if (SPD_IS_SVAL(attrId)) {
        return (class_table[classId].sattr[attrId - IVAL_NUM]);
    } else {
        return (NULL);
    }
}

/* ꥯ饹°ο롥 */

int spdGetNumOfAttrs(SpdClassId classId)
{
    if (!spdIsValidClassOrRelationId(classId)) {
        spdErrorExit("spdGetNumOfAttrs(): %d: Invalid class id.\n");
    }

    return (class_table[classId].max_iattr + 1 +
            class_table[classId].max_sattr + 1);
}

/* ꤵ줿饹°ο롥 */

int spdGetNumOfIntAttrs(SpdClassId classId)
{
    if (!spdIsValidClassOrRelationId(classId)) {
        spdErrorExit("spdGetNumOfIntAttrs(): %d: Invalid class id.\n");
    }

    return (class_table[classId].max_iattr + 1);
}

/* ꤵ줿饹ʸ°ο롥 */

int spdGetNumOfStrAttrs(SpdClassId classId)
{
    if (!spdIsValidClassOrRelationId(classId)) {
        spdErrorExit("spdGetNumOfStrAttrs(): %d: Invalid class id.\n");
    }

    return (class_table[classId].max_sattr + 1);
}

/******************************************************************************/

/*
 * "SpdAttrId spdGet{First,Last}AttrId{Int,Str}(SpdClassId classId);"
 */

/* ꤵ줿饹ˤ롤°κǾμֹ롥 */

SpdAttrId spdGetFirstAttrIdInt(SpdClassId classId)
{
    if (!spdIsValidClassOrRelationId(classId)) {
        spdErrorExit("spdGetFirstAttrIdInt(): %d: Invalid class id.\n");
    }

    return (0);
}

/* ꤵ줿饹ˤ롤°κμֹ롥 */

SpdAttrId spdGetLastAttrIdInt(SpdClassId classId)
{
    if (!spdIsValidClassOrRelationId(classId)) {
        spdErrorExit("spdGetLastAttrIdInt(): %d: Invalid class id.\n");
    }

    return (class_table[classId].max_iattr);
}

/* ꤵ줿饹ˤ롤ʸ°κǾμֹ롥 */

SpdAttrId spdGetFirstAttrIdStr(SpdClassId classId)
{
    if (!spdIsValidClassOrRelationId(classId)) {
        spdErrorExit("spdGetFirstAttrIdStr(): %d: Invalid class id.\n");
    }

    return (SVAL(0));
}

/* ꤵ줿饹ˤ롤ʸ°κμֹ롥 */

SpdAttrId spdGetLastAttrIdStr(SpdClassId classId)
{
    if (!spdIsValidClassOrRelationId(classId)) {
        spdErrorExit("spdGetLastAttrIdStr(): %d: Invalid class id.\n");
    }

    return (SVAL(class_table[classId].max_sattr));
}
