/* 
 * Program:             $RCSfile: getClassId.c,v $  $Revision: 30.12 $
 * 
 * Purpose:             
 * 
 * Author:              K.Hayashi  1995/02/20
 *                      S.Yamamoto  1995/03/05
 * 
 * (C) Copyright:       K.Hayashi and S.Yamamoto  1995 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: getClassId.c,v 30.12 2002/11/03 07:48:39 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

SpdClassId spdGetClassId(SpdId objectId)
{
    SpdClassId  classId = SPD_GET_CID_FROM_OBJ_ID(objectId);

    return (spdIsValidClassOrRelationId(classId) ?
            classId : SPD_NON_CID);
}

SpdString spdGetClassName(SpdId objectId)
{
    return (spdGetClassNameById(spdGetClassId(objectId)));
}

/******************************************************************************/

SpdBoolean spdIsValidClassOrRelationId(SpdClassId classId)
{
    return (SPD_FIRST_CID <= classId && classId <= SPD_LAST_RID);
}

SpdBoolean spdIsValidClassId(SpdClassId classId)
{
    return (spdIsValidClassOrRelationId(classId) && SPD_IS_CLS_ID(classId));
}

SpdBoolean spdIsValidRelationId(SpdClassId relId)
{
    return (spdIsValidClassOrRelationId(relId) && SPD_IS_REL_ID(relId));
}

/******************************************************************************/

SpdString spdGetClassNameById(SpdClassId classId)
{
    return (spdIsValidClassOrRelationId(classId) ? 
            class_table[classId].name : NULL);
}
