/* 
 * Program:             $RCSfile: numOfElem.c,v $  $Revision: 40.7 $
 * 
 * Purpose:             
 * 
 * Author:              S.Yamamoto  2001/11/24
 * 
 * (C) Copyright:       S.Yamamoto  2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: numOfElem.c,v 40.7 2003/07/08 05:46:41 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

typedef struct {
    /* 
     * SpdInfo˵ϿƤ롤֥Ȥμֹκ͡
     */
    SpdId       maxId;

    /* 
     * ֥Ȥμֹκ͡ޤcommitƤʤʤ
     * SDB˽񤭹ޤƤʤ֥ȤޤޤƤ롥
     */
    SpdId       tmpMaxId;

    /* 
     * SpdInfo˵ϿƤ륪֥ȤθĿ
     */
    int         num;
} SpdDbInfo;

static SpdDbInfo spdDbInfo[SPD_CRID_NUM_ALL];

void spdInitDbInfo(void)
{
    SpdClassId  cid;

    for (cid = SPD_FIRST_CID; cid <= SPD_LAST_RID; cid++) {
        spdDbInfo[cid].maxId = SPD_NON_ID;
        spdDbInfo[cid].tmpMaxId = SPD_NON_ID;
        spdDbInfo[cid].num = 0;
    }
}

void spdOpenDbInfo(void)
{
    SpdClassId  cid;
    SpdInfo     *info;

    info = spdOpenSDBinfo();
    for (cid = SPD_FIRST_CID; cid <= SPD_LAST_RID; cid++) {
        spdDbInfo[cid].num = spdGetInfoInt(info, spdGetClassNameById(cid), 0);
    }
    spdCloseInfo(info);
}

void spdCloseDbInfo(void)
{
    SpdClassId  cid;

    for (cid = SPD_FIRST_CID; cid <= SPD_LAST_RID; cid++) {
        spdDbInfo[cid].maxId = SPD_NON_ID;
        spdDbInfo[cid].tmpMaxId = SPD_NON_ID;
        spdDbInfo[cid].num = 0;
    }
}

/******************************************************************************/

int spdGetDbInfoNumOfObjs(SpdClassId classId)
{
    return (spdIsValidClassOrRelationId(classId) ?
            spdDbInfo[classId].num : -1);
}

int spdGetDbInfoMaxId(SpdClassId classId)
{
    return (spdIsValidClassOrRelationId(classId) ?
            spdDbInfo[classId].maxId : SPD_NON_ID);
}

void spdSetDbInfoMaxId(SpdClassId classId, SpdObjId id)
{
    if (spdDbInfo[classId].maxId == SPD_NON_ID ||
        spdDbInfo[classId].maxId < id) {
        spdDbInfo[classId].maxId = id;
    }
}

int spdGetDbInfoTmpMaxId(SpdClassId classId)
{
    return (spdIsValidClassOrRelationId(classId) ?
            spdDbInfo[classId].tmpMaxId : SPD_NON_ID);
}

void spdSetDbInfoTmpMaxId(SpdClassId classId, SpdObjId id)
{
    if (spdDbInfo[classId].tmpMaxId == SPD_NON_ID ||
        spdDbInfo[classId].tmpMaxId < id) {
        spdDbInfo[classId].tmpMaxId = id;
    }
}

/******************************************************************************/

void spdDumpDbInfo(void)
{
    SpdClassId      cid;
    SpdConstString  className;

    for (cid = SPD_FIRST_CID; cid <= SPD_LAST_RID; cid++) {
        className = spdGetClassNameById(cid);
        fprintf(stderr, "%d, %s: ", cid, (className != NULL ? className : "?"));
        fprintf(stderr, "maxId %d, ", spdDbInfo[cid].maxId);
        fprintf(stderr, "tmpMaxId %d, ", spdDbInfo[cid].tmpMaxId);
        fprintf(stderr, "num %d", spdDbInfo[cid].num);
        fprintf(stderr, ".\n");
    }
}
