/* 
 * Program:             $RCSfile: spdGetClassIdByName.c,v $  $Revision: 30.8 $
 * 
 * Purpose:             
 * 
 * Author:              M.Hakamata  1998/07/15
 *                      S.Yamamoto  1998/07/21
 * 
 * (C) Copyright:       M.Hakamata and S.Yamamoto  1998
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdGetClassIdByName.c,v 30.8 2003/07/06 10:09:29 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

#ifndef SAPID_FAST_spdGetClassIdByName

int spdGetClassIdByName(SpdConstString className)
{
    int i;
    
    for (i = 0; class_table[i].typ; i++) {
        if (SPD_STREQ(className, class_table[i].name))
            return (i);
    }
    return (-1);
}

#else /* SAPID_FAST_spdGetClassIdByName */

#include <Sapid/spdSet2.h>

static SpdSet2  set = NULL;

static void freeSet(void);
static void initializeSet(void);

/*
 * ơ֥롥
 */

static void freeSet(void)
{
    spdFreeSet2(set);
}

/*
 * class nameclass idؤΥơ֥롥
 */

static void initializeSet(void)
{
    int i;
  
    set = spdCreateSet2(SPDSET_STRING_KEY, SPDSET_OBJID_VALUE);
    for (i = 0; class_table[i].name != NULL; i++) {
        spdAddElemSO(set, class_table[i].name, i);
    }

    atexit(freeSet);
}

/*
 * class nameclass idؤѴԤ
 * ¸ߤʤclass nameꤷȤSPD_NON_ID֤
 */

SpdClassId spdGetClassIdByName(SpdConstString className)
{
    SpdElem     *elem;
  
    if (set == NULL) {
        initializeSet();
    }

    elem = spdSearchElemS(set, className);
    return ((elem == NULL) ? SPD_NON_CID : spdSetGetValueO(elem->value));
}

#endif /* SAPID_FAST_spdGetClassIdByName */
