/* 
 * Program:             $RCSfile: regindex.c,v $  $Revision: 30.6 $
 * 
 * Purpose:             桼롼
 *                      offset/length ˤ륤ǥåؿ
 * 
 * Author:              T.Hidaka  1998/11/13
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: regindex.c,v 30.6 2003/07/08 05:46:44 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

/* offset ӤƥȤ롥 */

static int sortRegIndex(const void *r1, const void *r2)
{
    SpdRegionIndexNode *reg1, *reg2;
    
    reg1 = (SpdRegionIndexNode *)r1;
    reg2 = (SpdRegionIndexNode *)r2;
    
    return reg1->offset - reg2->offset;
}

SpdRegionIndex spddb_createRegionIndex(SpdObjId parentId, 
                                       SpdClassId relClassId)
{
    SpdRegionIndex regIndex;
    SpdSet2 rels;
    SpdRel *relp;
    SetCursor csr;
    int i = 0;

    rels = spdGetChildRelSet(parentId, relClassId);

    regIndex.size = rels->elemNum;
    regIndex.nodes = spdMalloc(sizeof(SpdRegionIndexNode) * regIndex.size);
    regIndex.parentId = parentId;

   for (csr = spdSetCursorCreate(rels); spdSetCursorNext(&csr);) {
        relp = (SpdRel *)spdSetGetValueP(csr.curElem->value);
        regIndex.nodes[i].relationId = relp->relationId;
        regIndex.nodes[i].offset = spdGetOffset(relp->relationId);
        regIndex.nodes[i].length = spdGetLength(relp->objectId);
        i++;
    }
    spdFreeSet2(rels);

    SPD_QSORT(regIndex.nodes, regIndex.size, sizeof(SpdRegionIndexNode),
                sortRegIndex);

    return regIndex;
}

static int findRegIndexOffset(void *o, void *n)
{
    int offset;
    SpdRegionIndexNode *node;

    offset = *(int *)o;
    node = (SpdRegionIndexNode *)n;
    
    if (offset < node->offset)
        return -1;
    else if (offset < node->offset + node->length)
        return 0;
    else
        return 1;
}

SpdRegionIndexNode *spddb_searchRegionIndex(SpdRegionIndex *regIndex,
                                            int offset)
{
    return SPD_BSEARCH(&offset, regIndex->nodes, regIndex->size,
                         sizeof(SpdRegionIndexNode), findRegIndexOffset);
}

void spddb_freeRegionIndex(SpdRegionIndex *regIndex)
{
    spdFree(regIndex->nodes);
    regIndex->size = 0;
    regIndex->parentId = SPD_NON_ID;
}
