/* 
 * Program:             $RCSfile: scheme.c,v $  $Revision: 30.30 $
 * 
 * Purpose:             ǥϿ, ޥ
 *                      
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: scheme.c,v 30.30 2003/08/16 10:32:56 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

/* ǥID->SpdDBModel Υǥå */
static int nModels = 0;
static SpdDBModel **models = NULL;

/* 饹ID->SpdDBClass Υǥå */
static SpdSet2 classes = NULL;  /* νϽλޤǤ free Ƥʤ */

static SpdDBModel *spddb_GetDBModelById(SpdModelId modelId);
static SpdDBClass *spddb_GetDBClassById(SpdClassId classId);

/* 饹ID -> SpdDBClass Υǥåɲ */

static void addClassIndex(SpdDBClass *cl)
{
    if (classes == NULL) {
        classes = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_POINTER_VALUE);
        classes->valueFree = NULL;  /* no need to free value elements */
        classes->valueCopy = NULL;  /* shares value elements. */
    }

    spdAddElemOP(classes, cl->id, cl);
}

/* °ǡ */

static void adjustAttrData(SpdDBAttr *attr)
{
    int i;
    int max = 0;
    
    attr->hash = spdDBCalcHash(attr->name);
    
    if (attr->type == SPD_DBT_ENUM && attr->enums) {
        for (i = 0; attr->enums[i].name; i++) {
            attr->enums[i].nhash = spdDBCalcHash(attr->enums[i].name);
            attr->enums[i].shash = spdDBCalcHash(attr->enums[i].str);
            if (max < attr->enums[i].value) {
                max = attr->enums[i].value;
            }
        }

        attr->bitwidth = 0;
        while (max) {
            max >>= 1;
            ++attr->bitwidth;
        }
    } else {
        attr->bitwidth = 0;
    }
}

/* 饹ǡ */

static void adjustClassData(SpdDBClass *cls)
{
    SpdDBAttr *attr;
    int nvalues;                            /* ° */
    int iattrno;                            /* ӥåȥեɤǵͤ°ֹ */
    int usedbit;                            /* ӥåȿ */
                
    cls->hash = spdDBCalcHash(cls->name);

    nvalues = usedbit = 0;
    iattrno = -1;
    /* name  NULL Ǥ褦°иޤ */
    for (cls->nAttrs = 0;
         cls->nAttrs < SPD_ISVAL_NUM && (cls->attrs[cls->nAttrs]).name != NULL;
         cls->nAttrs++) {
        attr = &(cls->attrs[cls->nAttrs]);
        adjustAttrData(attr);

        /* seq ưŪ */
        switch(attr->type) {
          case SPD_DBT_STR:
          case SPD_DBT_OID:
            attr->seq = nvalues++;
            break;
          case SPD_DBT_INT:
          case SPD_DBT_ENUM:
            if (attr->bitwidth > 0) {
                if ((iattrno < 0) ||
                    !(usedbit + attr->bitwidth < SAPID_INTBITS)) {
                    iattrno = nvalues++;
                    usedbit = 0;
                }
                attr->seq = iattrno;
                attr->firstbit = usedbit;
                usedbit += attr->bitwidth;
            } else {
                attr->seq = nvalues++;
            }
            break;
          default:
            break;
        }
    }
    cls->nValues = nvalues;
}

/* ǥ륢ؿ */

/* Added by S.Yamamoto 2001/03/29. */

SpdDBModel *spdGetDBModelById(SpdModelId modelId)
{
    return spddb_GetDBModelById(modelId);
}

static SpdDBModel *spddb_GetDBModelById(SpdModelId modelId)
{
    SpdDBModel  *model = NULL;
    int         i;

    for (i = 0; i < nModels; i++) {
        if (models[i]->id == modelId) {
            model = models[i];
            break;
        }
    }
    return model;
}

/* 
 * ǥѤSapidDB˥ǥϿ롥
 * modelˤϡСˤäƼư줿
 * ¤ѿؤΥݥ󥿤Ϥ
 */

SpdModelId spdUseModel(SpdDBModel *model)
{
    if (model == NULL) {
        return SPD_NON_MID;
    } else if (spddb_GetDBModelById(model->id)) {
        return model->id;
    }
    
    /* !! modelsfreeƤȤʤ(by N.Koyama). */
    models = spdRealloc(models, (nModels + 1) * sizeof(SpdDBModel *));
    
    /* 饹롥 */
    model->nClasses = 0;
    if (model->classes) {
        while (model->classes[model->nClasses].name) {
            model->classes[model->nClasses].modelId = model->id;
        
            /* 饹Υǡ롥 */
            adjustClassData(&(model->classes[model->nClasses]));
            /* 饹IDΥǥåɲä롥 */
            addClassIndex(&(model->classes[model->nClasses]));
        
            model->nClasses++;
        }
    }
    
    /* ݡȥ饹롥 */
    model->nImports = 0;
    if (model->imports) {
        while (0 <= model->imports[model->nImports++].classId) {
            /* Nothing. */
        }
    }
    
    /* ϥåͤ׻롥 */
    model->hash = spdDBCalcHash(model->name);
    
    models[nModels++] = model;
    
    return model->id;
}

/*
 * ϿѤΥǥ롥
 * 
 * AR4Ȥθߴ꤬ΤǡŪ˥ȤȤ(2001/10/20)
 */

/* 
 * int spdGetModelNum(void)
 * {
 *     return (nModels);
 * }
 */

/* ǥμֹ椫ǥ̾롥 */

SpdConstString spdGetModelNameById(SpdModelId modelId)
{
    SpdDBModel  *mdl = spddb_GetDBModelById(modelId);

    return (mdl != NULL ? mdl->name : NULL);
}

/* ǥ̾ǥμֹ롥 */

SpdModelId spdGetModelIdByName(SpdConstString modelName)
{
    SpdModelId  res = SPD_NON_ID;
    SpdSet2     models;
    SpdDBModel  *mdl;
    int         hash;
    SetCursor   csr;

    if (modelName == NULL) {
        return SPD_NON_ID;
    }

    hash = spdDBCalcHash(modelName);
    models = spdGetAllModels();
    for (csr = spdSetCursorCreate(models); spdSetCursorNext(&csr);) {
        mdl = spddb_GetDBModelById(spdSetGetValueO(csr.curElem->value));
        if (mdl->hash == hash &&  SPD_STREQ(mdl->name, modelName)) {
            res = mdl->id;
            break;
        }
    }
    spdFreeSet2(models);
    return res;
}

/*
 * Set new pathname of the model directory (ex. "PSDB").
 * Added by N.Fukuyasu 2003/08/11.
 */

void spdSetDBPathOfModel(SpdModelId modelId, SpdConstString pathname)
{
    SpdDBModel  *mdl = spddb_GetDBModelById(modelId);

    if (mdl != NULL) {
        mdl->pathname = pathname;
    }
}

/* ǥΥ󥹥󥹤¸Хѥ롥 */

SpdConstString spdGetDBPathOfModel(SpdModelId modelId)
{
    SpdDBModel  *mdl = spddb_GetDBModelById(modelId);

    return (mdl != NULL ? mdl->pathname : NULL);
}

/* ƤΥǥIDν롥 */

SpdIdSet spdGetAllModels(void)
{
    SpdIdSet    set;
    int         i;
    
    /* νλȤƤ̵̤Ǥ? */
    set = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
    for (i = 0; i < nModels; i++) {
        spdAddElemOK(set, models[i]->id);
    }
    return set;
}

/* 饹ؿ */
/* 饹ID SpdDBClass *  */

SpdDBClass *spdGetDBClassById(SpdClassId classId)
{
    return spddb_GetDBClassById(classId);
}

static SpdDBClass *spddb_GetDBClassById(SpdClassId classId)
{
    SpdElem *elem;
    if (classes == NULL) {
        return NULL;
    }
    elem = spdSearchElemO(classes, classId);
    if (elem == NULL) { /* not exist */
        return NULL;
    }
    return spdSetGetValueP(elem->value);
}

/* 饹°ǥID */

SpdModelId spdGetModelId(SpdClassId classId)
{
    SpdDBClass *cls;

    cls = spddb_GetDBClassById(classId);
    if (cls) {
        return cls->modelId;
    }
    return SPD_NON_ID;
}

/* 
 * ǥ°륯饹θĿ롥
 * 
 * public ʤΤƿ롥̾Υ饹public
 * ݡȥ饹accessФĴ٤롥
 * 
 * AR4Ȥθߴ꤬ΤǡŪ˥ȤȤ(2001/10/20)
 */

/* 
 * int spdGetClassNum(SpdModelId modelId)
 * {
 * 
 *     SpdDBModel      *mdl;
 *     int nClasses,   i;
 *     
 *     if ((mdl = spddb_GetDBModelById(modelId)) == NULL) {
 *         return (0);
 *     }
 * 
 *     nClasses = mdl->nClasses;
 *     for (i = 0; i < mdl->nImports; i++) {
 *         if (mdl->imports[i].access) {
 *             nClasses++;
 *         }
 *     }
 * 
 *     return (nClasses);
 * }
 */

static SpdIdSet spdGetAllClassesOfModel(SpdModelId modelId)
{
    SpdIdSet classes;
    SpdDBModel *mdl;
    int i;
    
    mdl = spddb_GetDBModelById(modelId);

    classes = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);

    if (mdl == NULL) {
        return classes;
    }

    for (i = 0; i < mdl->nClasses; i++) {
        spdAddElemOK(classes, mdl->classes[i].id);
    }
    
    for (i = 0; i < mdl->nImports; i++) {
        if (mdl->imports[i].access)
            spdAddElemOK(classes, mdl->imports[i].classId);
    }

    return classes;
}

/* ǥ°饹IDν */

SpdIdSet spdGetAllClasses(SpdModelId modelId)
{
    /* spdGetClassNum Ʊͤν */
    SpdIdSet models;
    SpdIdSet classes, res;
    
    if (modelId == SPD_NON_ID) {
        SetCursor csr;
        res = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);

        models = spdGetAllModels();
        for (csr = spdSetCursorCreate(models); spdSetCursorNext(&csr);) {
            modelId = spdSetGetValueO(csr.curElem->value);
            classes = spdGetAllClassesOfModel(modelId);
            res = spdAddSet2(res, classes);
            spdFreeSet2(classes);
        }
        spdFreeSet2(models);
        return res;
    } else {
        return spdGetAllClassesOfModel(modelId);
    }
}

/* 饹ID餽Υ饹̾ */

SpdConstString spdGetClassNameById(SpdClassId classId)
{
    SpdDBClass *cls;
    cls = spddb_GetDBClassById(classId);

    if (cls) {
        return cls->name;
    } else {
        return NULL;
    }
}

/* 饹̾餽Υ饹ID */

SpdClassId spddb_GetClassIdByName(SpdConstString className, SpdModelId modelId)
{
    SpdDBClass *cls;
    int hash;
    SetCursor csr;

    if (className == NULL || classes == NULL) {
        return SPD_NON_ID;
    }

    hash = spdDBCalcHash(className);
    
    for (csr = spdSetCursorCreate(classes); spdSetCursorNext(&csr);) {
        cls = spdSetGetValueP(csr.curElem->value);
        if (cls->hash == hash && SPD_STREQ(cls->name, className)) {
            if (modelId == SPD_NON_ID || cls->modelId == modelId) {
                return cls->id;
            }
        }
    }

    return SPD_NON_ID;
}

/* 饹̾餽Υ饹ID(ߴ) */

SpdClassId spdGetClassIdByName(SpdConstString className)
{
    return spddb_GetClassIdByName(className, SPD_NON_ID);
}

/* 饹ID餽Υ饹ͤ */

int spdGetClassSort(SpdClassId classId)
{
    SpdDBClass *cls;
    cls = spddb_GetDBClassById(classId);

    if (cls == NULL) {
        return 0;
    }
    return cls->sort;
}

/* °ؿ */
/* ꤵ줿饹°ο롥 */

int spdGetNumOfAttrs(SpdClassId classId)
{
    SpdDBClass  *cls;

    if ((cls = spddb_GetDBClassById(classId)) != NULL) {
        return cls->nAttrs;
    } else {
        return 0;
    }
}

int spddb_GetValueNum(SpdClassId classId)
{
    SpdDBClass *cls;

    cls = spddb_GetDBClassById(classId);
    if (cls) {
        return cls->nValues;
    } else {
        return 0;
    }
}

/* °ֹ椫SpdDBAttr*  */

static SpdDBAttr *spddb_GetDBAttrByNo(SpdClassId classId, int attrNo)
{
    SpdDBClass *cls;
    cls = spddb_GetDBClassById(classId);

    if (cls && 0 <= attrNo && attrNo < spdGetNumOfAttrs(classId)) {
        return &(cls->attrs[attrNo]);
    } else {
        return NULL;
    }
}

/* ӥåȥեͤμ */

static int spddb_GetAttrBitfieldVal_in(SpdDBAttr *attr, int ivalue)
{
    if (attr == NULL) {
        return SAPID_NON_VALUE;
    }
    
    if (attr->bitwidth > 0) {
        ivalue >>= attr->firstbit;
        ivalue &= ((1u << attr->bitwidth) - 1);
    }

    return ivalue;
}

int spddb_GetAttrBitfieldVal(SpdClassId classId, int attrNo, int ivalue)
{
    SpdDBAttr *attr;
    attr = spddb_GetDBAttrByNo(classId, attrNo);

    return spddb_GetAttrBitfieldVal_in(attr, ivalue);
}

/* ӥåȥեͤ */

static int spddb_SetAttrBitfieldVal_in(SpdDBAttr *attr, int ivalue, int value)
{
    unsigned int mask;

    if (attr == NULL) {
        return SAPID_NON_VALUE;
    }

    if (attr->bitwidth > 0) {
        value <<= attr->firstbit;
        mask = ((1u << attr->bitwidth) - 1) << attr->firstbit;
        ivalue &= ~mask;
        ivalue |= value;
    } else {
        ivalue = value;
    }

    return ivalue;
}

int spddb_SetAttrBitfieldVal(SpdClassId classId, int attrNo,
                             int ivalue, int value)
{
    SpdDBAttr *attr;
    attr = spddb_GetDBAttrByNo(classId, attrNo);

    return spddb_SetAttrBitfieldVal_in(attr, ivalue, value);
}

/* 饹λƤ°ֹ롥 */
/* ν̵̤ʤǤϤʤ.... */
SpdSet2 spdGetAllAttrNo(SpdClassId classId)
{
    SpdIdSet    set;
    int         nattrs;
    int         i;
    
    set = spdCreateSet2(SPDSET_INT_KEY, SPDSET_KEY_IS_VALUE);
    nattrs = spdGetNumOfAttrs(classId);
    for (i = 0; i < nattrs; i++) {
        spdAddElemIK(set, i);
    }
    
    return set;
}

/* °ֹ椫°̾롥 */

SpdConstString spdGetAttrNameByNo(SpdClassId classId, int attrNo)
{
    SpdDBAttr *attr;

    if ((attr = spddb_GetDBAttrByNo(classId, attrNo)) != NULL) {
        return attr->name;
    } else {
        if (attrNo == SAPIDDB_ATTR_ID) {
            return "id";
        } else if (attrNo == SAPIDDB_ATTR_CLASSID) {
            return "classid";
        } else {
            return NULL;
        }
    }
}

/* °̾°ֹ롥 */

int spdGetAttrNoByName(SpdClassId classId, SpdConstString attrName)
{
    int i, nattrs;
    SpdDBAttr *attr;
    int hash;

    if (attrName == NULL) {
        return SPD_NON_ID;
    }

    switch (attrName[0]) {
    case 'i':
        if (SPD_STREQ("id", attrName)) {
            return SAPIDDB_ATTR_ID;
        }
        break;
    case 'c':
        if (SPD_STREQ("classid", attrName)) {
            return SAPIDDB_ATTR_CLASSID;
        }
        break;
    }
    if (classId == SPD_NON_ID ||
        (spdGetClassSort(classId) & SAPIDDB_SORT_REL)) {
        switch (attrName[0]) {
        case 'p':
            if (SPD_STREQ("p-id", attrName)) {
                return SAPIDDB_ATTR_P_ID;
            }
            break;
        case 'c':
            if (SPD_STREQ("c-id", attrName)) {
                return SAPIDDB_ATTR_C_ID;
            }
            break;
        }
    }

    nattrs = spdGetNumOfAttrs(classId);
    hash = spdDBCalcHash(attrName);

    for (i = 0; i < nattrs; i++) {
        attr = spddb_GetDBAttrByNo(classId, i);
        if (attr->hash == hash && SPD_STREQ(attr->name, attrName)) {
            return i;
        }
    }

    return SAPIDDB_ATTR_NONE;
}

/* °źֹ */

int spddb_GetAttrSeq(SpdClassId classId, int attrNo)
{
    SpdDBAttr *attr;
    attr = spddb_GetDBAttrByNo(classId, attrNo);

    if (attr) {
        return attr->seq;
    } else {
        if (attrNo == SAPIDDB_ATTR_ID || attrNo == SAPIDDB_ATTR_CLASSID)
            return attrNo;
        else
            return SAPIDDB_ATTR_NONE;
    }
}

/* °η */
/* !! SpdDBType ¤Τ˾ʤ뤫 */

SpdDBType spdGetAttrType(SpdClassId classId, int attrNo)
{
    SpdDBAttr *attr;
    attr = spddb_GetDBAttrByNo(classId, attrNo);

    if (attr) {
        return attr->type;
    } else {
        if (attrNo == SAPIDDB_ATTR_ID || attrNo == SAPIDDB_ATTR_CLASSID)
            return SPD_DBT_INT;
        else
            return SPD_DBT_NON;
    }
}

/* SpdDBObj  value  */

void spddb_FreeDBObjValue(SpdDBObj *obj)
{
    SpdDBClass *cls;
    SpdDBAttr *attr;
    int i;
  
    if (obj == NULL)
        return;

    cls = spddb_GetDBClassById(obj->classId);
    if (cls == NULL) return;

    for (i = 0; cls->fields[i] != SAPIDDB_ATTR_NONE; i++) {
        if (cls->fields[i] >= 0) {
            attr = &(cls->attrs[cls->fields[i]]);
            switch (attr->type) {
              case SPD_DBT_STR:
                if (obj->value[attr->seq].svalue) {
                    spdFree(obj->value[attr->seq].svalue);
                }
                obj->value[attr->seq].svalue = NULL;
                break;
              default:
                break;
            }
        }
    }
}

/* SpdDBObj  value  */

void spddb_InitDBObjValue(SpdDBObj *obj)
{
    SpdDBClass *cls;
    SpdDBAttr *attr;
    int i;
  
    if (obj == NULL)
        return;

    cls = spddb_GetDBClassById(obj->classId);
    
    for (i = 0; cls->fields[i] != SAPIDDB_ATTR_NONE; i++) {
        if (cls->fields[i] >= 0) {
            attr = &(cls->attrs[cls->fields[i]]);
            switch (attr->type) {
              case SPD_DBT_STR:
                obj->value[attr->seq].svalue = NULL;
                break;
              default:
                obj->value[attr->seq].ivalue = 0;
                break;
            }
        }
    }
}

/* ե뤫°ͤɤ߹ࡥ */

static void readAttr(FILE *fp, SpdDBAttr *attr, SpdDBObj *obj)
{
    if (attr == NULL) {
        return;
    }
    
    switch (attr->type) {
      case SPD_DBT_INT:
      case SPD_DBT_OID:
      case SPD_DBT_ENUM:
        obj->value[attr->seq].ivalue =
            spddb_SetAttrBitfieldVal_in(attr, obj->value[attr->seq].ivalue,
                                        spdReadIntAttr(fp));
        break;
      case SPD_DBT_STR:
        obj->value[attr->seq].svalue = spdStrdup(spdReadStrAttr(fp));
        break;
      default:
        break;
    }
}

/* ե뤫饿ץɤ߹ࡥ */

SpdObjId spddb_ReadTuple(FILE *fp, SpdClassId classId, SpdDBObj *obj)
{
    SpdDBClass *cls;
    int i;
    
    cls = spddb_GetDBClassById(classId);
    obj->id = obj->classId = SPD_NON_ID;
    
    /* ޤɤߤʤǡɤ߹ࡥ */
    for (i = 0; cls->fields[i] != SAPIDDB_ATTR_NONE; i++) {
        if (cls->fields[i] >= 0) {
            /* ̾°ͤɤࡥ */
            readAttr(fp, &(cls->attrs[cls->fields[i]]), obj);
        } else {
            switch (cls->fields[i]) {
              case SAPIDDB_ATTR_ID:
                obj->id = spdReadIntAttr(fp);
                break;
              case SAPIDDB_ATTR_CLASSID:    /* ֤󤢤ꤨʤ... */
                obj->classId = spdReadIntAttr(fp);
                break;
              default:
                break;
            }
        }

    }

    if (obj->classId == SPD_NON_ID) {
        obj->classId = classId;
    }
    
    return obj->id;
}

/* ե°ͤ񤭹 */

static void writeAttr(FILE *fp, SpdDBAttr *attr, SpdDBObj *obj)
{
    if (attr == NULL) {
        return;
    }

    switch (attr->type) {
      case SPD_DBT_INT:
      case SPD_DBT_OID:
      case SPD_DBT_ENUM:
        spdWriteIntAttr(fp,
                        spddb_GetAttrBitfieldVal_in(attr, obj->value[attr->seq].ivalue));
        break;
      case SPD_DBT_STR:
        spdWriteStrAttr(fp, obj->value[attr->seq].svalue);
        break;
      default:
        break;
    }
}

/* ե˥ץ񤭹 */

SpdObjId spddb_WriteTuple(FILE *fp, SpdClassId classId, SpdObjId objId)
{
    SpdDBClass *cls;
    SpdDBObj *obj;
    int i;

    obj = spddb_GetDBObjById(objId);

    if (obj == NULL) {
        return SPD_NON_ID;
    }
    cls = spddb_GetDBClassById(classId);

    spddb_CreateTuple(fp);
    /* ޤɤߤʤǡ񤭹 */
    for (i = 0; cls->fields[i] != SAPIDDB_ATTR_NONE; i++) {
        if (cls->fields[i] >= 0) {
            /* ̾Υȥӥ塼Ȥ */
            writeAttr(fp, &(cls->attrs[cls->fields[i]]), obj);
        } else {
            switch (cls->fields[i]) {
              case SAPIDDB_ATTR_ID:
                spdWriteIntAttr(fp, obj->id);
                break;
              case SAPIDDB_ATTR_CLASSID:    /* ֤󤢤ꤨʤ...*/
                spdWriteIntAttr(fp, obj->classId);
                break;
              default:
                break;
            }
        }
    }
    spddb_CommitTuple(fp);

    return obj->id;
}

/* ؿ */
/* ͤͤʸɽѴ */

SpdConstString spdGetEnumStrVal(SpdClassId classId, int attrNo, int enumValue)
{
    SpdDBAttr *attr;
    int i;
    
    attr = spddb_GetDBAttrByNo(classId, attrNo);

    if (attr == NULL) {
        return NULL;
    }

    if (attr->type != SPD_DBT_ENUM) {
        return NULL;
    }

    for (i = 0; attr->enums[i].name; i++) {
        if (attr->enums[i].value == enumValue) {
            return attr->enums[i].str;
        }
    }
    
    return NULL;
}

/* ͤʸɽͤѴ */

int spdGetEnumIntVal(SpdClassId classId, int attrNo, SpdConstString enumStr)
{
    SpdDBAttr *attr;
    int i;
    int hash;
    
    if (enumStr == NULL) {
        return SAPID_NON_VALUE;
    }

    attr = spddb_GetDBAttrByNo(classId, attrNo);

    if (attr == NULL) {
        return SAPID_NON_VALUE;
    }

    if (attr->type != SPD_DBT_ENUM) {
        return SAPID_NON_VALUE;
    }

    hash = spdDBCalcHash(enumStr);

    for (i = 0; attr->enums[i].name; i++) {
        if (hash == attr->enums[i].nhash &&
            SPD_STREQ(attr->enums[i].name, enumStr)) {
            return attr->enums[i].value;
        } else if (hash == attr->enums[i].shash &&
                   SPD_STREQ(attr->enums[i].str, enumStr)) {
            return attr->enums[i].value;
        }
    }
    
    return SAPID_NON_VALUE;
}

/******************************************************************************/

/* 
 * Added by S.Yamamoto 2001/06/03.
 */

SpdBoolean spdIsValidModelId(SpdModelId modelId)
{
    return (SPD_FIRST_MID <= modelId && modelId <=  SPD_LAST_MID);
}

SpdClassId spdGetFirstCid(SpdModelId modelId)
{
    if (!spdIsValidModelId(modelId)) {
        spdErrorExit("spdGetFirstCid(): %d: Invalid model id.\n", modelId);
    }
    return (spddb_GetDBModelById(modelId)->firstCid);
}

SpdClassId spdGetLastCid(SpdModelId modelId)
{
    if (!spdIsValidModelId(modelId)) {
        spdErrorExit("spdGetLastCid(): %d: Invalid model id.\n", modelId);
    }
    return (spddb_GetDBModelById(modelId)->lastCid);
}

SpdClassId spdGetFirstRid(SpdModelId modelId)
{
    if (!spdIsValidModelId(modelId)) {
        spdErrorExit("spdGetFirstRid(): %d: Invalid model id.\n", modelId);
    }
    return (spddb_GetDBModelById(modelId)->firstRid);
}

SpdClassId spdGetLastRid(SpdModelId modelId)
{
    if (!spdIsValidModelId(modelId)) {
        spdErrorExit("spdGetLastRid(): %d: Invalid model id.\n", modelId);
    }
    return (spddb_GetDBModelById(modelId)->lastRid);
}

/******************************************************************************/

SpdBoolean spdIsValidClassOrRelationId(SpdClassId classId)
{
    return (SPD_FIRST_CID <= classId && classId <= SPD_LAST_RID);
}

SpdBoolean spdIsValidClassId(SpdClassId classId)
{
    return (spdIsValidClassOrRelationId(classId) && 
            (spdGetClassSort(classId) & SAPIDDB_SORT_OBJ));
}

SpdBoolean spdIsValidRelationId(SpdClassId relId)
{
    return (spdIsValidClassOrRelationId(relId) && 
            (spdGetClassSort(relId) & SAPIDDB_SORT_REL));
}

/******************************************************************************/

#ifdef DAPID

/* Copied from spddb_WriteTuple(). */

SpdObjId spdWriteTempObj(FILE *fp, SpdDBObj* obj)
{
    int         i;
    SpdDBClass  *cls;

    if (obj == NULL) {
        return SPD_NON_ID;
    }
    cls = spddb_GetDBClassById(obj->classId);

    spddb_CreateTuple(fp);
    /* ޤɤߤʤǡ񤭹 */
    for (i = 0; cls->fields[i] != SAPIDDB_ATTR_NONE; i++) {
        if (cls->fields[i] >= 0) {
            /* ̾Υȥӥ塼Ȥ */
            writeAttr(fp, &(cls->attrs[cls->fields[i]]), obj);
        } else {
            switch (cls->fields[i]) {
              case SAPIDDB_ATTR_ID:
                spdWriteIntAttr(fp, obj->id);
                break;
              case SAPIDDB_ATTR_CLASSID:    /* ֤󤢤ꤨʤ... */
                spdWriteIntAttr(fp, obj->classId);
                break;
              default:
                break;
            }
        }
    }
    spddb_CommitTuple(fp);

    return obj->id;
}

#endif /* DAPID */
