/* 
 * Program:             $RCSfile: write_db.c,v $  $Revision: 30.22 $
 * 
 * Purpose:             DB񤭹ߴؿ
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: write_db.c,v 30.22 2003/07/08 05:46:43 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

/* ץ롥 */

void spddb_CreateTuple(FILE *fp)
{
}

/* ץνλ */

void spddb_CommitTuple(FILE *fp)
{
    if (spdGetWriteSDBformat() == SAPID_TEXT_FORMAT_SDB) {
        putc('\n', fp);
    }
}

static FILE *openClassDB(SpdClassId classId)
{
    SpdConstString  path;
    SpdConstString  className;
    SpdModelId      modelId;
    
    modelId = spdGetModelId(classId);
    path = spdGetDBPathOfModel(modelId);
    className = spdGetClassNameById(classId);
    if (path == NULL || className == NULL) {
        return (NULL);
    }

    return (spdOpenSDBfile(path, className, SAPID_O_WRITE));
}

static void closeClassDB(FILE *fp)
{
    spdFclose(fp);
}

/* 饹Υ󥹥󥹤ƽϤ롥 */

int spdWriteAClass(SpdClassId classId, SpdDBId dbId)
{
    SpdIdSet classes;
    FILE *fp;
    SpdIdSet extent;
    SpdId objId;
    SpdDBId oldDBId;
    SpdInfo *info;
    SetCursor csr;

    classes = spdGetAllClasses(SPD_NON_ID);
    if (classId == SPD_NON_ID || !spdContainsO(classes, classId)) {
        spdFreeSet2(classes);
        return SAPID_ERR_INVALID_CLASSID;
    }
    spdFreeSet2(classes);
    
    oldDBId = spdSetDefaultDB(dbId);
    if ((fp = openClassDB(classId)) == NULL) {
        return SAPID_ERR_CANT_OPEN_SDB;
    }
    extent = spdGetClassExtentP(classId); /* no need to free */
    for (csr = spdSetCursorCreate(extent); spdSetCursorNext(&csr);) {
        objId = spdSetGetValueO(csr.curElem->value);
        spddb_WriteTuple(fp, classId, objId);
    }

    info = spdOpenSDBinfo();
    spdSetInfoInt(info, spdGetClassNameById(classId), 
                  extent ? (int)(extent->elemNum) : 0);
    spdCloseInfo(info);

    closeClassDB(fp);
    spdSetDefaultDB(oldDBId);
    return 0;
}

static int spdWriteAModel(SpdModelId modelId, SpdDBId dbId)
{
    SpdIdSet models, classes;
    SpdClassId classId;
    int res;
    SetCursor csr;

    models = spdGetAllModels();
    if (modelId == SPD_NON_ID || !spdContainsO(models, modelId)) {
        spdFreeSet2(models);
        return (SAPID_ERR_INVALID_MODELID);
    }
    spdFreeSet2(models);

    classes = spdGetAllClasses(modelId);

    /* ֥ȤȴϢ򤹤٤ƽ񤭹 */
    for (csr = spdSetCursorCreate(classes); spdSetCursorNext(&csr);) {
        classId = spdSetGetValueO(csr.curElem->value);
        if ((res = spdWriteAClass(classId, dbId)) < 0) {
            spdFreeSet2(classes);
            return res;
        }
    }
    spdFreeSet2(classes);
    
    return 0;
}

/* ǥΥ󥹥󥹤򤹤٤ƽϤ롥 */

int spdCommitDB(SpdModelId modelId, SpdDBId dbId)
{
    SpdIdSet models;
    SpdInfo *info;
    int res;
    SetCursor csr;

    if (modelId == SPD_NON_ID) {
        models = spdGetAllModels();
        for (csr = spdSetCursorCreate(models); spdSetCursorNext(&csr);) {
            modelId = spdSetGetValueO(csr.curElem->value);
            if ((res = spdWriteAModel(modelId, dbId)) < 0) {
                spdFreeSet2(models);
                return res;
            }
        }
        spdFreeSet2(models);
    } else {
        if ((res = spdWriteAModel(modelId, dbId)) < 0) {
            return res;
        }
    }

    info = spdOpenSDBinfo();
    spddb_WriteSDBInfo(info, dbId);
    spdCloseInfo(info);

    return 0;
}
