/* 
 * Program:             $RCSfile: genChkAttrId.c,v $  $Revision: 31.7 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  1999/12/07
 * 
 * (C) Copyright:       S.Yamamoto  1999 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: genChkAttrId.c,v 31.7 2003/06/28 15:31:55 yamamoto Exp yamamoto $";
#endif

#include <ctype.h>
#include <stdio.h>
#include <Sapid/Sapid.h>

extern Class_t      class_table[];

int main(int argc, char *argv[])
{
    int     i;                              /* Class id. */
    int     j;                              /* Attribute id. */
    char    *cp;

    for (i = 0; class_table[i].name != NULL; i++) {
        if (SPD_IS_REL_ID(i)) {
            /* Skip relationships. */
            continue;
        }
        /* Integer attributes. */
        for (j = 0; j < SPD_MAX(SpdObjIValN, SpdRelIValN); j++) {
            if (class_table[i].iattr[j] != NULL) {
                printf("    {");

                /* Attribute id macro. */
                printf("SPD_AID_");
                for (cp = class_table[i].name; *cp != '\0'; cp++) {
                    putchar(toupper(*cp));
                }
                putchar('_');
                for (cp = class_table[i].iattr[j]; *cp != '\0'; cp++) {
                    putchar(toupper(*cp));
                }
                printf(", ");

                /* Class name. */
                printf("\"%s\", ", class_table[i].name);
                
                /* Attribute name. */
                printf("\"%s\"", class_table[i].iattr[j]);

                printf("},");
                printf("\n");
            }
        }

        /* String attributes. */
        for (j = 0; j < SpdObjSValN; j++) {
            if (class_table[i].sattr[j] != NULL) {
                printf("    {");

                /* Attribute id macro. */
                printf("SPD_AID_");
                for (cp = class_table[i].name; *cp != '\0'; cp++) {
                    putchar(toupper(*cp));
                }
                putchar('_');
                for (cp = class_table[i].sattr[j]; *cp != '\0'; cp++) {
                    putchar(toupper(*cp));
                }
                printf(", ");

                /* Class name. */
                printf("\"%s\", ", class_table[i].name);
                
                /* Attribute name. */
                printf("\"%s\"", class_table[i].sattr[j]);

                printf("},");
                printf("\n");
            }
        }
        printf("\n");
    }

    /* Terminator. */
    printf("    {SPD_NON_AID, NULL, NULL}\n");

    return (EXIT_SUCCESS);
}
