/* 
 * Program:             $RCSfile: mkAttrId.c,v $  $Revision: 31.7 $
 * 
 * Purpose:             Generate class table.
 * 
 * Author:              S.Yamamoto  1999/11/28
 * 
 * (C) Copyright:       S.Yamamoto  1999 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: mkAttrId.c,v 31.7 2003/08/17 07:48:06 yamamoto Exp yamamoto $";
#endif

#include <ctype.h>
#include <stdio.h>
#include <Sapid/Sapid.h>

extern Class_t      class_table[];

int main(int argc, char *argv[])
{
    int     i;                              /* Class id. */
    int     j;                              /* Attribute id. */
    char    *cp;

    printf("/* \n");
    printf(" * Generated by: mkAttrId.\n");
    printf(" */\n");
    printf("\n");

    for (i = 0; class_table[i].name != NULL; i++) {
        if (SPD_IS_REL_ID(i)) {
            /* Skip relationships. */
            continue;
        }
        /* Integer attributes. */
        for (j = 0; j < SPD_MAX(SpdObjIValN, SpdRelIValN); j++) {
            if (class_table[i].iattr[j] != NULL) {
                printf("#define SPD_AID_");
                for (cp = class_table[i].name; *cp != '\0'; cp++) {
                    putchar(toupper(*cp));
                }
                putchar('_');
                for (cp = class_table[i].iattr[j]; *cp != '\0'; cp++) {
                    putchar(toupper(*cp));
                }
                printf(" %d\n", j);
            }
        }
        /* String attributes. */
        for (j = 0; j < SpdObjSValN; j++) {
            if (class_table[i].sattr[j] != NULL) {
                printf("#define SPD_AID_");
                for (cp = class_table[i].name; *cp != '\0'; cp++) {
                    putchar(toupper(*cp));
                }
                putchar('_');
                for (cp = class_table[i].sattr[j]; *cp != '\0'; cp++) {
                    putchar(toupper(*cp));
                }
                printf(" %d\n", j + IVAL_NUM);
            }
        }
        printf("\n");
    }

    return (EXIT_SUCCESS);
}
