/* 
 * Program:             $RCSfile: mkGetAttrIdByName3.c,v $  $Revision: 30.8 $
 * 
 * Purpose:             Generate spdGetAttrIdByName3().
 * 
 * Author:              S.Yamamoto  1995/03/20
 * 
 * (C) Copyright:       S.Yamamoto  1995 - 2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: mkGetAttrIdByName3.c,v 30.8 2003/06/28 15:31:43 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "mkGetAttrNameId.h"

/* #define DEBUG_INPUTS */

/* 
 * SpdAttrNameId spdGetAttrNameId(SpdConstString cp);
 */

int main(int argc, char *argv[])
{
    int         i, j, k, c, len, inputs_num;
    char        buf[SPD_STRING_LEN + 1];
    char        *inputs[MAX_INPUTS_NUM];
    SpdBoolean  is_found;

    i = 0;
    while (fgets(buf, SPD_STRING_LEN + 1, stdin) != NULL) {
        /* Trim the last newline character. */
        len = strlen(buf);  
        buf[len - 1] = '\0';

        inputs[i++] = spdStrdup(buf);

#ifdef DEBUG_INPUTS
        spdMessage("\"%s\".\n", buf);
#endif      
    }

    printf("static SpdAttrId attr_id[/* AttrNameId */][SPD_CRID_NUM_ALL] = {\n");

    inputs_num = i;
    for (i = 0; i < inputs_num; i++) {
        printf("    /* %s */\n", inputs[i]);
        /* spdMessage("str \"%s\", attrNameId %d.\n",          */
        /*            inputs[i], spdGetAttrNameId(inputs[i])); */
        printf("    {");
        for (c = 0; class_table[c].name != NULL; c++) {
            if (c != 0) {
                printf(", ");
                if ((c % 5) == 0) {
                    printf("\n     ");
                }
            }
            is_found = FALSE;
            for (j = 0; j < SPD_MAX(SpdObjIValN, SpdRelIValN); j++) {
                if (class_table[c].iattr[j] != NULL &&
                    SPD_STREQ(class_table[c].iattr[j], inputs[i])) {
                    /* spdMessage("    %s, iattr %d.\n",   */
                    /*            class_table[c].name, j); */
                    is_found = TRUE;
                    break;
                }
            }
            for (k = 0; k < SpdObjSValN; k++) {
                if (class_table[c].sattr[k] != NULL &&
                    SPD_STREQ(class_table[c].sattr[k], inputs[i])) {
                    /* spdMessage("    %s, sattr %d.\n",   */
                    /*            class_table[c].name, k); */
                    is_found = TRUE;
                    break;
                }
            }

            if (SPD_STREQ(inputs[i], "p-id")) {
                printf("%2d", SPD_AID_REL_P_ID);
            } else if (SPD_STREQ(inputs[i], "c-id")) {
                printf("%2d", SPD_AID_REL_C_ID);
            } else if (is_found) {
                if (j != SPD_MAX(SpdObjIValN, SpdRelIValN)) {
                    /* printf("%2d", j); */
                    printf("%2d /* %s */", j, class_table[c].name);
                } else if (k != SpdObjSValN) {
                    /* printf("%2d", k); */
                    printf("%2d /* %s */",
                           k + SpdObjIValN, class_table[c].name);
                } else {
                    spdErrorExit("Error.");
                }
            } else {
                printf("%d", SPD_NON_ANAME_ID);
            }

        }
        printf("},\n");
    }
    printf("};\n");
    
    for (i = 0; i < inputs_num; i++) {
        spdFree(inputs[i]);
    }
    return (EXIT_SUCCESS);
}
