/* 
 * Program:             $RCSfile: mkGetAttrNameIdSub.c,v $  $Revision: 30.9 $
 * 
 * Purpose:             Generate class table.
 * 
 * Author:              S.Yamamoto  1995/03/20
 * 
 * (C) Copyright:       S.Yamamoto  1995 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: mkGetAttrNameIdSub.c,v 30.9 2001/08/17 14:06:42 yamamoto Exp yamamoto $";
#endif

#include <stdarg.h>
#include <stdio.h>
#include <Sapid/Sapid.h>
#include "mkGetAttrNameId.h"

#define INDENT_STRING       "    "

/* DEBUG_MKMA_LIB */

#if defined(lint)
#define DW_MKMA             printf      /* Just for cheking. */
#elif defined(DEBUG_MKMA_LIB)
#define DW_MKMA             spdWarning
#else
#define DW_MKMA             (void)
#endif

static int  mkMA_notFound;

static void     mkMA_body(int i, StrAndVal strs[], int n, int indent);
static void     run_found(int i, StrAndVal strs[], int m, int run_length,
                          int indent);
static void     iout(int indent, const char *format, ...);

void mkMA(char *type, char *func, StrAndVal strs[], int n, int notFound)
{
    int     indent = 0;

    iout(indent, "%s %s(const char *cp)\n", type, func);
    iout(indent, "{\n");
    mkMA_notFound = notFound;
    mkMA_body(-1, strs, n, indent + 1);
    iout(indent, "}\n");
}

/* 
 * i: strs[]ǤiʸܤޤǤʬäƤ롥
 * strs[]: ʸ󽸹硥
 * n: ʸ󽸹ǤθĿ
 * indent: ɽѤΥǥȥ٥롥
 */

static void mkMA_body(int i, StrAndVal strs[], int n, int indent)
{
    char    savedChar;
    int     m, run_length;

    DW_MKMA("mkMA_body(i %d, , n %d, indent %d):\n", i, n, indent);

    savedChar = 0177;   /* Initialize with a character never exist in strs[]. */
    run_length = 0;
    for (m = 0; m < n; m++) {
        if (savedChar != strs[m].str[i + 1]) {
            if (0 < run_length) {
                run_found(i, strs, m, run_length, indent);
                run_length = 0;
            }
            DW_MKMA("mkMA_body(): i %d, %s.\n", i, strs[m].str);
            if (m == (n - 1) || strs[m].str[i + 1] != strs[m + 1].str[i + 1]) {
                DW_MKMA("    Found.\n");
                if (strs[m].str[i + 1] == '\0') {
                    iout(indent, "if (*(cp + %d) == '\\0') {\n", i + 1);
                } else {
                    iout(indent, "if (*(cp + %d) == '%c') {\n",
                         i + 1, strs[m].str[i + 1]);
                }
                iout(indent + 1, "/* \"%s\". */\n", strs[m].str);
                iout(indent + 1, "return (%d);\n", strs[m].val);
                iout(indent, "}\n");
            } else {
                run_length = 1;
            }
        } else {
            DW_MKMA("mkMA_body(): i %d, %s.\n", i, strs[m].str);
            run_length++;
        }
        savedChar = strs[m].str[i + 1];
    }
    if (0 < run_length) {
        run_found(i, strs, m, run_length, indent);
    }
    iout(indent, "/* Invalid input. */\n");
    iout(indent, "return (%d);\n", mkMA_notFound);
}

/*
 * strs[](m - run_length)ܤǤ(m - 1)ܤǤϡ
 * i + 1ܤʸȤݾڤƤǸƤФ롥
 */

static void run_found(int i, StrAndVal strs[], int m, int run_length,
                      int indent)
{
    DW_MKMA("    Run, %d.\n", run_length);

    iout(indent, "if (*(cp + %d) == '%c') {\n", i + 1, strs[m - 1].str[i + 1]);
    iout(indent + 1, "/* mkMA_body(%d, , %d, %d); */\n",
         i + 1, run_length, indent + 1);
    mkMA_body(i + 1, &(strs[m - run_length]), run_length, indent + 1);
    iout(indent, "}\n");
}

static void iout(int indent, const char *format, ...)
{
    int         i;
    va_list     args;
    
    fflush(stdout);
    fflush(stderr);

    for (i = 0; i < indent; i++) {
        fputs(INDENT_STRING, stdout);
    }
    va_start(args, format);
    vfprintf(stdout, format, args);
    va_end(args);

    fflush(stdout);
}
