/* 
 * Program:             $RCSfile: genSpdGetTyp.c,v $  $Revision: 40.6 $
 * 
 * Purpose:             Generate class table.
 * 
 * Author:              S.Yamamoto  1995/03/20
 * 
 * (C) Copyright:       S.Yamamoto  1995 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: genSpdGetTyp.c,v 40.6 2003/08/17 07:48:15 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

extern Class_t      class_table[];

SpdConstString getTypMacroName(int id);

int main(int argc, char *argv[])
{
    int             i;
    SpdConstString  program_name;                  /* This program name. */

    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);

    printf("/* \n");
    printf(" * Generated by: mkGetTyp.\n");
    printf(" */\n");
    printf("\n");

    printf("#include <stdio.h>\n");
    printf("#include <Sapid/Sapid.h>\n");
    printf("\n");

    printf("int spdGetTypTable[] = {\n");
    for (i = 0; class_table[i].name != NULL; i++) {
        printf("     %s, /* \"%s\", %d. */\n", 
           getTypMacroName(class_table[i].typ), class_table[i].name, i);
    }
    printf("};\n");
    printf("\n");

    printf("int spdGetTyp(SpdClassId classId)\n");
    printf("{\n");

    printf("    return ((SPD_FIRST_CID <= classId && classId <= SPD_LAST_RID) ?\n");
    printf("            spdGetTypTable[classId] :\n");
    printf("            -1);\n");
    printf("}\n");

    exit(EXIT_SUCCESS);
}
