/* 
 * Program:             $RCSfile: getTypMacroName.c,v $  $Revision: 40.8 $
 * 
 * Purpose:             Generate class table.
 * 
 * Author:              S.Yamamoto  1995/03/20
 * 
 * (C) Copyright:       S.Yamamoto  1995 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: getTypMacroName.c,v 40.8 2003/06/28 15:31:53 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

#define UNKNOWN_TYP_ID      "*** Unknown typ id. ***"
#define UNKNOWN_SORT_ID     "*** Unknown sort id. ***"

static SpdValName typNameTable[] = {
    { SPD_VAL_NAME2(C_TYP_OC) },
    { SPD_VAL_NAME2(C_TYP_O_) },

    { SPD_VAL_NAME2(C_TYP_RC) },
    { SPD_VAL_NAME2(C_TYP_R_) },
};

SpdConstString getTypMacroName(int id)
{
    int     i;
    
    for (i = 0; i < SPD_ARRAY_SIZE(typNameTable); i++) {
        if (id == typNameTable[i].value) {
            return (typNameTable[i].name);
        }
    }
    return (UNKNOWN_TYP_ID);
}

/******************************************************************************/

static SpdValName sortNameTable[] = {
    { SPD_VAL_NAME2(SAPIDDB_SORT_OBJ) },
    { SPD_VAL_NAME2(SAPIDDB_SORT_OBJ_TREENODE) },
    { SPD_VAL_NAME2(SAPIDDB_SORT_OBJ_TEXT) },
    { SPD_VAL_NAME2(SAPIDDB_SORT_OBJ_TREENODE | SAPIDDB_SORT_OBJ_TEXT) },

    { SPD_VAL_NAME2(SAPIDDB_SORT_REL) },
    { SPD_VAL_NAME2(SAPIDDB_SORT_REL_COMPOSITE) },
    { SPD_VAL_NAME2(SAPIDDB_SORT_REL_REFERENCE) },
    { SPD_VAL_NAME2(SAPIDDB_SORT_REL_ONE_TO_ONE) }
};

SpdConstString getSortMacroName(int id)
{
    int             i;
    char            *result[256];
    
    result[0] = '\0'; 
    for (i = 0; i < SPD_ARRAY_SIZE(sortNameTable); i++) {
        if (id & SAPIDDB_SORT_OBJ_TREENODE) {
            /* Object. */
            if (id & SAPIDDB_SORT_OBJ_TREENODE &&
                id & SAPIDDB_SORT_OBJ_TEXT) {
                return ("SAPIDDB_SORT_OBJ_TREENODE | SAPIDDB_SORT_OBJ_TEXT");
            } else if (id & SAPIDDB_SORT_OBJ_TREENODE) {
                return ("SAPIDDB_SORT_OBJ_TREENODE");
            } else if (id & SAPIDDB_SORT_OBJ_TEXT) {
                return ("SAPIDDB_SORT_OBJ_TEXT");
            } else {
                return ("SAPIDDB_SORT_OBJ_TREENODE");
            }
        } else if (id & SAPIDDB_SORT_REL) {
            if (id & SAPIDDB_SORT_REL_COMPOSITE) {
                return ("SAPIDDB_SORT_REL_COMPOSITE");
            } else if (id & SAPIDDB_SORT_REL_REFERENCE) {
                return ("SAPIDDB_SORT_REL_REFERENCE");
            } else if (id & SAPIDDB_SORT_REL_ONE_TO_ONE) {
                return ("SAPIDDB_SORT_REL_ONE_TO_ONE");
            } else {
                return ("SAPIDDB_SORT_REL");
            }
        } else {
            return (UNKNOWN_SORT_ID);
        }
    }
    SPD_DUMMY_RETURN(NULL);
}
