/* 
 * Program:             $RCSfile: mkWriteSDB.c,v $  $Revision: 30.23 $
 * 
 * (C) Copyright:       R.Miura and S.Yamamoto  1997 - 1998
 *                      This file is a product of the project Sapid.
 * 
 *                      Generated by: mkWriteSDB in Sapid-5.93.0.
 */

#ifndef lint
static char rcsid[] =
    "$Id: mkWriteSDB.c,v 30.23 2003/08/17 07:48:09 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/write_sdb_sub.h>

/* FuncA. */

void write_program_sub(FILE *fp, int id, SpdString name)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%s%c\n",
			id, SDB_ATTR_SEPARATOR,
			name, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		fputs(name, fp);
		fputc('\0', fp);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_file_sub(FILE *fp, int id, SpdString name)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%s%c\n",
			id, SDB_ATTR_SEPARATOR,
			name, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		fputs(name, fp);
		fputc('\0', fp);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_declaration_sub(FILE *fp, int id, int length, int sort, int storage)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c%d%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR,
			sort, SDB_ATTR_SEPARATOR,
			storage, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		spdWriteIntAttrBinary(fp, sort);
		spdWriteIntAttrBinary(fp, storage);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_declarator_sub(FILE *fp, int id, int length, int sort)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR,
			sort, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		spdWriteIntAttrBinary(fp, sort);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_identifier_sub(FILE *fp, int id, int length, int sort, int scope, SpdString name)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c%d%c%s%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR,
			sort, SDB_ATTR_SEPARATOR,
			scope, SDB_ATTR_SEPARATOR,
			name, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		spdWriteIntAttrBinary(fp, sort);
		spdWriteIntAttrBinary(fp, scope);
		fputs(name, fp);
		fputc('\0', fp);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_optionaldecl_sub(FILE *fp, int id, int length, int sort)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR,
			sort, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		spdWriteIntAttrBinary(fp, sort);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_block_sub(FILE *fp, int id, int length, int sort)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR,
			sort, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		spdWriteIntAttrBinary(fp, sort);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_expression_sub(FILE *fp, int id, int length, int sort, int lrtype)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c%d%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR,
			sort, SDB_ATTR_SEPARATOR,
			lrtype, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		spdWriteIntAttrBinary(fp, sort);
		spdWriteIntAttrBinary(fp, lrtype);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_label_sub(FILE *fp, int id, int length, int sort, SpdString name)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c%s%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR,
			sort, SDB_ATTR_SEPARATOR,
			name, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		spdWriteIntAttrBinary(fp, sort);
		fputs(name, fp);
		fputc('\0', fp);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_constant_sub(FILE *fp, int id, int length, int type, SpdString value)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c%s%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR,
			type, SDB_ATTR_SEPARATOR,
			value, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		spdWriteIntAttrBinary(fp, type);
		fputs(value, fp);
		fputc('\0', fp);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_type_sub(FILE *fp, int id, int sort, int qualifier, int type, int size, int sign, SpdString name)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c%d%c%d%c%d%c%s%c\n",
			id, SDB_ATTR_SEPARATOR,
			sort, SDB_ATTR_SEPARATOR,
			qualifier, SDB_ATTR_SEPARATOR,
			type, SDB_ATTR_SEPARATOR,
			size, SDB_ATTR_SEPARATOR,
			sign, SDB_ATTR_SEPARATOR,
			name, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, sort);
		spdWriteIntAttrBinary(fp, qualifier);
		spdWriteIntAttrBinary(fp, type);
		spdWriteIntAttrBinary(fp, size);
		spdWriteIntAttrBinary(fp, sign);
		fputs(name, fp);
		fputc('\0', fp);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_operator_sub(FILE *fp, int id, int length, int sort)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR,
			sort, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		spdWriteIntAttrBinary(fp, sort);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_library_sub(FILE *fp, int id, SpdString name)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%s%c\n",
			id, SDB_ATTR_SEPARATOR,
			name, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		fputs(name, fp);
		fputc('\0', fp);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_blk_blk_sub(FILE *fp, int parent_block_id, int children_block_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			parent_block_id, SDB_ATTR_SEPARATOR,
			children_block_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, parent_block_id);
		spdWriteIntAttrBinary(fp, children_block_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_blk_decl_sub(FILE *fp, int parent_block_id, int children_declaration_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			parent_block_id, SDB_ATTR_SEPARATOR,
			children_declaration_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, parent_block_id);
		spdWriteIntAttrBinary(fp, children_declaration_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_blk_expr_sub(FILE *fp, int parent_block_id, int children_expression_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			parent_block_id, SDB_ATTR_SEPARATOR,
			children_expression_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, parent_block_id);
		spdWriteIntAttrBinary(fp, children_expression_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_blk_label_sub(FILE *fp, int block_id, int label_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			block_id, SDB_ATTR_SEPARATOR,
			label_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, block_id);
		spdWriteIntAttrBinary(fp, label_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_case_cexpr_sub(FILE *fp, int label_id, int expression_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			label_id, SDB_ATTR_SEPARATOR,
			expression_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, label_id);
		spdWriteIntAttrBinary(fp, expression_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_const_ref_sub(FILE *fp, int expression_id, int const_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			expression_id, SDB_ATTR_SEPARATOR,
			const_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, expression_id);
		spdWriteIntAttrBinary(fp, const_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_decl_decl_sub(FILE *fp, int declaration_id, int declarator_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			declaration_id, SDB_ATTR_SEPARATOR,
			declarator_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, declaration_id);
		spdWriteIntAttrBinary(fp, declarator_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_decl_ident_sub(FILE *fp, int declarator_id, int identifier_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			declarator_id, SDB_ATTR_SEPARATOR,
			identifier_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, declarator_id);
		spdWriteIntAttrBinary(fp, identifier_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_decl_opt_sub(FILE *fp, int declarator_id, int optionaldecl_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			declarator_id, SDB_ATTR_SEPARATOR,
			optionaldecl_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, declarator_id);
		spdWriteIntAttrBinary(fp, optionaldecl_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_decl_type_sub(FILE *fp, int declaration_id, int type_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			declaration_id, SDB_ATTR_SEPARATOR,
			type_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, declaration_id);
		spdWriteIntAttrBinary(fp, type_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_expr_expr_sub(FILE *fp, int outer_expression_id, int inner_expression_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			outer_expression_id, SDB_ATTR_SEPARATOR,
			inner_expression_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, outer_expression_id);
		spdWriteIntAttrBinary(fp, inner_expression_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_expr_op_sub(FILE *fp, int expression_id, int operator_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			expression_id, SDB_ATTR_SEPARATOR,
			operator_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, expression_id);
		spdWriteIntAttrBinary(fp, operator_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_expr_type_sub(FILE *fp, int expression_id, int type_id)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			expression_id, SDB_ATTR_SEPARATOR,
			type_id, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, expression_id);
		spdWriteIntAttrBinary(fp, type_id);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_file_decl_sub(FILE *fp, int file_id, int declaration_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			file_id, SDB_ATTR_SEPARATOR,
			declaration_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, file_id);
		spdWriteIntAttrBinary(fp, declaration_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_func_body_sub(FILE *fp, int function_id, int block_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			function_id, SDB_ATTR_SEPARATOR,
			block_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, function_id);
		spdWriteIntAttrBinary(fp, block_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_func_parm_sub(FILE *fp, int optionaldecl_id, int declaration_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			optionaldecl_id, SDB_ATTR_SEPARATOR,
			declaration_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, optionaldecl_id);
		spdWriteIntAttrBinary(fp, declaration_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_goto_label_sub(FILE *fp, int expression_id, int label_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			expression_id, SDB_ATTR_SEPARATOR,
			label_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, expression_id);
		spdWriteIntAttrBinary(fp, label_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_ident_ref_sub(FILE *fp, int expression_id, int identifier_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			expression_id, SDB_ATTR_SEPARATOR,
			identifier_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, expression_id);
		spdWriteIntAttrBinary(fp, identifier_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_ident_type_sub(FILE *fp, int identifier_id, int type_id)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			identifier_id, SDB_ATTR_SEPARATOR,
			type_id, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, identifier_id);
		spdWriteIntAttrBinary(fp, type_id);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_init_expr_sub(FILE *fp, int optionaldecl_id, int expression_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			optionaldecl_id, SDB_ATTR_SEPARATOR,
			expression_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, optionaldecl_id);
		spdWriteIntAttrBinary(fp, expression_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_op_type_sub(FILE *fp, int operator_id, int type_id)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			operator_id, SDB_ATTR_SEPARATOR,
			type_id, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, operator_id);
		spdWriteIntAttrBinary(fp, type_id);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_prog_file_sub(FILE *fp, int program_id, int file_id)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			program_id, SDB_ATTR_SEPARATOR,
			file_id, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, program_id);
		spdWriteIntAttrBinary(fp, file_id);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_struct_decl_sub(FILE *fp, int optionaldecl_id, int declaration_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			optionaldecl_id, SDB_ATTR_SEPARATOR,
			declaration_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, optionaldecl_id);
		spdWriteIntAttrBinary(fp, declaration_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_type_cexpr_sub(FILE *fp, int type_id, int expression_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			type_id, SDB_ATTR_SEPARATOR,
			expression_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, type_id);
		spdWriteIntAttrBinary(fp, expression_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_type_is_sub(FILE *fp, int type_id, int identifier_id)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			type_id, SDB_ATTR_SEPARATOR,
			identifier_id, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, type_id);
		spdWriteIntAttrBinary(fp, identifier_id);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_type_st_sub(FILE *fp, int type_pointer_id, int type_pointed_id)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			type_pointer_id, SDB_ATTR_SEPARATOR,
			type_pointed_id, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, type_pointer_id);
		spdWriteIntAttrBinary(fp, type_pointed_id);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_prot_parm_sub(FILE *fp, int optionaldecl_id, int declaration_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			optionaldecl_id, SDB_ATTR_SEPARATOR,
			declaration_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, optionaldecl_id);
		spdWriteIntAttrBinary(fp, declaration_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_funcptr_parm_sub(FILE *fp, int optionaldecl_id, int declaration_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			optionaldecl_id, SDB_ATTR_SEPARATOR,
			declaration_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, optionaldecl_id);
		spdWriteIntAttrBinary(fp, declaration_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_decr_type_sub(FILE *fp, int declarator_id, int type_id)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			declarator_id, SDB_ATTR_SEPARATOR,
			type_id, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, declarator_id);
		spdWriteIntAttrBinary(fp, type_id);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_prog_lib_sub(FILE *fp, int program_id, int library_id)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			program_id, SDB_ATTR_SEPARATOR,
			library_id, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, program_id);
		spdWriteIntAttrBinary(fp, library_id);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_lib_file_sub(FILE *fp, int library_id, int file_id)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			library_id, SDB_ATTR_SEPARATOR,
			file_id, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, library_id);
		spdWriteIntAttrBinary(fp, file_id);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_pfile_sub(FILE *fp, int id, SpdString name)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%s%c\n",
			id, SDB_ATTR_SEPARATOR,
			name, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		fputs(name, fp);
		fputc('\0', fp);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_pblock_sub(FILE *fp, int id, int length, int sort)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR,
			sort, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		spdWriteIntAttrBinary(fp, sort);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_macroPattern_sub(FILE *fp, int id, int length)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_macroBody_sub(FILE *fp, int id, int length, SpdString name)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%s%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR,
			name, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		fputs(name, fp);
		fputc('\0', fp);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_macroName_sub(FILE *fp, int id, int length, SpdString name)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%s%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR,
			name, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		fputs(name, fp);
		fputc('\0', fp);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_macroOptional_sub(FILE *fp, int id, int length)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_macroDeclArg_sub(FILE *fp, int id, int length, SpdString name)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%s%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR,
			name, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		fputs(name, fp);
		fputc('\0', fp);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_macroCall_sub(FILE *fp, int id, int length)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_macroCallArg_sub(FILE *fp, int id, int length, SpdString name)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%s%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR,
			name, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		fputs(name, fp);
		fputc('\0', fp);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_hfile_sub(FILE *fp, int id, int length, int sort, SpdString name)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c%s%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR,
			sort, SDB_ATTR_SEPARATOR,
			name, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		spdWriteIntAttrBinary(fp, sort);
		fputs(name, fp);
		fputc('\0', fp);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_iblock_sub(FILE *fp, int id, int length)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			id, SDB_ATTR_SEPARATOR,
			length, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, id);
		spdWriteIntAttrBinary(fp, length);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_file_block_sub(FILE *fp, int pfile_id, int pblock_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			pfile_id, SDB_ATTR_SEPARATOR,
			pblock_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, pfile_id);
		spdWriteIntAttrBinary(fp, pblock_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_call_mcall_sub(FILE *fp, int pblock_id, int macroCall_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			pblock_id, SDB_ATTR_SEPARATOR,
			macroCall_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, pblock_id);
		spdWriteIntAttrBinary(fp, macroCall_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_mbody_mcall_sub(FILE *fp, int macroBody_id, int macroCall_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			macroBody_id, SDB_ATTR_SEPARATOR,
			macroCall_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, macroBody_id);
		spdWriteIntAttrBinary(fp, macroCall_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_mcall_mname_sub(FILE *fp, int macroCall_id, int macroName_id)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			macroCall_id, SDB_ATTR_SEPARATOR,
			macroName_id, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, macroCall_id);
		spdWriteIntAttrBinary(fp, macroName_id);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_mcall_mcalla_sub(FILE *fp, int macroCall_id, int macroCallArg_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			macroCall_id, SDB_ATTR_SEPARATOR,
			macroCallArg_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, macroCall_id);
		spdWriteIntAttrBinary(fp, macroCallArg_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_def_mpatt_sub(FILE *fp, int pblock_id, int macroPattern_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			pblock_id, SDB_ATTR_SEPARATOR,
			macroPattern_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, pblock_id);
		spdWriteIntAttrBinary(fp, macroPattern_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_def_mbody_sub(FILE *fp, int pblock_id, int macroBody_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			pblock_id, SDB_ATTR_SEPARATOR,
			macroBody_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, pblock_id);
		spdWriteIntAttrBinary(fp, macroBody_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_mpatt_mname_sub(FILE *fp, int macroPattern_id, int macroName_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			macroPattern_id, SDB_ATTR_SEPARATOR,
			macroName_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, macroPattern_id);
		spdWriteIntAttrBinary(fp, macroName_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_mpatt_mopt_sub(FILE *fp, int macroPattern_id, int macroOptional_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			macroPattern_id, SDB_ATTR_SEPARATOR,
			macroOptional_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, macroPattern_id);
		spdWriteIntAttrBinary(fp, macroOptional_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_mopt_mdecla_sub(FILE *fp, int macroOptional_id, int macroDeclArg_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			macroOptional_id, SDB_ATTR_SEPARATOR,
			macroDeclArg_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, macroOptional_id);
		spdWriteIntAttrBinary(fp, macroDeclArg_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_mbody_mdecla_sub(FILE *fp, int macroBody_id, int macroDeclArg_id, int order, int skip, int sharp)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c%d%c%d%c\n",
			macroBody_id, SDB_ATTR_SEPARATOR,
			macroDeclArg_id, SDB_ATTR_SEPARATOR,
			order, SDB_ATTR_SEPARATOR,
			skip, SDB_ATTR_SEPARATOR,
			sharp, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, macroBody_id);
		spdWriteIntAttrBinary(fp, macroDeclArg_id);
		spdWriteIntAttrBinary(fp, order);
		spdWriteIntAttrBinary(fp, skip);
		spdWriteIntAttrBinary(fp, sharp);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_incld_hfile_sub(FILE *fp, int pblock_id, int hfile_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			pblock_id, SDB_ATTR_SEPARATOR,
			hfile_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, pblock_id);
		spdWriteIntAttrBinary(fp, hfile_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_hfile_file_sub(FILE *fp, int hfile_id, int pfile_id)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			hfile_id, SDB_ATTR_SEPARATOR,
			pfile_id, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, hfile_id);
		spdWriteIntAttrBinary(fp, pfile_id);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_mcalla_mcall_sub(FILE *fp, int macroCallArg_id, int macroCall_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			macroCallArg_id, SDB_ATTR_SEPARATOR,
			macroCall_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, macroCallArg_id);
		spdWriteIntAttrBinary(fp, macroCall_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_cfile_ifile_sub(FILE *fp, int pfile_id, int file_id)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			pfile_id, SDB_ATTR_SEPARATOR,
			file_id, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, pfile_id);
		spdWriteIntAttrBinary(fp, file_id);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_ifile_iblock_sub(FILE *fp, int file_id, int iblock_id, int offset)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c%d%c\n",
			file_id, SDB_ATTR_SEPARATOR,
			iblock_id, SDB_ATTR_SEPARATOR,
			offset, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, file_id);
		spdWriteIntAttrBinary(fp, iblock_id);
		spdWriteIntAttrBinary(fp, offset);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void write_pblock_iblock_sub(FILE *fp, int pblock_id, int iblock_id)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		fprintf(fp, "%d%c%d%c\n",
			pblock_id, SDB_ATTR_SEPARATOR,
			iblock_id, SDB_ATTR_SEPARATOR);
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		spdWriteIntAttrBinary(fp, pblock_id);
		spdWriteIntAttrBinary(fp, iblock_id);
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

/* FuncB. */

void spdWriteDBObj(FILE *fp, SpdDBObj *obj)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		switch (spdGetClassId((SpdObjId)(obj->Obj_id))) {
		  case SPD_CID_PROGRAM:
			fprintf(fp, "%d%c%s%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->svalue[0], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_FILE:
			fprintf(fp, "%d%c%s%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->svalue[0], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_DECLARATION:
			fprintf(fp, "%d%c%d%c%d%c%d%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->ivalue[2], SDB_ATTR_SEPARATOR,
				obj->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_DECLARATOR:
			fprintf(fp, "%d%c%d%c%d%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_IDENTIFIER:
			fprintf(fp, "%d%c%d%c%d%c%d%c%s%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->ivalue[2], SDB_ATTR_SEPARATOR,
				obj->ivalue[3], SDB_ATTR_SEPARATOR,
				obj->svalue[0], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_OPTIONALDECL:
			fprintf(fp, "%d%c%d%c%d%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_BLOCK:
			fprintf(fp, "%d%c%d%c%d%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_EXPRESSION:
			fprintf(fp, "%d%c%d%c%d%c%d%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->ivalue[2], SDB_ATTR_SEPARATOR,
				obj->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_LABEL:
			fprintf(fp, "%d%c%d%c%d%c%s%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->ivalue[2], SDB_ATTR_SEPARATOR,
				obj->svalue[0], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_CONSTANT:
			fprintf(fp, "%d%c%d%c%d%c%s%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->ivalue[2], SDB_ATTR_SEPARATOR,
				obj->svalue[0], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_TYPE:
			fprintf(fp, "%d%c%d%c%d%c%d%c%d%c%d%c%s%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->ivalue[2], SDB_ATTR_SEPARATOR,
				obj->ivalue[3], SDB_ATTR_SEPARATOR,
				obj->ivalue[4], SDB_ATTR_SEPARATOR,
				obj->ivalue[5], SDB_ATTR_SEPARATOR,
				obj->svalue[0], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_OPERATOR:
			fprintf(fp, "%d%c%d%c%d%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_LIBRARY:
			fprintf(fp, "%d%c%s%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->svalue[0], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_PFILE:
			fprintf(fp, "%d%c%s%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->svalue[0], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_PBLOCK:
			fprintf(fp, "%d%c%d%c%d%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_MACROPATTERN:
			fprintf(fp, "%d%c%d%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_MACROBODY:
			fprintf(fp, "%d%c%d%c%s%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->svalue[0], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_MACRONAME:
			fprintf(fp, "%d%c%d%c%s%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->svalue[0], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_MACROOPTIONAL:
			fprintf(fp, "%d%c%d%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_MACRODECLARG:
			fprintf(fp, "%d%c%d%c%s%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->svalue[0], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_MACROCALL:
			fprintf(fp, "%d%c%d%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_MACROCALLARG:
			fprintf(fp, "%d%c%d%c%s%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->svalue[0], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_HFILE:
			fprintf(fp, "%d%c%d%c%d%c%s%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR,
				obj->ivalue[2], SDB_ATTR_SEPARATOR,
				obj->svalue[0], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_CID_IBLOCK:
			fprintf(fp, "%d%c%d%c\n",
				obj->ivalue[0], SDB_ATTR_SEPARATOR,
				obj->ivalue[1], SDB_ATTR_SEPARATOR);
			break;
		  default:
			spdErrorExit("Invalid class Id.\n");
			break;
		}
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		switch (spdGetClassId((SpdObjId)(obj->Obj_id))) {
		  case SPD_CID_PROGRAM:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			fputs(obj->svalue[0], fp);
			fputc('\0', fp);
			break;
		  case SPD_CID_FILE:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			fputs(obj->svalue[0], fp);
			fputc('\0', fp);
			break;
		  case SPD_CID_DECLARATION:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			spdWriteIntAttrBinary(fp, obj->ivalue[2]);
			spdWriteIntAttrBinary(fp, obj->ivalue[3]);
			break;
		  case SPD_CID_DECLARATOR:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			spdWriteIntAttrBinary(fp, obj->ivalue[2]);
			break;
		  case SPD_CID_IDENTIFIER:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			spdWriteIntAttrBinary(fp, obj->ivalue[2]);
			spdWriteIntAttrBinary(fp, obj->ivalue[3]);
			fputs(obj->svalue[0], fp);
			fputc('\0', fp);
			break;
		  case SPD_CID_OPTIONALDECL:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			spdWriteIntAttrBinary(fp, obj->ivalue[2]);
			break;
		  case SPD_CID_BLOCK:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			spdWriteIntAttrBinary(fp, obj->ivalue[2]);
			break;
		  case SPD_CID_EXPRESSION:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			spdWriteIntAttrBinary(fp, obj->ivalue[2]);
			spdWriteIntAttrBinary(fp, obj->ivalue[3]);
			break;
		  case SPD_CID_LABEL:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			spdWriteIntAttrBinary(fp, obj->ivalue[2]);
			fputs(obj->svalue[0], fp);
			fputc('\0', fp);
			break;
		  case SPD_CID_CONSTANT:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			spdWriteIntAttrBinary(fp, obj->ivalue[2]);
			fputs(obj->svalue[0], fp);
			fputc('\0', fp);
			break;
		  case SPD_CID_TYPE:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			spdWriteIntAttrBinary(fp, obj->ivalue[2]);
			spdWriteIntAttrBinary(fp, obj->ivalue[3]);
			spdWriteIntAttrBinary(fp, obj->ivalue[4]);
			spdWriteIntAttrBinary(fp, obj->ivalue[5]);
			fputs(obj->svalue[0], fp);
			fputc('\0', fp);
			break;
		  case SPD_CID_OPERATOR:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			spdWriteIntAttrBinary(fp, obj->ivalue[2]);
			break;
		  case SPD_CID_LIBRARY:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			fputs(obj->svalue[0], fp);
			fputc('\0', fp);
			break;
		  case SPD_CID_PFILE:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			fputs(obj->svalue[0], fp);
			fputc('\0', fp);
			break;
		  case SPD_CID_PBLOCK:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			spdWriteIntAttrBinary(fp, obj->ivalue[2]);
			break;
		  case SPD_CID_MACROPATTERN:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			break;
		  case SPD_CID_MACROBODY:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			fputs(obj->svalue[0], fp);
			fputc('\0', fp);
			break;
		  case SPD_CID_MACRONAME:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			fputs(obj->svalue[0], fp);
			fputc('\0', fp);
			break;
		  case SPD_CID_MACROOPTIONAL:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			break;
		  case SPD_CID_MACRODECLARG:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			fputs(obj->svalue[0], fp);
			fputc('\0', fp);
			break;
		  case SPD_CID_MACROCALL:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			break;
		  case SPD_CID_MACROCALLARG:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			fputs(obj->svalue[0], fp);
			fputc('\0', fp);
			break;
		  case SPD_CID_HFILE:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			spdWriteIntAttrBinary(fp, obj->ivalue[2]);
			fputs(obj->svalue[0], fp);
			fputc('\0', fp);
			break;
		  case SPD_CID_IBLOCK:
			spdWriteIntAttrBinary(fp, obj->ivalue[0]);
			spdWriteIntAttrBinary(fp, obj->ivalue[1]);
			break;
		  default:
			spdErrorExit("Invalid class Id.\n");
			break;
		}
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

void spdWriteDBRel(FILE *fp, SpdDBRel *rel)
{
	switch (spdGetWriteSDBformat()) {
	  case SAPID_TEXT_FORMAT_SDB:
		switch (spdGetClassId((SpdRelId)(rel->Rel_id))) {
		  case SPD_RID_BLK_BLK:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_BLK_DECL:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_BLK_EXPR:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_BLK_LABEL:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_CASE_CEXPR:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_CONST_REF:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_DECL_DECL:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_DECL_IDENT:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_DECL_OPT:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_DECL_TYPE:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_EXPR_EXPR:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_EXPR_OP:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_EXPR_TYPE:
			fprintf(fp, "%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_FILE_DECL:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_FUNC_BODY:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_FUNC_PARM:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_GOTO_LABEL:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_IDENT_REF:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_IDENT_TYPE:
			fprintf(fp, "%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_INIT_EXPR:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_OP_TYPE:
			fprintf(fp, "%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_PROG_FILE:
			fprintf(fp, "%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_STRUCT_DECL:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_TYPE_CEXPR:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_TYPE_IS:
			fprintf(fp, "%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_TYPE_ST:
			fprintf(fp, "%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_PROT_PARM:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_FUNCPTR_PARM:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_DECR_TYPE:
			fprintf(fp, "%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_PROG_LIB:
			fprintf(fp, "%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_LIB_FILE:
			fprintf(fp, "%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_FILE_BLOCK:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_CALL_MCALL:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_MBODY_MCALL:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_MCALL_MNAME:
			fprintf(fp, "%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_MCALL_MCALLA:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_DEF_MPATT:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_DEF_MBODY:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_MPATT_MNAME:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_MPATT_MOPT:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_MOPT_MDECLA:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_MBODY_MDECLA:
			fprintf(fp, "%d%c%d%c%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR,
				rel->ivalue[4], SDB_ATTR_SEPARATOR,
				rel->ivalue[5], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_INCLD_HFILE:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_HFILE_FILE:
			fprintf(fp, "%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_MCALLA_MCALL:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_CFILE_IFILE:
			fprintf(fp, "%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_IFILE_IBLOCK:
			fprintf(fp, "%d%c%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR,
				rel->ivalue[3], SDB_ATTR_SEPARATOR);
			break;
		  case SPD_RID_PBLOCK_IBLOCK:
			fprintf(fp, "%d%c%d%c\n",
				rel->ivalue[1], SDB_ATTR_SEPARATOR,
				rel->ivalue[2], SDB_ATTR_SEPARATOR);
			break;
		  default:
			spdErrorExit("Invalid class Id.\n");
			break;
		}
		break;
	  case SAPID_BINARY_FORMAT_SDB:
		switch (spdGetClassId((SpdRelId)(rel->Rel_id))) {
		  case SPD_RID_BLK_BLK:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_BLK_DECL:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_BLK_EXPR:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_BLK_LABEL:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_CASE_CEXPR:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_CONST_REF:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_DECL_DECL:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_DECL_IDENT:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_DECL_OPT:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_DECL_TYPE:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_EXPR_EXPR:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_EXPR_OP:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_EXPR_TYPE:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			break;
		  case SPD_RID_FILE_DECL:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_FUNC_BODY:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_FUNC_PARM:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_GOTO_LABEL:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_IDENT_REF:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_IDENT_TYPE:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			break;
		  case SPD_RID_INIT_EXPR:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_OP_TYPE:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			break;
		  case SPD_RID_PROG_FILE:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			break;
		  case SPD_RID_STRUCT_DECL:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_TYPE_CEXPR:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_TYPE_IS:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			break;
		  case SPD_RID_TYPE_ST:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			break;
		  case SPD_RID_PROT_PARM:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_FUNCPTR_PARM:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_DECR_TYPE:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			break;
		  case SPD_RID_PROG_LIB:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			break;
		  case SPD_RID_LIB_FILE:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			break;
		  case SPD_RID_FILE_BLOCK:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_CALL_MCALL:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_MBODY_MCALL:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_MCALL_MNAME:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			break;
		  case SPD_RID_MCALL_MCALLA:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_DEF_MPATT:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_DEF_MBODY:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_MPATT_MNAME:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_MPATT_MOPT:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_MOPT_MDECLA:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_MBODY_MDECLA:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			spdWriteIntAttrBinary(fp, rel->ivalue[4]);
			spdWriteIntAttrBinary(fp, rel->ivalue[5]);
			break;
		  case SPD_RID_INCLD_HFILE:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_HFILE_FILE:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			break;
		  case SPD_RID_MCALLA_MCALL:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_CFILE_IFILE:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			break;
		  case SPD_RID_IFILE_IBLOCK:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			spdWriteIntAttrBinary(fp, rel->ivalue[3]);
			break;
		  case SPD_RID_PBLOCK_IBLOCK:
			spdWriteIntAttrBinary(fp, rel->ivalue[1]);
			spdWriteIntAttrBinary(fp, rel->ivalue[2]);
			break;
		  default:
			spdErrorExit("Invalid class Id.\n");
			break;
		}
		break;
	  default:
		spdErrorExit("Invalid write format.\n");
		break;
	}
}

