/* 
 * Program:             $RCSfile: Jx2Html.java,v $  $Revision: 50.35 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hotta  2003/09/02
 *                      S.Yamamoto  2003/09/02
 *
 * (C) Copyright:       Y.Hotta and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/*
 * $Id: Jx2Html.java,v 50.35 2003/11/09 12:37:08 yamamoto Exp yamamoto $
 */

/*
 * Problem:
 * (1) Netscape<a name="foo" />λʤ褦ǧ뤿ᡤ
 * Ū<a name="foo"></a>Ȥ.
 */

package JXModel3.jx2html;

import javax.xml.parsers.*;
import org.w3c.dom.*;
import java.io.*;
import java.util.regex.*;
import java.util.Hashtable;
import gnu.getopt.*;
import sapid.util.*;

class Jx2Html {
    static StringBuffer sb = new StringBuffer();
    static Hashtable hasharray = new Hashtable();

    // üζԤο.
    private static final int TRAILING_LINE_NUM = 100;

    static int linenum = 1;
    static int allline = 0;
    static int alllinelength = 0;
    static int numQName = 0;

    static String type = "";
    static String typetmp = "";
    static String typeid = "";
    static String typeidtmp = "";

    static String outfile;
    static String infile;
    static String mode;
    static boolean debug;
    static boolean noheader = false;
    static String encode;
    static String path;

    // Added by T.Takahashi 2003/10/21.
    static boolean jsoutput = false;

    static void setLineNum() {
        linenum++;
    }

    static void setAllLine() {
        int hoge = allline;
        do {
            alllinelength++;
            hoge = hoge / 10;
        } while (hoge != 0);
    }

    static String getLineNum(int i) {
        linenum++;
        String s = Integer.toString(i);
        int linelength = 0;
        int hoge = i;
        do {
            linelength++;
            hoge = hoge / 10;
        } while (hoge != 0);
        if (alllinelength < 5) {
            alllinelength = 5;
        }
        int j = alllinelength - linelength;
        for (int k = 1; k < j; k++) {
            s = " " + s;
        }
        return s;
    }

    static void checkOption(String[] args, int argslen) {
        int c;
        Getopt g = new Getopt("Jx2Html", args, "avot:n");
        while ((c = g.getopt()) != -1) {
            switch (c) {
            case 't':
                path = g.getOptarg();
                path += "/";
                break;
            case 'a':
                mode = "A";
                break;
            case 'v':
                debug = true;
                break;
            case 'n':
                noheader = true;
                break;
            case 'o':     // Added by T.Takahashi 2003/10/21.
                jsoutput = true;
            default:
                break;
            }
        }
        if (mode == null) {
            mode = "noA";
        }
        if (debug) {
            System.out.println("Jx2Html Mode: " + mode);
        }
        argslen -= g.getOptind();
        if (argslen >= 1) {
            infile = args[g.getOptind() + 0];
            if (argslen >= 2) {
                outfile = args[g.getOptind() + 1];
            } else {
                outfile = null;
            }
        }
    }
    public static void main(String[] args) throws Exception {
        path = "";

        checkOption(args, args.length);

        Document doc = null;

        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = dbf.newDocumentBuilder();

        // XMLեμ.
        doc = db.parse(new File(infile));

        //Կμ
        NodeList lst = doc.getElementsByTagName("nl");
        int aln = lst.getLength() - 1;
        if (aln > -1) {
            Node n = lst.item(aln);
            NamedNodeMap attrlist = n.getAttributes();
            Node attr = attrlist.getNamedItem("line");
            allline = Integer.parseInt(attr.getNodeValue());
        } else {
            allline = 1;
        }
        setAllLine();

        // 롼Ǥ.
        Element root = doc.getDocumentElement();

        // ѥå٤.
        int packageDepth;
        NodeList packagelist = root.getElementsByTagName("Package");
        if (packagelist.getLength() > 0) {
            Node pack = packagelist.item(0);
            walkQName(pack);
            packageDepth = numQName / 2 + 1;
        } else {
            packageDepth = 0;
        }
        String ppath ="";
        for (int i = 0; i < packageDepth; i++) {
            ppath += "../";
        }
        encode = SpdEncoding.getEncoding(infile).toString();
        if (!noheader) {
            // 롼ǳϥ.
            sb.append("<?xml version=\"1.0\" encoding=\"" + encode + "\" ?>\n");
            sb.append("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n");
            sb.append("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\" lang=\"ja\">\n");
            sb.append("<head>\n");
            sb.append("<title>" + infile.substring(0, infile.length() - 4) + "</title>\n");
            sb.append("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" +
                      encode + "\" />\n");
            sb.append("<meta http-equiv=\"Content-Style-Type\" content=\"text/css\" />\n");

            // Added by T.Takahashi 2003/10/21.
            if (jsoutput) {
                sb.append("<meta http-equiv=\"Content-Script-Type\" content=\"text/javascript\">\n");
            }

            sb.append("<link rel=\"stylesheet\" href=\"" + ppath + "Jx2Html.css\" type=\"text/css\" />\n");

            // Added by T.Takahashi 2003/10/21.
            if (jsoutput) {
                sb.append("<script src=\"" + ppath + path + "js/display.js\" type=\"text/javascript\"></script>\n");
                sb.append("<script src=\"" + ppath + path + "js/deploy.js\" type=\"text/javascript\"></script>\n");
                sb.append("<script src=\"" + ppath + path + "js/ref.js\" type=\"text/javascript\"></script>\n");
                sb.append("<script src=\"" + ppath + path + "js/scroll.js\" type=\"text/javascript\"></script>\n");
                sb.append("<script src=\"" + ppath + path + "js/drag.js\" type=\"text/javascript\"></script>\n");
            }

            sb.append("</head>\n");
            sb.append("<body>\n");
        }
        sb.append("<pre>\n");
        if (mode.equals("A")) {
            //sb.append("<a name =\"l"+linenum+"\" />");
            // Modified by T.Takahashi 2003/10/21.
            sb.append("<a " + (jsoutput ? "id" : "name") + "=\"l" + linenum + "\"></a>");
        }
        sb.append("<span class=\"linenum\">" + getLineNum(1) + ": </span>");

        // ʸϤ򤿤ɤ.
        walk(root);

        // 롼ǽλ.
        for (int i = 1; i < TRAILING_LINE_NUM; i++) {
            sb.append("\n");
        }
        sb.append("\n</pre>\n");
        if (!noheader) {
            sb.append("\n</body>\n</html>\n");
        }

        // ʸ񤭽Ф.
        if (outfile != null) {
            FileOutputStream fos = new FileOutputStream(new File(outfile));
            OutputStreamWriter osw = new OutputStreamWriter(fos, encode);
            osw.write(sb.toString());
            osw.close();
        } else {
            System.out.println(sb);
        }
    }

    static void setType(String s, String t) {
        if (t.equals("type") || t.equals("expr_method") || t.equals("expr_var")) {
            typetmp = type;
            typeidtmp = typeid;
            if (t.equals("type")) {
                hasharray.put(t, s);
            }
        } else if (s.equals("field") || s.equals("local") || s.equals("param")) {
            hasharray.put(t, s);
        }
        type = s;
        typeid = t;
    }

    static String getType(String s) {
        if (s.equals(typeid)) {
            String type_ = type;
            type = "";
            typeid = "";
            return type_;
        } else if (typeid.equals("type")) {
            String type_ = (String)hasharray.get(s);
            if (type_ == null) {
                type_ = "class";
            }
            type = typetmp;
            typeid = typeidtmp;
            return type_;
        } else if (typeid.equals("expr_method")) {
            String type_ = type;
            type = typetmp;
            typeid = typeidtmp;
            return type_;
        } else if (typeid.equals("expr_var")) {
            String type_ = (String)hasharray.get(s);
            if (type_ == null) {
                type_ = "field";
            }
            type = typetmp;
            typeid = typeidtmp;
            return type_;
        } else {
            return "other";
        }

    }

    static String checkAnchor(String m, String val) {
        if (m.equals("A")) {
            //return "<a name=\""+val+"\" />";
            // Modified by T.Takahashi 2003/10/21.
            return "<a " + (jsoutput ? "id" : "name") + "=\"" + val + "\"></a>";
        } else {
            return "";
        }
    }
    static void walkQName(Node n) {
        for (Node ch = n.getFirstChild(); ch != null; ch = ch.getNextSibling()) {
            if (ch.getNodeName().equals("QName")) {
                numQName++;
                walkQName(ch);
            }
        }
    }
    // ΡɤλҤ򤿤ɤ.
    static void walk(Node n) {
        for (Node ch = n.getFirstChild(); ch != null; ch = ch.getNextSibling()) {
            //Ǥ
            if (ch.getNodeType() == Node.ELEMENT_NODE) {
                if (ch.getNodeName().equals("Class")) {
                    NamedNodeMap attrlist = ch.getAttributes();
                    Node attr = attrlist.getNamedItem("id");
                    setType("class", attr.getNodeValue());
                    sb.append(checkAnchor(mode, attr.getNodeValue()));
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("Package")) {
                    NamedNodeMap attrlist = ch.getAttributes();
                    Node attr = attrlist.getNamedItem("id");
                    sb.append(checkAnchor(mode, attr.getNodeValue()));
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("Intf")) {
                    NamedNodeMap attrlist = ch.getAttributes();
                    Node attr = attrlist.getNamedItem("id");
                    setType("intf", attr.getNodeValue());
                    sb.append(checkAnchor(mode, attr.getNodeValue()));
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("Import")) {
                    NamedNodeMap attrlist = ch.getAttributes();
                    Node attr = attrlist.getNamedItem("id");
                    sb.append(checkAnchor(mode, attr.getNodeValue()));
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("ImplOpt")) {
                    sb.append("");
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("ExtdOpt")) {
                    sb.append("");
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("ThrwOpt")) {
                    sb.append("");
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("Ctor")) {
                    NamedNodeMap attrlist = ch.getAttributes();
                    Node attr = attrlist.getNamedItem("id");
                    setType("method", attr.getNodeValue());
                    sb.append(checkAnchor(mode, attr.getNodeValue()));
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("SInit")) {
                    sb.append("");
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("Field")) {
                    NamedNodeMap attrlist = ch.getAttributes();
                    Node attr = attrlist.getNamedItem("id");
                    setType("field", attr.getNodeValue());
                    sb.append(checkAnchor(mode, attr.getNodeValue()));
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("Local")) {
                    NamedNodeMap attrlist = ch.getAttributes();
                    Node attr = attrlist.getNamedItem("id");
                    setType("local", attr.getNodeValue());
                    sb.append(checkAnchor(mode, attr.getNodeValue()));
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("literal")) {
                    sb.append("<span class=\"literal\">");
                    walk(ch);
                    sb.append("</span>");
                } else if (ch.getNodeName().equals("kw")) {
                    sb.append("<span class=\"keyword\">");
                    walk(ch);
                    sb.append("</span>");
                } else if (ch.getNodeName().equals("Members")) {
                    sb.append("");
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("Method")) {
                    NamedNodeMap attrlist = ch.getAttributes();
                    Node attr = attrlist.getNamedItem("id");
                    setType("method", attr.getNodeValue());
                    sb.append(checkAnchor(mode, attr.getNodeValue()));
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("Param")) {
                    NamedNodeMap attrlist = ch.getAttributes();
                    Node attr = attrlist.getNamedItem("id");
                    setType("param", attr.getNodeValue());
                    sb.append(checkAnchor(mode, attr.getNodeValue()));
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("Stmt")) {
                    sb.append("");
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("Expr")) {
                    if (ch.hasAttributes()) {
                        NamedNodeMap attrlist = ch.getAttributes();
                        Node attr = attrlist.getNamedItem("sort");
                        if (attr.getNodeValue().equals("MethodCall")) {
                            setType("method", "expr_method");
                        } else if (attr.getNodeValue().equals("VarRef")) {
                            setType("hoge", "expr_var");
                        }
                    }
                    sb.append("");
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("Label")) {
                    sb.append("");
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("comment")) {
                    sb.append("<span class=\"comment\">");
                    walk(ch);
                    sb.append("</span>");
                } else if (ch.getNodeName().equals("Type")) {
                    if (ch.hasAttributes()) {
                        NamedNodeMap attrlist = ch.getAttributes();
                        Node attr = attrlist.getNamedItem("sort");
                        if (attr.getNodeValue().equals("Object")) {
                            setType("class", "type");
                        }
                    }
                    sb.append("");
                    walk(ch);
                    sb.append("");

                } else if (ch.getNodeName().equals("QName")) {
                    sb.append("");
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("op")) {
                    sb.append("<span class=\"op\">");
                    walk(ch);
                    sb.append("</span>");
                } else if (ch.getNodeName().equals("sp")) {
                    sb.append("");
                    walk(ch);
                    sb.append("");
                } else if (ch.getNodeName().equals("nl")) {
                    NamedNodeMap attrlist = ch.getAttributes();
                    Node attr = attrlist.getNamedItem("line");
                    int i = Integer.parseInt(attr.getNodeValue()) + 1;
                    if (i < allline + 1) {
                        sb.append("\n");
                        if (mode.equals("A")) {
                            //sb.append("<a name =\"l"+i+"\" />");
                            // Modified by T.Takahashi 2003/10/21.
                            sb.append("<a " + (jsoutput ? "id" : "name") + "=\"l" + i + "\"></a>");
                        }
                        sb.append("<span class=\"linenum\">" + getLineNum(i) + ": </span>");
                    }
                } else if (ch.getNodeName().equals("ident")) {
                    if (ch.hasAttributes()) {
                        NamedNodeMap attrlist = ch.getAttributes();
                        Node attr = attrlist.getNamedItem("defid");
                        if (mode.equals("A")) {
                            if (jsoutput) {
                                sb.append("<a href=\"javascript:ref('" +
                                          attr.getNodeValue() + "')");
                            } else {
                                sb.append("<a href=\"#" + attr.getNodeValue());
                            }
                            sb.append("\" class=\"" + getType(attr.getNodeValue()) + "\">");
                            walk(ch);
                            sb.append("</a>");
                        } else {
                            sb.append("<span class=\"" + getType(attr.getNodeValue()) + "\">");
                            walk(ch);
                            sb.append("</span>");
                        }
                    } else {
                        getType("foo");
                        walk(ch);
                    }

                }
            } else if (ch.getNodeType() == Node.TEXT_NODE) {
                // ƥȤ.
                String s = ch.getNodeValue();
                s = s.replaceAll("&", "&amp;");
                s = s.replaceAll("<", "&lt;");
                s = s.replaceAll(">", "&gt;");
                Pattern pattern = Pattern.compile("\n");
                String[] strings = pattern.split(s);
                s = strings[0];
                if (strings.length > 1) {
                    s += "</span>\n";
                    if (mode.equals("A")) {
                        //s += "<a name =\"l"+linenum+"\" />";
                        // Modified by T.Takahashi 2003/10/21.
                        s += "<a " + (jsoutput ? "id" : "name") + "=\"l" + linenum + "\"></a>";
                    }
                    s += "<span class=\"linenum\">";
                    s += getLineNum(linenum) + ": </span><span class=\"comment\">";
                }
                for (int i = 1; i < strings.length; i++) {
                    if (i == strings.length - 1) {
                        s += strings[i];
                    } else {
                        s += strings[i] + "</span>\n";
                        if (mode.equals("A")) {
                            //s += "<a name =\"l"+linenum+"\" />";
                            // Modified by T.Takahashi 2003/10/21.
                            s += "<a " + (jsoutput ? "id" : "name") + "=\"l" + linenum + "\"></a>";
                        }
                        s += "<span class=\"linenum\">";
                        s += getLineNum(linenum) + ": </span><span class=\"comment\">";
                    }
                }
                sb.append(s);
            }
        }
    }
}
