/* 
 * Program:             $RCSfile: MkSourceView.java,v $  $Revision: 50.3 $
 * 
 * Purpose:     
 *
 * Author:              T.Takahashi  2003/10/30
 *                      S..Yamamoto  2003/10/30
 *
 * (C) Copyright:       T.Takahashi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: MkSourceView.java,v 50.3 2003/11/26 23:25:19 yamamoto Exp yamamoto $
 */

package JXModel3.jx2html;

import gnu.getopt.*;

public class MkSourceView extends MkOutline{

    private String packageDir;

    public MkSourceView(String[] args)
    {
        super();
        packageDir = "./";
        parseOptions(args, args.length);
        setEncoding();
    }
    protected String makeHeader(String title, String css, String encoding)
    {
        return "<?xml version=\"1.0\" encoding=\"" + encoding + "\" ?>\n" +
            "<!DOCTYPE html " + 
            "PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" " +
            "\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n" +
            "<html xmlns=\"http://www.w3.org/1999/xhtml\" " +
            "xml:lang=\"ja\" lang=\"ja\">\n" +
            "  <head>\n" +
            "    <title>" + title + "</title>\n" +
            "    <meta http-equiv=\"Content-Type\" " +
            "content=\"text/html; charset=" + encoding + "\" />\n" +
            "    <meta http-equiv=\"Content-Style-Type\" " +
            "content=\"text/css\" />\n" +
            "    <meta http-equiv=\"Content-Script-Type\" " +
            "content=\"text/javascript\" />\n" +
            "    <link href=\"" + css +
            "\" type=\"text/css\" rel=\"stylesheet\" />\n" +
            "    <script src=\"" + topDir +
            "js/display.js\" type=\"text/javascript\"></script>\n" +
            "    <script src=\"" + topDir +
            "js/deploy.js\" type=\"text/javascript\"></script>\n" +
            "    <script src=\"" + topDir +
            "js/ref.js\" type=\"text/javascript\"></script>\n" +
            "    <script src=\"" + topDir +
            "js/scroll.js\" type=\"text/javascript\"></script>\n" +
            "    <script src=\"" + topDir +
            "js/drag.js\" type=\"text/javascript\"></script>\n" +
            "  </head>\n";
    }

    public boolean parseOptions(String args[], int argc)
    {
        int     ch;
        Getopt g = new Getopt("MkSourceView", args, "x:t:p:n");

        while ((ch = g.getopt()) != -1) {
            switch (ch) {
            case 'x':
                xsltPath = appendSlash(g.getOptarg());
                break;
            case 't':
                topDir = appendSlash(g.getOptarg());
                break;
            case 'p':
                packageDir = appendSlash(g.getOptarg());
                break;
            case 'n':
                noHeader = true;
                break;
            default:
                // print_usage(program_name);
                break;
            }
        }
        argc -= g.getOptind();
        switch (argc) {
        case 1:
            inFile = new String(args[g.getOptind()]);
            break;
        case 2:
            inFile = new String(args[g.getOptind()]);
            outFile = new String(args[g.getOptind() + 1]);
            break;
        default:
            System.err.println("command [options] InputFile [OutputFile]\n" +
                               "OPTOION:\n" +
                               " -x XSLTdir\n" +
                               " -t TOPdir\n" +
                               " -n\n");
            System.exit(1);
        }
        return true;
    }

    public static void main(String[] args)
    {
        MkSourceView mksv = new MkSourceView(args);

        String[] paramName  = { "packageDir" };
        String[] paramValue = { mksv.packageDir };

        mksv.xslTransform("sourceView.xsl", paramName, paramValue);

        String str = mksv.getStrBuf();
        int ln = Integer.parseInt(str.substring(0, str.indexOf(">")).
                                  replaceFirst("<!--([0]|[1-9][0-9]*)--",
                                               "$1"));
        if (!mksv.noHeader) {
            mksv.insert(0, "  <body>\n");
            mksv.insert(0, mksv.makeHeader("SourceView",
                                           "Jx2Html.css",
                                           mksv.getEncoding()));
        }

        mksv.append("\n    <div id=\"lineNum\">\n");

        for (int i = 1; i <= ln; i++) {
            mksv.append("      <a id=\"line" + i + "\" class=\"line\">" +
                        i + ":</a><br />\n");
        }
        mksv.append("    </div>\n");

        if (!mksv.noHeader) {
            mksv.append("  </body>\n" +
                        "</html>");
        }

        mksv.flushBuffer();
    }
}
