<?xml version="1.0" encoding="Shift_JIS"?>

<!--
# 
# Program:		$RCSfile: treeView.xsl,v $  $Revision: 53.14 $
# 
# Purpose:      
# 
# Author:		Y.Sawada  2003/10/01
# Author:		S.Yamamoto  2003/10/01
# 
# (C) Copyright:	Y.Sawada and S.Yamamoto  2003
#			This file is a product of the project Sapid.
# 
-->

<!--
    $Id: treeView.xsl,v 53.14 2003/11/22 12:20:14 yamamoto Exp yamamoto $
-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="xml" omit-xml-declaration="yes"/>

  <xsl:param name="topDir"/>

  <xsl:template match="/">
    <xsl:comment>
      <xsl:text>Package:</xsl:text>
      <xsl:value-of select="/File/Package/QName"/>
    </xsl:comment>
    <xsl:call-template name="newline"/>
    <xsl:apply-templates />
  </xsl:template>

  <xsl:template match="Import[1]">
    <xsl:element name="div">
      <xsl:call-template name="newline"/>
      <xsl:element name="a">
        <xsl:attribute name="href">
          <xsl:text>javascript:menu('import2','import1')</xsl:text>
        </xsl:attribute>
        <xsl:element name="img">
          <xsl:attribute name="id">
            <xsl:text>import1</xsl:text>
          </xsl:attribute>
          <xsl:attribute name="alt">
            <xsl:text>plus</xsl:text>
          </xsl:attribute>
          <xsl:attribute name="src">
            <!--<xsl:call-template name="setDepthWrapper"/>-->
            <xsl:value-of select="$topDir"/>
            <xsl:text>image/p.gif</xsl:text>
          </xsl:attribute>
        </xsl:element>
      </xsl:element>
      <xsl:call-template name="newline"/>
      <xsl:element name="a">
        <xsl:attribute name="href">javascript:menu2('<xsl:value-of select="@id"/>')</xsl:attribute>
        <xsl:attribute name="ondblclick">menu('import2','import1')</xsl:attribute>
        <xsl:text>import</xsl:text>
      </xsl:element>
      <xsl:call-template name="newline"/>
      <xsl:element name="div">
        <xsl:attribute name="class">
          <xsl:text>indent</xsl:text>
        </xsl:attribute>
        <xsl:attribute name="id">
          <xsl:text>import2</xsl:text>
        </xsl:attribute>
        <xsl:attribute name="style">
          <xsl:text>display:none</xsl:text>
        </xsl:attribute>
        <xsl:call-template name="newline"/>
        <xsl:for-each select="/File/Import">
          <xsl:element name="a">
            <xsl:attribute name="href">
              <xsl:text>javascript:menu2('</xsl:text>
              <xsl:value-of select="@id"/>
              <xsl:text>')</xsl:text>
            </xsl:attribute>
            <xsl:value-of select="QName"/>
          </xsl:element>
          <xsl:element name="br"></xsl:element>
          <xsl:call-template name="newline"/>
        </xsl:for-each>
      </xsl:element>
      <xsl:call-template name="newline"/>
    </xsl:element>
    <xsl:call-template name="newline"/>
  </xsl:template>

  <xsl:template match="Class|Intf">
    <xsl:element name="div">
      <xsl:call-template name="newline"/>
      <xsl:choose>
        <xsl:when test="count(./Members/*) = 0">
          <xsl:element name="img">
            <xsl:attribute name="alt">
              <xsl:text>minus</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="src">
              <!--<xsl:call-template name="setDepthWrapper"/>-->
              <xsl:value-of select="$topDir"/>
              <xsl:text>image/m.gif</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="id">
              <xsl:value-of select="ident"/>
            </xsl:attribute>
          </xsl:element>
          <xsl:call-template name="newline"/>
          <!-- Class => C, Intf  => I  -->
          <xsl:value-of select="substring(name(), 1, 1)"/><xsl:text>:</xsl:text>
          <xsl:element name="a">
            <xsl:attribute name="ondblclick">
              <xsl:text>menu('</xsl:text>
              <xsl:value-of select="@id"/>
              <xsl:text>','</xsl:text>
              <xsl:value-of select="ident"/>
              <xsl:text>')</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="href">
              <xsl:text>javascript:menu2('</xsl:text>
              <xsl:value-of select="@id"/>
              <xsl:text>')</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="class">
              <xsl:value-of select="name()"/>
            </xsl:attribute>
            <xsl:value-of select="ident"/>
          </xsl:element>
          <xsl:call-template name="newline"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="a">
            <xsl:attribute name="href">
              <xsl:text>javascript:menu('</xsl:text>
              <xsl:value-of select="@id"/>
              <xsl:text>','</xsl:text>
              <xsl:value-of select="ident"/>
              <xsl:text>')</xsl:text>
              </xsl:attribute>
            <xsl:element name="img">
              <xsl:attribute name="alt">
                <xsl:text>plus</xsl:text>
              </xsl:attribute>
              <xsl:attribute name="src">
                <!--<xsl:call-template name="setDepthWrapper"/>-->
                <xsl:value-of select="$topDir"/>
                <xsl:text>image/p.gif</xsl:text>
              </xsl:attribute>
              <xsl:attribute name="id">
                <xsl:value-of select="ident"/>
              </xsl:attribute>
            </xsl:element>
          </xsl:element>
          <xsl:call-template name="newline"/>
          <!-- Class => C, Intf  => I  -->
          <xsl:value-of select="substring(name(), 1, 1)" /><xsl:text>:</xsl:text>
          <xsl:element name="a">
            <xsl:attribute name="ondblclick">
              <xsl:text>menu('</xsl:text>
              <xsl:value-of select="@id"/>','<xsl:value-of select="ident"/>
              <xsl:text>')</xsl:text>
              </xsl:attribute>
            <xsl:attribute name="href">
              <xsl:text>javascript:menu2('</xsl:text>
              <xsl:value-of select="@id"/>
              <xsl:text>')</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="class">
              <xsl:value-of select="name()"/>
            </xsl:attribute>
            <xsl:value-of select="ident"/>
          </xsl:element>
          <xsl:call-template name="newline"/>
          <xsl:element name="div">
            <xsl:attribute name="class">
              <xsl:text>indent</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="style">
              <xsl:text>display:none;</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
            <xsl:call-template name="newline"/>
            <xsl:for-each select="Members/Field">
              <xsl:text>f:</xsl:text>
              <xsl:element name="a">
                <xsl:attribute name="href">
                  <xsl:text>javascript:menu2('</xsl:text>
                  <xsl:value-of select="@id"/>
                  <xsl:text>')</xsl:text>
                </xsl:attribute>
                <xsl:attribute name="class">field</xsl:attribute>
                <xsl:value-of select="ident"/>
              </xsl:element>
              <xsl:element name="br"></xsl:element>
              <xsl:call-template name="newline"/>
            </xsl:for-each>
            <xsl:for-each select="Members/Ctor">
              <xsl:text>c:</xsl:text>
              <xsl:element name="a">
                <xsl:attribute name="href">
                  <xsl:text>javascript:menu2('</xsl:text>
                  <xsl:value-of select="@id"/>
                  <xsl:text>')</xsl:text>
                </xsl:attribute>
                <xsl:attribute name="class">method</xsl:attribute>
                <xsl:value-of select="ident"/><xsl:apply-templates />
              </xsl:element>
              <xsl:element name="br"></xsl:element>
              <xsl:call-template name="newline"/>
            </xsl:for-each>
            <xsl:for-each select="Members/Method">
              <xsl:text>m:</xsl:text>
              <xsl:element name="a">
                <xsl:attribute name="href">
                  <xsl:text>javascript:menu2('</xsl:text>
                  <xsl:value-of select="@id"/>
                  <xsl:text>')</xsl:text>
                  </xsl:attribute>
                <xsl:attribute name="class">method</xsl:attribute>
                <xsl:value-of select="ident"/><xsl:apply-templates />
              </xsl:element>
              <xsl:element name="br"></xsl:element>
              <xsl:call-template name="newline"/>
            </xsl:for-each>
            <xsl:for-each select="Members/Intf">
              <xsl:apply-templates select="../Intf"/>
            </xsl:for-each>
            <xsl:for-each select="Members/Class">
              <xsl:apply-templates select="../Class"/>
            </xsl:for-each>
          </xsl:element>
          <xsl:call-template name="newline"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>
    <xsl:call-template name="newline"/>
  </xsl:template>

  <xsl:template match="Param|Method/op|Ctor/op">
   <xsl:value-of select="."/>
  </xsl:template>

  <xsl:template match="text()|@*">
    <xsl:apply-templates />
  </xsl:template>

  <xsl:template name="setDepthWrapper">
    <xsl:call-template name="setDepth">
      <xsl:with-param name="package" select="/File/Package/QName"/>
    </xsl:call-template>
  </xsl:template>

  <xsl:template name="setDepth">
    <xsl:param name="package"/>
    <xsl:param name="depth"/>
    <xsl:choose>
      <xsl:when test="string-length($package) > 0">
        <xsl:call-template name="setDepth">
          <xsl:with-param name="package"
            select="substring-after($package, '.')"/>
          <xsl:with-param name="depth" select="concat($depth, '../')"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$depth"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="newline">
    <xsl:text>
</xsl:text>
  </xsl:template>

</xsl:stylesheet>
