<?xml version="1.0" encoding="Shift_JIS"?>

<!--
# 
# Program:              $RCSfile: xref.xsl,v $  $Revision: 50.10 $
# 
# Purpose:      
# 
# Author:               T.Takahashi  2003/10/01
# Author:               S.Yamamoto  2003/10/01
# 
# (C) Copyright:        T.Takahashi and S.Yamamoto  2003
#                       This file is a product of the project Sapid.
# 
-->

<!--
    $Id: xref.xsl,v 50.10 2003/11/22 06:41:38 yamamoto Exp yamamoto $
-->  

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.0">
  <xsl:output
    method="xml"
    omit-xml-declaration="yes"/>
  <xsl:include href="treeView.xsl"/>
  <xsl:param name="topDir"/>
  <xsl:key name="decendants" match="*" use="name()"/>

  <xsl:template match="/">
    <xsl:element name="body">
      <xsl:call-template name="newline"/>
      <xsl:call-template name="xref">
        <xsl:with-param name="sort" select="'class'"/>
      </xsl:call-template>
      <xsl:call-template name="xref">
        <xsl:with-param name="sort" select="'intf'"/>
      </xsl:call-template>
      <xsl:call-template name="xref">
        <xsl:with-param name="sort" select="'method'"/>
      </xsl:call-template>
      <xsl:call-template name="xref">
        <xsl:with-param name="sort" select="'field'"/>
      </xsl:call-template>
      <xsl:call-template name="newline"/>
    </xsl:element>
    <xsl:call-template name="newline"/>
  </xsl:template>

  <xsl:template name="xref">
    <xsl:param name="sort"/>
    <xsl:element name="div">
      <xsl:call-template name="newline"/>
      <xsl:element name="a">
        <xsl:attribute name="href">
          <xsl:text>javascript:menu('</xsl:text>
          <xsl:value-of select="$sort"/>
          <xsl:text>2','</xsl:text>
          <xsl:value-of select="$sort"/>
          <xsl:text>1')</xsl:text>
        </xsl:attribute>
          <xsl:element name="img">
            <xsl:attribute name="alt">
              <xsl:text>plus</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="id">
              <xsl:value-of select="$sort"/>
              <xsl:text>1</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="src">
              <xsl:value-of select="$topDir"/>
              <xsl:text>image/p.gif</xsl:text>
            </xsl:attribute>
          </xsl:element>
        </xsl:element>
        <xsl:call-template name="newline"/>
        <xsl:element name="a">
          <xsl:attribute name="ondblclick">
            <xsl:text>menu('</xsl:text>
            <xsl:value-of select="$sort"/>
            <xsl:text>2','</xsl:text>
            <xsl:value-of select="$sort"/>
            <xsl:text>1')</xsl:text>
          </xsl:attribute>
          <xsl:attribute name="class">
            <xsl:value-of select="$sort"/>
          </xsl:attribute>
          <xsl:value-of
            select="concat(translate(substring($sort, 1, 1), 'cimf', 'CIMF'),
                           substring($sort, 2))"/>
        </xsl:element>
        <xsl:call-template name="newline"/>
        <xsl:element name="div">
          <xsl:attribute name="style">
            <xsl:text>display:none</xsl:text>
          </xsl:attribute>
          <xsl:attribute name="id">
            <xsl:value-of select="$sort"/>
            <xsl:text>2</xsl:text>
          </xsl:attribute>
          <xsl:attribute name="class">
            <xsl:text>indent</xsl:text>
          </xsl:attribute>
          <xsl:call-template name="newline"/>
          <xsl:choose>
            <xsl:when test="$sort = 'class'">
              <xsl:apply-templates select=".//Class">
                <xsl:sort select=".//Class/ident"/>
              </xsl:apply-templates>
            </xsl:when>
            <xsl:when test="$sort = 'intf'">
              <xsl:apply-templates select=".//Intf">
                <xsl:sort select=".//Intf/ident"/>
              </xsl:apply-templates>
            </xsl:when>
            <xsl:when test="$sort = 'method'">
              <xsl:for-each select=".//Method|.//Ctor">
                <xsl:sort select="ident"/>
                <xsl:call-template name="outputAnchor">
                  <xsl:with-param name="sort" select="$sort"/>
                </xsl:call-template>
              </xsl:for-each>
            </xsl:when>
            <xsl:when test="$sort = 'field'">
              <xsl:for-each select=".//Field">
                <xsl:sort select="ident"/>
                <xsl:call-template name="outputAnchor">
                  <xsl:with-param name="sort" select="$sort"/>
                </xsl:call-template>
              </xsl:for-each>
            </xsl:when>
          </xsl:choose>
        </xsl:element>
        <xsl:call-template name="newline"/>
      </xsl:element>
  </xsl:template>

  <xsl:template match="Class|Intf">
    <xsl:apply-templates select="ident"/>
  </xsl:template>

  <xsl:template match="ident">
    <xsl:element name="a">
      <xsl:attribute name="href">
        <xsl:call-template name="outputHref"/>
        <xsl:value-of select="../@id"/>
        <xsl:text>')</xsl:text>
      </xsl:attribute>
      <xsl:attribute name="class">
        <xsl:value-of select="name(..)"/>
      </xsl:attribute>
      <xsl:variable name="packageStr"
        select="ancestor::node()/Package/QName"/>
      <xsl:if test="string-length($packageStr) > 0">
        <xsl:value-of select="concat($packageStr, '.')"/>
      </xsl:if>
      <xsl:value-of select="."/>
    </xsl:element>
    <xsl:element name="br"></xsl:element>
    <xsl:call-template name="newline"/>
  </xsl:template>

  <xsl:template name="outputAnchor">
    <xsl:param name="sort"/>
    <xsl:element name="a">
      <xsl:attribute name="href">
        <xsl:call-template name="outputHref"/>
        <xsl:value-of select="@id"/>
        <xsl:text>')</xsl:text>
      </xsl:attribute>
      <xsl:attribute name="class">
        <xsl:value-of select="$sort"/>
      </xsl:attribute>
      <xsl:value-of select="ident"/>
    </xsl:element>
    <xsl:element name="br"></xsl:element>
    <xsl:call-template name="newline"/>
  </xsl:template>

  <xsl:template name="outputHref">
    <xsl:text>javascript:</xsl:text>
    <xsl:text>xrefFileset('</xsl:text>
    <xsl:apply-templates select="ancestor::node()/Package/QName"/>
    <xsl:value-of select="ancestor::node()/@name"/>
    <xsl:text>','</xsl:text>
  </xsl:template>

  <xsl:template match="Package/QName">
    <xsl:value-of select="concat(translate(., '.', '/'), '/')"/>
  </xsl:template>

</xsl:stylesheet>
