#! PerlCmd
# 
# Program:              $RCSfile: indentXML.pl,v $  $Revision: 40.16 $
# 
# Purpose:
# 
# Author:               S.Yamamoto  1997/08/01
# 
# Copyright:            S.Yamamoto  2002 - 2003
#                       This file is a product of the project Sapid.
# 

# 
# $Id: indentXML.pl,v 40.16 2003/08/03 11:31:01 yamamoto Exp yamamoto $
# 

$indent = 0;
$prefix_bar = " ";
$prefix_sp  = " ";
$skip_nl  = 0;

# 
# Parse options.
# 

use Getopt::Std;

getopts('bi:n');
if ($opt_b) {
    $prefix_bar = "|";
}
if ($opt_n) {
    $skip_nl = 1;
}

for ($j = 0; $i < $opt_i - 1; $i++) {
    $prefix_bar = $prefix_bar . " ";
    $prefix_sp  = $prefix_sp . " ";
}

# print "opt_i: $opt_i\n";
# print "prefix_bar: \"$prefix_bar\"\n";
# print "prefix_sp:  \"$prefix_sp\"\n";
# exit 99;

# 
# Script body.
# 

$leading_blank_lines = 1;
while (<>) {
    # Skip leading blank lines.
    if (/^$/ && $leading_blank_lines) {
        next;
    } else {
        $leading_blank_lines = 0;
    }
 
    if (/^<\//) {			# End tag.
        $indent--;
        for ($i = 0; $i < $indent; $i++) {
            print $prefix_sp;
        }
    } elsif (/^</) {			# Start tag.
        for ($i = 0; $i < $indent; $i++) {
            print $prefix_bar;
        }
        if (/^<nl / && $skip_nl) {	# Skip a newline after "<nl>".
            chop;
	}
        if (! /\/>/) {
            $indent++;
        }
    }
    print $_;
}

exit 0;
