/*
 * Created on 2003/06/17
 * Repository.java - Copyright (c) 2003 H.Yoshida
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS IS FREEWARE. NO WARRANTY.
 */
 
package JXModel3.xsdml;

import java.io.*;
import java.util.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * Xapid Repository Class
 * @author H.Yoshida
 */
public class Repository {
	/**
	 * The XSDML objects.
	 */
	Vector m_v_xsdml;
	
	/**
	 * Load an XSDML file by URI.
	 * @param uri
	 * @param doVaridate
	 * @return
	 */
	public SpdDocument loadXSDML(String uri, boolean doVaridate) {
		Document newdoc = null;
		try {
			DocumentBuilderFactory dbf =
				DocumentBuilderFactory.newInstance();
			DocumentBuilder dbuilder =
				dbf.newDocumentBuilder();
			dbf.setValidating(doVaridate);
			newdoc = dbuilder.parse(uri);
		}
		catch (IOException e) {
			System.out.println("IOException:" + e.getMessage());
		}
		catch (SAXException e) {
			System.out.println("SAXException:" + e.getMessage());
		}
		catch (IllegalArgumentException e) {
			System.out.println("IllegalArgumentException:" + e.getMessage());
		}
		catch (ParserConfigurationException e) {
			System.out.println("ParserConfigurationException:" + e.getMessage());
		}
		return new SpdDocument(newdoc);
	}

}


