/*
 * Created on 2003/06/07
 * SpdDocument.java - Copyright (c) 2003 H.Yoshida
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS IS FREEWARE. NO WARRANTY.
 */

package JXModel3.xsdml;

import org.w3c.dom.*;

/**
 * XSDML Document Class
 * @author H.Yoshida
 */
public final class SpdDocument {
	/**
	 * The attached XML document object.
	 * @see http://java.sun.com/j2se/1.4/ja/docs/ja/api/org/w3c/dom/Document.html
	 */
	public Document domdoc = null;
	
	/**
	 * The constructor.
	 * Attach a XML document.
	 */
	public SpdDocument(Document doc) {
		domdoc = doc;
	}
	
	/**
	 * Get the XSDML File element.
	 * @return
	 */
	public SpdElement getFileElement() {
		if (domdoc==null) return null;
		SpdElement elem = new SpdElement(domdoc.getDocumentElement());
		return elem;
	}
}

