/* 
 * Program:             $RCSfile: DBTableBaseMaker.java,v $  $Revision: 40.7 $
 * 
 * Purpose:             Convert J-model schema in C language into Java's one.
 *
 * Author:              K.Hoshino  2001/10/02
 *                      S.Yamamoto  2001/10/02
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: DBTableBaseMaker.java,v 40.7 2003/08/17 07:49:33 yamamoto Exp yamamoto $
 */

package Japid.DBTableBaseMaker;

import java.io.*;
import java.util.*;

/**
 * ϤɸϡϤɸϤȤϤɸϤ
 * "Japid.Freja.DBAccess.DBTableBase.java"֤뤳ȤꤷƤ롥
 *
 * @author K.Hoshino
 * @see Japid.Freja.DBAccess.DBTable
 */

public class DBTableBaseMaker {
    public StringBuffer inputString;

    public StringTokenizer tokenizer;

    public DBTableBaseMaker() {
        inputString = new StringBuffer("");
        tokenizer = null;
    }

    /**
     * Cǽ񤫤줿DBTableɸϤɤ߹ࡥ
     */
    public void readCTable() {
        try {
            InputStreamReader   isr = new InputStreamReader(System.in);
            BufferedReader      br = new BufferedReader(isr);
            String              line = null;

            while ((line = br.readLine()) != null) {
                inputString.append(line);
                inputString.append('\n');
            }
            br.close();
        } catch(Exception e) {
            e.printStackTrace();
        }

        tokenizer = new StringTokenizer(inputString.toString(), " \t\n\r\f,=}");
    }

    /** ʸϤJava(Freja)DBTable롥 */
    public void makeJavaTable() {
        printBegin();

        /* RelTableClassTableˤ뤳ȤˤƤ롥 */

        findClassTable();
            while (readOneClassTable()) {
        }

        println();

        findRelTable();
        while (readOneRelTable()) {
        }

        printEnd();
    }

    /** "{"ޤ";"ޤɤФ */
    public boolean findLeftBracket() {
        String  token = "";

        while (tokenizer.hasMoreTokens()) {
            token = tokenizer.nextToken();
            if (token.equals("{") || token.equals(";")) break;
        }
        if (!tokenizer.hasMoreTokens()) return false;
        else if (token.equals("{")) return true;
        else if (token.equals(";")) return false;
        else return false;
    }

    //////////////////////////////////////////////////////////////

    /** dbClassTableκǽޤɤФ */
    public void findClassTable() {
        while (tokenizer.hasMoreTokens() &&
               !(tokenizer.nextToken().equals("dbClassTable[]"))) {
        }
        findLeftBracket();
    }

    /** 饹Υơ֥1ɤࡥ */
    public boolean readOneClassTable() {
        boolean boo = findLeftBracket();

        if (!boo) return false;

        String name = tokenizer.nextToken();

        if (name.equals("NULL")) return false;

        String symSort = tokenizer.nextToken();

        findLeftBracket();

        printOneClassTableBegin();
        while (readOneClassAttr()) {
        }
        printOneClassTableEnd(name, symSort);

        return true;
    }

    /** 饹°1ɤࡥ */
    public boolean readOneClassAttr() {
        findLeftBracket();

        boolean hasNext = true;
        String token1 = tokenizer.nextToken();
        String token2 = tokenizer.nextToken();

        if (!token1.equals("SPD_DBT_NON")) {
            printOneClassAttrAdd(token1, token2);
            hasNext = true;
        } else {
            hasNext = false;
        }

        return hasNext;
    }

    //////////////////////////////////////////////////////////////

    /** dbRelTableκǽޤɤФ */
    public void findRelTable() {
        while (tokenizer.hasMoreTokens() &&
               !tokenizer.nextToken().equals("dbRelTable[]")) {
        }
        findLeftBracket();
    }

    /** ϢΥơ֥1ɤࡥ */
    public boolean readOneRelTable() {
        boolean boo = findLeftBracket();
        if (!boo) return false;

        String name = tokenizer.nextToken();

        if (name.equals("NULL")) return false;

        findLeftBracket();

        printOneRelTableBegin();
        while (readOneRelAttr()) {
        }
        printOneRelTableEnd(name);

        return true;
    }

    /** Ϣ°1ɤ. */
    public boolean readOneRelAttr() {
        findLeftBracket();

        boolean hasNext = true;
        String token1 = tokenizer.nextToken();
        String token2 = tokenizer.nextToken();
        String token3 = tokenizer.nextToken();

        if (!token1.equals("SPD_DBT_NON")) {
            printOneRelAttrAdd(token1, token2, token3);
            hasNext = true;
        } else {
            hasNext = false;
        }

        return hasNext;
    }

    // --------------------------------------------------
    // ϤϰʲΥ᥽åɷѤƿԤȤȤ 
    // -------------------------------------------------

    private void printBegin() {
        println("/*");
        println(" * Generated by: DBTableMaker.");
        println(" */");
        println("");
        println("package Japid.Freja.DBAccess;");
        println("");
        println("import java.io.*;");
        println("import java.util.*;");
        println("");
        println("/**");
        println(" * See \"DBTable.java\" and \"DBTableBaseMaker.java\".");
        println(" */");
        println("public class DBTableBase {");
        printTab(); println("public Vector dbClassTables;");
        printTab(); println("public Vector dbRelTables;");
        printTab(); println("");
        printTab(); println("public DBTableBase() {");

        printTab(); printTab(); println("Vector attr;");
        printTab(); printTab(); println("");
        printTab(); printTab(); println("dbClassTables = new Vector();");
        printTab(); printTab(); println("dbRelTables = new Vector();");
        printTab(); printTab(); println("");
    }

    private void printOneClassTableBegin() {
        printTab(); printTab(); println("attr = new Vector();");
    }

    private void printOneClassAttrAdd(String sdbSort, String name) {
        String tab = null;

        if (sdbSort.equals("SPD_DBT_INT")) tab = "    ";
        else if (sdbSort.equals("SPD_DBT_STR"))tab = " ";
        else tab = "    ";

        printTab(); printTab(); println("attr.add(new DBClassAttr(SdbSort." + sdbSort +
                                        "," + tab + name + "));");
    }

    private void printOneClassTableEnd(String className, String symSort) {
        printTab(); printTab(); println("dbClassTables.add(new DBClass(" + 
                                        className + ", SymSort." + symSort + ", attr));");
    }

    private void printOneRelTableBegin() {
        printTab(); printTab(); println("attr = new Vector();");
    }

    private void printOneRelAttrAdd(String sdbSort, String name, String symSort) {
        String tab = null;

        if (sdbSort.equals("SPD_DBT_INT")) tab = "    ";
        else if (sdbSort.equals("SPD_DBT_STR")) tab = " ";
        else tab = "    ";

        printTab(); printTab(); println("attr.add(new DBRelAttr(SdbSort." + sdbSort +
                                        "," + tab + name + ", SymSort." + symSort + "));");
    }

    private void printOneRelTableEnd(String relName) {
        printTab(); printTab(); println("dbRelTables.add(new DBRel(" + 
                                        relName + ", attr));");
    }

    private void printEnd() {
        printTab(); println("}");
        println("}");
    }

    private void printTab() {
        System.out.print("    ");
    }

    private void print(String str) {
        System.out.print(str);
    }

    private void println(String str) {
        System.out.println(str);
    }

    private void println() {
        System.out.println();
    }
    // --------------------------------------------------------

    public void makeDBTable() {
        readCTable();

        makeJavaTable();
    }
    
    public static void main(String[] args) {
        DBTableBaseMaker dbtm = new DBTableBaseMaker();

        dbtm.makeDBTable();        
    }
}
