/* 
 * Program:             $RCSfile: DBClass.java,v $  $Revision: 40.8 $
 * 
 * Purpose:             
 *
 * Author:              K.Hoshino  2001/10/02
 *                      S.Yamamoto  2001/10/02
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: DBClass.java,v 40.8 2003/02/15 11:56:35 yamamoto Exp yamamoto $
 */

package Japid.Freja.DBAccess;

import java.io.*;
import java.util.*;
import Japid.Freja.*;

/*
 * !! classrelscheme formatۤʤΤݤʤȤ 
 * Freja¦ɬפȤȤsort, nameΤߤʤΤǡ
 * Ʊ饹ǰȤǽǤ롥礹٤?
 * K.Hoshino 2001/10/14.
 */

public class DBClass {
    String className;
    SymSort symSort;
    /** ǡDBClassAttr */
    Vector attr;

    public DBClass() {
    }

    public DBClass(String className, SymSort symSort, Vector attr) {
        this.className = className;
        this.symSort = symSort;
        this.attr = attr;
    }

    public DBClass(String className, int symSort, Vector attr) {
        this(className, new SymSort(symSort), attr);
    }

    public SymSort getSymSort() {
        return symSort;
    }

    public int getSymSortVal() {
        return symSort.sort;
    }

    public int getAttrNum() {
        return attr.size();
    }

    public DBClassAttr getAttrAt(int i) {
        return (DBClassAttr) attr.elementAt(i);
    }

    public String getAttrNameAt(int i) {
        return getAttrAt(i).name;
    }

    public boolean attrIsIntAt(int i) {
        return getAttrAt(i).sort.isInt();
    }

    public boolean attrIsStringAt(int i) {
        return getAttrAt(i).sort.isString();
    }

    public int getAttrIndexByName(String name) {
        for (int i = 0; i < attr.size(); i++) {
            if (getAttrNameAt(i).equals(name))
                return i;
        }

        FrjWorld.error("No Attr \"" + name + "\" in DBClass \"" + className + "\"");
        return -1;
    }
}
