/* 
 * Program:             $RCSfile: DBClassObject.java,v $  $Revision: 40.7 $
 * 
 * Purpose:             Handler for InfoFile.
 *
 * Author:              K.Hoshino  2001/10/02
 *                      S.Yamamoto  2001/10/02
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: DBClassObject.java,v 40.7 2003/02/15 11:56:35 yamamoto Exp yamamoto $
 */

/*
 * 2001/10/14, K.Hoshino.
 * DB˴ؤ륯饹ϡä®٤˽򤪤߷פ򤹤٤
 * DBΥǡ11ĤɽΤ򤳤Τ褦˥¿
 * 褦ˤ٤Ǥʤ
 */

package Japid.Freja.DBAccess;

import java.io.*;
import java.util.*;
import Japid.Freja.*;

/** Class object data. */
public class DBClassObject extends DBClass {
    Vector value;

    public DBClassObject() {
        value = new Vector();
    }

    public DBClassObject(String className, SymSort symSort, Vector attr) {
        super(className, symSort, attr);
        value = new Vector();
    }

    public DBClassObject(DBClass dbClass) {
        super(dbClass.className, dbClass.symSort, dbClass.attr);
        value = new Vector();
    }

    // -------------------------------------------------------------
    public boolean setIntValue(int intValue) {
        if (attrIsIntAt(value.size())) {
            value.add(new Integer(intValue));
            return true;
        } else {
            return false;
        }       
    }

    public boolean setStringValue(String strValue) {
        if (attrIsStringAt(value.size())) {
            value.add(new String(strValue));
            return true;
        } else {
            return false;
        }
    }

    // -------------------------------------------------------------
    public boolean setIntValueAt(int i, int intValue) {
        if (value.size() < i + 1) {
            value.setSize(i + 1);
        }

        if (attrIsIntAt(i)) {
            value.setElementAt(new Integer(intValue), i);
            return true;
        } else {
            return false;
        }
    }

    public boolean setStringValueAt(int i, String strValue) {
        if (value.size() < i + 1) {
            value.setSize(i + 1);
        }

        if (attrIsStringAt(i)) {
            value.setElementAt(new String(strValue), i);
            return true;
        } else {
            return false;
        }
    }

    // -------------------------------------------------------------
    public int getIntValueAt(int i) {
        if (attrIsIntAt(i)) {
            return ((Integer) value.elementAt(i)).intValue();
        } else {
            return JDBConsts.JAPID_NON_ID;
        }
    }

    public String getStringValueAt(int i) {
        if (attrIsStringAt(i)) {
            return (String) value.elementAt(i);
        } else {
            return null;
        }
    }

    // -------------------------------------------------------------
    public boolean setIntValueByName(String name, int intValue) {
        int index = getAttrIndexByName(name);
        if (index != -1) {
            return setIntValueAt(index, intValue);
        } else {
            return false;
        }
    }

    public boolean setStringValueByName(String name, String strValue) {
        int index = getAttrIndexByName(name);
        if (index != -1) {
            return setStringValueAt(index, strValue);
        } else {
            return false;
        }
    }
    // -------------------------------------------------------------
    public int getIntValueByName(String name) {
        int index = getAttrIndexByName(name);
        if (index != -1) {
            return getIntValueAt(index);
        } else {
            return JDBConsts.JAPID_NON_ID;
        }
    }

    public String getStringValueByName(String name) {
        int index = getAttrIndexByName(name);
        if (index != -1) {
            return getStringValueAt(index);
        } else {
            return null;
        }
    }

    // -------------------------------------------------------------

    /**
     * make new DBClassObject from FrejaObject on memory
     */
    public static DBClassObject getDBClassObject(FrjObject obj) {
        DBClass dbc = FrjWorld.dbTable.getDBClassByName(obj.getClassName());
        DBClassObject dbco = new DBClassObject(dbc);
        int attrNum = dbco.getAttrNum();
        for (int i = 0; i < attrNum; i++) {
            if (dbco.attrIsIntAt(i)) {
                if (dbco.getAttrNameAt(i).equals("id")) {
                    dbco.setIntValueAt(i, FrjID.getFrejaDataID(
                                           ReflectionUtil.getAttrValLongByName(obj, dbco.getAttrNameAt(i))));
                } else {
                    dbco.setIntValueAt(i, ReflectionUtil.getAttrValIntByName(obj, dbco.getAttrNameAt(i)));
                }
            } else if (dbco.attrIsStringAt(i)) {
                String str = ReflectionUtil.getAttrValStringByName(obj, dbco.getAttrNameAt(i));
                // nullϤ٤ǤϤʤ
                if (str == null) {
                    str = new String("");
                }
                dbco.setStringValueAt(i, str);
            }
        }
        return dbco;
    }
}
