/* 
 * Program:             $RCSfile: DBRelObject.java,v $  $Revision: 40.7 $
 * 
 * Purpose:             
 *
 * Author:              K.Hoshino  2001/10/02
 *                      S.Yamamoto  2001/10/02
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: DBRelObject.java,v 40.7 2003/02/15 11:56:36 yamamoto Exp yamamoto $
 */

package Japid.Freja.DBAccess;

import java.io.*;
import java.util.*;
import Japid.Freja.*;

/* DBɤߤϢ֥ȥǡ.  */
public class DBRelObject extends DBRel {
    Vector value;

    public DBRelObject() {
        value = new Vector();
    }

    public DBRelObject(String relName, Vector attr) {
        super(relName, attr);
        value = new Vector();
    }

    public DBRelObject(DBRel dbRel) {
        super(dbRel.relName, dbRel.attr);
        value = new Vector();
    }

    // -------------------------------------------------------------
    public boolean setIntValue(int intValue) {
        if (attrIsIntAt(value.size())) {
            value.add(new Integer(intValue));
            return true;
        } else {
            return false;
        }       
    }

    public boolean setStringValue(String strValue) {
        if (attrIsStringAt(value.size())) {
            value.add(new String(strValue));
            return true;
        } else {
            return false;
        }
    }

    // -------------------------------------------------------------
    // פ
    public boolean setIntValueAt(int i, int intValue) {
        if (value.size() < i + 1) {
            value.setSize(i + 1);
        }

        if (attrIsIntAt(i)) {
            value.setElementAt(new Integer(intValue), i);
            return true;
        } else {
            return false;
        }
    }

    public boolean setStringValueAt(int i, String strValue) {
        if (value.size() < i + 1) {
            value.setSize(i + 1);
        }

        if (attrIsStringAt(i)) {
            value.setElementAt(new String(strValue), i);
            return true;
        } else {
            return false;
        }
    }

    // -------------------------------------------------------------
    public int getIntValueAt(int i) {
        if (attrIsIntAt(i)) {
            return ((Integer) value.elementAt(i)).intValue();
        } else {
            return JDBConsts.JAPID_NON_ID;
        }
    }

    public String getStringValueAt(int i) {
        if (attrIsStringAt(i)) {
            return (String) value.elementAt(i);
        } else {
            return null;
        }
    }

    // -------------------------------------------------------------
    public boolean setIntValueByName(String name, int intValue) {
        int index = getAttrIndexByName(name);
        if (index != -1) {
            return setIntValueAt(index, intValue);
        } else {
            return false;
        }
    }

    public boolean setStringValueByName(String name, String strValue) {
        int index = getAttrIndexByName(name);
        if (index != -1) {
            return setStringValueAt(index, strValue);
        } else {
            return false;
        }
    }
    // -------------------------------------------------------------
    public int getIntValueByName(String name) {
        int index = getAttrIndexByName(name);
        if (index != -1) {
            return getIntValueAt(index);
        } else {
            return JDBConsts.JAPID_NON_ID;
        }
    }

    public String getStringValueByName(String name) {
        int index = getAttrIndexByName(name);
        if (index != -1) {
            return getStringValueAt(index);
        } else {
            return null;
        }
    }

    // -------------------------------------------------------------

    /* RelationClassξȰäƤ줾java饹ѰդƤ餺
     * FrjObjectȤͤۤʤ롣Ȥ߷פɬפȤʤ
     */
    /**
     * make new DBRelObject from FrejaRelation on memory
     * @see Japid.Freja.FrjRelation.java
     */
    public static DBRelObject getDBRelObject(FrjRelation rel) {
        DBRel dbr = FrjWorld.dbTable.getDBRelByName(rel.getRelationName());
        DBRelObject dbro = new DBRelObject(dbr);

        dbro.setIntValue(FrjID.getFrejaDataID(rel.oid1));
        dbro.setIntValue(FrjID.getFrejaDataID(rel.oid2));

        return dbro;
    }
}
