/* 
 * Program:             $RCSfile: JpdSDBformat.java,v $  $Revision: 40.7 $
 * 
 * Purpose:             
 *
 * Author:              K.Hoshino  2001/10/02
 *                      S.Yamamoto  2001/10/02
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: JpdSDBformat.java,v 40.7 2003/02/15 11:56:37 yamamoto Exp yamamoto $
 */

package Japid.Freja.DBAccess;

import java.io.*;
import java.util.*;
import Japid.Freja.*;

/**
 * K.Hoshino 2001/10/08.
 * "<SAPID_TOP>/lib/SpdUtil/spdSDBformat.c"η˹碌
 * Frejaformatۤʤ뤳ȤꤷơstaticǤʤۤɤȽǤ
 */

public class JpdSDBformat {
    public static final int JAPID_TEXT_FORMAT_SDB = 0;
    public static final int JAPID_BINARY_FORMAT_SDB = 1;
    
    /* SDB formats. */
    private int read_sdb_format = JAPID_TEXT_FORMAT_SDB;
    private int write_sdb_format = JAPID_TEXT_FORMAT_SDB;

    public JpdSDBformat() {
    }

    public JpdSDBformat(int read_sdb_format, int write_sdb_format) {
        this.read_sdb_format = read_sdb_format;
        this.write_sdb_format = write_sdb_format;
    }

    /* 
     * Set and get SDB format.
     */
    
    public void jpdSetReadSDBformat(int format) {
        if (format == JAPID_TEXT_FORMAT_SDB || 
            format == JAPID_BINARY_FORMAT_SDB) {
            read_sdb_format = format;
        } else {
            FrjWorld.error(format + ": Invalid read format.");
        }
    }
    
    public void jpdSetReadSDBformatBinary() {
        jpdSetReadSDBformat(JAPID_BINARY_FORMAT_SDB);
    }
    
    public void jpdSetReadSDBformatText() {
        jpdSetReadSDBformat(JAPID_TEXT_FORMAT_SDB);
    }

    public int jpdGetReadSDBformat() {
        return (read_sdb_format);
    }

    public void jpdSetWriteSDBformat(int format) {
        if (format == JAPID_TEXT_FORMAT_SDB || 
            format == JAPID_BINARY_FORMAT_SDB) {
            write_sdb_format = format;
        } else {
            FrjWorld.error(format + ": Invalid write format.");
        }
    }
    
    public void jpdSetWriteSDBformatBinary() {
        jpdSetWriteSDBformat(JAPID_BINARY_FORMAT_SDB);
    }
    
    public void jpdSetWriteSDBformatText() {
        jpdSetWriteSDBformat(JAPID_TEXT_FORMAT_SDB);
    }

    public int jpdGetWriteSDBformat() {
        return (write_sdb_format);
    }
}
