/* 
 * Program:             $RCSfile: SymSort.java,v $  $Revision: 40.12 $
 * 
 * Purpose:             
 *
 * Author:              K.Hoshino  2001/10/02
 *                      S.Yamamoto  2001/10/02
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SymSort.java,v 40.12 2003/02/20 15:14:07 yamamoto Exp yamamoto $
 */

package Japid.Freja.DBAccess;

import java.io.*;
import java.util.*;
import Japid.Freja.*;

/**
 * @see Japid.Freja.DBAccess.DBTableBase
 */
public class SymSort {
    public static final int SPD_FIRST_CID_J_MODEL;

    public static final int SPD_CID_J_FILE;
    public static final int SPD_CID_J_CLASS;
    public static final int SPD_CID_J_INTERFACE;
    public static final int SPD_CID_J_VARIABLE;
    public static final int SPD_CID_J_ROUTINE;
    public static final int SPD_CID_J_TYPE;
    public static final int SPD_CID_J_MODIFIER;
    public static final int SPD_CID_J_SBLOCK;
    public static final int SPD_CID_J_STATEMENT;
    public static final int SPD_CID_J_EXPRESSION;
    public static final int SPD_CID_J_LITERAL;
    public static final int SPD_CID_J_OPERATOR;
    public static final int SPD_CID_J_QNAME;
    public static final int SPD_CID_J_SPECIAL;
    public static final int SPD_CID_J_LABEL;
    public static final int SPD_CID_J_COMMENT;
    public static final int SPD_CID_J_WILDCARD;

    public static final int JPD_INVALID_ID;

    public int sort;

    public SymSort() {
        sort = JPD_INVALID_ID;
    }

    public SymSort(int sort) {
        this.sort = sort;
    }

    public static SymSort getSymSortByName(String name) {
        DBClass dbClass = FrjWorld.dbTable.getDBClassByName(name);
        
        if (dbClass == null) {
            return (new SymSort(JPD_INVALID_ID));
        } else {
            return dbClass.getSymSort();
        }
    }

    public static int getSymSortValByName(String name) {
        DBClass dbClass = FrjWorld.dbTable.getDBClassByName(name);
        
        if (dbClass == null) {
            return JPD_INVALID_ID;
        } else {
            return dbClass.getSymSortVal();
        }
    }

    public static int symSort2TableIndex(int symSortVal) {
        return symSortVal - SPD_FIRST_CID_J_MODEL;
    }

    public static int tableIndex2SymSort(int index) {
        if (index == JPD_INVALID_ID) {
            return JPD_INVALID_ID;
        } else {
            return index + SPD_FIRST_CID_J_MODEL;
        }
    }

    static {
        SPD_FIRST_CID_J_MODEL = 189;    /* !! */

        int i = SPD_FIRST_CID_J_MODEL;

        SPD_CID_J_FILE = i++;
        SPD_CID_J_CLASS = i++;
        SPD_CID_J_INTERFACE = i++;
        SPD_CID_J_VARIABLE = i++;
        SPD_CID_J_ROUTINE = i++;
        SPD_CID_J_TYPE = i++;
        SPD_CID_J_MODIFIER = i++;
        SPD_CID_J_SBLOCK = i++;
        SPD_CID_J_STATEMENT = i++;
        SPD_CID_J_EXPRESSION = i++;
        SPD_CID_J_LITERAL = i++;
        SPD_CID_J_OPERATOR = i++;
        SPD_CID_J_QNAME = i++;
        SPD_CID_J_SPECIAL = i++;
        SPD_CID_J_LABEL = i++;
        SPD_CID_J_COMMENT = i++;
        SPD_CID_J_WILDCARD = i++;

        JPD_INVALID_ID = -1;            /* !! */
    }
}
