/* 
 * Program:             $RCSfile: DefaultLoader.java,v $  $Revision: 41.6 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: DefaultLoader.java,v 41.6 2003/02/15 11:56:26 yamamoto Exp yamamoto $
 */

package Japid.Freja;

import java.io.*;
import java.util.*;

public class DefaultLoader implements Loader {
    /**
     * entryǡɤ߹ǥ֥Ȥ
     * 륪֥ȤΥ饹nameSetStringȤ
     * ǼƤ롥饹ΥץեånamePrefixͿ
     * loadernameSetΥ饹ưŪ˺
     */
    public static void load(Enumeration nameSet, String namePrefix,
                            FrejaEntry entry) {
        if (namePrefix == null) {
            namePrefix = "";
        }
        while (nameSet.hasMoreElements()) {
            String name = (String) nameSet.nextElement();
            Loadable loader = null;
            try {
                Class c = Class.forName(namePrefix + name);
                loader = (Loadable) c.newInstance();
                loader.load(entry, name);
            }
            catch (ClassNotFoundException ext) {
                FrjWorld.warning("Java class " + namePrefix + name
                                        + " is not defined");
            }
            catch (Exception ext) {
                ext.printStackTrace();
            }
        }
    }

    /**
     * entryloaderȤäƥǡɤ߹ǥ֥Ȥ
     * 륪֥ȤΥ饹nameSetStringȤ
     * ǼƤ롥饹ΥץեånamePrefixͿ롥
     */
    public static void load(Loadable loader,
                            Enumeration nameSet, String namePrefix,
                            FrejaEntry entry) {
        if (loader == null) {
            load(nameSet, namePrefix, entry);
        }
                
        if (namePrefix == null) {
            namePrefix = "";
        }
        while (nameSet.hasMoreElements()) {
            String name = (String) nameSet.nextElement();
            loader.load(entry, (String) name);
        }
    }

    // default loader, load from entry
    public void load(FrejaEntry entry) {
        // load classes
        load(FrjExtents.getClassNames(), "Japid.Freja.Frj", entry);
        // load relations
        load(new FrjRelation(), FrjExtents.getRelationNames(), null, entry);

        // set related objects
        for (Enumeration e = FrjExtents.getAllObjects(entry.getFrejaID());
             e.hasMoreElements();) {
            ((FrjObject) e.nextElement()).setRelatedObjects();
        }
    }
}
