/* 
 * Program:             $RCSfile: F2SFile.java,v $  $Revision: 41.5 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: F2SFile.java,v 41.5 2003/02/15 11:56:39 yamamoto Exp yamamoto $
 */

package Japid.Freja.F2S;

import java.io.*;
import java.util.*;
import Japid.Freja.*;
import Japid.Freja.DBAccess.*;

public class F2SFile extends FrjFile implements F2SObject {
    // Constructors
    public F2SFile(FrejaEntry entry, DBClassObject obj) {
        super(entry, obj);
    }

    public F2SFile() {
        super();
    }

    protected void create(FrejaEntry entry, DBClassObject obj) {
        new F2SFile(entry, obj);
    }

    public String toSource() {
        String source = "";

        source += "/*** " + this.getStr() + " ***/\n";

        if (definedPackage != null) {
            source += "package " + ((F2SQName) definedPackage).toSource();
            source += ";\n";
        }
        for (Enumeration e = getImportedPackages();
             e.hasMoreElements();) {
            source += "import " + ((F2SQName) e.nextElement()).toSource()
                + ";\n";
        }

        for (Enumeration e = getClasses();
             e.hasMoreElements();) {
            source += ((F2SClass) e.nextElement()).toSource();
        }

        for (Enumeration e = getInterfaces();
             e.hasMoreElements();) {
            source += ((F2SInterface) e.nextElement()).toSource();
        }

        return source;
    }
}
