/* 
 * Program:             $RCSfile: F2SInterface.java,v $  $Revision: 41.8 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: F2SInterface.java,v 41.8 2003/02/15 11:56:39 yamamoto Exp yamamoto $
 */

package Japid.Freja.F2S;

import java.io.*;
import java.util.*;
import Japid.Freja.*;
import Japid.Freja.DBAccess.*;

public class F2SInterface extends FrjInterface implements F2SObject {
    // Constructors
    public F2SInterface(FrejaEntry entry, DBClassObject obj) {
        super(entry, obj);
    }

    public F2SInterface() {
        super();
    }

    protected void create(FrejaEntry entry, DBClassObject obj) {
        new F2SInterface(entry, obj);
    }

    public String toSource() {
        //String source = "";
        String source = getIndention();
        sortRelatedObjects(new SortByOffset());

        for (Enumeration e = getModifiers();
             e.hasMoreElements();) {
            source += ((FrjModifier) e.nextElement()).getStr() + " ";
        }

        source += "interface " + this.getStr() + " ";

        Enumeration ei = getSuperInterfaceTypes();
        if (ei.hasMoreElements()) {
            source += "extends ";
            String comma = "";
            while (ei.hasMoreElements()) {
                source += comma + ((F2SType) ei.nextElement()).toSource();
                comma = ", ";
            }
        }
        source += "{\n";

        for (Enumeration e = getMemberClasses();
             e.hasMoreElements();) {
            F2SClass f2sClass = (F2SClass) e.nextElement();
            f2sClass.setIndentLevel(getIndentLevel() + 1);
            source += f2sClass.toSource() + "\n";
        }

        for (Enumeration e = getMemberInterfaces();
             e.hasMoreElements();) {
            F2SInterface f2sInterface = (F2SInterface) e.nextElement();
            f2sInterface.setIndentLevel(getIndentLevel() + 1);
            source += f2sInterface.toSource() + "\n";
        }

        for (Enumeration e = getMembers();
             e.hasMoreElements();) {
            source += getIndention();
            source += "    " + ((F2SVariable) e.nextElement()).toSource()
                + ";\n";
        }

        for (Enumeration e = getRoutines();
             e.hasMoreElements();) {
            F2SRoutine f2sRoutine = (F2SRoutine) e.nextElement();
            f2sRoutine.setIndentLevel(getIndentLevel() + 1);
            source += f2sRoutine.toSource() + "\n";
        }

        source += getIndention() + "}\n";
        return source;
    }

    private int indentLevel = 0;

    private int getIndentLevel() {
        return indentLevel;
    }

    void setIndentLevel(int indentLevel) {
        this.indentLevel = indentLevel;
    }

    private String getIndention() {
        String indent = "";
        int width = getIndentLevel() * INDENT_WIDTH;
        for(int i = 0; i < width; i++){
            indent += " ";
        }
        return indent;
    }
}
