/* 
 * Program:             $RCSfile: F2SLabel.java,v $  $Revision: 41.9 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: F2SLabel.java,v 41.9 2003/02/15 11:56:41 yamamoto Exp yamamoto $
 */

package Japid.Freja.F2S;

import java.io.*;
import java.util.*;
import Japid.Freja.*;
import Japid.Freja.DBAccess.*;

public class F2SLabel extends FrjLabel implements F2SObject {
    // Constructors
    public F2SLabel(FrejaEntry entry, DBClassObject obj) {
        super(entry, obj);
    }

    public F2SLabel() {
        super();
    }

    protected void create(FrejaEntry entry, DBClassObject obj) {
        new F2SLabel(entry, obj);
    }

    public String toSource() {
        String source = "";
        sortRelatedObjects(new SortByOffset());
        if (sort == DEFINED) {
            source +=  getIndention() + getStr() + ": ";
        }
        else if (sort == REFERRED) {
            source += getStr();
        }
        else if (sort == CASE) {
            setIndentLevel(getIndentLevel() - 1);
            source += getIndention() + "case "
                + ((F2SExpression) getCaseValue()).toSource() + ":\n";
            setIndentLevel(getIndentLevel() + 1);
        }
        else if (sort == DEFAULT) {
            setIndentLevel(getIndentLevel() - 1);
            source += getIndention() + getStr() + ":\n";
            setIndentLevel(getIndentLevel() + 1);
        }
        else {
            FrjWorld.error("No such Label sort " + this);
        }
        return source;
    }

    private int indentLevel = 0;

    private int getIndentLevel() {
        return indentLevel;
    }

    void setIndentLevel(int indentLevel) {
        this.indentLevel = indentLevel;
    }

    private String getIndention() {
        String indent = "";
        int width = getIndentLevel() * INDENT_WIDTH;
        for(int i = 0; i < width; i++){
            indent += " ";
        }
        return indent;
    }
}
