/* 
 * Program:             $RCSfile: F2SLoader.java,v $  $Revision: 41.5 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: F2SLoader.java,v 41.5 2003/02/15 11:56:41 yamamoto Exp yamamoto $
 */

package Japid.Freja.F2S;

import java.util.*;
import Japid.Freja.*;

public class F2SLoader implements Loader {
    static Vector       classNames = new Vector();
        
    public void load(FrejaEntry entry) {
        DefaultLoader.load(F2SLoader.getClassNames(), null, entry);
        DefaultLoader.load(new FrjRelation(), FrjExtents.getRelationNames(),
                           null, entry);
        // set related objects
        for (Enumeration e = FrjExtents.getAllObjects(entry.getFrejaID());
             e.hasMoreElements();) {
            ((FrjObject) e.nextElement()).setRelatedObjects();
        }
    }

    static {
        classNames.addElement("Japid.Freja.F2S.F2SFile");
        classNames.addElement("Japid.Freja.F2S.F2SClass");
        classNames.addElement("Japid.Freja.F2S.F2SInterface");
        classNames.addElement("Japid.Freja.F2S.F2SQName");
        classNames.addElement("Japid.Freja.F2S.F2SType");
        classNames.addElement("Japid.Freja.F2S.F2SVariable");
        classNames.addElement("Japid.Freja.F2S.F2SRoutine");
        classNames.addElement("Japid.Freja.F2S.F2SStatement");
        classNames.addElement("Japid.Freja.F2S.F2SExpression");
        classNames.addElement("Japid.Freja.F2S.F2SLabel");
        classNames.addElement("Japid.Freja.FrjOperator");
        classNames.addElement("Japid.Freja.FrjLiteral");
        classNames.addElement("Japid.Freja.FrjSpecial");
        classNames.addElement("Japid.Freja.FrjModifier");
        classNames.addElement("Japid.Freja.FrjSBlock");
        classNames.addElement("Japid.Freja.FrjComment");
    }

    static public Enumeration getClassNames() {
        return classNames.elements();
    }
}
