/* 
 * Program:             $RCSfile: F2SPackage.java,v $  $Revision: 41.7 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: F2SPackage.java,v 41.7 2003/02/15 11:56:42 yamamoto Exp yamamoto $
 */

package Japid.Freja.F2S;

import java.io.*;
import java.util.*;
import Japid.Freja.*;
import Japid.Freja.F2S.*;

public class F2SPackage {
    String pkgName = null;
    static final boolean debug = true;
        
    F2SPackage(String pkgName) {
        this.pkgName = pkgName;
    }
        
    void convert() {
        Runtime runtime = Runtime.getRuntime();

        Dictionary writtenFiles = new Hashtable();
        for (Enumeration e = Creja.getClasses(pkgName);
             e.hasMoreElements();) {
            String className = (String) e.nextElement();
            FrejaEntry entry = Creja.getFrejaEntry(pkgName, className);
            if (entry == null || !entry.exists()) {
                FrjWorld.error("No such SDB: "
                                      + pkgName + "." + className);
                continue;
            }
            System.err.println(pkgName + "." + className);

            new F2SLoader().load(entry);
            for (Enumeration e2 = FrjExtents.getObjects("File");
                 e2.hasMoreElements();) {
                F2SFile f2sFile = (F2SFile) e2.nextElement();
                if (writtenFiles.get(f2sFile.getStr()) != null) {
                    // already writtern
                    System.err.println("already writtern " + className);
                    continue;
                }
                String source = f2sFile.toSource();
                writtenFiles.put(f2sFile.getStr(), f2sFile);
                File tmp = new File(f2sFile.getStr());
                File outFile = new File(tmp.getName());
                try {
                    FileOutputStream fout = new FileOutputStream(outFile);
                    PrintStream dout = new PrintStream(fout);
                    dout.print(source);
                }
                catch (IOException ext) {
                    ext.printStackTrace();
                }
                source = null; // for effective GC
            }
            FrjExtents.clear();
        }
        FrjWorld.debug(debug, "Total: " + runtime.totalMemory()
                              + " Free: " + runtime.freeMemory());
        FrjWorld.debug(debug, "Object: " + FrjExtents.getObjectNums()
                              + " Relation: " + FrjExtents.getRelationNums());

    }

    public static void main(String args[]) {
        if (args.length < 1) {
            System.err.println("Usage: java Japid.Tools.F2SPackage packageName");
            System.exit(1);
        }
        F2SPackage tester = new F2SPackage(args[0]);
        tester.convert();
    }
}
