/* 
 * Program:             $RCSfile: F2SRoutine.java,v $  $Revision: 41.8 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: F2SRoutine.java,v 41.8 2003/02/15 11:56:40 yamamoto Exp yamamoto $
 */

package Japid.Freja.F2S;

import java.io.*;
import java.util.*;
import Japid.Freja.*;
import Japid.Freja.DBAccess.*;

public class F2SRoutine extends FrjRoutine implements F2SObject {
    // Constructors
    public F2SRoutine(FrejaEntry entry, DBClassObject obj) {
        super(entry, obj);
    }

    public F2SRoutine() {
        super();
    }

    protected void create(FrejaEntry entry, DBClassObject obj) {
        new F2SRoutine(entry, obj);
    }

    public String toSource() {
        String source = getIndention();

        sortRelatedObjects(new SortByOffset());
        String comma = "";
        for (Enumeration e = getModifiers();
             e.hasMoreElements();) {
            source += ((FrjModifier) e.nextElement()).getStr() + " ";
        }

        if (returnType != null) {
            source += ((F2SType) returnType).toSource() + " ";
        }

        source += this.getStr();
                
        source += "(";
        for (Enumeration e = getParameters();
             e.hasMoreElements();) {
            source += comma + ((F2SVariable) e.nextElement()).toSource();
            comma = ", ";
        }
        source += ") ";

        Enumeration et = getThrowTypes();
        if (et.hasMoreElements()) {
            source += "throws ";
            comma = "";
            while (et.hasMoreElements()) {
                source += comma + ((F2SType) et.nextElement()).toSource();
                comma = ", ";
            }
        }

        if (body != null) {
            F2SStatement f2sStatement = (F2SStatement) body;
            f2sStatement.setIndentLevel(getIndentLevel());
            source += f2sStatement.toSource();
        }
        else {
            source += ";\n";
        }
        return source;
    }

    private int indentLevel = 0;

    private int getIndentLevel() {
        return indentLevel;
    }

    void setIndentLevel(int indentLevel) {
        this.indentLevel = indentLevel;
    }

    private String getIndention() {
        String indent = "";
        int width = getIndentLevel() * INDENT_WIDTH;
        for(int i = 0; i < width; i++){
            indent += " ";
        }
        return indent;
    }
}
