/* 
 * Program:             $RCSfile: F2SVariable.java,v $  $Revision: 41.6 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: F2SVariable.java,v 41.6 2003/02/15 11:56:41 yamamoto Exp yamamoto $
 */

package Japid.Freja.F2S;

import java.io.*;
import java.util.*;
import Japid.Freja.*;
import Japid.Freja.DBAccess.*;

public class F2SVariable extends FrjVariable implements F2SObject {
    // Constructors
    public F2SVariable(FrejaEntry entry, DBClassObject obj) {
        super(entry, obj);
    }

    public F2SVariable() {
        super();
    }

    protected void create(FrejaEntry entry, DBClassObject obj) {
        new F2SVariable(entry, obj);
    }

    public String toSource() {  
        String source = "";
        source += this.toSourceModifierType();
        source += this.toSourceExceptType();
        return source;
    }

    private String toSourceModifierType() {
        String source = "";
        sortRelatedObjects(new SortByOffset());
        for (Enumeration e = getModifiers();
             e.hasMoreElements();) {
            source += ((FrjModifier) e.nextElement()).getStr() + " ";
        }
        source += ((F2SType) type).toSource() + " ";
        return source;
    }
                
    private String toSourceExceptType() {
        String source = " ";
        source += this.getStr();
        if (initializer != null) {
            if (initializer.getSort() == FrjExpression.LISTED) {
                F2SExpression.initializerLevel++;
                source += " = "
                    + ((F2SExpression) initializer).toSource();
                F2SExpression.initializerLevel--;
            }
            else {
                source += " = " + ((F2SExpression) initializer).toSource();
            }
        }
        return source;
    }

    /**
          * Converts variables to source.
          * Variables having the same type are listed by comma.
          * <P>
          * e.g.<BR>
          *  int a, b;  -- a.toSource(); b.toSource() -->  int a; intb;
          *             -- FrjVariable.toSources(ab) --> int a, b;
          */
    public static String toSource(Enumeration vars) {   
        String source = "";
        boolean firstVar = true;
        FrjType prevType = null;
        while (vars.hasMoreElements()) {
            F2SVariable var = (F2SVariable) vars.nextElement();
            if (firstVar) {
                prevType = var.getType();
                source += var.toSourceModifierType();
                source += var.toSourceExceptType();
                firstVar = false;
            }
            else {
                if (var.getType() == prevType) {
                    source += ", " + var.toSourceExceptType();
                }
                else {
                    prevType = var.getType();
                    source += ";\n";
                    source += var.toSourceModifierType();
                    source += var.toSourceExceptType();
                    firstVar = false;
                }
            }
        }
        return source;
    }
}
