/* 
 * Program:             $RCSfile: FrjSpecial.java,v $  $Revision: 41.4 $
 * 
 * Purpose:             The class corresponding to File.
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: FrjSpecial.java,v 41.4 2003/02/15 11:56:30 yamamoto Exp yamamoto $
 */

package Japid.Freja;

import java.io.*;
import java.util.*;
import Japid.Freja.DBAccess.*;

public class FrjSpecial extends FrjObject {
    // Class variables
    /** A class name of this class. */
    public final static String  CLASS_NAME = "Special";

    // Related object
    protected FrjExpression expression = null;

    // Constructors
    public FrjSpecial(FrejaEntry entry, DBClassObject obj) {
        super(entry, obj);
    }

    public FrjSpecial(FrejaEntry entry) {
        super(entry);
    }
    public FrjSpecial() {
        super();
    }

    // Class methods
    /** return the class name of this object */
    public static String getClassNameStatically() {
        return CLASS_NAME;
    }

    /** create object from SDB */
    protected void create(FrejaEntry entry, DBClassObject obj) {
        new FrjSpecial(entry, obj);
    }

    // Instance method
    /** return the class name dynamically */
    public String getClassName() {
        return CLASS_NAME;
    }

    // about relation
    public void removeRelatedObjects() {
        super.removeRelatedObjects();
        expression = null;
    }

    protected void setRelatedObject(FrjObject obj, FrjRelation rel)
        throws NoSuchRelatedObjectException {

        String relName = rel.getRelationName();
        if (relName.equals(FrjRelations.REFER_SPECIAL)) {
            expression = (FrjExpression) obj;
        }
        else if (relName.equals(FrjRelations.SYMBOL_COMMENT)) {
            setRelatedComment(obj);
        }
        else {
            throw new NoSuchRelatedObjectException(rel);
        }
    }
    public void sortRelatedObjects(VectorSorter sorter) {
    }

    /** Traverse <I>refer_special</I>. */
    public FrjExpression getExpression() {
        return expression;
    }

    /** return parent object if exists */
    public FrjObject getParentObject() {
        return expression;
    }

    public boolean isThis() {
        return str.equals("this");
    }
    public boolean isSuper() {
        return str.equals("super");
    }
    public boolean isTrue() {
        return str.equals("true");
    }
    public boolean isFalse() {
        return str.equals("false");
    }
    public boolean isNull() {
        return str.equals("null");
    }
    public boolean isClass() {
        return str.equals("class");
    }

    // traverse method
    public void traverse(TraverseMethod tm) {
        tm.doBeforeTraverse(this);
        tm.doMyself(this);
        tm.doAfterTraverse(this);
    }
}
