/* 
 * Program:             $RCSfile: ReflectionUtil.java,v $  $Revision: 41.9 $
 * 
 * Purpose:             Reflection access to member variable of Freja object.
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: ReflectionUtil.java,v 41.9 2003/02/15 11:56:34 yamamoto Exp yamamoto $
 */

package Japid.Freja;

import java.lang.reflect.Field;

public class ReflectionUtil {
    /**
     * nameˤɽեɤ롥
     */
    public static Field getTargetField(Object obj, String name) {
        Field targetField = null;

        try {
            targetField = obj.getClass().getField(name);
        } catch (NoSuchFieldException e) {
            FrjWorld.error("No such field \"" + name + "\".");
        } catch (SecurityException e) {
            e.printStackTrace();
        }
        return targetField;
    }

    /****************************** int ******************************/

    /**
     * nameˤɽեɤIntͤ롥
     */
    public static int getAttrValIntByName(Object obj, String name) {
        int return_int = -1;

        Field targetField = getTargetField(obj, name);
        if(targetField == null) return -1;

        try {
            return_int = targetField.getInt(obj);
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }
        return return_int;
    }

    /**
     * nameˤɽեɤIntͤꤹ롥
     */
    public static void setAttrValIntByName(Object obj, String name, int val) {
        Field targetField = getTargetField(obj, name);
        if (targetField == null) {
            return;
        }

        try {
            targetField.setInt(obj, val);
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }
    }

    /****************************** long ******************************/

    /**
     * nameˤɽեɤLongͤ롥
     */
    public static long getAttrValLongByName(Object obj, String name) {
        long return_long = -1;

        Field targetField = getTargetField(obj, name);
        if(targetField == null) return -1;

        try {
            return_long = targetField.getLong(obj);
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }
        return return_long;
    }

    /**
     * nameˤɽեɤLongͤꤹ롥
     */
    public static void setAttrValLongByName(Object obj, String name, long val) {
        Field targetField = getTargetField(obj, name);
        if (targetField == null) {
            return;
        }

        try {
            targetField.setLong(obj, val);
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }
    }

    /****************************** String ******************************/

    /**
     * nameˤɽեɤStringͤ롥
     */
    public static String getAttrValStringByName(Object obj, String name) {
        String return_str = null;

        Field targetField = getTargetField(obj, name);
        if (targetField == null) {
            return null;
        }

        try {
            return_str = (String)targetField.get(obj);
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }
        return return_str;
    }

    /**
     * nameˤɽեɤStringͤꤹ롥
     */
    public static void setAttrValStringByName(Object obj,
                                              String name, String val) {
        Field targetField = getTargetField(obj, name);
        if (targetField == null) {
            return;
        }

        try {
            targetField.set(obj, val);
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }
    }
}
