/* 
 * Program:             $RCSfile: RelationTest.java,v $  $Revision: 41.8 $
 * 
 * Purpose:             A test class of "Japid.Freja".
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: RelationTest.java,v 41.8 2003/02/15 11:56:32 yamamoto Exp yamamoto $
 */

package Japid.Freja;

import java.io.*;
import java.util.*;

public class RelationTest {
    private static Vector relatedObjects = new Vector();

    public static void main(String args[]) {
        if (args.length == 0) {
            return;
        }

        FrjWorld.setUsingCreja(false);

        for (int i = 0; i < args.length; i++) {
            String className = args[i];

            /* SDBǡɤ߹ࡥ */
            FrejaEntry entry = new FrejaEntry(FrjWorld.J_MODEL_PATH, className);
            if (!entry.exists()) {
                FrjWorld.errorExit(className + ": No such SDB.");
            }
            Japid.Freja.FrjWorld.message("loading "
                                         + entry.getFrejaPath() + "...");
            FrjWorld.load(entry);
                
            boolean passed = true;
            System.err.println("Search for unreachable objects...");
            System.err.print("Extents: " + FrjExtents.getObjectNums() + " ");
            System.err.flush();
            Enumeration e
                = FrjExtents.getObjects(FrjFile.getClassNameStatically());
            FrjObject file = (FrjObject) e.nextElement();
            traverseRelatedObjects(file);
                        
            System.err.println("Reachable: " + relatedObjects.size());
            if (FrjExtents.getObjectNums() != relatedObjects.size()) {
                passed = false;
            }
                
            for (Enumeration e1 = FrjExtents.getAllObjects();
                 e1.hasMoreElements();) {
                FrjObject obj = (FrjObject) e1.nextElement();
                if (!relatedObjects.contains(obj)) {
                    System.err.println("Unreachable: " + obj);
                    passed = false;
                }
            }
            if (passed) {
                System.err.println("Test Passed.");
            } else {
                System.err.println("Test Failed.");
            }

            System.err.println("Search for uni-linked objects...");
            passed = true;
            for (Enumeration e2 = FrjExtents.getAllObjects();
                 e2.hasMoreElements();) {
                FrjObject obj = (FrjObject) e2.nextElement();

              loop:
                for (Enumeration e3 = obj.getRelatedObjects();
                     e3.hasMoreElements();) {
                    FrjObject relatedObj = (FrjObject) e3.nextElement();
                    for (Enumeration e4 = relatedObj.getRelatedObjects();
                         e4.hasMoreElements();) {
                        if (e4.nextElement() == obj) {
                            continue loop;
                        }
                    }
                    System.err.println("Uni-linked: " + obj + "\n"
                                       + " ==> " + relatedObj);
                    passed = false;
                }
            }
            if (passed) {
                System.err.println("Test Passed.");
            } else {
                System.err.println("Test Failed.");
            }

            clear();
            System.err.println();
        }
    }

    private static void clear() {
        FrjExtents.clear();
        relatedObjects.removeAllElements();
    }
                
    private static void traverseRelatedObjects(FrjObject obj) {
        if (relatedObjects.contains(obj)) {
            return;
        }
                        
        relatedObjects.addElement(obj);
        for (Enumeration e = obj.getRelatedObjects();
             e.hasMoreElements();) {
            traverseRelatedObjects((FrjObject) e.nextElement());
        }
    }
}
