/* 
 * Program:             $RCSfile: STB.java,v $  $Revision: 41.8 $
 * 
 * Purpose:             A test class of "Japid.Freja".
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: STB.java,v 41.8 2003/02/12 03:39:41 yamamoto Exp yamamoto $
 */

package Japid.Freja;

import java.io.*;
import java.util.*;

/**
 *  STB is Simple Textbase Browser.
 */ 

public class STB {
    public static void main(String args[]) {
        if (args.length == 0) {
            usage();
            return;
        }
        FrjWorld.setUsingCreja(false);

        FrjWorld.message("start reading Data");

        /* SDBǡɤ߹ */
        FrejaEntry entry = new FrejaEntry(FrjWorld.J_MODEL_PATH, args[0]);
        FrjWorld.load(entry);

        FrjWorld.message("...");

        /* (Expression)ķꤹ */
        // FrjExpression.setTypes();

        FrjWorld.message("finish reading Data");

        System.out.println("Object: " + FrjExtents.getObjectNums()
                           + " Relation: " + FrjExtents.getRelationNums());
        // System.out.println("Max OID: " + entry.maxOID +
        //                    " Max RID: " + entry.maxRID);
        System.out.println("Memory: " + Runtime.getRuntime().totalMemory());

        for (int i = 1; i < args.length; i++) {
            if (args[i].indexOf('_') < 0) {     // Class.
                String className = args[i];
                System.out.println("Objects " + className);
                VectorSorter sorter
                    = new SortByOffset(FrjExtents.getObjects(className));
                sorter.sort();
                                
                for (Enumeration e = sorter.getVector().elements();
                     e.hasMoreElements();) {
                    FrjObject obj = (FrjObject) e.nextElement();
                    System.out.println(obj);
                    for (Enumeration e2 = obj.getRelatedObjects();
                         e2.hasMoreElements();) {
                        System.out.println("    " + e2.nextElement());
                    }
                }
            } else {    // Relation.
                String relName = args[i];
                System.out.println("Relation " + relName);
                for (Enumeration e = FrjExtents.getRelations(relName);
                     e.hasMoreElements();) {
                    System.out.println((FrjRelation) e.nextElement());
                }
            }
        }
    }

    static void usage() {
        System.err.println("Usage: java Japid.Freja.STB FileName [DBClasses]");
    }
}
