/* 
 * Program:             $RCSfile: VectorSorter.java,v $  $Revision: 41.4 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: VectorSorter.java,v 41.4 2003/02/12 03:39:43 yamamoto Exp yamamoto $
 */

package Japid.Freja;

import java.util.Vector;
import java.util.Enumeration;

public abstract class VectorSorter {
    protected Vector    v;

    public VectorSorter(Vector v) {
        this.v = v;
    }

    public VectorSorter() {
        this.v = null;
    }

    public VectorSorter(Enumeration e) {
        setEnumeration(e);
    }

    public void setVector(Vector v) {
        this.v = v;
    }
    public void setEnumeration(Enumeration e) {
        this.v = new Vector();
        while (e.hasMoreElements()) {
            v.addElement(e.nextElement());
        }
    }
    public Vector getVector() {
        return v;
    }

    public Enumeration getEnumeration() {
        return v.elements();
    }

    /**
     *  compare a and b
     *      if a < b  return negative
     *      if a > b  return positive
     *      if a == b return 0
     */
    abstract protected int compare(Object a, Object b);

        
    private Object[] work;
    private int mi, mj, mk, mp;
    public void sort() {
        if (v.size() > 50) {
            work = new Object[v.size()/2 +1];
            msort(0, v.size()-1);
        } else {
            bsort();
        }
    }
    private void msort(int first, int last) {
        if (first < last) {
            int middle = (first + last) / 2;
            msort(first, middle);
            msort(middle + 1, last);
            mp = 0;
            try {
                for (mi = first; mi <= middle; mi++) {
                    work[mp++] = v.elementAt(mi);
                }
            }
            catch (Exception e) {
                e.printStackTrace();
                System.err.println("mp: " + mp + " mi: " + mi
                                   +" mj: " + mj + " mk: " + mk);
            }
            mi = middle + 1; mj = 0; mk = first;
            while (mi <= last && mj < mp) {
                if (compare(work[mj], v.elementAt(mi)) <= 0) {
                    v.setElementAt(work[mj++], mk++);
                } else {
                    v.setElementAt(v.elementAt(mi++), mk++);
                }
            }
            while (mj < mp) {
                v.setElementAt(work[mj++], mk++);
            }
        }
    }

    public void bsort() {
        /** sort list by bubble sort algorithm  */
        boolean swaped = false; 
        int             last = v.size();

        do {
            swaped = false;
            for (int i = 0; i < last -1; i++) {
                Object a = v.elementAt(i);
                Object b = v.elementAt(i+1);
                if (compare(a, b) > 0) {
                    swap(a, b);
                    swaped = true;
                }
            }
        } while (swaped);
    }

    protected void swap(Object a, Object b) {
        int             indexA = v.indexOf(a);
        int             indexB = v.indexOf(b);
        Object  tmp = a;
                
        v.setElementAt(b, indexA);
        v.setElementAt(tmp, indexB);
    }
}
