/* 
 * Program:             $RCSfile: IsValidXML.java,v $  $Revision: 40.6 $
 * 
 * Purpose:             
 *
 * Author:              S.Yamamoto  2003/01/20
 *
 * (C) Copyright:       S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: IsValidXML.java,v 40.6 2003/06/12 11:38:24 yamamoto Exp yamamoto $
 */

package Japid.Tools.IsValidXML;

import java.io.*;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;

import Japid.util.Stopwatch;

public class IsValidXML {
    public static void main(String[] args) throws Exception {
        Stopwatch timer = new Stopwatch().start();

        InputSource is = new InputSource(new FileInputStream(args[0]));
        String uri = new File(args[0]).toURI().toString();
        is.setSystemId(uri);
        SAXParserFactory spf = SAXParserFactory.newInstance();
        spf.setValidating(true);
        SAXParser sp = spf.newSAXParser();
        sp.parse(is, new TestHandler());

        timer.printTimeProf("IsValidXML");
        return;
    }
}

class TestHandler extends DefaultHandler {
    public void error (SAXParseException ex) throws SAXException {
        System.err.print("Error: ");
        System.err.print("l." + Integer.toString(ex.getLineNumber()) + ", ");
        System.err.print("c." + Integer.toString(ex.getColumnNumber()) + ": ");
        System.err.println(ex.getMessage());
    }
}
