/* 
 * Program:             $RCSfile: PrintMembersInRoutine.java,v $  $Revision: 40.5 $
 * 
 * Purpose:             
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: PrintMembersInRoutine.java,v 40.5 2003/02/15 11:56:43 yamamoto Exp yamamoto $
 */

package Japid.Tools;

import java.util.*;
import Japid.Freja.*;
import Japid.Freja.F2S.*;

/** ȤƤѿvars˼ */
class GetRefVar implements TraverseMethod {
    Vector      LVarExprs = new Vector();
    Vector      RVarExprs = new Vector();
    Vector      OOVarExprs = new Vector();
    Vector      callers = new Vector();

    public void doBeforeTraverse(FrjObject obj) {
    }

    /** objѿλȼǥѿ򻲾ȤƤvars˲ä */
    public void doMyself(FrjObject obj) {
        if (obj instanceof FrjExpression) {
            FrjExpression expr = (FrjExpression) obj;
            if (expr.getSort() == FrjExpression.REF_VAR) {
                                // ѿλȼ
                FrjVariable var = (FrjVariable) expr.getReferree();
                // ȤƤѿ
                if (var != null
                    && var.getSort() == FrjVariable.CLASS_MEM) {
                    // ѿλȼ
                    int lrsort = expr.getLRSort();
                    if (lrsort == FrjExpression.R_VALUE) {
                        // 
                        if (!RVarExprs.contains(var)
                            && !LVarExprs.contains(var)) {
                            RVarExprs.addElement(var);
                        }
                    }
                    else if (lrsort == FrjExpression.L_VALUE
                             || lrsort == FrjExpression.LR_VALUE) {
                        // 
                        if (!LVarExprs.contains(var)) {
                            LVarExprs.addElement(var);
                            if (RVarExprs.contains(var)) {
                                RVarExprs.removeElement(var);
                            }
                        }
                    }
                    else if (lrsort == FrjExpression.OBJECT_OPERATION) {
                        if (!OOVarExprs.contains(var)) {
                            OOVarExprs.addElement(var);
                        }
                    }
                }
            }
            else if (expr.getSort() == FrjExpression.METHOD_CALL) {
                                // ᥽åɸƤӽФ
                expr.setType();
                FrjRoutine r = expr.getRoutine();
                if (r != null) {
                    callers.addElement(r);
                }
            }
        }
    }
    public void doAfterTraverse(FrjObject obj) {
    }
}

/** 롼ǻȤƤѿɽ */
public class PrintMembersInRoutine {
    public static void main(String args[]) {
        if (args.length == 0) {
            System.err.println("Usage: command ClassName");
            return;
        }
        // Υ饹SDBɤ߹
        new F2SLoader().load(Creja.getFrejaEntry(args[0]));

        // Routine饹Υ֥Ȥ
        Enumeration routines
            = FrjExtents.getObjects(FrjRoutine.getClassNameStatically());
                
        // Routine饹Υ֥Ȥoffsetǥ
        VectorSorter sorter = new SortByOffset(routines);
        sorter.sort();
                
        for (Enumeration e = sorter.getVector().elements();
             e.hasMoreElements();) {
            FrjRoutine r = (FrjRoutine) e.nextElement();

            // r ʲΥ֥ȤGetRefVarǥȥС
            GetRefVar grv = new GetRefVar();
            r.traverse(grv);

            // ᥽åɡ󥹥ȥ饯ν
            printRoutine(r);
            System.out.println(":");

            // ѿƤӽФƤ᥽åɤν
            printVars(grv.LVarExprs, "  Left Values");
            printVars(grv.RVarExprs, "  Right Values");
            printVars(grv.OOVarExprs, "  Object Operations");
            printRoutines(grv.callers, "  Callers");
            System.out.println();
        }
    }

    static void printVars(Vector v, String mes) {
        int VAR_LEN = 20, TYPE_LEN = 10;
        if (v.size() > 0) {
            System.out.println(mes);
            for (Enumeration e = v.elements();
                 e.hasMoreElements();) {
                F2SVariable var = (F2SVariable) e.nextElement();
                System.out.print("    ");
                print(var.getStr(), VAR_LEN);
                System.out.print(": ");
                print(((F2SType) var.getType()).toSource(), TYPE_LEN);
                System.out.println();
            }
        }
    }

    static void printRoutines(Vector v, String mes) {
        if (v.size() > 0) {
            System.out.println(mes);
            for (Enumeration e = v.elements();
                 e.hasMoreElements();) {
                System.out.print("    ");
                printRoutine((FrjRoutine) e.nextElement());
                System.out.println();
            }
        }
    }

    static void printRoutine(FrjRoutine r) {
        F2SType rt = (F2SType) r.getReturnType();
        if (rt != null) {
            System.out.print(rt.toSource() + " ");
        }
        System.out.print(r.getStr() + "(");
        VectorSorter sorter1 = new SortByOffset(r.getParameters());
        sorter1.sort(); // offsetǥ
        String comma = "";
        for (Enumeration e1 = sorter1.getVector().elements();
             e1.hasMoreElements();) {
            System.out.print(comma
                             + ((F2SVariable) e1.nextElement()).toSource());
            comma = ", ";
        }
        System.out.print(")");
    }

    static void print(String s, int len) {
        System.out.print(s);
        for (int i = s.length(); i < len; i++) {
            System.out.print(" ");
        }
    }
}
