/* 
 * Program:             $RCSfile: DataModel.java,v $  $Revision: 40.3 $
 * 
 * Purpose:             
 *
 * Author:              H.Kuwabara  2003/06/02
 *                      S.Yamamoto  2003/06/02
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: DataModel.java,v 40.3 2003/07/08 05:47:56 yamamoto Exp yamamoto $
 */

package Japid.Tools.Syab3;

import java.text.MessageFormat;
import Japid.Freja.*;

public class DataModel {
    private Resource res;

    private FrejaEntry entry;
    private String className;
    private static int frejaID;

    private DataModel() {
        res = Resource.getInstance();
        frejaID = 1;
    }

    public DataModel(String className, String loaderName, int frejaID) {
        this();
        if (frejaID >= FrjID.MAX_FREJA) {
            this.frejaID = frejaID % FrjID.MAX_FREJA;
        } else {
            this.frejaID = frejaID;
        }

        if (loaderName != null) {
            try {
                Class clazz = Class.forName(loaderName);
                FrjWorld.setLoader((Loader)clazz.newInstance());
            } catch (Exception e) {
                FrjWorld.errorExit(MessageFormat.format(res.getString("NoLoader"), 
                                                        new String[]{loaderName}));
            }
        }

        setClassName(className);
    }

    protected void load() {
        entry = Creja.getFrejaEntry(className);
        if (entry == null) {
            String mes = MessageFormat.format(res.getString("dialog.NoSDB.message"), 
                                              new String[]{className});
            String title = res.getString("dialog.NoSDB.title");
            MessageDialog.showMessageDialog(mes, title, 
                                            MessageDialog.WARNING_MESSAGE);
            return;
        }

        FrjWorld.load(entry);
    }

    public void reload() {
        FrjExtents.clear();
        load();
    }

    public FrejaEntry getFrejaEntry() {
        return entry;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public static long convertToFullID(long id) {
        return FrjID.getID(frejaID, FrjID.getFrejaDataID(id));
    }
}
