/* 
 * Program:             $RCSfile: RelationsListModel.java,v $  $Revision: 40.3 $
 * 
 * Purpose:             
 *
 * Author:              H.Kuwabara  2003/06/02
 *                      S.Yamamoto  2003/06/02
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: RelationsListModel.java,v 40.3 2003/07/08 05:47:57 yamamoto Exp yamamoto $
 */

package Japid.Tools.Syab3;

import java.util.ArrayList;
import java.util.Enumeration;
import javax.swing.DefaultListModel;
import javax.swing.JList;

import Japid.Freja.*;

public class RelationsListModel extends DefaultListModel {
    private ArrayList listRelations;
    private FrjObject specifiedObject;

    public RelationsListModel() {
        listRelations = new ArrayList();
    }

    public void setRelations(FrjObject object) {
        specifiedObject = object;
        removeAllRelations();

        FrjObject parent = object.getParentObject();
        FrjRelation parentRelation = null;

        for (Enumeration e = object.getRelations(); e.hasMoreElements(); ) {
            FrjRelation rel = (FrjRelation)e.nextElement();
            if (rel.getRelatedObject(object).equals(parent)) {
                parentRelation = rel;
                addParentRelation(parentRelation);
                break;
            }
        }

        for (Enumeration e = object.getRelations(); e.hasMoreElements(); ) {
            FrjRelation rel = (FrjRelation)e.nextElement();
            if (rel == parentRelation) {
                continue;
            }
            addRelation(rel);
        }
    }

    protected void addParentRelation(FrjRelation relation) {
        if (relation != null) {
            listRelations.add(relation);
            addElement("[[" + relation.getRelationName() + "]]" + 
                       DataModel.convertToFullID(relation.getID()));
        }
    }

    protected void addRelation(FrjRelation relation) {
        if (relation != null) {
            listRelations.add(relation);
            addElement("[" + relation.getRelationName() + "]" + 
                       DataModel.convertToFullID(relation.getID()));
        }
    }

    public void removeAllRelations() {
        listRelations.clear();
        removeAllElements();
    }

    public FrjObject getRelatedObject(int index) {
        if (index >= 0 && index < listRelations.size()) {
            FrjRelation relation = (FrjRelation)listRelations.get(index);
            return relation.getRelatedObject(specifiedObject);
        } else {
            return null;
        }
    }
}
