/* 
 * Program:             $RCSfile: Resource.java,v $  $Revision: 40.3 $
 * 
 * Purpose:             
 *
 * Author:              H.Kuwabara  2003/06/02
 *                      S.Yamamoto  2003/06/02
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: Resource.java,v 40.3 2003/07/08 05:47:58 yamamoto Exp yamamoto $
 */

package Japid.Tools.Syab3;

import java.util.Locale;
import java.util.ResourceBundle;
import java.util.MissingResourceException;

import Japid.Freja.*;

public final class Resource {
    private static final Resource resource = new Resource();
    private static ResourceBundle rb = null;

    static {
        if (rb == null) {
            try {
                rb = ResourceBundle.getBundle("Japid.Tools.Syab3.resources.Syab3", 
                                              Locale.getDefault());
            } catch (MissingResourceException e) {
                FrjWorld.errorExit("Can't find resource file.");
            }
        }
    }

    private Resource() {
    }

    /**
     *  Gets a resource bundle of Syab3.
     *  @return a resource bundle
     */
    public static Resource getInstance() {
        return resource;
    }

    /**
     *  Gets a string for the given key.
     *  @param key the key for the desired string
     *  @return the string for the given key
     */
    public String getString(String key) {
        String value;

        try {
            value = rb.getString(key);
        } catch (MissingResourceException e) {
            value = "";
        }

        return value;
    }
}
