/* 
 * Program:             $RCSfile: SourceCodeArea.java,v $  $Revision: 40.3 $
 * 
 * Purpose:             
 *
 * Author:              H.Kuwabara  2003/06/02
 *                      S.Yamamoto  2003/06/02
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SourceCodeArea.java,v 40.3 2003/07/08 05:47:58 yamamoto Exp yamamoto $
 */

package Japid.Tools.Syab3;

import java.awt.Font;
import javax.swing.JTextArea;

import Japid.Freja.*;

public class SourceCodeArea extends JTextArea {
    private DataModel model;

    private SourceCodeArea() {
        setEditable(false);
        setFont(new Font("Monospaced", Font.PLAIN, 14));
    }

    public SourceCodeArea(DataModel model) {
        this();
        this.model = model;
    }

    public void load() {
        FrejaEntry entry = model.getFrejaEntry();

        if (entry == null) {
            return;
        }

        setText(entry.readText(0, entry.getFileSize()));
    }

    public void reload() {
        setText("");
        load();
    }

    public void select(FrjObject object) {
        select(object.getOffset(), object.getOffset() + object.getLength());
    }
}
