/* 
 * Program:             $RCSfile: ViewModelMediator.java,v $  $Revision: 40.3 $
 * 
 * Purpose:             
 *
 * Author:              H.Kuwabara  2003/06/02
 *                      S.Yamamoto  2003/06/02
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: ViewModelMediator.java,v 40.3 2003/07/08 05:47:58 yamamoto Exp yamamoto $
 */

package Japid.Tools.Syab3;

import Japid.Freja.*;

public class ViewModelMediator {
    private SpecifiedObjectsListModel listObjects;
    private ObjectAttributesArea attrsObject;
    private RelationsListModel listRelations;
    private ObjectAttributesArea attrsRelation;
    private SourceCodeArea sourceCode;

    public ViewModelMediator() {
    }

    public void registObjectsListModel(SpecifiedObjectsListModel model) {
        listObjects = model;
    }

    public void registObjectAttributes(ObjectAttributesArea area) {
        attrsObject = area;
    }

    public void registRelationsListModel(RelationsListModel model) {
        listRelations = model;
    }

    public void registRelationAttributes(ObjectAttributesArea area) {
        attrsRelation = area;
    }

    public void registSourceCodeArea(SourceCodeArea area) {
        sourceCode = area;
    }

    public SpecifiedObjectsListModel getObjectsListModel() {
        return listObjects;
    }

    public RelationsListModel getRelationsListModel() {
        return listRelations;
    }

    public void reload() {
        listObjects.removeAllObjects();
        attrsObject.clearText();
        listRelations.removeAllRelations();
        attrsRelation.clearText();
        sourceCode.reload();
    }

    public void selectClass(String className) {
        listObjects.setObjects(className);
        attrsObject.clearText();
        listRelations.removeAllElements();
        attrsRelation.clearText();
    }

    public void selectObject(int index) {
        FrjObject object = listObjects.getObject(index);
        if (object != null) {
            attrsObject.setObject(object);
            listRelations.setRelations(object);
            attrsRelation.clearText();
            sourceCode.select(object);
        }
    }

    public void selectRelation(int index) {
        FrjObject object = listRelations.getRelatedObject(index);
        if (object != null) {
            attrsRelation.setObject(object);
            sourceCode.select(object);
        }
    }

    public void selectOffsetSorter() {
        listObjects.useSorterByOffset();
    }

    public void selectIDSorter() {
        listObjects.useSorterByID();
    }

    public void where() {
        int start = sourceCode.getSelectionStart();
        int end = sourceCode.getSelectionEnd();
        listObjects.setObjects(start, end);
        attrsObject.clearText();
        listRelations.removeAllRelations();
        attrsRelation.clearText();
    }
}
