/* 
 * Program:             $RCSfile: ListSelect.java,v $  $Revision: 40.3 $
 * 
 * Purpose:             
 *
 * Author:              H.Kuwabara  2003/06/02
 *                      S.Yamamoto  2003/06/02
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: ListSelect.java,v 40.3 2003/07/08 05:48:00 yamamoto Exp yamamoto $
 */

package Japid.Tools.Syab3.action;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JList;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import Japid.Tools.Syab3.ViewModelMediator;

public abstract class ListSelect 
    extends MouseAdapter implements ListSelectionListener {
    protected ViewModelMediator mediator;
    private JList listView;
    private boolean changed;

    private ListSelect() {
        changed = false;
    }

    public ListSelect(ViewModelMediator mediator, JList listView) {
        this();
        this.mediator = mediator;
        this.listView = listView;
    }

    public void mouseReleased(MouseEvent e) {
        int index = listView.getSelectedIndex();
        if (!changed && (index == listView.locationToIndex(e.getPoint()))) {
            select(index);
        }
        changed = false;
    }

    public void valueChanged(ListSelectionEvent e) {
        if (!e.getValueIsAdjusting()) {
            select(listView.getSelectedIndex());
            changed = true;
        } else {
            changed = false;
        }
    }

    protected abstract void select(int index);
}
