/* 
 * Program:             $RCSfile: Load.java,v $  $Revision: 40.3 $
 * 
 * Purpose:             
 *
 * Author:              H.Kuwabara  2003/06/02
 *                      S.Yamamoto  2003/06/02
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: Load.java,v 40.3 2003/07/08 05:48:00 yamamoto Exp yamamoto $
 */

package Japid.Tools.Syab3.action;

import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.JOptionPane;

import Japid.Tools.Syab3.DataModel;
import Japid.Tools.Syab3.Frame;
import Japid.Tools.Syab3.Resource;
import Japid.Tools.Syab3.ViewModelMediator;

public class Load extends AbstractAction {
    private DataModel model;
    private Frame frame;
    private ViewModelMediator mediator;

    private Load() {
    }

    public Load(DataModel model, Frame frame, ViewModelMediator mediator) {
        this.model = model;
        this.frame = frame;
        this.mediator = mediator;
    }

    public void actionPerformed(ActionEvent e) {
        Resource res = Resource.getInstance();
        String className = JOptionPane.showInputDialog(frame,
                                                       res.getString("dialog.class.message"), 
                                                       res.getString("dialog.class.title"), 
                                                       JOptionPane.QUESTION_MESSAGE);

        if (className != null) {
            model.setClassName(className);
            model.reload();
            mediator.reload();
            frame.setOpenClassName(className);
        }
    }
}
