/* 
 * Program:             $RCSfile: CrejaLoader.java,v $  $Revision: 40.6 $
 * 
 * Purpose:             
 *
 * Author:              K.Hoshino  2000/07/08
 *                      S.Yamamoto  2000/07/08
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: CrejaLoader.java,v 40.6 2003/02/15 11:56:46 yamamoto Exp yamamoto $
 */

package Japid.Tools.jspie;

import java.io.*;
import java.util.*;
import Japid.Freja.*;

public class CrejaLoader {
    static final String className = "CrejaLoader";

    CrejaLoader() {
    }
    
    // 1ĤΥ饹ɤ߹ The TAO of Japid P7
    public boolean makeObject(String className) {
        FrejaEntry entry = Creja.getFrejaEntry(className);
        if (entry == null || !entry.exists()) {  // Freja¸ߤʤ
            JspieUtil.error(className, "No such Freja.");
            return false;
        }
        FrjWorld.load(entry);  // SDBǡɤ
        return true;
    }
    
    // ѥå饹ɤ߹ The TAO of Japid P14
    public boolean makeAllObject(String packageName) {
        boolean return_value = false;

        for (Enumeration e = Creja.getClasses(packageName); e.hasMoreElements();) {
            String className = (String) e.nextElement();
            FrejaEntry entry = Creja.getFrejaEntry(packageName, className);

            if (entry != null && entry.exists()) {  // Freja¸ߤ
                FrjWorld.load(entry);  // SDBǡɤ
                return_value = true;
            } else {
                JspieUtil.error(className, "No such Freja.");
            }
        }
        // packageName¤classNameä
        if (!return_value) {
            return_value = makeObject(packageName);
        }
        return return_value;
    }
    
    public void loadCreja(String args[]) {
        boolean success = false;
            
        if (args.length > 0) {
            for (int i = 0; i < args.length; i++) {
                success |= makeAllObject(args[i]);
            }
            if (!success) {
                JspieUtil.error(className, "Can't open Freja at all.");
            }
        }
    }
}
