/* 
 * Program:             $RCSfile: JspieDoclet.java,v $  $Revision: 40.5 $
 * 
 * Purpose:             
 *
 * Author:              K.Hoshino  2001/10/02
 *                      S.Yamamoto  2001/10/02
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: JspieDoclet.java,v 40.5 2003/02/15 11:56:47 yamamoto Exp yamamoto $
 */

package Japid.Tools.jspie;

import java.io.*;
import com.sun.javadoc.*;

import Japid.Freja.*;
import Japid.Tools.jspie.doclets.*;
import Japid.Tools.jspie.doclets.standard.*;

public class JspieDoclet extends Standard {
    // Override start() method !
    /**
     * The "start" method as required by Javadoc.
     *
     * @param Root
     * @see com.sun.javadoc.Root
     * @return boolean
     */
    public static boolean start(RootDoc root) throws IOException {
        ClassDoc classdoc[] = root.specifiedClasses();
        PackageDoc packagedoc[] = root.specifiedPackages();

        String options[][] = root.options();

        Jspie jspie_object = new Jspie();

        String to_jspie[] = new String[classdoc.length + packagedoc.length];
        for (int i = 0; i < classdoc.length; i++) {
            to_jspie[i] = classdoc[i].qualifiedName();
        }
        for (int i = classdoc.length; i < to_jspie.length; i++) {
            to_jspie[i] = packagedoc[i].name();
        }

        jspie_object.start(options, to_jspie);

        try { 
            configuration().setOptions(root);
            (new JspieDoclet()).startGeneration(root);

            jspie_object.writeSourceFiles();
        } catch (DocletAbortException exc) {
          //exc.printStackTrace();
            return false; // message has already been displayed
        }
        return true;
    }
}
