/* 
 * Program:             $RCSfile: SourceFile.java,v $  $Revision: 40.5 $
 * 
 * Purpose:             Υե롤ѹʤɤݻ
 *                      եHTMLΥեؤνϡ
 *
 * Author:              K.Hoshino  2000/07/08
 *                      S.Yamamoto  2000/07/08
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SourceFile.java,v 40.5 2003/02/15 11:56:48 yamamoto Exp yamamoto $
 */

package Japid.Tools.jspie;

import java.io.*;
import java.util.*;
import Japid.Freja.*;

/**
 * ByteBuffer version
 *
 * JavaƤΡʸפUnicode2 (or 3, or more?)Хʸ
 * ݻƤ(char2ХȤǤ)Japidϴ
 * ǤoffsetʤɤХñ̤Ƿ׻Ƥꡤܸʤɤ2ХȤ1
 * Ĥʸ̣Τɤ¸ߤȡʬƤޤ
 *
 * ΤᡤStringBufferѤΤϤᡤȼ˺ 
 * jspie.ByteBuffer饹Ѥ褦
 */

public class SourceFile {
    static final String className = "SourceFile";

    /** 񤭴Υե */
    ByteBuffer pure_source = null;
    /** 񤭴Υե */
    ByteBuffer source = null;

    /** ϥǥ쥯ȥΥ롼 */
    String out_dir_root = ".";
    /** ϥǥ쥯ȥ */
    String out_dir_dir = ".";
    /** ϥե̾ */
    String out_filename = "somename.java";

    /** ϥǥ쥯ȥΥ롼Ȥο */
    int depth = 0;
    String depthString = null;

    /** եHTMLΤνϥե̾ */
    String out_file = "somename.java.html(zettai path)";
    /** եHTMLΤΥ롼Ȥнϥե̾ */
    String out_source_file_from_root = "somename.java.html(soutai path)";

    Vector changeVector = null;
    SourceChange[] changeArray = null;

    FrejaEntry entry = null;
    FrjFile f = null;

    //MoreInfoManager moreinfo_manager;

    public SourceFile(FrjFile f, String out_dir/*, MoreInfoManager moreinfo_manager*/) {
        this.f = f;
        entry = f.getFrejaEntry();

        this.pure_source = new ByteBuffer(entry.readText(0, entry.getFileSize()));
        this.source = new ByteBuffer(entry.readText(0, entry.getFileSize()));
        this.out_dir_root = out_dir;

        setOutFile();

        changeVector = new Vector();
        //this.moreinfo_manager = moreinfo_manager;
    }

    /**
     * եHTMLν򥻥å
     */
    public void setOutFile() {
        StringBuffer sb = new StringBuffer(f.getStr());
        int from = sb.length();

        while (from != 0 && sb.charAt(from-1) != '/') {
            from--;
        }
        out_filename = sb.substring(from, sb.length());
        
        FrjQName package_def = f.getDefinedPackage();
        if (package_def != null) {
            out_dir_dir = package_def.getFullString();

            /* ѥåο¬ */
            depth = 1;
            for (int i = 0; i < out_dir_dir.length(); i++) {
                if (out_dir_dir.charAt(i) == '.') {
                    depth++;
                }
            }

            out_dir_dir = out_dir_dir.replace('.','/');
        } else {
            depth = 0;
            out_dir_dir = "";
        }

        depthString = new String("./");
        for (int i = 0; i < depth; i++) {
            depthString += "../";
        }

        /* ϥե륻å */
        File file1 = new File(out_dir_dir, out_filename + ".html");
        out_source_file_from_root = new String(file1.getPath());
        file1 = new File(out_dir_root, file1.getPath());
        out_file = new String(file1.getPath());
    }

    /**
     * ѹɲ
     * add change to source
     */
    public void addSourceChange(SourceChange change) {
        boolean overlap = false;

        /* Ťʤ꤬??? */
        long changeID = change.before.getID(); 

        for (int i = 0; i < changeVector.size(); i++) {
            SourceChange inchange = (SourceChange) changeVector.elementAt(i);
            long inID = inchange.before.getID();
            if (changeID == inID) {
                //JspieUtil.error(className, inchange.before.getStr() + " is already in changeVector");
                overlap = true;
            }
        }

        if (!overlap) {
            changeVector.add(change);
        }
    }

    /**
     * ɤؤѹȿǤ
     * reflect changes to plain source code
     */
    private void flushChange() {
        /* sort by StrOffset */

        /* changeArray = (SourceChange[]) changeVector.toArray(); ǤϤ ??? */
        Object[] objectArray = changeVector.toArray();

        changeArray = new SourceChange[objectArray.length];
        for (int i = 0; i<objectArray.length; i++) {
            changeArray[i] = (SourceChange) objectArray[i];
        }
        Arrays.sort(changeArray);

        /* ȿ */
        int offset = 0;
        int buffer_pointer = 0;
        for (int i = 0; i < changeArray.length; i++) {
            SourceChange oneChange = changeArray[i];

            int changeOffset = oneChange.before.getStrOffset();

            /* եΡ񤭴ʸ󤬽ʣƤϤϤʤ */
            if (offset > changeOffset) {
                JspieUtil.error(className, "Change Strings Overlap in source file " + out_file + " !!");
                JspieUtil.error(className, "offset : " + offset + " > changeOffset " + changeOffset);
                JspieUtil.error(className, oneChange.before.getClassName() + " : " + oneChange.before.getStr());
                // System.exit(1);
            } else {
                buffer_pointer += changeOffset - offset;
                int before_length = oneChange.before.getStr().getBytes().length;
                int after_length = oneChange.after.getBytes().length;
                source.replace(buffer_pointer, buffer_pointer + before_length, oneChange.after);
                offset = changeOffset + before_length;
                buffer_pointer += after_length;
            }
        }

        /* ɤ˹ֹĤ */
        putLineNum();
    }

    /**
     * ɤ˹ֹĤ
     * (sourceľƤΤǡѹȿǤθ˹Ԥȡ)
     */
    private void putLineNum() {
        int all_linenum = 0;
        int linenum_length = 0;

        /* Կ */
        for (int i = 0; i < source.length(); i++) {
            all_linenum++;
            while (i + 1 < source.length() && source.charAt(i + 1) != (byte) '\n') {
                i++;
            }
        }
        /* Կη */
        int hoge = all_linenum;
        do {
            linenum_length++;
            hoge = hoge / 10;
        } while (hoge != 0);

        /* ֹĤ */
        int linenum = 0;
        for (int i = 0; i < source.length(); i++) {
            linenum++;

            String linenumStr = String.valueOf(linenum);
            if (linenumStr.length() != linenum_length) {
                StringBuffer linenum_sb = new StringBuffer(linenumStr);
                for (int j = linenumStr.length(); j < linenum_length; j++) {
                    linenum_sb.insert(0, " ");
                }
                linenumStr = linenum_sb.toString();
            }

            String insertStr = coloring(" " + linenumStr + " :\t", "linenumColor");
            source.insert(i, insertStr);
            i += insertStr.length();
            
            while (i < source.length() && source.charAt(i) != (byte) '\n') {
                i++;
            }
        }
    }

    /**
     * եHTML
     * output sourcefile-HTML
     */
    public void writeToFile() throws IOException {
        flushChange();
        
        System.out.println("Now Making SourceFileHTML for [ " + out_file + " ]");
        
        FileWriter fw1 = new FileWriter(out_file);
        writeHeader(fw1);
        
        writeContent(fw1);
        
        writeFooter(fw1);
        fw1.close();
    }

    /**
     * եHTMLΥإåν
     * output sourcefile-HTML header
     */
    private void writeHeader(FileWriter fw1) throws IOException {
        fw1.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2//EN\">\n");
        fw1.write("\n");
        fw1.write("<HTML>\n");
        fw1.write("<HEAD>\n");
        fw1.write("<TITLE></TITLE>\n");

        fw1.write("<LINK REL = \"stylesheet\" TYPE = \"text/css\" HREF = \"");

        fw1.write(depthString);
        fw1.write("jspie.css\">");

        fw1.write("</HEAD>\n");
        fw1.write("\n");
        fw1.write("<BODY BGCOLOR=\"white\">\n");
        fw1.write("\n");
        fw1.write("<PRE>\n");
        fw1.write("\n");
    }

    /**
     * եHTMLƤν
     * output sourcefile-HTML contents
     */
    private void writeContent(FileWriter fw1) throws IOException {
        String source_str = source.toString();
        // source_str = htmlFix(source_str);
        fw1.write(source_str);
    }

    /**
     * եHTMLΥեåν
     * output sourcefile-HTML hooter
     */
    private void writeFooter(FileWriter fw1) throws IOException {
        fw1.write("\n");
        fw1.write("</PRE>\n");
        fw1.write("\n");
        fw1.write("</BODY>\n");
        fw1.write("\n");
        fw1.write("</HTML>\n");
    }

    //
    // 饽եǤβ
    //

    HtmlColor c = new HtmlColor();

    ClassMoreInfo class_moreinfo = null;
    MethodMoreInfo method_moreinfo = null;
    FieldMoreInfo field_moreinfo = null;

    /**
     * եβ
     */
    public void analyseFile() {
        first_move(f);
        
        // 饹
        for (Enumeration e = f.getClasses(); e.hasMoreElements(); ) {
            analyseClass((FrjClass) e.nextElement());
        }
        // 󥿥ե
        for (Enumeration e = f.getInterfaces(); e.hasMoreElements(); ) {
            analyseInterface((FrjInterface) e.nextElement());
        }
        // import 
        for (Enumeration e = f.getImportedPackages(); e.hasMoreElements(); ) {
            analyseQName((FrjQName) e.nextElement());
        }
        // package 
        FrjQName frj_qname = f.getDefinedPackage();
        if (frj_qname != null) {
            analyseQName(frj_qname);
        }
    }

    /**
     * 饹β
     */
    private void analyseClass(FrjClass frj_class) {

        class_moreinfo = new ClassMoreInfo(frj_class);
        class_moreinfo.setDef("<A HREF = \"" + depthString + out_source_file_from_root + "#" + frj_class.getFullClassName() + 
                              "\">" + out_filename + "(line : " + getLineNo(frj_class) + ")</A>");
        class_moreinfo.setCommonName(frj_class.getFullClassName());
        MoreInfoManager.setClassMoreInfo(class_moreinfo);

        first_move(frj_class);

        String after = getHtmlString(frj_class);
        after = coloring(after, c.classColor);
        after = linkToInfo(frj_class, after);
        addSourceChange(new SourceChange(frj_class, after));
        
        // ѿ
        for (Enumeration e = frj_class.getMembers(); e.hasMoreElements(); ) {
            analyseVariable((FrjVariable) e.nextElement());
        }

        // ᥽å
        for (Enumeration e = frj_class.getRoutines(); e.hasMoreElements(); ) {
            analyseRoutine((FrjRoutine) e.nextElement());
        }

        // 
        for (Enumeration e = frj_class.getModifiers(); e.hasMoreElements(); ) {
            analyseModifier((FrjModifier) e.nextElement());
        }

        // SBlock Τ顼Ǥ
        //for (Enumeration e = frj_class.getMembers(); e.hasMoreElements(); ) {
        //    analyseSBlock((FrjSBlock) e.nextElement());
        //}

        //Enumeration e = frj_class.getMembers();
        //if (e.hasMoreElements()) {
        //    for (; e.hasMoreElements(); ) {
        //        analyseSBlock((FrjSBlock) e.nextElement());
        //    }
        //}
    }

    /**
     * 󥿥եβ
     */
    private void analyseInterface(FrjInterface frj_interface) {

        class_moreinfo = new ClassMoreInfo(frj_interface);
        class_moreinfo.setDef("<A HREF = \"" + depthString + out_source_file_from_root + "#" + 
                              frj_interface.getFullClassName() + "\">" +
                              out_filename + "(line : " + getLineNo(frj_interface) + ")</A>");
        class_moreinfo.setCommonName(frj_interface.getFullClassName());
        MoreInfoManager.setClassMoreInfo(class_moreinfo);

        first_move(frj_interface);

        String after = getHtmlString(frj_interface);
        after = coloring(after, c.interfaceColor);
        after = linkToInfo(frj_interface, after);
        addSourceChange(new SourceChange(frj_interface, after));
        
        // ѿ
        for (Enumeration e = frj_interface.getMembers(); e.hasMoreElements(); ) {
            analyseVariable((FrjVariable) e.nextElement());
        }

        // ᥽å
        for (Enumeration e = frj_interface.getRoutines(); e.hasMoreElements(); ) {
            analyseRoutine((FrjRoutine) e.nextElement());
        }

        // 
        for (Enumeration e = frj_interface.getModifiers(); e.hasMoreElements(); ) {
            analyseModifier((FrjModifier) e.nextElement());        
        }

        // SBlock
        for (Enumeration e = frj_interface.getMembers(); e.hasMoreElements(); ) {
            analyseSBlock((FrjSBlock) e.nextElement());
        }
    }

    /**
     * ᥽åɡ󥹥ȥ饯β
     */
    private void analyseRoutine(FrjRoutine frj_routine) {

        String common_name = getRoutineFullName(frj_routine);
        method_moreinfo = new MethodMoreInfo(frj_routine);
        method_moreinfo.setDef("<A HREF = \"" + depthString + out_source_file_from_root + "#" + common_name + "\">" +
                               out_filename + "(line : " + getLineNo(frj_routine) + ")</A>");
        method_moreinfo.setCommonName(common_name);
        class_moreinfo.setMethodMoreInfo(method_moreinfo);

        first_move(frj_routine);

        String after = null;
        int sort = frj_routine.getSort();

        after = getHtmlString(frj_routine);
        if (sort == FrjRoutine.METHOD) {
            after = coloring(after, c.methodColor);
            after = linkToInfo(frj_routine, after);

            // ֤ͤη
            if (sort == FrjRoutine.METHOD) {
                analyseType(frj_routine.getReturnType());
            }
        } else {
            after = coloring(after, c.constructorColor);
            after = linkToInfo(frj_routine, after);
        }
        addSourceChange(new SourceChange(frj_routine, after));

        // 
        for (Enumeration e = frj_routine.getParameters(); e.hasMoreElements(); ) {
            analyseVariable((FrjVariable) e.nextElement());
        }

        // 
        for (Enumeration e = frj_routine.getModifiers(); e.hasMoreElements(); ) {
            analyseModifier((FrjModifier) e.nextElement());        
        }

        // Throws
        for (Enumeration e = frj_routine.getThrowTypes(); e.hasMoreElements(); ) {
            analyseType((FrjType) e.nextElement());        
        }

        // body
        analyseStatement(frj_routine.getBody());
    }

    /**
     * ѿβ
     */
    private void analyseVariable(FrjVariable frj_variable) {

        String after = getHtmlString(frj_variable);
        int sort = frj_variable.getSort();

        if (sort == FrjVariable.CLASS_MEM || sort == FrjVariable.INTERFACE_MEM) {
            after = coloring(after, c.memberVariableColor);

            after = linkToInfo(frj_variable, after);

            String common_name = frj_variable.getStr();
            field_moreinfo = new FieldMoreInfo(frj_variable);
            field_moreinfo.setDef("<A HREF = \"" + depthString + out_source_file_from_root + "#" + common_name + "\">" +
                                  out_filename + "(line : " + getLineNo(frj_variable) + ")</A>");
            field_moreinfo.setCommonName(common_name);
            class_moreinfo.setFieldMoreInfo(field_moreinfo);
        } else {
            after = coloring(after, c.variableColor);
        }
        addSourceChange(new SourceChange(frj_variable, after));

        // 
        FrjExpression frj_expression = frj_variable.getInitializer();
        if (frj_expression != null) {
            analyseExpression(frj_expression);        
        }

        // 
        for (Enumeration e = frj_variable.getModifiers(); e.hasMoreElements(); ) {
            analyseModifier((FrjModifier) e.nextElement());
        }

        // Type
        analyseType((FrjType) frj_variable.getType());
    }

    /**
     * Typeβ
     */
    private void analyseType(FrjType frj_type) {
        first_move(frj_type);
        String after;
        
        // ֥ȷ
        if (frj_type.getSort() == FrjType.OBJECT) {
            //after = getHtmlString(frj_type);
            //after = coloring(after, c.classRefColor);
            // addSourceChange(new SourceChange(frj_type, after));
            FrjQName frj_qname = frj_type.getQName();
            if (frj_qname != null) {
                analyseQName(frj_qname);
            }

            /* 
            FrjClassInterface frj_classinterface = frj_type.getReferringClassInterface();
            if(frj_classinterface != null){
                System.out.println(" >>>>> " + frj_classinterface.getStr());
            }else{
                System.out.println(" null!!! ");
            }
            */
        } else {
            after = getHtmlString(frj_type);
            after = coloring(after, c.typeColor);
            addSourceChange(new SourceChange(frj_type, after));
            //  type_type򤿤ɤ
            if (frj_type.getSort() == FrjType.ARRAY) {
                analyseType(frj_type.getChildType());
            }
        }
    }

    /**
     * Modifierβ
     */
    private void analyseModifier(FrjModifier frj_modifier) {
        first_move(frj_modifier);

        String after = getHtmlString(frj_modifier);
        after = coloring(after, c.modifierColor);
        addSourceChange(new SourceChange(frj_modifier, after));
    }

    /**
     * Ū(static ֥å)β
     */
    private void analyseSBlock(FrjSBlock frj_sblock) {
        first_move(frj_sblock);

        analyseStatement(frj_sblock.getBody());
    }

    /**
     * Statementβ
     */
    private void analyseStatement(FrjStatement frj_statement) {
        first_move(frj_statement);
        // statement_statement
        for (Enumeration e = frj_statement.getChildStatements(); e.hasMoreElements(); ) {
            FrjStatement child_frj_statement = (FrjStatement) e.nextElement();
            
            analyseStatement(child_frj_statement);
        }
        // Expression
        for (Enumeration e = frj_statement.getExpressions(); e.hasMoreElements(); ) {
            FrjExpression frj_expression = (FrjExpression) e.nextElement();
            
            analyseExpression(frj_expression);
        }
        // LocalVariable
        for (Enumeration e = frj_statement.getLocalVariables(); e.hasMoreElements(); ) {
            FrjVariable frj_variable = (FrjVariable) e.nextElement();
            
            analyseVariable(frj_variable);
        }
        // Label
        for (Enumeration e = frj_statement.getLabels(); e.hasMoreElements(); ) {
            FrjLabel frj_label = (FrjLabel) e.nextElement();
            
            analyseLabel(frj_label);
        }
    }

    /**
     * Expressionβ
     */
    private void analyseExpression(FrjExpression frj_expression) {
        first_move(frj_expression);
        int sort = frj_expression.getSort();
        
        if (sort == FrjExpression.EMPTY) {
        } else if(sort == FrjExpression.REF_VAR) {
            // analyseVariable((FrjVariable) frj_expression.getReferree()); !!
        } else if(sort == FrjExpression.REF_ARRAY) {    // Japid̤??? J-modelͽ P8
        } else if(sort == FrjExpression.REF_LITERAL) {
            analyseLiteral((FrjLiteral) frj_expression.getReferree());
        } else if(sort == FrjExpression.REF_TYPE) {
            analyseType((FrjType) frj_expression.getReferree());
        } else if(sort == FrjExpression.REF_SPECIAL) {
            analyseSpecial((FrjSpecial) frj_expression.getReferree());

        } else if(sort == FrjExpression.METHOD_CALL) {
            //System.out.println("method_call : " + frj_expression.getStr());
        } else if(sort == FrjExpression.CONSTRUCTOR_CALL) {
            //System.out.println("constructor_call : " + frj_expression.getStr());
        } else if(sort == FrjExpression.OPERATION) {
            analyseOperator(frj_expression.getOperator());
            for (Enumeration e = frj_expression.getOperands(); e.hasMoreElements(); ) {
                 analyseExpression((FrjExpression) e.nextElement());
            }
        } else if(sort == FrjExpression.REF_QNAME) {
            analyseQName((FrjQName) frj_expression.getReferree());
        } else if(sort == FrjExpression.LISTED) {
        } else if(sort == FrjExpression.DIM_EXPRESSION) {
        }


        // expression_expression
        for (Enumeration e = frj_expression.getChildExpressions(); e.hasMoreElements(); ) {
            analyseExpression((FrjExpression) e.nextElement());
        }
    }

    /**
     * ƥβ
     */
    private void analyseLiteral(FrjLiteral frj_literal) {
        first_move(frj_literal);
        String after = getHtmlString(frj_literal);
        after = coloring(after, c.literalColor);
        addSourceChange(new SourceChange(frj_literal, after));
    }

    /**
     * Operator β
     */
    private void analyseOperator(FrjOperator frj_operator) {
        first_move(frj_operator);
        String after = getHtmlString(frj_operator);
        after = coloring(after, c.textColor);
        addSourceChange(new SourceChange(frj_operator, after));
    }

    /**
     * Qname β
     */
    private void analyseQName(FrjQName frj_qname) {
        first_move(frj_qname);

        Enumeration e = frj_qname.getChildQNames();
        if (e.hasMoreElements()) {
            for (; e.hasMoreElements(); ) {
                analyseQName((FrjQName) e.nextElement());
            }
            analyseOperator(frj_qname.getDot());
        } else {
            String after = getHtmlString(frj_qname);
            after = coloring(after, c.qnameColor);
            addSourceChange(new SourceChange(frj_qname, after));
        }
    }

    /**
     * Special(super, this, true, false, null) β
     */
    private void analyseSpecial(FrjSpecial frj_special) {
        first_move(frj_special);
        String after = getHtmlString(frj_special);
        after = coloring(after, c.specialColor);
        addSourceChange(new SourceChange(frj_special, after));
    }

    /**
     * ٥β
     */
    private void analyseLabel(FrjLabel frj_label) {
        first_move(frj_label);
        String after = getHtmlString(frj_label);
        after = coloring(after, c.labelColor);
        addSourceChange(new SourceChange(frj_label, after));

        FrjExpression frj_exp = frj_label.getCaseValue();
        if(frj_exp != null) analyseExpression(frj_exp);
    }

    /**
     * Ȥβ
     */
    private void analyseComment(FrjComment frj_comment) {
        first_move(frj_comment);
        String after = getHtmlString(frj_comment);
        after = coloring(after, c.commentColor);
        addSourceChange(new SourceChange(frj_comment, after));
    }

    /**
     * Ǥ˴ϢŤ줿Ȥ뤫Ĵ٤
     */
    private void first_move(FrjObject frj_object)
    {
        for (Enumeration e = frj_object.getComments(); e.hasMoreElements(); ) {
            analyseComment((FrjComment) e.nextElement());
        }
    }

    /**
     * Ť
     */
    private String coloring(String before, String color) {
        String after = new String("<SPAN CLASS = \"" + color + "\">" + before + "</SPAN>");
        return after;
    }

    /**
     * ֤Υ٥Ť
     */
    private String labeling(String label, String before) {
        String after = new String("<A NAME=\"" + label + "\"></A>" + before);
        return after;
    }

    /**
     * ʸHTMLľ֤
     */
    private String getHtmlString(FrjObject frj_obj) {
        final String lt = "&lt;";    // <
        final String gt = "&gt;";    // >
        final String quot = "&quot;";    // "
        final String amp = "&amp;";    // &

        StringBuffer sb = new StringBuffer(frj_obj.getStr());
        for (int i = 0; i < sb.length(); i++) {
            char now_char = sb.charAt(i);
            if (now_char == '<') {
                sb.replace(i, i+1, lt);
                i += lt.length();
                i--;
            } else if(now_char == '>') {
                sb.replace(i, i+1, gt);
                i += gt.length();
                i--;
            } else if(now_char == '"') {
                sb.replace(i, i+1, quot);
                i += quot.length();
                i--;
            } else if(now_char == '&') {
                sb.replace(i, i+1, amp);
                i += amp.length();
                i--;
            }
        }

        return sb.toString();
    }

    /**
     *  ե֤եؤΥ
     */
    private String linkToInfo(FrjObject frj_obj, String before) {
        String after = null;
                
        FrjClassInterface fci = frj_obj.getDefinerClassInterface();

        /** javadocˤä;HTMLΥ롼Ȥнϥե̾ */
        File file1 = null;
        if (fci != null) {
            file1 = new File(out_dir_dir, fci.getStr() + ".html");
        } else {
            file1 = new File(out_dir_dir, "error!!" + ".html");
        }
        String out_javadoc_file_from_root = new String(file1.getPath());

        // եΥ饹󥿥ես꤫顤եإ
        if (frj_obj.getClassName().equals("Class") || frj_obj.getClassName().equals("Interface")) {
            after = new String("<A HREF=\"" + depthString + out_javadoc_file_from_root + 
                               "\">" + before + "</A>");
            after = labeling(fci.getFullClassName(), after);
        // եΥѿս꤫顤եΡեɤξܺ٤γսإ
        } else if (frj_obj.getClassName().equals("Variable")) {
            FrjVariable frj_var = (FrjVariable) frj_obj;
            if (frj_var.getSort() == FrjVariable.CLASS_MEM || 
                frj_var.getSort() == FrjVariable.INTERFACE_MEM) {
                
                after = new String("<A HREF=\"" + depthString + out_javadoc_file_from_root + 
                                   "#" + frj_var.getStr() + "\">" + before + "</A>");
                // ֤Υ٥
                after = labeling(frj_var.getStr(), after);
            }
        // եΥ᥽åս꤫顤եΡ᥽åɤξܺ٤γսإ
        } else if (frj_obj.getClassName().equals("Routine")) {
            FrjRoutine frj_rou = (FrjRoutine) frj_obj;
            // ĤΥ󥯤Ĥ(ݡȤˤäơǤϾάƤ봰饹̾ˤ?)
            String full_name = getRoutineFullName(frj_rou);
            after = new String("<A HREF=\"" + depthString + out_javadoc_file_from_root + 
                               "#" + full_name + "\">" + before + "</A>");

            // ֤Υ٥
            after = labeling(full_name, after);
        }

        if (after == null) {
            after = before;
        }

        return after;        
    }


    /**
     * RoutineΡĤΥե͡
     */
    public String getRoutineFullName(FrjRoutine frj_rou) {
        FrjTypeList hikisuu_list = frj_rou.parameter2TypeList();
        Enumeration e = hikisuu_list.elements();
        // ̾
        StringBuffer sb = new StringBuffer(frj_rou.getStr());
        sb.append("(");
        
        if (e.hasMoreElements()) {
            VectorSorter sorter = new SortByOffset(e);
            sorter.sort();
            e = (sorter.getVector()).elements();
            
            for (; e.hasMoreElements(); ) {
                FrjType one_type = (FrjType) e.nextElement();
                sb.append(getfullName(one_type));
                sb.append(", ");
            }
            sb.delete(sb.length() - 2, sb.length());
        }
        
        sb.append(")");
        String full_name = sb.toString();
        
        return full_name;
    }

    /**
     * η顤ηδ̾
     */
    public String getfullName(FrjType frj_type) {
        StringBuffer full_name = null;
        int array_dimension = 0;

        while (frj_type.getSort() == FrjType.ARRAY) {
            array_dimension++;
            frj_type = frj_type.getChildType();
        }

        if (frj_type.getSort() == FrjType.PRIMITIVE) {
            full_name = new StringBuffer(frj_type.getStr());
        } else if (frj_type.getSort() == FrjType.OBJECT) {
            String full_path = getfullPath(frj_type);
            if (full_path != null) {
                full_name = new StringBuffer(full_path);
            } else { 
                full_name = new StringBuffer(frj_type.getStr());
            }
        }
        
        while (array_dimension > 0) {
            array_dimension--;
            full_name.append("[]");
        }

        return full_name.toString();
    }

    /**
     * ֥ȷ顤ηδ饹ѥ̾
     */
    public String getfullPath(FrjType frj_type) {
        String full_path = null;

        if (!FrjWorld.isAutoLoading()) {
            FrjWorld.setAutoLoading(true);
        }
        FrjClassInterface fci = frj_type.getReferringClassInterface();
        FrjWorld.setAutoLoading(false);
        
        if (fci != null) {
            full_path = fci.getFullClassName();
        } else {
            full_path = null;
        }

        return full_path;
    }

    /**
     * Ȱ֤֤ؤΥ(̤)
     */
    private String linkToDef(FrjObject frj_obj, String before) {
        String after = null;

        return after;
    }

    /**
     * FrjObject ξɽ
     */
    private void printFrjObjectInfo(FrjObject o) {
        System.out.println("------------------------------");
        System.out.println("ID : " + o.getID());
        System.out.println("String : " + o.getStr());
        System.out.println("Offset : " + o.getOffset());
        System.out.println("Length : " + o.getLength());
    }

    /**
     *  FrjObject եǤϲܤϤޤ뤫
     *  (ϴ郎unicodeǷ׻ƤФʤΤʤΤˡġFrjObject.getLineNo()뤫顥)
     */
    private int getLineNo(FrjObject o) {
        int obj_offset = o.getOffset();
        int linenum = 1;
        for (int i = 0; i < obj_offset; i++) {
            if (pure_source.charAt(i) == (byte) '\n') {
                linenum++;
            }
        }

        return linenum;
    }
}

/**
 * Ǥοʬ(stylesheetѡ̵̣ˤʤäƤޤäĤɡĻȤ
 * ѤΤäȤɤ)
 */

class HtmlColor {
    static final String classColor = "classColor";
    static final String interfaceColor = "interfaceColor";

    static final String memberVariableColor = "memberVariableColor";
    static final String constructorColor = "constructorColor";
    static final String methodColor = "methodColor";

    static final String variableColor = "variableColor";
    static final String literalColor = "literalColor";

    static final String specialColor = "specialColor";

    static final String typeColor = "typeColor";
    static final String classRefColor = "classRefColor";
    static final String packageRefColor = "packageRefColor";

    static final String qnameColor = "qnameColor";

    static final String labelColor = "labelColor";
    static final String modifierColor = "modifierColor";

    static final String commentColor = "commentColor";

    static final String textColor = "textColor";
}
