/* 
 * Program:             $RCSfile: SourceFileMaker.java,v $  $Revision: 40.4 $
 * 
 * Purpose:             
 *
 * Author:              K.Hoshino  2000/07/08
 *                      S.Yamamoto  2000/07/08
 *
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SourceFileMaker.java,v 40.4 2003/02/15 11:56:48 yamamoto Exp yamamoto $
 */

package Japid.Tools.jspie;

import java.io.*;
import java.util.*;
import Japid.Freja.*;

/**
 * եطν
 */

public class SourceFileMaker {
    /**
     * ϥǥ쥯ȥΥȥå
     */
    String out_dir;

    /**
     * SourceFile 饹ݻ
     */
    Vector sources;

    /**
     * 饹ɲþJapid¦Doclet¦Ϥͤ
     */
    /*MoreInfoManager moreinfo_manager;*/

    SourceFileMaker() {
        out_dir = null;
        sources = new Vector();
        /*moreinfo_manager = new MoreInfoManager();*/
    }
    
    /**
     * եβ
     */
    public void analyseSourceFiles(JspieConfiguration jc) {
        try {
            out_dir = jc.destdirname;

            Enumeration e = FrjExtents.getObjects(FrjFile.getClassNameStatically());
            Vector v = new Vector();
            for (; e.hasMoreElements(); ) {
                v.addElement(e.nextElement());
            }

            for (int i = 0; i < v.size(); i++) {
                FrjFile f = (FrjFile)v.elementAt(i);
                analyseOneSourceFile(f);
            }
        } catch (Exception e) {
            System.out.println("Exception: " + e);
        }
    }

    /**
     * ĤΥեβ
     */
    private boolean analyseOneSourceFile(FrjFile f) {
        try {

            /*
              SourceFile饹κVectorݻ
            */
            SourceFile sf = new SourceFile(f, out_dir/*, moreinfo_manager*/);
            sf.analyseFile();
            sources.addElement(sf);

        } catch (Exception e) {
            System.out.println("Exception: "+e);
        }
        return true;
    }

    /**
     * եHTMLν
     */
    public void writeSourceFiles() throws IOException {
        printStyleSheet();

        for (int i = 0; i < sources.size(); i++) {
            SourceFile sf = (SourceFile) sources.elementAt(i);
            sf.writeToFile();
        }
    }

    /**
     * 륷Ȥν
     */
    private void printStyleSheet() {
        File f = new File(out_dir, "jspie.css");
        try {
            FileWriter fw = new FileWriter(f.getPath());
            
            fw.write("/*\n");
            fw.write("        jspie եѤΥ륷\n");
            fw.write("        2000.7.26 Kou Hoshino\n");
            fw.write("*/\n");
            fw.write("\n");
            fw.write("BODY {\n");
            fw.write("     color: #000000;\n");
            fw.write("     background-color: #FFFFFF;\n");
            fw.write("\n");
            fw.write(".classColor {color: Red;}\n");
            fw.write(".interfaceColor {color: Red;}\n");
            fw.write("\n");
            fw.write(".memberVariableColor {color: Green;}\n");
            fw.write(".constructorColor {color: Green;}\n");
            fw.write(".methodColor {color: Green;}\n");
            fw.write("\n");
            fw.write(".variableColor {color: Purple;}\n");
            fw.write("\n");
            fw.write(".literalColor {color: Teal;}\n");
            fw.write("\n");
            fw.write(".specialColor {color: Gray;}\n");
            fw.write("\n");
            fw.write(".typeColor {color: Fuchsia;}\n");
            fw.write(".classRefColor {color: Maroon;}\n");
            fw.write(".packageRefColor {color: Maroon;}\n");
            fw.write("\n");
            fw.write(".labelColor {color: Olive;}\n");
            fw.write(".modifierColor {color: Olive;}\n");
            fw.write(".commentColor {color: Gray;}\n");
            fw.write("\n");
            fw.write(".qnameColor {color: Black;}\n");
            fw.write("\n");
            fw.write(".textColor {color: Black;}\n");
            fw.write("\n");
            fw.write(".linenumColor {color: Black;}\n");

            fw.close();
        } catch (IOException e) {
        }
    }
}

/* 
 * jspie եѤΥ륷(2000/07/26)
 * 
 * BODY {
 *     color: #000000;
 *     background-color: #FFFFFF;
 * }
 * 
 * .classColor             {color: Red;}
 * .interfaceColor         {color: Red;}
 * 
 * .memberVariableColor    {color: Green;}
 * .constructorColor       {color: Green;}
 * .methodColor            {color: Green;}
 * 
 * .variableColor          {color: Purple;}
 * 
 * .literalColor           {color: Aqua;}
 * 
 * .specialColor           {color: Gray;}
 * 
 * .typeColor              {color: Fuchsia;}
 * .classRefColor          {color: Maroon;}
 * .packageRefColor        {color: Maroon;}
 * 
 * .labelColor             {color: Olive;}
 * .modifierColor          {color: Olive;}
 * .commentColor           {color: Gray;}
 * 
 * .qnameColor             {color: Black;}
 * 
 * .textColor              {color: Black;}
 */
