/*
 *     GenXrefXML.java  Nov 3, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package Japid.genxrefxml;

import org.jtool.platform.pgstruct.*;
import java.util.List;

public class GenXrefXML {
    private static final String SAPID_DIR = "/usr/local/Sapid";

    public static void main(String[] args) {
        if (args.length > 0) {
            GenXrefXML.run(args[0]);
        } else {
            System.err.println("Usage: java GenXML project_dir");
        }
    }

    public static void run(String projectTopDir) {
        ProgramStructure.setSapidDir(SAPID_DIR);
        ProgramStructure.setProjectTopDir(projectTopDir);

        List files = ProgramStructure.resolveAccess();
        // ProgramStructure.printAllXMLDocuments();

        GenFileXML.write(files);
        GenProjectXML.write(files);
        
        ProgramStructure.terminated();
        System.exit(0);
    }
}
