/* 
 * Program:             $RCSfile: LinkInfo.java,v $  $Revision: 50.1 $
 * 
 * Purpose:             
 *
 * Author:              Y.Sawada  2003/10/01
 *                      S.Yamamoto  2003/10/01
 *
 * (C) Copyright:       Y.Sawada and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: LinkInfo.java,v 50.1 2003/11/24 04:29:57 yamamoto Exp yamamoto $
 */

package jspie3;

import org.w3c.dom.*;

public class LinkInfo extends MemoData{

    // test code
    public static void main(String[] args){
        LinkInfo li = new LinkInfo("./memo-link.xml","Shift_JIS");
        li.appendLinkElement("s999","10","20","ApplyXPath","m2");
        li.editLinkElement("l2","s111","1110","1120","ApplyXPath","m3");
    }
    // test code end

    public LinkInfo(String path,String encoding){
        super(path,encoding);
    }

    public String appendLinkElement(String posId,String x,String y,
				    String posVal,String memoId){
        Element newEl = createLinkElement(posId,x,y,posVal,memoId);
        root.appendChild(newEl);
        String leng = String.valueOf(getLength() + 1);
        root.setAttribute("leng",leng);
        serialize();
        return newEl.getAttribute("id");
    }

    public void editLinkElement(String linkId,String posId,String x,
                                String y,String posVal,String memoId){
        Element newEl = createLinkElement(posId,x,y,posVal,memoId);
        newEl.setAttribute("id",linkId);
        Element targetEl = getElementById(linkId);
        if(targetEl != null){
            root.replaceChild(newEl,targetEl);
            serialize();
        }
    }

    private Element createLinkElement(String posId,String x,String y,
				      String posVal,String memoId){
        Element link = doc.createElement("link");
        Element pos = doc.createElement("pos");
        Element memo = doc.createElement("memo");
        link.setAttribute("id","l" + (getLength() + 1));
        pos.setAttribute("id",posId);
        pos.setAttribute("x",x);
        pos.setAttribute("y",y);
        memo.setAttribute("id",memoId);
        pos.appendChild(doc.createTextNode(posVal));
        link.appendChild(pos);
        link.appendChild(memo);
        return link;
    }
}
