/* 
 * Program:             $RCSfile: MemoData.java,v $  $Revision: 50.2 $
 * 
 * Purpose:             
 *
 * Author:              Y.Sawada  2003/10/01
 *                      S.Yamamoto  2003/10/01
 *
 * (C) Copyright:       Y.Sawada and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: MemoData.java,v 50.2 2003/11/25 13:44:24 yamamoto Exp yamamoto $
 */

package jspie3;

import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import javax.xml.transform.*;

public class MemoData {
    protected Document doc;
    protected String path;
    protected String encoding;
    protected Element root;

    // test code
    public static void main(String[] args){
        MemoData link = new MemoData("./memo-link.xml","Shift_JIS");
        System.out.println(link.getElementById("l2").getAttribute("id"));
        MemoData memo = new MemoData("./memo.xml","Shift_JIS");
        System.out.println(memo.getElementById("m2").getAttribute("id"));
        memo.setElementValue("m2","body","ahoahoahoaho");
        System.out.println(memo.getElementValue("m2","title"));
    }
    // test code end

    public MemoData(String path,String encoding){
        try {
            this.path = path;
            this.encoding = encoding;
            FileReader fl = new FileReader(path);
            BufferedReader br = new BufferedReader(fl);
            InputSource src = new InputSource(br);
            DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder builder = dbfactory.newDocumentBuilder();
            doc = builder.parse(src);
            root = doc.getDocumentElement();
        } catch (Exception e) {
            e.printStackTrace(System.out);
        }
    }

    public void removeElement(String targetId){
        Element targetEl = getElementById(targetId);
        if(targetEl != null){
            root.removeChild(targetEl);
            serialize();
        }
    }

    public Element getElementById(String targetId){
        NodeList nl = root.getChildNodes();
        for(int i = 0 ; i < nl.getLength(); i++){
            Node node = nl.item(i);
            if(node.getNodeType() == Node.ELEMENT_NODE){
                Element el = (Element)node;
                String id = el.getAttribute("id");
                if(id !=null && id.equals(targetId)){
                    return el;
                }
            }
        }
        return null;
    }

    public void setElementValue(String id,String elementName,String value){
        Element targetEl = getElementById(id);
        if(targetEl != null && targetEl.hasChildNodes()){
            Node node1 = targetEl.getElementsByTagName(elementName).item(0);
            if(node1 != null && node1.hasChildNodes()){
                Node node2 = node1.getFirstChild();
                if(node2 != null && node2.getNodeType() == Node.TEXT_NODE){
                    node2.setNodeValue(value);
                    serialize();
                }
            }
        }
    }

    public String getElementValue(String id,String elementName){
        Element targetEl = getElementById(id);
        if(targetEl != null && targetEl.hasChildNodes()){
            Node node1 = targetEl.getElementsByTagName(elementName).item(0);
            if(node1 != null && node1.hasChildNodes()){
                Node node2 = node1.getFirstChild();
                if(node2 != null && node2.getNodeType() == Node.TEXT_NODE){
                    return node2.getNodeValue();
                }
            }
        }
        return null;
    }

    public int getLength(){
        String id = root.getAttribute("leng");
        return  Integer.parseInt(id);
    }

    protected void serialize(){
        try{
            TransformerFactory transFactory = TransformerFactory.newInstance();
            Transformer transformer = transFactory.newTransformer();
            transformer.setOutputProperty("encoding",encoding);
            transformer.setOutputProperty("indent","yes");
            DOMSource source = new DOMSource(doc);
            StreamResult result = new StreamResult(path);
            transformer.transform(source, result);
        }catch(Exception e){
            e.printStackTrace(System.out);
        }
    }
    public static String strEncode(String strVal) throws UnsupportedEncodingException{
        if(strVal == null || strVal.equals("")){
            return ("none");
        }
        else{
            return (new String(strVal.getBytes("ISO-8859-1"),"JISAutoDetect"));
        }
    }

    public static String CRLT(String strEsc){
        StringBuffer strResult = new StringBuffer();
        int intEnd = 0;
        int cnt = 0;
        intEnd = strEsc.indexOf(System.getProperty("line.separator"),cnt);
        while(intEnd != -1){
            strResult.append(strEsc.substring(cnt,intEnd));
            strResult.append("<br />");
            cnt = intEnd + 1;
            intEnd = strEsc.indexOf(System.getProperty("line.separator"),cnt);
        }
        strResult.append(strEsc.substring(cnt));
        return strResult.toString();
    }
}
