/* 
 * Program:             $RCSfile: MemoInfo.java,v $  $Revision: 50.1 $
 * 
 * Purpose:             
 *
 * Author:              Y.Sawada  2003/10/01
 *                      S.Yamamoto  2003/10/01
 *
 * (C) Copyright:       Y.Sawada and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: MemoInfo.java,v 50.1 2003/11/24 04:30:10 yamamoto Exp yamamoto $
 */

package jspie3;

import org.w3c.dom.*;
import java.text.*;
import java.util.*;

public class MemoInfo extends MemoData{
    static final String[] paramName = {
	"auther",
	"create",
	"modify",
	"sort",
	"importance",
	"state",
	"limit",
	"permit",
	"publicity",
	"title",
	"document",
	"doclink",
	"relation",
	"body"
    };

    // test code
    public static void main(String[] args){
        MemoInfo mi = new MemoInfo("./memo.xml","Shift_JIS");
        String[] val = {"notkiso","1122","1122","0","0","1","1","0","0",
                        "tittt","do","doclink","rere","bodybody"};
        System.out.println(mi.appendMemoElement(val));
        mi.editMemoElement("m3",val);
    }
    // test code end

    public MemoInfo(String path,String encoding){
        super(path,encoding);
    }

    public String appendMemoElement(String[] paramVal){
        if(paramVal.length == paramName.length){
            Element newEl = createMemoElement(paramVal);
            root.appendChild(newEl);
            String leng = String.valueOf(getLength() + 1);
            root.setAttribute("leng",leng);
            serialize();
            return newEl.getAttribute("id");
        }
        else{
            return null;
        }
    }

    public void editMemoElement(String memoId,String[] paramVal){
        Element targetEl = getElementById(memoId);
        if(targetEl != null){
            Element newEl = createMemoElement(paramVal);
            newEl.replaceChild(targetEl.getElementsByTagName("create").item(0)
                               ,newEl.getElementsByTagName("create").item(0));
            newEl.replaceChild(targetEl.getElementsByTagName("auther").item(0)
                               ,newEl.getElementsByTagName("auther").item(0));
            newEl.setAttribute("id",memoId);
            root.replaceChild(newEl,targetEl);
            serialize();
        }
    }

    private Element createMemoElement(String[] paramVal){
        if(paramVal.length == paramName.length){
            Element memo = doc.createElement("memo");
            memo.setAttribute("id","m" + (getLength() + 1));
            paramVal[1] = getDate();
            paramVal[2] = getDate();
            for(int i = 0; i < paramVal.length; i++){
                Text val = doc.createTextNode(paramVal[i]);
                Element el = doc.createElement(paramName[i]);
                el.appendChild(val);
                memo.appendChild(el);
            }
            return memo;
        }
        else{
            return null;
        }
    }

    private String getDate(){
        Calendar cal = Calendar.getInstance();
        Date dat = cal.getTime();
        SimpleDateFormat fmt = new SimpleDateFormat("yyyy MM/dd HH:mm");
        return fmt.format(dat).toString();
    }
}
