/* 
 * Program:             $RCSfile: SearchMemo.java,v $  $Revision: 50.3 $
 * 
 * Purpose:             
 *
 * Author:              Y.Sawada  2003/10/01
 *                      S.Yamamoto  2003/10/01
 *
 * (C) Copyright:       Y.Sawada and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SearchMemo.java,v 50.3 2003/11/18 14:54:11 yamamoto Exp yamamoto $
 */

package jspie3;

import java.io.*;
import java.util.*;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;

public class SearchMemo {
    HashSet result;

    // test code
    public static void main(String[] args){// throws Exception {
	SearchQuery sq = new SearchQuery();
	sq.setProject("0");
	sq.setPackageName("none");
	sq.setFileName("Customer");
	sq.setQueryString("ҡ");
	sq.setAnd(false);
	sq.setCheckBody(true);
	sq.setCheckTitle(true);
	sq.setCheckAuther(true);
	sq.setScope(0);
	SearchMemo sm = new SearchMemo(".",sq);
	System.out.println(sm.getResult());
	if(sm.getResult() !=null){
	    SearchMemoResult smr = new SearchMemoResult(".",sm.getResult());
	    int scope = sq.getScope();
	    if(scope == 0){ // project
		smr.memoTreeVisit();
	    }
	    else if(scope == 1){ // package
		// mada
	    }
	    else if(scope == 2){ // file
		smr.memoTreeVisit(sq.getFileName());
	    }
	    System.out.print(smr.getResult());
	}
	else{
	    System.out.println("SearchMemo: not found");
	}
	return;
    }
    // test code end

    public SearchMemo(String path,SearchQuery sq){
	try{
	    InputSource is = new InputSource(new FileInputStream(path + "/memo.xml"));
	    String uri = new File(path + "/memo.xml").toURI().toString();
	    is.setSystemId(uri);
	    SAXParserFactory spf = SAXParserFactory.newInstance();
	    SAXParser sp = spf.newSAXParser();
	    SearchHandler sh = new SearchHandler();
	    sh.setParam(sq);
	    sp.parse(is,sh);
	    result = sh.getResult();
	}
	catch(Exception e){
	}
    }
    public HashSet getResult(){
	return result;
    }
}

class SearchHandler extends DefaultHandler {
    StringBuffer sb;
    String  memoId;
    HashSet result;
    SearchQuery sq;

    public void setParam(SearchQuery sq){
	this.sq = sq;
    }

    public HashSet getResult(){
	return result;
    }

    public boolean match(String str){
	String[] querys = sq.getQueryStrings();
	boolean isAnd = sq.isAnd();
	for(int i = 0; i < querys.length; i++){
	    if((str.indexOf(querys[i]) == -1) == isAnd){
		return !isAnd;
	    }
	}
	return isAnd;
    }

    public void startDocument() {
	memoId = new String();
	result = new HashSet();
    }

    public void startElement(String namespaceURI, String localName,
                             String qName, Attributes atts) {
        sb = new StringBuffer();
	if (qName.equals("memo")) {
	   memoId = atts.getValue("id");
        }
    }
	
    public void endElement(String namespaceURI, String localName,
                           String qName) {
	if((qName.equals("auther") && sq.isCheckAuther()) ||
	   (qName.equals("title") && sq.isCheckTitle()) ||
	   (qName.equals("body") && sq.isCheckBody())){
	    String str = sb.toString();
	    if(match(str)){
		result.add(memoId);
	    }
	}
    }
    
    public void characters(char[] ch, int start, int length) {
        sb.append(ch, start, length);
    }
}
