/* 
 * Program:             $RCSfile: WriteListTree.java,v $  $Revision: 50.4 $
 * 
 * Purpose:             
 *
 * Author:              Y.Sawada  2003/10/01
 *                      S.Yamamoto  2003/10/01
 *
 * (C) Copyright:       Y.Sawada and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: WriteListTree.java,v 50.4 2003/11/24 12:25:22 yamamoto Exp yamamoto $
 */

package jspie3;

import java.io.*;
import java.util.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;

public class WriteListTree extends WriteMemoTree{
    
    public WriteListTree(String path){
        super(path);
    }
    
    public void visit(Node node, String linkIds){
        String linkId = ((Element)node).getAttribute("id");
        NodeList nl2 = node.getChildNodes();
        Element pos = (Element)nl2.item(1);
        Element memo = (Element)nl2.item(3);
        String posId = pos.getAttribute("id");
        String memoId = memo.getAttribute("id");
        String fileName = pos.getFirstChild().getNodeValue();
        Node memoNode = getMemoNode(memoId);
        Hashtable c = getMemoContents(memoNode);
        makeIndent();
        result.append("<div class=\"indent\">\n");
        makeIndent();
        result.append("  <a href=\"javascript:window.top.f21.mref('");
        if(depth != 0){ // child
            String[] ances = linkIds.split("_");
            result.append(ances[0] + "');");
            for(int i = 2; i <= ances.length; i++) {
                result.append("window.top.f21.displayBlock('");
                result.append(ances[0]);
                for(int j = 1; j < i; j++){
                    result.append("_" + ances[j]);
                }
                result.append("c');");
            }
            result.append("\"></a>" + c.get("title") + "<br />\n");
        }
        else{ // root
            result.append(linkIds + "')\"></a>" + c.get("title") + "<br />\n");
        }
        makeIndent();
        result.append("  " + c.get("auther") + ":" +  c.get("create") + "<br />\n");
        // children
        ArrayList children = getChildren(memoId,linkIds);
        if(children != null && children.size() != 0){
            makeIndent();
            result.append("  <a href=\"javascript:display('" + linkIds
                          + "c')\">+</a>children(" + children.size() + ")<br />\n");
        }
        makeIndent();
        result.append("  <div id=\"" + linkIds + "c\" style=\"display:none\">\n");
    }

    public void visitAfter(Node node, String linkIds){
        makeIndent();
        result.append("  </div>\n");
        makeIndent();
        result.append("</div>\n");
    }
}
