/* 
 * Program:             $RCSfile: WriteMemoTree.java,v $  $Revision: 50.6 $
 * 
 * Purpose:             
 *
 * Author:              Y.Sawada  2003/10/01
 *                      S.Yamamoto  2003/10/01
 *
 * (C) Copyright:       Y.Sawada and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: WriteMemoTree.java,v 50.6 2003/11/25 13:44:25 yamamoto Exp yamamoto $
 */

package jspie3;

import java.io.*;
import java.util.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

public class WriteMemoTree extends MemoTreeVisitor{
    protected Document memoDoc;

    // test code
    public static void main(String[] args){
        WriteMemoTree wmt = new WriteMemoTree(".");
        wmt.memoTreeVisit();
        System.out.println(wmt.getResult());
        wmt.memoDoc.getNodeType();
    }
    // test code end

    public WriteMemoTree(String path){
        super(path);
        try {
            FileReader fl = new FileReader(path + "/memo.xml");
            BufferedReader br = new BufferedReader(fl);
            InputSource src = new InputSource(br);
            DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder builder = dbfactory.newDocumentBuilder();
            memoDoc = builder.parse(src);
        } catch (Exception e) {
            //      e.printStackTrace();
        }
    }

    protected void visit(Node node, String linkIds){
        String linkId = ((Element)node).getAttribute("id");
        NodeList nl2 = node.getChildNodes();
        Element pos = (Element)nl2.item(1);
        Element memo = (Element)nl2.item(3);
        String posId = pos.getAttribute("id");
        String memoId = memo.getAttribute("id");
        String fileName = pos.getFirstChild().getNodeValue();
        Node memoNode = getMemoNode(memoId);
        Hashtable c = getMemoContents(memoNode);
        if(depth != 0){
            makeIndent();
            result.append("<div class=\"memo2\" id=\"" + linkIds +  "\" ");
            result.append("style=\"position:display:block;\">\n");
            result.append("  <a class=\"u\" href=\"javascript:display('");
            result.append(linkIds + "c')\">" + c.get("title") + "</a>\n");
        }
        else{
            makeIndent();
            result.append("<div class=\"memo\" id=\"" + linkIds + "\" ");
            result.append("style=\"display:block;position:absolute;top:10px;left:10px;\" ");
            result.append("onmousedown=\"clickElement='" + linkIds + "';mdown(event);return false\">\n");
            makeIndent();
            result.append("  <a class=\"u\" href=\"javascript:display('");
            result.append(linkIds + "c')\">" + c.get("title") + "</a>\n");
            makeIndent();
            result.append("  <a href=\"javascript:display('" + linkIds + "')\"></a><br />\n");
        }
        makeIndent();
        result.append("  <div id=\"" + linkIds + "c\" style=\"display:none;\">\n");
        makeIndent();
        result.append("    " + c.get("auther") + ":" +  c.get("create") + "<br />\n");
        makeIndent();
        result.append("    " + c.get("body") + "<br />&nbsp;<br />\n");
        makeIndent();
        result.append("    <a class=\"u\" href=\"javascript:display('");
        result.append(linkIds + "v')\">" + "ܺ</a>\n");
        makeIndent();
        if(depth != 0) { // child
            result.append("    <a class=\"u\" target=\"f12\" ");
            result.append("href=\"editChildForm.jsp?file=" + fileName + "&amp;linkId=" + linkId + "&amp;linkIds=" + linkIds +  "\">Խ</a>\n");
        }
        else { // root
            result.append("    <a class=\"u\" target=\"f12\" ");
            result.append("href=\"editForm.jsp?fileName=" + fileName + "&amp;memoId=" + memoId + "&amp;linkId=" + linkId + "\">Խ</a>\n");
            result.append("    <a class=\"u\" href=\"javascript:objref1('");
            result.append(posId + "')\">" + "о</a>\n");
            makeIndent();
            result.append("    <a class=\"u\" target=\"f12\" ");
            result.append("href=\"addForm.jsp?fileName=" + fileName + "&amp;memoId=" + memoId + "\">ɲ</a>\n");
        }
        result.append("    <a class=\"u\" target=\"f12\" ");
        result.append("href=\"childForm.jsp?fileName=" + fileName + "&amp;memoId=" + memoId + "&amp;linkId=" + linkIds + "\">ɲ</a>\n");
        result.append("    <a class=\"u\" target=\"f12\" ");
        result.append("href=\"memoSearchForm.jsp?fileName=" + fileName + "&amp;memoId=" + memoId + "&amp;linkIds=" + linkIds + "\">Ϣɲ</a><br />\n");
        makeIndent();
        result.append("    <div id=\"" + linkIds + "v\" style=\"display:none;\">\n");
        makeIndent();
        result.append("      ID : " + memoId + "<br />\n");
        makeIndent();
        result.append("      䵾ID : " + linkId + " (" + linkIds + ")<br />\n");
        if(depth == 0) {
            makeIndent();
            result.append("      źղս :");
            String links = getOtherLinks(memoId);
            String[] link = links.split(",");
            for(int i = 0; i < link.length; i++){
                String poss = getLinkPos(link[i],linkDoc);
                if(poss != null && poss.equals(fileName)) { // this file
                    if(link[i].equals(linkId)) { //  this memo
                        result.append(" " + link[i] + " ");
                    }
                    else { // other memo
                        result.append(" <a class=\"u\" href=\"javascript:mref('"+ link[i] +"')\">" + link[i] + "</a> ");
                    }
                }
                else { // other file
                    result.append(" <a class=\"u\" href=\"fileset.jsp?file=" + poss + "&amp;id=" + link[i] + "\">" + link[i] + "(" + poss + ")</a> ");
                }
            }
            result.append("<br />\n");
        }
        makeIndent();
        result.append("       : " + c.get("auther") + "<br />\n");
        makeIndent();
        result.append("       : " + c.get("create") + "<br />\n");
        makeIndent();
        result.append("       : " + c.get("modify") + "<br />\n");
        makeIndent();
        result.append("      ʬ : " + IndexData.getData("sort",(String)c.get("sort")) + "<br />\n");
        makeIndent();
        result.append("       : " + IndexData.getData("importance",(String)c.get("importance")) + "<br />\n");
        makeIndent();
        result.append("      䵾 : " + IndexData.getData("state",(String)c.get("state")) + "<br />\n");
        makeIndent();
        result.append("      ݻ : " + IndexData.getData("limit",(String)c.get("limit")) + "<br />\n");
        makeIndent();
        result.append("      ѹ : " + IndexData.getData("permit",(String)c.get("permit")) + "<br />\n");
        makeIndent();
        result.append("      䵸 : " + IndexData.getData("publicity",(String)c.get("publicity")) + "<br />\n");
        makeIndent();
        result.append("      ϢDOC : ");
        String document = (String)c.get("document");
        if(document != null && !document.equals("none")){
            result.append("<a class=\"u\" target=\"_blank\" href=\"" + document + "\">" + document + "</a>");
        }
        else{
            result.append(document);
        }
	result.append("<br />\n");
        makeIndent();
        result.append("      Ϣ : ");
        String relations = (String)c.get("relation");
        if(relations != null && !relations.equals("none")){
            String[] relation = relations.split(",");
            for(int i = 0; i < relation.length; i++){
                String poss2 = getLinkPos(relation[i],linkDoc);
                if(poss2 != null && poss2.equals(rootFileName)) { // this file
                    if(relation[i].equals(linkId)) { //  this memo
                        result.append(" " + relation[i] + " ");
                    }
                    else { // other memo
                        result.append(" <a class=\"u\" href=\"javascript:mref('" 
                                      + relation[i] +"')\">" + relation[i] + "</a> ");
                    }
                }
                else { // other file
                    result.append(" <a class=\"u\" href=\"fileset.jsp?file="
                                  + poss2 + "&amp;id=" + relation[i] + "\">"
                                  + relation[i] + "(" + poss2 + ")</a> ");
                }
            }
        }
        else{
            result.append(relations);
        }
        result.append("<br />\n");
        makeIndent();
        result.append("    </div>\n");
    }

    protected void visitAfter(Node node, String linkIds){
        makeIndent();
        result.append("  </div>\n");
        makeIndent();
        result.append("</div>\n");  
    }

    public void makeIndent(){
        for(int i = 0; i < depth; i++){
            result.append("      ");
        }
    }


    public Node getMemoNode(String targetMemoId){
        Node root = memoDoc.getDocumentElement();
        NodeList nl = root.getChildNodes();
        for(int i = 0; i < nl.getLength(); i++){
            Node node = nl.item(i);
            if(node.getNodeName().equals("memo")){
                String memoId = ((Element)node).getAttribute("id");
                if(memoId != null && memoId.equals(targetMemoId)){
                    return node;
                }
            }
        }
        return null;
    }

    public Hashtable getMemoContents(Node memoNode){
        Hashtable contents = new Hashtable();
        contents.put("id",((Element)memoNode).getAttribute("id"));
        NodeList nl = memoNode.getChildNodes();
        for(int i = 1; i < nl.getLength(); i++){
            Node node = nl.item(i);
            if(node.getNodeType() == Node.ELEMENT_NODE){
                String nodeName = node.getNodeName();
                String nodeVal = node.getFirstChild().getNodeValue();
                contents.put(nodeName,nodeVal);
            }
        }
        return contents;
    }

    String getOtherLinks(String memoId){
        StringBuffer sb = new StringBuffer();
        boolean b = false;
        Node objRoot = linkDoc.getDocumentElement();
        NodeList clnNod = objRoot.getChildNodes();
        int leng = clnNod.getLength();
    
        for(int i = 0 ; i < leng; i++){
            Node node = clnNod.item(i);
            if(node.getNodeName().equals("link")){
                String linkId = ((Element)node).getAttribute("id");
                NodeList children = node.getChildNodes();
                Element pos = (Element)children.item(1);
                Element memo = (Element)children.item(3);
                String id = memo.getAttribute("id");
                if(id !=null && id.equals(memoId)){
                    if(!b) {
                        sb.append(linkId);
                        b = true;
                    }
                    else {
                        sb.append(",");
                        sb.append(linkId);
                    }
                }
            }
        }
    
        if(!b) {
            return null;
        }
        else {
            return sb.toString();
        }
    }
    
    public static String getLinkPos(String linkIds,Document linkDoc){
        Node objRoot = linkDoc.getDocumentElement();
        NodeList clnNod = objRoot.getChildNodes();
        int leng = clnNod.getLength();
	if(linkIds.indexOf("_") != -1){
	    linkIds = linkIds.substring(0,linkIds.indexOf("_"));
	}
    
        for(int i = 0 ; i < leng; i++){
            Node node = clnNod.item(i);
            if(node.getNodeName().equals("link")){
                String id = ((Element)node).getAttribute("id");
                NodeList children = node.getChildNodes();
                Element pos = (Element)children.item(1);
                if(id !=null && id.equals(linkIds)){
                    return pos.getFirstChild().getNodeValue();
                }
            }
        }
        return null;    
    }
}
