/* 
 * Program:             $RCSfile: AreaModelAR.c,v $  $Revision: 30.20 $
 * 
 * Purpose:             AreaModel ؿ
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: AreaModelAR.c,v 30.20 2003/07/08 05:46:22 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/AreaModelAR.h>

/* ° order ꤹ뤿ɽ */
/* ƤΥ֥Ȥ򥭡Ȥơ¸δϢorderκͤݻ */
/* !! ƤʣΥ饹δϢ¸ߤȤμǤϤʤ */

static SpdSet2 ordermap = NULL;

static void freeOrderMap(void)
{
    if (ordermap) {
        spdFreeSet2(ordermap);
    }

    ordermap = NULL;
}

static int atexitflag = FALSE;

/* ° order ꤹ */

void spdarea_initOrder(SpdObjId parentId)
{
    if (ordermap == NULL) {
        ordermap = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_INT_VALUE);
        if (atexitflag == FALSE) {
            atexit(freeOrderMap);
            atexitflag = TRUE;
        }
    }

    spdAddElemOI(ordermap, parentId, 0);
}

/* ° order ꤹ */

void spdarea_setOrder(SpdRelId relId)
{
    SpdObjId parentId;
    SpdSet2 rels;
    SpdRel *relp;
    SetCursor csr;
    int order = -1, o;

    if (ordermap == NULL) {
        ordermap = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_INT_VALUE);
        if (atexitflag == FALSE) {
            atexit(freeOrderMap);
            atexitflag = TRUE;
        }
    }

    parentId = spdGetAttrIntVal(relId, SAPIDDB_ATTR_P_ID);

    if (!spdContainsO(ordermap, parentId)) {
        rels = spdGetChildRelSet(parentId, spdGetClassId(relId));
        for (csr = spdSetCursorCreate(rels); spdSetCursorNext(&csr);) {
            relp = spdSetGetValueP(csr.curElem->value);
            if (relId != relp->relationId) {
                o = spdGetAttrIntValByName(relp->relationId, "order");
                if (order < o) {
                    order = o;
                }
            }
        }
        spdFreeSet2(rels);
    } else {
        spdDelElemO(ordermap, parentId);
    }
    order++;
    spdAddElemOI(ordermap, parentId, order);

    spdSetAttrIntValByName(relId, "order", order);
}

int spdCastValueDataInt(SpdValueData value)
{
    switch (value.type) {
    case SpdValue_Integer:
        return value.v.intval;
    case SpdValue_Unsigned_Integer:
        return (int)value.v.uintval;
    case SpdValue_Pointer:
        return (int)value.v.pointerval;
    default:
        ;
    }
    
    /* !!  int ϰϳ֤ͤ٤ */
    return SAPID_NON_VALUE;
}

/* const_ref 򤿤ɤʰ */

SpdValueData spdEvalConstExpression(SpdObjId cexprId)
{
    SpdObjId constId;
    int type;
    SpdConstString value;
    SpdValueData res;

    /* ˽ǰΤ intval ˤŬͤƤ */
    res.type = SpdValue_NonValue;
    res.v.intval = -1;

    if (spdGetClassId(cexprId) != SPD_CID_EXPRESSION) {
        return res;
    }

    constId = spdGetAChildObjId(cexprId, SPD_RID_CONST_REF);
    if (constId == SPD_NON_ID) {
        return res;
    }
    type = spdGetAttrIntValByName(constId, "type");
    value = spdGetAttrStrValByName(constId, "value");

    switch (type) {
      case CONST_INT:
        res.type = SpdValue_Integer;
        res.v.intval = strtol(value, NULL, 10);
        break;
      case CONST_CHAR:
        /* !! Ȥꤢ 'a' ʤɤ 2ʸܤľͤȤ */
        res.type = SpdValue_Integer;
        res.v.intval = value[1];
        break;
      case CONST_FLOAT:
        /* !! ̤ݡ */
        break;
      default:
        return res;
    }

    return res;
}
