/* 
 * Program:             $RCSfile: area.c,v $  $Revision: 30.17 $
 * 
 * Purpose:             area ؿ
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: area.c,v 30.17 2003/07/08 05:46:23 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/AreaModelAR.h>

/* ѿ variableId ˴ϢŤ줿 area 롥
   storageϴ˻ꤵƤΤȤ롥*/

SpdObjId spdGetVariableArea(SpdObjId variableId)
{
    SpdIdSet areas, storages;
    SpdObjId areaId, res = SPD_NON_ID;
    SpdObjId storageId;
    SpdElem *pArea;
    SpdClassId classId;
    SetCursor csr;
    
    classId = spdGetClassId(variableId);

    if (classId == SPD_CID_IDENTIFIER) {
        /* area ° storage ν */
        /* storageId  key ˤ area νˤ */
        /* !! mapǼǽ */
        areas = spdGetChildObjIdSet(variableId, SPD_RID_VARIABLE_AREA);
        storages = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_OBJID_VALUE);
        for (csr = spdSetCursorCreate(areas); spdSetCursorNext(&csr);) {
            areaId = spdSetGetValueO(csr.curElem->value);
            storageId = spdGetAParentObjId(areaId, SPD_RID_STORAGE_AREA);
            spdAddElemOO(storages, storageId, areaId);
        }
        spdFreeSet2(areas);

        /* current-storage ˤΤܤäõ */
        storageId = spdGetCurrentStorage();
        while (storageId != SPD_NON_ID) {
            if ((pArea = spdSearchElemO(storages, storageId)) != NULL) {
                res = spdSetGetValueO(pArea->value);
                break;
            }

            if (spdGetAttrIntValByName(storageId, "sort")  
                == AREA_STORAGE_FUNC) {
                /* ؿ storage μ Хstorage */
                storageId = spdGetGlobalStorage();
            } else {
                /* ʳϿƤ򤿤ɤ */
                storageId = spdGetAParentObjId(storageId, 
                                               SPD_RID_STORAGE_STORAGE);
            }
        }
        spdFreeSet2(storages);
    }

    return res;
}

/* ¤ΤΥФΰ */

SpdObjId spdGetMemberArea(SpdObjId areaId, SpdObjId memberId)
{
    SpdIdSet areas;
    SpdObjId aId, res = SPD_NON_ID;
    SpdObjId memId;
    SetCursor csr;
  
    areas = spdGetChildObjIdSet(areaId, SPD_RID_AREA_AREA);
    for (csr = spdSetCursorCreate(areas); spdSetCursorNext(&csr);) {
        aId = spdSetGetValueO(csr.curElem->value);
        memId = spdGetAParentObjId(aId, SPD_RID_MEMBER_AREA);
        if (memId == memberId) {
              res = areaId;
              /* aId ֤ΤǤϤʤΤ? */
              break;
          }
      }
    spdFreeSet2(areas);
    return res;
}

/* Ǥΰ */

SpdObjId spdGetArrayElementArea(SpdObjId areaId, int index)
{
    SpdSet2 areas;
    SpdRel *relp;
    SpdObjId res = SPD_NON_ID;
    SetCursor csr;
  
    areas = spdGetChildRelSet(areaId, SPD_RID_AREA_AREA);
    for (csr = spdSetCursorCreate(areas); spdSetCursorNext(&csr);) {
        relp = spdSetGetValueP(csr.curElem->value);
        if (spdGetAttrIntValByName(relp->relationId, "order") == index) {
            res = relp->objectId;
            break;
        }
    }
    spdFreeSet2(areas);
    return res;
}
