/* 
 * Program:             $RCSfile: create.c,v $  $Revision: 30.46 $
 * 
 * Purpose:             ֥Ⱥؿ
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: create.c,v 30.46 2003/07/08 05:46:23 yamamoto Exp yamamoto $";
#endif

#include <ctype.h>
#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/AreaModelAR.h>

/* ֥Ⱥؿ */

/* areaId  SPD_NON_ID ʳꤹСѤ area ؤԤ */
static SpdObjId spdarea_InitStringArea(SpdObjId areaId, SpdConstString str, 
                                       SpdBoolean escflag)
{
    static SpdObjId charTypeId, acharTypeId = SPD_NON_ID;
    static SpdBoolean f = FALSE;
    SpdObjId pAreaId, cAreaId;
    SpdRelId relId;
    SpdConstString p;
    SpdValueData value;
    int i, c, d;
    int hasSubArea;

    /* ŪʤΤ1٤¹ */
    if (!f) {
        /* !!  const char [] 褤 */
        charTypeId = smuFindType(TYPE_UNKNOWN, TYPE_UNKNOWN, TYPE_UNKNOWN, 
                                 TYPE_CHAR);

        if (areaId != SPD_NON_ID) {
            /* area η */
            acharTypeId = spdGetAChildObjId(areaId, SPD_RID_AREA_TYPE);
        }
        
        if (acharTypeId == SPD_NON_ID) {
            if (charTypeId == SPD_NON_ID) {
                spdWarning("Type object \"char\" is not found in SDB.\n");
            }
    
            /* ˼Ԥ char [] 򸡺 */
            acharTypeId = smuFindArrayOf(charTypeId);
        }
        
        if (acharTypeId == SPD_NON_ID) {
            /* SDB  char [] ¸ߤʤ */
            spdWarning("Type object \"char []\" is not found in SDB.\n");
        }
        f = TRUE;
    }

    if (areaId == SPD_NON_ID) {
        /* Τ area  */
        pAreaId = spdCreateObj(SPD_CID_AREA, SPD_NON_ID);
        spdarea_initOrder(pAreaId);
        spdCreateRel(SPD_RID_AREA_TYPE, SPD_NON_ID, 
                     pAreaId, acharTypeId);
        spdSetAttrIntValByName(pAreaId, "sort", AREA_ARRAY);
    } else {
        pAreaId = areaId;
    }

    if (spdGetAChildObjId(pAreaId, SPD_RID_AREA_AREA) 
        != SPD_NON_ID) {
        hasSubArea = TRUE;
    } else {
        hasSubArea = FALSE;
    }
        
    p = str;

    /* Ƭ " ɤФ */
    if (escflag)
    while (*p++ != '"')
        ;

    for (i = 0; (c = *p++) && (escflag == FALSE || c != '"'); i++) {
        if (escflag) {
        /* \ 饨ץ󥹡³ʸȶ˼¹ԴĶ
           1ʸ */
        if (c == '\\') {
            c = *p++;

            if (isalpha(c)) {
                switch (c) {
                  case 'a':
                    c = '\a';
                    break;
                  case 'b':
                    c = '\b';
                    break;
                  case 'f':
                    c = '\f';
                    break;
                  case 'n':
                    c = '\n';
                    break;
                  case 'r':
                    c = '\r';
                    break;
                  case 't':
                    c = '\t';
                    break;
                  case 'v':
                    c = '\v';
                    break;
                  case 'x':
                    /* 16ʥץ */
                    c = 0;
                    while (isxdigit(d = *p++)) {
                        c *= 16;
                        if (isdigit(d)) {
                            c += (d - '0');
                        } else {
                            c += (tolower(d) - 'a');
                        }
                    }
        
                    /* ɤФ 1ʸ᤹ */
                    p--;
                    break;
                  default:
                    /* ANSI ̤ư */
                    break;
                }
            } else if (isdigit(c)) {
                /* 8ʥץ */
                c -= '0';
                while (isdigit(d = *p++)) {
                    c *= 8;
                    c += (d - '0');
                }
                /* ɤФ 1ʸ᤹ */
                p--;
            }
        }
        }

        if (hasSubArea == FALSE) {
            /* Ǥ area Τ area ȴϢդ */
            cAreaId = spdCreateArea(charTypeId);
            relId = spdCreateRel(SPD_RID_AREA_AREA, SPD_NON_ID,
                                 pAreaId, cAreaId);
            spdSetAttrIntValByName(relId, "order", i);
        } else {
            cAreaId = spdGetAChildObjIdWithRelAttr(pAreaId, 
                                                   SPD_RID_AREA_AREA,
                                                   "order", i);
        }

        /* ͤ */
        value.type = SpdValue_Integer;
        value.v.intval = c;
        spdSetValueData(cAreaId, value);
    }

    /* Ĥΰƽ */
    value.type = SpdValue_Integer;
    value.v.intval = '\0';

    do {
        if (hasSubArea == FALSE) {
            /* Ǥ area Τ area ȴϢդ */
            cAreaId = spdCreateArea(charTypeId);
            relId = spdCreateRel(SPD_RID_AREA_AREA, SPD_NON_ID,
                                 pAreaId, cAreaId);
            spdSetAttrIntValByName(relId, "order", i);
        } else {
            cAreaId = spdGetAChildObjIdWithRelAttr(pAreaId, 
                                                   SPD_RID_AREA_AREA,
                                                   "order", i++);
        }
        if (cAreaId != SPD_NON_ID) {
            spdSetValueData(cAreaId, value);
        }
    } while (hasSubArea && cAreaId != SPD_NON_ID);

    return pAreaId;
}

static SpdObjId spdarea_InitConstantStringArea(SpdObjId areaId, 
                                               SpdObjId stringId)
{
    SpdObjId pAreaId;
    SpdClassId classId;
    SpdConstString str;

    /* ʸʳ̵ */
    /* !! "abc" "def" Τ褦ʸϢ̤ݡ */
    classId = spdGetClassId(stringId);
    if (classId == SPD_CID_EXPRESSION) {
        stringId = spdGetAChildObjId(stringId, SPD_RID_CONST_REF);
        classId = spdGetClassId(stringId);
    }

    if (classId != SPD_CID_CONSTANT ||
        spdGetAttrIntValByName(stringId, "type") != CONST_STRING) {
        return SPD_NON_ID;
    }

    str = spdGetAttrStrValByName(stringId, "value");

    pAreaId = spdarea_InitStringArea(areaId, str, TRUE);

    /* constant  area ȤδϢ */
    spdCreateRel(SPD_RID_STRING_AREA, SPD_NON_ID,
                 stringId, pAreaId);

    return pAreaId;
}

SpdObjId spdCreateStringArea(SpdConstString str, SpdObjId storageId)
{
    SpdObjId areaId;

    areaId = spdarea_InitStringArea(SPD_NON_ID, str, FALSE);

    if (storageId != SPD_NON_ID) {
        spdCreateRel(SPD_RID_STORAGE_AREA, SPD_NON_ID,
                     storageId, areaId);
    }

    return areaId;
}

SpdObjId spdCreateConstantStringArea(SpdObjId stringId, SpdObjId storageId)
{
    SpdObjId areaId;

    areaId = spdarea_InitConstantStringArea(SPD_NON_ID, stringId);

    if (storageId != SPD_NON_ID) {
        spdCreateRel(SPD_RID_STORAGE_AREA, SPD_NON_ID,
                     storageId, areaId);
    }

    return areaId;
}

SpdObjId spdSetStringArea(SpdObjId areaId, SpdConstString str)
{
    return spdarea_InitStringArea(areaId, str, FALSE);
}

SpdObjId spdSetConstantStringArea(SpdObjId areaId, SpdObjId stringId)
{
    return spdarea_InitConstantStringArea(areaId, stringId);
}

SpdObjId spdCreateArea(SpdObjId typeId)
{
    SpdObjId areaId = SPD_NON_ID;
    SpdObjId typenameId, orgtypeId, cexprId;
    SpdObjId memberTypeId, memberAreaId;
    SpdObjId elemTypeId, elemAreaId;
    SpdSet2 members;
    SpdRelId relId;
    SpdRel *memberp;
    int elemNum;
    SetCursor csr;
    int i;
    int sort, order;

    if (spdGetClassId(typeId) != SPD_CID_TYPE) {
        return SPD_NON_ID;
    }
    
    sort = spdGetAttrIntValByName(typeId, "sort");
    switch(sort) {
      case TYPE_TYPE_DEF:
        /* typedef 줿Ȥηơη area  */
        typenameId = spdGetAChildObjId(typeId, SPD_RID_TYPE_IS);
        orgtypeId = spdGetAChildObjId(typenameId, SPD_RID_IDENT_TYPE);
        areaId = spdCreateArea(orgtypeId);
        /* areaId --area_type-- orgtypeId ȤϢĥƤΤ
           areaId --area_type-- typeId ˽񤭴 */
        relId = spdGetARelId(areaId, orgtypeId, "area_type");
        spdSetAttrIntValByName(relId, "type_id", typeId);
        break;
      case TYPE_STRUCT_TAG:
      case TYPE_UNION_TAG:
      case TYPE_DECLARATION:
      case TYPE_POINTER:
      case TYPE_ARRAY:
      case TYPE_ENUM_SPECIFIER:
        /* area  */
        areaId = spdCreateObj(SPD_CID_AREA, SPD_NON_ID);
        spdarea_initOrder(areaId);
        spdCreateRel(SPD_RID_AREA_TYPE, SPD_NON_ID, areaId, typeId);

        /* ¤ľˤϺƵŪ˺ */
        switch(sort) {
          case TYPE_STRUCT_TAG:
            spdSetAttrIntValByName(areaId, "sort", AREA_STRUCT);
            members = spdGetChildRelSet(typeId,
                                          SPD_RID_STRUCT_MEMBER);
            for (csr = spdSetCursorCreate(members); spdSetCursorNext(&csr);) {
                memberp = spdSetGetValueP(csr.curElem->value);
                /* !! const struct ʾϡФη const ˤ٤ */
                /* !! const ΰʤΤ̤ */
                memberTypeId = spdGetAChildObjId(memberp->objectId, 
                                                 SPD_RID_MEMBER_TYPE);
                memberAreaId = spdCreateArea(memberTypeId);
                relId = spdCreateRel(SPD_RID_AREA_AREA, SPD_NON_ID,
                                     areaId, memberAreaId);
                spdCreateRel(SPD_RID_MEMBER_AREA, SPD_NON_ID,
                             memberp->objectId, areaId);
                order = spdGetAttrIntValByName(memberp->relationId, "order");
                spdSetAttrIntValByName(relId, "order", order);
            }
            spdFreeSet2(members);
            break;
          case TYPE_UNION_TAG:
            /* !! union ΰ̤Τ̤ */
            spdSetAttrIntValByName(areaId, "sort", AREA_UNION);
            break;
          case TYPE_ARRAY:
            /* ǿǿꤵƤʤ
               ǤϳǤ area ֥ȤϺ
               ͤꤹȤ˺ */
            cexprId = spdGetAChildObjId(typeId, SPD_RID_TYPE_CEXPR);
            if (cexprId != SPD_NON_ID) {
                elemNum = spdCastValueDataInt(spdEvalConstExpression(cexprId));
                /* !! const array ʾϡǤη const ˤ٤ */
                /* !! const ΰʤΤ̤ */
                elemTypeId = spdGetAChildObjId(typeId, SPD_RID_TYPE_ST);
                for (i = 0; i < elemNum; i++) {
                    elemAreaId = spdCreateArea(elemTypeId);
                    relId = spdCreateRel(SPD_RID_AREA_AREA, 
                                         SPD_NON_ID, areaId, elemAreaId);
                    spdSetAttrIntValByName(relId, "order", i);
                }
            }

            spdSetAttrIntValByName(areaId, "sort", AREA_ARRAY);
            break;
          case TYPE_DECLARATION:
          case TYPE_POINTER:
          case TYPE_ENUM_SPECIFIER:
            spdSetAttrIntValByName(areaId, "sort", AREA_BASIC);
            break;
        }
    
        break;
      case TYPE_FUNC:
      default:
        /* 顼 */
        return SPD_NON_ID;
        break;
    }
    
    return areaId;
}

/* 1area롥 */
/* !! Ƥareaˤarea_typeϺƤʤ */

SpdObjId spdCreateArrayArea(SpdObjId typeId, int n)
{
    int i;
    SpdObjId pAreaId, cAreaId;
    SpdRelId relId;

    pAreaId = spdCreateObj(SPD_CID_AREA, SPD_NON_ID);
    spdSetAttrIntValByName(pAreaId, "sort", AREA_ARRAY);

    for (i = 0; i < n; i++) {
        cAreaId = spdCreateArea(typeId);
        relId = spdCreateRel(SPD_RID_AREA_AREA, SPD_NON_ID,
                             pAreaId, cAreaId);
        spdSetAttrIntValByName(relId, "order", i);
    }

    return pAreaId;
}

static int isConstStringExpression(SpdObjId exprId)
{
    SpdObjId stringId;

    /* !! "abc" "def" Τ褦ʸϢ̤ݡ */
    stringId = spdGetAChildObjId(exprId, SPD_RID_CONST_REF);
    
    if (stringId == SPD_NON_ID)
        return FALSE;

    if (spdGetAttrIntValByName(stringId, "type") != CONST_STRING)
        return FALSE;

    return TRUE;
}

static int spdCompareRelOrder(const SpdRel *a, const SpdRel *b)
{
    return (spdGetAttrIntValByName(a->relationId, "order")
            - spdGetAttrIntValByName(b->relationId, "order"));
}

static int setInitValueArray(SpdObjId areaId, SpdRelArray initExprs,
                                  int ioff)
{
    SpdRelArray subInitExprs, areas;
    SpdObjId initExprId, elemAreaId, elemTypeId;
    SpdRelId relId;
    int sort, areaSort;
    int i, j;

    areaSort = spdGetAttrIntValByName(areaId, "sort");
    areas = spdGetRelSortedArray(areaId, "area_area", "p-id", 
                                 NULL, spdCompareRelOrder);
    i = ioff;
    j = 0; 
    while (i < initExprs.size && (areas.size <= 0 || j < areas.size)) {
        initExprId = initExprs.rel[i].objectId;
        if (isConstStringExpression(initExprId)) {
            /* ʸˤ */
            spdSetConstantStringArea(areaId, initExprId);
            i++;
        } else {
            elemAreaId = SPD_NON_ID;
            if (areaSort != AREA_BASIC) {
                /* ¤ΰؤξ */
                if (areas.size == 0) {
                    if (areaSort != AREA_ARRAY) {
                        spdWarning("area %d has no subarea and not array.\n", areaId);
                    }
                    /* ΰ褬¸ߤʤ(ǿά줿)
                       ϻΰ */
                    elemTypeId = spdGetAChildObjId(areaId, 
                                                   SPD_RID_AREA_TYPE);
                    elemTypeId = spdGetAChildObjId(elemTypeId, 
                                                   SPD_RID_TYPE_ST);
                    elemAreaId = spdCreateArea(elemTypeId);
                    relId = spdCreateRel(SPD_RID_AREA_AREA, 
                                         SPD_NON_ID, areaId, elemAreaId);
                    spdSetAttrIntValByName(relId, "order", j++);
                } else if (areas.size > 0) {
                    elemAreaId = areas.rel[j++].objectId;
                }
            }
            
            sort = spdGetAttrIntValByName(initExprId, "sort");
            if (sort == EXPR_SORT_INITLIST) {
                subInitExprs = spdGetRelSortedArray(initExprId, "expr_expr",
                                                    "p-id",
                                                    NULL, spdCompareRelOffset);
                if (areaSort != AREA_BASIC) {
                    setInitValueArray(elemAreaId, subInitExprs, 0);
                    i++;
                } else {
                    /* ñΰؤξ (% ;ʬ {} ) */
                    /* ʬƺƵ */
                    setInitValueArray(areaId, subInitExprs, 0);
                    i++;
                }
                spdFreeRelArray(subInitExprs);
            } else {
                if (areaSort != AREA_BASIC) {
                    i += setInitValueArray(elemAreaId, initExprs, i);
                } else {
                    /* ̾ͤ */
                    spdSetValueData(areaId, 
                                    spdEvalConstExpression(initExprId));
                    i++;
                    break;
                }
            }
        }
    }

    /* Ĥΰ */
    for (; areas.size > 0 && j < areas.size; j++) {
        spdInitializeAreaValue(areas.rel[j].objectId);
    }

    spdFreeRelArray(areas);


    return i - ioff;
}

static SpdObjId setInitValue(SpdObjId areaId, SpdObjId optId)
{
    SpdObjId initExprId;
    SpdRelArray initExprs;

    initExprId = spdGetAChildObjId(optId, SPD_RID_INIT_EXPR);
    if (spdGetAttrIntValByName(initExprId, "sort") == EXPR_SORT_INITLIST) {
        initExprs = spdGetRelSortedArray(initExprId, "expr_expr", "p-id",
                                         NULL, spdCompareRelOffset);
        setInitValueArray(areaId, initExprs, 0);
        spdFreeRelArray(initExprs);
    } else {
        if (isConstStringExpression(initExprId)) {
            /* ʸˤ */
            spdSetConstantStringArea(areaId, initExprId);
        } else {
            spdSetValueData(areaId, 
                            spdEvalConstExpression(initExprId));
        }
    }

    return areaId;
}

static SpdObjId findInitializer(SpdObjId variableId)
{
    SpdIdSet decrs;
    SpdObjId decrId, optId = SPD_NON_ID;
    SetCursor csr;


    decrs = spdGetParentObjIdSet(variableId, SPD_RID_DECL_IDENT);
    for (csr = spdSetCursorCreate(decrs); spdSetCursorNext(&csr);) {
        decrId = spdSetGetValueO(csr.curElem->value);
        if ((optId = spdGetAChildObjIdWithObjAttr(decrId, SPD_RID_DECL_OPT,
                                                 "sort", OPT_INITIALIZER))
            != SPD_NON_ID) {
            break;
        }
    }
    spdFreeSet2(decrs);

    return optId;
}

SpdObjId spdCreateVariableArea(SpdObjId variableId, SpdObjId storageId)
{
    SpdObjId typeId, areaId, optId;
    SpdRelId relId;

    /* ѿη area  */
    typeId = spdGetAChildObjId(variableId, SPD_RID_IDENT_TYPE);
    areaId = spdCreateArea(typeId);

    /*  area ѿϢդ */
    relId = spdCreateRel(SPD_RID_VARIABLE_AREA, SPD_NON_ID,
                         variableId, areaId);
    spdarea_setOrder(relId);

    if (storageId != SPD_NON_ID) {
        /*  area  storage ȴϢդ */
        relId = spdCreateRel(SPD_RID_STORAGE_AREA,
                             SPD_NON_ID,
                             storageId, areaId);
    }

    /*  */
    optId = findInitializer(variableId);

    if (optId != SPD_NON_ID) {
        setInitValue(areaId, optId);
    }
    
    return areaId;
}

SpdObjId spdCreateStorage(SpdObjId parentId)
{
    SpdObjId storageId;
    SpdRelId relId;
    SpdClassId relClassId;
    int sort;

    /* storage  */
    storageId = spdCreateObj(SPD_CID_STORAGE, SPD_NON_ID);
    spdarea_initOrder(storageId);

    if (parentId == SPD_NON_ID) {
        sort = AREA_STORAGE_HEAP;
    } else {
        switch (spdGetClassId(parentId)) {
        case SPD_CID_BLOCK:
            sort = AREA_STORAGE_LOCAL;
            relClassId = SPD_RID_BLOCK_STORAGE;
            break;
        case SPD_CID_OPTIONALDECL:
            sort = AREA_STORAGE_FUNC;
            relClassId = SPD_RID_FUNC_STORAGE;
            break;
        case SPD_CID_PROGRAM:
            sort = AREA_STORAGE_GLOBAL;
            relClassId = SPD_RID_PROG_STORAGE;
            break;
        }
    }
    spdSetAttrIntValByName(storageId, "sort", sort);

    /* block ȴϢդ */
    if (parentId != SPD_NON_ID) {
        relId = spdCreateRel(relClassId, SPD_NON_ID, parentId, storageId);
        spdarea_setOrder(relId);
    }

    return storageId;
}

static int isGlobalDecl(SpdObjId declId)
{
    int storage;

    storage = spdGetAttrIntValByName(declId, "storage");

    /* extern  static Ū˽񤫤Ƥ global */
    if (storage == STORAGE_EXTERN || storage == STORAGE_STATIC) {
        return TRUE;
    }

    /* storage ̤ξ */
    if (storage == STORAGE_NONE) {
        /* file_decl äƤ global */
        if (spdGetAParentObjId(declId, SPD_RID_FILE_DECL) !=
            SPD_NON_ID) {
            return TRUE;
        }
    }

    return FALSE;
}

SpdObjId spdCreateStorageArea(SpdObjId parentId)
{
    SpdObjId storageId, declId, decrId, identId, stringId;
    SpdIdSet decls, decrs, strings, variables = NULL;
    SetCursor csr1, csr2;
    int fGlobal;    /* global storage γ area  true */

    /* block / optdecl ˴ޤޤƤѿˤĤArea
       storageȴϢŤ */
    switch (spdGetClassId(parentId)) {
    case SPD_CID_PROGRAM:
        decls = spdGetClassExtent(SPD_CID_DECLARATION);
        variables = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
        fGlobal = TRUE;
        break;
    case SPD_CID_BLOCK:
        decls = spdGetChildObjIdSet(parentId, SPD_RID_BLK_DECL);
        fGlobal = FALSE;
        break;
    case SPD_CID_OPTIONALDECL:
        decls = spdGetChildObjIdSet(parentId, SPD_RID_FUNC_PARM);
        fGlobal = FALSE;
        break;
    default:
        return SPD_NON_ID;
    }

    /* storage  */
    storageId = spdCreateStorage(parentId);

    if (fGlobal) {
        /* Ƥ ʸ area, value  */
        strings = spdGetClassExtentP(SPD_CID_CONSTANT); /* no need to free */
        for (csr1 = spdSetCursorCreate(strings); spdSetCursorNext(&csr1);) {
            stringId = spdSetGetValueO(csr1.curElem->value);
            if (spdGetAttrIntValByName(stringId, "type") != CONST_STRING) {
                /* ʸʳ̵ */
                continue;
            }
            
            /* !! ϽϺɬפϤʤ(ѿ area/value Ƚʣ) */
            spdCreateConstantStringArea(stringId, storageId);
        }
    }

    for (csr1 = spdSetCursorCreate(decls); spdSetCursorNext(&csr1);) {
        declId = spdSetGetValueO(csr1.curElem->value);

        /* ̿ fGlobal ȰפʤΤϥå */
        if (isGlobalDecl(declId) != fGlobal)
            continue;

        /* optional_decl ΤȤʳΤΤϥå */
        if (spdGetClassId(parentId) == SPD_CID_OPTIONALDECL
            && spdGetAttrIntValByName(declId, "sort") != DECL_PARAMETER)
            continue;

        decrs = spdGetChildObjIdSet(declId, SPD_RID_DECL_DECL);
        for (csr2 = spdSetCursorCreate(decrs); spdSetCursorNext(&csr2);) {
            decrId = spdSetGetValueO(csr2.curElem->value);

            /* ѿʳϥå */
            if (spdGetAttrIntValByName(decrId, "sort") != DECL_VARIABLE) {
                continue;
                /* break ǤϤʤΤ tag ʤɤɤФ */
            }

            /* ѿ id  */
            identId = spdGetAChildObjId(decrId, SPD_RID_DECL_IDENT);
            if (spdGetAttrIntValByName(identId, "sort") == ID_VARIABLE) {
                if (!fGlobal || !spdContainsO(variables, identId)) {
                    /* ѿ˴Ϣդ줿 area  */
                    /* !! storage_area   declarator ν
                       (ѿ)ȿǤƤʤΤǡѿ֤Ǥ
                       ޤʤ */
                    spdCreateVariableArea(identId, storageId);
                    if (fGlobal) {
                        spdAddElemOK(variables, identId);
                    }
                }
            }
        }
        spdFreeSet2(decrs);
    }
    spdFreeSet2(decls);
    if (variables != NULL) {
        spdFreeSet2(variables);
    }
    return storageId;
}

/* spdCreateStorage ˥ޡ */
SpdObjId spdCreateGlobalStorage(SpdObjId programId)
{
    return spdCreateStorageArea(programId);
}

/* ¥ݥͤ areaId, offset ΥݥɽѴ */
/* !! ֤ˤ̤б */
SpdValueData spdConvRealPtrToAreaPtr(SpdValueData value)
{
    SpdObjId areaId = SPD_NON_ID, aId;
    int address = 0, size = 0, a, s;
    SpdIdSet areas;
    SetCursor csr;
    int ptrval;

    ptrval = (int)value.v.pointerval;
    areas = spdGetClassExtentP(SPD_CID_AREA); /* no need to free */
    for (csr = spdSetCursorCreate(areas); spdSetCursorNext(&csr);) {
        aId = spdSetGetValueO(csr.curElem->value);
        a = spdGetAttrIntValByName(aId, "address");
        s = spdGetAttrIntValByName(aId, "size");

        if (a <= ptrval && ptrval < a + s && address <= a && size <= s) {
            areaId = aId;
            address = a;
            size = s;
        }
    }

    if (areaId != SPD_NON_ID) {
        value.type = SpdValue_Pointer;
        value.v.ptr.areaId = areaId;
        value.v.ptr.offset = ptrval - address;
    } else {
        value.type = SpdValue_NonValue;
        value.v.intval = -1;
    }

    return value;
}

SpdObjId spdCreateValue(SpdValueData value)
{
    SpdObjId valueId;
    SpdRelId relId;

    if (value.type == SpdValue_RealPointer) {
        value = spdConvRealPtrToAreaPtr(value);
        if (value.type == SpdValue_NonValue) {
            /* ͤ¥ݥ󥿤ݻ뤿 value_obj ʤ */
            return SPD_NON_ID;
        }
    }

    valueId = spdCreateObj(SPD_CID_VALUE, SPD_NON_ID);
    spdSetAttrIntValByName(valueId, "type", value.type);

    switch (value.type) {
    case SpdValue_Pointer:
        /* ݥ󥿤ϴϢŸ */
        relId = spdCreateRel(SPD_RID_POINT_TO, SPD_NON_ID,
                             valueId, value.v.ptr.areaId);
        spdSetAttrIntValByName(relId, "offset", value.v.ptr.offset);
        spdSetAttrIntValByName(valueId, "sort", VALUE_POINTER);
        break;
    case SpdValue_FuncPointer:
        /* ؿݥ󥿤ϴϢŸ */
        relId = spdCreateRel(SPD_RID_FUNCPTR_TO, SPD_NON_ID,
                             valueId, value.v.funcId);
        spdSetAttrIntValByName(valueId, "sort", VALUE_POINTER);
        break;
    case SpdValue_NonValue:
        spdSetAttrIntValByName(valueId, "value", -1);
        spdSetAttrIntValByName(valueId, "sort", VALUE_NONVALUE);
        break;
    default:
        /* !! int ǤȤꤢå */
        /* !! Binary Ƴ줿ѹ */
        spdSetAttrIntValByName(valueId, "value", value.v.intval);
        spdSetAttrIntValByName(valueId, "sort", VALUE_BASIC);
        break;
    }

    return valueId;
}

/* ֥ȹ¤ؿ */
/* Area Ȥ˴ϢValueƺ */
void spdDeleteArea(SpdObjId objId)
{
    SpdRel *childp = NULL;
    SpdIdSet childs;
    SpdClassId classId;
    SetCursor csr;

    childs = spdGetChildRelSet(objId, SPD_NON_ID);
    for (csr = spdSetCursorCreate(childs); spdSetCursorNext(&csr);) {
        childp = spdSetGetValueP(csr.curElem->value);
        classId = spdGetClassId(childp->objectId);
        switch (classId) {
          case SPD_CID_AREA:
            spdDeleteArea(childp->objectId);
            break;
          case SPD_CID_VALUE:
            spdDeleteObj(childp->objectId);
            break;
          default:
            break;
        }
    }
    if (childp) {
        spdDeleteObj(childp->objectId);
    }

    spdFreeSet2(childs);
}

/* Storate Ȥ˴ϢAreaƺ */
void spdDeleteStorageArea(SpdObjId objId)
{
    SpdRel *childp = NULL;
    SpdIdSet childs;
    SpdClassId classId;
    SetCursor csr;

    childs = spdGetChildRelSet(objId, SPD_NON_ID);
    for (csr = spdSetCursorCreate(childs); spdSetCursorNext(&csr);) {
        childp = spdSetGetValueP(csr.curElem->value);
        classId = spdGetClassId(childp->objectId);
        switch (classId) {
          case SPD_CID_AREA:
            spdDeleteArea(childp->objectId);
            break;
          default:
            break;
        }
    }
    if (childp) {
        spdDeleteObj(childp->objectId);
    }

    spdFreeSet2(childs);
}
