/* 
 * Program:             $RCSfile: storagestack.c,v $  $Revision: 30.7 $
 * 
 * Purpose:             AreaModelAR.
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: storagestack.c,v 30.7 2002/10/21 07:26:13 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/AreaModelAR.h>

/*----------------------------------------------------------------------
  ѿ
 ----------------------------------------------------------------------*/

/*
 * Modified by S.Yamamoto 2000/03/24.
 * 
 * static currentStorage = SPD_NON_ID;
 * static globalStorage = SPD_NON_ID;
 */
static SpdObjId     currentStorage = SPD_NON_ID;
static SpdObjId     globalStorage = SPD_NON_ID;

/*----------------------------------------------------------------------
  ؿ
  ----------------------------------------------------------------------*/

void spdEnableStorage(SpdObjId storageId)
{
    spdCreateRel(SPD_RID_STORAGE_STORAGE, SPD_NON_ID, 
                 currentStorage, storageId);
    currentStorage = storageId;
}

SpdObjId spdDisableStorage(void)
{
    SpdObjId oldStorage;

    oldStorage = currentStorage;
    currentStorage = spdGetAParentObjId(currentStorage, 
                                        SPD_RID_STORAGE_STORAGE);

    return oldStorage;
}

SpdObjId spdGetCurrentStorage(void)
{
    return currentStorage;
}

SpdObjId spdSetCurrentStorage(SpdObjId storageId)
{
    SpdObjId oldStorage;

    oldStorage = currentStorage;
    currentStorage = storageId;

    return oldStorage;
}

SpdObjId spdSetGlobalStorage(SpdObjId storageId)
{
    if (spdGetClassId(storageId) == SPD_CID_STORAGE) {
        return (globalStorage = storageId);
    }

    return SPD_NON_ID;
}

SpdObjId spdGetGlobalStorage(void)
{
    return globalStorage;
}
