/* 
 * Program:             $RCSfile: value.c,v $  $Revision: 30.21 $
 * 
 * Purpose:             ͥؿ
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: value.c,v 30.21 2003/07/08 05:46:23 yamamoto Exp yamamoto $";
#endif

/* 
 * ñAreaModelȤƻȤˤϡSetValueϴؿǡ
 * ¸value˴ɬפ롥
 */

#include <limits.h>                 /* For INT_MIN. */
#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/AreaModelAR.h>

/* !! ʤȲꤹȡ¸ͤɬפ롥 */

SpdObjId spdSetValue(SpdObjId areaId, SpdObjId valueId)
{
    spdarea_setOrder(spdCreateRel(SPD_RID_AREA_VALUE, SPD_NON_ID,
                                  areaId, valueId));
    return valueId;
}

SpdObjId spdSetValueData(SpdObjId areaId, SpdValueData value)
{
    SpdObjId valueId;

    valueId = spdCreateValue(value);
    if (valueId != SPD_NON_ID) {
        return spdSetValue(areaId, valueId);
    } else {
        /* ͤ¥ݥ󥿤ݻ롥 */
        spdSetAttrIntValByName(areaId, "address", (int)value.v.pointerval);
        spdSetAttrIntValByName(areaId, "indirect", AREA_DIRECT);

        /* !! Temporarily added by S.Yamamoto. */
        SPD_DUMMY_RETURN(SPD_NON_ID);
    }
}

/* ΰͤ롥 */

SpdObjId spdInitializeAreaValue(SpdObjId areaId)
{
    SpdObjId        typeId;
    int             sort, type;
    SpdValueData    value;
  
    if ((typeId = spdGetAChildObjId(areaId, SPD_RID_AREA_TYPE)) ==
        SPD_NON_ID) {
        return SPD_NON_ID;
    }
    sort = spdGetAttrIntValByName(typeId, "sort");

    if (sort == TYPE_POINTER) {
        value.type = SpdValue_Pointer;
        value.v.ptr.areaId = SPD_NON_ID;
        value.v.ptr.offset = 0;
    } else if (sort != TYPE_DECLARATION) {
        return SPD_NON_ID;
    }

    type = spdGetAttrIntValByName(typeId, "type");
    switch (type) {
      case TYPE_INT:
      case TYPE_CHAR:
        value.type = SpdValue_Integer;
        value.v.intval = 0;
        break;
      case TYPE_FLOAT:
      case TYPE_DOUBLE:
      default:
        /* !! ̤ݡ */
        return SPD_NON_ID;
    }
    return (spdSetValueData(areaId, value));
}

/* !! timeϻĤȤγĥѡ */

SpdObjId spdGetValue(SpdObjId areaId, int time)
{
    SpdIdSet    values;
    SpdObjId    valueId, res = SPD_NON_ID;
    int         order = INT_MIN, o;
    SetCursor   csr;
    
    values = spdGetChildObjIdSet(areaId, SPD_RID_AREA_VALUE);
    for (csr = spdSetCursorCreate(values); spdSetCursorNext(&csr);) {
        valueId = spdSetGetValueO(csr.curElem->value);
        o = spdGetAttrIntValByName(valueId, "order");
        if (order < o) {
            order = o;
            res = valueId;
        }
    }
    spdFreeSet2(values);
    return res;
}

SpdValueData spdGetValueDataFromValue(SpdObjId valueId)
{
    SpdValueData    res;
    SpdRel          rel;

    if (valueId == SPD_NON_ID) {
        /* valueId ʾ֤ */
        res.type = SpdValue_NonValue;
        res.v.intval = -1;
        return res;
    }
    res.type = spdGetAttrIntValByName(valueId, "type");
    switch (res.type) {
      case SpdValue_Pointer:
        /* ݥ󥿤ξϴϢξSpdValueData롥 */
        rel = spdGetAChildRel(valueId, SPD_RID_POINT_TO);

        res.v.ptr.areaId = rel.objectId;
        res.v.ptr.offset = spdGetOffset(rel.relationId);
        break;
      case SpdValue_FuncPointer:
        /* ؿݥ󥿤ξϴϢξSpdValueData롥 */
        rel = spdGetAChildRel(valueId, SPD_RID_FUNCPTR_TO);
        res.v.funcId = rel.objectId;
        break;
      default:
        /* !! intǼ롥binaryƳ줿ѹ */
        res.v.intval = spdGetAttrIntValByName(valueId, "value");
        break;
    }
    return res;
}

SpdValueData spdGetValueData(SpdObjId areaId, int time)
{
    SpdObjId        valueId;
    SpdValueData    res;

    if (spdGetAttrIntValByName(areaId, "indirect") != AREA_DIRECT) {
        valueId = spdGetValue(areaId, time);
        return spdGetValueDataFromValue(valueId);
    } else {
        res.type = SpdValue_RealPointer;
        res.v.pointerval = (void *)spdGetAttrIntValByName(areaId, "address");
        return res;
    }
}

SpdValueData spdGetFuncNameValueData(SpdObjId funcId)
{
    SpdValueData res;

    if (funcId == SPD_NON_ID ||
        spdGetAttrIntValByName(funcId, "sort") != ID_FUNCTION) {
        /* valueIdʾ֤ */
        res.type = SpdValue_NonValue;
        res.v.intval = -1;
        return (res);
    }
    res.type = SpdValue_FuncPointer;
    res.v.funcId = funcId;
    return res;
}
