/* 
 * Program:             $RCSfile: CommentView.c,v $  $Revision: 40.5 $
 * 
 * Purpose:             Class definition of CommentView.
 * 
 * Author:              K.Hoshino  2001/10/27
 *                      S.Yamamoto  2001/10/27 
 * 
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: CommentView.c,v 40.5 2003/04/07 16:02:56 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

#if defined(SAPID_AR5)

static SpdValName relatedcomment_lintsort[] = {
    /* Ϥޤfallthrough */
    { SPD_VAL_NAME3(LINT_FALLTHROUGH, "fallthrough") },
    { 0, NULL, NULL}
};

/* see AR3Sub.c */

static SpdDBClass Comment_view_classes[] = {
    /*---------- ֥ ----------*/
    {
        "pcomment",    /* physicalcomment */
        SPD_CID_PCOMMENT,
        SAPIDDB_SORT_OBJ_TREENODE | SAPIDDB_SORT_OBJ_TEXT,
        { SAPIDDB_ATTR_ID, 0, 1, 2, 3, 4, 5, 6, SAPIDDB_ATTR_NONE },
        {
            { "length", SPD_DBT_INT, NULL, SPD_NON_ID, 0 },
            { "lint_sort", SPD_DBT_ENUM, relatedcomment_lintsort },
            /* !! ֥ȤoffsetʤȤ뽾ȿƤ? */
            { "offset", SPD_DBT_INT },
            /* !! 3ĤϤʤ⤷ʤɡ*/
            { "line_num_begin", SPD_DBT_INT },
            { "line_num_end", SPD_DBT_INT },
            { "offset_from_linehead", SPD_DBT_INT },
            { "str", SPD_DBT_STR },
            { NULL, SPD_DBT_NON },
        }
    },
    {
        "lcomment",    /* logicalcomment */
        SPD_CID_LCOMMENT,
        SAPIDDB_SORT_OBJ,
        { SAPIDDB_ATTR_ID, 0, SAPIDDB_ATTR_NONE },
        {
            { "str", SPD_DBT_STR },
            { NULL, SPD_DBT_NON },
        }
    },

    /*---------- Ϣ ----------*/
    {
        "pfile_pcomment",
        SPD_RID_PFILE_PCOMMENT,
        SAPIDDB_SORT_REL_COMPOSITE,
        { 0, 1, 2, SAPIDDB_ATTR_NONE },
        {
            { "pfile_id", SPD_DBT_OID, NULL, SPD_CID_PFILE },
            { "pcomment_id", SPD_DBT_OID, NULL, SPD_CID_PCOMMENT }, 
            { "offset", SPD_DBT_INT },
            { NULL, SPD_DBT_NON },
        }
    },
    {
        "pcomment_lcomment",    /* physical_logical */
        SPD_RID_PCOMMENT_LCOMMENT,
        SAPIDDB_SORT_REL_REFERENCE,
        { 0, 1, SAPIDDB_ATTR_NONE },
        {
            { "pcomment_id", SPD_DBT_OID, NULL, SPD_CID_PCOMMENT }, 
            { "lcomment_id", SPD_DBT_OID, NULL, SPD_CID_LCOMMENT },
            { NULL, SPD_DBT_NON },
        }
    },
    /* ʸǤȤδϢ */
    {
        "lcomment_pfile",
        SPD_RID_LCOMMENT_PFILE,
        SAPIDDB_SORT_REL,
        { 0, 1, SAPIDDB_ATTR_NONE },
        {
            {"lcomment_id", SPD_DBT_OID, NULL, SPD_CID_LCOMMENT },
            {"pfile_id", SPD_DBT_OID, NULL, SPD_CID_PFILE }, 
            { NULL, SPD_DBT_NON },
        }
    },
    {
        "lcomment_pblock",
        SPD_RID_LCOMMENT_PBLOCK,
        SAPIDDB_SORT_REL,
        { 0, 1, SAPIDDB_ATTR_NONE },
        {
            {"lcomment_id", SPD_DBT_OID, NULL, SPD_CID_LCOMMENT },
            {"pblock_id", SPD_DBT_OID, NULL, SPD_CID_PBLOCK }, 
            { NULL, SPD_DBT_NON },
        }
    },
    {
        "lcomment_declaration",
        SPD_RID_LCOMMENT_DECLARATION,
        SAPIDDB_SORT_REL,
        { 0, 1, SAPIDDB_ATTR_NONE },
        {
            {"lcomment_id", SPD_DBT_OID, NULL, SPD_CID_LCOMMENT },
            {"declaration_id", SPD_DBT_OID, NULL, SPD_CID_DECLARATION }, 
            { NULL, SPD_DBT_NON },
        }
    },
    {
        "lcomment_label",
        SPD_RID_LCOMMENT_LABEL,
        SAPIDDB_SORT_REL,
        { 0, 1, SAPIDDB_ATTR_NONE },
        {
            {"lcomment_id", SPD_DBT_OID, NULL, SPD_CID_LCOMMENT },
            {"label_id", SPD_DBT_OID, NULL, SPD_CID_LABEL }, 
            { NULL, SPD_DBT_NON },
        }
    },
    {
        "lcomment_expression",
        SPD_RID_LCOMMENT_EXPRESSION,
        SAPIDDB_SORT_REL,
        { 0, 1, SAPIDDB_ATTR_NONE },
        {
            {"lcomment_id", SPD_DBT_OID, NULL, SPD_CID_LCOMMENT },
            {"expression_id", SPD_DBT_OID, NULL, SPD_CID_EXPRESSION }, 
            { NULL, SPD_DBT_NON },
        }
    },
    {
        "lcomment_block",
        SPD_RID_LCOMMENT_BLOCK,
        SAPIDDB_SORT_REL,
        { 0, 1, SAPIDDB_ATTR_NONE },
        {
            {"lcomment_id", SPD_DBT_OID, NULL, SPD_CID_LCOMMENT },
            {"block_id", SPD_DBT_OID, NULL, SPD_CID_BLOCK }, 
            { NULL, SPD_DBT_NON },
        }
    },

    /*
     * !!
     * 
     * {
     *     "lcomment_element",
     *     SPD_RID_LCOMMENT_ELEMENT,
     *     SAPIDDB_SORT_REL,
     *     { 0, 1, SAPIDDB_ATTR_NONE },
     *     {
     *         {"lcomment_id", SPD_DBT_OID, NULL, SPD_CID_LCOMMENT },
     *         {"element_id", SPD_DBT_OID, NULL, SPD_CID_ },ǤդΥ饹ʤ???
     *             { NULL, SPD_DBT_NON },
     *     }
     * },
     */

    {
        NULL, SPD_NON_ID, 0, {SAPIDDB_ATTR_NONE}
    }
};

#endif /* defined(SAPID_AR5) */

/******************************************************************************/

SpdDBModel Comment_view = {
    SPD_MID_COMMENT_VIEW,
    "Comment-view",
    SPD_COMMENT_VIEW_VERSION,
    SPD_COMMENT_VIEW_DIR,

    SPD_FIRST_CID_COMMENT_VIEW,
    SPD_LAST_CID_COMMENT_VIEW,
    SPD_CID_NUM_COMMENT_VIEW,

    SPD_FIRST_RID_COMMENT_VIEW,
    SPD_LAST_RID_COMMENT_VIEW,
    SPD_RID_NUM_COMMENT_VIEW,

    SPD_CRID_NUM_COMMENT_VIEW,

#if defined(SAPID_AR5)

    Comment_view_classes,
    NULL

#endif /* defined(SAPID_AR5) */
};
