/* 
 * Program:             $RCSfile: CommentViewAR.c,v $  $Revision: 40.7 $
 * 
 * Purpose:             Access routines of CommentView.
 * 
 * Author:              K.Hoshino  2001/10/27
 *                      S.Yamamoto  2001/10/27 
 * 
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: CommentViewAR.c,v 40.7 2003/07/08 05:46:32 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/CommentViewAR.h>

static int compCE(const void *a, const void *b);

/*
 * ʪΰ襳Ȥμ
 */

SpdIdSet getAllPcomments(void)
{
    return spdGetClassExtent(SPD_CID_PCOMMENT);
}

/*
 * ΰ襳Ȥμ
 */

SpdIdSet getAllLcomments(void)
{
    return spdGetClassExtent(SPD_CID_LCOMMENT);
}

/*************************************************/

/*
 * qsortƤӽФݤӴؿ(offset)
 */

static int compCE(const void *a, const void *b)
{
    SpdObjId aa = *(SpdObjId *)a;
    SpdObjId bb = *(SpdObjId *)b;
    int aa_offset = getLcommentOffset(aa);
    int bb_offset = getLcommentOffset(bb);
    int return_int;

    if (aa_offset < bb_offset) return_int =  -1;
    else if (aa_offset == bb_offset) return_int = 0;
    else return_int = 1;

    return return_int;
}

/*
 * եʪΰ襳Ȥμ
 */

SpdIdSet getPcommentsInPfile(SpdObjId pfileId)
{
    return spdGetChildObjIdSet(pfileId, SPD_RID_PFILE_PCOMMENT);
}

/*
 * եʪΰ襳Ȥoffset
 */

SpdObjIdArray getPcommentsInPfileSorted(SpdObjId pfileId)
{
    SpdObjIdArray retArray;
    SpdObjId *array;
    SetCursor csr;
    int i;
    
    SpdIdSet tmpIdSet = getPcommentsInPfile(pfileId);

    array = (SpdObjId *) spdMalloc(sizeof(SpdObjId) * tmpIdSet->elemNum);
    i = 0;
    for (csr = spdSetCursorCreate(tmpIdSet); spdSetCursorNext(&csr);) {
        array[i++] = spdSetGetValueO(csr.curElem->value);
    }
    /* arrayoffsetǥ */
    spdQsortTmp(array, tmpIdSet->elemNum, sizeof(SpdObjId), compCE);

    retArray.size = tmpIdSet->elemNum;
    retArray.id = array;

    spdFreeSet2(tmpIdSet);
    return retArray;
}

/*
 * եΰ襳Ȥμ
 */

SpdIdSet getLcommentsInPfile(SpdObjId pfileId)
{
    SpdIdSet pcommentIds = getPcommentsInPfile(pfileId);
    SpdIdSet lcommentIds = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
    SetCursor csr;

    for (csr = spdSetCursorCreate(pcommentIds); spdSetCursorNext(&csr);) {
        SpdObjId pcommentId = spdSetGetValueO(csr.curElem->value);
        SpdObjId lcommentId = spdGetAChildObjId(pcommentId, 
                                                SPD_RID_PCOMMENT_LCOMMENT);
        spdAddElemOK(lcommentIds, lcommentId);
    }

    spdFreeSet2(pcommentIds);
    return lcommentIds;
}

/*
 * եΰ襳Ȥoffset
 */

SpdObjIdArray getLcommentsInPfileSorted(SpdObjId pfileId)
{
    SpdObjIdArray retArray;
    SpdObjId *array;
    SetCursor csr;
    int i;

    SpdIdSet tmpIdSet = getLcommentsInPfile(pfileId);

    array = (SpdObjId *) spdMalloc(sizeof(SpdObjId) * tmpIdSet->elemNum);
    i = 0;
    for (csr = spdSetCursorCreate(tmpIdSet); spdSetCursorNext(&csr);) {
        array[i++] = spdSetGetValueO(csr.curElem->value);
    }
    /* arrayoffsetǥ */
    spdQsortTmp(array, tmpIdSet->elemNum, sizeof(SpdObjId), compCE);

    retArray.size = tmpIdSet->elemNum;
    retArray.id = array;

    spdFreeSet2(tmpIdSet);
    return retArray;
}

/*
 * ΰ¸ߤl_commentoffsetμ
 */

SpdObjIdArray getLcommentsWithinRegionP(SpdRegion regionP)
{
    SpdObjId pfileId = regionP.fileId;
    int start = regionP.offset;
    int end = regionP.offset + regionP.length;

    SpdIdSet lcommentIds;
    SpdIdSet tmpIdSet = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
    SetCursor csr;

    SpdObjId *array;
    SpdObjIdArray retArray;
    int i;


    /* !! ⤷spdGetObjIdOfModelSortedArrayȤȤаȯʤΤ? */

    lcommentIds = spdGetClassExtentP(SPD_CID_LCOMMENT); /* no need to free */
    for (csr = spdSetCursorCreate(lcommentIds); spdSetCursorNext(&csr);) {
        SpdObjId lcommentId = spdSetGetValueO(csr.curElem->value);
        int tmpOffset = getLcommentOffset(lcommentId);

        if (pfileId == getLcommentFile(lcommentId) &&
            start < tmpOffset && tmpOffset < end) {
            spdAddElemOK(tmpIdSet, lcommentId);
        }
    }

    array = (SpdObjId *) spdMalloc(sizeof(SpdObjId) * tmpIdSet->elemNum);
    i = 0;
    for (csr = spdSetCursorCreate(tmpIdSet); spdSetCursorNext(&csr);) {
        array[i++] = spdSetGetValueO(csr.curElem->value);
    }
    /* arrayoffsetǥ */
    spdQsortTmp(array, tmpIdSet->elemNum, sizeof(SpdObjId), compCE);

    retArray.size = tmpIdSet->elemNum;
    retArray.id = array;

    spdFreeSet2(tmpIdSet);

    return retArray;
}

/*************************************************/

/*
 * ʪΰ襳Ȥ˻Ĥ褦ΰ襳Ȥ֤
 */

SpdObjId getLcomment(SpdObjId pcommentId)
{
    return spdGetAChildObjId(pcommentId, SPD_RID_PCOMMENT_LCOMMENT);
}

/*
 * ΰ襳Ȥ餽ʪΰ跲֤
 */

SpdIdSet getPcomments(SpdObjId lcommentId)
{
    return spdGetParentObjIdSet(lcommentId, SPD_RID_PCOMMENT_LCOMMENT);
}

/*
 * 빽ʸǤȴϢΤΰ襳Ȥ1ļ
 * (SpdSet֤褦ˤʤ٤)
 */

SpdObjId getARelatedLcomment(SpdObjId elementId)
{
    SpdObjId lcommentId = SPD_NON_ID;
    
    lcommentId = spdGetAParentObjId(elementId, SPD_RID_LCOMMENT_PFILE);
    if (lcommentId == SPD_NON_ID)
        lcommentId = spdGetAParentObjId(elementId, SPD_RID_LCOMMENT_PBLOCK);
    if (lcommentId == SPD_NON_ID)
        lcommentId = spdGetAParentObjId(elementId, SPD_RID_LCOMMENT_DECLARATION);
    if (lcommentId == SPD_NON_ID)
        lcommentId = spdGetAParentObjId(elementId, SPD_RID_LCOMMENT_LABEL);
    if (lcommentId == SPD_NON_ID)
        lcommentId = spdGetAParentObjId(elementId, SPD_RID_LCOMMENT_EXPRESSION);
    if (lcommentId == SPD_NON_ID)
        lcommentId = spdGetAParentObjId(elementId, SPD_RID_LCOMMENT_BLOCK);
    
    return lcommentId;
}

static SpdIdSet getRelatedLcommentsSub(SpdIdSet lcomments,
                                             SpdObjId elementId, SpdClassId cId)
{
    SpdIdSet lcommentIds;

    lcommentIds = spdGetParentObjIdSet(elementId, cId);
    lcomments = spdAddSet2(lcomments, lcommentIds);
    spdFreeSet2(lcommentIds);

    return lcomments;
}

/*
 * 빽ʸǤȴϢΤΰ襳ȷ1ļ
 */

SpdIdSet getRelatedLcomments(SpdObjId elementId)
{
    SpdIdSet lcomments = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);

    lcomments = getRelatedLcommentsSub(lcomments, elementId, SPD_RID_LCOMMENT_PFILE);
    lcomments = getRelatedLcommentsSub(lcomments, elementId, SPD_RID_LCOMMENT_PBLOCK);
    lcomments = getRelatedLcommentsSub(lcomments, elementId, SPD_RID_LCOMMENT_DECLARATION);
    lcomments = getRelatedLcommentsSub(lcomments, elementId, SPD_RID_LCOMMENT_LABEL);
    lcomments = getRelatedLcommentsSub(lcomments, elementId, SPD_RID_LCOMMENT_EXPRESSION);
    lcomments = getRelatedLcommentsSub(lcomments, elementId, SPD_RID_LCOMMENT_BLOCK);

    return lcomments;
}

/*
 * ΰ襳ȤȴϢΤ빽ʸǤ
 * 
 * !! 1ĤΥȤʣιʸǤƤⰷ
 * ˤʤSpdSet֤褦ˤʤ뤫?
 */

SpdObjId getRelatedElementId(SpdObjId rcommentId)
{
    SpdObjId elementId = SPD_NON_ID;
    
    elementId = spdGetAChildObjId(rcommentId, SPD_RID_LCOMMENT_PFILE);
    if (elementId == SPD_NON_ID)
        elementId = spdGetAChildObjId(rcommentId, SPD_RID_LCOMMENT_PBLOCK);
    if (elementId == SPD_NON_ID)
        elementId = spdGetAChildObjId(rcommentId, SPD_RID_LCOMMENT_DECLARATION);
    if (elementId == SPD_NON_ID)
        elementId = spdGetAChildObjId(rcommentId, SPD_RID_LCOMMENT_LABEL);
    if (elementId == SPD_NON_ID)
        elementId = spdGetAChildObjId(rcommentId, SPD_RID_LCOMMENT_EXPRESSION);
    if (elementId == SPD_NON_ID)
        elementId = spdGetAChildObjId(rcommentId, SPD_RID_LCOMMENT_BLOCK);
    
    return elementId;
}

/********************************************************/

/* Ȥʸ(°ȤƻäƤ). */
SpdConstString getLcommentString(SpdObjId lcommentId)
{
    return spdGetAttrStrValByName(lcommentId, "str");
}

/********************************************************/

/* Ȥ¸ߤե */
SpdObjId getLcommentFile(SpdObjId lcommentId)
{
    SpdObjId pcommentId = spdGetAParentObjId(lcommentId, SPD_RID_PCOMMENT_LCOMMENT);
    return spdGetAParentObjId(pcommentId, SPD_RID_PFILE_PCOMMENT);
}

/********************************************************/

/* ȤĹ(ʪȤLength°ñ. °ˤ٤?). */
int getLcommentLength(SpdObjId lcommentId)
{
    SetCursor csr;
    SpdIdSet pcommentIds = spdGetParentObjIdSet(lcommentId, SPD_RID_PCOMMENT_LCOMMENT);
    SpdObjId pcommentId;

    int totalLength = 0;

    for (csr = spdSetCursorCreate(pcommentIds); spdSetCursorNext(&csr);) {
        pcommentId = spdSetGetValueO(csr.curElem->value);
        totalLength += spdGetAttrIntValByName(pcommentId, "length");
    }
    spdFreeSet2(pcommentIds);

    return totalLength;
}

/* Ȥoffset(ʪȤoffsetκǾ). */
int getLcommentOffset(SpdObjId lcommentId)
{
    SetCursor csr;
    SpdIdSet pcommentIds = spdGetParentObjIdSet(lcommentId, SPD_RID_PCOMMENT_LCOMMENT);
    SpdObjId pcommentId;

    int offset = -1;
    int tmpOffset = -1;

    for (csr = spdSetCursorCreate(pcommentIds); spdSetCursorNext(&csr);) {
        pcommentId = spdSetGetValueO(csr.curElem->value);
        tmpOffset = spdGetAttrIntValByName(pcommentId, "offset");
        if (offset > tmpOffset || offset == -1) {
            offset = tmpOffset;
        }
    }
    spdFreeSet2(pcommentIds);

    return offset;
}

/* Ȥ¸ߤʬΰ־ιֹ */
int getLcommentLineNumBegin(SpdObjId lcommentId)
{
    SetCursor csr;
    SpdIdSet pcommentIds = spdGetParentObjIdSet(lcommentId, SPD_RID_PCOMMENT_LCOMMENT);
    SpdObjId pcommentId;

    int lineNumBegin = -1;
    int tmpLineNumBegin = -1;

    for (csr = spdSetCursorCreate(pcommentIds); spdSetCursorNext(&csr);) {
        pcommentId = spdSetGetValueO(csr.curElem->value);
        tmpLineNumBegin = spdGetAttrIntValByName(pcommentId, "line_num_begin");
        if (lineNumBegin > tmpLineNumBegin || lineNumBegin == -1) {
            lineNumBegin = tmpLineNumBegin;
        }
    }
    spdFreeSet2(pcommentIds);

    return lineNumBegin;
}

/* Ȥ¸ߤʬΰֲιֹ */
int getLcommentLineNumEnd(SpdObjId lcommentId)
{
    SetCursor csr;
    SpdIdSet pcommentIds = spdGetParentObjIdSet(lcommentId, SPD_RID_PCOMMENT_LCOMMENT);
    SpdObjId pcommentId;

    int lineNumEnd = -1;
    int tmpLineNumEnd = -1;

    for (csr = spdSetCursorCreate(pcommentIds); spdSetCursorNext(&csr);) {
        pcommentId = spdSetGetValueO(csr.curElem->value);
        tmpLineNumEnd = spdGetAttrIntValByName(pcommentId, "line_num_end");
        if (lineNumEnd < tmpLineNumEnd || lineNumEnd == -1) {
            lineNumEnd = tmpLineNumEnd;
        }
    }
    spdFreeSet2(pcommentIds);

    return lineNumEnd;
}

/* ȤιƬΰ */
/*
 * ȤʪȤϤ٤ƹƬΰ֤·äƤ롤
 * ȤꤷƤ롥
 */
int getLcommentOffsetFromLineHead(SpdObjId lcommentId)
{
    SpdObjId pcommentId = spdGetAParentObjId(lcommentId, SPD_RID_PCOMMENT_LCOMMENT);

    return spdGetAttrIntValByName(pcommentId, "offset_from_linehead");
}

/* Ȥ͡ʰ־Ȥ */
void getLcommentPositionInfos(SpdObjId lcommentId, int *length, int *offset,
                                    int *lineNumBegin, int *lineNumEnd, int *offsetFromLinehead)
{
    SetCursor csr;
    SpdIdSet pcommentIds = spdGetParentObjIdSet(lcommentId, SPD_RID_PCOMMENT_LCOMMENT);
    SpdObjId pcommentId;

    int totalLength = 0;

    int p_offset = -1;
    int tmpOffset = -1;

    int p_lineNumBegin = -1;
    int tmpLineNumBegin = -1;

    int p_lineNumEnd = -1;
    int tmpLineNumEnd = -1;

    for (csr = spdSetCursorCreate(pcommentIds); spdSetCursorNext(&csr);) {
        pcommentId = spdSetGetValueO(csr.curElem->value);

        totalLength += spdGetAttrIntValByName(pcommentId, "length");

        tmpOffset = spdGetAttrIntValByName(pcommentId, "offset");
        if (p_offset > tmpOffset || p_offset == -1) {
            p_offset = tmpOffset;
        }

        tmpLineNumBegin = spdGetAttrIntValByName(pcommentId, "line_num_begin");
        if (p_lineNumBegin > tmpLineNumBegin || p_lineNumBegin == -1) {
            p_lineNumBegin = tmpLineNumBegin;
        }

        tmpLineNumEnd = spdGetAttrIntValByName(pcommentId, "line_num_end");
        if (p_lineNumEnd < tmpLineNumEnd || p_lineNumEnd == -1) {
            p_lineNumEnd = tmpLineNumEnd;
        }
    }

    *length = totalLength;
    
    *offset = p_offset;
    *lineNumBegin = p_lineNumBegin;
    *lineNumEnd = p_lineNumEnd;

    pcommentId = spdGetAParentObjId(lcommentId, SPD_RID_PCOMMENT_LCOMMENT);
    *offsetFromLinehead = spdGetAttrIntValByName(pcommentId, "offset_from_linehead");

    spdFreeSet2(pcommentIds);
}

/********************************************************/

/* ʬl_commentμ */
SpdObjIdArray getLcommentsOnReference(SpdObjId declaratorId)
{
    SpdObjId identifierId = spdGetAChildObjId(declaratorId, SPD_RID_DECL_IDENT);
    SpdIdSet pfileIds = spdGetClassExtentP(SPD_CID_PFILE);/* no need to free */
    SetCursor csr;

    /* expr_expr礭ؤɤä */
    SpdIdSet coveredExpIds = spdCreateSet2(SPDSET_OBJID_KEY,
                                           SPDSET_KEY_IS_VALUE);

    SpdIdSet lcommentIds = spdCreateSet2(SPDSET_OBJID_KEY,
                                           SPDSET_KEY_IS_VALUE);

    SpdObjId *retId;
    SpdObjIdArray retArray;
    int index = 0;

    /* ʬɽexpression */
    if (identifierId != SPD_NON_ID) {
        SpdIdSet expressionIds = spdGetParentObjIdSet(identifierId, 
                                                      SPD_RID_IDENT_REF);

        for (csr = spdSetCursorCreate(expressionIds); spdSetCursorNext(&csr);) {
            SpdObjId expressionId = spdSetGetValueO(csr.curElem->value);
            while (expressionId != SPD_NON_ID) {
                spdAddElemOK(coveredExpIds, expressionId);

                /* 礭ñ̤Ǥexpression */
                expressionId = spdGetAParentObjId(expressionId, 
                                                  SPD_RID_EXPR_EXPR);
            }
        }
        spdFreeSet2(expressionIds);
    }

    /* lcommentν */
    for (csr = spdSetCursorCreate(coveredExpIds); spdSetCursorNext(&csr);) {
        SpdObjId expressionId = spdSetGetValueO(csr.curElem->value);
        SpdObjId lcommentId = spdGetAParentObjId(expressionId,
                                                 SPD_RID_LCOMMENT_EXPRESSION);
        if (lcommentId != SPD_NON_ID) {
            spdAddElemOK(lcommentIds, lcommentId);
        }
    }

    retId = (SpdObjId *) spdMalloc(sizeof(SpdObjId) * lcommentIds->elemNum);

    /* pfileoffsetǤޤȤ */
    for (csr = spdSetCursorCreate(pfileIds); spdSetCursorNext(&csr);) {
        SpdObjId pfileId = spdSetGetValueO(csr.curElem->value);
        SpdIdSet tmpSet = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
        SetCursor csr2;
        
        SpdObjId *array;

        for (csr2 = spdSetCursorCreate(lcommentIds); spdSetCursorNext(&csr);) {
            SpdObjId lcommentId = spdSetGetValueO(csr2.curElem->value);
            if (pfileId == getLcommentFile(lcommentId)) {
                spdAddElemOK(tmpSet, lcommentId);
            }
        }

        if (tmpSet->elemNum != 0) {
            int j;

            /* arrayľ */
            array = (SpdObjId *) spdMalloc(sizeof(SpdObjId) * tmpSet->elemNum);
            j = 0;
            for (csr2 = spdSetCursorCreate(tmpSet); spdSetCursorNext(&csr);) {
                array[j++] = spdSetGetValueO(csr2.curElem->value);
            }
            /* arrayoffsetǥ */
            spdQsortTmp(array, tmpSet->elemNum, sizeof(SpdObjId), compCE);
            
            /* ֤ͤΤͤ */
            for (j = 0; j < tmpSet->elemNum; j++) {
                retId[index] = array[j];
                index++;
            }
            spdFree(array);
        }
        spdFreeSet2(tmpSet);
    }

    retArray.size = lcommentIds->elemNum;
    retArray.id = retId;

    spdFreeSet2(lcommentIds);
    spdFreeSet2(coveredExpIds);

    return retArray;
}
