/* 
 * Program:             $RCSfile: DmodelAR.c,v $  $Revision: 30.11 $
 * 
 * Purpose:
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: DmodelAR.c,v 30.11 2003/07/08 05:46:25 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <sys/stat.h>
#include <Sapid/Sapid.h>
#include <Sapid/DmodelAR.h>

/*
 * Ϣ򤵤ΤܤädocfileIdˤ֤ĤȤdocfile_docfrag롥
 */

SpdRel spdGetDocfileDocfrag(SpdId id)
{
    SpdClassId classId;
    SpdObjId objectId;
    int sort;
    SpdRel rel, docfiledocfrag = {SPD_NON_ID, SPD_NON_ID};
    SpdRel *relp;
    SpdSet2 rels;
    SetCursor csr;

    classId = spdGetClassId(id);
    sort = spdGetClassSort(classId);
    if (sort & SAPIDDB_SORT_REL) {
        objectId = spdGetAttrIntVal(id, SAPIDDB_ATTR_P_ID);
        if (spdGetClassId(objectId) == SPD_CID_DOCFILE){
            docfiledocfrag.objectId = objectId;
            docfiledocfrag.relationId = id;
            return docfiledocfrag;
        }
    }else{
        objectId = id;
    }

    classId = spdGetClassId(objectId);
    if(classId < SPD_FIRST_CID_D_MODEL || classId > SPD_LAST_RID_D_MODEL){
        rel = spdGetSrcelemSrcfrag(objectId);
        if(rel.objectId == SPD_NON_ID){
            return docfiledocfrag;          /*{SPD_NON_ID, SPD_NON_ID};*/
        }else{
            objectId = rel.objectId;
            classId = spdGetClassId(objectId);
        }
    }

    switch(classId){
      case SPD_CID_SOFTWARE:
      case SPD_CID_DOCUMENT:
      case SPD_CID_DOCFILE:
        return docfiledocfrag;              /*{SPD_NON_ID, SPD_NON_ID};*/
    }

    rels = spdGetParentRelSet(objectId, SPD_NON_ID);
    for (csr = spdSetCursorCreate(rels); spdSetCursorNext(&csr);) {
        relp = spdSetGetValueP(csr.curElem->value);
        if (spdGetClassSort(spdGetClassId(relp->relationId))
            & (SAPIDDB_SORT_REL_COMPOSITE ^ SAPIDDB_SORT_REL)) {
            docfiledocfrag = spdGetDocfileDocfrag(relp->relationId);
        }
    }
    spdFreeSet2(rels);

    return docfiledocfrag;
}

/*
 * id򤵤ΤܤädocfragIdˤ֤ĤȤsrcelem_srcfrag롥
 */

SpdRel spdGetSrcelemSrcfrag(SpdId id)
{
    SpdClassId classId;
    SpdObjId objectId;
    int sort;
    SpdRel *relp, srcelemsrcfrag = {SPD_NON_ID, SPD_NON_ID};
    SpdSet2 rels;
    SetCursor csr;

    classId = spdGetClassId(id);
    sort = spdGetClassSort(classId);
    if (sort & SAPIDDB_SORT_REL) {
        objectId = spdGetAttrIntVal(id, SAPIDDB_ATTR_P_ID);
        if (classId == SPD_RID_SRCELEM_SRCFRAG){
            srcelemsrcfrag.objectId = objectId;
            srcelemsrcfrag.relationId = id;
            return srcelemsrcfrag;
        }
    }else{
        objectId = id;
    }

    classId = spdGetClassId(objectId);
    /* λD-modelΥ֥ȤädocfragǤϤʤ */
    if(classId >= SPD_FIRST_CID_D_MODEL && classId <= SPD_LAST_RID_D_MODEL)
        return srcelemsrcfrag;              /*{SPD_NON_ID, SPD_NON_ID};*/

    switch(classId){
      case SPD_CID_PROGRAM:
      case SPD_CID_FILE:
        return srcelemsrcfrag;              /*{SPD_NON_ID, SPD_NON_ID};*/
    }

    rels = spdGetParentRelSet(objectId, SPD_NON_ID);
    for (csr = spdSetCursorCreate(rels); spdSetCursorNext(&csr);) {
        relp = spdSetGetValueP(csr.curElem->value);
        if (spdGetClassSort(spdGetClassId(relp->relationId))
            & (SAPIDDB_SORT_REL_COMPOSITE ^ SAPIDDB_SORT_REL)) {
            srcelemsrcfrag = spdGetSrcelemSrcfrag(relp->relationId);
        }
    }
    spdFreeSet2(rels);

    return srcelemsrcfrag;
}
