/* 
 * Program:             $RCSfile: ImodelAR.c,v $  $Revision: 30.30 $
 * 
 * Purpose:             桼롼
 *                      I-model¸δؿ
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: ImodelAR.c,v 30.30 2003/07/08 06:19:45 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <sys/stat.h>
#include <Sapid/Sapid.h>
#include <Sapid/ImodelAR.h>

/* 
 * 륪֥Ȥ⤷ϴϢ(SpdObjId/SpdRelIdɤǤǽ)̤ä
 *  file_decl Ƽ(filefile_declSpdRelν֤)
 * idfileprogramμֹξ϶֤
 */

static SpdSet2 spdGetFileDeclSet(SpdId id)
{
    SpdIdSet res;
    SpdObjId objectId;
    SpdRel *relp, *filedecl;
    SpdSet2 rels;
    SpdSet2 filedecls;
    SetCursor csr;
    SpdClassId classId;
    int sort;

    res = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_POINTER_VALUE);
    res->valueFree = spdElemFreeSpdRel;
    res->valueCopy = spdElemCopySpdRel;

    classId = spdGetClassId(id);
    sort = spdGetClassSort(classId);

    if (sort & SAPIDDB_SORT_REL) {
        objectId = spdGetAttrIntVal(id, SAPIDDB_ATTR_P_ID);
    
        if (spdGetClassId(objectId) == SPD_CID_FILE) {
            filedecl = (SpdRel *)spdMalloc(sizeof(SpdRel));
            filedecl->objectId = objectId;
            filedecl->relationId = id;
            spdAddElemOP(res, filedecl->relationId, filedecl);
            return res;
        }
    } else {
        objectId = id;
        if (classId == SPD_CID_FILE || classId == SPD_CID_PROGRAM) {
            return res;
        }
    }

    rels = spdGetParentRelSet(objectId, SPD_NON_ID);
    for (csr = spdSetCursorCreate(rels); spdSetCursorNext(&csr);) {
    relp = spdSetGetValueP(csr.curElem->value);
        if (spdGetClassSort(spdGetClassId(relp->relationId))
            & (SAPIDDB_SORT_REL_COMPOSITE ^ SAPIDDB_SORT_REL)) {
            filedecls = spdGetFileDeclSet(relp->relationId);
            res = spdAddSet2(res, filedecls);
            spdFreeSet2(filedecls);
        }
    }
    spdFreeSet2(rels);

    return res;
}

/* 
 * relation򤵤ΤܤäfileIdˤ֤ĤȤfile_decl롥
 * fileIdSPD_NON_IDꤹȡȤˤǽ˸ĤäΤ֤
 */

SpdRel spdGetFileDeclOfFile(SpdRelId relationId, SpdObjId fileId)
{
    SpdSet2 filedecls;
    SpdRel filedecl = SPD_NON_REL;
    SetCursor csr;
    
    filedecls = spdGetFileDeclSet(relationId);
    for (csr = spdSetCursorCreate(filedecls); spdSetCursorNext(&csr);) {
    filedecl = *(SpdRel *)spdSetGetValueP(csr.curElem->value);
        if (fileId == SPD_NON_ID || 
            spdGetAttrIntVal(filedecl.relationId, SAPIDDB_ATTR_P_ID) == fileId)
            break;
    }
    spdFreeSet2(filedecls);

    return filedecl;
}

/* 
 * !! relative offsetꤷƤ롥
 * Ʊfile̾󤻤ˤбʤ
 */

int spdGetAbsoluteOffset(SpdRelId relationId, SpdObjId fileId)
{
    SpdRel filedecl;

    if (spdGetClassId(relationId) == SPD_RID_FILE_DECL) {
        return spdGetOffset(relationId);
    }
    filedecl = spdGetFileDeclOfFile(relationId, fileId);
    return spdGetOffset(filedecl.relationId) + spdGetOffset(relationId);
}

int spdGetRelativeOffset(SpdRelId relationId)
{
    return spdGetOffset(relationId);
}

/* Ѵؿ */

/* 
 * SpdRelνSpdOccνѴ롥
 * 
 * SpdRelΤrelationIdƤʤҤobjectIdȤoffset
 * 롥parentIdˤʬڤκˤʤäƤ륪֥Ȥꤹ롥
 */

SpdSet2 spdConvRelSetToOccSet(SpdSet2 rels, SpdObjId parentId)
{
    SpdSet2 occs;
    SpdOcc *occ;
    SpdRel *relp;
    SpdSet2 filedecls = NULL;
    SetCursor   csr1, csr2;
    int key = 0;
    SpdClassId pClassId = SPD_NON_ID;

    if (parentId != SPD_NON_ID) {
        pClassId = spdGetClassId(parentId);
        /* parentId  file ʳξϡΥ֥Ȥο
           file_decl õ filedecls ¸ */
        if (pClassId != SPD_CID_FILE && 
            pClassId != SPD_CID_DECLARATION) {
            filedecls = spdGetFileDeclSet(parentId);
        }
    }

    occs = spdCreateSet2(SPDSET_INT_KEY, SPDSET_POINTER_VALUE);
    occs->valueFree = spdElemFreeSpdOcc;
    occs->valueCopy = spdElemCopySpdOcc;
    for (csr1 = spdSetCursorCreate(rels); spdSetCursorNext(&csr1);) {
        SpdObjId objid;
        relp = spdSetGetValueP(csr1.curElem->value);
        objid = spdGetAttrIntVal(relp->relationId, SAPIDDB_ATTR_C_ID);
        if (parentId != SPD_NON_ID && pClassId == SPD_CID_FILE) {
            /* parentId  fileId ä */
            occ = (SpdOcc *)spdMalloc(sizeof(SpdOcc));
            occ->objectId = objid;
            occ->relationId = relp->relationId;
            occ->fileId = parentId;
            occ->offset = spdGetAbsoluteOffset(occ->relationId, parentId);
            spdAddElemIP(occs, key++, occ);
        } else {
            if (parentId == SPD_NON_ID || pClassId == SPD_CID_DECLARATION) {
                /* parentId  ꤵƤʤä */
                filedecls = spdGetFileDeclSet(relp->relationId);
            }
            /* filedecls  offset ׻ */
            for (csr2 = spdSetCursorCreate(filedecls); 
                 spdSetCursorNext(&csr2);) {
                SpdObjId fileId =
                    ((SpdRel *)spdSetGetValueP(csr2.curElem->value))->objectId;
                int offset = spdGetAbsoluteOffset(relp->relationId, fileId);

                if (offset > 0) {
                    occ = (SpdOcc *)spdMalloc(sizeof(SpdOcc));
                    occ->objectId = objid;
                    occ->relationId = relp->relationId;
                    occ->fileId = fileId;
                    occ->offset = offset;
                    spdAddElemIP(occs, key++, occ);
                }
            }
            if (parentId == SPD_NON_ID || pClassId == SPD_CID_DECLARATION) {
                spdFreeSet2(filedecls);
                filedecls = NULL;
            }
        }
    }
    if (filedecls) {
        spdFreeSet2(filedecls);
    }
    
    return occs;
}

SpdSet2 spdConvOccSetToRelSet(SpdSet2 occs)
{
    SpdSet2 rels;
    SpdOcc *occp;
    SpdRel *relp;
    SetCursor csr;

    rels = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_POINTER_VALUE);
    rels->valueFree = spdElemFreeSpdRel;
    rels->valueCopy = spdElemCopySpdRel;

    if (occs) {
        for (csr = spdSetCursorCreate(occs); spdSetCursorNext(&csr);) {
            occp = spdSetGetValueP(csr.curElem->value);
            relp = (SpdRel *)spdMalloc(sizeof(SpdRel));
            relp->objectId = occp->objectId;
            relp->relationId = occp->relationId;
            spdAddElemOP(rels, relp->relationId, relp);
        }
    }

    return rels;
}

SpdSet2 spdGetOffsetOfObjSet(SpdObjId objectId, SpdObjId fileId)
{
    SpdSet2  res, rels;
    SpdOcc  *occp;
    SpdRel  *relp;
    SetCursor csr;

    /* file֥Ȥξoffset = 0֤ */
    if (spdGetClassId(objectId) == SPD_CID_FILE) {
        res = spdCreateSet2(SPDSET_INT_KEY, SPDSET_POINTER_VALUE);
        res->valueFree = spdElemFreeSpdOcc;
        res->valueCopy = spdElemCopySpdOcc;
        occp = (SpdOcc *)spdMalloc(sizeof(SpdOcc));
        occp->fileId = objectId;
        occp->offset = 0;
        occp->relationId = SPD_NON_ID;
        occp->objectId = objectId;
        spdAddElemIP(res, 0, occp);
        return res;
    }

    /* ƤδϢ롥 */
    rels = spdGetParentRelSet(objectId, SPD_NON_ID);
    for (csr = spdSetCursorCreate(rels); spdSetCursorNext(&csr);) {
        relp = spdSetGetValueP(csr.curElem->value);
        if (!(spdGetClassSort(spdGetClassId(relp->relationId)) &
              (SAPIDDB_SORT_REL_COMPOSITE ^ SAPIDDB_SORT_REL))) {
            spdDelElemO(rels, relp->relationId);
        }
    }
    if (fileId == SPD_NON_ID || fileId == SPD_ANY_FILE_ID) {
        res = spdConvRelSetToOccSet(rels, objectId);
    } else {
        res = spdConvRelSetToOccSet(rels, fileId);
    }

    spdFreeSet2(rels);
    return res;
}

SpdSet2 spdGetIncludedOccSet(SpdObjId objectId,
                            SpdConstString objectType, SpdObjId fileId)
{
    SpdSet2 res, relset;

    /* spdSearchChildObj ȤäƼ */
    relset = spdSearchChildObj(objectId, spdGetClassIdByName(objectType));

    /* SpdRel ν SpdOcc νѴ */
    res = spdConvRelSetToOccSet(relset, fileId);

    spdFreeSet2(relset);
    return res;
}

SpdConstString spdGetObjText(SpdObjId objectId)
{
    SpdConstString  name;
    SpdClassId      classId = spdGetClassId(objectId);
    
    if (classId == SPD_CID_CONSTANT) {
        return (spdGetAttrValString(objectId, "value"));
    } else if ((name = spdGetName(objectId)) != NULL) {
        return (name);
    } else if ((spdGetClassSort(classId) & SAPIDDB_SORT_OBJ_TEXT) ==
               SAPIDDB_SORT_OBJ_TEXT || classId == SPD_CID_FILE) {
        SpdObjId        fileId;
        int             offset, length;
        SpdSet2         occs;
        SpdOcc          *occp = NULL;
        SetCursor       csr;
        FILE            *fp;
        static char     *buf = NULL;

        if (classId == SPD_CID_FILE) {
            fileId = objectId;
            offset = 0;
            length = spdGetFileLength(fileId);
        } else {
            occs = spdGetOffsetOfObjSet(objectId, SPD_NON_ID);
            /* fileId  offset ĤΤõ */
            for (csr = spdSetCursorCreate(occs); spdSetCursorNext(&csr);) {
                occp = spdSetGetValueP(csr.curElem->value);
                if (occp->fileId != SPD_NON_ID && occp->offset != SPD_NON_OFFSET)
                    break;
            }
            if (csr.curElem == NULL) {  /* դʤä */
                spdFreeSet2(occs);
                return NULL;
            }
            spdFreeSet2(occs);
            fileId = occp->fileId;
            offset = occp->offset;
            length = spdGetLength(objectId);
        }
        buf = spdRealloc(buf, length + 1);
        fp = smuOpenSrcFile(fileId);
        SPD_FSEEK(fp, offset, SEEK_SET);
        spdFreadChar(buf, length, fp);
        spdFclose(fp);
        return buf;
    } else {
        return NULL;
    }
}

int spdGetLengthOfObj(SpdObjId objectId)
{
    SpdConstString      str;

    str = spdGetObjText(objectId);
    /*
     * if (str) {
     *     return strlen(str);
     * } else {
     *     return SPD_NON_LENGTH;
     * }
     */
    return ((str != NULL) ? (int)strlen(str) : SPD_NON_LENGTH);
}
