/* 
 * Program:             $RCSfile: ImodelARcompat.c,v $  $Revision: 30.12 $
 * 
 * Purpose:             桼롼(AR4ߴؿ)
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: ImodelARcompat.c,v 30.12 2003/07/06 10:09:08 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/ImodelAR.h>
#include <Sapid/ImodelARcompat.h>

static SpdOcc       spdNonOcc = SPD_NON_OCC;
static SpdModelId   spdImodelId = SPD_NON_ID;
static SpdDBId      spdIDBId = SPD_NON_ID;

SpdObjId spdGetFileId(SpdRelId relationId)
{
    return spdGetFileDeclOfFile(relationId, SPD_NON_ID).objectId;
}

#if defined(COMPATIBLE_AR4)

SpdCursor *spdGetOffsetOfObjInit(SpdObjId objectId)
{
    return spddb_CreateCursor(spdGetOffsetOfObjSet(objectId, SPD_NON_ID));
}

#else /* !defined(COMPATIBLE_AR4) */

SpdCursor *spdGetOffsetOfObjInit(SpdObjId objectId, SpdObjId fileId)
{
    return spddb_CreateCursor(spdGetOffsetOfObjSet(objectId, fileId));
}

#endif /* !defined(COMPATIBLE_AR4) */

SpdOcc spdGetOffsetOfObj(SpdCursor *csr)
{
    SpdElem    *res;

    res = spddb_IterCursor(csr);
    return (res == NULL ? spdNonOcc : *(SpdOcc *)spdSetGetValueP(res->value));
}

/*
 * Added by S.Yamamoto 2001/06/19.
 */

SpdOcc spdGetAnOffsetOfObj(SpdObjId objectId)
{
    SpdCursor   *csr;
    SpdOcc      occ;

    if ((csr = spdGetOffsetOfObjInit(objectId)) == NULL) {
        return (spdNonOcc);
    }
    occ = spdGetOffsetOfObj(csr);
    spdFreeCursor(csr);

    return (occ.objectId == SPD_NON_ID ? spdNonOcc : occ);
}

SpdCursor *spdGetIncludedOccInit(SpdObjId objectId, SpdConstString objectType,
                                 SpdObjId fileId)
{
    return spddb_CreateCursor(spdGetIncludedOccSet(objectId, objectType,
                                                   fileId));
}

SpdOcc spdGetIncludedOcc(SpdCursor *csr)
{
    SpdElem        *res;

    res = spddb_IterCursor(csr);
    return (res == NULL ? spdNonOcc : *(SpdOcc *)spdSetGetValueP(res->value));
}

int spdWriteAllImodelClass(SpdConstString dirName)
{
    SpdConstString oldSDBdir;

    oldSDBdir = spdStrdup(spdGetSDBdir());
    spdSetSDBdir(dirName);
    
    spdCommitDB(spdImodelId, spdIDBId);

    spdSetSDBdir(oldSDBdir);
    spdFree(oldSDBdir);

    return 0;
}

int spdWriteAllClass(SpdConstString dirName)
{
    spdWriteAllImodelClass(dirName);

    return 0;
}

/******************************************************************************/

/* SMUΤɬס */

SpdCursor *spdGetObjIdOfModelInit(SpdString className, SpdString name,
                                  SpdString model)
{
    return spdGetObjIdInit(className, name);
}

int spdGetObjIdOfModel(SpdCursor *csr)
{
    return spdGetObjId(csr);
}

int spdGetAnObjIdOfModel(SpdString className, SpdString name, SpdString model)
{
    return spdGetAnObjId(className, name);
}
