/* 
 * Program:             $RCSfile: Pmodel.h,v $  $Revision: 30.15 $
 * 
 * Purpose:             Class definition of P-model.
 * 
 * Author:              T.Hidaka  1998/10/13
 * Modified:            S.Yamamoto  2000/05/01
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: Pmodel.h,v 30.15 2003/02/20 15:12:41 yamamoto Exp yamamoto $
 */ 

#if !defined(_SAPID_P_MODEL_H)
#define _SAPID_P_MODEL_H

/* Class id. */

#define SPD_CID_PFILE               (SPD_FIRST_CID_P_MODEL + 0)
#define SPD_CID_PBLOCK              (SPD_FIRST_CID_P_MODEL + 1)
#define SPD_CID_MACROPATTERN        (SPD_FIRST_CID_P_MODEL + 2)
#define SPD_CID_MACROBODY           (SPD_FIRST_CID_P_MODEL + 3)
#define SPD_CID_MACRONAME           (SPD_FIRST_CID_P_MODEL + 4)
#define SPD_CID_MACROOPTIONAL       (SPD_FIRST_CID_P_MODEL + 5)
#define SPD_CID_MACRODECLARG        (SPD_FIRST_CID_P_MODEL + 6)
#define SPD_CID_MACROCALL           (SPD_FIRST_CID_P_MODEL + 7)
#define SPD_CID_MACROCALLARG        (SPD_FIRST_CID_P_MODEL + 8)
#define SPD_CID_HFILE               (SPD_FIRST_CID_P_MODEL + 9)
#define SPD_CID_IBLOCK              (SPD_FIRST_CID_P_MODEL + 10)

#if (SPD_CID_IBLOCK != SPD_LAST_CID_P_MODEL)
    "Invalid configuration."
#endif

#define SPD_CID_NUM_P_MODEL \
        (SPD_LAST_CID_P_MODEL - SPD_FIRST_CID_P_MODEL + 1)

/* Relation id. */

#define SPD_RID_FILE_BLOCK          (SPD_FIRST_RID_P_MODEL + 0)
#define SPD_RID_CALL_MCALL          (SPD_FIRST_RID_P_MODEL + 1)
#define SPD_RID_MBODY_MCALL         (SPD_FIRST_RID_P_MODEL + 2)
#define SPD_RID_MCALL_MNAME         (SPD_FIRST_RID_P_MODEL + 3)
#define SPD_RID_MCALL_MCALLA        (SPD_FIRST_RID_P_MODEL + 4)
#define SPD_RID_DEF_MPATT           (SPD_FIRST_RID_P_MODEL + 5)
#define SPD_RID_DEF_MBODY           (SPD_FIRST_RID_P_MODEL + 6)
#define SPD_RID_MPATT_MNAME         (SPD_FIRST_RID_P_MODEL + 7)
#define SPD_RID_MPATT_MOPT          (SPD_FIRST_RID_P_MODEL + 8)
#define SPD_RID_MOPT_MDECLA         (SPD_FIRST_RID_P_MODEL + 9)
#define SPD_RID_MBODY_MDECLA        (SPD_FIRST_RID_P_MODEL + 10)
#define SPD_RID_INCLD_HFILE         (SPD_FIRST_RID_P_MODEL + 11)
#define SPD_RID_HFILE_FILE          (SPD_FIRST_RID_P_MODEL + 12)
#define SPD_RID_MCALLA_MCALL        (SPD_FIRST_RID_P_MODEL + 13)
#define SPD_RID_CFILE_IFILE         (SPD_FIRST_RID_P_MODEL + 14)
#define SPD_RID_IFILE_IBLOCK        (SPD_FIRST_RID_P_MODEL + 15)
#define SPD_RID_PBLOCK_IBLOCK       (SPD_FIRST_RID_P_MODEL + 16)

#if (SPD_RID_PBLOCK_IBLOCK != SPD_LAST_RID_P_MODEL)
    "Invalid configuration."
#endif

#define SPD_RID_NUM_P_MODEL \
            (SPD_LAST_RID_P_MODEL - SPD_FIRST_RID_P_MODEL + 1)

/* Number of all classes and relations. */

#define SPD_CRID_NUM_P_MODEL \
        (SPD_CID_NUM_P_MODEL + SPD_RID_NUM_P_MODEL)

/******************************************************************************/

#define PBLOCK_COMMENT          1
#define PBLOCK_MACROCALL        2
#define PBLOCK_NORMAL           3
#define PBLOCK_DIRECTIVE        4

#define PBLOCK_DEFINE_FILE      10
#define PBLOCK_DEFINE_OPTION    11
#define PBLOCK_DEFINE_INIT      12
#define PBLOCK_UNDEF            13
#define PBLOCK_INCLUDE          14
#define PBLOCK_IF               15
#define PBLOCK_ELSE             16
#define PBLOCK_ELIF             17
#define PBLOCK_ENDIF            18
#define PBLOCK_IFDEF            19
#define PBLOCK_IFNDEF           20
#define PBLOCK_PRAGMA           21
#define PBLOCK_LINE             22
#define PBLOCK_ERROR            23

#define HFILE_ANGLE             0
#define HFILE_DQUOT             1

/******************************************************************************/

#define SPD_P_MODEL_VERSION         1

extern SpdDBModel P_model;

#endif /* !defined(_SAPID_P_MODEL_H) */
