/* 
 * Program:             $RCSfile: PmodelAR.h,v $  $Revision: 30.7 $
 * 
 * Purpose:             P-model access functions.
 * 
 * Author:              T.Hidaka  1998/11/13
 * Modified:            S.Yamamoto  2000/05/01
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2000
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: PmodelAR.h,v 30.7 2003/07/08 07:46:18 yamamoto Exp yamamoto $
 */ 

#if !defined(_SPD_P_MODEL_AR_H)
#define _SPD_P_MODEL_AR_H

#if defined(SAPID_AR5)

void spdFreePmodelRegIndex(SpdObjId fileId);
SpdRegionIndex *spdGetPmodelRegIndex(SpdObjId fileId);

SpdObjId spdGetABlockId(SpdObjId fileId, int offset);
SpdRegion spdConvOccToRegion(SpdOcc occ);
SpdOcc spdConvRegionToOcc(SpdRegion region);
SpdObjId spdGetCfileIdByPfileId(SpdObjId pfileId);
SpdRegion spdConvRegionItoCbyPIDB(SpdRegion regionI);
SpdRegion spdConvRegionItoC(SpdRegion regionI);
SpdRegion spdConvRegionCtoI(SpdRegion regionC);
char *spdGetTextByRegion(SpdRegion region);
SpdBoolean spdIsInHeaderFile(SpdObjId fileId, int offset);
SpdObjId spdGetPfileIdIncludingIoffset(SpdObjId fileId, int offset);
SpdObjIdArray spdGetBlockIdArrayOfRegion(SpdRegion region, int sort);
SpdObjIdArray spdGetBlockIdArrayIncludingRegion(SpdRegion region);
SpdObjIdArray spdGetBlockIdArrayOfMcall(SpdRegion region);

#endif /* defined(SAPID_AR5) */

#endif /* !defined(_SPD_P_MODEL_AR_H) */
