/* 
 * Program:             $RCSfile: SDAmodel.h,v $  $Revision: 31.11 $
 * 
 * Purpose:
 *
 * Author:              T.Suzuki  1998/10/22
 *                      S.Yamamoto  1997/10/22
 *
 * (C) Copyright:       T.Suzuki and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SDAmodel.h,v 31.11 2003/02/20 15:12:47 yamamoto Exp yamamoto $
 */ 

#ifndef _SPD_SDA_MODEL_H
#define _SPD_SDA_MODEL_H

/*
 * Note:
 * SDA_MODEL_V2 means below.
 * [decl (func)] -<>- [sdafunc] -<frst_stmt>- [stmt]
 */

/* Class id. */

#define SPD_CID_SDAFUNC             (SPD_FIRST_CID_SDA_MODEL + 0)
#define SPD_CID_VARG                (SPD_FIRST_CID_SDA_MODEL + 1)

#if (SPD_CID_VARG != SPD_LAST_CID_SDA_MODEL)
    "Invalid configuration."
#endif

#define SPD_CID_NUM_SDA_MODEL \
        (SPD_LAST_CID_SDA_MODEL - SPD_FIRST_CID_SDA_MODEL + 1)

/* Relation id. */

#define SPD_RID_NEXT_STMT           (SPD_FIRST_RID_SDA_MODEL + 0)
#define SPD_RID_DATA_DEPEND         (SPD_FIRST_RID_SDA_MODEL + 1)
#define SPD_RID_FUNC_SFUNC          (SPD_FIRST_RID_SDA_MODEL + 2)
#define SPD_RID_SFUNC_VARG          (SPD_FIRST_RID_SDA_MODEL + 3)
#define SPD_RID_SFUNC_STMT          (SPD_FIRST_RID_SDA_MODEL + 4)
#define SPD_RID_IDENT_VARG          (SPD_FIRST_RID_SDA_MODEL + 5)

#if (SPD_RID_IDENT_VARG != SPD_LAST_RID_SDA_MODEL)
    "Invalid configuration."
#endif

#define SPD_RID_NUM_SDA_MODEL \
        (SPD_LAST_RID_SDA_MODEL - SPD_FIRST_RID_SDA_MODEL + 1)

/* Number of all classes and relations. */

#define SPD_CRID_NUM_SDA_MODEL \
        (SPD_CID_NUM_SDA_MODEL + SPD_RID_NUM_SDA_MODEL)

/******************************************************************************/

/* Attribute value of class "varg". */

#define VARG_IN          0
#define VARG_OUT         1

/* Attribute value of relationship "next_stmt". */

#define NEXTSTMT_NORMAL   0
/* #define NEXTSTMT_START    1 */
#define NEXTSTMT_CONTROL  2
#define NEXTSTMT_LOOPBACK 3
#define NEXTSTMT_DECL     4
#define NEXTSTMT_END      5

/******************************************************************************/

#define SPD_SDA_MODEL_VERSION       1

extern SpdDBModel SDA_model;

#endif /* _SPD_SDA_MODEL_H */
