/* 
 * Program:             $RCSfile: sdaarea.c,v $  $Revision: 31.5 $
 * 
 * Purpose:
 *
 * Author:              T.Suzuki  1998/10/22
 *                      S.Yamamoto  1997/10/22
 *
 * (C) Copyright:       T.Suzuki and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: sdaarea.c,v 31.5 2003/04/07 16:02:54 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

#if defined(SAPID_AR5)

static SpdValName sdaarea_sort[] = {
    { SPD_VAL_NAME3(SAREA_NORMAL, "normal") },
    { SPD_VAL_NAME3(SAREA_STRUCT, "struct") },
    { SPD_VAL_NAME3(SAREA_POINTER, "pointer") },
    { SPD_VAL_NAME3(SAREA_ARRAY, "array") },        /* Necessary? */
    { SPD_VAL_NAME3(SAREA_FUNC, "func") },          /* Necessary? */
    { 0, NULL, NULL }
};

static SpdDBClass SDAarea_model_classes[] = {
    /* Classes. */
    {
        "sArea",
        SPD_CID_SAREA,
        SAPIDDB_SORT_OBJ,
        { SAPIDDB_ATTR_ID, 0, SAPIDDB_ATTR_NONE },
        {
            {"sort", SPD_DBT_ENUM, sdaarea_sort},
            { NULL, SPD_DBT_NON },
        }
    },

    /* Relationships. */
    {
        "ident_area",
        SPD_RID_IDENT_SAREA,
        SAPIDDB_SORT_REL_REFERENCE,
        { 0, 1, SAPIDDB_ATTR_NONE },
        {
            {"ident_id", SPD_DBT_OID, NULL, SPD_CID_IDENTIFIER}, 
            {"area_id",  SPD_DBT_OID, NULL, SPD_CID_SAREA},
            { NULL, SPD_DBT_NON },
        }
    },
    {
        "consist_of",
        SPD_RID_CONSIST_OF,
        SAPIDDB_SORT_REL_REFERENCE,
        { 0, 1, SAPIDDB_ATTR_NONE },
        {
            {"p_area_id", SPD_DBT_OID, NULL, SPD_CID_SAREA}, 
            {"c_area_id", SPD_DBT_OID, NULL, SPD_CID_SAREA},
            { NULL, SPD_DBT_NON },
        }
    },
    {
        "sarea_sarea",
        SPD_RID_SAREA_SAREA,
        SAPIDDB_SORT_REL_REFERENCE,
        { 0, 1, SAPIDDB_ATTR_NONE },
        {
            {"p_area_id", SPD_DBT_OID, NULL, SPD_CID_SAREA}, 
            {"c_area_id", SPD_DBT_OID, NULL, SPD_CID_SAREA},
            { NULL, SPD_DBT_NON },
        }
    },
    /* 
     * {
     *     "alias_to",
     *     SPD_RID_ALIAS_TO,
     *     SAPIDDB_SORT_REL_REFERENCE,
     *     { 0, 1, SAPIDDB_ATTR_NONE },
     *     {
     *         {"p_area_id", SPD_DBT_OID, NULL, SPD_CID_SAREA}, 
     *         {"c_area_id", SPD_DBT_OID, NULL, SPD_CID_SAREA},
     *         { NULL, SPD_DBT_NON },
     *     }
     * },
     * {
     *     "expr_sarea",
     *     SPD_RID_EXPR_SAREA,
     *     SAPIDDB_SORT_REL_REFERENCE,
     *     { 0, 1, SAPIDDB_ATTR_NONE },
     *     {
     *         {"expr", SPD_DBT_OID, NULL, SPD_CID_EXPRESSION},
     *         {"area_id", SPD_DBT_OID, NULL, SPD_CID_SAREA},
     *         { NULL, SPD_DBT_NON },
     *     }
     * },
     */
    {
        NULL, SPD_NON_ID, 0, {SAPIDDB_ATTR_NONE}
    }

};

#endif /* defined(SAPID_AR5) */

/******************************************************************************/

SpdDBModel SDAarea_model = {
    SPD_MID_SDA_AREA_MODEL,
    "SDAarea-model",
    SPD_SDA_AREA_MODEL_VERSION,
    SPD_SDA_AREA_MODEL_DIR,

    SPD_FIRST_CID_SA_MODEL,
    SPD_LAST_CID_SA_MODEL,
    SPD_CID_NUM_SA_MODEL,

    SPD_FIRST_RID_SA_MODEL,
    SPD_LAST_RID_SA_MODEL,
    SPD_RID_NUM_SA_MODEL,

    SPD_CRID_NUM_SA_MODEL,

#if defined(SAPID_AR5)

    SDAarea_model_classes,
    NULL,

#endif /* defined(SAPID_AR5) */
};
