/* 
 * Program:             $RCSfile: sdaareaAR.c,v $  $Revision: 31.8 $
 * 
 * Purpose:
 *
 * Author:              T.Suzuki  1998/10/22
 *                      S.Yamamoto  1997/10/22
 *
 * (C) Copyright:       T.Suzuki and S.Yamamoto  1998 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: sdaareaAR.c,v 31.8 2003/07/08 05:46:30 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

extern int verbose_flag;

/* 
 * ѿбArea뤹롥
 * 
 * :
 * int **a;(a[o]-->*a[o]-->**a[_]) Ф
 * 
 * a:[identifier] --ident_sarea--> [pointer] --sarea_sarea-->
 *                                 [pointer] --sarea_sarea--> [normal]
 * 롥
 */

static SpdObjId create_area(SpdObjId tobj, int inner_pointer_flag)
{
    int      sort;
    SpdSet2   sets;
    SetCursor csr;
    SpdObjId type_id, area1 = SPD_NON_ID, area2;

    sort = spdGetAttrIntValByName(tobj, "sort");

    switch (sort) {

      default:
        spdWarning("Unexpected @(%d)!\n", tobj);
        break;

      case TYPE_TYPE_DEF:
        /* ι¤Ĵ٤ */
        type_id = spdGetAChildObjId(
                                    spdGetAChildObjId(tobj, SPD_RID_TYPE_IS),
                                    SPD_RID_IDENT_TYPE);
        return create_area(type_id, inner_pointer_flag);

      case TYPE_ARRAY:
        area1 = spdCreateObj(SPD_CID_SAREA, SPD_NON_ID);
        spdSetAttrIntValByName(area1, "sort", SAREA_NORMAL);
        type_id = spdGetAChildObjId(tobj, SPD_RID_TYPE_ST);

        /*  area2 = create_area(type_id, inner_pointer_flag);*/
        spdSetAttrIntValByName(area1, "sort", SAREA_NORMAL);
        return area1;

      case TYPE_ENUM_SPECIFIER:
      case TYPE_DECLARATION:                /* ܷ */
        area1 = spdCreateObj(SPD_CID_SAREA, SPD_NON_ID);
        spdSetAttrIntValByName(area1, "sort", SAREA_NORMAL);
        return area1;

      case TYPE_STRUCT_TAG:                 /* ¤ */ /* typeview-model */

      case TYPE_UNION_TAG:
        area1 = spdCreateObj(SPD_CID_SAREA, SPD_NON_ID);
        spdSetAttrIntValByName(area1, "sort", SAREA_STRUCT);

        if (inner_pointer_flag < 2) {
            sets = spdGetChildObjIdSet(tobj, SPD_RID_STRUCT_MEMBER);
            for (csr = spdSetCursorCreate(sets); spdSetCursorNext(&csr);) {
                /* ¤ΥAreaȤδϢ */
                SpdObjId mem_id, m_ident, type_id;

                mem_id = spdSetGetValueO(csr.curElem->value);
                type_id =spdGetAChildObjId(mem_id, SPD_RID_MEMBER_TYPE);
                m_ident =spdGetAChildObjId(mem_id, SPD_RID_MEMBER_NAME);
        
                area2 = create_area(type_id, inner_pointer_flag);
                spdCreateRel(SPD_RID_CONSIST_OF, SPD_NON_ID, area1, area2);
                if (verbose_flag) {
                    printf("Area: id:%d area:%d\n", m_ident, area2);
                }
                spdCreateRel(SPD_RID_IDENT_SAREA, SPD_NON_ID, m_ident, area2);
            }
            spdFreeSet2(sets);
        }
        return area1;

      case TYPE_POINTER:                    /* ݥ */
        area1 = spdCreateObj(SPD_CID_SAREA, SPD_NON_ID);
        spdSetAttrIntValByName(area1, "sort", SAREA_POINTER);
        type_id = spdGetAChildObjId(tobj, SPD_RID_TYPE_ST);
    
        area2 = create_area(type_id, inner_pointer_flag+1);
        spdCreateRel(SPD_RID_SAREA_SAREA, SPD_NON_ID, area1, area2);
        return area1;
    
      case TYPE_FUNC:                       /* Ȥʤפʵ⤹ */
        area1 = spdCreateObj(SPD_CID_SAREA, SPD_NON_ID);
        spdSetAttrIntValByName(area1, "sort", SAREA_FUNC);
        return area1;
    }

    return area1;
}

/*
 * declaratorФ area
 */

SpdObjId sdaCreateArea(SpdObjId decr)
{
    SpdObjId tobj, area, id;

    tobj = spdGetAChildObjId(decr, SPD_RID_DECR_TYPE);
    id   = spdGetAChildObjId(decr, SPD_RID_DECL_IDENT);

    if (id != SPD_NON_ID) {
    
        area = create_area(tobj, 0);

        if (verbose_flag) {
            printf("Area: id:%d area:%d\n", id, area);
        }
        spdCreateRel(SPD_RID_IDENT_SAREA, SPD_NON_ID, id, area);
    }
    
    return tobj;
}

/*
 * block-stmt˴ޤޤdeclaratorФarea
 */

void sdaCreateArea_Block(SpdObjId blk_stmt)
{
    SpdSet2 decrs;
    SpdObjId decr;
    SetCursor csr;

    /* blockdecrident */
    decrs = spdGetChildObjIdSet(blk_stmt, SPD_RID_BLOCK_DECL);
    for (csr = spdSetCursorCreate(decrs); spdSetCursorNext(&csr);) {
        decr = spdSetGetValueO(csr.curElem->value);
        sdaCreateArea(decr);
    }
    spdFreeSet2(decrs);
    return;
}

/*
 * ꤷ¤ΤareaΡexpr or identifierǻꤷ
 * ФArea롥
 *   ΤʤСSPD_NON_ID֤
 */

SpdObjId sdaAreaGetMember(SpdObjId str_area, SpdObjId obj)
{
    SpdIdSet mbrs;
    SetCursor csr;
    SpdObjId ret_area = SPD_NON_ID;
    
    /* expressionǤСidentifierѴ */
    if (spdGetClassId(obj) == SPD_CID_EXPRESSION) {
        obj = spdGetAChildObjId(obj, SPD_RID_IDENT_REF);
    }

    if (spdGetClassId(obj) != SPD_CID_IDENTIFIER)
        return SPD_NON_ID;

    mbrs = spdGetChildObjIdSet(str_area, SPD_RID_CONSIST_OF);
    for (csr = spdSetCursorCreate(mbrs); spdSetCursorNext(&csr);) {
        SpdObjId area = spdSetGetValueO(csr.curElem->value);
        /*      spdGetAChildObjId( *(SpdObjId*)spdGetAElem(mbrs, NULL),
                SPD_RID_CONSIST_OF);*/
        if (spdGetAParentObjId(area, SPD_RID_IDENT_SAREA) == obj) {
            ret_area = area;
        }
    }
    spdFreeSet2(mbrs);
    return ret_area;
}
