/* 
 * Program:             $RCSfile: StmtModelAR.c,v $  $Revision: 30.9 $
 * 
 * Purpose:             Access Library Of SDA
 *
 * Author:              T.Suzuki  1998/10/22
 *                      S.Yamamoto  1998/10/22
 *
 * (C) Copyright:       T.Suzuki and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: StmtModelAR.c,v 30.9 2003/07/08 05:46:28 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
/* #include <Sapid/StmtModelAR.h> */
#include "StmtModelAR.h"

/*
 * expressionФ° statement
 */
SpdObjId
spdGetStmtOfExpr(SpdObjId expr)
{
    while(spdGetClassId(expr) == SPD_CID_EXPRESSION) {
        SpdSet2 rels;
        SpdRel *tmp_rel = NULL;
        SetCursor csr;

        /* ҤȤĤȽǤǤȤϤҤȤĤʤ */
        SpdRel rel = spdGetAParentRel(expr, SPD_NON_ID);
        int r_sort = spdGetClassId(rel.relationId);
    
        if (r_sort == SPD_RID_EXPR_EXPR
            || r_sort == SPD_RID_FOR_EXPR
            || r_sort == SPD_RID_COND_EXPR
            || r_sort == SPD_RID_ITER_EXPR
            || r_sort == SPD_RID_STMT_EXPR
            || r_sort == SPD_RID_RETURN_EXPR
            || r_sort == SPD_RID_INIT_EXPR) {
            expr = rel.objectId;
            continue;
        }

        /* ҤȤĤȽǤǤʤȤ */
        /* ٤ƤδϢɬפʤΤ */
        rels = spdGetParentRelSet(expr, SPD_NON_ID);
        for (csr = spdSetCursorCreate(rels); spdSetCursorNext(&csr);) {
            tmp_rel = spdSetGetValueP(csr.curElem->value);
            r_sort = spdGetClassId(tmp_rel->relationId);
            if (r_sort == SPD_RID_EXPR_EXPR
                || r_sort == SPD_RID_FOR_EXPR
                || r_sort == SPD_RID_COND_EXPR
                || r_sort == SPD_RID_ITER_EXPR
                || r_sort == SPD_RID_STMT_EXPR
                || r_sort == SPD_RID_RETURN_EXPR
                || r_sort == SPD_RID_INIT_EXPR) {
                expr = tmp_rel->objectId;
                break;
            }
        }
        if (csr.curElem == NULL) {
            /*    spdWarning("spdGetStmtOfExpr(): "
                  "Unexpected Rel-Sort selected.(%s)\n",
                  spdGetClassNameById(r_sort)); */
            if (rels->elemNum == 0) {
                return SPD_NON_ID;
            }
            expr = tmp_rel->objectId;
        }
        spdFreeSet2(rels);
    }
    return expr;
}

/*
 * statement˴ޤޤ롢٤Ƥ expression
 */
SpdSet2
spdGetExprOfStmt(SpdObjId stmt)
{
    SpdSet2 exprs;                           /* expression */
    SpdSet2 g_exprs;                         /* ŪĴ٤뤿 expression Хåե*/

    exprs = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
    g_exprs = spdGetChildObjIdSet(stmt, SPD_NON_ID);
    /* ̩ˤ stmt_expr/decl_exprΤȤ¤餫--^ */

    while(g_exprs->elemNum > 0) {
        SpdSet2  i_exprs;
        SpdObjId c_expr;
        SetCursor csr;

        csr = spdSetCursorCreate(g_exprs); spdSetCursorNext(&csr);
        c_expr = spdSetGetValueO(csr.curElem->value);
        spdDelElemO(g_exprs, c_expr);
        if (spdGetClassId(c_expr) == SPD_CID_EXPRESSION)
            spdAddElemOK(exprs, c_expr);

        i_exprs = spdGetChildObjIdSet(c_expr, SPD_RID_EXPR_EXPR);
        g_exprs = spdAddSet2(g_exprs, i_exprs);
        spdFreeSet2(i_exprs);
    }

    spdFreeSet2(g_exprs);
    return exprs;
}

/*
 * Stmt/Declľexpression뤿 Convenienceؿ
 */
SpdRel
spdGetAStmtExprRel(SpdObjId stmt)
{
    if (spdGetClassId(stmt) == SPD_CID_STATEMENT) {
        return spdGetAChildRel(stmt, SPD_RID_STMT_EXPR);
    } else {
        return spdGetAChildRel(stmt, SPD_RID_INIT_EXPR);
    }
}

/*
 * controlƤstmt(ľstatement)롣
 *
 *  ߤϡ
 *    -<block_stmt>-        -<block_stmt>---- (stmt)
 *  -<control_body>- [stmt] -<control_body>-- (stmt)
 *     -<else_body>-        -<else_body>----- (stmt)
 *     -<func_body>-
 *                          -<block_decl>-- (decl)
 *              -<stmt_label>-- (label)
 *                          -<iter/for/cond_expr>---(expr)
 *              -<stmt/return_expr>-----(expr)
 *              (-<block_scope>-)
 *
 * Input:  statmenet/declaration/expression  ֥
 * Output: controlƤstatementID
 */
SpdRel
sdaGetParentCtrlRel(SpdObjId stmt)
{
    SpdRel     ret_rel;
    SpdClassId in_cls;

    in_cls = spdGetClassId(stmt);

    switch(in_cls) {
      case SPD_CID_EXPRESSION:
        /* Convert to statement */
        stmt = spdGetStmtOfExpr(stmt);

      case SPD_CID_STATEMENT:
        ret_rel = spdGetAParentRel(stmt, SPD_RID_BLOCK_STMT);
        if (ret_rel.objectId == SPD_NON_ID)
            ret_rel = spdGetAParentRel(stmt, SPD_RID_CONTROL_BODY);
        if (ret_rel.objectId == SPD_NON_ID)
            ret_rel = spdGetAParentRel(stmt, SPD_RID_ELSE_BODY);
        break;

      case SPD_CID_DECLARATION:
        ret_rel = spdGetAParentRel(stmt, SPD_RID_BLOCK_DECL);
        break;
    
      default:
        /* Ȥꤢobject롣statementǤʤSPD_NON_ID */
        ret_rel = spdGetAParentRel(stmt, SPD_NON_ID);

        if (spdGetClassId(ret_rel.objectId) != SPD_CID_STATEMENT) {
            ret_rel.objectId   = SPD_NON_ID;
            ret_rel.relationId = SPD_NON_ID;
        }
        break;
    }

    return ret_rel;
}

SpdObjId
sdaGetParentCtrlStmt(SpdObjId stmt)
{
    return sdaGetParentCtrlRel(stmt).objectId;
}

/*
 * ꤷstatement controlstatement
 *
 * Input:  statmenet  ֥
 * Output: controlstatementν
 */
SpdSet2
sdaGetChildCtrlStmt(SpdObjId stmt)
{
    int      sort;
    SpdSet2   ret_set;
    SpdObjId tmp_obj;

    /* 
     * [stmt:block] -*-<block_stmt>--- (stmt)
     *  [stmt:cond] -1-<control_body>- (stmt)
     *    [stmt:if] -1-<else_body>---- (stmt)
     */

    sort = spdGetAttrIntValByName(stmt, "sort");

    if (sort == STATE_BLOCK) {
        ret_set = spdGetChildObjIdSet(stmt, SPD_RID_BLOCK_STMT);
        return ret_set;
    }

    ret_set = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
    
    switch (sort) {
      case STATE_IF:
        tmp_obj = spdGetAChildObjId(stmt, SPD_RID_ELSE_BODY);
        spdAddElemOK(ret_set, tmp_obj);

      case STATE_FOR:
      case STATE_DO:
      case STATE_WHILE:
      case STATE_SWITCH:
        tmp_obj = spdGetAChildObjId(stmt, SPD_RID_CONTROL_BODY);
        spdAddElemOK(ret_set, tmp_obj);
        break;

      case STATE_NORMAL:  case STATE_BREAK:  case STATE_CONTINUE:
      case STATE_GOTO:    case STATE_RETURN:
        break;
      default:
        spdWarning("sdaGetChildCtrlStmt: "
                   "Unexpected statement sort:%d %d\n", stmt, sort);
    }

    return ret_set;
}

/* ----------------------------------------
   ---------------------------------------- */

/*
 * relation offset
 */
static int
compar_relidOffset(const SpdQueueElemType *a, const SpdQueueElemType *b)
{
    SpdRelId rid_a = *((SpdRelId*)a);
    SpdRelId rid_b = *((SpdRelId*)b);
    return spdGetOffset(rid_a) - spdGetOffset(rid_b);
}

/*
 * 륪֥ȤΡꤵ줿(Ҥ)ط
 * offsetǥȤ֤
 *  output:
 *    relationId Queue֤
 */

typedef enum {
    GET_SORTED_STMT, GET_SORTED_RELID
} GetSortedType;

static SpdQueue*
getSortedStmts_common(SpdObjId blk, SpdClassId get_rel, GetSortedType type)
{
    SetCursor csr;

    /* Ҷ(stmt)򤹤٤ */
    SpdIdSet stmts = spdGetChildRelIdSet(blk, SPD_RID_BLOCK_STMT);
    SpdIdSet decls = spdGetChildRelIdSet(blk, SPD_RID_BLOCK_DECL);

    /* offset   */
    SpdQueue q  = spdQueueInit();
    SpdQueue *q2 = (SpdQueue*)spdMalloc(sizeof(SpdQueue));

    for (csr = spdSetCursorCreate(stmts); spdSetCursorNext(&csr);) {
        spdQueuePushFront(&q,spdSetGetValueO(csr.curElem->value));
    }
    for (csr = spdSetCursorCreate(decls); spdSetCursorNext(&csr);) {
        spdQueuePushFront(&q, spdSetGetValueO(csr.curElem->value));
    }

    spdQueueSort(&q, compar_relidOffset);

    *q2 = spdQueueInit();
    while(q.elem>0) {
        if (type == GET_SORTED_RELID){
            /* relationid */
            spdQueuePushFront(q2, (SpdRelId)spdQueuePopBack(&q));
        } else {
            /* stmt/decl object */
            int rid = spdGetAttrIntVal((SpdRelId)spdQueuePopBack(&q),
                                       SAPIDDB_ATTR_C_ID);
            spdQueuePushFront(q2, rid);
        }
    }

    spdQueueClean(&q);
    spdFreeSet2(stmts);
    spdFreeSet2(decls);
    return q2;
}

/*
 * BlockβStmt򥪥եåȤǥȤ̤֤
 */
SpdQueue*
spdGetSortedStmtRelId(SpdObjId blk)
{
    return getSortedStmts_common(blk,SPD_RID_BLOCK_STMT, GET_SORTED_RELID);
}

SpdQueue*
spdGetSortedStmts(SpdObjId blk)
{
    return getSortedStmts_common(blk, SPD_RID_BLOCK_STMT, GET_SORTED_STMT);
}
