/* 
 * Program:             $RCSfile: TypeView.c,v $  $Revision: 31.5 $
 * 
 * Purpose:             Class definition of TypeView.
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: TypeView.c,v 31.5 2003/04/07 16:02:55 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

#if defined(SAPID_AR5)

static SpdDBClass Type_view_classes[] = {
    /* Classes. */
    {
        "member",
        SPD_CID_MEMBER,
        SAPIDDB_SORT_OBJ_TREENODE,
        { SAPIDDB_ATTR_ID, SAPIDDB_ATTR_NONE },
        {
            { NULL, SPD_DBT_NON },
        }
    },
    {
        "enumerator",
        SPD_CID_ENUMERATOR,
        SAPIDDB_SORT_OBJ_TREENODE,
        { SAPIDDB_ATTR_ID, 0, SAPIDDB_ATTR_NONE },
        {
            { "value", SPD_DBT_INT },
            { NULL, SPD_DBT_NON },
        }
    },

    /* Relationships. */
    {
        "struct_member",
        SPD_RID_STRUCT_MEMBER,
        SAPIDDB_SORT_REL_COMPOSITE,
        { 0, 1, 2, SAPIDDB_ATTR_NONE },
        {
            {"struct_id", SPD_DBT_OID, NULL, SPD_CID_TYPE }, 
            {"member_id", SPD_DBT_OID, NULL, SPD_CID_MEMBER },
            {"order", SPD_DBT_INT }, 
            { NULL, SPD_DBT_NON },
        }
    },
    {
        "member_type",
        SPD_RID_MEMBER_TYPE,
        SAPIDDB_SORT_REL_REFERENCE,
        { 0, 1, SAPIDDB_ATTR_NONE },
        {
            {"member_id", SPD_DBT_OID, NULL, SPD_CID_MEMBER },
            {"type_id", SPD_DBT_OID, NULL, SPD_CID_TYPE }, 
            { NULL, SPD_DBT_NON },
        }
    },
    {
        "member_name",
        SPD_RID_MEMBER_NAME,
        SAPIDDB_SORT_REL_ONE_TO_ONE,
        { 0, 1, SAPIDDB_ATTR_NONE },
        {
            {"member_id", SPD_DBT_OID, NULL, SPD_CID_MEMBER },
            {"identifier_id", SPD_DBT_OID, NULL, SPD_CID_IDENTIFIER }, 
            { NULL, SPD_DBT_NON },
        }
    },
    {
        "enum_enumerator",
        SPD_RID_ENUM_ENUMERATOR,
        SAPIDDB_SORT_REL_ONE_TO_ONE,
        { 0, 1, 2, SAPIDDB_ATTR_NONE },
        {
            {"enum_id", SPD_DBT_OID, NULL, SPD_CID_TYPE }, 
            {"enumerator_id", SPD_DBT_OID, NULL, SPD_CID_ENUMERATOR },
            {"order", SPD_DBT_INT }, 
            { NULL, SPD_DBT_NON },
        }
    },
    {
        "enumerator_name",
        SPD_RID_ENUMERATOR_NAME,
        SAPIDDB_SORT_REL_ONE_TO_ONE,
        { 0, 1, SAPIDDB_ATTR_NONE },
        {
            {"enumerator_id", SPD_DBT_OID, NULL, SPD_CID_ENUMERATOR },
            {"identifier_id", SPD_DBT_OID, NULL, SPD_CID_IDENTIFIER }, 
            { NULL, SPD_DBT_NON },
        }
    },
    {
        "array_num",
        SPD_RID_ARRAY_NUM,
        SAPIDDB_SORT_REL_ONE_TO_ONE,
        { 0, 1, SAPIDDB_ATTR_NONE },
        {
            {"array_id", SPD_DBT_OID, NULL, SPD_CID_TYPE },
            {"constant_id", SPD_DBT_OID, NULL, SPD_CID_CONSTANT }, 
            { NULL, SPD_DBT_NON },
        }
    },

    {
        NULL, SPD_NON_ID, 0, {SAPIDDB_ATTR_NONE}
    }
};

#endif /* defined(SAPID_AR5) */

/******************************************************************************/

SpdDBModel TypeView_model = {
    SPD_MID_TYPE_VIEW,
    "Type-view",
    SPD_TYPE_VIEW_VERSION,
    SPD_TYPE_VIEW_DIR,

    SPD_FIRST_CID_TYPE_VIEW,
    SPD_LAST_CID_TYPE_VIEW,
    SPD_CID_NUM_TYPE_VIEW,

    SPD_FIRST_RID_TYPE_VIEW,
    SPD_LAST_RID_TYPE_VIEW,
    SPD_RID_NUM_TYPE_VIEW,

    SPD_CRID_NUM_TYPE_VIEW,

#if defined(SAPID_AR5)

    Type_view_classes,
    NULL,

#endif /* defined(SAPID_AR5) */
};
