/* 
 * Program:             $RCSfile: expr_analy.c,v $  $Revision: 30.27 $
 * 
 * Purpose:
 *
 * Author:              T.Suzuki  1998/10/22
 *                      S.Yamamoto  1997/10/22
 *
 * (C) Copyright:       T.Suzuki and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: expr_analy.c,v 30.27 2003/07/08 05:48:25 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "statinfo.h"

extern int      only_traverse_flag;
extern int      verbose_flag;
extern SpdIdSet global_var;        /* ѿΥХåե */
extern SpdObjId current_vstmt;     /* ߤ vstmt */

SpdIdSet getArea(SpdObjId expr, SdaStatInfo *info, int left_value_flag);

extern SpdObjId sdaAreaGetMember(SpdObjId str_area, SpdObjId obj);

/*
 * ѿκǽλȤǤ bodydef褦˰
 */

int make_global_def(SpdObjId expr, SpdObjId area, SdaStatInfo *info)
{
    SpdObjId ident = spdGetAChildObjId(expr, SPD_RID_IDENT_REF);

    if (spdContainsO(global_var, ident)) {
        SpdRel      tmp;
        SpdObjId    virtual_decl;

        /* varg (sort: VARG_IN)롥
           Ȥߤʤƥ󥯤ĥ롥 */
        {
            virtual_decl = spdCreateObj(SPD_CID_VARG, SPD_NON_ID);
            spdCreateRel(SPD_RID_IDENT_VARG,
                         SPD_NON_ID, ident, virtual_decl);
            spdCreateRel(SPD_RID_SFUNC_VARG,
                         SPD_NON_ID, current_vstmt, virtual_decl);
            spdSetAttrIntValByName(virtual_decl, "sort", VARG_IN);
        }

        tmp = info->stmt;
        info->stmt.objectId = current_vstmt;
        info_add_r_d(info, area, current_vstmt);
        info->stmt = tmp;

        /* Ϣ */
        spdCreateRel(SPD_RID_DATA_DEPEND,
                     SPD_NON_ID, virtual_decl, expr);

        if (verbose_flag) {
            printf("create rel DD: %d-->%d\n", current_vstmt, expr);
        }

        return 1;
    }
    return 0;
}

/*
 * ꥢɤǰƤĴ١
 * exprȡref-defδط
 */

int make_ref_rel(SpdObjId expr, SpdObjId area, SdaStatInfo *info)
{
    int      i;
    SpdQueue *defs;
    
    /* rd_maparea --> def-exprs */
    defs = info_get_def(info, area);        /*  area  expr */
    
    /*  expr --> def-exprs */
    if (defs == NULL) {
        make_global_def(expr, area, info);
        return 0;
    }
    
    for (i=0; i<defs->elem; i++) {
        SpdObjId def_expr = spdQueuePeek(defs, i);
    
        /* exprδ֤˰¸ط */
        spdCreateRel(SPD_RID_DATA_DEPEND, SPD_NON_ID, def_expr, expr);
        if (verbose_flag) {
            printf("create rel DD: %d-->%d\n", def_expr, expr);
        }
    }

    return 1;
}

/*
 * ϤΤareaξ
 */

void make_ref_rel_set(SpdObjId expr, SpdIdSet a_set, SdaStatInfo *info)
{
    int err_cnt = 0;
    SetCursor csr;

    for (csr = spdSetCursorCreate(a_set); spdSetCursorNext(&csr);) {
        SpdObjId area;

        area = spdSetGetValueO(csr.curElem->value);
        err_cnt += make_ref_rel(expr, area, info);
    }

    if (err_cnt == a_set->elemNum) {
        spdWarning("No prev def: %d.\n", expr);
    }
    
    return;
}

/* 
 * rdmap  Ͽ
 * rdmap: [area] --> [def-exprs]
 */

void info_add_def(SpdObjId area, SpdObjId expr, SdaStatInfo *info)
{
    /* դexpr defȤϿ */
    info_del_def(info, area);               /* ޤǤξõ */
    info_add_r_d(info, area, expr);         /* [area] --> [expr] */

    if (verbose_flag) {
        printf("add definition: A:%d E:%d\n", area, expr);
    }
}

/*
 * ꤷ expression Area֤
 *  
 *  1:  expressionˤơinner-exprȡoperatorĴ٤
 *     pointerʤ顤
 */

static SpdSet2 op_pointer_proc(SpdSet2 exprs, SdaStatInfo *info)
{
    SpdIdSet ret_set = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
    SetCursor csr_e, csr_p;

    for (csr_e = spdSetCursorCreate(exprs); spdSetCursorNext(&csr_e);) {
        SpdSet2   p_area_set;
        SpdObjId c_expr;

        c_expr = ((SpdRel*)spdSetGetValueP(csr_e.curElem->value))->objectId;
        p_area_set = getArea(c_expr, info, FALSE);

        for (csr_p = spdSetCursorCreate(p_area_set); spdSetCursorNext(&csr_p);) {
            SpdSet2 areas;
            SpdObjId p_area, area;
            SetCursor csr_a;
        
            p_area = spdSetGetValueO(csr_p.curElem->value);
            areas = spdGetChildObjIdSet(p_area, SPD_RID_SAREA_SAREA);
            for (csr_a = spdSetCursorCreate(areas); spdSetCursorNext(&csr_a);) {
                area = ((SpdRel*)spdSetGetValueP(csr_a.curElem->value))->objectId;
                if (area != SPD_NON_ID)
                    spdAddElemOK(ret_set, area);
            }
            spdFreeSet2(areas);
        }
        spdFreeSet2(p_area_set);
    }
    
    return ret_set;
}

/*
 * 2Ĥ relationؤΥݥ󥿤äӤ
 * 礭 졦ͤ򴹤
 */

static int two_item_sort_offset(SpdRel *r1, SpdRel *r2)
{
    int off1, off2;

    off1 = spdGetOffset(r1->relationId);
    off2 = spdGetOffset(r2->relationId);
    if (off1 > off2) {
        SpdRel tmp;
        tmp = *r1; *r1 = *r2; *r2 = tmp;
        return 1;
    }
    return 0;
}

static int three_item_sort_offset(SpdRel *r1, SpdRel *r2, SpdRel *r3)
{
    SpdRel tmp;

    /* 3 Item Bubble Sort */
    if (spdGetOffset(r2->relationId) > spdGetOffset(r3->relationId)) {
        tmp = *r2; *r2 = *r3; *r3 = tmp;
    }
    if (spdGetOffset(r1->relationId) > spdGetOffset(r2->relationId)){
        tmp = *r1; *r1 = *r2; *r2 = tmp;
    }
    if (spdGetOffset(r2->relationId) > spdGetOffset(r3->relationId)) {
        tmp = *r2; *r2 = *r3; *r3 = tmp;
    }

    return 0;
}

/*
 * structν
 */

SpdIdSet struct_dot_proc(SpdSet2 exprs, SdaStatInfo *info)
{
    SpdRel r1, r2;
    SpdIdSet ret_area;
    SpdObjId area, area2;
    SetCursor csr;

    csr = spdSetCursorCreate(exprs);
    spdSetCursorNext(&csr);
    r1 = *(SpdRel*)spdSetGetValueP(csr.curElem->value);
    spdSetCursorNext(&csr);
    r2 = *(SpdRel*)spdSetGetValueP(csr.curElem->value);
    
    two_item_sort_offset(&r1, &r2);

    ret_area = getArea(r1.objectId, info, FALSE);
    if (ret_area->elemNum == 0) {
        spdWarning("Required struct tag.\n");
        return ret_area;                    /* ԤʤƤɬפʤ */
    }
    csr = spdSetCursorCreate(ret_area);
    spdSetCursorNext(&csr);
    area2 = spdSetGetValueO(csr.curElem->value);
    area = sdaAreaGetMember(area2, r2.objectId);
    spdFreeSet2(ret_area);
    
    ret_area = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
    spdAddElemOK(ret_area, area);

    return ret_area;
}

/*
 * arrowν
 */

SpdIdSet op_arrow_proc(SpdSet2 exprs, SdaStatInfo *info)
{
    SpdRel r1, r2;
    SpdIdSet ret_area, area1, areas2;
    SetCursor csr, csr1, csr2;

    ret_area = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
    csr = spdSetCursorCreate(exprs);
    spdSetCursorNext(&csr);
    r1 = *(SpdRel*)spdSetGetValueP(csr.curElem->value);
    spdSetCursorNext(&csr);
    r2 = *(SpdRel*)spdSetGetValueP(csr.curElem->value);
    two_item_sort_offset(&r1, &r2);
    area1 = getArea(r1.objectId, info, FALSE);

    for (csr1 = spdSetCursorCreate(area1); spdSetCursorNext(&csr1);) {
        SpdObjId area;

        area = spdSetGetValueO(csr1.curElem->value);
        areas2 = spdGetChildObjIdSet(area, SPD_RID_SAREA_SAREA);
        for (csr2 = spdSetCursorCreate(areas2); spdSetCursorNext(&csr2);) {
            area = sdaAreaGetMember(spdSetGetValueO(csr2.curElem->value),
                                    r2.objectId);
            /* area = spdGetAChildObjId(area, SPD_RID_SAREA_SAREA); */
            spdAddElemOK(ret_area, area);
        }
        spdFreeSet2(areas2);
    }
    spdFreeSet2(area1);

    return ret_area;
}

/*
 * 2黻ν
 *    դarearefer (area)
 *    ASSIGN Ǥʤդ refer (area)
 *    OP_A_, ASSIGN Ф def (area, expr)
 *    դݥ󥿤ξ硤դ򥨥ꥢ (area, area)
 *
 *  (ret_area)ϡAssign/OP_A_*ξ硤դΤ
*  ʳ٤ ֤Ф褤
*
*  TODO:
*  a[b]ΰ
*/

SpdIdSet two_term_op(SpdObjId expr1, SpdObjId expr2, SpdSet2 l_area,
                     SpdSet2 r_area, SpdObjId op_sort, SdaStatInfo *info)
{
    SpdIdSet ret_set = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
    SpdQueue r_a = spdQueueInit();
    int sort = op_sort;
    SetCursor csr;
    
    /* դarearefer (area) */
    for (csr = spdSetCursorCreate(r_area); spdSetCursorNext(&csr);) {
        SpdObjId area = spdSetGetValueO(csr.curElem->value);
        /* make_ref_rel(expr2, area, info); ס -- ˤäƤ */

        spdQueueEnqueue(&r_a, area);

        /* Assign/OP_A_*ǤʤΤ  դͤȤ֤ */
        if (sort == OP_A_MUL || sort == OP_A_DIV || sort == OP_A_MOD||
            sort == OP_A_AND || sort == OP_A_XOR || sort == OP_A_OR ||
            sort == OP_A_SHL || sort == OP_A_SHR ||
            sort == OP_ASSIGN  || sort == OP_A_ADD || sort == OP_A_SUB)
            /* ͤȤ֤Τϡݥ󥿤λΤ */
            if (spdGetAChildObjId(area, SPD_RID_SAREA_SAREA) != SPD_NON_ID)
                spdAddElemOK(ret_set, area);
    }

    for (csr = spdSetCursorCreate(l_area); spdSetCursorNext(&csr);) {
        SpdObjId area = spdSetGetValueO(csr.curElem->value);

        if (op_sort != OP_ASSIGN) {
            /* ASSIGN Ǥʤդ refer (area) */
            make_ref_rel(expr1, area, info);
        } else {
            /* դݥ󥿤ξ硤դ򥨥ꥢ (area, area) */
            /* ¿ʬassign OK -- arrayҤȤĤareaɽ */
            /* ¦ϡʡ᤹ */
            /*      SpdObjId area_po = */
            /*          spdGetAChildObjId(area, SPD_RID_SAREA_SAREA); */
            if (spdGetAChildObjId(area, SPD_RID_SAREA_SAREA) != SPD_NON_ID) {
                int j;
                for (j = 0; j < r_a.elem; j++) {
                    if (verbose_flag) {
                        printf("Alias %d %d\n", area, spdQueuePeek(&r_a, j));
                    }
                    spdCreateRel(SPD_RID_SAREA_SAREA,
                                 SPD_NON_ID, area, spdQueuePeek(&r_a, j));
                }
            }
        }
        /* OP_A_*, ASSIGN Ф def (area, expr) */
        /* դͤȤ֤ΤϡAssign줿 or ݥ󥿤ξ */
        if (sort == OP_A_MUL || sort == OP_A_DIV || sort == OP_A_MOD||
            sort == OP_A_AND || sort == OP_A_XOR || sort == OP_A_OR || 
            sort == OP_A_SHL || sort == OP_A_SHR ||
            sort == OP_ASSIGN || sort == OP_A_ADD || sort == OP_A_SUB) {
            info_add_def(area, expr1, info);

            spdAddElemOK(ret_set, area);
        } else {
            if (spdGetAChildObjId(area, SPD_RID_SAREA_SAREA) != SPD_NON_ID)
                spdAddElemOK(ret_set, area);
        }
    }

    spdQueueClean(&r_a);

    return ret_set;
}

/*
 * Areaμӡarea֤δϢ
 *  exprƵŪéʤ顤exprˤĤƤԤʤ
 *
 *  left_value_flag : 
 *    դξ硤identifierreferˤʤʤᡤ
 *    Ƚ򤹤뤿Ϥդɤ򼨤ե饰
 *  : exprФ area֥Ȥν
 */

SpdIdSet getArea(SpdObjId expr, SdaStatInfo *info, int left_value_flag)
{
    int         sort;
    SpdObjId    oprt, area;
    SpdSet2     ret_area, exprs;
    SpdRel      r1, r2, r3;
    SpdRel      *rp;
    SetCursor   csr;

    ret_area = NULL;
    if (expr == SPD_NON_ID)
        return spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);

    exprs= spdGetChildRelSet(expr, SPD_RID_EXPR_EXPR);
    oprt = spdGetAChildObjId(expr, SPD_RID_EXPR_OP);
    sort = spdGetAttrIntValByName(oprt, "sort");

    if (oprt == SPD_NON_ID) {
        if (spdGetAttrIntValByName(expr, "sort") == EXPR_SORT_FUNCCALL) {
            for (csr = spdSetCursorCreate(exprs); spdSetCursorNext(&csr);) {
            /* ؿ°η׻ */
                SpdObjId expr;

                expr = ((SpdRel *)spdSetGetValueP(csr.curElem->value))->objectId;
                ret_area = getArea(expr, info, FALSE);
                spdFreeSet2(ret_area);
            }
            ret_area = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
        } else {
            /* ǲؤexpression */
            /* expr --> identifier --> area */
            SpdObjId ident;

            ret_area = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
            ident = spdGetAChildObjId(expr,  SPD_RID_IDENT_REF);
            area  = spdGetAChildObjId(ident, SPD_RID_IDENT_SAREA);
            if (area != SPD_NON_ID) {
                spdAddElemOK(ret_area, area);
                if (!left_value_flag)
                    make_ref_rel(expr, area, info);
            }
        }
        spdFreeSet2(exprs);
        return ret_area;
    }

    switch (sort) {                         /* 黻ҤǾʬ */
      case OP_POINTER:                      /* pointerξ */
        ret_area = op_pointer_proc(exprs, info);
        if (!left_value_flag)
            make_ref_rel_set(expr, ret_area, info);
        break;

      case OP_ADDRESS:                      /* address expression: 1 expr. */
        csr = spdSetCursorCreate(exprs);
        spdSetCursorNext(&csr);
        rp = spdSetGetValueP(csr.curElem->value);
        ret_area = getArea(rp->objectId, info, FALSE);
        break;

      case OP_DOT:                          /* dot expression (a.b)*/
        ret_area = struct_dot_proc(exprs, info);
        if (!left_value_flag)
            make_ref_rel_set(expr, ret_area, info);
        break;

      case OP_ARROW:                        /* arrow (( a->b )) */
        ret_area = op_arrow_proc(exprs, info);
        if (!left_value_flag)
            make_ref_rel_set(expr, ret_area, info);
        break;

      case OP_COLON:                        /**/
      case OP_QUESTION:                     /**/
        csr = spdSetCursorCreate(exprs);
        spdSetCursorNext(&csr);
        r1 = *(SpdRel*)spdSetGetValueP(csr.curElem->value);
        spdSetCursorNext(&csr);
        r2 = *(SpdRel*)spdSetGetValueP(csr.curElem->value);
        spdSetCursorNext(&csr);
        r3 = *(SpdRel*)spdSetGetValueP(csr.curElem->value);
        three_item_sort_offset(&r1, &r2, &r3);
        {
            SpdSet2 area_0, area_2;
            area_0   = getArea(r1.objectId, info, FALSE); /* ȤΤ */
            spdFreeSet2(area_0);
            ret_area = getArea(r2.objectId, info, FALSE);
            area_2   = getArea(r3.objectId, info, FALSE);
            for (csr = spdSetCursorCreate(area_2); spdSetCursorNext(&csr);) {
                spdAddElemOK(ret_area, spdSetGetValueO(csr.curElem->value));
            }
            spdFreeSet2(area_2);
        }
        break;

        /* ʳξ */
      case OP_SIZEOF_TYPE:                  /* OP_SIZEOF? */
        ret_area = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
        break;
    
      case OP_L_PAR: case OP_R_PAR:         /*  */
      case OP_NOT:   case OP_B_NOT:  
      case OP_PLUS:  case OP_MINUS:
      case OP_CAST:
        /* 1黻 Τޤή */
        csr = spdSetCursorCreate(exprs);
        spdSetCursorNext(&csr);
        rp = spdSetGetValueP(csr.curElem->value);
        ret_area = getArea(rp->objectId, info, FALSE);
        break;

      case OP_INC:   case OP_DEC:
        /* /֤Ǥ櫓ɬפ */
        csr = spdSetCursorCreate(exprs);
        spdSetCursorNext(&csr);
        rp = spdSetGetValueP(csr.curElem->value);
        ret_area = getArea(rp->objectId, info, FALSE);
        /* if correct analyze, ret_area has one elem at least */
        if (ret_area->elemNum == 0) break;
        csr = spdSetCursorCreate(ret_area);
        spdSetCursorNext(&csr);
        area = spdSetGetValueO(csr.curElem->value);
        info_add_def(area, r1.objectId, info);
        break;
    
      default:                              /* 2黻 */
        if (exprs->elemNum == 0) break;
        csr = spdSetCursorCreate(exprs);
        spdSetCursorNext(&csr);
        r1 = *(SpdRel*)spdSetGetValueP(csr.curElem->value);
        spdSetCursorNext(&csr);
        r2 = *(SpdRel*)spdSetGetValueP(csr.curElem->value);
        two_item_sort_offset(&r1, &r2);
        {
            SpdSet2 ret_areaA, ret_areaB;
        
            ret_areaA = getArea(r1.objectId, info, TRUE); /*  */
            ret_areaB = getArea(r2.objectId, info, FALSE); /*  */
            ret_area = two_term_op(r1.objectId, r2.objectId,
                                   ret_areaA, ret_areaB, sort, info);
            spdFreeSet2(ret_areaA);
            spdFreeSet2(ret_areaB);
        }
        break;
    }

    spdFreeSet2(exprs);
    return ret_area;
}

/*
 * exprβ
 */

void expr_analyze(SpdObjId expr, SdaStatInfo* info)
{
    SpdSet2 r_set;

    if (!only_traverse_flag) {
    
        r_set = getArea(expr, info, FALSE);

        spdFreeSet2(r_set);
    }

    return;
}

/*
 *  var-argument
 */

static void make_out_varg(SpdQueue *q, SpdObjId ident)
{
    int j;

    SpdObjId varg = SPD_NON_ID;

    for (j = 0; j < q->elem; j++) {
        SpdObjId expr = spdQueuePeek(q, j);

        /* varg줿ΡľܤΤΤϽ */
        SpdClassId cid = spdGetClassId(expr);
        if (cid == SPD_CID_VARG ||
            cid == SPD_CID_SDAFUNC ||
            cid == SPD_CID_DECLARATOR) continue;
        
        if (varg == SPD_NON_ID) {
            SpdRelId f_v;

            /* varg(OUT), sfunc_varg */
            varg = spdCreateObj(SPD_CID_VARG, SPD_NON_ID);
            f_v  = spdCreateRel(SPD_RID_SFUNC_VARG,
                                SPD_NON_ID, current_vstmt, varg);
            spdSetAttrIntValByName(varg, "sort", VARG_OUT);

            /* ident_varg */
            if (ident != SPD_NON_ID)
                spdCreateRel(SPD_RID_IDENT_VARG, SPD_NON_ID, ident, varg);
        }
        spdCreateRel(SPD_RID_DATA_DEPEND, SPD_NON_ID, expr, varg);
    }
    return;
}

/*
 * ؿȴѿԤʤƤ顤varg
 *                 ˤĤƤƱͤ˹Ԥʤ
 * : SdaStatInfo
 */

int make_global_out(SdaStatInfo* info)
{
    SpdSet2     rdmp = info->rdmp;
    SetCursor   csr;
    
    for (csr = spdSetCursorCreate(rdmp); spdSetCursorNext(&csr);) {
        int a_sort;
        SpdObjId ident;

        SpdQueue *q = spdSetGetValueP(csr.curElem->value);
        SpdObjId area = spdSetGetValueO(csr.curElem->key);
        a_sort = spdGetAttrIntValByName(area, "sort");

        ident = spdGetAParentObjId(area, SPD_RID_IDENT_SAREA);

        if (spdContainsO(global_var, ident)) {
            /* ѿξ */
            make_out_varg(q, ident);
        } else {
            /* Фξ */
            if (spdGetAttrIntValByName(ident, "sort") == ID_MEMBER) {
                area = spdGetAParentObjId(area, SPD_RID_CONSIST_OF);
                a_sort = spdGetAttrIntValByName(area, "sort");
                ident = spdGetAParentObjId(area, SPD_RID_IDENT_SAREA);
            }

            /* Υݥ󥿤ξ */
            while (a_sort != SAREA_POINTER) {
                area = spdGetAParentObjId(area, SPD_RID_SAREA_SAREA);
                if (area != SPD_NON_ID) {
                    a_sort = spdGetAttrIntValByName(area, "sort");
                    ident = spdGetAParentObjId(area, SPD_RID_IDENT_SAREA);
                    continue;
                }
                area = spdGetAParentObjId(area, SPD_RID_CONSIST_OF);
                if (area == SPD_NON_ID) break;
                ident = spdGetAParentObjId(area, SPD_RID_IDENT_SAREA);
            }

            if (area == SPD_NON_ID) continue;

            if (a_sort == SAREA_POINTER) {
                /* γؤΰ¸Ƚ */
                SpdObjId decr = spdGetAParentObjId(ident, SPD_RID_DECL_IDENT);
                SpdObjId decl = spdGetAParentObjId(decr, SPD_RID_DECL_DECL);
                SpdObjId opt  = spdGetAParentObjId(decl, SPD_RID_FUNC_PARM);

                if (opt != SPD_NON_ID) {
                    make_out_varg(q, ident);
                }
            }
        }
    }
    return 1;
}
