/* 
 * Program:             $RCSfile: mkdd.c,v $  $Revision: 30.31 $
 * 
 * Purpose:
 *
 * Author:              T.Suzuki  1998/10/22
 *                      S.Yamamoto  1997/10/22
 *
 * (C) Copyright:       T.Suzuki and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: mkdd.c,v 30.31 2003/07/08 05:48:25 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "statinfo.h"

/* Global flags. */

int only_traverse_flag  = 0;  /* 1:expr_analyzeԤʤʤ */
static int not_write_db = 1;  /* 1:ǡ١ؤν񤭹ߤԤʤʤ */
       int verbose_flag = 0;  /* 1:verbose output */

SpdIdSet global_var;          /* ѿΥХåե */
SpdObjId current_vstmt;       /* ߤ body */

static SpdRel spd_non_id_rel = {SPD_NON_ID, SPD_NON_ID};

/* Definitions (إåذư٤) */

/* in sdaarea.c */
extern SpdObjId sdaCreateArea(SpdObjId decr);

/* exprβ */
extern void expr_analyze(SpdObjId expr, SdaStatInfo* info);
extern void info_add_def(SpdObjId area, SpdObjId expr, SdaStatInfo *info);

extern void     waitq_init(void);
extern void     waitq_free(void);
extern void     waitq_add_stmt(SdaStatInfo *inf, SpdRel stmt);
extern int      waitq_size(void);
extern SdaStatInfo* getNextFromWQ(void);

extern int make_global_out(SdaStatInfo* info);
extern void execq_add_stmt(SdaStatInfo *inf, SpdRel rel);

/* 
 * Ϥ줿Ԥμ¹ԤԤʤ٤Ƚ򤹤롥
 * ˼¹Ԥ٤stmtιԤ֤
 * NULLϤ줿ȤϡԤ󤫤롥
 */

static SdaStatInfo* getNextStmt(SdaStatInfo *info)
{
    SdaStatInfo *nxt_info = NULL;

    if (info != NULL && info->stmt.objectId != SPD_NON_ID) {
        if (1) {
            /* stmt˼¹ԤƤ */
            /* ¹Իξ֤ */
            if (1) {
                /* ߤref-def֤Ʊ(ޤޤ) */
                /* Ʒ׻ɬפʤ, loopback-stackƱʤ顤¹Ԥʤ
                   Ԥ󤫤õ */
                /* ʤСblockФޤǡƷ׻éФ褤
                   νϤʤݤʤΤǡʤƷ׻Ԥʤ*/
            } else {
                /* Ʒ׻ɬ */
                /* ΥΡɤdef-ref֤ɲ */
                /* Ȥξ֤ѲɬפϤʤ */
            }
        }
        nxt_info = info;
        nxt_info = check_already_exec(info);
        /* 
         * if (nxt_info != NULL) {
         *     info_view(nxt_info);
         * }
         * if (waitq_check_queue(info)) {
         *     nxt_info == NULL;
         * }
         */
    }

    if (nxt_info == NULL || nxt_info->stmt.objectId == SPD_NON_ID) {
        /* ̤nxtʤ, Ǥ椫õ */
        if (info != NULL) info_free(info);
        nxt_info = getNextFromWQ();
    }

    return nxt_info;                        /* ¹Ԥ٤ SdaStatInfo֤ */
}

static SpdObjId multi_next(SdaStatInfo *stat)
{
    /*
     * ʣ nextʸ
     * ҤȤĤ򼡤Ȥ֤
     * ҤȤĤ waitqåѤ 
     */
    SpdObjId pid;
    SpdRel nxt_stmt = spd_non_id_rel;
    SpdSet2 stmts = spdGetChildRelSet(stat->stmt.objectId, SPD_RID_NEXT_STMT);
    SetCursor csr;
    int i;

    pid = spdGetAParentObjId(stat->stmt.objectId, SPD_RID_BLOCK_STMT);

    for (i = 0, csr = spdSetCursorCreate(stmts); spdSetCursorNext(&csr); i++) {
        SpdRel *stmtp = spdSetGetValueP(csr.curElem->value);
    
        if (nxt_stmt.objectId == SPD_NON_ID &&
            (i == stmts->elemNum - 1 ||
             pid != spdGetAParentObjId(stmtp->objectId, SPD_RID_BLOCK_STMT) )) {

            /* ƤƱ٥ˤʤΤõ 
               ǽΤΤ򼡤˼¹ԤʸȤ */
            nxt_stmt = *stmtp;

        } else {
            /* waitqå */     
            waitq_add_stmt(stat, *stmtp);
        }
    }

    spdFreeSet2(stmts);
    
    /* ѹƤƶʤ */
    stat->stmt = nxt_stmt;

    return nxt_stmt.objectId;
}

/*
 * Ʊ٥μʸõ
 */

SpdObjId next_real_stmt(SdaStatInfo *stat)
{
    SpdRel *rp = NULL;
    SpdSet2 s = spdGetChildRelSet(stat->stmt.objectId, SPD_RID_NEXT_STMT);
    SetCursor csr;

    for (csr = spdSetCursorCreate(s); spdSetCursorNext(&csr);) {
        int rsort;
        rp = spdSetGetValueP(csr.curElem->value);
        rsort = spdGetAttrIntValByName(rp->relationId, "sort");
        if (rsort != NEXTSTMT_CONTROL)
            break;
    }
    spdFreeSet2(s);

    stat->stmt = *rp;
    return rp->objectId;
}

SpdObjId for_stmt(SdaStatInfo *stat)
{
    SpdObjId expr;
    SpdObjId stmt = stat->stmt.objectId;

    if (spdGetAttrIntValByName(stat->stmt.relationId, "sort") ==
        NEXTSTMT_LOOPBACK) {
        /* loopbackˤä  */
        /* iterator ɾ */
        expr = spdGetAChildObjId(stmt, SPD_RID_ITER_EXPR);
        expr_analyze(expr, stat);
        /* condition expression */
        expr = spdGetAChildObjId(stmt, SPD_RID_COND_EXPR);
        expr_analyze(expr, stat);

        if (info_loopcnt_get(stat, SPD_NON_ID) > 1) {
            /* 롼פȴ */
            /* Τޤޡʸ */
            info_loop_pop(stat, SPD_NON_ID);
            return next_real_stmt(stat);
        }
    
        info_loopcnt_inc(stat);

        /* ϡƱ */

    } else {
        /* initial expr */
        expr = spdGetAChildObjId(stmt, SPD_RID_FOR_EXPR);
        expr_analyze(expr, stat);
        /* condition expression */
        expr = spdGetAChildObjId(stmt, SPD_RID_COND_EXPR);
        expr_analyze(expr, stat);

        info_loop_add(stat, stat->stmt.objectId);
    }

    /* ʸ / ʸstackѤ / block-¹Ԥ֤ */
    return multi_next(stat);
}

SpdObjId while_stmt(SdaStatInfo *stat)
{
    SpdObjId expr;

    /* ɬ condition expression ϼ¹ */
    expr = spdGetAChildObjId(stat->stmt.objectId, SPD_RID_COND_EXPR);
    expr_analyze(expr, stat);

    if (spdGetAttrIntValByName(stat->stmt.relationId,"sort")
        ==NEXTSTMT_LOOPBACK) {
        /* loopbackˤä  */
        if (info_loopcnt_get(stat, SPD_NON_ID) > 1) {
            /* 롼פȴ */
            /* Τޤޡʸ */
            info_loop_pop(stat, SPD_NON_ID);
            return next_real_stmt(stat);
        }
    
        info_loopcnt_inc(stat);
    } else {
        info_loop_add(stat, stat->stmt.objectId);
    }

    return multi_next(stat);
}

SpdObjId do_stmt(SdaStatInfo *stat)
{
    SpdObjId expr;

    if (spdGetAttrIntValByName(stat->stmt.relationId, "sort")
        == NEXTSTMT_LOOPBACK) {
        /* loopbackˤä  */
        /* condition expression  */
        expr = spdGetAChildObjId(stat->stmt.objectId, SPD_RID_COND_EXPR);
        expr_analyze(expr, stat);
        if (info_loopcnt_get(stat, SPD_NON_ID) > 1) {
            /* 롼פȴ */
            /* Τޤޡʸ */
            info_loop_pop(stat, SPD_NON_ID);
            return next_real_stmt(stat);
        }
        info_loopcnt_inc(stat);
    } else {
        info_loop_add(stat, stat->stmt.objectId);
    }

    return multi_next(stat);
}

SpdObjId getCatchStmt_common(SpdObjId stmt, int type)
{
    SpdObjId    t_stmt = stmt;

    while (1) {
        int         sort;
        SpdObjId    up = spdGetAParentObjId(stmt, SPD_RID_BLOCK_STMT);

        if (up == SPD_NON_ID) {
            up = spdGetAParentObjId(stmt, SPD_RID_CONTROL_BODY);
        }
        if (up == SPD_NON_ID) {
            up = spdGetAParentObjId(stmt, SPD_RID_ELSE_BODY);
        }
        if (up == SPD_NON_ID) {
            /* 
             * spdError("Parent block not exist (%d).\n", t_stmt);
             */
            spdWarning("%d: Parent block not exist.\n", t_stmt);
            return (SPD_NON_ID);
        }

        stmt = up;
        sort = spdGetAttrIntValByName(stmt, "sort");
    
        if (sort == STATE_WHILE || sort == STATE_DO || sort == STATE_FOR) {
            return (stmt);
        }

        if (type < 3 && sort == STATE_SWITCH) {
            /* breakcatch롥 */
            return (stmt);
        }

        if (type < 2 && sort == STATE_IF) {
            /* ctrl blockơ */
            return (stmt);
        }
    }
    /* Not reach here. */
}

SpdObjId getStmtCatch_loop(SpdObjId stmt)
{
    return getCatchStmt_common(stmt, 3);
}

SpdObjId getStmtCatch_break(SpdObjId stmt)
{
    return getCatchStmt_common(stmt, 2);
}

SpdObjId getStmtCatch_ctrl(SpdObjId stmt)
{
    return getCatchStmt_common(stmt, 1);
}

SpdObjId break_stmt(SdaStatInfo *stat)
{
    /* upper block switchǤʤʤ */
    /* 롼ץåҤȤġ */
    SpdObjId blk = getStmtCatch_break(stat->stmt.objectId);
    if (spdGetAttrIntValByName(blk, "sort") != STATE_SWITCH)
        info_loop_pop(stat, blk);

    /* ʸ+֤ Ԥå */
    return multi_next(stat);
}

SpdObjId goto_stmt(SdaStatInfo *stat)
{
    SpdObjId up;
    SpdRel   nxt_stmt;

    /* ư褬ɤloop֥åäƤ뤫Ĵ٤ */
    nxt_stmt = spdGetAChildRel(stat->stmt.objectId, SPD_RID_NEXT_STMT);
    up = getStmtCatch_loop(nxt_stmt.objectId);

    /* ޤǤΥ֥åloopåä */ 
    while (stat->lpq->elem > 0) {
        SpdObjId lp_blk = info_loop_top(stat);
        if (lp_blk == up)
            break;
        info_loop_pop(stat, SPD_NON_ID);
    }

    /* ߤξ֤Ǽʸ */
    stat->stmt = nxt_stmt;
    
    return nxt_stmt.objectId;
}

static void decl_stmt(SdaStatInfo *stat)
{
    SpdIdSet decrs = 
        spdGetChildObjIdSet(stat->stmt.objectId, SPD_RID_DECL_DECL);
    SetCursor csr;
    
    for (csr = spdSetCursorCreate(decrs); spdSetCursorNext(&csr);) {
        SpdObjId decr = spdSetGetValueO(csr.curElem->value);
        SpdObjId init = spdGetAChildObjId(decr, SPD_RID_DECL_OPT);
        SpdObjId expr = spdGetAChildObjId(init, SPD_RID_INIT_EXPR);

        if (expr != SPD_NON_ID) {
            /* Intialize expression */
            SpdObjId ident = spdGetAChildObjId(decr, SPD_RID_DECL_IDENT);
            SpdObjId area  = spdGetAChildObjId(ident,SPD_RID_IDENT_SAREA);

            expr_analyze(expr, stat);
            info_add_def(area, decr, stat); /* expr褤 */
        }
    }
    spdFreeSet2(decrs);

    return;
}

/* 
 * ؿɲ
 *  decr줿Ȥߤʤ
 */

static void parm_add(SdaStatInfo *stat, SpdSet2 decls)
{
    SetCursor csr;

    for (csr = spdSetCursorCreate(decls); spdSetCursorNext(&csr);) {
        SpdObjId decl  = spdSetGetValueO(csr.curElem->value);
        SpdObjId decr  = spdGetAChildObjId(decl, SPD_RID_DECL_DECL);
        SpdObjId ident = spdGetAChildObjId(decr, SPD_RID_DECL_IDENT);
        SpdObjId area  = spdGetAChildObjId(ident,SPD_RID_IDENT_SAREA);
    
        if (area != SPD_NON_ID) {
            /* ݥ󥿤ʤɤϡƵŪƤȤߤʤ٤ */
            info_add_def(area, decr, stat);
        }
    }
}

SpdObjId stmt_analy(SdaStatInfo *stat)
{
    SpdObjId expr;
    SpdObjId stmt = stat->stmt.objectId;
    int sort      = spdGetAttrIntValByName(stmt, "sort");
    int cid  = spdGetClassId(stmt);
    SpdRel nxt_rel = spd_non_id_rel;

    if (verbose_flag) {
        printf("A: %d(%d) %d\n",
               stat->stmt.objectId,
               spdGetAChildObjId(stat->stmt.objectId, SPD_RID_STMT_EXPR),
               stat->stmt.relationId);
    }

    if (cid == SPD_CID_DECLARATION || cid == SPD_CID_LABEL) {
        /* ξ*/
        if (cid == SPD_CID_DECLARATION)
            decl_stmt(stat);
        /* ʸμƱ */
        nxt_rel = spdGetAChildRel(stmt, SPD_RID_NEXT_STMT);
        stat->stmt = nxt_rel;
        return nxt_rel.objectId;
    }

    if (cid == SPD_CID_SDAFUNC) {
        /* ŪʺǸʸ */
        make_global_out(stat);
        
        stat->stmt = nxt_rel;
        return nxt_rel.objectId;
    }

    switch (sort) {

      default:
        spdErrorExit("Unknown statement sort(%d:%d)\n", stmt, sort);
        /* EXIT */

      case STATE_IF:
      case STATE_SWITCH:
        execq_add_stmt(stat, stat->stmt);
        expr = spdGetAChildObjId(stmt, SPD_RID_COND_EXPR); /* Ｐ */
        expr_analyze(expr, stat);
        return multi_next(stat);

      case STATE_FOR:
        execq_add_stmt(stat, stat->stmt);
        return for_stmt(stat);
      case STATE_DO:
        execq_add_stmt(stat, stat->stmt);
        return do_stmt(stat);               /* ǽ */
      case STATE_WHILE:
        execq_add_stmt(stat, stat->stmt);
        return while_stmt(stat);            /* ǽ */

      case STATE_NORMAL:                    /* ̾ʸ */
        expr = spdGetAChildObjId(stmt, SPD_RID_STMT_EXPR);
        expr_analyze(expr, stat);

        nxt_rel = spdGetAChildRel(stmt, SPD_RID_NEXT_STMT);
        stat->stmt = nxt_rel;
        return nxt_rel.objectId;

      case STATE_CONTINUE:
        nxt_rel = spdGetAChildRel(stmt, SPD_RID_NEXT_STMT);
        stat->stmt = nxt_rel;
        return nxt_rel.objectId;
    
      case STATE_BREAK:  return break_stmt(stat);

      case STATE_GOTO:   return goto_stmt(stat); 

      case STATE_RETURN:
        /* func-out֥Ȥί٤ (̤) */
        expr = spdGetAChildObjId(stmt, SPD_RID_RETURN_EXPR);
        expr_analyze(expr, stat);
        nxt_rel = spdGetAChildRel(stmt, SPD_RID_NEXT_STMT);
        stat->stmt = nxt_rel;
        return nxt_rel.objectId;

      case STATE_BLOCK:     /* ǽʳ¸ߤʤϤ(trv_mode=0ΤȤ) */
        stat->stmt = spdGetAChildRel(stmt, SPD_RID_NEXT_STMT);
        return nxt_rel.objectId;
    }

    /* Not reach here. */
}

void main_loop(SpdObjId vstmt, SpdSet2 parm_decls)
{
    /* int         body_ref_cnt = 0; */
    SdaStatInfo *stat;
    SpdRel      nxt_rel = spdGetAChildRel(vstmt, SPD_RID_SFUNC_STMT);

    if (nxt_rel.objectId == SPD_NON_ID) return; /* ؿ */

    stat = info_init();
    stat->stmt = nxt_rel;
    current_vstmt = vstmt;

    parm_add(stat, parm_decls);

    waitq_init();
    waitq_add_stmt(stat, spd_non_id_rel);

    while (waitq_size() > 0) {              /* åˤʤޤǲ */
        stat = getNextStmt(NULL);
        while (stat != NULL) {
            /* 
             * if (stat->stmt.objectId == vstmt && ++body_ref_cnt != 0) {
             *     info_free(stat);
             *     break;
             * }
             */
            
            /* stmtμˤäơ exprβϤԤʤ */
            stmt_analy(stat);

            /*  stmt롿åѤ */
            stat = getNextStmt(stat);
        }
    }

    waitq_free();
}

void find_body(void)
{
    SpdIdSet funcs, files;
    SetCursor csr;
    
    files = spdGetClassExtentP(SPD_CID_FILE); /* no need to free */
    funcs = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
    global_var = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_KEY_IS_VALUE);
    
    /* for each file */
    for (csr = spdSetCursorCreate(files); spdSetCursorNext(&csr);) { 
        SetCursor csr_d;

        SpdIdSet decls = spdGetChildObjIdSet(
            spdSetGetValueO(csr.curElem->value), SPD_RID_FILE_DECL);

        /* for each decl */
        for (csr_d = spdSetCursorCreate(decls); spdSetCursorNext(&csr_d);) {
            int sort;
            SpdObjId decl;

            decl = spdSetGetValueO(csr_d.curElem->value);
            sort = spdGetAttrIntValByName(decl, "sort");
        
            if (sort == DECL_NORMAL) {
                /* ѿγǼ */
                SpdIdSet decrs = spdGetChildObjIdSet(decl, SPD_RID_DECL_DECL);
                SetCursor csr_r;

                for (csr_r = spdSetCursorCreate(decrs);
                     spdSetCursorNext(&csr_r);) {
                    SpdObjId decr, ident;

                    decr = spdSetGetValueO(csr_r.curElem->value);
                    ident = spdGetAChildObjId(decr, SPD_RID_DECL_IDENT);
                    spdAddElemOK(global_var, ident);
                }
                spdFreeSet2(decrs);

            } else if (sort == DECL_FUNCDEF){
                /* ؿγǼ */
                spdAddElemOK(funcs, decl);
            }
        }
        spdFreeSet2(decls);
    }
    
    for (csr = spdSetCursorCreate(funcs); spdSetCursorNext(&csr);) {
        /* For each func. */
        SpdObjId    decl = spdSetGetValueO(csr.curElem->value);
        SpdObjId    vstmt = spdGetAChildObjId(decl, SPD_RID_FUNC_SFUNC);
        SpdObjId    decr= spdGetAChildObjId(decl, SPD_RID_DECL_DECL);
        SpdObjId    opt = spdGetAChildObjId(decr, SPD_RID_DECL_OPT);
        SpdSet2     parms = spdGetChildObjIdSet(opt, SPD_RID_FUNC_PARM);

        if (vstmt != SPD_NON_ID) {
            if (verbose_flag) {
                spdMessage("=-=-=-=-=-Func Start(%d)-=-=-=-=-=\n", vstmt);
            }
            main_loop(vstmt, parms);
        }
        spdFreeSet2(parms);
    }
    spdFreeSet2(funcs);
}

/*
 * BlockФarea롥
 */

void create_decl_area(void)
{
    SpdIdSet decrs;
    SetCursor csr;

    decrs = spdGetClassExtentP(SPD_CID_DECLARATOR); /* no need to free */

    for (csr = spdSetCursorCreate(decrs); spdSetCursorNext(&csr);) {
        int         sort;
        SpdObjId    decr;

        decr = spdSetGetValueO(csr.curElem->value);
        sort = spdGetAttrIntValByName(decr, "sort");
        if (sort == DECL_VARIABLE || sort == DECL_PARMTYPE) {
            sdaCreateArea(decr);
        }
    }
}

void opt_analyze(int argc, char *argv[])
{
    char c;

    while ((c = getopt(argc, argv, "d:ntv")) != EOF) {
        switch (c) {
          case 'd':             /* Directory for SDB. */
            spdSetSDBdir(optarg);
            break;
          case 'n': 
            not_write_db ^= 1;
            break;
          case 't': 
            only_traverse_flag ^= 1;
            break;
          case 'v':
            verbose_flag ^= 1;
            break;
          default:
            spdErrorExit("'%c': Invalid option.\n", c);
            break;
        }
    }
}

int main(int argc, char *argv[])
{
    int     md1, md2, md3, md4, md5;
    int     db;

    spdInitialize(spdBasename(argv[0]));
    opt_analyze(argc, argv);

    md1 = spdUseModel(&I_model);
    md2 = spdUseModel(&Stmt_model);
    md3 = spdUseModel(&SDA_model);
    md4 = spdUseModel(&TypeView_model);
    md5 = spdUseModel(&SDAarea_model);
    db = spdOpenSDB();

    spdCreateDB(md5, db);
    spdReadDB(md4, db);
    spdReadDB(md1, db);
    spdReadDB(md2, db);
    spdReadDB(md3, db);

    create_decl_area();
    find_body();
    if (!not_write_db) {
        spdCommitDB(md3, db);
        /* SDAarea_model is not used except in this program. */
        /* 
         * spdCommitDB(md5, db);
         */
    }

    return (EXIT_SUCCESS);
}
