/* 
 * Program:             $RCSfile: statinfo.h,v $  $Revision: 30.5 $
 * 
 * Purpose:
 *
 * Author:              T.Suzuki  1998/10/22
 *                      S.Yamamoto  1997/10/22
 *
 * (C) Copyright:       T.Suzuki and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef _STAT_INFO_H
#define _STAT_INFO_H

typedef struct _SdaStatInfo {
    /* stmt */
    SpdRel    stmt;
    /* ref-def map (SpdObjId -> SpdQueue). */
    SpdSet2   rdmp;
    /* Loop stack (SpdObjId -> int). */
    SpdQueue  *lpq;
    SpdQueue  *lpqc;

} SdaStatInfo;

extern SdaStatInfo*info_init(void);
extern void        info_free(SdaStatInfo *inf);
extern void        info_loop_add(SdaStatInfo *inf, SpdObjId lp_stmt);
extern SpdObjId    info_loop_top(const SdaStatInfo *inf);
extern int         info_loopcnt_get(const SdaStatInfo *inf, SpdObjId lp_stmt);
extern int         info_loopcnt_inc(SdaStatInfo *inf);
extern SpdObjId    info_loop_pop(SdaStatInfo *inf, SpdObjId blk);


extern SdaStatInfo*check_already_exec(SdaStatInfo *inf);
extern SdaStatInfo*info_dup(const SdaStatInfo *inf);

extern int         info_reduce_rdmp(SdaStatInfo *inf1, SdaStatInfo *inf2);

extern SpdQueue* info_get_def(const SdaStatInfo *inf, SpdObjId stmt);
extern void      info_del_def(SdaStatInfo *inf, SpdObjId def);
extern void      info_add_r_ds(SdaStatInfo*inf, SpdObjId ref, SpdIdSet defs);
extern void      info_add_r_d(SdaStatInfo *inf, SpdObjId ref, SpdObjId def);

#endif /* _STAT_INFO_H */
