import wapid.access.*;
import java.util.*;

public class Restructure {
    static int currentoffset = 0;

    public static void main(String args[]) {
        Access ac = new Access();
        ac.load(args[0]);

        for (Iterator m = ac.getObjects("File");m.hasNext();) {
            WpdFile wf = (WpdFile)m.next();
            for (Iterator n = wf.getNodesOffsetOrderWithoutComment();n.hasNext();) {
                WpdNode wn = (WpdNode)n.next();
                printNode(wn);
            }

        }
    }

    static void printNode(WpdNode wn) {
        if (wn.getClassName().equals("Element")) {
            for (Iterator m = wn.getTags();m.hasNext();) {
                WpdTag wt = (WpdTag)m.next();
                if (wt.getClassName().equals("Starttag")) {
                    String s = new String();
                    System.out.print("<" + wt.getName());
                    currentoffset += 1 + wt.getName().length();
                    
                    for (Iterator n = wn.getAttributesOffsetOrder();n.hasNext();) {
                        WpdAttribute wa = (WpdAttribute)n.next();
                        for (;currentoffset < wa.getOffset();currentoffset++) {
                            System.out.print(" ");
                        }
                        System.out.print(wa.getNameAndValue());
                        currentoffset += wa.getLength();
                    }
                    for (;currentoffset < wt.getOffset() + wt.getLength()-1;currentoffset++) {
                        System.out.print(" ");
                    }
                        
                    System.out.print(">");
                    currentoffset++;
                    for (Iterator n = wn.getChildNodesOffsetOrder();n.hasNext();) {
                        WpdNode wn2 = (WpdNode)n.next();
                        printNode(wn2);
                    }
                } else if (wt.getClassName().equals("Emptytag")) {
                    System.out.print("<" + wt.getName());
                    currentoffset += 1 + wt.getName().length();

                    for (Iterator n = wn.getAttributesOffsetOrder();n.hasNext();) {
                        WpdAttribute wa = (WpdAttribute)n.next();
                        for (;currentoffset < wa.getOffset();currentoffset++) {
                            System.out.print(" ");
                        }
                        System.out.print(wa.getNameAndValue());
                        currentoffset += wa.getLength();
                    }
                    for (;currentoffset < wt.getOffset() + wt.getLength()-2;currentoffset++) {
                        System.out.print(" ");
                    }
                    System.out.print("/>");
                    currentoffset += 2;
                }
            }
            for (Iterator m = wn.getTags();m.hasNext();) {
                WpdTag wt = (WpdTag)m.next();
                if (wt.getClassName().equals("Endtag")) {
                    System.out.print("</" + wt.getName());
                    currentoffset += 2 + wt.getName().length();
                    for (;currentoffset < wt.getOffset() + wt.getLength()-2;currentoffset++) {
                        System.out.print(" ");
                    }
                    System.out.print(">");
                    currentoffset += 1;
                }
            }

        } else if (wn.getClassName().equals("Text")) {
            System.out.print(wn.getText());
            currentoffset += wn.getLength();
        } else if (wn.getClassName().equals("Script")) {
            System.out.print(wn.getScript());
            currentoffset += wn.getLength();
        } else if (wn.getClassName().equals("Comment")) {
            System.out.print(wn.getComment());
            currentoffset += wn.getLength();
        } else if (wn.getClassName().equals("Xmldecl")) {
            System.out.print("<?xml");
            currentoffset += 5;
            for (Iterator n = wn.getAttributesOffsetOrder();n.hasNext();) {
                WpdAttribute wa = (WpdAttribute)n.next();
                for (;currentoffset < wa.getOffset();currentoffset++) {
                    System.out.print(" ");
                }
                System.out.print(wa.getNameAndValue());
                currentoffset += wa.getLength();
            }
            for (;currentoffset < wn.getOffset() + wn.getLength()-2;currentoffset++) {
                System.out.print(" ");
            }
            System.out.print("?>");
            currentoffset += 2;

        } else if (wn.getClassName().equals("Doctypedecl")) {
	    int length = 0;
            System.out.print("<!DOCTYPE " + wn.getRootName() + " " + wn.getPublicOrSystem() + " " + wn.getPublicIdent());
	    if (!wn.getSystemIdent().equals("")) {
		System.out.print(" " + wn.getSystemIdent());
		length += 1 + wn.getSystemIdent().length();
	    } 	    
	    if (!wn.getInnerDtd().equals("")) {
		System.out.print(" " + wn.getInnerDtd());
		length += 1 + wn.getInnerDtd().length();
	    }
	    length += 12 + wn.getRootName().length() + wn.getPublicOrSystem().length() + wn.getPublicIdent().length();

	    for (;length < wn.getLength()-1;length++) {
		System.out.print(" ");
	    }            
            System.out.print(">");
            currentoffset += wn.getLength();
        }
    }

        
}
/*
class WpdObjectComparator implements Comparator{
    public int compare(Object o1,Object o2){
        WpdObject wo1=(WpdObject)o1;
        WpdObject wo2=(WpdObject)o2;
        if(wo1.getOffset()<wo2.getOffset()){
            return -1;
        }else if(wo1.getOffset()>wo2.getOffset()){
            return 1;
        }else{
            return 0;
        }       
    }
}
*/          

