/* 
 * Program:             $RCSfile: SpdMsg.java,v $
 * 
 * Purpose:             
 * 
 * Author:              K.Niimi  2003/09/04
 *                      S.Yamamoto  2003/09/04
 * 
 * (C) Copyright:       K.Niimi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SpdMsg.java,v 50.6 2003/10/14 15:00:04 yamamoto Exp yamamoto $
 */

package sapid.util;

import java.io.*;

/**
 * åɽ饹
 *
 * @author K.Niimi and S.Yamamoto
 */

public class SpdMsg
{
    /* ץ̾ */
    private static String progName = null;

    /** ץȤΥץեå */
    private static String projectName = "Sapid";
    
    /** ܺ٥åϤ뤫ݤ? */
    private static boolean isVerboseMode = false;

    /** ǥХååФݤ? */
    private static boolean isDebugMode = false;
    
    /** ץ̾ꤹ롥 */
    public static void setProgramName(String name) {
        progName = name;
    }
    /** ץ̾롥 */
    public static String getProgramName() {
        return progName;
    }

    /** ץ̾ꤹ롥 */
    public static void setProjectName(String name) {
        projectName = name;
    }
    /** ץ̾롥 */
    public static String getProjectName() {
        return projectName;
    }
    
    /** ܺ٥å⡼ɤꤹ롥 */
    public static void setVerboseMode(boolean mode) {
        isVerboseMode = mode;
    }
    /** ܺ٥å⡼ɤݤ? */
    public static boolean isVerboseMode() {
        return isVerboseMode;
    }

    /** ǥХåå⡼ɤꤹ롥 */
    public static void setDebugMode(boolean mode) {
        isDebugMode = mode;
    }
    /** ǥХåå⡼ɤݤ? */
    public static boolean isDebugMode() {
        return isDebugMode;
    }
    
    // -----------------------------------------------------------------

    /**
     * Prints message to stderr.
     */
    public static void message(Object str) {
        printError(projectName, str);
    }

    /**
     * Prints verbose message to stderr.
     */
    public static void verbose(Object str) {
        if (isVerboseMode) {
            printError(projectName, str);
        }
    }

    // -----------------------------------------------------------------

    /**
     * Prints warning message to stderr.
     */
    public static void warning(Object str) {
        printError("Warning", str);
    }

    /**
     * Prints warning message and stack trace to stderr.
     */
    public static void warning(Object str, Exception e) {
        printError("Warning", str);
        //e.printStackTrace();
        printStackTrace("Warning",e);
    }
    
    // -----------------------------------------------------------------

    /**
     * Prints error message to stderr.
     */
    public static void error(Object str) {
        printError("Error", str);
    }

    /**
     * Prints error message and stack trace to stderr.
     */
    public static void error(Object str, Exception e) {
        printError("Error", str);
        //e.printStackTrace();
        printStackTrace("Error",e);
    }
    
    /**
     * Prints error message to stderr, and then exit.
     */
    public static void errorExit(Object str) {
        printError("Error", str);
        System.exit(1);
    }
    
    /**
     * Prints error message and stack trace to stderr, and then exit.
     */
    public static void errorExit(Object str, Exception e) {
        printError("Error", str);
        //e.printStackTrace();
        printStackTrace("Error",e);
        System.exit(1);
    }
    
    // -----------------------------------------------------------------

    /**
     * Prints debug message to stderr.
     */
    public static void debug(Object str) {
        if (isDebugMode) {
            printError("Debug", str);
        }
    }

    // -----------------------------------------------------------------

    /**
     * prefix̵ΥåϤ롥
     */
    public static void println(Object str) {
        System.out.println(str);
    }
    
    /** ԤϤ롥 */
    public static void println() {
        System.out.println();
    }
    
    // -----------------------------------------------------------------

    /** stdoutؽϤ롥 */
    private static void printOut(String prefix, Object str) {
        System.out.flush();
        System.err.flush();
        if (progName == null) {
            System.out.println(prefix + ": " + str);
        } else {
            System.out.println(prefix + ": " + progName + ": " + str);
        }
        System.out.flush();
    }

    /** stderrؽϤ롥 */
    private static void printError(String prefix, Object str) {
        System.out.flush();
        System.err.flush();
        if (progName == null) {
            System.err.println(prefix + ": " + str);
        } else {
            System.err.println(prefix + ": " + progName + ": " + str);
        }
        System.err.flush();
    }

    /** print stack trace */
    private static void printStackTrace(String prefix,Exception e){
        printError(prefix,e.toString());
        StackTraceElement[] elem = e.getStackTrace();
        for(int i=0;i<elem.length;i++){
            if(i==0){
                printError(prefix,elem[i]);
            } else {
                printError(prefix,"      "+elem[i]);
            }
            
            

        }
    }
    
}
