/*  
 * Program:             $RCSfile: JSXTComment.java,v $  $Revision: 50.6 $
 * 
 * Purpose:             Comment (TerminalNode).
 *                      child: 
 * 
 * Author:              S.Takeshi  2003/08/03
 *                      S.Yamamoto  2003/08/03
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: JSXTComment.java,v 50.6 2003/08/12 06:36:40 yamamoto Exp yamamoto $
 */

package wapid.jsxmodel;

import wapid.parser.js.*;

public class JSXTComment extends JSXTMetaNode {
    public String node_name = "comment";

    /** save expression sort */
    public int commentSort;

    public static final int NOT_SORTED = -1;
    
    public static final int SINGLE = 0;
    public static final int MULTI = 1;
    
    /** constructor */
    public JSXTComment(int depth, Token firstToken, Token lastToken, int sort) {
        super(depth, firstToken, lastToken);
        super.node_type = COM;
        setNodeName(node_name);
        this.commentSort = sort;
        this.isTerminalNode = true;     
    }
    
    /** int to Stirng : XML attribute */
    public String toAttribute(){
        StringBuffer sb = new StringBuffer(" sort=\"");
        switch(commentSort){        
            case SINGLE:
                sb.append("Single");
                break;
            case MULTI:
                sb.append("Multi");
                break;
            default:
                sb.append("NOT_SORTED");
                break;
        }
        sb.append("\" ");
        return sb.toString();
    }
}
