/*  
 * Program:             $RCSfile: JSXTEndOfLine.java,v $  $Revision: 50.7 $
 * 
 * Purpose:             EndOfLine (TerminalNode).
 *                      child: 
 * 
 * Author:              S.Takeshi  2003/08/03
 *                      S.Yamamoto  2003/08/03
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: JSXTEndOfLine.java,v 50.7 2003/08/14 07:22:31 yamamoto Exp yamamoto $
 */

package wapid.jsxmodel;

import wapid.parser.js.*;

public class JSXTEndOfLine extends JSXTMetaNode {
    public String node_name = "nl";

    /** save comment sort */
    protected int commentSort;

    public static final int NOT_SORTED = -1;
    
    /** constructor */
    public JSXTEndOfLine(int depth, Token firstToken, Token lastToken) {
        super(depth, firstToken, lastToken);
		super.node_type = EOL;
        setNodeName(node_name);
        this.isTerminalNode = true;
    }
    
    /** get line num */
    public String getLineNum(){
    	 return "line=\""+firstToken.beginLine+"\"";
    }

	/** get char offset */
	public String getCharOffset(){
		 return "coffset=\""+firstToken.beginColumn+"\"";
	}

}
