/*  
 * Program:             $RCSfile: JSXTFunctionDeclaration.java,v $  $Revision: 50.6 $
 * 
 * Purpose:             FunctionDeclaration (NonTerminalNode).
 *                      child: 
 * 
 * Author:              S.Takeshi  2003/08/03
 *                      S.Yamamoto  2003/08/03
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: JSXTFunctionDeclaration.java,v 50.6 2003/08/12 06:36:43 yamamoto Exp yamamoto $
 */

package wapid.jsxmodel;

import wapid.parser.js.*;

public class JSXTFunctionDeclaration extends JSXTMetaNode {
    public int node_type = FUNDEC;
    public String node_name = "FunDec";

    /** save statement sort */
    protected int functionSort;
    
    public static final int NAMED = 0;
    public static final int ANONYMOUS = 1;

    public JSXTFunctionDeclaration(int depth, Token firstToken, Token lastToken,
				   int sort) {
        super(depth, firstToken, lastToken);
        setNodeName(node_name);
        this.functionSort = sort;
    }
    
    /** int to Stirng : XML attribute */
    public String toAttribute(){
        StringBuffer sb = new StringBuffer(" sort=\"");
        switch(functionSort){
            case NAMED:
                sb.append("Named");
                break;    
            case ANONYMOUS:
                sb.append("Anonymous");
                break;          
            default:
                sb.append("NOT_SORTED");
                break;
        }
        sb.append("\"");
        return sb.toString();
    }
}
