/*  
 * Program:             $RCSfile: JSXTLiteral.java,v $  $Revision: 50.6 $
 * 
 * Purpose:             literal (TerminalNode).
 * 
 * Author:              S.Takeshi  2003/08/03
 *                      S.Yamamoto  2003/08/03
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: JSXTLiteral.java,v 50.6 2003/08/12 06:20:33 yamamoto Exp yamamoto $
 */

package wapid.jsxmodel;

import wapid.parser.js.*;

public class JSXTLiteral extends JSXTMetaNode {

    public int node_type = LITERAL;
    public String node_name = "literal";
    private String literalName = null;
    private String literalSort = null;

    public JSXTLiteral(int depth, Token firstToken, Token lastToken, String literal_sort) {
        super(depth, firstToken, lastToken);
        setNodeName(node_name);
        super.isTerminalNode = true;
        this.literalName = firstToken.image;
        this.literalSort = literal_sort;
    }
    
    public void setName(String literalName) {
        this.literalName = literalName.intern();
    }
    
    /** int to Stirng : XML attribute */
    public String toAttribute(){
        StringBuffer sb = new StringBuffer(" sort=\"");
        sb.append(literalSort);
        sb.append("\" ");
        return sb.toString();
    }
}
