/*  
 * Program:             $RCSfile: JSXTStatement.java,v $  $Revision: 50.6 $
 * 
 * Purpose:             Statement (NonTerminalNode).
 *                      child: 
 * 
 * Author:              S.Takeshi  2003/08/03
 *                      S.Yamamoto  2003/08/03
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: JSXTStatement.java,v 50.6 2003/08/12 06:20:39 yamamoto Exp yamamoto $
 */

package wapid.jsxmodel;

import wapid.parser.js.*;

public class JSXTStatement extends JSXTMetaNode {

    public int node_type = STMT;
    public String node_name = "Stmt";

    /** save statement sort */
    protected int statementSort;
    
    public static final int BLOCK = 0;
    public static final int VARIABLE = 1;
    public static final int EMPTY = 2;
    public static final int EXPRESSION = 3;
    public static final int IF = 4;
    public static final int DOWHILE = 5;
    public static final int WHILE = 6;
    public static final int FOR = 7;
    public static final int CONTINUE = 8;
    public static final int BREAK = 9;
    public static final int RETURN = 10;
    public static final int WITH = 11;
    public static final int LABELLED = 12;
    public static final int SWITCH = 13;
    public static final int THROW = 14;
    public static final int TRY = 15;
    

    public JSXTStatement(int depth, Token firstToken, Token lastToken, int sort) {
        super(depth, firstToken, lastToken);
        setNodeName(node_name);
        this.statementSort = sort;
    }
    
    /** int to Stirng : XML attribute */
    public String toAttribute(){
        StringBuffer sb = new StringBuffer(" sort=\"");
        switch(statementSort){
            case BLOCK:
                sb.append("Block");
                break;    
            case VARIABLE:
                sb.append("Var");
                break;
            case EMPTY:
                sb.append("Empty");
                break;
            case EXPRESSION:
                sb.append("Expr");
                break;                
            case IF:
                sb.append("If");
                break;                           
            case DOWHILE:
                sb.append("DoWhile");
                break;                
            case WHILE:
                sb.append("While");
                break;                
            case FOR:
                sb.append("For");
                break;
            case CONTINUE:
                sb.append("Continue");
                break;                
            case BREAK:
                sb.append("Break");
                break;                
            case RETURN:
                sb.append("Return");
                break;                                
            case WITH:
                sb.append("With");
                break;
            case LABELLED:
                sb.append("Labelled");
                break;
            case SWITCH:
                sb.append("Switch");
                break;                
            case THROW:
                sb.append("Throw");
                break;                
            case TRY:
                sb.append("Try");
                break;                               
            default:
                sb.append("NOT_SORTED");
                break;
        }

        sb.append("\"");
        return sb.toString();
        
    }

}
