/*  
 * Program:             $RCSfile: CSSGenerator.java,v $  $Revision: 50.2 $
 * 
 * Purpose:             CSS generator.
 * 
 * Author:              S.Takeshi  2003/09/06
 *                      S.Yamamoto  2003/09/06
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: CSSGenerator.java,v 50.2 2003/09/07 07:28:56 yamamoto Exp yamamoto $
 */

package wapid.jsxmodel.xref;

/**
 * CSS generator.
 */

import java.io.*;

public class CSSGenerator {

	public CSSGenerator() {
	}

	/**
	 * CSS 
	 * @param outputFileName
	 */
	public void makeCSS(String outputFileName) {
		try {
			int bottomMarginLineNum = 25;
			FileWriter w = new FileWriter(outputFileName);

			w.write("body { background-color: #FFFFFF; }");

			w.write("p{");
			w.write("font-size:16px;");
			w.write("font-style: normal;");
			w.write("line-height: 20px;");
			w.write("background-color: #FFEEBB;");
			w.write("border-left: 6px solid #EEBB88;");
			w.write("padding-left: 6px;");
			w.write("}\n");

			w.write("pre {");
			w.write("font-style : normal;");
			w.write("font-size : 12px;");
			w.write("line-height : 16px;");
			w.write("color : #000000;");
			w.write("border : 1px solid #000000;");
			w.write("padding : 6px;");
			w.write("background-color : #DDDDDD;");
			w.write("}\n");
			
			w.write("a:link {");
			w.write("color : #0000FF;");
			w.write("text-decoration : none;");
			w.write("}\n");
			w.write("a:visited {");
			w.write("color : #CC0000;");
			w.write("text-decoration : none;");
			w.write("}\n");
			w.write("a:hover {");
			w.write("color : #DDAA77;");
			w.write("background-color : #FFEEBB;");
			w.write("text-decoration : underline;");
			w.write("}\n");
			w.write("a:active {");
			w.write("color : #CC0066;");
			w.write("text-decoration : none;");
			w.write("}\n");
					
			w.flush();
			w.close();
		} catch (Exception e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}
}
