/*  
 * Program:             $RCSfile: FunctionHandler.java,v $  $Revision: 50.2 $
 * 
 * Purpose:             
 * 
 * Author:              S.Takeshi  2003/09/06
 *                      S.Yamamoto  2003/09/06
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: FunctionHandler.java,v 50.2 2003/09/07 07:28:56 yamamoto Exp yamamoto $
 */

package wapid.jsxmodel.xref;

import wapid.jsxmodel.xsapid.*;
import java.util.*;

public class FunctionHandler {

	final SpdElementFilter JSX_VARDEC = new SpdElementFilterByName("VarDec");
	final SpdElementFilter JSX_IDENT = new SpdElementFilterByName("ident");
	final SpdElementFilter JSX_EXPR = new SpdElementFilterByName("Expr");
	final SpdElementFilter JSX_PARAM = new SpdElementFilterByName("Param");

	/**
	 * 
	 * @param fl
	 * @return
	 */
	public Vector getFunctions(SpdElementList fl) {
		// tmporaly
		SpdElement funNameIdent, curFun;
		Vector funList = new Vector();
		SymbolTableFunction stf = null;

		for (int i = 0; i < fl.size(); i++) {
			curFun = fl.getElementAt(i);

			// check local variable declaration
			funNameIdent = curFun.getIndexedChild(JSX_IDENT, 1);
			stf =
				new SymbolTableFunction(
					funNameIdent.getText(),
					curFun.getText(),
					curFun.getPositionString(),
					Integer.parseInt(curFun.getID()),
					Integer.parseInt(funNameIdent.getID()),
					1);

			SpdElementList elf = curFun.searchDecendant(JSX_VARDEC);
			boolean isGrobal = false;
			VariableHandler vh = new VariableHandler(isGrobal);
			stf.STLocalVar = vh.getVariables(elf);

			// check parameters
			SpdElementList paramList = curFun.searchChild(JSX_PARAM);
			for (int j = 0; j < paramList.size(); j++) {				
				SpdElement param = paramList.getElementAt(j);
				SpdElement paramIdent = param.getIndexedChild(JSX_IDENT, 1);
				SymbolTableElement p =
					new SymbolTableElement(
						paramIdent.getText(),
						paramIdent.getPositionString(),
						Integer.parseInt(paramIdent.getID()),
						SymbolTableConstants.PARAM);
				stf.STLocalVar.add(p);
			}

			funList.add(stf);
		}
		return funList;
	}
}
