/*  
 * Program:             $RCSfile: SearchSymbolTable.java,v $  $Revision: 50.2 $
 * 
 * Purpose:             Search symbol table.
 * 
 * Author:              S.Takeshi  2003/09/06
 *                      S.Yamamoto  2003/09/06
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SearchSymbolTable.java,v 50.2 2003/09/07 07:28:57 yamamoto Exp yamamoto $
 */

/**
 * Search Symbol Table
 * 
 * @author shiki
 */

package wapid.jsxmodel.xref;

public class SearchSymbolTable {

	SymbolTable st;

	public SearchSymbolTable(SymbolTable st) {
		this.st = st;
	}

	/**
	 * search Function
	 * @param id
	 * @return
	 */
	public int searchFunction(int id) {
		int definedID = -1;
		for (int i = 0; i < st.STFunction.size(); i++) {
			SymbolTableFunction tmp =
				(SymbolTableFunction) st.STFunction.elementAt(i);
			if (tmp.funNameIdentID == id) {
				definedID = tmp.funID;
			} else {
				for (int j = 0; j < tmp.STRefFunCall.size(); j++) {
					SymbolTableReference tmp2 =
						(SymbolTableReference) tmp.STRefFunCall.elementAt(j);
					if (tmp2.identID == id) {
						definedID = tmp2.defID;
					}
				}
			}
		}

		return definedID;
	}

	/**
	 * search grobal variable
	 * @param id
	 * @return
	 */
	public int searchGrobalVar(int id) {
		int definedID = -1;
		for (int i = 0; i < st.STGrobalVar.size(); i++) {
			SymbolTableElement tmp =
				(SymbolTableElement) st.STGrobalVar.elementAt(i);
			if (tmp.symID == id) {
				definedID = tmp.symID;
			} else {
				for (int j = 0; j < tmp.usedList.size(); j++) {
					SymbolTableReference tmp2 =
						(SymbolTableReference) tmp.usedList.elementAt(j);
					if (tmp2.identID == id) {
						definedID = tmp2.defID;
					}
				}
			}
		}

		return definedID;
	}

	/**
	 * search local variable
	 * @param id
	 * @return
	 */
	public int searchLocalVar(int id) {
		int definedID = -1;
		for (int i = 0; i < st.STFunction.size(); i++) {
			SymbolTableFunction tmpFun =
				(SymbolTableFunction) st.STFunction.elementAt(i);
			for (int j = 0; j < tmpFun.STLocalVar.size(); j++) {
				SymbolTableElement tmpLocalVar =
					(SymbolTableElement) tmpFun.STLocalVar.elementAt(j);
				if (tmpLocalVar.symID == id) {
					definedID = tmpLocalVar.symID;
				} else {
					for (int k = 0; k < tmpLocalVar.usedList.size(); k++) {
						SymbolTableReference tmpEl =
							(SymbolTableReference) tmpLocalVar.usedList.elementAt(k);
						if (tmpEl.identID == id) {
							definedID = tmpEl.defID;
						}
					}
				}

			}
		}

		return definedID;
	}

}
