/*  
 * Program:             $RCSfile: VariableHandler.java,v $  $Revision: 50.2 $
 * 
 * Purpose:             VariableHander.
 * 
 * Author:              S.Takeshi  2003/09/06
 *                      S.Yamamoto  2003/09/06
 * 
 * (C) Copyright:       S.Takeshi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: VariableHandler.java,v 50.2 2003/09/07 07:28:58 yamamoto Exp yamamoto $
 */

/**
 * Variable hander.
 * 
 * @author 
 */

package wapid.jsxmodel.xref;

import wapid.jsxmodel.xsapid.*;
import java.util.*;

public class VariableHandler {

	boolean isGrobal;

	final SpdElementFilter JSX_VARDEC = new SpdElementFilterByName("VarDec");
	final SpdElementFilter JSX_IDENT = new SpdElementFilterByName("ident");
	final SpdElementFilter JSX_EXPR = new SpdElementFilterByName("Expr");

	public VariableHandler(boolean isGrobal) {
		this.isGrobal = isGrobal;
	}

	public Vector getVariables(SpdElementList elv) {

		// tmporaly
		SpdElement ie, e;
		Vector symList = new Vector();
		SymbolTableElement symEl = null;

		for (int j = 0; j < elv.size(); j++) {
			e = elv.getElementAt(j);

			// ident only			
			SpdElementList el = e.searchChild(JSX_IDENT);
			int i = 0;
			do {
				ie = el.getElementAt(i);
				if (ie != null) {
					if (isGrobal) {
						symEl = new SymbolTableElement(ie.getText(),ie.getPositionString(),Integer.parseInt(ie.getID()),SymbolTableConstants.GROBALVARIABLE);
					} else {
						symEl = new SymbolTableElement(ie.getText(),ie.getPositionString(),Integer.parseInt(ie.getID()),SymbolTableConstants.LOCALVARIABLE);
					}
					symList.add(symEl);
				}
				i++;
			} while (ie != null);

			// ident in AssignmentExpression
			SpdElementList elexpr = e.searchChild(JSX_EXPR);
			if (elexpr != null) {
				i = 0;
				do {
					ie = elexpr.getElementAt(i);
					if (ie != null) {
						ie = ie.getIndexedChild(JSX_IDENT, 1);
						if (isGrobal) {
							symEl = new SymbolTableElement(ie.getText(),ie.getPositionString(),Integer.parseInt(ie.getID()),SymbolTableConstants.GROBALVARIABLE);
						} else {
							symEl = new SymbolTableElement(ie.getText(),ie.getPositionString(),Integer.parseInt(ie.getID()),SymbolTableConstants.LOCALVARIABLE);
						}
						symList.add(symEl);
					}
					i++;
				} while (ie != null);
			}
		}
		return symList;
	}
}
