/*
 * Created on 2003/06/10
 * XSDMLElementList.java - Copyright (c) 2003 H.Yoshida
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS IS FREEWARE. NO WARRANTY.
 */

package wapid.jsxmodel.xsapid;
import wapid.jsxmodel.xsapid.SpdElement;

import java.util.*;

/**
 * XSDML Element List Class
 * @author H.Yoshida
 */
public class SpdElementList {

	protected Vector m_elementvec;

	/**
	 * The constructor.
	 */
	public SpdElementList() {
		m_elementvec = new Vector(10);
	}

	/**
	 * Add XSDML element to this list.
	 * @param e
	 */
	public void addElement(SpdElement e) {
		m_elementvec.addElement(e);
	}

	/**
	 * Add XSDML element to this list.
	 * @param e
	 */
	public SpdElement getElementAt(int num) {
		if (num>=0 && num < m_elementvec.size())
			return (SpdElement)m_elementvec.get(num);
		else return null;
	}
	
	/**
	 * Invoke handler's method for each elements in the list.
	 * @param e
	 */
	public void invokeForEach(SpdElementHandler xseh) {
		for (int i=0; i<m_elementvec.size(); i++) {
			SpdElement xe = (SpdElement)m_elementvec.get(i);
			xseh.action(xe);
		}
		
	}
	
	public int size(){
		return m_elementvec.size();
	}
}

