package wapid.parser.wxmodel;

import java.io.*;

import gnu.getopt.*;

import sapid.util.*;
/**
 * XHTMLϤ򤹤ץΥȥݥ
 *
 * @author Ken Niimi.
 *
 */
public class MkWXModel
{
    /** 󥳡ǥ󥰤ݻ */
    //private static String file_encoding = "EUC-JP";

    /** ץ२ȥݥ */
    public static void main(String args[]){
        try{
            
            //ץ̾Υå
            SpdMsg.setProjectName("Sapid");
            SpdMsg.setProgramName("WX");

            //ΤȤϤ
            if( args.length==0 ){
                SpdMsg.error("­ޤ");
                SpdMsg.println();
                printHelp();
                return;
            }

            String fileName = null;
            String outputDirName = null;
            String file_encoding = null;
            boolean compareOriginal = false;
            
            //ץΥϥɥ
            Getopt g = new Getopt("Wapid: WX:",args,"D:hve:c");
            int c;
            while((c=g.getopt())!=-1){
                switch(c){
                    case 'D':
                        outputDirName = g.getOptarg();
                        break;
                    case 'h':
                        printHelp();
                        return;
                    case 'v':
                        SpdMsg.setVerboseMode(true);
                        break;
                    case 'e':
                        file_encoding = g.getOptarg();
                        break;
                    case 'c':
                        compareOriginal = true;
                        break;
                    default:
                        break;
                }
            }

            //ϥե
            int indx = g.getOptind();
            if(indx>=args.length){
                SpdMsg.error("ϥե̾ϤƲ");
                SpdMsg.println();
                printHelp();
                return;
            }
            fileName = args[indx];

            //WXModel κ
            WXModel wxmodel = new WXModel(fileName);
            if(outputDirName!=null){
                wxmodel.setSDBName(outputDirName);
            }
            if(file_encoding!=null){
                wxmodel.setEncoding(file_encoding);
            }
            wxmodel.analyze();

            if(compareOriginal){
                SpdMsg.verbose("Compare to original source file.");
                if(wxmodel.isSameToOriginal()){
                    SpdMsg.verbose("Same to Original");
                } else {
                    SpdMsg.warning("Differ from Original");
                }
            }
        }catch(Exception e){
            SpdMsg.errorExit("Exception in MkWXModel",e);
        }
    }

    /** إפ */
    public static void printHelp(){
        SpdMsg.println("NAME");
        SpdMsg.println("   MkWXModel - WXModel maker");
        SpdMsg.println("SYNOPSIS");
        SpdMsg.println("   java wapid.parser.wxmodel.MkWXModel [options] file");
        SpdMsg.println("   -h                : Show this help.");
        SpdMsg.println("   -D                : Directory for SDB (\"SDB\").");
        SpdMsg.println("   -e                : Set output file encoding. (\"EUC-JP\").");
        SpdMsg.println("   -v                : Print verbose message.");
        SpdMsg.println("   -c                : Validate XML and Compare detagged XML and original source file.");
    }
}
