package wapid.parser.wxmodel;

/**
 * XMLϤ륯饹
 *  XMLBNF˶ᤤǤΥդ
 *
 * @author ken
 */
public class MkWXModelVisitor extends WXModelParserVisitorAdapter
{

    /** եɽ̾ */
    public static final String WX_FILE_TAG_NAME = "File";

    /** XMLDeclɽ̾ */
    public static final String WX_XMLDECL_TAG_NAME = "XMLDecl";
    
    /** DoctypeDeclɽ̾ */
    public static final String WX_DOCTYPE_DECL_TAG_NAME = "DoctypeDecl";

    /** Elementɽ̾ */
    public static final String WX_ELEMENT_TAG_NAME = "Element";

    /** ɽ̾ */
    public static final String WX_EMPTY_TAG_NAME = "Empty";

    /** °ɽ̾ */
    public static final String WX_ATTRIBUTE_TAG_NAME = "Attribute";

    /** ExternalID򼨤̾ */
    public static final String WX_EXTERNAL_ID_TAG_NAME = "ExternalID";

    /** XML-STYLESHEET򼨤̾ */
    public static final String WX_XML_STYLESHEET_TAG_NAME = "StyleSheet";
    
    /** ʸƥɽ̾ */
    public static final String WX_STRING_LITERAL_TAG_NAME = "String";
    
    /** ϥɽ̾ */
    public static final String WX_STARTTAG_TAG_NAME = "STag";

    /** γ򼨤̾ */
    public static final String WX_TAG_OPEN_TAG_NAME = "tago";

    /** Ĥ򼨤̾ */
    public static final String WX_TAG_CLOSE_TAG_NAME = "tagc";

    /** ̾򼨤̾ */
    public static final String WX_NAME_TAG_NAME = "name";

    /** SYSTEMʸɽ̾ */
    public static final String WX_SYSTEM_TAG_NAME = "system";

    /** PUBLICʸɽ̾ */
    public static final String WX_PUBLIC_TAG_NAME = "public";

    /** " ɽ̾ */
    public static final String WX_DQUOTE_TAG_NAME = "dquote";

    /** ' ɽ̾ */
    public static final String WX_SQUOTE_TAG_NAME = "squote";

    /** = ɽ̾ */
    public static final String WX_EQUAL_TAG_NAME = "eq";

    /** ƥȤɽ̾ */
    public static final String WX_TEXT_TAG_NAME = "text";

    /** Ȥɽ̾ */
    public static final String WX_COMMENT_TAG_NAME = "comment";

    /** scriptletɽ̾ */
    public static final String WX_SCRIPTLET_TAG_NAME = "scriptlet";

    /** ʸɽ̾ */
    public static final String WX_SP_TAG_NAME = "sp";

    /** ʸɽ̾ */
    public static final String WX_NL_TAG_NAME = "nl";
    
    /** ϤʸݻХåե */
    private XMLStringBuffer buffer = null;

    /** Ǹ˽ϤSpecialToken */
    private Token lastSpecialToken = null;

    /** ID */
    private WXIDFactory idFactory = null;
    
    /** 󥹥ȥ饯 */
    public MkWXModelVisitor(){
        this("EUC-JP","\n");
    }

    /** ʸɤȤ󥹥ȥ饯 */
    public MkWXModelVisitor(String encoding,String lineSep){
        idFactory = new WXIDFactory();
        
        buffer = new XMLStringBuffer();
        buffer.append("<?xml version=\"1.0\" encoding=\"" + encoding + "\"?>" + lineSep);
        buffer.append("<!DOCTYPE File SYSTEM \"WXModel.dtd\">" + lineSep);
    }
    

    
    /** ʸɽ */
    public String toString(){
        return buffer.toString();
    }


    /** SpecialToken XMLʸɽ֤ޤ */
    private String toXMLSpecialToken(String st){
        XMLStringBuffer xsb = new XMLStringBuffer();
        String tagName = getSpecialTokenTag(st);
        xsb.appendTag(toOpenTag(tagName));
        xsb.appendText(st);
        xsb.appendTag(toCloseTag(tagName));
        return xsb.toString();
    }

    /** SpecialToken Υ֤ */
    private String getSpecialTokenTag(String st){
        if(st.equals("\n")| st.equals("\r\n") | st.equals("\r") ){
            return WX_NL_TAG_NAME;
        } else if (st.startsWith("<!--")) {
            return WX_COMMENT_TAG_NAME;
        } else if (st.startsWith("<%")) {
            return WX_SCRIPTLET_TAG_NAME;
        }
        return WX_SP_TAG_NAME;
    }
    
    
    
    /** ΡɤȤ˸ƤӽФޤ */
    protected void doSpecialToken(SimpleNode node,Object data){
        Token st = node.getSpecialToken();
        if(st!=null){
            while(st.specialToken!=null){
                st = st.specialToken;
            }
            while(st!=null){
                if( (lastSpecialToken==null) || lastSpecialToken.isPre(st) ){
                    String tagName = getSpecialTokenTag(st.toString());
                    if( tagName.equals(WX_SP_TAG_NAME) ){
                        if(textBuffer==null){
                            textBuffer = new StringBuffer();
                        }
                        textBuffer.append(st.toString());
                    } else {
                        appendOpenTag(tagName);
                        appendText(st.toString());
                        appendCloseTag(tagName);
                    }
                    
                    lastSpecialToken = st;
                }
                st = st.next;                
            }
        }
    }

    /** ߤιԿ */
    private int currentLineNum = 1;
    /** ߤΥ饯եå */
    private int currentCOffset = 0;
    /** ߤΥХȥեå */
    private int currentBOffset = 0;

    /** °֤ޤ */
    private String toAttribute(String tagName){
        if(tagName.equals("nl")){
            //ʸΥեåȤʬϤޤ­ƤʤΤǡ䤷Ƥ
            String ret = " line=\"" + currentLineNum + "\""
                    + " coffset=\"" + (currentCOffset+1) + "\""
                    + " offset=\"" + (currentBOffset+1) + "\"";
            currentLineNum++;
            return ret;
        } else {
            return "";
        }
    }
    

    
    /** ϥʸɽ֤ */
    private String toOpenTag(String tagName){
        return "<"+tagName+ " id=\"" + idFactory.getID(tagName) + "\""
                + toAttribute(tagName) + ">";
    }
    /** λʸɽ֤ */
    private String toCloseTag(String tagName){
        return "</"+tagName+">";

    }

    
    /** Ϣ³TextϢ뤹뤿ΥХåե */
    private StringBuffer textBuffer = null;
    /** ХåեƥȤɤݻ */
    private boolean isTextBuffer = false;
    
    /** ץ󥿥ɲ */
    private void appendOpenTag(String tagName){
        //==============================================================
        // ڡ TextλˤϡtextBuffer˰öƤ
        // ¾ΤΤ褿ˤϡХåեʸäƤˤ,
        //   ˽ФƤ 롣
        //==============================================================
        if(textBuffer!=null){
            if(isTextBuffer){
                buffer.appendTag(toOpenTag(WX_TEXT_TAG_NAME));
            } else {
                buffer.appendTag(toOpenTag(WX_SP_TAG_NAME));
            }

            //եåȤɲ
            String wrtText = textBuffer.toString();
            currentCOffset += wrtText.length();
            currentBOffset += wrtText.getBytes().length;
    
            buffer.appendText(wrtText);
            
            if(isTextBuffer){
                buffer.appendTag(toCloseTag(WX_TEXT_TAG_NAME));
            } else {
                buffer.appendTag(toCloseTag(WX_SP_TAG_NAME));
            }
            textBuffer = null;
            isTextBuffer = false;
        }
        buffer.appendTag(toOpenTag(tagName));
    }

    /** Textɲ */
    private void appendText(String text){
        currentCOffset += text.length();
        currentBOffset += text.getBytes().length;
        buffer.appendText(text);
    }
    
    /** ɲ */
    private void appendCloseTag(String tagName){
        buffer.appendTag(toCloseTag(tagName));
    }
    
    
    /** Document */
    public Object visit(ASTdocument node, Object data){
        Object obj = null;
        appendOpenTag(WX_FILE_TAG_NAME);
        doSpecialToken(node,data);
        obj = visitChildNode(node,data);
        appendCloseTag(WX_FILE_TAG_NAME);
        return obj;
    }
    public Object visit(ASTXMLDecl node, Object data){
        Object obj = null;
        appendOpenTag(WX_XMLDECL_TAG_NAME);
        doSpecialToken(node,data);
        obj = visitChildNode(node,data);
        appendCloseTag(WX_XMLDECL_TAG_NAME);
        return obj;
    }

    public Object visit(ASTXMLDeclS node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_TAG_OPEN_TAG_NAME);
        //obj = visitChildNode(node,data);
        appendText(node.getFirstToken().toString());
        appendCloseTag(WX_TAG_OPEN_TAG_NAME);
        return obj;
    }

    public Object visit(ASTAttribute node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_ATTRIBUTE_TAG_NAME);
        obj = visitChildNode(node,data);
        appendCloseTag(WX_ATTRIBUTE_TAG_NAME);
        return obj;
    }

    public Object visit(ASTIdentifier node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_NAME_TAG_NAME);
        //obj = visitChildNode(node,data);
        appendText(node.getFirstToken().toString());
        appendCloseTag(WX_NAME_TAG_NAME);
        return obj;
    }

    public Object visit(ASTEq node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_EQUAL_TAG_NAME);
        //obj = visitChildNode(node,data);
        appendText(node.getFirstToken().toString());
        appendCloseTag(WX_EQUAL_TAG_NAME);
        return obj;
    }

    public Object visit(ASTStringLiteral node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_STRING_LITERAL_TAG_NAME);
        obj = visitChildNode(node,data);
        //appendText(node.getFirstToken().toString());
        appendCloseTag(WX_STRING_LITERAL_TAG_NAME);
        return obj;
    }

    public Object visit(ASTQTagc node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_TAG_CLOSE_TAG_NAME);
        //obj = visitChildNode(node,data);
        appendText(node.getFirstToken().toString());
        appendCloseTag(WX_TAG_CLOSE_TAG_NAME);
        return obj;
    }

    public Object visit(ASTdoctypedecl node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_DOCTYPE_DECL_TAG_NAME);
        obj = visitChildNode(node,data);
        appendCloseTag(WX_DOCTYPE_DECL_TAG_NAME);
        return obj;
    }

    public Object visit(ASTDocType node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        //appendOpenTag("Doctype");
        appendOpenTag(WX_TAG_OPEN_TAG_NAME);
        //obj = visitChildNode(node,data);
        appendText(node.getFirstToken().toString());
        appendCloseTag(WX_TAG_OPEN_TAG_NAME);
        return obj;
    }

    public Object visit(ASTExternalID node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_EXTERNAL_ID_TAG_NAME);
        obj = visitChildNode(node,data);
        appendCloseTag(WX_EXTERNAL_ID_TAG_NAME);
        return obj;
    }

    public Object visit(ASTSystem node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_SYSTEM_TAG_NAME);
        appendText(node.getFirstToken().toString());
        appendCloseTag(WX_SYSTEM_TAG_NAME);
        return obj;
    }

    public Object visit(ASTPublic node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_PUBLIC_TAG_NAME);
        appendText(node.getFirstToken().toString());
        appendCloseTag(WX_PUBLIC_TAG_NAME);
        return obj;
    }

    public Object visit(ASTTagc node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_TAG_CLOSE_TAG_NAME);
        appendText(node.getFirstToken().toString());
        appendCloseTag(WX_TAG_CLOSE_TAG_NAME);
        return obj;
    }

    public Object visit(ASTXMLStyleSheet node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_XML_STYLESHEET_TAG_NAME);
        obj = visitChildNode(node,data);
        appendCloseTag(WX_XML_STYLESHEET_TAG_NAME);
        return obj;
    }

    public Object visit(ASTSTag node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_STARTTAG_TAG_NAME);
        obj = visitChildNode(node,data);
        appendCloseTag(WX_STARTTAG_TAG_NAME);
        return obj;
    }

    public Object visit(ASTETag node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag("ETag");
        obj = visitChildNode(node,data);
        appendCloseTag("ETag");
        return obj;
    }
    
    public Object visit(ASTTago node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_TAG_OPEN_TAG_NAME);
        appendText(node.getFirstToken().toString());
        appendCloseTag(WX_TAG_OPEN_TAG_NAME);
        return obj;
    }

    public Object visit(ASTETago node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_TAG_OPEN_TAG_NAME);
        appendText(node.getFirstToken().toString());
        appendCloseTag(WX_TAG_OPEN_TAG_NAME);
        return obj;
    }

    public Object visit(ASTETagc node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_TAG_CLOSE_TAG_NAME);
        appendText(node.getFirstToken().toString());
        appendCloseTag(WX_TAG_CLOSE_TAG_NAME);
        return obj;
    }

    public Object visit(ASTEmptyElemTag node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_EMPTY_TAG_NAME);
        obj = visitChildNode(node,data);
        //appendText(node.getFirstToken().toString());
        appendCloseTag(WX_EMPTY_TAG_NAME);
        return obj;
    }

    public Object visit(ASTText node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        /*
        appendOpenTag(WX_TEXT_TAG_NAME);
        appendText(node.getFirstToken().toString());
        appendCloseTag(WX_TEXT_TAG_NAME);
        */
        if(textBuffer==null){
            textBuffer = new StringBuffer();
        }
        textBuffer.append(node.getFirstToken().toString());
        isTextBuffer = true;
        
        return obj;
    }

    public Object visit(ASTDQuote node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_DQUOTE_TAG_NAME);
        appendText(node.getFirstToken().toString());
        appendCloseTag(WX_DQUOTE_TAG_NAME);

        return obj;
    }

    public Object visit(ASTSQuote node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_SQUOTE_TAG_NAME);
        appendText(node.getFirstToken().toString());
        appendCloseTag(WX_SQUOTE_TAG_NAME);

        return obj;
    }
    
    public Object visit(ASTEndOfFile node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        obj = visitChildNode(node,data);
        return obj;
    }

    public Object visit(ASTelement node, Object data){
        Object obj = null;
        doSpecialToken(node,data);
        appendOpenTag(WX_ELEMENT_TAG_NAME);
        obj = visitChildNode(node,data);
        appendCloseTag(WX_ELEMENT_TAG_NAME);
        return obj;
    }



}
