package wapid.parser.wxmodel;

import java.io.*;

/**
 * DBإ򤹤뤿Υ饹
 *
 * @author ken
 */
public class WXDBAccessor
{
    /** ǥեȤSDB̾ */
    public static final String DEFAULT_SDB_DIR_NAME = "SDB";

    /** ǥ̾ */
    public static final String WX_MODEL_NAME = "WXModel";

    /** SDB̾ */
    private static String sdbName = null;

    /** SDBγĥ */
    private static final String SDB_FILE_EXTENSION = ".xml";

    /** DTDΥ꥽ѥ */
    public static final String DTD_RESOURCE_PATH = "/wapid/parser/wxmodel/resources/WXModel.dtd";

    /** DTDΥե̾ */
    public static final String DTD_FILE_NAME = "WXModel.dtd";
    
    /** 󥹥ȥ饯 */
    public WXDBAccessor(){
        sdbName = DEFAULT_SDB_DIR_NAME;
    }
    
    
    /** SDB̾Υå */
    public void setSDBName(String sdbName){
        this.sdbName = sdbName;
    }

    /** SDB̾μ */
    public String getSDBName(){
        return sdbName;
    }

    /** SDBν񤭹 */
    public void writeSDB(String analyzedFileName,String buf){
        writeSDB(analyzedFileName,buf,"EUC-JP");
    }

    public void writeSDB(String analyzedFileName,String buf,String encoding){
        
        File writeFile = getSDBFile(analyzedFileName);
        File writeDir = writeFile.getParentFile();
        try{
            if(!writeDir.exists()){
                writeDir.mkdirs();
            }

            //Output xml file
            FileOutputStream fos = new FileOutputStream(writeFile);
            OutputStreamWriter osw = new OutputStreamWriter(fos,encoding);
            osw.write(buf);
            osw.close();
            
            //FileWriter fw = new FileWriter(writeFile);
            //fw.write(buf);
            //fw.close();

            outputDTD(writeDir);
        }catch(Exception e){
            e.printStackTrace();
        }
    }



    
    /** DTDSDBǥ쥯ȥ˽ */
    private void outputDTD(File writeDir){
        InputStream inStream = getClass().getResourceAsStream(DTD_RESOURCE_PATH);
        File dtdFile = new File(writeDir,DTD_FILE_NAME);

        try{
            FileWriter fw = new FileWriter(dtdFile);
            
            byte[] byteRead = new byte[1024];            
            int iRead = -1;
            while((iRead = inStream.read(byteRead))!=-1){
                fw.write(new String(byteRead),0,iRead);
            }
            fw.close();
        }
        catch(Exception e){
            e.printStackTrace();
        }
        
    }
    
    /**
     * SDBΥեѥ֤
     *  SDBϤΥݥꥷ֤Ϥ򤤤ޤ
     */
    public File getSDBFile(String analyzedFileName){

        //ե̾Τѡ
        analyzedFileName = (new File(analyzedFileName)).getName();
        
        File sdbFile = new File(sdbName + File.separator + WX_MODEL_NAME +
                                  File.separator + analyzedFileName + SDB_FILE_EXTENSION );
        return sdbFile;
    }
    
    /** SDBΥեѥ֤̾ */
    public String getSDBFileName(String analyzedFileName){
        File sdbFile = getSDBFile(analyzedFileName);
        return sdbFile.toString();
    }
}
