package wapid.parser.xhtml;
import java.io.*;
import java.util.*;

public class OutputVisitor implements ParseVisitor {
    public Object visit(SimpleNode node, Object data) {
        return null;
    }
    
    public Object visit(ASTfile node, Object sdbdir) {
        try {
            FileOutputStream fos = new FileOutputStream(sdbdir + "File",true);
        OutputStreamWriter out = new OutputStreamWriter(fos);
        out.write((String)node.getAttriId() + node.getName() + "\n");
        out.flush();
        out.close();
      }catch(IOException e) {
          System.out.println(e.getMessage());
      }

      int num = node.jjtGetNumChildren();
      for (int i = 0;i < num;i++) {
          SimpleNode child = (SimpleNode)node.jjtGetChild(i);
          String nodename = child.toString();
          if (nodename.equals("element") || nodename.equals("script") || nodename.equals("xmldecl") || nodename.equals("doctypedecl") || nodename.equals("comment")) {
              try {
                  FileOutputStream fos = new FileOutputStream(sdbdir + "file_node",true);
                  OutputStreamWriter out = new OutputStreamWriter(fos);
                  out.write(node.getAttriId() + child.getAttriId() + "\n");
                  out.flush();
                  out.close();
              }catch(IOException e) {
                  System.out.println(e.getMessage());
              }
          }else  if (nodename.equals("text") || nodename.equals("space")) {
                int tmp = child.getID();
                int offset = child.getOffset();
                int length = 0;
                String text = new String();
                int j = i;
                while(nodename.equals("text") || nodename.equals("space")) {
                    length += child.getLength();
                    text = text.concat(child.getText());
                    i = j;
                    if (j >= num-1)break;
                    child = (SimpleNode)node.jjtGetChild(++j);
                    nodename = child.toString();
                }

                child = new SimpleNode(0);//node.jjtGetChild(i-1);
                child.setID(tmp);
                child.setOffset(offset);
                child.setLength(length);
                try {
                    FileOutputStream fos = new FileOutputStream(sdbdir + "Node",true);
                    OutputStreamWriter out = new OutputStreamWriter(fos);
                    out.write((String)child.getAttriId() + SimpleNode.TEXT + text + "\n");
                    out.flush();
                    out.close();
                }catch(IOException e) {
                    System.out.println(e.getMessage());
                } 
                //              i--;
                try {
                    FileOutputStream fos = new FileOutputStream(sdbdir + "file_node",true);
                    OutputStreamWriter out = new OutputStreamWriter(fos);
                    out.write(node.getAttriId() + child.getAttriId() + "\n");
                    out.flush();
                    out.close();
                }catch(IOException e) {
                    System.out.println(e.getMessage());
                }
          }
          child.jjtAccept(this, sdbdir);
      }
      return null;

    }

    public Object visit(ASTelement node, Object sdbdir) {
        try {
            FileOutputStream fos = new FileOutputStream(sdbdir + "Node",true);
            OutputStreamWriter out = new OutputStreamWriter(fos);
            out.write((String)node.getAttriId() + SimpleNode.ELEMENT + "\n");
            out.flush();
            out.close();
        }catch(IOException e) {
            System.out.println(e.getMessage());
        } 

        int num = node.jjtGetNumChildren();
        for (int i = 0;i < num;i++) {
            SimpleNode child = (SimpleNode)node.jjtGetChild(i);
            String nodename = child.toString();
            if (nodename.equals("element") || nodename.equals("script") || nodename.equals("xmldecl") || nodename.equals("doctypedecl") || nodename.equals("comment")) {
                try {
                    FileOutputStream fos = new FileOutputStream(sdbdir + "pnode_cnode",true);
                    OutputStreamWriter out = new OutputStreamWriter(fos);
                    out.write(node.getAttriId() + child.getAttriId() + "\n");
                    out.flush();
                    out.close();
                }catch(IOException e) {
                    System.out.println(e.getMessage());
                }
            }else if (nodename.equals("attri")) {
                try {
                    FileOutputStream fos = new FileOutputStream(sdbdir + "node_attri",true);
                    OutputStreamWriter out = new OutputStreamWriter(fos);
                    out.write(node.getAttriId() + child.getAttriId() + "\n");
                    out.flush();
                    out.close();
                }catch(IOException e) {
                    System.out.println(e.getMessage());
                }
            }else /*if (nodename.equals("text")||nodename.equals("space")){
                int tmp=i;
                for (;i<num;i++){
                    child=(SimpleNode)node.jjtGetChild(i);
                    nodename=child.toString();
                    if (nodename.equals("text")||nodename.equals("space")){
                        
                        i=tmp+1;
                        break;
                    }
                }

                try {
                    FileOutputStream fos=new FileOutputStream(sdbdir+"pnode_cnode",true);
                    OutputStreamWriter out=new OutputStreamWriter(fos);
                    out.write(node.getAttriId()+child.getAttriId()+"\n");
                    out.flush();
                    out.close();
                }catch(IOException e){
                    System.out.println(e.getMessage());
                }



                i--;
                }else*/ if (nodename.equals("starttag") || nodename.equals("endtag") || nodename.equals("emptytag")) {
                try {
                    FileOutputStream fos = new FileOutputStream(sdbdir + "node_tag",true);
                    OutputStreamWriter out = new OutputStreamWriter(fos);
                    out.write(node.getAttriId() + child.getAttriId() + "\n");
                    out.flush();
                    out.close();
                }catch(IOException e) {
                    System.out.println(e.getMessage());
                }
            }else if (nodename.equals("text") || nodename.equals("space")) {
                int tmp = child.getID();
                int offset = child.getOffset();
                int length = 0;
                String text = new String();
                int j = i;
                while(nodename.equals("text") || nodename.equals("space")) {
                    length += child.getLength();
                    text = text.concat(child.getText());
                    //              System.out.println(child.getText());
                    i = j;
                    if (j >= (num-1))break;

                    child = (SimpleNode)node.jjtGetChild(++j);
                    nodename = child.toString();
                }

                child = new SimpleNode(0);//(SimpleNode)node.jjtGetChild(i-1);
                child.setID(tmp);
                child.setOffset(offset);
                child.setLength(length);
                try {
                    FileOutputStream fos = new FileOutputStream(sdbdir + "Node",true);
                    OutputStreamWriter out = new OutputStreamWriter(fos);
                    out.write((String)child.getAttriId() + SimpleNode.TEXT + text + "\n");
                    out.flush();
                    out.close();
                }catch(IOException e) {
                    System.out.println(e.getMessage());
                } 
                //              i--;
                try {
                    FileOutputStream fos = new FileOutputStream(sdbdir + "pnode_cnode",true);
                    OutputStreamWriter out = new OutputStreamWriter(fos);
                    out.write(node.getAttriId() + child.getAttriId() + "\n");
                    out.flush();
                    out.close();
                }catch(IOException e) {
                    System.out.println(e.getMessage());
                }
            }
            child.jjtAccept(this, sdbdir);
        }


        return null;
    }

    public Object visit(ASTstarttag node, Object sdbdir) {
        try {
            FileOutputStream fos = new FileOutputStream(sdbdir + "Tag",true);
            OutputStreamWriter out = new OutputStreamWriter(fos);
            out.write((String)node.getAttriId() + SimpleNode.STARTTAG + node.getName() + "\n");
            out.flush();
            out.close();
        }catch(IOException e) {
            System.out.println(e.getMessage());
        } 

        
        return null;
    }

    
    public Object visit(ASTemptytag node, Object sdbdir) {
        try {
            FileOutputStream fos = new FileOutputStream(sdbdir + "Tag",true);
            OutputStreamWriter out = new OutputStreamWriter(fos);
            out.write((String)node.getAttriId() + SimpleNode.EMPTYTAG + node.getName() + "\n");
            out.flush();
            out.close();
        }catch(IOException e) {
            System.out.println(e.getMessage());
        } 
        return null;
    }
    
    public Object visit(ASTtext node, Object sdbdir) {
        return null;
    }
    
    public Object visit(ASTattri node, Object sdbdir) {
        try {
            FileOutputStream fos = new FileOutputStream(sdbdir + "Attribute",true);
            OutputStreamWriter out = new OutputStreamWriter(fos);
            out.write((String)node.getAttriId() + node.getAttri() + "\n");
            out.flush();
            out.close();
        }catch(IOException e) {
            System.out.println(e.getMessage());
        } 
        return null;
    }
    
    public Object visit(ASTendtag node, Object sdbdir) {
        try {
            FileOutputStream fos = new FileOutputStream(sdbdir + "Tag",true);
            OutputStreamWriter out = new OutputStreamWriter(fos);
            out.write((String)node.getAttriId() + SimpleNode.ENDTAG + node.getName() + "\n");
            out.flush();
            out.close();
        }catch(IOException e) {
            System.out.println(e.getMessage());
        } 
        return null;
    }
    
    public Object visit(ASTscript node, Object sdbdir) {
        try {
            FileOutputStream fos = new FileOutputStream(sdbdir + "Node",true);
            OutputStreamWriter out = new OutputStreamWriter(fos);
            out.write((String)node.getAttriId() + SimpleNode.SCRIPT + node.getScript() + "\n");
            out.flush();
            out.close();
        }catch(IOException e) {
            System.out.println(e.getMessage());
        } 
        return null;
    }

    public Object visit(ASTdoctypedecl node, Object sdbdir) {
        try {
            FileOutputStream fos = new FileOutputStream(sdbdir + "Node",true);
            OutputStreamWriter out = new OutputStreamWriter(fos);
            out.write((String)node.getAttriId() + SimpleNode.DOCTYPEDECL);
            for (Iterator n = node.getValues();n.hasNext();) {
                String s = (String)n.next();
                out.write(s + " ");
            }
            for (int i = 0;i < node.jjtGetNumChildren();i++ ) {
                SimpleNode child = (SimpleNode)node.jjtGetChild(i);
		String nodename = child.toString();
		if (nodename.equals("doctypeval")) {
		    out.write(child.getValue() + " ");
		}
            }
	    for (int i = 0;i < node.jjtGetNumChildren();i++ ) {
                SimpleNode child = (SimpleNode)node.jjtGetChild(i);
		String nodename = child.toString();
		if (nodename.equals("innerdtd")) {
		    out.write(child.getDtd() + " ");
		}
	    }
            out.write("\n");

            out.flush();
            out.close();
        }catch(IOException e) {
            System.out.println(e.getMessage());
        } 
        
        return null;
    }

    public Object visit(ASTxmldecl node, Object sdbdir) {
        try {
            FileOutputStream fos = new FileOutputStream(sdbdir + "Node",true);
            OutputStreamWriter out = new OutputStreamWriter(fos);
            out.write((String)node.getAttriId() + SimpleNode.XMLDECL + "\n");
            out.flush();
            out.close();
        }catch(IOException e) {
            System.out.println(e.getMessage());
        } 


        int num = node.jjtGetNumChildren();
        for (int i = 0;i < num;i++) {
            SimpleNode child = (SimpleNode)node.jjtGetChild(i);
            String nodename = child.toString();
            if (nodename.equals("attri")) {
                try {
                    FileOutputStream fos = new FileOutputStream(sdbdir + "node_attri",true);
                    OutputStreamWriter out = new OutputStreamWriter(fos);
                    out.write(node.getAttriId() + child.getAttriId() + "\n");
                    out.flush();
                    out.close();
                }catch(IOException e) {
                    System.out.println(e.getMessage());
                }
            }
            child.jjtAccept(this, sdbdir);
        }
        return null;
    }

    public Object visit(ASTspace node, Object sdbdir) {
        return null;
    }
    public Object visit(ASTdoctypeval node, Object sdbdir) {
        return null;
    }

    public Object visit(ASTinnerdtd node,Object sdbdir) {
	return null;
    }

    public Object visit(ASTcomment node,Object sdbdir) {
        try {
            FileOutputStream fos = new FileOutputStream(sdbdir + "Node",true);
            OutputStreamWriter out = new OutputStreamWriter(fos);
            out.write((String)node.getAttriId() + SimpleNode.COMMENT + node.getComment() + "\n");
            out.flush();
            out.close();
        }catch(IOException e) {
            System.out.println(e.getMessage());
        } 

        return null;
    }

}
