package wapid.wxmodel.abstractwxmodelar;

import java.io.*;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.URL;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * <b>AWxFile</b> is generated from WXModel.rxm by Relaxer.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <elementRule role="File">
 *   <choice occurs="*">
 *     <ref label="XMLDecl"/>
 *     <ref label="DoctypeDecl"/>
 *     <ref label="StyleSheet"/>
 *     <ref label="Element"/>
 *     <ref label="sp"/>
 *     <ref label="nl"/>
 *     <ref label="comment"/>
 *     <ref label="scriptlet"/>
 *   </choice>
 * </elementRule>
 * 
 * <tag name="File">
 *   <attribute name="id" required="true" type="ID"/>
 * </tag>
 * -->
 * <!-- for javadoc -->
 * <pre> &lt;elementRule role="File"&gt;
 *   &lt;choice occurs="*"&gt;
 *     &lt;ref label="XMLDecl"/&gt;
 *     &lt;ref label="DoctypeDecl"/&gt;
 *     &lt;ref label="StyleSheet"/&gt;
 *     &lt;ref label="Element"/&gt;
 *     &lt;ref label="sp"/&gt;
 *     &lt;ref label="nl"/&gt;
 *     &lt;ref label="comment"/&gt;
 *     &lt;ref label="scriptlet"/&gt;
 *   &lt;/choice&gt;
 * &lt;/elementRule&gt;
 * &lt;tag name="File"&gt;
 *   &lt;attribute name="id" required="true" type="ID"/&gt;
 * &lt;/tag&gt;
 * </pre>
 *
 * @version WXModel.rxm 1.0 (Tue Oct 14 15:24:08 JST 2003)
 * @author  Relaxer 1.0rc2 (http://www.relaxer.org)
 */
public class AWxFile implements java.io.Serializable, Cloneable, IRVisitable, IRNode {
    private String id_;
    // List<IAWxFileChoice>
    private java.util.List content_ = new java.util.ArrayList();
    private IRNode parentRNode_;

    /**
     * Creates a <code>AWxFile</code>.
     *
     */
    public AWxFile() {
        id_ = "";
    }

    /**
     * Creates a <code>AWxFile</code>.
     *
     * @param source
     */
    public AWxFile(AWxFile source) {
        setup(source);
    }

    /**
     * Creates a <code>AWxFile</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public AWxFile(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>AWxFile</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public AWxFile(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>AWxFile</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public AWxFile(Element element) {
        setup(element);
    }

    /**
     * Creates a <code>AWxFile</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public AWxFile(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file);
    }

    /**
     * Creates a <code>AWxFile</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public AWxFile(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(uri);
    }

    /**
     * Creates a <code>AWxFile</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public AWxFile(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(url);
    }

    /**
     * Creates a <code>AWxFile</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public AWxFile(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(in);
    }

    /**
     * Creates a <code>AWxFile</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public AWxFile(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(is);
    }

    /**
     * Creates a <code>AWxFile</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public AWxFile(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(reader);
    }

    /**
     * Initializes the <code>AWxFile</code> by the AWxFile <code>source</code>.
     *
     * @param source
     */
    public void setup(AWxFile source) {
        int size;
        setId(source.getId());
        this.content_.clear();
        size = source.content_.size();
        for (int i = 0;i < size;i++) {
            addContent((IAWxFileChoice)source.getContent(i).clone());
        }
    }

    /**
     * Initializes the <code>AWxFile</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>AWxFile</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>AWxFile</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        init(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        IWXModelFactory factory = WXModelFactory.getFactory();
        RStack stack = new RStack(element);
        id_ = URelaxer.getAttributePropertyAsString(element, "id");
        content_.clear();
        while (true) {
            if (AWxNl.isMatch(stack)) {
                addContent(factory.createAWxNl(stack));
            } else if (AWxXMLDecl.isMatch(stack)) {
                addContent(factory.createAWxXMLDecl(stack));
            } else if (AWxDoctypeDecl.isMatch(stack)) {
                addContent(factory.createAWxDoctypeDecl(stack));
            } else if (AWxStyleSheet.isMatch(stack)) {
                addContent(factory.createAWxStyleSheet(stack));
            } else if (AWxElement.isMatch(stack)) {
                addContent(factory.createAWxElement(stack));
            } else if (AWxSp.isMatch(stack)) {
                addContent(factory.createAWxSp(stack));
            } else if (AWxComment.isMatch(stack)) {
                addContent(factory.createAWxComment(stack));
            } else if (AWxScriptlet.isMatch(stack)) {
                addContent(factory.createAWxScriptlet(stack));
            } else {
                break;
            }
        }
    }

    /**
     * @return Object
     */
    public Object clone() {
        IWXModelFactory factory = WXModelFactory.getFactory();
        return (factory.createAWxFile(this));
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElement("File");
        int size;
        if (this.id_ != null) {
            URelaxer.setAttributePropertyByString(element, "id", this.id_);
        }
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IAWxFileChoice value = (IAWxFileChoice)this.content_.get(i);
            value.makeElement(element);
        }
        parent.appendChild(element);
    }

    /**
     * Initializes the <code>AWxFile</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file.toURL());
    }

    /**
     * Initializes the <code>AWxFile</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(uri, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>AWxFile</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>AWxFile</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>AWxFile</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>AWxFile</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE));
    }

    /**
     * Creates a DOM document representation of the object.
     *
     * @exception ParserConfigurationException
     * @return Document
     */
    public Document makeDocument() throws ParserConfigurationException {
        Document doc = UJAXP.makeDocument();
        makeElement(doc);
        return (doc);
    }

    /**
     * Gets the String property <b>id</b>.
     *
     * @return String
     */
    public final String getId() {
        return (id_);
    }

    /**
     * Sets the String property <b>id</b>.
     *
     * @param p_id
     */
    public final void setId(String p_id) {
        this.id_ = p_id;
    }

    /**
     * Gets the IAWxFileChoice property <b>content</b>.
     *
     * @return IAWxFileChoice[]
     */
    public final IAWxFileChoice[] getContent() {
        IAWxFileChoice[] array = new IAWxFileChoice[content_.size()];
        return ((IAWxFileChoice[])content_.toArray(array));
    }

    /**
     * Sets the IAWxFileChoice property <b>content</b>.
     *
     * @param p_content
     */
    public final void setContent(IAWxFileChoice[] p_content) {
        this.content_.clear();
        for (int i = 0;i < p_content.length;i++) {
            addContent(p_content[i]);
        }
        for (int i = 0;i < p_content.length;i++) {
            p_content[i].rSetParentRNode(this);
        }
    }

    /**
     * Sets the IAWxFileChoice property <b>content</b>.
     *
     * @param p_content
     */
    public final void setContent(IAWxFileChoice p_content) {
        this.content_.clear();
        addContent(p_content);
        if (p_content != null) {
            p_content.rSetParentRNode(this);
        }
    }

    /**
     * Adds the IAWxFileChoice property <b>content</b>.
     *
     * @param p_content
     */
    public final void addContent(IAWxFileChoice p_content) {
        this.content_.add(p_content);
        if (p_content != null) {
            p_content.rSetParentRNode(this);
        }
    }

    /**
     * Adds the IAWxFileChoice property <b>content</b>.
     *
     * @param p_content
     */
    public final void addContent(IAWxFileChoice[] p_content) {
        for (int i = 0;i < p_content.length;i++) {
            addContent(p_content[i]);
        }
        for (int i = 0;i < p_content.length;i++) {
            p_content[i].rSetParentRNode(this);
        }
    }

    /**
     * Gets number of the IAWxFileChoice property <b>content</b>.
     *
     * @return int
     */
    public final int sizeContent() {
        return (content_.size());
    }

    /**
     * Gets the IAWxFileChoice property <b>content</b> by index.
     *
     * @param index
     * @return IAWxFileChoice
     */
    public final IAWxFileChoice getContent(int index) {
        return ((IAWxFileChoice)content_.get(index));
    }

    /**
     * Sets the IAWxFileChoice property <b>content</b> by index.
     *
     * @param index
     * @param p_content
     */
    public final void setContent(int index, IAWxFileChoice p_content) {
        this.content_.set(index, p_content);
        if (p_content != null) {
            p_content.rSetParentRNode(this);
        }
    }

    /**
     * Adds the IAWxFileChoice property <b>content</b> by index.
     *
     * @param index
     * @param p_content
     */
    public final void addContent(int index, IAWxFileChoice p_content) {
        this.content_.add(index, p_content);
        if (p_content != null) {
            p_content.rSetParentRNode(this);
        }
    }

    /**
     * Remove the IAWxFileChoice property <b>content</b> by index.
     *
     * @param index
     */
    public final void removeContent(int index) {
        this.content_.remove(index);
    }

    /**
     * Remove the IAWxFileChoice property <b>content</b> by object.
     *
     * @param p_content
     */
    public final void removeContent(IAWxFileChoice p_content) {
        this.content_.remove(p_content);
    }

    /**
     * Clear the IAWxFileChoice property <b>content</b>.
     *
     */
    public final void clearContent() {
        this.content_.clear();
    }

    /**
     * Makes a XML text representation.
     *
     * @return String
     */
    public String makeTextDocument() {
        StringBuffer buffer = new StringBuffer();
        makeTextElement(buffer);
        return (new String(buffer));
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(StringBuffer buffer) {
        int size;
        buffer.append("<File");
        if (id_ != null) {
            buffer.append(" id=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getId())));
            buffer.append("\"");
        }
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IAWxFileChoice value = (IAWxFileChoice)this.content_.get(i);
            value.makeTextAttribute(buffer);
        }
        buffer.append(">");
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IAWxFileChoice value = (IAWxFileChoice)this.content_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.append("</File>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextElement(Writer buffer) throws IOException {
        int size;
        buffer.write("<File");
        if (id_ != null) {
            buffer.write(" id=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getId())));
            buffer.write("\"");
        }
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IAWxFileChoice value = (IAWxFileChoice)this.content_.get(i);
            value.makeTextAttribute(buffer);
        }
        buffer.write(">");
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IAWxFileChoice value = (IAWxFileChoice)this.content_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.write("</File>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(PrintWriter buffer) {
        int size;
        buffer.print("<File");
        if (id_ != null) {
            buffer.print(" id=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getId())));
            buffer.print("\"");
        }
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IAWxFileChoice value = (IAWxFileChoice)this.content_.get(i);
            value.makeTextAttribute(buffer);
        }
        buffer.print(">");
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IAWxFileChoice value = (IAWxFileChoice)this.content_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.print("</File>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(StringBuffer buffer) {
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextAttribute(Writer buffer) throws IOException {
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(PrintWriter buffer) {
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getIdAsString() {
        return (URelaxer.getString(getId()));
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setIdByString(String string) {
        setId(string);
    }

    /**
     * Returns a String representation of this object.
     * While this method informs as XML format representaion, 
     *  it's purpose is just information, not making 
     * a rigid XML documentation.
     *
     * @return String
     */
    public String toString() {
        try {
            return (makeTextDocument());
        } catch (Exception e) {
            return (super.toString());
        }
    }

    /**
     * Accepts the Visitor for enter behavior.
     *
     * @param visitor
     * @return boolean
     */
    public boolean enter(IRVisitor visitor) {
        return (visitor.enter(this));
    }

    /**
     * Accepts the Visitor for leave behavior.
     *
     * @param visitor
     */
    public void leave(IRVisitor visitor) {
        visitor.leave(this);
    }

    /**
     * Gets the IRNode property <b>parentRNode</b>.
     *
     * @return IRNode
     */
    public final IRNode rGetParentRNode() {
        return (parentRNode_);
    }

    /**
     * Sets the IRNode property <b>parentRNode</b>.
     *
     * @param p_parentRNode
     */
    public final void rSetParentRNode(IRNode p_parentRNode) {
        this.parentRNode_ = p_parentRNode;
    }

    /**
     * Gets child RNodes.
     *
     * @return IRNode[]
     */
    public IRNode[] rGetRNodes() {
        java.util.List classNodes = new java.util.ArrayList();
        classNodes.addAll(content_);
        IRNode[] nodes = new IRNode[classNodes.size()];
        return ((IRNode[])classNodes.toArray(nodes));
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>AWxFile</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        if (!URelaxer.isTargetElement(element, "File")) {
            return (false);
        }
        RStack target = new RStack(element);
        boolean $match$ = false;
        Element child;
        while (true) {
            if (AWxNl.isMatchHungry(target)) {
                $match$ = true;
            } else if (AWxXMLDecl.isMatchHungry(target)) {
                $match$ = true;
            } else if (AWxDoctypeDecl.isMatchHungry(target)) {
                $match$ = true;
            } else if (AWxStyleSheet.isMatchHungry(target)) {
                $match$ = true;
            } else if (AWxElement.isMatchHungry(target)) {
                $match$ = true;
            } else if (AWxSp.isMatchHungry(target)) {
                $match$ = true;
            } else if (AWxComment.isMatchHungry(target)) {
                $match$ = true;
            } else if (AWxScriptlet.isMatchHungry(target)) {
                $match$ = true;
            } else {
                break;
            }
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>AWxFile</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>AWxFile</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
