package wapid.wxmodel.abstractwxmodelar;

import java.io.*;
import java.net.MalformedURLException;
import java.net.URL;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * AbstractWXModelFactory is generated by Relaxer based on WXModel.rxm.
 *
 * @version WXModel.rxm 1.0 (Tue Oct 14 15:24:11 JST 2003)
 * @author  Relaxer 1.0rc2 (http://www.relaxer.org)
 */
public abstract class AbstractWXModelFactory implements IWXModelFactory {
    protected org.xml.sax.ErrorHandler errorHandler;
    protected org.xml.sax.EntityResolver entityResolver;
    protected String baseUri;

    /**
     * Sets a <b>errorHandler</b>.
     *
     * @param errorHandler
     */
    public void setErrorHandler(org.xml.sax.ErrorHandler errorHandler) {
        this.errorHandler = errorHandler;
    }

    /**
     * Gets a <b>errorHandler</b>.
     *
     * @return org.xml.sax.ErrorHandler
     */
    public org.xml.sax.ErrorHandler getErrorHandler() {
        return (errorHandler);
    }

    /**
     * Sets a <b>entityResolver</b>.
     *
     * @param entityResolver
     */
    public void setEntityResolver(org.xml.sax.EntityResolver entityResolver) {
        this.entityResolver = entityResolver;
    }

    /**
     * Gets a <b>entityResolver</b>.
     *
     * @return org.xml.sax.EntityResolver
     */
    public org.xml.sax.EntityResolver getEntityResolver() {
        return (entityResolver);
    }

    /**
     * Sets a <b>baseUri</b>.
     *
     * @param baseUri
     */
    public void setBaseUri(String baseUri) {
        this.baseUri = baseUri;
    }

    /**
     * Gets a <b>baseUri</b>.
     *
     * @return String
     */
    public String getBaseUri() {
        return (baseUri);
    }

    /**
     * Creates a <code>Object</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    public Object create(File file) throws IOException, SAXException, ParserConfigurationException {
        Object node = create(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (node);
    }

    /**
     * Creates a <code>Object</code> by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    public Object create(String uri) throws IOException, SAXException, ParserConfigurationException {
        Object node = create(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (node);
    }

    /**
     * Creates a <code>Object</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    public Object create(URL url) throws IOException, SAXException, ParserConfigurationException {
        Object node = create(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (node);
    }

    /**
     * Creates a <code>Object</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    public Object create(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        Object node = create(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (node);
    }

    /**
     * Creates a <code>Object</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    public Object create(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        Object node = create(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (node);
    }

    /**
     * Creates a <code>Object</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    public Object create(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        Object node = create(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (node);
    }

    /**
     * Creates a <code>Object</code> by the copy <code>Object</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    public Object create(Object source) throws IOException, SAXException, ParserConfigurationException {
        if (source instanceof AWxFile) {
            AWxFile node = createAWxFile();
            node.setup((AWxFile)source);
            return(node);
        } else if (source instanceof AWxNl) {
            AWxNl node = createAWxNl();
            node.setup((AWxNl)source);
            return(node);
        } else if (source instanceof AWxXMLDecl) {
            AWxXMLDecl node = createAWxXMLDecl();
            node.setup((AWxXMLDecl)source);
            return(node);
        } else if (source instanceof AWxAttribute) {
            AWxAttribute node = createAWxAttribute();
            node.setup((AWxAttribute)source);
            return(node);
        } else if (source instanceof AWxString) {
            AWxString node = createAWxString();
            node.setup((AWxString)source);
            return(node);
        } else if (source instanceof AWxDquote) {
            AWxDquote node = createAWxDquote();
            node.setup((AWxDquote)source);
            return(node);
        } else if (source instanceof AWxSquote) {
            AWxSquote node = createAWxSquote();
            node.setup((AWxSquote)source);
            return(node);
        } else if (source instanceof AWxText) {
            AWxText node = createAWxText();
            node.setup((AWxText)source);
            return(node);
        } else if (source instanceof AWxSp) {
            AWxSp node = createAWxSp();
            node.setup((AWxSp)source);
            return(node);
        } else if (source instanceof AWxComment) {
            AWxComment node = createAWxComment();
            node.setup((AWxComment)source);
            return(node);
        } else if (source instanceof AWxScriptlet) {
            AWxScriptlet node = createAWxScriptlet();
            node.setup((AWxScriptlet)source);
            return(node);
        } else if (source instanceof AWxName) {
            AWxName node = createAWxName();
            node.setup((AWxName)source);
            return(node);
        } else if (source instanceof AWxEq) {
            AWxEq node = createAWxEq();
            node.setup((AWxEq)source);
            return(node);
        } else if (source instanceof AWxTago) {
            AWxTago node = createAWxTago();
            node.setup((AWxTago)source);
            return(node);
        } else if (source instanceof AWxTagc) {
            AWxTagc node = createAWxTagc();
            node.setup((AWxTagc)source);
            return(node);
        } else if (source instanceof AWxDoctypeDecl) {
            AWxDoctypeDecl node = createAWxDoctypeDecl();
            node.setup((AWxDoctypeDecl)source);
            return(node);
        } else if (source instanceof AWxExternalID) {
            AWxExternalID node = createAWxExternalID();
            node.setup((AWxExternalID)source);
            return(node);
        } else if (source instanceof AWxSystem) {
            AWxSystem node = createAWxSystem();
            node.setup((AWxSystem)source);
            return(node);
        } else if (source instanceof AWxPublic) {
            AWxPublic node = createAWxPublic();
            node.setup((AWxPublic)source);
            return(node);
        } else if (source instanceof AWxStyleSheet) {
            AWxStyleSheet node = createAWxStyleSheet();
            node.setup((AWxStyleSheet)source);
            return(node);
        } else if (source instanceof AWxElement) {
            AWxElement node = createAWxElement();
            node.setup((AWxElement)source);
            return(node);
        } else if (source instanceof AWxSTag) {
            AWxSTag node = createAWxSTag();
            node.setup((AWxSTag)source);
            return(node);
        } else if (source instanceof AWxETag) {
            AWxETag node = createAWxETag();
            node.setup((AWxETag)source);
            return(node);
        } else if (source instanceof AWxEmpty) {
            AWxEmpty node = createAWxEmpty();
            node.setup((AWxEmpty)source);
            return(node);
        } else {
            return (null);
        }
    }

    /**
     * Creates a <code>Object</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    public Object create(Document doc) throws IOException, SAXException, ParserConfigurationException {
        Object node = create(doc.getDocumentElement());
        return (node);
    }

    /**
     * Creates a <code>Object</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return Object
     */
    public Object create(Element element) throws IOException, SAXException, ParserConfigurationException {
        if (AWxFile.isMatch(element)) {
            AWxFile node = createAWxFile();
            node.setup(element);
            return(node);
        } else if (AWxNl.isMatch(element)) {
            AWxNl node = createAWxNl();
            node.setup(element);
            return(node);
        } else if (AWxXMLDecl.isMatch(element)) {
            AWxXMLDecl node = createAWxXMLDecl();
            node.setup(element);
            return(node);
        } else if (AWxAttribute.isMatch(element)) {
            AWxAttribute node = createAWxAttribute();
            node.setup(element);
            return(node);
        } else if (AWxString.isMatch(element)) {
            AWxString node = createAWxString();
            node.setup(element);
            return(node);
        } else if (AWxDquote.isMatch(element)) {
            AWxDquote node = createAWxDquote();
            node.setup(element);
            return(node);
        } else if (AWxSquote.isMatch(element)) {
            AWxSquote node = createAWxSquote();
            node.setup(element);
            return(node);
        } else if (AWxText.isMatch(element)) {
            AWxText node = createAWxText();
            node.setup(element);
            return(node);
        } else if (AWxSp.isMatch(element)) {
            AWxSp node = createAWxSp();
            node.setup(element);
            return(node);
        } else if (AWxComment.isMatch(element)) {
            AWxComment node = createAWxComment();
            node.setup(element);
            return(node);
        } else if (AWxScriptlet.isMatch(element)) {
            AWxScriptlet node = createAWxScriptlet();
            node.setup(element);
            return(node);
        } else if (AWxName.isMatch(element)) {
            AWxName node = createAWxName();
            node.setup(element);
            return(node);
        } else if (AWxEq.isMatch(element)) {
            AWxEq node = createAWxEq();
            node.setup(element);
            return(node);
        } else if (AWxTago.isMatch(element)) {
            AWxTago node = createAWxTago();
            node.setup(element);
            return(node);
        } else if (AWxTagc.isMatch(element)) {
            AWxTagc node = createAWxTagc();
            node.setup(element);
            return(node);
        } else if (AWxDoctypeDecl.isMatch(element)) {
            AWxDoctypeDecl node = createAWxDoctypeDecl();
            node.setup(element);
            return(node);
        } else if (AWxExternalID.isMatch(element)) {
            AWxExternalID node = createAWxExternalID();
            node.setup(element);
            return(node);
        } else if (AWxSystem.isMatch(element)) {
            AWxSystem node = createAWxSystem();
            node.setup(element);
            return(node);
        } else if (AWxPublic.isMatch(element)) {
            AWxPublic node = createAWxPublic();
            node.setup(element);
            return(node);
        } else if (AWxStyleSheet.isMatch(element)) {
            AWxStyleSheet node = createAWxStyleSheet();
            node.setup(element);
            return(node);
        } else if (AWxElement.isMatch(element)) {
            AWxElement node = createAWxElement();
            node.setup(element);
            return(node);
        } else if (AWxSTag.isMatch(element)) {
            AWxSTag node = createAWxSTag();
            node.setup(element);
            return(node);
        } else if (AWxETag.isMatch(element)) {
            AWxETag node = createAWxETag();
            node.setup(element);
            return(node);
        } else if (AWxEmpty.isMatch(element)) {
            AWxEmpty node = createAWxEmpty();
            node.setup(element);
            return(node);
        } else {
            return (null);
        }
    }

    /**
     * Creates a <code>AWxFile</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxFile
     */
    public AWxFile createAWxFile(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxFile aWxFile_ = createAWxFile();
        aWxFile_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxFile_);
    }

    /**
     * Creates a <code>AWxNl</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxNl
     */
    public AWxNl createAWxNl(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxNl aWxNl_ = createAWxNl();
        aWxNl_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxNl_);
    }

    /**
     * Creates a <code>AWxXMLDecl</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxXMLDecl
     */
    public AWxXMLDecl createAWxXMLDecl(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxXMLDecl aWxXMLDecl_ = createAWxXMLDecl();
        aWxXMLDecl_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxXMLDecl_);
    }

    /**
     * Creates a <code>AWxAttribute</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxAttribute
     */
    public AWxAttribute createAWxAttribute(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxAttribute aWxAttribute_ = createAWxAttribute();
        aWxAttribute_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxAttribute_);
    }

    /**
     * Creates a <code>AWxString</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxString
     */
    public AWxString createAWxString(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxString aWxString_ = createAWxString();
        aWxString_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxString_);
    }

    /**
     * Creates a <code>AWxDquote</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxDquote
     */
    public AWxDquote createAWxDquote(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxDquote aWxDquote_ = createAWxDquote();
        aWxDquote_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxDquote_);
    }

    /**
     * Creates a <code>AWxSquote</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSquote
     */
    public AWxSquote createAWxSquote(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxSquote aWxSquote_ = createAWxSquote();
        aWxSquote_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSquote_);
    }

    /**
     * Creates a <code>AWxText</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxText
     */
    public AWxText createAWxText(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxText aWxText_ = createAWxText();
        aWxText_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxText_);
    }

    /**
     * Creates a <code>AWxSp</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSp
     */
    public AWxSp createAWxSp(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxSp aWxSp_ = createAWxSp();
        aWxSp_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSp_);
    }

    /**
     * Creates a <code>AWxComment</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxComment
     */
    public AWxComment createAWxComment(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxComment aWxComment_ = createAWxComment();
        aWxComment_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxComment_);
    }

    /**
     * Creates a <code>AWxScriptlet</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxScriptlet
     */
    public AWxScriptlet createAWxScriptlet(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxScriptlet aWxScriptlet_ = createAWxScriptlet();
        aWxScriptlet_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxScriptlet_);
    }

    /**
     * Creates a <code>AWxName</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxName
     */
    public AWxName createAWxName(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxName aWxName_ = createAWxName();
        aWxName_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxName_);
    }

    /**
     * Creates a <code>AWxEq</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxEq
     */
    public AWxEq createAWxEq(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxEq aWxEq_ = createAWxEq();
        aWxEq_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxEq_);
    }

    /**
     * Creates a <code>AWxTago</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxTago
     */
    public AWxTago createAWxTago(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxTago aWxTago_ = createAWxTago();
        aWxTago_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxTago_);
    }

    /**
     * Creates a <code>AWxTagc</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxTagc
     */
    public AWxTagc createAWxTagc(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxTagc aWxTagc_ = createAWxTagc();
        aWxTagc_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxTagc_);
    }

    /**
     * Creates a <code>AWxDoctypeDecl</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxDoctypeDecl
     */
    public AWxDoctypeDecl createAWxDoctypeDecl(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxDoctypeDecl aWxDoctypeDecl_ = createAWxDoctypeDecl();
        aWxDoctypeDecl_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxDoctypeDecl_);
    }

    /**
     * Creates a <code>AWxExternalID</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxExternalID
     */
    public AWxExternalID createAWxExternalID(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxExternalID aWxExternalID_ = createAWxExternalID();
        aWxExternalID_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxExternalID_);
    }

    /**
     * Creates a <code>AWxSystem</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSystem
     */
    public AWxSystem createAWxSystem(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxSystem aWxSystem_ = createAWxSystem();
        aWxSystem_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSystem_);
    }

    /**
     * Creates a <code>AWxPublic</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxPublic
     */
    public AWxPublic createAWxPublic(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxPublic aWxPublic_ = createAWxPublic();
        aWxPublic_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxPublic_);
    }

    /**
     * Creates a <code>AWxStyleSheet</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxStyleSheet
     */
    public AWxStyleSheet createAWxStyleSheet(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxStyleSheet aWxStyleSheet_ = createAWxStyleSheet();
        aWxStyleSheet_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxStyleSheet_);
    }

    /**
     * Creates a <code>AWxElement</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxElement
     */
    public AWxElement createAWxElement(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxElement aWxElement_ = createAWxElement();
        aWxElement_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxElement_);
    }

    /**
     * Creates a <code>AWxSTag</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSTag
     */
    public AWxSTag createAWxSTag(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxSTag aWxSTag_ = createAWxSTag();
        aWxSTag_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSTag_);
    }

    /**
     * Creates a <code>AWxETag</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxETag
     */
    public AWxETag createAWxETag(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxETag aWxETag_ = createAWxETag();
        aWxETag_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxETag_);
    }

    /**
     * Creates a <code>AWxEmpty</code> by the File <code>file</code>.
     * This method is a template method for concrete classes.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxEmpty
     */
    public AWxEmpty createAWxEmpty(File file) throws IOException, SAXException, ParserConfigurationException {
        AWxEmpty aWxEmpty_ = createAWxEmpty();
        aWxEmpty_.setup(UJAXP.getDocument(file, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxEmpty_);
    }

    /**
     * Creates a <code>AWxFile</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxFile
     */
    public AWxFile createAWxFile(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxFile aWxFile_ = createAWxFile();
        aWxFile_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxFile_);
    }

    /**
     * Creates a <code>AWxNl</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxNl
     */
    public AWxNl createAWxNl(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxNl aWxNl_ = createAWxNl();
        aWxNl_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxNl_);
    }

    /**
     * Creates a <code>AWxXMLDecl</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxXMLDecl
     */
    public AWxXMLDecl createAWxXMLDecl(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxXMLDecl aWxXMLDecl_ = createAWxXMLDecl();
        aWxXMLDecl_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxXMLDecl_);
    }

    /**
     * Creates a <code>AWxAttribute</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxAttribute
     */
    public AWxAttribute createAWxAttribute(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxAttribute aWxAttribute_ = createAWxAttribute();
        aWxAttribute_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxAttribute_);
    }

    /**
     * Creates a <code>AWxString</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxString
     */
    public AWxString createAWxString(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxString aWxString_ = createAWxString();
        aWxString_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxString_);
    }

    /**
     * Creates a <code>AWxDquote</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxDquote
     */
    public AWxDquote createAWxDquote(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxDquote aWxDquote_ = createAWxDquote();
        aWxDquote_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxDquote_);
    }

    /**
     * Creates a <code>AWxSquote</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSquote
     */
    public AWxSquote createAWxSquote(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxSquote aWxSquote_ = createAWxSquote();
        aWxSquote_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSquote_);
    }

    /**
     * Creates a <code>AWxText</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxText
     */
    public AWxText createAWxText(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxText aWxText_ = createAWxText();
        aWxText_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxText_);
    }

    /**
     * Creates a <code>AWxSp</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSp
     */
    public AWxSp createAWxSp(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxSp aWxSp_ = createAWxSp();
        aWxSp_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSp_);
    }

    /**
     * Creates a <code>AWxComment</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxComment
     */
    public AWxComment createAWxComment(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxComment aWxComment_ = createAWxComment();
        aWxComment_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxComment_);
    }

    /**
     * Creates a <code>AWxScriptlet</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxScriptlet
     */
    public AWxScriptlet createAWxScriptlet(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxScriptlet aWxScriptlet_ = createAWxScriptlet();
        aWxScriptlet_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxScriptlet_);
    }

    /**
     * Creates a <code>AWxName</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxName
     */
    public AWxName createAWxName(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxName aWxName_ = createAWxName();
        aWxName_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxName_);
    }

    /**
     * Creates a <code>AWxEq</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxEq
     */
    public AWxEq createAWxEq(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxEq aWxEq_ = createAWxEq();
        aWxEq_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxEq_);
    }

    /**
     * Creates a <code>AWxTago</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxTago
     */
    public AWxTago createAWxTago(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxTago aWxTago_ = createAWxTago();
        aWxTago_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxTago_);
    }

    /**
     * Creates a <code>AWxTagc</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxTagc
     */
    public AWxTagc createAWxTagc(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxTagc aWxTagc_ = createAWxTagc();
        aWxTagc_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxTagc_);
    }

    /**
     * Creates a <code>AWxDoctypeDecl</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxDoctypeDecl
     */
    public AWxDoctypeDecl createAWxDoctypeDecl(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxDoctypeDecl aWxDoctypeDecl_ = createAWxDoctypeDecl();
        aWxDoctypeDecl_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxDoctypeDecl_);
    }

    /**
     * Creates a <code>AWxExternalID</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxExternalID
     */
    public AWxExternalID createAWxExternalID(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxExternalID aWxExternalID_ = createAWxExternalID();
        aWxExternalID_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxExternalID_);
    }

    /**
     * Creates a <code>AWxSystem</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSystem
     */
    public AWxSystem createAWxSystem(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxSystem aWxSystem_ = createAWxSystem();
        aWxSystem_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSystem_);
    }

    /**
     * Creates a <code>AWxPublic</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxPublic
     */
    public AWxPublic createAWxPublic(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxPublic aWxPublic_ = createAWxPublic();
        aWxPublic_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxPublic_);
    }

    /**
     * Creates a <code>AWxStyleSheet</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxStyleSheet
     */
    public AWxStyleSheet createAWxStyleSheet(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxStyleSheet aWxStyleSheet_ = createAWxStyleSheet();
        aWxStyleSheet_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxStyleSheet_);
    }

    /**
     * Creates a <code>AWxElement</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxElement
     */
    public AWxElement createAWxElement(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxElement aWxElement_ = createAWxElement();
        aWxElement_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxElement_);
    }

    /**
     * Creates a <code>AWxSTag</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSTag
     */
    public AWxSTag createAWxSTag(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxSTag aWxSTag_ = createAWxSTag();
        aWxSTag_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSTag_);
    }

    /**
     * Creates a <code>AWxETag</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxETag
     */
    public AWxETag createAWxETag(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxETag aWxETag_ = createAWxETag();
        aWxETag_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxETag_);
    }

    /**
     * Creates a <code>AWxEmpty</code>
     * by the String representation of URI <code>uri</code>.
     * This method is a template method for concrete classes.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxEmpty
     */
    public AWxEmpty createAWxEmpty(String uri) throws IOException, SAXException, ParserConfigurationException {
        AWxEmpty aWxEmpty_ = createAWxEmpty();
        aWxEmpty_.setup(UJAXP.getDocument(uri, baseUri, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxEmpty_);
    }

    /**
     * Creates a <code>AWxFile</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxFile
     */
    public AWxFile createAWxFile(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxFile aWxFile_ = createAWxFile();
        aWxFile_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxFile_);
    }

    /**
     * Creates a <code>AWxNl</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxNl
     */
    public AWxNl createAWxNl(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxNl aWxNl_ = createAWxNl();
        aWxNl_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxNl_);
    }

    /**
     * Creates a <code>AWxXMLDecl</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxXMLDecl
     */
    public AWxXMLDecl createAWxXMLDecl(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxXMLDecl aWxXMLDecl_ = createAWxXMLDecl();
        aWxXMLDecl_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxXMLDecl_);
    }

    /**
     * Creates a <code>AWxAttribute</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxAttribute
     */
    public AWxAttribute createAWxAttribute(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxAttribute aWxAttribute_ = createAWxAttribute();
        aWxAttribute_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxAttribute_);
    }

    /**
     * Creates a <code>AWxString</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxString
     */
    public AWxString createAWxString(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxString aWxString_ = createAWxString();
        aWxString_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxString_);
    }

    /**
     * Creates a <code>AWxDquote</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxDquote
     */
    public AWxDquote createAWxDquote(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxDquote aWxDquote_ = createAWxDquote();
        aWxDquote_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxDquote_);
    }

    /**
     * Creates a <code>AWxSquote</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSquote
     */
    public AWxSquote createAWxSquote(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxSquote aWxSquote_ = createAWxSquote();
        aWxSquote_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSquote_);
    }

    /**
     * Creates a <code>AWxText</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxText
     */
    public AWxText createAWxText(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxText aWxText_ = createAWxText();
        aWxText_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxText_);
    }

    /**
     * Creates a <code>AWxSp</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSp
     */
    public AWxSp createAWxSp(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxSp aWxSp_ = createAWxSp();
        aWxSp_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSp_);
    }

    /**
     * Creates a <code>AWxComment</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxComment
     */
    public AWxComment createAWxComment(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxComment aWxComment_ = createAWxComment();
        aWxComment_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxComment_);
    }

    /**
     * Creates a <code>AWxScriptlet</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxScriptlet
     */
    public AWxScriptlet createAWxScriptlet(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxScriptlet aWxScriptlet_ = createAWxScriptlet();
        aWxScriptlet_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxScriptlet_);
    }

    /**
     * Creates a <code>AWxName</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxName
     */
    public AWxName createAWxName(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxName aWxName_ = createAWxName();
        aWxName_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxName_);
    }

    /**
     * Creates a <code>AWxEq</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxEq
     */
    public AWxEq createAWxEq(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxEq aWxEq_ = createAWxEq();
        aWxEq_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxEq_);
    }

    /**
     * Creates a <code>AWxTago</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxTago
     */
    public AWxTago createAWxTago(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxTago aWxTago_ = createAWxTago();
        aWxTago_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxTago_);
    }

    /**
     * Creates a <code>AWxTagc</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxTagc
     */
    public AWxTagc createAWxTagc(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxTagc aWxTagc_ = createAWxTagc();
        aWxTagc_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxTagc_);
    }

    /**
     * Creates a <code>AWxDoctypeDecl</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxDoctypeDecl
     */
    public AWxDoctypeDecl createAWxDoctypeDecl(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxDoctypeDecl aWxDoctypeDecl_ = createAWxDoctypeDecl();
        aWxDoctypeDecl_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxDoctypeDecl_);
    }

    /**
     * Creates a <code>AWxExternalID</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxExternalID
     */
    public AWxExternalID createAWxExternalID(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxExternalID aWxExternalID_ = createAWxExternalID();
        aWxExternalID_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxExternalID_);
    }

    /**
     * Creates a <code>AWxSystem</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSystem
     */
    public AWxSystem createAWxSystem(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxSystem aWxSystem_ = createAWxSystem();
        aWxSystem_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSystem_);
    }

    /**
     * Creates a <code>AWxPublic</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxPublic
     */
    public AWxPublic createAWxPublic(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxPublic aWxPublic_ = createAWxPublic();
        aWxPublic_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxPublic_);
    }

    /**
     * Creates a <code>AWxStyleSheet</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxStyleSheet
     */
    public AWxStyleSheet createAWxStyleSheet(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxStyleSheet aWxStyleSheet_ = createAWxStyleSheet();
        aWxStyleSheet_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxStyleSheet_);
    }

    /**
     * Creates a <code>AWxElement</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxElement
     */
    public AWxElement createAWxElement(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxElement aWxElement_ = createAWxElement();
        aWxElement_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxElement_);
    }

    /**
     * Creates a <code>AWxSTag</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSTag
     */
    public AWxSTag createAWxSTag(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxSTag aWxSTag_ = createAWxSTag();
        aWxSTag_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSTag_);
    }

    /**
     * Creates a <code>AWxETag</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxETag
     */
    public AWxETag createAWxETag(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxETag aWxETag_ = createAWxETag();
        aWxETag_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxETag_);
    }

    /**
     * Creates a <code>AWxEmpty</code> by the URL <code>url</code>.
     * This method is a template method for concrete classes.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxEmpty
     */
    public AWxEmpty createAWxEmpty(URL url) throws IOException, SAXException, ParserConfigurationException {
        AWxEmpty aWxEmpty_ = createAWxEmpty();
        aWxEmpty_.setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxEmpty_);
    }

    /**
     * Creates a <code>AWxFile</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxFile
     */
    public AWxFile createAWxFile(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxFile aWxFile_ = createAWxFile();
        aWxFile_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxFile_);
    }

    /**
     * Creates a <code>AWxNl</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxNl
     */
    public AWxNl createAWxNl(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxNl aWxNl_ = createAWxNl();
        aWxNl_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxNl_);
    }

    /**
     * Creates a <code>AWxXMLDecl</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxXMLDecl
     */
    public AWxXMLDecl createAWxXMLDecl(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxXMLDecl aWxXMLDecl_ = createAWxXMLDecl();
        aWxXMLDecl_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxXMLDecl_);
    }

    /**
     * Creates a <code>AWxAttribute</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxAttribute
     */
    public AWxAttribute createAWxAttribute(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxAttribute aWxAttribute_ = createAWxAttribute();
        aWxAttribute_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxAttribute_);
    }

    /**
     * Creates a <code>AWxString</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxString
     */
    public AWxString createAWxString(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxString aWxString_ = createAWxString();
        aWxString_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxString_);
    }

    /**
     * Creates a <code>AWxDquote</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxDquote
     */
    public AWxDquote createAWxDquote(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxDquote aWxDquote_ = createAWxDquote();
        aWxDquote_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxDquote_);
    }

    /**
     * Creates a <code>AWxSquote</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSquote
     */
    public AWxSquote createAWxSquote(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxSquote aWxSquote_ = createAWxSquote();
        aWxSquote_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSquote_);
    }

    /**
     * Creates a <code>AWxText</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxText
     */
    public AWxText createAWxText(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxText aWxText_ = createAWxText();
        aWxText_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxText_);
    }

    /**
     * Creates a <code>AWxSp</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSp
     */
    public AWxSp createAWxSp(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxSp aWxSp_ = createAWxSp();
        aWxSp_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSp_);
    }

    /**
     * Creates a <code>AWxComment</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxComment
     */
    public AWxComment createAWxComment(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxComment aWxComment_ = createAWxComment();
        aWxComment_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxComment_);
    }

    /**
     * Creates a <code>AWxScriptlet</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxScriptlet
     */
    public AWxScriptlet createAWxScriptlet(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxScriptlet aWxScriptlet_ = createAWxScriptlet();
        aWxScriptlet_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxScriptlet_);
    }

    /**
     * Creates a <code>AWxName</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxName
     */
    public AWxName createAWxName(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxName aWxName_ = createAWxName();
        aWxName_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxName_);
    }

    /**
     * Creates a <code>AWxEq</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxEq
     */
    public AWxEq createAWxEq(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxEq aWxEq_ = createAWxEq();
        aWxEq_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxEq_);
    }

    /**
     * Creates a <code>AWxTago</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxTago
     */
    public AWxTago createAWxTago(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxTago aWxTago_ = createAWxTago();
        aWxTago_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxTago_);
    }

    /**
     * Creates a <code>AWxTagc</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxTagc
     */
    public AWxTagc createAWxTagc(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxTagc aWxTagc_ = createAWxTagc();
        aWxTagc_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxTagc_);
    }

    /**
     * Creates a <code>AWxDoctypeDecl</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxDoctypeDecl
     */
    public AWxDoctypeDecl createAWxDoctypeDecl(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxDoctypeDecl aWxDoctypeDecl_ = createAWxDoctypeDecl();
        aWxDoctypeDecl_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxDoctypeDecl_);
    }

    /**
     * Creates a <code>AWxExternalID</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxExternalID
     */
    public AWxExternalID createAWxExternalID(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxExternalID aWxExternalID_ = createAWxExternalID();
        aWxExternalID_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxExternalID_);
    }

    /**
     * Creates a <code>AWxSystem</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSystem
     */
    public AWxSystem createAWxSystem(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxSystem aWxSystem_ = createAWxSystem();
        aWxSystem_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSystem_);
    }

    /**
     * Creates a <code>AWxPublic</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxPublic
     */
    public AWxPublic createAWxPublic(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxPublic aWxPublic_ = createAWxPublic();
        aWxPublic_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxPublic_);
    }

    /**
     * Creates a <code>AWxStyleSheet</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxStyleSheet
     */
    public AWxStyleSheet createAWxStyleSheet(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxStyleSheet aWxStyleSheet_ = createAWxStyleSheet();
        aWxStyleSheet_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxStyleSheet_);
    }

    /**
     * Creates a <code>AWxElement</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxElement
     */
    public AWxElement createAWxElement(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxElement aWxElement_ = createAWxElement();
        aWxElement_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxElement_);
    }

    /**
     * Creates a <code>AWxSTag</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSTag
     */
    public AWxSTag createAWxSTag(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxSTag aWxSTag_ = createAWxSTag();
        aWxSTag_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSTag_);
    }

    /**
     * Creates a <code>AWxETag</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxETag
     */
    public AWxETag createAWxETag(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxETag aWxETag_ = createAWxETag();
        aWxETag_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxETag_);
    }

    /**
     * Creates a <code>AWxEmpty</code> by the InputStream <code>in</code>.
     * This method is a template method for concrete classes.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxEmpty
     */
    public AWxEmpty createAWxEmpty(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        AWxEmpty aWxEmpty_ = createAWxEmpty();
        aWxEmpty_.setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxEmpty_);
    }

    /**
     * Creates a <code>AWxFile</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxFile
     */
    public AWxFile createAWxFile(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxFile aWxFile_ = createAWxFile();
        aWxFile_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxFile_);
    }

    /**
     * Creates a <code>AWxNl</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxNl
     */
    public AWxNl createAWxNl(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxNl aWxNl_ = createAWxNl();
        aWxNl_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxNl_);
    }

    /**
     * Creates a <code>AWxXMLDecl</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxXMLDecl
     */
    public AWxXMLDecl createAWxXMLDecl(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxXMLDecl aWxXMLDecl_ = createAWxXMLDecl();
        aWxXMLDecl_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxXMLDecl_);
    }

    /**
     * Creates a <code>AWxAttribute</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxAttribute
     */
    public AWxAttribute createAWxAttribute(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxAttribute aWxAttribute_ = createAWxAttribute();
        aWxAttribute_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxAttribute_);
    }

    /**
     * Creates a <code>AWxString</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxString
     */
    public AWxString createAWxString(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxString aWxString_ = createAWxString();
        aWxString_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxString_);
    }

    /**
     * Creates a <code>AWxDquote</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxDquote
     */
    public AWxDquote createAWxDquote(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxDquote aWxDquote_ = createAWxDquote();
        aWxDquote_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxDquote_);
    }

    /**
     * Creates a <code>AWxSquote</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSquote
     */
    public AWxSquote createAWxSquote(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxSquote aWxSquote_ = createAWxSquote();
        aWxSquote_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSquote_);
    }

    /**
     * Creates a <code>AWxText</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxText
     */
    public AWxText createAWxText(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxText aWxText_ = createAWxText();
        aWxText_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxText_);
    }

    /**
     * Creates a <code>AWxSp</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSp
     */
    public AWxSp createAWxSp(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxSp aWxSp_ = createAWxSp();
        aWxSp_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSp_);
    }

    /**
     * Creates a <code>AWxComment</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxComment
     */
    public AWxComment createAWxComment(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxComment aWxComment_ = createAWxComment();
        aWxComment_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxComment_);
    }

    /**
     * Creates a <code>AWxScriptlet</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxScriptlet
     */
    public AWxScriptlet createAWxScriptlet(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxScriptlet aWxScriptlet_ = createAWxScriptlet();
        aWxScriptlet_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxScriptlet_);
    }

    /**
     * Creates a <code>AWxName</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxName
     */
    public AWxName createAWxName(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxName aWxName_ = createAWxName();
        aWxName_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxName_);
    }

    /**
     * Creates a <code>AWxEq</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxEq
     */
    public AWxEq createAWxEq(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxEq aWxEq_ = createAWxEq();
        aWxEq_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxEq_);
    }

    /**
     * Creates a <code>AWxTago</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxTago
     */
    public AWxTago createAWxTago(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxTago aWxTago_ = createAWxTago();
        aWxTago_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxTago_);
    }

    /**
     * Creates a <code>AWxTagc</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxTagc
     */
    public AWxTagc createAWxTagc(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxTagc aWxTagc_ = createAWxTagc();
        aWxTagc_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxTagc_);
    }

    /**
     * Creates a <code>AWxDoctypeDecl</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxDoctypeDecl
     */
    public AWxDoctypeDecl createAWxDoctypeDecl(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxDoctypeDecl aWxDoctypeDecl_ = createAWxDoctypeDecl();
        aWxDoctypeDecl_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxDoctypeDecl_);
    }

    /**
     * Creates a <code>AWxExternalID</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxExternalID
     */
    public AWxExternalID createAWxExternalID(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxExternalID aWxExternalID_ = createAWxExternalID();
        aWxExternalID_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxExternalID_);
    }

    /**
     * Creates a <code>AWxSystem</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSystem
     */
    public AWxSystem createAWxSystem(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxSystem aWxSystem_ = createAWxSystem();
        aWxSystem_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSystem_);
    }

    /**
     * Creates a <code>AWxPublic</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxPublic
     */
    public AWxPublic createAWxPublic(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxPublic aWxPublic_ = createAWxPublic();
        aWxPublic_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxPublic_);
    }

    /**
     * Creates a <code>AWxStyleSheet</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxStyleSheet
     */
    public AWxStyleSheet createAWxStyleSheet(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxStyleSheet aWxStyleSheet_ = createAWxStyleSheet();
        aWxStyleSheet_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxStyleSheet_);
    }

    /**
     * Creates a <code>AWxElement</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxElement
     */
    public AWxElement createAWxElement(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxElement aWxElement_ = createAWxElement();
        aWxElement_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxElement_);
    }

    /**
     * Creates a <code>AWxSTag</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSTag
     */
    public AWxSTag createAWxSTag(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxSTag aWxSTag_ = createAWxSTag();
        aWxSTag_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSTag_);
    }

    /**
     * Creates a <code>AWxETag</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxETag
     */
    public AWxETag createAWxETag(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxETag aWxETag_ = createAWxETag();
        aWxETag_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxETag_);
    }

    /**
     * Creates a <code>AWxEmpty</code> by the InputSource <code>is</code>.
     * This method is a template method for concrete classes.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxEmpty
     */
    public AWxEmpty createAWxEmpty(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        AWxEmpty aWxEmpty_ = createAWxEmpty();
        aWxEmpty_.setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxEmpty_);
    }

    /**
     * Creates a <code>AWxFile</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxFile
     */
    public AWxFile createAWxFile(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxFile aWxFile_ = createAWxFile();
        aWxFile_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxFile_);
    }

    /**
     * Creates a <code>AWxNl</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxNl
     */
    public AWxNl createAWxNl(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxNl aWxNl_ = createAWxNl();
        aWxNl_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxNl_);
    }

    /**
     * Creates a <code>AWxXMLDecl</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxXMLDecl
     */
    public AWxXMLDecl createAWxXMLDecl(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxXMLDecl aWxXMLDecl_ = createAWxXMLDecl();
        aWxXMLDecl_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxXMLDecl_);
    }

    /**
     * Creates a <code>AWxAttribute</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxAttribute
     */
    public AWxAttribute createAWxAttribute(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxAttribute aWxAttribute_ = createAWxAttribute();
        aWxAttribute_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxAttribute_);
    }

    /**
     * Creates a <code>AWxString</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxString
     */
    public AWxString createAWxString(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxString aWxString_ = createAWxString();
        aWxString_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxString_);
    }

    /**
     * Creates a <code>AWxDquote</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxDquote
     */
    public AWxDquote createAWxDquote(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxDquote aWxDquote_ = createAWxDquote();
        aWxDquote_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxDquote_);
    }

    /**
     * Creates a <code>AWxSquote</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSquote
     */
    public AWxSquote createAWxSquote(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxSquote aWxSquote_ = createAWxSquote();
        aWxSquote_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSquote_);
    }

    /**
     * Creates a <code>AWxText</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxText
     */
    public AWxText createAWxText(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxText aWxText_ = createAWxText();
        aWxText_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxText_);
    }

    /**
     * Creates a <code>AWxSp</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSp
     */
    public AWxSp createAWxSp(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxSp aWxSp_ = createAWxSp();
        aWxSp_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSp_);
    }

    /**
     * Creates a <code>AWxComment</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxComment
     */
    public AWxComment createAWxComment(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxComment aWxComment_ = createAWxComment();
        aWxComment_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxComment_);
    }

    /**
     * Creates a <code>AWxScriptlet</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxScriptlet
     */
    public AWxScriptlet createAWxScriptlet(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxScriptlet aWxScriptlet_ = createAWxScriptlet();
        aWxScriptlet_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxScriptlet_);
    }

    /**
     * Creates a <code>AWxName</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxName
     */
    public AWxName createAWxName(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxName aWxName_ = createAWxName();
        aWxName_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxName_);
    }

    /**
     * Creates a <code>AWxEq</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxEq
     */
    public AWxEq createAWxEq(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxEq aWxEq_ = createAWxEq();
        aWxEq_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxEq_);
    }

    /**
     * Creates a <code>AWxTago</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxTago
     */
    public AWxTago createAWxTago(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxTago aWxTago_ = createAWxTago();
        aWxTago_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxTago_);
    }

    /**
     * Creates a <code>AWxTagc</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxTagc
     */
    public AWxTagc createAWxTagc(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxTagc aWxTagc_ = createAWxTagc();
        aWxTagc_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxTagc_);
    }

    /**
     * Creates a <code>AWxDoctypeDecl</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxDoctypeDecl
     */
    public AWxDoctypeDecl createAWxDoctypeDecl(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxDoctypeDecl aWxDoctypeDecl_ = createAWxDoctypeDecl();
        aWxDoctypeDecl_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxDoctypeDecl_);
    }

    /**
     * Creates a <code>AWxExternalID</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxExternalID
     */
    public AWxExternalID createAWxExternalID(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxExternalID aWxExternalID_ = createAWxExternalID();
        aWxExternalID_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxExternalID_);
    }

    /**
     * Creates a <code>AWxSystem</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSystem
     */
    public AWxSystem createAWxSystem(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxSystem aWxSystem_ = createAWxSystem();
        aWxSystem_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSystem_);
    }

    /**
     * Creates a <code>AWxPublic</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxPublic
     */
    public AWxPublic createAWxPublic(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxPublic aWxPublic_ = createAWxPublic();
        aWxPublic_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxPublic_);
    }

    /**
     * Creates a <code>AWxStyleSheet</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxStyleSheet
     */
    public AWxStyleSheet createAWxStyleSheet(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxStyleSheet aWxStyleSheet_ = createAWxStyleSheet();
        aWxStyleSheet_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxStyleSheet_);
    }

    /**
     * Creates a <code>AWxElement</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxElement
     */
    public AWxElement createAWxElement(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxElement aWxElement_ = createAWxElement();
        aWxElement_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxElement_);
    }

    /**
     * Creates a <code>AWxSTag</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxSTag
     */
    public AWxSTag createAWxSTag(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxSTag aWxSTag_ = createAWxSTag();
        aWxSTag_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxSTag_);
    }

    /**
     * Creates a <code>AWxETag</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxETag
     */
    public AWxETag createAWxETag(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxETag aWxETag_ = createAWxETag();
        aWxETag_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxETag_);
    }

    /**
     * Creates a <code>AWxEmpty</code> by the Reader <code>reader</code>.
     * This method is a template method for concrete classes.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     * @return AWxEmpty
     */
    public AWxEmpty createAWxEmpty(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        AWxEmpty aWxEmpty_ = createAWxEmpty();
        aWxEmpty_.setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE, errorHandler, entityResolver));
        return (aWxEmpty_);
    }

    /**
     * Creates a <code>AWxFile</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxFile
     */
    public AWxFile createAWxFile(AWxFile source) {
        AWxFile aWxFile_ = createAWxFile();
        aWxFile_.setup(source);
        return (aWxFile_);
    }

    /**
     * Creates a <code>AWxNl</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxNl
     */
    public AWxNl createAWxNl(AWxNl source) {
        AWxNl aWxNl_ = createAWxNl();
        aWxNl_.setup(source);
        return (aWxNl_);
    }

    /**
     * Creates a <code>AWxXMLDecl</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxXMLDecl
     */
    public AWxXMLDecl createAWxXMLDecl(AWxXMLDecl source) {
        AWxXMLDecl aWxXMLDecl_ = createAWxXMLDecl();
        aWxXMLDecl_.setup(source);
        return (aWxXMLDecl_);
    }

    /**
     * Creates a <code>AWxAttribute</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxAttribute
     */
    public AWxAttribute createAWxAttribute(AWxAttribute source) {
        AWxAttribute aWxAttribute_ = createAWxAttribute();
        aWxAttribute_.setup(source);
        return (aWxAttribute_);
    }

    /**
     * Creates a <code>AWxString</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxString
     */
    public AWxString createAWxString(AWxString source) {
        AWxString aWxString_ = createAWxString();
        aWxString_.setup(source);
        return (aWxString_);
    }

    /**
     * Creates a <code>AWxDquote</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxDquote
     */
    public AWxDquote createAWxDquote(AWxDquote source) {
        AWxDquote aWxDquote_ = createAWxDquote();
        aWxDquote_.setup(source);
        return (aWxDquote_);
    }

    /**
     * Creates a <code>AWxSquote</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxSquote
     */
    public AWxSquote createAWxSquote(AWxSquote source) {
        AWxSquote aWxSquote_ = createAWxSquote();
        aWxSquote_.setup(source);
        return (aWxSquote_);
    }

    /**
     * Creates a <code>AWxText</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxText
     */
    public AWxText createAWxText(AWxText source) {
        AWxText aWxText_ = createAWxText();
        aWxText_.setup(source);
        return (aWxText_);
    }

    /**
     * Creates a <code>AWxSp</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxSp
     */
    public AWxSp createAWxSp(AWxSp source) {
        AWxSp aWxSp_ = createAWxSp();
        aWxSp_.setup(source);
        return (aWxSp_);
    }

    /**
     * Creates a <code>AWxComment</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxComment
     */
    public AWxComment createAWxComment(AWxComment source) {
        AWxComment aWxComment_ = createAWxComment();
        aWxComment_.setup(source);
        return (aWxComment_);
    }

    /**
     * Creates a <code>AWxScriptlet</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxScriptlet
     */
    public AWxScriptlet createAWxScriptlet(AWxScriptlet source) {
        AWxScriptlet aWxScriptlet_ = createAWxScriptlet();
        aWxScriptlet_.setup(source);
        return (aWxScriptlet_);
    }

    /**
     * Creates a <code>AWxName</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxName
     */
    public AWxName createAWxName(AWxName source) {
        AWxName aWxName_ = createAWxName();
        aWxName_.setup(source);
        return (aWxName_);
    }

    /**
     * Creates a <code>AWxEq</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxEq
     */
    public AWxEq createAWxEq(AWxEq source) {
        AWxEq aWxEq_ = createAWxEq();
        aWxEq_.setup(source);
        return (aWxEq_);
    }

    /**
     * Creates a <code>AWxTago</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxTago
     */
    public AWxTago createAWxTago(AWxTago source) {
        AWxTago aWxTago_ = createAWxTago();
        aWxTago_.setup(source);
        return (aWxTago_);
    }

    /**
     * Creates a <code>AWxTagc</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxTagc
     */
    public AWxTagc createAWxTagc(AWxTagc source) {
        AWxTagc aWxTagc_ = createAWxTagc();
        aWxTagc_.setup(source);
        return (aWxTagc_);
    }

    /**
     * Creates a <code>AWxDoctypeDecl</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxDoctypeDecl
     */
    public AWxDoctypeDecl createAWxDoctypeDecl(AWxDoctypeDecl source) {
        AWxDoctypeDecl aWxDoctypeDecl_ = createAWxDoctypeDecl();
        aWxDoctypeDecl_.setup(source);
        return (aWxDoctypeDecl_);
    }

    /**
     * Creates a <code>AWxExternalID</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxExternalID
     */
    public AWxExternalID createAWxExternalID(AWxExternalID source) {
        AWxExternalID aWxExternalID_ = createAWxExternalID();
        aWxExternalID_.setup(source);
        return (aWxExternalID_);
    }

    /**
     * Creates a <code>AWxSystem</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxSystem
     */
    public AWxSystem createAWxSystem(AWxSystem source) {
        AWxSystem aWxSystem_ = createAWxSystem();
        aWxSystem_.setup(source);
        return (aWxSystem_);
    }

    /**
     * Creates a <code>AWxPublic</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxPublic
     */
    public AWxPublic createAWxPublic(AWxPublic source) {
        AWxPublic aWxPublic_ = createAWxPublic();
        aWxPublic_.setup(source);
        return (aWxPublic_);
    }

    /**
     * Creates a <code>AWxStyleSheet</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxStyleSheet
     */
    public AWxStyleSheet createAWxStyleSheet(AWxStyleSheet source) {
        AWxStyleSheet aWxStyleSheet_ = createAWxStyleSheet();
        aWxStyleSheet_.setup(source);
        return (aWxStyleSheet_);
    }

    /**
     * Creates a <code>AWxElement</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxElement
     */
    public AWxElement createAWxElement(AWxElement source) {
        AWxElement aWxElement_ = createAWxElement();
        aWxElement_.setup(source);
        return (aWxElement_);
    }

    /**
     * Creates a <code>AWxSTag</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxSTag
     */
    public AWxSTag createAWxSTag(AWxSTag source) {
        AWxSTag aWxSTag_ = createAWxSTag();
        aWxSTag_.setup(source);
        return (aWxSTag_);
    }

    /**
     * Creates a <code>AWxETag</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxETag
     */
    public AWxETag createAWxETag(AWxETag source) {
        AWxETag aWxETag_ = createAWxETag();
        aWxETag_.setup(source);
        return (aWxETag_);
    }

    /**
     * Creates a <code>AWxEmpty</code> by the object <code>source</code>.
     * This method is a template method for concrete classes.
     *
     * @param source
     * @return AWxEmpty
     */
    public AWxEmpty createAWxEmpty(AWxEmpty source) {
        AWxEmpty aWxEmpty_ = createAWxEmpty();
        aWxEmpty_.setup(source);
        return (aWxEmpty_);
    }

    /**
     * Creates a <code>AWxFile</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxFile
     */
    public AWxFile createAWxFile(Document doc) {
        AWxFile aWxFile_ = createAWxFile();
        aWxFile_.setup(doc);
        return (aWxFile_);
    }

    /**
     * Creates a <code>AWxNl</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxNl
     */
    public AWxNl createAWxNl(Document doc) {
        AWxNl aWxNl_ = createAWxNl();
        aWxNl_.setup(doc);
        return (aWxNl_);
    }

    /**
     * Creates a <code>AWxXMLDecl</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxXMLDecl
     */
    public AWxXMLDecl createAWxXMLDecl(Document doc) {
        AWxXMLDecl aWxXMLDecl_ = createAWxXMLDecl();
        aWxXMLDecl_.setup(doc);
        return (aWxXMLDecl_);
    }

    /**
     * Creates a <code>AWxAttribute</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxAttribute
     */
    public AWxAttribute createAWxAttribute(Document doc) {
        AWxAttribute aWxAttribute_ = createAWxAttribute();
        aWxAttribute_.setup(doc);
        return (aWxAttribute_);
    }

    /**
     * Creates a <code>AWxString</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxString
     */
    public AWxString createAWxString(Document doc) {
        AWxString aWxString_ = createAWxString();
        aWxString_.setup(doc);
        return (aWxString_);
    }

    /**
     * Creates a <code>AWxDquote</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxDquote
     */
    public AWxDquote createAWxDquote(Document doc) {
        AWxDquote aWxDquote_ = createAWxDquote();
        aWxDquote_.setup(doc);
        return (aWxDquote_);
    }

    /**
     * Creates a <code>AWxSquote</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxSquote
     */
    public AWxSquote createAWxSquote(Document doc) {
        AWxSquote aWxSquote_ = createAWxSquote();
        aWxSquote_.setup(doc);
        return (aWxSquote_);
    }

    /**
     * Creates a <code>AWxText</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxText
     */
    public AWxText createAWxText(Document doc) {
        AWxText aWxText_ = createAWxText();
        aWxText_.setup(doc);
        return (aWxText_);
    }

    /**
     * Creates a <code>AWxSp</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxSp
     */
    public AWxSp createAWxSp(Document doc) {
        AWxSp aWxSp_ = createAWxSp();
        aWxSp_.setup(doc);
        return (aWxSp_);
    }

    /**
     * Creates a <code>AWxComment</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxComment
     */
    public AWxComment createAWxComment(Document doc) {
        AWxComment aWxComment_ = createAWxComment();
        aWxComment_.setup(doc);
        return (aWxComment_);
    }

    /**
     * Creates a <code>AWxScriptlet</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxScriptlet
     */
    public AWxScriptlet createAWxScriptlet(Document doc) {
        AWxScriptlet aWxScriptlet_ = createAWxScriptlet();
        aWxScriptlet_.setup(doc);
        return (aWxScriptlet_);
    }

    /**
     * Creates a <code>AWxName</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxName
     */
    public AWxName createAWxName(Document doc) {
        AWxName aWxName_ = createAWxName();
        aWxName_.setup(doc);
        return (aWxName_);
    }

    /**
     * Creates a <code>AWxEq</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxEq
     */
    public AWxEq createAWxEq(Document doc) {
        AWxEq aWxEq_ = createAWxEq();
        aWxEq_.setup(doc);
        return (aWxEq_);
    }

    /**
     * Creates a <code>AWxTago</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxTago
     */
    public AWxTago createAWxTago(Document doc) {
        AWxTago aWxTago_ = createAWxTago();
        aWxTago_.setup(doc);
        return (aWxTago_);
    }

    /**
     * Creates a <code>AWxTagc</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxTagc
     */
    public AWxTagc createAWxTagc(Document doc) {
        AWxTagc aWxTagc_ = createAWxTagc();
        aWxTagc_.setup(doc);
        return (aWxTagc_);
    }

    /**
     * Creates a <code>AWxDoctypeDecl</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxDoctypeDecl
     */
    public AWxDoctypeDecl createAWxDoctypeDecl(Document doc) {
        AWxDoctypeDecl aWxDoctypeDecl_ = createAWxDoctypeDecl();
        aWxDoctypeDecl_.setup(doc);
        return (aWxDoctypeDecl_);
    }

    /**
     * Creates a <code>AWxExternalID</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxExternalID
     */
    public AWxExternalID createAWxExternalID(Document doc) {
        AWxExternalID aWxExternalID_ = createAWxExternalID();
        aWxExternalID_.setup(doc);
        return (aWxExternalID_);
    }

    /**
     * Creates a <code>AWxSystem</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxSystem
     */
    public AWxSystem createAWxSystem(Document doc) {
        AWxSystem aWxSystem_ = createAWxSystem();
        aWxSystem_.setup(doc);
        return (aWxSystem_);
    }

    /**
     * Creates a <code>AWxPublic</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxPublic
     */
    public AWxPublic createAWxPublic(Document doc) {
        AWxPublic aWxPublic_ = createAWxPublic();
        aWxPublic_.setup(doc);
        return (aWxPublic_);
    }

    /**
     * Creates a <code>AWxStyleSheet</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxStyleSheet
     */
    public AWxStyleSheet createAWxStyleSheet(Document doc) {
        AWxStyleSheet aWxStyleSheet_ = createAWxStyleSheet();
        aWxStyleSheet_.setup(doc);
        return (aWxStyleSheet_);
    }

    /**
     * Creates a <code>AWxElement</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxElement
     */
    public AWxElement createAWxElement(Document doc) {
        AWxElement aWxElement_ = createAWxElement();
        aWxElement_.setup(doc);
        return (aWxElement_);
    }

    /**
     * Creates a <code>AWxSTag</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxSTag
     */
    public AWxSTag createAWxSTag(Document doc) {
        AWxSTag aWxSTag_ = createAWxSTag();
        aWxSTag_.setup(doc);
        return (aWxSTag_);
    }

    /**
     * Creates a <code>AWxETag</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxETag
     */
    public AWxETag createAWxETag(Document doc) {
        AWxETag aWxETag_ = createAWxETag();
        aWxETag_.setup(doc);
        return (aWxETag_);
    }

    /**
     * Creates a <code>AWxEmpty</code> by the Document <code>doc</code>.
     * This method is a template method for concrete classes.
     *
     * @param doc
     * @return AWxEmpty
     */
    public AWxEmpty createAWxEmpty(Document doc) {
        AWxEmpty aWxEmpty_ = createAWxEmpty();
        aWxEmpty_.setup(doc);
        return (aWxEmpty_);
    }

    /**
     * Creates a <code>AWxFile</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxFile
     */
    public AWxFile createAWxFile(Element element) {
        AWxFile aWxFile_ = createAWxFile();
        aWxFile_.setup(element);
        return (aWxFile_);
    }

    /**
     * Creates a <code>AWxNl</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxNl
     */
    public AWxNl createAWxNl(Element element) {
        AWxNl aWxNl_ = createAWxNl();
        aWxNl_.setup(element);
        return (aWxNl_);
    }

    /**
     * Creates a <code>AWxXMLDecl</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxXMLDecl
     */
    public AWxXMLDecl createAWxXMLDecl(Element element) {
        AWxXMLDecl aWxXMLDecl_ = createAWxXMLDecl();
        aWxXMLDecl_.setup(element);
        return (aWxXMLDecl_);
    }

    /**
     * Creates a <code>AWxAttribute</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxAttribute
     */
    public AWxAttribute createAWxAttribute(Element element) {
        AWxAttribute aWxAttribute_ = createAWxAttribute();
        aWxAttribute_.setup(element);
        return (aWxAttribute_);
    }

    /**
     * Creates a <code>AWxString</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxString
     */
    public AWxString createAWxString(Element element) {
        AWxString aWxString_ = createAWxString();
        aWxString_.setup(element);
        return (aWxString_);
    }

    /**
     * Creates a <code>AWxDquote</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxDquote
     */
    public AWxDquote createAWxDquote(Element element) {
        AWxDquote aWxDquote_ = createAWxDquote();
        aWxDquote_.setup(element);
        return (aWxDquote_);
    }

    /**
     * Creates a <code>AWxSquote</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxSquote
     */
    public AWxSquote createAWxSquote(Element element) {
        AWxSquote aWxSquote_ = createAWxSquote();
        aWxSquote_.setup(element);
        return (aWxSquote_);
    }

    /**
     * Creates a <code>AWxText</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxText
     */
    public AWxText createAWxText(Element element) {
        AWxText aWxText_ = createAWxText();
        aWxText_.setup(element);
        return (aWxText_);
    }

    /**
     * Creates a <code>AWxSp</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxSp
     */
    public AWxSp createAWxSp(Element element) {
        AWxSp aWxSp_ = createAWxSp();
        aWxSp_.setup(element);
        return (aWxSp_);
    }

    /**
     * Creates a <code>AWxComment</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxComment
     */
    public AWxComment createAWxComment(Element element) {
        AWxComment aWxComment_ = createAWxComment();
        aWxComment_.setup(element);
        return (aWxComment_);
    }

    /**
     * Creates a <code>AWxScriptlet</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxScriptlet
     */
    public AWxScriptlet createAWxScriptlet(Element element) {
        AWxScriptlet aWxScriptlet_ = createAWxScriptlet();
        aWxScriptlet_.setup(element);
        return (aWxScriptlet_);
    }

    /**
     * Creates a <code>AWxName</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxName
     */
    public AWxName createAWxName(Element element) {
        AWxName aWxName_ = createAWxName();
        aWxName_.setup(element);
        return (aWxName_);
    }

    /**
     * Creates a <code>AWxEq</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxEq
     */
    public AWxEq createAWxEq(Element element) {
        AWxEq aWxEq_ = createAWxEq();
        aWxEq_.setup(element);
        return (aWxEq_);
    }

    /**
     * Creates a <code>AWxTago</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxTago
     */
    public AWxTago createAWxTago(Element element) {
        AWxTago aWxTago_ = createAWxTago();
        aWxTago_.setup(element);
        return (aWxTago_);
    }

    /**
     * Creates a <code>AWxTagc</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxTagc
     */
    public AWxTagc createAWxTagc(Element element) {
        AWxTagc aWxTagc_ = createAWxTagc();
        aWxTagc_.setup(element);
        return (aWxTagc_);
    }

    /**
     * Creates a <code>AWxDoctypeDecl</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxDoctypeDecl
     */
    public AWxDoctypeDecl createAWxDoctypeDecl(Element element) {
        AWxDoctypeDecl aWxDoctypeDecl_ = createAWxDoctypeDecl();
        aWxDoctypeDecl_.setup(element);
        return (aWxDoctypeDecl_);
    }

    /**
     * Creates a <code>AWxExternalID</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxExternalID
     */
    public AWxExternalID createAWxExternalID(Element element) {
        AWxExternalID aWxExternalID_ = createAWxExternalID();
        aWxExternalID_.setup(element);
        return (aWxExternalID_);
    }

    /**
     * Creates a <code>AWxSystem</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxSystem
     */
    public AWxSystem createAWxSystem(Element element) {
        AWxSystem aWxSystem_ = createAWxSystem();
        aWxSystem_.setup(element);
        return (aWxSystem_);
    }

    /**
     * Creates a <code>AWxPublic</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxPublic
     */
    public AWxPublic createAWxPublic(Element element) {
        AWxPublic aWxPublic_ = createAWxPublic();
        aWxPublic_.setup(element);
        return (aWxPublic_);
    }

    /**
     * Creates a <code>AWxStyleSheet</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxStyleSheet
     */
    public AWxStyleSheet createAWxStyleSheet(Element element) {
        AWxStyleSheet aWxStyleSheet_ = createAWxStyleSheet();
        aWxStyleSheet_.setup(element);
        return (aWxStyleSheet_);
    }

    /**
     * Creates a <code>AWxElement</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxElement
     */
    public AWxElement createAWxElement(Element element) {
        AWxElement aWxElement_ = createAWxElement();
        aWxElement_.setup(element);
        return (aWxElement_);
    }

    /**
     * Creates a <code>AWxSTag</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxSTag
     */
    public AWxSTag createAWxSTag(Element element) {
        AWxSTag aWxSTag_ = createAWxSTag();
        aWxSTag_.setup(element);
        return (aWxSTag_);
    }

    /**
     * Creates a <code>AWxETag</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxETag
     */
    public AWxETag createAWxETag(Element element) {
        AWxETag aWxETag_ = createAWxETag();
        aWxETag_.setup(element);
        return (aWxETag_);
    }

    /**
     * Creates a <code>AWxEmpty</code> by the Element <code>element</code>.
     * This method is a template method for concrete classes.
     *
     * @param element
     * @return AWxEmpty
     */
    public AWxEmpty createAWxEmpty(Element element) {
        AWxEmpty aWxEmpty_ = createAWxEmpty();
        aWxEmpty_.setup(element);
        return (aWxEmpty_);
    }

    /**
     * Creates a <code>AWxFile</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxFile
     */
    public AWxFile createAWxFile(RStack stack) {
        AWxFile aWxFile_ = createAWxFile();
        aWxFile_.setup(stack);
        return (aWxFile_);
    }

    /**
     * Creates a <code>AWxNl</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxNl
     */
    public AWxNl createAWxNl(RStack stack) {
        AWxNl aWxNl_ = createAWxNl();
        aWxNl_.setup(stack);
        return (aWxNl_);
    }

    /**
     * Creates a <code>AWxXMLDecl</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxXMLDecl
     */
    public AWxXMLDecl createAWxXMLDecl(RStack stack) {
        AWxXMLDecl aWxXMLDecl_ = createAWxXMLDecl();
        aWxXMLDecl_.setup(stack);
        return (aWxXMLDecl_);
    }

    /**
     * Creates a <code>AWxAttribute</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxAttribute
     */
    public AWxAttribute createAWxAttribute(RStack stack) {
        AWxAttribute aWxAttribute_ = createAWxAttribute();
        aWxAttribute_.setup(stack);
        return (aWxAttribute_);
    }

    /**
     * Creates a <code>AWxString</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxString
     */
    public AWxString createAWxString(RStack stack) {
        AWxString aWxString_ = createAWxString();
        aWxString_.setup(stack);
        return (aWxString_);
    }

    /**
     * Creates a <code>AWxDquote</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxDquote
     */
    public AWxDquote createAWxDquote(RStack stack) {
        AWxDquote aWxDquote_ = createAWxDquote();
        aWxDquote_.setup(stack);
        return (aWxDquote_);
    }

    /**
     * Creates a <code>AWxSquote</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxSquote
     */
    public AWxSquote createAWxSquote(RStack stack) {
        AWxSquote aWxSquote_ = createAWxSquote();
        aWxSquote_.setup(stack);
        return (aWxSquote_);
    }

    /**
     * Creates a <code>AWxText</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxText
     */
    public AWxText createAWxText(RStack stack) {
        AWxText aWxText_ = createAWxText();
        aWxText_.setup(stack);
        return (aWxText_);
    }

    /**
     * Creates a <code>AWxSp</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxSp
     */
    public AWxSp createAWxSp(RStack stack) {
        AWxSp aWxSp_ = createAWxSp();
        aWxSp_.setup(stack);
        return (aWxSp_);
    }

    /**
     * Creates a <code>AWxComment</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxComment
     */
    public AWxComment createAWxComment(RStack stack) {
        AWxComment aWxComment_ = createAWxComment();
        aWxComment_.setup(stack);
        return (aWxComment_);
    }

    /**
     * Creates a <code>AWxScriptlet</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxScriptlet
     */
    public AWxScriptlet createAWxScriptlet(RStack stack) {
        AWxScriptlet aWxScriptlet_ = createAWxScriptlet();
        aWxScriptlet_.setup(stack);
        return (aWxScriptlet_);
    }

    /**
     * Creates a <code>AWxName</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxName
     */
    public AWxName createAWxName(RStack stack) {
        AWxName aWxName_ = createAWxName();
        aWxName_.setup(stack);
        return (aWxName_);
    }

    /**
     * Creates a <code>AWxEq</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxEq
     */
    public AWxEq createAWxEq(RStack stack) {
        AWxEq aWxEq_ = createAWxEq();
        aWxEq_.setup(stack);
        return (aWxEq_);
    }

    /**
     * Creates a <code>AWxTago</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxTago
     */
    public AWxTago createAWxTago(RStack stack) {
        AWxTago aWxTago_ = createAWxTago();
        aWxTago_.setup(stack);
        return (aWxTago_);
    }

    /**
     * Creates a <code>AWxTagc</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxTagc
     */
    public AWxTagc createAWxTagc(RStack stack) {
        AWxTagc aWxTagc_ = createAWxTagc();
        aWxTagc_.setup(stack);
        return (aWxTagc_);
    }

    /**
     * Creates a <code>AWxDoctypeDecl</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxDoctypeDecl
     */
    public AWxDoctypeDecl createAWxDoctypeDecl(RStack stack) {
        AWxDoctypeDecl aWxDoctypeDecl_ = createAWxDoctypeDecl();
        aWxDoctypeDecl_.setup(stack);
        return (aWxDoctypeDecl_);
    }

    /**
     * Creates a <code>AWxExternalID</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxExternalID
     */
    public AWxExternalID createAWxExternalID(RStack stack) {
        AWxExternalID aWxExternalID_ = createAWxExternalID();
        aWxExternalID_.setup(stack);
        return (aWxExternalID_);
    }

    /**
     * Creates a <code>AWxSystem</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxSystem
     */
    public AWxSystem createAWxSystem(RStack stack) {
        AWxSystem aWxSystem_ = createAWxSystem();
        aWxSystem_.setup(stack);
        return (aWxSystem_);
    }

    /**
     * Creates a <code>AWxPublic</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxPublic
     */
    public AWxPublic createAWxPublic(RStack stack) {
        AWxPublic aWxPublic_ = createAWxPublic();
        aWxPublic_.setup(stack);
        return (aWxPublic_);
    }

    /**
     * Creates a <code>AWxStyleSheet</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxStyleSheet
     */
    public AWxStyleSheet createAWxStyleSheet(RStack stack) {
        AWxStyleSheet aWxStyleSheet_ = createAWxStyleSheet();
        aWxStyleSheet_.setup(stack);
        return (aWxStyleSheet_);
    }

    /**
     * Creates a <code>AWxElement</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxElement
     */
    public AWxElement createAWxElement(RStack stack) {
        AWxElement aWxElement_ = createAWxElement();
        aWxElement_.setup(stack);
        return (aWxElement_);
    }

    /**
     * Creates a <code>AWxSTag</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxSTag
     */
    public AWxSTag createAWxSTag(RStack stack) {
        AWxSTag aWxSTag_ = createAWxSTag();
        aWxSTag_.setup(stack);
        return (aWxSTag_);
    }

    /**
     * Creates a <code>AWxETag</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxETag
     */
    public AWxETag createAWxETag(RStack stack) {
        AWxETag aWxETag_ = createAWxETag();
        aWxETag_.setup(stack);
        return (aWxETag_);
    }

    /**
     * Creates a <code>AWxEmpty</code> by the Stack <code>stack</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     * This method is a template method for concrete classes.
     *
     * @param stack
     * @return AWxEmpty
     */
    public AWxEmpty createAWxEmpty(RStack stack) {
        AWxEmpty aWxEmpty_ = createAWxEmpty();
        aWxEmpty_.setup(stack);
        return (aWxEmpty_);
    }
}
