/* 
 * Program:             $RCSfile: PIDB.c,v $  $Revision: 30.36 $
 * 
 * Purpose:
 * 
 * Author:              T.Mimura  1992/12/22
 *                      S.Yamamoto  1994/09/01
 * 
 * Note:                Modified preprocessor in GCC ver. 1.4.2.
 *
 * (C) Copyright:       T.Mimura and S.Yamamoto  1992 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid_PIDB_c[] =
    "$Id: PIDB.c,v 30.36 2003/06/28 15:32:28 yamamoto Exp yamamoto $";
#endif

/* 
 * "cccp.c"ѤХѿ:
 *     instack
 *     indepth
 * 
 * "cccp.c"Ѥ:
 *     DEFINITION
 *     struct reflist
 *     FILE_BUF
 *     U_CHAR
 */

#define IS_DEFINED_IN_INITIALIZATION(p) SPD_STREQ((p), "*Initialization*")
#define IS_DEFINED_IN_DOPTION(p)        SPD_STREQ((p), "*Doption*")

/* Temporarily added by S.Yamamoto 2003/05/21. */
#define SPD_WRITE_INT_ATTR(fp, val)     spdWriteIntAttr((fp), (val))

char *PREdataSuffix[CPPinfoN] = {
    PIDB_DEFINE_SUFFIX,
    PIDB_EXPAND_SUFFIX,
    PIDB_IFEXPR_SUFFIX
};

FILE *PREdataFile[CPPinfoN];

int pidbNumOfRecord[CPPinfoN] = {
    0,
    0,
    0
};

typedef struct  {               /* Position in a file (line, column). */
    int     real_lineno;
    int     column;
} PositionInFile;

void    PREdataInitialize(SpdObjId ifileId);

static int              countNewlineSpace(U_CHAR *start, U_CHAR *end);
static void             write_argnames(FILE *fp, U_CHAR *argnames, int args);
static void             pidbWriteDefineInfo(U_CHAR *symname, int sym_length,
                                            DEFINITION *defn);
static PositionInFile   GetPosition(FILE_BUF *fp, U_CHAR *bp);

/*
 * Υݥ󥿤 FILE_BUF  ֥ fp ΥХåեβܲ
 * ؤĴ٤롥 PositionInFile* ǤϤʤ PositionInFile ֤
 */

static PositionInFile  GetPosition(FILE_BUF *fp, U_CHAR *bp)
{
    PositionInFile  pos;
    U_CHAR          *p;
    int             ns;                     /* NewlineSpace or NewlineTab. */
    
    pos.real_lineno = 1;
    pos.column = 1;
    ns = 0;
    p = fp->buf;
    while (p != bp) {
        if (*p == '\n') {
            if (fp->macro!=0 && fp->argno < 0) {
                ns++;
            } else {
                pos.real_lineno++;
                pos.column = 0;
            }
        }
        pos.column++;
        p++;
    }
    pos.column -= ns;
    return (pos);
}

/*
 * ϰϤˤ NewlineSpace ڤ NewlineTab 롥
 */

static int countNewlineSpace(U_CHAR *start, U_CHAR *end)
{
    int     r;
    U_CHAR  *p;
    
    r = 0;
    if (end <= start) {
        return (0);
    }
    for (p = start; p < end; p++) {
        if (*p != '\n') {
            continue;
        }
        if (*(p+1) == ' '  ||  *(p+1) == '\t') {
            r ++;
            p++;
        }
    }
    return (r);
}

/*
 * 
 */

void    PREdataInitialize(SpdObjId ifileId)
{
    int     i;
    char    fileName[FILENAME_MAX + 1];
    
    for (i = 0; i < CPPinfoN; i++) {
        sprintf(fileName, "%d%s", ifileId, PREdataSuffix[i]);
        PREdataFile[i] = spdOpenSDBfile(PIDB_DIR, fileName, SAPID_O_WRITE);
    }
}

/*
 * λ
 */

void    PREdataWindUp(SpdObjId ifile_id)
{
    int     i;

    for (i = 0; i < CPPinfoN; i++) {
        spdFclose(PREdataFile[i]);
    }
}

/*
 * InputBuffer˴ؤ񤭽Ф
 */

void    write_InputBufferDB(FILE *fp, InputBuffer ib)
{
    if (ib->fname != 0) {
        /* 0: ե롥 */
        spdWriteIntAttr(fp, 0);
        spdWriteStrAttr(fp, ib->fname);
    } else if (ib->macro != 0) {
        /* 1: ޥŸ */
        spdWriteIntAttr(fp, 1);
        spdWriteIntAttr(fp, ib->macrocallID);
    } else if (ib->argno >= 0) {
        /* 2: ޥΰ */
        spdWriteIntAttr(fp, 2);
        spdWriteIntAttr(fp, ib->macrocallID);
        spdWriteIntAttr(fp, ib->argno);
    } else {
        spdErrorExit("Invalid InputBuffer.\n");
    }
    pidbWriteLineSeparator(fp);
}

/*
 * ϥե˴ؤ񤭽Ф
 */

void    write_OutputBufferDB(FILE *fp, FILE_BUF *ob)
{
    if (ob->fname != 0) {
        spdWriteIntAttr(fp, 0);
        spdWriteStrAttr(fp, ob->fname);
    } else if (ob->argno >= 0) {
        spdWriteIntAttr(fp, 1);
        spdWriteIntAttr(fp, ob->macrocallID);
        spdWriteIntAttr(fp, ob->argno);
    } else {
        spdErrorExit("Invalid OutputBuffer.\n");
    }
    pidbWriteLineSeparator(fp);
}

/*
 *  DEFINITION Υ U_CHAR *expansion 
 * NewlineSpace  space ˡNewlineTab  tab ֤롥
 */

void    MakeExpansionText(U_CHAR *origin, U_CHAR *expansion)
{
    U_CHAR      *p, *q;
    
    strcpy((char *)expansion, (char *)origin);
    p = expansion;
    while (*p !=  '\0') {
        if (*p=='\n' && (*(p + 1)==' ' || *(p + 1)=='\t')) {
            *p = *(p + 1);                  /* Newline  */
            q = p + 1;                      /* ʹߤʸ1ʸ˵ͤ롥 */ 
            while (*q != '\0') {
                *q = *(q + 1);
                q++;
            }
        }
        p++;
    }
}

/*
 * write_do_define Τ˥ޥΥѥ᡼Ϥ롥
 */

static void write_argnames(FILE *fp, U_CHAR *argnames, int args)
{
    int     i;
    U_CHAR  *ap, arg[100];
    /* 100ʸʾΥѥ᡼ϻȤޤ */

    if (args < 1) {
        return;
    }
    ap = argnames;
    while (*ap != '\0') {
        ap++;
    }
    
    for (i = 0; i < args; i++) {
        int     len = 0, j;

        while (ap != argnames && *(ap - 1) != ',') {
            ap--;
            len++;
        }
        for (j = 0; j < len; j++) {
            arg[j] = *(ap + j);
        }
        arg[len] = '\0';
        if (ap != argnames) {
            ap--;
        }
        /* ̾ */
        SPDWRITESTRATTR(fp, arg);
        pidbWriteLineSeparator(fp);
    }
}

/*
 * ޥξ񤭽Ф
 * 
 * ƤӽФ: do_define()
 * symnamesym_length: 줿ܥƬʸȤĹ
 * defn: 줿ޥ
 */

static void pidbWriteDefineInfo(U_CHAR *symname, int sym_length, 
                                DEFINITION *defn)
{
    FILE            *fp;
    struct reflist  *ap;
    FILE_BUF        *ip;
    int             refn;
    U_CHAR          expansion[SPD_LINE_LEN + 1];
    U_CHAR          tmp[SPD_LINE_LEN + 1];
    
    fp = PREdataFile[CPPinfoDEFINE];
    ip = &(instack[indepth]);
    
    /* ޥμֹ桥 */
    spdWriteIntAttr(fp, defn->ID);
    pidbWriteLineSeparator(fp);

    /* ֡ */
    if (ip->fname == NULL) {
        spdErrorExit("File name in which macro defined is NULL.\n" );
    }
    if (IS_DEFINED_IN_INITIALIZATION(ip->fname)) {
        /* 0:  */
        spdWriteIntAttr(fp, 0);
    } else if (IS_DEFINED_IN_DOPTION(ip->fname)) {
        /* 1: -D option */
        spdWriteIntAttr(fp, 1);
    } else {
        /* 2: #define */
        spdWriteIntAttr(fp, 2);
        spdWriteStrAttr(fp, ip->fname);
        SPD_WRITE_INT_ATTR(fp, ip->directiveStart - ip->buf);
        SPD_WRITE_INT_ATTR(fp, ip->bufp - ip->buf);
    }
    pidbWriteLineSeparator(fp);

    /* ޥ̾ */
    STRNCPY(tmp, symname, sym_length);
    tmp[sym_length] = '\0';
    SPDWRITESTRATTR(fp, tmp);
    pidbWriteLineSeparator(fp);

    /* θĿ */
    spdWriteIntAttr(fp, defn->nargs);
    pidbWriteLineSeparator(fp);
    
    /* ִʸ */
    MakeExpansionText(defn->expansion, expansion);
    SPDWRITESTRATTR(fp, expansion);
    pidbWriteLineSeparator(fp);

    if (defn->nargs > 0) {
        refn = 0;
        ap = defn->pattern;
        while (ap  != NULL) {
            refn++;
            ap = ap->next;
        }
        /* Ÿκݤ˰Ȥ */
        spdWriteIntAttr(fp, refn);
        pidbWriteLineSeparator(fp);

        ap = defn->pattern;
        while (ap != NULL) {
            int         nc, i;
            U_CHAR      *p;
            
            nc = ap->nchars;
            p=defn->expansion;
            if (ap == defn->pattern) {      /* only for first reference */
                /* NewlineSpace, NewkineTab ʬʸ򸺤餹  */
                for (i=0; i < defn->pattern->nchars;  i++) {
                    if (*p == '\n') {
                        nc--;
                    }
                    p++;
                }
            }
            /* ֡ */
            spdWriteIntAttr(fp, nc);
            spdWriteIntAttr(fp, ap->argno);
            /* "#"ĤƤ뤫 */
            spdWriteIntAttr(fp, (ap->stringify != 0) ? 1 : 0);
            /* "##"ˤ뤫 */
            spdWriteIntAttr(fp, (ap->raw_before != 0) ? 1 : 0);
            /* "##"ˤ뤫 */
            spdWriteIntAttr(fp, (ap->raw_after != 0) ? 1 : 0);
            pidbWriteLineSeparator(fp);

            ap = ap->next;
        }
        write_argnames(fp, defn->argnames, defn->nargs);
    }
    /* ޥˤϥեΰ֡ */
    SPD_WRITE_INT_ATTR(fp, outbuf.directiveStart - outbuf.buf);
    pidbWriteLineSeparator(fp);

    pidbWriteTupleSeparator(fp);
    pidbNumOfRecord[CPPinfoDEFINE]++;
}

/*
 * ޥŸξ񤭽Фop Ͻϥե롥
 */

void pidbWriteExpandInfo(FILE_BUF *op)
{
    FILE        *fp;
    FILE_BUF    *ip;
    InputBuffer call;
    int         nargs;
    
    fp = PREdataFile[CPPinfoEXPAND];
    ip = &(instack[indepth]);
    call = ip->inBuf;
    nargs = ip->macro->value.defn->nargs;
    
    if (ip->macro == 0) {
        spdWarning("Invalid macroexpand.\n");
    }
    if (ip->macrocallID < 0) {
        /* macrocallID ξ̵뤹٤ޥƽФ */
        if (nargs > 0) {
            spdFree(ip->args);
        }
        return;
    }

    /* Id. of macro expansion. */    
    spdWriteIntAttr(fp, ip->macrocallID);
    pidbWriteLineSeparator(fp);

    /* Id. of macro. */
    spdWriteIntAttr(fp, ip->macro->value.defn->ID);
    pidbWriteLineSeparator(fp);

    /* ïΥޥƤΤ */
    write_InputBufferDB(fp, call);

    /* ޥƤӽФΰ(ϰ) */
    {
        int     c1 = 0, c2 = 0;
        U_CHAR  *p;
        
        if (call->macro!=NULL && call->argno < 0) {
            for (p = call->buf; p < ip->inStart; p++) {
                if (*p == '\n')
                    c1++;
            }
        }
        if (call->macro != NULL && call->argno < 0) {
            for (p = call->buf; p < ip->inEnd; p++) {
                if (*p == '\n')
                    c2++;
            }
        } /* For Newline Space, NewlineTab. */
        SPD_WRITE_INT_ATTR(fp, ip->inStart - call->buf - c1);
        SPD_WRITE_INT_ATTR(fp, ip->inEnd - call->buf - c2);
        pidbWriteLineSeparator(fp);
    }
    
    /* ˴ؤǡ */
    if (0 < nargs) {
        int                         i;
        struct PREdataMacargData    *ag;
        
        ag = ip->args;
        for (i = 0; i < nargs; i++) {
            int     c = 0;
            
            if (ag->inBuf->macro!=NULL && ag->inBuf->argno < 0) {
                U_CHAR      *p;

                for (p=ag->inBuf->buf; p < ag->inStart; p++) {
                    if (*p == '\n') {
                        c++;
                    }
                }
            } /* For Newline Space, NewlineTab. */
            SPD_WRITE_INT_ATTR(fp, ag->inStart - ag->inBuf->buf - c);
            SPD_WRITE_INT_ATTR(fp, ag->inEnd   - ag->inBuf->buf - c);
            spdWriteIntAttr(fp, ag->raw_length);
            spdWriteIntAttr(fp, ag->expand_length - ag->expNewlineSpace);
            spdWriteIntAttr(fp, ag->stringified_length);
            spdWriteIntAttr(fp, ag->trailingSpace);
            spdWriteIntAttr(fp, ag->followingSpace);
            pidbWriteLineSeparator(fp);
            ag++;
        }
        spdFree(ip->args);
    }
    
    {
        int     d1, d2;
        
        d1 = d2 = 0;
        if (op->fname == 0) {
            d1 = countNewlineSpace(op->buf, op->buf+ip->outStart);
            d2 = countNewlineSpace(op->buf, op->bufp - 1);
        }
        /* ϥե˴ؤ */
        write_OutputBufferDB(fp, op);

        spdWriteIntAttr(fp, ip->outStart - d1);
        SPD_WRITE_INT_ATTR(fp, op->bufp - 1 - op->buf - d2);
        pidbWriteLineSeparator(fp);
    }

    pidbWriteTupleSeparator(fp);
    pidbNumOfRecord[CPPinfoEXPAND]++;
}

/******************************************************************************/

/*
 * ".c"ե".i"եбɽ"./SDB/PIDB/cfile_ifile"˽Ϥ롥
 * 1Ԥη
 * 
 *     <".c"եμֹ>\t<".i"եμֹ>
 * 
 * Ǥ롥
 */

void pidbWriteCtoITable(SpdObjId cfile_id, SpdObjId ifile_id)
{
    FILE    *fp;

    fp = spdOpenSDBfile(PIDB_DIR, PIDB_CFILE_IFILE, SAPID_O_APPEND);
    fprintf(fp, "%d\t%d\n", cfile_id, ifile_id);
    spdFclose(fp);
}

/******************************************************************************/

/*
 * Output whether #if/#ifdef/#ifndef/#elif block is expanded or not.
 *
 * Format:
 * cfilename cline boolean ifilename iline
 *
 * #if directive exist at cfilename (in cline), and
 * its value is bolean, and it is expanded to ifilename (in iline).
 *
 */

void pidbWriteIfExprInfo(FILE_BUF *op, SpdBoolean bool)
{
    FILE *fp;
    FILE_BUF    *ip;

    fp = PREdataFile[CPPinfoIFEXPR];
    ip = &(instack[indepth]);

    spdWriteStrAttr(fp, ip->fname);
    spdWriteIntAttr(fp, GetPosition(ip, ip->directiveStart).real_lineno);
    spdWriteIntAttr(fp, bool);
    spdWriteStrAttr(fp, op->fname);
    spdWriteIntAttr(fp, GetPosition(op, op->directiveStart).real_lineno);
    pidbWriteLineSeparator(fp);

    pidbWriteTupleSeparator(fp);
    pidbNumOfRecord[CPPinfoIFEXPR]++;
}
