/* 
 * Program:             $RCSfile: cccp-proto.h,v $  $Revision: 40.7 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  2002/09/15
 *
 * (C) Copyright:       S.Yamamoto  2002
 *                      This file is a product of the project Sapid.
 */

/* cccp.c */
void PREdataInitialize(SpdObjId ifileId);
void PREdataWindUp(SpdObjId ifile_id);
void write_InputBufferDB(FILE *fp, InputBuffer ib);
void write_OutputBufferDB(FILE *fp, FILE_BUF *ob);
void MakeExpansionText(U_CHAR *origin, U_CHAR *expansion);
void pidbWriteExpandInfo(FILE_BUF *op);
void pidbWriteCtoITable(SpdObjId cfile_id, SpdObjId ifile_id);
void pidbWriteIfExprInfo(FILE_BUF *op, SpdBoolean bool);
int main(int argc, char **argv);
/* int trigraph_pcp(FILE_BUF *buf); */
void trigraph_pcp(FILE_BUF *buf);
/* int newline_fix(U_CHAR *bp); */
void newline_fix(U_CHAR *bp);
void name_newline_fix(U_CHAR *bp);
void rescan(FILE_BUF *op, int output_marks);
FILE_BUF expand_to_temp_buffer(U_CHAR *buf, U_CHAR *limit, int output_marks, int macrocallID, int argno);
int handle_directive(FILE_BUF *ip, FILE_BUF *op);
void special_symbol(HASHNODE *hp, FILE_BUF *op);
void do_include(U_CHAR *buf, U_CHAR *limit, FILE_BUF *op, struct directive *keyword);
void finclude(int f, char *fname, FILE_BUF *op);
int do_define(U_CHAR *buf, U_CHAR *limit, FILE_BUF *op, struct directive *keyword);
int compare_defs(DEFINITION *d1, DEFINITION *d2);
int comp_def_part(int first, U_CHAR *beg1, int len1, U_CHAR *beg2, int len2, int last);
DEFINITION *collect_expansion(U_CHAR *buf, U_CHAR *end, int nargs, struct arglist *arglist);
void do_line(U_CHAR *buf, U_CHAR *limit, FILE_BUF *op, struct directive *keyword);
void do_undef(U_CHAR *buf, U_CHAR *limit, FILE_BUF *op, struct directive *keyword);
void do_error(U_CHAR *buf, U_CHAR *limit, FILE_BUF *op, struct directive *keyword);
void do_once(void);
void do_pragma(U_CHAR *buf, U_CHAR *limit, FILE_BUF *op, struct directive *keyword);
void do_sccs(void);
void do_if(U_CHAR *buf, U_CHAR *limit, FILE_BUF *op, struct directive *keyword);
void do_elif(U_CHAR *buf, U_CHAR *limit, FILE_BUF *op, struct directive *keyword);
int eval_if_expression(U_CHAR *buf, int length);
void do_xifdef(U_CHAR *buf, U_CHAR *limit, FILE_BUF *op, struct directive *keyword);
void conditional_skip(FILE_BUF *ip, int skip, enum node_type type);
void skip_if_group(FILE_BUF *ip, int any);
void do_else(U_CHAR *buf, U_CHAR *limit, FILE_BUF *op, struct directive *keyword);
void do_endif(U_CHAR *buf, U_CHAR *limit, FILE_BUF *op, struct directive *keyword);
void validate_else(register U_CHAR *p);
U_CHAR *skip_to_end_of_comment(register FILE_BUF *ip, int *line_counter);
U_CHAR *skip_quoted_string(register U_CHAR *bp, register U_CHAR *limit, int start_line, int *count_newlines, int *backslash_newlines_p, int *eofp);
void output_line_command(FILE_BUF *ip, FILE_BUF *op, int conditional, enum file_change_code file_change);
void macroexpand(HASHNODE *hp, FILE_BUF *op);
char *macarg(register struct argdata *argptr, int macrocallID, int argno);
U_CHAR *macarg1(U_CHAR *start, register U_CHAR *limit, int *depthptr, int *newlines, int *comments);
int discard_comments(U_CHAR *start, int length, int newlines);
/* void error(char *msg, int arg1, int arg2, int arg3); */
/* void error_from_errno(char *name); */
void warning(char *msg, int arg1, int arg2, int arg3);
void error_with_line(int line, char *msg, int arg1, int arg2, int arg3);
int line_for_error(int line);
int grow_outbuf(register FILE_BUF *obuf, register int needed);
HASHNODE *install(U_CHAR *name, int len, enum node_type type, int ivalue, DEFINITION *dvalue, int hash);
HASHNODE *lookup(U_CHAR *name, int len, int hash);
void delete_macro(HASHNODE *hp);
int hashf(register U_CHAR *name, register int len, int hashsize);
void dump_all_macros(void);
void dump_defn_1(U_CHAR *base, int start, int length);
void dump_arg_n(DEFINITION *defn, int argnum);
void initialize_char_syntax(void);
void initialize_builtins(void);
void make_definition(U_CHAR *str, int isDoption);
void make_undef(U_CHAR *str);
void deps_output(char *string, int size);
void fatal(char *str, char *arg);
void fancy_abort(void);
/* void perror_with_name(char *name); */
void pfatal_with_name(char *name);
void memory_full(void);
char *xmalloc(int size);
char *xrealloc(char *old, int size);
char *xcalloc(int number, int size);
char *savestring(char *input);
int file_size_and_mode(int fd, int *mode_pointer, long int *size_pointer);

/* cexp.y */
int parse_c_expression(char *string);
