/* 
 * Program:             $RCSfile: fix-0059.c,v $  $Revision: 30.12 $
 * 
 * Purpose:
 * 
 * Author:              N.Fukuyasu  1998/02/28
 *                      S.Yamamoto  1998/02/28
 * 
 * (C) Copyright:       N.Fukuyasu and S.Yamamoto  1998
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: fix-0059.c,v 30.12 2003/06/28 15:32:01 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/write_sdb_sub.h>
#include "fixSDB.h"

static SpdObjId find_ident(SpdString, SpdObjId);
static SpdObjId find_ident_decl(SpdString, SpdObjIdArray);
static SpdBoolean no_ident_ref(SpdObjId);
static int get_offset(SpdObjId);
static SpdBoolean is_scope(SpdObjId);
static SpdBoolean is_decl(SpdObjId);

/*
 * Ͽֹ: sdbin3-0059
 * ɾ:
 * ؿؤΥݥ󥿤ȤäƴؿƤӽФѿ̤ǰϤ鷺
 * ̾δؿƽФƱͤ˽񤤤Ȥˡѿ̻Ҥȴؿؤ
 * ݥ󥿤μȤδ֤˴Ϣ ident_ref ¸ߤʤ
 *
 *      int (*func)();
 *      func();
 *
 * (func)() Ƚ񤤤̤롥
 */

void fix0059(SpdInfo *info)
{
    SpdString progname;
    SpdObjIdArray expr_array;
    SpdString ident_name = NULL;
    int i;

    SpdObjId ident_id;
    int offset;
    int ident_ref_num, append_ident_ref_num = 0;
    FILE *fp = NULL;

    progname = smuGetAProgramName();
    if (spdTarget("I-model", progname) == SPD_NON_ID) {
        spdErrorExit("Program \"%s\" not found.\n", progname);
    }

    /* Ϣ "ident_ref" Τʤ expression 򸫤Ĥ */
    expr_array = spdGetObjIdArray("expression", NULL, no_ident_ref);

    fp = spdOpenSDBfile(I_MODEL_DIR, "ident_ref", SAPID_O_APPEND);

    for (i = 0; i < expr_array.size; i++) {
        /* expression Υƥ */
        ident_name = spdStrdup(spdGetObjText(expr_array.id[i]));
        /* expression  offset */
        offset = get_offset(expr_array.id[i]);
        /* ident_ref ǴϢդ٤ identifier */
        ident_id = find_ident(ident_name, expr_array.id[i]);

        if (ident_id != SPD_NON_ID) {
            append_ident_ref_num++;
            write_ident_ref_sub(fp, expr_array.id[i], ident_id, offset);
            if (fix_v_flag) {
                spdMessage("Added ident_ref: expr %d, ident %d,"
                           " offset %d: \"%s\".\n",
                           expr_array.id[i], ident_id, offset, ident_name);
            }
        }

        spdFree(ident_name);
    }

    spdFclose(fp);

    if (append_ident_ref_num > 0) {
        ident_ref_num = spdGetInfoInt(info, "ident_ref", 0);
        spdSetInfoInt(info, "ident_ref",
                         ident_ref_num + append_ident_ref_num);
    }
    spdFreeObjIdArray(expr_array);
}

/*
 * obj °륹פéä name õ
 * ¸ߤ identifier 򡤤ʤ SPD_NON_ID ֤
 */

static SpdObjId find_ident(SpdString name, SpdObjId obj)
{
    SpdObjIdArray decl_array;
    SpdObjId ident_id;

    /* ϢˤɤäƺǤᤤפ򸫤Ĥ */
    do {
        obj = spdGetARelObj(obj, "any", "c-id");
        if (obj == SPD_NON_ID) return SPD_NON_ID;
    } while (!is_scope(obj));

    /* Ĥפ˴ޤޤ declaration  */
    decl_array = spdGetRelObjArray(obj, "any", "p-id", is_decl);

    /* declaration  name  identifier  */
    ident_id = find_ident_decl(name, decl_array);
    spdFreeObjIdArray(decl_array);

    /* identifier ĤʤкƵŪ˷֤ */
    return (ident_id != SPD_NON_ID ? ident_id : find_ident(name, obj));
}

/*
 * declaration  name 뤫ɤĴ٤롥
 * ¸ߤ identifier 򡤤ʤ SPD_NON_ID ֤
 */

static SpdObjId find_ident_decl(SpdString name, SpdObjIdArray decl_array)
{
    SpdObjId ident_id;
    SpdObjIdArray decr_array;
    SpdString ident_name = NULL;
    int i, j;

    for (i = 0; i < decl_array.size; i++) {
        /* declaration -- <decl_decl> -- declarator */
        decr_array = spdGetRelObjArray(decl_array.id[i], "decl_decl",
                                       "declaration_id", NULL);
        for (j = 0; j < decr_array.size; j++) {
            /* declarator -- <decl_ident> -- identifier */
            ident_id = spdGetARelObj(decr_array.id[j], "decl_ident",
                                     "declarator_id");
            ident_name = spdGetName(ident_id);
            if (ident_name != NULL && SPD_STREQ(name, ident_name)) {
                spdFreeObjIdArray(decr_array);
                return ident_id;
            }
        }
        spdFreeObjIdArray(decr_array);
    }

    return SPD_NON_ID;
}

/*
 * BugList sdbin3-0059 ˤ ident_ref Τʤ expression 򸫤Ĥ롥
 */

static SpdBoolean no_ident_ref(SpdObjId expr)
{
    /* Ѽ(EXPR_SORT_ARITH) && Ҥ仲Ȥʤ expression */
    return ((spdGetAttrValInt(expr, "sort") == EXPR_SORT_ARITH) &&
            (spdGetARelObj(expr, "any", "p-id") == SPD_NON_ID));
}

/*
 * طˤ obj  offset 롥SMU  AR ٤⡩
 */

static int get_offset(SpdObjId obj)
{
    SpdRel rel;

    rel = spdGetARel(obj, "any", "c-id");   /* ƤȤδϢ */
    return spdGetOffset(rel.relationId);
}

/*
 * obj פɽݤĴ٤Ҹ졥
 */

static SpdBoolean is_scope(SpdObjId obj)
{
    SpdClassId class_id = spdGetClassId(obj);

    /* פ compound block, funcdef, file Τ줫 */
    return (((class_id == SPD_CID_BLOCK) &&
             (spdGetAttrValInt(obj, "sort") == BLOCK_COMP)) ||
            ((class_id == SPD_CID_OPTIONALDECL) &&
             (spdGetAttrValInt(obj, "sort") == OPT_FUNCDEF)) ||
            ((class_id == SPD_CID_FILE)));
}

/*
 * obj  declaration ݤĴ٤Ҹ졥SMU ٤⡩
 */

static SpdBoolean is_decl(SpdObjId obj)
{
    return (spdGetClassId(obj) == SPD_CID_DECLARATION);
}
