/* 
 * Program:             $RCSfile: fixSDB.c,v $  $Revision: 30.14 $
 * 
 * Purpose:
 * 
 * Author:              N.Fukuyasu  1998/02/28
 *                      S.Yamamoto  1998/02/28
 * 
 * (C) Copyright:       N.Fukuyasu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: fixSDB.c,v 30.14 2003/06/28 15:32:01 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "fixSDB.h"

/*
 * ؿɲˡ:
 * fixSDB.h ˥ץȥɲä
 * fix_table[]  BugList ֹȸƤӽФؿ󤹤롥
 */

static struct _fix_table {
    int num;                                /* Bug number. */
    void (*fix_func)(SpdInfo *info);        /* Fix function. */
} fix_table[] = {
    { 59, fix0059 },
    { -1, NULL }
};

SpdBoolean fix_v_flag = FALSE;

static SpdConstString   program_name;

static void usage(void)
{
    spdErrorExit("Usage: %s [-dv] -b bug_number\n", program_name);
}

int main(int argc, char *argv[])
{
    int         c, i;
    int         bug_num = -1;
    SpdString   prof_str = NULL;
    char        prof_name[SPD_STRING_LEN + 1];
    SpdInfo     *info;

    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);
    while ((c = getopt(argc, argv, "b:d:v")) != EOF) {
        switch (c) {
          case 'b':
            bug_num = atoi(optarg);
            break;
          case 'd':                         /* SDB directory. */
            spdSetSDBdir(optarg);
            spdMessage("SDB directory \"%s\".\n", spdGetSDBdir());
            break;
          case 'v':                         /* Verbose mode. */
            fix_v_flag = TRUE;
            break;
          default:
            usage();
            break;
        }
    }
    if (bug_num <= 0) {
        usage();
    }

    info = spdOpenSDBinfo();
    
    /* 񤭹formatꤹ롥 */
    if (SPD_STREQ(spdGetInfoString(info, "BINARY_FORMAT_SDB"), "TRUE")) {
        spdSetWriteSDBformat(SAPID_BINARY_FORMAT_SDB);
    } 

    for (i = 0; 0 < fix_table[i].num; i++) {
        if (fix_table[i].num == bug_num) {
            if (fix_v_flag) {
                spdMessage("Fix bug-%04d.\n", bug_num);
            }
            sprintf(prof_name, "FIXED_%04d", bug_num);
            if ((prof_str = spdGetInfoString(info, prof_name)) == NULL ||
                !SPD_STREQ(prof_str, "TRUE")) {
                /* bug_num  fix Ƥʤä */
                fix_table[i].fix_func(info);
                spdSetInfoString(info, prof_name, "TRUE");
            } else {                        /* Ǥ fix Ƥ */
                spdWarning("Bug-%04d is already fixed.\n", bug_num);
            }
            break;
        }
    }
    
    spdCloseInfo(info);

    if (fix_table[i].num <= 0) {
        spdWarning("%s: Invalid bug-%04d specified.\n", program_name, bug_num);
        return (EXIT_FAILURE);
    }

    return (EXIT_SUCCESS);
}
