# 
# Program:              $RCSfile: getGccDopts.awk,v $  $Revision: 32.9 $
# 
# Purpose:              Get gcc -D options.
# 
# Author:               N.Ito  1998/06/10
#                       S.Yamamoto  1998/06/10
# 
# Copyright:            N.Ito and S.Yamamoto  1998 - 2000
#                       This file is a product of the project Sapid.
#

# 
# $Id: getGccDopts.awk,v 32.9 2002/06/28 00:10:37 yamamoto Exp yamamoto $
# 

# 
# Read a line after "gcc version ..." line in gcc verbose message.
# 

BEGIN {
    already_output = 0;
    delimiter = " ";
    flag = 0;
    is_gcc_related_mode = 0;
    for (i = 0; i < ARGC; i++) {
	if (ARGV[i] == "gcc_related_mode=1") {
	    is_gcc_related_mode = 1;
	} else if (ARGV[i] == "separate_line_mode=1") {
	    delimiter = "\n";
	}
    }
}

{
    if (flag == 1) {
	n = split($0, option, " ");
	for (i = 1; i <= n; i++) {
	    if (option[i] ~ /-D__GNUC__/) {
		if (is_gcc_related_mode == 1) {
		    printf("\"%s\"%s", option[i], delimiter);
		    already_output = 1;
		} else {
		    # Skip "-D__GNUC__=X" option.
		}
	    } else if (option[i] ~ /-D__GNUC_MINOR__/) {
		if (is_gcc_related_mode == 1) {
		    printf("\"%s\"%s", option[i], delimiter);
		    already_output = 1;
		} else {
		    # Skip "-D__GNUC_MINOR__=X" option.
		}
	    } else if (option[i] ~ /-D/) {
		if (is_gcc_related_mode == 1) {
		    # Skip other options.
		} else {
		    split(option[i], macro, "=");
		    if (match(macro[1], "\\(.*\\)")) {
			# Skip a malformed macro pattern.
		    } else {
			printf("\"%s\"%s", option[i], delimiter);
			already_output = 1;
		    }
		}
	    }
	}
	exit;
    }
}

/^gcc version / {
    flag = 1;
}

/^Apple Computer, / {
    flag = 1;
}

END {
    if (separate_line_mode == 0 && already_output == 1) {
	printf("\n");
    }
}
