# 
# Program:              $RCSfile: getGccIopts.awk,v $  $Revision: 32.7 $
# 
# Purpose:              Get gcc -I options.
# 
# Author:               N.Ito  1998/06/10
#                       S.Yamamoto  1998/06/10
# 
# Copyright:            N.Ito and S.Yamamoto  1998 - 2000
#                       This file is a product of the project Sapid.
#

# 
# $Id: getGccIopts.awk,v 32.7 2000/06/14 07:04:45 yamamoto Exp yamamoto $
# 

# 
# Read output of "gcc -v".
# 

BEGIN {
    already_output = 0;
    delimiter = " ";
    flag = 0;
    is_longest_mode = 0;
    for (i = 0; i < ARGC; i++) {
	if (ARGV[i] == "longest_mode=1") {
	    is_longest_mode = 1;
	    longest = "";
	} else if (ARGV[i] == "separate_line_mode=1") {
	    delimiter = "\n";
	}
    }
}

/^End of search list\.$/ {
    exit;
} 

/^ \// || /^ \\/ || /^ [A-Z]:\\/ {
    if (flag == 1) {
	split($0, option, " ");

	# Convert DOS path separator into UNIX one.
        gsub("\\\\", "/", option[1]);

	if (is_longest_mode == 1) {
	    if (length(longest) < length(option[1])) {
		longest = option[1]; 
	    }
	} else {
	    printf("-I%s%s", option[1], delimiter);
            already_output = 1;
	}
    }
}

/^#include <\.\.\.> search starts here:$/ {
    flag = 1;
}

END {
    if (is_longest_mode == 1 && longest != "") {
	printf("-I%s%s", longest, delimiter);
	already_output = 1;
    }

    if (separate_line_mode == 0 && already_output == 1) {
	printf("\n");
    }
}
