/* 
 * Program:             $RCSfile: SyntaxTree.c,v $  $Revision: 40.24 $
 * 
 * Purpose:             yylex()ꤵ줿YYSTYPE
 *                      ʸڤΥΡɤȤƤ°դäؿ
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: SyntaxTree.c,v 40.24 2003/07/25 13:14:51 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "JB.h"
#include "y.tab.h"
#include "FuncProto.h"

/**
 * 饹ꤹ롥
 */

SymData *setClass(SymData *jclass)
{
    jclass->symSort = SPD_CID_J_CLASS;
    jclass->u.jclass = spdMalloc(sizeof(JpdClass));
    jclass->u.jclass->sort = JPD_INVALID_ID;
    jclass->u.jclass->member = NULL;
    jclass->u.jclass->modifier = NULL;
    jclass->u.jclass->super = NULL;
    jclass->u.jclass->interface = NULL;
    jclass->u.jclass->memberSymTab = NULL;
    jclass->u.jclass->nextClassOrInterface = NULL;
    jclass->u.jclass->nextClassOrInterface = NULL;
    jclass->u.jclass->nextMember = NULL;
    jclass->u.jclass->arguments = NULL;
    return jclass;
}

SymData *setAnonClass(SymData *newObj, SymData *body)
{
    SymData     *newOp, *type, *lp, *args, *rp;
    SymData     *jclass, *opExpr, *anonExpr, *anOperator;

    /* NewObjectPrefixʬ򤹤 */
    newOp = newObj->u.newObject->newOp;
    type = newObj->u.newObject->typeName;
    lp = newObj->u.newObject->lp;
    args = newObj->u.newObject->args;
    rp = newObj->u.newObject->rp;

    /* Set operator. */
    anOperator = setOperator(newOp, JPD_O_NEW_OBJECT);
    
    /* set class */
    jclass = getSymData();
    setClass(jclass);
    jclass->str = (char *) spdMalloc(strlen(type->str) +1);
    strcpy(jclass->str, type->str);
    jclass->u.jclass->member = body->u.routine->nextMember;
    jclass->u.jclass->memberSymTab = newObj->u.newObject->memberSymTab;
    /* bodyȤϥߡ */
    setClassSort(jclass, ANON_CLASS);
    setClassArguments(jclass, args);
    setOffsetAndLength(jclass, type, body);
    setComment(jclass, body);
    freeSymData(body);

    setComment(jclass, lp);
    freeSymData(lp);
    setComment(jclass, rp);
    freeSymData(rp);

    /* set type */
    /* type = setType(type, OBJECT_TYPE);*/
    type->u.type->jclass = jclass;
    
    /* create ANON_CLASS expression */
    anonExpr = setExpression(NULL, E_ANON_CLASS,
                             NULL, type, NULL, NULL);
    setOffsetAndLength(anonExpr, jclass, jclass);
                                 
    /* create OPERATION expression */
    opExpr = setExpression(NULL, E_OPERATION,
                           anOperator, anonExpr, NULL, NULL);
    setOffsetAndLength(opExpr, anOperator, anonExpr);

    return opExpr;
}

SymData *setNewObjectPrefix(SymData *newOp, SymData *typeName,
                            SymData *lp, SymData *args, SymData *rp)
{
    SymData *ret;
    ret = getSymData();
    ret->u.newObject = spdMalloc(sizeof(JpdNewObjectPrefix));
    ret->u.newObject->newOp = newOp;
    ret->u.newObject->typeName = typeName;
    ret->u.newObject->args = args;
    ret->u.newObject->lp = lp;
    ret->u.newObject->rp = rp;
    ret->u.newObject->memberSymTab = pushMemberSymTab();
    return ret;
}

/**
 * interfaceꤹ롥
 */

SymData *setInterface(SymData *interface)
{
    interface->symSort = SPD_CID_J_INTERFACE;
    interface->u.interface = spdMalloc(sizeof(JpdInterface));
    interface->u.interface->sort = JPD_INVALID_ID;
    interface->u.interface->member = NULL;
    interface->u.interface->modifier = NULL;
    interface->u.interface->super = NULL;
    interface->u.interface->memberSymTab = NULL;
    interface->u.interface->nextClassOrInterface = NULL;
    interface->u.interface->nextMember = NULL;
    return interface;
}

/**
 * ᥽å̾Ȱꤹ롥
 */

SymData *setRoutine(SymData *method, RoutineSort sort)
{
    method->symSort = SPD_CID_J_ROUTINE;
    method->u.routine = spdMalloc(sizeof(JpdRoutine));
    method->u.routine->sort = sort;
    method->u.routine->parameter = NULL;
    method->u.routine->modifier = NULL;
    method->u.routine->returnType = NULL;
    method->u.routine->throwType = NULL;
    method->u.routine->nextMember = NULL;
    return method;
}

/**
 * Ҥꤹ롥
 */

SymData *setModifier(SymData *symData)
{
    /* spdMessage("Modifier: (l.%d, c.%d) %s\n",
       yylineno, c_count, symData->str); */
    symData->symSort = SPD_CID_J_MODIFIER;
    symData->u.modifier = spdMalloc(sizeof(JpdModifier));
    symData->u.modifier->next = NULL;
    return symData;
}

SymData *setType(SymData *symData, TypeSort sort)
{
    if (symData == NULL) {
        symData = getSymData();
    }
    symData->symSort = SPD_CID_J_TYPE;
    symData->u.type = spdMalloc(sizeof(JpdType));
    symData->u.type->sort = sort;
    symData->u.type->pkgName = NULL;
    symData->u.type->qname = NULL;
    symData->u.type->next = NULL;
    symData->u.type->nextType = NULL;
    symData->u.type->jclass = NULL;
    return symData;
}

/**
 * ѿѿʸڤΥΡɤȤƻȤ褦ꤹ롥
 * λǤѿηҤꤵʤ
 */

SymData *setVariable(SymData *symData)
{
    symData->symSort = SPD_CID_J_VARIABLE;
    symData->u.variable = spdMalloc(sizeof(JpdVariable));
    symData->u.variable->modifier = NULL;
    symData->u.variable->type = NULL;
    symData->u.variable->initializer = NULL;
    symData->u.variable->next = NULL;
    symData->u.variable->nextMember = NULL;
    return symData;
}

/**
 * ѿ˷ҤꤷɽϿ롥
 * varssetVariable()줿SymDataΥꥹȤˤʤäƤ롥
 */

SymData *setMemberVariable(SymData *vars, SymData *type, SymData *mod)
{
    SymData *var, *vtype;

    for (var = vars; var != NULL;
         var = var->u.variable->next) {
        var->u.variable->sort = CLASS_MEM;
        var->u.variable->modifier = mod;
        if (var->u.variable->type != NULL) { /* var[][]ʤɤξ */
            vtype = var->u.variable->type;
            while (vtype->u.type->next != NULL) { /* ꥹȤκǸõ */
                vtype = vtype->u.type->next;
            }
            vtype->u.type->next = type;
        }
        else {
            var->u.variable->type = type;
        }
        addVar2MemberSymTab(var);           /* ɽϿ */
    }
    return vars;
}

/**
 * ѿ˷ҤꤷɽϿ롥
 * varssetVariable()줿SymDataΥꥹȤˤʤäƤ롥
 */

SymData *setLocalVariable(SymData *vars, SymData *type, SymData *mod,
                          VarSort sort)
{
    SymData *var, *vtype;

    for (var = vars; var != NULL;
         var = var->u.variable->next) {
        var->u.variable->sort = sort;
        var->u.variable->modifier = mod;
        if (var->u.variable->type != NULL) { /* var[][]ʤɤξ */
            vtype = var->u.variable->type;
            while (vtype->u.type->next != NULL) { /* ꥹȤκǸõ */
                vtype = vtype->u.type->next;
            }
            vtype->u.type->next = type;
        }
        else {
            var->u.variable->type = type;
        }
        addVar2LocalSymTab(var);            /* ɽϿ */
    }
    return vars;
}

/**
 * QualifiedNameꤹ롥λǤϥꥹȹ¤ˤϤʤäƤʤ
 */

SymData *setQName(SymData *symData)
{
    symData->symSort = SPD_CID_J_QNAME;
    symData->u.qname = spdMalloc(sizeof(JpdQName));
    symData->u.qname->first = NULL;
    symData->u.qname->second = NULL;
    symData->u.qname->dot = NULL;
    symData->u.qname->nextQName = NULL;
    return symData;
}

/**
 * ʸΥΡɤstmtꤷ֤
 * stmtNULLΤȤϿ˥ΡɤƤ롥
 * stmtSortϼμ(EMPTY, EXPRESSION, BLOCKʤ)
 * ꤵʤexpression#statemetn#NULLˤƤ
 */

SymData *setStatement(SymData *stmt, StatementSort stmtSort)
{
    if (stmt == NULL) {
        stmt = getSymData();
    }
    stmt->symSort = SPD_CID_J_STATEMENT;
    stmt->u.statement = spdMalloc(sizeof(JpdStatement));
    stmt->u.statement->sort = stmtSort;
    stmt->u.statement->expression1 = NULL;
    stmt->u.statement->expression2 = NULL;
    stmt->u.statement->expression3 = NULL;
    stmt->u.statement->statement1 = NULL;
    stmt->u.statement->statement2 = NULL;   
    stmt->u.statement->label = NULL;
    stmt->u.statement->next = NULL;
    stmt->u.statement->block = NULL;

    return stmt;
}

/**
 * ΥΡɤexprꤷ֤
 * exprNULLΤȤϿ˥ΡɤƤ롥
 * exprSortϼμ(REF_VAR, OPERATIONʤ)ɽ
 * first, second, thirdoperatorΥڥɤɽ
 * exprSortREF_VAR, REF_LITERALʤɤΤȤfirst˻ȤƤѿ
 * ʤɤꤹ롥ꤵʤoperatorڥɤNULLˤƤ
 */

SymData *setExpression(SymData *expr, ExpressionSort exprSort,
                       SymData *anOperator,
                       SymData *first, SymData *second, SymData *third)
{

    if (expr == NULL) {
        expr = getSymData();
    }
    expr->symSort = SPD_CID_J_EXPRESSION;
    expr->u.expression = spdMalloc(sizeof(JpdExpression));
    expr->u.expression->sort = exprSort;
    expr->u.expression->lrsort = JPD_INVALID_ID;
    expr->u.expression->two_pass_resolve = FALSE;
    expr->u.expression->joperator = anOperator;
    expr->u.expression->first = first;
    expr->u.expression->second = second;
    expr->u.expression->third = third;
    expr->u.expression->next = NULL;
    return expr;
}

SymData *qname2PrimaryNoNewArray(SymData *qname0)
{
    /* QName: ѿλȡλǵɽõ */
    SymData *var, *expr;
    SpdBoolean resolveLater = FALSE;

    if (qname0->u.qname->dot == NULL) {
        /* DOTǷ礵ƤʤQualifiedName */
        var = searchForLocalSymTab(qname0->str, NULL);
        if (var == NULL) {
            var = searchForMemberSymTab(qname0->str, NULL);
            if (var == NULL) {
                resolveLater = TRUE;
                if (verbose) {
                    spdWarning("\"%s\": Unknown identifier (l.%d, c.%d).\n",
                               qname0->str, yylineno, c_count);
                }
            }
        }
        spdFree(qname0->u.qname);
        expr = setExpression(qname0, E_REF_VAR, NULL, var, NULL, NULL);
        setLRSort(expr, R_VALUE);
        setTwoPassResolve(expr, resolveLater);
        
        jpdDebugMessage(jpdDebug.variable, "(l.%d, c.%d): ", yylineno, c_count);
        jpdDebugFunc2Call(jpdDebug.variable,
                          putVariable, var, "Refer");
    }
    else {                                  /* DOTǷ礵줿QualifiedName */
        SymData         *qname1;

        for (qname1 = qname0; qname1->u.qname->first != NULL;
             qname1 = qname1->u.qname->first)
            ;
        
        var = searchForLocalSymTab(qname1->str, NULL);
        if (var == NULL) {
            var = searchForMemberSymTab(qname1->str, NULL);
        }

        if (var != NULL) {
            /* qname1ѿ(֥), eg. obj.mem1.mem2 */
            SymData *p;

            expr = qname2Expression(qname0, R_VALUE);
            for (p = expr; p->u.expression->first != NULL;
                 p = p->u.expression->first)
                ;
            /* obj ȤƤѿ˴ϢϤ */
            p = setExpression(p, E_REF_VAR, NULL,
                              var, NULL, NULL);
            setLRSort(p, R_VALUE);
        }
        else {
            /* JustNameϥѥå뤤ϥ饹 */
            /*
             *  Ǥa.b.ccѿȻפä
             *  Expr(OP)=Expr(REF_QNAME, a.b) OP(.) Expr(REF_VAR, c)
             *  Ȥ򤷤Ƥ
             */
            SymData *first, *second;
            
            first = setExpression(NULL, E_REF_QNAME, NULL,
                                  qname0->u.qname->first, NULL, NULL);
            setLRSort(first, R_VALUE);
            setOffsetAndLength(first, qname0->u.qname->first,
                               qname0->u.qname->first);
            spdFree(qname0->u.qname->second->u.qname);
            second = setExpression(qname0->u.qname->second, E_REF_VAR, NULL,
                                   NULL, NULL, NULL);
            setLRSort(second, R_VALUE);
            setOffsetAndLength(second, qname0->u.qname->second,
                               qname0->u.qname->second);
            expr = setExpression(NULL, E_OPERATION, qname0->u.qname->dot,
                                 first, second, NULL);
            setLRSort(expr, R_VALUE);
            setOffsetAndLength(expr, first, second);
            freeSymData(qname0);
        }
    }
    jpdDebugFunc2Call(jpdDebug.expression,
                      putExpression, expr, "PrimaryE");

    return expr;
}

SymData *setConstructorCall(SymData *newObj)
{
    SymData     *newOp, *typeName, *lp, *args, *rp;
    SymData     *constructor, *expr, *anOperator;

    /*
     * NewObjectPrefixʬ򤹤롥
     *     : NEW TypeName '(' ArgumentList ')'
     */
    newOp = newObj->u.newObject->newOp;
    typeName = newObj->u.newObject->typeName;
    lp = newObj->u.newObject->lp;
    args = newObj->u.newObject->args;
    rp = newObj->u.newObject->rp;

    /* 󥹥ȥ饯뼰롥 */
    anOperator = setOperator(newOp, JPD_O_NEW_OBJECT);
    constructor = setExpression(NULL, E_CONSTRUCTOR_CALL, NULL,
                                typeName, NULL, NULL);
    setLRSort(constructor, NONE);
    setMethodArguments(constructor, args);
    setOffsetAndLength(constructor, typeName, rp);
    
    /* ϵɽfirstTypeNameɽ饹ˤ  */
    expr = setExpression(NULL, E_OPERATION, anOperator,
                         constructor, NULL, NULL);
    setLRSort(expr, NONE);
    setOffsetAndLength(expr, anOperator, rp);

    setComment(expr, lp);
    freeSymData(lp);
    setComment(expr, rp);
    freeSymData(rp);

    jpdDebugFunc2Call(jpdDebug.type, putType, typeName, "Alloc Type");
    return expr;
}

/**
 * Class Literal Expression (TypeName DOT CLASS)ꤹ롥
 */

SymData *setClassLiteralExpression(SymData *type,
                                   SymData *dot,
                                   SymData *jclass)
{
    SymData *refType, *refSpecial, *retExpr;

    setOperator(dot, JPD_O_BINARY);
    setSpecialName(jclass);

    refType = setExpression(NULL, E_REF_TYPE, NULL, type, NULL, NULL);
    setLRSort(refType, R_VALUE);
    setOffsetAndLength(refType, type, type);

    refSpecial = setExpression(NULL, E_REF_SPECIAL, NULL, jclass, NULL, NULL);
    setLRSort(refSpecial, NONE);
    setOffsetAndLength(refSpecial, jclass, jclass);
    
    retExpr = setExpression(NULL, E_OPERATION, dot, refType, refSpecial, NULL);
    setLRSort(retExpr, R_VALUE);
    setOffsetAndLength(retExpr, refType, refSpecial);

    return retExpr;
}

/**
 * SpecialNameꤹ롥SpecialNameǤsymData->uϻȤʤ
 */

SymData *setSpecialName(SymData *symData)
{
    symData->symSort = SPD_CID_J_SPECIAL;
    return symData;
}

/**
 * Operatorꤹ롥SymDataNULLʤ鿷˳Ƥ롥
 * ++֤֡sortPREFIX, POSTFIXǶ̤롥
 * -ñࡤsortPREFIX, BINARYǶ̤롥
 */

SymData *setOperator(SymData *symData, OperatorSort sort)
{
    if (symData == NULL) {
        symData = getSymData();
    }
    symData->symSort = SPD_CID_J_OPERATOR;
    symData->u.joperator = spdMalloc(sizeof(JpdOperator));
    symData->u.joperator->sort = sort;
    return symData;
}

/**
 * !! ٥ꤷơ٥뵭ɽϿ(ͽ)
 */

SymData *setLabel(SymData *label, LabelSort sort)
{
    label->symSort = SPD_CID_J_LABEL;
    label->u.label = spdMalloc(sizeof(JpdLabel));
    label->u.label->sort = sort;
    label->u.label->defined = NULL;
    label->u.label->caseValue = NULL;
    label->u.label->next = NULL;

    if (sort == DEF_LABEL) {                /* ٥ */
        addLabel2LabelSymTab(label, NULL);
    }
    else if (sort == REF_LABEL) {           /* ٥뻲 */
        if ((label->u.label->defined = searchForLabelSymTab(label->str, NULL))
            == NULL) {
            spdError("Label %s is not defined.\n", label->str);
        }
    }
        
    return label;
}

/**
 * case٥ꤹ롥labelNULLΤȤϿ˥ΡɤƤ롥
 */

SymData *setCaseLabel(SymData *label, SymData *expr)
{
    if (label == NULL) {
        label = getSymData();
    }
    label->symSort = SPD_CID_J_LABEL;
    label->u.label = spdMalloc(sizeof(JpdLabel));
    label->u.label->sort = CASE_LABEL;
    label->u.label->defined = NULL;
    label->u.label->caseValue = expr;
    label->u.label->next = NULL;
    return label;
}

/**
 * default٥ꤹ롥labelNULLΤȤϿ˥ΡɤƤ롥
 */

SymData *setDefaultLabel(SymData *label)
{
    if (label == NULL) {
        label = getSymData();
    }
    label->symSort = SPD_CID_J_LABEL;
    label->u.label = spdMalloc(sizeof(JpdLabel));
    label->u.label->sort = DEFAULT_LABEL;
    label->u.label->defined = NULL;
    label->u.label->caseValue = NULL;
    label->u.label->next = NULL;
    return label;
}

/**
 * static blocksblockꤹ롥sblockNULLʤ鿷˳Ƥ롥
 */

SymData *setSBlock(SymData *sblock, SBlockSort sort, SymData *block)
{
    if (sblock == NULL) {
        sblock = getSymData();
    }
    sblock->symSort = SPD_CID_J_SBLOCK;
    sblock->u.sblock = spdMalloc(sizeof(JpdSBlock));
    sblock->u.sblock->sort = sort;
    sblock->u.sblock->block = block;
    sblock->u.sblock->nextMember = NULL;
    return sblock;
}

SymData *qname2Expression(SymData *qname, LRSort lrsort)
{
    SymData *first, *second, *dot, *res;
    
    first = qname->u.qname->first;
    second = qname->u.qname->second;
    dot = qname->u.qname->dot;
    spdFree(qname->u.qname);
    if (dot == NULL) {
        res = setExpression(qname, E_REF_VAR, NULL,
                            NULL, NULL, NULL);
        setLRSort(res, lrsort);
        return res;
    }
    else {
        first = qname2Expression(first, lrsort);
        second = qname2Expression(second, lrsort);
        res = setExpression(qname, E_OPERATION, dot,
                            first, second, NULL);
        setLRSort(res, lrsort);
        return res;
    }
}

SymData *qname2Type(SymData *qname0)
{
    if (qname0->u.qname->first == NULL) {   /* DOTǷ礵Ƥʤ */
        spdFree(qname0->u.qname);
        setType(qname0, OBJECT_TYPE);
        return qname0;
    } else {                                /* DOTǷ礵Ƥ */
        SymData *qname = qname0->u.qname->first;
        SymData *type = qname0->u.qname->second;
            
        spdFree(type->u.qname);
        freeSymData(qname0->u.qname->dot);
        freeSymData(qname0);
        
        setType(type, OBJECT_TYPE);
        type->u.type->qname = qname;
        return type;
    }
}

/**
 * exprʲμlrsortlrˤ롥R means recursive.
 */

void setLRSortR(SymData *expr, LRSort lr)
{
    if (expr == NULL || expr->symSort != SPD_CID_J_EXPRESSION) {
        return;
    }
    if (!(isLockedLRSort(expr) || expr->u.expression->lrsort == NONE)) {
        expr->u.expression->lrsort = lr;
    }
    if (!(expr->u.expression->sort == E_METHOD_CALL ||
          expr->u.expression->sort == E_CONSTRUCTOR_CALL ||
          expr->u.expression->sort == E_DIM_EXPR)) {
        setLRSortR(expr->u.expression->first, lr);
        setLRSortR(expr->u.expression->second, lr);
        setLRSortR(expr->u.expression->third, lr);
    }
}

/**
 * exprʲμlrsortlock롥R means recursive.
 */

void lockLRSortR(SymData *expr)
{
    if (expr == NULL || expr->symSort != SPD_CID_J_EXPRESSION) {
        return;
    }
    lockLRSort(expr);
    if (!(expr->u.expression->sort == E_METHOD_CALL ||
          expr->u.expression->sort == E_CONSTRUCTOR_CALL ||
          expr->u.expression->sort == E_DIM_EXPR)) {
        lockLRSortR(expr->u.expression->first);
        lockLRSortR(expr->u.expression->second);
        lockLRSortR(expr->u.expression->third);
    }
}

/**
 * symData򥹥å¤Ѵå֤
 * 顼äNULL֤symDataΥꥹȹ¤¸롥
 */

SymDataStack *setSymDataStack(SymData *symData)
{
    SymDataStack *stack;
    SymData     *elem;

    if ((stack = getSymDataStack()) == NULL) {
        return NULL;
    }

    switch (symData->symSort) {
      case SPD_CID_J_QNAME:
        for (elem = symData; elem != NULL; elem = elem->u.qname->first) {
            pushSymDataStack(stack, elem);
        }
        break;
      case SPD_CID_J_EXPRESSION:
        for (elem = symData; elem != NULL; elem = elem->u.expression->next) {
            pushSymDataStack(stack, elem);
        }
        break;
      default:
        spdFree(stack);
        return NULL;
    }
    return stack;
}

SymDataStack *setQNameStack(SymDataStack *stack, SymData *qname)
{
    if (qname->u.qname->first == NULL) {
        pushSymDataStack(stack, qname);
    } else {
        setQNameStack(stack, qname->u.qname->second);
        if (qname->u.qname->first == NULL) {
            pushSymDataStack(stack, qname);
        } else {
            setQNameStack(stack, qname->u.qname->first);
        }
    }
    return stack;
}

/**
 * å֤
 */

SymDataStack *getSymDataStack(void)
{
    SymDataStack *stack;

    stack = (SymDataStack *) spdMalloc(sizeof(SymDataStack));
    stack->stack[0] = NULL;                 /* sentinel */
    stack->cur = &(stack->stack[0]);
    return stack;
}

/**
 * åǡФ顼äNULL֤
 */

SymData *popSymDataStack(SymDataStack *stack)
{
    SymData *ret;
    
    if (isEmptySymDataStack(stack)) {
        ret = NULL;
    } else {
        ret = *(stack->cur);
        (stack->cur)--;
    }
    return ret;
}

/**
 * å˥ǡ졤Υǡ֤顼äNULL֤
 */

SymData *pushSymDataStack(SymDataStack *stack, SymData *elem)
{
    if (stack->cur - stack->stack >= MAX_STACK_SIZE - 1) {
        return NULL;
    } else {
        (stack->cur)++;
        *(stack->cur) = elem;
    }
    return elem;
}

/**
 * stackݤɽҸ졥
 */

int isEmptySymDataStack(SymDataStack *stack)
{
    return (*(stack->cur) == NULL);
}


/**
 * Set SymData's id and return SymData.
 */

SymData *getSymData(void)
{
    SymData     *result;

    result = (SymData *) spdMalloc(sizeof(SymData));

    /* Initialize result for safety. */
    result->symSort = JPD_INVALID_ID;
    result->id = JPD_INVALID_ID;
    result->offset = JPD_INVALID_ID;
    result->length = JPD_INVALID_ID;
    result->strOffset = JPD_INVALID_ID;
    result->str = NULL;
    result->comment = NULL;
    result->u.expression = NULL;

    return result;
}

/**
 * Free allocated SymData.
 */

void freeSymData(SymData *symData)
{
    if (symData->str != NULL) {
        spdFree(symData->str);
    }
    if (symData->u.expression != NULL) {
        /* ϳƥФФƹԤ٤ */
        spdFree(symData->u.expression);
    }
    spdFree(symData);
}

/**
 * firstlastǹsymDataoffsetlengthꤷ
 * symData֤顼ξNULL֤
 */

SymData *setOffsetAndLength(SymData *symData, SymData *first, SymData *last)
{
    if (first->offset == JPD_INVALID_ID || last->offset == JPD_INVALID_ID) {
        spdWarning("Offset isn't set.\n");
        return NULL;
    }
    if (first->offset > last->offset) {
        spdWarning("first and last offset is opposite.\n");
        return NULL;
    }
    
    symData->offset = first->offset;
    symData->length = (last->offset + last->length) - first->offset;
    
    return symData;
}
