/* 
 * Program:             $RCSfile: getElements.c,v $  $Revision: 40.8 $
 * 
 * Purpose:             
 * 
 * Author:              K.Hoshino  2001/10/27
 *                      S.Yamamoto  2001/10/27 
 * 
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
"$Id: getElements.c,v 40.8 2003/07/08 05:46:55 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
/* spdGetAbsoluteOffsetΤ */
#include <Sapid/ImodelAR.h>
/* spdConvRegionItoCΤ */
#include <Sapid/PmodelAR.h>
/* getOffsetFromLineHead, getLineNum, getSourceFileStringؿΤ */
#include <Sapid/CommentViewAR.h>

#include "mkCommentView.h"

static void setSourcePositionInfos(CommentViewOcc *cvOcc);
static void getElementsFromDeclaration(SpdObjId declarationId);

/*
 * !! ɤspdConvRegionItoC(SpdRegion)ϼԤ뤳Ȥ뤿褦
 * 2001/01/31
 */

void printSpdConvRegionItoCFailerInfo(SpdObjId objectId,
                                      SpdRegion regionI, SpdRegion regionC)
{
    printf("----- spdConvRegionItoC failed!!! -----\n");
    printObjInfo(objectId);
    printf("before >> ");
    printRegionInfo(regionI);
    printf("after >> ");
    printRegionInfo(regionC);
}

/*
 * եʸμ
 * (եĹˡARѰդƤʤ?)
 *
 * 桼¦ǳɬפ
 */

SpdString getSourceString(void)
{
    SetCursor csr;
    int sourceFileLength = 0;

    /* pfileId  pblock θƤӽФ */
    SpdSet2 pblockRels = spdGetChildRelSet(pfileId, SPD_RID_FILE_BLOCK);

    for (csr = spdSetCursorCreate(pblockRels); spdSetCursorNext(&csr);) {
        int offset, length;
        SpdRel *pblockRel_p;
        SpdObjId pblockId;
        SpdRelId pblockRelId;

        pblockRel_p = spdSetGetValueP(csr.curElem->value);
        pblockId = pblockRel_p->objectId;
        pblockRelId = pblockRel_p->relationId;

        offset = spdGetOffset(pblockRelId);
        length = spdGetLength(pblockId);
      
        if (offset + length > sourceFileLength) 
            sourceFileLength = offset + length; 
    }
    spdFreeSet2(pblockRels);

    sourceString = getSourceFileString(pfileId, 0, sourceFileLength);
    return sourceString;
}

/* CommentViewOccΥץǤΰ־򥻥åȤ */

static void setSourcePositionInfos(CommentViewOcc *cvOcc)
{
    cvOcc->str = 
        getSubString(sourceString, cvOcc->region.offset, cvOcc->region.length);
    cvOcc->offsetFromLineHead = 
        getOffsetFromLineHead(cvOcc->region.offset, sourceString);
    cvOcc->lineNumBegin = 
        getLineNum(cvOcc->region.offset, sourceString);
    cvOcc->lineNumEnd = 
        getLineNum(cvOcc->region.offset + cvOcc->region.length - 1, sourceString);
}

/* CommentViewOccǤꡤݻ */

CommentViewOcc *setCommentViewOcc(SpdObjId objectId, SpdRegion region,
                                  SpdRelId relationId, SpdSet2 occs)
{
    CommentViewOcc *cvOcc;

    cvOcc = spdCalloc(1, sizeof(CommentViewOcc));

    cvOcc->objectId = objectId;
    cvOcc->region = region;

    cvOcc->related = FALSE;

    /* 󥯥롼ɤ줿ΤǤǤʤ(ߥեݻƤ) */
    /* !! ľ٤ */
    if (region.fileId == pfileId) {
        setSourcePositionInfos(cvOcc);
    }
    cvOcc->relationId = relationId;
  
    spdAddElemOP(occs, objectId, cvOcc);

    return cvOcc;
}

/* P-Model ˤ pblock μФݻ */

void getPblocks(void)
{
    SetCursor csr;
    SpdSet2 pblockRels;

    /* pfileId  pblock θƤӽФ */
    pblockRels = spdGetChildRelSet(pfileId, SPD_RID_FILE_BLOCK);

    for (csr = spdSetCursorCreate(pblockRels); spdSetCursorNext(&csr);) {
        SpdRel *pblockRel_p;
        SpdObjId pblockId, pcommentId, lcommentId;
        SpdRelId pblockRelId, pfile_pcommentId, pcomment_lcommentId;
        SpdRegion region;
        int sort, offset, length;
        CommentViewOcc *cvOcc;

        pblockRel_p = spdSetGetValueP(csr.curElem->value);
        pblockId = pblockRel_p->objectId;
        pblockRelId = pblockRel_p->relationId;

        offset = spdGetOffset(pblockRelId);
        length = spdGetLength(pblockId);

        region.fileId = pfileId;
        region.offset = offset;
        region.length = length;
      
        sort = spdGetAttrIntValByName(pblockId, "sort");
        switch (sort) {
          case PBLOCK_NORMAL:               /* normal ̵ */
            break;
          case PBLOCK_COMMENT:              /* comment ̽ */
            /* pcomment  */
            pcommentId = spdCreateObj(SPD_CID_PCOMMENT, SPD_NON_ID);
            /* pcomment ° */
            spdSetAttrIntValByName(pcommentId, "length", length);
            spdSetAttrIntValByName(pcommentId, "offset", offset);

            /* pfile_pcomment  */
            pfile_pcommentId = 
                spdCreateRel(SPD_RID_PFILE_PCOMMENT, SPD_NON_ID, pfileId, pcommentId);
            /* pfile_pcomment ° */
            spdSetAttrIntValByName(pfile_pcommentId, "offset", offset);

            /* CommentViewOcc ݻ */
            cvOcc = setCommentViewOcc(pcommentId, region, pfile_pcommentId, pcommentOccs);

            /* pcomment °(part 2) */
            spdSetAttrIntValByName(pcommentId, "offset_from_linehead", cvOcc->offsetFromLineHead);
            spdSetAttrIntValByName(pcommentId, "line_num_begin", cvOcc->lineNumBegin);
            spdSetAttrIntValByName(pcommentId, "line_num_end", cvOcc->lineNumEnd);
            spdSetAttrStrValByName(pcommentId, "str", cvOcc->str);

            /*  lcomment  */
            /* mkRelation.cˤǤפˤʤä缡ä褦ˤ */
            lcommentId = spdCreateObj(SPD_CID_LCOMMENT, SPD_NON_ID);
            
            /*  pcomment_lcomment  */
            /* mkRelation.cˤǤפˤʤä缡ä褦ˤ */
            pcomment_lcommentId = spdCreateRel(SPD_RID_PCOMMENT_LCOMMENT, SPD_NON_ID, pcommentId, lcommentId);

            break;
          default:                          /* ¾Ǥ ȤդΤʤǤȤݻ */
            setCommentViewOcc(pblockId, region, pblockRelId, pblockOccs);
            break;
        }
    }
    spdFreeSet2(pblockRels);
}

/* ============================================================= */

/*
 * ʬ֥åǤ뤫ɤ
 */
/*
static SpdBoolean isBranchBlock(const SpdOcc occ)
{
    int sort;

    if (spdGetClassId(occ.objectId) != SPD_CID_BLOCK) return FALSE;

    sort = spdGetAttrIntValByName(occ.objectId, "sort");
    if (sort != BLOCK_IF && sort != BLOCK_SWITCH && sort != BLOCK_FOR &&
        sort != BLOCK_WHILE && sort != BLOCK_DO) return FALSE;

    return TRUE;
}
*/

/*
static void getElementsFromDeclarationSub(SpdObjId declarationId,
                                          SpdString objectType, SpdSet occs)
{
    int i;
    SpdOccArray childElements;

    // SpdOcc
    if (spdSafetyStrcmp(objectType, "block") == 0) {
        childElements = spdGetIncludedOccArray(declarationId, objectType, ifileId, isBranchBlock);
    } else {
        childElements = spdGetIncludedOccArray(declarationId, objectType, ifileId, NULL);
    }

    // CommentViewOccѴơoccs˥åȤ
    for (i = 0; i < childElements.size; i++) {
        SpdOcc occ;
        SpdRegion regionI, regionC;
 
        occ = (childElements.occ)[i];

        regionI.fileId = ifileId;
        regionI.offset = spdGetAbsoluteOffset(occ.relationId, ifileId);
        regionI.length = spdGetLength(occ.objectId);

        regionC = spdConvRegionItoC(regionI);
      
        // ɤregionѴ˼ԤƤޤȤ⤢餷
        if (regionC.fileId == SPD_NON_ID) {
            printSpdConvRegionItoCFailerInfo(occ.objectId, regionI, regionC);
        } else {
            setCommentViewOcc(occ.objectId, regionC, occ.relationId, occs);
        }
    }
    spdFreeOccArray(childElements);
}
*/

/*
 * declaration ǤǡȤդΤФ
 *
 * !! offsetδطǻ֤?
 * !! ΨɤˤϡǤɤɬפ롥ޤspdTraverse?
 */

/*
static void getElementsFromDeclaration_old(SpdObjId declarationId)
{
    // declaration Ф
    getElementsFromDeclarationSub(declarationId, "declaration", declarationOccs);
    // expression Ф
    getElementsFromDeclarationSub(declarationId, "expression", expressionOccs);
    // label Ф
    getElementsFromDeclarationSub(declarationId, "label", labelOccs);
    // block Ф
    getElementsFromDeclarationSub(declarationId, "block", blockOccs);
}
*/

/* ============================================================= */

static void getElementsFromDeclaration(SpdObjId declarationId)
{
    SpdRelId relId = spdGetAParentRelId(declarationId, SPD_RID_FILE_DECL);
    int declOffset = spdGetOffset(relId);

    traverseForCommentViewGetElem(ifileId, declarationId, declOffset);
}

/* Ȥդ¾ǤΥ饹ν */

void getElements(void)
{
    /* pfileϥ󥯥롼ɤ줿եǤϤʤ */
    if (!pfileIsIncludedFile) {
        SpdSet2 rels;
        SetCursor csr;

        /* file  declaration  */
        rels = spdGetChildRelSet(ifileId, SPD_RID_FILE_DECL);
        for (csr = spdSetCursorCreate(rels); spdSetCursorNext(&csr);) {
            SpdRel *relp = spdSetGetValueP(csr.curElem->value);

            SpdRegion regionI, regionC;
      
            regionI.fileId = ifileId;
            regionI.offset = spdGetOffset(relp->relationId);
            regionI.length = spdGetLength(relp->objectId);
      
            /* ΰ.cѤ */
            regionC = spdConvRegionItoC(regionI);
      
            if (regionC.fileId == SPD_NON_ID) { /* ɤregionѴ˼ԤƤޤȤ⤢餷 */
#ifdef MKCOMMENTVIEW_DEBUG
                printSpdConvRegionItoCFailerInfo(relp->objectId, regionI, regionC);
#endif
                /* ե¸ߤΤǤн³ */
            } else if (spdIsInHeaderFile(ifileId, regionI.offset) == FALSE) {
                setCommentViewOcc(relp->objectId, regionC, 
                                  relp->relationId, declarationOccs);
    
                /* declaration ǤǡȤդΤФ */
                getElementsFromDeclaration(relp->objectId);
            } else {
                /* 󥯥롼ɤ줿եI-modelƤݻ */
                setCommentViewOcc(relp->objectId, regionC, 
                                  relp->relationId, includedDeclarationOccs);
            }
        }
        spdFreeSet2(rels);
    } else {                                /* 󥯥롼ɤ줿եǤ */
        /* äΤ˾äƹԤȤ⡥ݤʤΤǺϤʤ */
        SetCursor csr;
        for (csr = spdSetCursorCreate(includedDeclarationOccs);
             spdSetCursorNext(&csr);) {
            CommentViewOcc *cvOcc = spdSetGetValueP(csr.curElem->value);
            if (cvOcc->region.fileId == pfileId) {
                /* 󥯥롼ɤ¦ΥեΤȤˤϤǤʤäʬ */
                /* ΤȤե뼫Τʸ󤬤ʤä顥ʤ */
                /* ϢݻƤ٤ۤɥ櫓ǤϤʤ */
                /* ޤϻ֤ʤᡥ */
                CommentViewOcc *new_cvOcc = 
                    (CommentViewOcc *)spdMalloc(sizeof(CommentViewOcc));
                *new_cvOcc = *cvOcc;
                setSourcePositionInfos(new_cvOcc);
                /* Ǥɲ */
                spdAddElemOP(declarationOccs, cvOcc->objectId, new_cvOcc);

                /* declaration ǤǡȤդΤФ */
                getElementsFromDeclaration(cvOcc->objectId);
            }
        }
    }
}

/*
 * pblock  macrocall  region Ʊ expression Ͻ
 *
 * !! SpdSetoffsetǥȤƤʬõԤäꤷƥԡɤ
 * 夲ɬפ롥ΤνǸ롥
 */

void removeMacroCallExpression(void)
{
    SpdSet2 tmp = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_POINTER_VALUE);
    SetCursor csr_p;

    for (csr_p = spdSetCursorCreate(pblockOccs); spdSetCursorNext(&csr_p);) {
        CommentViewOcc *cvOcc = spdSetGetValueP(csr_p.curElem->value);
    
        if (spdGetAttrIntValByName(cvOcc->objectId, "sort")
            == PBLOCK_MACROCALL) {
            SetCursor csr_e;
            for (csr_e = spdSetCursorCreate(expressionOccs);
                 spdSetCursorNext(&csr_e);) {
                CommentViewOcc *cvOcc2 = spdSetGetValueP(csr_e.curElem->value);

                if (cvOcc->region.fileId == cvOcc2->region.fileId &&
                    cvOcc->region.offset == cvOcc2->region.offset &&
                    cvOcc->region.length == cvOcc2->region.length) {
                    spdAddElemOP(tmp, cvOcc2->objectId, NULL);  
                }
            }
        }
    }
    
    expressionOccs = spdDifferenceSet2(expressionOccs, tmp);
    spdFreeSet2(tmp);
}

/*
 * Ȥդ⤷ʤ elementOccs κ
 */

void mkElementOccs(void)
{
    SpdSet2 res;

    res = spdDupSet2(pblockOccs);
    res = spdAddSet2(res, declarationOccs);
    res = spdAddSet2(res, labelOccs);
    res = spdAddSet2(res, expressionOccs);
    res = spdAddSet2(res, blockOccs);
    elementOccs = res;
}
