/* 
 * Program:             $RCSfile: getElementsSubByTraverse.c,v $  $Revision: 40.6 $
 * 
 * Purpose:             
 * 
 * Author:              K.Hoshino  2001/10/27
 *                      S.Yamamoto  2001/10/27 
 * 
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
"$Id: getElementsSubByTraverse.c,v 40.6 2003/07/06 10:09:45 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/PmodelAR.h>
#include <Sapid/ImodelAR.h>
#include <Sapid/ImodelARcompat.h>
#include <Sapid/CommentViewAR.h>
#include "mkCommentView.h"

/* SPIE2traverse.h򻲹 */

typedef struct _MkCommentViewTraverse {
    SpdObjId    ifileId;
    int         declOffset;
    SpdRel      presentRel;
} MkCommentViewTraverse;


static void setElement(MkCommentViewTraverse *trav, SpdSet2 occs)
{
    SpdRegion regionI, regionC;

    SpdObjId objectId = trav->presentRel.objectId;
    SpdObjId relationId = trav->presentRel.relationId;

    regionI.fileId = trav->ifileId;
    regionI.offset = trav->declOffset + spdGetOffset(relationId);
    regionI.length = spdGetLength(objectId);

    regionC = spdConvRegionItoC(regionI);
      
    if (regionC.fileId == SPD_NON_ID) {   /* ɤregionѴ˼ԤƤޤȤ⤢餷 */
#ifdef MKCOMMENTVIEW_DEBUG
        printSpdConvRegionItoCFailerInfo(objectId, regionI, regionC);
#endif
    } else {
        setCommentViewOcc(objectId, regionC, relationId, occs);
    }
}

/* declaration. */

static SpdTrvActRelFunc beforeRelDecl(SpdObjId id, SpdRel rel,
                                      MkCommentViewTraverse *trav)
{
    trav->presentRel = rel;
    setElement(trav, declarationOccs);

    return SAPID_TRV_GO;
}

/* expression. */

static SpdTrvActRelFunc beforeRelExpression(SpdObjId id, SpdRel rel,
                                            MkCommentViewTraverse *trav)
{
    trav->presentRel = rel;
    setElement(trav, expressionOccs);

    return SAPID_TRV_GO;
}

/* label. */

static SpdTrvActRelFunc beforeRelLabel(SpdObjId id, SpdRel rel,
                                       MkCommentViewTraverse *trav)
{
    trav->presentRel = rel;
    setElement(trav, labelOccs);

    return SAPID_TRV_GO;
}

/* block. */

static SpdTrvActRelFunc beforeRelBlock(SpdObjId id, SpdRel rel,
                                       MkCommentViewTraverse *trav)
{
    if (spdSafetyStrcmp(spdGetAttrStrValByName(rel.objectId, "sort"), "branch block") == 0) {
        trav->presentRel = rel;
        setElement(trav, blockOccs);
    }

    return SAPID_TRV_GO;
}

/* SPIE2traverse.c򻲹 */

void traverseForCommentViewGetElem(SpdObjId ifileId, SpdObjId declarationId,
                                   int declOffset)
{
    SpdTrvActInfo   *info;
    MkCommentViewTraverse trav;

    trav.ifileId = ifileId;
    trav.declOffset = declOffset;
    
    info = spdTrvInitActInfo();

    /*
     * declaration.
     */    
    /* block -> declaration. */
    spdTrvAddRel(info, SPD_RID_BLK_DECL);
    /* optionaldecl  -> declaration. */
    spdTrvAddRel(info, SPD_RID_STRUCT_DECL);
    spdTrvAddRel(info, SPD_RID_PROT_PARM);
    spdTrvAddRel(info, SPD_RID_FUNC_PARM);
    spdTrvAddRel(info, SPD_RID_FUNCPTR_PARM);
    
    /* declarator. */    
    spdTrvAddRel(info, SPD_RID_DECL_DECL);
    /* optionaldecl */
    spdTrvAddRel(info, SPD_RID_DECL_OPT);

    /* block. */
    spdTrvAddRel(info, SPD_RID_FUNC_BODY);
    spdTrvAddRel(info, SPD_RID_BLK_BLK);
    
    /* label. */
    spdTrvAddRel(info, SPD_RID_BLK_LABEL);

    /* expression. */
    spdTrvAddRel(info, SPD_RID_BLK_EXPR);

    spdTrvAddRel(info, SPD_RID_CASE_CEXPR);
    
    spdTrvAddRel(info, SPD_RID_EXPR_EXPR);
    
    spdTrvAddRel(info, SPD_RID_INIT_EXPR);

    /**********************/
    /* ãν */
    /**********************/

    /* declaration. */
    spdTrvAddActFuncOfRelClass(info, SPD_RID_BLK_DECL, SAPID_TRV_ACT_BEFORE,
                               (SpdTrvActRelFunc)beforeRelDecl);

    spdTrvAddActFuncOfRelClass(info, SPD_RID_STRUCT_DECL, SAPID_TRV_ACT_BEFORE,
                               (SpdTrvActRelFunc)beforeRelDecl);
    spdTrvAddActFuncOfRelClass(info, SPD_RID_PROT_PARM, SAPID_TRV_ACT_BEFORE,
                               (SpdTrvActRelFunc)beforeRelDecl);
    spdTrvAddActFuncOfRelClass(info, SPD_RID_FUNC_PARM, SAPID_TRV_ACT_BEFORE,
                               (SpdTrvActRelFunc)beforeRelDecl);
    spdTrvAddActFuncOfRelClass(info, SPD_RID_FUNCPTR_PARM, SAPID_TRV_ACT_BEFORE,
                               (SpdTrvActRelFunc)beforeRelDecl);
    /* block. */
    spdTrvAddActFuncOfRelClass(info, SPD_RID_FUNC_BODY, SAPID_TRV_ACT_BEFORE,
                               (SpdTrvActRelFunc)beforeRelBlock);
    spdTrvAddActFuncOfRelClass(info, SPD_RID_BLK_BLK, SAPID_TRV_ACT_BEFORE,
                               (SpdTrvActRelFunc)beforeRelBlock);
    /* label. */
    spdTrvAddActFuncOfRelClass(info, SPD_RID_BLK_LABEL, SAPID_TRV_ACT_BEFORE,
                               (SpdTrvActRelFunc)beforeRelLabel);
    /* expression. */
    spdTrvAddActFuncOfRelClass(info, SPD_RID_BLK_EXPR, SAPID_TRV_ACT_BEFORE,
                               (SpdTrvActRelFunc)beforeRelExpression);
    spdTrvAddActFuncOfRelClass(info, SPD_RID_CASE_CEXPR, SAPID_TRV_ACT_BEFORE,
                               (SpdTrvActRelFunc)beforeRelExpression);
    spdTrvAddActFuncOfRelClass(info, SPD_RID_EXPR_EXPR, SAPID_TRV_ACT_BEFORE,
                               (SpdTrvActRelFunc)beforeRelExpression);
    spdTrvAddActFuncOfRelClass(info, SPD_RID_INIT_EXPR, SAPID_TRV_ACT_BEFORE,
                               (SpdTrvActRelFunc)beforeRelExpression);

    spdTraverse(declarationId, info, &trav);
    spdTrvFreeActInfo(info);
}
