/* 
 * Program:             $RCSfile: mkCommentView.c,v $  $Revision: 40.14 $
 * 
 * Purpose:             
 * 
 * Author:              K.Hoshino  2001/10/27
 *                      S.Yamamoto  2001/10/27 
 * 
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
"$Id: mkCommentView.c,v 40.14 2003/07/08 05:46:55 yamamoto Exp yamamoto $";
#endif

/* 
 * (1) 2001/01/31
 * !! ֤ޤ
 * ΤˤϤۤɤäƤʤɡʸǤμ˻֤
 * äƤޤ褦Ǥ
 */

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/CommentViewAR.h>
#include "mkCommentView.h"

SpdSet2 pcommentOccs; /* CommentView Ǥʪΰ襳Ǥν */

SpdSet2 elementOccs; /* Ȥդ¾ǤΥ饹ν */
SpdSet2 declarationOccs;
SpdSet2 labelOccs;
SpdSet2 expressionOccs;
SpdSet2 pblockOccs;
SpdSet2 blockOccs;

/* 󥯥롼ɤ줿եνΤν */
SpdSet2 includedDeclarationOccs; /* ifileǤǡ󥯥롼ɤ줿 */
                                /* ե¸ߤ */
SpdIdSet includedPfileIds;      /* 󥯥롼ɤƤե */
                                /* (ȤꡤΥȷϥỌ̇̄ΰΥƥ) */
SpdBoolean pfileIsIncludedFile; /* ߽Υե뤬pfileǤ뤫ɤ */

SpdObjId pfileId; /* ߽ pfile */
SpdObjId ifileId; /* ߽ ifile */

SpdString sourceString;  /* ߽ pfile ʸ */

static void beforeAnalyse(void);
static void afterAnalyse(void);
static void makeOneFileCommentView(void);
static void getIncludedFileIds(int parentPfileId);
static void spdMakeCommentView(void);
static int compCE(const void *a, const void *b);
static SpdString makeLcommentString(SpdObjId lcomment);
static void setLcommentString(void);

/*
 * 
 */

static void beforeAnalyse(void)
{
    /*  */
    /*
     * elementOccs = spdCreateSet(sizeof(CommentViewOcc));
     * elementOccs ¾Ǥ¤ȤƺΤǡǤϽʤ
     */
    pcommentOccs = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_POINTER_VALUE);
    declarationOccs = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_POINTER_VALUE);
    labelOccs = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_POINTER_VALUE);
    expressionOccs = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_POINTER_VALUE);
    pblockOccs = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_POINTER_VALUE);
    blockOccs = spdCreateSet2(SPDSET_OBJID_KEY, SPDSET_POINTER_VALUE);

    /* եʸμ */
    sourceString = getSourceString();

    /* pblock롥 */
    getPblocks();
    /* ȤդI-modelιʸǤ롥 */
    getElements();
    /* פʹʸǤ롥 */
    removeMacroCallExpression();

    /*
     * Ȥդ⤷ʤelementOccs롥
     * !! κݤ˹ʸǤκۤȤɹͤʤΤʤ
     * elementOccsǤޤȤƽ뤫
     */
    mkElementOccs();
}

void spdFreeCommentViewOcc(SpdElemValue elem)
{
    CommentViewOcc *occ = spdSetGetValueP(elem);
    if (occ != NULL) {
        if (occ->str != NULL) {
            spdFree(occ->str);
        }
        spdFree(occ);
    }
}

/*
 * λ
 */

static void afterAnalyse(void)
{
    SetCursor csr;

    /* եʸγ */
    spdSafetyFree(sourceString);

    /* 糫 */
    for (csr = spdSetCursorCreate(pcommentOccs); spdSetCursorNext(&csr);) {
        CommentViewOcc *cvOcc = 
            (CommentViewOcc *)spdSetGetValueP(csr.curElem->value);
        spdSafetyFree(cvOcc->str);
        spdSafetyFree(cvOcc);
    }
    spdFreeSet2(pcommentOccs);
    spdFreeSet2(elementOccs);         /* Ȥդ¾Ǥν糫 */
    spdFreeSet2(declarationOccs);     /* Ȥդdeclarationν糫 */
    spdFreeSet2(labelOccs);           /* Ȥդlabelν糫 */
    spdFreeSet2(expressionOccs);      /* Ȥդexpressionν糫 */
    spdFreeSet2(pblockOccs);          /* Ȥդpblockν糫 */
    spdFreeSet2(blockOccs);           /* Ȥդblockν糫 */
}

/*
 * եñ̤CommentView롥
 */

static void makeOneFileCommentView(void)
{
    beforeAnalyse();

    /* Ϣդ */
    analyse();

    /* lcommentstr°򥻥åȤ롥 */
    setLcommentString();

#ifdef MKCOMMENTVIEW_DEBUG
    /* ƹʸǾϤ롥 */
    /*printElementsInfo(TRUE, TRUE, TRUE, TRUE, TRUE);*/
    /* pcommentϤ롥 */
    /*printPcommentsInfo();*/
    /* lcommentϤ롥 */
    printLcommentInfoInPfile(pfileId);
#endif

    afterAnalyse();
}

/*
 * ƵƤӽФˤä¿Ťinclude줿Τ롥
 */

static void getIncludedFileIds(int parentPfileId)
{
    SetCursor csr;
    SpdIdSet tmpIds = spdGetChildObjIdSet(parentPfileId, SPD_RID_FILE_BLOCK);

    for (csr = spdSetCursorCreate(tmpIds); spdSetCursorNext(&csr);) {
        SpdObjId pblockId = spdSetGetValueO(csr.curElem->value);

        if (spdGetAttrIntValByName(pblockId, "sort") == PBLOCK_INCLUDE) {
            SpdObjId hfileId = spdGetAChildObjId(pblockId, SPD_RID_INCLD_HFILE);
            /* hfileIdNON_IDˤʤ뤳Ȥ褦ʤ?
               եμΤĤʤäΤ? */
            if (hfileId != SPD_NON_ID) {
                SpdObjId h_pfileId = spdGetAChildObjId(hfileId, SPD_RID_HFILE_FILE);
                if(!spdContainsO(includedPfileIds, h_pfileId)) {
                    spdAddElemOK(includedPfileIds, h_pfileId);
                    /* ƵƤӽФ */
                    getIncludedFileIds(h_pfileId);
                }
            }
        }
    }
    spdFreeSet2(tmpIds);
}

/*
 * CommentView롥 
 */

static void spdMakeCommentView(void)
{
    SpdIdSet ifiles;
    SetCursor csr;

    /*  file μ */
    ifiles = spdGetClassExtentP(SPD_CID_FILE); /* no need to free */

    /* ñ̤ϳƥե뤴Ȥʬ䤵 */
    for (csr = spdSetCursorCreate(ifiles); spdSetCursorNext(&csr);) {
#ifndef MKCOMMENTVIEW_AVOID_INCLUDED_FILE
        SetCursor csr;
#endif

        /* եId */
        ifileId = spdSetGetValueO(csr.curElem->value);
        pfileId = spdGetARelObj(ifileId, "cfile_ifile", "file_id");

        /* бpfileʤΤϥեȤƤμ֤ΤʤNameΤߤΤ */
        /* ʤʤΤ¸ߤƤΤ??? */
        if (pfileId != SPD_NON_ID) {
            /* !! spdSafetyStrcmp(spdGetName(pfileId), "mkCommentView.c") == 0 */
            /* !! spdSafetyStrcmp(spdGetName(pfileId), "unzip.c") == 0 */

            /* 󥯥롼ɤ줿եνΤɬפʽν */
            includedDeclarationOccs = spdCreateSet2(SPDSET_OBJID_KEY,
                                                    SPDSET_POINTER_VALUE);
            includedDeclarationOccs->valueFree = spdFreeCommentViewOcc;
            includedPfileIds = spdCreateSet2(SPDSET_OBJID_KEY, 
                                            SPDSET_KEY_IS_VALUE);
            /* 󥯥롼ɤ줿եμ */
            getIncludedFileIds(pfileId);

            /******************************************/
            /* ifile-pfile ·äƤեν */
            /******************************************/
            pfileIsIncludedFile = FALSE;
            makeOneFileCommentView();
      
#ifndef MKCOMMENTVIEW_AVOID_INCLUDED_FILE

            /************************************/
            /* 󥯥롼ɤ줿եν */
            /************************************/
            pfileIsIncludedFile = TRUE;
      
            /* 󥯥롼ɤ¦Υեνä롥 */
            /* κݡ󥯥롼ɤ줿եI-modelǤݻƤ */
      
            /*
             * бifileʤ褦pfileν
             * (Ĥޤϥ󥯥롼ɤե)ϡ
             * 󥯥롼ɤե뤬¿ȤƤʣƤޤ
             * (Ʊե򥤥󥯥롼ɤǤ⡤SDBpfileʲϤ줾
             * ΩʤΤȤƽƤ롥)
             * 󥯥롼ɤեΩեȤư褦
             * ǥ뤬ѹ(ɲ?)Ѥġ
             */
      
            /* ե뤴Ȥ˽ */
            for (csr = spdSetCursorCreate(includedPfileIds); 
                 spdSetCursorNext(&csr);) {
                pfileId = spdSetGetValueP(cur.curElem->value);
                /* ƥեʤ */
#ifdef MKCOMMENTVIEW_AVOID_SYSTEM_FILE
                if (!smuIsSystemFile(pfileId)) {
#endif
                    /* ե뤴Ȥν */
                    makeOneFileCommentView();
#ifdef MKCOMMENTVIEW_AVOID_SYSTEM_FILE
                }
#endif
            }

#endif

            /* 󥯥롼ɤ줿եνΤɬפʽν */
            spdFreeSet2(includedDeclarationOccs);
            spdFreeSet2(includedPfileIds);
        }
    }
}

/* ==================================================================== */

/*
 * qsortӴؿ(offset)
 */

static int compCE(const void *a, const void *b)
{
    SpdObjId aa = *(SpdObjId *)a;
    SpdObjId bb = *(SpdObjId *)b;
    int aa_offset = spdGetAttrIntValByName(aa, "offset");
    int bb_offset = spdGetAttrIntValByName(bb, "offset");
    int return_int;

    if(aa_offset < bb_offset) return_int =  -1;
    else if(aa_offset == bb_offset) return_int = 0;
    else return_int = 1;

    return return_int;
}

/*
 * ΰ襳Ȥʸ롥
 */

static SpdString makeLcommentString(SpdObjId lcomment)
{
    SpdObjId *array = NULL;
    SpdString from_str = spdStrdup(""), to_str = NULL;
    SpdIdSet pcommentIds;
    SetCursor csr;
    int i;

    /* !! ⤷spdGetObjIdOfModelSortedArrayȤȤаȯʤΤ? */

    pcommentIds = spdGetParentObjIdSet(lcomment, SPD_RID_PCOMMENT_LCOMMENT);

    array = (SpdObjId *) spdMalloc(sizeof(SpdObjId) * pcommentIds->elemNum);
    for (i = 0, csr = spdSetCursorCreate(pcommentIds); 
         spdSetCursorNext(&csr); i++) {
        array[i] = spdSetGetValueO(csr.curElem->value);
    }
    /* arrayoffsetǥ */
    spdQsortTmp(array, pcommentIds->elemNum, sizeof(SpdObjId), compCE);

    for (i = 0; i < pcommentIds->elemNum; i++) {
        int zzz;
        int offset, length, line_num_begin, line_num_end, offset_from_linehead;

        offset = spdGetAttrIntValByName(array[i], "offset");
        length = spdGetAttrIntValByName(array[i], "length");
        line_num_begin = spdGetAttrIntValByName(array[i], "line_num_begin");
        line_num_end = spdGetAttrIntValByName(array[i], "line_num_end");
        offset_from_linehead = spdGetAttrIntValByName(array[i], "offset_from_linehead");
    
        /* ԤκԤ */
        if (i != 0) {
            int line_gap = line_num_begin - spdGetAttrIntValByName(array[i - 1], "line_num_end");
      
            for (zzz = 0; zzz < line_gap; zzz++) {
                to_str = spdStrcatDup(from_str, "\n");
                spdFree(from_str);
                from_str = to_str;
            }
        }
    
        /* offset_from_lineheadʬڡ */
        for (zzz = 0; zzz < offset_from_linehead; zzz++) {
            to_str = spdStrcatDup(from_str, " ");
            spdFree(from_str);
            from_str = to_str;
        }

        to_str = spdStrcatDup(from_str, spdGetAttrStrValByName(array[i], "str"));
        spdFree(from_str);
        from_str = to_str;
    }

    spdFreeSet2(pcommentIds);
    spdSafetyFree(array);
    
    return from_str;
}

/* lcommentstr°򥻥åȤ롥 */

static void setLcommentString(void)
{
    SetCursor csr;
    SpdIdSet lcommentIds = getLcommentsInPfile(pfileId);
    for (csr = spdSetCursorCreate(lcommentIds); spdSetCursorNext(&csr);) {
        SpdObjId lcommentId = spdSetGetValueO(csr.curElem->value);
        SpdString str = makeLcommentString(lcommentId);
        spdSetAttrStrValByName(lcommentId, "str", str);
        spdFree(str);
    }
}

/* ==================================================================== */

int main(int argc, char *argv[])
{
    SpdDBId     dbId;
    SpdModelId  ImodelId, PmodelId, CommentViewId;

    spdInitialize(spdBasename(argv[0]));
    parse_option(argc, argv);

    /* Imodel, Pmodel, Comment_view3ĤΥǥ򰷤 */
    ImodelId = spdUseModel(&I_model);
    PmodelId = spdUseModel(&P_model);
    CommentViewId = spdUseModel(&Comment_view);

    /* SDBoepn롥 */
    if ((dbId = spdOpenSDB()) == SPD_NON_ID) {
        spdErrorExit("Program not found.\n");
    }

    /* ImodelPmodelɤ߹ࡥ */
    spdReadDB(ImodelId, dbId);
    spdReadDB(PmodelId, dbId);

    /* CommentViewΤDBƤ롥 */
    spdCreateDB(CommentViewId, dbId);

    /* CommentView롥 */
    spdMakeCommentView();

#ifdef MKCOMMENTVIEW_DEBUG
    {
        SpdIdSet pcommentIds = spdGetClassExtent(SPD_CID_PCOMMENT);
        SpdIdSet lcommentIds = spdGetClassExtent(SPD_CID_LCOMMENT);

        printf("\n=======================================================\n");
        printf("|| total || pcomment lcomment : %d %d\n", pcommentIds->elemNum,
               lcommentIds->elemNum);
        printf("=======================================================\n\n");
        spdFreeSet(pcommentIds);
        spdFreeSet(lcommentIds);
    }
#endif

    /* CommentViewϤclose롥 */
    spdCommitDB(CommentViewId, dbId);
    spdCloseSDB(dbId);

    return (EXIT_SUCCESS);
}

/*
 * Analyzing options.
 */

void parse_option(int argc, char *argv[])
{
    int     ch;

    while ((ch = getopt(argc, argv, "d:")) != -1) {
        switch (ch) {
          case 'd':                         /* Directory for SDB. */
            spdSetSDBdir(optarg);
            break;
          default:
            spdErrorExit("'%c': Invalid option.\n", ch);
            break;
        }
    }
}
