/* 
 * Program:             $RCSfile: mkCommentViewTest.c,v $  $Revision: 40.8 $
 * 
 * Purpose:             
 * 
 * Author:              K.Hoshino  2001/10/27
 *                      S.Yamamoto  2001/10/27 
 * 
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
"$Id: mkCommentViewTest.c,v 40.8 2003/07/08 05:46:55 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

#include <Sapid/PmodelAR.h>             /* Fro spdGetTextByRegion(). */
 
/* getOffsetFromLineHead, getLineNum, getSourceFileStringδؿΤ */
#include <Sapid/CommentViewAR.h>

#include "mkCommentView.h"

/* CommentViewOcc Ǿν */

void printCommentViewOccInfo(CommentViewOcc *occ)
{
    char *str = spdGetTextByRegion(occ->region);
    printf("---------------------------------------------------------------------\n");
    printf("Id     : %d \n", occ->objectId);
    printf("Class  : %s \n", spdGetClassName(occ->objectId));
    printf("File   : %s \n", spdGetName(occ->region.fileId));
    printf("sort   : %s \n", spdGetAttrStrValByName(occ->objectId, "sort"));
    printf("offset : %d \n", occ->region.offset);
    printf("length : %d \n", occ->region.length);

    printf("offsetFromPreviousNewLine : %d \n", occ->offsetFromLineHead);
    printf("lineNumFrom : %d \n", occ->lineNumBegin);
    printf("lineNumTo : %d \n", occ->lineNumEnd);
    printf("related : %d \n", occ->related);

    printf("String : \n");
    printf("%s\n", str);
    printf("---------------------------------------------------------------------\n");
    spdSafetyFree(str);
}

/* CommentViewOcc ǤȤƻ SpdSet ν */

void printCommentViewOccsInfo(SpdSet2 occs)
{
    SetCursor csr;
    for (csr = spdSetCursorCreate(occs); spdSetCursorNext(&csr);) {
        printCommentViewOccInfo(spdSetGetValueP(csr.curElem->value));
    }
}

/* SpdOcc Ǿν */

void printOccInfo(SpdOcc *occ)
{
    char *str = getSourceFileString(occ->fileId, occ->offset, 
                                    spdGetLength(occ->objectId));
    printf("---------------------------------------------------------------------\n");
    printf("Id     : %d \n", occ->objectId);
    printf("File   : %s \n", spdGetName(occ->fileId));
    printf("sort   : %s \n", spdGetAttrStrValByName(occ->objectId, "sort"));
    printf("offset : %d \n", occ->offset);
    printf("length : %d \n", spdGetLength(occ->objectId));
    printf("String : \n");
    printf("%s\n", str);
    spdSafetyFree(str);
}

/* SpdObjId Ǿν */

void printObjInfo(SpdObjId objectId)
{
    printf("---------------------------------------------------------------------\n");
    printf("Id : %d | Class : %s | sort : %s | length : %d | name : %s\n",
           objectId, spdGetClassName(objectId),
           spdGetAttrStrValByName(objectId, "sort"), 
           spdGetAttrIntValByName(objectId, "length"), 
           spdGetAttrStrValByName(objectId, "name"));
}

/* pfile  LCOMMENT ν */

void printLcommentInfoInPfile(SpdObjId pfileId)
{
    int i;
    SpdObjIdArray lcommentArray = getLcommentsInPfileSorted(pfileId);

    printf("*****************************************************\n");
    printf("* lcomments in file : %s \n", 
           spdGetAttrStrValByName(pfileId, "name"));
    printf("*****************************************************\n");

    for (i = 0; i < lcommentArray.size; i++) {
        SpdObjId lcommentId = lcommentArray.id[i];
        printALcommentInfo(lcommentId);
    }

    spdFreeObjIdArray(lcommentArray);
}

/*  LCOMMENT ν */

void printAllLcommentInfo(void)
{
    SetCursor csr;
    SpdIdSet lcommentIds = spdGetClassExtentP(SPD_CID_LCOMMENT); /* no need to free */

    for (csr = spdSetCursorCreate(lcommentIds); spdSetCursorNext(&csr);) {
        SpdObjId lcommentId = spdSetGetValueO(csr.curElem->value);
        printALcommentInfo(lcommentId);
    }
}

/* 1Ĥ LCOMMENT δϢ빽ʸǤ */
static void printALcommentInfoSub(SpdObjId lcommentId, SpdClassId spdRId, SpdString str, SpdSet2 occs)
{
    SpdObjId objId = spdGetAChildObjId(lcommentId, spdRId);

    if (objId != SPD_NON_ID) {
        printf("---------------------------------------------------------------------\n");
        printf("    %s\n", str);
    
        if (spdRId == SPD_RID_LCOMMENT_PFILE) {
            printObjInfo(objId);
        } else {
            printCommentViewOccInfo((CommentViewOcc *)
                                    spdSearchElemO(occs, objId));
        }
    }
}

/* 1Ĥ LCOMMENT ν */
void printALcommentInfo(SpdObjId lcommentId)
{
    SpdObjId pfileId = getLcommentFile(lcommentId);
    int length, offset, lineNumBegin, lineNumEnd, offsetFromLinehead;
    getLcommentPositionInfos(lcommentId, &length, &offset, &lineNumBegin, 
                             &lineNumEnd, &offsetFromLinehead);

    printf("===================================================================\n");

    printf("ID : %d \n", lcommentId);
    printf("pfile : %s (ID : %d)\n", spdGetAttrStrValByName(pfileId, "name"), pfileId);
    printf("offset : %d\n", offset);
    printf("total length : %d\n", length);
    printf("lineNumBegin : %d\n", lineNumBegin);
    /* printf("lineNumEnd : %d\n", lineNumEnd); */
    /* printf("offsetFromLinehead : %d\n", offsetFromLinehead); */
    printf("string : \n%s\n", spdGetAttrStrValByName(lcommentId, "str"));
   
    printALcommentInfoSub(lcommentId, SPD_RID_PCOMMENT_LCOMMENT, "pcomment_lcomment", pcommentOccs);
    
    /* ΤȤɤ줫ĤʤΤɡޡǰΤᡣ */
    
    /* fileelementOccs˴ޤޤƤʤΤ */
    printALcommentInfoSub(lcommentId, SPD_RID_LCOMMENT_PFILE, "comment_pfile", NULL);
    
    printALcommentInfoSub(lcommentId, SPD_RID_LCOMMENT_PBLOCK, "comment_pblock", elementOccs);
    printALcommentInfoSub(lcommentId, SPD_RID_LCOMMENT_DECLARATION, "comment_declaration", elementOccs);
    printALcommentInfoSub(lcommentId, SPD_RID_LCOMMENT_LABEL, "comment_label", elementOccs);
    printALcommentInfoSub(lcommentId, SPD_RID_LCOMMENT_EXPRESSION, "comment_expression", elementOccs);
    printALcommentInfoSub(lcommentId, SPD_RID_LCOMMENT_BLOCK, "comment_block", blockOccs);

    printf("===================================================================\n");
}

/*
 * ƹʸǾν
 */

void printElementsInfo(SpdBoolean p, SpdBoolean d, SpdBoolean l,
                       SpdBoolean e, SpdBoolean b)
{
    if(p == TRUE) printCommentViewOccsInfo(pblockOccs);
    if(d == TRUE) printCommentViewOccsInfo(declarationOccs);
    if(l == TRUE) printCommentViewOccsInfo(labelOccs);
    if(e == TRUE) printCommentViewOccsInfo(expressionOccs);
    if(b == TRUE) printCommentViewOccsInfo(blockOccs);
}

/*
 * Regionν
 */

void printRegionInfo(SpdRegion region)
{
    printf("fileId : %d | offset : %d | length : %d \n",
           region.fileId, region.offset, region.length);
}
