/* 
 * Program:             $RCSfile: mkRelation.c,v $  $Revision: 40.10 $
 * 
 * Purpose:             
 * 
 * Author:              K.Hoshino  2001/10/27
 *                      S.Yamamoto  2001/10/27 
 * 
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
"$Id: mkRelation.c,v 40.10 2003/07/08 05:46:55 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/PmodelAR.h>         /* For spdGetTextByRegion(). */
#include <Sapid/CommentViewAR.h>
#include "mkCommentView.h"

/*
 * !! ʲCommentViewOccϥХѿȤưäΤ
 * ߷פȤɤʤä?
 */

static CommentViewOcc *pcomment = NULL; /* ߽Υ */

static CommentViewOcc *previousLineFirst = NULL;
static CommentViewOcc *previousOffset = NULL;

static CommentViewOcc *previous = NULL; /* ľιʸ */
static CommentViewOcc *next = NULL; /* ľιʸ */
static CommentViewOcc *tmp = NULL;

static int previousNextLineNum = -1; /* previous  pcomment Ȥδ֤βԤο */
static int nextNextLineNum = -1; /* pcomment  next Ȥδ֤βԤο */

/*
 * pcommentꤷǤʤɽ
 */

static void initialize(CommentViewOcc *a_pcomment)
{
    pcomment = a_pcomment;
    previous = NULL;
    next = NULL;
    tmp = NULL;
  
    previousNextLineNum = -1;
    nextNextLineNum = -1;
}

/*
 * Ϣpcomment_(줾ιʸ)
 */

static void createRelToElement(SpdObjId elemId)
{
    SpdClassId cId = spdGetClassId(elemId);
    SpdClassId rId;

    SpdObjId pcommentId, lcommentId;

    SpdIdSet pcommentIds;

    CommentViewOcc *cvOcc;

    SetCursor csr;

    switch (cId) {
      case SPD_CID_PFILE:
        rId = SPD_RID_LCOMMENT_PFILE;
        break;
      case SPD_CID_PBLOCK:
        rId = SPD_RID_LCOMMENT_PBLOCK;
        break;
      case SPD_CID_DECLARATION:
        rId = SPD_RID_LCOMMENT_DECLARATION;
        break;
      case SPD_CID_LABEL:
        rId = SPD_RID_LCOMMENT_LABEL;
        break;
      case SPD_CID_EXPRESSION:
        rId = SPD_RID_LCOMMENT_EXPRESSION;
        break;
      case SPD_CID_BLOCK:
        rId = SPD_RID_LCOMMENT_BLOCK;
        break;
      default:
        /* ʤϤ */
        spdErrorExit("Error occured in createRelToElement(mkRelation.c)");
        break;
    }

    lcommentId = spdGetAChildObjId(pcomment->objectId, SPD_RID_PCOMMENT_LCOMMENT);
    /* Ϣ! */
    spdCreateRel(rId, SPD_NON_ID, lcommentId, elemId);

    /* ΰʪΰƹʸǤȤδϢѤߤȤʤ */
    pcommentIds = spdGetParentObjIdSet(lcommentId, SPD_RID_PCOMMENT_LCOMMENT);
    for (csr = spdSetCursorCreate(pcommentIds); spdSetCursorNext(&csr);) {
        pcommentId = spdSetGetValueO(csr.curElem->value);
        cvOcc = spdSetGetValueP(
            spdSearchElemO(pcommentOccs, pcommentId)->value);
        if (cvOcc != NULL) {
            cvOcc->related = TRUE;
        }
    }
    spdFreeSet2(pcommentIds);
}

/*
 * FALLTHROUGHȤ顤ľΥ٥˴ϢĤ롥
 * ľΤۤɤ?Ȥ?
 * ¾LINT̤б
 */

static void mkRelationForFallthrough(void)
{
    SetCursor csr;

    for (csr = spdSetCursorCreate(pcommentOccs); spdSetCursorNext(&csr);) {
        SpdString str = NULL;

        initialize(spdSetGetValueP(csr.curElem->value));

        str = spdGetTextByRegion(pcomment->region);
        if (spdSafetyStrcmp(str, "/*FALLTHROUGH*/") == 0) {
            SetCursor csr;

            for (csr = spdSetCursorCreate(labelOccs); spdSetCursorNext(&csr);) {
                tmp = spdSetGetValueP(csr.curElem->value);
                if(tmp->region.offset < pcomment->region.offset &&
                   (previous == NULL 
                    || previous->region.offset < tmp->region.offset))
                    previous = tmp;
            }
            if (previous != NULL) {
                createRelToElement(previous->objectId);
            }
        }
        spdSafetyFree(str);
    }
}

/*
 * Ȥν񼰤β
 */

static void analyseFormat(void)
{
    mkRelationForFallthrough();
}

/* 
 * 1ܤ lcomment κ 
 * ñˡ֤˲⹽ʸǤʤϢ³ȤĤʤ
 */

static void mkLogical1st(void)
{
    SetCursor csr_p, csr_t, csr_e;

    for (csr_p = spdSetCursorCreate(pcommentOccs); spdSetCursorNext(&csr_p);) {
        initialize(spdSetGetValueP(csr_p.curElem->value));

        /*
         * äȤᤤΥȤõ
         */
        for (csr_t = spdSetCursorCreate(pcommentOccs); 
             spdSetCursorNext(&csr_t);) {
            tmp = spdSetGetValueP(csr_t.curElem->value);
      
            /* ƱǡޤϼʬʤΤǲ⤷ʤ */
            if (pcomment->region.offset >= tmp->region.offset) {

                /* ᤤǤ򥻥å */
            } else if (next == NULL || 
                       next->region.offset > tmp->region.offset) {
                next = tmp;
            }
        }

        /*
         * ιԤǡԤoffsetƱͤ ?
         */
        if (next != NULL &&
            next->lineNumBegin - pcomment->lineNumEnd == 1 &&
            pcomment->offsetFromLineHead == next->offsetFromLineHead) {
      
            /* ------------------------------------------  */
            /* ƴ֤˹ʸǤʤˤʤдϢ  */
            /* ------------------------------------------  */
            for (csr_e = spdSetCursorCreate(elementOccs);
                 spdSetCursorNext(&csr_e);) {
                tmp = spdSetGetValueP(csr_e.curElem->value);

                if (tmp->region.offset < next->region.offset &&
                    tmp->region.offset >= 
                    pcomment->region.offset + pcomment->region.length) {
                    break;
                }
            }
            if (csr_e.curElem == NULL) {
                SpdObjId lcomment1 = spdGetAChildObjId(
                    pcomment->objectId, SPD_RID_PCOMMENT_LCOMMENT);
                SpdObjId lcomment2 = spdGetAChildObjId(
                    next->objectId, SPD_RID_PCOMMENT_LCOMMENT);

                if (lcomment1 != lcomment2) {
                    SpdIdSet tmpPcommentIdSet = spdGetParentObjIdSet(
                        lcomment2, SPD_RID_PCOMMENT_LCOMMENT);
                    SetCursor csr;
                    
                    /* PCOMMENT_LCOMMENTϢ */
                    for (csr = spdSetCursorCreate(tmpPcommentIdSet);
                         spdSetCursorNext(&csr);) {
                        SpdObjId tmpPcommentId = 
                            spdSetGetValueO(csr.curElem->value);
                        spdCreateRel(SPD_RID_PCOMMENT_LCOMMENT, 
                                     SPD_NON_ID, tmpPcommentId, lcomment1);
                    }
                    /* פSPD_RID_PCOMMENT_LCOMMENTϢLCOMMENT饹֥Ȥκ */
                    /*spdDeleteObj(spdGetAChildRelId(next->objectId, SPD_RID_PCOMMENT_LCOMMENT));*/
                    spdDeleteObj(lcomment2);

                    spdFreeSet2(tmpPcommentIdSet);
                }
            }
        }
    }
}

/* 
 * 2ܤ lcomment κ 
 * ƱʸǤˤĤƤꡢ˹Ƭΰ֤ƱΤĤʤ
 */

static void mkLogical2nd(void)
{
    /*
     * ̤
     */
}

/*
 * from κǴʸ to ΥեåȤޤǤ˲ԥɤĤ뤫
 */

int getNextLineNum(CommentViewOcc *from, CommentViewOcc *to)
{
    int counter = to->lineNumBegin - from->lineNumEnd;

    /*
     * PBLOCKǤ'#'ǻϤޤΤɬԤޤǤǤȤ
     * Τǡͤ䤹
     */
    if (spdGetClassId(from->objectId) == SPD_CID_PBLOCK) {
        int sort = spdGetAttrIntValByName(from->objectId, "sort");
        switch (sort) {
          case PBLOCK_INCLUDE:
            /*FALLTHROUGH*/
          case PBLOCK_DEFINE_FILE:
            /*FALLTHROUGH*/
          case PBLOCK_UNDEF:
            /*FALLTHROUGH*/
          case PBLOCK_IF:
            /*FALLTHROUGH*/
          case PBLOCK_ELSE:
            /*FALLTHROUGH*/
          case PBLOCK_ELIF:
            /*FALLTHROUGH*/
          case PBLOCK_ENDIF:
            /*FALLTHROUGH*/
          case PBLOCK_IFDEF:
            /*FALLTHROUGH*/
          case PBLOCK_IFNDEF:
            /*FALLTHROUGH*/
          case PBLOCK_PRAGMA:
            /*FALLTHROUGH*/
          case PBLOCK_LINE:
            /*FALLTHROUGH*/
          case PBLOCK_ERROR:
            counter++;
            break;
          default:
            break;
        }
    }
  
    return counter;
}

/*
 * ȤľǡľǤФ
 * (ľǤΰ˥ȤޤޤƤ뤳Ȥ⤢)
 */

static void setPreviousNext(void)
{
    SetCursor csr;
  
    int offset = pcomment->region.offset;
    int length = pcomment->region.length;

    /*  */
    previous = previousOffset = previousLineFirst = next = NULL;

    for (csr = spdSetCursorCreate(elementOccs); spdSetCursorNext(&csr);) {
        SpdRegion reg;
        tmp = spdSetGetValueP(csr.curElem->value);

        reg = tmp->region;

        /* previousOffset : offset ᤤ */
        if (reg.offset < offset) {
            /* offset ᤤΤʤset */
            if (previousOffset == NULL || reg.offset > previousOffset->region.offset)
                previousOffset = tmp;
            /* Ʊ offset ʤ length 礭Τset */
            else if (reg.offset == previousOffset->region.offset &&
                     reg.length > previousOffset->region.length)
                previousOffset = tmp;
        }

        /* previous : offset + length ᤤ */
        if (reg.offset + reg.length < offset) {
            /* offset + length ᤤΤʤset */
            if (previous == NULL || 
                reg.offset + reg.length > previous->region.offset + previous->region.length)
                previous = tmp;
            /* Ʊ offset + length ʤ length 礭Τset */
            else if (reg.offset + reg.length == previous->region.offset + 
                     previous->region.length &&
                     reg.length > previous->region.length)
                previous = tmp;
        }

        /* previousLineFirst : ƱԤǡιԤΤäȤˤ */
        if (reg.offset + reg.length < offset) {
            /* äȤˤʤset */
            if (previousLineFirst == NULL || 
                (getNextLineNum(tmp, pcomment) == 0 &&
                 reg.offset < previousLineFirst->region.offset))
                previousLineFirst = tmp;
            /* Ʊ offset + length ʤ length 礭Τset */
            else if (getNextLineNum(tmp, pcomment) == 0 &&
                     reg.offset == previousLineFirst->region.offset &&
                     reg.length > previousLineFirst->region.length)
                previousLineFirst = tmp;
        }

        if (tmp->region.offset >= offset + length) {
            /* ᤤΤʤset */
            if (next == NULL || reg.offset < next->region.offset)
                next = tmp;
            /* Ʊoffsetʤlength礭Τset */
            else if (reg.offset == next->region.offset &&
                     reg.length > next->region.length)
                next = tmp;
        }
    }
  
    if (previous != NULL) previousNextLineNum = getNextLineNum(previous, pcomment);
    if (next != NULL) nextNextLineNum = getNextLineNum(pcomment, next);
}

static void createRelToElementInPositionAnalyse(SpdObjId elementId)
{
    createRelToElement(elementId);
}

/*
 * ʸǤȤ
 * ִطˤ빽ʸǤȤδϢդ
 */

static void analyseByElementPosition(void)
{
    SetCursor csr;

    /* pcommentȤ˽ */
    for (csr = spdSetCursorCreate(pcommentOccs); spdSetCursorNext(&csr);) {
        initialize(spdSetGetValueP(csr.curElem->value));

        if (pcomment->related == FALSE) {
            setPreviousNext();
      
            if (previous == NULL) {
                /* fileȤδϢ */
                if (next == NULL || nextNextLineNum > 1) {
                    createRelToElementInPositionAnalyse(pfileId);
                } else {
                    createRelToElementInPositionAnalyse(next->objectId);
                }
            } else {
                /* Ǥʤ */
                if (next == NULL) {
                    /* (κǴι)Ʊ */
                    if (previousNextLineNum == 0) {
                        createRelToElementInPositionAnalyse(previous->objectId);
                    } else {
                    }

                    /* ǤǤ⤢ */
                } else {

                    /* (κǴι)Ʊ */
                    if (previousNextLineNum == 0) {
                        createRelToElementInPositionAnalyse(previous->objectId);

                        /* ǤƱ */
                    } else if (nextNextLineNum == 0) {
                        createRelToElementInPositionAnalyse(next->objectId);

                        /* ǤιԤǡ */
                        /* ˲ԤoffsetƱ */
                    } else if (nextNextLineNum == 1 && 
                               pcomment->offsetFromLineHead == next->offsetFromLineHead) {
                        createRelToElementInPositionAnalyse(next->objectId);
        
                        /* ǤΥƤơ(κǴι)Τι */
                        /* ˲ԤoffsetƱ */
                    } else if (nextNextLineNum > 1 && previousNextLineNum == 1 &&
                               pcomment->offsetFromLineHead == previous->offsetFromLineHead) {
                        createRelToElementInPositionAnalyse(previous->objectId);
        
                        /* ǤΥƤơǤϴؿǤ */
                        /* ˲ԤoffsetƱ */
                    } else if (previousNextLineNum > 1) {
                        if (spdGetClassId(next->objectId) == SPD_CID_DECLARATION &&
                            pcomment->offsetFromLineHead == next->offsetFromLineHead) {
                            int sort = spdGetAttrIntValByName(next->objectId, "sort");
                            if (sort == DECL_FUNCDEF) createRelToElementInPositionAnalyse(next->objectId);
                        }
                    }
                }
            }
        }
    }
}

/*
 * pcomment°Ϣ 
 * (ޤޤȼǤ롥ʤȯŸ˾ࡥ)
 */

void analyse(void)
{
    /* ν񼰤β */
    analyseFormat();

    /* ΰ1ܤκ */
    mkLogical1st();

    /* ʸǤȤΰִطˤ빽ʸǤȤδϢդ */
    analyseByElementPosition();

    /* ΰ2ܤκ */
    mkLogical2nd();
}
