/* 
 * Program:             $RCSfile: mkExprType2.c,v $  $Revision: 30.15 $
 * 
 * Purpose:
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: mkExprType2.c,v 30.15 2003/06/28 15:32:04 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/write_sdb_sub.h>

/*
 * Name of file and SpdInfo entry.
 */
#define EXPR_TYPE               "expr_type"
#define EXPR_TYPE2              "expr_type2"

static SpdBoolean flag_t = FALSE;

static void dump_expr_type(void);
static void parse_option(int argc, char *argv[]);

int main(int argc, char *argv[])
{
    SpdConstString  program_name;              /* This program name. */
    SpdDBId         dbId;
    SpdModelId      ImodelId;

    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);
    parse_option(argc, argv);
    argc -= optind;
    argv += optind;

    ImodelId = spdUseModel(&I_model);
    dbId = spdOpenSDB();
    spdReadDB(SPD_NON_MID, dbId);
    dump_expr_type();
    return (EXIT_SUCCESS);
}

static void dump_expr_type(void)
{
    int             num_expr_type;
    SpdInfo         *info;
    SpdObjId        obj_id;
    SpdCursor       *obj_csr;
    FILE            *fp;

    info = spdOpenSDBinfo();
    if (SPD_STREQ(spdGetInfoString(info, "BINARY_FORMAT_SDB"), "TRUE")) {
        spdSetWriteSDBformat(SAPID_BINARY_FORMAT_SDB);
    } 

    fp = spdOpenSDBfile(spdGetModelDir(SPD_MID_I_MODEL),
                        (flag_t ? EXPR_TYPE2 : EXPR_TYPE), SAPID_O_WRITE);

    num_expr_type = 0;
    obj_csr = spdGetObjIdInit("expression", NULL);
    while ((obj_id = spdGetObjId(obj_csr)) != SPD_NON_ID) {
        if (smuGetExprType(obj_id) != SPD_NON_ID) {
            write_expr_type_sub(fp, obj_id, smuGetExprType(obj_id));
            num_expr_type++;
        }
    }
    spdFreeCursor(obj_csr);

    spdFclose(fp);

    /* SpdInfo˴Ϣ"expr_type"ο񤭹ࡥ */ 
    spdSetInfoInt(info, (flag_t ? EXPR_TYPE2 : EXPR_TYPE), num_expr_type);

    spdCloseInfo(info);
}

static void parse_option(int argc, char *argv[])
{
    int     ch;

    while ((ch = getopt(argc, argv, "d:t")) != -1) {
        switch (ch) {
          case 'd':                         /* Directory for SDB. */
            spdSetSDBdir(optarg);
            spdMessage("SDB directory \"%s\".\n", spdGetSDBdir());
            break;
          case 't':                         /* Test. */
            flag_t = ON;
            break;
          default:
            spdErrorExit("'%c': Invalid option.\n", ch);
            break;
        }
    }
}
