/* 
 * Program:             $RCSfile: bitVector.c,v $  $Revision: 40.8 $
 * 
 * Purpose:
 *
 * Author:              T.Saso  2001/12/11
 *                      S.Yamamoto  2001/12/11
 *
 * (C) Copyright:       T.Saso and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: bitVector.c,v 40.8 2002/07/09 12:13:41 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "mkDD.h"

/* Reachη׻˻Ȥӥåȥ٥ȥΥ롼 */

/* ӥåȥ٥ȥΥѿǴ롥 */
static int bitVectorSize;
static int bitVectorIntSize; /* intʬ礭 */

/* ؿ */

void initBitVectorSize(int size)
{
    bitVectorSize = size;

    if ((bitVectorSize % (sizeof(int) * 8)) == 0) {
        bitVectorIntSize = bitVectorSize / ((sizeof(int) * 8));
    } else {
        /* sizeof(int) */
        bitVectorIntSize = bitVectorSize / ((sizeof(int) * 8)) + 1;
    }
}

bitVector *createBitVector(void)
{
    int i;
    bitVector *p;
    if (bitVectorSize > 0) {
        p = (bitVector *)spdMalloc(sizeof(int) * bitVectorIntSize);
        for (i = 0; i < bitVectorIntSize; i++) {
            p[i] = 0;
        }
    } else {
        p = NULL;
    }
    return p;
}

void setBitVector(bitVector *bv, int n)
{
    int mask = 1;

    if (n >= bitVectorSize || n < 0) {
        spdErrorExit("setBitVector(): %d: Invalid argument n.\n", n);
    }

    mask = mask << (n % (sizeof(int) * 8));
    /* fprintf(stderr, "mask %d\n", mask); */
    bv[n / (sizeof(int) * 8)] |= mask;
}

/* ̤Ѵؿ */

void clrBitVector(bitVector *bv, int n)
{
    int mask = 1;

    if (n >= bitVectorSize || n < 0) {
        spdErrorExit("clrBitVector(): %d: Invalid argument n.\n", n);
    }

    mask = mask << (n % (sizeof(int) * 8));
    mask = ~mask;
    bv[n / (sizeof(int) * 8)] &= mask;
}

SpdBoolean chkBitVector(bitVector *bv, int n)
{
    int mask = 1, t;

    if (n >= bitVectorSize || n < 0) {
        spdErrorExit("chkBitVector(): %d: Invalid argument n.\n", n);
    }

    mask = mask << (n % (sizeof(int) * 8));
    t = bv[n / (sizeof(int) * 8)];
    t &= mask;
    if (t) {
        return TRUE;
    } else {
        return FALSE;
    }
}

void andBitVector(bitVector *d, bitVector *s)
{
    int i;

    for (i = 0; i < bitVectorIntSize; i++) {
        d[i] &= s[i];
    }
}

void orBitVector(bitVector *d, bitVector *s)
{
    int i;

    for (i = 0; i < bitVectorIntSize; i++) {
        d[i] |= s[i];
    }
}

/* ̤Ѵؿ */

void xorBitVector(bitVector *d, bitVector *s)
{
    int i;

    for (i = 0; i < bitVectorIntSize; i++) {
        d[i] ^= s[i];
    }
}

void notBitVector(bitVector *d)
{
    int i;

    for (i = 0; i < bitVectorIntSize; i++) {
        d[i] = ~d[i];
    }
}

void copyBitVector(bitVector *d, bitVector *s)
{
    int i;

    for (i = 0; i < bitVectorIntSize; i++) {
        d[i] = s[i];
    }
}

void resetBitVector(bitVector *d)
{
    int i;

    for (i = 0; i < bitVectorIntSize; i++) {
        d[i] = 0;
    }
}

SpdBoolean isEqualBitVector(bitVector *a, bitVector *b)
{
    int i;

    for (i = 0; i < bitVectorIntSize; i++) {
        if (a[i] != b[i]) {
            return FALSE;
        }
    }
    return TRUE;
}
