/* 
 * Program:             $RCSfile: calcDD.c,v $  $Revision: 40.11 $
 * 
 * Purpose:
 *
 * Author:              T.Saso  2001/12/11
 *                      S.Yamamoto  2001/12/11
 *
 * (C) Copyright:       T.Saso and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
"$Id: calcDD.c,v 40.11 2002/10/21 07:27:05 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "mkDD.h"

static SpdBoolean searchDUSet(SpdObjId def, SpdObjId used);
static SpdBoolean searchDDSet(SpdObjId def, SpdObjId ref);

static SpdBoolean isRightValue(SpdObjId exprId);
static void createRelDefUsed(SpdObjId exprId, SpdObjId curDefObjId);
static void createRelDataDependence(SpdObjId exprId, SpdObjId curDefObjId,
                                    bitVector *reach);
static void calcLocalReach(SpdObjId exprId, bitVector *localNewReach);
static void setSubExprDefAndKill(SpdObjId exprId,
                                 bitVector *def, bitVector *kill);
static void skipDefedExpr(SpdObjId exprId, SpdObjId curDefObjId,
                          bitVector *localReach, bitVector *localNewReach);
static void calcExpr(SpdObjId exprId, SpdObjId curDefObjId,
                     bitVector *localReach, bitVector *localNewReach);
static void calcTopLevelObj(SpdObjId objId);

extern int debugPrintFlag;
extern int debugPrintFlag2;

/* 
 * ʣϿѤνΤι¤Τʤɡ
 * 
 * Ϣdef_use, data_dependence2ŤϿХб뤿ν
 * !! Ūˡ⤷ʤ
 */

/* 
 * ϢϿХåեΥ
 * ĤΥȥåץ٥뼰ФơREL_SET_MAXĤϢʤ
 */
/* #define REL_SET_MAX 200 *//* Modified by S.Yamamoto 2002/07/09. */
#define REL_SET_MAX     600

/* def_used δϢǴˤĤäȤ򵭲뤿ι¤ */

typedef struct _defUsedNode {
    SpdObjId    def;
    SpdObjId    used;
} defUsedNode;

/* data_dependence δϢǴˤĤäȤ򵭲뤿ι¤ */

typedef struct _defUsedSet {
    int         size;
    struct _defUsedNode *array;
} defUsedSet;

typedef struct _dataDependenceNode {
    SpdObjId    def;
    SpdObjId    ref;
} dataDependenceNode;

typedef struct _dataDependenceSet {
    int         size;
    struct _dataDependenceNode *array;
} dataDependenceSet;

/* ѿȤѰ  */
static defUsedSet        DUSet;
static dataDependenceSet DDSet;

static SpdBoolean searchDUSet(SpdObjId def, SpdObjId used)
{
    int i;

    for (i = 0; i < DUSet.size; i++) {
        if (DUSet.array[i].def == def &&
            DUSet.array[i].used == used) {
            return TRUE;                    /* Ͽ */
        }
    }
    return FALSE;                           /* ̤Ͽ */
}

static SpdBoolean searchDDSet(SpdObjId def, SpdObjId ref)
{
    int i;

    for (i = 0; i < DDSet.size; i++) {
        if (DDSet.array[i].def == def &&
            DDSet.array[i].ref == ref) {
            return TRUE;                    /* Ͽ */
        }
    }
    return FALSE;                           /* ̤Ͽ */
}

/* ޤǽʣϿѤΥץ */

/******************************************************************************/

/* ǥХåѴؿ */

void printReach2(bitVector *reach)
{
    int i;
    subExprListNode *curNode;

    curNode = getSLHead();
    i = 0;
    while (curNode != NULL) {
        if (chkBitVector(reach, i) == TRUE) {
            fprintf(stderr, "   #  reach(%d): %d\n", i, curNode->objId);
        }
        curNode = curNode->next;
        i++;
    }
}

static SpdBoolean isRightValue(SpdObjId exprId)
{
    SpdObjId identId;
    int lrtype;

    lrtype = spdGetAttrValInt(exprId, "lrtype");
    if (lrtype == EXPR_L_VALUE) {
        return FALSE;
    }
    /* ¤ΥФ򤱤롥 */
    identId = spdGetARelObj(exprId, "ident_ref", "expression_id");
    if (spdGetAttrValInt(identId, "sort") == ID_MEMBER) {
        return FALSE;
    }
    return TRUE;
}

/* 
 * exprId ʬid
 * curDefObjId Ƽid
 * reach ʬؤreach
 */

static void createRelDefUsed(SpdObjId exprId, SpdObjId curDefObjId)
{
    SpdRelId relId;
    /* identId ǤʤΤϡdef_usedĥʤƤɤ */

    /* ʣϿåɤ */
    if (searchDUSet(curDefObjId, exprId) == TRUE) {
        /* fprintf(stderr, "Jyuufuku Touroku : DU %d -> %d\n",
           curDefObjId, exprId); */
        return;
    }

    /* defΤuse״ط */
    if (curDefObjId != SPD_NON_ID) {
        relId = spdCreateObj(SPD_RID_DEF_USED, SPD_NON_ID);
        spdSetAttrIntValByName(relId, "defObjId", curDefObjId);
        spdSetAttrIntValByName(relId, "usedExprId", exprId);

        if (debugPrintFlag) {
            fprintf(stderr, "def_used: defObjId %d --> usedExprId %d\n",
                    curDefObjId, exprId);
        }

        /* ʣϿϿ */
        DUSet.array[DUSet.size].def  = curDefObjId;
        DUSet.array[DUSet.size].used = exprId;
        DUSet.size++;
        if (DUSet.size == REL_SET_MAX) {
            spdErrorExit("DUSet overflow.\n");
        }
    }
}

/* !! : ΤȤcurDefObjIdϴؿǻѤƤʤ */

static void createRelDataDependence(SpdObjId exprId, SpdObjId curDefObjId,
                                    bitVector *reach)
{
    int i;
    SpdObjId identId;
    SpdRelId relId;
    SpdBoolean withPtrFlag, defUnkownAreaFlag;
    subExprListNode *curNode;

    getExprInfo(exprId, &identId, &withPtrFlag, &defUnkownAreaFlag);

    /* ǡ¸ط */
    curNode = getSLHead();
    i = 0;
    while (curNode != NULL) {
        if (chkBitVector(reach, i) == TRUE) {
            /* ̾ȽǤݥ */
            if (curNode->identId == identId &&
                curNode->withPtrFlag == withPtrFlag) {

                /* ʣϿåɤ */
                if (searchDDSet(curNode->objId, exprId) == TRUE) {
                    /* fprintf(stderr, "Jyuufuku Touroku : DD %d -> %d\n",
                       curNode->objId, exprId); */
                    curNode = curNode->next;
                    i++;
                    continue;
                }

                relId = spdCreateObj(SPD_RID_DATA_DEPENDENCE, SPD_NON_ID);
                spdSetAttrIntValByName(relId, "defObjId", curNode->objId);
                spdSetAttrIntValByName(relId, "refExprId", exprId);

                if (debugPrintFlag) {
                    fprintf(stderr, "data_dependence: defObjId %d --> refExprId %d\n",
                            curNode->objId, exprId);
                }

                /* ʣϿϿ */
                DDSet.array[DDSet.size].def = curNode->objId;
                DDSet.array[DDSet.size].ref = exprId;
                DDSet.size++;
                if (DDSet.size == REL_SET_MAX) {
                    spdErrorExit("DDSet overflow.\n");
                }
            }
        }
        curNode = curNode->next;
        i++;
    }
}

static void calcLocalReach(SpdObjId exprId, bitVector *localNewReach)
{
    bitVector *def, *kill, *tempReach;
  
    def = createBitVector();
    kill = createBitVector();
    tempReach = createBitVector();
    setSubExprDefAndKill(exprId, def, kill);
    copyBitVector(tempReach, kill);
    notBitVector(tempReach);
    andBitVector(tempReach, localNewReach);
    orBitVector(tempReach, def);
    copyBitVector(localNewReach, tempReach); /*  */
    spdFree(def);
    spdFree(kill);
    spdFree(tempReach);
}

/* declarator ϽФʤ */

static void setSubExprDefAndKill(SpdObjId exprId,
                                 bitVector *def, bitVector *kill)
{
    int i;
    subExprListNode *curNode, *targetNode;
    SpdObjId keyIdentId;
    /* SpdBoolean keyWithPtrFlag; */

    /* def򥻥å */
    setBitVector(def, searchSLNodeNumber(exprId));

    /* kill򥻥å */
    /* !! äΤˤ */
    targetNode = searchSLNode(exprId);
    keyIdentId = targetNode->identId;
    /* keyWithPtrFlag = targetNode->withPtrFlag; */
    /* withPtrFlag FALSEλΤkillΤǡ
     *  withPtrFlagȽˤϻѤʤ
     */
    curNode = getSLHead();
    i = 0;
    while (curNode != NULL) {
        if (curNode->objId != exprId &&
            curNode->identId == keyIdentId &&
            curNode->withPtrFlag == FALSE) {
            setBitVector(kill, i);
        }
        curNode = curNode->next;
        i++;
    }
}

static void skipDefedExpr(SpdObjId exprId, SpdObjId curDefObjId,
                          bitVector *localReach, bitVector *localNewReach)
{
    int i;
    SpdObjId opId, cExprId;
    SpdRelArray exprBuf;
    SpdBoolean skipIsSuccess = FALSE;

    cExprId = skipParAndDot(exprId, NULL);

    opId = spdGetARelObj(cExprId, "expr_op", "expression_id");
    /* ݥ󥿤ѤƤʤ硥 */
    if (opId == SPD_NON_ID) {
        return;
    }
    switch (spdGetAttrValInt(opId, "sort")) {
      case OP_POINTER:
      case OP_ARROW:
      case OP_L_ARRAY:
      case OP_R_ARRAY:
        skipIsSuccess = TRUE;               /* ̤ */
        break;
      default:
        fprintf(stderr, "skipDefExpr error %d\n", spdGetAttrValInt(opId, "sort"));
        spdWarning("skipDefedExpr\n");
    }
  
    /* λʣʬФ롥 */
    exprBuf = spdGetRelSortedArray(exprId, "expr_expr", "outer_expression_id",
                                   NULL, spdCompareRelOffset);
    for (i = 0; i < exprBuf.size; i++) {
        calcExpr(exprBuf.rel[0].objectId, curDefObjId,
                 localReach, localNewReach);    
    }
    spdFreeRelArray(exprBuf);
}

static void calcExpr(SpdObjId exprId, SpdObjId curDefObjId,
                     bitVector *localReach, bitVector *localNewReach)
{
    int i;
    bitVector *localNewReachCopy;
    SpdRelArray exprBuf;
    SpdObjId opId;
    SpdBoolean controlFlag = FALSE, branchFlag = FALSE;
    SpdBoolean firstSubExprIsDefedExpr = FALSE;

    opId = spdGetARelObj(exprId, "expr_op", "expression_id");
    if (opId == SPD_NON_ID) {
        int     sort;

        sort = spdGetAttrValInt(exprId, "sort");
        if (sort != EXPR_RETURN && sort != EXPR_SORT_FUNCCALL) {

            /* ¦expressin */
            /* exprͤȽ̤롥 */
            if (isRightValue(exprId) == TRUE &&
                spdGetARelObj(exprId, "const_ref", "expression_id") == SPD_NON_ID) {
                createRelDefUsed(exprId, curDefObjId);
                createRelDataDependence(exprId, curDefObjId, localReach);
            }
            return;
        }
    } else {
        switch (spdGetAttrValInt(opId, "sort")) {
            /* &&, || */
          case OP_L_AND:
          case OP_L_OR:
          case OP_COMMA:
            controlFlag = TRUE;
            break;
            /* ? : */
          case OP_QUESTION:
          case OP_COLON:
            controlFlag = TRUE;
            branchFlag = TRUE;
            break;
            /* withPtr */
          case OP_POINTER:
          case OP_ARROW:
            /* case OP_DOT: */ /* 롼 */
          case OP_L_ARRAY:
          case OP_R_ARRAY:
            createRelDefUsed(exprId, curDefObjId);
            createRelDataDependence(exprId, curDefObjId, localReach);
            break;
            /* ͤ뼰 */
          case OP_ASSIGN:
            firstSubExprIsDefedExpr = TRUE;
          case OP_A_ADD:
          case OP_A_SUB:
          case OP_A_MUL:
          case OP_A_DIV:
          case OP_A_MOD:
          case OP_A_AND:
          case OP_A_XOR:
          case OP_A_OR:
          case OP_A_SHL:
          case OP_A_SHR:
          case OP_INC:
          case OP_DEC:
            createRelDefUsed(exprId, curDefObjId); /* test */
            /* REACH׻ */
            calcLocalReach(exprId, localNewReach);
            curDefObjId = exprId;
            break;
          case OP_ADDRESS:
            /* ѿΥɥ쥹λ */
            /* puts("address"); */
            return;
            break;
          default:
            break;
        }
    }

    exprBuf = spdGetRelSortedArray(exprId, "expr_expr", "outer_expression_id",
                                   NULL, spdCompareRelOffset);
    for (i = 0; i < exprBuf.size; i++) {
        if (i == 1 && branchFlag == TRUE) {
            localNewReachCopy = createBitVector();
            copyBitVector(localNewReachCopy, localNewReach);
        } else if (i == 2 && branchFlag == TRUE) {
            copyBitVector(localNewReach, localNewReachCopy);
        }
        if (i >= 1 && controlFlag == TRUE) {
            copyBitVector(localReach, localNewReach);
        }
    
        if (i == 0 && firstSubExprIsDefedExpr == TRUE) {
            skipDefedExpr(exprBuf.rel[i].objectId, curDefObjId,
                          localReach, localNewReach);
      
        } else {
            calcExpr(exprBuf.rel[i].objectId, curDefObjId,
                     localReach, localNewReach);
        }
        /*
         * fprintf(stderr, "exprId %d %d\n", exprId, i);
         * puts("localReach");
         * printReach2(localReach);
         * puts("localNewReach");
         * printReach2(localNewReach);
         */
    }

    if (branchFlag == TRUE) {
        spdFree(localNewReachCopy);
    }
    spdFreeRelArray(exprBuf);
}

/*
 * expression  declaration 롥
 * ѤƤѿդơȤDDδϢϤ롥
 */

static void calcTopLevelObj(SpdObjId objId)
{
    topLevelListNode *node;
    bitVector *reach, *newReach;

    if (spdGetClassId(objId) == SPD_CID_EXPRESSION) {
        reach = createBitVector();
        newReach = createBitVector();
        if ((node = searchTLLNode(objId)) == NULL) {
            /* ꥹȤϿƤʤä硢顼 */
            spdErrorExit("calcTopLevelObj(): %d: Invalid objId.\n", objId);
        }
        copyBitVector(reach, node->reach);
        copyBitVector(newReach, node->reach);
        calcExpr(objId, SPD_NON_ID, reach, newReach);
        spdFree(reach);
        spdFree(newReach);
    } else if (spdGetClassId(objId) == SPD_CID_DECLARATION) {
        int i;
        SpdRelArray decrBuf;
    
        decrBuf = spdGetRelSortedArray(objId, "decl_decl", "declaration_id",
                                       NULL, spdCompareRelOffset);
        for (i = 0; i < decrBuf.size; i++) {
            SpdObjId decrId, optId;

            decrId = decrBuf.rel[i].objectId;
            optId = spdGetARelObj(decrId, "decl_opt", "declarator_id");
            if (optId  == SPD_NON_ID) {
                continue;
            }
            /* դdeclarator */
            /* Ĵ٤롥 */
            reach = createBitVector();
            newReach = createBitVector();
            node = searchTLLNode(objId);
            copyBitVector(reach, node->reach);
            copyBitVector(newReach, node->reach);
            calcExpr(spdGetARelObj(optId, "init_expr", "optionaldecl_id"),
                     decrId,
                     reach, newReach);
            spdFree(reach);
            spdFree(newReach);
        }
        spdFreeRelArray(decrBuf);
    }
}

void calcDD(void)
{
    topLevelListNode *curNode;

    /* ΰ */
    DUSet.array = spdMalloc(sizeof(defUsedNode) * REL_SET_MAX);
    DDSet.array = spdMalloc(sizeof(dataDependenceNode) * REL_SET_MAX);

    curNode = getTLLHead();
    while (curNode != NULL) {
        /* fprintf(stderr, "calcDD():curNode->objId %d\n", curNode->objId); */
        DUSet.size = 0;
        DDSet.size = 0;

        calcTopLevelObj(curNode->objId);
        curNode = curNode->next;
    }

    /*  */
    spdFree(DUSet.array);
    spdFree(DDSet.array);
}
