/* 
 * Program:             $RCSfile: mkDD.c,v $  $Revision: 40.8 $
 * 
 * Purpose:
 *
 * Author:              T.Saso  2001/12/11
 *                      S.Yamamoto  2001/12/11
 *
 * (C) Copyright:       T.Saso and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: mkDD.c,v 40.8 2003/05/29 04:19:36 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "mkDD.h"

static void funcTop(SpdObjId declId);
static void file2func(SpdObjId file_id);
static void prog2file(SpdObjId prog_id);
static void opt_analyze(int argc, char *argv[]);

int debugPrintFlag = 0;  /* -D ץб */
int debugPrintFlag2 = 0; /* -v ץб */

static SpdConstString program_name;

static void funcTop(SpdObjId declId)
{
    /* ȥåץ٥뼰ΥꥹȤ롥 */
    mkTLList(declId);
    /* ȥåץ٥뼰ΥꥹȤ򻲾ȤơʬΥꥹȤ롥 */
    mkSList();
    /* subExprListΥΡɤİʾ夢Reach׻롥 */
    if (getSLSize() > 0){
        /* Reach׻˻Ȥӥåȥ٥ȥ빽¤ν򤹤롥 */
        initBitVectorSize(getSLSize());
        /* DefKillᡤȥåץ٥뼰ΥꥹȤ˽񤭹ࡥ */
        setDefAndKill();
        /* Reachᡤȥåץ٥뼰ΥꥹȤ˽񤭹ࡥ */
        calcReach();
        /* printReach(); */
        calcDD();
    }
    freeSList();
    freeTLList();
}

/*
 * "file"idꡤΥեȴϢΤؿ"declaration"
 * id롥"declaration"id˴ؿfuncTop()Ƥ֡
 */

static void file2func(SpdObjId file_id)
{
    SpdCursor *decl_csr;
    SpdObjId  decl_id;

    decl_csr = spdGetRelObjInit(file_id, "file_decl", "file_id");
    while ((decl_id = spdGetRelObj(decl_csr)) != SPD_NON_ID) {
        if (spdGetAttrValInt(decl_id, "sort") == DECL_FUNCDEF) {
            if (debugPrintFlag) {
                SpdObjId funcDecr_id, funcName_id;

                /* ؿ̾ɽ */
                funcDecr_id = spdGetARelObj(decl_id,
                                            "decl_decl", "declaration_id");
                funcName_id = spdGetARelObj(funcDecr_id,
                                            "decl_ident", "declarator_id");
                fprintf(stderr, "function name : %s\n",
                        spdGetName(funcName_id));
            }
            funcTop(decl_id);
        }
    }
    spdFreeCursor(decl_csr);
    return;
}

/* 
 * "program"idꡤΥץȴϢΤ"file"id롥
 * ơ"file"id˴ؿfile2func()Ƥ֡
 */

static void prog2file(SpdObjId prog_id)
{
    SpdCursor *file_csr;
    SpdObjId  file_id;
    
    /* "prog_file"δϢ򤿤ɤ롥 */
    file_csr = spdGetRelObjInit(prog_id, "prog_file", "program_id");
    while ((file_id = spdGetRelObj(file_csr)) != SPD_NON_ID) {
        if (debugPrintFlag){
            fprintf(stderr, "file name : %s\n", spdGetName(file_id));
        }
        file2func(file_id);
    }
    spdFreeCursor(file_csr);
    return;
}

static void opt_analyze(int argc, char *argv[])
{
    char c;

    while ((c = getopt(argc, argv, "d:Dv")) != EOF) {
        switch (c) {
          case 'd':
            /* Directory for SDB. */
            spdSetSDBdir(optarg);
            break;
          case 'D':
            /* debug: äϢɽ롥 */
            debugPrintFlag = 1;
            break;
          case 'v':
            /* verbose: ¿ξɽ롥 */
            debugPrintFlag2 = 1;
            break;
          default:
            spdErrorExit("'%c': Invalid option.\n", c);
            break;
        }
    }
}

int main(int argc, char *argv[])
{   
    SpdModelId  i_id, fv_id;
    SpdDBId     sdb_id;

    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);
    opt_analyze(argc, argv);

    i_id = spdUseModel(&I_model);
    fv_id = spdUseModel(&Flow_view);
    sdb_id = spdOpenSDB();
    spdReadDB(i_id, sdb_id);
    if (spdReadDB(fv_id, sdb_id) == SAPID_ERR_CANT_OPEN_SDB) {
        spdErrorExit("Can't open FlowVkew(Control Flow) database.\n");
    }
    prog2file(spdGetAnObjId("program", NULL));
    spdMessage("Writing FlowView database.\n");
    spdCommitDB(fv_id, sdb_id);
    spdCloseSDB(sdb_id);
    return (EXIT_SUCCESS);
}
