/* 
 * Program:             $RCSfile: mkDD.h,v $  $Revision: 40.5 $
 * 
 * Purpose:
 *
 * Author:              T.Saso  2001/12/11
 *                      S.Yamamoto  2001/12/11
 *
 * (C) Copyright:       T.Saso and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef _SPD_MKDD_H
#define _SPD_MKDD_H

typedef int bitVector;

typedef struct _topLevelListNode {
    SpdObjId    objId;
    bitVector   *def;
    bitVector   *kill;
    bitVector   *reach;
    struct _topLevelListNode *next;
} topLevelListNode;

typedef struct _subExprListNode {
    SpdObjId    objId;
    SpdObjId    identId;
    SpdBoolean  withPtrFlag;
    SpdBoolean  defUnkownAreaFlag;
    SpdBoolean  killFlag;
    SpdObjId    topLevelObjId;
    struct _subExprListNode *next;
} subExprListNode;

/* "calcReach.c"˸Ū */

typedef struct _preObjListNode {
    SpdObjId    objId;
    struct _preObjListNode *next;
} preObjListNode;

/* Ѥؿ */

/* mkDD.c */

/* FVapi.c */
SpdObjId getFVNode(SpdObjId blkId, SpdId classId);

/* mkList.c */
topLevelListNode *getTLLHead(void);
topLevelListNode *searchTLLNode(SpdObjId objId);
int getTLLSize(void);
void freeTLList(void);
void mkTLList(SpdObjId declId);

/* mkSubList.c */
subExprListNode *getSLHead(void);
subExprListNode *searchSLNode(SpdObjId objId);
int searchSLNodeNumber(SpdObjId objId);
int getSLSize(void);
void freeSList(void);
SpdObjId skipParAndDot(SpdObjId exprId, SpdBoolean *killFlag);
SpdBoolean getExprInfo(SpdObjId exprId, SpdObjId *identId,
                       SpdBoolean *withPtrFlag,
                       SpdBoolean *defUnkownAreaFlag);
void mkSList(void);

/* bitVector.c */
void initBitVectorSize(int size);
bitVector *createBitVector(void);
void setBitVector(bitVector *bv, int n);
void clrBitVector(bitVector *bv, int n);
SpdBoolean chkBitVector(bitVector *bv, int n);
void andBitVector(bitVector *d, bitVector *s);
void orBitVector(bitVector *d, bitVector *s);
void xorBitVector(bitVector *d, bitVector *s);
void notBitVector(bitVector *d);
void copyBitVector(bitVector *d, bitVector *s);
void resetBitVector(bitVector *d);
SpdBoolean isEqualBitVector(bitVector *a, bitVector *b);

/* setDefKill.c */
void setDefAndKill(void);

/* calcReach.c */
void printReach(void);
void calcReach(void);

/* calcDD.c */
void printReach2(bitVector *reach);
void calcDD(void);

#endif /* _SPD_MKDD_H */
