/* 
 * Program:             $RCSfile: setDefKill.c,v $  $Revision: 40.10 $
 * 
 * Purpose:
 *
 * Author:              T.Saso  2001/12/11
 *                      S.Yamamoto  2001/12/11
 *
 * (C) Copyright:       T.Saso and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: setDefKill.c,v 40.10 2002/07/09 12:13:41 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "mkDD.h"

static void setDef(topLevelListNode *tLLNode);
static void setKill(topLevelListNode *tLLNode);

extern int debugPrintFlag;
extern int debugPrintFlag2;

static void setDef(topLevelListNode *tLLNode)
{
    int i = 0;
    subExprListNode *curNode;

    curNode = getSLHead();
    while (curNode != NULL) {
        if (curNode->topLevelObjId == tLLNode->objId) {
            setBitVector(tLLNode->def, i);
        }
        curNode = curNode->next;
        i++;
    }
}

#ifdef NOT_USED

static SpdBoolean isDefAddressExpr(subExprListNode *sLNode)
{
    SpdObjId typeId;

    if (sLNode->withPtrFlag == FALSE) {
        typeId = spdGetARelObj(sLNode->identId, "ident_type", "identifier_id");
        if (spdGetAttrValInt(typeId, "sort") == TYPE_POINTER) {
            return TRUE;
        }
    }
    return FALSE;
}

#endif /* NOT_USED */

static void setKill(topLevelListNode *tLLNode)
{
    int i;
    subExprListNode *curNode1, *curNode2;
    SpdObjId keyIdentId;
    /* SpdBoolean keyWithPtrFlag; */

    /* ¦Υ롼פϡtLLNodeDefƤidentifierĴ٤Ƥ롥 */
    curNode1 = getSLHead();
    while (curNode1 != NULL) {
        if (curNode1->defUnkownAreaFlag == FALSE &&
            curNode1->topLevelObjId == tLLNode->objId &&
            curNode1->killFlag == TRUE) {
            /* ¦Υ롼פϡtLLNodeDefƤΤƱidentifierDef
               ƤʬKillνƤ롥 */
            keyIdentId = curNode1->identId;
            /* keyWithPtrFlag = curNode1->withPtrFlag; */ 
            /* withPtrFlag Ƚ˻Ѥʤ */

            curNode2 = getSLHead();
            i = 0;
            while (curNode2 != NULL) {
                if (curNode2->topLevelObjId != tLLNode->objId &&
                    curNode2->identId == keyIdentId &&
                    curNode2->withPtrFlag == FALSE) { 
                    /* withPtrFlag == TRUE ξ Kill ʤƤ褤*/

                    setBitVector(tLLNode->kill, i);
                    /* fprintf(stderr, "   kill %d\n", curNode2->objId); */
                }
                curNode2 = curNode2->next;
                i++;
            }
        } else if (curNode1->defUnkownAreaFlag == TRUE) {

#ifdef COMMENTED
            /* 
             *  Subject: Re:
             *  Date:    Sun, 26 May 2002 21:13:18 +0900
             *  From:    saso <ccz60720@hkg.odn.ne.jp>
             *  To:      yamamoto@ist.aichi-pu.ac.jp
             * 
             * μǤϡ
             *     **p = 10;
             * Ȥ褦ˡɥ쥹ǤʤΰФ
             * ƤϡͤʬꥹȡפγƥΡɤĥե饰
             * (defUnkownAreaFlag)TRUEˤƤޤ(­: *p = 10 Ȥ
             * ϡpλؤΰȤȤǥɥ쥹ǤΰȤߤʤ
             * ޤ)ǡȥȤƤʬͭˤȡ
             * äɥ쥹Ǥʤΰؤ̤äѥǤϡ
             * ɤͤ񤭴뤫Ƚ̤Ǥʤᡤ٤Ƥμ̵ˤ
             * Ȥ򤷤Ƥ(Ϥ)Ǥ
             * 
             * ȥȤƤտޤǤʬͭˤΤϾ
             * 郎ȻפäȤȡʬΥƥȤ򤢤ޤꤷ
             * ƤʤäȤꡤνͭˤϤʤ
             * ä񤤤ΤǥȥȤƻĤƤĤȤ
             * äȻפޤͭˤʤƤ⡤åŤʤ
             * ưˤʤϤǤȥƥȤǤ顤ư
             * ǤΡϥ٥Ĵ˻Ȥ뤫⤷ޤ
             */
            curNode2 = getSLHead();
            i = 0;
            while (curNode2 != NULL) {
                /* ƱƤ°ʬʳ٤ƤKill롥*/
                if (curNode2->topLevelObjId != tLLNode->objId) {
                    setBitVector(tLLNode->kill, i);
                }
                curNode2 = curNode2->next;
                i++;
            }
#endif /* COMMENTED */

        } 
        curNode1 = curNode1->next;
    }
}

void setDefAndKill(void)
{
    topLevelListNode *curNode;

    /* ȥåץ٥뼰ΥΡɤ1ĤĸƤ*/
    curNode = getTLLHead();
    while (curNode != NULL) {
        /* fprintf(stderr, "setDefAndKill():curNode->objId %d\n",
           curNode->objId); */

        /* ǡΡɤȤΥӥåȥ٥ȥΰݤ롥 */
        curNode->def = (bitVector *)createBitVector();
        curNode->kill = (bitVector *)createBitVector();
        curNode->reach = (bitVector *)createBitVector(); /* reach */

        /* fprintf(stderr, "def mae %d\n", curNode->def[0]); */
        /* Def 򥻥å */
        setDef(curNode);
        /* fprintf(stderr, "def ato %d\n", curNode->def[0]); */

        /* fprintf(stderr, "kill mae %d\n", curNode->kill[0]); */
        /* kill 򥻥å */
        setKill(curNode);
        /* fprintf(stderr, "kill ato %d\n", curNode->kill[0]); */

        curNode = curNode->next;
    }
}
