/* 
 * Program:             $RCSfile: include.c,v $  $Revision: 30.13 $
 * 
 * Purpose:
 * 
 * Author:              T.Hidaka  1998/12/01
 *                      S.Yamamoto  1999/01/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: include.c,v 30.13 2003/07/20 11:46:08 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "mkPmodel.h"

/* #include ν */

/*  hfile, incld_hfile,  */

static int getIncludeArg(FileBuffer *fb, MyCursor *csr, SpdObjId pblockId)
{
    int         c, i;
    int         sort;
    int         offset;
    SpdObjId    hfileId;
    SpdRelId    relId;
    /* char *filename; */
    static char tmp[FILENAME_MAX + 1];  

    hfileId = spdCreatePmodelObj(SPD_CID_HFILE);
    relId = spdCreatePmodelRel(SPD_RID_INCLD_HFILE, pblockId, hfileId);
    spdSetAttrIntValByName(relId, "offset", csr->current.offset);

    offset = csr->current.offset;
    
    c = nextChar(fb, csr);
    switch (c) {
      case '<':
        sort = HFILE_ANGLE;
        break;
      case '"':
        sort = HFILE_DQUOT;
        break;
      default:
        return -1;
    }
    
    /* filename = spdMalloc(1); */
    i = 0;
    while ((c = nextChar(fb, csr)) != '\0') {
        if ((sort == HFILE_ANGLE && c == '>') || 
            (sort == HFILE_DQUOT && c == '"'))
            break;
        /* filename = spdRealloc(filename, i + 2); */
        /* filename[i] = c; */
        /* i++; */
        tmp[i++] = c;
    }
    /* filename[i] = '\0'; */
    tmp[i] = '\0';
    
    spdSetAttrIntValByName(hfileId, "sort", sort);
    spdSetAttrIntValByName(hfileId, "length", csr->current.offset - offset);
    /* spdSetAttrStrValByName(hfileId, "name", filename); */
    /* spdFree(filename); */
    spdSetAttrStrValByName(hfileId, "name", tmp);
    
    return hfileId;
}

int parseIncludeDirective(CFileBuffer *cFileBuf, IFileBuffer *iFileBuf, 
                          MyCursor *paramcsr, SpdObjId pblockId)
{
    SpdObjId    hfileId, pfileId;
    int         lineno;

    if (verbose) {
        spdMessage("%s(%d): Analyzing include directive.\n",
                   cFileBuf->lineInfo.filename, cFileBuf->csr.current.lineno);
    }

    /* hfile, incld_hfile  */
    hfileId = getIncludeArg(&(cFileBuf->fb), paramcsr, pblockId);
    
    /* ŸƤʤСɤФ줿 #include  */
    if (isSkipedLine(cFileBuf, iFileBuf)) {
        if (verbose) {
            spdMessage("skiped include directive.\n");
        }

        return 0;
    }

    /* 󥯥롼ɤ줿եˤĤƽ(Ƶ) */
    pfileId = makePmodelOfCFile(iFileBuf);

    if (verbose) {
        spdMessage("%s(%d): Analyzing of include is end.\n",
                   cFileBuf->lineInfo.filename, cFileBuf->csr.current.lineno);
    }
    
    /* hfile_file  */
    spdCreatePmodelRel(SPD_RID_HFILE_FILE, hfileId, pfileId);
    
    /* # directive (leave-directive)å */
    if (checkLeaveSharpDirective(iFileBuf, cFileBuf->lineInfo.filename, 
                                 &lineno) == FALSE) {
        spdErrorExit("At %s(%d), # line after include has wrong "
                     "filename or lineno\n",
                     iFileBuf->fb.filename, iFileBuf->csr.top.lineno);
    }

    getNextMacroCall(cFileBuf, iFileBuf);
    
    return lineno - cFileBuf->csr.top.lineno - cFileBuf->lineInfo.loffset;
}
