/* 
 * Program:             $RCSfile: index.c,v $  $Revision: 30.4 $
 * 
 * Purpose:
 * 
 * Author:              T.Hidaka  1998/12/01
 *                      S.Yamamoto  1999/01/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 1999
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: index.c,v 30.4 2002/10/21 07:26:47 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "mkPmodel.h"

static SpdSet macroIndex = NULL;

void freeMacroIndex(void)
{
    if (macroIndex)
        spdFreeSet(macroIndex);

    macroIndex = NULL;
}

void createMacroIndex(void)
{
    static int atexitflag = FALSE;

    if (atexitflag == FALSE) {
        atexit(freeMacroIndex);
        atexitflag = TRUE;
    }
    macroIndex = spdCreateSet(sizeof(SpdObjId));
}

void addMacroIndex(int id, SpdObjId macroNameId)
{
    if (macroIndex == NULL) {
        createMacroIndex();
    }
    if (verbose)
        spdMessage("addMacroIndex: macID:%d -> macroNameId:%d\n", 
                   id, macroNameId);
    spdAddElem(macroIndex, id, &macroNameId);
}

SpdObjId searchMacroIndex(int id)
{
    SpdObjId *pObjId;

    if (macroIndex) {
        pObjId = spdSearchElem(macroIndex, id);
        if (pObjId)
            return *pObjId;
    }

    return SPD_NON_ID;
}
