/* 
 * Program:             $RCSfile: mkPmodel.h,v $  $Revision: 30.18 $
 * 
 * Purpose:
 * 
 * Author:              T.Hidaka  1998/12/01
 *                      S.Yamamoto  1999/01/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#define PBLOCK_UNKNOWN  (-1)
#define PBLOCK_EOF      (-2)

/* !!  */
/* 
 * ȡĹʤSPD_ID_LEN򡤹ԤĹʤSPD_LINE_LEN"Sapid.h"
 * ѰդƤΤạ̇̄äƤΤʤȤäƲ
 * TOKENĹ2048礭᤮Τǡɤ餫ȤLINEΤۤ?
 * Ȥ⡤ޥɬפbuffer礭? "PIDB.h"STRLEN_MAXȤ
 * Υޥޤ
 */

#define MAX_TOKEN_LEN   2048

typedef struct blockinfo_t {
    int sort;               /* block μ */
    int length;             /* Ĺ(byte) */
    int offset;             /* offset */
} BlockInfo;

typedef struct foffset_t {
    int offset;             /* offset */
    int lineno;             /* ֹ */
} FOffset;

typedef struct MyCursorTag {
    FOffset top;
    FOffset current;
    FOffset next;
} MyCursor;

typedef struct filebuffer_t {
    SpdObjId fileId;        /* եΥ֥ID(file饹) */
    char *filename;         /* ե̾ */
    unsigned char *buf;              /* ե */
    int size;               /* եΥ */
} FileBuffer;

typedef struct ifilebuffer_t {
    FileBuffer fb;
    MyCursor csr;
    struct skipinfo_t {
        int cloffset;       /* ߤιԤбϤ .c ιֹȤκʬ */
        int lineno;         /* .i  # Ԥˤäƻꤵ줿 .c ιֹ */
        char *filename;
        SpdBoolean fpadding;/* .c.iŸԿ㤦Υѥǥ󥰤åե饰 */
    } skip;
    int mExpId;                /* ѤΥޥƤӽФ ID */
    int ifexprId;
} IFileBuffer;

typedef struct ifstack_t {
    struct ifstack_t *next;
    SpdBoolean ifexpr;
    SpdBoolean expanded;
} IFStack;

typedef struct cfilebuffer_t {
    FileBuffer fb;
    MyCursor csr;
    BlockInfo currentBlock;
    BlockInfo nextBlock;
    struct linedirectiveinfo_t {
        char *filename;         /* #line Ԥ ե̾ */
        int loffset;            /* ߤ .c Ȥιֹκ */
    } lineInfo;
    struct cmcallinfo_t {
        int id;                 /* ΥޥƤӽФ ID */
        int clength;            /* .c ǤĹ(byte) */
        int coffset;            /* .c Ǥoffset */
        int ilength;            /* .i ǤĹ(byte) */
        int ioffset;            /* .i Ǥoffset */
    } nextMcall;
    IFStack ifstack;
} CFileBuffer;

typedef struct {
    char str[MAX_TOKEN_LEN + 1];
    int offset, length;
    SpdObjId objId;
} PPRegion;

#define USE_MACROBODY_HASH

/* file.c */
SpdObjId makePmodelOfCFile(IFileBuffer *iFileBuf);
void makePmodelOfIFile(SpdObjId iFileId);

/* filebuf.c */
int skipPhisicalLine(const FileBuffer *fb, MyCursor *csr, int n);
int skipLogicalLine(const FileBuffer *fb, MyCursor *csr, int n);
int isEndOfFile(const FileBuffer *fb, const MyCursor *csr);
int readFileBuffer(FileBuffer *fb, SpdObjId fileId);
void freeFileBuffer(FileBuffer *fb);
MyCursor initCursor(const FileBuffer *fb);
int peekChar(const FileBuffer *fb, const MyCursor *csr);
int nextChar(const FileBuffer *fb, MyCursor *csr);
int skipSpace(const FileBuffer *fb, MyCursor *csr);
int skipComment(const FileBuffer *fb, MyCursor *csr);
SpdBoolean skipSpaceOrComment(const FileBuffer *fb, MyCursor *csr);
int skipToOffset(const FileBuffer *fb, MyCursor *csr, int offset);
/* 
 * int skipToLineno(const FileBuffer *fb, MyCursor *csr, int lineno);
 */
SpdBoolean isBeginningOfLine(const FileBuffer *fb, const MyCursor *csr);
SpdBoolean isNullLine(const MyCursor *csr);
SpdBoolean isContinueLine(const FileBuffer *fb, const MyCursor *csr);

/* Added by S.Yamamoto 2000/03/24. */
int countContinueLine(const FileBuffer *fb, const MyCursor *pcsr);

/* line.c */
SpdBoolean checkEnterSharpDirective(IFileBuffer *iFileBuf,
                   char **cfilename);
SpdBoolean checkLeaveSharpDirective(IFileBuffer *iFileBuf,
                   const char *cfilename, int *line);
/* 
 * SpdBoolean checkSkipSharpDirective(IFileBuffer *iFileBuf,
 *                    char **cfilename, int *line);
 */
void parseLineDirective(CFileBuffer *cFileBuf, IFileBuffer *iFileBuf,
            MyCursor *paramcsr);
int skipILine(CFileBuffer *cFileBuf, IFileBuffer *iFileBuf, int nlines);
SpdBoolean isSkipedLine(const CFileBuffer *cFileBuf, IFileBuffer *iFileBuf);

/* block.c */
void matchBlock(CFileBuffer *cFileBuf, IFileBuffer *iFileBuf);
int matchCommentInDirective(CFileBuffer *cFileBuf, IFileBuffer *iFileBuf);

/* macrocall.c */

#if defined(USE_MACROBODY_HASH)
void initMacroBodyHash(void);
void addMacroBodyHash(SpdObjId macroNameId, SpdObjId macroBodyId);
void freeMacroBodyHash(void);
#endif

void getNextMacroCall(CFileBuffer *cFileBuf, IFileBuffer *iFileBuf);
/* 
 * SpdObjId parseMacroCall(const CFileBuffer *cFileBuf, int offset, int expId);
 */
SpdObjId matchMacroCall(CFileBuffer *cFileBuf, IFileBuffer *iFileBuf);

/* directive.c */
SpdObjId matchDirective(CFileBuffer *cFileBuf, IFileBuffer *iFileBuf);

/* define.c */
void getToken(FileBuffer *fb, MyCursor *paramcsr, PPRegion *reg);
void parseDefineDirective(CFileBuffer *cFileBuf, MyCursor *paramcsr, 
              int ioffset, SpdObjId pblockId);
void parsePreDefinedOption(void);

/* include.c */
int parseIncludeDirective(CFileBuffer *cFileBuf, IFileBuffer *iFileBuf, 
              MyCursor *paramcsr, SpdObjId pblockId);

/* object.c */
SpdObjId spdCreatePmodelObj(SpdClassId classId);
SpdObjId spdCreatePmodelRel(SpdClassId classId, 
               SpdObjId parentId, SpdObjId childId);
SpdObjId createPblock(SpdObjId fileId, int sort, int offset, int length);

/* index.c */
void createMacroIndex(void);
void freeMacroIndex(void);
void addMacroIndex(int id, SpdObjId macroNameId);
SpdObjId searchMacroIndex(int id);

/* debug.c */
void printCursor(const char *s1, const FileBuffer *fb, MyCursor csr);
void printLine(const char *s1, const FileBuffer *fb, const MyCursor *csr);

/* 
 * extern int c_option;
 */

extern int verbose;
