/* 
 * Program:             $RCSfile: object.c,v $  $Revision: 30.14 $
 * 
 * Purpose:
 * 
 * Author:              T.Hidaka  1998/12/01
 *                      S.Yamamoto  1999/01/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: object.c,v 30.14 2002/10/21 07:26:47 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "mkPmodel.h"

/*
 * Generate object id.
 */

SpdObjId spdCreatePmodelObj(SpdClassId classId)
{
    return (spdCreateObj(classId, classId));
}

SpdObjId spdCreatePmodelRel(SpdClassId classId, 
                            SpdObjId parentId, SpdObjId childId)
{
    return (spdCreateRel(classId, SPD_NON_ID, parentId, childId));
}

SpdObjId createPblock(SpdObjId pfileId, int sort, int offset, int length)
{
    SpdObjId    pblockId;
    SpdRelId    relId;

    pblockId = spdCreatePmodelObj(SPD_CID_PBLOCK);
    spdSetAttrIntValByName(pblockId, "sort", sort);
    spdSetAttrIntValByName(pblockId, "length", length);

    relId = spdCreatePmodelRel(SPD_RID_FILE_BLOCK, pfileId, pblockId);
    spdSetAttrIntValByName(relId, "offset", offset);
    if (verbose) {
        spdMessage("createPblock(): Id: %d sort %d, offset %d, length %d.\n", 
                   pblockId, sort, offset, length);
    }
    return (pblockId);
}
