/* 
 * Program:             $RCSfile: mkTypeView.c,v $  $Revision: 30.20 $
 * 
 * Purpose:             ¤Τ˴ؤӥ塼롥
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: mkTypeView.c,v 30.20 2003/07/08 06:20:26 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/Imodel.h>
#include <Sapid/ImodelARcompat.h>
#include <Sapid/TypeView.h>

static void         parse_option(int argc, char *argv[]);

/* 
 * declarationν礫顤sortoptionaldecl򸡺롥
 * ʣäȤƤ̣ƱˤʤäƤϤʤΤ1Ĥ֤
 * 
 * !! ҤǤϤʤ¹ʲ⸡ƤޤΤǡmapȤäƺƼ
 * ɬפ뤫⡥
 */

static SpdObjId findOptionalDecl(SpdIdSet decls, int sort)
{
    SetCursor csr1, csr2, csr3;
    SpdIdSet decrs, optdecls;
    SpdObjId declId, decrId, optdeclId, res = SPD_NON_ID;

    for (csr1 = spdSetCursorCreate(decls); 
         spdSetCursorNext(&csr1) && res == SPD_NON_ID;) {
        declId = spdSetGetValueO(csr1.curElem->value);
        if (spdGetClassId(declId) != SPD_CID_DECLARATION) {
            continue;
        }
        decrs = spdGetChildObjIdSet(declId, SPD_RID_DECL_DECL);
        for (csr2 = spdSetCursorCreate(decrs);
             spdSetCursorNext(&csr2) && res == SPD_NON_ID;) {
            decrId = spdSetGetValueO(csr2.curElem->value);
            optdecls = spdGetChildObjIdSet(decrId, SPD_RID_DECL_OPT);
            for (csr3 = spdSetCursorCreate(optdecls);
                 spdSetCursorNext(&csr3) && res == SPD_NON_ID;) {
                optdeclId = spdSetGetValueO(csr3.curElem->value);
                if (spdGetAttrIntValByName(optdeclId, "sort") == sort) {
                    res = optdeclId;
                    break;
                }
            }
            spdFreeSet2(optdecls);
        }
        spdFreeSet2(decrs);
    }

    return res;
}

/* ФФƥӥ塼 */

static SpdObjId makeMemberView(SpdObjId decrId)
{
    SpdObjId identId, typeId;
    SpdObjId memberId;

    identId = spdGetAChildObjId(decrId, SPD_RID_DECL_IDENT);

    if (spdGetAttrIntValByName(identId, "sort") != ID_MEMBER) {
        return SPD_NON_ID;
    }
                   
    typeId = spdGetAChildObjId(decrId, SPD_RID_DECR_TYPE);

    memberId = spdCreateObj(SPD_CID_MEMBER, SPD_NON_ID);
    
    spdCreateRel(SPD_RID_MEMBER_NAME, SPD_NON_ID,
                 memberId, identId);
    spdCreateRel(SPD_RID_MEMBER_TYPE, SPD_NON_ID,
                 memberId, typeId);

    return memberId;
}

/* ҤФƥӥ塼 */

static SpdObjId makeEnumeratorView(SpdObjId decrId)
{
    SpdObjId identId;
    SpdObjId enumeratorId;

    identId = spdGetAChildObjId(decrId, SPD_RID_DECL_IDENT);

    if (spdGetAttrIntValByName(identId, "sort") != ID_ENUMERATOR) {
        return SPD_NON_ID;
    }
                   
    enumeratorId = spdCreateObj(SPD_CID_ENUMERATOR, SPD_NON_ID);
    
    spdCreateRel(SPD_RID_ENUMERATOR_NAME, SPD_NON_ID,
                 enumeratorId, identId);

    /* !! optionaldecl ľˤͤ */

    return enumeratorId;
}

/* ¤//󷿤Фƥӥ塼롥 */

static void makeStructView(SpdObjId typeId, int sort)
{
    SpdIdSet declset;
    SpdRelArray decls, decrs;
    SpdObjId declId, decrId, optdeclId, memberId;
    SpdRelId relId;
    int i, j;
    int order;
    
    /* SORT = struct Ǥ褦 optionaldecl  */
    declset = spdGetParentObjIdSet(typeId, SPD_RID_DECL_TYPE);
    optdeclId = findOptionalDecl(declset, OPT_STRUCT);
    spdFreeSet2(declset);

    /* 
     * optinaldecl Ĥʤϥåפ롥
     * ꤨʤϤޤˤ餷
     */
    if (optdeclId == SPD_NON_ID) {
        /* Modified by S.Yamamoto 1999/01/10. */
        /* spdWarning("Can't find declaration: %d.\n", typeId); */
        spdMessage("Can't find declaration: %d.\n", typeId);
        return;
    }

    /* Ф declaration  */
    order = 0;
    decls = spdGetRelSortedArray(optdeclId, "struct_decl", "p-id",
                                 NULL, spdCompareRelOffset);
    for (i = 0; i < decls.size; i++) {
        declId = decls.rel[i].objectId;
        decrs = spdGetRelSortedArray(declId, "decl_decl", "p-id", NULL,
                                     spdCompareRelOffset);

        for (j = 0; j < decrs.size; j++) {
            decrId = decrs.rel[j].objectId;

            switch (sort) {
              case TYPE_STRUCT_TAG:
              case TYPE_UNION_TAG:
                if ((memberId = makeMemberView(decrId)) == SPD_NON_ID)
                    continue;
        
                relId = spdCreateRel(SPD_RID_STRUCT_MEMBER, 
                                     SPD_NON_ID, typeId, memberId);
                break;
              case TYPE_ENUM_SPECIFIER:
                if ((memberId = makeEnumeratorView(decrId)) == SPD_NON_ID)
                    continue;
                /* !! ͤʤ(optdeclʤ)? */
                relId = spdCreateRel(SPD_RID_ENUM_ENUMERATOR,
                                     SPD_NON_ID, typeId, memberId);
            }
            spdSetAttrIntValByName(relId, "order", order);
        
            order++;
        }
        spdFreeRelArray(decrs);
    }

    spdFreeRelArray(decls);
}

static void spdMakeTypeView(void)
{
    SpdIdSet types;
    SpdObjId typeId;
    int sort;
    SetCursor csr;

    types = spdGetClassExtentP(SPD_CID_TYPE); /* no need to free */

    /* 
     * ¤//Υ򼨤typeõ
     * ̵̾¤ΤξtypeϺ롥
     */
    for (csr = spdSetCursorCreate(types); spdSetCursorNext(&csr);) {
        typeId = spdSetGetValueO(csr.curElem->value);
        sort = spdGetAttrIntValByName(typeId, "sort");
        switch(sort) {
          case TYPE_STRUCT_TAG:
          case TYPE_UNION_TAG:
          case TYPE_ENUM_SPECIFIER:
            makeStructView(typeId, sort);
            break;
          default:
            break;
        }
    }
}

int main(int argc, char *argv[])
{
    SpdDBId     dbId;
    SpdModelId  ImodelId, TypeViewId;

    spdInitialize(spdBasename(argv[0]));
    parse_option(argc, argv);

    ImodelId = spdUseModel(&I_model);
    TypeViewId = spdUseModel(&TypeView_model);
    dbId = spdOpenSDB();
    spdReadDB(ImodelId, dbId);
    spdCreateDB(TypeViewId, dbId);

    spdMakeTypeView();

    spdCommitDB(TypeViewId, dbId);
    spdCloseSDB(dbId);
    
    return (EXIT_SUCCESS);
}

/*
 * Analyzing options.
 */

static void parse_option(int argc, char *argv[])
{
    int     ch;

    while ((ch = getopt(argc, argv, "d:")) != -1) {
        switch (ch) {
          case 'd':             /* Directory for SDB. */
            spdSetSDBdir(optarg);
            break;
          default:
            spdErrorExit("'%c': Invalid option.\n", ch);
            break;
        }
    }
}
