/* 
 * Program:             $RCSfile: newer.c,v $  $Revision: 30.7 $
 * 
 * Purpose:             Compare file status.
 * 
 * Author:              H.Ariga  1994/11/08
 *                      S.Yamamoto  1995/02/01
 * 
 * Copyright:           H.Ariga and S.Yamamoto  1994 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: newer.c,v 30.7 2003/06/14 04:03:34 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <sys/types.h>      /* For stat(). */
#include <sys/stat.h>       /* For stat(). */
#include <Sapid/Sapid.h>

static char     *usage = 
    "USAGE\n"
    "     newer file1 file2\n"
    "DESCRIPTION\n"
    "     Return 1 if file1 is newer than file2. Othrwise return 0.\n"
    "     Return -1 if input is not correct.\n"
    "WARNINGS\n"
    "     This program does not output warning for invalid arguments.\n"; 

static void print_usage(void)
{
    fputs(usage, stderr);
    exit(EXIT_FAILURE);
}

int main(int argc, char *argv[])
{
    struct stat     st1, st2;
    int             ret = -1;

    if (argc != 3) {
        print_usage();
    }

    if ((stat(argv[1], &st1) == 0) && (stat(argv[2], &st2) == 0)) {
        ret = ((st2.st_mtime < st1.st_mtime) ? 1 : 0);
    }
    spdOutputForShell("%d", ret);
    return (ret);
}
