/* 
 * Program:             $RCSfile: block_spec.c,v $  $Revision: 30.3 $
 * 
 * Purpose:             ֥å˴ؤǡ١롼
 * 
 * Author:              K.Mabuchi  1991/09/30
 *                      S.Yamamoto  1992/04/01
 * Modified:            H.Ariga  1993/07/01
 * 
 * (C) Copyright:       K.Mabuchi, H.Ariga and S.Yamamoto  1991 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: block_spec.c,v 30.3 2002/11/04 12:48:07 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

extern BO_ListP     blk_blk;
extern LO_ListP     blk_labl; 
extern int          block_level;
extern DO_ListP     blk_decl;

BOP         current_blk = NULL;
BOP         prev_blk = NULL;

/* ֥å֥Ȥɲ */
BOP insert_block(int sort,WP ptr)
{
    static int bo_num = 0;
    BOP new;

    new = (BOP)spdCalloc(sizeof(struct BlockObject),1);

    new->id = INC_ID(bo_num);
    new->sort = sort;
    new->decl_list = NULL;
    new->expr_list = NULL;
    new->blk_list = NULL;
    new->length = (ptr ? ptr->length : 0);
    new->next = bo_list;
    new->prev = NULL;
    if (bo_list != NULL) bo_list->prev = new;
    bo_list = current_blk = new;

    return new;
}

/* ֥åꥹȤɲ */
BO_ListP insert_block_list(BO_ListP list, BOP ptr_bo,WP ptr)
{
    BO_ListP new;
    extern FOP current_file;

    new = (BO_ListP)spdCalloc(sizeof(struct BlockObjectList),1);
    new->block_s = ptr_bo;
    new->source = app_source_LC(NULL,(ptr?ptr->head_point:0),current_file);
    
    new->next = list;
    new->prev = NULL;
    if (list != NULL) list->prev = new;

    return new;
}

void close_block(void)
{
    extern EO_ListP blk_expr;
    extern Point basic_blk;
    BOP tmp_block;
#ifdef   BLOCK_DEBUG
    EO_ListP tmp_expr;
#endif  
    
    if (basic_blk.flag) {
        tmp_block = (BOP)basic_blk.ptr;
        tmp_block->length
            = basic_blk.tail_point - basic_blk.head_point;
        basic_blk.flag = 0;
#ifdef   BLOCK_DEBUG
        printf("close basic id %d, %d - %d \n",tmp_block->id,
               basic_blk.head_point, basic_blk.tail_point);
#endif  
    }
    if (current_blk) {
        current_blk->expr_list = blk_expr;
        prev_blk = current_blk; 
        blk_expr = NULL;
#ifdef BLOCK_DEBUG
        printf ("blk id = %d\n",current_blk->id);
        for  (tmp_expr = current_blk->expr_list; tmp_expr ; tmp_expr=tmp_expr->next)
            printf ("\texpr id = %d\n",tmp_expr->expr->id);
#endif
        current_blk = NULL;
    }
}

void push_block(void)
{
    ++block_level;
    push_pointer((void *)blk_blk);
    push_pointer((void *)blk_labl);
    push_pointer((void *)current_blk);
    push_pointer((void *)blk_decl);
    blk_blk = NULL;
    blk_labl = NULL;
}

void pop_block(void)
{
    --block_level;
    blk_decl = (DO_ListP)pop_pointer();
    current_blk = (BOP)pop_pointer();
    blk_labl = (LO_ListP)pop_pointer();
    blk_blk = (BO_ListP)pop_pointer();
}
