/* 
 * Program:             $RCSfile: constant_spec.c,v $  $Revision: 30.5 $
 * 
 * Purpose:             ˴ؤǡ١롼
 * 
 * Author:              K.Mabuchi  1991/09/30
 *                      S.Yamamoto  1992/04/01
 * Modified:            H.Ariga  1993/07/01
 * 
 * (C) Copyright:       K.Mabuchi, H.Ariga and S.Yamamoto  1991 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: constant_spec.c,v 30.5 2003/06/22 07:26:47 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

extern SpdString sdb_null_value;

/* ץ༱̻Ҥͤõ */
/* Deleted by S.Yamamoto 1997/07/19. */
/* 
 * CSP find_constant(char *name)
 * {
 *     CSP ptr = NO_NAME;
 * 
 *     if (ptr != NO_NAME) { 
 *         for (ptr = cs_list; ptr != NULL; ptr = ptr->next)
 *             if (SPD_STREQ(ptr->name, name)) break;
 *     }
 *     return ptr;
 * }
 */

/* ֥Ȥɲ */

CSP insert_constant(char *name,int type,int length,int point,FOP file)
{
    static int cs_num = 0;
    CSP new;


    if ((new = find_enum_pos(name)) == NULL) {
        /* name ̤ */
        new = (CSP)spdCalloc(sizeof(ConstSpec),1);

        new->id = INC_ID(cs_num);
        new->type = type;
        new->length = length;
        new->const_s = NULL;

        if (name != NULL) {
            SPEC_NAME_COPY(new->name, name);
        } else {
            new->name = sdb_null_value;
        }

        new->next = cs_list;
        new->source = NULL;
        new->prev = NULL;
        if (cs_list != NULL) cs_list->prev = new;
        cs_list = new;
    }
    new->source = app_source_LC(new->source,point,file);
    return new;
}

/* ͥꥹȤɲ */

struct CS_List *insert_cs_list(struct CS_List *list, CSP cs_ptr,WP ptr)
{
    struct CS_List *new;
    extern FOP current_file;

    new = (struct CS_List *)spdCalloc(sizeof(struct CS_List),1);
    new->const_s = cs_ptr;

    new->next = list;
    new->source = (ptr ? app_source_LC(NULL,ptr->head_point,current_file) :
                   NULL);
    new->prev = NULL;
    if (list != NULL) list->prev = new;
    
    list = new;
    return list;
}

CSP app_enum_pos(WP ptr)
{
    CSP ptr_cs;
    extern int yylineno;
    extern FOP current_file;
    extern IDO_ListP ident_ref;
    
    if (!(ptr_cs = find_enum_pos(ptr->name))) {
        spdWarning("enum '%s' not defined! at line %d in %s" ,
                   ptr->name,yylineno,current_file->name);
        return (NULL);
    }

    ident_ref = insert_identifier_list(ident_ref,
                                       find_identifier_by_ptr(ptr_cs,
                                                              ID_ENUMERATOR),
                                       ptr);
    return (ptr_cs);
}
