/* 
 * Program:             $RCSfile: expression_spec.c,v $  $Revision: 30.5 $
 * 
 * Purpose:             ˴ؤǡ١롼
 * 
 * Author:              K.Mabuchi  1991/09/30
 *                      S.Yamamoto  1992/04/01
 * Modified:            H.Ariga  1993/07/01
 * 
 * (C) Copyright:       K.Mabuchi, H.Ariga and S.Yamamoto  1991 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: expression_spec.c,v 30.5 2002/11/04 12:48:07 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

extern FOP current_file;

EO_ListP expr_stack = NULL;

extern MEMS_ListP mem_ref;
extern DataListP var_ref;
extern TypeListP type_expr;
extern IDO_ListP ident_ref;

void push_expression(void)
{
    push_pointer((void *)mem_ref);
    mem_ref = NULL;
    push_pointer((void *)var_ref);
    var_ref = NULL;
    push_pointer((void *)ident_ref);
    ident_ref = NULL;
}

void pop_expression(void)
{
    ident_ref = (IDO_ListP)pop_pointer();
    var_ref = (DataListP)pop_pointer();
    mem_ref = (MEMS_ListP)pop_pointer();
}

EOP insert_expression(WP ptr)
{
    EOP         new;
    static int  eo_num = 0;
  
    new = (EOP)spdCalloc(sizeof(struct ExprObject),1);
 
    new->id = INC_ID(eo_num);
    new->length = (ptr ? ptr->length : 0);
    new->sort = EXPR_SORT_ARITH;
    new->lrtype = NON;
    new->next = eo_list;
    new->prev = (EOP)NULL;
    if (eo_list) {
        eo_list->prev = new;
    }
    eo_list = new;
    return eo_list;
}

/* Ͽ: Ĺ0, ֤ϼΥȡΰ֡ */

EOP insert_empty_expression(void)
{
    EOP         new; 

    new = insert_expression(NULL);
    new->sort = EXPR_EMPTY;
    return new;
}

EO_ListP insert_expression_list(EO_ListP list,EOP ptr,WP wp)
{
    EO_ListP    new;

    if (ptr) {
        new = (EO_ListP)spdCalloc(sizeof (struct ExprObject),1);
        new->expr = ptr;
        new->source = app_source_LC(NULL,wp->head_point,current_file);
      
        new->next = list;
        if (list) {
            list->prev = new;
        }
    } else {
        new = list;
    }
    return new;
}

void set_unary_expression(EOP expr, int op, WP opptr, WP expr1)
{
    expr->length = get_length(opptr, expr1);
    expr->expr_list =
        insert_expression_list(expr->expr_list, expr1->expr, expr1);
    expr->op_list =
        insert_operator_list(expr->op_list, find_operator(op,NULL),opptr);
}

void set_post_unary_expression(EOP expr, WP expr1, int op, WP opptr)
{
    expr->length = get_length(expr1, opptr);
    expr->expr_list =
        insert_expression_list(expr->expr_list, expr1->expr, expr1);
    expr->op_list =
        insert_operator_list(expr->op_list, find_operator(op,NULL),opptr);
}

void set_binary_expression(EOP expr,WP expr1, int op, WP opptr, WP expr2)
{
    expr->length = get_length(expr1, expr2);
    expr->expr_list =
        insert_expression_list(expr->expr_list, expr1->expr, expr1);
    expr->expr_list = 
        insert_expression_list(expr->expr_list, expr2->expr, expr2);
    expr->op_list =
        insert_operator_list(expr->op_list, find_operator(op,NULL),opptr);
}

/*
 * Ĥα黻ҤȰĤμʤ뼰˴ؤơexpression 
 * ͤ򥻥åȤ롥
 * ֥󥯥/ǥȤϽʤ op expr ν
 * ɽ뼰Τߡ
 * expression  sort ˴ؤƤ operator  sort Ƚǡ
 */

EOP make_unary_expression(WP op, WP expr)
{
    EOP tmp_expr;

    tmp_expr = insert_expression(op);
    set_unary_expression(tmp_expr, op->sort, op, expr);
    switch (op->sort) {
        /* "++", "--" ֥󥯥/ǥ */
      case OP_INC:  case OP_DEC:
        tmp_expr->sort = EXPR_SORT_ARITH;
        break;
        /* "+", "-", "~", "!" */
      case OP_PLUS: case OP_MINUS: case OP_B_NOT: case OP_NOT:
        tmp_expr->lrtype = EXPR_R_VALUE;
        tmp_expr->sort = EXPR_SORT_ARITH;
        break;
        /* "&" */
      case OP_ADDRESS:
        tmp_expr->lrtype = EXPR_P_REF;
        tmp_expr->sort = EXPR_SORT_ARITH;
        break;
        /* "*" */
      case OP_POINTER:
        tmp_expr->lrtype = EXPR_PR_VALUE;
        tmp_expr->sort = EXPR_SORT_ARITH;
        break;
        /* "sizeof" */
      case OP_SIZEOF:
        tmp_expr->lrtype = EXPR_R_VALUE;
        tmp_expr->sort = EXPR_SORT_ARITH;
        break;
        /* "BUILTIN" */
      case OP_BUILTIN:
        tmp_expr->lrtype = EXPR_R_VALUE;
        tmp_expr->sort = EXPR_SORT_ARITH;
        break;
    }
    return tmp_expr;
}

/*
 * ֥󥯥/ǥȼ˴ؤơexpression 
 * ͤ򥻥åȤ롥expr op νɽ뼰Τߡ
 */

EOP make_post_unary_expression(WP expr, WP op)
{
    EOP tmp_expr;

    tmp_expr = insert_expression(expr);
    set_post_unary_expression(tmp_expr, expr, op->sort, op);
    tmp_expr->lrtype = EXPR_R_VALUE;
    tmp_expr->sort = EXPR_SORT_ARITH;
    return tmp_expr;
}

/*
 * ĤμȰĤα黻Ҥʤ뼰˴ؤơexpression 
 * ͤ򥻥åȤ롥
 * expression  sort ˴ؤƤ operator  sort Ƚǡ
 */

EOP make_binary_expression(WP expr1, WP op, WP expr2)
{
    EOP tmp_expr;

    tmp_expr = insert_expression(expr1);
    set_binary_expression(tmp_expr, expr1, op->sort, op, expr2);
    tmp_expr->lrtype = EXPR_R_VALUE;
    switch (op->sort) {
        /* "=", "*=", "/=", "%=", "+=", "-=", "<<=", ">>=", "&=", "^=", "|=" */
      case OP_ASSIGN: case OP_A_MUL:  case OP_A_DIV:  case OP_A_MOD:
      case OP_A_ADD:  case OP_A_SUB:  case OP_A_SHL:  case OP_A_SHR:
      case OP_A_AND:  case OP_A_XOR:  case OP_A_OR:
        /* "|", "^", "&" */
      case OP_B_OR:   case OP_B_XOR:  case OP_B_AND:
        /* "==", "!=" */
      case OP_EQ:     case OP_NE:
        /* "<", "<=", ">", ">=" */
      case OP_LT:     case OP_LE:     case OP_GT:     case OP_GE:
        /* "<<", ">>" */
      case OP_SHL:    case OP_SHR:
        /* "+", "-" */
      case OP_ADD:    case OP_SUB:
        /* "*", "/", "%" */
      case OP_MUL:    case OP_DIV:    case OP_MOD:
        tmp_expr->sort = EXPR_SORT_ARITH;
        break;
        /* "||", "&&" */
      case OP_L_OR:   case OP_L_AND:
        tmp_expr->sort = EXPR_SORT_ARITH;
        break;
        /* ".", "->" */
      case OP_DOT:    case OP_ARROW:
        tmp_expr->sort = EXPR_SORT_ARITH;
        break;
        /* "," */
      case OP_COMMA:
        tmp_expr->sort = EXPR_SORT_ARITH;
        break;
    }

    return tmp_expr;
}

/*
 * for statementΤexpression list
 */

EO_ListP make_expression_list(EOP init, WP e0,
                              EOP cond, WP e1,
                              EOP succ, WP e2)
{
    EO_ListP    blk_expr = NULL;
    int         i;

    /* 
     * struct {
     *     EOP eo;
     *     WP  wp;
     * } expr[3] = {
     *     {init, e0}, {cond, e1}, {succ, e2}
     * };
     */
    struct {
        EOP     eo;
        WP      wp;
    } expr[3];

    expr[0].eo = init;
    expr[0].wp = e0;
    expr[1].eo = cond;
    expr[1].wp = e1;
    expr[2].eo = succ;
    expr[2].wp = e2;

    /* forʸinit, cond, succ3Ĥexpression鹽롥 */
    for (i = 0; i < 3; i++) {
        if (expr[i].eo == NULL) {
            expr[i].eo = insert_empty_expression();
        }
        blk_expr = insert_expression_list(blk_expr, expr[i].eo, expr[i].wp);
    }
    return blk_expr;
}
