/* 
 * Program:             $RCSfile: file_obj.c,v $  $Revision: 30.15 $
 * 
 * Purpose:             ե˴ؤǡ١롼
 * 
 * Author:              K.Mabuchi  1991/09/30
 *                      S.Yamamoto  1992/04/01
 * Modified:            H.Ariga  1993/07/01
 * 
 * (C) Copyright:       K.Mabuchi, H.Ariga and S.Yamamoto  1991 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: file_obj.c,v 30.15 2003/06/28 15:32:14 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

FOP find_file(char *name)
{
    FOP     ptr;

    for (ptr = fo_list; ptr != NULL; ptr = ptr->next) {
        if (SPD_STREQ(ptr->name, name)) {
            break;
        }
    }
    return (ptr);
}

ScopeListP insert_scope_list(ScopeListP scope_list,SCP sc)
{
    ScopeListP  new;

    new = spdCalloc(1, sizeof(struct SCOPE_List));
    new->scope = sc;
    new->next = scope_list;
    return (new);
}

ScopeListP free_scope_list(ScopeListP scope_list)
{
    ScopeListP  old = NULL;

    if (scope_list != NULL) {
        old = scope_list->next;
        spdFree(scope_list);
    }
    return (old);
}

SCP find_scope(ScopeListP scope_list, SCP sc)
{
    ScopeListP  tmp_sc;

    for (tmp_sc = scope_list; tmp_sc != NULL; tmp_sc=tmp_sc->next) {
        if (tmp_sc->scope == sc) {
            break;
        }
    }
    return (tmp_sc ? tmp_sc->scope : NULL);
}

/******************************************************************************/

/* Program object. */

POP insert_program(char *name)
{
    static int  po_num = 0;
    POP         new;

    new = spdCalloc(1, sizeof(PO));
    new->id = INC_ID(po_num);
    SPEC_NAME_COPY(new->name, name);
    new->file = NULL;
    new->next = po_list;
    /* Struct PO does not have member prev. */
    po_list = new;

    return (new);
}

/******************************************************************************/

/* File object. */

FOP insert_file(char *name)
{
    FOP         new;

#if defined(DAPID)
    static int  fo_num = 0;
#endif

    new = spdCalloc(1, sizeof(FO));

#if defined(DAPID)
    new->id = INC_ID(fo_num);
#else
    /* id ˤĤƤ pidb ˤϻ˳Ƥ줿ΤѤ롥 */
    /* new->id = INC_ID(fo_num); */
    if ((new->id = spdSearchGlobalObj("file", name)) == SPD_NON_ID) {
        spdWarning("\"%s\" is not found.\n", name);
    }
#endif

    SPEC_NAME_COPY(new->name, name);
    new->scope = spdCalloc(1, sizeof(Scope));
    new->next = fo_list;
    fo_list = new;
    return (new);
}
