/* 
 * Program:             $RCSfile: function_spec.c,v $  $Revision: 30.10 $
 * 
 * Purpose:             ؿ˴ؤǡ١롼
 * 
 * Author:              K.Mabuchi  1991/09/30
 *                      S.Yamamoto  1992/04/01
 * Modified:            H.Ariga  1993/07/01
 * 
 * (C) Copyright:       K.Mabuchi, H.Ariga and S.Yamamoto  1991 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: function_spec.c,v 30.10 2003/06/22 07:26:47 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

extern FOP  current_file;
extern struct Stack_Parm *func_parm_stack;
extern struct Stack_Func *direct_decl_stack;

/* ֥ȼ̻Ҥؿͤõ */

FSP find_function_id(int id)
{
    FSP ptr;

    for (ptr = fs_list; ptr != NULL; ptr = ptr->next)
        if (ptr->id == id) break;
    return ptr;
}

/* ץ༱̻Ҥؿͤõ */

FSP find_function(char *name)
{
    FSP ptr;

    for (ptr = fs_list; ptr != NULL; ptr = ptr->next)
        if (SPD_STREQ(ptr->name, name)) break;
    return ptr;
}

/* ؿͤɲ */

FSP insert_function(char *name,WP ptr)
{
    static int  fs_num = 0;
    FSP         new;

    if ((new = find_function(name)) == NULL) {
        new = (FSP)spdCalloc(sizeof(struct FS), 1);
        new->id = INC_ID(fs_num);
        SPEC_NAME_COPY(new->name, name);
        /* 
         * new->input = NULL;
         * new->output = NULL;
         * new->local_ds = NULL;
         * new->local_cs = NULL;
         * new->refer_to = NULL;
         */
        new->type = NULL;
        new->length = (ptr ? ptr->length : 0);
        new->next = fs_list;
        new->prev = NULL;
        if (fs_list != NULL) {
            fs_list->prev = new;
        }
        fs_list = new;
    }
    return new;
}

FunctionListP insert_function_list(FunctionListP list,FSP ptr_fs,WP ptr)
{
    FunctionListP new;
      
    new = (FunctionListP)spdCalloc(sizeof(struct FS_List),1);
    new->function_s = ptr_fs;
    new->source = (ptr ? app_source_LC(NULL,ptr->head_point,current_file):
                   NULL);
    new->next = list;
    new->prev = NULL;
    if (list != NULL) list->prev = new;

    return new;
}

/******************************************************************************/

/* Declaration object. */

DNOP insert_declaration(WP ptr)
{
    DNOP        new;
    static int  decl_num = 0;
  
    new = (DNOP)spdCalloc(1, sizeof(DNO));
    new->id = INC_ID(decl_num);
    new->length = (ptr != NULL) ? ptr->length : 0;
    new->next = do_list;
    if (do_list != NULL) {
        do_list->prev = new;
    }
    do_list = new;
    return (new);
}

/* decl_type  */
DNOP make_decl_type2(DNOP decl, TS2P type)
{
    TS2P tmp_type;

    if (decl != NULL && type != NULL) {
        for (tmp_type = type; tmp_type->type_st_prev != NULL;
             tmp_type = tmp_type->type_st_prev);
        decl->type2 = append_type_list2(NULL, type, tmp_type->source);
    }
    return decl;
}

DO_ListP insert_declaration_list(DO_ListP list, DNOP ptr, WP wp)
{
    DO_ListP    new;

    new = (DO_ListP)spdCalloc(1, sizeof(DO_List));
    new->source = SET_NEW_SOURCE(NULL, wp, current_file);
    new->decl = ptr;
    new->next = list;
    if (list != NULL) {
        list->prev = new;
    }
    return (new);
}

/* Declarator object. */

DROP insert_declarator(WP ptr)
{
    DROP        new;
    static int  dt_num = 0;
  
    new = (DROP)spdCalloc(1, sizeof(DRO));
    new->id = INC_ID(dt_num);
    new->length = (ptr != NULL) ? ptr->length : 0;
    new->next = dt_list;
    if (dt_list != NULL) {
        dt_list->prev = new;
    }
    dt_list = new;
    return (new);
}

/* decr_type  */
DROP make_decr_type2(DROP decr, TS2P type)
{
    if (decr != NULL && type != NULL) {
        decr->type2 = type;
    }
    return decr;
}

DT_ListP insert_declarator_list(DT_ListP list, DROP ptr, WP wp)
{
    DT_ListP    new;

    new = (DT_ListP)spdCalloc(1, sizeof(DT_List));
    new->source = SET_NEW_SOURCE(NULL, wp, current_file);
    new->dt = ptr;
    new->next = list;
    if (list != NULL) {
        list->prev = new;
    }
    return (new);
}

/* OptionalDecl object. */

ODP insert_optionaldecl(WP ptr)
{
    ODP         new;
    static int  opt_num = 0;
  
    new = (ODP)spdCalloc(1, sizeof(OD));
    new->id = INC_ID(opt_num);
    new->length = (ptr != NULL) ? ptr->length : 0;
    new->next = od_list;
    if (od_list != NULL) {
        od_list->prev = new;
    }
    od_list = new;
    return (new);
}

OD_ListP insert_optionaldecl_list(OD_ListP list,ODP ptr,WP wp)
{
    OD_ListP    new;

    new = (OD_ListP)spdCalloc(1, sizeof(OD_List));
    new->source = SET_NEW_SOURCE(NULL, wp, current_file);
    new->opt = ptr;
    new->next = list;
    if (list != NULL ) {
        list->prev = new;
    }
    return (new);
}

/******************************************************************************/

void set_declaration(DNOP decl, TypeListP type_decl,
                     FunctionListP func_decl, TypeListP type_ref)
{
    TypeListP   type_l;
  
#if DECL_DEBUG
    printf ("decl id %d\n",decl->id);
#endif

    for (type_l = type_decl; type_l ; type_l = type_l->next) {
        type_l->type_s->decl = decl;
#if DECL_DEBUG
        printf("\tType id %d name:%s\n",
               type_l->type_s->id, type_l->type_s->name);
#endif
    }

    decl->type = type_decl;
    decl->func_l = func_decl;
    decl->type_ref = type_ref;
}

struct Stack_Parm *push_func_parm(void)
{
    struct Stack_Parm   *new;

    new = spdCalloc(sizeof(struct Stack_Parm), 1);
    new->next = func_parm_stack;
    new->decl_l = NULL;
    func_parm_stack = new;
    return (func_parm_stack);
}

struct Stack_Parm *pop_func_parm(void)
{
    struct Stack_Parm   *ptr;
    
    if (func_parm_stack != NULL) {
        ptr = func_parm_stack;
        func_parm_stack = func_parm_stack->next;
        spdFree(ptr);
    }
    return (func_parm_stack);
}

struct Stack_Func *push_direct_decl(int direct_decl)
{
    struct Stack_Func   *new;

    new = spdCalloc(sizeof(struct Stack_Func), 1);
    new->next = direct_decl_stack;
    new->direct_decl = direct_decl;
    direct_decl_stack = new;
    return (direct_decl_stack);
}

struct Stack_Func *pop_direct_decl(void)
{
    struct Stack_Func   *ptr;
    
    if (direct_decl_stack != NULL) {
        ptr = direct_decl_stack;
        direct_decl_stack = direct_decl_stack->next;
        spdFree(ptr);
    }
    return (direct_decl_stack);
}
