/* 
 * Program:             $RCSfile: identifier.c,v $  $Revision: 30.6 $
 * 
 * Purpose:             ̻Ҥ˴ؤǡ١롼
 * 
 * Author:              K.Mabuchi  1991/09/30
 *                      S.Yamamoto  1992/04/01
 * Modified:            H.Ariga  1993/07/01
 * 
 * (C) Copyright:       K.Mabuchi, H.Ariga and S.Yamamoto  1991 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: identifier.c,v 30.6 2003/06/28 15:32:14 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

extern SpdStringPool *str_pool;

IDOP insert_identifier(char *name,int sort)
{
    static int  id_num = 0;
    IDOP        new;

#if DELETED
    ULP         tmp_ul;
    SrcLCP      src;
#endif

    new = (IDOP)spdCalloc(sizeof(IDO),1);
    new->id = INC_ID(id_num);
    SPEC_NAME_COPY(new->name, name);
    new->sort = sort;
    new->ISDB_storage = ISDB_NORMAL;

#if DELETED
    if (tmp_ul = find_undefined_identifier(name)) {
        new->source = cat_source_LC(tmp_ul->source,new->source);
    }
#endif

    new->next = id_list;
    new->prev = NULL;
    if (id_list != NULL) id_list->prev = new;
    id_list = new;

    return new;
}

/* ident_type  */
void set_ident_type2(IDOP ident, TS2P type)
{
    if (ident != NULL && type != NULL) {
#ifdef IDENT_TYPE2_DEBUG
        fprintf(stderr, "ident_type: %d(%s) %d\n",
                ident->id, ident->name, type->id);
#endif /* IDENT_TYPE2_DEBUG */
        ident->type2 = type;
    }
}

SpdBoolean is_defined_ident_type2(IDOP ident)
{
    return (ident->type2 != NULL);
}

void set_ident_type2_list(IDO_ListP id_l, TS2P type)
{
    while (id_l != NULL) {
        set_ident_type2(id_l->ident, type);
        id_l = id_l->next;
    }
}

/* ǡꥹȤɲ */
IDO_ListP insert_identifier_list(IDO_ListP list, IDOP ptr_id, WP ptr)
{
    IDO_ListP new;
    extern FOP current_file;
    
    new = (IDO_ListP)spdCalloc(sizeof(IDO_List),1);
    new->ident = ptr_id;
    new->source = (ptr ? app_source_LC(NULL,ptr->point,current_file) : NULL);
    
    new->next = list;
    new->prev = NULL;
    if (list != NULL) list->prev = new;

    return new;
}

IDOP find_identifier(char *name, int sort)
{
    IDOP ptr;

    for (ptr = id_list; ptr != NULL; ptr = ptr->next) {
        if (SPD_STREQ(ptr->name, name) && ptr->sort & sort)
            break;
    }
    return (ptr);
}

IDOP find_identifier_by_ptr(void *data, int sort)
{
    IDOP ptr;

    for (ptr = id_list; ptr != NULL; ptr = ptr->next) {
        /* Modified by S.Yamamoto 1997/11/10. */
        /* if (sort && ptr->sort & sort) { */

        if (ptr->sort & sort) {
            if (ptr->sort == ID_VARIABLE && data == (void *)ptr->data.var)
                break;
            else if (ptr->sort == ID_FUNCTION && data == (void *)ptr->data.func)
                break;
            else if (ptr->sort == ID_MEMBER && data == (void *)ptr->data.mem)
                break;
            else if (ptr->sort == ID_ENUMERATOR &&
                     data == (void *)ptr->data.type)
                break;
        }
    }
    return (ptr);
}

IDOP find_identifier_list_by_name(IDO_ListP list, char *name, int sort)
{
    IDOP ident;

    if (name == NULL) return NULL;
    while (list != NULL) {
        ident = list->ident;
        if (ident != NULL && ident->sort == sort && ident->name != NULL
            && SPD_STREQ(ident->name, name)) {
            return ident;
        }
        list = list->next;
    }
    return NULL;
}

ULP find_undefined_identifier(char *name)
{
    ULP tmp_ul;
    
    for (tmp_ul = undef_list; tmp_ul !=(ULP)NULL ; tmp_ul = tmp_ul->next) {
        if (SPD_STREQ(tmp_ul->name, name)) {
            break;
        }
    }
    return tmp_ul;
}

ULP insert_undefined_identifier(WP ptr)
{
    ULP new;
    
    new = (ULP)spdCalloc(sizeof(UL),1);
    SPEC_NAME_COPY(new->name, ptr->name); 
    new->source = NULL;
    new->next = undef_list;
    if (undef_list != NULL)
        undef_list->prev = new;
    undef_list = new;
    return new;
}

void app_undefined_identifier(WP ptr)
{
    ULP ptr_ul;
    extern FOP current_file;
    
    if (!(ptr_ul = find_undefined_identifier(ptr->name))) {
        /* new */
        ptr_ul = insert_undefined_identifier(ptr);
    }
    printf("undefined %s\n",ptr->name); 
    
    ptr_ul->source = app_source_LC(ptr_ul->source,ptr->point,current_file);
}
