/* 
 * Program:             $RCSfile: member_spec.c,v $  $Revision: 30.10 $
 * 
 * Purpose:             ¤ΥФ˴ؤǡ١롼
 * 
 * Author:              K.Mabuchi  1991/09/30
 *                      S.Yamamoto  1992/04/01
 * Modified:            H.Ariga  1993/07/01
 * 
 * (C) Copyright:       K.Mabuchi, H.Ariga and S.Yamamoto  1991 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: member_spec.c,v 30.10 2003/06/22 07:26:47 yamamoto Exp yamamoto $";
#endif /* not lint */

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

extern FOP current_file;

/* ץ༱̻Ҥ¤typeΥХ֥Ȥõ */

MEMSP find_dot_member(TSP type, char *name)
{
    MEMS_ListP ptr;
    TSP type_tmp;

    ptr = NULL;
    for (type_tmp = type ; type_tmp->sort == TYPE_TYPE_DEF;
         type_tmp = type_tmp->pointer)
        /* Empty. */; 
    if (type_tmp->sort == TYPE_STRUCT_TAG || type_tmp->sort == TYPE_UNION_TAG) {
#ifdef REVISE_STRUCT_WITHOUT_MEMBER
        /* If type_tmp has no member, try to find members. */
        if (type_tmp->struc == NULL) {
            TSP t = find_struct_with_members(type_tmp->name);
            /* If members are found, set the pointer in struc. */
            if (t != NULL) {
                spdWarning("Incorrect links between types of struct/union"
                           " '%s' and identifiers may exist"
                           ", because of sdbin4's bug.\n",
                           type_tmp->name);
                type_tmp->struc = t->struc;
            }
        }
#endif
        for (ptr = type_tmp->struc ; ptr != NULL; ptr = ptr->next) {
            if (SPD_STREQ(ptr->member_s->name, name)) {
                break;
            }
        }
    }
    return (ptr ? ptr->member_s : NULL);
}

MEMSP find_arrow_member(TSP type, char *name)
{
    MEMS_ListP ptr;
    TSP type_tmp;

    ptr = NULL;
    for (type_tmp = type ; type_tmp->sort == TYPE_TYPE_DEF;
         type_tmp = type_tmp->pointer)
        /* Empty. */; 
    if (type_tmp->sort == TYPE_POINTER || type_tmp->sort == TYPE_ARRAY) {
        for (type_tmp = type_tmp->pointer ; type_tmp->sort == TYPE_TYPE_DEF;
             type_tmp = type_tmp->pointer)
            /* Empty. */; 
        if (type_tmp->sort == TYPE_STRUCT_TAG
            || type_tmp->sort == TYPE_UNION_TAG) {
#ifdef REVISE_STRUCT_WITHOUT_MEMBER
            /* If type_tmp has no member, try to find members. */
            if (type_tmp->struc == NULL) {
                TSP t = find_struct_with_members(type_tmp->name);
                /* If members are found, set the pointer in struc. */
                if (t != NULL) {
                    spdWarning("Incorrect links between types of struct/union"
                               " '%s' and identifiers may exist"
                               ", because of sdbin4's bug.\n",
                               type_tmp->name);
                    type_tmp->struc = t->struc;
                }
            }
#endif
            for (ptr = type_tmp->struc ; ptr != NULL; ptr = ptr->next) {
                if (SPD_STREQ(ptr->member_s->name, name)) {
                    break;
                }
            }
        }
    }
    return (ptr ? ptr->member_s : NULL);
}

/* ¤ΥХ֥Ȥɲ */

MEMSP insert_member(char *name, TSP type, WP ptr)
{
    static int  mems_num = 0;
    MEMSP       new;

    new = (MEMSP)spdCalloc(sizeof(struct MEMS),1);

    new->id = INC_ID(mems_num);
    SPEC_NAME_COPY(new->name, name);
    new->type = type;
    new->source = (ptr ? app_source_LC(NULL,ptr->point,current_file) : NULL);
    new->next = mems_list;
    new->prev = NULL;
    if (mems_list != NULL) {
        mems_list->prev = new;
    }
    mems_list = new;

    return new;
}

/* ¤ΥХꥹȤɲ */

MEMS_ListP insert_member_list(MEMS_ListP list, MEMSP ptr_mems,WP ptr)
{
    MEMS_ListP new;
    MEMS_ListP tmp;

    new = (MEMS_ListP)spdCalloc(sizeof(struct MEMS_List),1);
    new->member_s = ptr_mems;
    new->source = (ptr ? app_source_LC(NULL,ptr->point,current_file) : NULL);
    new->next = NULL;
    if (list){
        for ( tmp = list ; tmp->next ; tmp = tmp->next );
        tmp->next = new;
        new->prev = tmp;
    }
    else list = new;
    
    return list;
}
