/* 
 * Program:             $RCSfile: operator_spec.c,v $  $Revision: 30.5 $
 * 
 * Purpose:             黻Ҥ˴ؤǡ١롼
 * 
 * Author:              K.Mabuchi  1991/09/30
 *                      S.Yamamoto  1992/04/01
 * Modified:            H.Ariga  1993/07/01
 * 
 * (C) Copyright:       K.Mabuchi, H.Ariga and S.Yamamoto  1991 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: operator_spec.c,v 30.5 2002/11/04 12:48:08 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

OO_ListP operator_table;

/* 黻ҥ֥Ȥɲä롥 */

OOP insert_operator(int sort,int length)
{
    static int  oo_num = 0;
    OOP         new;

    new = (OOP)spdCalloc(sizeof(struct OperatorObject),1);

    new->id = INC_ID(oo_num);
    new->sort = sort;
    new->length = length;
    new->type = NULL;

    new->next = oo_list;
    new->prev = NULL;
    if (oo_list != NULL) {
        oo_list->prev = new;
    }
    oo_list = new;
    
    return new;
}

/* op_type롥 */

OOP make_op_type2(OOP op, TS2P type)
{
    if (op != NULL && type != NULL) {
        op->type2 = type;
    }
    return op;
}

/* 黻ҥꥹȤɲä롥 */

OO_ListP insert_operator_list(OO_ListP list, OOP ptr_oo,WP ptr)
{
    OO_ListP new;
    extern FOP current_file;

    new = (OO_ListP)spdCalloc(sizeof(struct OperatorObjectList),1);
    new->operator_s = ptr_oo;
    new->source = app_source_LC(NULL, (ptr ? ptr->head_point : 0),
                                current_file);
    
    new->next = list;
    new->prev = NULL;
    if (list != NULL) {
        list->prev = new;
    }

    return new;
}

OOP find_operator(int sort,TSP type)
{
    OOP     tmp_oo;

    for (tmp_oo = oo_list ; tmp_oo ; tmp_oo = tmp_oo -> next) {
        if (tmp_oo->sort == sort) {
            if (sort == OP_SIZEOF_TYPE || sort == OP_CAST ||
                sort == OP_BUILTIN_TYPE) {
                if (tmp_oo->type != type)
                    continue;
            }
            break;
        }
    }
    return tmp_oo;
}

/* ͭα黻Ҥν */

void init_operator(void)
{
    insert_operator(OP_ARROW, 2);
    insert_operator(OP_DOT, 1);  
    insert_operator(OP_NOT, 1);
    insert_operator(OP_B_NOT, 1);
    insert_operator(OP_INC, 2);
    insert_operator(OP_DEC, 2);
    insert_operator(OP_PLUS, 1);  
    insert_operator(OP_MINUS, 1);
    insert_operator(OP_POINTER, 1);
    insert_operator(OP_ADDRESS, 1);
    insert_operator(OP_MUL, 1);
    insert_operator(OP_DIV, 1);
    insert_operator(OP_MOD, 1);
    insert_operator(OP_ADD, 1);
    insert_operator(OP_SUB, 1);
    insert_operator(OP_SHL, 2);
    insert_operator(OP_SHR, 2);
    insert_operator(OP_LT, 1);
    insert_operator(OP_LE, 2);
    insert_operator(OP_GT, 1);
    insert_operator(OP_GE, 2);
    insert_operator(OP_EQ, 2);
    insert_operator(OP_NE, 2); 
    insert_operator(OP_B_AND, 1);
    insert_operator(OP_B_XOR, 1);
    insert_operator(OP_B_OR, 1);
    insert_operator(OP_L_AND, 2);
    insert_operator(OP_L_OR, 2);
    insert_operator(OP_ASSIGN, 2);
    insert_operator(OP_A_ADD, 2);
    insert_operator(OP_A_SUB, 2);
    insert_operator(OP_A_MUL, 2);
    insert_operator(OP_A_DIV, 2);
    insert_operator(OP_A_MOD, 2);
    insert_operator(OP_A_AND, 2);
    insert_operator(OP_A_XOR, 2);
    insert_operator(OP_A_OR, 2); 
    insert_operator(OP_A_SHL, 3);
    insert_operator(OP_A_SHR, 3);
    insert_operator(OP_COMMA, 1);
    insert_operator(OP_SIZEOF, 6);
    insert_operator(OP_L_PAR, 1);
    insert_operator(OP_R_PAR, 1);
    insert_operator(OP_L_ARRAY, 1);
    insert_operator(OP_R_ARRAY, 1);
    insert_operator(OP_QUESTION, 1);
    insert_operator(OP_COLON, 1);
    insert_operator(OP_BUILTIN, 17);        /* __builtin_alignof */
}
