/* 
 * Program:             $RCSfile: sdbin4.c,v $  $Revision: 30.56 $
 * 
 * Purpose:
 * 
 * Author:              K.Mabuchi  1991/09/30
 *                      S.Yamamoto  1992/04/01
 * Modified:            H.Ariga  1993/07/01
 * 
 * (C) Copyright:       K.Mabuchi, H.Ariga and S.Yamamoto  1991 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: sdbin4.c,v 30.56 2003/06/08 11:04:18 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/write_sdb_sub.h>
#include "main.h"
#include "prototype.h"

#ifdef DAPID
#define OPTION_STRINGS              "bd:e:fl:o:tuvD"
#else
#define OPTION_STRINGS              "bd:e:fl:tuv"
#endif

/*
 * ƻͤΥꥹȤƬΥݥ󥿡
 */

TSP ts_list;
CSP cs_list;
DSP ds_list;
FSP fs_list;
FOP fo_list;
POP po_list;                    /* Note: Used only in D-model. */
MEMSP mems_list;
DNOP do_list;                   /* Variable name "dno_list" is better. */
DROP dt_list;                   /* Variable name "dro_list" is better. */
ODP od_list;
BOP bo_list;
EOP eo_list;
LOP lo_list;
OOP oo_list;
IDOP id_list;

ScopeListP  scope_list;
ULP         undef_list;

/*
 * make_type_spec()ǳݤ줿ΰfree뤿Υꥹȡ
 * ts_listϿ줿"ts_next = ts_prev = NULL;".
 */
TSP ts_list2;

SpdStringPool *str_pool = NULL;
SpdString sdb_null_value = NULL;

extern FILE *yyin;
extern TSP type_int;
extern MEMS_ListP mem_ref ;
extern DataListP var_ref ;
extern FunctionListP func_call ;
extern EO_ListP blk_expr ;
extern DO_ListP blk_decl;
extern EO_ListP arg_expr ;
extern DO_ListP file_decl ;
extern TypeListP type_decl ;
extern FunctionListP file_func;
extern BO_ListP func_blk;
extern LevelPtr level;
extern FOP tmp_fo;

extern int yydebug;
extern int yydebug_line;

/*
 * Accept undefined variable.
 * 
 * D-modelΥץҤ˸̤ޥ̤μ̻ҤȤ
 * ɬפ롥̾ϡ̤ccưƱǡ̤ѿ򥨥顼Ȥ롥
 * 
 * ==============================
 * void main(void)
 * {
 *     F(X);
 * }
 * ==============================
 */
SpdBoolean      accept_undef_var = FALSE;

/*
 * ץ-tꤵ줿顤ѿlegacy_typeTRUEˤơ
 * legacy type specϤ롥
 */
SpdBoolean      legacy_type = FALSE;

/*
 * F-modelϡΥ򡤤ǤʤǲϤ뤿
 * ǥǤ롥
 * 
 * ץ"#include"Ⱦʬȡѿؿʤɤ
 * ȾʬȤʬơȾʬ("#ifdef"
 * ʤɤ̤̾˽)
 * 
 * Ⱦʬ˸"#ifdef""#endif"ʤɤϥåפ롥ѿ
 *
 * #ifdef FOO
 *     int x;
 * #else
 *     short x;
 * #endif
 *
 * Τ褦"#ifdef"ǰϤޤƤθơ
 * Ʊ쥹פˤ뼱̻Ҥ¿
 * 
 * ̤ΤidentifierȤ줿ˡ˥饹identifierΥ֥Ȥ
 * Ϣident_ref롥
 *
 * Variable name is_F_model is better.
 */
SpdBoolean      F_model = FALSE;

SpdBoolean      is_D_model = FALSE;

SpdConstString  program_name;                   /* This program name. */
char            *filename;                      /* Current C source file. */

#ifdef DAPID
static char         *target_program_name = SPD_DEFAULT_TARGET_PROGRAM_NAME;
#endif

static void         parse_option(int argc, char *argv[]);
static void         print_usage(SpdConstString command_name);
static void         write_sapid_version(void);

int main(int argc, char *argv[])
{
    int         i;
    
    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);

    str_pool = spdStrPoolInit(SDBIN_DEFAULT_POOL_SIZE);
    /* nameΤʤconstant spectype specΤ˶ʸϿ롥 */
    sdb_null_value = spdStrPoolFastCopy(str_pool, "");

    parse_option(argc, argv);
    argc -= optind;
    argv += optind;
    if (argc < 1) {
        spdErrorExit("No input file.\n");
    }
    load_builtin();
    
    yydebug_line = 0;
    for (i = 0; i < argc; i++) {
        filename = argv[i];
        yyin = spdFopen(argv[i], SPD_FOPEN_RT_MODE);

#ifdef USE_FLEX   
        yyrestart(yyin);
#endif

#ifdef DAPID
        init_ptr(target_program_name);
#else
        init_ptr("");                       /* Dummy. */
#endif      

        analyze(filename);
        spdFclose(yyin);
        if (!legacy_type) {
            type2_post_process();
        }
        while ((scope_list = free_scope_list(scope_list)) != NULL) {
            /* Empty. */;
        }
        check_storage();
        write_db(filename);

#ifdef SAPID_MEMORY_PROFILE
        spdMessage("\"%s\": %d.\n", __FILE__, __LINE__);
        spdPrintMemProf();
#endif

        unlist();
        escape_level();
    }

#ifdef SCOPE_DEBUG
    for (ptr = fo_list; ptr != NULL; ptr = ptr->next) {
        TypeListP   ts_list;

        fprintf(stderr, "file name is %s. >>> %d\n", ptr->name, ptr->id);
        for (ts_list = ptr->scope->type_t; ts_list != NULL;
             ts_list = ts_list->next) {
            fprintf(stderr, "\t%s\n", ts_list->type_s->name);
        }
    }
#endif

    spdStrPoolFree(str_pool);
    write_sapid_version();
    return (EXIT_SUCCESS);
}

/*
 * Analyzing options.
 */

static void parse_option(int argc, char *argv[])
{
    int     ch;

    while ((ch = getopt(argc, argv, OPTION_STRINGS)) != -1) {
        switch (ch) {
          case 'b':                         /* Binary mode. */
            spdSetWriteSDBformat(SAPID_BINARY_FORMAT_SDB);
            break;
          case 'd':                         /* Directory for SDB. */
            spdSetSDBdir(optarg);
            break;
          case 'e':                         /* Set encoding. */
            spdSetInputEncode(optarg);
            break;
          case 'f':                         /* Use F-model. */
            F_model = TRUE;
            break;
          case 'l':                         /* Starting line for yacc debug. */
            yydebug_line = atoi(optarg);
            spdMessage("Debug mode line: %d.\n", yydebug_line);
            break;

#ifdef DAPID
          case 'o':                         /* Target program name. */
            target_program_name = optarg;
            break;
#endif

          case 't':
            legacy_type = TRUE;
            break;
          case 'u':                         /* Accept undefined variable. */
            accept_undef_var = TRUE;
            break;
          case 'v':                         /* Debug mode for lex and yacc. */
            yydebug = 1;
            break;

#ifdef DAPID
          case 'D':                         /* D-model. */
            is_D_model = TRUE;
            break;
#endif

          default:
            spdWarning("'%c': Invalid option.\n", ch);
            print_usage(program_name);
            break;
        }
    }
}

static void write_sapid_version(void)
{
    SpdInfo *info;

    info = spdOpenSDBinfo();
    smuSetSDBinfo(info);
    spdSetInfoString(info, "SDB4", "TRUE");
    spdCloseInfo(info);
}

/*
 * Printing usage.
 */

static void print_usage(SpdConstString command_name)
{
    const char  *usageMessage =
        "\n"
        "NAME\n"
        "    %s\n"
        "SYNOPSIS\n"
        "    %s [options] inputFiles\n"
        "DESCRIPTION\n"
        "    -d SDB-directory: \n"
        "    -o targetProgramName: \n"
        "VERSION\n"
        "    %d.%d.%d\n";

    spdErrorExit(usageMessage,
                 command_name, command_name,
                 SapidVersion, SapidRevision, SapidPatchLevel);
}
