/*
 * Program:             $RCSfile: storage.c,v $  $Revision: 30.3 $
 *
 * Purpose:
 *
 * Author:              S.Kawai  1995/10/01
 *                      S.Yamamoto  1996/06/02
 *
 * (C) Copyright:       S.Kawai and S.Yamamoto  1995 - 2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: storage.c,v 30.3 2002/10/21 07:26:52 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

FI              FI_top[HASH_SIZE];

void init_FI(void)
{
    int         i;

    for (i = 0; i < HASH_SIZE; i++) {
        FI_top[i] = NULL;
    }
}

/* ident  hash table  */

static void mkmap_file_ident(void)
{
    int         ident_id;
    FOP         fo_ptr;
    DO_ListP    do_ptr;
    DT_ListP    dt_ptr;
    IDO_ListP   id_ptr;
    FI          new;

    for (fo_ptr = fo_list; fo_ptr; fo_ptr = fo_ptr->next) {
        for (do_ptr = fo_ptr->decl; do_ptr; do_ptr = do_ptr->next) {
            for (dt_ptr = do_ptr->decl->dt_l; dt_ptr; dt_ptr = dt_ptr->next) {
                for (id_ptr = dt_ptr->dt->id_l; id_ptr; id_ptr = id_ptr->next){
                    ident_id = id_ptr->ident->id;
                    new = spdMalloc(sizeof(struct _ident));
                    new->id = ident_id;
                    new->dt_sort = dt_ptr->dt->sort;
                    new->decl_storage = do_ptr->decl->storage;
                    new->next = FI_top[ident_id % HASH_SIZE];
                    FI_top[ident_id % HASH_SIZE] = new;
                }
            }
        }
    }
}

FI check_ident(int ident_id)
{
    static FI       ptr;
    static SpdObjId static_id = SPD_NON_ID;

    if (static_id == ident_id) {
        ptr = ptr->next;
    } else {
        ptr = FI_top[ident_id % HASH_SIZE];
        static_id = ident_id;
    }

    for (/* Empty. */; ptr != NULL; ptr = ptr->next) {
        if(ptr->id == ident_id) {
            return ptr;
        }
    }
    return NULL;
}

int get_ident_storage(int ident_id)
{
    int res = 0;
    FI  id;

    while ((id = check_ident(ident_id)) != NULL) {
        if (id->decl_storage == STORAGE_STATIC) {
            res |= ISDB_STATIC;
        }
        switch(id->dt_sort){
          case DECL_PROTOTYPE:
          case DECL_FUNCDEF:
            res |= ISDB_FUNCTION;
            break;
          case DECL_VARIABLE:
            res |= ISDB_VARIABLE;
            break;
        }
    }
    return res;
}

void check_storage(void)
{
    IDOP         id_ptr;

    mkmap_file_ident();
    for (id_ptr = id_list; id_ptr; id_ptr = id_ptr->next){
        id_ptr->ISDB_storage = get_ident_storage(id_ptr->id);
        if (id_ptr->sort == ID_FUNCTION) {
            id_ptr->ISDB_storage |= ISDB_NO_PROTOTYPE;
        } 
    }
}
