/* 
 * Program:             $RCSfile: type_spec.c,v $  $Revision: 30.14 $
 * 
 * Purpose:             ˴ؤǡ١롼
 * 
 * Author:              K.Mabuchi  1991/09/30
 *                      S.Yamamoto  1992/04/01
 * Modified:            H.Ariga  1993/07/01
 * 
 * (C) Copyright:       K.Mabuchi, H.Ariga and S.Yamamoto  1991 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: type_spec.c,v 30.14 2003/06/28 15:32:15 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

/*
 * Debug flags.
 */

/* #define TYPE_REF_DEBUG */

#if defined(lint)
#define DW_TYPE_REF         printf      /* Just for cheking. */
#elif defined(TYPE_REF_DEBUG)
#define DW_TYPE_REF         spdMessage
#else
#define DW_TYPE_REF         (void)
#endif

/* #define TYPE_DEBUG          1 */
/* #define DISP_TYPE           1 */

/*
 * Variables.
 */

TSP         ptr_ts_struc, ptr_ts_enum;

static int  ts_num;

extern FOP  tmp_fo;
extern FOP  current_file;

extern struct Stack_Type    *ptr_ts_stack;
extern SpdString            sdb_null_value;

/* ץ༱̻Ҥͤ򸡺롥 */

TSP find_type(char *name, int sort)
{
    TypeListP ptr=NULL;
    ScopeListP sc_list;

    for (sc_list = scope_list ; sc_list ; sc_list = sc_list -> next) {
        for (ptr = sc_list->scope->type_t ; ptr != NULL; ptr = ptr->next) {
            if (SPD_STREQ(ptr->type_s->name, name) && ptr->type_s->sort == sort)
                break;
        }
        if (ptr) break;
    }

    return (ptr ? ptr->type_s : NULL);
}

/******************************************************************************/

/* ͤɲá */

TSP insert_type(char *name, WP ptr)
{
    TSP     new;

    new = (TSP)spdCalloc(1, sizeof(struct TS));
    clear_ts(new);
    new->id = INC_ID(ts_num);
    new->source = 
        (ptr != NULL) ? app_source_LC(NULL, ptr->point, current_file) : NULL;
    if (name != NULL) {
        SPEC_NAME_COPY(new->name, name);
    }
    new->next = ts_list;
    /* new->prev = NULL; */     /* No effect because allocated by calloc(). */
    if (ts_list != NULL) {
        ts_list->prev = new;
    }
    ts_list = new;

#if TYPE_DEBUG
    fprintf(stderr, "Insert Type id = %d\n", ts_num); 
#endif
    
    return (new);
}

/* ͥꥹȤɲá */

struct TS_List *insert_type_list(struct TS_List *list, TSP ptr, WP wp)
{
    struct TS_List  *new;

    new = (struct TS_List *)spdCalloc(1, sizeof(struct TS_List));
    new->source =
        (wp != NULL) ? app_source_LC(NULL,wp->point,current_file) : NULL;
    new->type_s = ptr;
    new->next = list;
    /* new->prev = NULL; */     /* No effect because allocated by calloc(). */
    if (list != NULL) {
        list->prev = new;
    }
    list = new;
    return (list);
}

/******************************************************************************/

TSP make_type_spec(void)
{
    TSP new;
    
    new = (TSP)spdCalloc(sizeof(struct TS),1);
    clear_ts(new);

    /*
     * make_type_spec() ǳݤ줿ΰ free 뤿Υꥹȡ
     * ts_list Ͽ줿 ts_next = ts_prev = NULL;
     */
    new->ts_next = ts_list2;
    if (ts_list2 != NULL) ts_list2->ts_prev = new;
    ts_list2 = new;

    return new;
}

void clear_ts(TSP ptr)
{
    /* DW_TYPE_REF("clear_ts(): ptr %x, ptr->type %d\n", ptr, ptr->type); */
    DW_TYPE_REF("clear_ts(): ptr %p, ptr->type %d\n", ptr, ptr->type);

    /* Fixed by S.Yamamoto 1998/01/06. */
    /* ptr->id = NULL; */
    ptr->id = SPD_NON_ID;
    ptr->name = sdb_null_value;
    ptr->sort = TYPE_UNKNOWN;
    ptr->class = TYPE_UNKNOWN;
    ptr->qualifier = TYPE_UNKNOWN;
    ptr->type = TYPE_UNKNOWN;
    ptr->length = TYPE_UNKNOWN;
    ptr->sign = TYPE_UNKNOWN;
    ptr->pointer = NULL;
    ptr->array = NULL;
    ptr->struc = NULL;
    ptr->enum_const = NULL;
    ptr->decl = NULL;
    ptr->ident = NULL;
}

void delete_ts_list2(TSP ptr)
{
    if (ptr == NULL) return;
    if (ptr->ts_prev != NULL) ptr->ts_prev->ts_next = ptr->ts_next;
    if (ptr->ts_next != NULL) ptr->ts_next->ts_prev = ptr->ts_prev;
    if (ptr == ts_list2) ts_list2 = ptr->ts_next;
    ptr->ts_prev = NULL;
    ptr->ts_next = NULL;
}

void free_type_spec(TSP ptr)
{
    free_EO_ListP(ptr->array);
    /* free_MEMS_ListP(ptr->struc); */
    /* free_CS_ListP(ptr->enum_const); */
    spdFree(ptr);
}

/* ͺΤΥåΥץå塥 */

struct Stack_Type *push_ts(void)
{
    struct Stack_Type   *new;

    DW_TYPE_REF("push_ts():\n");
    new = (struct Stack_Type *)spdCalloc(sizeof(struct Stack_Type),1);
    new->next = ptr_ts_stack;
    ptr_ts_stack = new;

    ptr_ts_stack->sort = make_type_spec();
    ptr_ts_stack->list = NULL;
    ptr_ts_stack->queue = NULL;
    ptr_ts_stack->point = -1;
    push_queue();

    return ptr_ts_stack;
}

/* ͺΤΥåΥݥåס */

struct Stack_Type *pop_ts(void)
{
    struct Stack_Type *ptr;

    DW_TYPE_REF("pop_ts():\n");
    if (ptr_ts_stack != NULL) {
        ptr = ptr_ts_stack;
        pop_queue();
        ptr_ts_stack = ptr_ts_stack->next;
        /*
         * make_type_spec() ǳݤ줿ΰ free 뤿Υꥹȡ
         * ts_list2  ptr->sort 
         */
        delete_ts_list2(ptr->sort);
        free_type_spec(ptr->sort);
        spdFree(ptr);
    }

    return ptr_ts_stack;
}

TSP list_ts(void)
{
    TSP new;

    new = make_type_spec();
    new->next = ptr_ts_stack->list;
    ptr_ts_stack->list = new;
    return new;
}

TSP queue_in_ts(void)
{
    TSP new;

    new = make_type_spec();

    new->next = NULL;
    if (ptr_ts_stack->queue->in != NULL) {
        ptr_ts_stack->queue->in->next = new;
    } else {
        ptr_ts_stack->queue->out = new;
    }
    ptr_ts_stack->queue->in = new;

    return new;
}

TSP queue_out_ts(void)
{
    if (ptr_ts_stack->queue->out->next != NULL) {
        ptr_ts_stack->queue->out = ptr_ts_stack->queue->out->next;
    }
    return ptr_ts_stack->queue->out;
}

/* ݥ󥿤ηͤΥꥹȤΥץå塥 */

void push_queue(void)
{
    struct Stack_Queue *new;

    new = (struct Stack_Queue *)spdCalloc(sizeof(struct Stack_Queue),1);
    new->in = NULL;
    new->out = NULL;

    new->next = ptr_ts_stack->queue;
    ptr_ts_stack->queue = new;
}

/* ݥ󥿤ηͤΥꥹȤΥݥåס */

struct Stack_Queue *pop_queue(void)
{
    struct Stack_Queue *ptr;

    if (ptr_ts_stack->queue != NULL) {
        ptr = ptr_ts_stack->queue;
        ptr_ts_stack->queue = ptr_ts_stack->queue->next;
        spdFree(ptr);
    }

    return ptr_ts_stack->queue;
}

/* ͥ󥹤˥ݥ󥿤ĥ롥 */

TSP ass_ptr_queue(TSP ptr_queue)
{
    TSP ptr;

    for (ptr = ptr_queue; ptr->next != NULL; ptr = ptr->next) {
        switch (ptr->next->sort) {
          case TYPE_POINTER:
          case TYPE_ARRAY:
          case TYPE_FUNC:
            ptr->next->pointer = ptr;
            break;
          default:
            break;
        }
    }
    return ptr->next;
}

/* ͥ١椫פ뷿ͤõ⤷äݥ󥿤ĥ
   ưפ뷿ͤΥݥ󥿤֤ʤäNULL֤ */

TSP cmp_type_spec(TSP ptr)
{
    TSP ptr_ts;

    for (ptr_ts = ts_list; ptr_ts != NULL; ptr_ts = ptr_ts->next) {
        if (ptr->sort == ptr_ts->sort){
            switch (ptr->sort) {
              case TYPE_DECLARATION:
                if (ptr->type == ptr_ts->type
                    && ptr->length == ptr_ts->length
                    && ptr->sign == ptr_ts->sign
                    && ptr->qualifier == ptr_ts->qualifier) {
                    if (ptr->next != NULL)
                        ptr->next->pointer = ptr_ts;
                    return ptr_ts;
                }
                break;
              case TYPE_POINTER:
                if (ptr->pointer == ptr_ts->pointer
                    && ptr->qualifier == ptr_ts->qualifier) {
                    if (ptr->next != NULL)
                        ptr->next->pointer = ptr_ts;
                    return ptr_ts;
                }
                break;
              case TYPE_ARRAY:
                if (ptr->pointer == ptr_ts->pointer
                    && ptr->array == ptr_ts->array) {
                    if (ptr->next != NULL) 
                        ptr->next->pointer = ptr_ts;
                    return ptr_ts;
                }
                break;
              case TYPE_STRUCT_TAG:
              case TYPE_UNION_TAG:
#ifdef DEBUG_950328
                fprintf(stdout,"cmp_type_spec called ptr_ts->id = %d\n",
                        ptr_ts->id);
                printf("ptr->struc = %x  ptr_ts->struc = %x name = %s(%x)\n",
                       ptr->struc, ptr_ts->struc, ptr->name,ptr->name);
#endif
                if (ptr->qualifier == ptr_ts->qualifier &&
                    ((*(ptr->name) != '\0' &&
                      SPD_STREQ(ptr->name, ptr_ts->name))
                     || ((ptr->struc != NULL && ptr_ts->struc != NULL)
                         && ptr->struc == ptr_ts->struc ))) {
                    if (ptr->next != NULL)
                        ptr->next->pointer = ptr_ts;
#ifdef DEBUG_950328
                    fprintf(stdout, " and struct matched %d %s\n",
                            ptr_ts->id, ptr->name);
#endif
                    return ptr_ts;
                }
                break;
              case TYPE_ENUM_SPECIFIER:
                if (ptr->pointer == ptr_ts->pointer
                    && ptr->enum_const == ptr_ts->enum_const) {
                    if (ptr->next != NULL) 
                        ptr->next->pointer = ptr_ts;
                    return ptr_ts;
                }
                break;
              case TYPE_TYPE_DEF:
                if (SPD_STREQ(ptr->name, ptr_ts->name) &&
                    ptr->qualifier == ptr_ts->qualifier) {
                    if (ptr->next != NULL)
                        ptr->next->pointer = ptr_ts;
                    return ptr_ts;
                }
                break;
              default:
                break;
            }
        }
    }       
    return NULL;
}

/* ͥ󥹤򷿻ͥ١Ӥפʤʬ˴ؤƷͤ
   롥 */

TSP cmp_queue(TSP ptr_queue)
{
    TSP ptr, loop, end, ptr_ts, ptr_tmp;

    ptr = ptr_queue;
    while (ptr != NULL) {
        ptr_tmp = ptr->next;
        if ((ptr_ts = cmp_type_spec(ptr)) == NULL) {
            loop = ptr;
            do {
                end = loop;
                loop = loop->next;
                end->id = INC_ID(ts_num);    
                end->next = ts_list;
                ts_list = end;
                /*
                 * make_type_spec() ǳݤ줿ΰ free 뤿Υꥹȡ
                 * ts_list2  end 
                 */
                delete_ts_list2(end);
            } while (loop != NULL);
            return end;
        } else if (ptr == ptr_queue) {
            /*
             * make_type_spec() ǳݤ줿ΰ free 뤿Υꥹȡ
             * ts_list2  ptr_queue 
             */
            delete_ts_list2(ptr_queue);
            spdFree(ptr_queue);
        }
        ptr = ptr_tmp;
    }
    return ptr_ts;
}

/* ݥ󥿤ηͥ󥹤 */

TSP app_pointer_id(void)
{
    queue_in_ts();
    ptr_ts_stack->queue->in->sort = TYPE_POINTER;
 
    return ptr_ts_stack->queue->in;
}

/* ηͥ󥹤 */

TSP app_array_id(EOP ptr_expr, WP ptr)
{
    list_ts();
    ptr_ts_stack->list->sort = TYPE_ARRAY;
    if (ptr_expr)
        ptr_ts_stack->list->array
            = (ptr_expr ? insert_expression_list(NULL,ptr_expr,ptr) : NULL);

    return ptr_ts_stack->list;
}

/* ؿηͥ󥹤 */

TSP app_func_id(void)
{
    list_ts();
    ptr_ts_stack->list->sort = TYPE_FUNC;

    return ptr_ts_stack->list;
}

void copy_type_spec2(TSP ptr_s, TSP ptr_d)
{
    ptr_d->id = ptr_s->id;
    SPEC_NAME_COPY(ptr_d->name, ptr_s->name);
    ptr_d->sort = ptr_s->sort;
    ptr_d->class = ptr_s->class;
    ptr_d->qualifier = ptr_s->qualifier;
    ptr_d->type = ptr_s->type;
    ptr_d->length = ptr_s->length;
    ptr_d->sign = ptr_s->sign;
    ptr_d->pointer = ptr_s->pointer;
    ptr_d->array = ptr_s->array;
    ptr_d->struc = ptr_s->struc;
    ptr_d->enum_const = ptr_s->enum_const;
    ptr_d->decl = ptr_s->decl;
    ptr_d->ident = ptr_s->ident;
    ptr_d->source = ptr_s->source;
    ptr_d->next = NULL;
    ptr_d->prev = NULL;
}

/* ͤʣ */

TSP copy_type_spec(TSP ptr_s)
{
    TSP new;

    new = make_type_spec();
    copy_type_spec2(ptr_s, new);
    return new;
}

TSP find_cp_typedef(char *name, TSP ptr_ts)
{
    TSP ptr;

    ptr = find_type(name, TYPE_TYPE_DEF);

    if (ptr != NULL) {
        SPEC_NAME_COPY(ptr_ts->name, ptr->name);
        ptr_ts->sort = ptr->sort;
        ptr_ts->pointer = ptr->pointer;
    }
    return ptr;
}

/******************************************************************************/

extern TypeListP guessed_type;

TSP find_guessed_typedef_type(char *name)
{
    TypeListP   ptr;

    for (ptr = guessed_type; ptr != NULL; ptr = ptr->next) {
        if (SPD_STREQ(ptr->type_s->name, name))
            break;
    }

    return (ptr ? ptr->type_s : NULL);
}

TSP find_cp_guessed_typedef(char *name, TSP ptr_ts)
{
    TSP         ptr;

    if ((ptr = find_guessed_typedef_type(name)) != NULL) {
        SPEC_NAME_COPY(ptr_ts->name, ptr->name);
        ptr_ts->sort = ptr->sort;
        ptr_ts->pointer = ptr->pointer;
    }
    return (ptr);
}

/******************************************************************************/

TSP find_cp_struc(char *name, TSP ptr_ts)
{
    TSP ptr;

    if (name != NULL) {
        if ((ptr = find_type(name, TYPE_STRUCT_TAG)) == NULL) {
            ptr = find_type(name, TYPE_UNION_TAG);
        }
    }
    /* ptr = (name ? find_type(name, TYPE_STRUCT_TAG) : (TSP)NULL); */

    if (ptr != NULL) {
        SPEC_NAME_COPY(ptr_ts->name, ptr->name);
        ptr_ts->sort = ptr->sort;
        ptr_ts->struc = ptr->struc;
    }
    return ptr;
}

TSP find_cp_enum(char *name, TSP ptr_ts)
{
    TSP ptr;

    ptr = find_type(name, TYPE_ENUM_SPECIFIER);

    if (ptr != NULL) {
        SPEC_NAME_COPY(ptr_ts->name, ptr->name);
        ptr_ts->sort = ptr->sort;
        ptr_ts->enum_const = ptr->enum_const;
    }
    return ptr;
}

#ifdef DISP_TYPE /*************************************************************/

static char *string_qualifier[] = {"const", "volatile"};
static char *string_type[] = {"void", "int", "char", "float", "double", "..."};
static char *string_length[] = {"short", "long"};
static char *string_sign[] = {"signed", "unsigned"};
static char *string_sort[] = {"None", "Declaration", "Pointer", "Array",
                                  "Function", "Structure", "TypeDef", 
                                  "Member" ,"Enum"};

void disp_ptr_ts_stack(TSP ptr_queue)
{
    TSP ptr;

    fprintf(stderr, "ptr_ts_stack : %s", string_sort[ptr_queue->sort]);
    for (ptr = ptr_queue->next; ptr != NULL; ptr = ptr->next) {
        fprintf(stderr, " -> %s", string_sort[ptr->sort]);
    }
    fprintf(stderr, "\n");
}

void disp_type_id(TSP ptr_queue)
{
    TSP ptr;

    fprintf(stderr, "Type sequence : %s", string_sort[ptr_queue->sort]);
    for (ptr = ptr_queue->pointer; ptr != NULL; ptr = ptr->pointer) {
        fprintf(stderr, " -> %s", string_sort[ptr->sort]);
    }
    fprintf(stderr, "\n");
}

void disp_type(TSP ptr)
{
    struct MEMS_List *mems_l;

    if (!ptr) return;
    fprintf(stderr, "\tId:\t%d\n", ptr->id);
    fprintf(stderr, "\tName:\t%s\n", ptr->name);
    fprintf(stderr, "\tAttribute:\t%s\n", string_sort[ptr->sort]);
    if (ptr->qualifier > 0)
        fprintf(stderr, "\tQualifier:\t%s\n", 
                string_qualifier[ptr->qualifier-1]);
    switch (ptr->sort) {
      case TYPE_ARRAY:
        if (ptr->pointer != NULL) {
            fprintf(stderr, "\tArray:\t%d\n\n", ptr->pointer->id);
            disp_type(ptr->pointer);
        }
        break;
      case TYPE_TYPE_DEF:
        if (ptr->pointer != NULL) {
            fprintf(stderr, "\tTypdedef:\t%d\n\n", ptr->pointer->id);
            disp_type(ptr->pointer);
        }
        break;
      case TYPE_POINTER:
        if (ptr->pointer != NULL) {
            fprintf(stderr, "\tPointer:\t%d\n\n", ptr->pointer->id);
            disp_type(ptr->pointer);
        }
        break;
      case TYPE_FUNC:
        if (ptr->pointer != NULL) {
            fprintf(stderr, "\tFunction:\t%d\n\n", ptr->pointer->id);
            disp_type(ptr->pointer);
        }
        break;
      case TYPE_STRUCT_TAG:
      case TYPE_UNION_TAG:
        if (ptr->struc != NULL) {
            fprintf(stderr, "\tStructure:(%x)\t",ptr->struc);
            for (mems_l = ptr->struc; mems_l != NULL; mems_l = mems_l->next)
                if (mems_l->member_s != NULL)
                    fprintf(stderr, "%s(%d) ", mems_l->member_s->name,
                            mems_l->member_s->id);
            fprintf(stderr, "\n");
        }       
        break;
      case TYPE_DECLARATION:
        if (ptr->type > 0)
            fprintf(stderr, "\tType:\t%s\n", string_type[ptr->type-1]);
        if (ptr->length > 0)
            fprintf(stderr, "\tLength:\t%s\n", string_length[ptr->length - 1]);
        if (ptr->sign > 0)
            fprintf(stderr, "\tSign:\t%s\n", string_sign[ptr->sign - 1]);
        break;
      default:
        break;
    }
}

#endif /* DISP_TYPE *//********************************************************/

/* ͥ󥹤ȷͤٷͤϿ롥 */

TSP app_type_spec(void)
{
    TSP ptr_queue, ptr_ts;

#if TYPE_DEBUG
    spdMessage("app_type_spec()\n"); 
#endif

    if (ptr_ts_stack->sort->sort == 0) {
        ptr_ts_stack->sort->sort = TYPE_DECLARATION;
        ptr_ts_stack->sort->type = TYPE_INT;
    }
    ptr_queue = copy_type_spec(ptr_ts_stack->sort);
    ptr_queue->next = ptr_ts_stack->list;
    ass_ptr_queue(ptr_queue);
#ifdef TYPE_DEBUG
    disp_ptr_ts_stack(ptr_queue);
    disp_type(ptr_queue);
#endif
    ptr_ts = cmp_queue(ptr_queue);
#ifdef TYPE_DEBUG
    disp_type_id(ptr_ts);
    disp_type(ptr_ts);
    
    fprintf(stderr, "\n");
#endif
    ptr_ts_stack->list = NULL;
    pop_queue();                            /* ptr_ts_stack->queue = NULL; */
    push_queue();

    return ptr_ts;
}

TSP make_point_type(TSP ptr_type)
{
    TSP ptr_tmp;

    for (ptr_tmp = ts_list; ptr_tmp != NULL; ptr_tmp = ptr_tmp->next) {
        if (ptr_tmp->sort == TYPE_POINTER && ptr_tmp->pointer == ptr_type) {
#ifdef POINTER_DEBUG
            printf("& operator find type id:%d\n",ptr_tmp->id);
#endif
            break;
        }
    }
    if (!ptr_tmp) {
        ptr_tmp = insert_type(NULL,NULL);
        ptr_tmp->sort = TYPE_POINTER;
        ptr_tmp->pointer = ptr_type;
#ifdef POINTER_DEBUG
        printf("& operator create new type id:%d\n",ptr_tmp->id);
#endif
    }
    return ptr_tmp;
}

TSP get_non_pointer_type(TSP ptr)
{
    /* 
     * for (; ptr && (ptr->sort == TYPE_POINTER ||
     *                ptr->sort == TYPE_ARRAY ||
     *                ptr->sort == TYPE_FUNC ) ; ptr = ptr->pointer);
     */
    while (ptr && (ptr->sort == TYPE_POINTER || ptr->sort == TYPE_ARRAY ||
                   ptr->sort == TYPE_FUNC)) {
        ptr = ptr->pointer;
    }
    return ptr;
}

#ifdef REVISE_STRUCT_WITHOUT_MEMBER

/* 
 * Added by A.Yoshida 1999/08/02.
 * This function is for revising incorrect type objects of struct/union, 
 * which do not have pointers to members.                                
 */

TSP find_struct_with_members(char *name)
{
    TypeListP ptr = NULL;
    ScopeListP sc_list;

    for (sc_list = scope_list ; sc_list ; sc_list = sc_list -> next) {
        for (ptr = sc_list->scope->type_t ; ptr != NULL; ptr = ptr->next) {
            if (SPD_STREQ(ptr->type_s->name, name) &&
                (ptr->type_s->sort == TYPE_STRUCT_TAG ||
                 ptr->type_s->sort == TYPE_UNION_TAG) &&
                ptr->type_s->struc != NULL) {
                return ptr->type_s;
            }
        }
    }
    return NULL;
}
#endif
