/* 
 * Program:             $RCSfile: type_spec2.c,v $  $Revision: 30.10 $
 * 
 * Purpose:
 * 
 * Author:              N.Fukuyasu  1998/11/23
 *                      S.Yamamoto  1998/11/23
 * 
 * (C) Copyright:       N.Fukuyasu and S.Yamamoto  1998 - 2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: type_spec2.c,v 30.10 2003/07/30 16:27:31 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

/* #define TYPE_SPEC2_DEBUG */
#ifdef TYPE_SPEC2_DEBUG
static void dw_all_type_spec2(void);
static void dw_type_spec2(TS2P);
#endif

extern SpdString sdb_null_value;

extern FOP current_file;

TS2P ts2_list = NULL;       /* ¾ˤ碌 sdbin4.c ٤? */
static int ts2_num = 0;

/*
 *  type_spec2 
 * 줿 ts2_list Ǵơts2_list  unlist.c  free() 롥
 */

TS2P make_type_spec2(char *name, int sort, int qualifier, int type,
                     int length, int sign, WP wp)
{
    TS2P new_ts;

    new_ts = (TS2P)spdCalloc(1, sizeof(TypeSpec2));
    new_ts->id = INC_ID(ts2_num);

    if (name != NULL) {
        SPEC_NAME_COPY(new_ts->name, name);
    } else {
        new_ts->name = sdb_null_value;
    }
    new_ts->sort = sort;
    new_ts->qualifier = qualifier;
    new_ts->type = type;
    new_ts->length = length;
    new_ts->sign = sign;

    /*
     * new_ts  spdCalloc() Τǰʲס
     *
     * new_ts->type_st_prev = NULL;
     * new_ts->type_st_next = NULL;
     * new_ts->ident = NULL;
     * new_ts->array = NULL;
     */

    if (wp != NULL)
        new_ts->source = app_source_LC(NULL, wp->point, current_file);

    new_ts->deleted = FALSE;                /* ޡν */

    new_ts->next = ts2_list;
    if (ts2_list != NULL) {
        ts2_list->prev = new_ts;
    }
    ts2_list = new_ts;

#ifdef TYPE_SPEC2_DEBUG
    dw_type_spec2(new_ts);
#endif

    return (new_ts);
}

/* ts2_list  free */

void free_ts2_list(void)
{
    TS2P tmp_ts;

    while (ts2_list != NULL) {
        tmp_ts = ts2_list;
        ts2_list = ts2_list->next;
        free_type_list2(tmp_ts->type_st_next); /* type_st  free */
        free_EO_ListP(tmp_ts->array);       /* type_cexpr  free */
        free_Src_LC_P(tmp_ts->source);
        spdFree(tmp_ts);
    }
}

/* type_spec2 ΥꥹȤؤɲ */

TS2_ListP append_type_list2(TS2_ListP list, TS2P type_spec, SrcLCP source)
{
    TS2_ListP new_list;

    if (type_spec == NULL) return list;
    new_list = (TS2_ListP)spdCalloc(1, sizeof(TypeList2));
    new_list->type_spec = type_spec;

    new_list->source = (source == NULL ? NULL :
                        app_source_LC(NULL, source->point, current_file));

    new_list->next = list;
    if (list != NULL) {
        list->prev = new_list;
    }

    return (new_list);
}

/* type_list2  free */

void free_type_list2(TS2_ListP list)
{
    TS2_ListP tmp_list;

    while (list != NULL) {
        tmp_list = list;
        list = list->next;
        free_Src_LC_P(tmp_list->source);
        spdFree(tmp_list);
    }
}

/******************************************************************************/

/*
 * type_spec2 ˴ؤϢ
 */

/* Ϣ type_st  */

void make_type_st2(TS2P p_type, TS2P c_type)
{
    if (p_type == NULL || c_type == NULL) return;

    c_type->type_st_prev = p_type;
    p_type->type_st_next = append_type_list2(p_type->type_st_next, c_type,
                                             NULL);

#ifdef TYPE_SPEC2_DEBUG
    fprintf(stderr, "type_st p: %d   c: %d\n", p_type->id, c_type->id);
#endif
}

/* p_type  c_type_list δ֤δϢ type_st  */

void make_type_st2_list(TS2P p_type, TS2_ListP c_type_list)
{
    while (c_type_list != NULL) {
        make_type_st2(p_type, c_type_list->type_spec);
        c_type_list = c_type_list->next;
    }
}

/* Ϣ type_is  */

TS2P make_type_is2(TS2P type, IDOP ident)
{
    if (type == NULL || ident == NULL) return type;
    type->ident = ident;

#ifdef TYPE_SPEC2_DEBUG
    fprintf(stderr, "type_is type: %d   ident: %d\n", type->id, ident->id);
#endif

    return type;
}

/******************************************************************************/

/* ʲϡѿtmp_typeȤʤǡΤޤreturnФ褤ΤǤ? */ 

TS2P make_type_spec2_specifier(int type, WP wp)
{
    TS2P tmp_type;
    tmp_type = make_type_spec2(NULL, TYPE_DECLARATION, TYPE_UNKNOWN,
                               type, TYPE_UNKNOWN, TYPE_UNKNOWN, wp);
    return tmp_type;
}

TS2P make_type_spec2_size(int size, WP wp)
{
    TS2P tmp_type;
    tmp_type = make_type_spec2(NULL, TYPE_DECLARATION, TYPE_UNKNOWN,
                               TYPE_UNKNOWN, size, TYPE_UNKNOWN, wp);
    return tmp_type;
}

TS2P make_type_spec2_sign(int sign, WP wp)
{
    TS2P tmp_type;
    tmp_type = make_type_spec2(NULL, TYPE_DECLARATION, TYPE_UNKNOWN,
                               TYPE_UNKNOWN, TYPE_UNKNOWN, sign, wp);
    return tmp_type;
}

TS2P make_type_spec2_typedef(char *name, WP wp)
{
    TS2P tmp_type;
    tmp_type = make_type_spec2(name, TYPE_TYPE_DEF, TYPE_UNKNOWN,
                               TYPE_UNKNOWN, TYPE_UNKNOWN, TYPE_UNKNOWN, wp);
    return tmp_type;
}

TS2P make_type_spec2_struct(char *name, int sort, WP wp)
{
    TS2P tmp_type;
    tmp_type = make_type_spec2(name, sort, TYPE_UNKNOWN,
                               TYPE_UNKNOWN, TYPE_UNKNOWN, TYPE_UNKNOWN, wp);
    return tmp_type;
}

TS2P make_type_spec2_enum(char *name, WP wp)
{
    TS2P tmp_type;
    tmp_type = make_type_spec2(name, TYPE_ENUM_SPECIFIER, TYPE_UNKNOWN,
                               TYPE_UNKNOWN, TYPE_UNKNOWN, TYPE_UNKNOWN, wp);
    return tmp_type;
}

TS2P make_type_spec2_qualifier(int qualifier, WP wp)
{
    TS2P tmp_type;
    tmp_type = make_type_spec2(NULL, TYPE_DECLARATION, qualifier,
                               TYPE_UNKNOWN, TYPE_UNKNOWN, TYPE_UNKNOWN, wp);
    return tmp_type;
}

TS2P make_type_spec2_sort(int sort, WP wp)
{
    TS2P tmp_type;
    tmp_type = make_type_spec2(NULL, sort, TYPE_UNKNOWN,
                               TYPE_UNKNOWN, TYPE_UNKNOWN, TYPE_UNKNOWN, wp);
    return tmp_type;
}

/* 礭expr󷿤 */

TS2P make_type_spec2_array(WP expr, WP wp)
{
    TS2P tmp_type;
    tmp_type = make_type_spec2(NULL, TYPE_ARRAY, TYPE_UNKNOWN,
                               TYPE_UNKNOWN, TYPE_UNKNOWN, TYPE_UNKNOWN, wp);
    if (expr != NULL)
        tmp_type->array = insert_expression_list(NULL, expr->expr, expr);
    return tmp_type;
}

/* ۤ int ˤĤƤʤƤ֤ */

TS2P type_spec2_implicit_int(void)
{
    static TS2P implicit_int = NULL;

    if (implicit_int == NULL)
        implicit_int = make_type_spec2_specifier(TYPE_INT, NULL);

    return implicit_int;
}

/* deleted ռ type_spec  id 롥 */
int get_type_spec2_id(TS2P tmp_type)
{
    while (tmp_type != NULL && tmp_type->deleted) tmp_type = tmp_type->u_type;
    if (tmp_type == NULL) return SPD_NON_ID;
    return tmp_type->id;
}

/******************************************************************************/

/* ˴ؤԤ */

/*
 * ts2_ptr  type_st_next ǷФ type Τ *, [], ()() ǤʤΤ
 * 롥
 */

static TS2P next_ts2_specifier(TS2P ts2_ptr)
{
    TS2P next_type_spec;

    /* if (ts2_ptr == NULL) return NULL; */
    if (ts2_ptr->type_st_next == NULL) return NULL;
    next_type_spec = ts2_ptr->type_st_next->type_spec;
    if (next_type_spec->sort == TYPE_POINTER ||
        next_type_spec->sort == TYPE_ARRAY ||
        next_type_spec->sort == TYPE_FUNC) return NULL;

    return next_type_spec;
}

/* "unsined" - "long" - "int"  "unsined long int" ˤޤȤ롥 */

static void make_specifier_sub(TS2P ts2_ptr)
{
    TS2P next_ts2;

    char *name = NULL;
    int  sort = TYPE_UNKNOWN;
    int  qualifier = TYPE_UNKNOWN;
    int  type = TYPE_UNKNOWN;
    int  length = TYPE_UNKNOWN;
    int  sign = TYPE_UNKNOWN;
    IDOP ident = NULL;

    if (ts2_ptr == NULL) return;

    /* specifier or qualifier δ֡°ͤФƤޡ */
    while ((next_ts2 = next_ts2_specifier(ts2_ptr)) != NULL) {
        ts2_ptr->deleted = TRUE;
        ts2_ptr->u_type = next_ts2;

        if (!SPD_STREQ(ts2_ptr->name, ""))
            SPEC_NAME_COPY(name, ts2_ptr->name);
        if (ts2_ptr->sort != TYPE_UNKNOWN && sort != TYPE_TYPE_DEF)
            sort = ts2_ptr->sort;
        if (ts2_ptr->qualifier != TYPE_UNKNOWN) qualifier = ts2_ptr->qualifier;
        if (ts2_ptr->type != TYPE_UNKNOWN) type = ts2_ptr->type;
#ifdef ACCEPT_TYPE_LONG_LONG
        if (ts2_ptr->length == TYPE_LONG && length == TYPE_LONG)
            length = TYPE_LONG_LONG;
        else
#endif
            if (ts2_ptr->length != TYPE_UNKNOWN) length = ts2_ptr->length;
        if (ts2_ptr->sign != TYPE_UNKNOWN) sign = ts2_ptr->sign;

        if (ts2_ptr->ident != NULL) ident = ts2_ptr->ident;

        ts2_ptr = next_ts2;
    }

    if (ts2_ptr->sort != TYPE_DECLARATION) sort = ts2_ptr->sort;

#ifdef ACCEPT_TYPE_LONG_LONG
    if (ts2_ptr->length == TYPE_LONG && length == TYPE_LONG)
        length = TYPE_LONG_LONG;
#endif

    if (name != NULL) SPEC_NAME_COPY(ts2_ptr->name, name);
    if (sort != TYPE_UNKNOWN) ts2_ptr->sort = sort;
    if (qualifier != TYPE_UNKNOWN) ts2_ptr->qualifier = qualifier;
    if (type != TYPE_UNKNOWN) ts2_ptr->type = type;
    if (length != TYPE_UNKNOWN) ts2_ptr->length = length;
    if (sign != TYPE_UNKNOWN) ts2_ptr->sign = sign;
    if (ident != NULL) ts2_ptr->ident = ident;
    ts2_ptr->type_st_prev = NULL;           /* type_st  */
}

static void make_specifier(void)
{
    TS2P ts2_ptr;

    for (ts2_ptr = ts2_list; ts2_ptr != NULL; ts2_ptr = ts2_ptr->next) {
        if (ts2_ptr->type_st_prev == NULL) {
            make_specifier_sub(ts2_ptr);
        }
    }
}

/*
 * decr_type2 ĥƤʤ declarator ˤĤ ident_type2  type2 
 *  decr_type2 ĥ롥
 */

static void make_all_decr_type2_sub(DROP dt_ptr)
{
    IDOP ido_ptr;

    /* if (dt_ptr == NULL) return; */
    if (dt_ptr->id_l == NULL) return;

    ido_ptr = dt_ptr->id_l->ident;
    if (ido_ptr != NULL && ido_ptr->type2 != NULL)
        dt_ptr->type2 = ido_ptr->type2;
}

static void make_all_decr_type2(void)
{
    DROP dt_ptr;

    for (dt_ptr = dt_list; dt_ptr != NULL; dt_ptr = dt_ptr->next) {
        if (dt_ptr->type2 == NULL) {
            make_all_decr_type2_sub(dt_ptr);
        }
    }
}

/*
 * decl_type2 Τʤ declaration ˤĤưۤ int  decl_type2 ĥ롥
 * ؿΰ(DECL_PARAMETER)(DECL_ENUMERATOR) Ͻ
 */

static void make_all_decl_type2(void)
{
    DNOP do_ptr;

    for (do_ptr = do_list; do_ptr != NULL; do_ptr = do_ptr->next) {
        if (do_ptr->sort != DECL_PARAMETER &&
            do_ptr->sort != DECL_ENUMERATOR &&
            do_ptr->type2 == NULL) {
            do_ptr->type2 = append_type_list2(NULL, type_spec2_implicit_int(),
                                              NULL);
        }
    }
}

/*
 * "* const" ĤˤޤȤ롥
 */

static void unify_star_qualifier(void)
{
    TS2P ts2_ptr, ts2_prev;

    for (ts2_ptr = ts2_list; ts2_ptr != NULL; ts2_ptr = ts2_ptr->next) {
        ts2_prev = ts2_ptr->type_st_prev;
        if (ts2_ptr->qualifier != TYPE_UNKNOWN &&
            ts2_prev != NULL && ts2_prev->sort == TYPE_POINTER) {
            ts2_ptr->sort = ts2_prev->sort;
            ts2_ptr->type_st_prev = ts2_prev->type_st_prev;
            ts2_prev->id = ts2_ptr->id;
            ts2_prev->deleted = TRUE;
            ts2_prev->u_type = ts2_ptr;
        }
    }
}

/*
 * ٤ȤƤʤ typedef Τ type name Ǥ褦ʤ٤Ƥ
 * identifier ˤĤ type 롥
 * (type specifier ̾󤻤˹Ԥ)
 */
static void make_all_typedef(void)
{
    IDOP ido_ptr;

    for (ido_ptr = id_list; ido_ptr != NULL; ido_ptr = ido_ptr->next) {
        if (ido_ptr->sort == ID_TYPENAME) {
            TS2P tmp_type;
            tmp_type = make_type_spec2_typedef(ido_ptr->name, NULL);
            tmp_type = make_type_is2(tmp_type, ido_ptr);
        }
    }
}

/*
 * type specifier ͭ롥
 */
static SpdBoolean is_identical(const TS2P a, const TS2P b)
{
    if (a == NULL || b == NULL) return FALSE;
    if (a->sort != b->sort || a->qualifier != b->qualifier ||
        a->type != b->type || a->length != b->length ||
        a->sign != b->sign) return FALSE;
    if (a->sort == TYPE_FUNC) return FALSE;
 
    /*
     * Modified for suppress message "suggest parentheses around && within ||"
     * from gcc by S.Yamamoto 2000/03/19.
     * 
     * if (a->sort == TYPE_ARRAY && a->array != NULL || b->array != NULL) {
     *     return FALSE;
     * }
     */
    if ((a->sort == TYPE_ARRAY && a->array != NULL) || b->array != NULL) {
        return FALSE;
    }
    if (a->sort == TYPE_BUILTIN) {
        return SPD_STREQ(a->name, b->name);
    }

    if (a->ident != NULL && b->ident != NULL && a->ident->id == b->ident->id)
        return TRUE;
    if (a->ident != NULL || b->ident != NULL) return FALSE;
    if (a->sort == TYPE_STRUCT_TAG || a->sort == TYPE_UNION_TAG ||
        a->sort == TYPE_ENUM_SPECIFIER) return FALSE;

    return TRUE;
}

static TS2P copy_ts2(TS2P ts2_ptr)
{
    TS2P new_ts;

    new_ts = make_type_spec2(ts2_ptr->name, ts2_ptr->sort, ts2_ptr->qualifier,
                             ts2_ptr->type, ts2_ptr->length, ts2_ptr->sign,
                             NULL);
    if (ts2_ptr->array != NULL) {
        WD tmp_wp;
        tmp_wp.head_point = ts2_ptr->array->source->point;
        new_ts->array = insert_expression_list(NULL, ts2_ptr->array->expr,
                                               &tmp_wp);
    }
    new_ts = make_type_is2(new_ts, ts2_ptr->ident);

    return new_ts;
}

static void unify_type_spec2_sub(TS2_ListP ts2_l, TS2P ts2_ptr)
{
    TS2_ListP tmp_l, tmp_l2;
    TS2P tmp_type, u_type;

    if (ts2_l == NULL) return;

    for (tmp_l = ts2_l; tmp_l != NULL; tmp_l = tmp_l->next) {
        tmp_type = tmp_l->type_spec;
        while (tmp_type->deleted) tmp_type = tmp_type->u_type;
        for (tmp_l2 = ts2_ptr->type_st_next;
             tmp_l2 != NULL; tmp_l2 = tmp_l2->next) {
            u_type = tmp_l2->type_spec;
            if (is_identical(u_type, tmp_type)) break;
        }
        if (tmp_l2 == NULL) {
            /* tmp_type  tmp_l2 ˤʤ */
            /* Ʊ°ͤ type_spec2  */
            u_type = copy_ts2(tmp_type);
            make_type_st2(ts2_ptr, u_type);
        }
        tmp_type->id = u_type->id;
        tmp_type->deleted = TRUE;
        tmp_type->u_type = u_type;
        unify_type_spec2_sub(tmp_type->type_st_next, u_type);
    }
}

static void unify_type_spec2(void)
{
    TS2P ts2_ptr, u_type;
    TS2_ListP ut_list = NULL, tmp_list;

    for (ts2_ptr = ts2_list; ts2_ptr != NULL; ts2_ptr = ts2_ptr->next) {
        if (!ts2_ptr->deleted && ts2_ptr->type_st_prev == NULL) {
            /* ts2_ptr  type_st  root ʤ */
            for (tmp_list = ut_list; tmp_list != NULL;
                 tmp_list = tmp_list->next) {
                u_type = tmp_list->type_spec;
                /* ut_list  ts2_ptr ޤޤƤ */
                if (is_identical(u_type, ts2_ptr)) break;
            }
            if (tmp_list == NULL) {
                /* ut_list  ts2_ptr ޤޤƤʤä */
                /* Ʊ°ͤ type_spec2  */
                u_type = copy_ts2(ts2_ptr);
                /* ut_list Ͽ */
                ut_list = append_type_list2(ut_list, u_type, NULL);
            }
            ts2_ptr->id = u_type->id;
            ts2_ptr->deleted = TRUE;
            ts2_ptr->u_type = u_type;
            unify_type_spec2_sub(ts2_ptr->type_st_next, u_type);
        }
    }

    free_type_list2(ut_list);
}

/*
 * ˴ؤ
 */

void type2_post_process(void)
{
    /* int ٤ʤäΤ */
    type_spec2_implicit_int();

    make_specifier();
    make_all_decr_type2();
    make_all_decl_type2();
    unify_star_qualifier();
    make_all_typedef();
    unify_type_spec2();

#ifdef TYPE_SPEC2_DEBUG
    dw_all_type_spec2();
#endif
}

/******************************************************************************/

#ifdef TYPE_SPEC2_DEBUG

static void dw_all_type_spec2(void)
{
    TS2P tmp_ts;

    fprintf(stderr, "\n--- type_spec2 --------\n");

    for (tmp_ts = ts2_list; tmp_ts != NULL; tmp_ts = tmp_ts->next)
        dw_type_spec2(tmp_ts);

    fprintf(stderr, "-----------------------\n\n");
}

static void dw_type_spec2(TS2P ts)
{
    static char *dw_type_name[] = {
        "", "void ", "int ", "char ", "float ", "double ", "... "
    };
    static char *dw_type_qualifier[] = {
        "", "const ", "volatile "
    };
    static char *dw_type_length[] = {
        "", "short ", "long "
    };
    static char *dw_type_sign[] = {
        "", "signed ", "unsigned "
    };

    if (ts == NULL) return;

    fprintf(stderr, "%3d: ", ts->id);

    switch (ts->sort) {
      case TYPE_DECLARATION:
        fprintf(stderr, "%s", dw_type_name[ts->type]);
        break;
      case TYPE_POINTER:
        fprintf(stderr, "*   ");
        break;
      case TYPE_ARRAY:
        fprintf(stderr, "[");
        if (ts->array != NULL) fprintf(stderr, "(%d)", ts->array->expr->id);
        fprintf(stderr, "]  ");
        break;
      case TYPE_FUNC:
        fprintf(stderr, "()()");
        break;
      case TYPE_STRUCT_TAG:
        fprintf(stderr, "struct");
        if (ts->name != NULL) fprintf(stderr, " %s", ts->name);
        break;
      case TYPE_TYPE_DEF:
        if (ts->name != NULL) fprintf(stderr, "%s", ts->name);
        break;
      case TYPE_MEMBER:
        fprintf(stderr, "%d ¸ߤʤϤ", ts->sort);
        break;
      case TYPE_ENUM_SPECIFIER:
        fprintf(stderr, "enum");
        if (ts->name != NULL) fprintf(stderr, " %s", ts->name);
        break;
      case TYPE_UNION_TAG:
        fprintf(stderr, "union");
        if (ts->name != NULL) fprintf(stderr, " %s", ts->name);
        break;
      default:
        break;
    }

    fprintf(stderr, "%s%s%s", dw_type_qualifier[ts->qualifier],
            dw_type_length[ts->length], dw_type_sign[ts->sign]);

    if (ts->type_st_prev != NULL)
        fprintf(stderr, "\t-> %d ", ts->type_st_prev->id);

    if (ts->deleted == TRUE)
        fprintf(stderr, "(deleted)");

    fprintf(stderr, "\n");
}

#endif /* TYPE_SPEC2_DEBUG */
