/* 
 * Program:             $RCSfile: unlist.c,v $  $Revision: 30.12 $
 * 
 * Purpose:
 * 
 * Author:              S.Kawai  1996/09/10
 *                      S.Yamamoto  1996/09/10
 *
 * (C) Copyright:       S.Kawai and S.Yamamoto  1996 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: unlist.c,v 30.12 2003/07/08 05:47:07 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

extern TSP type_int;
extern MEMS_ListP mem_ref;
extern DataListP var_ref;
/* extern FunctionListP func_call; */
extern EO_ListP blk_expr;
extern DO_ListP blk_decl;
extern EO_ListP arg_expr;
extern DO_ListP file_decl;
extern TypeListP type_decl;
extern FunctionListP file_func;
/* extern BO_ListP func_blk; */
extern LevelPtr level;
extern FOP tmp_fo;

extern SpdBoolean       is_D_model;

/* extern char *target_program_name; */

extern FI FI_top[];

void free_Src_LC_P(Src_LC_P ptr)
{
    Src_LC_P    ptr_tmp;

    while (ptr != NULL) {
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_Var_Table(struct Var_Table *ptr)
{
    struct Var_Table *ptr_tmp;

    while (ptr != NULL) {
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_Enum_Table(struct Enum_Table *ptr)
{
    struct Enum_Table *ptr_tmp;

    while (ptr != NULL) {
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_Label_Table(LabelTablePtr ptr)
{
    LabelTablePtr ptr_tmp;

    while (ptr != NULL) {
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_TS_ListP(TypeListP ptr)
{
    /*
     * struct Source_LC *source;
     */
    TypeListP   ptr_tmp;

    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_DS_ListP(DataListP ptr)
{
    /*
     * struct Source_LC *source;
     */
    DataListP   ptr_tmp;

    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_CS_ListP(ConstListP ptr)
{
    /*
     * struct Source_LC *source;
     */
    ConstListP  ptr_tmp;

    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_FS_ListP(FunctionListP ptr)
{
    /*
     * struct Source_LC *source;
     */
    FunctionListP       ptr_tmp;

    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_MEMS_ListP(MEMS_ListP ptr)
{
    /*
     * struct Source_LC *source;
     */
    MEMS_ListP  ptr_tmp;

    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_SCP(SCP ptr)
{
    /*
     * struct Var_Table *var_t;
     * struct Enum_Table *const_t;
     * struct TS_List *type_t;
     */
    if (ptr != NULL) {
        free_Var_Table(ptr->var_t);
        free_Enum_Table(ptr->const_t);
        free_TS_ListP(ptr->type_t);
        spdFree(ptr);
    }
}

void free_FO_ListP(FO_ListP ptr)
{
    FO_ListP    ptr_tmp;

    while (ptr != NULL) {
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_DO_ListP(DO_ListP ptr)
{
    /*
     * struct Source_LC *source;
     */
    DO_ListP    ptr_tmp;

    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_DT_ListP(DT_ListP ptr)
{
    /*
     * struct Source_LC *source;
     */
    DT_ListP    ptr_tmp;

    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_IDO_ListP(IDO_ListP ptr)
{
    /*
     * struct Source_LC *source;
     */
    IDO_ListP   ptr_tmp;

    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_OD_ListP(OD_ListP ptr)
{
    /*
     * struct Source_LC *source;
     */
    OD_ListP    ptr_tmp;

    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_BO_ListP(BO_ListP ptr)
{
    /*
     * struct Source_LC *source;
     */
    BO_ListP    ptr_tmp;

    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_EO_ListP(EO_ListP ptr)
{
    /*
     * struct Source_LC *source;
     */
    EO_ListP    ptr_tmp;

    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_LO_ListP(LO_ListP ptr)
{
    /*
     * struct Source_LC *source;
     */
    LO_ListP    ptr_tmp;

    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_OO_ListP(OO_ListP ptr)
{
    /*
     * struct Source_LC *source;
     */
    OO_ListP    ptr_tmp;

    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_TSP(void)
{
    /* 
     * struct ExprObjectList *array;
     * struct MEMS_List *struc;
     * struct CS_List *enum_const;
     * struct Source_LC *source;
     */
    TSP     ptr, ptr_tmp;

    ptr = ts_list;
    while (ptr != NULL) {
        free_EO_ListP(ptr->array);
        /* free_MEMS_ListP(ptr->struc); */
        free_CS_ListP(ptr->enum_const);
        /* free_Src_LC_P(ptr->source); */

        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_CSP(void)
{
    /* 
     * char *doc;
     * char *value;
     * struct CS_List *const_s;
     * struct Source_LC *source;
     */
    CSP     ptr, ptr_tmp;

    ptr = cs_list;
    while (ptr != NULL) {
        spdFree(ptr->value);
        free_CS_ListP(ptr->const_s);
        free_Src_LC_P(ptr->source);

        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_DSP(void)
{
    /* 
     * char *doc;
     * struct Source_LC *source;
     */
    DSP     ptr, ptr_tmp;

    ptr = ds_list;
    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);

        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_FSP(void)
{
    /* 
     * char *doc;
     */
    FSP     ptr, ptr_tmp;

    ptr = fs_list;
    while (ptr != NULL) {
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_POP(void)
{
    /*
     * FO_ListP    file;
     */
    POP ptr, ptr_tmp;

    ptr = po_list;
    while (ptr != NULL) {
        free_FO_ListP(ptr->file);

        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_FOP(void)
{
    /*
     * char        *doc;
     * struct DeclObjectList *decl;
     * FO_ListP    fo_list;
     * struct SCOPE *scope;
     */
    FOP     ptr, ptr_tmp;

    ptr = fo_list;
    while (ptr != NULL) {
        free_DO_ListP(ptr->decl);
        free_FO_ListP(ptr->fo_list);
        free_SCP(ptr->scope);

        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_DNOP(void)
{
    DNOP    ptr, ptr_tmp;

    ptr = do_list;
    while (ptr != NULL) {
        /* free_DS_ListP(ptr->var); */
        free_TS_ListP(ptr->type);
        free_TS_ListP(ptr->type_ref);
        free_CS_ListP(ptr->const_l);
        free_FS_ListP(ptr->func_l);
        free_MEMS_ListP(ptr->mem_l);
        free_BO_ListP(ptr->block_l);
        free_DT_ListP(ptr->dt_l);

        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_DROP(void)
{
    DROP     ptr, ptr_tmp;

    ptr = dt_list;
    while (ptr != NULL) {
        free_IDO_ListP(ptr->id_l);
        free_OD_ListP(ptr->opt_l);

        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_ODP(void)
{
    /* 
     * struct DeclObjectList *decl_l;
     * struct BlockObjectList *block_l;
     * struct ExprObjectList  *initexpr_l;
     * struct TS_List *prototype;
     */
    ODP     ptr, ptr_tmp;

    ptr = od_list;
    while (ptr != NULL) {
        free_DO_ListP(ptr->decl_l);
        free_BO_ListP(ptr->block_l);
        free_EO_ListP(ptr->initexpr_l);
        free_TS_ListP(ptr->prototype);

        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_BOP(void)
{
    /* 
     * struct DeclObjectList *decl_list;
     * struct ExprObjectList *expr_list;
     * struct BlockObjectList *blk_list;
     * struct LabelObjectList *label_list;
     */
    BOP     ptr, ptr_tmp;

    ptr = bo_list;
    while (ptr != NULL) {
        free_DO_ListP(ptr->decl_list);
        free_EO_ListP(ptr->expr_list);
        free_BO_ListP(ptr->blk_list);
        free_LO_ListP(ptr->label_list);

        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_EOP(void)
{
    /* 
     * IDO_ListP  id_l;
     * ConstListP csl;
     * MEMS_ListP memsl;
     * DataListP dsl;
     * FunctionListP fsl;
     * TypeListP type;
     * struct LabelObjectList *label_list;
     * struct ExprObjectList *expr_list;
     * struct OperatorObjectList *op_list;
     */
    EOP     ptr, ptr_tmp;

    ptr = eo_list;
    while (ptr != NULL) {
        free_IDO_ListP(ptr->id_l);
        free_CS_ListP(ptr->csl);
        free_MEMS_ListP(ptr->memsl);
        free_DS_ListP(ptr->dsl);
        free_FS_ListP(ptr->fsl);
        free_TS_ListP(ptr->type);
        free_LO_ListP(ptr->label_list);
        free_EO_ListP(ptr->expr_list);
        free_OO_ListP(ptr->op_list);

        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_LOP(void)
{
    /* 
     * struct ExprObjectList *expr_l;
     */
    LOP     ptr, ptr_tmp;

    ptr = lo_list;
    while (ptr != NULL) {
        free_EO_ListP(ptr->expr_l);

        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_OOP(void)
{
    OOP     ptr, ptr_tmp;

    ptr = oo_list;
    while (ptr != NULL) {
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_IDOP(void)
{
    IDOP    ptr, ptr_tmp;

    ptr = id_list;
    while (ptr != NULL) {
        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_MEMSP(void)
{
    /* 
     * char *doc;
     * struct Source_LC *source;
     */
    MEMSP   ptr, ptr_tmp;

    ptr = mems_list;
    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);

        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

void free_ULP(void)
{
    /*
     * struct Source_LC *source;
     */
    ULP     ptr, ptr_tmp;

    ptr = undef_list;
    while (ptr != NULL) {
        free_Src_LC_P(ptr->source);

        ptr_tmp = ptr;
        ptr = ptr->next;
        spdFree(ptr_tmp);
    }
}

/*
 * make_type_spec() ǳݤ줿ΰ free
 *                                      N.Fukuyasu 1998/06/16.
 */
void free_ts_list2(void)
{
    /* 
     * struct ExprObjectList *array;
     * struct MEMS_List *struc;
     * struct CS_List *enum_const;
     * struct Source_LC *source;
     */
    TSP     ptr, ptr_tmp;

    ptr = ts_list2;
    while (ptr != NULL) {
        free_EO_ListP(ptr->array);
        /* free_MEMS_ListP(ptr->struc); */
        free_CS_ListP(ptr->enum_const);
        /* free_Src_LC_P(ptr->source); */

        ptr_tmp = ptr;
        ptr = ptr->ts_next;
        spdFree(ptr_tmp);
    }
}

/* "storage.c". */

void free_FI(void)
{
    FI      ptr, ptr_tmp;
    int     i;

    for (i = 0; i < HASH_SIZE; i++) {
        ptr = FI_top[i];
        while (ptr != NULL) {
            ptr_tmp = ptr;
            ptr = ptr->next;
            spdFree(ptr_tmp);
        }
    }
}

void init_ptr(char *target_prog)
{
    ts_list = NULL;
    cs_list = NULL;
    ds_list = NULL;
    fs_list = NULL;

    po_list = NULL;
    fo_list = NULL;
    do_list = NULL;
    dt_list = NULL;    
    od_list = NULL;
    bo_list = NULL;
    eo_list = NULL;
    lo_list = NULL;
    oo_list = NULL;

    id_list = NULL;
    scope_list = NULL;
    mems_list = NULL;
    undef_list = NULL;

    mem_ref = NULL;
    /* var_ref = NULL; */
    /* func_call = NULL; */
    blk_expr = NULL;
    blk_decl = NULL;
    arg_expr = NULL;
    file_decl = NULL;
    type_decl = NULL;
    file_func = NULL;
    /* func_blk = NULL; */
    tmp_fo = NULL;

    type_int = insert_type("", NULL);
    /* ts_list->sort = TYPE_DECLARATION; */
    /* ts_list->type = TYPE_INT;         */
    type_int->sort = TYPE_DECLARATION;
    type_int->type = TYPE_INT;
    
    init_operator();
    insert_level(SCOPE_GLOBAL);

    if (is_D_model) {
        po_list = insert_program(target_prog);  /* Note: Used only in D-model. */
    }

    init_FI();

    /*
     * make_type_spec() ǳݤ줿ΰ free 뤿Υꥹȡ
     * ts_list Ͽ줿 ts_next = ts_prev = NULL;
     *                                          N.Fukuyasu 1998/06/16.
     */
    ts_list2 = NULL;

#ifdef OLD_TYPE_SPEC2
    push_current_type_spec2(NULL);
#endif
}

void unlist(void)
{
    /* ʲ"main.h"extern declarationˤ */
    free_TSP();
    free_CSP();
    free_DSP();
    free_FSP();

    free_FOP();
    free_POP();
    free_MEMSP();
    free_DNOP();
    free_DROP();
    free_ODP();
    free_BOP();
    free_EOP();
    free_LOP();
    free_OOP();
    free_IDOP();

    /*
     * "sdbin4.c""free_scope_list()"ƤΤ
     * "free_ScopeListP()"θƤӽФס
     */
    /* free_ScopeListP(); */

    free_ULP();
    free_FI();          /* "storage.c". */

    /*
     * make_type_spec() ǳݤ줿ΰ free
     *                                  N.Fukuyasu 1998/06/16.
     */
    free_ts_list2();

#ifdef OLD_TYPE_SPEC2
    pop_current_type_spec2();
#endif
    free_ts2_list();
}
