/* 
 * Program:             $RCSfile: variable_spec.c,v $  $Revision: 30.12 $
 * 
 * Purpose:             ѿ˴ؤǡ١롼
 * 
 * Author:              K.Mabuchi  1991/09/30
 *                      S.Yamamoto  1992/04/01
 * Modified:            H.Ariga  1993/07/01
 * 
 * (C) Copyright:       K.Mabuchi, H.Ariga and S.Yamamoto  1991 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: variable_spec.c,v 30.12 2003/06/28 15:32:15 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

#ifdef DEBUG_951002
static void     show_data(DSP ptr);
#endif

extern SpdBoolean       F_model;

/* ֥ȼ̻Ҥѿ֥Ȥõ */
DSP find_v_id(int id)
{
    DSP ptr;

    for (ptr = ds_list; ptr != NULL; ptr = ptr->next)
        if (ptr->id == id) break;
    return ptr;
}

/* ץ༱̻Ҥѿ֥Ȥõ */
DSP find_data(char *name)
{
    DSP ptr = (DSP)NULL;
    LevelPtr lev ;
    struct Var_Table *var_t;
    

    for(lev = get_current_level() ; lev ; lev = lev->next) {
        for(var_t = lev->var_t ;  var_t ; var_t = var_t->next) {
            if (SPD_STREQ(var_t->var_s->name, name)) {
                ptr = var_t->var_s;
            }
        }
    }
    return ptr;
}

/* ץ༱̻ҤХѿ֥Ȥõ */
DSP find_data_in_global(char *name)
{
    DSP ptr = (DSP)NULL;
    LevelPtr lev ;
    /* LevelPtr get_current_level(); */
    struct Var_Table *var_t;

#ifdef DEBUG_FIND_DATA_IN_GLOBAL
    printf("find_data_in_global: called\n");
#endif  
    lev = find_level_has_type(SCOPE_GLOBAL);
#ifdef DEBUG_FIND_DATA_IN_GLOBAL
    printf("find_data_in_global: lev = %x\n",lev);
#endif  
    for(var_t = lev->var_t ;  var_t ; var_t = var_t->next) {
        if (SPD_STREQ(var_t->var_s->name, name)) {
            ptr = var_t->var_s;
        }
    }
#ifdef DEBUG_FIND_DATA_IN_GLOBAL
    printf("find_data_in_global: ptr = %x\n",ptr);
#endif  
    return ptr;
}

/******************************************************************************/

/* Added by: A.Yoshida, 1999/07/05 */
/* This function is called only from insert_data(). */

static SpdBoolean is_same_type(TSP type1, TSP type2, SpdBoolean *quali_comp)
{
    /* Note: In this function, *quali_comp is set FALSE only when 
       qualifier is incompatible. *quali_comp should be initialized 
       to TRUE before called. */

    if (type1 == type2) {
        /* If type1 and type2 are exactly same, type1 and type2 have
           the same pointer to type structure. */
        return TRUE;
    }

    /* Shift to real type from typedef-ed type. */
    if (type1->sort == TYPE_TYPE_DEF) {
        return is_same_type(type1->pointer, type2, quali_comp);
    }
    if (type2->sort == TYPE_TYPE_DEF) {
        return is_same_type(type1, type2->pointer, quali_comp);
    }

    if (type1->qualifier != type2->qualifier) {
        *quali_comp = FALSE;    /* Incompatible qualifier */
    }

    /* Test type compatibility. */
    switch (type1->sort) {
    case TYPE_DECLARATION:
        if (type2->sort == TYPE_ENUM_SPECIFIER && type1->type == TYPE_INT) {
            return TRUE;
            /* See the note in the case of TYPE_ENUM_SPECIFIER. */
        }
        if (type2->sort != TYPE_DECLARATION) return FALSE;
        if ((type1->type == type2->type && type1->type == TYPE_INT)
            || (type1->type == TYPE_INT && type2->type == TYPE_UNKNOWN)
            || (type1->type == TYPE_UNKNOWN && type2->type == TYPE_INT)) {

            if ((type1->sign != type2->sign)
                && (type1->sign == TYPE_UNSIGNED 
                    || type2->sign == TYPE_UNSIGNED)) {
                /* Note: assuming that integer is signed. */
                return FALSE;
            }
            if (type1->length == type2->length){
                return TRUE;
            }
            return FALSE;
        } else if (type1->type == TYPE_CHAR && type2->type == TYPE_CHAR) {
            /* Note: gcc treats signed (or unsigned) char and (no sign) char 
               as conflicting types. */
            if (type1->sign == type2->sign) {
                return TRUE;
            }
            return FALSE;
        }
        break;
    case TYPE_POINTER:
        if (type2->sort != TYPE_POINTER) return FALSE;
        if (is_same_type(type1->pointer, type2->pointer, quali_comp)) {
            return TRUE;
        }
        break;
    case TYPE_ARRAY:
        if (type2->sort != TYPE_ARRAY) return FALSE;
        if (!is_same_type(type1->pointer, type2->pointer, quali_comp)) {
            break;
        }
        /* Testing the equality of array sizes is difficult. */
        /* Ignore array sizes as work arround. */
        return TRUE;

#if 0
        /* Dangerous pointer accesses. */
        if (type1->array->expr->csl != NULL
            && type2->array->expr->csl != NULL
            && SPD_STREQ(type1->array->expr->csl->const_s->value,
                         type2->array->expr->csl->const_s->value)) {
            /* In this case, same immediate values are specified as 
               array size. */
            return TRUE;
        }
        if (type1->array->expr->id_l != NULL
            && type2->array->expr->id_l != NULL
            && type2->array->expr->id_l->ident ==
            type1->array->expr->id_l->ident) {
            /* In this case, same enumerators are specfied as array size. */
            return TRUE;
        }
        /* Note: an enumerator in array size should be treated as constant 
           value. But, there is no easy way to know the real value of
           the enumerator. So, the following case is not supported:
           enum {ONE=1, TWO}; int x[TWO]; int x[2];
           gcc has been supported this case. */
#endif /* 0 */

        break;
    case TYPE_FUNC:
        if (type2->sort != TYPE_FUNC) return FALSE;
        /* Shift to returned values' type. */
        return is_same_type(type1->pointer, type2->pointer, quali_comp);
        /* Note: arguments should be tested. But, how to get them? */
    case TYPE_ENUM_SPECIFIER:
        if (type2->sort == TYPE_ENUM_SPECIFIER) {
            if (type1->ident == NULL && type2->ident == NULL) {
                return TRUE;
            }
            if (type1->ident != NULL && type2->ident != NULL
                && SPD_STREQ(type1->ident->name, type2->ident->name)) {
                return TRUE;
            }
            return FALSE;
        }
        if (type2->sort == TYPE_DECLARATION && type2->type == TYPE_INT) {
            /* If an enum specifier has an enumerator whose value is negative, 
               the type of the enum specifier is SIGNED INT, otherwise 
               UNSIGNED INT. But there is no way to know the existence
               of such an enumerator. For upper compatibility, enum specifiers
               are to be treated as same type with INT. */
            return TRUE;
        }
        break;
    case TYPE_STRUCT_TAG:
    case TYPE_UNION_TAG:
        if (type1->sort == type2->sort 
            && SPD_STREQ(type1->name, type2->name)) {
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

/******************************************************************************/

/* ѿ֥Ȥɲ */
DSP insert_data(char *name, TSP type, int sort, int class, int point, FOP file)
{
    DSP         new, ptr;
    ULP         tmp_ul;
    static int  ds_num = 0;
    SpdBoolean          dup_var_flag = FALSE;
    SpdBoolean          quali_comp = TRUE; /* Must be initialized to TRUE. */

    if (class == STORAGE_EXTERN && (ptr = find_data_in_global(name)) != NULL) {
        if (!is_same_type(type, ptr->type, &quali_comp)) {
            yyerror("Conflicting types of variables.");
        }
        if (!quali_comp) {
            spdWarning("Incompatible qualifiers for variable: \"%s\".\n",
                       name);
            /* In some cases, incompatible qualifiers are not allowed. 
               For example, "const int *p" in global name space and 
               "extern int *p" in local name space are not allowed because
               of type confliction. But, for the sake of simpleness, these
               illegal cases are ignored. */
        }
        return ptr;
    } else if (sort == VAR_GLOBAL) {
        if (find_identifier_in_same_scope(name, SCOPE_FILE)) {
            spdWarning("Redefined static variable \"%s\" in file scope.\n",
                       name);
            dup_var_flag = TRUE;
        } else if (find_identifier_in_same_scope(name, SCOPE_GLOBAL)) {
            ptr = find_data(name);
            if (ptr != NULL && ptr->class == STORAGE_EXTERN) {
                ptr->class = class ;
                ptr->source = app_source_LC(NULL,point,file);
                return ptr;
            }
            spdWarning("Redefined variable \"%s\" in global scope.\n", name);
            dup_var_flag = TRUE;
        }
    } else if (find_identifier_in_same_scope(name, SCOPE_LOCAL)) {
        spdWarning("Redefined variable \"%s\" in local scope.\n", name);
        if (F_model && (ptr = find_data(name)) != NULL) {
            /* Is this realy needed for F-model? Is there any program
               declaring two variables of same name in a local scope? */
            return ptr;
        }
        /* Gcc does not allow this case. */
        yyerror("");
    }
    if (dup_var_flag && (ptr = find_data(name)) != NULL) {
        if (F_model) return ptr;
        if (!is_same_type(type, ptr->type, &quali_comp)) {
            yyerror("Conflicting types of variables.");
        }
        if (!quali_comp) { /* See above. */
            spdWarning("Incompatible qualifiers for variable: \"%s\".\n",
                       name);
        }
        return ptr;
    }

    new = (DSP)spdCalloc(1, sizeof(struct DS));
    new->id = INC_ID(ds_num);
    SPEC_NAME_COPY(new->name, name);
    new->sort = sort;
    new->type = type;
    new->class = class;
    if (class != STORAGE_EXTERN) {
        new->source = app_source_LC(NULL,point,file);
    }
    if ((tmp_ul = find_undefined_identifier(name)) != NULL) {
        new->source = cat_source_LC(tmp_ul->source,new->source);
    }
    new->next = ds_list;
    /* new->prev = NULL; */     /* No effect because allocated by calloc(). */
    if (ds_list != NULL) {
        ds_list->prev = new;
    }
    ds_list = new;

    return (new);
}

/* ǡꥹȤɲ */
/* struct DS_List *insert_data_list(struct DS_List *list, DSP ptr_ds, WP ptr) */
/* struct DS_List *insert_data_list(DataListP list, DSP ptr_ds, WP ptr) */
/* struct DS_List *insert_data_list(DS_ListP list, DSP ptr_ds, WP ptr) */

DS_ListP insert_data_list(DS_ListP list, DSP ptr_ds, WP ptr)
{
    DS_ListP        new;
    extern FOP      current_file;
    
    new = (DS_ListP)spdCalloc(1, sizeof(struct DS_List));
    new->source =
        (ptr != NULL) ? app_source_LC(NULL, ptr->point, current_file) : NULL;
    new->data_s = ptr_ds;
    new->next = list;
    /* new->prev = NULL; */     /* No effect because allocated by calloc(). */
    if (list != NULL) {
        list->prev = new;
    }
    return new;
}

struct DS_List *insert_gbl_list(struct DS_List *list, char *name)
{
    DSP ptr;
    struct DS_List *ds_l;

    if ((ptr = find_data(name)) != NULL) {
        for (ds_l = list; ds_l != NULL; ds_l = ds_l->next)
            if (ds_l->data_s == ptr) return list;
        list = insert_data_list(list, ptr,NULL);
    }
    return list;
}

/******************************************************************************/

#ifdef DEBUG_951002

static void show_data(DSP ptr)
{
    if (ptr) {
        printf("data id %d %s %d\n", ptr->id,ptr->name,ptr->class);
#ifdef DISP_TYPE_0
        disp_type(ptr->type);
#endif      
    } else {
        printf("data ptr is NULL\n");
    }
}

#endif /* DEBUG_951002 */

TSP app_var_pos(WP ptr)
{
    DSP ptr_vs = (DSP)NULL;
    FSP ptr_fs = (FSP)NULL;
    IDOP ptr_id = (IDOP)NULL;
    extern DataListP var_ref ;
    extern IDO_ListP ident_ref;

    if (!(ptr_vs = find_var_pos(ptr->name)))
        if(!(ptr_fs = find_function(ptr->name))) {
            app_undefined_identifier(ptr);
        }
    if (ptr_vs) {
#ifdef IDENT_DEBUG
        fprintf(stderr,"app_var_pos ident id = %d\n",
                find_identifier_by_ptr(ptr_vs,ID_VARIABLE)->id);
#endif
        var_ref = insert_data_list(var_ref, ptr_vs, ptr);
        ptr_id = find_identifier_by_ptr(ptr_vs,ID_VARIABLE);
#ifdef DEBUG_950319
        if (ptr_id == (IDOP)NULL) {
            fprintf(stderr, "Cannot find var identifier %s line:%d\n",
                    ptr->name, yylineno);
        }
#endif
        ident_ref =
            insert_identifier_list(ident_ref, ptr_id, ptr);
        return ptr_vs->type;
    }
    if (ptr_fs) {
#ifdef IDENT_DEBUG
        fprintf(stderr,"app_var_pos ident id = %d\n",
                find_identifier_by_ptr(ptr_vs,ID_VARIABLE)->id);
#endif
#ifdef DEBUG_950319
        if (ptr_id == (IDOP)NULL) {
            fprintf(stderr, "Can't find var identifier %s line:%d\n",
                    ptr->name, yylineno);
        }
#endif
        ptr_id = find_identifier_by_ptr(ptr_fs,ID_FUNCTION);
        ident_ref =
            insert_identifier_list(ident_ref, ptr_id,ptr);
                   
        return ptr_fs->type;
    }
    return (TSP)NULL;
}

DSP find_var_list(struct DS_List* list, char *name)
{
    for (; list != NULL; list = list->next) {
        if (SPD_STREQ(name, list->data_s->name)) {
            return list->data_s;
        }
    }
    return NULL;
}
