/* 
 * Program:             $RCSfile: write_sdb.c,v $  $Revision: 30.45 $
 * 
 * Purpose:             ǡ١եϥ롼
 * 
 * Author:              K.Mabuchi  1991/09/30
 *                      S.Yamamoto  1992/04/01
 * Modified:            H.Ariga  1993/06/01
 * 
 * (C) Copyright:       K.Mabuchi, H.Ariga and S.Yamamoto  1991 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: write_sdb.c,v 30.45 2003/06/01 06:14:40 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/write_sdb_sub.h>
#include "ISDB.h"
#include "main.h"
#include "prototype.h"

static int get_ident_scope(int storage);

extern SpdBoolean   legacy_type;
extern SpdBoolean   is_D_model;

/* 
 * ǡ١ץηȤνϴؿ
 * 
 * °ͤϡSPD_DBT_INT (intǡ), SPD_DBT_STR ("char *"ǡ)
 * 줫Ǥ롥
 * 
 * ǡ١ˤϥХʥ(ǥե)ȥƥȷ(ǥХå)
 * Ĥη롥<SDB_ATTR_SEPARATOR>ϥޥSDB_ATTR_SEPARATOR
 * Ƥ롥
 * 
 * (1) Хʥ
 * °ζڤȥץζڤ¸ߤʤ
 * 
 * SPD_DBT_INTCint׻endian˰¸4Хʬdump롥
 * 
 * SPD_DBT_STRʸȤƽϤθ'\0'Ϥ롥
 * 
 * (2) ƥȷ
 * Ĥ°ϡ<VALUE><SDB_ATTR_SEPARATOR>ɽ졤ĤΥץ
 * °¤ӤȤɽ롥ץν'\n'Ϥ롥
 * 
 * SPD_DBT_INTCintprintf()ؿ"%d"ǽϤθ
 * <SDB_ATTR_SEPARATOR>Ϥ롥 
 * 
 * SPD_DBT_STRʸȤƽϤ('\0'ղäʤ)θˡ
 * <SDB_ATTR_SEPARATOR>Ϥ롥 
 */
/* 
 * Modified by R.Miura in Sapid-2.347 1997/10/24.
 * class_table[]ȤݤĤᡤƥ饹Фƴؿwrite_xxx_sub()
 * ѰդƤ֤褦ˤ
 * 
 * Modified by R.Miura 1997/06/16.
 * ؿwrite_xxx_xxx()򡤽񤭹󥹥󥹤ο֤褦ѹ
 * 񤭹Ĥޤʣ줵ƤʤäΤǡ
 * ɤǵۼ뤫¤ääȤʤ
 * 
 * Modified by S.Yamamoto 2000/03/18.
 * ԤޤSPD_DBT_STR°򰷤褦ˤ뤿ˡƥȥ⡼ɤ
 * <SDB_ATTR_SEPARATOR><VALUE><VALUE><SDB_ATTR_SEPARATOR>
 * ѹ
 */

/* 
 * Classes.
 */

static int write_type(FILE *out, TSP ptr)
{
    if (ptr->sort != TYPE_UNKNOWN) {
        write_type_sub(out,
                       ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE),
                       ptr->sort,
                       ptr->qualifier,
                       ptr->type,
                       ptr->length,
                       ptr->sign,
                       ptr->name);
        return 1;
    } else {
        spdError("write_type(): %d: Unknown type sort.\n", ptr->sort);
        return 0;
    }
}

static int write_type2(FILE *out, TS2P ptr)
{
    static int id = 0;

    /* ޡդƤϤʤ */
    if (ptr->deleted == TRUE) {
        return 0;
    }

    if (ptr->sort != TYPE_UNKNOWN) {
        ptr->id = id++;
        write_type_sub(out,
                       ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE),
                       ptr->sort,
                       ptr->qualifier,
                       ptr->type,
                       ptr->length,
                       ptr->sign,
                       ptr->name);
        return 1;
    } else {
        spdError("write_type(): %d: Unknown type sort.\n", ptr->sort);
        return 0;
    }
}

static int write_constant(FILE *out, CSP ptr)
{
    if (ptr->type != CONST_ENUM) { 
        write_constant_sub(out,
                           ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_CONSTANT),
                           ptr->length,
                           ptr->type,
                           ptr->value);
        return 1;
    }
    return 0;
}

static int write_identifier(FILE *out, IDOP ptr)
{
    write_identifier_sub(out,
                         ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_IDENTIFIER),
                         ptr->length,
                         ptr->sort,
                         get_ident_scope(ptr->ISDB_storage),
                         ptr->name);
    return 1;
}

static int write_declaration(FILE *out, DNOP ptr)
{
    write_declaration_sub(out,
                          ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATION),
                          ptr->length,
                          ptr->sort,
                          ptr->storage);
    return 1;
}

static int write_declarator(FILE *out, DROP ptr)
{
    write_declarator_sub(out,
                         ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATOR),
                         ptr->length,
                         ptr->sort);
    return 1;
}

static int write_optionaldecl(FILE *out, ODP ptr)
{
    write_optionaldecl_sub(out,
                           ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_OPTIONALDECL),
                           ptr->length,
                           ptr->sort);
    return 1;
}

static int write_block(FILE *out, BOP ptr)
{
    write_block_sub(out,
                    ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_BLOCK),
                    ptr->length,
                    ptr->sort);
    return 1;
}

static int write_expression(FILE *out, EOP ptr)
{
    write_expression_sub(out,
                         ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_EXPRESSION),
                         ptr->length,
                         ptr->sort,
                         ptr->lrtype);
    return 1;
}

static int write_label(FILE *out, LOP ptr)
{
    write_label_sub(out,
                    ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_LABEL),
                    ptr->length,
                    ptr->sort,
                    ptr->name);
    return 1;
}

static int write_operator(FILE *out, OOP ptr)
{
    write_operator_sub(out,
                       ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_OPERATOR),
                       ptr->length,
                       ptr->sort);
    return 1;
}

/*
 * Relationships.
 */

static int write_func_parm(FILE *out, ODP ptr)
{
    DO_ListP do_l;
    int count = 0;

    for (do_l = ptr->decl_l; do_l; do_l = do_l->next) {
        write_func_parm_sub(out,
                            ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_OPTIONALDECL),
                            do_l->decl->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATION),
                            do_l->source->point);
        count++;
    }
    return count;
}

static int write_struct_decl(FILE *out, ODP ptr)
{
    DO_ListP do_l;
    int count = 0;

    for (do_l = ptr->decl_l; do_l; do_l = do_l->next) {
        write_struct_decl_sub(out,
                              ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_OPTIONALDECL),
                              do_l->decl->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATION),
                              do_l->source->point);
        count++;
    }
    return count;
}

static int write_decl_decl(FILE *out, DNOP ptr)
{
    DT_ListP dt_l;
    int count = 0;

    for (dt_l = ptr->dt_l; dt_l; dt_l = dt_l->next) {
        write_decl_decl_sub(out,
                            ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATION),
                            dt_l->dt->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATOR),
                            dt_l->source->point);
        count++;
    }
    return count;
}

static int write_decl_ident(FILE *out, DROP ptr)
{
    IDO_ListP id_l;
    int count = 0;

    for (id_l = ptr->id_l; id_l; id_l = id_l->next) {
        write_decl_ident_sub(out,
                             ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATOR),
                             id_l->ident->id + SPD_OBJ_ID_OFFSET(SPD_CID_IDENTIFIER),
                             id_l->source->point);
        count++;
    }
    return count;
}

static int write_ident_type(FILE *out, IDOP ptr)
{
    if (legacy_type) {
        if (ptr->type != NULL) {
            write_ident_type_sub(out,
                                 ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_IDENTIFIER),
                                 ptr->type->id + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE));
            return 1;
        }
    } else {
        if (ptr->type2 != NULL) {
            write_ident_type_sub(out,
                                 ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_IDENTIFIER),
                                 get_type_spec2_id(ptr->type2) + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE));
            return 1;
        }
    }
    return 0;
}

static int write_type_st(FILE *out, TSP ptr)
{
    if (ptr->sort == TYPE_POINTER || ptr->sort == TYPE_FUNC ||
        ptr->sort == TYPE_ARRAY) {
        if (ptr->pointer != NULL) {
            write_type_st_sub(out,
                              ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE),
                              ptr->pointer->id + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE));
            return 1;
        }
    }
    return 0;
}

static int write_type_st2(FILE *out, TS2P ptr)
{
    /* ޡդƤϤʤ */
    if (ptr->deleted == TRUE) {
        return 0;
    }

    if (ptr->type_st_prev != NULL) {
        write_type_st_sub(out,
                          get_type_spec2_id(ptr) + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE),
                          get_type_spec2_id(ptr->type_st_prev) + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE));
        return 1;
    }
    return 0;
}

static int write_type_is(FILE *out, TSP ptr)
{
    if (ptr->sort == TYPE_TYPE_DEF || ptr->sort == TYPE_STRUCT_TAG ||
        ptr->sort == TYPE_ENUM_SPECIFIER || ptr->sort == TYPE_UNION_TAG) {
        if (ptr->ident != NULL) {
            write_type_is_sub(out,
                              ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE),
                              ptr->ident->id + SPD_OBJ_ID_OFFSET(SPD_CID_IDENTIFIER));
            return 1;
        }
    }
    return 0;
}

static int write_type_is2(FILE *out, TS2P ptr)
{
    /* ޡդƤϤʤ */
    if (ptr->deleted == TRUE) {
        return 0;
    }

    if (ptr->sort == TYPE_TYPE_DEF || ptr->sort == TYPE_STRUCT_TAG ||
        ptr->sort == TYPE_ENUM_SPECIFIER || ptr->sort == TYPE_UNION_TAG) {
        if (ptr->ident != NULL) {
            write_type_is_sub(out,
                              get_type_spec2_id(ptr) + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE),
                              ptr->ident->id + SPD_OBJ_ID_OFFSET(SPD_CID_IDENTIFIER));
            return 1;
        }
    }
    return 0;
}

static int write_file_decl(FILE *out, FOP ptr)
{
    DO_ListP do_l;
    int count = 0;

    for (do_l = ptr->decl; do_l != NULL; do_l = do_l->next) {
        /* Modified by N.Fukuyasu 1999/08/26. */
        write_file_decl_sub(out,
                            ptr->id /* + SPD_OBJ_ID_OFFSET(SPD_CID_FILE) */,
                            do_l->decl->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATION),
                            do_l->source->point);
        count++;
    }
    return count;
}

static int write_init_expr(FILE *out, ODP ptr)
{
    EO_ListP eo_l;
    int count = 0;

    for (eo_l = ptr->initexpr_l; eo_l; eo_l = eo_l->next) {
        write_init_expr_sub(out,
                            ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_OPTIONALDECL),
                            eo_l->expr->id + SPD_OBJ_ID_OFFSET(SPD_CID_EXPRESSION),
                            eo_l->source->point); 
        count++;
    }
    return count;
}

static int write_func_body(FILE *out, ODP ptr)
{
    BO_ListP bo_l;
    int count = 0;

    for (bo_l = ptr->block_l; bo_l; bo_l = bo_l->next) {
        write_func_body_sub(out,
                            ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_OPTIONALDECL),
                            bo_l->block_s->id + SPD_OBJ_ID_OFFSET(SPD_CID_BLOCK),
                            bo_l->source->point);
        count++;
    }
    return count;
}

static int write_blk_decl(FILE *out, BOP ptr)
{
    DO_ListP do_l;
    int count = 0;

    for (do_l = ptr->decl_list; do_l; do_l = do_l->next) {
        write_blk_decl_sub(out,
                           ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_BLOCK),
                           do_l->decl->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATION),
                           do_l->source->point);
        count++;
    }
    return count;
}

static int write_blk_expr(FILE *out, BOP ptr)
{
    EO_ListP eo_l;
    int count = 0;

    for (eo_l = ptr->expr_list; eo_l; eo_l = eo_l->next) {
        write_blk_expr_sub(out,
                           ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_BLOCK),
                           eo_l->expr->id + SPD_OBJ_ID_OFFSET(SPD_CID_EXPRESSION),
                           eo_l->source->point);
        count++;
    }
    return count;
}

static int write_blk_label(FILE *out, BOP ptr)
{
    LO_ListP lo_l;
    int count = 0;

    for (lo_l = ptr->label_list; lo_l; lo_l = lo_l->next) {
        write_blk_label_sub(out,
                            ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_BLOCK),
                            lo_l->label_s->id + SPD_OBJ_ID_OFFSET(SPD_CID_LABEL),
                            lo_l->source->point);
        count++;
    }
    return count;
}

static int write_case_cexpr(FILE *out, LOP ptr)
{
    if (ptr->sort == LABEL_CASE) {
        write_case_cexpr_sub(out,
                             ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_LABEL),
                             ptr->expr_l->expr->id + SPD_OBJ_ID_OFFSET(SPD_CID_EXPRESSION),
                             ptr->expr_l->source->point);
        return 1;
    }
    return 0;
}

static int write_blk_blk(FILE *out, BOP ptr)
{
    BO_ListP bo_l;
    int count = 0;

    for (bo_l = ptr->blk_list; bo_l; bo_l = bo_l->next) {
        write_blk_blk_sub(out,
                          ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_BLOCK),
                          bo_l->block_s->id + SPD_OBJ_ID_OFFSET(SPD_CID_BLOCK),
                          bo_l->source->point);
        count++;
    }
    return count;
}

static int write_const_ref(FILE *out, EOP ptr)
{
    ConstListP cs_l;
    int count = 0;

    for (cs_l = ptr->csl; cs_l; cs_l = cs_l->next) {
        write_const_ref_sub(out,
                            ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_EXPRESSION),
                            cs_l->const_s->id + SPD_OBJ_ID_OFFSET(SPD_CID_CONSTANT),
                            cs_l->source->point);
        count++;
    }
    return count;
}

static int write_ident_ref(FILE *out, EOP ptr)
{
    IDO_ListP id_l;
    int count = 0;

    for (id_l = ptr->id_l; id_l; id_l = id_l->next) {
        write_ident_ref_sub(out,
                            ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_EXPRESSION),
                            id_l->ident->id + SPD_OBJ_ID_OFFSET(SPD_CID_IDENTIFIER),
                            id_l->source->point);
        count++;
    }
    return count;
}

static int write_type_cexpr(FILE *out, TSP ptr)
{
    if (ptr->sort == TYPE_ARRAY) {
        if (ptr->array != NULL) {
            write_type_cexpr_sub(out,
                                 ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE),
                                 ptr->array->expr->id + SPD_OBJ_ID_OFFSET(SPD_CID_EXPRESSION),
                                 ptr->array->source->point);
            return 1;
        }
    }
    return 0;
}

static int write_type_cexpr2(FILE *out, TS2P ptr)
{
    /* ޡդƤϤʤ */
    if (ptr->deleted == TRUE) {
        return 0;
    }

    if (ptr->sort == TYPE_ARRAY) {
        if (ptr->array != NULL) {
            write_type_cexpr_sub(out,
                                 get_type_spec2_id(ptr) + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE),
                                 ptr->array->expr->id + SPD_OBJ_ID_OFFSET(SPD_CID_EXPRESSION),
                                 ptr->array->source->point);
            return 1;
        }
    }
    return 0;
}

static int write_decl_type(FILE *out, DNOP ptr)
{
    TypeListP ts_l;
    int count = 0;

    if (legacy_type) {
        for (ts_l = ptr->type_ref; ts_l; ts_l = ts_l->next) {
            write_decl_type_sub(out,
                                ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATION),
                                ts_l->type_s->id + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE),
                                ts_l->source->point);
            count++;
        }
    } else {
        TS2_ListP ts2_l;
        for (ts2_l = ptr->type2; ts2_l != NULL; ts2_l = ts2_l->next) {
            write_decl_type_sub(out,
                                ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATION),
                                get_type_spec2_id(ts2_l->type_spec) + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE),
                                (ts2_l->source != NULL) ?
                                ts2_l->source->point : SPD_NON_OFFSET);
            count++;
        }
    }
    return count;
}

static int write_expr_expr(FILE *out, EOP ptr)
{
    EO_ListP eo_l;
    int count = 0;

    for (eo_l = ptr->expr_list; eo_l; eo_l = eo_l->next) {
        write_expr_expr_sub(out,
                            ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_EXPRESSION),
                            eo_l->expr->id + SPD_OBJ_ID_OFFSET(SPD_CID_EXPRESSION),
                            eo_l->source->point);
        count++;
    }
    return count;
}

static int write_goto_label(FILE *out, EOP ptr)
{
    LO_ListP lo_l;
    int count = 0;

    for (lo_l = ptr->label_list; lo_l; lo_l = lo_l->next) {
        write_goto_label_sub(out,
                             ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_EXPRESSION),
                             lo_l->label_s->id + SPD_OBJ_ID_OFFSET(SPD_CID_LABEL),
                             lo_l->source->point);
        count++;
    }
    return count;
}

static int write_expr_op(FILE *out, EOP ptr)
{
    OO_ListP oo_l;
    int count = 0;

    for (oo_l = ptr->op_list; oo_l; oo_l = oo_l->next) {
        write_expr_op_sub(out,
                          ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_EXPRESSION),
                          oo_l->operator_s->id + SPD_OBJ_ID_OFFSET(SPD_CID_OPERATOR),
                          oo_l->source->point);
        count++;
    }
    return count;
}

static int write_decl_opt(FILE *out, DROP ptr)
{
    OD_ListP l;
    int count = 0;

    for (l = ptr->opt_l; l != NULL; l = l->next) {
        write_decl_opt_sub(out,
                           ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATOR),
                           l->opt->id + SPD_OBJ_ID_OFFSET(SPD_CID_OPTIONALDECL),
                           (l->source ? l->source->point : 0));
        count++;
    }
    return count;
}

static int write_op_type(FILE *out, OOP ptr)
{
#ifdef DEBUG_OP_TYPE
    fprintf(stderr, "op_type op: %d.\n", ptr->id);
#endif

    if (legacy_type) {
        if (ptr->sort == OP_SIZEOF_TYPE || ptr->sort == OP_CAST ||
            ptr->sort == OP_BUILTIN_TYPE) {
            write_op_type_sub(out,
                              ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_OPERATOR),
                              ptr->type->id + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE));

#ifdef DEBUG_OP_TYPE
            fprintf(stderr, "op_type expr: %d.\n", ptr->type->id);
#endif
            return 1;
        }
    } else {
        if (ptr->sort == OP_SIZEOF_TYPE || ptr->sort == OP_CAST ||
            ptr->sort == OP_BUILTIN_TYPE) {
            write_op_type_sub(out,
                              ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_OPERATOR),
                              get_type_spec2_id(ptr->type2) + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE));
            
            return 1;
        }
    }
    return 0;
}

/* Added 1997/05/18. */

#if (2 <= SapidVersion)

static int write_prot_parm(FILE *out, ODP ptr)
{
    DO_ListP do_l;
    int count = 0;

    for (do_l = ptr->decl_l; do_l != NULL; do_l = do_l->next) {
        write_prot_parm_sub(out,
                            ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_OPTIONALDECL),
                            do_l->decl->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATION),
                            do_l->source->point);
        count++;
    }
    return count;
}

static int write_funcptr_parm(FILE *out, ODP ptr)
{
    DO_ListP do_l;
    int count = 0;

    for (do_l = ptr->decl_l; do_l != NULL; do_l = do_l->next) {
        write_funcptr_parm_sub(out,
                               ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_OPTIONALDECL),
                               do_l->decl->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATION),
                               do_l->source->point);
        count++;
    }
    return count;
}

static int write_decr_type(FILE *out, DROP ptr)
{
    if (legacy_type) {
        if (ptr->type) {
            write_decr_type_sub(out,
                                ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATOR),
                                ptr->type->id + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE));
            return 1;
        }
    } else {
        if (ptr->type2) {
            write_decr_type_sub(out,
                                ptr->id + SPD_OBJ_ID_OFFSET(SPD_CID_DECLARATOR),
                                get_type_spec2_id(ptr->type2) + SPD_OBJ_ID_OFFSET(SPD_CID_TYPE));
            return 1;
        }
    }
    return 0;
}

#endif /* (2 <= SapidVersion) */

/******************************************************************************/

/* 
 * ꤵ줿ISDBե˥֥ȤϤ롥
 * Ʊˡ񤭹֥ȿinfoե˽Ϥ롥
 * 
 * : 
 * sdblinkϥ饹IDνɤ߹ߤԤᡤ񤭹ߤ⥯饹IDν
 * ˽ɬפ롥
 */

void write_db(char *filename)
{
    TSP         ts_ptr;
    TS2P        ts2_ptr;
    CSP         cs_ptr;
    FOP         fo_ptr;
    DNOP        do_ptr;
    DROP        dt_ptr;
    ODP         od_ptr;
    BOP         bo_ptr;
    EOP         eo_ptr;
    LOP         lo_ptr;
    OOP         oo_ptr;
    IDOP        id_ptr;
    int         count;                  /* Counter for number of objects. */
    SpdObjId    file_id;
    FILE        *ISDB_out;
    SpdInfo     *ISDB_info;

    if ((file_id = spdSearchGlobalObj("file", filename)) == SPD_NON_ID) {
        spdErrorExit("Can't get file ID of \"%s\".\n", filename);
    }

    /* Open ISDB. */
    if (is_D_model) {
        ISDB_out = spdOpenDSDB(filename, SAPID_O_WRITE);
    } else {
        ISDB_out = spdOpenISDB(file_id, SAPID_O_WRITE);
    }

    /* Open ISDB Info. */
    if (is_D_model) {
        ISDB_info = spdOpenDSDBinfo(filename);
    } else {
        ISDB_info = spdOpenISDBinfo(file_id);
    }

    /* Classes. */

    /* Removed by N.Fukuyasu 1999/08/26. */
    /* ISDBˤ program, file, prog_fileϤʤ */

    count = 0;
    for (do_ptr = do_list; do_ptr != NULL; do_ptr = do_ptr->next) {
        count += write_declaration(ISDB_out, do_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_CID_DECLARATION), count);

    count = 0;
    for (dt_ptr = dt_list; dt_ptr != NULL; dt_ptr = dt_ptr->next) {
        count += write_declarator(ISDB_out, dt_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_CID_DECLARATOR), count);

    count = 0;
    for (id_ptr = id_list; id_ptr != NULL; id_ptr = id_ptr->next) {
        count += write_identifier(ISDB_out, id_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_CID_IDENTIFIER), count);

    count = 0;
    for (od_ptr = od_list; od_ptr != NULL; od_ptr = od_ptr->next) {
        count += write_optionaldecl(ISDB_out, od_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_CID_OPTIONALDECL), count);    
    count = 0;
    for (bo_ptr = bo_list; bo_ptr != NULL; bo_ptr = bo_ptr->next) {
        count += write_block(ISDB_out, bo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_CID_BLOCK), count);    

    count = 0;
    for (eo_ptr = eo_list; eo_ptr != NULL; eo_ptr = eo_ptr->next) {
        count += write_expression(ISDB_out, eo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_CID_EXPRESSION), count);    
    count = 0;
    for (lo_ptr = lo_list; lo_ptr != NULL; lo_ptr = lo_ptr->next) {
        count += write_label(ISDB_out, lo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_CID_LABEL), count);    

    count = 0;
    for (cs_ptr = cs_list; cs_ptr != NULL; cs_ptr = cs_ptr->next) {
        count += write_constant(ISDB_out, cs_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_CID_CONSTANT), count);

    count = 0;
    if (legacy_type) {
        for (ts_ptr = ts_list; ts_ptr != NULL; ts_ptr = ts_ptr->next) {
            count += write_type(ISDB_out, ts_ptr);
        }
    } else {
        for (ts2_ptr = ts2_list; ts2_ptr != NULL; ts2_ptr = ts2_ptr->next) {
            count += write_type2(ISDB_out, ts2_ptr);
        }
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_CID_TYPE), count);    
    
    count = 0;
    for (oo_ptr = oo_list; oo_ptr != NULL; oo_ptr = oo_ptr->next) {
        count += write_operator(ISDB_out, oo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_CID_OPERATOR), count);

    /* Relations. */

    count = 0;
    for (bo_ptr = bo_list; bo_ptr != NULL; bo_ptr = bo_ptr->next) {
        count += write_blk_blk(ISDB_out, bo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_BLK_BLK), count);

    count = 0;
    for (bo_ptr = bo_list; bo_ptr != NULL; bo_ptr = bo_ptr->next) {
        count += write_blk_decl(ISDB_out, bo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_BLK_DECL), count);

    count = 0;
    for (bo_ptr = bo_list; bo_ptr != NULL; bo_ptr = bo_ptr->next) {
        count += write_blk_expr(ISDB_out, bo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_BLK_EXPR), count);

    count = 0;
    for (bo_ptr = bo_list; bo_ptr != NULL; bo_ptr = bo_ptr->next) {
        count += write_blk_label(ISDB_out, bo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_BLK_LABEL), count);

    count = 0;
    for (lo_ptr = lo_list; lo_ptr != NULL; lo_ptr = lo_ptr->next) {
        count += write_case_cexpr(ISDB_out, lo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_CASE_CEXPR), count);

    count = 0;
    for (eo_ptr = eo_list; eo_ptr != NULL; eo_ptr = eo_ptr->next) {
        count += write_const_ref(ISDB_out, eo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_CONST_REF), count);

    count = 0;
    for (do_ptr = do_list; do_ptr != NULL; do_ptr = do_ptr->next) {
        count += write_decl_decl(ISDB_out, do_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_DECL_DECL), count);
    
    count = 0;
    for (dt_ptr = dt_list; dt_ptr != NULL; dt_ptr = dt_ptr->next) {
        count += write_decl_ident(ISDB_out,dt_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_DECL_IDENT), count);

    count = 0;
    for (dt_ptr = dt_list; dt_ptr != NULL; dt_ptr = dt_ptr->next) {
        count += write_decl_opt(ISDB_out,dt_ptr);
    } 
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_DECL_OPT), count);

    count = 0;
    for (do_ptr = do_list; do_ptr != NULL; do_ptr = do_ptr->next) {
        count += write_decl_type(ISDB_out, do_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_DECL_TYPE), count);

    count = 0;
    for (eo_ptr = eo_list; eo_ptr != NULL; eo_ptr = eo_ptr->next) {
        count += write_expr_expr(ISDB_out, eo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_EXPR_EXPR), count);
    
    count = 0;
    for (eo_ptr = eo_list; eo_ptr != NULL; eo_ptr = eo_ptr->next) {
        count += write_expr_op(ISDB_out, eo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_EXPR_OP), count);

    count = 0;
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_EXPR_TYPE), count);

    count = 0;
    for (fo_ptr = fo_list; fo_ptr != NULL; fo_ptr = fo_ptr->next) {
        count += write_file_decl(ISDB_out, fo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_FILE_DECL), count);

    count = 0;
    for (od_ptr = od_list; od_ptr != NULL; od_ptr = od_ptr->next) {
        if (od_ptr->sort == OPT_FUNCDEF) {
            count += write_func_body(ISDB_out, od_ptr);
        }
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_FUNC_BODY), count);
    
    count = 0;
    for (od_ptr = od_list; od_ptr != NULL; od_ptr = od_ptr->next) {
        if (od_ptr->sort == OPT_FUNCDEF) {
            count += write_func_parm(ISDB_out, od_ptr);
        }
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_FUNC_PARM), count);
    
    count = 0;
    for (eo_ptr = eo_list; eo_ptr != NULL; eo_ptr = eo_ptr->next) {
        count += write_goto_label(ISDB_out, eo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_GOTO_LABEL), count);
    
    count = 0;
    for (eo_ptr = eo_list; eo_ptr != NULL; eo_ptr = eo_ptr->next) {
        count += write_ident_ref(ISDB_out, eo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_IDENT_REF), count);
    
    count = 0;
    for (id_ptr = id_list; id_ptr != NULL; id_ptr = id_ptr->next) {
        count += write_ident_type(ISDB_out, id_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_IDENT_TYPE), count);

    count = 0;
    for (od_ptr = od_list; od_ptr != NULL; od_ptr = od_ptr->next) {
        if (od_ptr->sort == OPT_INITIALIZER) {
            count += write_init_expr(ISDB_out, od_ptr);
        }
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_INIT_EXPR), count);

    count = 0;
    for (oo_ptr = oo_list; oo_ptr != NULL; oo_ptr = oo_ptr->next) {
        count += write_op_type(ISDB_out, oo_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_OP_TYPE), count);

    /* Removed by N.Fukuyasu 1999/08/26. */
    /*
     * count = 0;
     * for (po_ptr = po_list; po_ptr != NULL; po_ptr = po_ptr->next) {
     *     count += write_prog_file(ISDB_out, po_ptr);
     * }
     * spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_PROG_FILE),
     *               count);
     */

    count = 0;
    for (od_ptr = od_list; od_ptr != NULL; od_ptr = od_ptr->next) {
        if (od_ptr->sort == OPT_STRUCT) {
            count += write_struct_decl(ISDB_out, od_ptr);
        }
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_STRUCT_DECL), count);
    
    count = 0;
    if (legacy_type) {
        for (ts_ptr = ts_list; ts_ptr != NULL; ts_ptr = ts_ptr->next) {
            count += write_type_cexpr(ISDB_out, ts_ptr);
        }
    } else {
        for (ts2_ptr = ts2_list; ts2_ptr != NULL; ts2_ptr = ts2_ptr->next) {
            count += write_type_cexpr2(ISDB_out, ts2_ptr);
        }
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_TYPE_CEXPR), count);

    count = 0;
    if (legacy_type) {
        for (ts_ptr = ts_list; ts_ptr != NULL; ts_ptr = ts_ptr->next) {
            count += write_type_is(ISDB_out, ts_ptr);
        }
    } else {
        for (ts2_ptr = ts2_list; ts2_ptr != NULL; ts2_ptr = ts2_ptr->next) {
            count += write_type_is2(ISDB_out, ts2_ptr);
        }
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_TYPE_IS), count);

    count = 0;
    if (legacy_type) {
        for (ts_ptr = ts_list; ts_ptr != NULL; ts_ptr = ts_ptr->next) {
            count += write_type_st(ISDB_out, ts_ptr);
        }
    } else {
        for (ts2_ptr = ts2_list; ts2_ptr != NULL; ts2_ptr = ts2_ptr->next) {
            count += write_type_st2(ISDB_out, ts2_ptr);
        }
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_TYPE_ST), count);

#if (2 <= SapidVersion)

    count = 0;
    for (od_ptr = od_list; od_ptr != NULL; od_ptr = od_ptr->next) {
        if (od_ptr->sort == OPT_PROTOTYPE) {
            count += write_prot_parm(ISDB_out, od_ptr);
        }
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_PROT_PARM), count);
    
    count = 0;
    for (od_ptr = od_list; od_ptr != NULL; od_ptr = od_ptr->next) {
        if (od_ptr->sort == OPT_FUNCPTR) {
            count += write_funcptr_parm(ISDB_out, od_ptr);
        }
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_FUNCPTR_PARM), count);

    count = 0;
    for (dt_ptr = dt_list; dt_ptr != NULL; dt_ptr = dt_ptr->next) {
        count += write_decr_type(ISDB_out, dt_ptr);
    }
    spdSetInfoInt(ISDB_info, spdGetClassNameById(SPD_RID_DECR_TYPE), count);

#endif /* (2 <= SapidVersion) */

    if (spdGetWriteSDBformat() == SAPID_BINARY_FORMAT_SDB) {
        spdSetInfoString(ISDB_info, "BINARY_FORMAT_SDB", "TRUE");
    } else {
        spdSetInfoString(ISDB_info, "BINARY_FORMAT_SDB", "FALSE");
    }

    /*
     * Modified by N.Fukuyasu 1998/12/08.
     * typelegacy typeݤ¾Ѥ뤳ȤϤʤȻפǰΤᡥ
     */
    spdSetInfoString(ISDB_info, "LEGACY_TYPE_SPEC",
                     legacy_type ? "TRUE" : "FALSE");

    /* Close. */
    spdFclose(ISDB_out);
    spdCloseInfo(ISDB_info);
}

/******************************************************************************/

/*
 * Get scope's value of identifier.
 */

static int get_ident_scope(int storage)
{
    if (storage & ISDB_STATIC) {
        return ID_SCOPE_NOT_GLOBAL;
    } else if ((storage & ISDB_VARIABLE) ||
               (storage & ISDB_FUNCTION) ||
               (storage & ISDB_NO_PROTOTYPE)) {
        return ID_SCOPE_GLOBAL;
    } else {
        return ID_SCOPE_NOT_GLOBAL;
    }
}
