%{

/* 
 * Program:             $RCSfile: yacc.y,v $  $Revision: 30.109 $
 * 
 * Purpose:             ʸϤˤǡ١κ
 * 
 * Author:              K.Mabuchi  1991/09/30
 *                      S.Yamamoto  1992/04/01
 * Modified:            H.Ariga  1993/07/01
 *                      N.Fukuyasu  1998/06/20
 *                      A.Yoshida  1999/06/03
 * 
 * (C) Copyright:       K.Mabuchi and S.Yamamoto  1991 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint 
static char rcsid[] =
    "$Id: yacc.y,v 30.109 2003/07/30 16:27:32 yamamoto Exp yamamoto $";
#endif

/*
 * Memo:
 * A.Yoshida 1999/06/04.
 * Enumeconst_flag and ENUMERATION_CONSTANT are to be removed clearly
 * in the next release.
 */

#include <stdarg.h>
#include <stdio.h>
#include <Sapid/Sapid.h>
#include "main.h"
#include "prototype.h"

/* Default value is 150. */
#define YYMAXDEPTH      600

/*
 * Debug flags.
 */

/* #define TYPE_REF_DEBUG */

#if defined(TYPE_REF_DEBUG) || defined(lint)
static void dw_type_ref(char *format, WP wp);
#else
#define dw_type_ref         (void)
#endif

/* #define APP_TYPE_SPEC_DEBUG */

#ifdef APP_TYPE_SPEC_DEBUG
#define APP_TYPE_SPEC()     (spdMessage("%s, %d: app_type_spec()\n", \
                                        __FILE__, __LINE__), \
                             app_type_spec())
#else
#define APP_TYPE_SPEC()     app_type_spec()
#endif

/* Added by A.Yoshida 1999/09/26. */
/* #define SPECIFIER_FLAG_DEBUG */

#ifdef SPECIFIER_FLAG_DEBUG
#define set_specifier_flag(x)   (spdMessage("set specifier flag (%d) to %d," \
                                            " at %d in %s\n",\
                                            specifier_flag, (x), \
                                            __LINE__, __FILE__), \
                                 specifier_flag = (x))
#else
#define set_specifier_flag(x)   (specifier_flag = (x))
#endif

/*
 * Macros.
 */

#define FIX_SDBIN3_0065_1   /* Fix sdbin3-0065 part 1. */

#define DATA_NAME       1
#define FUNCTION_NAME   2
#define CONST_DATA      3
#define STRING_DATA     4
#define STRUCT_MEMBER   5
#define ARRAY_NAME      6
#define ID_NAME         7
#define FUNC_PTR        8
/* Function type may be declared by "typedef void f(int a)". */
#define FUNC_TYPE       9

/*
 * For func_or_comp value.
 */

#define GLOBAL      1
#define DEF_FUNC    2
#define COMP_STAT   3
#define IN_FUNC     4
#define DEF_PARM    5   /* For formal parameters in pointer type to function. */

int func_or_comp = GLOBAL;

int chk950309 = 0;

Point basic_blk;
WD decl_point;
WD func_opt_point;

struct _Stack {
    void            *top;
    struct _Stack   *prev;
};

typedef struct _Stack Stack;
typedef struct _Stack * StackP;
StackP ptr_stack;

/* Current C source file. Defined in "sdbin4.c". */
extern char     *filename;

extern int      c_count;            /* Defined in "lex.l". */
extern int      paren_level;        /* Defined in "lex.l". */

extern char     *yytext;
extern int      yylineno;
extern FILE     *yyout;

extern BOP          bo_list, current_blk;
extern LO_ListP     label_table;

int enum_counter;
int flag_func;
int func_end_ln;
struct Stack_Func *direct_decl_stack;   /* Added by N.Fukuyasu 1997/06/02. */
int block_level;
int ident_flag;
int specifier_flag;

int storage;
struct Stack_Storage *storage_stack;    /* Added by N.Fukuyasu 1997/10/22. */
int func_class;

TSP ptr_type, ptr_type_func, type_int;
struct Stack_Type *ptr_ts_stack;
extern TSP ptr_ts_struc, ptr_ts_enum;

CSP ptr_const;

DSP ptr_data;

struct DS *ptr_fs_output;
struct DS_List *ptr_fs_input = NULL;
struct CS_List *ptr_fs_l_cs,  *ptr_enum_cs_list;
FunctionSpec tmp_function;

BOP tmp_blk;
DNOP current_decl;
int decl_head_point;
MEMSP ptr_mems;
FOP current_file;
#ifdef CONST_DEBUG
void *tmp_ptr;
#endif

ConstListP const_in_type;
MEMS_ListP mem_ref ;
DataListP var_ref;
IDO_ListP ident_ref;

EO_ListP blk_expr;
DO_ListP blk_decl;
struct Stack_Decl *decl_decl_stack; /* Added by N.Fukuyasu 1997/10/24. */
FunctionListP func_decl;
FunctionListP func_def;
EO_ListP arg_expr;
DO_ListP file_decl;
TypeListP type_decl;

IDO_ListP ident_decl;
IDO_ListP func_ident_decl;

IDO_ListP global_id_list;
IDO_ListP infile_id_list;

FunctionListP file_func;
BOP bodyblock;
BO_ListP func_body;
BO_ListP blk_blk;
TSP tmp_struct;
struct Stack_Parm *func_parm_stack;     /* Added by N.Fukuyasu 1997/06/02. */
LO_ListP blk_labl = NULL;
TSP tmp_ts;
TypeListP type_ref,type_expr;
extern FOP tmp_fo;
struct Word_data tmp_wp;

/* For printing line number of ".c" or ".h" file in yyerror(). */
extern int source_lineno;

static void WP_copy_name(WP, WP);
static void free_WP(WP);
static void append_link_type_is(void);
static void make_func_body(WP);
static void print_lines(char *fileName, int lineNum, int margin);

static DNOP make_function_definition(WP func, WP type, WP decr, WP body);
static DNOP process_identifier_list(WP);
static MEMSP process_struct_declarator(WP st_decr, WP decr);
static OD_ListP make_function_pointer(WP decr, WP decl_point, DO_ListP decl_l);
static void after_declaration(DNOP, WP);
static void init_declarator_make_type_ref(void);
static void process_declaration_list(WP);
static void process_function_declarator(WP decr);
static void process_prototype_declarator(WP init_decr, WP decr);
static void process_typedef_declarator(WP init_decr, WP decr);
static void process_variable_declarator(WP init_decr, WP decr,
                                        SpdBoolean has_initializer);

static void update_region_info(WP, ...);

static void process_function_direct_declarator(WP decr, WP lp);
static void process_func_postfix_expression(WP expr, WP rp, EO_ListP arg);


#define WP_COPY_IDENT(a, b) \
    (WP_copy_name((a), (b)), (a)->point = (b)->point, (a)->length = (b)->length)

extern SpdStringPool    *str_pool;

extern SpdBoolean       accept_undef_var;
extern SpdBoolean       F_model;

SpdBoolean labeled_stmt_flag = 0;       /* See the rules about statement. */

%}

%token          BREAK
%token          CASE
%token          CHARACTER_CONSTANT
%token          W_CHARACTER_CONSTANT
%token          CONTINUE
%token          DEFAULT
%token          DO
%token          ELSE
%token          ENUM
/* %token          ENUMERATION_CONSTANT */
%token          FLOATING_CONSTANT
%token          FOR
%token          GOTO
%token          IDENTIFIER
%token          IF
%token          INTEGER_CONSTANT
%token          RETURN
%token          SIZEOF
%token          STORAGE_CLASS_SPECIFIER
%token          STRING_CONSTANT
%token          STRUCT_OR_UNION
%token          SWITCH
%token          TYPEDEF_NAME
%token          BUILTIN_TYPE_NAME
%token          GUESSED_TYPEDEF_NAME    /* For D-model. */
%token          TYPE_QUALIFIER
%token          TYPE_SPECIFIER
%token          TYPE_SPECIFIER_SIZE
%token          TYPE_SPECIFIER_SIGN
%token          WHILE

%token          AND
%token          AND_AND
%token          AND_EQUAL
%token          ARROW
%token          DOT
%token          DOTS
%token          EQUAL
%token          EQUAL_EQUAL
%token          EXCLAMATION
%token          EXCLAMATION_EQUAL
%token          HAT
%token          HAT_EQUAL
%token          LESS
%token          LESS_EQUAL
%token          LESS_LESS
%token          LESS_LESS_EQUAL
%token          MINUS
%token          MINUS_EQUAL
%token          MINUS_MINUS
%token          MORE
%token          MORE_EQUAL
%token          MORE_MORE
%token          MORE_MORE_EQUAL
%token          OR
%token          OR_EQUAL
%token          OR_OR
%token          PERCENT
%token          PERCENT_EQUAL
%token          PLUS
%token          PLUS_EQUAL
%token          PLUS_PLUS
%token          SLASH
%token          SLASH_EQUAL
%token          STAR
%token          STAR_EQUAL
%token          TILDA
%token          SEMICOLON
%token          COMMA
%token          BUILTIN_TYPE_PARAMETER
    
%%

translation_unit   /* ================================================ */
    /* Modified by N.Fukuyasu to accept an empty file 1997/02/03. */
    /* : external_declaration */

    : /* Empty. */ {
        $$ = (WP)spdCalloc(1, sizeof(struct Word_data));
    }

    | translation_unit external_declaration {
        update_region_info($$, $1, $2, NULL);
    }
    ;

external_declaration   /* ============================================ */
    : function_definition {
        clear_ts(ptr_ts_stack->sort);

        func_or_comp = GLOBAL;

        free_DS_ListP(ptr_fs_input);
        ptr_fs_input = NULL;

        func_def = NULL;    /* NULL? */
        func_body = NULL;
        pop_func_parm();    /* Added by N.Fukuyasu 1997/06/02. */
        push_func_parm();
        pop_storage();      /* Added by N.Fukuyasu 1997/10/22. */
        push_storage();
        pop_decl_decl();    /* Added by N.Fukuyasu 1997/10/24. */
        push_decl_decl();

        $$ = $1;
        set_specifier_flag(0);
    }

    | declaration {
        DNOP tmp_decl;
        clear_ts(ptr_ts_stack->sort);
        
        tmp_decl = insert_declaration($1);
        tmp_decl->dt_l = (DT_ListP)$1->dataptr;
        tmp_decl->sort = (storage_stack->storage == STORAGE_TYPEDEF) ?
            DECL_TYPE : DECL_NORMAL;
        tmp_decl->storage = storage_stack->storage;

#ifdef DECL_DEBUG
        fprintf(stderr, "insert decl = id = %d typedef = %d sort = %d.\n",
                tmp_decl->id,storage_stack->storage,$1->sort);
        if (type_decl)
            fprintf(stderr, "type decl id = %d.\n", type_decl->id);
#endif
        file_decl = insert_declaration_list(file_decl,tmp_decl,$1);
        
        after_declaration(tmp_decl, $1);

        ptr_type_func = NULL;

        free_DS_ListP(ptr_fs_input);
        ptr_fs_input = NULL;

        pop_func_parm();    /* Added by N.Fukuyasu 1997/06/02. */
        push_func_parm();

        $$ = $1;
    }

    | semicolon {
        /* Empty declaration. *//* Added by A.Yoshida 1999/08/02. */
        spdWarning("\"%s\": %d: Skip empty declaration.\n",
                   filename, yylineno);
    }
    ;

function_definition   /* ============================================= */
    : declarator { 
        /* func_decl_point.head_point = $1->head_point; */

        process_function_declarator($1);

        set_func_opt_point(decl_point);

        func_or_comp = COMP_STAT;
    }
    compound_statement {
        TS2P tmp_type;

        make_func_body($3);

        /* implicit_int  declarator ηϢ */
        tmp_type = type_spec2_implicit_int();
        make_type_st2(tmp_type, $1->type_spec2);

        make_function_definition($1, NULL, $1, $3);

        $$ = $1;
        update_region_info($$, $1, $3, NULL);
    }           

    | declarator { 
        process_function_declarator($1);

        push_direct_decl(DEF_FUNC);
        push_storage(); /* Added by N.Fukuyasu 1997/10/22. */

        set_func_opt_point(decl_point);

        func_or_comp = DEF_FUNC;
    }
    declaration_list {
        pop_direct_decl();
        pop_storage();  /* Added by N.Fukuyasu 1997/10/22. */
        /* function parameter decl */
        func_or_comp = COMP_STAT;
    }
    compound_statement {
        TS2P tmp_type;

        make_func_body($5);

        /* func_decl_point.head_point = $1->head_point; */

        /* implicit_int  declarator ηϢ */
        tmp_type = type_spec2_implicit_int();
        make_type_st2(tmp_type, $1->type_spec2);

        make_function_definition($1, NULL, $1, $5);

        $$ = $1;
        reset_wp_type_spec2($$);
        update_region_info($$, $1, $3, $5, NULL);
    }           

    | declaration_specifiers declarator { 
        process_function_declarator($2);

#ifdef FIX_SDBIN3_0065_1
        clear_ts(ptr_ts_stack->sort);
#endif 
        set_func_opt_point(decl_point);

        func_or_comp = COMP_STAT;
    }
    compound_statement {
        TS2P tmp_type;

        make_func_body($4);

        /* func_decl_point.head_point = $2->head_point; */

        /* declaration_specifiers  declarator ηϢ */
        tmp_type = $1->type_spec2_last;
        if (tmp_type == NULL) tmp_type = type_spec2_implicit_int();
        make_type_st2(tmp_type, $2->type_spec2);

        make_function_definition($1, $1, $2, $4);

        $$ = $1;
        WP_copy_name($$, $2); /* $$->name = $2->name; */
        $$->length = $2->length;
        $$->sort = $2->sort;
        update_region_info($$, $1, $2, $4, NULL);
    }           

    | declaration_specifiers declarator { 
        process_function_declarator($2);

#ifdef FIX_SDBIN3_0065_1
        clear_ts(ptr_ts_stack->sort);
#endif 
        push_direct_decl(DEF_FUNC);
        push_storage(); /* Added by N.Fukuyasu 1997/10/22. */
        push_decl_decl();

        set_func_opt_point(decl_point);

        func_or_comp = DEF_FUNC;
    }
    declaration_list {
        pop_direct_decl();
        pop_storage();  /* Added by N.Fukuyasu 1997/10/22. */
        pop_decl_decl();
        /* function parameter decl */
        func_or_comp = COMP_STAT;
    }
    compound_statement {
        TS2P tmp_type;

        make_func_body($6);

        /* func_decl_point.head_point = $2->head_point; */

        /* declaration_specifiers  declarator ηϢ */
        tmp_type = $1->type_spec2_last;
        if (tmp_type == NULL) tmp_type = type_spec2_implicit_int();
        make_type_st2(tmp_type, $2->type_spec2);

        make_function_definition($1, $1, $2, $6);

        $$ = $1;        
        WP_copy_name($$, $2); /* $$->name = $2->name; */
        $$->length = $2->length;
        $$->sort = $2->sort;
        update_region_info($$, $1, $2, $4, $6, NULL);
    }           
    ;

declaration   /* ===================================================== */
    : declaration_specifiers semicolon {
        tmp_wp.point = ptr_ts_stack->point;
        tmp_ts = APP_TYPE_SPEC();
        type_ref = insert_type_list(type_ref,
                                    get_non_pointer_type(tmp_ts), &tmp_wp);
        set_specifier_flag(0);
        $$ = $1;
        $$->dataptr = (void *)(decl_decl_stack->decl_decl);
        update_region_info($$, $1, $2, NULL);
    }

    | declaration_specifiers init_declarator_list semicolon {
        TS2P tmp_type;

        set_specifier_flag(0);
        /* declaration_specifiers  init_declarator_list ηϢ */
        tmp_type = $1->type_spec2_last;
        if (tmp_type == NULL) tmp_type = type_spec2_implicit_int();
        make_type_st2_list(tmp_type, $2->type_list2);
        free_type_list2($2->type_list2);
        /* ̤ identifier η */
        set_ident_type2_list($2->ident_list, tmp_type);
        free_IDO_ListP($2->ident_list);

        $$ = $1;
        $$->sort = $2->sort;
        $$->dataptr = (void *)(decl_decl_stack->decl_decl);
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

declaration_list   /* ================================================ */
    : sub_declaration_list

    | sub_declaration_list DOTS {
        /* Ignore unexpected DOTS of variable arguments. */
        spdWarning("\"%s\": %d: Skip three dots in declaration.\n",
                   filename, yylineno);
    }
    ;

sub_declaration_list   /*============================================= */
    : declaration {
        process_declaration_list($1);
        $$ = $1;
    }

    | declaration_list declaration {
        process_declaration_list($2);
        $$ = $1;
        update_region_info($$, $1, $2, NULL);
    }
    ;

declaration_specifiers   /* ========================================== */
    : storage_class_specifier

    | storage_class_specifier declaration_specifiers {
        $$ = $1;
        $$->type_spec2 = $2->type_spec2;
        $$->type_spec2_last = $2->type_spec2_last;
        update_region_info($$, $1, $2, NULL);
    }

    | type_specifier {
        ptr_ts_stack->point = $1->head_point;
        $$ = $1;
        dw_type_ref("type_specifier      %d, \"%s\"\n", $1);
    }

    | type_specifier declaration_specifiers {
        ptr_ts_stack->point = $1->head_point;
        make_type_st2($1->type_spec2, $2->type_spec2);

        $$ = $1;
        if ($2->type_spec2_last != NULL) {
            $$->type_spec2_last = $2->type_spec2_last;
        }
        update_region_info($$, $1, $2, NULL);
        dw_type_ref("type_specifier decl %d, \"%s\"\n", $1);
    }

    | type_qualifier {
        ptr_ts_stack->point = $1->head_point;
        $$ = $1;
        dw_type_ref("type_qualifier      %d, \"%s\"\n", $1);
    }

    | type_qualifier declaration_specifiers {
        ptr_ts_stack->point = $1->head_point;
        make_type_st2($1->type_spec2, $2->type_spec2);
        $$ = $1;
        if ($2->type_spec2_last != NULL) {
            $$->type_spec2_last = $2->type_spec2_last;
        }
        update_region_info($$, $1, $2, NULL);
        dw_type_ref("type_qualifier decl %d, \"%s\"\n", $1);
    }
    ;

storage_class_specifier   /* ========================================= */
    : STORAGE_CLASS_SPECIFIER { 
        storage_stack->storage = storage;
        ptr_ts_stack->sort->class = $1->sort;
        $$ = $1;
        reset_wp_type_spec2($$);
        dw_type_ref("STORAGE_CLASSR      %d, \"%s\"\n", $1);
    }
    ;

type_specifier   /* ================================================== */
    : TYPE_SPECIFIER {
        ptr_ts_stack->sort->type = $1->sort;
        ptr_ts_stack->sort->sort = TYPE_DECLARATION;
        set_specifier_flag(1);

        $$ = $1;
        $$->type_spec2 = make_type_spec2_specifier($1->sort, $1);
        $$->type_spec2_last = $$->type_spec2;

        dw_type_ref("TYPE_SPECIFIER      %d, \"%s\"\n", $1);
    }

    | TYPE_SPECIFIER_SIZE {
#ifdef ACCEPT_TYPE_LONG_LONG
        int type_sort = $1->sort;

        if ($1->sort == TYPE_LONG && ptr_ts_stack->sort->length == TYPE_LONG) {
            type_sort = TYPE_LONG_LONG;
        }
        ptr_ts_stack->sort->length = type_sort;
#else
        ptr_ts_stack->sort->length = $1->sort;
#endif
        ptr_ts_stack->sort->sort = TYPE_DECLARATION;

        $$ = $1;
        $$->type_spec2 = make_type_spec2_size($1->sort, $1);
        $$->type_spec2_last = $$->type_spec2;

        dw_type_ref("TYPE_SPECIFIER_SIZE %d, \"%s\"\n", $1);
        set_specifier_flag(1);
    }

    | TYPE_SPECIFIER_SIGN {
        ptr_ts_stack->sort->sign = $1->sort;
        ptr_ts_stack->sort->sort = TYPE_DECLARATION;

        $$ = $1;
        $$->type_spec2 = make_type_spec2_sign($1->sort, $1);
        $$->type_spec2_last = $$->type_spec2;

        dw_type_ref("TYPE_SPECIFIER_SIGN %d, \"%s\"\n", $1);
    }

    | struct_or_union_specifier {
        ident_flag = NON;
        set_specifier_flag(1);
        $$ = $1;
    }

    | enum_specifier {
#ifdef ENUM_DEBUG
        fprintf(stderr,"enum_specifier %s\n",$1->name);
        /* fprintf(stderr,"decl_decl(ptr) = %x\n",decl_decl); */
#endif
        set_specifier_flag(1);
        $$ = $1;
    }

    | typedef_name {
        set_specifier_flag(1);
        $$ = $1;
    }

    | BUILTIN_TYPE_NAME {
        set_specifier_flag(1);

        $$ = $1;
        $$->type_spec2 = make_type_spec2($1->name, TYPE_BUILTIN, TYPE_UNKNOWN,
                          TYPE_BUILTIN_TYPE, TYPE_UNKNOWN, TYPE_UNKNOWN, $1);
        $$->type_spec2_last = $$->type_spec2;

        dw_type_ref("TYPE_SPECIFIER      %d, \"%s\"\n", $1);
    }
    ;

type_qualifier   /* ================================================== */
    : TYPE_QUALIFIER {
        ptr_ts_stack->sort->qualifier = $1->sort;

        $$ = $1;
        $$->type_spec2 = make_type_spec2_qualifier($1->sort, $1);
        $$->type_spec2_last = $$->type_spec2;

        dw_type_ref("TYPE_QUALIFIER      %d, \"%s\"\n", $1);
    }
    ;

struct_or_union_specifier   /* ======================================= */
    : struct_or_union {
        ident_flag = ID_MEMBER;
#ifdef DEBUG_950328
        printf("struct_or_union pre push \n");
        disp_type(ptr_ts_struc);
#endif
        push_pointer((void *)ptr_ts_struc);
        ptr_ts_struc = insert_type((char *)NULL,$1);
#ifdef DEBUG_STRUCT_UNION
        fprintf(stderr, "struct or union : sort = %d\n", $1->sort);
#endif
        ptr_ts_struc->sort = $1->sort;
        /* TYPE_STRUCT_TAG or TYPE_UNION_TAG */
        tmp_fo->scope->type_t = insert_type_list(tmp_fo->scope->type_t,
                                                 ptr_ts_struc, NULL);
#ifdef DEBUG_950328
        printf("struct_or_union after push \n");
        disp_type(ptr_ts_struc);
#endif
        
        /* type_decl = insert_type_list(type_decl, ptr_ts_struc, $1); */
#ifdef MEMBER_DEBUG
        printf("new struct id:%d in\n",ptr_ts_struc->id);
#endif
        push_ts();
        set_specifier_flag(0);
        push_decl_decl();   /* Added by N.Fukuyasu 1997/10/24. */

        $$ = $1;        
        $$->type_spec2 = make_type_spec2_struct(NULL, $1->sort, $1);
        $$->type_spec2_last = $$->type_spec2;
    } 
    '{' struct_declaration_list '}' {
        ODP tmp_opt;
        DROP tmp_dt;
        pop_ts();
        
        pop_decl_decl();    /* Added by N.Fukuyasu 1997/10/24. */
#ifdef MEMBER_DEBUG
        printf("new struct id:%d out\n",ptr_ts_struc->id);
#endif
        copy_type_spec2(ptr_ts_struc, ptr_ts_stack->sort);
#ifdef DEBUG_950328
        printf("struct_or_union pre pop \n");
        disp_type(ptr_ts_struc);
#endif
        ptr_ts_struc = (TSP)pop_pointer();
#ifdef DEBUG_950328
        printf("struct_or_union after pop \n");
        disp_type(ptr_ts_struc);
#endif
        tmp_opt = (ODP)$4->dataptr;
        tmp_opt->length = get_length($3, $5);
        tmp_dt = insert_declarator(NULL);
        tmp_dt->length = tmp_opt->length;
        tmp_dt->opt_l =
            insert_optionaldecl_list(NULL,tmp_opt,$3);
        tmp_dt->sort = DECL_TAG;
        decl_decl_stack->decl_decl =
            insert_declarator_list(NULL,tmp_dt,$3);

        update_region_info($$, $1, $3, $4, $5, NULL);
    }

    | struct_or_union ident_or_type {   
        IDOP tmp_ident;
        TS2P tmp_type;
        
        ident_flag = ID_MEMBER;
#ifdef DEBUG_950328
        printf("struct_or_union pre push \n");
        disp_type(ptr_ts_struc);
#endif
        push_pointer((void *)ptr_ts_struc);
#ifdef DEBUG_STRUCT_UNION
        fprintf(stderr, "struct or union : sort = %d\n", $1->sort);
#endif
        if (!(ptr_ts_struc = find_cp_struc($2->name, ptr_ts_stack->sort))) {
            ptr_ts_struc = insert_type($2->name,$2);
            ptr_ts_struc->sort = $1->sort;
            /* TYPE_STRUCT_TAG or TYPE_UNION_TAG */
            tmp_fo->scope->type_t = insert_type_list(tmp_fo->scope->type_t,
                                                     ptr_ts_struc, $2);
            /* tmp_ident = insert_identifier($2->name,ID_TAG); */
        } else {
            /* tmp_ident = find_identifier($2->name,ID_TAG); */
        }
#ifdef DEBUG_950328
        printf("struct_or_union after push \n");
        disp_type(ptr_ts_struc);
#endif

        tmp_ident = find_tag_with_member($2->name);

        tmp_ident->data.type = ptr_ts_struc;
        tmp_ident->length = $2->length;
        ptr_ts_struc->ident = tmp_ident;
        ident_decl =
            insert_identifier_list(NULL,tmp_ident,$2);
        push_ts();
        push_pointer((void *)ident_decl);
        ident_decl = NULL;
        set_specifier_flag(0);
        push_decl_decl();   /* Added by N.Fukuyasu 1997/10/24. */

        tmp_type = make_type_spec2_struct($2->name, $1->sort, $1);
        tmp_type = make_type_is2(tmp_type, tmp_ident);
        $$ = $1;
        $$->type_spec2 = tmp_type;
        $$->type_spec2_last = tmp_type;
    }
    '{' struct_declaration_list '}' {
        ODP tmp_opt;
        DROP tmp_dt;
        ident_decl = (IDO_ListP)pop_pointer();
        pop_ts();
        
        pop_decl_decl();    /* Added by N.Fukuyasu 1997/10/24. */
        
        copy_type_spec2(ptr_ts_struc, ptr_ts_stack->sort);
#ifdef DEBUG_950328
        printf("struct_or_union pre pop \n");
        disp_type(ptr_ts_struc);
#endif
        ptr_ts_struc = (TSP)pop_pointer();
#ifdef DEBUG_950328
        printf("struct_or_union after pop \n");
        disp_type(ptr_ts_struc);
#endif
        tmp_opt = (ODP)$5->dataptr;
        tmp_opt->length = get_length($4, $6);
        tmp_dt = insert_declarator(NULL);
        tmp_dt->length = get_length($2, $6);
        tmp_dt->opt_l =
            insert_optionaldecl_list(NULL,tmp_opt,$4);
        tmp_dt->sort = DECL_TAG;
        /* Fixing sdbin3-0048. */
        /* ident_decl->ident->type = ptr_ts_struc;*/
        tmp_dt->id_l = ident_decl;
        ident_decl = NULL;
        decl_decl_stack->decl_decl =
            insert_declarator_list(NULL,tmp_dt,$2);

        WP_COPY_IDENT($$, $2);
        $$->sort = $2->sort;
        update_region_info($$, $1, $2, $4, $5, $6, NULL);
        if (tmp_opt->decl_l == NULL) {  /* Added by A.Yoshida 1999/08/02. */
            spdWarning("Empty body of struct/union at l.%d.\n", yylineno);
       }

    }

    | struct_or_union ident_or_type {
        TSP ptr_ts;
        DROP tmp_dt;
        IDOP tmp_ident;
        TS2P tmp_type;
        
#ifdef DEBUG_STRUCT_UNION
        fprintf(stderr, "struct or union : sort = %d\n", $1->sort);
#endif
        if (!(ptr_ts = find_cp_struc($2->name, ptr_ts_stack->sort))) {
            ptr_ts = insert_type($2->name,$2);
            ptr_ts->sort = $1->sort;
            /* TYPE_STRUCT_TAG or TYPE_UNION_TAG */
            ptr_ts->struc = NULL;
            copy_type_spec2(ptr_ts, ptr_ts_stack->sort);
            tmp_fo->scope->type_t = insert_type_list(tmp_fo->scope->type_t,
                                                     ptr_ts, $2);
            /* tmp_ident = insert_identifier($2->name,ID_TAG); */
        }
        /* tmp_ident = find_identifier($2->name,ID_TAG); */

        tmp_ident = find_tag_without_member($2->name);
        tmp_ident->length = $2->length;
        tmp_ident->data.type = ptr_ts;
        ptr_ts->ident = tmp_ident;

        /* Fixing sdbin4-0117, modified by A.Yoshida 1999/05/06. */
        /*
         * A declarator can take a cast operator of struct (or union)
         * type in its initializer. In this context, the variable 
         * 'ident_decl' has a valid pointer to a link between the 
         * decalrator and the identifier in it, when processing at 
         * this point. Old code forgot the existence of the link and
         * initialized the variable.
         */
        push_pointer((void *)ident_decl);       /* Push anyway, and */

        ident_decl = insert_identifier_list(NULL,tmp_ident,$2);
        tmp_dt = insert_declarator(NULL);
        tmp_dt->length =  $2->length;
        tmp_dt->sort = DECL_TAG;
        tmp_dt->id_l = ident_decl;
        ident_decl = (IDO_ListP)pop_pointer();  /* pop here. No side effect.*/
        decl_decl_stack->decl_decl = insert_declarator_list(NULL,tmp_dt,$2);
        
        tmp_type = make_type_spec2_struct($2->name, $1->sort, $1);
        tmp_type = make_type_is2(tmp_type, tmp_ident);
        $$ = $1;
        $$->type_spec2 = tmp_type;
        $$->type_spec2_last = tmp_type;
        update_region_info($$, $1, $2, NULL);
    }
    ;

struct_or_union   /* ================================================= */
    : STRUCT_OR_UNION {
        set_specifier_flag(1);
        $$ = $1;

#ifdef DEBUG_STRUCT_UNION
        fprintf(stderr, "STRUCT OR UNION : sort = %d\n", $$->sort);
#endif
    }
    ;

struct_declaration_list   /* ========================================= */
    : /* struct_declaration */ { /* Empty body of struct/union. */
        ODP tmp_opt;
        
        /* clear_ts(ptr_ts_stack->sort); */
        tmp_opt = insert_optionaldecl(NULL);
#ifdef DECL_DEBUG
        fprintf(stderr,"optdecl id %d\n", tmp_opt->id);
#endif
        tmp_opt->sort = OPT_STRUCT;
        $$ = (WP)spdCalloc(1, sizeof(struct Word_data));
        $$->dataptr = (void *)tmp_opt;
    }

    | struct_declaration_list struct_declaration {
        ODP tmp_opt;
        clear_ts(ptr_ts_stack->sort);
        
        tmp_opt = (ODP)$1->dataptr;
        tmp_opt->decl_l =
            insert_declaration_list(tmp_opt->decl_l,(DNOP)$2->dataptr,$2);
        $$ = $1;
        $$->dataptr = (void *)tmp_opt;
        update_region_info($$, $1, $2, NULL);
        pop_decl_decl();    /* Added by N.Fukuyasu 1997/10/24. */
        push_decl_decl();
    }
    ;

init_declarator_list   /* ============================================ */
    : init_declarator {
        DROP tmp_dt;
        tmp_dt = insert_declarator($1);
        tmp_dt->sort = $1->sort;
        tmp_dt->id_l = ident_decl;
        if ($1->dataptr)
            tmp_dt->opt_l = (OD_ListP)$1->dataptr;
        tmp_dt->length = $1->length;
        tmp_dt->type = $1->type;

        /*
         * Ϣ decr_type 
         * int x; Τ褦 declarator ʬ type ʤ硤
         * declarator "x"  decr_type ĥʤ
         */
        tmp_dt = make_decr_type2(tmp_dt, $1->type_spec2_last);
        
        decl_decl_stack->decl_decl =
            insert_declarator_list(decl_decl_stack->decl_decl,tmp_dt,$1);

        $$ = $1;
        $$->type_list2 = append_type_list2(NULL, $1->type_spec2, NULL);
        /* ̤ identifier ΥꥹȤ */
        if ($1->ident != NULL) {
            $$->ident_list = insert_identifier_list(NULL, $1->ident, NULL);
            $$->ident = NULL;
        }

        $$->type = NULL;

        /* Fixing sdbin4-0118, modified by A.Yoshida 1999/05/30. */
        /*
         * Because another init_declarator may follow this declarator,
         * the following flag must be set. If not set, the identifier 
         * in the init_declarator following this declarator is to be
         * analyzed as a TYPEDEF_NAME or an ENUMERATION_CONSTANT by lex
         * when the same name is declared in typedef declaration and/or 
         * enumerator declaration before.
         */
        set_specifier_flag(1);
    }

    | init_declarator_list COMMA init_declarator {
        DROP tmp_dt;
        tmp_dt = insert_declarator($3);
        tmp_dt->sort = $3->sort;
        tmp_dt->id_l = ident_decl;
        if ($3->dataptr)
            tmp_dt->opt_l = (OD_ListP)$3->dataptr;
        tmp_dt->length = $3->length;
        tmp_dt->type = $3->type;
        
        /*
         * Ϣ decr_type 
         * int x; Τ褦 declarator ʬ type ʤ硤
         * declarator "x"  decr_type ĥʤ
         */
        tmp_dt = make_decr_type2(tmp_dt, $3->type_spec2_last);

        decl_decl_stack->decl_decl =
            insert_declarator_list(decl_decl_stack->decl_decl,tmp_dt,$3);

        $$ = $1;
        $$->type_list2 = append_type_list2($1->type_list2, $3->type_spec2,
                                           NULL);
        /* ̤ identifier ΥꥹȤ */
        if ($3->ident != NULL) {
            $$->ident_list
                = insert_identifier_list($1->ident_list, $3->ident, NULL);
        }
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

init_declarator   /* ================================================= */
    : declarator {
        init_declarator_make_type_ref();

        $$ = $1;
        $$->type = ptr_type;
        $$->ident = NULL;       /* ident_type  */

        if (storage_stack->storage == STORAGE_TYPEDEF) {
            process_typedef_declarator($$, $1);
        } else {
            append_link_type_is();
            
            switch ($1->sort) {
              case DATA_NAME:
              case FUNC_PTR:
              case FUNC_TYPE:
                process_variable_declarator($$, $1, FALSE);
                break;
              case NON:
                /* Function prototype */
                process_prototype_declarator($$, $1);
                break;
              default:
                break;
            }
        }

        /* $$->dataptr ˤ optionaldecl_list ꤵƤ롥 */
    }

    | declarator {
        init_declarator_make_type_ref();

        $$ = $1;
        $$->type = ptr_type;
        $$->ident = NULL;       /* ident_type  */

        process_variable_declarator($$, $1, TRUE);
        
    } EQUAL initializer {
        ODP tmp_opt;
        
        tmp_opt = insert_optionaldecl(NULL);
        tmp_opt->sort = OPT_INITIALIZER;
        tmp_opt->initexpr_l = insert_expression_list(NULL,$4->expr,$4);
        tmp_opt->length = get_length($3, $4);
        $$->dataptr = (void *)insert_optionaldecl_list($$->dataptr,tmp_opt,$3);

        /* $$->dataptr ˤ optionaldecl_list ꤵƤ롥 */

        update_region_info($$, $1, $3, $4, NULL);
    }
    ;

struct_declaration   /* ============================================== */
    : specifier_qualifier_list struct_declarator_list semicolon {
        DNOP tmp_decl;
        tmp_decl = insert_declaration($1);
        tmp_decl->length = get_length($1, $3);
        tmp_decl->sort = DECL_MEMBER;
        tmp_decl->mem_l = (MEMS_ListP)$2->dataptr;
        tmp_decl->type_ref =
            insert_type_list(NULL, get_non_pointer_type($2->type), $1);
        tmp_decl->dt_l = decl_decl_stack->decl_decl;

        /* Ϣ decl_type  */
        tmp_decl = make_decl_type2(tmp_decl, $1->type_spec2_last);

        type_ref = NULL;
        set_specifier_flag(0);
        /* specifier_qualifier_list  struct_declarator_list ηϢ */
        make_type_st2_list($1->type_spec2_last, $2->type_list2);
        free_type_list2($2->type_list2);
        /* ̤ identifier η */
        set_ident_type2_list($2->ident_list, $1->type_spec2_last);
        free_IDO_ListP($2->ident_list);
        
        $$ = $1;
        $$->dataptr = (void *)tmp_decl;
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

specifier_qualifier_list   /* ======================================== */
    : type_specifier {
        ptr_ts_stack->point = $1->head_point;
#ifdef TYPE_REF_DEBUG
        printf("ST type_specifier      %d\n",$1->head_point);
#endif
        $$ = $1;
        $$->type_spec2_last = $1->type_spec2;
    }

    | type_specifier specifier_qualifier_list {
        ptr_ts_stack->point = $1->head_point;
#ifdef TYPE_REF_DEBUG
        printf("ST type_specifier-list %d\n",$1->head_point);
#endif
        make_type_st2($1->type_spec2, $2->type_spec2);
        $$ = $1;
        $$->type_spec2_last = $2->type_spec2_last;
        update_region_info($$, $1, $2, NULL);
    }   

    | type_qualifier {
        ptr_ts_stack->point = $1->head_point;
#ifdef TYPE_REF_DEBUG
        printf("ST type_qualifier      %d\n",$1->head_point);
#endif
        $$ = $1;
        $$->type_spec2_last = $1->type_spec2;
    }

    | type_qualifier specifier_qualifier_list {
        ptr_ts_stack->point = $1->head_point;
#ifdef TYPE_REF_DEBUG
        printf("ST type_qualifier-list %d\n",$1->head_point);
#endif
        make_type_st2($1->type_spec2, $2->type_spec2);
        $$ = $1;
        $$->type_spec2_last = $2->type_spec2_last;
        update_region_info($$, $1, $2, NULL);
    }
    ;

struct_declarator_list   /* ========================================== */
    : struct_declarator {
        MEMS_ListP mem_l = (MEMS_ListP)NULL;
        if ($1->dataptr)
            mem_l = insert_member_list(NULL,(MEMSP)$1->dataptr,$1);
        $$ = $1;
        $$->type_list2 = append_type_list2(NULL, $1->type_spec2, NULL);
        /* ̤ identifier ΥꥹȤ */
        if ($1->ident != NULL) {
            $$->ident_list = insert_identifier_list(NULL, $1->ident, NULL);
            $$->ident = NULL;
        }
        $$->dataptr = (void *)mem_l;
        set_specifier_flag(1);
    }

    | struct_declarator_list COMMA struct_declarator {
        MEMS_ListP mem_l = (MEMS_ListP)$1->dataptr;
        if ($3->dataptr)
            mem_l = insert_member_list(mem_l,(MEMSP)$3->dataptr,$3);
        $$ = $1;
        $$->type_list2 = append_type_list2($1->type_list2, $3->type_spec2,
                                           NULL);
        /* ̤ identifier ΥꥹȤ */
        if ($3->ident != NULL) {
            $$->ident_list
                = insert_identifier_list($1->ident_list, $3->ident, NULL);
        }
        $$->dataptr = (void *)mem_l;
        update_region_info($$, $1, $2, $3, NULL);
        set_specifier_flag(1);
    }
    ;

struct_declarator   /* =============================================== */
    : declarator {
        $$ = $1;
        $$->dataptr = (void *)process_struct_declarator($$, $1);
        $$->type = ptr_type;
    }

    | declarator ':' constant_expression {
        const_in_type = insert_cs_list(const_in_type ,ptr_const,$3); 
        $$ = $1;
        $$->dataptr = (void *)process_struct_declarator($$, $1);
        $$->type = ptr_type;
        
        update_region_info($$, $1, $2, $3, NULL);
    }

    | ':' constant_expression {
        $$ = $1;
        reset_wp_type_spec2($$);
        $$->dataptr = (void *)NULL;
        update_region_info($$, $1, $2, NULL);
    }
    ;

enum_prefix   /* ===================================================== */
    : ENUM {
        enum_counter = 0;
        ptr_enum_cs_list = NULL;
        $$ = $1;
        /* Added by A.Yoshida 1999/06/03. */
        /* Because enumerators whose name is same with typedef-ed name may 
           exist, lex must treat all identifier as IDENTIFIER. */
        set_specifier_flag(1);
    }
    ;

enum_specifier   /* ================================================== */
    : enum_prefix  '{' { set_specifier_flag(1); } tmp_enumerator_list '}' {
        /* 
         * set_specifier_flag(1): Added by A.Yoshida, 2002/04/02.
         * 
         * The lexer always set the flag to 1 when it finds a token '{', 
         * because the flag must be 0 at the beginning of a compound 
         * block. But, specifier_flag must be 1 at the beginning of a 
         * enumerator_list, because the lexer would recognize the first 
         * enumerator in enumerator_list as TYPEDEF_NAME
         * (or GUESSED_TYPEDEF_NAME in D-model) if not.
         */

        ODP tmp_opt;
        DROP tmp_dt;
        
        ptr_ts_enum = insert_type(NULL,$1);
        ptr_ts_enum->sort = TYPE_ENUM_SPECIFIER;
        ptr_ts_enum->enum_const = ptr_enum_cs_list;
        copy_type_spec2(ptr_ts_enum, ptr_ts_stack->sort);
        tmp_opt = (ODP)$4->dataptr;
        tmp_opt->length = get_length($2, $5);
        tmp_dt = insert_declarator(NULL);
        tmp_dt->length = tmp_opt->length;
        tmp_dt->opt_l = insert_optionaldecl_list(NULL, tmp_opt, $2);
        tmp_dt->sort = DECL_TAG;
        
        decl_decl_stack->decl_decl =
            insert_declarator_list(decl_decl_stack->decl_decl, tmp_dt, $2);
        
        $$ = $1;
        $$->type_spec2 = make_type_spec2_enum(NULL, $1);
        $$->type_spec2_last = $$->type_spec2;
        update_region_info($$, $1, $2, $4, $5, NULL);
    }
    | enum_prefix ident_or_type {
        IDOP tmp_ident;
        TS2P tmp_type;
        
        ptr_ts_enum = insert_type($2->name, $2);
        ptr_ts_enum->sort = TYPE_ENUM_SPECIFIER;

        tmp_ident = find_tag_with_member($2->name);

        /* tmp_ident = insert_identifier($2->name, ID_TAG); */
        tmp_ident->data.type = ptr_ts_enum;
        tmp_ident->length = $2->length;
        ptr_ts_enum->ident = tmp_ident;
        ident_decl = insert_identifier_list(NULL, tmp_ident, $2);
        push_pointer((void *)ident_decl);
        ident_decl = NULL;
        
        tmp_fo->scope->type_t
            = insert_type_list(tmp_fo->scope->type_t, ptr_ts_enum, $1);

        tmp_type = make_type_spec2_enum($2->name, $1);
        tmp_type = make_type_is2(tmp_type, tmp_ident);
        $$ = $1;
        $$->type_spec2 = tmp_type;
        $$->type_spec2_last = $$->type_spec2;
    }
    '{' { set_specifier_flag(1); } tmp_enumerator_list '}' {
        ODP tmp_opt;
        DROP tmp_dt;
        ident_decl = (IDO_ListP)pop_pointer();
        
        ptr_ts_enum->enum_const = ptr_enum_cs_list;
        copy_type_spec2(ptr_ts_enum, ptr_ts_stack->sort);
        tmp_opt = (ODP)$6->dataptr;
        tmp_opt->length = get_length($4, $7);
        tmp_dt = insert_declarator(NULL);
        tmp_dt->length = get_length($2, $7);
        tmp_dt->opt_l = insert_optionaldecl_list(NULL, tmp_opt, $4);
        tmp_dt->sort = DECL_TAG;
        /* for BUGFIX sdbin3-0035 */
        /* ident_decl->ident->type = ptr_ts_enum; */ 
        tmp_dt->id_l = ident_decl;
        
        ident_decl = NULL;
        decl_decl_stack->decl_decl =
            insert_declarator_list(decl_decl_stack->decl_decl, tmp_dt, $2);

        WP_COPY_IDENT($$, $2);
        $$->sort = $2->sort;
        update_region_info($$, $1, $2, $4, $6, $7, NULL);
    }

    | enum_prefix ident_or_type {
        TSP ptr_ts;
        DROP tmp_dt;
        IDOP tmp_ident;
        TS2P tmp_type;
        
        if (!find_cp_enum($2->name, ptr_ts_stack->sort)) {
            ptr_ts = insert_type($2->name, $2);
            ptr_ts->sort = TYPE_ENUM_SPECIFIER;
            ptr_ts->struc = NULL;
            copy_type_spec2(ptr_ts, ptr_ts_stack->sort);
            tmp_fo->scope->type_t = insert_type_list(tmp_fo->scope->type_t,
                                                     ptr_ts, $2);
            /* tmp_ident = insert_identifier($2->name, ID_TAG); */
        }
        /* tmp_ident = find_identifier($2->name, ID_TAG); */

        tmp_ident = find_tag_without_member($2->name);
        tmp_ident->length = $2->length;

        /* Modified by A.Yoshida 1999/05/06. */
        /*
         * There was a bug same with sdbin4-0117. See memo in the rule 
         * of struct_or_union_specifier.
         */
        push_pointer((void *)ident_decl);       /* Push anyway, and */
        ident_decl = insert_identifier_list(NULL, tmp_ident, $2);
        tmp_dt = insert_declarator(NULL);
        tmp_dt->length =  $2->length;
        tmp_dt->sort = DECL_TAG;
        tmp_dt->id_l = ident_decl;
        ident_decl = (IDO_ListP)pop_pointer();  /* pop here. No side effect.*/
        decl_decl_stack->decl_decl =
            insert_declarator_list(decl_decl_stack->decl_decl, tmp_dt, $2);
        
        tmp_type = make_type_spec2_enum($2->name, $1);
        tmp_type = make_type_is2(tmp_type, tmp_ident);
        $$ = $1;
        $$->type_spec2 = tmp_type;
        $$->type_spec2_last = $$->type_spec2;
        update_region_info($$, $1, $2, NULL);
    }
    ;

tmp_enumerator_list   /* ============================================= */
    : enumerator_list {
        $$ = $1;
    }
    | enumerator_list COMMA {
        spdWarning("\"%s\": %d: Comma at end of enumerator list.\n",
                   filename, yylineno);
        $$ = $1;
        /* Added by S.Yamamoto 1999/05/05. */
        /* Treat COMMA as nothing. */
        /* !! length νɬפʤ? */
        /* $$->expr->length = get_length($1, $2); */
        update_region_info($$, $1, $2, NULL);
    }
    ;

enumerator_list   /* ================================================= */
    : enumerator {
        ODP tmp_opt;
        DNOP tmp_decl;
        
        clear_ts(ptr_ts_stack->sort);
        tmp_opt = insert_optionaldecl(NULL);
        tmp_opt->sort = OPT_STRUCT;
        tmp_decl = insert_declaration(NULL);
        tmp_decl->sort = DECL_ENUMERATOR;
        tmp_decl->length = $1->length;
        tmp_decl->dt_l = 
            insert_declarator_list(NULL, (DROP)$1->dataptr, $1);
        tmp_opt->decl_l =
            insert_declaration_list(NULL,tmp_decl,$1);
        $$ = $1;
        $$->dataptr = (void *)tmp_opt;
    }

    | enumerator_list COMMA enumerator {
        ODP tmp_opt;
        DNOP tmp_decl;
        tmp_opt = (ODP)$1->dataptr;
        tmp_decl = insert_declaration(NULL);
        tmp_decl->sort = DECL_ENUMERATOR;
        tmp_decl->length = $3->length;
        tmp_decl->dt_l = 
            insert_declarator_list(NULL, (DROP)$3->dataptr, $3);
        tmp_opt->decl_l =
            insert_declaration_list(tmp_opt->decl_l,tmp_decl,$3);
        
        $$ = $1;
        $$->dataptr = (void *)tmp_opt;

        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

enumerator   /* ====================================================== */
    : identifier {
        IDOP    tmp_ident;
        DROP    tmp_dt;
        
        ptr_const = insert_constant($1->name, CONST_ENUM, $1->length,
                                    $1->point, current_file);
        ptr_enum_cs_list = insert_cs_list(ptr_enum_cs_list, ptr_const, NULL);
        tmp_ident = insert_identifier($1->name, ID_ENUMERATOR);
        tmp_ident->data.cons = ptr_const;
        tmp_ident->length = $1->length;
        tmp_ident->type = type_int;

        /* enumerator ηϰۤ int */
        set_ident_type2(tmp_ident, type_spec2_implicit_int());
        
        tmp_dt = insert_declarator($1);
        tmp_dt->sort = DECL_ENUMERATOR;
        tmp_dt->id_l = insert_identifier_list(NULL, tmp_ident, $1);
        tmp_dt->type = type_int;
        ptr_const->value = spdStrdup($1->name);
        add_const_table(ptr_const);
        $$ = $1;
        $$->dataptr = (void *)tmp_dt;
    }

    | identifier EQUAL constant_expression {
        IDOP tmp_ident;
        ODP  tmp_opt;
        DROP  tmp_dt;
        
        ptr_const = insert_constant($1->name, CONST_ENUM, $1->length,
                                    $1->point, current_file);
        ptr_enum_cs_list = insert_cs_list(ptr_enum_cs_list, ptr_const, NULL);
        tmp_ident = insert_identifier($1->name, ID_ENUMERATOR);
        tmp_ident->data.cons = ptr_const;
        tmp_ident->length = $1->length;
        tmp_ident->type = type_int;

        /* enumerator ηϰۤ int */
        set_ident_type2(tmp_ident, type_spec2_implicit_int());

        tmp_dt = insert_declarator(NULL);
        tmp_dt->length = get_length($1, $3);
        tmp_dt->sort = DECL_ENUMERATOR;
        tmp_dt->id_l = insert_identifier_list(NULL, tmp_ident, $1);
        tmp_dt->type = type_int;
        tmp_opt = insert_optionaldecl(NULL);
        tmp_opt->sort = OPT_INITIALIZER;
        tmp_opt->initexpr_l = insert_expression_list(NULL, $3->expr, $3);
        tmp_opt->length = get_length($2, $3);
        tmp_dt->opt_l = insert_optionaldecl_list(NULL, tmp_opt, $2);
        ptr_const->value = spdStrdup($1->name);
        add_const_table(ptr_const);
        
        /* ptr_const reused for $3 */
        $$ = $1;
        $$->dataptr = (void *)tmp_dt;
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

declarator   /* ====================================================== */
    : pointer direct_declarator {
        ptr_ts_stack->queue->in->next = ptr_ts_stack->list;
        ptr_ts_stack->list = ptr_ts_stack->queue->out;
        
        $$ = $1;
        WP_COPY_IDENT($$, $2);

        /* pointer  direct_declarator ηϢ */
        make_type_st2($1->type_spec2_last, $2->type_spec2);
        if ($2->type_spec2_last != NULL) {
            $$->type_spec2_last = $2->type_spec2_last;
        }

#ifdef VAR_DEBUG
        printf("pointer direct_decl  %s  sort = %d\n", $2->name,$2->sort);
#endif
        $$->sort = $2->sort;
        if ($2->sort == ID_NAME) {
            $$->sort = DATA_NAME;
        } else if ($2->sort == FUNCTION_NAME) {
            $$->sort = NON;
        }
        $$->dataptr = $2->dataptr;
        update_region_info($$, $1, $2, NULL);
    }

    | direct_declarator {
        $$ = $1;
        if ($1->sort == ID_NAME) {
            $$->sort = DATA_NAME;
        } else if ($1->sort == FUNCTION_NAME) {
            $$->sort = NON;
        }
    }
    ;

direct_declarator   /* =============================================== */
    : identifier {
        set_specifier_flag(0);
        $$ = $1;
        reset_wp_type_spec2($$);
    }

    | direct_declarator_nest_lp declarator ')' {
        pop_queue();
        
        $$ = $1;
        WP_COPY_IDENT($$, $2);
        $$->sort = $2->sort;
#ifdef VAR_DEBUG
        printf("pointer (direct_decl)  %s  sort = %d\n", $2->name,$2->sort);
#endif
        /* $$->sort = DATA_NAME; */

        $$->type_spec2 = $2->type_spec2;
        $$->type_spec2_last = $2->type_spec2_last;
        
        update_region_info($$, $1, $2, $3, NULL);
    }

    | direct_declarator '[' ']' {
        TS2P tmp_type;
        tmp_type = make_type_spec2_array(NULL, $2);

        app_array_id(NULL,NULL);
        
        make_type_st2(tmp_type, $1->type_spec2);
        $$ = $1;
        $$->type_spec2 = tmp_type;
        if ($1->type_spec2_last == NULL) {
            $$->type_spec2_last = tmp_type;
        }
        update_region_info($$, $1, $2, $3, NULL);
    }

    | direct_declarator '[' {
        push_ts();
    }
    constant_expression ']' {
        TS2P tmp_type;
        tmp_type = make_type_spec2_array($4, $2);

        pop_ts();
        app_array_id($4->expr, $4);
        
        make_type_st2(tmp_type, $1->type_spec2);
        $$ = $1;
        $$->type_spec2 = tmp_type;
        if ($1->type_spec2_last == NULL) {
            $$->type_spec2_last = tmp_type;
        }
        update_region_info($$, $1, $2, $4, $5, NULL);
    }

    | direct_declarator '(' {
        push_ts();
        if (direct_decl_stack->direct_decl != NON) {
            push_func_parm();
        }
        if (direct_decl_stack->direct_decl == DEF_FUNC ||
            direct_decl_stack->direct_decl == DEF_PARM) {
            /* Added by A.Yoshida 1999/08/11. */
            /* A function's parameter typed as a pointer to function may 
               has some declarations as parameters. These declarations 
               exists in a different scope, which we call DEF_PARM, from
               function scope. */
            push_direct_decl(DEF_PARM);
        } else {
            push_direct_decl(DEF_FUNC);
        }
        push_storage();     /* Added by N.Fukuyasu 1997/10/22. */
        push_decl_decl();   /* Added by N.Fukuyasu 1997/10/24. */
        insert_level(SCOPE_LOCAL);  /* Added by A.Yoshida 1999/08/20. */
        /* Added by N.Fukuyasu 1997/10/25. */
        push_pointer((void *)type_ref);
        type_ref = NULL;
    }
    parameter_type_list ')' {
        /* Added by N.Fukuyasu 1997/10/25. */
        type_ref = (TypeListP)pop_pointer();
        pop_ts();
        pop_direct_decl();
        pop_storage();      /* Added by N.Fukuyasu 1997/10/22. */
        pop_decl_decl();    /* Added by N.Fukuyasu 1997/10/24. */
        escape_level();     /* Added by A.Yoshida 1999/08/20. */
        if (direct_decl_stack->direct_decl != NON) {
            pop_func_parm();
        }
        
        $$ = $1;
        process_function_direct_declarator($$, $2);

        $$->dataptr = $4->dataptr;
        update_region_info($$, $1, $2, $4, $5, NULL);
    }

    | direct_declarator '(' ')' {
#ifdef VAR_DEBUG
        printf("pointer direct_decl()  %s  sort = %d\n", $1->name, $1->sort);
#endif
        
        $$ = $1;
        process_function_direct_declarator($$, $2);
        update_region_info($$, $1, $2, $3, NULL);
    }

    | direct_declarator '(' identifier_list ')' {
        $$ = $1;
        process_function_direct_declarator($$, $2);
        update_region_info($$, $1, $2, $3, $4, NULL);
    }
    ;

direct_declarator_nest_lp   /* ======================================= */
    : '(' {
        push_queue();
        $$ = $1;
    }
    ;

star   /* ============================================================ */
    : STAR {
        app_pointer_id();
        $$ = $1;
        $$->type_spec2 = make_type_spec2_sort(TYPE_POINTER, $1);
        $$->type_spec2_last = $$->type_spec2;
    }
    ;

pointer   /* ========================================================= */
    : star {
#ifdef PARM_DEBUG
        printf ("pointer WP head %d total %d name %s\n",
                $1->head_point,$1->length,$1->name);
#endif
        $$ = $1;
        $$->type_spec2_last = $1->type_spec2;
    }

    | star type_qualifier_list {
        make_type_st2($1->type_spec2, $2->type_spec2);
        $$ = $1;
        $$->type_spec2_last = $2->type_spec2_last;
        update_region_info($$, $1, $2, NULL);
    }

    | star type_qualifier_list pointer {
        make_type_st2($1->type_spec2, $2->type_spec2);
        make_type_st2($2->type_spec2_last, $3->type_spec2);
        $$ = $1;
        $$->type_spec2_last = $3->type_spec2_last;
        update_region_info($$, $1, $2, $3, NULL);
    }

    | star pointer {
        make_type_st2($1->type_spec2, $2->type_spec2);
        $$ = $1;
        $$->type_spec2_last = $2->type_spec2_last;
        update_region_info($$, $1, $2, NULL);
    }
    ;

type_qualifier_list   /* ============================================= */
    : type_qualifier {
        ptr_ts_stack->queue->in->qualifier = $1->sort;
        $$ = $1;
    }

    | type_qualifier_list type_qualifier {
        ptr_ts_stack->queue->in->qualifier = $2->sort;
        make_type_st2($1->type_spec2_last, $2->type_spec2);
        $$ = $1;
        $$->type_spec2_last = $2->type_spec2;
        update_region_info($$, $1, $2, NULL);
    }
    ;

parameter_type_list   /* ============================================= */
    : parameter_list

    | parameter_list COMMA DOTS {
        DNOP tmp_decl;
        TypeListP tmp_type_ref;
        TS2P tmp_type2;
        
        ptr_ts_stack->sort->type = TYPE_DOTS;
        ptr_ts_stack->sort->sort = TYPE_DECLARATION;
        ptr_type = APP_TYPE_SPEC();
        tmp_type_ref = insert_type_list(NULL,
                                        get_non_pointer_type(ptr_type),
                                        $3);

        /*  TYPE_DOTS  */
        tmp_type2 = make_type_spec2_specifier(TYPE_DOTS, $3);

        tmp_decl = insert_declaration(NULL);
        tmp_decl->sort = DECL_PARAMETER;
        tmp_decl->length = $3->length;

        /* Ϣ decl_type  */
        tmp_decl = make_decl_type2(tmp_decl, tmp_type2);

        set_declaration(tmp_decl, NULL, NULL, tmp_type_ref);
        
        clear_ts(ptr_ts_stack->sort);
        
        type_ref = NULL;
        
        func_parm_stack->decl_l
            = insert_declaration_list(func_parm_stack->decl_l, tmp_decl, $3);
        $$ = $1;
        $$->dataptr = (void *)insert_declaration_list($1->dataptr,
                                                      tmp_decl, $3);
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

parameter_list   /* ================================================== */
    : parameter_declaration {
        clear_ts(ptr_ts_stack->sort);
        $$ = $1;
        if ($1->dataptr) {
            $$->dataptr =
                (void *)insert_declaration_list(NULL, (DNOP)$1->dataptr, $1);
        }
        pop_storage();      /* Added by N.Fukuyasu 1997/10/22. */
        push_storage();
        pop_decl_decl();    /* Added by N.Fukuyasu 1997/10/24. */
        push_decl_decl();
        type_ref = NULL;
    }

    | parameter_list COMMA parameter_declaration {
        clear_ts(ptr_ts_stack->sort);
        $$ = $1;
        if ($3->dataptr) {
            $$->dataptr = (void *)insert_declaration_list($1->dataptr,
                                                          (DNOP)$3->dataptr,
                                                          $3);
        }
        pop_storage();      /* Added by N.Fukuyasu 1997/10/22. */
        push_storage();
        pop_decl_decl();    /* Added by N.Fukuyasu 1997/10/24. */
        push_decl_decl();
        type_ref = NULL;
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

parameter_declaration   /* =========================================== */
    : declaration_specifiers declarator {
        DNOP        tmp_decl;
        DROP        tmp_dt;
        IDOP        tmp_ident;
        TypeListP   tmp_type_ref;
        TS2P        tmp_type, tmp_type2;
        
        tmp_wp.point = ptr_ts_stack->point;
        ptr_type = APP_TYPE_SPEC();
        tmp_type_ref = insert_type_list(NULL,
                                        get_non_pointer_type(ptr_type),
                                        &tmp_wp);
        
        /* Fixing sdbin3-0086, Added by N.Fukuyasu 1998/05/11. */
        append_link_type_is();
        
#ifdef PARM_DEBUG
        printf("direct_decl = %d at %d \n", direct_decl_stack->direct_decl,
               $1->head_point);
#endif
        
        ptr_data = insert_data($2->name, ptr_type, VAR_LOCAL,
                               storage_stack->storage,
                               $2->point, current_file);
        if (!F_model ||
            (tmp_ident = find_identifier_by_ptr(ptr_data, ID_VARIABLE)) == NULL) {
            tmp_ident = insert_identifier($2->name, ID_VARIABLE);
            tmp_ident->length = strlen($2->name);
            tmp_ident->data.var = ptr_data;
            tmp_ident->type = ptr_type;

            /* ident_type  */
            tmp_type2 = $2->type_spec2_last;
            if (tmp_type2 == NULL) tmp_type2 = $1->type_spec2_last;
            if (tmp_type2 == NULL) tmp_type2 = type_spec2_implicit_int();
            set_ident_type2(tmp_ident, tmp_type2);
        }
        
        tmp_dt = insert_declarator($2);
        tmp_dt->sort = DECL_VARIABLE;
        tmp_dt->id_l = insert_identifier_list(NULL, tmp_ident, $2);
        tmp_dt->type = ptr_type;

        /* Ϣ decr_type  */
        tmp_dt = make_decr_type2(tmp_dt, $2->type_spec2_last);

        /* function pointer or function type */
        if ($2->sort == FUNC_PTR || $2->sort == FUNC_TYPE) {
            tmp_dt->opt_l = make_function_pointer($2, &decl_point,
                                                  (DO_ListP)$2->dataptr);
        }
        
        tmp_decl = insert_declaration(NULL);
        tmp_decl->sort = DECL_PARAMETER;
        tmp_decl->length = get_length($1, $2);
        /* Added by N.Fukuyasu 1997/10/22. */
        tmp_decl->storage = storage_stack->storage;
        tmp_decl->dt_l =
            insert_declarator_list(decl_decl_stack->decl_decl, tmp_dt, $2);

        /* Ϣ decl_type  */
        tmp_decl = make_decl_type2(tmp_decl, $1->type_spec2_last);

        set_declaration(tmp_decl, NULL, NULL, tmp_type_ref);
        func_parm_stack->decl_l
            = insert_declaration_list(func_parm_stack->decl_l, tmp_decl, $1);

        /* declaration_specifiers  declarator ηϢ */
        tmp_type = $1->type_spec2_last;
        if (tmp_type == NULL) {
            tmp_type = type_spec2_implicit_int();
        }
        make_type_st2(tmp_type, $2->type_spec2);

        $$ = $1;
        $$->dataptr = (void *)tmp_decl;
        
        if (direct_decl_stack->direct_decl == DEF_FUNC) {
#ifdef PARM_DEBUG
            printf("\tdecl var name %s at %d length %d\n",
                   $2->name, $2->head_point, $2->length);
#endif
            ptr_fs_input = insert_data_list(ptr_fs_input, ptr_data, NULL);
        }
        
        /* type_ref = NULL ; */
        set_specifier_flag(0);
        update_region_info($$, $1, $2, NULL);
    }

    | declaration_specifiers {
        DNOP        tmp_decl;
        TypeListP   tmp_type_ref;
        
        tmp_wp.point = ptr_ts_stack->point;
        ptr_type = APP_TYPE_SPEC();
        tmp_type_ref = insert_type_list(NULL,
                                        get_non_pointer_type(ptr_type),
                                        &tmp_wp);
        
        /* Fixing sdbin3-0086, Added by N.Fukuyasu 1998/05/11. */
        append_link_type_is();
        
        tmp_decl = insert_declaration(NULL);
        tmp_decl->sort = DECL_PARAMETER;
        tmp_decl->length = $1->length;
        /* Added by N.Fukuyasu 1997/10/22. */
        tmp_decl->storage = storage_stack->storage;

        /*
         * "int f(struct X);"declaration "struct X"declarator "X"
         * δ֤δϢdecl_decl.
         */
        tmp_decl->dt_l = decl_decl_stack->decl_decl;

        /* Ϣ decl_type  */
        tmp_decl = make_decl_type2(tmp_decl, $1->type_spec2_last);

        set_declaration(tmp_decl, NULL, NULL, tmp_type_ref);
        $$ = $1;
        $$->dataptr = (void *)tmp_decl;

        set_specifier_flag(0);
    }

    | declaration_specifiers abstract_declarator {
        DNOP        tmp_decl;
        DROP        tmp_dt;
        TypeListP   tmp_type_ref;
        TS2P        tmp_type;
        
        tmp_wp.point = ptr_ts_stack->point;
        ptr_type = APP_TYPE_SPEC();
        tmp_type_ref = insert_type_list(NULL, get_non_pointer_type(ptr_type),
                                        &tmp_wp);
        
        /* Fixing sdbin3-0086, added by N.Fukuyasu 1998/05/11. */
        append_link_type_is();
        
        tmp_dt = insert_declarator($2);
        tmp_dt->sort = DECL_PARMTYPE;
        if ($2->dataptr != NULL) {          /* function pointer */
            tmp_dt->opt_l = (OD_ListP)$2->dataptr;
        }
        tmp_dt->type = ptr_type;

        /* Ϣ decr_type  */
        tmp_dt = make_decr_type2(tmp_dt, $2->type_spec2_last);
        
        tmp_decl = insert_declaration(NULL);
        tmp_decl->sort = DECL_PARAMETER;
        tmp_decl->length = get_length($1,$2);
        /* Added by N.Fukuyasu 1997/10/22. */
        tmp_decl->storage = storage_stack->storage;
        /* Moved by N.Fukuyasu 1997/06/01. */
        /* tmp_decl->dt_l = decl_decl; */

        /*
         * "int f(struct X *);"declaration "struct X *"declarator "X"
         * declarator "*"Ȥδ֤δϢdecl_decl.
         */
        tmp_decl->dt_l = insert_declarator_list(decl_decl_stack->decl_decl,
                                                tmp_dt, $2);

        /* Ϣ decl_type  */
        tmp_decl = make_decl_type2(tmp_decl, $1->type_spec2_last);

        set_declaration(tmp_decl,NULL,NULL,tmp_type_ref);

        /* declaration_specifiers  abstract_declarator ηϢ */
        tmp_type = $1->type_spec2_last;
        if (tmp_type == NULL) {
            tmp_type = type_spec2_implicit_int();
        }
        make_type_st2(tmp_type, $2->type_spec2);

        $$ = $1;
        $$->dataptr = (void *)tmp_decl;
        
        type_ref = NULL;    /* Added by N.Fukuyasu 1997/06/01. */
        set_specifier_flag(0);
        update_region_info($$, $1, $2, NULL);
    }
    ;

identifier_list   /* ===== Used only in function definition parameter. */
    : identifier {
        DNOP    tmp_decl = process_identifier_list($1);
        
        /*
         * type_ref  NULL ǤʤϤ뤫?
         *  NULL ʤ
         *     process_identifier_list() ֤
         *     tmp_decl
         *      set_declaration() θƤӽФ
         * ס
         * N.Fukuyasu 1998/06/16.
         */
        /*
         * identifier_list  K&R δؿΰ˸롥
         * ξ硤ɽ declaration ϴϢ decl_type 
         * ʤΤ type_ref  NULL Ǥ롥
         * N.Fukuyasu 1998/06/22.
         */
        set_declaration(tmp_decl,NULL,NULL,type_ref);
        type_ref = NULL ;
        $$ = $1;
    }

    | identifier_list COMMA identifier {
        process_identifier_list($3);
        $$ = $1;
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

identifier   /* ====================================================== */
    : IDENTIFIER {
        $$ = $1;
        $$->sort = ID_NAME;
    }
    ;

initializer   /* ===================================================== */
    : assignment_expression {
        /* expression in decl ? */
        
        free_TS_ListP(type_expr);

        ident_ref = NULL;
        var_ref = NULL;
        mem_ref = NULL;
        type_expr = NULL;
        $$ = $1;
    }

    | '{' tmp_initializer_list '}' {
        $$ = $1;
        $$->expr = $2->expr;
        $$->expr->length = get_length($1, $3);
        $$->expr->sort = EXPR_SORT_INITLIST;
        
        update_region_info($$, $1, $2, $3, NULL);
    }

    | '{' '}' {
        EOP empty;

        empty = insert_expression(NULL);
        empty->length = get_length($1, $2);
        empty->sort = EXPR_SORT_INITLIST;
        empty->lrtype = EXPR_R_VALUE;
        
        $$ = $1;
        $$->expr = empty;
        
        update_region_info($$, $1, $2, NULL);
        spdWarning("Empty initializer list exists at l.%d.\n", yylineno);
    }
    ;

tmp_initializer_list   /* ============================================ */
    : initializer_list {
        $$ = $1;
    }

    | initializer_list COMMA {
        $$ = $1;
        $$->expr->length = get_length($1, $2);
        update_region_info($$, $1, $2, NULL);
    }
    ;

initializer_list   /* ================================================ */
    : initializer {
        EOP tmp_expr;
        
        tmp_expr = insert_expression($1);
        tmp_expr->length = $1->length;
        tmp_expr->expr_list =
            insert_expression_list(NULL, $1->expr, $1);
        tmp_expr->lrtype = EXPR_R_VALUE;
        tmp_expr->sort = EXPR_SORT_INITLIST;

        $$ = $1;
        $$->expr = tmp_expr;
    }
    
    | initializer_list COMMA initializer {
        $$ = $1;
        $$->expr->length = get_length($1, $3);
        $$->expr->expr_list =
            insert_expression_list($$->expr->expr_list, $3->expr, $3);
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

type_name   /* ======================================================= */
    : specifier_qualifier_list {
        set_specifier_flag(0);
        $$ = $1;
    }

    | specifier_qualifier_list abstract_declarator {
        set_specifier_flag(0);
        /* specifier_qualifier_list  abstract_declarator ηϢ */
        make_type_st2($1->type_spec2_last, $2->type_spec2);

        $$ = $1;
        $$->type_spec2_last = $2->type_spec2_last;
        update_region_info($$, $1, $2, NULL);
    }
    ;

abstract_declarator   /* ============================================= */
    : pointer {
        ptr_ts_stack->queue->in->next = ptr_ts_stack->list;
        ptr_ts_stack->list = ptr_ts_stack->queue->out;
        $$ = $1;
    }

    | direct_abstract_declarator

    | pointer direct_abstract_declarator {
        ptr_ts_stack->queue->in->next = ptr_ts_stack->list;
        ptr_ts_stack->list = ptr_ts_stack->queue->out;
        make_type_st2($1->type_spec2_last, $2->type_spec2);
        $$ = $1;
        $$->type_spec2_last = $2->type_spec2_last;
        $$->dataptr = $2->dataptr;
        update_region_info($$, $1, $2, NULL);
    }
    ;

direct_abstract_declarator   /* ====================================== */
    : direct_declarator_nest_lp  abstract_declarator ')' {
        pop_queue();
        set_specifier_flag(0);
        $$ = $1;
        $$->type_spec2 = $2->type_spec2;
        $$->type_spec2_last = $2->type_spec2_last;
        update_region_info($$, $1, $2, $3, NULL);
    }

    | '[' ']' {
        TS2P tmp_type;
        tmp_type = make_type_spec2_array(NULL, $1);

        app_array_id(NULL,NULL);
        set_specifier_flag(0);
        $$ = $1;
        $$->type_spec2 = tmp_type;
        $$->type_spec2_last = tmp_type;
        update_region_info($$, $1, $2, NULL);
    }

    | '[' { 
        set_specifier_flag(0);
    }
    constant_expression ']' {
        TS2P tmp_type;
        tmp_type = make_type_spec2_array($3, $1);

#if CONST_DEBUG
        fprintf(stderr,"$$->name:%s\n",$3->name);
#endif
        set_specifier_flag(0);
        app_array_id($3->expr,$3);
        
        $$ = $1;        
        $$->type_spec2 = tmp_type;
        $$->type_spec2_last = tmp_type;
        update_region_info($$, $1, $3, $4, NULL);
    }

    | direct_abstract_declarator '[' ']' {
        TS2P tmp_type;
        tmp_type = make_type_spec2_array(NULL, $2);

        app_array_id(NULL,NULL);
        set_specifier_flag(0);
        make_type_st2(tmp_type, $1->type_spec2);
        $$ = $1;
        $$->type_spec2 = tmp_type;
        if ($1->type_spec2_last == NULL) {
            $$->type_spec2_last = tmp_type;
        }

        update_region_info($$, $1, $2, $3, NULL);
    }

    | direct_abstract_declarator '[' {
        set_specifier_flag(0);
    }
    constant_expression ']' {
        TS2P tmp_type;
        tmp_type = make_type_spec2_array($4, $2);

#if CONST_DEBUG
        fprintf(stderr,"$$->name:%s\n",$4->name);
#endif
        app_array_id($4->expr,$4);
        set_specifier_flag(0);
        make_type_st2(tmp_type, $1->type_spec2);
        $$ = $1;
        $$->type_spec2 = tmp_type;
        if ($1->type_spec2_last == NULL) {
            $$->type_spec2_last = tmp_type;
        }

        update_region_info($$, $1, $2, $4, $5, NULL);
    }

    | '(' ')' {
        TS2P tmp_type;
        tmp_type = make_type_spec2_sort(TYPE_FUNC, $1);

        app_func_id();
        set_specifier_flag(0);
        $$ = $1;
        $$->type_spec2 = tmp_type;
        $$->type_spec2_last = tmp_type;
        $$->dataptr = (void *)make_function_pointer($2, $1, NULL);
        update_region_info($$, $1, $2, NULL);
    }

    | '(' {
        push_ts();
        push_func_parm();
        push_storage(); /* Added by N.Fukuyasu 1997/10/22. */
        push_decl_decl();   /* Added by N.Fukuyasu 1997/10/24. */
        /* Added by N.Fukuyasu 1997/10/25. */
        push_pointer((void *)type_ref);
        type_ref = NULL;
    }
    parameter_type_list ')' {
        TS2P tmp_type;
        tmp_type = make_type_spec2_sort(TYPE_FUNC, $1);

        /* Added by N.Fukuyasu 1997/10/25. */
        type_ref = (TypeListP)pop_pointer();
        pop_ts();
        pop_func_parm();
        pop_storage();  /* Added by N.Fukuyasu 1997/10/22. */
        pop_decl_decl();    /* Added by N.Fukuyasu 1997/10/24. */
        
        app_func_id();
        set_specifier_flag(0);
        $$ = $1;
        $$->type_spec2 = tmp_type;
        $$->type_spec2_last = tmp_type;
        $$->dataptr = (void *)make_function_pointer($4, $1,
                                                    (DO_ListP)$3->dataptr);
        update_region_info($$, $1, $3, $4, NULL);
    }

    | direct_abstract_declarator '(' ')' {
        TS2P tmp_type;
        tmp_type = make_type_spec2_sort(TYPE_FUNC, $2);

        app_func_id();
        set_specifier_flag(0);
        make_type_st2(tmp_type, $1->type_spec2);
        $$ = $1;
        $$->type_spec2 = tmp_type;
        if ($1->type_spec2_last == NULL) {
            $$->type_spec2_last = tmp_type;
        }

        $$->dataptr = (void *)make_function_pointer($3, $2, NULL);
        update_region_info($$, $1, $2, $3, NULL);
    }

    | direct_abstract_declarator '(' {
        push_ts();
        push_func_parm();
        push_storage(); /* Added by N.Fukuyasu 1997/10/22. */
        push_decl_decl();   /* Added by N.Fukuyasu 1997/10/24. */
    }
    parameter_type_list ')' {
        TS2P tmp_type;
        tmp_type = make_type_spec2_sort(TYPE_FUNC, $2);

        pop_ts();
        pop_func_parm();
        pop_storage();  /* Added by N.Fukuyasu 1997/10/22. */
        pop_decl_decl();    /* Added by N.Fukuyasu 1997/10/24. */
        
        app_func_id();
        set_specifier_flag(0);
        make_type_st2(tmp_type, $1->type_spec2);
        $$ = $1;
        $$->type_spec2 = tmp_type;
        if ($1->type_spec2_last == NULL) {
            $$->type_spec2_last = tmp_type;
        }

        $$->dataptr = (void *)make_function_pointer($5, $2,
                                                    (DO_ListP)$4->dataptr);
        update_region_info($$, $1, $2, $4, $5, NULL);
    }
    ;

typedef_name   /* ==================================================== */
    : TYPEDEF_NAME {
        TS2P tmp_type;

        tmp_type = make_type_spec2_typedef($1->name, $1);
        tmp_type = make_type_is2(tmp_type, $1->ident);

        $$ = $1;
        $$->ident = NULL;
        find_cp_typedef($1->name, ptr_ts_stack->sort);

        $$->type_spec2 = tmp_type;
        $$->type_spec2_last = tmp_type;
    }

    | GUESSED_TYPEDEF_NAME {
        /* 
         * typedefƤʤTYPEDEF_NAME?
         * For D-model.
         */
        TS2P    tmp_type;
        
        tmp_type = make_type_spec2_typedef($1->name, $1);
        tmp_type = make_type_is2(tmp_type, $1->ident);
        $$ = $1;
        $$->ident = NULL;
        find_cp_guessed_typedef($1->name , ptr_ts_stack->sort);
        $$->type_spec2 = tmp_type;
        $$->type_spec2_last = tmp_type;
    }
    ;

label_or_statement   /* ============================================== */
    : label {
        $$ = $1;
        labeled_stmt_flag = TRUE;
        /* If this flag is TRUE after reduced compound block, the last label 
           in the compound block does not followed by statement. See also
           the rule of compound_statement. */
    }

    | statement {
        $$ = $1;
        labeled_stmt_flag = FALSE;
    }
    ;

labeled_statement   /* =============================================== */
    /* Control statements must take labeled_statement. */
    : statement {
        $$ = $1;
    }

    | label labeled_statement {
        $$ = $2;
    }
    ;

statement   /* ======================================================= */
    : expression_statement {
        if (!basic_blk.flag) {
            tmp_blk = insert_block(BLOCK_BASIC,NULL);
            basic_blk.ptr = (void *)tmp_blk; 
            basic_blk.head_point = $1->head_point;
            basic_blk.flag = BLOCK_BASIC;
            blk_blk = insert_block_list(blk_blk,tmp_blk,$1);
        } else {
#if BLOCK_DEBUG
            printf(stderr, "in expr state block sort %d at %d\n",
                   current_blk->sort, $1->head_point);
#endif
        }
        basic_blk.tail_point = $1->head_point + $1->length;
        $$ = $1;        
    }

    | compound_statement {
        flag_func = NON;
        close_block();
        $$ = $1;
    }

    | selection_statement {
        close_block();
        $$ = $1;
    }

    | iteration_statement {
        close_block();
        $$ = $1;
    }

    | jump_statement {
        blk_expr = insert_expression_list(blk_expr,$1->expr,$1);
        if (!basic_blk.flag) {
            tmp_blk = insert_block(BLOCK_BASIC,NULL);
            basic_blk.ptr = (void *)tmp_blk; 
            basic_blk.head_point = $1->head_point;
            basic_blk.flag = BLOCK_BASIC;
            blk_blk = insert_block_list(blk_blk,tmp_blk,$1);
        } else{
#if BLOCK_DEBUG
            printf(stderr, "in expr state block sort %d at %d\n",
                   current_blk->sort,$1->head_point); 
#endif
        }
        basic_blk.tail_point = $1->head_point + $1->length;
        close_block();
        $$ = $1;
    }
    ;

label   /* =========================================================== */
    : ident_or_type ':' {
        LOP tmp_label;
        
        close_block();
        if ((tmp_label = find_label($1->name)) == NULL) {
            tmp_label = insert_label(LABEL_NAMED,0);
            SPEC_NAME_COPY(tmp_label->name,$1->name);
            add_label_table(tmp_label);
        }
        tmp_label->length = get_length($1, $2);
        blk_labl = insert_label_list(blk_labl,tmp_label,$1);
        $$ = $1;
    } 

    | CASE constant_expression ':' {
        LOP tmp_label;
        close_block();
        tmp_label = insert_label(LABEL_CASE,get_length($1,$3));
        tmp_label->expr_l = insert_expression_list(NULL, $2->expr, $2);
        blk_labl = insert_label_list(blk_labl,tmp_label,$1);
        $$ = $1;
    }

    | DEFAULT ':' {
        LOP tmp_label;          
        close_block();
        
        tmp_label = insert_label(LABEL_DEFAULT, get_length($1, $2));
        blk_labl = insert_label_list(blk_labl,tmp_label,$1);
        $$ = $1;
    }
    ;

expression_statement   /* ============================================ */
    : semicolon {
        EOP empty;
        empty = insert_empty_expression();
        blk_expr = insert_expression_list(blk_expr,empty,$1);
        $$ = $1;
        /*
         * $$->head_point = $1->head_point;
         * $$->length = 1;
         */
    }           

    | expression semicolon {
        blk_expr = insert_expression_list(blk_expr,$1->expr,$1);
        $$ = $1;
        update_region_info($$, $1, $2, NULL);
    }
    ;

compound_statement   /* ============================================== */
    : compound_statement_tmp {
        close_block();
        tmp_blk = insert_block(BLOCK_COMP,$1);
        tmp_blk->blk_list = blk_blk;
        tmp_blk->label_list = blk_labl;
        blk_labl = NULL;
        tmp_blk->decl_list = blk_decl;
        blk_decl = (DO_ListP)pop_pointer();
        pop_block(); /* --block_level occurred */
        blk_blk = insert_block_list(blk_blk,tmp_blk,$1);
        $$ = $1;
        $$->dataptr = (void *)tmp_blk;
        if (labeled_stmt_flag) {
            spdWarning("No statement exits for label at l.%d.\n", yylineno);
            labeled_stmt_flag = FALSE;
        }
    }
    ;

compound_statement_tmp   /* ========================================== */
    : comp_statement_lp comp_statement_rp {
        $$ = $1;
        update_region_info($$, $1, $2, NULL);
    }

    | comp_statement_lp statement_list  comp_statement_rp {
#ifdef BLOCK_DEBUG
        printf("basic.flag = %d line = %d\n",basic_blk.flag,
               yylineno);
#endif
        close_block(); 
        $$ = $1;
        update_region_info($$, $1, $2, $3, NULL);
    }

    | comp_statement_lp declaration_list  comp_statement_rp {
        $$ = $1;
        update_region_info($$, $1, $2, $3, NULL);
    }

    | comp_statement_lp declaration_list  statement_list  comp_statement_rp {
#ifdef BLOCK_DEBUG
        printf("basic.flag = %d line = %d\n",basic_blk.flag,
               yylineno);
#endif
        $$ = $1;
        update_region_info($$, $1, $2, $3, $4, NULL);
    }
    ;

comp_statement_lp   /* =============================================== */
    : '{' {
        push_func_parm();
        push_storage(); /* Added by N.Fukuyasu 1997/10/22. */
        push_decl_decl();   /* Added by N.Fukuyasu 1997/10/24. */
        insert_level(SCOPE_LOCAL);
        switch (flag_func) {
          case  DEF_FUNC: 
            add_var_table_list(ptr_fs_input);
#ifdef VAR_DEBUG
            disp_lev();
#endif
            flag_func = IN_FUNC;
            break;
          default:
            flag_func = NON;
        }
        close_block();
#if BLOCK_DEBUG
        printf ("COMP LP block_level = %d\n",block_level);
#endif            
        push_block();
        push_pointer((void *)blk_decl);
        blk_decl = NULL;
        push_pointer((void *)type_decl);
        type_decl = NULL;
        $$ = $1;
    }
    ;

comp_statement_rp   /* =============================================== */
    : '}' {
        pop_func_parm();
        pop_storage();  /* Added by N.Fukuyasu 1997/10/22. */
        pop_decl_decl();    /* Added by N.Fukuyasu 1997/10/24. */
        type_decl = (TypeListP)pop_pointer();
        escape_level();
#ifdef VAR_DEBUG
        disp_lev();
#endif
        $$ = $1;
    }
    ;

statement_list   /* ================================================== */
    : label_or_statement

    | statement_list label_or_statement {
        $$ = $1;
        update_region_info($$, $1, $2, NULL);
    }
    ;

if_prefix   /* ======================================================= */
    : IF '(' {
        close_block();
        push_block();
        $$ = $1;
        update_region_info($$, $1, $2, NULL);
    }
    ;

if_prefix_expression   /* ============================================ */
    : if_prefix expression ')' {
        $$ = $1;
        $$->dataptr = (void *)insert_expression_list(NULL, $2->expr, $2);
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

if_prefix_expression_statement   /* ================================== */
    : if_prefix_expression labeled_statement {
        close_block();
        $$ = $1;
        $$->dataptr = $1->dataptr;
        update_region_info($$, $1, $2, NULL);
    }
    ;
          
selection_statement   /* ============================================= */
    : if_prefix_expression_statement {
        tmp_blk = insert_block(BLOCK_IF,$1);
        tmp_blk->expr_list = (EO_ListP)$1->dataptr;
        tmp_blk->blk_list = blk_blk;
        tmp_blk->label_list = blk_labl; 
        blk_labl = NULL;
        pop_block();
        blk_blk = insert_block_list(blk_blk,tmp_blk,$1);
        $$ = $1;
    }

    | if_prefix_expression_statement ELSE labeled_statement {
        close_block();
        tmp_blk = insert_block(BLOCK_IF,$1);
        tmp_blk->expr_list = (EO_ListP)$1->dataptr;
        tmp_blk->blk_list = blk_blk;
        tmp_blk->label_list = blk_labl;
        blk_labl = NULL;
        tmp_blk->length = get_length($1, $3);
        pop_block();
        blk_blk = insert_block_list(blk_blk,tmp_blk,$1);
        
        $$ = $1;
        update_region_info($$, $1, $2, $3, NULL);
    }

    | SWITCH '(' {
        close_block();
        push_block();
    }
    expression ')' labeled_statement {
        close_block();
        
        tmp_blk = insert_block(BLOCK_SWITCH,NULL);
        tmp_blk->expr_list =
            insert_expression_list(NULL, $4->expr, $4);
        tmp_blk->blk_list = blk_blk;
        tmp_blk->label_list = blk_labl; 
        blk_labl = NULL;
        tmp_blk->length = get_length($1, $6);
        pop_block();
        blk_blk = insert_block_list(blk_blk,tmp_blk,$1);
        
        $$ = $1;
        update_region_info($$, $1, $2, $4, $5, $6, NULL);
    }
    ;

for_prefix   /* ====================================================== */
    : FOR '(' {
        close_block();
        push_block();
        $$ = $1;
        update_region_info($$, $1, $2, NULL);
    }
    ;

for_postfix   /* ===================================================== */
    : ')' labeled_statement {
        $$ = $1;       
        update_region_info($$, $1, $2, NULL);
    }
    ;

iteration_statement   /* ============================================= */
    : WHILE '(' {
        close_block();
        push_block();
    }
    expression ')' labeled_statement {
        close_block();
        tmp_blk = insert_block(BLOCK_WHILE,NULL);
        tmp_blk->expr_list =
            insert_expression_list(NULL,$4->expr,$4);
        tmp_blk->blk_list = blk_blk;
        tmp_blk->label_list = blk_labl; 
        blk_labl = NULL;
        tmp_blk->length = get_length($1, $6);
        pop_block();
        blk_blk = insert_block_list(blk_blk,tmp_blk,$1);
        
        $$ = $1;
        update_region_info($$, $1, $2, $4, $5, $6, NULL);
    }

    | DO {
        close_block();
        push_block();
    }
    labeled_statement {
        close_block();
    }
    WHILE '(' expression ')' semicolon {
        tmp_blk = insert_block(BLOCK_DO,NULL);
        tmp_blk->expr_list =
            insert_expression_list(NULL,$7->expr,$7);
        tmp_blk->blk_list = blk_blk;
        tmp_blk->label_list = blk_labl; 
        blk_labl = NULL;
        tmp_blk->length = get_length($1, $9);
        pop_block();
        blk_blk = insert_block_list(blk_blk,tmp_blk,$1);
        
        $$ = $1;
        update_region_info($$, $1, $3, $5, $6, $7, $8, $9, NULL);
    }

    | for_statement {
        close_block();
        tmp_blk = insert_block(BLOCK_FOR,$1);
        tmp_blk->expr_list = (EO_ListP)$1->dataptr;
        tmp_blk->blk_list = blk_blk;
        tmp_blk->label_list = blk_labl;
        blk_labl = NULL;
        pop_block();
        blk_blk = insert_block_list(blk_blk,tmp_blk,$1);
        $$ = $1;
    }
    ;

for_statement   /* =================================================== */
    : for_prefix semicolon semicolon for_postfix {
        $$ = $1;
        $$->dataptr =
            (void *)make_expression_list(NULL, $2, NULL, $3, NULL, $4);
        update_region_info($$, $1, $2, $3, $4, NULL);
    }

    | for_prefix expression semicolon semicolon for_postfix {
        $$ = $1;
        $$->dataptr =
            (void *)make_expression_list($2->expr, $2, NULL, $4, NULL, $5);
        update_region_info($$, $1, $2, $3, $4, $5, NULL);
    }

    | for_prefix semicolon expression semicolon for_postfix {
        $$ = $1;
        $$->dataptr =
            (void *)make_expression_list(NULL, $2, $3->expr, $3, NULL, $5);
        update_region_info($$, $1, $2, $3, $4, $5, NULL);
    }

    | for_prefix semicolon semicolon expression for_postfix {
        $$ = $1;
        $$->dataptr =
            (void *)make_expression_list(NULL, $2, NULL, $3, $4->expr, $4);
        update_region_info($$, $1, $2, $3, $4, $5, NULL);
    }

    | for_prefix semicolon expression semicolon expression for_postfix {
        $$ = $1;
        $$->dataptr =
            (void *)make_expression_list(NULL, $2, $3->expr, $3, $5->expr, $5);
        update_region_info($$, $1, $2, $3, $4, $5, $6, NULL);
    }

    | for_prefix expression semicolon semicolon expression for_postfix {
        $$ = $1;
        $$->dataptr =
            (void *)make_expression_list($2->expr, $2, NULL, $4, $5->expr, $5);
        update_region_info($$, $1, $2, $3, $4, $5, $6, NULL);
    }

    | for_prefix expression semicolon expression semicolon for_postfix {
        $$ = $1;
        $$->dataptr =
            (void *)make_expression_list($2->expr, $2, $4->expr, $4, NULL, $6);
        update_region_info($$, $1, $2, $3, $4, $5, $6, NULL);
    }
    | for_prefix expression semicolon expression semicolon expression for_postfix {
        $$ = $1;
        $$->dataptr =
            (void *)make_expression_list($2->expr, $2, $4->expr, $4,
                                         $6->expr, $6);
        update_region_info($$, $1, $2, $3, $4, $5, $6, $7, NULL);
    }
    ;

jump_statement   /* ================================================== */
    : GOTO ident_or_type semicolon {
        EOP tmp_expr;
        LOP tmp_label;          
        tmp_expr = insert_expression($1);
        tmp_expr->sort = EXPR_GOTO;
        tmp_expr->length = get_length($1,$2);
        if ((tmp_label = find_label($2->name)) == NULL) {
            tmp_label = insert_label(LABEL_NAMED,0);
            SPEC_NAME_COPY(tmp_label->name,$2->name);
            add_label_table(tmp_label);
        }
        tmp_expr->label_list = insert_label_list(NULL,tmp_label,$2);
        
        $$ = $1;
        $$->expr = tmp_expr;
        update_region_info($$, $1, $2, $3, NULL);
    }

    | CONTINUE semicolon {
        EOP tmp_expr;
        tmp_expr = insert_expression($1);
        tmp_expr->sort = EXPR_CONTINUE;
        $$ = $1;
        $$->expr = tmp_expr;
        update_region_info($$, $1, $2, NULL);
    }

    | BREAK semicolon {
        EOP tmp_expr;
        tmp_expr = insert_expression($1);
        tmp_expr->sort = EXPR_BREAK;
        $$ = $1;
        $$->expr = tmp_expr;
        update_region_info($$, $1, $2, NULL);
    }

    | RETURN semicolon {
        EOP tmp_expr;
        tmp_expr = insert_expression($1);
        tmp_expr->sort = EXPR_RETURN;
        $$ = $1;
        $$->expr = tmp_expr;
        update_region_info($$, $1, $2, NULL);
    }

    | RETURN {
        push_expression();
    }
    expression semicolon {
        EOP tmp_expr;
        pop_expression();
        tmp_expr = insert_expression($1);
        tmp_expr->sort = EXPR_RETURN;
        tmp_expr->length = get_length($1, $3);
        tmp_expr->expr_list =
            insert_expression_list(tmp_expr->expr_list, $3->expr, $3);
        
        $$ = $1;
        $$->expr = tmp_expr;
        update_region_info($$, $1, $3, $4, NULL);
    }
    ;   

expression   /* ====================================================== */
    : assignment_expression {
        $$ = $1;
        $$->dataptr = NULL;
    }

    | expression COMMA assignment_expression {
        $$ = $1;
        $2->sort = OP_COMMA;
        $$->expr = make_binary_expression($1, $2, $3);
        $$->type = $3->type; /* The value of the last expression becomes */
                             /* the value of the whole expression. */
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

assignment_expression   /* =========================================== */
    : conditional_expression

    | cast_expression assignment_operator assignment_expression {
        /* Left value. */
        /* Gcc allows cast expression in left hand side. In ANSI, only 
           unary_expression is allowd in LHS.  */
        /*   Changed by: A.Yoshida, 1999/08/27 */
        if ($1->expr->op_list != NULL &&
            $1->expr->op_list->operator_s->sort == OP_CAST) {
            spdWarning("\"%s\": %d: A cast operator exists in left value.\n",
                       filename, yylineno);
        }
        if ($1->expr->lrtype == EXPR_PR_VALUE) {
            $1->expr->lrtype = EXPR_PL_VALUE;
            if ($2->sort != OP_ASSIGN) {
                $1->expr->lrtype |= EXPR_PR_VALUE;
            } else {
                $1->expr->lrtype &= (~ EXPR_R_VALUE);
                $1->expr->lrtype &= (~ EXPR_PR_VALUE);
            }
        } else {
            $1->expr->lrtype = EXPR_L_VALUE;
            if ($2->sort != OP_ASSIGN) {
                $1->expr->lrtype |= EXPR_R_VALUE;
            } else {
                $1->expr->lrtype &= (~ EXPR_R_VALUE);
                $1->expr->lrtype &= (~ EXPR_PR_VALUE);
            }
        }

        $$ = $1;        
        $$->expr = make_binary_expression($1, $2, $3);
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

assignment_operator   /* ============================================= */
    : EQUAL             { $$ = $1; $$->sort = OP_ASSIGN; }
    | STAR_EQUAL        { $$ = $1; $$->sort = OP_A_MUL; }
    | SLASH_EQUAL       { $$ = $1; $$->sort = OP_A_DIV; }
    | PERCENT_EQUAL     { $$ = $1; $$->sort = OP_A_MOD; }
    | PLUS_EQUAL        { $$ = $1; $$->sort = OP_A_ADD; }
    | MINUS_EQUAL       { $$ = $1; $$->sort = OP_A_SUB; }
    | LESS_LESS_EQUAL   { $$ = $1; $$->sort = OP_A_SHL; }
    | MORE_MORE_EQUAL   { $$ = $1; $$->sort = OP_A_SHR; }
    | AND_EQUAL         { $$ = $1; $$->sort = OP_A_AND; }
    | HAT_EQUAL         { $$ = $1; $$->sort = OP_A_XOR; }
    | OR_EQUAL          { $$ = $1; $$->sort = OP_A_OR; }
    ;

conditional_expression   /* ========================================== */
    : logical_OR_expression

    | logical_OR_expression '?' expression ':' conditional_expression {
        EOP tmp_expr;
        
        /* set expression field of $$ */
        tmp_expr = insert_expression($1);
        tmp_expr->length = get_length($1,$5);
        
        tmp_expr->expr_list =
            insert_expression_list(tmp_expr->expr_list, $1->expr, $1);
        tmp_expr->expr_list =
            insert_expression_list(tmp_expr->expr_list, $3->expr, $3);
        tmp_expr->expr_list =
            insert_expression_list(tmp_expr->expr_list, $5->expr, $5);
        tmp_expr->op_list =
            insert_operator_list(tmp_expr->op_list,
                                 find_operator(OP_QUESTION,NULL),$2);
        tmp_expr->op_list =
            insert_operator_list(tmp_expr->op_list,
                                 find_operator(OP_COLON,NULL),$4);
        tmp_expr->lrtype = EXPR_R_VALUE;
        tmp_expr->sort = EXPR_SORT_ARITH;
        $$ = $1;
        $$->expr = tmp_expr;
        if ($3->type) {
            $$->type = $3->type;
        } else if ($5->type) {
            $$->type = $5->type;
        }
        update_region_info($$, $1, $2, $3, $4, $5, NULL);
    }
    ;

constant_expression   /* ============================================= */
    : conditional_expression
    ;

logical_OR_expression   /* =========================================== */
    : logical_AND_expression

    | logical_OR_expression OR_OR logical_AND_expression {
        $2->sort = OP_L_OR;
        $$ = $1;
        $$->expr = make_binary_expression($1, $2, $3);
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

logical_AND_expression   /* ========================================== */
    : inclusive_OR_expression

    | logical_AND_expression AND_AND inclusive_OR_expression {
        $2->sort = OP_L_AND;
        $$ = $1;
        $$->expr = make_binary_expression($1, $2, $3);
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

inclusive_OR_expression   /* ========================================= */
    : exclusive_OR_expression

    | inclusive_OR_expression OR exclusive_OR_expression {
        $2->sort = OP_B_OR;
        $$ = $1;
        $$->expr = make_binary_expression($1, $2, $3);
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

exclusive_OR_expression   /* ========================================= */
    : AND_expression

    | exclusive_OR_expression HAT AND_expression {
        $2->sort = OP_B_XOR;
        $$ = $1;
        $$->expr = make_binary_expression($1, $2, $3);
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

AND_expression   /* ================================================== */
    : equality_expression

    | AND_expression AND equality_expression {
        $2->sort = OP_B_AND;
        $$ = $1;
        $$->expr = make_binary_expression($1, $2, $3);
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

equality_expression   /* ============================================= */
    : relational_expression

    | equality_expression equality_operator relational_expression {
        $$ = $1;
        $$->expr = make_binary_expression($1, $2, $3);
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

equality_operator   /* =============================================== */
    : EQUAL_EQUAL           { $$ = $1; $$->sort = OP_EQ; }
    | EXCLAMATION_EQUAL     { $$ = $1; $$->sort = OP_NE; }
    ;

relational_expression   /* =========================================== */
    : shift_expression

    | relational_expression relational_operator shift_expression {
        $$ = $1;
        $$->expr = make_binary_expression($1, $2, $3);
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

relational_operator   /* ============================================= */
    : LESS          { $$ = $1; $$->sort = OP_LT; }
    | LESS_EQUAL    { $$ = $1; $$->sort = OP_LE; }
    | MORE          { $$ = $1; $$->sort = OP_GT; }
    | MORE_EQUAL    { $$ = $1; $$->sort = OP_GE; }
    ;

shift_expression   /* ================================================ */
    : additive_expression

    | shift_expression shift_operator additive_expression {
        $$ = $1;
        $$->expr = make_binary_expression($1, $2, $3);
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

shift_operator   /* ================================================== */
    : LESS_LESS     { $$ = $1; $$->sort = OP_SHL; }
    | MORE_MORE     { $$ = $1; $$->sort = OP_SHR; }
    ;

additive_expression   /* ============================================= */
    : multiplicative_expression

    | additive_expression additive_operator multiplicative_expression {
        $$ = $1;
        $$->expr = make_binary_expression($1, $2, $3);
        if ($3->type != NULL) {
            /* If one of operands is pointer type, type of the whole 
               expression becomes pointer type too. */
            TSP type_tmp;
            for (type_tmp = $3->type ; type_tmp->sort == TYPE_TYPE_DEF
                     ; type_tmp = type_tmp->pointer); 
            if (type_tmp->sort == TYPE_POINTER) {
                $$->type = type_tmp;
                /* "$$->type = $3->type;" works fine, but less effient. */
                /* Note: when both of operands are pointer and the operator
                   is subtraction, the type of the whole expression is INTEGER.
                   But this implementation treats this case as pointer type.
                   This implementation is not valid, but no error occurs
                   because pointer type can convert into integer. */
            }
        }
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

additive_operator   /* =============================================== */
    : PLUS      { $$ = $1; $$->sort = OP_ADD; }
    | MINUS     { $$ = $1; $$->sort = OP_SUB; }
    ;
    
multiplicative_expression   /* ======================================= */
    : cast_expression

    | multiplicative_expression multiplicative_operator cast_expression {
        $$ = $1;
        $$->expr = make_binary_expression($1, $2, $3);
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

multiplicative_operator   /* ========================================= */
    : STAR      { $$ = $1; $$->sort = OP_MUL; }
    | SLASH     { $$ = $1; $$->sort = OP_DIV; }
    | PERCENT   { $$ = $1; $$->sort = OP_MOD; }
    ;

cast_expression   /* ================================================= */
    : unary_expression

    | '(' {
        push_ts();
        push_pointer((void *)type_ref);
        /*
         * Replaced by N.Fukuyasu 1997/10/24.
         * I think this push is unnecessary.
         * But, I have no confidence, so replace "push" function.
         */
        /* push_pointer((void *)decl_decl); */
        /* decl_decl = NULL; */
        push_decl_decl();
        type_ref = NULL;
    }
    type_name ')' cast_expression {
        EOP tmp_expr;
        OOP new_op;
        tmp_wp.point = ptr_ts_stack->point;
        ptr_type = APP_TYPE_SPEC();
        type_expr = insert_type_list(type_expr, ptr_type, &tmp_wp);
        /* Replaced by N.Fukuyasu 1997/10/24. */
        /* decl_decl = (DT_ListP)pop_pointer(); */
        pop_decl_decl();
        type_ref = (TypeListP)pop_pointer();
        pop_ts();
#ifdef DEBUG_950317
        fprintf(stderr,"(cast) type id = %d\n",ptr_type->id);
#ifdef DISP_TYPE          
        disp_type(ptr_type);
#endif          
#endif
        set_specifier_flag(0);
        $$ = $1;
        $$->type = ptr_type;
        
        /* set expression field of $$ */
        tmp_expr = insert_expression($1);
        tmp_expr->length = get_length($1,$5);
        tmp_expr->expr_list =
            insert_expression_list(tmp_expr->expr_list, $5->expr, $5);
        /* new operator setting */
        new_op = insert_operator(OP_CAST,get_length($1,$4));
        new_op->type = ptr_type;

        /* Ϣ op_type  */
        make_op_type2(new_op, $3->type_spec2_last);

#ifdef DEBUG_OP_TYPE
        fprintf(stderr,"(cast) type id: %d\n",ptr_type->id);
#endif
        tmp_expr->op_list =
            insert_operator_list(tmp_expr->op_list,new_op,$1);
        /* OP=$1 */
        /* OP=$3 type */
        /* OP=$4 */
        tmp_expr->lrtype = EXPR_R_VALUE;
        tmp_expr->sort = EXPR_SORT_ARITH;
        $$->expr = tmp_expr;

        WP_COPY_IDENT($$, $5);
        $$->sort = $5->sort;
        update_region_info($$, $1, $3, $4, $5, NULL);
    }
    ;

unary_expression   /* ================================================ */
    : postfix_expression {
        FSP tmp_fs;
        
        $$ = $1;
#ifdef DEBUG_950330
        fprintf(stdout,"POSTFIX EXPR sort = %d\n",$$->sort);
#endif
        if ($$->sort == DATA_NAME) {
            $$->type = app_var_pos($1);
            $$->sort = NON;
#ifdef DEBUG_950330
            disp_type($$->type);
#endif
        }
        
        if (var_ref) {
            $$->expr->dsl = var_ref;
            var_ref = NULL;
        }   
        if (mem_ref) {
            $$->expr->memsl = mem_ref;
            mem_ref = NULL;
        }
        if (ident_ref) {
            $$->expr->id_l = ident_ref ;
            ident_ref = NULL;
        }
        if ($1->sort == FUNCTION_NAME) {
            tmp_fs = find_function($1->name);
            $$->expr->fsl =
                insert_function_list($$->expr->fsl,tmp_fs,$1);
            $$->expr->id_l =
                insert_identifier_list(NULL,
                    find_identifier_by_ptr(tmp_fs,ID_FUNCTION),$1);
            $$->sort = NON;
        }

        /* ѿF_model°륳Ȥ򻲾ȤΤȡ */
        if (F_model || accept_undef_var) {
            if ($1->sort == ID_NAME) {
                IDOP tmp_ident;
                tmp_ident = insert_identifier($1->name, ID_VARIABLE);
                tmp_ident->length = $1->length;
                push_ts();
                ptr_ts_stack->sort->type = TYPE_INT;
                ptr_ts_stack->sort->sort = TYPE_DECLARATION;
                tmp_ident->type = APP_TYPE_SPEC();

                /* tmp_ident ηϰۤ int */
                set_ident_type2(tmp_ident, type_spec2_implicit_int());

                pop_ts();
                $$->expr->id_l = insert_identifier_list(NULL, tmp_ident, $1);
                $$->sort = NON;
            }
        }
    }

    | PLUS_PLUS cast_expression {
        $$ = $1;
        if ($2->expr->lrtype == EXPR_PR_VALUE) {
            $2->expr->lrtype = EXPR_PL_VALUE | EXPR_PR_VALUE;
        } else {
            $2->expr->lrtype = EXPR_L_VALUE | EXPR_R_VALUE;
        }
        $1->sort = OP_INC;
        $$->expr = make_unary_expression($1, $2);
        WP_COPY_IDENT($$, $2);
        $$->sort = $2->sort;
        $$->type = $2->type;
        update_region_info($$, $1, $2, NULL);
    }

    | MINUS_MINUS cast_expression {
        $$ = $1;
        if ($2->expr->lrtype == EXPR_PR_VALUE) {
            $2->expr->lrtype = EXPR_PL_VALUE | EXPR_PR_VALUE;
        } else {
            $2->expr->lrtype = EXPR_L_VALUE | EXPR_R_VALUE;
        }
        $1->sort = OP_DEC;
        $$->expr = make_unary_expression($1, $2);
        WP_COPY_IDENT($$, $2);
        $$->sort = $2->sort;
        $$->type = $2->type;
        update_region_info($$, $1, $2, NULL);
    }

    | unary_operator cast_expression {
        $$ = $1;
        $$->expr = make_unary_expression($1, $2);
        WP_COPY_IDENT($$, $2);
        $$->sort = $2->sort;
        $$->type = $2->type;
        update_region_info($$, $1, $2, NULL);
    }

    | AND cast_expression {
#ifdef POINTER_DEBUG
        printf("& operator\n");
#ifdef DISP_TYPE          
        disp_type($2->type);
#endif          
#endif
        $$ = $1;
        if ($2->type) {
            $$->type = make_point_type($2->type);
#ifdef POINTER_DEBUG
            printf("\n&type\n");
#ifdef DISP_TYPE          
            disp_type($2->type);
#endif
#endif
        } else {
            yyerror("");
        }
        $1->sort = OP_ADDRESS;
        $$->expr = make_unary_expression($1, $2);
        WP_COPY_IDENT($$, $2);
        $$->sort = $2->sort;
        update_region_info($$, $1, $2, NULL);
    }

    | STAR cast_expression {
        TSP type_tmp;
        
        $$ = $1;
        if ($2->type) {
            for (type_tmp = $2->type ; type_tmp->sort == TYPE_TYPE_DEF
                 ; type_tmp = type_tmp->pointer); 
            if (type_tmp->sort == TYPE_POINTER ||
                type_tmp->sort == TYPE_ARRAY) {
                $$->type = type_tmp->pointer;
            } else if(type_tmp->sort == TYPE_FUNC) {
                $$->type = type_tmp;
            } else {
                spdWarning("STAR cast_expr: Can't find pointer type.\n");
#ifdef DISP_TYPE          
                disp_type($2->type);
#endif
                yyerror("");
            }
        } else {
            spdWarning("STAR cast_expr: No type description pointer type.\n");
            yyerror("");
        }
        $1->sort = OP_POINTER;
        $$->expr = make_unary_expression($1, $2);
        WP_COPY_IDENT($$, $2);
        $$->sort = $2->sort;
        update_region_info($$, $1, $2, NULL);
    }

    | SIZEOF unary_expression {
        $$ = $1;
        $1->sort = OP_SIZEOF;
        $$->expr = make_unary_expression($1, $2);
        WP_COPY_IDENT($$, $2);
        $$->sort = $2->sort;
        update_region_info($$, $1, $2, NULL);
    }

    | SIZEOF '(' {
        push_ts();
        push_pointer((void *)type_ref);
        /*
         * Replaced by N.Fukuyasu 1997/10/24.
         * I think this push is unnecessary.
         * But, I have no confidence, so replace "push" function.
         */
        /* push_pointer((void *)decl_decl); */
        /* decl_decl = NULL; */
        push_decl_decl();
        type_ref = NULL;
    }
    type_name ')' {
        EOP tmp_expr;
        OOP new_op;
        
        tmp_wp.point = ptr_ts_stack->point;
        ptr_type = APP_TYPE_SPEC();
        type_expr = insert_type_list(type_expr, ptr_type, &tmp_wp);
        /* Replaced by N.Fukuyasu 1997/10/24. */
        /* decl_decl = (DT_ListP)pop_pointer(); */
        pop_decl_decl();
        type_ref = (TypeListP)pop_pointer();
        pop_ts();
        
        /* set expression field of $$ */
        tmp_expr = insert_expression($1);
        tmp_expr->length = get_length($1, $5);
        /* new operator setting */
        new_op = insert_operator(OP_SIZEOF_TYPE,tmp_expr->length);
        new_op->type = ptr_type;

        /* Ϣ op_type  */
        make_op_type2(new_op, $4->type_spec2_last);

#ifdef DEBUG_OP_TYPE
        fprintf(stderr,"sizeof() type id: %d\n",ptr_type->id);
#endif
        tmp_expr->op_list = insert_operator_list(tmp_expr->op_list,new_op,$1);
        /* OP=$1 */
        /* OP=$2 OP_SIZEOF_TYPE */
        /* OP=$5 */
        set_specifier_flag(0);
        tmp_expr->lrtype = EXPR_R_VALUE;
        tmp_expr->sort = EXPR_SORT_ARITH;
        $$ = $1;
        $$->expr = tmp_expr;
        WP_COPY_IDENT($$, $4);
        $$->sort = $4->sort;
        update_region_info($$, $1, $2, $4, $5, NULL);
    }

    | BUILTIN_TYPE_PARAMETER unary_expression {
        $$ = $1;
        $1->sort = OP_BUILTIN;
        $$->expr = make_unary_expression($1, $2);
        WP_COPY_IDENT($$, $2);
        $$->sort = $2->sort;
        update_region_info($$, $1, $2, NULL);
    }

    | BUILTIN_TYPE_PARAMETER '(' {
        push_ts();
        push_pointer((void *)type_ref);
        /*
         * Replaced by N.Fukuyasu 1997/10/24.
         * I think this push is unnecessary.
         * But, I have no confidence, so replace "push" function.
         */
        /* push_pointer((void *)decl_decl); */
        /* decl_decl = NULL; */
        push_decl_decl();
        type_ref = NULL;
    }
    type_name ')' {
        EOP tmp_expr;
        OOP new_op;
        
        tmp_wp.point = ptr_ts_stack->point;
        ptr_type = APP_TYPE_SPEC();
        type_expr = insert_type_list(type_expr, ptr_type, &tmp_wp);
        /* Replaced by N.Fukuyasu 1997/10/24. */
        /* decl_decl = (DT_ListP)pop_pointer(); */
        pop_decl_decl();
        type_ref = (TypeListP)pop_pointer();
        pop_ts();
        
        /* set expression field of $$ */
        tmp_expr = insert_expression($1);
        tmp_expr->length = get_length($1, $5);
        /* new operator setting */
        new_op = insert_operator(OP_BUILTIN_TYPE,tmp_expr->length);
        new_op->type = ptr_type;

        /* Ϣ op_type  */
        make_op_type2(new_op, $4->type_spec2_last);

#ifdef DEBUG_OP_TYPE
        fprintf(stderr,"%s() type id: %d\n",$1->name, ptr_type->id);
#endif
        tmp_expr->op_list = insert_operator_list(tmp_expr->op_list,new_op,$1);
        /* OP=$1 */
        /* OP=$2 OP_BUILTIN_TYPE */
        /* OP=$5 */
        set_specifier_flag(0);
        tmp_expr->lrtype = EXPR_R_VALUE;
        tmp_expr->sort = EXPR_SORT_ARITH;
        $$ = $1;
        $$->expr = tmp_expr;
        WP_COPY_IDENT($$, $4);
        $$->sort = $4->sort;
        update_region_info($$, $1, $2, $4, $5, NULL);
    }
    ;

unary_operator   /* ================================================== */
    : PLUS          { $$ = $1; $$->sort = OP_PLUS; }
    | MINUS         { $$ = $1; $$->sort = OP_MINUS; }
    | TILDA         { $$ = $1; $$->sort = OP_B_NOT; }
    | EXCLAMATION   { $$ = $1; $$->sort = OP_NOT; }
    ;

postfix_expression   /* ============================================== */
    : primary_expression {
        $$ = $1;
        if (!($1->expr)) {
            $$->expr = insert_expression($1);
            $$->expr->length = $1->length;
            $$->expr->lrtype = EXPR_R_VALUE;
        }
        if (ident_ref) {
            $$->expr->id_l = ident_ref ;
            ident_ref = NULL;
        }
    }

    | postfix_expression '[' {
        push_expression();
    }
    expression ']' {
        TSP type_tmp;
        EOP tmp_expr;
        
        pop_expression();
        $$ = $1;
        /* set type field of $$ */
        if ($1->sort == DATA_NAME) {
            for (type_tmp = app_var_pos($1) ; type_tmp->sort == TYPE_TYPE_DEF
                 ; type_tmp = type_tmp->pointer); 
            $$->type=type_tmp->pointer;
#if POINTER_DEBUG
            printf("DN %s[] type:%d\n",$1->name,$$->type->id);
#endif          
            if (var_ref) {
                $1->expr->dsl = var_ref;
                var_ref = NULL;
            }
            if (ident_ref) {
                $$->expr->id_l = ident_ref ;
                ident_ref = NULL;
            }
        } else if ($1->type && $1->type->pointer) {
            for (type_tmp = $1->type ; type_tmp->sort == TYPE_TYPE_DEF
                 ; type_tmp = type_tmp->pointer); 
            $$->type = type_tmp->pointer;
#if POINTER_DEBUG
            printf("  %s[] type:%d\n",$1->name,$$->type->id);
#endif          
        }
        /* set expression field of $$ */
        tmp_expr = insert_expression($1);
        tmp_expr->length = get_length($1,$5);
        tmp_expr->expr_list =
            insert_expression_list(tmp_expr->expr_list, $1->expr, $1);
        tmp_expr->expr_list =
            insert_expression_list(tmp_expr->expr_list, $4->expr, $4);
        tmp_expr->op_list =
            insert_operator_list(tmp_expr->op_list,
                                 find_operator(OP_L_ARRAY,NULL),$2);
        tmp_expr->op_list =
            insert_operator_list(tmp_expr->op_list,
                                 find_operator(OP_R_ARRAY,NULL),$5);
        tmp_expr->lrtype = EXPR_PR_VALUE;
        tmp_expr->sort = EXPR_SORT_ARITH;
        $$->expr = tmp_expr;
        $$->sort = ARRAY_NAME;
        update_region_info($$, $1, $2, $4, $5, NULL);
    }

    | postfix_expression '(' ')' {
        $$ = $1;
        process_func_postfix_expression($$, $3, NULL);
        update_region_info($$, $1, $2, $3, NULL);
    }

    | postfix_expression '(' {
        push_pointer((void *)arg_expr);
        push_pointer((void *)var_ref);
        push_pointer((void *)mem_ref);
        
        push_pointer((void *)type_expr);
        push_pointer((void *)ident_ref);
        
        var_ref = NULL;
        mem_ref = NULL;
        arg_expr = NULL;
        type_expr = NULL;
        ident_ref = NULL;
    }
    argument_expression_list ')' {
        free_TS_ListP(type_expr);
        
        ident_ref = (IDO_ListP)pop_pointer();
        type_expr = (TypeListP)pop_pointer();
        mem_ref = (MEMS_ListP)pop_pointer();
        var_ref = (DataListP)pop_pointer();
        
        $$ = $1;
        process_func_postfix_expression($$, $5, arg_expr);
        arg_expr = (EO_ListP)pop_pointer();
        update_region_info($$, $1, $2, $4, $5, NULL);
    }

    | postfix_expression DOT ident_or_type {
        MEMSP member_tmp;
        DSP data_tmp;
        EOP tmp_expr_mem;
        
        $$ = $1;
        if ($1->sort == STRUCT_MEMBER) {
#ifdef DEBUG_950328
            if (yydebug) {
                printf("dot STRUCT_MEMBER\n");
                disp_type(tmp_struct);
            }
#endif

            member_tmp = find_dot_member(tmp_struct,$3->name);
            if (!member_tmp) {
                printf("struct (dot)member not defined 1 '%s'\n",$3->name);
                yyerror("");
            }
            mem_ref = insert_member_list (mem_ref, member_tmp,$3);
#if MEMBER_DEBUG
            printf("struct (ST) %s member %s \n",$1->name,$3->name);
#endif
        } else {
            if ($1->type) {
                member_tmp = find_dot_member($1->type,$3->name);
            } else {
                data_tmp = find_var_pos($1->name);
                if (data_tmp == NULL) {
                    spdWarning("Variable \"%s\" is not defined before.\n",
                               $1->name);
                    yyerror("");
                }
                member_tmp = find_dot_member(data_tmp->type,$3->name);
            }
            if (!member_tmp) {
#if DEBUG_951002
                printf("dot   type %d name %s\n",$1->type->id,$3->name);
#ifdef DISP_TYPE          
                disp_type($1->type);
#endif
#endif
                printf("struct (dot)member not defined 2 '%s'\n",$3->name);
                yyerror("");
            }
            mem_ref = insert_member_list (mem_ref , member_tmp,$3);
#if MEMBER_DEBUG
            printf("struct     %s member %s (%d) \n",
                   $1->name,$3->name,member_tmp->id);
#endif
            if ($1->sort == DATA_NAME) {
#ifdef VAR_DEBUG
                printf("postfix DOT  %s\n", $1->name);
#endif
                app_var_pos($1);
                if (var_ref) {
                    $1->expr->dsl = var_ref;
                    var_ref = NULL;
                }
                if (ident_ref) {
                    $$->expr->id_l = ident_ref ;
                    ident_ref = NULL;
                }
            }
        }
        tmp_struct = member_tmp->type;
#if POINTER_DEBUG
        disp_type(tmp_struct);
#endif
        $$->type = tmp_struct;
        
        tmp_expr_mem = insert_expression($3);
        $3->expr = tmp_expr_mem;
        if (mem_ref) {
            tmp_expr_mem->memsl = mem_ref;
            tmp_expr_mem->id_l = 
                insert_identifier_list(NULL,
                                       find_identifier_by_ptr(mem_ref->member_s,ID_MEMBER),$3);
            mem_ref = NULL;
        }
        
        $2->sort = OP_DOT;
        $$->expr = make_binary_expression($1, $2, $3);
        WP_COPY_IDENT($$, $3);
        $$->sort = STRUCT_MEMBER;
        update_region_info($$, $1, $2, $3, NULL);
        set_specifier_flag(0); /* $3 may be recognized as type name. */
    }

    | postfix_expression ARROW ident_or_type {
        MEMSP member_tmp;
        DSP data_tmp;
        EOP tmp_expr_mem;
        
        $$ = $1;
        if ($1->sort == STRUCT_MEMBER) {
#ifdef DEBUG_950328
            if (yydebug) {
                printf("arrow STRUCT_MEMBER\n");
                disp_type(tmp_struct);
            }
#endif
            member_tmp = find_arrow_member(tmp_struct,$3->name);
            if (!member_tmp) {
                printf("struct (arrow)member not defined 1 '%s'\n",$3->name);
                yyerror("");
            }
            mem_ref = insert_member_list (mem_ref , member_tmp,$3);
#if MEMBER_DEBUG
            printf("struct (ST) %s member %s \n",$1->name,$3->name);
#endif
        } else {
            if ($1->type) {
#ifdef DEBUG_950320
                if(yydebug) disp_type($1->type);
#endif
                  
#if POINTER_DEBUG
                printf("arrow type %d name %s\n",$1->type->id,$3->name);
#endif
                member_tmp = find_arrow_member($1->type,$3->name);
            } else {
                data_tmp = find_var_pos($1->name);
                if (data_tmp == NULL) {
                    spdWarning("Variable \"%s\" is not defined before.\n",
                               $1->name);
                    yyerror("");
                }
                member_tmp = find_arrow_member(data_tmp->type,$3->name);
            }
            if (!member_tmp) {
                printf("struct (arrow)member not defined 2 '%s'\n",$3->name);
                yyerror("");
            }
            mem_ref = insert_member_list (mem_ref , member_tmp,$3);
#if MEMBER_DEBUG
            printf("struct     %s member %s (%d)\n",$1->name,$3->name,member_tmp->id);
#endif
            if ($1->sort == DATA_NAME) {
#ifdef VAR_DEBUG
                printf("postfix ARROW %s\n", $1->name);
#endif
                app_var_pos($1);
                if (var_ref) {
                    $1->expr->dsl = var_ref;
                    var_ref = NULL;
                }
                if (ident_ref) {
                    $$->expr->id_l = ident_ref ;
                    ident_ref = NULL;
                }
            }
        }
        tmp_struct = member_tmp->type;
        
        tmp_expr_mem = insert_expression($3);
        $3->expr = tmp_expr_mem;
        if (mem_ref) {
            tmp_expr_mem->memsl = mem_ref;
            tmp_expr_mem->id_l = 
                insert_identifier_list(NULL,
                                       find_identifier_by_ptr(mem_ref->member_s,ID_MEMBER),$3);
            mem_ref = NULL;
        }
        
        $2->sort = OP_ARROW;
        $$->expr = make_binary_expression($1, $2, $3);
        $$->type = tmp_struct;
        WP_COPY_IDENT($$, $3);
        $$->sort = STRUCT_MEMBER;
        
        update_region_info($$, $1, $2, $3, NULL);
        set_specifier_flag(0); /* $3 may be recognized as type name. */
    }

    | postfix_expression PLUS_PLUS {
        EOP tmp_expr;
        if ($1->sort == DATA_NAME) {
            $1->type = app_var_pos($1);
        }
        if ($1->expr->lrtype == EXPR_PR_VALUE) {
            $1->expr->lrtype = EXPR_PL_VALUE | EXPR_PR_VALUE;
        } else {
            $1->expr->lrtype = EXPR_L_VALUE | EXPR_R_VALUE;
        }
        
        $$ = $1;
        $2->sort = OP_INC;
        tmp_expr = make_post_unary_expression($1, $2);
        if (var_ref) {
            $1->expr->dsl = var_ref;
            var_ref = NULL;
        }
        if (ident_ref) {
            $$->expr->id_l = ident_ref ;
            ident_ref = NULL;
        }
        $$->expr = tmp_expr;
        $$->sort = NON;
        update_region_info($$, $1, $2, NULL);
    }

    | postfix_expression MINUS_MINUS {
        EOP tmp_expr;
        if ($1->sort == DATA_NAME) {
            $1->type = app_var_pos($1);
        }
        if ($1->expr->lrtype == EXPR_PR_VALUE) {
            $1->expr->lrtype = EXPR_PL_VALUE | EXPR_PR_VALUE;
        } else {
            $1->expr->lrtype = EXPR_L_VALUE | EXPR_R_VALUE;
        }
        
        $$ = $1;
        $2->sort = OP_DEC;
        tmp_expr = make_post_unary_expression($1, $2);
        if (var_ref) {
            $1->expr->dsl = var_ref;
            var_ref = NULL;
        }
        if (ident_ref) {
            $$->expr->id_l = ident_ref ;
            ident_ref = NULL;
        }
        
        $$->expr = tmp_expr;
        $$->sort = NON;
        update_region_info($$, $1, $2, NULL);
    }
    ;

primary_expression   /* ============================================== */
    : identifier {
        DSP tmp_ds;
        FSP tmp_fs;
        IDOP tmp_ident;
        CSP tmp_cs;

        if (lookup_pe_ident($1->name, &tmp_ds, &tmp_cs)) {
            if (tmp_ds != NULL) {
                /* The identifier is variable. */
                $$->sort = DATA_NAME;
                $$->type = tmp_ds->type;
            } else { /* tmp_cs != NULL */
                /* The identifier is enumerator. */
                ident_ref = insert_identifier_list(ident_ref,
                         find_identifier_by_ptr(tmp_cs,  ID_ENUMERATOR), $1);
                $$->dataptr = NULL;
                $$->sort = CONST_DATA;
            }
        } else if ((tmp_fs = find_function($1->name)) != NULL) {
            tmp_ident = find_identifier_by_ptr(tmp_fs,ID_FUNCTION);
            $$->sort = FUNCTION_NAME;
            $$->type = tmp_ident->type;
        } else {
            $$->sort = ID_NAME;
        }
        $$->expr = NULL;
    }

    | constant {
        $$ = $1;
        $$->expr = insert_expression($1);
        $$->expr->length = $1->length;
        $$->expr->lrtype = EXPR_R_VALUE;
        if ($$->dataptr) {
            $$->expr->csl = (ConstListP)$$->dataptr;
        }
        $$->sort = CONST_DATA;
    }

    | string_list {
        EOP tmp_expr;
        if ($1->dataptr) {
            tmp_expr = insert_expression($1);
            tmp_expr->expr_list = (EO_ListP)$1->dataptr;
            tmp_expr->length = $1->length;
            tmp_expr->lrtype = EXPR_R_VALUE;

        } else {
            tmp_expr = $1->expr;
        }
        $$ = $1;
        $$->sort = NON;
        $$->expr = tmp_expr;
        $$->dataptr = NULL;
    }

    | '(' {
        push_expression();
    }
    expression ')' {
        EOP tmp_expr;
        
        pop_expression();

        $$ = $1;        
#ifdef DEBUG_950317
        if($3->type) {
            fprintf(stderr,"(expr) type id = %d\n",$3->type->id);
#ifdef DISP_TYPE
            disp_type($3->type);
#endif
        }
#endif
        tmp_expr = insert_expression($3);
        tmp_expr->length = get_length($1, $4);
        tmp_expr->expr_list =
            insert_expression_list(tmp_expr->expr_list, $3->expr, $3);
        $$->expr = tmp_expr;
        $$->expr->lrtype = $3->expr->lrtype;
        $$->expr->sort = EXPR_SORT_ARITH;
        tmp_expr->op_list =
            insert_operator_list(tmp_expr->op_list,
                                 find_operator(OP_L_PAR,NULL),$1);
        tmp_expr->op_list =
            insert_operator_list(tmp_expr->op_list,
                                 find_operator(OP_R_PAR,NULL),$4);
        WP_COPY_IDENT($$, $3);
        $$->sort = NON;
        $$->type = $3->type;
        update_region_info($$, $1, $3, $4, NULL);
    }
    ;

string_list   /* ===================================================== */
    : string {
        $$ = $1;
        $$->dataptr = NULL;
    }

    | string_list string {
        EO_ListP expr_list;
        
        expr_list = (EO_ListP)$1->dataptr;
        if (expr_list == NULL)
            expr_list = insert_expression_list(NULL, $1->expr, $1);
        expr_list = insert_expression_list(expr_list, $2->expr, $2);
        
        $$ = $1;            
        $$->dataptr = (void *)expr_list;
        update_region_info($$, $1, $2, NULL);
    }
    ;

string   /* ========================================================== */
    : STRING_CONSTANT {
        EOP tmp_expr;
        ptr_const=insert_constant(NO_NAME,CONST_STRING,$1->length,
                                  $1->point,current_file);
        ptr_const->value = spdStrdup($1->name);
        tmp_expr = insert_expression($1);
        tmp_expr->csl = insert_cs_list(NULL,ptr_const,$1);
        tmp_expr->length = $1->length;
        tmp_expr->lrtype = EXPR_R_VALUE;
        $$ = $1;
        
        /* Fixing sdbin3-0040. */
        push_ts();
        ptr_ts_stack->sort->type = TYPE_CHAR;
        ptr_ts_stack->sort->sort = TYPE_DECLARATION;
        app_pointer_id();
        ptr_ts_stack->queue->in->next = ptr_ts_stack->list;
        ptr_ts_stack->list = ptr_ts_stack->queue->out;
        $$->type = APP_TYPE_SPEC();
#ifdef DEBUG_0040
        disp_type($$->type);
#endif          
        pop_ts();
        
        $$->sort = NON;
        $$->expr = tmp_expr;
    }
    ;

argument_expression_list   /* ======================================== */
    : assignment_expression {
        $$ = $1;
        arg_expr = insert_expression_list(arg_expr,$1->expr,$1);
    }

    | argument_expression_list COMMA assignment_expression {
        $$ = $1;
        arg_expr = insert_expression_list(arg_expr,$3->expr,$3);
        update_region_info($$, $1, $2, $3, NULL);
    }
    ;

constant   /* ======================================================== */
    : INTEGER_CONSTANT {
        ptr_const = insert_constant(NO_NAME, CONST_INT, $1->length,
                                    $1->point, current_file);
        ptr_const->value = spdStrdup($1->name);
        $$ = $1;
        $$->dataptr = (void *)insert_cs_list(NULL, ptr_const, $1);
    }

    | CHARACTER_CONSTANT {
        ptr_const = insert_constant(NO_NAME, CONST_CHAR, $1->length,
                                    $1->point, current_file);
        ptr_const->value = spdStrdup($1->name);
        $$ = $1;
        $$->dataptr = (void *)insert_cs_list(NULL, ptr_const, $1);
    }

    | W_CHARACTER_CONSTANT {
        ptr_const = insert_constant(NO_NAME, CONST_WCHAR, $1->length,
                                    $1->point, current_file);
        ptr_const->value = spdStrdup($1->name);
        $$ = $1;
        $$->dataptr = (void *)insert_cs_list(NULL, ptr_const, $1);
    }

    | FLOATING_CONSTANT {
        ptr_const = insert_constant(NO_NAME, CONST_FLOAT, $1->length,
                                    $1->point, current_file);
        ptr_const->value = spdStrdup($1->name);
        $$ = $1;
        $$->dataptr = (void *)insert_cs_list(NULL, ptr_const, $1);
    }
    ;

semicolon   /* ======================================================= */
    : ';'
    ;

ident_or_type   /* ==================== Added by A.Yoshida 1999/06/10. */
    : identifier {
        $$ = $1;
        $$->sort = ID_NAME;
    }
    | TYPEDEF_NAME {
        $$ = $1;
        $$->sort = ID_NAME;
    }
    | BUILTIN_TYPE_NAME {
        $$ = $1;
        $$->sort = ID_NAME;
    }
    ;

%%
    
void yyerror(char *msg)
{
    /*
     * If a syntax error occurs, reducer calls this function with an argument
     * "syntax error".
     */

    if (tmp_fo != NULL) {
        spdError("yyerror(): \"%s\" l.%d.\n", tmp_fo->name, source_lineno);
        print_lines(tmp_fo->name, source_lineno, 2);
    }
    if (msg == NULL || *msg == '\0') {
        spdError("yyerror(): \"%s\" l.%d.\n", current_file->name, yylineno);
        print_lines(current_file->name, yylineno, 2);
    } else {
        spdError(((*(msg + strlen(msg) - 1) == '\n') ?
                  "yyerror(): \"%s\" l.%d: yytext \"%s\": %s" :
                  "yyerror(): \"%s\" l.%d: yytext \"%s\": %s\n"),
                 current_file->name, yylineno, yytext, msg);
        print_lines(current_file->name, yylineno, 2);
    }
    exit(EXIT_FAILURE);
}       

/*
 * Print error line.
 */

static void print_lines(char *fileName, int lineNum, int margin)
{
    FILE    *file;
    int     c;
    int     line_count = 1;
    int     end_line;
    int     start_line;
    int     target_line;

    file = spdFopen(fileName, SPD_FOPEN_RT_MODE);
    start_line = lineNum - margin;
    while (line_count < start_line) {
        if ((c = fgetc(file)) == EOF) {
            spdErrorExit("Invalid line number %d.\n", lineNum);
        }
        if (c == '\n') {
            line_count++;
        }
    }
    end_line = lineNum + margin;
    if (start_line <= 0) {
        start_line = 1;
    }
    for (target_line = start_line; target_line <= end_line; target_line++) {
        c = fgetc(file);
        spdMessage("%4d: ", target_line);
        while ((c != '\n') && (c != EOF)) {
            fputc(c, stderr);
            c = fgetc(file);
        }
        fputc('\n', stderr);
        if (c == EOF) {
            break;
        }
    }
    spdFclose(file);
}

/*
 * ɤϤ롥
 */

void analyze(char *filename)
{
    block_level = 0;
    basic_blk.flag = 0;
    label_table = NULL;
    push_decl_decl();       /* Added by N.Fukuyasu 1997/10/24. */
    set_specifier_flag(0);
    ptr_ts_struc = NULL ;
    
    ptr_ts_stack = NULL;
    type_ref = NULL;
    ident_ref = NULL;
    push_ts();

    func_parm_stack = NULL;
    push_func_parm();

    direct_decl_stack = NULL;
    push_direct_decl(NON);

    storage_stack = NULL;
    push_storage();
    
    c_count = 0;
    paren_level = 0;
    yylineno = 1;
    source_lineno = 1;      /* Be set by the first line's "#line" directive. */ 
    insert_level(SCOPE_FILE);
    tmp_fo = current_file = insert_file(filename);
    scope_list = insert_scope_list(scope_list, tmp_fo->scope);
    yyparse();
    close_block();

#ifdef TYPE_REF_DEBUG
    for (/* Empty. */; type_ref != NULL; type_ref = type_ref->next) {
        fprintf(stderr, "type_ref %d  type:%d\n",
                type_ref->source->point, type_ref->type_s->id);
    }
#endif    

    func_end_ln = 0;
    current_file->decl = file_decl;  

#ifdef FILE_DEBUG
    fprintf(stderr, "File id %d name:%s\n",fo_list->id,fo_list->name);
    for (/* Empty. */; file_decl != NULL; file_decl = file_decl->next) {
        fprintf(stderr, "\tdeclaration id %d\n", file_decl->decl->id);
    }
#endif

    escape_level();
    file_decl = NULL;
    file_func = NULL;

    pop_ts();
}

Src_LC_P app_source_LC(Src_LC_P source, int point, FOP file)
{
    Src_LC_P new;
    
    new = (Src_LC_P)spdCalloc(sizeof(Src_LC),1);
    new->point = point;
    new->file = file;
    new->next = source;
    return new;
}

Src_LC_P cat_source_LC(Src_LC_P src1, Src_LC_P src2)
{
    /* Append list src1 with src2, and return src1. */
    
    Src_LC_P tmp_src;
    
    if (src1) {
        tmp_src = src1;
        while (tmp_src->next)
            tmp_src = tmp_src->next;
        tmp_src->next = src2;
        tmp_src = src1;
    } else {
        tmp_src = src2;
    }
    return tmp_src;
}

#if PUSH_DEBUG
static stack_number = 0;
#endif

void push_pointer(void *ptr)
{
    StackP new;
    
    new = (StackP)spdCalloc(sizeof (Stack),1);
    
    new->top = ptr;
    new->prev = ptr_stack;
    ptr_stack = new;

#if PUSH_DEBUG
    stack_number++;
    printf("push (%d)\n",stack_number);
#endif
}

void *pop_pointer(void)
{
    void *top;
    StackP tmp;
    
    top = NULL;
    
    if (ptr_stack) {
        top = ptr_stack->top;
        tmp = ptr_stack;
        ptr_stack = ptr_stack->prev;
        spdFree(tmp);
    }

#if PUSH_DEBUG
    stack_number--;
    printf("pop  (%d)\n",stack_number);
#endif

    return top;
}

int get_length(WP from, WP to)
{
    return (to->head_point + to->length - from->head_point);
}

static void WP_copy_name(WP a, WP b)
{
    /* b->namea->name˥ԡ롥 */
    if (a == NULL || b == NULL || b->name == NULL) {
        return;
    }
    a->name = spdStrPoolCopy(str_pool, b->name);
}

static void free_WP(WP ptr)
{
    if (ptr != NULL) {
        spdFree(ptr);
    }
}

/******************************************************************************/

static void append_link_type_is(void)
{
    TSP     ptr_ts;
    IDOP    tmp_ident;
    
    /* ptr_typeéä[ݥ󥿡ؿ]ǤʤΤ򸫤Ĥ롥 */
    for (ptr_ts = ptr_type;
         ptr_ts->sort == TYPE_POINTER || ptr_ts->sort == TYPE_FUNC ||
         ptr_ts->sort == TYPE_ARRAY; ptr_ts = ptr_ts->pointer);

    /* [typedef¤ΡΡ]ξ硥 */
    if (ptr_ts->sort == TYPE_TYPE_DEF && ptr_ts->ident == NULL) {
        /* ηɽidentifier򸫤ĤƴϢtype_isĥ롥*/
        tmp_ident = find_identifier(ptr_ts->name, ID_TYPENAME);
        ptr_ts->ident = tmp_ident;
        if (!tmp_ident) {
            yyerror("");
        }
    } else if ((ptr_ts->sort == TYPE_STRUCT_TAG ||
                ptr_ts->sort == TYPE_UNION_TAG ||
                ptr_ts->sort == TYPE_ENUM_SPECIFIER) &&
               ptr_ts->ident == NULL && ptr_ts->name) {
        /* ηɽidentifier򸫤ĤƴϢtype_isĥ롥*/
        tmp_ident = find_identifier(ptr_ts->name, ID_TAG);
        ptr_ts->ident = tmp_ident;
    }
}

static void make_func_body(WP comp)
{
    free_BO_ListP(blk_blk);
    blk_blk = NULL;
    func_body = insert_block_list(NULL, (BOP)comp->dataptr, comp);
    pop_block();
    close_block();
}

/*
 * ؿˤdeclaratorФԤ
 */

static void process_function_declarator(WP decr)
{
    func_class = ptr_ts_stack->sort->class;
    ptr_type_func = APP_TYPE_SPEC();
        
    flag_func = DEF_FUNC;
    func_ident_decl = ident_decl;
    ident_decl = NULL;
        
    if (func_ident_decl != NULL &&
        func_ident_decl->ident->sort == ID_FUNCTION) {
        func_ident_decl->ident->data.func->type = ptr_type_func;
        func_ident_decl->ident->type = ptr_type_func;
        /* ident˴ؿꤹ롥 */
        set_ident_type2(func_ident_decl->ident, decr->type_spec2_last);
    }
}

/*
 * ؿˤdeclaration, declarator, optionaldecl롥
 */

static DNOP make_function_definition(WP func, WP type, WP decr, WP body)
{
    DNOP    tmp_decl;
    DROP    tmp_decr;
    ODP     tmp_opt;

    /* ꥹȤӴؿΤɽoptionaldecl롥 */
    tmp_opt = insert_optionaldecl(NULL);
    tmp_opt->length = get_length(&func_opt_point, body);
    tmp_opt->sort = OPT_FUNCDEF;
    tmp_opt->block_l = func_body;
    tmp_opt->decl_l = func_parm_stack->decl_l;
        
    /* ؿ̾optionaldeclʤdeclarator롥 */
    tmp_decr = insert_declarator(NULL);
    tmp_decr->length = get_length(decr, body);
    tmp_decr->opt_l = insert_optionaldecl_list(NULL, tmp_opt, &func_opt_point);
    tmp_decr->sort = DECL_FUNCDEF;
    tmp_decr->type = ptr_type_func;
    tmp_decr->id_l = func_ident_decl;
    /* Ϣ decr_type  */
    tmp_decr = make_decr_type2(tmp_decr, decr->type_spec2_last);

    /* ؿɽdeclaration롥 */
    tmp_decl = insert_declaration(NULL);
    tmp_decl->length = get_length(func, body);
    tmp_decl->storage = storage_stack->storage;
    tmp_decl->sort = DECL_FUNCDEF;
    tmp_decl->func_l = func_def;        /* !! NULL? */
    tmp_decl->dt_l = insert_declarator_list(decl_decl_stack->decl_decl,
                                            tmp_decr, decr);
        
    if (ptr_type_func) {
        tmp_decl->type_ref =
            insert_type_list(NULL, get_non_pointer_type(ptr_type_func), func);
    }

    if (type != NULL && type->type_spec2 != NULL) {
        /* Ϣdecl_type롥 */
        tmp_decl = make_decl_type2(tmp_decl, type->type_spec2_last);
    }

    /* Ϣfile_decl롥 */
    file_decl = insert_declaration_list(file_decl, tmp_decl, func);

    return tmp_decl;
}

/******************************************************************************/

static void after_declaration(DNOP tmp_decl, WP type)
{
    /* Ϣdecl_type롥 */
    tmp_decl = make_decl_type2(tmp_decl, type->type_spec2_last);

    set_declaration(tmp_decl,type_decl,func_decl,type_ref);

    type_decl = NULL;
    func_decl = NULL;
    type_ref = NULL ;
    
    pop_storage();      /* Added by N.Fukuyasu 1997/10/22. */
    push_storage();
    pop_decl_decl();    /* Added by N.Fukuyasu 1997/10/24. */
    push_decl_decl();
}

/*
 * declaration_list : declaration
 *                  | declaration_list declaration
 */

static void process_declaration_list(WP decl)
{
    DNOP    tmp_decl;
    
    clear_ts(ptr_ts_stack->sort);
    tmp_decl = insert_declaration(decl);
    tmp_decl->dt_l = (DT_ListP)decl->dataptr;
    tmp_decl->storage = storage_stack->storage ;
    tmp_decl->sort = DECL_NORMAL;

    switch (func_or_comp) {
      case DEF_FUNC :
        func_parm_stack->decl_l =
            insert_declaration_list(func_parm_stack->decl_l, tmp_decl,decl);
        break;
      case COMP_STAT:
      case GLOBAL:
        blk_decl = insert_declaration_list(blk_decl,tmp_decl,decl);
        break;
    }
    
    after_declaration(tmp_decl, decl);
}

/*
 * ؿݥ󥿤optionaldecl롥
 */

static OD_ListP make_function_pointer(WP decr, WP decl_point, DO_ListP decl_l)
{
    ODP         tmp_opt;
    OD_ListP    tmp_od_l;

    tmp_opt = insert_optionaldecl(NULL);
    tmp_opt->length = get_length(decl_point, decr);
    tmp_opt->sort = OPT_FUNCPTR;
    tmp_opt->decl_l = decl_l;

    tmp_od_l = insert_optionaldecl_list(NULL, tmp_opt, decl_point);
    return tmp_od_l;
}

/* 
 * type_ref롥
 * 
 * init_declarator : declarator
 *                 | declarator EQUAL initializer
 */

static void init_declarator_make_type_ref(void)
{
    tmp_wp.point = ptr_ts_stack->point;
    ptr_type = APP_TYPE_SPEC();

    if (!type_ref || type_ref->source->point != tmp_wp.point) {
        type_ref = insert_type_list(type_ref,get_non_pointer_type(ptr_type),
                                    &tmp_wp);
    }
}

/* typedef˴ؤinit_declaratorν */

static void process_typedef_declarator(WP init_decr, WP decr)
{
    TSP     ptr_ts;
    IDOP    tmp_ident;

    ptr_ts = insert_type(decr->name,decr);
    ptr_ts->sort = TYPE_TYPE_DEF;
    ptr_ts->pointer = ptr_type;           
    type_decl = insert_type_list(type_decl, ptr_ts ,decr);
        
    tmp_fo->scope->type_t = insert_type_list(tmp_fo->scope->type_t,
                                             ptr_ts, decr);

    tmp_ident = insert_identifier(decr->name,ID_TYPENAME);
    tmp_ident->data.type = ptr_ts;
    tmp_ident->length = strlen(decr->name); 
    tmp_ident->type = ptr_type;

    ptr_ts->ident = tmp_ident;           
    ident_decl = insert_identifier_list(NULL, tmp_ident, decr);

    /* typedef 줿̻Ҥ򸽺ߤΥפηơ֥Ͽ롥 */
    add_typedef_table(tmp_ident);

    /* tmp_identηꤹ롥ʤ$$->identϿ롥 */
    if (decr->type_spec2_last != NULL) {
        set_ident_type2(tmp_ident, decr->type_spec2_last);
    } else {
        init_decr->ident = tmp_ident;   /* tmp_identϷ */
    }

    if (decr->sort == FUNC_PTR || decr->sort == FUNC_TYPE) {
        init_decr->dataptr =
            (void *)make_function_pointer(decr, &decl_point,
                                          (DO_ListP)decr->dataptr);
    } else {
        init_decr->dataptr = NULL;
    }

    init_decr->sort = DECL_TYPE;
}

/* ѿ(ؿݥ󥿤ޤ)˴ؤinit_declaratorν */

static void process_variable_declarator(WP init_decr, WP decr,
                                        SpdBoolean has_initializer)
{
    IDOP        tmp_ident;
    LevelPtr    lev;

    if (has_initializer) {
        if (func_or_comp == DEF_FUNC) {
            yyerror("Parameter is initialized.\n");
        }
        if (func_or_comp == COMP_STAT &&
            ptr_ts_stack->sort->class == VAR_EXTERN) {
            yyerror("Has both `extern' and initializer.\n");
        }
    }

    if (func_or_comp == GLOBAL ||
        (func_or_comp == COMP_STAT &&
         ptr_ts_stack->sort->class == VAR_EXTERN)) {
        /* scope  global */
        ptr_data = insert_data(decr->name, ptr_type, VAR_GLOBAL, 
                               storage_stack->storage,
                               decr->point, current_file);
                        
    } else if (func_or_comp == COMP_STAT) {
        /* scope  local */
        ptr_data = insert_data(decr->name, ptr_type, VAR_LOCAL, 
                               storage_stack->storage,
                               decr->point, current_file);

    } else {    /* func_or_comp == DEF_FUNC */
        ptr_data = find_var_list(ptr_fs_input, decr->name);
                        
        if (ptr_data == NULL) { /* Error? */
            ptr_data = insert_data(decr->name, ptr_type, VAR_LOCAL, 
                                   storage_stack->storage,
                                   decr->point, current_file);
            ptr_fs_input = insert_data_list(ptr_fs_input, ptr_data, decr);
        } else {
            ptr_data->class = ptr_ts_stack->sort->class;
            ptr_data->type = ptr_type;
            insert_var_pos(ptr_data, decr);
        }
    }

    tmp_ident = NULL;
    /* identifier θ */
    if (func_or_comp != COMP_STAT ||
        ptr_ts_stack->sort->class == VAR_EXTERN || F_model)
        tmp_ident = find_identifier_by_ptr(ptr_data, ID_VARIABLE);

    if (func_or_comp == DEF_FUNC || tmp_ident == NULL) {
        if (tmp_ident == NULL) {
            /* identifier Ĥʤп */
            tmp_ident = insert_identifier(decr->name, ID_VARIABLE);
            tmp_ident->data.var = ptr_data;
            tmp_ident->length = strlen(decr->name);
        }
        tmp_ident->type = ptr_type;

        /*
         * tmp_ident ηꡥʤ $$->ident Ͽ
         */
        if (decr->type_spec2_last != NULL) {
            set_ident_type2(tmp_ident, decr->type_spec2_last);
        } else {
            init_decr->ident = tmp_ident;  /* tmp_ident Ϸ */
        }

        if (func_or_comp == GLOBAL) {
            lev = ((ptr_ts_stack->sort->class == VAR_STATIC) ?
                   find_level_has_type(SCOPE_FILE) :
                   find_level_has_type(SCOPE_GLOBAL));
            lev->var_t = insert_var_table(lev->var_t, ptr_data);
        } else if (func_or_comp == COMP_STAT &&
                   ptr_ts_stack->sort->class == VAR_EXTERN) {
            lev = find_level_has_type(SCOPE_GLOBAL);
            lev->var_t = insert_var_table(lev->var_t, ptr_data);
        }
    }

    if (func_or_comp == COMP_STAT) {
        add_var_table(ptr_data);
    }

    ident_decl = insert_identifier_list(NULL, tmp_ident, decr);

    if (decr->sort == FUNC_PTR || decr->sort == FUNC_TYPE) {
        init_decr->dataptr =
            (void *)make_function_pointer(decr, &decl_point,
                                          (DO_ListP)decr->dataptr);
    } else {
        init_decr->dataptr = NULL;
    }

    init_decr->sort = DECL_VARIABLE;
}

/* ץȥ˴ؤinit_declaratorν */

static void process_prototype_declarator(WP init_decr, WP decr)
{
    FSP ptr_func;
    ODP tmp_opt;

    if (ident_decl->ident->sort == ID_FUNCTION) {
        ptr_func = ident_decl->ident->data.func;
        ptr_func->type = ptr_type;
        ident_decl->ident->type = ptr_type;

        /* ident_type ̤ʤ identifier ˴ؿ */
        if (!is_defined_ident_type2(ident_decl->ident))
            set_ident_type2(ident_decl->ident, decr->type_spec2_last);
    }

    tmp_opt = insert_optionaldecl(NULL);
    tmp_opt->length = get_length(&decl_point, decr);
    tmp_opt->sort = OPT_PROTOTYPE;
    tmp_opt->decl_l = decr->dataptr;
    init_decr->dataptr =
        (void *)insert_optionaldecl_list(NULL, tmp_opt, &decl_point);

    init_decr->sort = DECL_PROTOTYPE;
}

/*
 * struct_declarator : declarator
 *                   | declarator ':' constant_expression
 */

static MEMSP process_struct_declarator(WP st_decr, WP decr)
{
    IDOP tmp_ident;
    DROP tmp_dt;

    tmp_wp.point = ptr_ts_stack->point;
    ptr_type = APP_TYPE_SPEC();

    /*
     * type_refdecl_typeΤlistǤ뤬
     * "struct_declaration : ..."ƤΤǰʲפǤ롥
     * N.Fukuyasu 1998/06/22.
     *
     * type_ref = insert_type_list(type_ref, get_non_pointer_type(ptr_type),
     *                             &tmp_wp);
     */

    ptr_mems = insert_member(decr->name,ptr_type,decr);
    tmp_ident = insert_identifier(decr->name,ID_MEMBER);
    tmp_ident->data.mem = ptr_mems;
    tmp_ident->length = strlen(decr->name);
    ident_decl = insert_identifier_list(NULL,tmp_ident,decr);
    tmp_ident->type = ptr_type;

    /* tmp_ident ηꡤʤ $$->ident Ͽ */
    if (decr->type_spec2_last != NULL) {
        set_ident_type2(tmp_ident, decr->type_spec2_last);
    } else {
        st_decr->ident = tmp_ident;     /* tmp_ident Ϸ */
    }

    ptr_ts_struc->struc =
        insert_member_list(ptr_ts_struc->struc,ptr_mems,NULL);

    tmp_dt = insert_declarator(decr);
    tmp_dt->sort = DECL_MEMBER;
    tmp_dt->id_l = ident_decl;
    tmp_dt->length = decr->length;
    tmp_dt->type = ptr_type;

    /*
     * Ϣ decr_type 
     * int x; Τ褦 declarator ʬ type ʤ硤
     * declarator "x"  decr_type ĥʤ
     */
    tmp_dt = make_decr_type2(tmp_dt, decr->type_spec2_last);

    if (decr->sort == FUNC_PTR || decr->sort == FUNC_TYPE) {
        tmp_dt->opt_l = make_function_pointer(decr, &decl_point,
                                              (DO_ListP)decr->dataptr);
    }

    decl_decl_stack->decl_decl =
        insert_declarator_list(decl_decl_stack->decl_decl, tmp_dt,decr);

    return ptr_mems;
}

/* 
 * identifier_list : identifier
 *                 | identifier_list COMMA identifier
 */

static DNOP process_identifier_list(WP ident)
{
    IDOP tmp_ident;
    DROP tmp_dt;
    DNOP tmp_decl;
    
    ptr_data = insert_data(ident->name, type_int, VAR_LOCAL, STORAGE_AUTO,
                           ident->point, current_file);
    if (!F_model ||
        (tmp_ident = find_identifier_by_ptr(ptr_data, ID_VARIABLE)) == NULL) {
        tmp_ident = insert_identifier(ident->name,ID_VARIABLE);
        tmp_ident->length = ident->length;
        tmp_ident->data.var = ptr_data;
        tmp_ident->type = type_int;

        /*
         * ؿץȥסؿݥ󥿤ΰηϾά줿硤
         * ۤ int
         */
        set_ident_type2(tmp_ident, type_spec2_implicit_int());
    }
    
    tmp_dt = insert_declarator(ident);
    tmp_dt->sort = DECL_VARIABLE;
    tmp_dt->id_l = insert_identifier_list(NULL,tmp_ident,ident);              
    tmp_dt->type = type_int;

    /*
     * declarator ηϰۤ int ꡥ
     * ʤϤTSP λͤ˹碌Ƥ
     */
    tmp_dt = make_decr_type2(tmp_dt, type_spec2_implicit_int());
    
    tmp_decl = insert_declaration(NULL);
    tmp_decl->sort = DECL_PARAMETER;
    tmp_decl->length = ident->length;
    tmp_decl->dt_l = insert_declarator_list(NULL, tmp_dt, ident);
    
    ptr_fs_input = insert_data_list(ptr_fs_input, ptr_data,NULL);

    /* ɬؿΥѥ᡼Ǥ롥N.Fukuyasu 1998/06/16. */
    func_parm_stack->decl_l
        = insert_declaration_list(func_parm_stack->decl_l,tmp_decl,ident);

    return tmp_decl;
}

/*
 * ߤΥפname¤ΡΡ󷿤Υ򸫤Ĥ롥
 * ĤʤidentifierפϿ(ʤ)
 */

IDOP find_tag_without_member(char *name)
{
    IDOP tmp_ident;
    Tag_TableP tmp_tag;

    if ((tmp_tag = find_tag_recursive(name)) == NULL) {
        tmp_ident = insert_identifier(name, ID_TAG);
        add_tag_table(tmp_ident, FALSE);
    } else {
        tmp_ident = get_tag_ident(tmp_tag);
    }

    return tmp_ident;
}

/*
 * ߤΥפname¤ΡΡ󷿤Υ򸫤Ĥ롥
 * ĤʤidentifierפϿ()
 */

IDOP find_tag_with_member(char *name)
{
    IDOP tmp_ident;
    Tag_TableP tmp_tag;

    if ((tmp_tag = find_tag_in_current(name)) != NULL) {
        /* tag ƱǸĤä */
        if (tag_has_member_def(tmp_tag) == FALSE) {
            set_tag_table_member_def(tmp_tag);
            tmp_ident = get_tag_ident(tmp_tag);
        } else {
            spdMessage("redefinition of %s\n", name);
            yyerror("");
        }
    } else {
        /* tag Ĥʤä鿷 */
        tmp_ident = insert_identifier(name, ID_TAG);
        add_tag_table(tmp_ident, TRUE);
    }

    return tmp_ident;
}

/******************************************************************************/

/*
 * word dataηꥻåȤ롥
 */

WP reset_wp_type_spec2(WP word)
{
    /* if (word == NULL) return word; */
    word->type_spec2 = NULL;
    word->type_spec2_last = NULL;
    return word;
}

/*
 * ؿΰΤνиꤹ롥
 */

void set_func_opt_point(WD point)
{
    func_opt_point.head_point = point.head_point;
    func_opt_point.length = point.length;
}

/******************************************************************************/

/* Maximum number of symbols. */
#define SAPID_SYMBOL_NUM        7

/*
 * ƥ롼ΥκǸǸƤФ졤head_pointlengthơ
 * פWPfree롥ʲ
 * 
 *     update_region_info($$, $1, $2, $3, $5, NULL);
 * 
 * Τ褦˰$$ǻϤޤǸNULLϤ$2ʹߤ򤹤٤free_WP()Τǡ
 * $$$1ʳƤˤϤδؿƤǤϤʤ
 *
 * N.Fukuyasu 1998/06/25.
 */

static void update_region_info(WP l_sym, ...)
{
    va_list     ap;
    WP          wp_tmp, syms[SAPID_SYMBOL_NUM];
    int         sym_num = 0, i;

    va_start(ap, l_sym);
    while ((wp_tmp = va_arg(ap, WP)) != NULL) {
        syms[sym_num] = wp_tmp;
        sym_num++;
    }
    va_end(ap);

    l_sym->head_point = syms[0]->head_point;
    l_sym->length = get_length(syms[0], syms[sym_num-1]);
    for (i = 1; i < sym_num; i++) {
        free_WP(syms[i]);
    }
}

/*
 * direct_declaratorΤؿ˴ؤ붦̽Ԥ
 * A.Yoshida 2001/06/06.
 */

static void process_function_direct_declarator(WP decr, WP lp)
{
    TS2P tmp_type;

    decl_point.head_point = lp->head_point;
    decl_point.length = lp->length;
        
    tmp_type = make_type_spec2_sort(TYPE_FUNC, lp);
        
    app_func_id();
        
    make_type_st2(tmp_type, decr->type_spec2);
    decr->type_spec2 = tmp_type;
    if (decr->type_spec2_last == NULL) {
        decr->type_spec2_last = tmp_type;
    }

    if (decr->sort == ID_NAME) {
        FSP ptr_func;
        IDOP tmp_ident;

        if ((ptr_func = find_function(decr->name)) == NULL) {
            ptr_func = insert_function(decr->name, NULL);
            ptr_func->length = decr->length;
        }
        if ((tmp_ident = find_identifier(decr->name, ID_FUNCTION)) == NULL) {
            tmp_ident = insert_identifier(decr->name, ID_FUNCTION);
            tmp_ident->length = strlen(decr->name);
            tmp_ident->data.func = ptr_func;
        }
                    
        ident_decl = insert_identifier_list(NULL, tmp_ident, decr);

        if (storage_stack->storage == STORAGE_TYPEDEF) {
            /* In the context of typedef. */
            decr->sort = FUNC_TYPE;
        } else {
            decr->sort = NON;
        }
    } else {
        decr->sort = FUNC_PTR;
    }
}

/*
 * postfix_expressionˤؿƤӽФ˴ؤ붦̽Ԥ
 * A.Yoshida 2001/06/06.
 */

static void process_func_postfix_expression(WP expr, WP rp, EO_ListP arg)
{
    FSP tmp_fs = NULL;
    EOP tmp_expr;

    if (expr->sort != NON && expr->sort != DATA_NAME) {
        if (expr->sort == FUNCTION_NAME) {
            tmp_fs = find_function(expr->name);
        } else if (expr->sort == ID_NAME) {
            IDOP tmp_ident;
            TS2P tmp_type;

            tmp_fs = insert_function(expr->name, NULL);
            tmp_ident = insert_identifier(expr->name, ID_FUNCTION);
            tmp_ident->data.func = tmp_fs;
            push_ts();
            ptr_ts_stack->sort->type = TYPE_INT;
            ptr_ts_stack->sort->sort = TYPE_DECLARATION;
            app_func_id();
            tmp_ident->length = strlen(expr->name); 
            tmp_ident->type = APP_TYPE_SPEC();

            /* ̤ʴؿηϰۤ int */
            tmp_type = make_type_spec2_sort(TYPE_FUNC, NULL);
            make_type_st2(type_spec2_implicit_int(), tmp_type);
            set_ident_type2(tmp_ident, tmp_type);

            tmp_fs->type = tmp_ident->type ;
            pop_ts();
        }
        if (tmp_fs) {
            expr->expr->id_l = insert_identifier_list(NULL,
                                                      find_identifier_by_ptr(tmp_fs, ID_FUNCTION),
                                                      expr);
        }
    }
    expr->sort = NON;
    if (expr->type) {
        expr->type = expr->type->pointer;
    } else if (tmp_fs) {
        expr->type = tmp_fs->type->pointer;
    } else {

#ifdef FUNCPTR_DEBUG
        fprintf(stderr, "ERR postfix_expression '(' ')' line = %d\n", 
                yylineno);
#endif        

    }

    tmp_expr = insert_expression(expr);
    tmp_expr->expr_list = insert_expression_list(arg, expr->expr, expr);
    tmp_expr->sort = EXPR_SORT_FUNCCALL;
    tmp_expr->length = get_length(expr, rp);
    expr->expr = tmp_expr;
}

/******************************************************************************/

#if defined(TYPE_REF_DEBUG) || defined(lint)

void dw_type_ref(char *format, WP wp)
{
    fprintf(stderr, format, wp->head_point, wp->name);
    fprintf(stderr, "    ptr_ts_stack %x, %x: ",
            (unsigned int)ptr_ts_stack, (unsigned int)ptr_ts_stack->sort);
    fprintf(stderr, "class %d, qualifier %d, sign %d, length %d, type %d\n",
            ptr_ts_stack->sort->class,
            ptr_ts_stack->sort->qualifier,
            ptr_ts_stack->sort->sign,
            ptr_ts_stack->sort->length,
            ptr_ts_stack->sort->type);
}

#endif /* defined(TYPE_REF_DEBUG) || defined(lint) */
