/*
 * Program:             $RCSfile: link4b_write.c,v $  $Revision: 30.19 $
 *
 * Purpose:             Write SDB.
 *
 * Author:              S.Kawai  1995/10/01
 *                      S.Yamamoto  1996/06/02
 * Modified:            R.Miura  1998/07/05
 *
 * (C) Copyright:       S.Kawai, R.Miura and S.Yamamoto  1995 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: link4b_write.c,v 30.19 2003/07/20 11:46:15 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/write_sdb_sub.h>
#include "ISDB.h"

#ifdef SDBLINK4B
#include "sdblink4b.h"
#elif SPD_MERGE_SDB
#include "sdblink4c.h"
#endif

static void write_db_sdblink_sub(SpdInfo *info, SpdModelId modelId)
{
    int         j, object_counter, dummy;
    SpdClassId  i;
    FILE        *fp;
    MyObject    *obj;
    Relation    *rel;

    SpdClassId  first_class_id, last_class_id;
    SpdClassId  first_rel_id, last_rel_id;
    SpdClassId  offset_class;               /* 饹ΰ͡ */
    SpdClassId  offset_rel;                 /* Ϣΰ͡ */
    SpdString   output_dir;

    switch (modelId) {
      case SPD_MID_I_MODEL:
        first_class_id = SPD_FIRST_CID_I_MODEL;
        last_class_id = SPD_LAST_CID_I_MODEL;
        offset_class = 0;
        first_rel_id = SPD_FIRST_RID_I_MODEL;
        last_rel_id = SPD_LAST_RID_I_MODEL;
        offset_rel = SPD_CID_NUM_I_MODEL;
        output_dir = I_MODEL_DIR;
        break;

#ifdef SPD_MERGE_SDB
      case SPD_MID_P_MODEL:
        first_class_id = SPD_FIRST_CID_P_MODEL;
        last_class_id = SPD_LAST_CID_P_MODEL;
        offset_class = SPD_RID_NUM_I_MODEL;
        first_rel_id = SPD_FIRST_RID_P_MODEL;
        last_rel_id = SPD_LAST_RID_P_MODEL;
        offset_rel = SAPID_I_P_CLASS_NUM;
        output_dir = P_MODEL_DIR;
        break;
#endif /* SPD_MERGE_SDB */

      default:
        spdErrorExit("Target DB is invalid.\n");
    }

    /* 饹ν */
    for (i = first_class_id; i <= last_class_id; i++) {
        fp = spdOpenSDBfile(output_dir, spdGetClassNameById(i), SAPID_O_WRITE);
        object_counter = 0;
        /* ҤȤĤŤļФƽϤ롥 */
        for (j = 0; j < class_object_set[i - offset_class]->elemNum; j++) {
            obj = spdGetAElem(class_object_set[i - offset_class], &dummy);
            if (obj->db_key == -1) {
                continue;
            }
            spdWriteDBObj(fp, &object_db[obj->db_key]);
            object_counter++;
        }
        spdFclose(fp);
        spdSetInfoInt(info, spdGetClassNameById(i), object_counter);
    }

    /* Ϣνϡ */
    for (i = first_rel_id; i <= last_rel_id; i++) {
        fp = spdOpenSDBfile(output_dir, spdGetClassNameById(i), SAPID_O_WRITE);
        object_counter = 0;
        /* ҤȤĤŤļФƽϤ롥 */
        for (j = 0; j < relation_array[i - offset_rel].elem_num; j++) {
            rel = &relation_array[i - offset_rel].elem[j];
            if (rel->db_key == -1) {
                continue;
            }
            spdWriteDBRel(fp, &relation_db[rel->db_key]);
            object_counter++;
        }
        spdFclose(fp);
        spdSetInfoInt(info, spdGetClassNameById(i), object_counter);
    }
}

void write_db_sdblink(void)
{
    SpdInfo  *info = spdOpenSDBinfo();

    write_db_sdblink_sub(info, SPD_MID_I_MODEL);
#ifdef SPD_MERGE_SDB
    write_db_sdblink_sub(info, SPD_MID_P_MODEL);
#endif

    spdCloseInfo(info);
}
