/*
 * Program:             $RCSfile: linklib4b.c,v $  $Revision: 30.17 $
 *
 * Purpose:
 *
 * Author:              S.Kawai  1997/02/08
 *                      S.Yamamoto  1997/02/08
 * Modified:            R.Miura  1998/07/05 
 *
 * (C) Copyright:       S.Kawai, R.Miura and S.Yamamoto  1997 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: linklib4b.c,v 30.17 2003/07/20 11:46:15 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "ISDB.h"

#ifdef SDBLINK4B
#include "sdblink4b.h"
#elif SPD_MERGE_SDB
#include "sdblink4c.h"
#endif

/* 
 * Ϣ̾õ롥
 * order:
 *  #define P_ID            0
 *  #define C_ID            1
 */

MyObject *search_object_by_rel(MyObject *obj, int target_class_id, int order)
{
    LinkArray *link_array;
    Link      *link;
    int       i;

    link_array = (order == P_ID ? &obj->p_link : &obj->c_link);
    
    for (i = 0; link_array->elem_num; i++) {
        link = &link_array->elem[i];
        if (link->rel->db_key != -1 && 
            spdGetClassId(relation_db[link->rel->db_key].Rel_id)
            == target_class_id)
            return link->obj;
    }
    return NULL;
}

/******************************************************************************/

/* 
 * MyObject Υåꥹȴ
 * Ʊ쥯饹Υ֥ȤȤա
 */

CheckTable *
create_obj_check_table(int table_size, SpdClassId class_id)
{
    CheckTable *table;

    table = (CheckTable *)spdMalloc(sizeof(CheckTable));
    table->db_key = (int *)spdMalloc(sizeof(int) * table_size);
    table->class_id = class_id;
    table->db_key_num = 0;
    return table;
}

void
add_to_obj_check_table(CheckTable *table, int db_key)
{
    /* ΰ襪Сϥåʤ */
    table->db_key[table->db_key_num++] = db_key;
}

SpdId
lookup_obj_check_table(CheckTable *table, int db_key)
{
    int i;

    for (i = 0; i < table->db_key_num; i++) {
        if (is_identical_db_obj(&object_db[table->db_key[i]],
                                &object_db[db_key],
                                table->class_id))
            return object_db[table->db_key[i]].Obj_id;
    }
    return SPD_NON_ID;    
}

void
free_obj_check_table(CheckTable *table)
{
    spdFree(table->db_key);
    spdFree(table);
}

/******************************************************************************/

/*
 * idѴơ֥δ
 */

/* idѴơ֥Ͽ롥 */

void
push_modification_table(SpdSet set, SpdId old_id, SpdId new_id)
{
    ModifyField     field;

    field.old_id = old_id;
    field.new_id = new_id;

    /* 
     * old_id򥭡Ȥơfield򽸹ɲä롥
     * spdAddElem()filedΥԡ򽸹ɲä롥
     */
    spdAddElem(set, old_id, &field);
}

/* 
 * setäƤ륪֥ȤδϢ롥
 */

void
modify_id(int target_class, SpdSet set)
{
    int         i, j;
    SpdBoolean  modify_p_id, modify_c_id;
    Relation    *ptr;
    ModifyField *element;

    for (i = SPD_CID_NUM_I_MODEL; i < SPD_CRID_NUM_I_MODEL; i++) {
        /* rel_class1rel_class2ϴϢοƤȻҤclass_idݻƤ롥 */
        modify_p_id = (class_table[i].rel_class1 == target_class);
        modify_c_id = (class_table[i].rel_class2 == target_class);
        if (!modify_p_id && !modify_c_id) {
            continue;
        }

        for (j = 0; j < relation_array[rel_index(i)].elem_num; j++) {
            ptr = &relation_array[rel_index(i)].elem[j];
            if (ptr->db_key == -1) {
                continue;                   /* ֥ȡ */
            }
            if (modify_p_id) {              /* p_idоݤǤ롥 */
                /* ơ֥뤫p_idold_idȤʤäƤΤõ */
                if ((element
                     = spdSearchElem(set, relation_db[ptr->db_key].Rel_p_id)) 
                    != NULL) {
                    /* p_idnew_id˽롥 */
                    relation_db[ptr->db_key].Rel_p_id = element->new_id;
                }
            }
            if (modify_c_id) {              /* c_idоݤǤ롥 */
                if ((element
                     = spdSearchElem(set, relation_db[ptr->db_key].Rel_c_id))
                    != NULL) {
                    relation_db[ptr->db_key].Rel_c_id = element->new_id;
                }
            }
        }
    }
}

/******************************************************************************/

/* 
 * db_Objidʳ°ͤƱ줫ɤȽꤹ롥
 *
 * db_obj1db_obj2Ʊ쥯饹Ǥ뤳ȤꤷƤ롥
 * max_iattr, max_sattr°κź
 * memcmpӤ뤿ᡤ°ͤ˶ʤȡ뤤0˽
 * Ƥ뤳ȤȤʤ롥
 */

SpdBoolean
is_identical_db_obj(SpdDBObj *db_obj1, SpdDBObj *db_obj2, SpdClassId classId)
{
    int   i;

    /* int°ӡ */
    if (memcmp(&db_obj1->ivalue[1], &db_obj2->ivalue[1],
               sizeof(int) * class_table[classId].max_iattr) != 0) {
        return FALSE;
    }

    /* string°ӡ */
    for (i = 0; i <= class_table[classId].max_sattr; i++) {
#ifdef SPD_MERGE_SDB
        if (classId == SPD_CID_FILE) {
            /* ƥեΤ̾󤻤Ԥ*/
            /* if (!smuIsSystemFile(db_obj1->svalue[i])) */
            if (!smuIsSystemFileName(db_obj1->svalue[i]))
                return FALSE;
        }
#endif /* SPD_MERGE_SDB */
            
        if (!SPD_STREQ(db_obj1->svalue[i], db_obj2->svalue[i])) {
            return FALSE;
        }
    }
    return TRUE;
}

/******************************************************************************/

/*
 * Ϣ˴ؤؿ
 */

void
add_new_link(LinkArray *link_array, MyObject *obj, Relation *rel)
{
    if (link_array->elem_num == 0) {
        link_array->elem = spdMalloc(sizeof(Link));
    } else {
        link_array->elem =
            spdRealloc(link_array->elem,
                       sizeof(Link) * (link_array->elem_num + 1));
    }

    link_array->elem[link_array->elem_num].obj = obj;
    link_array->elem[link_array->elem_num].rel = rel;
    link_array->elem_num++;
}

/* 
 * ٤ƤΥ饹֥ȴ֤Ϣĥ롥
 */

void
make_relations(void)
{
    int      i, j;
    SpdId    class_id;
    Relation *rel;
    MyObject *p_obj, *c_obj, *tmp_obj;

    for (i = SPD_CID_NUM_I_MODEL; i < SPD_CRID_NUM_I_MODEL; i++) {
        for (j = 0; j < relation_array[rel_index(i)].elem_num; j++) {
            rel = &relation_array[rel_index(i)].elem[j];
            if (rel->db_key == -1)
                continue;
            /* p_id õ */
            class_id = class_table[i].rel_class1;
            p_obj = spdSearchElem(class_object_set[class_index(class_id)],
                                  relation_db[rel->db_key].Rel_p_id);
            if (p_obj == NULL)
                spdErrorExit("Not find class object \"%s\".\n", 
                             spdGetClassNameById(class_id));
            /* c_id õ */
            class_id = class_table[i].rel_class2;
            c_obj = spdSearchElem(class_object_set[class_index(class_id)],
                                  relation_db[rel->db_key].Rel_c_id);
            if (c_obj == NULL)
                spdErrorExit("Not find class object \"%s\".\n",
                             spdGetClassNameById(class_id));

            /* δϢƤȻҤδطդˤ(ΤȤ case ) */
            switch (i) {
              case SPD_RID_TYPE_IS:
                tmp_obj = p_obj;
                p_obj = c_obj;
                c_obj = tmp_obj;
                /* 
                 * ()
                 * ȡ̤촹Τ˺ʤ
                 * ġϤϡޤդ᤹
                 */
                break;
            }
            add_new_link(&(p_obj->c_link), c_obj, rel);
            add_new_link(&(c_obj->p_link), p_obj, rel);
        }
    }
}

/* 
 * ٤ƤϢ
 */

void
clear_relations(void)
{
    /* !! Not implemented yet. */
}
