/*
 * Program:             $RCSfile: sdblink4b.c,v $  $Revision: 30.49 $
 *
 * Purpose:
 *
 * Author:              S.Kawai  1995/10/01
 *                      S.Yamamoto  1996/06/02
 * Modified:            R.Miura  1998/07/05
 *
 * (C) Copyright:       S.Kawai, R.Miura and S.Yamamoto  1995 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: sdblink4b.c,v 30.49 2003/08/10 14:14:39 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "ISDB.h"
#include "sdblink4b.h"

/*
 * 饹ӴϢǼѤѿ
 * ΤSpdSet󡤴ϢRelationȤƼƤ롥
 *
 * ʤǡ¤ۤʤ(S.Yamamoto 1999/04/04)?
 * ΤϡľܻȤ뤳Ȥ¿?
 */
SpdSet          class_object_set[SDBLINK_CLASS_NUM];
RelationArray   relation_array[SDBLINK_REL_NUM];

/* ѿAR4ƱˡǴƤ롥 */
SpdDBObj    *object_db;
SpdDBRel    *relation_db;
int         object_db_n;
int         relation_db_n;
int         object_db_alloc_n = 0;
int         relation_db_alloc_n = 0; 

/* ֥ȿΥơ֥롥 */
int         obj_and_rel_num_table[SDBLINK_CLASS_AND_REL_NUM];

/* 󥯸Υץ̾ */
static char         *target_program_name = SPD_DEFAULT_TARGET_PROGRAM_NAME;

static int          optimize_level = 0; 

static SpdConstString program_name;              /* This program name. */

static void parse_option(int argc, char *argv[]);
static void printUsage(SpdConstString command_name);

/******************************************************************************/

/*
 * ISDBβϤȥǡγǼ
 */

static void load_ISDB(FILE *fp, int file_no, SpdId file_id)
{
    int             obj_num, attr_id;
    int             scope, sort;
    int             offset1, offset2;
    SpdClassId      class_id;
    SpdId           id, new_id;
    SpdSet          operator_modify_set, extern_modify_set;
    SpdDBObj        db_obj;
    SpdDBRel        db_rel;
    SpdInfo         *info;

    /* Ѥset롥 */
    operator_modify_set = spdCreateSet(sizeof(ModifyField));
    extern_modify_set = spdCreateSet(sizeof(ModifyField));

    info = spdOpenISDBinfo(file_id);
    spdSetReadSDBformat(SPD_STREQ(spdGetInfoString(info, "BINARY_FORMAT_SDB"),
                                    "TRUE") ?
                        SAPID_BINARY_FORMAT_SDB :
                        SAPID_TEXT_FORMAT_SDB);

    /* Τν */
    for (class_id = SPD_FIRST_CID_I_MODEL;
         class_id <= SPD_LAST_CID_I_MODEL; class_id++) {
        /* file_noid_offsetfile_no + 1˥ԡ롥 */
        set_id_offset(file_no + 1, class_id,
                      get_id_offset(file_no, class_id) +
                      SPD_OBJ_ID_OFFSET(class_id) - 1);

        obj_num = spdGetInfoInt(info, spdGetClassNameById(class_id), 0);
        if (obj_num == 0) {
            continue;
        }

        while (obj_num--) {
            /* ꤵ줿cond˽롥 */
            db_obj = spdReadObj(fp, class_id);
            /* Note: ISDB ˤ program, file, prog_file ϽϤƤʤ */
            switch (class_id) {
              case SPD_CID_OPERATOR:        /**********************************/
                /*
                 * sizeofcastʳΥڥ졼̾󤻤롥
                 * °ͤƱȽꤹ롥
                 */
                db_obj.Obj_id += get_id_offset(file_no, class_id);
                sort = db_obj.ivalue[SPD_AID_OPERATOR_SORT];
                if (sort != OP_CAST && sort != OP_SIZEOF_TYPE &&
                    (new_id = get_equal_db_obj(&db_obj, class_id)) !=
                    SPD_NON_ID) {
                    /* ¸ߤΤ̾󤻤롥 */
                    push_modification_table(operator_modify_set,
                                            db_obj.Obj_id, new_id);
                    spdFreeStrsInObj(db_obj);
                } else {
                    add_new_object(class_id, db_obj);
                }
                set_id_offset(file_no + 1, class_id, db_obj.Obj_id);
                break;
              case SPD_CID_IDENTIFIER:      /**********************************/
                /* externΤ̾󤻤롥nameƱȽꤹ롥 */
                db_obj.Obj_id += get_id_offset(file_no, class_id);
                scope = db_obj.ivalue[SPD_AID_IDENTIFIER_SCOPE];
                if (scope == ID_SCOPE_GLOBAL) {
                    attr_id = SPD_AID_IDENTIFIER_NAME;
                    new_id = get_equal_global(db_obj.svalue[attr_id - SpdObjIValN]);
                    if (new_id != SPD_NON_ID) {
                        /* ¸ߤΤ̾󤻤롥 */
                        push_modification_table(extern_modify_set,
                                                db_obj.Obj_id, new_id);
                        spdFreeStrsInObj(db_obj);
                    } else {
                        push_global_table(db_obj.Obj_id,
                                          db_obj.svalue[attr_id - SpdObjIValN]);
                        add_new_object(class_id, db_obj);                       
                    }                   
                } else {
                    add_new_object(class_id, db_obj);
                }
                set_id_offset(file_no + 1, class_id, db_obj.Obj_id);
                break;
              default:                      /**********************************/
                db_obj.Obj_id += get_id_offset(file_no, class_id);
                add_new_object(class_id, db_obj);
                set_id_offset(file_no + 1, class_id, db_obj.Obj_id);
                break;
            }
        }
    }

    /* Ϣν */
    for (class_id = SPD_FIRST_RID_I_MODEL;
         class_id <= SPD_LAST_RID_I_MODEL; class_id++) {
        id = SPD_OBJ_ID_OFFSET(class_id);
        offset1 = get_id_offset(file_no, class_table[class_id].rel_class1);
        offset2 = get_id_offset(file_no, class_table[class_id].rel_class2);
        if ((obj_num = spdGetInfoInt(info,
                                     spdGetClassNameById(class_id), 0)) == 0) {
            continue;
        }
        while (obj_num--) {
            /* Ϣidɤ߹߻դ롥*/
            db_rel = spdReadRel(fp, class_id, id++);
            /* id񤭴 */
            db_rel.Rel_p_id += offset1;
            db_rel.Rel_c_id += offset2;
            /* Ͽ */
            add_new_relation(class_id, db_rel);
        }
    }
    /* ơ֥˽äid롥 */
    modify_id(SPD_CID_IDENTIFIER, extern_modify_set);
    modify_id(SPD_CID_OPERATOR, operator_modify_set);
    spdFreeSet(extern_modify_set);
    spdFreeSet(operator_modify_set);

    spdCloseInfo(info);
}

/*
 * Initialize tables.
 */

static void init_list(void)
{
    int     i;

    /* (SpdSet) class_object_set[]. */
    for (i = 0; i < SDBLINK_CLASS_NUM; i++) {
        class_object_set[i] = spdCreateSet(sizeof(MyObject));
    }
    /* Ϣ(Relation) relation_array[]. */
    for (i = 0; i < SDBLINK_REL_NUM; i++) {
        relation_array[i].elem =
            spdMalloc(sizeof(Relation) *
                      obj_and_rel_num_table[i + SDBLINK_CLASS_NUM]);
        relation_array[i].elem_num = 0;
    }
}

/*
 * Free heap memory.
 */

void free_sdblink(void)
{
    int     i;

    for (i = 0; i < SDBLINK_CLASS_NUM; i++) {
        spdFreeSet(class_object_set[i]);
    }
    for (i = 0; i < SDBLINK_REL_NUM; i++) {
        spdFree(relation_array[i].elem);
    }
    for (i = 0; i < object_db_n; i++) {
        spdFreeStrsInObj(object_db[i]);
    }
    spdFree(object_db);
    spdFree(relation_db);
}

/* Added by N.Fukuyasu 1999/08/27. */
/* target_program_name  program ֥Ȥ롥 */

SpdId make_program_object(void)
{
    SpdId       prog_id = SPD_OBJ_ID_OFFSET(SPD_CID_PROGRAM);
    SpdDBObj    db_obj;

    db_obj.Obj_id = prog_id;
    db_obj.svalue[SPD_AID_PROGRAM_NAME - SpdObjIValN] =
        spdStrdup(target_program_name);
    add_new_object(SPD_CID_PROGRAM, db_obj);

    return (prog_id);
}

/* Added by N.Fukuyasu 1999/08/27. */
/* file 饹ɤ߹ࡥ */

void read_file_class(int file_obj_num)
{
    FILE        *fp;
    SpdDBObj    db_obj;
    SpdInfo     *info;

    info = spdOpenSDBinfo();
    spdSetReadSDBformat(SPD_STREQ(spdGetInfoString(info, "BINARY_FORMAT_SDB"),
                                    "TRUE") ?
                        SAPID_BINARY_FORMAT_SDB :
                        SAPID_TEXT_FORMAT_SDB);
    spdCloseInfo(info);
    fp = spdOpenSDBfile(I_MODEL_DIR, spdGetClassNameById(SPD_CID_FILE),
                        SAPID_O_READ);
    while (file_obj_num--) {
        db_obj = spdReadObj(fp, SPD_CID_FILE);
        add_new_object(SPD_CID_FILE, db_obj);
    }
    spdFclose(fp);
}

/* Added by N.Fukuyasu 1999/08/27. */
/* prog_id  file_id δ֤˴Ϣ prog_file 롥 */

void make_prog_file(SpdId prog_id, SpdId file_id)
{
    static SpdId    id = SPD_OBJ_ID_OFFSET(SPD_RID_PROG_FILE);
    SpdDBRel        db_rel;

    db_rel.Rel_id = id++;
    db_rel.Rel_p_id = prog_id;
    db_rel.Rel_c_id = file_id;
    add_new_relation(SPD_RID_PROG_FILE, db_rel);
}

/*
 * Initialize.
 */

void initialize(int file_num, SpdId *file_id)
{
    int         i, tmp_count = 0;
    SpdId       class_id;
    SpdInfo     *info;
    SpdId       prog_id;
    int         file_obj_num;
    SpdConstString  className;

    /* ƤDBФinfoĴ١objrelο롥 */
    for (i = 0; i < SDBLINK_CLASS_AND_REL_NUM; i++) {
        obj_and_rel_num_table[i] = 0;
    }
    for (i = 0; i < file_num; i++) {
        info = spdOpenISDBinfo(file_id[i]);
        for (class_id = SPD_FIRST_CID_I_MODEL;
             class_id <= SPD_LAST_CID_I_MODEL; class_id++) {
            className = spdGetClassNameById(class_id);
            tmp_count = spdGetInfoNumOfObjs(info, className);
            object_db_alloc_n += tmp_count;
            obj_and_rel_num_table[class_id] += tmp_count;
        }
        for (class_id = SPD_FIRST_RID_I_MODEL;
             class_id <= SPD_LAST_RID_I_MODEL; class_id++) {
            className = spdGetClassNameById(class_id);
            tmp_count = spdGetInfoNumOfObjs(info, className);
            relation_db_alloc_n += tmp_count;
            obj_and_rel_num_table[class_id] += tmp_count;
        }
        spdCloseInfo(info);
    }

    for (class_id = SPD_FIRST_CID_I_MODEL;
         class_id <= SPD_LAST_RID_I_MODEL; class_id++) {
        className = spdGetClassNameById(class_id);
        if (SPD_ID_SPACE < obj_and_rel_num_table[class_id]) {
            spdErrorExit("Class \"%s\", num %d: Too many objects.\n",
                         className, obj_and_rel_num_table[class_id]);
        }  
    }

    /* Added by N.Fukuyasu 1999/08/27. */
    /*
     * ISDB ˽ϤƤΤ program, file ʳΥ֥ȤǤ롥
     * program ֥Ȥ򿷤뤿˥֥ȿ 1 
     * 롥file ֥Ȥ pidb ˤäѤߤǤ뤬
     * Ѥɤ߹Τ file ֥ȤθĿ⥪֥ȿ˲ä롥
     * ޤϢ prog_file 뤿 file_num Ϣ˲ä롥
     */
    object_db_alloc_n++;
    obj_and_rel_num_table[SPD_CID_PROGRAM] = 1;

    info = spdOpenSDBinfo();
    file_obj_num = spdGetInfoInt(info,
                                 spdGetClassNameById(SPD_CID_FILE), 0);
    object_db_alloc_n += file_obj_num;
    obj_and_rel_num_table[SPD_CID_FILE] = file_obj_num;
    spdCloseInfo(info);

    relation_db_alloc_n += file_num;
    obj_and_rel_num_table[SPD_RID_PROG_FILE] = file_num;

    /* 
     * info˰ΰݤ롥ɤ߹ߤκݤ̾󤻤ǽ
     * ΤǼºݤλ̤Ϥ꾯ʤʤ롥Ϥ鷺Ǥ롥
     */
    object_db = spdMalloc(sizeof(SpdDBObj) * object_db_alloc_n);
    object_db_n = 0;

    /* ƤδϢɤ߹िᡤݤΰƻѤ롥 */
    relation_db = spdMalloc(sizeof(SpdDBRel) * relation_db_alloc_n);
    relation_db_n = 0;

    init_id_offset(file_num);

    /* Initialize list. */
    init_list();

    /* Added by N.Fukuyasu 1999/08/27. */
    /* program ֥Ȥ롥 */
    prog_id = make_program_object();

    /* Added by N.Fukuyasu 1999/08/27. */
    /* SDB  file 饹ɤ߹ࡥ */
    read_file_class(file_obj_num);

    /* Added by N.Fukuyasu 1999/08/27. */
    /*
     * target_program_name  file_id Ϥ줿 file Ȥδ֤
     * Ϣ prog_file 롥
     */
    for (i = 0; i < file_num; i++) {
        make_prog_file(prog_id, file_id[i]);
    }
}

/*
 * Main.
 */

int main(int argc, char **argv)
{
    int         i;
    SpdInfo     *info;
    FILE        *fp;
    SpdId   *file_id;
    int     file_num;
    
    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);

    parse_option(argc, argv);
    argc -= optind;
    argv += optind;
    if (argc < 1) {
        spdErrorExit("No input file.\n");
    }

    file_num = argc;
    file_id = spdMalloc(sizeof(SpdId) * file_num);
    for (i = 0; i < file_num; i++) {
        if ((file_id[i] = spdSearchGlobalObjEx("file", argv[i])) == SPD_NON_ID)
            spdErrorExit("\"%s\" is not found.\n", argv[i]);
    }

    /* Initialize. */
    initialize(file_num, file_id);

    /* ISDBɤ߹ߡ */
    for (i = 0; i < file_num; i++) {
        /* ISDBϤ롥 */
        fp = spdOpenISDB(file_id[i], SAPID_O_READ);
        load_ISDB(fp, i, file_id[i]);
        spdFclose(fp);
    }

    if (file_id != NULL) {
        spdFree(file_id);
    }

    /* IdentifierѤΥϥå(global_map[])β */
    free_global_table();

    free_id_offset();

    /* Ŭ */
    if (0 < optimize_level) {
        optimizer(optimize_level);
    }

    /* Writing SDB. */
    write_db_sdblink();

    info = spdOpenSDBinfo();
    spdSetInfoString(info, "BINARY_FORMAT_SDB",
                     (spdGetWriteSDBformat() == SAPID_BINARY_FORMAT_SDB ? "TRUE" : "FALSE"));
    /* spdSetInfoInt(info, "ENDIAN", spdGetEndian()); */
    spdSetInfoInt(info, "OPTIMIZE_LEVEL", optimize_level);
    spdSetInfoString(info, "SHARED_DECLARATION",
                     ((1 < optimize_level) ? "TRUE" : "FALSE"));
    spdSetInfoString(info, "RELATIVE_OFFSET",
                     ((optimize_level < 3) ? "FALSE" : "TRUE"));
    spdCloseInfo(info);

    /* !! Release heap memories! */ 
    /* free_sdblink(); */

    return (EXIT_SUCCESS);
}

/*
 * Analyzing options.
 */

static void parse_option(int argc, char *argv[])
{
    int     ch;

    while ((ch = getopt(argc, argv, "d:o:O:b")) != -1) {
        switch (ch) {
          case 'd':                         /* Directory for SDB. */
            spdSetSDBdir(optarg);
            spdMessage("SDB directory \"%s\".\n", spdGetSDBdir());
            break;
          case 'o':                         /* Program name. */
            target_program_name = optarg;
            break;
          case 'O':                         /* Optimize SDB. */
            optimize_level = atoi(optarg);
            if (optimize_level < 1 || 3 < optimize_level) {
                printUsage(program_name);
            } else if (optimize_level == 2) {
                spdWarning("Obsolete \"-O2\" option is specified.\n");
            }
            break;
          case 'b':                         /* Binaryϡ */
            spdSetWriteSDBformat(SAPID_BINARY_FORMAT_SDB);
            break;
          default:
            printUsage(program_name);
            break;
        }
    }
}

/*
 * Usage.
 */

static void printUsage(SpdConstString command_name)
{
    const char  *usageMessage =
        "\n"
        "NAME\n"
        "    %s\n"
        "SYNOPSIS\n"
        "    %s [options] files\n"
        "    -b        : Output SDB with binary format.\n"
        "    -d dir    : Directory for SDB (\"SDB\").\n"
        "    -o target : Target name (\"a.out\")\n"
        "    -O1       : Optimize \"ident_type\" and \"type\".\n"
        "    -O3       : This enables all -O1 optimization. It also enables\n"
        "                optimization of \"declaration\" and makes relative offset.\n"
        "VERSION\n"
        "    %d.%d.%d\n";

    spdErrorExit(usageMessage,
                 command_name, command_name,
                 SapidVersion, SapidRevision, SapidPatchLevel);
}
