/*
 * Program:             $RCSfile: sdbopt4b.c,v $  $Revision: 30.18 $
 *
 * Purpose:
 *
 * Author:              S.Kawai  1996/10/30
 *                      S.Yamamoto  1996/10/30
 * Modified:            R.Miura  1998/07/05 
 *
 * (C) Copyright:       S.Kawai, R.Miura and S.Yamamoto  1996 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: sdbopt4b.c,v 30.18 2003/07/20 11:46:15 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "ISDB.h"

#ifdef SDBLINK4B
#include "sdblink4b.h"
#elif SPD_MERGE_SDB
#include "sdblink4c.h"
#endif

/* 
 * declaration̾󤻤Ѥ롤ڹ¤ӥ롼λꡥ
 * 
 * SDBLINK_NEW_COMP_TREE: Ҥ򽸹ŪӤ롥
 * SDBLINK_LINK_SORT:     ˻Ҥ°ͤǥȤ롥
 * ξȤ̤:        롼Ѥ롥
 */
#define SDBLINK_NEW_COMP_TREE
/* #define SDBLINK_LINK_SORT */

/******************************************************************************/

/* 
 * Optimize ident_type.
 */

/*
 * identifier ǿ type 
 */

static RealTypeField
get_real_type(MyObject *ident)
{
    RealTypeField   res;
    MyObject        *obj_csr, *obj_tmp;
    Link            *link;
    int             i;
    static MyObject *save_ident = NULL;
    static int      save_index;

    /* Ȱۤʤϥꥻå */
    if (save_ident != ident) {
        save_ident = ident;
        save_index = 0;
    }

    /* c_list ˤʣ ident_type é */
    for (i = save_index; i < ident->c_link.elem_num; i++) {
        link = &ident->c_link.elem[i];
        if (link->rel->db_key != -1 &&
            spdGetClassId(relation_db[link->rel->db_key].Rel_id)
            == SPD_RID_IDENT_TYPE) {
            res.rel = link->rel;            /* ident_type Υݥ󥿤¸ */
            obj_csr = link->obj;            /*  object */
            /* type_st 򤿤ɤäƺǿ type  */
            do {
                if ((obj_tmp = search_object_by_rel(obj_csr,
                                                    SPD_RID_TYPE_ST, C_ID))
                    != NULL) {
                    obj_csr = obj_tmp;
                }
            } while (obj_tmp);
            res.type = object_db[obj_csr->db_key].ivalue[SPD_AID_TYPE_TYPE];
            save_index = i + 1;             /*  link Υǥå¸ */
            return res;
        }
    }
    res.type = SPD_NON_ID;
    res.rel = NULL;
    return res;
}

/*
 * ʣϢ"ident_type"롥
 */

static void optimize_ident_type(void)
{
    RealTypeField org_real_type, real_type;
    SpdSet        ident_set;
    MyObject      *ident;
    int           i, dummy;

    /* ٤Ƥ identifier ֥Ȥ */
    ident_set = class_object_set[class_index(SPD_CID_IDENTIFIER)];

    for (i = 0; i < ident_set->elemNum; i++) {
        ident = spdGetAElem(ident_set, &dummy);
        if (ident->db_key == -1)
            continue;                       /* ֥ */
        org_real_type.type = SPD_NON_ID;

        while ((real_type = get_real_type(ident)).type != SPD_NON_ID) {
            if (org_real_type.type == SPD_NON_ID) {
                org_real_type = real_type;
                /* 2İʾ ident_type Ȥɤä */
            } else if (real_type.type != TYPE_INT &&
                       org_real_type.type < real_type.type) {
                org_real_type.rel->db_key = -1; /* ident_type  */
                org_real_type = real_type;
            } else {
                real_type.rel->db_key = -1; /* ident_type  */
            }
        }
    }
}

/******************************************************************************/

/* 
 * Optimize file.
 */

/*
 * ʣե륪֥Ȥ롥
 */

void optimize_file(void)
{
    SpdId      id;
    SpdSet     file_set, modify_set;
    MyObject   *obj;
    int        i, dummy;
    CheckTable *check_table;

    modify_set = spdCreateSet(sizeof(ModifyField)); /* id Τν */
    file_set = class_object_set[class_index(SPD_CID_FILE)];
    check_table = create_obj_check_table(file_set->elemNum, SPD_CID_FILE);

    for (i = 0; i < file_set->elemNum; i++) {
        obj = spdGetAElem(file_set, &dummy);
        if (obj->db_key == -1)
            continue;

        id = lookup_obj_check_table(check_table, obj->db_key);
        if (id != SPD_NON_ID) {
            /* ¸ߤ */
            /* ơ֥ɲäƺ */
            push_modification_table(modify_set,
                                    object_db[obj->db_key].Obj_id, id);
            obj->db_key = -1;
        } else {
            /* ޤ¸ߤƤʤ */
            add_to_obj_check_table(check_table, obj->db_key);
        }
    }
    free_obj_check_table(check_table);

#ifdef SPD_MERGE_SDB
    /* Added by H.Ohhashi 1999/06/30. */
    modify_src_table(modify_set);
#endif /* SPD_MERGE_SDB */

    modify_id(SPD_CID_FILE, modify_set);
    spdFreeSet(modify_set);
}

/******************************************************************************/

/* 
 * Optimize decl.
 */

static SpdSet
make_extend_attr_of_decl(void)
{
    SpdSet    decl_ext_attr_set, decl_set;
    MyObject  *decl;
    DeclField extend_attr;
    Link      *link;
    int       i, j, dummy;

    decl_ext_attr_set = spdCreateSet(sizeof(DeclField));
    decl_set = class_object_set[class_index(SPD_CID_DECLARATION)];
    for (i = 0; i < decl_set->elemNum; i++) {
        decl = spdGetAElem(decl_set, &dummy);
        if (decl->db_key == -1)
            continue;
        for (j = 0; j < decl->p_link.elem_num; j++) {
            link = &decl->p_link.elem[j];
            if (link->rel->db_key != -1 &&
                spdGetClassId(relation_db[link->rel->db_key].Rel_id)
                == SPD_RID_FILE_DECL) {
                extend_attr.obj = decl;
                extend_attr.rel = link->rel;
                extend_attr.offset = relation_db[link->rel->db_key].Rel_offset;
                extend_attr.length =
                    object_db[decl->db_key].ivalue[SPD_AID_DECLARATION_LENGTH];
                extend_attr.file_id =
                    /* 
                     * ֥Ȥʪ¸ߥեõ̤
                     * search_physical_file_id(file_ptr, extend_attr.offset);
                     */
                    1;

                spdAddElem(decl_ext_attr_set,
                           object_db[decl->db_key].Obj_id, &extend_attr);
                break;
            }
        }
    }
    return decl_ext_attr_set;
}

#ifdef SDBLINK_LINK_SORT

/* 
 * 2ĤlinkμΤ°ͤӤ롥
 */

static int
comp_obj_attrs(Link *link1, Link *link2)
{
    SpdClassId objClassId1, objClassId2;
    SpdClassId relClassId1, relClassId2;
    SpdDBObj *db_obj1, *db_obj2;
    int i, ret;

    relClassId1 = spdGetClassId(relation_db[link1->rel->db_key].Rel_id);
    relClassId2 = spdGetClassId(relation_db[link2->rel->db_key].Rel_id);

    if (relClassId1 != relClassId2) {
        return relClassId1 - relClassId2;
    }

    /* 
     * Ʊ relation 饹ä顤Ʊ object 饹
     * Ǥ뤳Ȥݾڤ? ΥɤϾĹ?
     */

    db_obj1 = &object_db[link1->obj->db_key];
    db_obj2 = &object_db[link2->obj->db_key];

    objClassId1 = spdGetClassId(db_obj1->Obj_id);
    objClassId2 = spdGetClassId(db_obj2->Obj_id);

    if (objClassId1 != objClassId2) {
        return objClassId1 - objClassId2;
    } else {

        /* int ° */
        if ((ret = memcmp(&(db_obj1->ivalue[1]), &(db_obj2->ivalue[1]),
                          sizeof(int) * class_table[objClassId1].max_iattr)) != 0) {
            return ret;
        }

        /* string ° */
        for (i = 0; i <= class_table[objClassId1].max_sattr; i++) {
            if ((ret = strcmp(db_obj1->svalue[i], db_obj2->svalue[i])) != 0) {
                return ret;
            }
        }
    }
    return 0;
}

#endif /* SDBLINK_LINK_SORT */

/*
 * ĥ꡼ƱΤ(ƱȽꤷȤ TRUE, Ƶ)
 */

static int
comp_tree(MyObject *obj1, MyObject *obj2, SpdSet del_set, int *del_id)
{
    int         i, j;  
    DeleteField del_elem;
    SpdClassId  class_id_1, class_id_2;

#ifdef SDBLINK_NEW_COMP_TREE
    SpdBoolean *isChecked;                  /* link ĴѤɤɽ */
    SpdBoolean find;
#endif /* SDBLINK_NEW_COMP_TREE */

    /* 
     * ƤӽФ¦ǡƱ쥯饹ݾڤƤΤǡɬ 
     * class_id_1 == class_id_2 Ǥ뤬Τ˻ĤƤ
     *  class_id_1 ٤Ȥ롥
     */
    class_id_1 = spdGetClassId(object_db[obj1->db_key].Obj_id);
    class_id_2 = spdGetClassId(object_db[obj2->db_key].Obj_id);
    if (class_id_1 != class_id_2) {
        return FALSE;
    }

    if (obj1->db_key == obj2->db_key) {
        return TRUE;
    }

    if (!is_identical_db_obj(&object_db[obj1->db_key],
                             &object_db[obj2->db_key], class_id_1)) {
        return FALSE;
    }
 
#ifdef SDBLINK_LINK_SORT

    /* 
     * ڤӤ c_link link  object °ͤ
     * Ȥ롥
     */
    SPD_QSORT((obj1->c_link).elem, (obj1->c_link).elem_num,
                sizeof(Link), comp_obj_attrs); 
    SPD_QSORT((obj2->c_link).elem, (obj2->c_link).elem_num,
                sizeof(Link), comp_obj_attrs);   

#endif /* SDBLINK_LINK_SORT */

#ifdef SDBLINK_NEW_COMP_TREE

    /* 
     * 르ꥺγ   R.Miura 1998/12/19.
     * () c_link éȤϡѤδϢ link ̵ǤȤФ
     * 
     * for (obj1  c_link 1Ĥ) {
     *     find = FALSE;
     *     for (obj2  c_link 1Ĥ) {
     *         if (å || link ĴϢƱ쥯饹Ǥʤ) continue;
     *         if (link  obj ƱΤ(comp_tree) == TRUE) {
     *             find = TRUE;
     *             åѤˤ;
     *             obj2 δϢ褦;
     *             break;
     *         }
     *     }
     *     if (find == FALSE) {
     *         return FALSE;
     *     }
     * }
     * 
     * for (obj2  c_link 1Ĥ) {
     *     if (åƤʤ link ) {
     *         return FALSE:
     *     }
     * }
     * 
     * obj2 褦;
     * return TRUE;
     */

    /* obj2  c_link Ѥ˥åơ֥ݡ */
    isChecked = spdMalloc(sizeof(SpdBoolean) * obj2->c_link.elem_num);
    for (j = 0; j < obj2->c_link.elem_num; j++) {
        isChecked[j] = FALSE;
    }

    /* obj1  c_link é */
    for (i = 0; i < obj1->c_link.elem_num; i++) {
        if (obj1->c_link.elem[i].rel->db_key == -1) {
            continue;
        }
        find = FALSE;

        /* obj2  c_link é */
        for (j = 0; j < obj2->c_link.elem_num; j++) {
            if (obj2->c_link.elem[j].rel->db_key == -1 ||
                isChecked[j] || 
                spdGetClassId(relation_db[obj1->c_link.elem[i].
                                          rel->db_key].Rel_id) !=
                spdGetClassId(relation_db[obj2->c_link.elem[j].
                                          rel->db_key].Rel_id)) {
                /*  or å or ϢƱ쥯饹Ǥʤ */
                continue;
            }
            /* c_link  obj  */
            if (comp_tree(obj1->c_link.elem[i].obj,
                          obj2->c_link.elem[j].obj, del_set, del_id) == TRUE) {
                find = TRUE;
                /* åѤˤ */
                isChecked[j] = TRUE;
                /* c_link λĴϢ褦 */
                del_elem.obj = NULL;
                del_elem.alt_obj = NULL;
                del_elem.rel = obj2->c_link.elem[j].rel;
                spdAddElem(del_set, ++(*del_id), &del_elem);
                break;
            }
        }
        if (find == FALSE) {
            /* obj2  c_link 椫ƱΤȯǤʤä */
            spdFree(isChecked);
            return FALSE;
        }
    }

    /* obj1 (⤦) c_link ʤ */
    for (j = 0; j < obj2->c_link.elem_num; j++) {
        if (obj2->c_link.elem[j].rel->db_key != -1 &&
            !isChecked[j]) {
            /* obj2 (ޤ) c_link  */
            spdFree(isChecked);
            return FALSE;
        }
    }

    /* obj2 (⤦) c_link ʤ */
    /*obj2 褦 */
    del_elem.obj = obj2;
    del_elem.alt_obj = obj1;
    del_elem.rel = NULL;
    spdAddElem(del_set, ++(*del_id), &del_elem);
    spdFree(isChecked);
    return TRUE;

#else  /* not SDBLINK_NEW_COMP */

    for (i = 0, j = 0; ; i++, j++) {
        if (i == obj1->c_link.elem_num && j == obj2->c_link.elem_num) { 
            del_elem.obj = obj2;
            del_elem.alt_obj = obj1;
            del_elem.rel = NULL;
            spdAddElem(del_set, ++(*del_id), &del_elem);
            return TRUE;
        } else if (i == obj1->c_link.elem_num || j == obj2->c_link.elem_num) {
            return FALSE;
        } else if (obj1->c_link.elem[i].rel->db_key == -1 &&
                   obj2->c_link.elem[j].rel->db_key == -1) {
            del_elem.obj = obj2;
            del_elem.alt_obj = obj1;
            del_elem.rel = NULL;
            spdAddElem(del_set, ++(*del_id), &del_elem);
            return TRUE;
        } else if (obj1->c_link.elem[i].rel->db_key == -1 ||
                   obj2->c_link.elem[j].rel->db_key == -1) {
            return FALSE;
        } else if (spdGetClassId(relation_db[obj1->c_link.elem[i].
                                             rel->db_key].Rel_id) !=
                   spdGetClassId(relation_db[obj2->c_link.elem[j].
                                             rel->db_key].Rel_id)) {
            return FALSE;
        } else {
            del_elem.obj = NULL;
            del_elem.alt_obj = NULL;
            del_elem.rel = obj2->c_link.elem[j].rel;
            spdAddElem(del_set, ++(*del_id), &del_elem);
            if (comp_tree(obj1->c_link.elem[i].obj, 
                          obj2->c_link.elem[j].obj, del_set, del_id) == FALSE)
                return FALSE;
        }
    }

#endif /* not SDBLINK_NEW_COMP_TREE */
}

/* 
 * ֥Ⱥȼ졼ĥؤԤ
 */

static void
alt_relation(MyObject *old_obj, MyObject *new_obj)
{
    Link *link, *link2;
    int  i, j;

    for (i = 0; i < old_obj->p_link.elem_num; i++) {
        link = &old_obj->p_link.elem[i];
        if (link->rel->db_key == -1)
            continue;
        for (j = 0; j < link->obj->c_link.elem_num; j++) {
            link2 = &link->obj->c_link.elem[j];
            if (link2->rel->db_key == -1 || link2->obj != old_obj)
                continue;
            /*
             * link->obj->c_link.elem[j]  old_obj ȤΥ졼
             * new_obj ȤΥ졼ĥؤ롥
             */
            link2->obj = new_obj;
            relation_db[link2->rel->db_key].Rel_c_id
                = object_db[new_obj->db_key].Obj_id;
            /*
             * new_obj->plink  link->obj ؤΥ졼ɲä롥
             */
            add_new_link(&(new_obj->p_link), link->obj, link->rel);
        }
    }
}

/* 
 * ˽äƥĥ꡼롥
 */

static void
del_tree(SpdSet del_set)
{
    int         i, dummy;
    DeleteField *del_csr;

    for (i = 0; i < del_set->elemNum; i++) {
        del_csr = spdGetAElem(del_set, &dummy);
        if (del_csr->obj != NULL) {         /* 饹֥Ȥκ */
            if (del_csr->obj->db_key == -1)
                continue;
            alt_relation(del_csr->obj, del_csr->alt_obj);
            del_csr->obj->db_key = -1;
        } else {                            /* 졼󥪥֥Ȥκ */
            del_csr->rel->db_key = -1;
        }
    }
}

/* 
 * ХեåͤΥå(Ƶ)
 */

static void
modify_offset(MyObject *obj, int decl_offset)
{
    Link *link;
    int  i;

    if (obj->db_key == -1)
        return;
    for (i = 0; i < obj->c_link.elem_num; i++) {
        link = &obj->c_link.elem[i];
        if (link->rel->db_key == -1)
            continue;
        if (link->rel->flag == FALSE &&
            relation_db[link->rel->db_key].Rel_offset != SPD_NON_ID) {
            relation_db[link->rel->db_key].Rel_offset = 
                relation_db[link->rel->db_key].Rel_offset - decl_offset;
            link->rel->flag = TRUE;
        }
        if (class_table[spdGetClassId(relation_db[link->rel->db_key].Rel_id)].typ
            & C_TYP_CMP) {
            modify_offset(link->obj, decl_offset);
        }
    }
}

#ifndef SPD_MERGE_SDB

/* 
 * ٤Ƥdeclarationĥ꡼ХեåȤ˽񤭴롥
 */

static void
set_relative_offset(SpdSet decl_set)
{
    int       i, dummy;
    DeclField *decl;

    for (i = 0; i < decl_set->elemNum; i++) {
        decl = spdGetAElem(decl_set, &dummy);
        if (decl->obj == NULL)
            continue;
        modify_offset(decl->obj, decl->offset);
    }
}

#endif /* not SPD_MERGE_SDB */

/* 
 * Ӵؿ
 */

static int
array_compare(DeclField *decl1, DeclField *decl2)
{
    return (object_db[decl1->obj->db_key].Obj_id -
            object_db[decl2->obj->db_key].Obj_id);
}

/* 
 * declarationκŬ
 */

static void
optimize_decl(int optimize_level)
{
    SpdSet    decl_attr_set, del_set;
    DeclField *decl_array;
    int       array_size;
    int       i, j, del_id;

    decl_attr_set = make_extend_attr_of_decl();
    array_size = decl_attr_set->elemNum;
    decl_array =(DeclField *)spdGetArrayOfElem(decl_attr_set);

    SPD_QSORT((void *)decl_array, array_size, sizeof(DeclField),
                (int(*)(const void*, const void*))array_compare);

    for (i = 0; i < array_size - 1; i++) {
        if (decl_array[i].obj == NULL)
            continue;

        if (object_db[decl_array[i].obj->db_key].ivalue[SPD_AID_DECLARATION_STORAGE] == STORAGE_STATIC)
            continue;

        for (j = i + 1; j < array_size; j++) {
            if (i == j ||
                decl_array[j].obj == NULL ||
                decl_array[i].file_id != decl_array[j].file_id ||
                decl_array[i].length != decl_array[j].length)
                continue;

            if (object_db[decl_array[i].obj->db_key].ivalue[SPD_AID_DECLARATION_STORAGE] == STORAGE_STATIC)
                continue;

            del_id = 0;
            del_set = spdCreateSet(sizeof(DeleteField));
        
            if (comp_tree(decl_array[i].obj, decl_array[j].obj,
                          del_set, &del_id) == TRUE) {
                /* declaration ĥ꡼κ */
                del_tree(del_set);
                /* declaration ĥ꡼礫 */
                decl_array[j].obj = NULL;
            }
            spdFreeSet(del_set);
        }
    }
    spdFree(decl_array);

#ifndef SPD_MERGE_SDB
    /* SDBޡХեåȲϤʤ */
    if (optimize_level >= 3) {
        spdMessage("Making relative offset.\n");
        set_relative_offset(decl_attr_set);
    }
#endif /* SPD_MERGE_SDB */

    spdFreeSet(decl_attr_set);
}

/******************************************************************************/

/* 
 * Optimize type.
 */

/*
 * ܷι
 */

static void
optimize_type(void)
{
    SpdId      id;
    SpdSet     type_set, modify_set;
    MyObject   *obj;
    int        i, dummy, sort;
    CheckTable *check_table;

    modify_set = spdCreateSet(sizeof(ModifyField)); /* id Τν */
    type_set = class_object_set[class_index(SPD_CID_TYPE)];
    check_table = create_obj_check_table(type_set->elemNum, SPD_CID_TYPE);

    for (i = 0; i < type_set->elemNum; i++) {
        obj = spdGetAElem(type_set, &dummy);
        if (obj->db_key == -1)
            continue;

        sort = object_db[obj->db_key].ivalue[SPD_AID_TYPE_SORT];
        if (sort != TYPE_DECLARATION)
            continue;

        /* TYPE_DECLARATION  type Ф */
        id = lookup_obj_check_table(check_table, obj->db_key);
        if (id != SPD_NON_ID) {
            /* Ǥ¸ߤ */
            push_modification_table(modify_set,
                                    object_db[obj->db_key].Obj_id, id);
            obj->db_key = -1;
        } else {
            /* ޤ¸ߤʤ */
            add_to_obj_check_table(check_table, obj->db_key);
        }
    }
    free_obj_check_table(check_table);
    modify_id(SPD_CID_TYPE, modify_set);
    spdFreeSet(modify_set);
}

/******************************************************************************/

/*
 * Ŭȥå״ؿ
 */

void
optimizer(int optimize_level)
{
    make_relations();

    /* Optimize. */
    spdMessage("Optimizing.\n");
    optimize_ident_type();

    /* 
     * Removed by N.Fukuyasu 1999/08/27.
     * sdblink ξ: file ֥Ȥ pidb Τ optimize ʤ
     */
#ifdef SPD_MERGE_SDB
    optimize_file();
#endif

    if (2 <= optimize_level) {
        optimize_decl(optimize_level);
    }
    optimize_type();

    /* clear_relations(); */
}
