/* 
 * Program:             $RCSfile: link_ISDB.c,v $  $Revision: 40.3 $
 * 
 * Purpose:             
 * 
 * Author:              N.Fukuyasu  2003/04/01
 *                      S.Yamamoto  2003/04/01        
 * 
 * (C) Copyright:       N.Fukuyasu and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: link_ISDB.c,v 40.3 2003/06/28 15:32:19 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "linklib.h"
#include "sdblink5.h"

/* 
 * count_ISDB_objs():
 *   饹ȤΥ֥/Ϣ롥
 *   I-modelΤprogram, file, prog_fileISDBˤϴޤޤʤ
 *   ϤˤɬפʤΤǸ̤˽򤷤Ƥ롥
 */

void count_ISDB_objs(int file_num, SpdObjId file_id[])
{
  SpdInfo *info;
  int i;

  for (i = 0; i < file_num; i++) {
    info = spdOpenISDBinfo(file_id[i]);
    count_objects_num(info, SPD_MID_I_MODEL);
    spdCloseInfo(info);
  }

  /* program object */
  add_class_obj_num(SPD_CID_PROGRAM, 1);

  /* file objects */
  info = spdOpenSDBinfo();
  add_class_obj_num(SPD_CID_FILE,
            get_info_num_of_objs_by_cid(info, SPD_CID_FILE));
  spdCloseInfo(info);

  /* prog_file relations */
  add_class_obj_num(SPD_RID_PROG_FILE, file_num);
}

/*
 * load_ISDB():
 *   1ĤISDBɤ߹ࡥ
 */

void load_ISDB(SpdObjId file_id)
{
  SpdInfo *info;
  FILE *fp;
  MergePair merge_pair;
  /* DBmergeݤIDuniqueˤ뤿Υեåȡ */
  int id_offset[SPD_LAST_CID_I_MODEL + 1];
  /* ƥ饹ȤκID(1ɤ߹ऴȤ˹) */
  static SpdObjId max_id[SPD_LAST_CID_I_MODEL + 1];
  static SpdBoolean is_first_file = TRUE;

  if (is_first_file) {
    initialize_max_id(max_id, SPD_MID_I_MODEL);
    is_first_file = FALSE;
  }

  initialize_id_offset(id_offset, max_id, SPD_MID_I_MODEL);

  /*
   * 1ĤDBɤ߹ࡥ
   * ֥Ȥ򤹤٤ɤ߹ǴϢ򤹤٤ɤ߹ࡥ
   */
  info = spdOpenISDBinfo(file_id);

  set_read_sdb_format(info);

  fp = spdOpenISDB(file_id, SAPID_O_READ);
  merge_pair = create_merge_pair();

  read_objects(fp, info, SPD_MID_I_MODEL, merge_pair, id_offset, max_id);
  read_relations(fp, info, SPD_MID_I_MODEL, merge_pair, id_offset);

  release_merge_pair(merge_pair);
  spdFclose(fp);

  spdCloseInfo(info);
}

static void write_SDB_info(SpdInfo *info);

/*
 * make_a_program_object():
 *   program֥Ȥ롥
 */

SpdObjId make_a_program_object(SpdConstString prog_name)
{
  SpdId prog_id = SPD_OBJ_ID_OFFSET(SPD_CID_PROGRAM);
  SpdDBObj db_obj;

  db_obj.Obj_id = prog_id;
  db_obj.svalue[SPD_AID_PROGRAM_NAME - SpdObjIValN] = spdStrdup(prog_name);
  add_new_object(SPD_CID_PROGRAM, db_obj);

  return prog_id;
}

/*
 * read_file_objects_Imodel():
 *   SDB(I-model)file饹Υ֥Ȥ򤹤٤ɤ߹ࡥ
 */

void read_file_objects_Imodel(void)
{
  FILE *fp;
  SpdDBObj db_obj;
  SpdInfo *info;
  SpdConstString binary_format;
  SpdConstString class_name;
  int file_obj_num;

  info = spdOpenSDBinfo();
  binary_format = spdGetInfoString(info, "BINARY_FORMAT_SDB");
  spdSetReadSDBformat(SPD_STREQ(binary_format, "TRUE") ?
              SAPID_BINARY_FORMAT_SDB : SAPID_TEXT_FORMAT_SDB);
  file_obj_num = get_info_num_of_objs_by_cid(info, SPD_CID_FILE);
  spdCloseInfo(info);
  class_name = spdGetClassNameById(SPD_CID_FILE);
  fp = spdOpenSDBfile(I_MODEL_DIR, class_name, SAPID_O_READ);
  /* load_class()ü첽ɤ߹ߡ */
  while (file_obj_num--) {
    db_obj = spdReadObj(fp, SPD_CID_FILE);
    add_new_object(SPD_CID_FILE, db_obj);
  }
  spdFclose(fp);
}

/*
 * make_prog_file():
 *   prog_idfile_idϢprog_file롥
 */

void make_prog_file(SpdObjId prog_id, SpdObjId file_id)
{
  static SpdRelId id = SPD_OBJ_ID_OFFSET(SPD_RID_PROG_FILE);
  SpdDBRel db_rel;

  db_rel.Rel_id = id++;
  db_rel.Rel_p_id = prog_id;
  db_rel.Rel_c_id = file_id;
  add_new_relation(SPD_RID_PROG_FILE, db_rel);
}

/*
 * write_SDB_info():
 *   SDBϤˡinfoեϤ롥
 */

static void write_SDB_info(SpdInfo *info)
{
  int level = get_optimize_level();

  spdSetInfoString(info, "BINARY_FORMAT_SDB",
           (spdGetWriteSDBformat() == SAPID_BINARY_FORMAT_SDB ?
            "TRUE" : "FALSE"));

  spdSetInfoInt(info, "OPTIMIZE_LEVEL", level);
  spdSetInfoString(info, "SHARED_DECLARATION", (level < 2 ? "FALSE" : "TRUE"));
  spdSetInfoString(info, "RELATIVE_OFFSET", (level < 3 ? "FALSE" : "TRUE"));
}

/*
 * write_Imodel():
 *   write_Imodel_objects(), write_Imodel_relations()ƤӽФơ
 *   ImodelSDBˤ٤ƽϤinfo롥
 */

void write_Imodel(void)
{
  SpdInfo *info;

  info = spdOpenSDBinfo();

  write_SDB_info(info);

  write_objects(info, SPD_MID_I_MODEL);
  write_relations(info, SPD_MID_I_MODEL);

  spdCloseInfo(info);
}
