/* 
 * Program:             $RCSfile: link_util.c,v $  $Revision: 40.3 $
 * 
 * Purpose:             
 * 
 * Author:              N.Fukuyasu  2003/04/01
 *                      S.Yamamoto  2003/04/01        
 * 
 * (C) Copyright:       N.Fukuyasu and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: link_util.c,v 40.3 2003/06/28 15:32:20 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "linklib.h"

/*
 * get_info_num_of_objs_by_cid():
 *   infocidΥ饹Υ֥ȤθĿ롥
 */

int get_info_num_of_objs_by_cid(SpdInfo *info, SpdClassId cid)
{
  SpdConstString class_name;
  int num;

  class_name = spdGetClassNameById(cid);
  num = spdGetInfoNumOfObjs(info, class_name);

  return num;
}

/*
 * set_read_sdb_format():
 *   ɤ߹ݤSDBΥեޥåȤinfoꤹ롥
 */

void set_read_sdb_format(SpdInfo *info)
{
  SpdConstString binary_format;

  binary_format = spdGetInfoString(info, "BINARY_FORMAT_SDB");
  spdSetReadSDBformat(SPD_STREQ(binary_format, "TRUE") ?
              SAPID_BINARY_FORMAT_SDB : SAPID_TEXT_FORMAT_SDB);
}

/**********************************************************************/

/*
 * is_identical_object():
 *   obj1obj2ˤĤIDʳ°ɤ򸡺롥
 */

SpdBoolean is_identical_object(SpdDBObj *obj1, SpdDBObj *obj2)
{
  SpdClassId cid;
  int i;

  cid = spdGetClassId(obj1->Obj_id);

  if (class_table[cid].max_iattr > 0) {
    if (memcmp(&obj1->ivalue[1], &obj2->ivalue[1],
           sizeof(int) * class_table[cid].max_iattr) != 0) {
      return FALSE;
    }
  }

  for (i = 0; i <= class_table[cid].max_sattr; i++) {
    if (!SPD_STREQ(obj1->svalue[i], obj2->svalue[i])) {
      return FALSE;
    }
  }

  return TRUE;
}
