/* 
 * Program:             $RCSfile: linklib.h,v $  $Revision: 40.2 $
 * 
 * Purpose:             
 * 
 * Author:              N.Fukuyasu  2003/04/01
 *                      S.Yamamoto  2003/04/01        
 * 
 * (C) Copyright:       N.Fukuyasu and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

#ifndef _LINK_LIB_H
#define _LINK_LIB_H

/*
 * ǥΥ᥿롥
 */

#define getParentClassId(cid) (class_table[cid].rel_class1)
#define getChildClassId(cid)  (class_table[cid].rel_class2)

#define isCompRel(cid) \
        (spdIsValidRelationId(cid) && (class_table[cid].typ & C_TYP_CMP))

#define Ident_name    svalue[SPD_AID_IDENTIFIER_NAME - SpdObjIValN]

/* link_util.c */

int get_info_num_of_objs_by_cid(SpdInfo *info, SpdClassId cid);
void set_read_sdb_format(SpdInfo *info);
SpdBoolean is_identical_object(SpdDBObj *obj1, SpdDBObj *obj2);

/**********************************************************************/

/* merge_pair.c */

/*
 * ֥Ȥбɽ
 */

typedef SpdSet MergePair;

MergePair create_merge_pair(void);
void release_merge_pair(MergePair pair);
void add_merge_pair(MergePair pair, SpdObjId src_id, SpdObjId dst_id);
void union_merge_pair(MergePair dst, MergePair src);
SpdObjId search_merge_pair(MergePair pair, SpdObjId src_id);
SpdObjId search_merge_pair_recursive(MergePair pair, SpdObjId src_id);

/* object_db.c */

void add_class_obj_num(SpdClassId cid, int num);

/*
 * SearchObjFunc:
 *   ʥ֥Ȥ򸡺뤿δؿ(ɤ߹߻̾󤻤˻)
 */

typedef SpdObjId (*SearchObjFunc)(SpdDBObj obj, SpdObjId old_id);

/*
 * SearchRelFunc:
 *   ʴϢ򸡺뤿δؿ(ɤ߹߻̾󤻤˻)
 */

typedef SpdBoolean (*SearchRelFunc)(SpdDBRel rel, MergePair merge_pair);

void initialize_search_functions(void);
void set_search_obj_function(SpdClassId cid, SearchObjFunc func);
void set_search_rel_function(SpdClassId cid, SearchRelFunc func);

void allocate_db(void);
void release_db(void);
void add_new_object(SpdClassId cid, SpdDBObj obj);
void add_new_relation(SpdClassId cid, SpdDBRel rel);
void delete_object(SpdClassId cid, MergePair merge_pair);
void delete_all_class_object(MergePair merge_pair);
void delete_relation(SpdClassId cid, MergePair merge_pair);
void delete_all_class_relation(MergePair merge_pair);
void modify_relation(SpdClassId cid, MergePair merge_pair);
void modify_all_relation(MergePair merge_pair);

SpdObjId load_class(SpdClassId cid, FILE *fp, SpdInfo *info, MergePair merge_pair, int id_offset);
void load_relation(SpdClassId cid, FILE *fp, SpdInfo *info, MergePair merge_pair, int id_offset[]);

void count_objects_num(SpdInfo *info, SpdModelId mid);
void initialize_max_id(SpdObjId max_id[], SpdModelId mid);
void initialize_id_offset(int id_offset[], SpdObjId max_id[], SpdModelId mid);

void read_objects(FILE *fp, SpdInfo *info, SpdModelId mid, MergePair merge_pair, int id_offset[], SpdObjId max_id[]);
void read_relations(FILE *fp, SpdInfo *info, SpdModelId mid, MergePair merge_pair, SpdObjId id_offset[]);

void write_objects(SpdInfo *info, SpdModelId mid);
void write_relations(SpdInfo *info, SpdModelId mid);

#endif /* _LINK_LIB_H */
