/* 
 * Program:             $RCSfile: merge_pair.c,v $  $Revision: 40.2 $
 * 
 * Purpose:             
 * 
 * Author:              N.Fukuyasu  2003/04/01
 *                      S.Yamamoto  2003/04/01        
 * 
 * (C) Copyright:       N.Fukuyasu and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: merge_pair.c,v 40.2 2003/04/01 09:03:25 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "linklib.h"

typedef struct _object_pair {
  SpdObjId obj_id1;
  SpdObjId obj_id2;
} ObjectPair;

/* ֥̾ѥơ֥ؿ */

/*
 * create_merge_pair(), release_merge_pair():
 *   ֥Ȥ̾󤻤κݤФˤʤ륪֥Ȥ뤿
 *   /롥
 */

MergePair create_merge_pair(void)
{
  SpdSet pair;

  pair = spdCreateSet(sizeof(ObjectPair));

  return (MergePair)pair;
}

void release_merge_pair(MergePair pair)
{
  if (pair != NULL) {
    spdFreeSet(pair);
  }
}

/*
 * add_merge_pair():
 *   MergePair˥֥ȤФɲä롥
 *   src_iddst_id̾󤻤롥
 */

void add_merge_pair(MergePair pair, SpdObjId src_id, SpdObjId dst_id)
{
  ObjectPair obj_pair;

  obj_pair.obj_id1 = src_id;
  obj_pair.obj_id2 = dst_id;
  spdAddElem((SpdSet)pair, src_id, &obj_pair);
}

/*
 * union_merge_pair():
 *   MergePair¤롥(dstsrcɲä롥)
 */

void union_merge_pair(MergePair dst, MergePair src)
{
  int i;
  int key;
  ObjectPair *obj_pair_p;

  for (i = 0; i < src->elemNum; i++) {
    obj_pair_p = (ObjectPair *)spdGetAElem(src, &key);
    /* add_merge_pair(dst, obj_pair_p->obj_id1, obj_pair_p->obj_id2); */
    spdAddElem(dst, key, obj_pair_p);
  }
}

/*
 * search_merge_pair():
 *   MergePairsrc_idϿƤ뤫ɤǧ롥
 *   ĤʤSPD_NON_ID֤
 *   Фˤʤ륪֥Ȥ򸡺ˤϡsearch_merge_pair_recursive()
 *   Ѥ롥
 */

SpdObjId search_merge_pair(MergePair pair, SpdObjId src_id)
{
  ObjectPair *obj_pair = NULL;

  if (pair != NULL) {
    obj_pair = spdSearchElem(pair, src_id);
  }

  return (obj_pair == NULL ? SPD_NON_ID : obj_pair->obj_id2);
}

/*
 * search_merge_pair_recursive():
 *   MergePairsrc_idФˤʤ륪֥Id򸡺롥
 *   Фˤʤ륪֥Ȥ˥ޡƤǽΤǡ
 *   ƵŪõ롥
 *   ¸ߤʤSPD_NON_ID֤
 */

SpdObjId search_merge_pair_recursive(MergePair pair, SpdObjId src_id)
{
  SpdObjId dst_id = SPD_NON_ID;

  while ((src_id = search_merge_pair(pair, src_id)) != SPD_NON_ID) {
    dst_id = src_id;
  }

  return dst_id;
}
