/* 
 * Program:             $RCSfile: relation_table.c,v $  $Revision: 40.2 $
 * 
 * Purpose:             
 * 
 * Author:              N.Fukuyasu  2003/04/01
 *                      S.Yamamoto  2003/04/01        
 * 
 * (C) Copyright:       N.Fukuyasu and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: relation_table.c,v 40.2 2003/04/01 09:03:28 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "linklib.h"
#include "sdbmerge.h"

#define RELATION_TABLE_BASE    32

RelTable add_relation_element(RelTable table, SpdObjId pobj, SpdObjId cobj)
{
  if (table.size <= table.num) {
    table.size += RELATION_TABLE_BASE;
    table.element = spdRealloc(table.element,
                   sizeof(RelTableElement) * table.size);
  }
  table.element[table.num].pobj_id = pobj;
  table.element[table.num].cobj_id = cobj;
  table.num++;

  return table;
}

RelTable release_relation_table(RelTable table)
{
  if (table.element != NULL) {
    spdFree(table.element);
  }
  table.element = NULL;
  table.size = 0;
  table.num = 0;

  return table;
}

int get_relation_table_num(RelTable table)
{
  return table.num;
}

SpdObjId get_relation_table_pobj_id(RelTable table, int i)
{
  return (0 <= i && i < table.num ? table.element[i].pobj_id : SPD_NON_ID);
}

SpdObjId get_relation_table_cobj_id(RelTable table, int i)
{
  return (0 <= i && i < table.num ? table.element[i].cobj_id : SPD_NON_ID);
}
