/*
 * Program:             $RCSfile: sdblink4c.c,v $  $Revision: 31.41 $
 *
 * Purpose:
 *
 * Author:              S.Kawai  1995/10/01
 *                      S.Yamamoto  1996/06/02
 * Modified:            R.Miura  1998/07/05
 *
 * (C) Copyright:       S.Kawai, R.Miura and S.Yamamoto  1995 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: sdblink4c.c,v 31.41 2003/08/10 14:14:45 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/write_sdb_sub.h>
#include "ISDB.h"
#include "sdblink4c.h"

#ifdef SPD_MERGE_SDB
#define OPTIONS             "bd:D:lo:O:s:"
#else
#define OPTIONS             "bd:o:O:"
#endif

/*
 * 饹ӴϢǼѤѿ
 * ΤSpdSet󡤴ϢRelationȤƼƤ롥
 *
 * ʤǡ¤ۤʤ(S.Yamamoto 1999/04/04)?
 * ΤϡľܻȤ뤳Ȥ¿?
 */
SpdSet          class_object_set[SDBLINK_CLASS_NUM];
RelationArray   relation_array[SDBLINK_REL_NUM];

/* ѿAR4ƱˡǴƤ롥 */
SpdDBObj    *object_db;
SpdDBRel    *relation_db;
int         object_db_n;
int         relation_db_n;
int         object_db_alloc_n = 0;
int         relation_db_alloc_n = 0; 

static SpdConstString program_name;              /* This program name. */

#ifdef SPD_MERGE_SDB
char        *script_name ="cp_src.sh";  /* Shell script file name. */
char        *gl_sdb_dir = SAPID_GL_SDB_DIR;
static SpdBoolean flag_l = OFF;         /* Flag for option "-l". */
#endif /* SPD_MERGE_SDB */

/* ֥ȿΥơ֥롥 */
int         obj_and_rel_num_table[SDBLINK_CLASS_AND_REL_NUM];

/* 󥯸Υץ̾ */
static char *target_program_name = SPD_DEFAULT_TARGET_PROGRAM_NAME;

static int          optimize_level = 0; 

/*
 * Function prototypes.
 */
static void parse_option(int argc, char *argv[]);
static void printUsage(SpdConstString command_name);

#ifdef SPD_MERGE_SDB
static SpdString make_val_str(int value);
static void write_sapid_version(SpdInfo *info);
#endif

#ifdef SPD_MERGE_SDB

/*
 * objectId ν°륯饹 new_id 饹ѹ
 *  objectId ֤
 */

static SpdId moveClass(SpdId objectId, SpdClassId new_id)
{
    return (objectId - SPD_OBJ_ID_OFFSET(spdGetClassId(objectId)) +
            SPD_OBJ_ID_OFFSET(new_id));
}

#endif /* SPD_MERGE_SDB */

/******************************************************************************/

#ifdef SPD_MERGE_SDB

void load_repository_Pmodel(SpdInfo *info, int file_no)
{
    FILE            *fp;
    int             obj_num;
    int             offset1, offset2;
    SpdClassId      class_id;
    SpdId           id;

    SpdDBObj        db_obj;
    SpdDBRel        db_rel;

    /* 饹֥Ȥν */
    for (class_id = SPD_FIRST_CID_P_MODEL;
         class_id <= SPD_LAST_CID_P_MODEL; class_id++) {
        set_id_offset(file_no + 1, class_id,
                      get_id_offset(file_no, class_id) +
                      SPD_OBJ_ID_OFFSET(class_id) - 1);
        obj_num = spdGetInfoInt(info, spdGetClassNameById(class_id), 0);
        if (obj_num == 0) continue;
      
        fp = spdOpenSDBfile(P_MODEL_DIR, class_table[class_id].name,
                            SAPID_O_READ);

        while (obj_num--) {
            db_obj = spdReadObj(fp, class_id);

            if (class_id == SPD_CID_PFILE) {
                addPfileFileTbl(db_obj.Obj_id,
                                get_id_offset(file_no, class_id));
            }

            db_obj.Obj_id += get_id_offset(file_no, class_id);
            /* Ͽ */
            add_new_object(class_id, db_obj);
            set_id_offset(file_no + 1, class_id, db_obj.Obj_id);
        }
        spdFclose(fp);
    }

    /* Ϣν */
    for (class_id = SPD_FIRST_RID_P_MODEL;
         class_id <= SPD_LAST_RID_P_MODEL; class_id++) {
        id = SPD_OBJ_ID_OFFSET(class_id);
        offset1 = get_id_offset(file_no, class_table[class_id].rel_class1);
        offset2 = get_id_offset(file_no, class_table[class_id].rel_class2);

        if ((obj_num = spdGetInfoInt(info,
                                     spdGetClassNameById(class_id), 0)) == 0) {
            continue;
        }

        fp = spdOpenSDBfile(P_MODEL_DIR, class_table[class_id].name,
                            SAPID_O_READ);
        while (obj_num--) {
            /* Ϣidɤ߹߻դ롥*/
            db_rel = spdReadRel(fp, class_id, id++);
            /* id񤭴 */
            db_rel.Rel_p_id += offset1;
            db_rel.Rel_c_id += offset2;
            /* Ͽ */
            add_new_relation(class_id, db_rel);
        }
        spdFclose(fp);
    }
}

#endif /* SPD_MERGE_SDB */

/*
 * ݥȥβϤȥǡγǼ 
 */

/* !! ʬȡޤȤ뤳ȤǤʬϤޤ롥 */

static void load_repository(FILE *fp, int file_no, SpdString filename)
{
    int             obj_num, attr_id;
    int             scope, sort;
    int             offset1, offset2;
    SpdClassId      class_id;
    SpdId           id, new_id;
    SpdSet          operator_modify_set, extern_modify_set;

#ifdef SPD_MERGE_SDB
    SpdSet          program_modify_set;
#endif /* SPD_MERGE_SDB */

    SpdDBObj        db_obj;
    SpdDBRel        db_rel;
    SpdInfo         *info;
    
    /* Ѥset롥 */
#ifdef SPD_MERGE_SDB
    program_modify_set = spdCreateSet(sizeof(ModifyField));
#endif /* SPD_MERGE_SDB */
    operator_modify_set = spdCreateSet(sizeof(ModifyField));
    extern_modify_set = spdCreateSet(sizeof(ModifyField));

#ifdef SPD_MERGE_SDB
    spdSetSDBdir(filename);
    info = spdOpenSDBinfo();
#else
    info = spdOpenISDBinfo(filename);
#endif

    spdSetReadSDBformat(SPD_STREQ(spdGetInfoString(info, "BINARY_FORMAT_SDB"),
                                    "TRUE") ?
                        SAPID_BINARY_FORMAT_SDB :
                        SAPID_TEXT_FORMAT_SDB);


    /* Τν */
    /* Classes in I-model. */
    for (class_id = SPD_FIRST_CID_I_MODEL;
         class_id <= SPD_LAST_CID_I_MODEL; class_id++) {
        set_id_offset(file_no + 1, class_id,
                      get_id_offset(file_no, class_id) +
                      SPD_OBJ_ID_OFFSET(class_id) - 1);
        obj_num = spdGetInfoInt(info, spdGetClassNameById(class_id), 0);
        if (obj_num == 0) {
            continue;
        }
    
#ifdef SPD_MERGE_SDB
        fp = spdOpenSDBfile(I_MODEL_DIR, class_table[class_id].name,
                            SAPID_O_READ);
        while (obj_num--) {
            /* ꤵ줿cond˽롥 */
            db_obj = spdReadObj(fp, class_id);
            /* -l ʤ̾󤻤Ϥʤ */
            if (!flag_l) {
                switch(class_id) {
                  case SPD_CID_FILE:
                    put_src_file_id(file_no, db_obj.Obj_id,
                                    get_id_offset(file_no, class_id));
                    /* Not break. */
                  default:
                    db_obj.Obj_id += get_id_offset(file_no, class_id);
                    /* Ͽ */
                    add_new_object(class_id, db_obj);
                    set_id_offset(file_no + 1, class_id, db_obj.Obj_id);
                    break;
                }
            } else {
                switch (class_id) {
                  case SPD_CID_PROGRAM:     /**********************************/
                    if (file_no !=0) {
                        /* ץब饤֥ξ */
                        db_obj.Obj_id = moveClass(db_obj.Obj_id, SPD_CID_LIBRARY);
                        add_new_object(SPD_CID_LIBRARY, db_obj);
                    } else {
                        /* ץबץꥱξ */
                        add_new_object(class_id, db_obj);
                        set_id_offset(file_no + 1, class_id, db_obj.Obj_id);
                    }
                    break;
                  case SPD_CID_FILE:
                    put_src_file_id(file_no, db_obj.Obj_id,
                                    get_id_offset(file_no, class_id));

                    /* after here "default" case */
                    db_obj.Obj_id += get_id_offset(file_no, class_id);
                    /* Ͽ */
                    add_new_object(class_id, db_obj);
                    set_id_offset(file_no + 1, class_id, db_obj.Obj_id);
                    break;
                  case SPD_CID_OPERATOR:    /**********************************/
                    /*
                     * sizeofcastʳΥڥ졼̾󤻤롥
                     * °ͤƱȽꤹ롥
                     */
                    db_obj.Obj_id += get_id_offset(file_no, class_id);
                    sort = db_obj.ivalue[SPD_AID_OPERATOR_SORT];
                    if (sort != OP_CAST && sort != OP_SIZEOF_TYPE &&
                        (new_id = get_equal_db_obj(&db_obj, class_id)) !=
                        SPD_NON_ID) {
                        /* ¸ߤΤ̾󤻤롥 */
                        push_modification_table(operator_modify_set,
                                                db_obj.Obj_id, new_id);
                        spdFreeStrsInObj(db_obj);
                    } else {
                        /* Ͽ */
                        add_new_object(class_id, db_obj);
                    }
                    set_id_offset(file_no + 1, class_id, db_obj.Obj_id);
                    break;

                  case SPD_CID_IDENTIFIER:  /**********************************/
                    /* externΤ̾󤻤롥nameƱȽꤹ롥 */
                    db_obj.Obj_id += get_id_offset(file_no, class_id);
                    scope = db_obj.ivalue[SPD_AID_IDENTIFIER_SCOPE];
                    if (scope == ID_SCOPE_GLOBAL) {
                        attr_id = SPD_AID_IDENTIFIER_NAME;
                        new_id = get_equal_global(db_obj.svalue[attr_id - SpdObjIValN]);
                        if (new_id != SPD_NON_ID) {
                            /* ¸ߤΤ̾󤻤롥 */
                            push_modification_table(extern_modify_set,
                                                    db_obj.Obj_id, new_id);
                            spdFreeStrsInObj(db_obj);
                        } else {
                            push_global_table(db_obj.Obj_id,
                                              db_obj.svalue[attr_id - SpdObjIValN]);
                            /* Ͽ */
                            add_new_object(class_id, db_obj);                       
                        }                   
                    } else {
                        /* Ͽ */
                        add_new_object(class_id, db_obj);
                    }
                    set_id_offset(file_no + 1, class_id, db_obj.Obj_id);
                    break;
          
                  default:                  /**********************************/
                    /* case COND_CLASS: */
                    db_obj.Obj_id += get_id_offset(file_no, class_id);
                    /* Ͽ */
                    add_new_object(class_id, db_obj);
                    set_id_offset(file_no + 1, class_id, db_obj.Obj_id);
                    break;
                }
            }
        }
        spdFclose(fp);
#else
        while (obj_num--) {
            /* ꤵ줿cond˽롥 */
            db_obj = spdReadObj(fp, class_id);
            /* Note: ISDB ˤ program, file, prog_file ϽϤƤʤ */
            switch (class_id) {
              case SPD_CID_OPERATOR:        /**********************************/
                /*
                 * sizeofcastʳΥڥ졼̾󤻤롥
                 * °ͤƱȽꤹ롥
                 */
                db_obj.Obj_id += get_id_offset(file_no, class_id);
                sort = db_obj.ivalue[SPD_AID_OPERATOR_SORT];
                if (sort != OP_CAST && sort != OP_SIZEOF_TYPE &&
                    (new_id = get_equal_db_obj(&db_obj, class_id)) !=
                    SPD_NON_ID) {
                    /* ¸ߤΤ̾󤻤롥 */
                    push_modification_table(operator_modify_set,
                                            db_obj.Obj_id, new_id);
                    spdFreeStrsInObj(db_obj);
                } else {
                    /* Ͽ */
                    add_new_object(class_id, db_obj);
                }
                set_id_offset(file_no + 1, class_id, db_obj.Obj_id);
                break;

              case SPD_CID_IDENTIFIER:      /**********************************/
                /* externΤ̾󤻤롥nameƱȽꤹ롥 */
                db_obj.Obj_id += get_id_offset(file_no, class_id);
                scope = db_obj.ivalue[SPD_AID_IDENTIFIER_SCOPE];
                if (scope == ID_SCOPE_GLOBAL) {
                    attr_id = SPD_AID_IDENTIFIER_NAME;
                    new_id = get_equal_global(db_obj.svalue[attr_id - SpdObjIValN]);
                    if (new_id != SPD_NON_ID) {
                        /* ¸ߤΤ̾󤻤롥 */
                        push_modification_table(extern_modify_set,
                                                db_obj.Obj_id, new_id);
                        spdFreeStrsInObj(db_obj);
                    } else {
                        push_global_table(db_obj.Obj_id,
                                          db_obj.svalue[attr_id - SpdObjIValN]);
                        /* Ͽ */
                        add_new_object(class_id, db_obj);                       
                    }                   
                } else {
                    /* Ͽ */
                    add_new_object(class_id, db_obj);
                }
                set_id_offset(file_no + 1, class_id, db_obj.Obj_id);
                break;

              default:                      /**********************************/
                /* case COND_CLASS: */
                db_obj.Obj_id += get_id_offset(file_no, class_id);
                /* Ͽ */
                add_new_object(class_id, db_obj);
                set_id_offset(file_no + 1, class_id, db_obj.Obj_id);
                break;
            }
        }
#endif /* SPD_MERGE_SDB */
    }

    /* Ϣν */
    for (class_id = SPD_FIRST_RID_I_MODEL;
         class_id <= SPD_LAST_RID_I_MODEL; class_id++) {
        id = SPD_OBJ_ID_OFFSET(class_id);
        offset1 = get_id_offset(file_no, class_table[class_id].rel_class1);
        offset2 = get_id_offset(file_no, class_table[class_id].rel_class2);
        if ((obj_num = spdGetInfoInt(info,
                                     spdGetClassNameById(class_id), 0)) == 0) {
            continue;
        }

#ifdef SPD_MERGE_SDB
        fp = spdOpenSDBfile(I_MODEL_DIR, class_table[class_id].name,
                            SAPID_O_READ);

        /* 饤֥꤫Ƚ */
        if (flag_l && file_no != 0 && class_id == SPD_RID_PROG_FILE) {
            id = SPD_OBJ_ID_OFFSET(SPD_RID_LIB_FILE);
            while (obj_num--) {
                /* Ϣidɤ߹߻դ롥*/
                db_rel = spdReadRel(fp, class_id, id++);
                /* id񤭴 */
                db_rel.Rel_p_id = moveClass(db_rel.Rel_p_id,
                                            SPD_CID_LIBRARY);
                /*
                 * db_rel.Rel_p_id = moveClass(db_rel.Rel_p_id,
                 * SPD_CID_LIBRARY) + offset1;
                 */

                db_rel.Rel_c_id += offset2;
                /* Ͽ */
                add_new_relation(SPD_RID_LIB_FILE, db_rel);
            }
        } else { 
            while (obj_num--) {
                /* Ϣidɤ߹߻դ롥*/
                db_rel = spdReadRel(fp, class_id, id++);
                /* id񤭴 */
                db_rel.Rel_p_id += offset1;
                db_rel.Rel_c_id += offset2;
                /* Ͽ */
                add_new_relation(class_id, db_rel);
            }
        }
        spdFclose(fp);
#else
        while (obj_num--) {
            /* Ϣidɤ߹߻դ롥*/
            db_rel = spdReadRel(fp, class_id, id++);
            /* id񤭴 */
            db_rel.Rel_p_id += offset1;
            db_rel.Rel_c_id += offset2;
            /* Ͽ */
            add_new_relation(class_id, db_rel);
        }
#endif /* SPD_MERGE_SDB */
    }

#ifdef SPD_MERGE_SDB
    load_repository_Pmodel(info, file_no);
#endif

    /* ơ֥˽äid롥 */
#ifdef SPD_MERGE_SDB
    modify_id(SPD_CID_PROGRAM, program_modify_set);
#endif
    modify_id(SPD_CID_IDENTIFIER, extern_modify_set);
    modify_id(SPD_CID_OPERATOR, operator_modify_set);

#ifdef SPD_MERGE_SDB
    spdFreeSet(program_modify_set);
#endif
    spdFreeSet(extern_modify_set);
    spdFreeSet(operator_modify_set);
    spdCloseInfo(info);
}

/*
 * Initialize tables.
 */

static void
init_list(void)
{
    int     i;

    /* (SpdSet) class_object_set[]. */
    for (i = 0; i < SDBLINK_CLASS_NUM; i++) {
        class_object_set[i] = spdCreateSet(sizeof(MyObject));
    }
    /* Ϣ(Relation) relation_array[]. */
    for (i = 0; i < SDBLINK_REL_NUM; i++) {
#ifdef SPD_MERGE_SDB
        if (i < SPD_RID_NUM_I_MODEL) {
            /* relation in I-model */
            relation_array[i].elem =
                spdMalloc(sizeof(Relation) *
                          obj_and_rel_num_table[i + SPD_CID_NUM_I_MODEL]);
        } else {
            /* relation in P-model */
            relation_array[i].elem =
                spdMalloc(sizeof(Relation) *
                          obj_and_rel_num_table[i + SDBLINK_CLASS_NUM]);
        }
#else
        relation_array[i].elem =
            spdMalloc(sizeof(Relation) *
                      obj_and_rel_num_table[i + SDBLINK_CLASS_NUM]);
#endif /* SPD_MERGE_SDB */
        relation_array[i].elem_num = 0;
    }
}

/*
 * Free heap memory.
 */

void
free_sdblink(void)
{
    int     i;

    for (i = 0; i < SDBLINK_CLASS_NUM; i++) {
        spdFreeSet(class_object_set[i]);
    }
    for (i = 0; i < SDBLINK_REL_NUM; i++) {
        spdFree(relation_array[i].elem);
    }
    for (i = 0; i < object_db_n; i++) {
        spdFreeStrsInObj(object_db[i]);
    }
    spdFree(object_db);
    spdFree(relation_db);
}

/* 饹Υ֥ȿ׻ */

static void calc_class_obj(SpdInfo *info, SpdId firstId, SpdId lastId,
                           int fileNo, SpdString file_name)
{
    SpdId class_id;
    int tmp_count;

    for (class_id = firstId; class_id <= lastId; class_id++) {
        tmp_count = spdGetInfoInt(info, spdGetClassNameById(class_id), 0);

#ifdef SPD_MERGE_SDB    
        if (class_id == SPD_CID_FILE) {
            init_src_array(fileNo, file_name, tmp_count);
        }
#endif /* SPD_MERGE_SDB */
        object_db_alloc_n += tmp_count;
        obj_and_rel_num_table[class_id] += tmp_count;
    }
}

/* ϢΥ֥ȿ׻ */

static void calc_rel_obj(SpdInfo *info, SpdId firstId, SpdId lastId, int fileNo)
{
    SpdId rel_id;
    int tmp_count;

    for (rel_id = firstId; rel_id <= lastId; rel_id++) {
        tmp_count = spdGetInfoInt(info, spdGetClassNameById(rel_id), 0);
    
        relation_db_alloc_n += tmp_count;
#ifdef SPD_MERGE_SDB
        /* lib_fileΰݤΤ H.Ohhashi 1999/06/28 */
        if (flag_l && fileNo != 0 && rel_id == SPD_RID_PROG_FILE) {
            obj_and_rel_num_table[SPD_RID_LIB_FILE] += tmp_count;
        } else {
            obj_and_rel_num_table[rel_id] += tmp_count;
        }
#else
        obj_and_rel_num_table[rel_id] += tmp_count;
#endif /* SPD_MERGE_SDB */
    }
}

#ifndef SPD_MERGE_SDB

/* Added by N.Fukuyasu 1999/08/27. */
/* target_program_name  program ֥Ȥ롥 */

SpdId make_program_object(void)
{
    SpdId       prog_id = SPD_OBJ_ID_OFFSET(SPD_CID_PROGRAM);
    SpdDBObj    db_obj;
    int         attr_id;

    db_obj.Obj_id = prog_id;
    attr_id = SPD_AID_PROGRAM_NAME;
    db_obj.svalue[attr_id - SpdObjIValN] = spdStrdup(target_program_name);
    add_new_object(SPD_CID_PROGRAM, db_obj);

    return (prog_id);
}

/* Added by N.Fukuyasu 1999/08/27. */
/* file 饹ɤ߹ࡥ */

void read_file_class(int file_obj_num)
{
    FILE    *fp;
    SpdDBObj    db_obj;
    SpdInfo *info;

    info = spdOpenSDBinfo();
    spdSetReadSDBformat(SPD_STREQ(spdGetInfoString(info, "BINARY_FORMAT_SDB"),
                                    "TRUE") ?
                        SAPID_BINARY_FORMAT_SDB :
                        SAPID_TEXT_FORMAT_SDB);
    spdCloseInfo(info);
    fp = spdOpenSDBfile(I_MODEL_DIR, spdGetClassNameById(SPD_CID_FILE),
                        SAPID_O_READ);
    while (file_obj_num--) {
        db_obj = spdReadObj(fp, SPD_CID_FILE);
        add_new_object(SPD_CID_FILE, db_obj);
    }
    spdFclose(fp);
}

/* Added by N.Fukuyasu 1999/08/27. */
/* prog_id  file_name Ȥδ֤˴Ϣ prog_file 롥 */

void make_prog_file(SpdId prog_id, char *file_name)
{
    SpdId       file_id;
    SpdDBRel    db_rel;
    static int  id = SPD_OBJ_ID_OFFSET(SPD_RID_PROG_FILE);

    if ((file_id = spdSearchGlobalObj("file", file_name)) != SPD_NON_ID) {
        db_rel.Rel_id = id++;
        db_rel.Rel_p_id = prog_id;
        db_rel.Rel_c_id = file_id;
        add_new_relation(SPD_RID_PROG_FILE, db_rel);
    }
}

#endif /* not SPD_MERGE_SDB */

/*
 * Initialize.
 */

void initialize(int argc, char *argv[])
{
    int         i;
    SpdInfo     *info;
#ifndef SPD_MERGE_SDB
    SpdId   prog_id, file_id, id;
    int     file_obj_num;
#endif /* not SPD_MERGE_SDB */

#ifdef SPD_MERGE_SDB
    /* ե򥳥ԡ뤿롥 */
    init_rep_array(argc);
#endif /* SPD_MERGE_SDB */

    /* ƤDBФinfoĴ١objrelο롥 */
    for (i = 0; i < SDBLINK_CLASS_AND_REL_NUM; i++) {
        obj_and_rel_num_table[i] = 0;
    }

    for (i = 0; i < argc; i++) {
#ifdef SPD_MERGE_SDB
        spdSetSDBdir(argv[i]);
        info = spdOpenSDBinfo();
#else
        info = spdOpenISDBinfo(argv[i]);
#endif /* SPD_MERGE_SDB */

        /* calculate number of I-model class & relation objects. */
        calc_class_obj(info, SPD_FIRST_CID_I_MODEL, SPD_LAST_CID_I_MODEL, 
                       i, argv[i]);
        calc_rel_obj(info, SPD_FIRST_RID_I_MODEL, SPD_LAST_RID_I_MODEL, i);

#ifdef SPD_MERGE_SDB
        /* calculate number of P-model class & relation objects. */
        calc_class_obj(info, SPD_FIRST_CID_P_MODEL, SPD_LAST_CID_P_MODEL, 
                       i, argv[i]);
        calc_rel_obj(info, SPD_FIRST_RID_P_MODEL, SPD_LAST_RID_P_MODEL, i);
#endif /* SPD_MERGE_SDB */
        spdCloseInfo(info);
    }

#ifdef SPD_MERGE_SDB
    /* Ϣ prog_lib Τΰɲ  H.Ohhashi 1999/06/28 */
    if (flag_l) {
        obj_and_rel_num_table[SPD_RID_PROG_LIB] += argc - 1;
        relation_db_alloc_n += obj_and_rel_num_table[SPD_RID_PROG_LIB];
    }
#endif /* SPD_MERGE_SDB */

#ifndef SPD_MERGE_SDB
    /* Added by N.Fukuyasu 1999/08/27. */
    /*
     * ISDB ˽ϤƤΤ program, file ʳΥ֥ȤǤ롥
     * program ֥Ȥ򿷤뤿˥֥ȿ 1 
     * 롥file ֥Ȥ pidb ˤäѤߤǤ뤬
     * Ѥɤ߹Τ file ֥ȤθĿ⥪֥ȿ˲ä롥
     * ޤϢ prog_file 뤿 argc Ϣ˲ä롥
     */
    object_db_alloc_n++;
    obj_and_rel_num_table[SPD_CID_PROGRAM] = 1;

    info = spdOpenSDBinfo();
    file_obj_num = spdGetInfoInt(info,
                                 spdGetClassNameById(SPD_CID_FILE), 0);
    object_db_alloc_n += file_obj_num;
    obj_and_rel_num_table[SPD_CID_FILE] = file_obj_num;
    spdCloseInfo(info);

    relation_db_alloc_n += argc;
    obj_and_rel_num_table[SPD_RID_PROG_FILE] = argc;
#endif /* not SPD_MERGE_SDB */

    /* 
     * info˰ΰݤ롥ɤ߹ߤκݤ̾󤻤ǽ
     * ΤǼºݤλ̤Ϥ꾯ʤʤ롥Ϥ鷺Ǥ롥
     */
    object_db = spdMalloc(sizeof(SpdDBObj) * object_db_alloc_n);
    object_db_n = 0;

    /* ƤδϢɤ߹िᡤݤΰƻѤ롥 */
    relation_db = spdMalloc(sizeof(SpdDBRel) * relation_db_alloc_n);
    relation_db_n = 0;

    init_id_offset(argc);

    /* Initialize list. */
    init_list();

#ifndef SPD_MERGE_SDB
    /* Added by N.Fukuyasu 1999/08/27. */
    /* program ֥Ȥ롥 */
    prog_id = make_program_object();

    /* Added by N.Fukuyasu 1999/08/27. */
    /* SDB  file 饹ɤ߹ࡥ */
    read_file_class(file_obj_num);

    /* Added by N.Fukuyasu 1999/08/27. */
    /*
     * target_program_name  argv Ϥ줿 file Ȥδ֤
     * Ϣ prog_file 롥
     */
    for (i = 0; i < argc; i++) {
        make_prog_file(prog_id, argv[i]);
    }
#endif /* not SPD_MERGE_SDB */
}

#ifdef SPD_MERGE_SDB

/*
 * prog_lib 񤭹.
 */

static void write_prog_lib(void)
{
    SpdDBRel    db_rel = {{0, 0, 0, 0, 0, 0}};
    int         i;
    SpdId       rel_id = SPD_OBJ_ID_OFFSET(SPD_RID_PROG_LIB);
    int         dummy;
    MyObject    *obj;

    db_rel.Rel_id = rel_id++;
    /* program ֥Ȥ롥 */
    obj = spdGetAElem(class_object_set[class_index(SPD_CID_PROGRAM)], &dummy);
    db_rel.Rel_p_id = object_db[obj->db_key].Obj_id;
    /* library ֥Ȥ롥 */
    for (i = 0; i < class_object_set[class_index(SPD_CID_LIBRARY)]->elemNum; i++) {
        obj = spdGetAElem(class_object_set[class_index(SPD_CID_LIBRARY)], &dummy);
        db_rel.Rel_c_id = object_db[obj->db_key].Obj_id;
        add_new_relation(SPD_RID_PROG_LIB, db_rel);
    }
}

#endif

/* Initialize this program name. */

static void init_prog_name(char **argv)
{
    /* 
     * if ((program_name = strrchr(argv[0], '/')) != NULL) {
     *     program_name++;
     * } else {
     *     program_name = argv[0];
     * }
     */
    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);
}

/*
 * Main.
 */

int main(int argc, char **argv)
{
    int         i;
    SpdInfo     *info;
    FILE        *fp = NULL;

    init_prog_name(argv);
    parse_option(argc, argv);
    argc -= optind;
    argv += optind;
    if (argc < 1) {
        spdErrorExit("No input file.\n");
    }

    /* Initialize. */
    initialize(argc, argv);
#ifdef SPD_MERGE_SDB
    /*
     * pfile̾󤻤򤷤ʤᡤ֥ȿιʬΰ
     * ݤ롥
     */
    initPfileFileTbl(obj_and_rel_num_table[SPD_CID_PFILE]);
#endif /* SPD_MERGE_SDB */

    /* ݥȥɤ߹ࡥ */
    for (i = 0; i < argc; i++) {
#ifdef SPD_MERGE_SDB
        /* argv[i]  SDB ¸ߤΥå */
        if (spdIsDirectory(argv[i]) == FALSE) {
            spdErrorExit("SDB %s not found.\n", argv[i]);
        }
#else
        fp = spdOpenISDB(argv[i], SAPID_O_READ);
#endif

        /* ݥȥϤ롥 */
        load_repository(fp, i, argv[i]);
#ifndef SPD_MERGE_SDB
        spdFclose(fp);
#endif
    }

#ifdef SPD_MERGE_SDB
    /* Ϣ prog_lib ν񤭹ߡ */
    if (flag_l) {
        write_prog_lib();
    }
#endif /* SPD_MERGE_SDB */

    /* IdentifierѤΥϥå(global_map[])β */
    free_global_table();

    free_id_offset();

    /* Ŭ */
#ifdef SPD_MERGE_SDB
    if (0 < optimize_level) {
        if (!flag_l) {
            /* -lǤʤϥե˴ؤƤŬԤ */
            optimize_file();
        } else {
            optimizer(optimize_level);
        }
    }
#else 
    if (0 < optimize_level) {
        optimizer(optimize_level);
    }
#endif /* SPD_MERGE_SDB */

    /* Writing SDB. */
    spdMessage("Writing SDB.\n");

#ifdef SPD_MERGE_SDB
    spdSetSDBdir(gl_sdb_dir);
#endif /* SPD_MERGE_SDB */
    write_db_sdblink();

    info = spdOpenSDBinfo();

#ifdef SPD_MERGE_SDB
    spdSetInfoString(info, "RELATIVE_OFFSET", "TRUE");
    write_sapid_version(info);
    
    /* Write copy source file information. */
    write_cp_src();
    free_rep_table();
#else
    /* Set relative offset information. */
    spdSetInfoString(info, "RELATIVE_OFFSET",
                     ((optimize_level < 3) ? "FALSE" : "TRUE"));
#endif /* SPD_MERGE_SDB */

    /* Set format information. */
    spdSetInfoString(info, "BINARY_FORMAT_SDB",
                     (spdGetWriteSDBformat() == SAPID_BINARY_FORMAT_SDB ? "TRUE" : "FALSE"));
    spdCloseInfo(info);

    /* !! Release heap memories! */ 
    /* free_sdblink(); */

    return (EXIT_SUCCESS);
}

/*
 * Analyzing options.
 */

static void parse_option(int argc, char *argv[])
{
    int     ch;

    while ((ch = getopt(argc, argv, OPTIONS)) != -1) {
        switch (ch) {
          case 'b':                         /* Binaryϡ */
            spdSetWriteSDBformat(SAPID_BINARY_FORMAT_SDB);
            break;
          case 'd':                         /* Directory for SDB. */
            spdSetSDBdir(optarg);
            spdMessage("SDB directory \"%s\".\n", spdGetSDBdir());
            break;
          case 'o':                         /* Program name. */
            target_program_name = optarg;
            spdMessage("Program name \"%s\".\n", target_program_name);
            break;
          case 'O':                         /* Optimize SDB. */
            optimize_level = atoi(optarg);
            if (optimize_level < 1 || 3 < optimize_level) {
                optimize_level = 2;
            }
            break;
#ifdef SPD_MERGE_SDB
          case 'D':
            gl_sdb_dir = optarg;
            break;
          case 's':
            script_name = optarg;
            break;
          case 'l':
            flag_l = ON;
            break;
#endif /* SPD_MERGE_SDB */
          default:
            printUsage(program_name);
            break;
        }
    }
}

/*
 * Usage.
 */

static void
printUsage(SpdConstString command_name)
{
    const char  *usageMessage =
        "\n"
        "NAME\n"
        "    %s\n"
        "SYNOPSIS\n"
        "    %s [options] inputFiles\n"
        "DESCRIPTION\n"
        "    -d SDBdirectory.\n"
        "    -o ProgramName\n"
#ifdef SPD_MERGE_SDB
        "    -D GlobalSDBdirectory\n"
        "    -s ScriptName\n"
        "    -l\n"
#endif /* SPD_MERGE_SDB */      
        "VERSION\n"
        "    %d.%d.%d\n";

    spdErrorExit(usageMessage,
                 command_name, command_name,
                 SapidVersion, SapidRevision, SapidPatchLevel);
}

/******************************************************************************/

#ifdef SPD_MERGE_SDB

/*
 * sdbin4.c 饳ԡ饤֥경٤?
 */

#ifdef SPD_MERGE_SDB

/*
 * Output version information.
 */

static SpdString make_val_str(int value)
{
    static char     val_str[SPD_LINE_LEN + 1];

    sprintf(val_str, "%d", value);
    return (val_str);
}

/*
 * "sdbin4.c"Ѥɲä
 */

static void write_sapid_version(SpdInfo *info)
{
    spdSetInfoString(info, SPD_MKSTR(SapidVersion),
                     make_val_str(SapidVersion));
    spdSetInfoString(info, SPD_MKSTR(SapidRevision),
                     make_val_str(SapidRevision));
    spdSetInfoString(info, SPD_MKSTR(SapidPatchLevel),
                     make_val_str(SapidPatchLevel));
    spdSetInfoString(info, SPD_MKSTR(SapidSDBVersion),
                     make_val_str(SapidSDBVersion));
    spdSetInfoString(info, SPD_MKSTR(SapidPIDBVersion),
                     make_val_str(SapidPIDBVersion));
    spdSetInfoString(info, "SDB4", "TRUE");
}

#endif /* SPD_MERGE_SDB */

#endif /* SPD_MERGE_SDB */
