/* 
 * Program:             $RCSfile: spdMkMiniInfo.c,v $  $Revision: 30.2 $
 * 
 * Purpose:
 * 
 * Author:              N.Fukuyasu  2000/01/22
 *                      S.Yamamoto  2000/01/22
 * 
 * (C) Copyright:       N.Fukuyasu and S.Yamamoto  2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdMkMiniInfo.c,v 30.2 2003/05/29 04:19:55 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

static SpdConstString program_name;

static void print_usage(void)
{
    spdErrorExit("Usage: %s [-b][-d dir]", program_name);
}

int main(int argc, char *argv[])
{
    int         c;
    SpdInfo     *info;

    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);

    while ((c = getopt(argc, argv, "bd:")) != EOF) {
        switch (c) {
          case 'b':
            spdSetWriteSDBformat(SAPID_BINARY_FORMAT_SDB);
            break;
          case 'd':
            spdSetSDBdir(optarg);
            break;
          default:
            print_usage();
            break;
        }
    }

    info = spdOpenSDBinfo();
    smuSetSDBinfo(info);
    spdSetInfoString(info, "BINARY_FORMAT_SDB",
                     (spdGetWriteSDBformat() == SAPID_BINARY_FORMAT_SDB ?
                      "TRUE" : "FALSE"));
    spdCloseInfo(info);

    return (EXIT_SUCCESS);
}
