/* 
 * Program:             $RCSfile: PIDB.c,v $  $Revision: 30.13 $
 * 
 * Purpose:
 * 
 * Author:              T.Mimura  1993/12/01
 *                      S.Yamamoto  1994/09/01
 * 
 * (C) Copyright:       T.Mimura and S.Yamamoto  1993 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: PIDB.c,v 30.13 2003/07/06 10:08:53 yamamoto Exp yamamoto $";
#endif

#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <Sapid/Sapid.h>
#include <Sapid/spdSet2.h>

DEFINEinfo      *defineInfo = NULL;     /* Array of macro define info. */
int             defineInfoN = 0;        /* Number of macro define info. */

EXPANDinfo      *expandInfo = NULL;     /* Array of macro expand info. */
int             expandInfoN = 0;        /* Number of macro expand info. */

IFEXPRinfo      *ifexprInfo = NULL;     /* Array of #if expression info. */
int             ifexprInfoN = 0;        /* Number of #if expression info. */

SpdBoolean      CPPinfoVerbose = FALSE;         /* Is verbose mode? */
int             CPPinfoQueueExtent = 1000;      /* Queue size. */

#ifdef PIDB_USE_FILENAME_INDEX

static SpdSet2  fname_set = NULL;

SpdObjId pidbConvFileId(SpdConstString fname)
{
    SpdObjId id;
    SpdElem *el;

    if (fname_set == NULL) {
        fname_set = spdCreateSet2(SPDSET_COPY_STRING_KEY, SPDSET_OBJID_VALUE);
        if (atexit(pidbConvFileId_free) < 0) {
            spdErrorExit("pidbConvFileId(): atexit() fails: %s", 
                         strerror(errno));
        }
    }
    
    if ((el = spdSearchElemS(fname_set, fname)) != NULL) {
        return spdSetGetValueO(el->value);
    }

    if ((id = smuGetFileIdByName(fname)) == SPD_NON_ID) {
        spdWarning("pidbConvFileId(): no id exists for %s.\n", fname);
        /* should be "error and exit"? */
        return id;;
    }
    
    if (spdAddElemSO(fname_set, fname, id) == NULL) {
        spdErrorExit("pidbConvFileId(): can't add the element for %s.\n", 
                     fname);
    }
    return id;
}

void pidbConvFileId_free(void)
{
    spdFreeSet2(fname_set);
}

#endif /* PIDB_USE_FILENAME_INDEX */
