/* 
 * Program:             $RCSfile: charConv.c,v $  $Revision: 30.18 $
 * 
 * Purpose:
 * 
 * Author:              T.Mimura  1993/12/01
 *                      S.Yamamoto  1994/09/01
 *                      M.Hakamata  1997/05/31
 * 
 * (C) Copyright:       T.Mimura, M.Hakamata and S.Yamamoto  1994 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: charConv.c,v 30.18 2003/07/08 05:46:08 yamamoto Exp yamamoto $";
#endif
  
/* 
 * PIDBѤ"*.c", "*.h""*.i"ʸбĴ٤롥
 * 
 * :
 * (1) ΥץλѤˤ("*.c"ץФ)Ĥ
 * ¤롥ͳ"lineConv.c"δؿȤäƤ뤿Ǥ롥
 * ¤ξܺ٤ˤĤƤϡ"lineConv.c"򻲾Ȥ뤳ȡ
 */

#include <stdio.h>
#include <Sapid/Sapid.h>

static int lengthBeforeExpansion(SpdConstString iname, int start, int end);
static int cppCharNotInMacroCtoI(char *cname, int cchar, char *cbuf, int clen,
                                 char *iname, char *ibuf, int ilen);
static int searchMacroCallIncludedInARegion(MacroCallRegion *region,
                                            int startId);
static int lengthAfterExpansion(char *cname, int start, int end);
static int searchMacroExpansionIncludedInARegion(MacroExpandRegion *region,
                                                 int startId);

/* 
 * ƤӽФ".c"λϰϤ˴ޤޤޥƤӽФstartIdʹߤܤ
 * Ĥʤ-1֤
 */

static int searchMacroCallIncludedInARegion(MacroCallRegion *region,
                                            int startId)
{
    int         i;
    
    if (startId < 0) {
        startId = 0;
    }
    if (expandInfoN <= startId) {
        return (-1);
    }
    
    for (i = startId; i < expandInfoN; i++) {
        if (equalInputText(region, &(expandInfo[i].input)) == FALSE) {
            continue;
        }
        if (region->start <= expandInfo[i].input.start &&
            expandInfo[i].input.end <= region->end) {
            return (i);
        }
    }
    return (-1);
}

/* 
 * ".c"λϰϤޥŸ˲ʸˤʤ뤫֤
 */

static int lengthAfterExpansion(char *cname, int start, int end)
{
    MacroCallRegion tmpRegion;
    int         i, len;
    
    tmpRegion.type  = CALL_FILE;
    tmpRegion.fname = cname;

#ifdef PIDB_USE_FILENAME_INDEX
    tmpRegion.fname_idx = pidbConvFileId(cname);
#endif

    tmpRegion.start = start;
    tmpRegion.end   = end;
    len = end - start + 1;
    i = 0;
    while (1) {
        int id;
        
        id = searchMacroCallIncludedInARegion(&tmpRegion, i);
        if (id < 0) {
            break;
        }
        len += (expandInfo[id].output.end - expandInfo[id].output.start)
            - (expandInfo[id].input .end - expandInfo[id].input. start);
        i = id + 1;                         /* θΤᡥ */
    }
    return (len);
}

/* 
 * "*.c""*.h"ʸб"*.i"ʸΰ֤֤Ĵ٤ʸϥޥ
 * ˴ޤޤƤʤȤ餫ʬäƤɬפ롥
 */

static int cppCharNotInMacroCtoI(char *cname, int cchar, char *cbuf, int clen,
                                 char *iname, char *ibuf, int ilen)
{
    int         cline, ccolumn, head, len, r, hline;
    int         iline;
    SpdLineTbl  tbl;

    tbl = spdCreateLineTbl(cbuf, clen);
    if (spdCnvOffsetToLineColumnSub(tbl, cchar, &cline, &ccolumn) < 0) {
        spdFreeLineTbl(tbl);
        return (-1);
    }

    hline = cline;
    /* ޥƤӽФ˴ޤޤƤʤֹԤƬʸפõ */
    while (1) {
        int             eid;
        MacroCallRegion creg;

        head = spdCnvLineColumnToOffsetSub(tbl, hline, 1);
        creg.type = CALL_FILE;
        creg.start = creg.end = head;
        creg.fname = cname;

#ifdef PIDB_USE_FILENAME_INDEX
        creg.fname_idx = pidbConvFileId(cname);
#endif

        eid = isInMacroCall(&creg);
        if (eid == -1 || expandInfo[eid].input.start == head) {
            break;
        }
        /* ԤƬޥƽФϤޤΤᡥ */
        hline --;
    }
    len = lengthAfterExpansion(cname, head, cchar);
    /* ιԤƬ顤Ūʸΰ֤ޤǤΡޥŸʸ */
    iline = lineConvertCtoI(cname, hline, ibuf, ilen);
    /* ιԤ .i βܤ */

    spdFreeLineTbl(tbl);
    r = spdCnvLineColumnToOffset(smuGetFileIdByName(iname), iline, 1) + len - 1;

    return (r);
}

/* 
 * Ÿ̤".i"λϰϤ˴ޤޤޥƤӽФstartIdʹߤܤ
 * Ĥʤ-1֤
 */

static int searchMacroExpansionIncludedInARegion(MacroExpandRegion *region,
                                                 int startId)
{
    int     i;
    
    if (startId < 0) {
        startId = 0;
    }
    if (expandInfoN <= startId) {
        return (-1);
    }
    for (i=startId; i<expandInfoN; i++) {
        if (equalOutputText(region, &(expandInfo[i].output)) == FALSE) {
            continue;
        }
        if (region->start <= expandInfo[i].output.start
            && expandInfo[i].output.start <= region->end) {
            return (i);
        }
    }
    return (-1);
}

/* 
 * "*.c"λϰϤޥŸ˲ʸˤʤ뤫֤
 */

static int lengthBeforeExpansion(SpdConstString iname, int start, int end)
{
    MacroExpandRegion   tmpRegion;
    int                 i, len, id;
    
    tmpRegion.type  = EXPAND_FILE;
    tmpRegion.fname = iname;

#ifdef PIDB_USE_FILENAME_INDEX
    tmpRegion.fname_idx = pidbConvFileId(iname);
#endif

    tmpRegion.start = start;
    tmpRegion.end   = end;
    len = end - start + 1;
    i = 0;
    
    while (1) {
        id = searchMacroExpansionIncludedInARegion(&tmpRegion, i);
        if (id < 0) {
            break;
        } else if (expandInfo[id].input.type == CALL_FILE) {
            len += (expandInfo[id].input. end - expandInfo[id].input. start)
                - (expandInfo[id].output.end - expandInfo[id].output.start);
        }
        i = id + 1;                         /* θΤᡥ */
    }
    return (len);
}

/* 
 * "*.c""*.h"ʸб"*.i"ʸΰ֤֤Ĵ٤ʸϥޥ
 * ˴ޤޤƤʤȤ餫ʬäƤɬפ롥ޤ
 * cnameΰˤ"*.c" ("*.h")ե̾(¿ξեѥ)Ρ
 * ʬ礭ݤƤɬפ롥۾郎ä-1֤
 */

int cppCharNotInMacroItoC(SpdConstString iname, int ichar, char *ibuf,
                          int ilen, char *cname)
{
    int         iline, icolumn, head, len, hline;
    int         cline;
    SpdLineTbl  tbl;

    tbl = spdGetLineTbl(smuGetFileIdByName(iname));
    if (spdCnvOffsetToLineColumnSub(tbl, ichar, &iline, &icolumn) < 0) {
        return (-1);
    }

    hline = iline;
    /* ޥŸ˴ޤޤʤֹԤƬʸפõ */
    while (1) {
        int                 eid;
        MacroExpandRegion   ereg;
        
        head = spdCnvLineColumnToOffsetSub(tbl, hline, 1);
        ereg.type = EXPAND_FILE;
        ereg.fname = iname;

#ifdef PIDB_USE_FILENAME_INDEX
        ereg.fname_idx = pidbConvFileId(iname);
#endif

        ereg.start = ereg.end = head;
        eid = isInMacroExpand(&ereg, -1, -1);
        if (eid == -1) {
            break;
        } else if (expandInfo[eid].output.start == head) {
            break;
        }
        /* ԤƬޥŸϤޤΤ */
        hline --;
    }
    len = lengthBeforeExpansion(iname, head, ichar);

    /* ǽ"*.c"Υե̾ʬ롥 */
    cline = lineConvertItoCwithTbl(cname, hline, ibuf, ilen, tbl);
    /* 
     * Debug write for HP-UX 1996/03/26.
     * spdWarning("cppCharNotInMacroItoC(): cname \"%s\".\n", cname);
     */

    return (spdCnvLineColumnToOffset(smuGetFileIdByName(cname), cline, 1) +
            len - 1);
}

/* 
 * ե̾cname"*.c"եΡեåoffsetʸбʸ
 * "*.i"եΤɤˤΤĴ٤롥̤queue롥 餫
 * ᡤ"*.c", "*.i"եɤߤǤɬפ롥
 * :
 *     cname: "*.c"ե̾
 *     offset: Ĵ٤ʸΰ֡
 *     queue: ̤Ǽ륭塼
 *     cbuf: "*.c"եɤߤΰ补
 *     clen: "*.c"եĹ
 *     iname: "*.i"ե̾
 *     ibuf: "*.i"եɤߤΰ补
 *     ilen: "*.i"եĹ
 * :
 *     0ʾ: бʸޥ˴ޤޤƤꡤбʸ¸ߤ롥
 *            ͤбսθĿ
 *     -1: бʸϥޥˤϴޤޤʤ бʸ1սꡥ
 *     -2: бʸ¸ߤʤδְ㤤ĴԲǽ
 */

int cppCharConvCtoI(char *cname, int offset, MacroExpandRegionQueue *queue,
                    char *cbuf, int clen, char *iname, char *ibuf, int ilen)
{
    MacroCallRegion mcreg;
    int             r;
    
    mcreg.type = CALL_FILE;
    mcreg.fname = cname;

#ifdef PIDB_USE_FILENAME_INDEX
    mcreg.fname_idx = pidbConvFileId(cname);
#endif

    mcreg.start = mcreg.end = offset;
    r = completeMacroExpand(&mcreg, queue);
    if (0 <= r) {
        /* ʸޥƤӽФ˴ޤޤ줿硥 */
        return r;
    }
    r = cppCharNotInMacroCtoI(cname, offset, cbuf, clen, iname, ibuf, ilen);
    if (r >= 0) {
        MacroExpandRegion   mereg;
        mereg.type = EXPAND_FILE;
        mereg.start = mereg.end = r;
        mereg.fname = iname;

#ifdef PIDB_USE_FILENAME_INDEX
        mereg.fname_idx = pidbConvFileId(iname);
#endif

        pushMacroExpandRegionQueue(queue, mereg);
        return -1;
    }
    return -2;
}

/* 
 * ե̾iname"*.i"եΡեåoffsetʸбʸ
 * "*.c" ("*.h")եΤɤˤΤĴ٤롥餫ᡤ".c", "*.i"
 * եɤߤǤɬפ롥cnameϡեѥǥե̾
 * ǼǤ뽽ʬ礭ɬס
 * 
 * :
 *     iname: "*.i"ե̾
 *     offset: Ĵ٤ʸΰ֡
 *     ibuf: "*.i"եɤߤΰ补
 *     ilen: "*.i"եĹ
 *     cname: бʸ"*.c"ե֤̾ΰ补
 *   
 * :
 *     0ʾ: бʸΰ֡
 *     -1: бʸϤʤ
 *     SAPID_CPP_NOT_SUPPORTED: ꤵ줿ʸ̤ݡȤʸǤ롥
 */

int cppCharConvItoC(SpdConstString iname, int offset, char *ibuf, int ilen,
                    char *cname)
{
    MacroExpandRegion   mereg;
    MacroCallRegion     mcreg;
    int                 r;
    
    mereg.type = EXPAND_FILE;
    mereg.start = mereg.end = offset;
    mereg.fname = iname;

#ifdef PIDB_USE_FILENAME_INDEX
    mereg.fname_idx = pidbConvFileId(iname);
#endif

    r = reverseParseAnOutputText(&mereg, &mcreg);
    if (r < 0) {
        /* -1 or SAPID_CPP_NOT_SUPPORTED. */
        return r;
    }
    if (r == 0) {         /* бʸ롥 */
        strcpy(cname, mcreg.fname);
        return mcreg.start;
    }
    /* ޥŸ˴ޤޤʤ */
    r = cppCharNotInMacroItoC(iname, offset, ibuf, ilen, cname);
    return r;
}
