/* 
 * Program:             $RCSfile: lineConv.c,v $  $Revision: 30.13 $
 * 
 * Purpose:
 * 
 * Author:              T.Mimura  1993/12/01
 *                      S.Yamamoto  1994/09/01
 *                      M.Hakamata  1997/05/31
 * 
 * (C) Copyright:       T.Mimura, M.Hakamata and S.Yamamoto  1994 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: lineConv.c,v 30.13 2002/07/29 11:43:14 yamamoto Exp yamamoto $";
#endif

/* 
 * ".c", ".h"ιԤ".i"ιԤбĴ٤롥
 *  
 * :
 * (1) ΥץǤ".i"եޤ줿ʲη
 * 
 * # ֹ ե̾ ֹ
 * 
 * ιԤ꤬ˤƹԤбĴ٤롥Υץϰʲ˼¤ġ
 * 
 * (a) "#line"ѤƤϡ˺롥
 * (b) Ĵ٤ԤХååˤäιԤϢ뤵Ƥ硤
 * ̤ʤ
 *
 * (2) ޥTESTȡưѤmain()ؿͭˤʤ롥
 * ޥC2I_ONLYȡ".c" -> ".i"ѴǽΤߤͭˤʤ롥
 * ޥI2C_ONLYȡ".i" -> ".c"ѴǽΤߤͭˤʤ롥
 * TESTˤϡC2I_ONLYI2C_ONLYΤɤ餫ɬ뤳ȡ
 */

#include <ctype.h>
#include <stdio.h>
#include <Sapid/Sapid.h>

#define FIX_PIDB_TESTER_960820
#define USE_FAST_IS_DIRECTIVE_LINE

#ifdef USE_FAST_IS_DIRECTIVE_LINE

#define isDirectiveLine(p)      (*(p) == '#')

#else /* not USE_FAST_IS_DIRECTIVE_LINE */

static SpdBoolean isDirectiveLine(const char *p);

#endif /* USE_FAST_IS_DIRECTIVE_LINE */

static char *searchNewLine(char *p, char *lim);
static char *reverseSearchNewLine(char *p, char *head);
static void parse_directive_line(char *buf, int *i1, char *fname, int *i2);

/* 
 * ԥɤõ롥limޤéäƤ⸫ĤʤäNULL֤
 */

static char *searchNewLine(char *p, char *lim)
{
    while (*p != '\n') {
        p++;
        if (p > lim) {
            return (NULL);
        }
    }
    return (p);
}

/* 
 * p˲ԥɤ򥵡롥headޤéäƤ⸫Ĥʤä
 * head֤ʤ*pʸޤԤƬʸΰ֤֤
 */

static char *reverseSearchNewLine(char *p, char *head)
{
    while (head < p) {
        p--;
        if (*p == '\n') {
            return (p + 1);
        }
    }
    return (head);
}

/* 
 * ιԤ#-directiveݤĴ٤롥
 * :
 *     p: ŪԤƬʸؤ
 *     lim: "*.i"եɤߤΰؤ
 */

#ifndef USE_FAST_IS_DIRECTIVE_LINE

static SpdBoolean isDirectiveLine(const char *p)
{
    return (*p == '#');
}

#endif /* not USE_FAST_IS_DIRECTIVE_LINE */

/* 
 * ιԤ#ֹԤݤĴ٤
 * :
 *     ؿisDirectiveLine()Ʊ
 * :
 * Ԥ"# "ǻϤޤꡤθ³йֹԤȤ롥äơ
 * ϸ̩ǤϤʤ
 */

static SpdBoolean isLineLine(char *p, char *lim)
{
#ifndef FIX_PIDB_TESTER_960820
    while (isspace(*p)) {       /* Ƭζ򥹥åפ */
        if (*p == '\n') return (FALSE);
        p++;
        if (p >= lim) return (FALSE);
    }
#endif /* not FIX_PIDB_TESTER_960820 */

    /*
     * # <line> "<filename>" [<num>]
     * # <line> "<filename>"
     */

    if ((lim - p) <= 1) {
        return (FALSE);                     /* Too short line. */
    }

    if (*p != '#' || *(p + 1) != ' ') {
        return (FALSE);
    }
    p += 2;

    /* "# "θ夬ֹ()å롥 */
    /* 
     * You don't need to check whether (p <= lim) or not,
     * because a terminator '\0' exists.
     */
    while (isdigit(*p)) {
        p++;
    }

    return (*p == ' ' || *p == '\n');
}

/* 
 * ʲ2ĤδؿѤˡؿspdReadFileInBufByName()Ѥơ
 * "*.i"եХåեɤ߹ɬפ롥
 */

/* 
 * "*.h", "*.c"λιԤ"*.i"βܤΤĴ٤Ƥιֹ֤
 * ˰۾郎ʤäꡤбԤ¸ߤʤ
 * ˤ-1֤
 * :
 *     name: "*.c", "*.h"Υե̾
 *     cline: бԤΤꤿ"*.c"եιֹ(1)
 *     ibuf: "*.i"եɤ߹Хåե
 *     ilen: "*.i"եĹ
 */

#ifndef I2C_ONLY

int lineConvertCtoI(char *name, int cline, char *ibuf, int ilen)
{
    char    *ibufp, *ibuflim, *nl;
    int     ih, ch, iline;
    char    fname[FILENAME_MAX + 1], cname[FILENAME_MAX + 1];
    int     i1, i2;
    SpdBoolean filematch = FALSE;
    
    sprintf(cname, "\"%s\"", name);
    ibuflim = ibuf + ilen;          /* "*.i"Хåե */
    ibufp =  ibuf;
    ih = ch = 1;
    iline = 1;
    nl = ibuf-1;
    /* 
     * "# line filename num"򻲾ȤŪιԤޤޤΰʤ롥
     */
    while (1) {
        ibufp = (nl+1);
        nl =  searchNewLine(ibufp, ibuflim);
        iline ++;
        if (nl == NULL) {
            if (iline-ih > cline-ch && filematch == TRUE) {
                break;
            } else {
                return (-1);
            }
        }
        if (!isLineLine(ibufp, nl)) continue;
        parse_directive_line(ibufp, &i1, fname, &i2);
        if (iline-ih > cline-ch && filematch == TRUE) {
            break;
        }
        if (SPD_STREQ(fname, cname)) {
            ih = iline;
            ch = i1;
            if (ch > cline) {
                return (-1);
            }
            /* ԥ󥿤ŪιԤɤۤƤޤä
               бԤ¸ߤʤä */
            filematch = TRUE;
            continue;
        } else {
            filematch = FALSE;
            continue;
        }
    }
    return (ih + (cline-ch));
}

#endif /* not I2C_ONLY */

/* 
 * "*.i"λιԤ"*.c", "*.i"βܤΤĴ٤Ƥιֹ֤
 * ˰۾郎ꡤʤäꡤбԤ¸ߤʤ
 * ˤ-1֤ޤ
 * :
 *     name: бԤޤޤ".c"뤤".h"Υե̾롥
 *           ʬΰݤƤƲ
 *     iline: бԤΤꤿ"*.i"եιֹ(1)
 *     ibuf: "*.i"եɤ߹Хåե
 *     ilen: "*.i"եĹ
 */

#ifndef C2I_ONLY

int lineConvertItoC(char *name, int iline, char *ibuf, int ilen)
{
    char    *ibufp, *ibuflim;
    int     cline, line;
    int     i1, i2;
    char    fname[FILENAME_MAX + 1], *fnamep;
    
    ibuflim = ibuf + ilen;
    ibufp = getHeadOfLine(ibuf, ilen, iline);
    if (isDirectiveLine(ibufp)) {
        /* #-directive ʤΤбԤ̵ */
        return (-1);
    }
    line = iline;
    do {
        ibufp = reverseSearchNewLine(ibufp - 1, ibuf);
        line--;
        if (ibufp < ibuf) {
            return (-1);
        }
    } while (!isLineLine(ibufp, ibuflim));
    parse_directive_line(ibufp, &i1, fname, &i2);
    cline = i1 + (iline - line) - 1;

    /* Delete preceding and trailing spaces. */
    fnamep = fname + 1;
    while (*fnamep != '\"') {
        *name++ = *fnamep++;
    }
    *name = '\0';

    return (cline);
}

int lineConvertItoCwithTbl(char *name, int iline, char *ibuf, int ilen,
                           SpdLineTbl tbl)
{
    char    *ibufp, *ibuflim;
    int     cline, line;
    int     i1, i2;
    char    fname[FILENAME_MAX + 1], *fnamep;
    
    ibuflim = ibuf + ilen;
    ibufp = ibuf + spdCnvLineColumnToOffsetSub(tbl, iline, 1);
    if (isDirectiveLine(ibufp)) {
        /* #-directiveʤΤбԤ̵ */
        return (-1);
    }
    line = iline;
    do {
        line--;
        if (line < 1) {
            return (-1);
        }
        ibufp = ibuf + spdCnvLineColumnToOffsetSub(tbl, line, 1);
    } while (!isLineLine(ibufp, ibuflim));
    parse_directive_line(ibufp, &i1, fname, &i2);
    cline = i1 + (iline - line) - 1;

    /* Delete preceding and trailing spaces. */
    fnamep = fname + 1;
    while (*fnamep != '\"') {
        *name++ = *fnamep++;
    }
    *name = '\0';

    return (cline);
}

#endif /* not C2I_ONLY */

/* 
 * parse_directive_line() has same facility with 
 *
 *     sscanf(ibufp, "# %d %s %d", &i1, fname, &i2). 
 *
 * But parse_directive_line() works more quickly than sscanf().
 * It contributes performance of reading PIDB.
 *
 * Added by A.Yoshida, 2002/07/22. 
*/

static void parse_directive_line(char *buf, int *i1, char *fname, int *i2)
{

    char *p = buf;
    char *f = fname;

    *i1 = 0;
    *i2 = 0;
    if (*p == '#') p++;                     /* Skip #. */
    while (isspace(*p)) p++;                /* Skip spaces. */

    /* Read the first sequence of digits. */
    while (isdigit(*p)) {
        *i1 = *i1 * 10 + (*p - '0');
        p++;
    }

    while (isspace(*p)) p++;                /* Skip spaces. */

    /* Read the first sequence of non-space characters. */
    while (!isspace(*p)) {
        *f++ = *p++;
        /* Warnning: no checking of buffer overrun for the buffer 'fname'! */
    }
    *f = '\0';

    /* Read the second sequence of digits. */
    while (isdigit(*p)) {
        *i2 = *i2 * 10 + (*p - '0');
        p++;
    }
}

/******************************************************************************/

/* 
 * ưmainؿ
 */

#if TEST

#if defined(C2I_ONLY)

int main(int argc, char *argv[])
{
    char    *cname, *iname;
    char    *ibuf;
    int     isize, cline, iline;
    
    if (argc != 4) {
        spdErrorExit("Invalid option.\n");
    }
    cname = argv[1];
    iname = argv[2];
    cline = atoi(argv[3]);
    fprintf(stderr, "%s %s %d\n", cname, iname, cline);
    isize = spdReadFileInBufByName(iname, &ibuf);
    iline = lineConvertCtoI(cname, cline, ibuf, isize);
    fprintf(stderr, " result ; line %d\n", iline);
    
    return (EXIT_SUCCESS);
}

#elif defined(I2C_ONLY)

int main(int argc, char *argv[])
{
    char    cname[FILENAME_MAX + 1], *iname;
    char    *ibuf;
    int     isize, cline, iline;
    
    if (argc != 3) {
        spdErrorExit("Invalid option.\n");
    }
    iname = argv[1];
    iline = atoi(argv[2]);
    fprintf(stderr, "%s %d\n", iname, cline);
    isize = spdReadFileInBufByName(iname, &ibuf);
    cline = lineConvertItoC(cname, iline, ibuf, isize);
    fprintf(stderr, " result ; %s  line %d\n", cname, cline);
    
    return (EXIT_SUCCESS);
}

#else /* !defined(C2I_ONLY) && defined(I2C_ONLY) */

    "Invalid configuration."

#endif /* !defined(C2I_ONLY) && defined(I2C_ONLY) */

#endif /* TEST */
