/* 
 * Program:             $RCSfile: macroCPPinfo.c,v $  $Revision: 30.6 $
 * 
 * Purpose:             (ޥط)
 * 
 * Author:              T.Mimura  1993/12/01
 *                      S.Yamamoto  1994/09/01
 * 
 * (C) Copyright:       T.Mimura and S.Yamamoto  1994 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: macroCPPinfo.c,v 30.6 2003/02/15 06:34:51 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

static int isInMacroArg(int id, MacroCallRegion *t);
static int shiftRegionCallExpand(MacroCallRegion *target);
static int expandMacro(int id, int argn, MacroCallRegion *a,
                       MacroExpandRegionQueue *eq, MacroCallRegionQueue *cq);
static int completeMacroArg(MacroCallRegion *target,
                            MacroExpandRegionQueue *eq);
static int macroCallToExpand(int id, MacroCallRegion *target,
                             MacroExpandRegionQueue *eq);

/*
 * Ĥ MacroCallRegion Υ֥ȤˤĤơ
 * ץץåɤ߽ФȤʤƥ(´Ǥ
 * ϥХåե)ɤĴ٤롥
 *  TRUE ֤
 */

SpdBoolean equalInputText(MacroCallRegion *a, MacroCallRegion *b)
{
    SpdBoolean  r = FALSE;
    
    if (a->type != b->type) {
        return (r);
    }
    switch (a->type) {
      case CALL_FILE:
#ifdef PIDB_USE_FILENAME_INDEX
        if (a->fname_idx ==  b->fname_idx) 
#else
        if (SPD_STREQ(a->fname, b->fname))
#endif
            r = TRUE;
        break;
      case CALL_MACROEXPANSION:
        if (a->macexpID == b->macexpID) {
            r= TRUE;
        }
        break;
      case CALL_MACROARG:
        if (a->macexpID == b->macexpID && a->argn == b->argn) {
            r = TRUE;
        }
        break;
    }
    return (r);
}

/*
 *  MacroCallRegion *t ޥƤӽФ˴ޤޤΤ
 * Ĵ١ޤޤʤ餽ΥޥŸID֤  դޤʤ
 * ʤ顤ͤ-1
 */

int isInMacroCall(MacroCallRegion *t)
{
    int     i, r;
    
    r = -1;
    for (i = 0; i < expandInfoN; i++) {
        if (equalInputText(t, &(expandInfo[i].input)) == TRUE) {
            if (expandInfo[i].input.start <= t->start &&
                t->end <= expandInfo[i].input.end) {
                r = i;
                break;
            }
        }
    }
    return (r);
}

/*
 * MacroCallRegion *t  ID id ΥޥƤӽФΤɤ줫ΰ
 * ޤޤΤĴ١ޤޤϤΰֹĴ٤롥
 * ޤޤʤ(뤤ϤΥޥʤ)
 * -1 ֤
 * *t ϤȤ ޥŸ ID=id ϸȰۤʤϡ
 * η̤̣ʤʤ
 */

static int isInMacroArg(int id, MacroCallRegion *t)
{
    int     i, r, n;
    
    n = defineInfo[ expandInfo[id].macID ].narg;
    /* θĿ */
    if (n <= 0) {
        return (-1);
    }
    r = -1;
    for (i = 0; i < n; i++) {
        if ((expandInfo[id].arg)[i].start <= t->start &&
            t->end <= (expandInfo[id].arg)[i].end) {
            r = i;
            break;
        }
    }
    return (r);
}

/*
 * MacroCallRegion *b  MacroCallRegion *a ˴ޤޤ뤫Ĵ٤롥
 * ޤޤʤ TRUE ֤
 */

SpdBoolean isMacroCallRedionIncluded(MacroCallRegion *a, MacroCallRegion *b)
{
    if (equalInputText(a, b) != TRUE) {
        return (FALSE);
    } else if (a->start <= b->start && b->end <= a->end) {
        return (TRUE);
    } else {
        return (FALSE);
    }
}

/*
 * MacroCallRegion *target ϤɤΥޥƤӽФˤޤޤʤᡤ
 * Τޤ޽Ϥޤ  ȤϤ֤ *target 
 * ʬǡޥθƤӽФäꤹȡִִ
 * ʸκ֤Ƥޤޤ  Ρ֤פ
 * ׻֤ޤ  ͤξϡ(ƥƬ)ؤΤ
 * 졤ξˤϸؤΤɽޤ
 * target->type  CALL_MACROEXPANSION  CALL_MACROARG Ǥʤ
 * ޤ  CALL_FILE ˤʤΤϤȡäȴְ㤨ޤ
 *
 */

static int shiftRegionCallExpand(MacroCallRegion *target)
{
    int     r, i;
    
    r = 0;
    for (i = 0; i < expandInfoN; i++) {
        if (equalInputText(target, &(expandInfo[i].input)) != TRUE) {
            continue;
        }
        /* ϸ㤦Ĥϴطޤ */

        if (expandInfo[i].input.end > target->start) {
            continue;
        }
        /* ΰ褬*targetˤʤĤطޤ */

        {
            int clen, elen;
            
            clen = expandInfo[i].input.end  - expandInfo[i].input.start;
            /* ƤӽФʸ - 1 */
            elen = expandInfo[i].output.end - expandInfo[i].output.start;
            /* Ÿʸ  - 1 */
            r += elen - clen;
            /*
             * 㤨СƤӽФεҤ10ʸǡŸ
             * 顤7ʸˤʤä硤ʹߤ3ʸˤޤ
             */
        }
    }
    return (r);
}

/*
 * ޥŸID=id ΰargn ˴ޤޤƤ MacroCallRegion *a
 * ϤΰŸȡMacroExpandRegionQueue *eq Ȥ
 * 褦ˤʤ롥
 * ΤȤΥޥʤִƤȡ
 * ϡִʸΤɤʬˤʤΤĴ٤ơ塼
 * *cq ֤(Τ褦ˤʤäƤʤͤͿ硤
 * ɤʤäƤΤޤ)
 *
 * Ȥ #, ## 黻Ҥ˴ؤϡιԤͤݤ
 * *a Ȥ  ؤʤ *eq ȤȤ
 *
 * ͤϡޥŸʸŪʸо줹
 * ʤ꥿ *cq ȤθĿ
 */

static int expandMacro(int id, int argn, MacroCallRegion *a,
                       MacroExpandRegionQueue *eq, MacroCallRegionQueue *cq)
{
    int             i, l, c, n;
    DEFINEinfo      *dinfo;
    MacroCallRegion answer;
    MacroArgInfo    *arg;
    
    /* ƤӽФ줿ޥ */
    dinfo = expandInfo[id].mac;
    /* 塼˥ץå夹뤿 MacroCallRegion */
    answer.type     = CALL_MACROEXPANSION;
    answer.macexpID = id;
    answer.macexp   = &(expandInfo[id]);
    
    l = 0;
    c = 0;
    n = 0;
    for (i = 0; i < dinfo->nref; i++) {
        ArgReference    *ref;
        ref = &((dinfo->ref)[i]);
        l += ref->nchar;
        arg = &((expandInfo[id].arg)[ref->argn]);
        /*fprintf(stderr, "  l = %d\n", l);*/
        if (ref->raw_before) {
            /* Ȥ ## ĤƤ */
            /* Ÿ줺ˡƬϢ³򤬼ʳϤΤޤޤη
               Ϥޤ  Ūʸʬ뤳Ȥ⤢ޤ       */
            if (ref->argn == argn) {
                answer.start = l + a->start - arg->trailing_space;
                answer.end   = l + a->end   - arg->trailing_space;
                if (a->start < arg->trailing_space) {
                    CPPinfoMessage("ŪʸϥޥŸ ID=%d ΰ %d  %d ܤλ(##)ǡäƤޤޤ\n", id+1, argn+1, n+1);
                    n++;
                } else {
                    CPPinfoMessage("ŪʸϥޥŸ ID=%d ΰ %d  %d ܤλ(##)ǡ%dʸǤ\n", id+1, argn+1, n+1, answer.start+1);
                    pushMacroCallRegionQueue(cq, answer);
                    c ++;
                    n ++;
                }
            }
            l += arg->raw_length - arg->trailing_space;
        } else if (ref->raw_after) {
            /* Ȥθ ## ĤƤ */
            /* Ϣ³򤬼ޤ   */
            if (ref->argn == argn) {
                answer.start = l + a->start;
                answer.end   = l + a->end  ;
                if (arg->raw_length -arg->following_space <= a->start) {
                    CPPinfoMessage("ŪʸϥޥŸ ID=%d ΰ %d  %d ܤλ(##)ǡäƤޤޤ\n", id+1, argn+1, n+1);
                    n++;
                } else {
                    CPPinfoMessage("ŪʸϥޥŸ ID=%d ΰ %d  %d ܤλ(##)ǡ%dʸǤ\n", id+1, argn+1, n+1, answer.start+1);
                    pushMacroCallRegionQueue(cq, answer);
                    c ++;
                    n ++;
                }
            }
            l += arg->raw_length - arg->following_space;
        } else if (ref->stringify) {
            /* Ȥ # ĤƤ */
            /* Ÿ줺ˡζ򤬼졤" ǳޤ
               ˰ "  \" ˡ \  \\ ֤ޤ
               ʸʬϵޤ
               Ȥ֤˴ؤ󤬸ʳ(1993.5.6)Ǥ
               ޤޤޤΤǡλˤϴְ㤨ޤ λ      */
            if (ref->argn == argn) {
                answer.start = l + a->start - arg->trailing_space +1;
                answer.end   = l + a->end   - arg->trailing_space +1;
                if (a->start < arg->trailing_space
                    || arg->raw_length -arg->following_space <= a->end) {
                    CPPinfoMessage("ŪʸϥޥŸ ID=%d ΰ %d  %d ܤλ(#)ǡäƤޤޤ\n", id+1, argn+1, n+1);
                    n++;
                } else {
                    CPPinfoMessage("ŪʸϥޥŸ ID=%d ΰ %d  %d ܤλ(#)ǡ%dʸǤ\n", id+1, argn+1, n+1, answer.start+1);
                    pushMacroCallRegionQueue(cq, answer);
                    c ++;
                    n ++;
                }
            }
            l += arg->stringified_length;
            /* stringified_length ˤϥơΣʸޤޤ롥 */
        } else {
            /*  #  ## դƤʤ
               Ÿ塤ޤ  ŸκݤŪʸʬƤ
               ⤷ޤ  塼 eq ȤĴ٤ƽʤޤ       */
            if (ref->argn == argn) {
                int m, j;
                m = usedMacroExpandRegionQueue(eq);
                j = 0;
                if (CPPinfoVerbose == TRUE) {
                    fprintf(stderr, "ŪʸϥޥŸ ID=%d ΰ %d  %d ܤλȤ", id+1, argn+1, n+1);
                }
                /* for (j=0; j<10; j++) {
                   MacroExpandRegion   e;
                   e = popMacroExpandRegionQueue(eq);
                   fprintf(stderr, " %d %d %d %d %d \n",
                   e.type, e.start, e.end, e.macexpID, e.argn);
                   pushMacroExpandRegionQueue(eq, e);
                   } 
                   exit(1);*/
                while (j<m) {
                    MacroExpandRegion   et;
                    et = popMacroExpandRegionQueue(eq);
                    pushMacroExpandRegionQueue(eq, et);
                    answer.start = l + et.start;
                    answer.end   = l + et.end  ;
                    if (CPPinfoVerbose == TRUE) {
                        /*fprintf(stderr, "--- %d %d %d ---", l, et.start, et.end);*/
                        fprintf(stderr, "%dʸ", answer.start+1);
                    }
                    pushMacroCallRegionQueue(cq, answer);
                    c++;
                    j++;
                }
                if (j==0) {
                    CPPinfoMessage("ФƤޤǤ\n");
                } else {
                    CPPinfoMessage("Ǥ\n");
                }
                n ++;
            }
            l += arg->expanded_length;
        }
    }
    return (c);
}

/*
 * ޥΰפ MacroCallRegion *target ΰ
 * ŸˤϡŸΰΤɤʬˤʤΤĴ١
 * η̤򥭥塼 *eq ֤
 * ͤŸΰˡ󡤸 *target 뤫
 * Ȥ
 */

static int completeMacroArg(MacroCallRegion *target, MacroExpandRegionQueue *eq)
{
    int id;
    
    id = isInMacroCall(target);
    if (id < 0) {
        /* ʤޥƤӽФ˴ޤޤʤ硤
           ʸϡޥΰפMacroExpandRegion ̤ */
        MacroExpandRegion   e;
        int         shift;
        
        if (CPPinfoVerbose == TRUE) {
            fprintf(stderr, "ŪʸϥޥƤӽФ ID=%d ΰ%dΤʤޥƤӽФˤϴޤޤƤޤ\n", target->macexpID+1, target->argn+1);
        }
        /* 塼˥ץå夹 MacroExpandRegion  */
        shift = shiftRegionCallExpand(target);
        e.type     = EXPAND_MACROARG;
        e.macexpID = target->macexpID;
        e.macexp   = target->macexp;    
        e.argn     = target->argn;
        e.start    = target->start +shift;
        e.end      = target->end   +shift;
        pushMacroExpandRegionQueue(eq, e);
        return (1);
    } else {
        /* ʤޥƤӽФ˴ޤޤ硤
           ƵŪ˽򤹤         */
        if (CPPinfoVerbose == TRUE) {
            fprintf(stderr, "ŪʸϥޥƤӽФ ID=%d ˴ޤޤޤ\n", id+1);
        }
        return (macroCallToExpand(id, target, eq));
    }
}

/*    ե륿פ MacroCallRegion *target ΰ
 * ŸˤϡŸΰΤɤʬˤʤΤĴ١
 * η̤򥭥塼 *eq ֤
 * ͤŸΰˡ󡤸 *target 뤫
 * Ȥ
 * ʸޥ˴ޤޤʤΤʤ 0 ֤
 */

int completeMacroExpand(MacroCallRegion *target, MacroExpandRegionQueue *eq)
{
    int id;
    
    id = isInMacroCall(target);
    if (id < 0) {
        /* ʸޥƤӽФ˴ޤޤʤ */
        /*  MacroExpandRegion   e;
            int         shift;*/
        
        if (CPPinfoVerbose == TRUE) {
            fprintf(stderr, "ŪʸϥޥƤӽФˤϴޤޤƤޤ\n");
        }
        /* 
         * shift = shiftRegionCallExpand(target);
         * e.type     = EXPAND_MACROARG;
         * e.macexpID = target->macexpID;
         * e.macexp   = target->macexp;    
         * e.argn     = target->argn;
         * e.start    = target->start +shift;
         * e.end      = target->end   +shift;
         * pushMacroExpandRegionQueue(eq, e);
         */
        return (-1);
    } else {
        /* ޥƤӽФ˴ޤޤ */
        if (CPPinfoVerbose == TRUE) {
            fprintf(stderr, "ŪʸϥޥƤӽФ ID=%d ˴ޤޤޤ\n", id+1);
        }
        return (macroCallToExpand(id, target, eq));
    }
}

/*
 * ޥƤӽФ ID=id ˴ޤޤ MacroCallRegion *t ˤĤ
 * (ޤޤʤ褦ͤϤϤɤʤäƤΤޤ)
 * ΥޥŸ塤*t Ÿ̤νΤɤ˹ԤΤ
 *  MacroExpandRegionQueue *q (塼(FIFO)֤)
 * ͤϡˡ *t 󸽤뤫ȤǤ
 * Ĥޤꡤ *q ȤθĿȰˤʤޤ
 * *t ޥΰ˴ޤޤʤϡ*t ŸˤϻĤ
 * ޤ  λ֤ͤ 0  ˤʤޤ         
 */

static int macroCallToExpand(int id, MacroCallRegion *target,
                             MacroExpandRegionQueue *eq)
{
    int             i;
    int             argn;
    int             nInArg, nInExpand, nInOutput;
    MacroCallRegion     argRegion;
    MacroCallRegion     expandRegion;
    MacroExpandRegionQueue  aq;
    MacroCallRegionQueue    cq;
    
    if (CPPinfoVerbose == TRUE) {
        fprintf(stderr, "ŪʸϤ%dʸǤ\n",
                target->start - expandInfo[id].input.start+1);
    }
    
    /* 
     * ˴ޤޤ뤫ʡ
     */
    argn = isInMacroArg(id, target);
    if (argn < 0) {
        CPPinfoMessage("ŪʸϥޥƤӽФΰ˴ޤޤʤä˾ǤƤޤޤ\n");
        return (0);
    }
    CPPinfoMessage("Ūʸϰ%d ˴ޤޤޤ\n", argn+1);
    CPPinfoMessage("ŪʸϤ%dʸǤ\n",
                   target->start - (expandInfo[id].arg)[argn].start+1);
    
    /*
     * ǤϡΰŸϤɤʤ뤫Ĵ٤Ƥߤޤ礦
     */
    createMacroExpandRegionQueue(&aq, CPPinfoQueueExtent);
    argRegion.type     = CALL_MACROARG;
    argRegion.macexpID = id;
    argRegion.macexp   = &(expandInfo[id]);
    argRegion.argn     = argn;
    argRegion.start    = target->start - (expandInfo[id].arg)[argn].start;
    argRegion.end      = target->end   - (expandInfo[id].arg)[argn].start  ;
    /* 
     * fprintf(stderr, ";;; %d, %d %d %d \n",
     *         (expandInfo[id].arg)[argn].start,
     *         (expandInfo[id].arg)[argn].end  ,
     *         argRegion.start, argRegion.end);
     */
    nInArg = completeMacroArg(&argRegion, &aq);
    /* nInArg ŸΰŪʸФƤ뤫ȤǤ */
    if (nInArg == 0) {
        if (CPPinfoVerbose == TRUE) {
            fprintf(stderr, "ޥŸID=%d ΰ%dŸ̡˴ޤޤƤŪʸϾǤƤޤޤ\n", id+1, argn+1);
        }
        return (0);
    } else {
        if (CPPinfoVerbose == TRUE) {
            fprintf(stderr, "ŪʸϥޥŸ ID=%d ΰ%dŸ̤ %d󸽤ޤ\n", id+1, argn+1, nInArg);
        }
    }
    
    /*
     * ŸѤΤǡΥޥŸˤĤĴ٤Ƥߤޤ礦
     */
    createMacroCallRegionQueue(&cq, CPPinfoQueueExtent);
    nInExpand = expandMacro(id, argn, &argRegion, &aq, &cq);
    /* nInExpand ϥޥִʸŪʸФƤΤȤ
       Ǥ
       㤨СäĤäƤ⡤ΰ٤⻲Ȥʤ
       褦ʾ硤0 ˤʤäƤޤޤ               */
    if (nInExpand == 0) {
        if (CPPinfoVerbose == TRUE) {
            fprintf(stderr, "ޥŸID=%d Ÿη̡ŪʸϾǤƤޤޤ\n", id+1);
        }
        return (0);
    }
    
    /*
     * ޥִλޤΤǡ줬ɤΤ褦˽Ϥ뤫
     * Ĵ٤ƤߤޤƱˤʤͥƥ󥰤åޤ
     */
    nInOutput = 0;
    for (i=0; i<nInExpand; i++) {
        int nestId;
        expandRegion = popMacroCallRegionQueue(&cq);
        nestId = isInMacroCall(&expandRegion);
        
        /*fprintf(stderr, "***** %d %d %d %d %d\n", expandRegion.type,
          expandRegion.start,  expandRegion.end,
          expandRegion.macexpID+1,  expandRegion.argn);*/
        
        if (nestId < 0) {
            /* ʤͥƥ󥰤Ϥʤä硤
               ʸϽ(expandInfo[id].output)̤ޤ */
            MacroExpandRegion   e;
            int         shift;
            
            shift = shiftRegionCallExpand(&expandRegion);
            /*  褽ΤΤ򼨤ФϤΤޤޥԡ */
            e.type     = expandInfo[id].output.type;
            e.fname    = expandInfo[id].output.fname;
#ifdef PIDB_USE_FILENAME_INDEX
            e.fname_idx = expandInfo[id].output.fname_idx;
#endif
            e.macexpID = expandInfo[id].output.macexpID;
            e.macexp   = expandInfo[id].output.macexp;
            e.argn     = expandInfo[id].output.argn;
            e.start    = expandInfo[id].output.start + expandRegion.start +shift;
            e.end      = expandInfo[id].output.start + expandRegion.end   +shift;
            /* 嵭2ԤκǸ -1 ˤϳοޤ(¼) */
            /* ΥȤϼäޤ̵뤷Ʋ(¼) */
            pushMacroExpandRegionQueue(eq, e);
            nInOutput ++;
            
        } else {
            /* ʤͥƥ󥰤ä硤
               ƵŪ˽ʤޤ       */
            if (CPPinfoVerbose == TRUE) {
                fprintf(stderr, "Ūʸ<Ϥ˥ޥƤӽФ ID=%d ˴ޤޤޤ\n",
                        nestId+1);
            }
            nInOutput += macroCallToExpand(nestId, &expandRegion, eq);
        }
    }
    
    freeMacroExpandRegionQueue(&aq);
    freeMacroCallRegionQueue(&cq);
    return (nInOutput);
}
