/* 
 * Program:             $RCSfile: mqueueCPPinfo.c,v $  $Revision: 30.1 $
 * 
 * Purpose:             
 *                      ޥե塼
 * 
 * Author:              T.Mimura  1993/12/01
 *                      S.Yamamoto  1994/09/01
 * 
 * (C) Copyright:       T.Mimura and S.Yamamoto  1994 - 1996
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: mqueueCPPinfo.c,v 30.1 1998/09/24 11:26:54 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

/*
 * MacroCallRegionQueue Υ塼
 */

/*  */
void    createMacroCallRegionQueue(MacroCallRegionQueue *queue, int extent)
{
    queue->buf    = spdMalloc(sizeof(MacroCallRegion) * extent);
    queue->extent = extent;
    queue->top = queue->tail = 0;
    queue->used = 0;
    return;
}

/*  */
void    freeMacroCallRegionQueue(MacroCallRegionQueue *queue)
{
    spdFree(queue->buf);
    queue->extent = 0;
    return;
}

/* PUSH */
void pushMacroCallRegionQueue(MacroCallRegionQueue *queue, MacroCallRegion reg)
{
    if (queue->used >= queue->extent) {
        spdErrorExit("MacroCallRegionQueue overflow.\n");
    }
    (queue->buf)[queue->tail] = reg;
    queue->tail ++;
    if (queue->tail >= queue->extent) queue->tail = 0;
    queue->used ++;
    return;
}

/* POP */
MacroCallRegion popMacroCallRegionQueue(MacroCallRegionQueue *queue)
{
    MacroCallRegion r;
    
    if (queue->used <= 0) {
        spdErrorExit("MacroCallRegionQueue is empty.\n");
    }
    r = (queue->buf)[queue->top];
    queue->top ++;
    if (queue->top >= queue->extent) queue->top = 0;
    queue->used --;
    
    return (r);
}

/* ߤλ */
int usedOBMacroCallRegionQueue(MacroCallRegionQueue *queue)
{
    return (queue->used);
}

/*
 * MacroExpandRegionQueue Υ塼
 */

/*  */
void    createMacroExpandRegionQueue(MacroExpandRegionQueue *queue, int extent)
{
    queue->buf    = spdMalloc(sizeof(MacroExpandRegion) * extent);
    queue->extent = extent;
    queue->top = queue->tail = 0;
    queue->used = 0;
    return;
}

/*  */
void    freeMacroExpandRegionQueue(MacroExpandRegionQueue *queue)
{
    spdFree(queue->buf);
    queue->extent = 0;
    return;
}

/* PUSH */
void    pushMacroExpandRegionQueue(MacroExpandRegionQueue *queue, MacroExpandRegion reg)
{
    if (queue->used >= queue->extent) {
        spdErrorExit("MacroExpandRegionQueue overflow.\n");
    }
    (queue->buf)[queue->tail] = reg;
    queue->tail ++;
    if (queue->tail >= queue->extent) queue->tail = 0;
    (queue->buf)[queue->tail] = reg;
    queue->used ++;
    return;
}

/* POP */
MacroExpandRegion   popMacroExpandRegionQueue(MacroExpandRegionQueue *queue)
{
    MacroExpandRegion   r;
    
    if (queue->used <= 0) {
        spdErrorExit("MacroExpandRegionQueue is empty.\n");
    }
    r = (queue->buf)[queue->top];
    queue->top ++;
    if (queue->top >= queue->extent) queue->top = 0;
    queue->used --;
    
    return (r);
}

/* ߤλ */
int usedMacroExpandRegionQueue(MacroExpandRegionQueue *queue)
{
    return (queue->used);
}
