/* 
 * Program:             $RCSfile: revmacroCPPinfo.c,v $  $Revision: 30.8 $
 * 
 * Purpose:             ޥŸ(".i"".c")é롥
 * 
 * Author:              T.Mimura  1993/12/01
 *                      S.Yamamoto  1994/09/01
 * 
 * (C) Copyright:       T.Mimura and S.Yamamoto  1994 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: revmacroCPPinfo.c,v 30.8 2003/06/28 15:31:13 yamamoto Exp yamamoto $";
#endif

/*
 * ΥΥȤˤ
 *   1Υͥƥ󥰤ȤϡʬΥ줿ޥΰƤ
 * ФȤͥƥ󥰡
 *   2Υͥƥ󥰤Ȥϡޥִȡʸ󤫤
 * ƤӽФȤͥƥ󥰡
 */

#include <stdio.h>
#include <Sapid/Sapid.h>

#define NOT_SUPPORT_CONCATENATE 1   /* ## 򥵥ݡȤʤ */
#define NOT_SUPPORT_STRINGIFY   1   /* # 򥵥ݡȤʤ */        

static int shiftRegionExpandCall(int id, MacroExpandRegion *region);
static int findExpandInfoCalledMacroExpand(MacroExpandRegion *exRegion,
                                           int exId);
static int findNestingType2Bottom(MacroExpandRegion *exRegion);
static int macroArgLengthBeforeExpansion(MacroExpandRegion *exRegion);

/*
 * Ĥ MacroExpandRegionΥ֥ȤˤĤ
 * νϥƥȤƱ줫ɤĴ٤롥
 */

SpdBoolean equalOutputText(MacroExpandRegion *a, MacroExpandRegion *b)
{
    SpdBoolean r;
    
    r = FALSE;
    if (a->type != b->type) {
        return (FALSE);
    }
    switch (a->type) {
      case EXPAND_FILE:
#ifdef PIDB_USE_FILENAME_INDEX
        if (a->fname_idx == b->fname_idx) 
#else
        if (SPD_STREQ(a->fname, b->fname))
#endif
            {
                r = TRUE;
            }
        break;
      case EXPAND_MACROARG:
        if (a->macexpID == b->macexpID && a->argn == b->argn) {
            r=TRUE;
        }
        break;
    }
    return (r);
}

/*
 * MacroExpandRegion *region ƽ¦ǤϲʸäĴ١
 * *region ʸȤκ(ϤϤ٤Ʋʸʤʤä)
 * ֤
 */

static int shiftRegionExpandCall(int id, MacroExpandRegion *region)
{
    int     r, i;
    
    r = 0;
    for (i=0; i<expandInfoN; i++) {
        if (equalOutputText(region, &(expandInfo[i].output)) &&
            region->start <= expandInfo[i].output.start &&
            expandInfo[i].output.end <= region->end) {
            if (expandInfo[i].input.type != CALL_MACROEXPANSION ||
                expandInfo[i].input.macexpID != id) {
                continue;
            }
            {
                int callLength, expandLength;

                /* fprintf(stderr, "id %d\n", i); */
                callLength = expandInfo[i].input.end -
                    expandInfo[i].input.start;
                expandLength = expandInfo[i].output.end -
                    expandInfo[i].output.start;
                r += expandLength - callLength;
            }
        }
    }
    return (r);
}

/*
 *  MacroExpandRegion ID;start  ID;end ޤǤΥޥŸ
 * νϷ̤Τʤ˴ޤޤΤĴ١ޤΤ(ʣ
 * 礬)Ǻǽ(IDֹ椬äȤ⾮)ޥŸ
 *  ID ֤ ̵ -1 ֤
 * start  end ξοˤȡޥŸܤ
 */

int isInMacroExpand(MacroExpandRegion *exRegion, int start, int end)
{
    int     i;
    
    start = SPD_MAX(start,0);
    if (end < 0) {
        end = expandInfoN - 1;
    }
    end = SPD_MIN(end + 1, expandInfoN);
    if (start > end) {
        return (-1);
    }

#ifdef DEBUG    
    CPPinfoMessage("2 expandInfoN %d start %d end %d\n",
                   expandInfoN, start, end);

#endif    

    for (i=start; i<end; i++) {
        if (equalOutputText(&(expandInfo[i].output), exRegion) == FALSE) {
            continue;
        }
        if (expandInfo[i].output.start <= exRegion->start &&
            exRegion->end <= expandInfo[i].output.end) {
            return (i);
        }
    }
    return (-1);
}

/*
 *  MacroExpandRegion Ÿ̤ν˴ޤޥŸ
 * θƽиޥŸID:exId ִȡʸǤΤ뤫
 * Ĵ(äƤĤ̵Ϥ)ФΥޥŸID̵֤
 *  -1 ֤
 */

static int findExpandInfoCalledMacroExpand(MacroExpandRegion *exRegion,
                                           int exId)
{
    int     n, id, top;
    
    top = 0;
    id = -1;
    while ((n=isInMacroExpand(exRegion, top, -1)) != -1) {
        if (expandInfo[n].input.type == CALL_MACROEXPANSION) {
            if (expandInfo[n].input.macexpID == exId) {
                id = n;
                break;
            }
        }
        top = n+1;
    }
    return (id);
}

/*
 *  MacroExpandRegion 򡤽Ϸ̤˴ޤǡǸŸ
 * Ϥޤꡤǽ˽äΤޥŸ椫鸫դ롥 
 * ޥŸդéǺǽ˸ʤФʤʤޥŸǤ롥
 *  MacroExpandRegion ˴ޤΤʣϡƽдط
 * ŪΤΤ֤
 * ŪΥޥŸ󤬤ФΥޥŸID֤
 * Ĥʤ-1֤
 */

static int findNestingType2Bottom(MacroExpandRegion *exRegion)
{
    int n, id;
    
    n = isInMacroExpand(exRegion, 0, -1);

#ifdef DEBUG    
    CPPinfoMessage("type %d  expID %d  argn %d  n %d\n",
                   exRegion->type, exRegion->macexpID+1, exRegion->argn+1, n+1);
#endif    

    if (n < 0) {
        return (-1);
    }
    
    /* 
     * ϰϤ˴ޤޥŸIDĤޤ
     * ΥޥŸִȡʸ󤫤ƤӽФ졤Ľ
     * ˻ϰϤޤΤСĤäޥŸ(ID:id)
     * ֺǸŸϤޤǽŸäޥŸ
     * ǤϤޤ
     */

    id = n;
    while (1) {
        n = findExpandInfoCalledMacroExpand(exRegion, id);
        if (n<0) break;
        id = n;
    }
    return (id);
}

/*
 * ޥŸID:id ˴ޤޤ뤳ȤʬäƤ MacroExpandRegion
 * *exRegion ˤĤ(ޥŸID:id ν *exRegion ȤƱ
 * ƥȤΤϤǤ)줬ΥޥŸΰ˴ޤޤƤ뤫
 * ɤĴ١ޤޤƤС줬ΥޥŸβܤΰ
 * ʤΤ(0,1,...)֤ޤޤƤʤС-1 ֤
 * ޤޤޤϡ*n ˤ줬ΰȤβʸܤʤΤ롥
 */

int isInMacroExpandArg(int id, MacroExpandRegion *exRegion, int *n)
{
    DEFINEinfo      *def;
    MacroArgInfo    *arg;
    int         i, l, c, d, shift, cutlength;
    
    {
        MacroExpandRegion   tmp;
        tmp = *exRegion;
        tmp.start = expandInfo[id].output.start;
        tmp.end   = exRegion->start;
        shift = shiftRegionExpandCall(id, &tmp);

#ifdef DEBUG    
        CPPinfoMessage("shift %d\n", shift);
#endif  

    }
    def = expandInfo[ id ].mac;
    c = exRegion->start - expandInfo[id].output.start - shift;

#ifdef DEBUG    
    CPPinfoMessage("id %d  start %d\n", id+1, exRegion->start+1);
#endif    

    l = 0;
    for (i=0; i<def->nref; i++) {
        ArgReference    *ref;
        ref = &((def->ref)[i]);
        
        if (l<=c && c<l+ref->nchar) return (-1);
        l += ref->nchar;
        arg = &((expandInfo[id].arg)[ ref->argn ]);
        if (ref->raw_before && ref->raw_after) {

            /* λȤξ¦ ## ĤƤ */
#if NOT_SUPPORT_CONCATENATE
            return SAPID_CPP_NOT_SUPPORTED;
#else
            d = arg->raw_length - arg->trailing_space - arg->following_space ;
            cutlength = arg->trailing_space;
#endif

        } else if (ref->raw_before) {

            /* λȤ ##  */
#if NOT_SUPPORT_CONCATENATE
            return SAPID_CPP_NOT_SUPPORTED;
#else           
            d = arg->raw_length - arg->trailing_space;
            cutlength = arg->trailing_space;
#endif          

        } else if (ref->raw_after) {

            /* λȤθ ##  */
#if NOT_SUPPORT_CONCATENATE
            return SAPID_CPP_NOT_SUPPORTED;
#else           
            d = arg->raw_length - arg->following_space;
            cutlength = 0;
#endif

        } else if (ref->stringify) {
            /* λȤ # ĤƤ */
            /* ʸ󲽤'"''\\' ȡ
               ְ㤨뤳Ȥ롥*/

#if NOT_SUPPORT_STRINGIFY
            return SAPID_CPP_NOT_SUPPORTED;
#else
            d = arg->stringified_length;
            cutlength = arg->trailing_space -1;
            /* ιԤ -1  qatation mark ʬ    */
#endif          

        } else {
            /* #  ## ĤƤʤ̤ΰ */
            d = arg->expanded_length;
            cutlength = 0;
        }
        if (l <= c && c < l + d) {
            *n = c-l +cutlength;
            /* Ūʸβʸܤ## ʤɤǥåȤ줿ʬ
               ͤ롥 */
            return (i);
        }
        l += d;
    }
    return (-1);
}

/*
 * 2(ޥΰ)  MacroExpandRegion *exRegion Ÿ
 * ʸäĴ٤롥
 * *exRegion ޥŸ̤ڤޤǤˤưꡥ
 *
 */

static int macroArgLengthBeforeExpansion(MacroExpandRegion *exRegion)
{
    int     i, len;
    
    len = exRegion->end - exRegion->start;
    for (i=0; i<expandInfoN; i++) {
        int callLen, expandLen;
        if (equalOutputText(exRegion, &(expandInfo[i].output)) == FALSE) {
            continue;
        }
        if (! (exRegion->start <= expandInfo[i].output.start &&
               expandInfo[i].output.end <= exRegion->end)) {
            continue;
        }
        callLen   = expandInfo[i].input.end  - expandInfo[i].input.start ;
        expandLen = expandInfo[i].output.end - expandInfo[i].output.start;
        len += (callLen - expandLen);
    }
    return (len);
}

/*
 * ĤνϥƥȤˤĤƥޥŸΥͥƥ󥰤é롥
 *
 * *target бʸǽŪˤϥƥȤΤɤ뤫
 * MacroCallRegion *result ֤ *result 
 * *target 2(ޥΰŸ)ʤ顤Ʊޥ
 * 򼨤2(ʬΥ줿ޥΰ)Ǥ롥
 * *target 1(ϥХåե)ʤ顤1ϥեǤ롥
 *
 * *target бʸϥƥȤ˸ʤʤ -1 ֤
 * ʸޥŸΰ˴ޤޤƤʤ 0 ֤
 * ʸޥŸ˴ޤޤ줺ϥƥȤ̤Τʤ1
 * ֤ λ*target νϥƥȤޥΰʤ *clRegion
 * ϰ̣Ĥեʤ̣ʤ
 */

int reverseParseAnOutputText(MacroExpandRegion *target,
                             MacroCallRegion *result)
{
    int         exId, targetLength, argn, n, r, refn;
    MacroExpandRegion   exRegion;
    MacroCallRegion clRegion;
    
    CPPinfoMessage("*** ϥƥ(");
    switch (target->type) {
      case EXPAND_FILE:
        CPPinfoMessage("ϥե'%s'", target->fname);
        break;
      case EXPAND_MACROARG:
        CPPinfoMessage("ޥŸID:%d%d",
                       target->macexpID+1, target->argn+1);
        break;
    }
    CPPinfoMessage(")˴ؤĴϤޤ\n");
    
    targetLength = target->end - target->start;
    exId = findNestingType2Bottom(target);
    if (exId < 0) {
        CPPinfoMessage("ʸϥޥŸˤϴޤޤޤ\n");
        switch (target->type) {
          case EXPAND_MACROARG:
            result->type     = CALL_MACROEXPANSION;
            result->macexpID = target->macexpID;
            result->macexp   = target->macexp;
            {
                int         len;
                MacroExpandRegion   tmp;
                tmp = *target;
                tmp.start = 0;
                tmp.end   = target->start;
                len = macroArgLengthBeforeExpansion(&tmp);
                result->start    = len;
                result->end      = len + targetLength;
            }
            r = 1;
            break;
          case EXPAND_FILE:
            r = 1;
            break;
        }
        CPPinfoMessage("*** ϥƥ(");
        switch (target->type) {
          case EXPAND_FILE:
            CPPinfoMessage("ϥե'%s'", target->fname);
            break;
          case EXPAND_MACROARG:
            CPPinfoMessage("ޥŸID:%d%d",
                           target->macexpID+1, target->argn+1);
            break;
        }
        CPPinfoMessage(")˴ؤĴ򽪤ޤ\n");
        return (r);
    }
    exRegion = *target;
    while (1) {
        CPPinfoMessage("ʸϥޥŸ ID=%d ˴ޤޤޤ\n",
                       exId + 1);
        refn = isInMacroExpandArg(exId, &exRegion, &n);

#if NOT_SUPPORT_CONCATENATE
        if ( refn == SAPID_CPP_NOT_SUPPORTED ) {
            CPPinfoMessage( "ʸ̤ݡȤǤ\n" );
            return SAPID_CPP_NOT_SUPPORTED;
        }
#endif

        if (refn < 0) {
            CPPinfoMessage("ʸϰ˴ޤޤƤޤ\n");
            r = -1;     
            break;
        }
        argn = ((expandInfo[exId].mac)->ref)[refn].argn;
        CPPinfoMessage("ʸ%d%dʸܤǤ\n",
                       argn+1, n+1);
        if (((expandInfo[exId].mac)->ref)[refn].raw_before == TRUE ||
            ((expandInfo[exId].mac)->ref)[refn].raw_after == TRUE ||
            ((expandInfo[exId].mac)->ref)[refn].stringify == TRUE) {
            *result = expandInfo[exId].input;
            result->start = (expandInfo[exId].arg)[argn].start + n;
            result->end = (expandInfo[exId].arg)[argn].start + n + targetLength;
            if (((expandInfo[exId].mac)->ref)[refn].stringify == TRUE) {
                CPPinfoMessage("ΰȤˤ # դƤޤ\n");
                if (n <= -1 && -1 <= n+targetLength) {
                    CPPinfoMessage("ʸϡʸ󲽤ν \" ˽Ťʤޤ\n");
                    r = -1;
                } else if (n<= (expandInfo[exId].arg)[argn].stringified_length-1 &&
                           (expandInfo[exId].arg)[argn].stringified_length-2 <= n+targetLength) {
                    CPPinfoMessage("ʸϡʸ󲽤θ \" ˽Ťʤޤ\n");
                    r=-1;
                } else {
                    r = 0;
                }
            } else {
                CPPinfoMessage("ΰȤˤ ## դƤޤ\n"
                               "ߤξϥݡȤƤޤ\n");

#if NOT_SUPPORT_CONCATENATE
                r = SAPID_CPP_NOT_SUPPORTED;
#else
                r = 0;
#endif

            }
            break;
        }
        /* ŪʸޥŸ˴ޤޤ졤ˤΰ˴ޤޤ
           ʬޤ */
        exRegion.type     = EXPAND_MACROARG;
        exRegion.macexpID = exId;
        exRegion.macexp   = &(expandInfo[ exId ]);
        exRegion.argn     = argn;
        exRegion.start    = n;
        exRegion.end      = n+targetLength;
        if ( ( r = reverseParseAnOutputText(&exRegion, &clRegion)) <0) {
            break;
        }

#ifdef DEBUG    
        CPPinfoMessage("clRegion.start = %d\n", clRegion.start);
#endif

        /* clRegion ˤʬΥ줿ޥΰˤ *target б
           ʸΰ֤äƤޤ */
        
        if (expandInfo[exId].input.type == CALL_MACROARG) {
            /* ĤäޥŸθƽиޥΰä硤ʾ塤
               νϥƥȤ˽Ϥ줿ޥŸϤ⤦̵Τǵ롥 */
            if (target->type != EXPAND_MACROARG) {
                spdErrorExit("ޥŸ˰۾郎ޤ(ƤӽФ줿ޥ˽ϤƤޤ)\n");
            }
            result->type     = CALL_MACROARG;
            result->macexpID = target->macexpID;
            result->macexp   = target->macexp;
            result->argn     = target->argn;
            result->start    = (expandInfo[exId].arg)[argn].start + clRegion.start;
            result->end      = result->start + targetLength;
            r = 0;  
            break;
        }
        if (expandInfo[exId].input.type == CALL_FILE) {
            /* Ĥäޥθƽиեä硤Ʊͤ˵롥 */
            /* ΥޥνϥեΤϤǤ롥           */
            if (target->type != EXPAND_FILE) {
                spdErrorExit("ޥŸ˰ʾ夬ޤ(ϥե뤫ƤӽФ줿ޥϥե˽ϤƤޤ)\n");
            }
            result->type     = CALL_FILE;
            result->fname    = expandInfo[exId].input.fname;
#ifdef PIDB_USE_FILENAME_INDEX
            result->fname_idx = expandInfo[exId].input.fname_idx;
#endif
            result->start    = (expandInfo[exId].arg)[argn].start + clRegion.start;
            result->end      = result->start + targetLength;
            r = 0;  
            break;
        }
        exRegion = *target;
        exRegion.start = expandInfo[ expandInfo[exId].input.macexpID ].output.start
            + (expandInfo[ exId ].arg)[ argn ].start
                + clRegion.start;
        exRegion.end   = exRegion.start + targetLength;
#ifdef DEBUG
        CPPinfoMessage("Ƭ               === %d\n", expandInfo[expandInfo[exId].input.macexpID].output.start);
        CPPinfoMessage("ΰΰ         === %d\n", (expandInfo[exId].arg)[argn].start);
        CPPinfoMessage("ǤŪʸΰ === %d\n", clRegion.start);
        CPPinfoMessage("exRegion.start === %d\n", exRegion.start);
#endif  
        exId = expandInfo[ exId ].input.macexpID;
    }
    
    CPPinfoMessage("*** ϥƥ(");
    switch (target->type) {
      case EXPAND_FILE:
        CPPinfoMessage("ϥե'%s'", target->fname);
        break;
      case EXPAND_MACROARG:
        CPPinfoMessage("ޥŸID:%d%d", target->macexpID+1, target->argn+1);
        break;
    }
    CPPinfoMessage(")˴ؤĴ򽪤ޤ\n");
    
    return (r);
}
