/* 
 * Program:             $RCSfile: exprUtil.c,v $  $Revision: 30.4 $
 * 
 * Purpose:             ʬह롥
 * 
 * Author:              T.Hidaka  1998/07/06
 *                      S.Yamamoto  1998/07/10
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: exprUtil.c,v 30.4 2002/10/21 07:26:06 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

int smuGetExprSort(SpdObjId exprId)
{
    SpdObjId    operatorId;
    int         opsort, exprsort;

    exprsort = spdGetAttrValInt(exprId, "sort");
    if (exprsort != EXPR_SORT_ARITH) {
        return exprsort;
    }

    operatorId = spdGetARelObj(exprId, "expr_op", "p-id");
    if (operatorId == SPD_NON_ID) {
        return EXPR_SORT_ARITH;
    }

    opsort = spdGetAttrValInt(operatorId, "sort");
    switch (opsort) {
      case OP_L_ARRAY:
      case OP_R_ARRAY:
        return EXPR_SORT_ARRAY;
      case OP_POINTER:
        return EXPR_SORT_POINTER;
      case OP_ADDRESS:
        return EXPR_SORT_ADDRESS;
      case OP_ARROW:
        return EXPR_SORT_POINTER_MEMBER;
      case OP_DOT:
        return EXPR_SORT_MEMBER;
      case OP_INC:
      case OP_DEC:
      case OP_PLUS:
      case OP_MINUS:
      case OP_MUL:
      case OP_DIV:
      case OP_MOD:
      case OP_ADD:
      case OP_SUB:
      case OP_ASSIGN:
      case OP_A_ADD:
      case OP_A_SUB:
      case OP_A_MUL:
      case OP_A_DIV:
      case OP_A_MOD:
      case OP_COMMA:
      case OP_L_PAR:
      case OP_R_PAR:
        return EXPR_SORT_ARITH;
      case OP_B_NOT:
      case OP_B_AND:
      case OP_B_XOR:
      case OP_B_OR:
      case OP_A_AND:
      case OP_A_XOR:
      case OP_A_OR:
        return EXPR_SORT_BIT;
      case OP_SHL:
      case OP_SHR:
      case OP_A_SHL:
      case OP_A_SHR:
        return EXPR_SORT_SHIFT;
      case OP_LT:
      case OP_LE:
      case OP_GT:
      case OP_GE:
      case OP_EQ:
      case OP_NE:
        return EXPR_SORT_COMPARE;
      case OP_L_AND:
      case OP_L_OR:
      case OP_NOT:
        return EXPR_SORT_LOGICAL;
      case OP_SIZEOF:
      case OP_SIZEOF_TYPE:
        return EXPR_SORT_SIZEOF;
      case OP_CAST:
        return EXPR_SORT_CAST;
      case OP_QUESTION:
      case OP_COLON:
        return EXPR_SORT_TRI;
      case OP_BUILTIN:
      case OP_BUILTIN_TYPE:
        return EXPR_SORT_BUILTIN;
    }

    return EXPR_SORT_ARITH;
}
