/* 
 * Program:             $RCSfile: getAProgramName.c,v $  $Revision: 30.38 $
 * 
 * Purpose:
 * 
 * Author:              A.Watanabe  1996/05/15
 *                      S.Yamamoto  1996/06/05
 * 
 * (C) Copyright:       A.Watanabe and S.Yamamoto  1996 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: getAProgramName.c,v 30.38 2003/06/28 15:31:23 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

SpdString smuGetAProgramName(void)
{
    FILE        *fp;
    SpdDBObj    obj;
    SpdInfo     *info;
    int         prog_num;

    static char buffer[SPD_LINE_LEN + 1];
    
    if (!smuIsValidSDB()) {                 /* SDBå롥 */
        spdErrorExit(SPD_MSG_INVALID_SDB, spdGetSDBdir());
    }

    /* Formatꤹ롥 */
    info = spdOpenSDBinfo();
    if (SPD_STREQ(spdGetInfoString(info, "BINARY_FORMAT_SDB"), "TRUE")) {
        spdSetReadSDBformat(SAPID_BINARY_FORMAT_SDB);
    } 
    prog_num = spdGetInfoInt(info, "program", 0);
    spdCloseInfo(info);

    if (prog_num == 0) {
        spdWarning("No program object.\n");
        return (NULL);
    }

    /* Read one object. */
    fp = spdOpenSDBfile(I_MODEL_DIR, "program", SAPID_O_READ);
    obj = spdReadObj(fp, SPD_CID_PROGRAM);
    strcpy(buffer, obj.svalue[SPD_AID_PROGRAM_NAME - SpdObjIValN]);
    spdFreeStrsInObj(obj);
    spdFclose(fp);
    
    return (buffer);
}

/*
 * SDBå롥ˡåɲä뤳ȡ
 */

SpdBoolean smuIsValidSDB(void)
{
    SpdInfo     *info;
    char        fname[FILENAME_MAX + 1];

    /* SDB¸ߤå롥 */
    if (!spdIsDirectory(spdGetSDBdir())) {
        spdError("smuIsValidSDB(): " SPD_MSG_NO_SDB, spdGetSDBdir());
        return (FALSE);
    }

    /* SAPID_VALIDATION_FILE_1¸ߤå롥 */
    strcpy(fname, spdGetSDBdir());
    strcat(fname, "/" SAPID_VALIDATION_FILE_1);
    if (!spdIsFile(fname)) {
        spdError("smuIsValidSDB(): \"%s\": No such file.\n", fname);
        return (FALSE);
    }

    /*
     * SDBѤץࡤʤץsdb4ƤӽФ줿ΤǤ
     * ʤץ˴ؤơSAPID_VALIDATION_FILE_2¸ߤå롥
     */
    if (getenv("SAPID_CALLED_IN_SDB4") == NULL) { 
        strcpy(fname, spdGetSDBdir());
        strcat(fname, "/" SAPID_VALIDATION_FILE_2);
        if (!spdIsFile(fname)) {
            spdError("smuIsValidSDB(): \"%s\": No such file.\n", fname);
            return (FALSE);
        }
    }

    info = spdOpenSDBinfo();
    /* Check validity of SpdInfo. */
    if (spdGetInfoInt(info, "SapidVersion", -1) == -1) {
        spdError("smuIsValidSDB(): Invalid SpdInfo file.\n");
        spdCloseInfo(info);
        return (FALSE);
    } 
    /* Check SDB version. */
    if (spdGetInfoInt(info, "SapidSDBVersion", 0) != SapidSDBVersion) {
        spdError("smuIsValidSDB(): SDB version %d should be %d.\n",
                 spdGetInfoInt(info, "SapidSDBVersion", 0), SapidSDBVersion);
        spdCloseInfo(info);
        return (FALSE);
    }
    /* Check PIDB version. */
    if (spdGetInfoInt(info, "SapidPIDBVersion", 0) != SapidPIDBVersion) {
        spdError("smuIsValidSDB(): PIDB version %d should be %d.\n",
                 spdGetInfoInt(info, "SapidPIDBVersion", 0), SapidPIDBVersion);
        spdCloseInfo(info);
        return (FALSE);
    }
    spdCloseInfo(info);

    return (TRUE);
}
