/* 
 * Program:             $RCSfile: operatorUtil.c,v $  $Revision: 30.6 $
 * 
 * Purpose:             黻Ҥʬह롥
 * 
 * Author:              T.Hidaka  1997/06/27
 *                      S.Yamamoto  1997/08/04
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1997 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: operatorUtil.c,v 30.6 2002/10/21 07:26:07 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

static int opcategory[OP_LAST];
static int opnterms[OP_LAST];
static int opcategoryflag = FALSE;

int smuGetOperatorTerms(SpdObjId op)
{
    if (op == SPD_NON_ID)
        return 0;

    if (spdGetClassId(op) != SPD_CID_OPERATOR) {
        return 0;
    }
    
    if (!opcategoryflag)
        smuInitOperatorCategory();

    return opnterms[spdGetAttrValInt(op, "sort")];
}

int smuGetOperatorCategory(SpdObjId op)
{
    if (op == SPD_NON_ID)
        return 0;

    if (spdGetClassId(op) != SPD_CID_OPERATOR) {
        return 0;
    }

    if (!opcategoryflag)
        smuInitOperatorCategory();

    return opcategory[spdGetAttrValInt(op, "sort")];
}

int smuInitOperatorCategory(void)
{
    if (opcategoryflag)
        return 0;

    opcategory[OP_ARROW] = 0;
    opcategory[OP_DOT] = 0;
    opcategory[OP_NOT] = OPCATEGORY_INT | OPCATEGORY_LOGICAL;
    opcategory[OP_B_NOT] = OPCATEGORY_INT;
    opcategory[OP_INC] = OPCATEGORY_ASSIGN | OPCATEGORY_ARITH;
    opcategory[OP_DEC] = OPCATEGORY_ASSIGN | OPCATEGORY_ARITH;
    opcategory[OP_PLUS] = OPCATEGORY_ARITH | OPCATEGORY_COMMUTATIVE;
    opcategory[OP_MINUS] = OPCATEGORY_ARITH;
    opcategory[OP_POINTER] = 0;
    opcategory[OP_ADDRESS] = OPCATEGORY_LVALUE;
    opcategory[OP_MUL] = OPCATEGORY_ARITH | OPCATEGORY_COMMUTATIVE;
    opcategory[OP_DIV] = OPCATEGORY_ARITH;
    opcategory[OP_MOD] = OPCATEGORY_INT;
    opcategory[OP_ADD] = OPCATEGORY_ARITH | OPCATEGORY_POINTER | OPCATEGORY_COMMUTATIVE;
    opcategory[OP_SUB] = OPCATEGORY_ARITH | OPCATEGORY_POINTER | OPCATEGORY_COMMUTATIVE;
    opcategory[OP_SHL] = OPCATEGORY_INT | OPCATEGORY_TRASHRTYPE;
    opcategory[OP_SHR] = OPCATEGORY_INT | OPCATEGORY_TRASHRTYPE;
    opcategory[OP_LT] = OPCATEGORY_LOGICAL | OPCATEGORY_ARITH | OPCATEGORY_POINTER;
    opcategory[OP_LE] = OPCATEGORY_LOGICAL | OPCATEGORY_ARITH | OPCATEGORY_POINTER;
    opcategory[OP_GT] = OPCATEGORY_LOGICAL | OPCATEGORY_ARITH | OPCATEGORY_POINTER;
    opcategory[OP_GE] = OPCATEGORY_LOGICAL | OPCATEGORY_ARITH | OPCATEGORY_POINTER;
    opcategory[OP_EQ] = OPCATEGORY_LOGICAL | OPCATEGORY_ARITH | OPCATEGORY_POINTER | OPCATEGORY_COMMUTATIVE;
    opcategory[OP_NE] = OPCATEGORY_LOGICAL | OPCATEGORY_ARITH | OPCATEGORY_POINTER | OPCATEGORY_COMMUTATIVE;
    opcategory[OP_B_AND] = OPCATEGORY_INT | OPCATEGORY_COMMUTATIVE;
    opcategory[OP_B_XOR] = OPCATEGORY_INT | OPCATEGORY_COMMUTATIVE;
    opcategory[OP_B_OR] = OPCATEGORY_INT | OPCATEGORY_COMMUTATIVE;
    opcategory[OP_L_AND] = OPCATEGORY_LOGICAL | OPCATEGORY_INT | OPCATEGORY_SEQUENCEP;
    opcategory[OP_L_OR] = OPCATEGORY_LOGICAL | OPCATEGORY_INT | OPCATEGORY_SEQUENCEP;
    opcategory[OP_ASSIGN] = OPCATEGORY_ASSIGN | OPCATEGORY_ARITH | OPCATEGORY_TRASHLVALUE | OPCATEGORY_TRASHRTYPE;
    opcategory[OP_A_ADD] = OPCATEGORY_ASSIGN | OPCATEGORY_ARITH | OPCATEGORY_POINTER | OPCATEGORY_TRASHRTYPE;
    opcategory[OP_A_SUB] = OPCATEGORY_ASSIGN | OPCATEGORY_ARITH | OPCATEGORY_POINTER | OPCATEGORY_TRASHRTYPE;
    opcategory[OP_A_MUL] = OPCATEGORY_ASSIGN | OPCATEGORY_ARITH | OPCATEGORY_TRASHRTYPE;
    opcategory[OP_A_DIV] = OPCATEGORY_ASSIGN | OPCATEGORY_ARITH | OPCATEGORY_TRASHRTYPE;
    opcategory[OP_A_MOD] = OPCATEGORY_ASSIGN | OPCATEGORY_INT | OPCATEGORY_TRASHRTYPE;
    opcategory[OP_A_AND] = OPCATEGORY_ASSIGN | OPCATEGORY_INT | OPCATEGORY_TRASHRTYPE;
    opcategory[OP_A_XOR] = OPCATEGORY_ASSIGN | OPCATEGORY_INT | OPCATEGORY_TRASHRTYPE;
    opcategory[OP_A_OR] = OPCATEGORY_ASSIGN | OPCATEGORY_INT | OPCATEGORY_TRASHRTYPE;
    opcategory[OP_A_SHL] = OPCATEGORY_ASSIGN | OPCATEGORY_INT | OPCATEGORY_TRASHRTYPE;
    opcategory[OP_A_SHR] = OPCATEGORY_ASSIGN | OPCATEGORY_INT | OPCATEGORY_TRASHRTYPE;
    opcategory[OP_COMMA] = OPCATEGORY_ARITH | OPCATEGORY_SEQUENCEP | OPCATEGORY_TRASHLVALUE;
    opcategory[OP_SIZEOF] = OPCATEGORY_ARITH;
    opcategory[OP_SIZEOF_TYPE] = 0;
    opcategory[OP_CAST] = OPCATEGORY_ARITH;
    opcategory[OP_L_PAR] = OPCATEGORY_ARITH | OPCATEGORY_POINTER;
    opcategory[OP_R_PAR] = OPCATEGORY_ARITH | OPCATEGORY_POINTER;
    opcategory[OP_L_ARRAY] = OPCATEGORY_POINTER;
    opcategory[OP_R_ARRAY] = OPCATEGORY_POINTER;
    opcategory[OP_QUESTION] = OPCATEGORY_INT | OPCATEGORY_SEQUENCEP;
    opcategory[OP_COLON] = OPCATEGORY_INT | OPCATEGORY_SEQUENCEP;

    opnterms[OP_ARROW] = 2;
    opnterms[OP_DOT] = 2;
    opnterms[OP_NOT] = 1;
    opnterms[OP_B_NOT] = 1;
    opnterms[OP_INC] = 1;
    opnterms[OP_DEC] = 1;
    opnterms[OP_PLUS] = 1;
    opnterms[OP_MINUS] = 1;
    opnterms[OP_POINTER] = 1;
    opnterms[OP_ADDRESS] = 1;
    opnterms[OP_MUL] = 2;
    opnterms[OP_DIV] = 2;
    opnterms[OP_MOD] = 2;
    opnterms[OP_ADD] = 2;
    opnterms[OP_SUB] = 2;
    opnterms[OP_SHL] = 2;
    opnterms[OP_SHR] = 2;
    opnterms[OP_LT] = 2;
    opnterms[OP_LE] = 2;
    opnterms[OP_GT] = 2;
    opnterms[OP_GE] = 2;
    opnterms[OP_EQ] = 2;
    opnterms[OP_NE] = 2;
    opnterms[OP_B_AND] = 2;
    opnterms[OP_B_XOR] = 2;
    opnterms[OP_B_OR] = 2;
    opnterms[OP_L_AND] = 2;
    opnterms[OP_L_OR] = 2;
    opnterms[OP_ASSIGN] = 2;
    opnterms[OP_A_ADD] = 2;
    opnterms[OP_A_SUB] = 2;
    opnterms[OP_A_MUL] = 2;
    opnterms[OP_A_DIV] = 2;
    opnterms[OP_A_MOD] = 2;
    opnterms[OP_A_AND] = 2;
    opnterms[OP_A_XOR] = 2;
    opnterms[OP_A_OR] = 2;
    opnterms[OP_A_SHL] = 2;
    opnterms[OP_A_SHR] = 2;
    opnterms[OP_COMMA] = 2;
    opnterms[OP_SIZEOF] = 1;
    opnterms[OP_SIZEOF_TYPE] = 0;
    opnterms[OP_CAST] = 1;
    opnterms[OP_L_PAR] = 1;
    opnterms[OP_R_PAR] = 1;
    opnterms[OP_L_ARRAY] = 2;
    opnterms[OP_R_ARRAY] = 2;
    opnterms[OP_QUESTION] = 3;
    opnterms[OP_COLON] = 3;

    opcategoryflag = TRUE;
    return 0;
}
