/*
 * Program:             $RCSfile: predVariable.c,v $  $Revision: 30.3 $
 *
 * Purpose:             Predicates for variable.
 *                      Moved from "<SAPID_TOP>/AR3/mkSpec3/basic.c".
 *
 * Author:              K.Hayashi  1995/02/20
 * Modified:            S.Yamamoto  1995/03/13
 *
 * (C) Copyright:       K.Hayashi and S.Yamamoto  1995
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: predVariable.c,v 30.3 2002/10/21 07:26:05 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

SpdBoolean  smuIsArgument(SpdObjId ident_id)
{
    SpdObjId    decl_id, decr_id, func_id;
    /* int mode; */
    
    if (spdGetClassId(ident_id) != SPD_CID_IDENTIFIER) {
        return (FALSE);
    }
    if (spdGetAttrValInt(ident_id, "sort") != ID_VARIABLE) {
        return (FALSE);
    }

    /* mode = spdGetSearchFlag(); */
    /* spdSetSearchFlag(SPD_SEARCH_ANY); */
    decr_id = spdGetARelObj(ident_id, "decl_ident", "any");
    decl_id = spdGetARelObj(decr_id, "decl_decl", "any");
    func_id = spdGetARelObj(decl_id, "func_parm", "any");
    /* spdSetSearchFlag(mode); */
    return (func_id != SPD_NON_ID);
}

SpdBoolean  smuIsGlobalVariable(SpdObjId ident_id)
{
    SpdObjId    decl_id, decr_id;
    SpdCursor   *csr;
    SpdBoolean  isGloval = FALSE;
    /* int mode; */
    
    if (spdGetClassId(ident_id) != SPD_CID_IDENTIFIER) {
        return (FALSE);
    }
    if (spdGetAttrValInt(ident_id, "sort") != ID_VARIABLE) {
        return (FALSE);
    }

    /* mode = spdGetSearchFlag(); */
    /* spdSetSearchFlag(SPD_SEARCH_ANY); */
    csr = spdGetRelObjInit(ident_id, "decl_ident", "any");
    while ((decr_id = spdGetRelObj(csr)) != SPD_NON_ID) {
        decl_id = spdGetARelObj(decr_id, "decl_decl", "any");
        if (spdGetARelObj(decl_id, "file_decl", "any") != SPD_NON_ID) {
            isGloval = TRUE;
            break;
        }
    }
    spdFreeCursor(csr);
    /* spdSetSearchFlag(mode); */
    return (isGloval);
}

SpdBoolean  smuIsLocalVariable(SpdObjId ident_id)
{
    if (spdGetClassId(ident_id) != SPD_CID_IDENTIFIER) {
        return (FALSE);
    }
    if (spdGetAttrValInt(ident_id, "sort") != ID_VARIABLE) {
        return (FALSE);
    }

    return (!smuIsArgument(ident_id) && !smuIsGlobalVariable(ident_id));
}

SpdBoolean  smuIsStaticId(SpdObjId ident_id)
{
    SpdObjId    decl_id, decr_id;
    /* int mode; */
    
    if (spdGetClassId(ident_id) != SPD_CID_IDENTIFIER) {
        return (FALSE);
    }

    /* mode = spdGetSearchFlag(); */
    /* spdSetSearchFlag(SPD_SEARCH_ANY); */
    decr_id = spdGetARelObj(ident_id, "decl_ident", "any");
    decl_id = spdGetARelObj(decr_id, "decl_decl", "any");
    /* spdSetSearchFlag(mode); */
    return (spdGetAttrValInt(decl_id, "storage") == STORAGE_STATIC);
}
