/* 
* Program:             $RCSfile: spdDeclarativeAPI.c,v $  $Revision: 41.9 $
* 
* Purpose:
* 
* Author:              N.Kaneko  2002/05/05
*                      S.Yamamoto  2002/05/05
* 
* (C) Copyright:       N.Kaneko and S.Yamamoto  2002
*                      This file is a product of the project Sapid.
*/

#ifndef lint
static char rcsid[] =
        "$Id: spdDeclarativeAPI.c,v 41.9 2003/01/12 05:59:37 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

static void printError(SpdConstString funcName,
                       SpdConstString InputClassName,
                       SpdConstString ClassName)
{
    spdErrorExit("%s: Invalid search from \"%s\" to \"%s\".\n",
            funcName, InputClassName, ClassName);
}

static SpdTargetObjSet initializeSet(void)
{
    SpdTargetObjSet     targetset;
    
    targetset.TargetObjIds = NULL;
    targetset.TargetObjNum = 0;
    targetset.UsedRelNames = NULL;
    return targetset;
}

static SpdTargetObjSet getTargetBasicMethod(SpdObjId inputId,
                                            SpdString relationName,
                                            SpdString attrName)
{
    SpdTargetObjSet Result;
    SpdObjIdArray   RelObjIds;
    int             i;
    
    Result = initializeSet();
    
    RelObjIds = spdGetRelObjArray(inputId, relationName, attrName, NULL);
    Result.TargetObjNum = RelObjIds.size;
    Result.TargetObjIds = spdRealloc(Result.TargetObjIds, (Result.TargetObjNum) * (sizeof(SpdObjId)));
    for (i = 0; i < Result.TargetObjNum; i++) {
        Result.TargetObjIds[i] = RelObjIds.id[i];
    }
    spdFreeObjIdArray(RelObjIds);
    if (Result.TargetObjNum != 0) {
        Result.UsedRelNames = spdStrcat(Result.UsedRelNames, "\"");
        Result.UsedRelNames = spdStrcat(Result.UsedRelNames, relationName);
        Result.UsedRelNames = spdStrcat(Result.UsedRelNames, "\"");
    }
    
    return Result;
}

static SpdTargetObjSet getChildTargetFromTarget(SpdTargetObjSet tmpResult,
                                                SpdString relationName,
                                                SpdString attrName)
{
    SpdTargetObjSet Result;
    SpdObjIdArray   ChildObjIds;
    int             add_item_flag;
    int             i, j , k;
    
    Result = initializeSet();
    if (tmpResult.TargetObjNum > 0) {
        for (i = 0; i < tmpResult.TargetObjNum; i++) {
            ChildObjIds = spdGetRelObjArray(tmpResult.TargetObjIds[i],
                    relationName, attrName, NULL);
            /*ҶΥ֥Ȥ뤫ɤå*/
            if (ChildObjIds.size > 0) {
                /*ܤϿ*/
                if (Result.TargetObjNum == 0) {
                    Result.TargetObjNum = ChildObjIds.size;
                    Result.TargetObjIds = spdRealloc(Result.TargetObjIds, (Result.TargetObjNum) * (sizeof(SpdObjId)));
                    
                    for (j = 0; j < ChildObjIds.size; j++) {
                        Result.TargetObjIds[j] = ChildObjIds.id[j];
                    }
                    Result.UsedRelNames = spdStrcat(Result.UsedRelNames, "\"");
                    Result.UsedRelNames = spdStrcat(Result.UsedRelNames, relationName);
                    Result.UsedRelNames = spdStrcat(Result.UsedRelNames, "\"");
                }
                /*ܰʹߤϿ*/
                else if (Result.TargetObjNum > 0) {
                    /*ϿƤʤɤå*/
                    for (j = 0; j < ChildObjIds.size; j++) {
                        /*add_item_flagͤʤʤʤ*/
                        add_item_flag = 0;
                        for (k = 0; k < Result.TargetObjNum; k++) {
                            if (Result.TargetObjIds[k] == ChildObjIds.id[j]) {
                                add_item_flag = 1;
                            }
                        }
                        if (add_item_flag == 0) {
                            /*ͤʤΤϿ*/
                            Result.TargetObjNum++;
                            Result.TargetObjIds = spdRealloc(Result.TargetObjIds, (Result.TargetObjNum) * (sizeof(SpdObjId)));
                            Result.TargetObjIds[(Result.TargetObjNum - 1)] = ChildObjIds.id[j];
                        }
                    }
                }
            }
            spdFreeObjIdArray(ChildObjIds);
        }
    }
    
    return Result;
}

static SpdTargetObjSet getNextParentTargetFromId(SpdObjId inputId,
                                                 SpdString relationName,
                                                 SpdString attrName,
                                                 SpdString ClassName)
{
    SpdTargetObjSet Result, tmpResult;
    SpdObjIdArray   ParentObjIds;
    int             add_item_flag;
    int             i, j, k;
    
    Result = initializeSet();
    ParentObjIds = spdGetRelObjArray(inputId, relationName, attrName, NULL);
    if (ParentObjIds.size != 0) {
        Result.UsedRelNames = spdStrcat(Result.UsedRelNames, "\"");
        Result.UsedRelNames = spdStrcat(Result.UsedRelNames, relationName);
        Result.UsedRelNames = spdStrcat(Result.UsedRelNames, "\"");
    }
    
    for (i = 0; i < ParentObjIds.size; i++) {
        tmpResult = initializeSet();
        tmpResult = spdGetAncestralObjs(ParentObjIds.id[i], ClassName);
        
        /*tmpResultη̤ResultϿ*/
        if (tmpResult.TargetObjNum != 0 && Result.TargetObjNum == 0) {
            Result.TargetObjNum = tmpResult.TargetObjNum;
            Result.TargetObjIds = spdRealloc(Result.TargetObjIds, (Result.TargetObjNum) * (sizeof(SpdObjId)));
            for (j = 0; j < tmpResult.TargetObjNum; j++) {
                Result.TargetObjIds[j] = tmpResult.TargetObjIds[j];
            }
            Result.UsedRelNames = spdStrcat(Result.UsedRelNames, "-");
            Result.UsedRelNames = spdStrcat(Result.UsedRelNames, tmpResult.UsedRelNames);
            
            spdFreeSpdTargetObjSet(tmpResult);
        }
        /*ܰʹtmpResultη̤ResultϿ*/
        else if (tmpResult.TargetObjNum != 0 && Result.TargetObjNum != 0) {
            /*ϿƤʤɤå*/
            for (j = 0; j < tmpResult.TargetObjNum; j++) {
                /*add_item_flagͤʤʤʤ*/
                add_item_flag = 0;
                for (k = 0; k < Result.TargetObjNum; k++) {
                    if (Result.TargetObjIds[k] == tmpResult.TargetObjIds[j]) {
                        add_item_flag = 1;
                    }
                }
                if (add_item_flag == 0) {
                    /*ͤʤΤϿ*/
                    Result.TargetObjNum++;
                    Result.TargetObjIds = spdRealloc(Result.TargetObjIds, (Result.TargetObjNum) * (sizeof(SpdObjId)));
                    Result.TargetObjIds[(Result.TargetObjNum - 1)] = tmpResult.TargetObjIds[j];
                }
            }
            spdFreeSpdTargetObjSet(tmpResult);
        }
    }
    
    return Result;
}

static SpdTargetObjSet getToObjs(SpdObjId inputId,
                                 SpdString relationName,
                                 SpdString attrName,
                                 int rel_type)

{
    /*rel_type:1 typeΥ֥Ȥμ :0 exprμ*/
    SpdTargetObjSet Result, tmpResult;
    SpdObjIdArray   obj_id_array;
    int             i, j;
    int             index;
    
    Result = initializeSet();
    obj_id_array = spdGetRelObjArray(inputId, relationName, attrName, NULL);
    if (obj_id_array.size != 0) {
        Result.UsedRelNames = spdStrcat(Result.UsedRelNames, "\"");
        Result.UsedRelNames = spdStrcat(Result.UsedRelNames, relationName);
        Result.UsedRelNames = spdStrcat(Result.UsedRelNames, "\"");
        Result.TargetObjNum = (int)obj_id_array.size;
        Result.TargetObjIds = spdRealloc(Result.TargetObjIds, (Result.TargetObjNum) * (sizeof(SpdObjId)));
        for (i = 0; i < obj_id_array.size; i++) {
            Result.TargetObjIds[i] = obj_id_array.id[i];
        }
        for (i = 0; i < Result.TargetObjNum; i++) {
            if (rel_type == 1) {
                tmpResult = spdGetToTypeObjs(Result.TargetObjIds[i], "type");
            } else if (rel_type == 0) {
                tmpResult = spdGetToExprObjs(Result.TargetObjIds[i], "expression");
            }
            if (tmpResult.TargetObjNum > 0) {
                Result.UsedRelNames = spdStrcat(Result.UsedRelNames, "-");
                Result.UsedRelNames = spdStrcat(Result.UsedRelNames, tmpResult.UsedRelNames);
                index = Result.TargetObjNum;
                Result.TargetObjNum += tmpResult.TargetObjNum;
                Result.TargetObjIds = spdRealloc(Result.TargetObjIds, (Result.TargetObjNum) * (sizeof(SpdObjId)));
                for (j = 0; j < tmpResult.TargetObjNum; j++) {
                    Result.TargetObjIds[index] = tmpResult.TargetObjIds[j];
                    index++;
                }
            }
        }
        spdFreeSpdTargetObjSet(tmpResult);
    }
    
    return Result;
}

static SpdTargetObjSet getFromObjs(SpdObjId inputId,
                                   SpdString relationName,
                                   SpdString attrName,
                                   SpdString ClassName,
                                   int rel_type)
{
    /*rel_type:1 typeΥ֥Ȥμ :0 exprμ*/
    SpdTargetObjSet Result, tmpResult;
    SpdObjIdArray   objIds;
    int             index;
    int             i, j;

    
    Result = getTargetBasicMethod(inputId, relationName, attrName);
    if (Result.TargetObjNum == 0) {
        if (rel_type == 1) {
            objIds = spdGetRelObjArray(inputId, "type_st", "type_pointed_id", NULL);
        } else if (rel_type == 0) {
            objIds = spdGetRelObjArray(inputId, "expr_expr", "inner_expression_id", NULL);
        }
        if (objIds.size != 0) {
            for (i = 0; i < objIds.size; i++) {
                if (rel_type == 1) {
                    tmpResult = spdGetFromTypeObjs(objIds.id[i], ClassName);
                } else if (rel_type == 0) {
                    tmpResult = spdGetFromExprObjs(objIds.id[i], ClassName);
                }
                if (tmpResult.TargetObjNum > 0) {
                    index = Result.TargetObjNum;
                    Result.TargetObjNum += tmpResult.TargetObjNum;
                    Result.TargetObjIds = spdRealloc(Result.TargetObjIds, (Result.TargetObjNum) * (sizeof(SpdObjId)));
                    for (j = 0; j < tmpResult.TargetObjNum; j++) {
                        Result.TargetObjIds[index] = tmpResult.TargetObjIds[j];
                        index++;
                    }
                    if (rel_type == 1) {
                        Result.UsedRelNames = spdStrcat(Result.UsedRelNames, "\"type_st\"-");
                    } else if (rel_type == 0) {
                        Result.UsedRelNames = spdStrcat(Result.UsedRelNames, "\"expr_expr\"-");
                    }
                    Result.UsedRelNames = spdStrcat(Result.UsedRelNames, tmpResult.UsedRelNames);
                }
            }
            spdFreeSpdTargetObjSet(tmpResult);
        }
        spdFreeObjIdArray(objIds);
    }
    return Result;
}

static SpdTargetObjSet getOuterObjs(SpdObjId inputId, int rel_type) 
{
    SpdTargetObjSet Result, tmpResult;
    int             Obj_NUM;
    int             i, j, index;

    if (rel_type == 1) {
        Result = getTargetBasicMethod(inputId, "type_st", "type_pointed_id");
    } else if (rel_type == 0) {
        Result = getTargetBasicMethod(inputId, "expr_expr", "inner_expression_id");
    }
    Obj_NUM = Result.TargetObjNum;
    index = Result.TargetObjNum;
    for (i = 0; i < Obj_NUM; i++) {
        if (rel_type == 1) {
            tmpResult = spdGetFromTypeObjs(Result.TargetObjIds[i], "type");
        } else if (rel_type == 0) {
            tmpResult = spdGetFromExprObjs(Result.TargetObjIds[i], "expression");
        }
        if (tmpResult.TargetObjNum != 0) {
            Result.TargetObjNum += tmpResult.TargetObjNum;
            Result.TargetObjIds = spdRealloc(Result.TargetObjIds, (Result.TargetObjNum) * (sizeof(SpdObjId)));
            for (j = 0; j < tmpResult.TargetObjNum; j++) {
                Result.TargetObjIds[index] = tmpResult.TargetObjIds[j];
                index++;
            }
        }
        spdFreeSpdTargetObjSet(tmpResult);
    }
    if (Obj_NUM != index) {
        if (rel_type == 1) {
            Result.UsedRelNames = spdStrcat(Result.UsedRelNames, "-\"type_st\"");
        } else if (rel_type == 0) {
            Result.UsedRelNames = spdStrcat(Result.UsedRelNames, "-\"expr_expr\"");
        }
    }

    return Result;
}

SpdTargetObjSet spdGetDescendedObjs(SpdObjId inputId, SpdString ClassName)
{
    SpdString       InputClassName;
    SpdClassId      InputClassId;
    SpdTargetObjSet Result, tmpResult;
    
    InputClassId = spdGetClassId(inputId);
    InputClassName = spdGetClassNameById(InputClassId);
    if (SPD_STREQ(ClassName, "program")) {
        printError("spdGetDescendedObjs()", InputClassName, ClassName);
    } else if (SPD_STREQ(ClassName, "library")) {
        if (SPD_STREQ(InputClassName, "program")) {
            Result = getTargetBasicMethod(inputId, "prog_lib", "program_id");
        } else {
            printError("spdGetDescendedObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(ClassName, "block")) {
        if (SPD_STREQ(InputClassName, "block")) {
            switch (spdGetAttrValInt(inputId, "sort")) {
              case BLOCK_COMP:
              case BLOCK_BRANCH:
              case BLOCK_FOR:
              case BLOCK_SWITCH:
              case BLOCK_IF:
              case BLOCK_WHILE:
              case BLOCK_HIERACHICAL:
              case BLOCK_DO:
                Result = getTargetBasicMethod(inputId, "blk_blk", "parent_block_id");
                break;
              default:
                break;
            }
        } else if (SPD_STREQ(InputClassName, "optionaldecl")) {
            if (spdGetAttrValInt(inputId, "sort") == OPT_FUNCDEF) {
                Result = getTargetBasicMethod(inputId, "func_body", "function_id");
            }
        } else {
            printError("spdGetDescendedObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(ClassName, "file")) {
        if (SPD_STREQ(InputClassName, "program")) {
            Result = getTargetBasicMethod(inputId, "prog_file", "program_id");
        } else if (SPD_STREQ(InputClassName, "library")) {
            Result = getTargetBasicMethod(inputId, "lib_file", "library_id");           
        } else {
            printError("spdGetDescendedObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(ClassName, "declaration")) {
        if (SPD_STREQ(InputClassName, "program") ||
                                SPD_STREQ(InputClassName, "library")) {
                        tmpResult = spdGetDescendedObjs(inputId, "file");
            Result = getChildTargetFromTarget(tmpResult, "file_decl", "file_id");
            spdFreeSpdTargetObjSet(tmpResult);
        } else if (SPD_STREQ(InputClassName, "file")) {
            Result = getTargetBasicMethod(inputId, "file_decl", "file_id");
        } else if (SPD_STREQ(InputClassName, "block") &&
                spdGetAttrValInt(inputId, "sort") == BLOCK_COMP) {
            Result = getTargetBasicMethod(inputId, "blk_decl", "parent_block_id");
        } else if (SPD_STREQ(InputClassName, "optionaldecl")) {
            switch (spdGetAttrValInt(inputId, "sort")) {
              case OPT_PROTOTYPE:
                Result = getTargetBasicMethod(inputId, "prot_parm", "optionaldecl_id");
                break;
              case OPT_FUNCDEF:
                Result = getTargetBasicMethod(inputId, "func_parm", "optionaldecl_id");
                break;
              case OPT_STRUCT:
                Result = getTargetBasicMethod(inputId, "struct_decl", "optionaldecl_id");
                break;
              case OPT_FUNCPTR:
                Result = getTargetBasicMethod(inputId, "funcptr_parm", "optionaldecl_id");
                break;
              default:
                Result = initializeSet();
                break;
            }
        } else {
            printError("spdGetDescendedObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(ClassName, "declarator")) {
        if (SPD_STREQ(InputClassName, "program") ||
                SPD_STREQ(InputClassName, "library") ||
                SPD_STREQ(InputClassName, "file") ||
                SPD_STREQ(InputClassName, "block") ||
                SPD_STREQ(InputClassName, "optionaldecl")) {
            tmpResult = spdGetDescendedObjs(inputId, "declaration");
            Result = getChildTargetFromTarget(tmpResult, "decl_decl", "declaration_id");
            spdFreeSpdTargetObjSet(tmpResult);
        } else if (SPD_STREQ(InputClassName, "declaration")) {
            Result = getTargetBasicMethod(inputId, "decl_decl", "declaration_id");
        } else {
            printError("spdGetDescendedObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(ClassName, "identifier")) {
        if (SPD_STREQ(InputClassName, "program") ||
                SPD_STREQ(InputClassName, "library") ||
                SPD_STREQ(InputClassName, "file") ||
                SPD_STREQ(InputClassName, "block") ||
                SPD_STREQ(InputClassName, "optionaldecl") ||
                SPD_STREQ(InputClassName, "declaration")) {
            tmpResult = spdGetDescendedObjs(inputId, "declarator");
                        Result = getChildTargetFromTarget(tmpResult, "decl_ident", "declarator_id");
                        spdFreeSpdTargetObjSet(tmpResult);
        } else if (SPD_STREQ(InputClassName, "declarator")) {
            Result = getTargetBasicMethod(inputId, "decl_ident", "declarator_id");
        } else {
            printError("spdGetDescendedObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(ClassName, "optionaldecl")) {
        if (SPD_STREQ(InputClassName, "program") ||
                SPD_STREQ(InputClassName, "library") ||
                SPD_STREQ(InputClassName, "file") ||
                SPD_STREQ(InputClassName, "block")
                || SPD_STREQ(InputClassName, "declaration")) {
            tmpResult = spdGetDescendedObjs(inputId, "declarator");
            Result = getChildTargetFromTarget(tmpResult, "decl_opt", "declarator_id");
            spdFreeSpdTargetObjSet(tmpResult);
        } else if (SPD_STREQ(InputClassName, "declarator")) {
            Result = getTargetBasicMethod(inputId, "decl_opt", "declarator_id");
        } else {
            printError("spdGetDescendedObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(ClassName, "expression")) {
        /*block,label˺ǽexpressionΤ߸Ф*/
        if (SPD_STREQ(InputClassName, "block")) {
            switch (spdGetAttrValInt(inputId, "sort")) {
              case BLOCK_COMP:case BLOCK_BRANCH: case BLOCK_FOR: case BLOCK_SWITCH:
              case BLOCK_IF: case BLOCK_WHILE: case BLOCK_HIERACHICAL: case BLOCK_DO:
                tmpResult = spdGetDescendedObjs(inputId, "label");
                Result = getChildTargetFromTarget(tmpResult, "case_cexpr", "label_id");
                spdFreeSpdTargetObjSet(tmpResult);
                break;
              case BLOCK_BASIC:
                Result = getTargetBasicMethod(inputId, "blk_expr", "parent_block_id");
                break;
              default:
                spdErrorExit("spdGetDescendedObjs(): Input block id %d is not block's parent id.\n",
                        inputId);
                break;
            }
        } else if (SPD_STREQ(InputClassName, "label")) {
            Result = getTargetBasicMethod(inputId, "case_cexpr", "label_id");
        } else if (SPD_STREQ(InputClassName, "expression")) {
            Result = getTargetBasicMethod(inputId, "expr_expr", "outer_expression_id");
        } else {
            printError("spdGetDescendedObjs()", InputClassName, ClassName);
        }
        
    } else if (SPD_STREQ(ClassName, "label")) {
        if (SPD_STREQ(InputClassName, "block")) {
            switch (spdGetAttrValInt(inputId, "sort")) {
              case BLOCK_COMP:case BLOCK_BRANCH: case BLOCK_FOR: case BLOCK_SWITCH:
              case BLOCK_IF: case BLOCK_WHILE: case BLOCK_HIERACHICAL: case BLOCK_DO:
                Result = getTargetBasicMethod(inputId, "blk_label", "block_id");
                break;
              default:
                spdErrorExit("spdGetDescendedObjs(): Input block id %d is not label's parent id.\n",
                        inputId);
                break;
            }
        } else {
            printError("spdGetDescendedObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(ClassName, "constant")) {
        printError("spdGetDescendedObjs()", InputClassName, ClassName);
    } else if (SPD_STREQ(ClassName, "type")) {
        printError("spdGetDescendedObjs()", InputClassName, ClassName);
    } else if (SPD_STREQ(ClassName, "operator")) {
        if (SPD_STREQ(InputClassName, "block") ||
                SPD_STREQ(InputClassName, "label")) {
            tmpResult = spdGetDescendedObjs(inputId, "expression");
            Result = getChildTargetFromTarget(tmpResult, "expr_op", "expression_id");
            spdFreeSpdTargetObjSet(tmpResult);
        } else if (SPD_STREQ(InputClassName, "expression")) {
            Result = getTargetBasicMethod(inputId, "expr_op", "expression_id");
        } else {
            printError("spdGetDescendedObjs()", InputClassName, ClassName);
        }
    } else {
        spdErrorExit("spdGetDescendedObjs(): Invalid class name \"%s\".\n",
                ClassName);
    }
    return Result;
}

SpdTargetObjSet spdGetAncestralObjs(SpdObjId inputId, SpdString ClassName)
{
    SpdString       InputClassName;
    SpdClassId      InputClassId;
    SpdObjId        ParentObjId;
    SpdTargetObjSet Result;
    int             switch_id;
    
    InputClassId = spdGetClassId(inputId);
    InputClassName = spdGetClassNameById(InputClassId);
    if (SPD_STREQ(InputClassName, "program")) {
        printError("spdGetAncestralObjs()", InputClassName, ClassName);
    } else if (SPD_STREQ(InputClassName, "library")) {
        if (SPD_STREQ(ClassName, "program")) {
            Result = getTargetBasicMethod(inputId, "prog_lib", "library_id");
        } else {
            printError("spdGetAncestralObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(InputClassName, "file")) {
        if (SPD_STREQ(ClassName, "program")) {
            Result = getTargetBasicMethod(inputId, "prog_file", "file_id");
        } else if (SPD_STREQ(ClassName, "library")) {
            Result = getTargetBasicMethod(inputId, "lib_file", "file_id");
        } else {
            printError("spdGetAncestralObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(InputClassName, "declaration")) {
        if (SPD_STREQ(ClassName, "program") || SPD_STREQ(ClassName, "library")) {
            Result = getNextParentTargetFromId(inputId, "file_decl", "declaration_id", ClassName);
        } else if (SPD_STREQ(ClassName, "file")) {
            Result = getTargetBasicMethod(inputId, "file_decl", "declaration_id");
        } else if (SPD_STREQ(ClassName, "block")) {
            Result = getTargetBasicMethod(inputId, "blk_decl", "children_declaration_id");
        } else if (SPD_STREQ(ClassName, "optionaldecl")) {
            /*ƥ֥ȤǤ"optionaldecl"sortĴ٤*/
            switch_id = SPD_NON_ID;
            ParentObjId = spdGetARelObj(inputId, "prot_parm", "declaration_id");
            if (ParentObjId != SPD_NON_ID && switch_id == SPD_NON_ID) {
                switch_id = OPT_PROTOTYPE;
            } else {
                ParentObjId = spdGetARelObj(inputId, "func_parm", "declaration_id");
            }
            if (ParentObjId != SPD_NON_ID && switch_id == SPD_NON_ID) {
                switch_id = OPT_FUNCDEF;
            } else {
                ParentObjId = spdGetARelObj(inputId, "struct_decl", "declaration_id");
            }
            if (ParentObjId != SPD_NON_ID && switch_id == SPD_NON_ID) {
                switch_id = OPT_STRUCT;
            } else {
                ParentObjId = spdGetARelObj(inputId, "funcptr_parm", "declaration_id");
            }
            if (ParentObjId != SPD_NON_ID && switch_id == SPD_NON_ID) {
                switch_id = OPT_FUNCPTR;
            }
            
            /*"optionaldecl"sortˤäƽ򤹤*/
            switch (switch_id) {
              case OPT_PROTOTYPE:
                Result = getTargetBasicMethod(inputId, "prot_parm", "declaration_id");
                break;
              case OPT_FUNCDEF:
                Result = getTargetBasicMethod(inputId, "func_parm", "declaration_id");
                break;
              case OPT_STRUCT:
                Result = getTargetBasicMethod(inputId, "struct_decl", "declaration_id");
                break;
              case OPT_FUNCPTR:
                Result = getTargetBasicMethod(inputId, "funcptr_parm", "declaration_id");
                break;
              default:
                break;
            }
        } else {
            printError("spdGetAncestralObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(InputClassName, "declarator")) {
        if (SPD_STREQ(ClassName, "program") || SPD_STREQ(ClassName, "library")
                || SPD_STREQ(ClassName, "file") || SPD_STREQ(ClassName, "optionaldecl")) {
            Result = getNextParentTargetFromId(inputId, "decl_decl", "declarator_id", ClassName);
        } else if (SPD_STREQ(ClassName, "declaration")) {
            Result = getTargetBasicMethod(inputId, "decl_decl", "declarator_id");
        } else {
            printError("spdGetAncestralObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(InputClassName, "identifier")) {
        if (SPD_STREQ(ClassName, "program") || SPD_STREQ(ClassName, "library")
                || SPD_STREQ(ClassName, "file") || SPD_STREQ(ClassName, "optionaldecl")
                || SPD_STREQ(ClassName, "declaration")) {
            Result = getNextParentTargetFromId(inputId, "decl_ident", "identifier_id", ClassName);
        } else if (SPD_STREQ(ClassName, "declarator")) {
            Result = getTargetBasicMethod(inputId, "decl_ident", "identifier_id");
        } else {
            printError("spdGetAncestralObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(InputClassName, "optionaldecl")) {
        if (SPD_STREQ(ClassName, "program") || SPD_STREQ(ClassName, "library")
                || SPD_STREQ(ClassName, "file") || SPD_STREQ(ClassName, "optionaldecl")
                || SPD_STREQ(ClassName, "declaration")) {
            Result = getNextParentTargetFromId(inputId, "decl_opt", "optional_id", ClassName);
        } else if (SPD_STREQ(ClassName, "declarator")) {
            Result = getTargetBasicMethod(inputId, "decl_opt", "optionaldecl_id");
        } else {
            printError("spdGetAncestralObjs()", InputClassName, ClassName);
        }
        
    } else if (SPD_STREQ(InputClassName, "block")) {
        if (SPD_STREQ(ClassName, "block")) {
            ParentObjId = spdGetARelObj(inputId, "blk_blk", "children_block_id");
            if (ParentObjId != SPD_NON_ID) {
                Result = getTargetBasicMethod(inputId, "blk_blk", "children_block_id");
            }
        } else if (SPD_STREQ(ClassName, "optionaldecl")) {
            ParentObjId = spdGetARelObj(inputId, "func_body", "block_id");
            if (ParentObjId != SPD_NON_ID) {
                Result = getTargetBasicMethod(inputId, "func_body", "block_id");
            }
        } else {
            printError("spdGetAncestralObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(InputClassName, "label")) {
        if (SPD_STREQ(ClassName, "block")) {
            Result = getTargetBasicMethod(inputId, "blk_label", "label_id");
        } else {
            printError("spdGetAncestralObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(InputClassName, "expression")) {
        if (SPD_STREQ(ClassName, "block")) {
            /*ľexpressionblockID*/
            Result = getTargetBasicMethod(inputId, "blk_expr", "children_expression_id");
            if(Result.TargetObjNum == 0) {
                /*ľexpressionblockʤСlabelͳblock*/
                Result = getNextParentTargetFromId(inputId, "case_cexpr", "expression_id", ClassName);
            }
        } else if (SPD_STREQ(ClassName, "label")) {
            Result = getTargetBasicMethod(inputId, "case_cexpr", "expression_id");
        } else if (SPD_STREQ(ClassName, "expression")) {
            Result = getTargetBasicMethod(inputId, "expr_expr", "inner_expression_id");
        } else {
            printError("spdGetAncestralObjs()", InputClassName, ClassName);
        }
        
    } else if (SPD_STREQ(InputClassName, "operator")) {
        if (SPD_STREQ(ClassName, "block") || SPD_STREQ(ClassName, "label")) {
            Result = getNextParentTargetFromId(inputId, "expr_op", "operator_id", ClassName);
        } else if (SPD_STREQ(ClassName, "expression")) {
            Result = getTargetBasicMethod(inputId, "expr_op", "operator_id");
        } else {
            printError("spdGetAncestralObjs()", InputClassName, ClassName);
        }
        
    } else if (SPD_STREQ(InputClassName, "constant") ||
               SPD_STREQ(ClassName, "type")) {
        printError("spdGetAncestralObjs()", InputClassName, ClassName);
    } else {
        spdErrorExit("spdGetAncestralObjs(): Invalid class name \"%s\".\n",
                ClassName);
    }
    return Result;
}

SpdTargetObjSet spdGetToTypeObjs(SpdObjId inputId, SpdString ClassName)
{
    SpdString       InputClassName;
    SpdClassId      InputClassId;
    SpdTargetObjSet Result;
    
    InputClassId = spdGetClassId(inputId);
    InputClassName = spdGetClassNameById(InputClassId);
    if (SPD_STREQ(ClassName, "type")) {
        /*input_idtype*/
        if (SPD_STREQ(InputClassName, "type")) {
            /*typetypeؤ*/
            Result = getToObjs(inputId,"type_st","type_pointer_id", 1);
        } else if (SPD_STREQ(InputClassName, "declaration")) {
            /*decltype*/
            Result = getToObjs(inputId,"decl_type","declaration_id", 1);
        } else if (SPD_STREQ(InputClassName, "declarator")) {
            /*decrtype*/
            Result = getToObjs(inputId,"decr_type","declarator_id", 1);
        } else if (SPD_STREQ(InputClassName, "identifier")) {
            /*identtype*/
            Result = getToObjs(inputId,"ident_type","identifier_id", 1);
        } else if (SPD_STREQ(InputClassName, "expression")) {
            /*exprtype*/
            Result = getToObjs(inputId,"expr_type","expression_id", 1);
        } else if (SPD_STREQ(InputClassName, "operator")) {
            /*operatortype*/
            Result = getToObjs(inputId,"op_type","operator_id", 1);
        } else {
            printError("spdGetToTypeObjs()", InputClassName, ClassName);
        }
    } else if (SPD_STREQ(InputClassName, "identifier")) {
        if (SPD_STREQ(ClassName, "ident_type")) {
            /*ident_typeꤵ줿*/
            Result = getToObjs(inputId, "ident_type", "identifier_id", 1);
        }else if (SPD_STREQ(ClassName, "type_is")) {
            /*type_isꤵ줿*/
            Result = getToObjs(inputId,"type_is","identifier_id", 1);
        }
    } else {
        printError("spdGetToTypeObjs()", InputClassName, ClassName);
    }
    return Result;
}

SpdTargetObjSet spdGetFromTypeObjs(SpdObjId inputId, SpdString ClassName)
{
    SpdString       InputClassName;
    SpdClassId      InputClassId;
    SpdTargetObjSet Result;
    
    InputClassId = spdGetClassId(inputId);
    InputClassName = spdGetClassNameById(InputClassId);
    if (SPD_STREQ(InputClassName, "type")) {
        /*typeϢĥ֥Ȥ*/
        if (SPD_STREQ(ClassName, "type")) {
            /*typetypeؤҤ¦˼*/
            Result = getOuterObjs(inputId, 1);
        } else if (SPD_STREQ(ClassName, "declaration")) {
            /*typedecl*/
            Result = getFromObjs(inputId, "decl_type", "type_id", "declaration", 1);
        } else if (SPD_STREQ(ClassName, "declarator")) {
            /*typedecr*/
            Result = getFromObjs(inputId, "decr_type", "type_id", "declarator", 1);
        } else if (SPD_STREQ(ClassName, "identifier")) {
            /*typeϢtype_isѤident*/
            Result = getFromObjs(inputId, "type_is", "type_id", "identifier", 1);
        } else if (SPD_STREQ(ClassName, "ident_type")) {
            /*ident_typeꤵ줿*/
            Result = getFromObjs(inputId, "ident_type", "type_id", "identifier", 1);
        }else if (SPD_STREQ(ClassName, "type_is")) {
            /*type_isꤵ줿*/
            Result = getFromObjs(inputId, "type_is", "type_id", "identifier", 1);
        } else if (SPD_STREQ(ClassName, "expression")) {
            /*typeexpr*/
            Result = getFromObjs(inputId, "expr_type", "type_id", "expression", 1);
        } else if (SPD_STREQ(ClassName, "operator")) {
            /*typeoperator*/
            Result = getFromObjs(inputId, "op_type", "type_id", "operator", 1);
        } else {
            printError("spdGetFromTypeObjs()", InputClassName, ClassName);
        }
    } else {
        printError("spdGetFromTypeObjs()", InputClassName, ClassName);
    }
    return Result;
}

SpdTargetObjSet spdGetToExprObjs(SpdObjId inputId, SpdString ClassName)
{
    SpdString       InputClassName;
    SpdClassId      InputClassId;
    SpdTargetObjSet Result;
    
    InputClassId = spdGetClassId(inputId);
    InputClassName = spdGetClassNameById(InputClassId);
    if (SPD_STREQ(ClassName, "expression")) {
        if (SPD_STREQ(InputClassName, "expression")) {
            /*expression¦˼*/
            Result = getToObjs(inputId, "expr_expr", "outer_expression_id", 0);
        } else if (SPD_STREQ(InputClassName, "identifier")) {
            /*identifierexpression*/
            Result = getToObjs(inputId, "ident_ref", "identifier_id", 0);
        } else if (SPD_STREQ(InputClassName, "optionaldecl")) {
            /*optionaldeclexpression*/
            switch (spdGetAttrValInt(inputId, "sort")) {
              case OPT_INITIALIZER:
                /*°initializerǤ*/
                Result = getToObjs(inputId, "init_expr", "optionaldecl_id", 0);
                break;
              default:
                /*¾ξϥ顼*/
                spdErrorExit("spdGetExprRelObjs(): %d: Not initializer.\n", inputId);
                break;
            }
        } else if (SPD_STREQ(InputClassName, "type")) {
            /* typeexpression */
            Result = getToObjs(inputId, "type_cexpr", "type_id", 0);
        } else if (SPD_STREQ(InputClassName, "constant")) {
            /*constantexpression*/
            Result = getToObjs(inputId, "const_ref", "const_id", 0);
        } else {
            printError("spdGetToExprObjs()", InputClassName, ClassName);
        }
    } else {
        printError("spdGetToExprObjs()", InputClassName, ClassName);
    }
    
    return Result;
}

SpdTargetObjSet spdGetFromExprObjs(SpdObjId inputId, SpdString ClassName)
{
    SpdString       InputClassName;
    SpdClassId      InputClassId;
    SpdTargetObjSet Result;
    
    InputClassId = spdGetClassId(inputId);
    InputClassName = spdGetClassNameById(InputClassId);
    if (SPD_STREQ(InputClassName, "expression")) {
        /*expressionȴط륪֥Ȥ*/
        if (SPD_STREQ(ClassName, "expression")) {
            /*¦expression*/
            Result = getOuterObjs(inputId, 0);
        } else if (SPD_STREQ(ClassName, "identifier")) {
            /*identifier*/
            Result = getFromObjs(inputId, "ident_ref", "expression_id", "identifier", 0);
        } else if (SPD_STREQ(ClassName, "optionaldecl")) {
            /*optionaldecl*/
            Result = getFromObjs(inputId, "init_expr", "expression_id", "optionaldecl", 0);
        } else if (SPD_STREQ(ClassName, "type")) {
            /*type*/
            Result = getFromObjs(inputId, "type_cexpr", "expression_id", "type", 0);
        } else if (SPD_STREQ(ClassName, "constant")) {
            /*constant*/
            Result = getFromObjs(inputId, "const_ref", "expression_id", "constant", 0);
        } else {
            printError("spdGetExprRelObjs()", InputClassName, ClassName);
        }
    } else {
        printError("spdGetExprRelObjs()", InputClassName, ClassName);
    }
    
    return Result;
}

void spdFreeSpdTargetObjSet(SpdTargetObjSet targetSet)
{
    spdSafetyFree(targetSet.TargetObjIds);
    targetSet.TargetObjNum = 0;
    spdSafetyFree(targetSet.UsedRelNames);
}
