/* 
 * Program:             $RCSfile: typeUtil.c,v $  $Revision: 30.11 $
 * 
 * Purpose:
 * 
 * Author:              T.Hidaka  1997/06/27
 *                      S.Yamamoto  1997/08/04
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1997 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: typeUtil.c,v 30.11 2003/06/28 15:31:25 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

SpdBoolean smuObjIdIsTypePointer(SpdObjId id)
{
    int sort = spdGetAttrValInt(id, "sort");

    return (sort == TYPE_POINTER || sort == TYPE_ARRAY);
}

SpdBoolean smuObjIdIsTypeIntegral(SpdObjId id)
{
    int type = spdGetAttrValInt(id, "type");
    int sort = spdGetAttrValInt(id, "sort");

    return ((sort == TYPE_DECLARATION) && 
            (type == TYPE_INT || type == TYPE_CHAR || type == TYPE_UNKNOWN));
}

SpdBoolean smuObjIdIsTypeDouble(SpdObjId id)
{
    int type = spdGetAttrValInt(id, "type");

    return (type == TYPE_DOUBLE);
}

SpdBoolean smuObjIdIsTypeLong(SpdObjId id)
{
    int size = spdGetAttrValInt(id, "size");

    return (size == TYPE_LONG);
}

SpdBoolean smuObjIdIsTypeUnsigned(SpdObjId id)
{
    int sign = spdGetAttrValInt(id, "sign");

    return (sign == TYPE_UNSIGNED);
}

/* 
 * δܷ򸡺롥
 */

SpdObjId smuFindType(int qualifier, int sign, int size, int type)
{
    SpdCursor *csr;
    SpdObjId id;
    
    csr = spdGetObjIdInit("type", NULL);
    while ((id = spdGetObjId(csr)) != SPD_NON_ID) {
        if (spdGetAttrValInt(id, "sort") == TYPE_DECLARATION &&
            spdGetAttrValInt(id, "type") == type &&
            spdGetAttrValInt(id, "sign") == sign &&
            spdGetAttrValInt(id, "size") == size &&
            spdGetAttrValInt(id, "qualifier") == qualifier) {
            break;
        }
    }
    spdFreeCursor(csr);

    /* ĤʤSPD_NON_IDˤʤ롥 */
    return id;
}

/* 
 * typedef򸡺롥
 */

SpdObjId smuFindTypedef(SpdString name)
{
    SpdCursor   *csr;
    SpdObjId    id;
    
    csr = spdGetObjIdInit("type", NULL);
    while ((id = spdGetObjId(csr)) != SPD_NON_ID) {
        if (spdGetAttrValInt(id, "sort") == TYPE_TYPE_DEF &&
            SPD_STREQ(spdGetAttrValString(id, "name"), name)) {
            break;
        }
    }
    spdFreeCursor(csr);

    /* ĤʤSPD_NON_IDˤʤ롥 */
    return id;
}

/* 
 * ηؤΥݥ󥿤򸡺롥
 */

SpdObjId smuFindPointerTo(SpdObjId type)
{
    SpdObjId res;
    SpdCursor *csr;

    if (spdGetClassId(type) != SPD_CID_TYPE) {
        return SPD_NON_ID;
    }
    
    csr = spdGetRelObjInit(type, "type_st", "c-id");
    while ((res = spdGetRelObj(csr)) != SPD_NON_ID) {
        if (spdGetAttrValInt(res, "sort") == TYPE_POINTER) {
            break;
        }
    }
    spdFreeCursor(csr);

    return res;
}

/* 
 * η򸡺롥
 */

SpdObjId smuFindArrayOf(SpdObjId type)
{
    SpdObjId res;
    SpdCursor *csr;

    if (spdGetClassId(type) != SPD_CID_TYPE) {
        return SPD_NON_ID;
    }
    
    csr = spdGetRelObjInit(type, "type_st", "c-id");
    while ((res = spdGetRelObj(csr)) != SPD_NON_ID) {
        if (spdGetAttrValInt(res, "sort") == TYPE_ARRAY) {
            break;
        }
    }
    spdFreeCursor(csr);

    return res;
}
