/* 
 * Program:             $RCSfile: SpdStrSub.h,v $  $Revision: 30.11 $
 * 
 * Purpose:             SpdStr header file.
 * 
 * Author:              N.Fukuyasu, S.Kawai and Y.Momiyama  1995/12/07
 * Modified:            S.Yamamoto  1995/12/08
 * 
 * (C) Copyright:       N.Fukuyasu, S.Kawai, Y.Momiyama
 *                      and S.Yamamoto  1995 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef _SPDSTR_SUB_H
#define _SPDSTR_SUB_H

#define spdStrCat(x, y)     spdStrcat((x), (y))

#define Indent()    res = spdStrCat(res, spdStrIndent())

/* Prototypes. */

SpdString spdStrAppDeclaration(SpdObjId, SpdObjId);
SpdString spdStrAppPrototype(SpdObjId, SpdObjId);
SpdString spdStrBasic(SpdObjId);
SpdString spdStrBlock(SpdObjId);
SpdString spdStrBranch(SpdObjId);
SpdString spdStrConstant(SpdObjId);
SpdString spdStrCompound(SpdObjId);
SpdString spdStrDeclaration(SpdObjId, SpdBoolean);
SpdString spdStrDeclarator(SpdObjId, SpdBoolean);
SpdString spdStrExpression(SpdObjId);
SpdString spdStrFile(SpdObjId);
SpdString spdStrIdentifier(SpdObjId);
SpdString spdStrLabel(SpdObjId);
SpdString spdStrOperator(SpdObjId);
SpdString spdStrOptionaldecl(SpdObjId);
SpdString spdStrType(SpdObjId);
SpdString spdStrTypeDeclaration(SpdObjId);
SpdString spdStrTypeSpecifier(SpdObjId);
SpdString spdStrHfile(SpdObjId);
SpdString spdStrMacroname(SpdObjId);
SpdString spdStrMacrodeclarg(SpdObjId);
SpdString spdStrMacrooptional(SpdObjId);
SpdString spdStrMacropattern(SpdObjId);
SpdString spdStrMacrobody(SpdObjId);
SpdString spdStrPblock(SpdObjId);

#ifdef BUGGY_SDBIN4_0110
SpdString spdStrTypeQualifier(SpdObjId, SpdString, int, SpdBoolean);
#else /* not BUGGY_SDBIN4_0110 */
SpdString spdStrTypeQualifier(SpdObjId, SpdString, int);
#endif /* not BUGGY_SDBIN4_0110 */

/* Utility functions. */

/* SpdString spdStrCat(SpdString, SpdString); */
SpdString spdStrIndent(void);
/* SpdBoolean spdStrIsRemakeFile(int mode); */

#define SPDSTR_IS_REMAKE_FILE_SET 1
#define SPDSTR_IS_REMAKE_FILE_QUERY 2

typedef struct {
    int         offset;
    char        *str;
    SpdObjId    objectId;
} stringInfomation;

typedef struct {
    int         offset;
    char        *name;
    SpdObjId    pblockId;
    SpdBoolean  withUndef;
} macroNameInfomation;

typedef struct {
    int         offset;
    char        *name;
} headerMacroInfomation;
    
SpdString spdStrPblockCutNull(SpdObjId objectId);

SpdBoolean spdObjIsFuncParameter(SpdObjId);
SpdObjId spdGetFuncParm(SpdObjId);
int cmp_offset(const SpdRel *, const SpdRel *);

/* spdDebug.c */
void func_in(char *class_name, char *res);
void func_out(char *class_name, char *res);

/******************************************************************************/

/* For only SpdStr2. */

#define IS_NOT_EXTERN   4
#define IS_WITH_MACRO   2
#define IS_WITH_INDEX   1

SpdObjId getFileFromType(SpdObjId typeId);

void macroInit(SpdObjId sourceId);

SpdString spdStrMacro(SpdObjId objectId);

SpdString macroArgCreateI(int n, int offset, char *filename);
SpdString macroArgCreateC(int n);
SpdString macroArgCreate(int n);
SpdString allCatDefineInfo(int catFlag);
SpdString strCut(SpdString res, int byte);
SpdString cutSpace(SpdString res);

#define MINUS_VALUE     (-1)

/* For include directive. */

int isInHeader(SpdObjId objectId);
SpdString allCatHeaderInfoAR4(SpdObjId ifileId, int catFlag);
SpdBoolean spdObjIdIsInclude(SpdObjId id);
SpdBoolean spdObjIdIsDefine(SpdObjId id);

/******************************************************************************/

/* Debug. */

/*
 * #define DEBUG_0058
 * #define DEBUG_EXPR_960830
 * #define DEBUG_TYPE_960830
 * #define DEBUG_INCLUDE_960830
 * #define DEBUG_INCLUDE_960830_1
 * #define DEBUG_INCLUDE_960914
 * #define DEBUG_INCLUDE_960914_TABLE
 */

/* Macro PRINTF_FLAG is replaced by DW_SPDSTR 1998/02/08. */
/* #define PRINTF_FLAG     0 */

/* #define DW_SPDSTR */

#if defined(DW_SPDSTR) || defined(lint)
#define DW_FUNC_IN          func_in
#define DW_FUNC_OUT         func_out
#else
#define DW_FUNC_IN          (void)
#define DW_FUNC_OUT         (void)
#endif

/******************************************************************************/

/*
 * sdbin3ѹȼ(1997/05/20)
 * ǥեȤˤΤǡʲΥޥϺ(2001/12/24)
 * 
 * #if (2 <= SapidVersion)
 * #define USE_PROT_PARM
 * #define USE_FUNCPTR_PARM
 * #endif
 */

/* 
 * ȼޥŸ褬˥ޥξ˵Хβ
 */

#ifdef BUGGY_SPDSTR_0102

#define SPDSTR_ERROR_MACRO_IN_MACRO     "$$$"

#endif /* BUGGY_SPDSTR_0102 */

/*
 * PIDB_0109ΥХ˵Хβ
 */

#ifdef BUGGY_PIDB_0109

SpdBoolean threeOffsetGetFileNameCfromI(char *iname, int offset, 
                                        int length, char *cname);

#endif /* BUGGY_PIDB_0109 */

#endif /* _SPDSTR_SUB_H */
