/* 
 * Program:             $RCSfile: macroArgument.c,v $  $Revision: 30.10 $
 * 
 * Purpose:
 * 
 * Author:              N.Ito, N.Fukuyasu and S.Yamamoto  1997/06/27
 * 
 * (C) Copyright:       N.Ito, N.Fukuyasu and S.Yamamoto  1997 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] = 
    "$Id: macroArgument.c,v 30.10 2002/12/16 12:09:24 yamamoto Exp yamamoto $";
#endif

#include <ctype.h>
#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/SpdStr.h>
#include "SpdStrSub.h"

static SpdBoolean macroArgExpansionSearch(int n);

/* 
 * "*.c"ե"*.i"եѤޥƹ롥
 * ¼ŪԲǽʤΤSAPID_ARG_LOSTˤ롥
 * 
 * n: ŸǾ郎פƤź
 */

SpdString macroArgCreate(int n) 
{
    SpdString   res = NULL;
    int         i;

    static SpdString save = NULL;
    
    if (save != NULL) {
        spdFree(save);
        save = NULL;
    }
    if (n == SPD_NON_ID) {
        return (res);
    }

    res = spdStrCat(res, "(");
    for (i = 0; i < expandInfo[n].mac->narg; i++) {
        res = spdStrCat(res, "SAPID_ARG_LOST");
        if (i != expandInfo[n].mac->narg - 1) {
            res = spdStrCat(res, ", ");
        }
    }
    res = spdStrCat(res,")"); 
    save = res;
    return (res);
}

/* 
 * iեѤƥޥƹ롥
 */

SpdString macroArgCreateI(int n, int offset, char *filename)
{
    /* ޥΰι¤ */
    struct ArgInfomation {
        char        *name;
        SpdBoolean  foundFlag;
    } *argInfo;
     
    /* ˴ޤޤƤޥ */
    struct MacroInArg {
        char *name;
        int start;
        int end;
    } *macroArg;
    
    SpdString   res = NULL;
    
    int         macroArgIndex;
    FILE        *fp; 
    char        *buf = NULL;
    int         bufIndex;
    int         i, j, k;
    int         *arg_n;
    int         tmp_length;

    static SpdString save = NULL;

    if (save != NULL) {
        spdFree(save);
        save = NULL;
    }
    if (n == SPD_NON_ID && offset == SPD_NON_ID) {
        return (res);
    }

    argInfo = spdMalloc(sizeof(struct ArgInfomation) * expandInfo[n].mac->narg);
    for(i = 0; i < expandInfo[n].mac->narg; i++){
        argInfo[i].name = NULL;
        argInfo[i].foundFlag = FALSE;
    }

    fp = smuOpenSrcFile(smuGetFileIdByName(filename));

    res = spdStrCat(res, "(");

    /* ö˳Ǽ롥 */
    SPD_FSEEK(fp, offset, SEEK_SET);
    for (i = 0; i < expandInfo[n].mac->nref; i++) {
        macroArgIndex = 0;
        arg_n = &expandInfo[n].mac->ref[i].argn;
       
        /* ޥ롥 */
        for (j = 0; j < expandInfoN; j++) {
            if (expandInfo[j].input.type == CALL_MACROARG &&
                expandInfo[j].input.macexpID == n &&
                expandInfo[j].input.argn == *arg_n &&
                !argInfo[*arg_n].foundFlag) {
           
                if (macroArgIndex == 0) {
                    macroArg = spdMalloc(sizeof(struct MacroInArg));
                } else {
                    macroArg = spdRealloc(macroArg, 
                                          sizeof(struct MacroInArg) *
                                          (macroArgIndex + 1) +
                                          sizeof(struct MacroInArg));
                }
     
                macroArg[macroArgIndex].name = NULL;
                macroArg[macroArgIndex].name 
                    = spdStrCat(macroArg[macroArgIndex].name,
                                expandInfo[j].mac->name);
                macroArg[macroArgIndex].start = expandInfo[j].output.start;
                macroArg[macroArgIndex].end = expandInfo[j].output.end;
 
                if (expandInfo[j].mac->narg == 0) {
                    macroArg[macroArgIndex].name 
                        = spdStrCat(macroArg[macroArgIndex].name, "()");
                } else if(expandInfo[j].mac->narg != SPD_NON_ID){
                    macroArg[macroArgIndex].name 
                        = spdStrCat(macroArg[macroArgIndex].name,
                                    macroArgCreateI(j, ftell(fp) + expandInfo[n].mac->ref[expandInfo[j].input.argn].nchar, filename));  
                }
                macroArgIndex++;
            }   
        }

#ifdef BUGGY_SPDSTR_0102 

        if (spdGetOption("buggy-SpdStr-0102") == ON) {
            if (macroArgExpansionSearch(n)) {
                save = res;
                spdFree(argInfo);
                if (macroArgIndex != 0) {
                    for (k = 0; k < macroArgIndex; k++) {
                        spdFree(macroArg[k].name);
                    }
                    spdFree(macroArg);
                }
                spdFclose(fp);
                return NULL;
            }
        }

#endif /* BUGGY_SPDSTR_0102 */
        
        /* եݥ󥿤νи˹碌Τ
           ˾ʤǤʤ */
        SPD_FSEEK(fp, expandInfo[n].mac->ref[i].nchar, SEEK_CUR); 
 
        buf = NULL;
        if(expandInfo[n].mac->ref[i].stringify){
            SPD_FSEEK(fp, sizeof(char), SEEK_CUR); /* ֥륯ơ */
            buf = spdMalloc(expandInfo[n].arg[*arg_n].stringified_length);
            fgets(buf, 
                  sizeof(char) * expandInfo[n].arg[*arg_n].stringified_length - 1,
                  fp);
            SPD_FSEEK(fp, sizeof(char), SEEK_CUR); /* ֥륯ơ */
        } else {
            buf = NULL;
            tmp_length = expandInfo[n].arg[*arg_n].expanded_length; 
       
            bufIndex = 0;
            for (j = 0; j < tmp_length; j++) {
                if (bufIndex == 0) {
                    buf = spdMalloc(2);
                } else {
                    buf = spdRealloc(buf, sizeof(char) * (bufIndex + 2));
                }
           
                buf[bufIndex] = (char)fgetc(fp);
                buf[bufIndex + 1] = '\0';
                if (macroArgIndex != 0) {
                    for (k = 0; k < macroArgIndex; k++) {
                        if (j == macroArg[k].start) {
                            buf[bufIndex] = '\0';
                            buf = spdStrCat(buf, macroArg[k].name);
                            j = macroArg[k].end;
                            SPD_FSEEK(fp, sizeof(char) *
                                      (macroArg[k].end - macroArg[k].start),
                                      SEEK_CUR);
                            bufIndex += (strlen(macroArg[k].name) - 1);
                            spdFree(macroArg[k].name);
                            break;
                        }
                    }
                }
                bufIndex++;
            }
            buf[bufIndex] = '\0';
        }

        if (!argInfo[*arg_n].foundFlag) {
            argInfo[*arg_n].name = NULL;
            argInfo[*arg_n].name = spdStrCat(argInfo[*arg_n].name,
                                             cutSpace(buf));
            argInfo[*arg_n].foundFlag = TRUE;
        }

        spdFree(buf);
        if (macroArgIndex != 0) {
            spdFree(macroArg);
        }
    }

    /* ˳Ǽ줿Ÿ롥 */
    for (i = 0; i < expandInfo[n].mac->narg; i++) {
        if (argInfo[i].foundFlag) {
            res = spdStrCat(res, argInfo[i].name);
        } else {
            res = spdStrCat(res, "SAPID_ARG_LOST");
        }
        spdFree(argInfo[i].name);
        if (i != expandInfo[n].mac->narg - 1) {
            res = spdStrCat(res, ", ");
        }
    }

    res = spdStrCat(res,")"); 

    spdFree(argInfo); 
    spdFclose(fp);

    save = res;
    return (res);
}

/* 
 * "*.c"ե"*.i"եѤƥޥƹ롥
 * 
 * n: ŸǾ郎פƤź
 */

SpdString macroArgCreateC(int n) 
{
    SpdString   res = NULL;
    char        buf[SPD_LINE_LEN + 1];
    FILE        *fp;
    int         i;
    
    static SpdString save = NULL;

    if (save != NULL) {
        spdFree(save);
        save = NULL;
    }
    if (n == SPD_NON_ID) {
        return (res);
    }

    fp = smuOpenSrcFile(smuGetFileIdByName(expandInfo[n].mac->pos.fname));
    res = spdStrCat(res, "(");
    for (i = 0; i < expandInfo[n].mac->narg; i++) {
        SPD_FSEEK(fp, expandInfo[n].arg[i].start +
                  expandInfo[n].arg[i].trailing_space, SEEK_SET);
        fgets(buf, sizeof(char) *
              (expandInfo[n].arg[i].raw_length - 
               expandInfo[n].arg[i].following_space + 1 -
               expandInfo[n].arg[i].trailing_space),
              fp);
        res = spdStrCat(res, buf);
        if (i != expandInfo[n].mac->narg - 1) {
            res = spdStrCat(res, ", ");
        }
    }
    res = spdStrCat(res,")"); 
    spdFclose(fp);
    
    save = res;
    return (res);
}

#ifdef BUGGY_SPDSTR_0102

static SpdBoolean macroArgExpansionSearch(int n)
{
    int     i;

    for (i = 0; i < expandInfoN; i++) {
        if ((expandInfo[i].input.type == CALL_MACROEXPANSION ||
             expandInfo[i].input.type == CALL_MACROARG) &&
            expandInfo[i].input.macexpID == n) {
            return (TRUE);
        }
    }
    return (FALSE);
}

#endif /* BUGGY_SPDSTR_0102 */
