/* 
 * Program:             $RCSfile: macroUtil.c,v $  $Revision: 30.3 $
 * 
 * Purpose:
 * 
 * Author:              N.Ito, N.Fukuyasu and S.Yamamoto  1997/06/27
 * 
 * (C) Copyright:       N.Ito, N.Fukuyasu and S.Yamamoto  1997 - 1998
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] = 
    "$Id: macroUtil.c,v 30.3 2002/10/21 07:25:57 yamamoto Exp yamamoto $";
#endif

#include <ctype.h>
#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/SpdStr.h>
#include "SpdStrSub.h"

/* #define ʸ */

SpdString allCatDefineInfo(int catFlag)
{
    /*
     * catFlag:
     * TRUE: ̾ư
     * FALSE: 곫ѡưϹԤʤ
     */

    static SpdString save = NULL;
    SpdString res = NULL;
    int i,j,pwd;
    int fileLen;

    if(save != NULL){
        spdFree(save);
        save = NULL;
    }

    if(catFlag == FALSE) return res;

    for(i = 0; i < defineInfoN; i++){
        if(defineInfo[i].pos.type == DEFINE_FILE){ 
            fileLen = strlen(defineInfo[i].pos.fname);
            if(defineInfo[i].pos.fname[fileLen - 1] != 'h'){ 
                res = spdStrCat(res, "#define ");
                if(defineInfo[i].narg == SPD_NON_ID){
                    res = spdStrCat(res, defineInfo[i].name);
                    res = spdStrCat(res, " ");
                    res = spdStrCat(res, defineInfo[i].expansion);
                    res = spdStrCat(res, "\n");
                } else if(defineInfo[i].narg == 0){
                    res = spdStrCat(res, defineInfo[i].name);
                    res = spdStrCat(res, "() ");
                    res = spdStrCat(res, defineInfo[i].expansion);
                    res = spdStrCat(res, "\n");
                } else {
                    res = spdStrCat(res, defineInfo[i].name);
                    res = spdStrCat(res, "(");
                    for(j = 0; j < defineInfo[i].narg; j++){
                        if(j != 0){
                            res = spdStrCat(res, ",");
                        }
                        res = spdStrCat(res, defineInfo[i].arg[j]);
                    }
                    res = spdStrCat(res, ") ");
      
                    pwd = 0;
                    for(j = 0; j < defineInfo[i].nref; j++){
                        res = spdStrCat(res,
                                        strCut(defineInfo[i].expansion + pwd, 
                                               defineInfo[i].ref[j].nchar));
                        pwd += defineInfo[i].ref[j].nchar;
                        if(defineInfo[i].ref[j].raw_before)
                            res = spdStrCat(res, " ## ");
                        if(defineInfo[i].ref[j].stringify)
                            res = spdStrCat(res, "#");
                        res = spdStrCat(res,
                                        defineInfo[i].arg[defineInfo[i].ref[j].argn]);
                        if(j == defineInfo[i].nref - 1)
                            res = spdStrCat(res, defineInfo[i].expansion + pwd);
                    }   
                    res = spdStrCat(res, "\n");
                }
            }
        }
    }
    res = spdStrCat(res, "\n");

    save = res;
    return res;
}

/* ʸ byte 礭ڤ(sprintf()Ȥ٤) */

SpdString strCut(SpdString res, int byte)
{
    SpdString str = NULL;
    static SpdString save = NULL;

    if(save != NULL){
        spdFree(save);
        save = NULL;
    }

    if(res == NULL && byte == SPD_NON_ID){
        return str;
    }

    str = spdMalloc(byte + 1);
    strncpy(str, res, byte);
    str[byte] = '\0';

    save = str;
    return str;
}

/* ƬΥڡ롥 */

SpdString cutSpace(SpdString res)
{
    int i = 0,k;

    if(res == NULL){
        return NULL;
    }

    while(!isgraph(res[i])){
        i++;
    }
  
    k = strlen(res);
    while(!isgraph(res[k])){
        k--;
    }
  
    res[k + 1] = '\0'; 
    return &res[i];
}
