/* 
 * Program:             $RCSfile: spdStr.c,v $  $Revision: 30.9 $
 * 
 * Purpose:
 * 
 * Author:              N.Fukuyasu, S.Kawai and Y.Momiyama  1995/12/07
 * Modified:            S.Yamamoto  1995/12/08
 * 
 * (C) Copyright:       N.Fukuyasu, S.Kawai, Y.Momiyama
 *                      and S.Yamamoto  1995 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdStr.c,v 30.9 2002/10/28 10:26:36 yamamoto Exp yamamoto $";
#endif

/* 
 * SpdStr  memory leak ηǤ
 * 
 * SpdString spdStrXxx(void)
 * {
 *     static SpdString save = NULL;
 *     SpdString res = NULL;
 * 
 *     if (save != NULL) {
 *         spdFree(save);
 *         save = NULL;
 *     }
 *     ...
 *     res = spdStrCat(res, spdStrXxx());
 *     ...
 *     if (save != NULL) spdFree(save);   <--- ιԤɲá
 *     save = res;
 * }
 * 
 * ȤɤǤ礦?
 * ƵƤӽФεؿΤɲäФϤǤ
 *
 * ƵƤӽФβǽ(spdStrϾά):
 * Block, Branch, Compound, Declarator, Optionaldecl,
 * Expression, AppDeclaration, Declaration, TypeSpecifier, TypeQualifier
 * 
 * ƵƤӽФβǽʤ:
 * Basic, Label, Identifier, Constant, Operator,
 * AppPrototype, Type, TypeDeclaration
 */

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/SpdStr.h>
#include "SpdStrSub.h"

int indent = 0;

static SpdBoolean spdIsFuncDecl(SpdObjId objectId);

/*
 * Declaration(DECL_PARMETER) ؿΤΰ
 * ä TRUE ֤
 */

SpdBoolean spdObjIsFuncParameter(SpdObjId objectId)
{
    if (spdGetClassId(objectId) != SPD_CID_DECLARATION) {
        return FALSE;
    }
    return (spdGetARelObj(objectId, "func_parm", "declaration_id")
            != SPD_NON_ID);
}

/*
 * ؿ̾ɽidentifierؿΤoptionaldecl򸫤Ĥ롥
 */

SpdObjId spdGetFuncParm(SpdObjId objectId)
{
    SpdObjIdArray   decl_array;
    SpdObjId        opt_id;

    decl_array = spdGetRelObjArray(objectId, "decl_ident", "identifier_id",
                                   spdIsFuncDecl);
    if (decl_array.size == 0) {
        return (SPD_NON_ID);
    } else {
        opt_id = spdGetARelObj(decl_array.id[0], "decl_opt", "declarator_id");
        return (opt_id);
    }
}

static SpdBoolean spdIsFuncDecl(SpdObjId objectId)
{
    return (spdGetAttrValInt(objectId, "sort") == DECL_FUNCDEF);
}

int cmp_offset(const SpdRel *a, const SpdRel *b)
{
    return (spdGetOffset(a->relationId) - spdGetOffset(b->relationId));
}

SpdString spdStrIndent(void)
{
    static SpdString save = NULL;
    static SpdString indentStr = "    ";    /* Indent string. */

    SpdString   res = NULL;
    int         i;

    if (save != NULL) {
        spdFree(save);
        save = NULL;
    }

    for (i = 0; i < indent; i++) {
        res = spdStrCat(res ,indentStr);
    }

    save = res;
    return res;
}

SpdString spdStr(SpdObjId objectId)
{
    SpdString   res = NULL;
    int         modeOption;
    SpdOcc      occ;
    SpdObjId    fileId;                     /* objectId  type λ˻Ȥ */
    int         classId;

    static SpdString    save = NULL;

    occ.fileId = SPD_NON_ID;

    modeOption = spdGetOption("mode");
    if (spdGetClassId(objectId) == SPD_CID_TYPE) {
        fileId = getFileFromType(objectId);

        /* Ǥ fileId ʤΤǤϤʤ(Ϥ) */
        if (fileId == SPD_NON_ID) {
            modeOption = spdGetOption("mode");  
            spdSetOption("mode", SAPID_I_MODE);
        } else {
            macroInit(fileId);
        }
    } else if (objectId != SPD_NON_ID) {
        if (spdGetClassId(objectId) == SPD_CID_FILE) {
            macroInit(objectId);
        } else {
            occ = spdGetAnOffsetOfObj(objectId);
            if (occ.fileId != SPD_NON_ID) {
                macroInit(occ.fileId);
            }
        }
    }

    if (save != NULL) {
        spdFree(save);
        save = NULL;
    }

    classId = spdGetClassId(objectId);
    if (classId == SPD_CID_FILE) {
        res = spdStrCat(res, spdStrFile(objectId));
    } else if (classId == SPD_CID_DECLARATION) {
        res = spdStrCat(res, spdStrDeclaration(objectId, FALSE));
    } else if (classId == SPD_CID_DECLARATOR) {
        res = spdStrCat(res, spdStrDeclarator(objectId, FALSE));
    } else if (classId == SPD_CID_OPTIONALDECL) {
        res = spdStrCat(res, spdStrOptionaldecl(objectId));
    } else if (classId == SPD_CID_BLOCK) {
        res = spdStrCat(res, spdStrBlock(objectId));
    } else if (classId == SPD_CID_EXPRESSION) {
        res = spdStrCat(res, spdStrExpression(objectId));
    } else if (classId == SPD_CID_OPERATOR) {
        res = spdStrCat(res, spdStrOperator(objectId));
    } else if (classId == SPD_CID_TYPE) {
        res = spdStrCat(res, spdStrType(objectId));
    } else if (classId == SPD_CID_IDENTIFIER) {
        res = spdStrCat(res, spdStrIdentifier(objectId));
    } else if (classId == SPD_CID_LABEL) {
        res = spdStrCat(res, spdStrLabel(objectId));
    } else if (classId == SPD_CID_CONSTANT) {
        res = spdStrCat(res, spdStrConstant(objectId));
    } else if (classId == SPD_CID_HFILE) {
        res = spdStrCat(res, spdStrHfile(objectId));
    } else if (classId == SPD_CID_MACRONAME) {
        res = spdStrCat(res, spdStrMacroname(objectId));
    } else if (classId == SPD_CID_MACRODECLARG) {
        res = spdStrCat(res, spdStrMacrodeclarg(objectId));
    } else if (classId == SPD_CID_MACROOPTIONAL) {
        res = spdStrCat(res, spdStrMacrooptional(objectId));
    } else if (classId == SPD_CID_MACROPATTERN) {
        res = spdStrCat(res, spdStrMacropattern(objectId));
    } else if (classId == SPD_CID_MACROBODY) {
        res = spdStrCat(res, spdStrMacrobody(objectId));
    } else if (classId == SPD_CID_PBLOCK) {
        res = spdStrCat(res, spdStrPblock(objectId));
    }

    spdSetOption("mode", modeOption);
    save = res;

    return (res);
}

void spdStrFree(void)
{
    spdStrAppDeclaration(SPD_NON_ID, SPD_NON_ID);
    spdStrAppPrototype(SPD_NON_ID, SPD_NON_ID);
    spdStrBasic(SPD_NON_ID);
    spdStrBlock(SPD_NON_ID);
    spdStrBranch(SPD_NON_ID);
    spdStrConstant(SPD_NON_ID);
    spdStrCompound(SPD_NON_ID);
    spdStrDeclaration(SPD_NON_ID, FALSE);
    spdStrDeclarator(SPD_NON_ID, FALSE);
    spdStrExpression(SPD_NON_ID);
    spdStrFile(SPD_NON_ID);
    spdStrIdentifier(SPD_NON_ID);
    spdStrLabel(SPD_NON_ID);
    spdStrOperator(SPD_NON_ID);
    spdStrOptionaldecl(SPD_NON_ID);
    spdStrType(SPD_NON_ID);
    spdStrTypeDeclaration(SPD_NON_ID);
    spdStrTypeSpecifier(SPD_NON_ID);

#ifdef BUGGY_SDBIN4_0110
    spdStrTypeQualifier(SPD_NON_ID, NULL, 0, FALSE);
#else  /* not BUGGY_SDBIN4_0110 */
    spdStrTypeQualifier(SPD_NON_ID, NULL, 0);
#endif /* not BUGGY_SDBIN4_0110 */

    strCut(NULL, SPD_NON_ID);

    spdStrHfile(SPD_NON_ID);
    spdStrMacroname(SPD_NON_ID);
    spdStrMacrodeclarg(SPD_NON_ID);
    spdStrMacrooptional(SPD_NON_ID);
    spdStrMacropattern(SPD_NON_ID);
    spdStrMacrobody(SPD_NON_ID);
    spdStrPblock(SPD_NON_ID);

    allCatHeaderInfoAR4(SPD_NON_ID,FALSE);
    allCatDefineInfo(FALSE);
    
    /* Commented by S.Yamamoto 1998/08/09. */
    /* macroCreate(NULL, SPD_NON_ID, SPD_NON_ID); */

    macroArgCreateI(SPD_NON_ID, SPD_NON_ID, NULL);
    macroArgCreateC(SPD_NON_ID);
    macroArgCreate(SPD_NON_ID);
    
    spdStrMacro(SPD_NON_ID);

    spdStr(SPD_NON_ID);
}
