/* 
 * Program:             $RCSfile: spdStr_decl.c,v $  $Revision: 30.9 $
 * 
 * Purpose:
 * 
 * Author:              N.Fukuyasu, S.Kawai and Y.Momiyama  1995/12/07
 * Modified:            S.Yamamoto  1995/12/08
 * 
 * (C) Copyright:       N.Fukuyasu, S.Kawai, Y.Momiyama
 *                      and S.Yamamoto  1995 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdStr_decl.c,v 30.9 2003/06/28 15:31:15 yamamoto Exp yamamoto $";
#endif

#include <ctype.h>
#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/SpdStr.h>
#include "SpdStrSub.h"

extern int indent;

SpdString spdStrDeclarator(SpdObjId objectId, SpdBoolean asProtoParm)
{
    SpdString       res = NULL;
    SpdObjId        obj_id, obj_type_id, decl_id, type_id;
    SpdString       tmpRes = NULL;
    SpdOccArray     opt_buf;
    SpdOcc          occ;
    int             sort;
    int             opt_proto;
    int             i;

    static SpdString    save = NULL;

#ifdef BUGGY_SPDSTR_0102
    SpdBoolean      buggyFlag = FALSE;
    int             modeOption;
#endif /* BUGGY_SPDSTR_0102 */

    if (save != NULL) {
        spdFree(save);
        save = NULL;
    }

    /* objectId Υ饹 declarator ǤʤСNULL ֤ */
    if ((spdGetClassId(objectId)) != SPD_CID_DECLARATOR) {
        return res;
    }

    res = spdStrCat(res, spdStrMacro(objectId));

#ifdef BUGGY_SPDSTR_0102
    if(res != NULL){
        if(SPD_STREQ(res, SPDSTR_ERROR_MACRO_IN_MACRO)){
            modeOption = spdGetOption("mode");
            spdSetOption("mode", SAPID_I_MODE);
            buggyFlag = TRUE;
            spdFree(res);
            res = NULL;
        }
    }
#endif /* BUGGY_SPDSTR_0102 */

    if(res != NULL){
        save = res;
        return res;
    }

    occ = spdGetAnOffsetOfObj(objectId);
    switch (sort = spdGetAttrValInt(objectId, "sort")) {
      case DECL_VARIABLE:                   /* ѿ */
      case DECL_MEMBER:                     /* Ф */
      case DECL_TYPE:                       /* typedef ˤ */
        decl_id = spdGetARelObj(objectId, "decl_decl", "declarator_id");
        if ((spdGetAttrValInt(decl_id, "sort") == DECL_PARAMETER) &&
            (asProtoParm || spdObjIsFuncParameter(decl_id) == FALSE)) {
            opt_proto = spdGetOption("prototype");
            switch (opt_proto) {
              case SPDSTR_PROTOTYPE_NON:
                obj_id = spdGetARelObj(objectId, "decl_ident",
                                       "declarator_id");
                /* obj_type_id = spdGetARelObj(obj_id, "ident_type",
                   "identifier_id"); */
                obj_type_id = spdGetARelObj(objectId, "decr_type",
                                            "declarator_id");
#ifdef BUGGY_SDBIN4_0110
                res = spdStrCat(res,
                                spdStrTypeQualifier(obj_type_id,
                                                    spdStrIdentifier(obj_id),
                                                    sort, FALSE));
#else  /* BUGGY_SDBIN4_0110 */
                res = spdStrCat(res,
                                spdStrTypeQualifier(obj_type_id,
                                                    spdStrIdentifier(obj_id),
                                                    sort));
#endif /* BUGGY_SDBIN4_0110 */
                opt_buf = spdGetIncludedOccSortedArray(objectId, 
                                                       "optionaldecl", 
                                                       occ.fileId, NULL,
                                                       spdCompareOccOffset);
                for(i = 0; i < opt_buf.size; i++){
                    if(spdGetAttrValInt(opt_buf.occ[i].objectId, "sort")
                       != OPT_FUNCPTR) 
                        res = spdStrCat(res, " ");
                    res = spdStrCat(res, spdStrOptionaldecl(opt_buf.occ[i].objectId));
                }
                spdFreeOccArray(opt_buf);
                break;
              case SPDSTR_PROTOTYPE_TYPE:
                obj_id = spdGetARelObj(objectId, "decl_ident",
                                       "declarator_id");
                /* obj_type_id = spdGetARelObj(obj_id, "ident_type",
                   "identifier_id"); */
                obj_type_id = spdGetARelObj(objectId, "decr_type",
                                            "declarator_id");
#ifdef BUGGY_SDBIN4_0110
                res = spdStrCat(res,
                                spdStrTypeQualifier(obj_type_id, 
                                                    NULL, sort, FALSE));
#else  /* BUGGY_SDBIN4_0110 */
                res = spdStrCat(res,
                                spdStrTypeQualifier(obj_type_id, NULL, sort));
#endif /* BUGGY_SDBIN4_0110 */

                opt_buf = spdGetIncludedOccSortedArray(objectId, 
                                                       "optionaldecl", 
                                                       occ.fileId, NULL,
                                                       spdCompareOccOffset);
                for(i = 0; i < opt_buf.size; i++){
                    if(spdGetAttrValInt(opt_buf.occ[i].objectId, "sort")
                       != OPT_FUNCPTR) 
                        res = spdStrCat(res, " ");
                    res = spdStrCat(res, spdStrOptionaldecl(opt_buf.occ[i].objectId));
                }
                spdFreeOccArray(opt_buf);

                break;
              case SPDSTR_PROTOTYPE_IDENT:
                obj_id = spdGetARelObj(objectId, "decl_ident",
                                       "declarator_id");
                res = spdStrCat(res, spdStrIdentifier(obj_id));
                break;
              case SPDSTR_PROTOTYPE_ALL:
                obj_id = spdGetARelObj(objectId, "decl_ident",
                                       "declarator_id");
                /* obj_type_id = spdGetARelObj(obj_id, "ident_type",
                   "identifier_id"); */
                obj_type_id = spdGetARelObj(objectId, "decr_type",
                                            "declarator_id");
#ifdef BUGGY_SDBIN4_0110
                res = spdStrCat(res,
                                spdStrTypeQualifier(obj_type_id,
                                                    spdStrIdentifier(obj_id),
                                                    sort, FALSE));
#else  /* BUGGY_SDBIN4_0110 */
                res = spdStrCat(res,
                                spdStrTypeQualifier(obj_type_id,
                                                    spdStrIdentifier(obj_id),
                                                    sort));
#endif /* BUGGY_SDBIN4_0110 */
                opt_buf = spdGetIncludedOccSortedArray(objectId, 
                                                       "optionaldecl", 
                                                       occ.fileId, NULL,
                                                       spdCompareOccOffset);

                for(i = 0; i < opt_buf.size; i++){
                    if(spdGetAttrValInt(opt_buf.occ[i].objectId, "sort")
                       != OPT_FUNCPTR) 
                        res = spdStrCat(res, " ");
                    res = spdStrCat(res, spdStrOptionaldecl(opt_buf.occ[i].objectId));
                }
                spdFreeOccArray(opt_buf);

                break;
            }
        } else {
            obj_id = spdGetARelObj(objectId, "decl_ident", "p-id");
            /*
             * void foo(a)
             * char *a;
             * { ... }
             * ȤؿΤ a  qualifier դ뤫ɤ
             * ꤹΤ˿Ƥ declaration δϢ decl_type ̵ͭ
             * Ĵ٤롥
             */
            /* decl_id = spdGetARelObj(objectId, "decl_decl", "c-id");*/
            if (spdGetARelObj(decl_id, "decl_type", "p-id") != SPD_NON_ID) {
                /* obj_type_id = spdGetARelObj(obj_id, "ident_type", "any"); */
                obj_type_id = spdGetARelObj(objectId, "decr_type",
                                            "declarator_id");
#ifdef BUGGY_SDBIN4_0110
                res = spdStrCat(res,
                                spdStrTypeQualifier(obj_type_id,
                                                    spdStrIdentifier(obj_id),
                                                    sort, FALSE));
#else  /* BUGGY_SDBIN4_0110 */
                res = spdStrCat(res,
                                spdStrTypeQualifier(obj_type_id,
                                                    spdStrIdentifier(obj_id),
                                                    sort));
#endif /* BUGGY_SDBIN4_0110 */
            } else {                        /* ѥ᡼ѿΤߤξ */
                res = spdStrCat(res, spdStrIdentifier(obj_id));
            }

            opt_buf = spdGetIncludedOccSortedArray(objectId, "optionaldecl",
                                                   occ.fileId, NULL, 
                                                   spdCompareOccOffset);
        
            for(i = 0; i < opt_buf.size; i++){
                if(spdGetAttrValInt(opt_buf.occ[i].objectId, "sort")
                   != OPT_FUNCPTR) 
                    res = spdStrCat(res, " ");
                res = spdStrCat(res, spdStrOptionaldecl(opt_buf.occ[i].objectId));
            }
            spdFreeOccArray(opt_buf);
        }
        break;
      case DECL_FUNCDEF:                    /* ؿ */
        obj_id = spdGetARelObj(objectId, "decl_ident", "p-id");
        /* obj_type_id = spdGetARelObj(obj_id, "ident_type", "any"); */
        obj_type_id = spdGetARelObj(objectId, "decr_type", "declarator_id");
#ifdef BUGGY_SDBIN4_0110
        res = spdStrCat(res, spdStrTypeQualifier(obj_type_id,
                                                 spdStrIdentifier(obj_id),
                                                 sort, FALSE));
#else  /* BUGGY_SDBIN4_0110 */
        res = spdStrCat(res, spdStrTypeQualifier(obj_type_id,
                                                 spdStrIdentifier(obj_id),
                                                 sort));
#endif /* BUGGY_SDBIN4_0110 */
        obj_id = spdGetARelObj(objectId, "decl_opt", "p-id");
        tmpRes = spdStrCat(tmpRes, spdStrOptionaldecl(obj_id));
        if(tmpRes != NULL){
            if(isalpha(tmpRes[0]) || tmpRes[0] == '_'){
                res = spdStrCat(res, " ");
            }
        }
        spdFree(tmpRes);
        res = spdStrCat(res, spdStrOptionaldecl(obj_id));
        break;
      case DECL_PROTOTYPE:                  /* ؿΥץȥ */
        obj_id = spdGetARelObj(objectId, "decl_ident", "p-id");
        /* obj_type_id = spdGetARelObj(obj_id, "ident_type", "any"); */
        obj_type_id = spdGetARelObj(objectId, "decr_type", "declarator_id");
#ifdef BUGGY_SDBIN4_0110
        res = spdStrCat(res, spdStrTypeQualifier(obj_type_id,
                                                 spdStrIdentifier(obj_id),
                                                 sort, FALSE));
#else  /* BUGGY_SDBIN4_0110 */
        res = spdStrCat(res, spdStrTypeQualifier(obj_type_id,
                                                 spdStrIdentifier(obj_id),
                                                 sort));
#endif /* BUGGY_SDBIN4_0110 */
        obj_id = spdGetARelObj(objectId, "decl_opt", "p-id");
        tmpRes = spdStrCat(tmpRes, spdStrOptionaldecl(obj_id));
        if(tmpRes != NULL){
            if(isalpha(tmpRes[0]) || tmpRes[0] == '_'){
                res = spdStrCat(res, " ");
            }
        }
        spdFree(tmpRes);
        res = spdStrCat(res, spdStrOptionaldecl(obj_id));
        break;
      case DECL_TAG:                        /* ķޤ */
        if ((obj_id = spdGetARelObj(objectId, "decl_ident", "p-id")) != -1) {
            res = spdStrCat(res, spdStrIdentifier(obj_id));
            res = spdStrCat(res, " ");
        }
        obj_id = spdGetARelObj(objectId, "decl_opt", "p-id");
        res = spdStrCat(res, spdStrOptionaldecl(obj_id));
        break;
      case DECL_ENUMERATOR:                 /* 󷿤 */
        obj_id = spdGetARelObj(objectId, "decl_ident", "p-id");
        res = spdStrCat(res, spdStrIdentifier(obj_id));
        if ((obj_id = spdGetARelObj(objectId, "decl_opt", "p-id")) != -1) {
            res = spdStrCat(res, " ");
            res = spdStrCat(res, spdStrOptionaldecl(obj_id));
        }
        break;
      case DECL_PARMTYPE:                   /* η */
        opt_proto = spdGetOption("prototype");
        switch (opt_proto) {
          case SPDSTR_PROTOTYPE_NON:
          case SPDSTR_PROTOTYPE_TYPE:
            type_id = spdGetARelObj(objectId, "decr_type", "declarator_id");
            if (type_id != SPD_NON_ID) {
#ifdef BUGGY_SDBIN4_0110
                res = spdStrCat(res,
                                spdStrTypeQualifier(type_id, NULL, 
                                                    sort, FALSE));
#else  /* BUGGY_SDBIN4_0110 */
                res = spdStrCat(res,
                                spdStrTypeQualifier(type_id, NULL, sort));
#endif /* BUGGY_SDBIN4_0110 */
            }

            if ((obj_id = spdGetARelObj(objectId, "decl_opt", "declarator_id"))
                != SPD_NON_ID) {
                if (spdGetAttrValInt(obj_id, "sort") != OPT_FUNCPTR)
                    res = spdStrCat(res, " ");
                res = spdStrCat(res, spdStrOptionaldecl(obj_id));
            }
            break;
          case SPDSTR_PROTOTYPE_IDENT:
            break;
          case SPDSTR_PROTOTYPE_ALL:
            type_id = spdGetARelObj(objectId, "decr_type", "declarator_id");
            if (type_id != SPD_NON_ID) {
#ifdef BUGGY_SDBIN4_0110
                res = spdStrCat(res,
                                spdStrTypeQualifier(type_id, NULL, 
                                                    sort, FALSE));
#else  /* BUGGY_SDBIN4_0110 */
                res = spdStrCat(res,
                                spdStrTypeQualifier(type_id, NULL, sort));
#endif /* BUGGY_SDBIN4_0110 */
            }
            if ((obj_id = spdGetARelObj(objectId, "decl_opt", "declarator_id"))
                != SPD_NON_ID) {
                if (spdGetAttrValInt(obj_id, "sort") != OPT_FUNCPTR)
                    res = spdStrCat(res, " ");
                res = spdStrCat(res, spdStrOptionaldecl(obj_id));
            }
            break;
        }
        break;
      default:
        break;
    }

    if (save != NULL){
        spdFree(save);
        save = NULL;
    }
    save = res;

#ifdef BUGGY_SPDSTR_0102
    if(buggyFlag)
        spdSetOption("mode", modeOption);
#endif /* BUGGY_SPDSTR_0102 */

    return res;
}

SpdString spdStrOptionaldecl(SpdObjId objectId)
{
    static SpdString save = NULL;
    SpdString   res = NULL;
    SpdObjId    obj_id;
    SpdCursor   *csr;
    SpdRel  opt_rel, *opt_buf;
    int     opt_buf_n, i;
    SpdRelArray decl_rel_array;
    SpdBoolean  first_parm, as_proto_parm = FALSE;

#ifdef BUGGY_SPDSTR_0102
    SpdBoolean buggyFlag = FALSE;
    int modeOption;
#endif /* BUGGY_SPDSTR_0102 */

    if (save != NULL) {
        spdFree(save);
        save = NULL;
    }

    /* objectId Υ饹 optionaldecl ǤʤСNULL ֤ */
    if ((spdGetClassId(objectId)) != SPD_CID_OPTIONALDECL) {
        return res;
    }

    res = spdStrCat(res, spdStrMacro(objectId));

#ifdef BUGGY_SPDSTR_0102
    if(res != NULL){
        if(SPD_STREQ(res, SPDSTR_ERROR_MACRO_IN_MACRO)){
            modeOption = spdGetOption("mode");
            spdSetOption("mode", SAPID_I_MODE);
            buggyFlag = TRUE;
            spdFree(res);
            res = NULL;
        }
    }
#endif /* BUGGY_SPDSTR_0102 */

    if(res != NULL){
        save = res;
        return res;
    }

    switch (spdGetAttrValInt(objectId, "sort")) {
      case OPT_PROTOTYPE:                   /* ץȥΰ */
        res = spdStrCat(res, "(");
        if (spdGetOption("prototype") != SPDSTR_PROTOTYPE_NON) {
            SpdObjId    ident_id;
            SpdObjId    parm_id;
            
            ident_id = spdGetARelObj(spdGetARelObj(objectId, "decl_opt",
                                                   "optionaldecl_id"),
                                     "decl_ident", "declarator_id");
            parm_id = spdGetFuncParm(ident_id);
            decl_rel_array = spdGetRelSortedArray(parm_id, "func_parm",
                                                  "optionaldecl_id", NULL,
                                                  spdCompareRelOffset);
            as_proto_parm = TRUE;
        } else {
            decl_rel_array = spdGetRelSortedArray(objectId, "prot_parm",
                                                  "p-id", NULL,
                                                  spdCompareRelOffset);
        }
        first_parm = TRUE;
        for (i = 0; i < decl_rel_array.size; i++) {
            SpdString   tmp = NULL;
            
            obj_id = decl_rel_array.rel[i].objectId;
            tmp = spdStrDeclaration(obj_id, as_proto_parm);
            if (tmp != NULL) {
                if (first_parm == TRUE) {
                    first_parm = FALSE;
                } else {
                    res = spdStrCat(res, ", ");
                }
                res = spdStrCat(res, tmp);
            }
        }
        spdFreeRelArray(decl_rel_array);
        res = spdStrCat(res, ")");
        break;
      case OPT_FUNCPTR:                     /* ؿݥΰ */
        res = spdStrCat(res, "(");
        decl_rel_array = spdGetRelSortedArray(objectId, "funcptr_parm", "p-id",
                                              NULL, spdCompareRelOffset);
        first_parm = TRUE;
        for (i = 0; i < decl_rel_array.size; i++) {
            SpdString tmp = NULL;
            obj_id = decl_rel_array.rel[i].objectId;
            tmp = spdStrDeclaration(obj_id, FALSE);
            if (tmp != NULL) {
                if (first_parm == TRUE) {
                    first_parm = FALSE;
                } else {
                    res = spdStrCat(res, ", ");
                }
                res = spdStrCat(res, tmp);
            }
        }
        spdFreeRelArray(decl_rel_array);
        res = spdStrCat(res, ")");
        break;
      case OPT_FUNCDEF:                     /* ؿΰ */
        res = spdStrCat(res, "(");
#ifdef COMMENTED_960709
        /* 
         * ΤޤޤǤ
         *     void foo(a)
         *     int a;
         *     { ... }
         * ȤؿƹǤʤ
         */
        opt_buf = NULL;
        opt_buf_n = 0;
        csr = spdGetRelInit(objectId, "func_parm", "p-id");
        while ((opt_rel = spdGetRel(csr)).relationId != -1) {
            opt_buf = spdRealloc(opt_buf, sizeof(SpdRel) * (opt_buf_n + 1));
            opt_buf[opt_buf_n++] = opt_rel;
        }
        spdFreeCursor(csr);
        SPD_QSORT(opt_buf, opt_buf_n, sizeof(SpdRel), cmp_offset);
        for (i = 0; i < opt_buf_n; i++) {
            if (i != 0) {
                res = spdStrCat(res, ", ");
            }
            res = spdStrCat(res,
                            spdStrDeclaration(opt_buf[i].objectId, FALSE));
        }
        spdFree(opt_buf);
        res = spdStrCat(res, ")\n");
#endif /* COMMENTED_960709 */
        /* 
         * ǼΤ褦˴Ϣ func_param 򤹤٤Ƽơ
         * declaration  sort  DECL_PARAMETER ξˤ "(" ")" ˹
         * DECL_NORMAL ξˤ ")" ȴؿΤȤδ֤˹롥
         */
        decl_rel_array = spdGetRelSortedArray(objectId, "func_parm", "p-id",
                                              NULL, spdCompareRelOffset);
        first_parm = TRUE;
        for (i = 0; i < decl_rel_array.size; i++) {
            obj_id = decl_rel_array.rel[i].objectId;
            if (spdGetAttrValInt(obj_id, "sort") == DECL_PARAMETER) {
                if (first_parm == TRUE)
                    first_parm = FALSE;
                else
                    res = spdStrCat(res, ", ");
                res = spdStrCat(res, spdStrDeclaration(obj_id, FALSE));
            }
        }
        res = spdStrCat(res, ")\n");
        for (i = 0; i < decl_rel_array.size; i++) {
            obj_id = decl_rel_array.rel[i].objectId;
            if (spdGetAttrValInt(obj_id, "sort") == DECL_NORMAL) {
                res = spdStrCat(res, spdStrDeclaration(obj_id, FALSE));
                res = spdStrCat(res, "\n");
            }
        }
        spdFreeRelArray(decl_rel_array);

        obj_id = spdGetARelObj(objectId, "func_body", "p-id");
        res = spdStrCat(res, spdStrCompound(obj_id));
        break;
      case OPT_INITIALIZER:                 /* ѿν */
        obj_id = spdGetARelObj(objectId, "init_expr", "p-id");
        res = spdStrCat(res, "= ");
        res = spdStrCat(res, spdStrExpression(obj_id));
        break;
      case OPT_STRUCT:                      /* ¤ΤΥ */
        res = spdStrCat(res, "{");
        opt_buf = NULL;
        opt_buf_n = 0;
        csr = spdGetRelInit(objectId, "struct_decl", "p-id");
        while ((opt_rel = spdGetRel(csr)).relationId != -1) {
            opt_buf = spdRealloc(opt_buf, sizeof(SpdRel) * (opt_buf_n + 1));
            opt_buf[opt_buf_n++] = opt_rel;
        }
        spdFreeCursor(csr);
        SPD_QSORT(opt_buf, opt_buf_n, sizeof(SpdRel), cmp_offset);
        if (spdGetAttrValInt(opt_buf[0].objectId, "sort") == DECL_ENUMERATOR) {
            for (i = 0; i < opt_buf_n; i++) {
                if (i != 0) {
                    res = spdStrCat(res, ", ");
                } else {
                    res = spdStrCat(res, " ");
                }
                res = spdStrCat(res,
                                spdStrDeclaration(opt_buf[i].objectId, FALSE));
            }
            res = spdStrCat(res, " }");
        } else {
            indent++;
            for (i = 0; i < opt_buf_n; i++) {
                res = spdStrCat(res, "\n");
                Indent();
                res = spdStrCat(res,
                                spdStrDeclaration(opt_buf[i].objectId, FALSE));
            }
            indent--;
            res = spdStrCat(res, "\n");
            Indent();
            res = spdStrCat(res, "}");
        }
        spdFree(opt_buf);
        break;
      default:
        break;
    }

    if (save != NULL){
        spdFree(save);
        save = NULL;
    }

    save = res;

#ifdef BUGGY_SPDSTR_0102
    if(buggyFlag)
        spdSetOption("mode", modeOption);
#endif /* BUGGY_SPDSTR_0102 */

    return res;
}

SpdString spdStrIdentifier(SpdObjId objectId)
{
    static SpdString save = NULL;
    SpdString   res = NULL;

#ifdef BUGGY_SPDSTR_0102
    SpdBoolean buggyFlag = FALSE;
    int modeOption;
#endif /* BUGGY_SPDSTR_0102 */

    if (save != NULL) {
        spdFree(save);
        save = NULL;
    }

    /* objectId Υ饹 identifier ǤʤСNULL ֤ */
    if ((spdGetClassId(objectId)) != SPD_CID_IDENTIFIER) {
        return res;
    }

    res = spdStrCat(res, spdStrMacro(objectId));

#ifdef BUGGY_SPDSTR_0102
    if(res != NULL){
        if(SPD_STREQ(res, SPDSTR_ERROR_MACRO_IN_MACRO)){
            modeOption = spdGetOption("mode");
            spdSetOption("mode", SAPID_I_MODE);
            buggyFlag = TRUE;
            spdFree(res);
            res = NULL;
        }
    }
#endif /* BUGGY_SPDSTR_0102 */

    if(res != NULL){
        save = res;
        return res;
    }

    res = spdStrCat(res, spdGetName(objectId));

    save = res;

#ifdef BUGGY_SPDSTR_0102
    if(buggyFlag)
        spdSetOption("mode", modeOption);
#endif /* BUGGY_SPDSTR_0102 */

    return res;
}
