/* 
 * Program:             $RCSfile: spdStr_typeUtil.c,v $  $Revision: 30.5 $
 * 
 * Purpose:
 * 
 * Author:              N.Ito and S.Yamamoto  1997/08/24
 * 
 * (C) Copyright:       N.Ito and S.Yamamoto  1997 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdStr_typeUtil.c,v 30.5 2002/10/21 07:25:57 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/SpdStr.h>
#include "SpdStrSub.h"

static SpdBoolean isNotExtern(SpdObjId decrId);
static SpdBoolean isWithMacro(SpdObjId decrId);
static SpdBoolean isWithIndex(SpdObjId decrId);

/*
 * ͥ:
 * () extern Ǥʤ
 * () ޥѤƤ
 * () 礭ꤵƤ
 */

SpdObjId getFileFromType(SpdObjId typeId)
{
    SpdOcc decr_occ;
    SpdCursor   *decr_csr; 
    SpdObjId decrId, fileId, decrId_save = SPD_NON_ID;

    int flag, maxFlag = 0;

    fileId = SPD_NON_ID;

    decr_csr = spdGetRelInit(typeId, "decr_type", "any");
    if(spdGetAttrValInt(typeId, "sort") == TYPE_ARRAY){
        while((decrId = spdGetRelObj(decr_csr)) != SPD_NON_ID){
            flag = 0;
            decr_occ = spdGetAnOffsetOfObj(decrId);
            if(decr_occ.fileId == SPD_NON_ID)
                continue;

            if(isNotExtern(decrId)) flag += IS_NOT_EXTERN;
            if(isWithMacro(decrId)) flag += IS_WITH_MACRO;
            if(isWithIndex(decrId)) flag += IS_WITH_INDEX;

            if(maxFlag <= flag || flag == 0){
                maxFlag = flag;
                decrId_save = decrId;
            } 
        }
    } else {
        decrId_save = spdGetRelObj(decr_csr);
    }
    spdFreeCursor(decr_csr);

    decr_occ = spdGetAnOffsetOfObj(decrId_save);
    fileId = decr_occ.fileId;

    return fileId; 
}

static SpdBoolean isNotExtern(SpdObjId decrId)
{
    SpdObjId    declId;
    SpdCursor   *decl_csr;

    decl_csr = spdGetRelInit(decrId, "decl_decl", "any");
    declId = spdGetRelObj(decl_csr);
    spdFreeCursor(decl_csr);

    if(spdGetAttrValInt(declId, "storage") == STORAGE_EXTERN)
        return FALSE;
    else return TRUE;
}

static SpdBoolean isWithMacro(SpdObjId decrId)
{
    SpdOcc      decr_occ;
    SpdCursor   *csr;

    SpdObjId typeId, exprId;
    SpdCursor *type_csr, *expr_csr;
    int modeOption;
  
    csr = spdGetOffsetOfObjInit(decrId);
    decr_occ = spdGetOffsetOfObj(csr);
    spdFreeCursor(csr);

    macroInit(decr_occ.fileId);

    type_csr = spdGetRelInit(decrId, "decr_type", "any");
    typeId = spdGetRelObj(type_csr);
    spdFreeCursor(type_csr);
  
    expr_csr = spdGetRelInit(typeId, "type_cexpr", "any");
    exprId = spdGetRelObj(expr_csr);
    spdFreeCursor(expr_csr);

    modeOption = spdGetOption("mode");
    spdSetOption("mode", SAPID_C_MODE);
    if (spdStrMacro(exprId) == NULL) {
        spdSetOption("mode", modeOption);
        return (FALSE);
    } else {
        spdSetOption("mode", modeOption);
        return (TRUE);
    }
}

static SpdBoolean isWithIndex(SpdObjId decrId)
{
    SpdObjId    typeId, exprId;
    SpdCursor   *type_csr, *expr_csr;
    int         modeOption;

    type_csr = spdGetRelInit(decrId, "decr_type", "any");
    typeId = spdGetRelObj(type_csr);
    spdFreeCursor(type_csr);
  
    expr_csr = spdGetRelInit(typeId, "type_cexpr", "any");
    exprId = spdGetRelObj(expr_csr);
    spdFreeCursor(expr_csr);

    modeOption = spdGetOption("mode");
    spdSetOption("mode", SAPID_I_MODE);
    if(spdStrExpression(exprId) == NULL){
        spdSetOption("mode", modeOption);
        return FALSE;
    } else {
        spdSetOption("mode", modeOption);
        return TRUE;
    }
}
