/* 
 * Program:             $RCSfile: SpdStr3Sub.h,v $  $Revision: 31.4 $
 * 
 * Purpose:             SpdStr header file.
 * 
 * Author:              S.Yamamoto  1998/06/28
 * 
 * (C) Copyright:       S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef _SPDSTR3_SUB_H
#define _SPDSTR3_SUB_H

typedef struct {
    char            *str;
    int             indent;
    SpdBoolean      else_flag;      /* 2 ʥǥȤΤɤΥե饰
                                       else ľˤΥե饰 TRUE ˤ */
    SpdBoolean      basic_flag;     /* else if βԡǥȤɤ */
    SpdQueue        indent_stack;   /* else if βԡǥȤɤ */
} SpdStr3Info;

/* spdStr3.c */
void spdStr3Indent(SpdStr3Info *);
SpdString spdStr3_in(SpdObjId, int);
SpdTrvActInfo *spdStr3GetTrvInfo(void);
/* 
 * SpdTrvActInfo *spdStr3CreateTrvInfo(void);
 * SpdTrvActInfo *spdStr3SetTrvInfo(SpdTrvActInfo *);
 */

/* spdStr3_block.c */
int spdStr3BeforeBlockDecl(SpdObjId, SpdRel, void *); 
int spdStr3BeforeBlockBlock(SpdObjId, SpdRel, void *); 
int spdStr3MiddleBlockBlock(SpdObjId, SpdRel, void *); 
int spdStr3AfterBlockBlock(SpdObjId, SpdRel, void *); 
int spdStr3BeforeBlockLabel(SpdObjId, SpdRel, void *); 
int spdStr3AfterBlockLabel(SpdObjId, SpdRel, void *); 
int spdStr3MiddleBlockExpr(SpdObjId, SpdRel, void *); 
int spdStr3BeforeBlockExpr(SpdObjId, SpdRel, void *); 
int spdStr3AfterBlockExpr(SpdObjId, SpdRel, void *); 

int spdStr3BeforeBlock(SpdObjId, void *); 
int spdStr3MiddleBlock(SpdObjId, int, void *); 
int spdStr3AfterBlock(SpdObjId, void *); 
int spdStr3BeforeLabel(SpdObjId, void *); 

/* spdStr3_decl.c */
int spdStr3AfterFileDecl(SpdObjId, SpdRel, void *); 
int spdStr3BeforeDeclDecl(SpdObjId id, SpdRel rel, void *p);
int spdStr3BeforeDeclIdent(SpdObjId id, SpdRel rel, void *p);
int spdStr3BeforeStructDecl(SpdObjId, SpdRel, void *); 

int spdStr3BeforeDeclarator(SpdObjId id, void *p);
int spdStr3BeforeDeclaration(SpdObjId id, void *p);
int spdStr3MiddleDeclaration(SpdObjId id, int count, void *p);
int spdStr3AfterDeclaration(SpdObjId id, void *p);
int spdStr3BeforeOptionalDecl(SpdObjId, void *); 
int spdStr3MiddleOptionalDecl(SpdObjId, int, void *); 
int spdStr3AfterOptionalDecl(SpdObjId, void *); 

/* spdStr3_expr.c */
int spdStr3BeforeExprExpr(SpdObjId, SpdRel, void *); 
int spdStr3BeforeExprOp(SpdObjId, SpdRel, void *); 
int spdStr3AfterExprOp(SpdObjId, SpdRel, void *); 

int spdStr3BeforeExpression(SpdObjId, void *); 
int spdStr3MiddleExpression(SpdObjId, int, void *); 
int spdStr3AfterExpression(SpdObjId, void *); 
int spdStr3BeforeOperator(SpdObjId, void *); 
int spdStr3AfterOperator(SpdObjId, void *); 
int spdStr3BeforeConstant(SpdObjId, void *); 
int spdStr3BeforeIdentifier(SpdObjId, void *);

/* spdStr3_type.c */
int spdStr3AfterType(SpdObjId, void *);
int spdStr3BeforeOpType(SpdObjId, SpdRel, void *);
/* 
 * SpdString spdStr3TypeDeclaration(SpdObjId);
 * SpdString spdStr3TypeSpecifier (SpdObjId);
 */
#ifdef BUGGY_SDBIN4_0110
SpdString spdStr3TypeQualifier(SpdObjId, SpdString, int, SpdBoolean);
#else /* BUGGY_SDBIN4_0110 */
SpdString spdStr3TypeQualifier(SpdObjId, SpdString, int);
#endif /* BUGGY_SDBIN4_0110 */

/* spdStr3_macro.c */
SpdObjId isMacroCallBlock(SpdObjId);
int spdStr3BeforeMacroOptional(SpdObjId, void *); 
int spdStr3MiddleMacroOptional(SpdObjId, int, void *); 
int spdStr3AfterMacroOptional(SpdObjId, void *); 
int spdStr3MiddleMacroCall(SpdObjId, int, void *); 
int spdStr3AfterMacroCall(SpdObjId, void *); 
int spdStr3BeforeMacroCallArg(SpdObjId, void *);
int spdStr3BeforePblock(SpdObjId, void *); 
int spdStr3BeforeMacroName(SpdObjId, void *); 
int spdStr3BeforeMacroDeclArg(SpdObjId, void *); 
int spdStr3BeforeHfile(SpdObjId, void *); 
int spdStr3AfterHfile(SpdObjId, void *); 
int spdStr3BeforeMacroBody(SpdObjId, void *); 

#endif /* _SPDSTR3_SUB_H */
