/* 
 * Program:             $RCSfile: spdStr3.c,v $  $Revision: 31.10 $
 * 
 * Purpose:
 * 
 * Author:              N.Iwamoto and S.Yamamoto  1998/06/28
 * 
 * (C) Copyright:       N.Iwamoto and S.Yamamoto  1998 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdStr3.c,v 31.10 2003/07/08 06:19:42 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/SpdStr3.h>
#include "SpdStr3Sub.h"

static SpdString str;

static int spdStr3CompareDeclaration(const SpdRel *, const SpdRel *);
static SpdTrvActInfo *spdStr3CreateTrvInfo(void);
static SpdTrvActInfo *spdStr3SetTrvInfo(SpdTrvActInfo *new_trv_info);

/* ǥȤĤؿ */

void spdStr3Indent(SpdStr3Info *info)
{
    int i;

    info->str = spdStrCat(info->str, "\n");
    for (i = 0; i < info->indent; i++) 
        info->str = spdStrCat(info->str, "    ");
}

void spdStr3Free(void)
{
    if (str != NULL)
        spdFree(str);
    str = NULL;
}

/* ؿͤη񤤤Ƥʤˤ int ˤʤä decl_type  
    decl_decl  offset ˤʤäƤޤ(ХեåȤ0)
   ΤȤ decl_type 褦󤹤ؿ
   Ͻ񤤤ƤʤΤ񤫤ʤ褦ˤɤ⡥*/

static int spdStr3CompareDeclaration(const SpdRel *a, const SpdRel *b)
{
    if (spdGetClassId(a->relationId) == SPD_RID_DECL_TYPE)
        return -1;
    else if (spdGetClassId(b->relationId) == SPD_RID_DECL_TYPE)
        return 1;
    else return (spdCompareRelOffset(a, b));
}

static SpdTrvActInfo *spdStr3CreateTrvInfo(void)
{
    SpdTrvActInfo   *info;

    info = spdTrvInitActInfo();             /* info ν */

    /* declaration ؿ */
    spdTrvAddSortFunc(info, SPD_CID_DECLARATION, 
                      spdStr3CompareDeclaration);    

    /* Ϣ classId бؿɲ */
    spdTrvAddActFuncOfRelClass(info, SPD_RID_FILE_DECL, 
                               SAPID_TRV_ACT_AFTER, spdStr3AfterFileDecl);

    spdTrvAddActFuncOfRelClass(info, SPD_RID_DECL_DECL, 
                               SAPID_TRV_ACT_BEFORE, spdStr3BeforeDeclDecl);

    spdTrvAddActFuncOfRelClass(info, SPD_RID_DECL_IDENT, 
                               SAPID_TRV_ACT_BEFORE, spdStr3BeforeDeclIdent);

    spdTrvAddActFuncOfRelClass(info, SPD_RID_BLK_DECL, 
                               SAPID_TRV_ACT_BEFORE, spdStr3BeforeBlockDecl);

    spdTrvAddActFuncOfRelClass(info, SPD_RID_BLK_BLK, 
                               SAPID_TRV_ACT_BEFORE, spdStr3BeforeBlockBlock);
    spdTrvAddActFuncOfRelClass(info, SPD_RID_BLK_BLK, 
                               SAPID_TRV_ACT_AFTER, spdStr3AfterBlockBlock);

    spdTrvAddActFuncOfRelClass(info, SPD_RID_BLK_EXPR, 
                               SAPID_TRV_ACT_BEFORE, spdStr3BeforeBlockExpr);
    spdTrvAddActFuncOfRelClass(info, SPD_RID_BLK_EXPR, 
                               SAPID_TRV_ACT_AFTER, spdStr3AfterBlockExpr);

    spdTrvAddActFuncOfRelClass(info, SPD_RID_BLK_LABEL, 
                               SAPID_TRV_ACT_AFTER, spdStr3AfterBlockLabel);
    spdTrvAddActFuncOfRelClass(info, SPD_RID_BLK_LABEL, 
                               SAPID_TRV_ACT_BEFORE, spdStr3BeforeBlockLabel);

    spdTrvAddActFuncOfRelClass(info, SPD_RID_EXPR_EXPR, 
                               SAPID_TRV_ACT_BEFORE, spdStr3BeforeExprExpr);

    spdTrvAddActFuncOfRelClass(info, SPD_RID_EXPR_OP, 
                               SAPID_TRV_ACT_BEFORE, spdStr3BeforeExprOp);
    spdTrvAddActFuncOfRelClass(info, SPD_RID_EXPR_OP, 
                               SAPID_TRV_ACT_AFTER, spdStr3AfterExprOp);

    spdTrvAddActFuncOfRelClass(info, SPD_RID_OP_TYPE, 
                               SAPID_TRV_ACT_BEFORE, spdStr3BeforeOpType);

    spdTrvAddActFuncOfRelClass(info, SPD_RID_STRUCT_DECL, 
                               SAPID_TRV_ACT_BEFORE, spdStr3BeforeStructDecl);

    /* classId бؿɲ */
    spdTrvAddActFuncOfClass(info, SPD_CID_DECLARATOR, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforeDeclarator);

    spdTrvAddActFuncOfClass(info, SPD_CID_DECLARATION, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforeDeclaration);
    spdTrvAddActFuncMidOfClass(info, SPD_CID_DECLARATION, 
                               spdStr3MiddleDeclaration);
    spdTrvAddActFuncOfClass(info, SPD_CID_DECLARATION, 
                            SAPID_TRV_ACT_AFTER, spdStr3AfterDeclaration);

    spdTrvAddActFuncOfClass(info, SPD_CID_LABEL, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforeLabel);

    spdTrvAddActFuncOfClass(info, SPD_CID_BLOCK, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforeBlock);
    spdTrvAddActFuncMidOfClass(info, SPD_CID_BLOCK, 
                               spdStr3MiddleBlock);
    spdTrvAddActFuncOfClass(info, SPD_CID_BLOCK, 
                            SAPID_TRV_ACT_AFTER, spdStr3AfterBlock);

    spdTrvAddActFuncOfClass(info, SPD_CID_EXPRESSION, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforeExpression);
    spdTrvAddActFuncMidOfClass(info, SPD_CID_EXPRESSION, 
                               spdStr3MiddleExpression);
    spdTrvAddActFuncOfClass(info, SPD_CID_EXPRESSION, 
                            SAPID_TRV_ACT_AFTER, spdStr3AfterExpression);

    spdTrvAddActFuncOfClass(info, SPD_CID_OPERATOR, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforeOperator);

    spdTrvAddActFuncOfClass(info, SPD_CID_OPERATOR, 
                            SAPID_TRV_ACT_AFTER, spdStr3AfterOperator);

    spdTrvAddActFuncOfClass(info, SPD_CID_CONSTANT, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforeConstant);

    spdTrvAddActFuncOfClass(info, SPD_CID_IDENTIFIER, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforeIdentifier);

    spdTrvAddActFuncOfClass(info, SPD_CID_TYPE, 
                            SAPID_TRV_ACT_AFTER, spdStr3AfterType);

    spdTrvAddActFuncOfClass(info, SPD_CID_OPTIONALDECL, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforeOptionalDecl);
    spdTrvAddActFuncMidOfClass(info, SPD_CID_OPTIONALDECL, 
                               spdStr3MiddleOptionalDecl);
    spdTrvAddActFuncOfClass(info, SPD_CID_OPTIONALDECL, 
                            SAPID_TRV_ACT_AFTER, spdStr3AfterOptionalDecl);

    spdTrvAddActFuncOfClass(info, SPD_CID_MACROOPTIONAL, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforeMacroOptional);
    spdTrvAddActFuncMidOfClass(info, SPD_CID_MACROOPTIONAL, 
                               spdStr3MiddleMacroOptional);
    spdTrvAddActFuncOfClass(info, SPD_CID_MACROOPTIONAL, 
                            SAPID_TRV_ACT_AFTER, spdStr3AfterMacroOptional);

    spdTrvAddActFuncMidOfClass(info, SPD_CID_MACROCALL, 
                               spdStr3MiddleMacroCall);
    spdTrvAddActFuncOfClass(info, SPD_CID_MACROCALL, 
                            SAPID_TRV_ACT_AFTER, spdStr3AfterMacroCall);

    spdTrvAddActFuncOfClass(info, SPD_CID_MACROCALLARG, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforeMacroCallArg);

    spdTrvAddActFuncOfClass(info, SPD_CID_PBLOCK, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforePblock);

    spdTrvAddActFuncOfClass(info, SPD_CID_MACRONAME, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforeMacroName);

    spdTrvAddActFuncOfClass(info, SPD_CID_MACRODECLARG, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforeMacroDeclArg);

    spdTrvAddActFuncOfClass(info, SPD_CID_HFILE, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforeHfile);
    spdTrvAddActFuncOfClass(info, SPD_CID_HFILE, 
                            SAPID_TRV_ACT_AFTER, spdStr3AfterHfile);

    spdTrvAddActFuncOfClass(info, SPD_CID_MACROBODY, 
                            SAPID_TRV_ACT_BEFORE, spdStr3BeforeMacroBody);


    /* éɬפΤϢɲä롥 */
    spdTrvAddRel(info, SPD_RID_DECL_DECL);
    spdTrvAddRel(info, SPD_RID_DECL_OPT);
    spdTrvAddRel(info, SPD_RID_DECL_IDENT);
    spdTrvAddRel(info, SPD_RID_DECL_TYPE);
    spdTrvAddRel(info, SPD_RID_BLK_DECL);
    spdTrvAddRel(info, SPD_RID_BLK_BLK);
    spdTrvAddRel(info, SPD_RID_BLK_LABEL);
    spdTrvAddRel(info, SPD_RID_BLK_EXPR);
    spdTrvAddRel(info, SPD_RID_INIT_EXPR);
    spdTrvAddRel(info, SPD_RID_EXPR_EXPR);
    spdTrvAddRel(info, SPD_RID_EXPR_OP);
    spdTrvAddRel(info, SPD_RID_IDENT_REF);
    spdTrvAddRel(info, SPD_RID_CONST_REF);
    spdTrvAddRel(info, SPD_RID_CASE_CEXPR);
    spdTrvAddRel(info, SPD_RID_FILE_DECL);
    spdTrvAddRel(info, SPD_RID_GOTO_LABEL);

    /* !! Ȥǹͤ뤳ȡ */
    /* spdTrvAddRel(info, SPD_RID_FUNC_PARM); */
    spdTrvAddRel(info, SPD_RID_FUNC_BODY);

    spdTrvAddRel(info, SPD_RID_FUNCPTR_PARM);
    spdTrvAddRel(info, SPD_RID_OP_TYPE);
    spdTrvAddRel(info, SPD_RID_STRUCT_DECL);
    spdTrvAddRel(info, SPD_RID_PROG_FILE);
    spdTrvAddRel(info, SPD_RID_PROT_PARM);


    spdTrvAddRel(info, SPD_RID_DEF_MPATT);
    spdTrvAddRel(info, SPD_RID_CALL_MCALL);
    spdTrvAddRel(info, SPD_RID_MCALL_MNAME);
    spdTrvAddRel(info, SPD_RID_MCALL_MCALLA);
    spdTrvAddRel(info, SPD_RID_DEF_MBODY);
    spdTrvAddRel(info, SPD_RID_MPATT_MNAME);
    spdTrvAddRel(info, SPD_RID_MPATT_MOPT);
    spdTrvAddRel(info, SPD_RID_MOPT_MDECLA);
    spdTrvAddRel(info, SPD_RID_INCLD_HFILE);
    
    return info;
}

static SpdTrvActInfo *trv_info = NULL;

SpdTrvActInfo *spdStr3GetTrvInfo(void)
{
    return trv_info;
}

static SpdTrvActInfo *spdStr3SetTrvInfo(SpdTrvActInfo *new_trv_info)
{
    SpdTrvActInfo   *old_trv_info;

    old_trv_info = trv_info;
    trv_info = new_trv_info;
    return old_trv_info;
}

/*
 * spdStr3spdStr3Ƥ֤ؿ 
 */

SpdString spdStr3_in(SpdObjId id, int indent)
{
    SpdStr3Info spdStr3Info;
    SpdQueue    array_stack = SPD_EMPTY_QUEUE;

    spdStr3Info.str = NULL;
    spdStr3Info.indent = indent;
    spdStr3Info.else_flag = FALSE;
    spdStr3Info.indent_stack = array_stack;
    
    spdTraverse(id, trv_info, &spdStr3Info);

    spdQueueClean(&spdStr3Info.indent_stack);
    return spdStr3Info.str;
}

SpdString spdStr3(SpdObjId id)
{
    SpdTrvActInfo *old_trv_info, *new_trv_info;
    new_trv_info = spdStr3CreateTrvInfo();
    old_trv_info = spdStr3SetTrvInfo(new_trv_info);
    str = spdStr3_in(id, 0);
    spdStr3SetTrvInfo(old_trv_info);
    spdTrvFreeActInfo(new_trv_info);
    return str;
}
