/* 
 * Program:             $RCSfile: spdStr3_decl.c,v $  $Revision: 31.9 $
 * 
 * Purpose:
 * 
 * Author:              N.Iwamoto and S.Yamamoto  1998/06/28
 * 
 * (C) Copyright:       N.Iwamoto and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdStr3_decl.c,v 31.9 2003/07/08 06:19:43 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/SpdStr3.h>
#include "SpdStr3Sub.h"

int spdStr3AfterFileDecl(SpdObjId id, SpdRel rel, void *p)
{
    char **res;
    SpdStr3Info *info;
    
    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    *res = spdStrCat(*res, "\n\n");
    
    return SAPID_TRV_GO;
}

int spdStr3BeforeDeclIdent(SpdObjId id, SpdRel rel, void *p)
{
    SpdObjId typeId;
    SpdString str, identStr = NULL;
    char **res;
    SpdStr3Info *info;
    int sort;
    
    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    typeId = spdGetARelObj(id, "decr_type", "declarator_id");
    sort = spdGetAttrValInt(id, "sort");
    identStr = spdStr3_in(rel.objectId, info->indent);
#ifdef BUGGY_SDBIN4_0110
    str = spdStr3TypeQualifier(typeId, identStr, sort, FALSE);
#else  /* BUGGY_SDBIN4_0110 */
    str = spdStr3TypeQualifier(typeId, identStr, sort);
#endif /* BUGGY_SDBIN4_0110 */
    
    if (sort != DECL_VARIABLE ||
        spdGetARelObj(spdGetARelObj(id, "decl_decl", "declarator_id"), 
                      "decl_type", "declaration_id") != SPD_NON_ID) {
        *res = spdStrCat(*res, " ");
    }
    *res = spdStrCat(*res, str);

    if (identStr != NULL) {
        spdFree(identStr);
    }
    return SAPID_TRV_SKIP;
}

int spdStr3BeforeDeclDecl(SpdObjId id, SpdRel rel, void *p)
{
    int sort;
    SpdRelArray optdecls;
    SpdString str = NULL;
    int i;
    char **res;
    SpdStr3Info *info;
    
    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    sort = spdGetAttrValInt(rel.objectId, "sort");
    
    if (sort == DECL_TAG) {
        optdecls = spdGetRelSortedArray(rel.objectId, "decl_opt", "p-id", 
                                        NULL, spdCompareRelOffset);
    
        for (i = 0; i < optdecls.size; i++) {
            str = spdStr3_in(optdecls.rel[i].objectId, info->indent);
            *res = spdStrCat(*res, str);
            if (str != NULL)
                spdFree(str);
        }
    
        spdFreeRelArray(optdecls);
    
        return SAPID_TRV_SKIP;
    }
    return SAPID_TRV_GO;
}

int spdStr3BeforeStructDecl(SpdObjId id, SpdRel rel, void *p)
{
    SpdStr3Info *info;
    
    info = (SpdStr3Info *)p;
    
    spdStr3Indent(info);
    
    return SAPID_TRV_GO;
}

/* ؿΥץȥΰΤȤ "*"  "[]" 
   Ϥ뤿δؿ%% ǹͤ뤳ȡ */

int spdStr3BeforeDeclarator(SpdObjId id, void *p)
{
    char **res;
    SpdStr3Info *info;
    int sort;
    SpdString str = NULL;
    SpdObjId typeId, pblock_id;

    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    /* spdStr3 -c 1998/10/13 */
    if (spdGetOption("mode") == SAPID_C_MODE) {
        if ((pblock_id = isMacroCallBlock(id)) != SPD_NON_ID) {
            str = spdStr3(pblock_id);
            if (str != NULL) {
                *res = spdStrCat(*res, str);
                spdFree(str);
                str = NULL;
            }
            return SAPID_TRV_STOP;
        }
    }

    sort = spdGetAttrValInt(id, "sort");
    switch(sort) {
      case DECL_PARMTYPE:
        typeId = spdGetARelObj(id, "decr_type", "declarator_id");
#ifdef BUGGY_SDBIN4_0110
        str = spdStr3TypeQualifier(typeId, NULL, sort, FALSE);
#else  /* BUGGY_SDBIN4_0110 */
        str = spdStr3TypeQualifier(typeId, NULL, sort);
#endif /* BUGGY_SDBIN4_0110 */
        if (str != NULL) {
            *res = spdStrCat(*res, " ");
            *res = spdStrCat(*res, str);
        }
    }
    return SAPID_TRV_GO;
}

int spdStr3BeforeDeclaration(SpdObjId id, void *p)
{
    char **res;
    SpdStr3Info *info;
    int sort;
    
    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    sort = spdGetAttrValInt(id, "storage");
    switch(sort) {
      case STORAGE_EXTERN:
        *res = spdStrCat(*res, "extern ");
        break;
      case STORAGE_STATIC:
        *res = spdStrCat(*res, "static ");
        break;
      case STORAGE_AUTO:
        *res = spdStrCat(*res, "auto ");
        break;
      case STORAGE_REGISTER:
        *res = spdStrCat(*res, "register ");
        break;
      case STORAGE_TYPEDEF:
#ifdef BUGGY_SDBIN3_0058
        /*
         * "typedef int INT();" ȤޤƤʤ
         *  declaration ˳̤ޤޤƤ餳ηǤȤ
         * declaration  text 롥
         * "typedef int (INT);" Ȥ褦ʤΤ
         * 줬櫓ǤϤʤ
         */
        {
            SpdString   obj = NULL;
            int i;
        
            obj = spdGetObjText(id);
        
            for (i = 0; i < strlen(obj); i++)
                if (obj[i] == '(') {
                    *res = spdStrCat(*res, obj);
#ifdef DEBUG_0058
                    fprintf(stderr, "typedef prototype: %d\n%s\n",
                            objectId, *res);
#endif /* DEBUG_0058 */
                    return SAPID_TRV_STOP;
                }
        }
#endif /* BUGGY_SDBIN3_0058 */
        *res = spdStrCat(*res, "typedef ");
        break;
      default:
        break;
    }
    
    /* !! decl_type 򤿤ɤäơTypeSpecifier Ϥ? */
    
    return SAPID_TRV_GO;
}

int spdStr3MiddleDeclaration(SpdObjId id, int count, void *p)
{
    char **res;
    SpdStr3Info *info;

    info = (SpdStr3Info *)p;
    res = &(info->str);

    if (0 < count) {
        *res = spdStrCat(*res, ",");
    }
    
    return SAPID_TRV_GO;
}

int spdStr3AfterDeclaration(SpdObjId id, void *p)
{
    char **res;
    SpdStr3Info *info;
    int sort;
    
    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    sort = spdGetAttrValInt(id, "sort");
    switch(sort) {
      case DECL_NORMAL:
      case DECL_TYPE:
      case DECL_MEMBER:
        *res = spdStrCat(*res, ";");
        break;
      default:
        break;
    }
    
    return SAPID_TRV_GO;
}

int spdStr3BeforeOptionalDecl(SpdObjId id, void *p)
{
    char **res;
    SpdStr3Info *info;
    int sort, decl_sort;
    int i;
    SpdRelArray decl_array;
    SpdRelArray parm_array;
    SpdString str;
    SpdObjId pblock_id;

    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    /* spdStr3 -c 1998/10/13 */
    if (spdGetOption("mode") == SAPID_C_MODE) {
        if ((pblock_id = isMacroCallBlock(id)) != SPD_NON_ID) {
            str = spdStr3(pblock_id);
            if (str != NULL) {
                *res = spdStrCat(*res, str);
                spdFree(str);
                str = NULL;
            }
            return SAPID_TRV_STOP;
        }
    }

    sort = spdGetAttrValInt(id, "sort");
    switch(sort) {
      case OPT_PROTOTYPE:
      case OPT_FUNCPTR:
        *res = spdStrCat(*res, "(");
        break;
      case OPT_FUNCDEF:
        *res = spdStrCat(*res, "(");
        /* 
         * void f(a)
         * int a;
         * { ... }
         * Τ褦ʴؿλ func_parm é
         * a  int a Ȥ declaration и롥
         * ɽ뤿˻Ū func_parm 
         * éä func_body  spdTraverse é뤳Ȥˤ롥
         * !! ǹͤ뤳ȡ
         */
        parm_array = spdGetRelSortedArray(id, "func_parm", "optionaldecl_id", 
                                          NULL, spdCompareRelOffset);
        for ( i = 0; i < parm_array.size; i++) {
            decl_sort = spdGetAttrValInt(parm_array.rel[i].objectId, "sort");
            if (decl_sort == DECL_PARAMETER) { 
                if (i != 0)
                    *res = spdStrCat(*res, ", ");
                str = spdStr3_in(parm_array.rel[i].objectId, info->indent);
                *res = spdStrCat(*res, str);
                if (str != NULL)
                    spdFree(str);
            }
        }
        *res = spdStrCat(*res, ")\n");
        for ( i = 0; i < parm_array.size; i++) {
            decl_sort = spdGetAttrValInt(parm_array.rel[i].objectId, "sort");
            if (decl_sort == DECL_NORMAL) {
                str = spdStr3_in(parm_array.rel[i].objectId, info->indent);
                *res = spdStrCat(*res, str);
                if (str != NULL)
                    spdFree(str);
                *res = spdStrCat(*res, "\n");
            }
        }
        spdFreeRelArray(parm_array);
        break;
      case OPT_STRUCT:
        *res = spdStrCat(*res, " {");
        info->indent++;
        decl_array = spdGetRelSortedArray(id, "struct_decl", "optionaldecl_id", 
                                          NULL, spdCompareRelOffset);
        /* enumerator ξ硤̾1ĤΤȤ " "ʳ ", " */
        if (spdGetAttrValInt(decl_array.rel[0].objectId, "sort") == 
            DECL_ENUMERATOR) {
            for (i = 0; i < decl_array.size; i++) {
                str = spdStr3_in(decl_array.rel[i].objectId, info->indent);
                *res = spdStrCat(*res, str);
                if (str != NULL)
                    spdFree(str);
                if (i == decl_array.size-1) {
                    *res = spdStrCat(*res, " ");
                } else {
                    *res = spdStrCat(*res, ",");
                }
            }
            *res = spdStrCat(*res, "}");
            spdFreeRelArray(decl_array);
            return SAPID_TRV_STOP;
        }
        spdFreeRelArray(decl_array);
        break;
      case OPT_INITIALIZER:                 /* ѿν */
        *res = spdStrCat(*res, " = ");
        break;
      default:
        break;
    }

    return SAPID_TRV_GO;
}

int spdStr3MiddleOptionalDecl(SpdObjId id, int count, void *p)
{
    char **res;
    SpdStr3Info *info;
    int sort;

    info = (SpdStr3Info *)p;
    res = &(info->str);

    sort = spdGetAttrValInt(id, "sort");
    switch(sort) {
      case OPT_PROTOTYPE:
      case OPT_FUNCPTR:
        *res = spdStrCat(*res, ", ");
        break;
        /* 
         * void f(a)
         * int a;
         * { ... }
         * ȤؿäȤˤܤʤΤǡǹͤ뤳ȡ
         */
      /* 
       * case OPT_FUNCDEF:
       *   *res = spdStrCat(*res, ", ");
       *   break; 
       */
      default:
        break;
    }
   
    return SAPID_TRV_GO;
}

int spdStr3AfterOptionalDecl(SpdObjId id, void *p)
{
    char **res;
    SpdStr3Info *info;
    int sort;
    /* SpdObjId body_id; */
    /* SpdString str;    */

    info = (SpdStr3Info *)p;
    res = &(info->str);

    sort = spdGetAttrValInt(id, "sort");
    switch(sort) {
      case OPT_PROTOTYPE:
      case OPT_FUNCPTR:
        *res = spdStrCat(*res, ")");
        break;
        /* 
         * !! 
         * void f(a)
         * int a;
         * { ... }
         * Τ褦ʴؿäȤܤʤΤǡǹͤ뤳ȡ
         */
      /* 
       * case OPT_FUNCDEF:
       *   *res = spdStrCat(*res, ")\n");
       *   body_id = spdGetARelObj(id, "func_body", "function_id");
       *   str = spdStr3_in(body_id, info->indent);
       *   *res = spdStrCat(*res, str);
       *   if (str != NULL) 
       *       spdFree(str);
       *   break;
       */
      case OPT_STRUCT:
        info->indent--;
        spdStr3Indent(info);
        *res = spdStrCat(*res, "}");
        break;
      default:
        break;
    }

    return SAPID_TRV_GO;
}
