/* 
 * Program:             $RCSfile: spdStr3_macro.c,v $  $Revision: 31.7 $
 * 
 * Purpose:
 * 
 * Author:              N.Iwamoto and S.Yamamoto  1998/06/28
 * 
 * (C) Copyright:       N.Iwamoto and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdStr3_macro.c,v 31.7 2003/07/08 06:19:43 yamamoto Exp yamamoto $";
#endif

/* SpdStr3 -c б */

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/SpdStr3.h>
#include "SpdStr3Sub.h"

static int spdCompareRelOrder(const SpdRel *, const SpdRel *);

/* 
 * idбregion".c"ѴȤޥƤӽФˤʤäƤ
 * pblockid֤ʳSPD_NON_ID֤
 */

SpdObjId isMacroCallBlock(SpdObjId id)
{
    SpdOcc occ;
    SpdObjId start_pblock_id, end_pblock_id;
    int length, end_offset;

    occ = spdGetAnOffsetOfObj(id);
    /* filenameμ(fileIdǤʤȤϤϤ) */
    if (occ.fileId == SPD_NON_ID) {
        return SPD_NON_ID;
    }

    if ((length = spdGetLength(id)) == SPD_NON_LENGTH) {
        return (SPD_NON_ID);
    }

    /* id  ƬȺǸ offset б .c  pblock  id  */
    /* Ʊʤ id  .c ǤϥޥʤΤǤ id ֤ */
    if ((start_pblock_id = spdGetABlockId(occ.fileId, occ.offset)) 
        != SPD_NON_ID) {
        end_offset = occ.offset + length;
        if ((end_pblock_id = spdGetABlockId(occ.fileId, end_offset)) 
            != SPD_NON_ID) {
            if (start_pblock_id == end_pblock_id) {
                if (spdGetAttrValInt(start_pblock_id, "sort") 
                    == PBLOCK_MACROCALL)
                    return start_pblock_id;
            }
        }
    }

    return SPD_NON_ID;
}

int spdStr3BeforeMacroOptional(SpdObjId id, void *p)
{
    char **res;
    SpdStr3Info *info;
    
    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    *res = spdStrCat(*res, "(");

    return SAPID_TRV_GO;
}

int spdStr3MiddleMacroOptional(SpdObjId id, int rel_count, void *p)
{
    char **res;
    SpdStr3Info *info;

    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    *res = spdStrCat(*res, ", ");

    return SAPID_TRV_GO;
}

int spdStr3AfterMacroOptional(SpdObjId id, void *p)
{
    char **res;
    SpdStr3Info *info;

    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    *res = spdStrCat(*res, ")");

    return SAPID_TRV_GO;
}

int spdStr3MiddleMacroCall(SpdObjId id, int rel_count, void *p)
{
    char **res;
    SpdStr3Info *info;

    info = (SpdStr3Info *)p;
    res = &(info->str);

    /* 1ܤ "(" ǡʳ "," */
    if (rel_count == 0) {
        *res = spdStrCat(*res, "(");
    } else {
        *res = spdStrCat(*res, ",");
    }
    return SAPID_TRV_GO;
}

int spdStr3AfterMacroCall(SpdObjId id, void *p)
{
    char **res;
    SpdStr3Info *info;
    SpdObjIdArray mcalla_array;

    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    /* 
     * mcall_mcalla δϢ ")" ɽ롥
     * !! ʤΤǸǹͤ뤳ȡ
     */
    mcalla_array = spdGetRelObjArray(id, "mcall_mcalla", "macroCall_id", NULL);
    if (mcalla_array.size != 0) {
        *res = spdStrCat(*res, ")");
    }
    return SAPID_TRV_GO;
}

int spdStr3BeforeMacroCallArg(SpdObjId id, void *p)
{
    char **res;
    SpdStr3Info *info;
    
    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    *res = spdStrCat(*res, spdGetName(id));

    return SAPID_TRV_GO;
}

int spdStr3BeforePblock(SpdObjId id, void *p)
{
    int sort;
    char **res;
    SpdStr3Info *info;

    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    sort = spdGetAttrValInt(id, "sort");
    
    switch(sort){
      case PBLOCK_INCLUDE:
        *res = spdStrCat(*res, "#include ");
        break;
      case PBLOCK_DEFINE_FILE:
        *res = spdStrCat(*res, "#define ");
        break;
      default:
        break;
    }
    return SAPID_TRV_GO;
}    

int spdStr3BeforeMacroName(SpdObjId id, void *p)
{
    char **res;
    SpdStr3Info *info;

    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    *res = spdStrCat(*res, spdGetName(id));

    return SAPID_TRV_GO;
}    

int spdStr3BeforeMacroDeclArg(SpdObjId id, void *p)
{
    char **res;
    SpdStr3Info *info;

    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    *res = spdStrCat(*res, spdGetName(id));

    return SAPID_TRV_GO;
}    

int spdStr3BeforeHfile(SpdObjId id, void *p)
{
    int sort;
    char **res;
    SpdStr3Info *info;

    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    sort = spdGetAttrValInt(id, "sort");
    
    switch(sort){
      case HFILE_ANGLE:
        *res = spdStrCat(*res, "<");
        break;
      case HFILE_DQUOT:
        *res = spdStrCat(*res, "\"");
        break;
      default:
        break;
    }
    *res = spdStrCat(*res, spdGetName(id));
    return SAPID_TRV_GO;
}    

int spdStr3AfterHfile(SpdObjId id, void *p)
{
    int sort;
    char **res;
    SpdStr3Info *info;

    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    sort = spdGetAttrValInt(id, "sort");
    
    switch(sort){
      case HFILE_ANGLE:
        *res = spdStrCat(*res, ">");
        break;
      case HFILE_DQUOT:
        *res = spdStrCat(*res, "\"");
        break;
      default:
        break;
    }
    return SAPID_TRV_GO;
}    

static int spdCompareRelOrder(const SpdRel *a, const SpdRel *b)
{
    return (spdGetAttrValInt(a->relationId, "order") -
            spdGetAttrValInt(b->relationId, "order"));
}

int spdStr3BeforeMacroBody(SpdObjId id, void *p)
{
    char **res;
    char *str = NULL;
    SpdStr3Info *info;
    SpdRelArray mbody_mdeclaArray;
    int i;
    char *normstr = NULL, *pointer;
    int skip, sharp;
    char *append = NULL;


    info = (SpdStr3Info *)p;
    res = &(info->str);
    
    *res = spdStrCat(*res, " ");

    normstr = spdStrdup(spdGetName(id));
    pointer = normstr;
    mbody_mdeclaArray = spdGetRelSortedArray(id, "mbody_mdecla", "p-id",
                                             NULL, spdCompareRelOrder);
    for (i = 0; i < mbody_mdeclaArray.size; i++) {
        /* skip ʸʬ normstr 򥳥ԡ롥 */
        skip = spdGetAttrValInt(mbody_mdeclaArray.rel[i].relationId, "skip");
        append = spdMalloc(skip + 1);
        strncpy(append, pointer, skip);
        append[skip] = '\0';
        *res = spdStrCat(*res, append);
        spdFree(append);
        append = NULL;
    
        pointer += skip;                    /* normstr Υݥ󥿤ʤޤ롥 */
    
        sharp = spdGetAttrValInt(mbody_mdeclaArray.rel[i].relationId, "sharp");
        if (sharp == 1) {
            *res = spdStrCat(*res, " #");
        }
        str = spdStr3(mbody_mdeclaArray.rel[i].objectId);
        if (str != NULL) {
            *res = spdStrCat(*res, str);
            spdFree(str);
            str = NULL;
        }

    }
    *res = spdStrCat(*res, pointer);
    spdFree(normstr);
    spdFreeRelArray(mbody_mdeclaArray);
    
    return SAPID_TRV_STOP;
}    
