/* 
 * Program:             $RCSfile: bxsearch.c,v $  $Revision: 30.3 $
 * 
 * Purpose:             Enhanced bsearch().
 * 
 * Author:              K.Hayashi  1995/02/20
 * Modified:            S.Yamamoto  1995/03/05
 * 
 * (C) Copyright:       K.Hayashi and S.Yamamoto  1995 - 1998
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: bxsearch.c,v 30.3 2003/04/13 03:17:42 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

void *bxsearch(const void *key, const void *base, size_t nmemb,
               size_t size, int (*compar) (const void *, const void *))
{
    void    *tmp;

    assert(key != NULL && base != NULL);
    
    tmp = (nmemb != 0) ? (void *)bsearch(key, base, nmemb, size, compar) : NULL;
    if (tmp != NULL) {
        while (tmp != base && compar(key, (char *)tmp - size) == 0) {
            tmp = (char *)tmp - size;
        }
    }
    return (tmp);
}
