/* 
 * Program:             $RCSfile: spdFseek.c,v $  $Revision: 30.22 $
 * 
 * Purpose:
 * 
 * Author:              N.Koyama  1998/11/15
 *                      S.Yamamoto  1998/11/15
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  1998 - 2002
 *                      This file is a product of the project Sapid.
 */

/*
 * WindowsιԶڤ"\r\n"Ǥ뤿ᡤñfseek()ƤӽФȥ
 * եåȤ롥кȤơ"\r\n""\n"Ʊ뤷ʤؿ
 * spdFseek{Cygwin,Win32}()ѰդΤȤSEEK_SETSEEK_CURΤߤ
 * ݡȤƤ롥
 * 
 * ToDo:
 * (1) SEEK_ENDб뤳ȡ
 * (2) mmap()ѤΨŪʼ¸ͤ뤳ȡ
 * (3) Զڤ֤ɽѤΨŪʼ¸ˡͤ뤳ȡ
 * 
 * Note:
 * ʤfileno()_fileno()ȤΤ?
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdFseek.c,v 30.22 2003/06/28 15:31:20 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

#ifdef WIN32

#include <io.h>
#include <fcntl.h>

int spdFseekWin32(FILE *stream, long int offset, int whence)
{
    int     c, savedMode;

    /* SEEK_SETSEEK_CUR򥵥ݡȤƤ롥 */
    if (whence != SEEK_SET && whence != SEEK_CUR) {
        spdErrorExit("spdFseekWin32(): whence %d: Not supported yet.\n");
    }

    /* SEEK_SETΤȤƬ˰ư롥 */
    if (whence == SEEK_SET && fseek(stream, 0, SEEK_SET)) {
        return (-1);
    }
    /* Хʥ⡼ɤѹ롥 */
    if ((savedMode = _setmode(_fileno(stream), _O_BINARY)) == -1) {
        return (-1);
    }

    /* Modified by S.Yamamoto 1998/11/22. */
    while (0 < offset--) {
        if ((c = getc(stream)) == EOF) {
            /* Too big offset. */
            return (-1);
        } else if (c == '\r') {
            /* '\r'ΤȤoffsetǥȤʤ */
            offset++;
        }
    }

    /* Υ⡼ɤ᤹ */
    if (_setmode(_fileno(stream), savedMode) == -1) {
        return (-1);
    }
    return (0);
}

#endif /* WIN32 */

#ifdef __CYGWIN__

#include <fcntl.h>

int spdFseekCygwin(FILE *stream, long int offset, int whence)
{
    int     c, savedMode;

    /* SEEK_SETSEEK_CUR򥵥ݡȤƤ롥 */
    if (whence != SEEK_SET && whence != SEEK_CUR) {
        spdErrorExit("spdFseekCygwin(): whence %d: Not support yet.\n");
    }

    /* SEEK_SETΤȤƬ˰ư롥 */
    if (whence == SEEK_SET && fseek(stream, 0, SEEK_SET)) {
        return (-1);
    }
    /* Хʥ⡼ɤѹ롥 */
    if ((savedMode = setmode(fileno(stream), O_BINARY)) == -1) {
        return (-1);
    }

    /* Modified by S.Yamamoto 1998/11/22. */
    while (0 < offset--) {
        if ((c = getc(stream)) == EOF) {
            /* Too big offset. */
            return (-1);
        } else if (c == '\r') {
            /* '\r'ΤȤoffsetǥȤʤ */
            offset++;
        }
    }

    /* Υ⡼ɤ᤹ */
    if (setmode(fileno(stream), savedMode) == -1) {
        return (-1);
    }
    return (0);
}

#endif /* __CYGWIN__ */

/******************************************************************************/

/*
 * fread() function with '\0' termination. Added by S.Yamamoto 2000/02/10.
 */

size_t spdFreadChar(void *ptr, size_t nitems, FILE *stream)
{
    size_t      s;

    s = fread(ptr, sizeof(char), nitems, stream);
    *((char *)ptr + s) = '\0';
    return (s);
}

/******************************************************************************/

int spdGetEndian(void)
{
    unsigned long int   i;

    if (sizeof(i) != 4) {
        spdErrorExit("Not a 32-bit architecture.\n");
    }

    i = (((((('A' << 8) + 'B') << 8) + 'C') << 8) + 'D');

    if (strncmp("ABCD", (char *)&i, sizeof(i)) == 0) {
        return (SPD_ENDIAN_BIG);
    } else if (strncmp("DCBA", (char *)&i, sizeof(i)) == 0) {
        return (SPD_ENDIAN_LITTLE);
    } else {
        spdErrorExit("spdGetEndian(): \"%s\": Invalid architecture.\n",
                     (char *)&i);
        SPD_DUMMY_RETURN(0);
    }
}

/******************************************************************************/

void spdOutputForShell(const char *format, int value)
{
    printf(format, value);

#ifndef WIN32
    printf("\n");
#endif

    fflush(stdout);
}
