/* 
 * Program:             $RCSfile: spdGetClassMacroName.c,v $  $Revision: 31.17 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  1995/03/20
 * Modified:            R.Miura  1998/07/18
 * 
 * (C) Copyright:       R.Miura and S.Yamamoto  1995 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdGetClassMacroName.c,v 31.17 2003/06/28 15:31:21 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

static SpdValName classNameTable[] = {
    /* I-model classes. */
    { SPD_VAL_NAME2(SPD_CID_PROGRAM) },
    { SPD_VAL_NAME2(SPD_CID_FILE) },
    { SPD_VAL_NAME2(SPD_CID_DECLARATION) },
    { SPD_VAL_NAME2(SPD_CID_DECLARATOR) },
    { SPD_VAL_NAME2(SPD_CID_IDENTIFIER) },
    { SPD_VAL_NAME2(SPD_CID_OPTIONALDECL) },
    { SPD_VAL_NAME2(SPD_CID_BLOCK) },
    { SPD_VAL_NAME2(SPD_CID_EXPRESSION) },
    { SPD_VAL_NAME2(SPD_CID_LABEL) },
    { SPD_VAL_NAME2(SPD_CID_CONSTANT) },
    { SPD_VAL_NAME2(SPD_CID_TYPE) },
    { SPD_VAL_NAME2(SPD_CID_OPERATOR) },
    { SPD_VAL_NAME2(SPD_CID_LIBRARY) },
    /* I-model relationships. */
    { SPD_VAL_NAME2(SPD_RID_BLK_BLK) },
    { SPD_VAL_NAME2(SPD_RID_BLK_DECL) },
    { SPD_VAL_NAME2(SPD_RID_BLK_EXPR) },
    { SPD_VAL_NAME2(SPD_RID_BLK_LABEL) },
    { SPD_VAL_NAME2(SPD_RID_CASE_CEXPR) },
    { SPD_VAL_NAME2(SPD_RID_CONST_REF) },
    { SPD_VAL_NAME2(SPD_RID_DECL_DECL) },
    { SPD_VAL_NAME2(SPD_RID_DECL_IDENT) },
    { SPD_VAL_NAME2(SPD_RID_DECL_OPT) },
    { SPD_VAL_NAME2(SPD_RID_DECL_TYPE) },
    { SPD_VAL_NAME2(SPD_RID_EXPR_EXPR) },
    { SPD_VAL_NAME2(SPD_RID_EXPR_OP) },
    { SPD_VAL_NAME2(SPD_RID_EXPR_TYPE) },
    { SPD_VAL_NAME2(SPD_RID_FILE_DECL) },
    { SPD_VAL_NAME2(SPD_RID_FUNC_BODY) },
    { SPD_VAL_NAME2(SPD_RID_FUNC_PARM) },
    { SPD_VAL_NAME2(SPD_RID_GOTO_LABEL) },
    { SPD_VAL_NAME2(SPD_RID_IDENT_REF) },
    { SPD_VAL_NAME2(SPD_RID_IDENT_TYPE) },
    { SPD_VAL_NAME2(SPD_RID_INIT_EXPR) },
    { SPD_VAL_NAME2(SPD_RID_OP_TYPE) },
    { SPD_VAL_NAME2(SPD_RID_PROG_FILE) },
    { SPD_VAL_NAME2(SPD_RID_STRUCT_DECL) },
    { SPD_VAL_NAME2(SPD_RID_TYPE_CEXPR) },
    { SPD_VAL_NAME2(SPD_RID_TYPE_IS) },
    { SPD_VAL_NAME2(SPD_RID_TYPE_ST) },
    { SPD_VAL_NAME2(SPD_RID_PROT_PARM) },
    { SPD_VAL_NAME2(SPD_RID_FUNCPTR_PARM) },
    { SPD_VAL_NAME2(SPD_RID_DECR_TYPE) },
    { SPD_VAL_NAME2(SPD_RID_PROG_LIB) },
    { SPD_VAL_NAME2(SPD_RID_LIB_FILE) },
    /* P-model classes. */
    { SPD_VAL_NAME2(SPD_CID_PFILE) },
    { SPD_VAL_NAME2(SPD_CID_PBLOCK) },
    { SPD_VAL_NAME2(SPD_CID_MACROPATTERN) },
    { SPD_VAL_NAME2(SPD_CID_MACROBODY) },
    { SPD_VAL_NAME2(SPD_CID_MACRONAME) },
    { SPD_VAL_NAME2(SPD_CID_MACROOPTIONAL) },
    { SPD_VAL_NAME2(SPD_CID_MACRODECLARG) },
    { SPD_VAL_NAME2(SPD_CID_MACROCALL) },
    { SPD_VAL_NAME2(SPD_CID_MACROCALLARG) },
    { SPD_VAL_NAME2(SPD_CID_HFILE) },
    { SPD_VAL_NAME2(SPD_CID_IBLOCK) },
    /* P-model relationships. */
    { SPD_VAL_NAME2(SPD_RID_FILE_BLOCK) },
    { SPD_VAL_NAME2(SPD_RID_CALL_MCALL) },
    { SPD_VAL_NAME2(SPD_RID_MBODY_MCALL) },
    { SPD_VAL_NAME2(SPD_RID_MCALL_MNAME) },
    { SPD_VAL_NAME2(SPD_RID_MCALL_MCALLA) },
    { SPD_VAL_NAME2(SPD_RID_DEF_MPATT) },
    { SPD_VAL_NAME2(SPD_RID_DEF_MBODY) },
    { SPD_VAL_NAME2(SPD_RID_MPATT_MNAME) },
    { SPD_VAL_NAME2(SPD_RID_MPATT_MOPT) },
    { SPD_VAL_NAME2(SPD_RID_MOPT_MDECLA) },
    { SPD_VAL_NAME2(SPD_RID_MBODY_MDECLA) },
    { SPD_VAL_NAME2(SPD_RID_INCLD_HFILE) },
    { SPD_VAL_NAME2(SPD_RID_HFILE_FILE) },
    { SPD_VAL_NAME2(SPD_RID_MCALLA_MCALL) },
    { SPD_VAL_NAME2(SPD_RID_CFILE_IFILE) },
    { SPD_VAL_NAME2(SPD_RID_IFILE_IBLOCK) },
    { SPD_VAL_NAME2(SPD_RID_PBLOCK_IBLOCK) },
    /* Area-model classes. */
    { SPD_VAL_NAME2(SPD_CID_STORAGE) },
    { SPD_VAL_NAME2(SPD_CID_AREA) },
    { SPD_VAL_NAME2(SPD_CID_VALUE) },
    /* Area-model relationships. */
    { SPD_VAL_NAME2(SPD_RID_STORAGE_AREA) },
    { SPD_VAL_NAME2(SPD_RID_STORAGE_STORAGE) },
    { SPD_VAL_NAME2(SPD_RID_AREA_AREA) },
    { SPD_VAL_NAME2(SPD_RID_AREA_VALUE) },
    { SPD_VAL_NAME2(SPD_RID_POINT_TO) },
    { SPD_VAL_NAME2(SPD_RID_FUNCPTR_TO) },
    { SPD_VAL_NAME2(SPD_RID_PROG_STORAGE) },
    { SPD_VAL_NAME2(SPD_RID_FUNC_STORAGE) },
    { SPD_VAL_NAME2(SPD_RID_BLOCK_STORAGE) },
    { SPD_VAL_NAME2(SPD_RID_VARIABLE_AREA) },
    { SPD_VAL_NAME2(SPD_RID_MEMBER_AREA) },
    { SPD_VAL_NAME2(SPD_RID_STRING_AREA) },
    { SPD_VAL_NAME2(SPD_RID_AREA_TYPE) },
    { SPD_VAL_NAME2(SPD_RID_VALUE_TYPE) },
    { SPD_VAL_NAME2(SPD_RID_VALUE_ENUM) },
    /* B-model classes. */
    { SPD_VAL_NAME2(SPD_CID_EXECUTION) },
    { SPD_VAL_NAME2(SPD_CID_OPERATION) },
    /* B-model relationships. */
    { SPD_VAL_NAME2(SPD_RID_PROG_EXEC) },
    { SPD_VAL_NAME2(SPD_RID_EXEC_OP) },
    { SPD_VAL_NAME2(SPD_RID_STATEMENT_OP) },
    { SPD_VAL_NAME2(SPD_RID_ALLOC_STORAGE) },
    { SPD_VAL_NAME2(SPD_RID_FREE_STORAGE) },
    { SPD_VAL_NAME2(SPD_RID_DEFINE_VALUE) },
    { SPD_VAL_NAME2(SPD_RID_REFER_VALUE) },
    { SPD_VAL_NAME2(SPD_RID_CALL_VALUE) },
    { SPD_VAL_NAME2(SPD_RID_RETURN_VALUE) },
    { SPD_VAL_NAME2(SPD_RID_BRANCH_VALUE) },
    { SPD_VAL_NAME2(SPD_RID_DEPEND_ON) },
    { SPD_VAL_NAME2(SPD_RID_CALL_FUNC) },
    { SPD_VAL_NAME2(SPD_RID_CALL_RETURN) },
    { SPD_VAL_NAME2(SPD_RID_ENTRY_EXIT) },
    /* D-model classes. */
    { SPD_VAL_NAME2(SPD_CID_SOFTWARE) },
    { SPD_VAL_NAME2(SPD_CID_DOCUMENT) },
    { SPD_VAL_NAME2(SPD_CID_DOCFILE) },
    { SPD_VAL_NAME2(SPD_CID_DOCFRAG) },
    { SPD_VAL_NAME2(SPD_CID_TEXTSTRING) },
    { SPD_VAL_NAME2(SPD_CID_ATTRIBUTE) },
    { SPD_VAL_NAME2(SPD_CID_DOCIDENT) },
    /* D-model relationships. */
    { SPD_VAL_NAME2(SPD_RID_SOFT_DOC) },
    { SPD_VAL_NAME2(SPD_RID_SOFT_PROG) },
    { SPD_VAL_NAME2(SPD_RID_DOC_DOCFILE) },
    { SPD_VAL_NAME2(SPD_RID_DOCFILE_DOCFRAG) },
    { SPD_VAL_NAME2(SPD_RID_DOCELEM_DOCFRAG) },
    { SPD_VAL_NAME2(SPD_RID_DOCELEM_ATTRIBUTE) },
    { SPD_VAL_NAME2(SPD_RID_ATTRIBUTE_VALUE) },
    { SPD_VAL_NAME2(SPD_RID_TEXTFRAG_TEXTSTRING) },
    { SPD_VAL_NAME2(SPD_RID_DEFELEM_DOCIDENT) },
    { SPD_VAL_NAME2(SPD_RID_IDENTELEM_DOCIDENT) },
    { SPD_VAL_NAME2(SPD_RID_SRCELEM_SRCFRAG) },
    { SPD_VAL_NAME2(SPD_RID_DOCIDENT_IDENTIFIER) },
    { SPD_VAL_NAME2(SPD_RID_LINKELEM_SRCFRAG) },
    /* SDA-model classes. */
    { SPD_VAL_NAME2(SPD_CID_SDAFUNC) },
    { SPD_VAL_NAME2(SPD_CID_VARG) },
    /* SDA-model relationships. */
    { SPD_VAL_NAME2(SPD_RID_NEXT_STMT) },
    { SPD_VAL_NAME2(SPD_RID_DATA_DEPEND) },
    { SPD_VAL_NAME2(SPD_RID_FUNC_SFUNC) },
    { SPD_VAL_NAME2(SPD_RID_SFUNC_VARG) },
    { SPD_VAL_NAME2(SPD_RID_SFUNC_STMT) },
    { SPD_VAL_NAME2(SPD_RID_IDENT_VARG) },
    /* Stmt-model classes. */
    { SPD_VAL_NAME2(SPD_CID_STATEMENT) },
    /* Stmt-model relationships. */
    { SPD_VAL_NAME2(SPD_RID_FOR_EXPR) },
    { SPD_VAL_NAME2(SPD_RID_COND_EXPR) },
    { SPD_VAL_NAME2(SPD_RID_ITER_EXPR) },
    { SPD_VAL_NAME2(SPD_RID_STMT_EXPR) },
    { SPD_VAL_NAME2(SPD_RID_STMT_LABEL) },
    { SPD_VAL_NAME2(SPD_RID_RETURN_EXPR) },
    { SPD_VAL_NAME2(SPD_RID_BLOCK_STMT) },
    { SPD_VAL_NAME2(SPD_RID_BLOCK_DECL) },
    { SPD_VAL_NAME2(SPD_RID_CONTROL_BODY) },
    { SPD_VAL_NAME2(SPD_RID_ELSE_BODY) },
    { SPD_VAL_NAME2(SPD_RID_STMT_IBLOCK) },
    /* Sarea-model classes. */
    { SPD_VAL_NAME2(SPD_CID_SAREA) },
    /* Sarea-model relationships. */
    { SPD_VAL_NAME2(SPD_RID_IDENT_SAREA) },
    { SPD_VAL_NAME2(SPD_RID_CONSIST_OF) },
    { SPD_VAL_NAME2(SPD_RID_SAREA_SAREA) },
    /* Type-view classes. */
    { SPD_VAL_NAME2(SPD_CID_MEMBER) },
    { SPD_VAL_NAME2(SPD_CID_ENUMERATOR) },
    /* Type-view relationships. */
    { SPD_VAL_NAME2(SPD_RID_STRUCT_MEMBER) },
    { SPD_VAL_NAME2(SPD_RID_MEMBER_TYPE) },
    { SPD_VAL_NAME2(SPD_RID_MEMBER_NAME) },
    { SPD_VAL_NAME2(SPD_RID_ENUM_ENUMERATOR) },
    { SPD_VAL_NAME2(SPD_RID_ENUMERATOR_NAME) },
    { SPD_VAL_NAME2(SPD_RID_ARRAY_NUM) },
    /* Comment-view classed. */
    { SPD_VAL_NAME2(SPD_CID_PCOMMENT) },
    { SPD_VAL_NAME2(SPD_CID_LCOMMENT) },
    /* Comment-view relationships. */
    { SPD_VAL_NAME2(SPD_RID_PFILE_PCOMMENT) },
    { SPD_VAL_NAME2(SPD_RID_PCOMMENT_LCOMMENT) },
    { SPD_VAL_NAME2(SPD_RID_LCOMMENT_PFILE) },
    { SPD_VAL_NAME2(SPD_RID_LCOMMENT_PBLOCK) },
    { SPD_VAL_NAME2(SPD_RID_LCOMMENT_DECLARATION) },
    { SPD_VAL_NAME2(SPD_RID_LCOMMENT_LABEL) },
    { SPD_VAL_NAME2(SPD_RID_LCOMMENT_EXPRESSION) },
    { SPD_VAL_NAME2(SPD_RID_LCOMMENT_BLOCK) },
    /* Flow-view classed. */
    { SPD_VAL_NAME2(SPD_CID_BLK_ENTRY) },   
    { SPD_VAL_NAME2(SPD_CID_BLK_GO_INTO) }, 
    { SPD_VAL_NAME2(SPD_CID_BLK_EXIT) },        
    { SPD_VAL_NAME2(SPD_CID_BLK_BREAK) },       
    { SPD_VAL_NAME2(SPD_CID_BLK_CONTINUE) },    
    { SPD_VAL_NAME2(SPD_CID_BLK_GO_AWAY) },     
    { SPD_VAL_NAME2(SPD_CID_BLK_RETURN) },      
    { SPD_VAL_NAME2(SPD_CID_SWITCH_BRANCH) },   
    /* Flow-view relationships. */
    { SPD_VAL_NAME2(SPD_RID_NEXT_NODE) },   
    { SPD_VAL_NAME2(SPD_RID_BLK_SDANODE) }, 
    { SPD_VAL_NAME2(SPD_RID_DATA_DEPENDENCE) }, 
    { SPD_VAL_NAME2(SPD_RID_DEF_USED) }, 
    /* FCDG-view classes. */
    { SPD_VAL_NAME2(SPD_CID_FCDG) },   
    /* FCDG-view relationships. */
    { SPD_VAL_NAME2(SPD_RID_FUNC_FCDG) },   
    { SPD_VAL_NAME2(SPD_RID_LIBDATA_DEPEND) },  
    { SPD_VAL_NAME2(SPD_RID_LIBCTRL_DEPEND) },  
    { SPD_VAL_NAME2(SPD_RID_FCDG_EXPR) },   
    { SPD_VAL_NAME2(SPD_RID_FCDG_LIB) },    
    { SPD_VAL_NAME2(SPD_RID_DEF_VAR) }, 
    { SPD_VAL_NAME2(SPD_RID_COND_OP) }, 
    { SPD_VAL_NAME2(SPD_RID_COND_VAL) },    
    /* J-model classes. */
    { SPD_VAL_NAME2(SPD_CID_J_FILE) },
    { SPD_VAL_NAME2(SPD_CID_J_CLASS) },
    { SPD_VAL_NAME2(SPD_CID_J_INTERFACE) },
    { SPD_VAL_NAME2(SPD_CID_J_VARIABLE) },
    { SPD_VAL_NAME2(SPD_CID_J_ROUTINE) },
    { SPD_VAL_NAME2(SPD_CID_J_TYPE) },
    { SPD_VAL_NAME2(SPD_CID_J_MODIFIER) },
    { SPD_VAL_NAME2(SPD_CID_J_SBLOCK) },
    { SPD_VAL_NAME2(SPD_CID_J_STATEMENT) },
    { SPD_VAL_NAME2(SPD_CID_J_EXPRESSION) },
    { SPD_VAL_NAME2(SPD_CID_J_LITERAL) },
    { SPD_VAL_NAME2(SPD_CID_J_OPERATOR) },
    { SPD_VAL_NAME2(SPD_CID_J_QNAME) },
    { SPD_VAL_NAME2(SPD_CID_J_SPECIAL) },
    { SPD_VAL_NAME2(SPD_CID_J_LABEL) },
    { SPD_VAL_NAME2(SPD_CID_J_COMMENT) },
    { SPD_VAL_NAME2(SPD_CID_J_WILDCARD) },
    /* J-model relationships. */
    { SPD_VAL_NAME2(SPD_RID_J_DEFINE_PACKAGE) },
    { SPD_VAL_NAME2(SPD_RID_J_IMPORT_PACKAGE) },
    { SPD_VAL_NAME2(SPD_RID_J_DEFINE_CLASS) },
    { SPD_VAL_NAME2(SPD_RID_J_IMPLEMENT_INTERFACE) },
    { SPD_VAL_NAME2(SPD_RID_J_EXTEND_CLASS) },
    { SPD_VAL_NAME2(SPD_RID_J_CLASS_MODIFIER) },
    { SPD_VAL_NAME2(SPD_RID_J_CLASS_VARIABLE) },
    { SPD_VAL_NAME2(SPD_RID_J_CLASS_ROUTINE) },
    { SPD_VAL_NAME2(SPD_RID_J_CLASS_SBLOCK) },
    { SPD_VAL_NAME2(SPD_RID_J_CLASS_ARGUMENT) },
    { SPD_VAL_NAME2(SPD_RID_J_CLASS_CLASS) },
    { SPD_VAL_NAME2(SPD_RID_J_CLASS_INTERFACE) },
    { SPD_VAL_NAME2(SPD_RID_J_DEFINE_INTERFACE) },
    { SPD_VAL_NAME2(SPD_RID_J_EXTEND_INTERFACE) },
    { SPD_VAL_NAME2(SPD_RID_J_INTERFACE_MODIFIER) },
    { SPD_VAL_NAME2(SPD_RID_J_INTERFACE_VARIABLE) },
    { SPD_VAL_NAME2(SPD_RID_J_INTERFACE_ROUTINE) },
    { SPD_VAL_NAME2(SPD_RID_J_INTERFACE_CLASS) },
    { SPD_VAL_NAME2(SPD_RID_J_INTERFACE_INTERFACE) },
    { SPD_VAL_NAME2(SPD_RID_J_VARIABLE_MODIFIER) },
    { SPD_VAL_NAME2(SPD_RID_J_VARIABLE_TYPE) },
    { SPD_VAL_NAME2(SPD_RID_J_INITIALIZE_VARIABLE) },
    { SPD_VAL_NAME2(SPD_RID_J_PARAMETER_VARIABLE) },
    { SPD_VAL_NAME2(SPD_RID_J_RETURN_TYPE) },
    { SPD_VAL_NAME2(SPD_RID_J_THROW_TYPE) },
    { SPD_VAL_NAME2(SPD_RID_J_ROUTINE_BODY) },
    { SPD_VAL_NAME2(SPD_RID_J_ROUTINE_MODIFIER) },
    { SPD_VAL_NAME2(SPD_RID_J_TYPE_CLASS) },
    { SPD_VAL_NAME2(SPD_RID_J_TYPE_INTERFACE) },
    { SPD_VAL_NAME2(SPD_RID_J_TYPE_TYPE) },
    { SPD_VAL_NAME2(SPD_RID_J_TYPE_QNAME) },
    { SPD_VAL_NAME2(SPD_RID_J_QNAME_QNAME) },
    { SPD_VAL_NAME2(SPD_RID_J_QNAME_DOT) },
    { SPD_VAL_NAME2(SPD_RID_J_SBLOCK_BODY) },
    { SPD_VAL_NAME2(SPD_RID_J_LOCAL_CLASS) },
    { SPD_VAL_NAME2(SPD_RID_J_LOCAL_VARIABLE) },
    { SPD_VAL_NAME2(SPD_RID_J_STATEMENT_LABEL) },
    { SPD_VAL_NAME2(SPD_RID_J_STATEMENT_STATEMENT) },
    { SPD_VAL_NAME2(SPD_RID_J_STATEMENT_EXPRESSION) },
    { SPD_VAL_NAME2(SPD_RID_J_REFER_LABEL) },
    { SPD_VAL_NAME2(SPD_RID_J_CASE_VALUE) },
    { SPD_VAL_NAME2(SPD_RID_J_EXPRESSION_OPERAND) },
    { SPD_VAL_NAME2(SPD_RID_J_EXPRESSION_OPERATOR) },
    { SPD_VAL_NAME2(SPD_RID_J_EXPRESSION_EXPRESSION) },
    { SPD_VAL_NAME2(SPD_RID_J_REFER_VARIABLE) },
    { SPD_VAL_NAME2(SPD_RID_J_REFER_LITERAL) },
    { SPD_VAL_NAME2(SPD_RID_J_REFER_SPECIAL) },
    { SPD_VAL_NAME2(SPD_RID_J_REFER_TYPE) },
    { SPD_VAL_NAME2(SPD_RID_J_REFER_QNAME) },
    { SPD_VAL_NAME2(SPD_RID_J_HAS_TYPE) },
    { SPD_VAL_NAME2(SPD_RID_J_INVOKE_ROUTINE) },
    { SPD_VAL_NAME2(SPD_RID_J_SYMBOL_COMMENT) },

    { SPD_VAL_NAME2(SPD_NON_CID) }
};

static SpdValName modelNameTable[] = {
    { SPD_VAL_NAME2(SPD_MID_I_MODEL) },
    { SPD_VAL_NAME2(SPD_MID_P_MODEL) },
    { SPD_VAL_NAME2(SPD_MID_AREA_MODEL) },
    { SPD_VAL_NAME2(SPD_MID_B_MODEL) },
    { SPD_VAL_NAME2(SPD_MID_D_MODEL) },
    { SPD_VAL_NAME2(SPD_MID_SDA_MODEL) },
    { SPD_VAL_NAME2(SPD_MID_STMT_MODEL) },
    { SPD_VAL_NAME2(SPD_MID_SDA_AREA_MODEL) },
    { SPD_VAL_NAME2(SPD_MID_TYPE_VIEW) },
    { SPD_VAL_NAME2(SPD_MID_COMMENT_VIEW) },
    { SPD_VAL_NAME2(SPD_MID_FLOW_VIEW) },
    { SPD_VAL_NAME2(SPD_MID_FCD_VIEW) },
    { SPD_VAL_NAME2(SPD_MID_J_MODEL) },
    
    { SPD_VAL_NAME2(SPD_NON_MID) }
};

SpdConstString spdGetClassMacroName(SpdClassId classId)
{
    int     i;
    
    for (i = 0; i < SPD_ARRAY_SIZE(classNameTable); i++) {
        if (classNameTable[i].value == classId) {
            return (classNameTable[i].name);
        }
    }
    return (NULL);
}

SpdConstString spdGetModelMacroName(SpdModelId modelId)
{
    int     i;
    
    for (i = 0; i < SPD_ARRAY_SIZE(modelNameTable); i++) {
        if (modelNameTable[i].value == modelId) {
            return (modelNameTable[i].name);
        }
    }
    return (NULL);
}
