/* 
 * Program:             $RCSfile: spdMemProf.c,v $  $Revision: 30.5 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  1997/10/05
 * 
 * (C) Copyright:       S.Yamamoto  1997 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdMemProf.c,v 30.5 2002/10/28 10:26:41 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

#ifdef HAVE_SBRK

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

static void         *saved_brk = 0;
static SpdBoolean   is_initialized = FALSE;

void spdInitMemProf(void)
{
    if (!is_initialized) {
        is_initialized = TRUE;
    }
    saved_brk = sbrk(0);
}

/*
 * Do nothing when already spdInitMemProf() called.
 */

void _spdSafetyInitMemProf(void)
{
    if (!is_initialized) {
        spdInitMemProf();
    }
}

void spdPrintMemProf(void)
{
    int     delta = (long)sbrk(0) - (long)saved_brk;

    if (!is_initialized) {
        spdMessage("Function spdInitMemProf() is not called.\n");
        spdInitMemProf();
    }

    spdMessage("Allocated heap: %d byte, %d Kbyte, %d Mbyte.\n",
               delta, delta / 1024, delta / (1024 * 1024));
}

#else /* not HAVE_SBRK */

/* Just dummy. */

void spdInitMemProf(void)
{
}

void _spdSafetyInitMemProf(void)
{
}

void spdPrintMemProf(void)
{
}

#endif /* not HAVE_SBRK */
