/* 
 * Program:             $RCSfile: spdOption.c,v $  $Revision: 30.2 $
 * 
 * Purpose:
 * 
 * Author:              Y.Momiyama  1997/07/05
 *                      S.Yamamoto  1996/07/05
 * 
 * (C) Copyright:       Y.Momiyama and S.Yamamoto  1997
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdOption.c,v 30.2 2003/06/28 15:31:20 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

static SpdOption *spdGlobalOption = NULL;

/* ץο */
static int spdCountOption(SpdOption *spdOption)
{
    int count = 0;

    if (spdOption == NULL) {
        return count;
    }

    for (count = 0; spdOption[count].option != NULL; count++) {
        /* Empty. */
    }

    return count;
}

/* ˥ץɲä */
static void spdAppendOption(SpdString option, int value,
                            int size        /* ® */)
{
    spdGlobalOption = spdRealloc(spdGlobalOption,
                                 sizeof(SpdOption) * (size + 2));
    /* Copy. */
    spdGlobalOption[size].option = spdStrdup(option);
    spdGlobalOption[size].value = value;
    /* Set terminal. */
    spdGlobalOption[size+1].option = NULL;
    spdGlobalOption[size+1].value = SAPID_NON_OPTION;
}

/* ٤ƤΥץʥץν򥻥åȤ */
static void spdSetDefaultOption(SpdOption *spdOption)
{
    int i, size;

    /* Clear current options. */
    spdFreeOption();

    /* Duplicate. */
    size = spdCountOption(spdOption);

    spdGlobalOption = spdMalloc(sizeof(SpdOption) * (size + 1));
    for (i = 0; i < size; i++) {
        spdGlobalOption[i].option = spdStrdup(spdOption[i].option);
        spdGlobalOption[i].value = spdOption[i].value;
    }

    /* Set terminal. */
    spdGlobalOption[i].option = NULL;
    spdGlobalOption[i].value = SAPID_NON_OPTION;
}

/* ץν񤭤ʤǷ礹 */
int spdInsertOption(SpdOption *spdOption)
{
    int insert = 0;
    int gsize;
    int i, j;

    if (spdOption == NULL) {
        return insert;
    }

    if (spdGlobalOption == NULL) {
        spdSetDefaultOption(spdOption);
        return spdCountOption(spdOption);
    }

    gsize = spdCountOption(spdGlobalOption);
    for (i = 0; spdOption[i].option != NULL; i++) {
        for (j = 0; j < gsize; j++) {
            if (SPD_STREQ(spdOption[i].option,
                            spdGlobalOption[j].option)) {
                break;
            }
        }
        if (j == gsize) {
            spdAppendOption(spdOption[i].option,
                            spdOption[i].value, gsize+insert);
            insert++;
        }
    }
    return insert;
}

/* ҤȤĤΥץ򥻥åȤ */
void spdSetOption(SpdString option, int value)
{
    int i = 0;

    if (option == NULL) {
        spdErrorExit("This option is empty.\n");
    }

    if (spdGlobalOption != NULL) {
        for (i = 0; spdGlobalOption[i].option != NULL; i++) {
            if (SPD_STREQ(option, spdGlobalOption[i].option)) {
                spdGlobalOption[i].value = value;
                break;
            }
        }
    }

    /* Append new option. */
    if (spdGlobalOption == NULL || spdGlobalOption[i].option == NULL) {
        spdAppendOption(option, value, i);
    }
}

/* ҤȤĤΥץ򻲾Ȥ */
int spdGetOption(SpdString option)
{
    int i;

    if (spdGlobalOption == NULL) {
        return SAPID_NON_OPTION;
    }

    for (i = 0; spdGlobalOption[i].option != NULL; i++) {
        if (SPD_STREQ(option, spdGlobalOption[i].option)) {
            return spdGlobalOption[i].value;
        }
    }
    return SAPID_NON_OPTION;
}

/* ٤ƤΥץ(β) */
void spdFreeOption(void)
{
    int i;

    if (spdGlobalOption != NULL) {
        for (i = 0; spdGlobalOption[i].option != NULL; i++) {
            spdFree(spdGlobalOption[i].option);
        }
        spdFree(spdGlobalOption);
        spdGlobalOption = NULL;
    }
}
