/* 
 * Program:             $RCSfile: spdSDBdir.c,v $  $Revision: 30.4 $
 * 
 * Purpose:             
 * 
 * Author:              M.Hakamata  1997/12/04
 *                      N.Fukuyasu  1997/12/04
 *                      S.Yamamoto  1997/12/06
 * 
 * (C) Copyright:       M.Hakamata, N.Fukuyasu and S.Yamamoto  1997
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdSDBdir.c,v 30.4 2000/03/19 10:07:54 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

static SpdString SDBdirectory = NULL;

static void freeSDBdirectory(void)
{
    if (SDBdirectory != NULL) {
        spdFree(SDBdirectory);
        SDBdirectory = NULL;
    }
}

void spdSetSDBdir(SpdConstString dir)
{
    static SpdBoolean   is_first_call = TRUE;

    if (is_first_call) {
        atexit(freeSDBdirectory);
        is_first_call = FALSE;
    }
    freeSDBdirectory();
    SDBdirectory = spdStrdup(dir == NULL ? SAPID_SDB_DIR : dir);
}

SpdString spdGetSDBdir(void)
{
    if (SDBdirectory == NULL) {
        spdSetSDBdir(NULL);
    }
    return (SDBdirectory);
}
