/* 
 * Program:             $RCSfile: spdSet.c,v $  $Revision: 30.9 $
 * 
 * Purpose:             
 * 
 * Author:              M.Hakamata  1997/01/30
 *                      A.Watanabe  1997/01/30
 *                      S.Yamamoto  1997/02/09
 * 
 * (C) Copyright:       M.Hakamata, A.Watanabe and S.Yamamoto  1997 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdSet.c,v 30.9 2003/07/08 06:19:37 yamamoto Exp yamamoto $";
#endif

#include <limits.h>
#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spdSet.h"
#include "spdSetSub.h"

/* ľ˻Ȥäset򤹤˻Ȥ褦˻ĤƤ */
#ifndef USE_PURIFY
#define SAVE_SET 
#endif

#ifdef SAVE_SET
static SpdSet1 save = NULL; 
#endif

/* ϥåɽκƹ */  
static void     _spdRebuildSet(SpdSet1 set);

/* ElemPtr Ѥΰ/ 뤿δؿ */
static ElemPtr  *_allocElemPtr(SpdSet1 set);
static void     _freeElemPtr(SpdSet1 set, ElemPtr *elemPtr);

/* #define SPDSET_DEBUG */

/*
 * ⥸Ȥδñʥϥåؿ
 * keyͤ unsigned int ؤѴԤʤߤϥޥǼ¸Ƥ롥
 */

/* 
 * static unsigned int
 * _setHash(SpdSet1 set, unsigned int key)
 * {
 *     return (key % set->bktNum);
 * }
 */

/*
 * ˡkeyǻꤵǤTRUE򡤤ʤFALSE֤
 */

SpdBoolean spdSetContains1(SpdSet1 set, int key)
{
    return (_spdSearchElem1(set, key) != NULL);
}

/*
 * key ǻꤷǤб ElemPtr ؤΥݥ󥿤֤
 * ȯǤʤäNULL֤ѤΤߡ
 */

ElemPtr *_spdSearchElem1(SpdSet1 set, register int key)
{
    register ElemPtr *cur;
    
    for (cur = set->bktAry[_setHash(set,key)].listp; 
         cur != NULL; cur = cur->next) {
        if (cur->key == key) {
            return cur;                     /* ȯ */
        }
    }
    return NULL;                            /* Ĥʤä */
}

/* 
 * Ǥ롥ޤǤؤΥݥ󥿤֤Ǥ˽
 * ¸ߤǤξϡNULL֤
 */

Contents spdAddElem1(SpdSet1 set, int key, Contents contents)
{
    register ElemPtr *ptr;
    register Bucket  *bkt;
    
    if ((ptr = _spdSearchElem1(set, key)) != NULL) { 
        return NULL;                        /* ¸ */
    }   

    if (set->elemNum > set->rebuildNum) {   /* ɬפʤϥåɽƹ */
        _spdRebuildSet(set); 
    }

    bkt = &(set->bktAry[_setHash(set,key)]);

    ptr = _allocElemPtr(set);               /* ElemPtr */

    ptr->next = bkt->listp;                 /* ꥹȤƬɲ  */ 
    bkt->listp = ptr;

    ptr->key = key;

    if (IS_DEFAULT_ELEM(set)) {
        /* keyǤȤϡΰݤʤ   */
        ptr->contents = (Contents)(&(ptr->key));
    } else if (IS_SMALL_ELEM(set)) {
        ptr->contents = (Contents)*(int *)contents;
    } else {
        /* contentsλؤƤ򥳥ԡ뤿ΰ  */
        ptr->contents = (Contents)spdMalloc(set->elemSiz);
        memcpy(ptr->contents, contents, set->elemSiz);
    }

    ptr->mark = UNMARK;
    set->elemNum++;
    bkt->elemNum++;

    /* return ptr->contents; */
    return (GET_CONTENTS(set, ptr->contents));
}

/*
 * key ǻꤷǤ򡤽礫õ롥
 * õ1֤Ԥ0֤
 */

int spdDelElem1(SpdSet1 set, register int key)
{
    register ElemPtr    *cur;
    register ElemPtr    *prev;
    Bucket              *bkt;

    bkt = &(set->bktAry[_setHash(set,key)]);
    for (cur = prev = bkt->listp; cur != NULL; prev = cur, cur = cur->next) {
        if (cur->key == key) {
            /* ݥ󥿤դѤ */
            if (prev == cur) {
                bkt->listp = cur->next;     /* ꥹȤƬǤξ */
            } else {
                prev->next = cur->next;     /* Ǥʤ */
            }

            if (IS_LARGE_ELEM(set)) {
                spdFree(cur->contents);
            }
            _freeElemPtr(set, cur);         /* ե꡼ꥹȤɲ */
            bkt->elemNum--;
            set->elemNum--;

            return 1;                       /* Ǥõ */
        }
    }
    return 0;                               /* ꤵ줿Ǥ¸ߤʤ */
}

/* 
 * Ѥΰݡ롥elemSizˤϡǤ礭ꤹ롥
 * DEFAULT_INT_SET ꤹȡkey == ǤǤ뽸ˤʤ롥
 */

SpdSet1 spdCreateSet1(size_t elemSiz)
{
    unsigned    int i;
    SpdSet1      set;

#ifdef SAVE_SET
    if (save != NULL) {
        set = save;
        save = NULL;
    } else {                                /* save == NULL */
        set = spdMalloc(sizeof(_SpdSet1));
        set->bktNum     = DEFAULT_BUCKET_NUM;
        set->bktAry     = (BktArray)spdMalloc(sizeof(Bucket) * set->bktNum);
        set->elemPBlkList = (ElemPtrBlk*)spdMalloc(sizeof(ElemPtrBlk));
        set->elemPBlkList->prev = NULL;
    }
#else  /* SAVE_SET */
    set = spdMalloc(sizeof(_SpdSet1));
    set->bktNum     = DEFAULT_BUCKET_NUM;
    set->bktAry     = (BktArray)spdMalloc(sizeof(Bucket) * set->bktNum);
    set->elemPBlkList = (ElemPtrBlk*)spdMalloc(sizeof(ElemPtrBlk));
    set->elemPBlkList->prev = NULL;
#endif /* SAVE_SET */

    set->freeList   = NULL;
    set->elemNum    = 0UL;
    set->rebuildNum = (unsigned long)(set->bktNum * ELEM_AVERAGE);
    set->elemSiz    = elemSiz;
    set->elemPBlkList->usedNum = 0U;
    for (i=0; i < set->bktNum; i++) {       /* Хåν */
        set->bktAry[i].elemNum = 0U;
        set->bktAry[i].listp   = NULL;
    }   
    set->memory = NULL;
    set->memIndex = 0U;

    return set;
}

/*
 * Τ˳ݤΰ롥
 */

void spdFreeSet1(SpdSet1 set)
{
    register ElemPtrBlk *cur;
    register ElemPtrBlk *prev;

#ifdef SAVE_SET
    SpdBoolean no_saved = TRUE;
#endif /* SAVE_SET */
    
    if (set == NULL) {
        return;
    }
#ifdef SPDSET_DEBUG
    spdStatSet1(set);
#endif /* SPDSET_DEBUG */

#ifdef SAVE_SET
    if (save == NULL) {
        no_saved = FALSE;
        save = set;                         /* saved */
    }
#endif /* SAVE_SET */

    if (IS_LARGE_ELEM(set)) {
        register unsigned int i;
        
        /* blkfreeƤʤʬcontents */
        /* UNUSED ΰ褬Τդ */
        for (cur = set->elemPBlkList; cur != NULL; cur = prev) {
            prev = cur->prev;
            for (i = cur->usedNum; i; i--) { /* i  unsigned */
                if (cur->elemP[i-1].mark != FREED) {
                    spdFree(cur->elemP[i-1].contents);
                }       
            }   
        }
    }

#ifdef SAVE_SET
    /* ElemPtrBlk (ĤĤ) */
    for (cur = set->elemPBlkList; cur->prev != NULL; cur = prev) {
        prev = cur->prev;
        spdFree(cur);
    }
    
    if (no_saved) {
        spdFree(cur);
        spdFree(set->bktAry);
        spdFree(set);
    } else {
        set->elemPBlkList = cur;
        set->bktNum = DEFAULT_BUCKET_NUM;
        set->bktAry = (BktArray)spdRealloc(set->bktAry, 
                                           sizeof(Bucket) * set->bktNum);
    }
#else  /* SAVE_SET */
    for (cur = set->elemPBlkList; cur != NULL; cur = prev) {
        prev = cur->prev;
        spdFree(cur);
    }
    spdFree(set->bktAry);
    spdFree(set);
#endif /* SAVE_SET */
}

/*
 * keyǻꤷǤؤΥݥ󥿤֤ǤʤNULL֤
 */

Contents spdSearchElem1(SpdSet1 set, int key)
{
    ElemPtr *ptr;

    ptr = _spdSearchElem1(set, key);
    return (ptr ? GET_CONTENTS(set, ptr->contents) : NULL);
}

/*
 * set 椫ǤļФset->elemNum Ϣ³ơۤʤ
 * ǤФǽȤѲ
 * ϡϢ³Ȥϸ¤ʤǤʤȤ NULL ֤
 */

Contents spdGetAElem1(SpdSet1 set, int *key)
{
    register ElemPtrBlk *cur;
    register            int i;

    /* ǿ 0 ΤȤ̤ʤΤǤ餫 */
    if (set->elemNum == 0U) {
        return NULL;
    }

    /* ֺǽ˸ƤФ줿Ȥ */
    if (set->memory == NULL) {
        set->memory =set->elemPBlkList;
        set->memIndex = set->elemPBlkList->usedNum;
    }

    /* Υ֥åˤĤ */
    cur = set->memory;
    for (i = set->memIndex - 1; i >= 0; i--) {
        if (cur->elemP[i].mark != FREED) {
            set->memIndex = i;
            if (key) *key = cur->elemP[i].key;
            return GET_CONTENTS(set, cur->elemP[i].contents);
        }
    }

    /* ֥åꥹȤνãޤ */
    for (cur = cur->prev; cur != NULL; cur = cur->prev) {
        for (i = cur->usedNum - 1; i >= 0; i--) {
            if (cur->elemP[i].mark != FREED) {
                set->memory   = cur;
                set->memIndex = i;
                if (key) *key = cur->elemP[i].key;
                return GET_CONTENTS(set, cur->elemP[i].contents);
            }
        }
    }

    /* ֥åꥹȤƬǽΥ֥åãޤ */
    for (cur = set->elemPBlkList; cur != set->memory; cur = cur-> prev) {
        for (i = cur->usedNum - 1; i >= 0; i--) {
            if (cur->elemP[i].mark != FREED) {
                set->memory   = cur;
                set->memIndex = i;
                if (key) *key = cur->elemP[i].key;
                return GET_CONTENTS(set, cur->elemP[i].contents);
            }
        }
    }

    /* ǽˤߤ֥åλĤʬˤĤ */
    for (i = cur->usedNum - 1; i >= set->memIndex; i--) {
        if (cur->elemP[i].mark != FREED) {
            set->memory   = cur;
            set->memIndex = i;
            if (key) *key = cur->elemP[i].key;
            return GET_CONTENTS(set, cur->elemP[i].contents);
        }
    }
    /* NOT REACHED */
    
    return NULL;                            /* ǰΤ */
}

/*
 * ƤǤˤ֤Ͽ˳ݤ줿ΰʤΤǡ
 * Ѽ¦ǲ뤳ȡ
 */

Contents spdGetArrayOfElem1(SpdSet1 set)
{
    register ElemPtr *ptr;
    register size_t size;
    Contents ary, p;
    unsigned int i;

    if (set->elemSiz) {
        size = set->elemSiz;
    } else {
        size = sizeof(int);
    }

    /* 
     * !! :                                                         
     * ⤷elemNum > UINT_MAX ΤȤޤ malloc Ǥʤǽ롥
     * ϡsize_t μΤ unsigned int ǤĶ¸ߤ٤  
     * 롥äȤ⡤ʿۤ򤹤ɬפ¿ˤʤ         
     */

    p = ary = (Contents)spdMalloc((size_t)set->elemNum * size);
    for (i = 0; i < set->bktNum; i++) {
        for (ptr = set->bktAry[i].listp; ptr != NULL; 
             ptr = ptr->next, p = (char*)p + size) {
            memcpy(p, GET_CONTENTS(set, ptr->contents), size);
        }
    }
    return ary;
}

/*
 * ϥåɽƹؿѡ
 *
 * :
 * 1ХåʿǸĿ(set->elemNum / set->bktNum)
 * ELEM_AVERAGEۤȤ˸ƤФ롥ǤϡʥХå
 * 䤷ϥåɽƹ롥
 *
 * ХåȤöϡ
 *   (Хåȿ) < 10000U ޤǤ  (ΥХåȿ) * 2 + 1
 *   (Хåȿ) > 10000U   (ΥХåȿ) + 10000U ն
 *                                 20ʲΤʤ
 * Ȥʤ롥20ʲ... κ bit̺ ֥ե빽¤ p.334 顥
 *
 * ʤХåȿϽ礬¸ߤ֡뤳ȤϤʤ
 */

static void _spdRebuildSet(SpdSet1 set)
{
    unsigned int       newBktNum;
    BktArray           newBktAry;
    unsigned int       oldBktNum;
    BktArray           oldBktAry;
    unsigned int i;
    register Bucket   *newBkt;
    register ElemPtr  *cur;
    register ElemPtr  *next;

    if (set->bktNum == INT_MAX) { 
        /* ХåȤθĿϡintκͤޤǤ */
        set->rebuildNum = ULONG_MAX;
        return;
    }

    
    /* resize bucket number  */
    newBktNum = set->bktNum;
    if (newBktNum > 10000U) {
        if ((unsigned long)newBktNum + 10000UL > (unsigned long)INT_MAX) {
            /* newBktNum κͤ INT_MAX  */
            newBktNum = INT_MAX;

        } else {
            newBktNum += 10000U;
        }
    } else {
        /* bktNum * 2 + 1*/
        newBktNum =  newBktNum * 2U + 1U;
    }

    /* newBktNum20ʲʤ褦ˤ */
    /* 20 κ bit̺֥ե빽¤p.334 */
    if (newBktNum % 2U == 0U) {
        newBktNum++;
    }
    while(newBktNum % 3U == 0U || newBktNum % 5U == 0U
          || newBktNum % 7U == 0U || newBktNum % 11U == 0U
          || newBktNum % 13U == 0U || newBktNum % 17U == 0U
          || newBktNum % 19U == 0U) {
        newBktNum += 2U;
    }

    /* Хåݤ */
    newBktAry = spdMalloc(sizeof(Bucket) * newBktNum);
    if (newBktAry == NULL) { 
        /* ΰݤ˼ԤƤ⡤ȤꤢǽλˤϤʤ */
        /* Ǥ⡤ޤ̣ʤ(Ǥ˥̤þƤ) */

        set->rebuildNum += 1000UL;
        /* פˡƹФˤƤ롥*/
        return;
    }

    /*  newBktNum, newBktAry  set  */
    /* ͤ¸                */
    oldBktNum = set->bktNum;
    oldBktAry = set->bktAry;
    set->bktNum = newBktNum;
    set->bktAry = newBktAry;

    for (i = 0; i < newBktNum; i++) {
        newBktAry[i].listp = NULL;
        newBktAry[i].elemNum = 0U;
    }

    /* ǤˤĤơϥå夷ľ(linkp  next ΤĤʤľ) */
    for (i = 0; i < oldBktNum; i++) {
        for (cur = oldBktAry[i].listp; cur != NULL; cur = next) { 
            next = cur->next;

            /* ꥹȤǤդä롥 */
            newBkt = &(newBktAry[_setHash(set, cur->key)]);
            cur->next = newBkt->listp;
            newBkt->listp = cur;
            newBkt->elemNum++;
        }
    }

    set->rebuildNum = (unsigned long)set->bktNum * ELEM_AVERAGE;
    spdFree(oldBktAry);
}

static ElemPtr *_allocElemPtr(SpdSet1 set)
{
    register ElemPtrBlk *curBlk;
    register ElemPtrBlk *newBlk;

    /* Υ֥å̤Ѥ ELEMPTR ļäƤ */
    curBlk = set->elemPBlkList;
    if (curBlk->usedNum < _ELEMPTR_BLKSIZ) {
        return &(curBlk->elemP[curBlk->usedNum++]);
    }
    
    /* ե꡼ꥹȤ ELEMPTR ļäƤ */
    if (set->freeList != NULL) {
        ElemPtr *p;
        p = set->freeList;
        set->freeList = p->next;
        return p;
    }

    /* ֥åϰաե꡼ꥹȤʤΤ */
    /* ֥åĳݤ           */
    set->elemPBlkList = newBlk = (ElemPtrBlk*)spdMalloc(sizeof(ElemPtrBlk));
    newBlk->prev = curBlk; 
    newBlk->usedNum = 1U;

    return &(newBlk->elemP[0U]);
}   

static void _freeElemPtr(SpdSet1 set, ElemPtr *elemPtr)
{
    /* ե꡼ꥹȤɲ */
    elemPtr->next = set->freeList;
    set->freeList = elemPtr;
    /* mark 򥻥åȤ */
    elemPtr->mark = FREED;
}

/******************************************************************************/

void spdClearSetEnumeration1(SpdSet1 set)
{
    set->memory = NULL;
}

/******************************************************************************/

#ifdef SPDSET_DEBUG

/*
 * (key)ñɽؿǥХåѡ
 * ºݤǤȤɽʤ
 */

void spdPrintSet1(SpdSet1 set)
{
    unsigned int    i,j;
    Bucket          *bkt;
    ElemPtr         *ptr;

    fprintf(stderr, "--------------------------------------\n");
    fprintf(stderr, "number of elements: %lu\n", set->elemNum);
    fprintf(stderr, "number of buckets : %u\n", set->bktNum);

    for (i = 0; i < set->bktNum; i++) {
        bkt = &(set->bktAry[i]);
        fprintf(stderr, "bkt[%d]|%d|", i, bkt->elemNum);
        ptr = bkt->listp;
        if (ptr == NULL) {
            fprintf(stderr, "     NULL |\n");
        } else {
            for (j = 0; j < bkt->elemNum; j++) {
                fprintf(stderr, " %c%8d|",
                        (ptr->mark == UNMARK) ? 'U' : 'M', ptr->key);
                ptr = ptr->next;
            }
            fprintf(stderr, "\n");
        }
    }
}

/*
 * ׾Ϥ롥ϥåؿǽɾʤɤѡ
 * ǥХåѡ
 */

void spdStatSet1(SpdSet1 set)
{
    unsigned long   zerobkt = 0UL;
    Bucket          *bkt;
    unsigned int    i;
    
    bkt = set->bktAry;
    for (i = 0; i < set->bktNum; i++) {
        if (bkt[i].elemNum == 0) {
            zerobkt++;
        }
    }

    if (set->elemNum == 0) {
        fprintf(stderr, "------------------------\n"
                "ǿ    : %lu\n"
                "Хåȿ: %lu\n"
                "------------------------\n",
                set->elemNum, set->bktNum);
    } else {
        fprintf(stderr, "------------------------\n"
                "ǿ    : %d\n"
                "Хåȿ: %d\n"
                "ͭΨ  : %f\n"
                "ʿϢĹ: %f\n"
                "------------------------\n", 
                set->elemNum, set->bktNum,
                100.0 * (set->bktNum - zerobkt) / set->bktNum,
                (double)(set->elemNum) / (set->bktNum - zerobkt));
    }
}   

#endif /* SPDSET_DEBUG */
