/* 
 * Program:             $RCSfile: spdSet3.h,v $  $Revision: 40.5 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  2003/01/25
 * 
 * (C) Copyright:       S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

#ifndef _SPDSET3_H
#define _SPDSET3_H

#define SPD_SS3_ELEM_MAX_BYTE   32
#define SPD_SS3_ELEM_MAX_INT    (SPD_SS3_ELEM_MAX_BYTE / sizeof(int))

typedef struct {
     int    x[SPD_SS3_ELEM_MAX_INT];
} Contents3;

typedef struct {
  /* Public members. */
  unsigned long elemNum;        /* Number of elements. */
  size_t        elemSiz;        /* Size of element. */
  void      *map3;

  /* Private members. */
  SpdBoolean    isFirstCall;    /* Used for spdGetAElem3(). */
} _SpdSet3;

typedef _SpdSet3 *SpdSet3;

SpdSet3 spdCreateSet3(size_t elemSiz);
Contents spdAddElem3(SpdSet3 set, int key, Contents contents);
Contents spdSearchElem3(SpdSet3 set, int key);
SpdBoolean spdSetContains3(SpdSet3 set, int key);
SpdSet3 spdDupSet3(SpdSet3 set);
int spdDelElem3(SpdSet3 set, int key);  /* !! Should be SpdBoolean. */
void spdFreeSet3(SpdSet3 set);
Contents spdGetArrayOfElem3(SpdSet3 set);
Contents spdGetAElem3(SpdSet3 set, int *key);

SpdSet3 spdUnionSet3(SpdSet3 s1, SpdSet3 s2);
SpdSet3 spdIntersectionSet3(SpdSet3 s1, SpdSet3 s2);
SpdSet3 spdDifferenceSet3(SpdSet3 s1, SpdSet3 s2);

void spdClearSetEnumeration3(SpdSet3 set);

#define SAPID_EMPTY_SET3       spdCreateSet3(DEFAULT_INT_SET)

#endif /* _SPDSET3_H */
