/* 
 * Program:             $RCSfile: spdSetOp.c,v $  $Revision: 30.4 $
 * 
 * Purpose:             
 * 
 * Author:              M.Hakamata  1997/06/27
 *                      S.Yamamoto  1997/02/09
 * 
 * (C) Copyright:       M.Hakamata and S.Yamamoto  1997 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdSetOp.c,v 30.4 2003/01/27 15:15:15 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spdSet.h"
#include "spdSetSub.h"

/*
 *  set ʣ롥Τΰݤ롥
 */

SpdSet1 spdDupSet1(SpdSet1 set)
{
    SpdSet1 ret;
    Contents contents;
    int i;
    int key;

    ret = spdCreateSet1(set->elemSiz);
    for (i = set->elemNum; i > 0; i--) {
        contents = spdGetAElem1(set, &key);
        spdAddElem1(ret, key, contents);
    }
    return ret;
}

/*
 *  s1  s2 ¤ȤꡤʽȤ֤
 */

SpdSet1 spdUnionSet1(SpdSet1 s1, SpdSet1 s2)
{
    SpdSet1 ret;
    Contents contents;
    int i;
    int key;

    if (s1->elemSiz != s2->elemSiz) return NULL;
    if (s1->elemNum < s2->elemNum) {
        ret = s2; s2 = s1; s1 = ret;
    }
    ret = spdDupSet1(s1);
    for (i = s2->elemNum; i > 0; i--) {
        contents = spdGetAElem1(s2, &key);
        spdAddElem1(ret, key, contents);
    }

    return ret;
}

/*
 *  s1 ȡ s2 ȤʣƤʬ(ʣƤ뤫ɤ
 * ȽǤϡkey ͤɤǹԤ) 򿷤ʽȤ֤
 */

SpdSet1 spdIntersectionSet1(SpdSet1 s1, SpdSet1 s2)
{
    SpdSet1 ret;
    int i;
    int key;
    Contents contents;

    if (s1->elemSiz != s2->elemSiz) return NULL;
    if (s1->elemNum > s2->elemNum) {
        ret = s1; s1 = s2; s2 = ret;
    }

    ret = spdCreateSet1(s1->elemSiz);
    for (i = s1->elemNum; i > 0; i--) {
        contents = spdGetAElem1(s1, &key);
        if (spdSetContains1(s2, key)) {
            spdAddElem1(ret, key, contents);
        }
    }
    return ret;
}

/*
 *  s1 顤 s2 ȽʣƤʬ(ʣƤ뤫ɤ
 * ȽǤϡkey ͤɤǹԤ) 򺹤ʬ򿷤
 * Ȥ֤
 */

SpdSet1 spdDifferenceSet1(SpdSet1 s1, SpdSet1 s2)
{
    register SpdSet1 ret;
    register Contents contents;
    register int i;
    int key;

    if (s1->elemSiz != s2->elemSiz) return NULL;
    ret = spdCreateSet1(s1->elemSiz);

    for (i = s1->elemNum; i > 0; i--) {
        contents = spdGetAElem1(s1, &key);
        if (!spdSetContains1(s2, key)) {
            spdAddElem1(ret, key, contents);
        }
    }

    return ret;
}

/*
 *  ǤˤĤ줿򤹤٤ƾä
 */

void spdClearMarks(SpdSet1 set)
{
    register ElemPtrBlk *blk;
    register unsigned int i;

    for (blk = set->elemPBlkList; blk != NULL; blk = blk->prev) {
        for (i = blk->usedNum; i; i--) {
            if (blk->elemP[i].mark != FREED) {
                blk->elemP[i].mark = UNMARK;
            }
        }
    }
}

/*
 * ǤˤĤ줿ȿž
 */

void spdInverseMark(SpdSet1 set)
{
    register ElemPtrBlk *blk;
    register unsigned int i;

    for (blk = set->elemPBlkList; blk != NULL; blk = blk->prev) {
        for (i = blk->usedNum; i; i--) {
            blk->elemP[i].mark = (blk->elemP[i].mark == UNMARK) ? MARK : UNMARK;
        }
    }
}

/*
 * key Ǥ򸡺ưĤ롥ĤǤؤΥݥ󥿤֤
 */

Contents spdSearchElemAndMark(SpdSet1 set, int key)
{
    register ElemPtr *elemPtr;

    if ((elemPtr = _spdSearchElem1(set, key)) == NULL) {
        return NULL;
    }
    elemPtr->mark = MARK;
    return GET_CONTENTS(set, elemPtr->contents);
}

/*
 * key Ǥ򸡺ưääǤؤΥݥ󥿤֤
 */

Contents spdSearchElemAndUnMark(SpdSet1 set, int key)
{
    register ElemPtr *elemPtr;

    if ((elemPtr = _spdSearchElem1(set, key)) == NULL) {
        return NULL;
    }
    elemPtr->mark = UNMARK;
    return GET_CONTENTS(set, elemPtr->contents);
}

/*
 * Ĥ줿Ǥ򽸹礫롥ǿ֤
 */

unsigned int spdDeleteMarkedElem(SpdSet1 set)
{
    register ElemPtrBlk *blk;
    register unsigned int i;
    register unsigned int deleted = 0;

    for (blk = set->elemPBlkList; blk != NULL; blk = blk->prev) {
        for (i = blk->usedNum; i; i--) {
            if (blk->elemP[i].mark == MARK) {
                deleted++;
                if (IS_LARGE_ELEM(set)) {
                    spdFree(blk->elemP[i].contents);
                }   
                blk->elemP[i].next = set->freeList;
                set->freeList = &(blk->elemP[i]);
            }
        }
    }
    set->elemNum -= deleted;
    return deleted;
}   

/*
 * ĤƤʤǤ򽸹礫
 */

unsigned int spdDeleteUnMarkedElem(SpdSet1 set)
{
    register ElemPtrBlk *blk;
    register unsigned int i;
    register unsigned int deleted = 0;

    for (blk = set->elemPBlkList; blk != NULL; blk = blk->prev) {
        for (i = blk->usedNum; i; i--) {
            if (blk->elemP[i].mark == UNMARK) {
                deleted++;
                if (IS_LARGE_ELEM(set)) {
                    spdFree(blk->elemP[i].contents);
                }
                blk->elemP[i].next = set->freeList;
                set->freeList = &(blk->elemP[i]);
            }
        }
    }
    set->elemNum -= deleted;
    return deleted;
}
