/* 
 * Program:             $RCSfile: spdSymlink.cc,v $  $Revision: 40.5 $
 * 
 * Purpose:             
 * 
 * Author:              T.Miyazoe  2003/04/23
 *                      S.Yamamoto  200d/04/23
 * 
 * (C) Copyright:       T.Miyazoe and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdSymlink.cc,v 40.5 2003/04/29 08:07:06 yamamoto Exp yamamoto $";
#endif

/* #define USE_WIN32_SHORTCUT */

extern "C" {
#include <stdio.h>
#include <Sapid/Sapid.h>
}

/*
 * name1symbolic linkȤname2롥
 * C.f. "path.c" in UNIX environment.
 */

#if defined(WIN32)

#if defined(USE_WIN32_SHORTCUT)

#include <windows.h>
/* #include <stdio.h> */
/* #include <string.h> */
#include <shlobj.h>

/* extern "C" void spdSymlink(const char *oldpath, const char *newpath); */

void spdSymlink(const char *oldpath, const char *newpath)
{
    char    targetpath[FILENAME_MAX + 1];
    char    shortcutpath[FILENAME_MAX + 1];
    int     ch = '/';
    char*   pdest;
    int     result;

    /* 
     * memset(targetpath, NULL, FILENAME_MAX);
     * memset(shortcutpath, NULL, FILENAME_MAX);
     */
    targetpath[0] = '\0';
    strcpy(shortcutpath, newpath);
    strcat(shortcutpath, ".lnk");
    pdest = strchr(oldpath, ch);
    if(pdest == NULL)
    {
        pdest = strrchr(shortcutpath, ch);
        if(pdest != NULL)
        {
            result = pdest - shortcutpath + 1;
            strncpy(targetpath, shortcutpath, result);
            strcat(targetpath, oldpath);
        }
    }
    else
    {
        strcpy(targetpath, oldpath);
    }

    for(;;)
    {
        pdest = strchr(targetpath, ch);
        if(pdest == NULL) break;
        *pdest = '\\';
    }
    for(;;)
    {
        pdest = strchr(shortcutpath, ch);
        if(pdest == NULL) break;
        *pdest = '\\';
    }

    if(!SUCCEEDED(CoInitialize(NULL))) return;

    IShellLink      *psl;
    IPersistFile    *ppf;
    HRESULT         hRes;

    hRes = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,
                            IID_IShellLink, (void **)&psl);
    if(SUCCEEDED(hRes))
    {       
        hRes = psl->QueryInterface(IID_IPersistFile, (void **)&ppf);
        if(SUCCEEDED(hRes))
        {
            hRes = psl->SetPath(targetpath);
            if(SUCCEEDED(hRes))
            {
                psl->SetIconLocation(targetpath, 0);
                psl->SetShowCmd(SW_NORMAL);

                WORD    wPathName[FILENAME_MAX + 1];
                MultiByteToWideChar(CP_ACP, 0, shortcutpath, -1,
                                    wPathName, FILENAME_MAX);
                hRes = ppf->Save(wPathName, TRUE);
            }
        }
    }
    
    // Release objects.
    psl->Release();
    ppf->Release();

    CoUninitialize();   // Clean up COM.
}

#else /* !defined(USE_WIN32_SHORTCUT) */

void spdSymlink(SpdConstString name1, SpdConstString name2)
{
    int         retVal;
    static char buf[32 + (FILENAME_MAX * 2) + 1];

    spdMessage("spdSymlink(): \"%s\" <- \"%s\".\n", name1, name2);

    /* !! Dirty trick. We assume existence of command "ln" in Cygwin. */
    sprintf(buf, "/bin/ln -s \"%s\" \"%s\"", name1, name2);
    retVal = system(buf);
    if (retVal != 0) {
        spdErrorExit("spdSymlink(): \"%s\": Can't make a link.\n", buf);
    }
}

#endif /* !defined(USE_WIN32_SHORTCUT) */

#endif /* defined(WIN32) */
