/* 
 * Program:             $RCSfile: attribute.c,v $  $Revision: 30.8 $
 * 
 * Purpose:             
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: attribute.c,v 30.8 2003/06/04 17:01:01 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
/* #include <stdlib.h> */
#include <Sapid/Sapid.h>
#include "ddbin.h"
#include "attribute.h"

AttributeObj *addAttributeObj(const char *attributename, const int offset)
{
    AttributeObj    *new;
    static int      attributeobj_num = SPD_OBJ_ID_OFFSET(SPD_CID_ATTRIBUTE);

    new = (AttributeObj *)spdCalloc(1,sizeof(AttributeObj));
    new->id = attributeobj_num++;
    new->name = spdStrdup(attributename);
    new->offset = offset;
    insertLinklistFirst(attributeobj_list, new);
    return new;
}

void freeAttributeObjList(void)
{
    Linklist lst = attributeobj_list;
    Node node=getFirstNode(lst);

    while(node){
        AttributeObj *p = (AttributeObj *)getNodeData(node);
        spdFree(p->name);
        spdFree(p);
        node = getNextNode(node);
    }
    freeLinklist(lst);
}

#ifdef DOC_DEBUG

void printAttributeList(void)
{
    Node node = getFirstNode(attributeobj_list);

    while(node){
        AttributeObj *p = (AttributeObj *)getNodeData(node);
        printf("AttObj: id:%d name:%s\n",p->id,p->name);    
        node=getNextNode(node);
    }
}

#endif /* DOC_DEBUG */
