/* 
 * Program:             $RCSfile: ddbin.h,v $  $Revision: 30.7 $
 * 
 * Purpose:             
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000 - 2001
 *                      This file is a product of the project Sapid.
 */

/* 
 * "$Id: ddbin.h,v 30.7 2001/12/28 06:34:02 yamamoto Exp yamamoto $";
 */

#ifndef _DDBIN_H
#define _DDBIN_H

#include "linklist.h"   /* For object listing. */

/* Document Object */

typedef struct _DocObj {
    int id;
    char *name;
    Linklist docfile_list;
} DocObj;

/* Doc File Object */

typedef struct _DocFileObj {
    int  id;
    char *name;
    Linklist docfrag_list;
} DocFileObj;

/* Doc Frag object. */

typedef struct _DocFragObj {
    int id;
    int sort;
    char *name;                             /* Element name. */
    int length;
    int offset;

    Linklist docfrag_list;                  /* For docelem_docfrag,
                                               identelem_docident
                                               textfrag_textstring. */
    Linklist docident_list;                 /* For defelem_docident. */
    Linklist attribute_list;                /* For basicelem_attribute. */
    char *srctext;                          /* If this is srccode-element,
                                               srctext represents srccode text. */
    int srcoffset;                          /* Srccode offset. */

} DocFragObj;

typedef struct _DocIdentInfo{
    int id;
    int sort;
    char *name;
} DocIdentInfo;

typedef struct _DocIdentObj{
    DocIdentInfo *docident;
    int offset;
} DocIdentObj;

typedef struct _TextstringObj {
    int id;
    char *text;                             /* Text body. */
    int offset;
} TextstringObj;

typedef struct _AttributeObj {
    int id;
    char *name;                             /* Attribute name. */
    int offset;
    TextstringObj *textstringObj;           /* Attribute value. */
} AttributeObj;

#ifdef DDBINMAIN
#define EXTERN
#else
#define EXTERN extern
#endif

/* Command-line option. */
EXTERN int verbose_mode;

/* Object List */
/* ֥Ȥfree뤿ˡ٤ƤΥ֥ȤϿ롥 */

EXTERN Linklist docobj_list;
EXTERN Linklist docfileobj_list;
EXTERN Linklist docfragobj_list;
EXTERN Linklist textstringobj_list;
EXTERN Linklist attributeobj_list;
EXTERN Linklist docidentinfo_list;
EXTERN Linklist docidentobj_list;

/* Special tags. */

#define DEFINE_TAG          "define"
#define DEFELEM_ATTRNAME    "name"
#define DEFELEM_ATTRSORT    "sort"
#define SRCCODE_TAG         "srccode"
#define DOCIDENT_TAG        "docident"
#define MACRODEF_TAG        "macrodef"

#endif /* not _DDBIN_H */
