/* 
 * Program:             $RCSfile: docfile.c,v $  $Revision: 30.7 $
 * 
 * Purpose:             
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: docfile.c,v 30.7 2003/06/04 17:01:00 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "ddbin.h"
#include "docfile.h"

DocFileObj *addDocFileObj(const char *filename)
{
    DocFileObj  *new;
    static int  docfileobj_num = SPD_OBJ_ID_OFFSET(SPD_CID_DOCFILE);

    new = (DocFileObj *)spdCalloc(1,sizeof(DocFileObj));
    new->id = docfileobj_num++;
    new->name = spdStrdup(filename);
    new->docfrag_list = initLinklist();
    insertLinklistFirst(docfileobj_list, new);
    return new;
}

void freeDocFileObjList(void)
{
    Linklist lst = docfileobj_list;
    Node node = getFirstNode(lst);

    while(node){
        DocFileObj *p = (DocFileObj *)getNodeData(node);
        spdFree(p->name);
        freeLinklist(p->docfrag_list);
        spdFree(p);
        node=getNextNode(node);
    }
    freeLinklist(lst);
}

#ifdef DOC_DEBUG

void printDocFileList(void)
{
    DocFileObj *p;
    Node node = getFirstNode(docfileobj_list);

    while(node){
        Node node2;
        DocFileObj *p = (DocFileObj *)getNodeData(node);
        printf("DocFileObj: id:%d name:%s\n",p->id,p->name);
        node=getNextNode(node);
        printf("  docfragid:");
        node2 = getFirstNode(p->docfrag_list);
        while(node2){
            DocFragObj *p2 = (DocFragObj *)getNodeData(node2);
            printf("%d ",p2->id);
            node2=getNextNode(node2);
        }
        printf("\n");
    }
}

#endif /* DOC_DEBUG */
