/* 
 * Program:             $RCSfile: document.c,v $  $Revision: 30.7 $
 * 
 * Purpose:             
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: document.c,v 30.7 2003/06/04 17:01:00 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
/* #include <stdlib.h> */
#include <Sapid/Sapid.h>
#include "ddbin.h"
#include "document.h"

DocObj *addDocumentObj(const char *docname)
{
    DocObj      *new;
    static int  docobj_num = SPD_OBJ_ID_OFFSET(SPD_CID_DOCUMENT);

    new = (DocObj *)spdCalloc(1, sizeof(DocObj));
    new->id = docobj_num++;
    new->name = spdStrdup(docname);
    new->docfile_list = initLinklist();
    insertLinklistFirst(docobj_list, new);
    return new;
}

void freeDocumentObjList(void)
{
    Linklist lst = docobj_list;
    Node node=getFirstNode(lst);

    while(node){
        DocObj *p = (DocObj *)getNodeData(node);
        spdFree(p->name);
        freeLinklist(p->docfile_list);
        spdFree(p);
        node = getNextNode(node);
    }
    freeLinklist(lst);
}

#ifdef DOC_DEBUG

void printDocumentList(void)
{
    Node node = getFirstNode(docobj_list);

    while(node){
        DocObj *p = (DocObj *)getNodeData(node);
        Node node2;
        printf("DocObj: id:%d name:%s\n",p->id,p->name);    
        node=getNextNode(node);
        printf("  docfileid:");
        node2 = getFirstNode(p->docfile_list);
        while(node2){
            DocFileObj *p2 = (DocFileObj *)getNodeData(node2);
            printf("%d ",p2->id);
            node2=getNextNode(node2);
        }
        printf("\n");
    }
}

#endif /* DOC_DEBUG */
