/* 
 * Program:             $RCSfile: linklist.c,v $  $Revision: 30.6 $
 * 
 * Purpose:             
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: linklist.c,v 30.6 2003/06/04 17:01:01 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "linklist.h"

Linklist initLinklist(void)
{
    Node node = (Node)spdCalloc(1, sizeof(*node));

    node->data = NULL;
    node->next = node;
    return node;
}

/* prevnodeμnode롥 */

Node insertNode(Node prevnode, Node node)
{
    node->next = prevnode->next;
    prevnode->next = node;
    return node;
}

/* linklstκǽ˥ǡɲä롥 */

void insertLinklistFirst(Linklist lst, void *data)
{
    Node node;

    node = (Node)spdCalloc(1, sizeof(*node));
    node->data = data;
    insertNode((Node)lst, node);
}

/* linklstκǽ˥ǡɲä롥 */

void *removeLinklistFirst(Linklist lst)
{
    Node node = lst->next;
    void *data = NULL;

    if(node){
        data = node->data;
        lst->next = node->next;
        node->next = NULL;                  /* ɬפʤɡ */
    }
    return data;
}

/*
 * linklist롥ǡϺʤ
 */

void freeLinklist(Linklist lst)
{
    Node node=lst->next;
    Node tmp_node;

    while(node->data){
        tmp_node = node;
        node = node->next;
        spdFree(tmp_node);
    }
    spdFree(lst);
}

Node getFirstNode(Linklist lst)
{
    return ((lst->next->data) ? lst->next: NULL);
}

void *getNodeData(Node node)
{
    return (node->data);
}

Node getNextNode(Node node)
{
    return ((node->next->data) ? node->next : NULL);
}

int isEmptyLinklist(Linklist lst)
{
    return (lst->next == lst);
}
