/* 
 * Program:             $RCSfile: make_source.c,v $  $Revision: 30.9 $
 * 
 * Purpose:             
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: make_source.c,v 30.9 2001/12/03 14:27:18 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "ddbin.h"

static SpdInfo *srcfrag_info; 

static void makeSourcecodeFromDocFrag(const char *docfilename,
                                      const DocFragObj *docfragobj)
{
    Node node;
    char *ifilename;
    FILE *fp;

    if(docfragobj == NULL)
        return;

    node = getFirstNode(docfragobj->docfrag_list);
    while(node){
        DocFragObj *childdocfragobj = (DocFragObj *)getNodeData(node);
        if(childdocfragobj->sort & DOCFRAG_SRCELEM){
            ifilename = makeDocIfilename(docfilename, childdocfragobj->id);
            fp = spdFopen(ifilename, SPD_FOPEN_WT_MODE);
            fprintf(fp,"%s\n",childdocfragobj->srctext);
            spdFclose(fp);
            spdAddInfoString(srcfrag_info, SRCFRAGINFO_ATTR_IFILENAME, ifilename);
            spdAddInfoInt(srcfrag_info, SRCFRAGINFO_ATTR_OFFSET,
                          childdocfragobj->offset);
            if(verbose_mode)
                spdMessage("output file:%s\n",ifilename);
        } else if (childdocfragobj->sort & DOCFRAG_DOCELEM) {
            makeSourcecodeFromDocFrag(docfilename, childdocfragobj);
        }
        node=getNextNode(node);
    }
}

static void makeSourcecodeFromDocFile(const DocFileObj *docfileobj)
{
    Node node = getFirstNode(docfileobj->docfrag_list);

    while(node){
        DocFragObj *docfragobj = (DocFragObj *)getNodeData(node);
        makeSourcecodeFromDocFrag(docfileobj->name, docfragobj);
        node=getNextNode(node);
    }
}

void makeSourcecode(const DocObj *docobj)
{
    Node node = getFirstNode(docobj->docfile_list);

    while(node){
        DocFileObj *docfileobj = (DocFileObj *)getNodeData(node);
        srcfrag_info = spdOpenDSDBsrcfraginfo(docfileobj->name);
        makeSourcecodeFromDocFile(docfileobj);
        spdCloseInfo(srcfrag_info);
        node=getNextNode(node);
    }
}
