/* 
 * Program:             $RCSfile: textstring.c,v $  $Revision: 30.6 $
 * 
 * Purpose:             
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: textstring.c,v 30.6 2003/06/04 17:01:01 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/Dmodel.h>
#include "ddbin.h"
#include "textstring.h"

TextstringObj *addTextstringObj(const char *text, int offset)
{
    TextstringObj   *new;
    static int      textstringobj_num = SPD_OBJ_ID_OFFSET(SPD_CID_TEXTSTRING);

    new = (TextstringObj *)spdCalloc(1,sizeof(TextstringObj));
    new->id = textstringobj_num++;
    new->text = spdStrdup(text);
    new->offset = offset;
    insertLinklistFirst(textstringobj_list, new);
    return new;
}

void freeTextstringObjList(void)
{
    Linklist lst = textstringobj_list;
    Node node = getFirstNode(lst);

    while(node){
        TextstringObj *p = (TextstringObj *)getNodeData(node);
        spdFree(p->text);
        spdFree(p);
        node=getNextNode(node);
    }
    freeLinklist(lst);
}

#ifdef DOC_DEBUG

void printTextstringList(void)
{
    Node node = getFirstNode(textstringobj_list);

    while(node){
        TextstringObj *p = (TextstringObj *)getNodeData(node);
        printf("Textstring:\n");
        printf("  id:%d\n",p->id);
        printf("  text:%s\n",p->text);
        printf("  offset:%d\n",p->offset);
        node=getNextNode(node);
        printf("\n");
    }
}

#endif /* DOC_DEBUG */
