/*
 * Program:             $RCSfile: docident.c,v $  $Revision: 30.5 $
 *
 * Purpose:
 *
 * Author:              S.Kawai  1995/10/01
 *                      S.Yamamoto  1996/06/02
 * Modified:            R.Miura  1998/07/05
 *
 * (C) Copyright:       S.Kawai, R.Miura and S.Yamamoto  1995 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: docident.c,v 30.5 2003/06/28 15:33:38 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "docident.h"
#include "ISDB.h"

/* docident̾󤻤뤿Υϥåơ֥롥 */
static GlobalTable  docident_map[HASH_SIZE];

/* 
 * identifierϥåơ֥ɲä롥
 */

void push_docident_table(SpdId id, const char *name)
{
    GlobalTable     new;

    new = spdMalloc(sizeof(struct _global_table));
    new->id = id;

    /* !! add_new_object()ơʣ̤줿ΰȤ褦ˤ */
    new->name = spdStrdup(name);

    new->next = docident_map[(unsigned int)(*name)];
    docident_map[(unsigned int)(*name)] = new;
}

/* 
 * ϥåθԤϿѤǤФidʳSPD_NON_ID֤
 */

SpdId get_equal_docident(const char *name)
{
    GlobalTable     ptr;

    for (ptr = docident_map[(unsigned int)(*name)];
         ptr != NULL; ptr = ptr->next) {
        if (SPD_STREQ(name, ptr->name)) {
            return (ptr->id);
        }
    }
    return (SPD_NON_ID);
}

/* 
 * ϥå롥
 */

void free_docident_table(void)
{
    int         i;
    GlobalTable ptr, ptr_next;

    for (i = 0; i < HASH_SIZE; i++) {
        for (ptr = docident_map[i]; ptr != NULL; ptr = ptr_next) {
            ptr_next = ptr->next;
            spdFree(ptr->name);
            spdFree(ptr);
        }
    }
}
