/* 
 * Program:             $RCSfile: SrcFunc.c,v $  $Revision: 41.18 $
 * 
 * Purpose:             
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: SrcFunc.c,v 41.18 2003/07/13 09:17:29 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "chkDoc.h"
#include "SrcElem.h"
#include "SrcFunc.h"
#include "funcinfo.h"

#ifdef DEBUG
void printFuncdefInfo(SpdObjId id);
#endif

SpdObjIdArray docfragid_array = SPD_EMPTY_ARRAY;

FuncInfoArray ValidFuncArray = EMPTY_FI_ARRAY;
FuncInfoArray ExistFuncArray = EMPTY_FI_ARRAY;
FuncInfoArray NoDocFuncArray = EMPTY_FI_ARRAY;
FuncInfoArray InvalidFuncTypeArray = EMPTY_FI_ARRAY;
FuncInfoArray InvalidArgNumArray = EMPTY_FI_ARRAY;
FuncInfoArray InvalidArgTypeArray = EMPTY_FI_ARRAY;
FuncInfoArray InvalidArgNameArray = EMPTY_FI_ARRAY;
FuncInfoArray NotExistFuncArray = EMPTY_FI_ARRAY;

/* ɥȤ¸ߤؿˤ¸ߤ뤫ɤĴ٤롥
   ¸ߤTRUE¸ߤʤFALSE֤ */

SpdBoolean isDocfragIdinArray(SpdObjId id)
{
    int i;
    
    for (i = 0; i < docfragid_array.size; i++)
        if(docfragid_array.id[i] == id)
            return TRUE;
    return FALSE;
}

/* ɥȤΥץҤdeclId */

SpdObjId getDocDeclId(SpdObjId docfragId)
{
    SpdObjId childDocfragId, declId;
    SpdCursor *docfragCsr;
    
    docfragCsr = spdGetRelObjInit(docfragId,"docelem_docfrag","docelem_id");
    while ((childDocfragId = spdGetObjId(docfragCsr)) != SPD_NON_ID) {
        if (spdGetAttrValInt(childDocfragId, "sort") == DOCFRAG_SRCELEM) {
            declId = spdGetARelObj(childDocfragId, "srcelem_srcfrag", "srcelem_id");
            spdFreeCursor(docfragCsr);
            return declId;
        } else if (spdGetAttrValInt(childDocfragId, "sort") == DOCFRAG_DOCELEM) {
            return (getDocDeclId(childDocfragId));
        }
    }
    spdFreeCursor(docfragCsr);
    return SPD_NON_ID;
}

void setFuncInfointoArraySub(FuncInfoArray *fiArray, FuncInfo fi)
{
    fiArray->fi = spdRealloc(fiArray->fi, sizeof(FuncInfo) * (fiArray->size + 1));
    fiArray->fi[fiArray->size] = fi;
    fiArray->size++;
}

void setFuncInfointoArray(FuncInfo fi)
{
    /* δؿɥȤˤ뤫Ĵ٤ʤƤ
     * 
     */
    if (fi.status == STATUS_NOFUNC){
        setFuncInfointoArraySub(&NoDocFuncArray, fi);
    } else if (!flag_f.detail && (fi.status == STATUS_EXISTFUNC)) {
        setFuncInfointoArraySub(&ExistFuncArray, fi);
    } else {
        if(fi.status&STATUS_INVALID_FUNCTYPE)
            setFuncInfointoArraySub(&InvalidFuncTypeArray, fi);
        else if(fi.status&STATUS_INVALID_ARGNUM)
            setFuncInfointoArraySub(&InvalidArgNumArray, fi);
        else if(fi.status&STATUS_INVALID_ARGTYPE)
            setFuncInfointoArraySub(&InvalidArgTypeArray, fi);
        else if(fi.status&STATUS_INVALID_ARGNAME)
            setFuncInfointoArraySub(&InvalidArgNameArray, fi);
        else
            setFuncInfointoArraySub(&ValidFuncArray, fi);
    }
}

void spdDocfragIdintoArray(SpdObjId id)
{
    docfragid_array.id = spdRealloc(docfragid_array.id, 
                                    sizeof(SpdObjId) * (docfragid_array.size + 1));
    docfragid_array.id[docfragid_array.size] = id;
    docfragid_array.size++;
}

void checkFuncInDoc(FuncInfo *fi)
{
    SpdObjId id, srcelemId;

    id = spdGetARelObj(fi->src.decl_id, "decl_decl", "declaration_id");
    id = spdGetARelObj(id, "decl_ident", "declarator_id");
    id = spdGetARelObj(id, "docident_identifier", "identifier_id");
    id = spdGetARelObj(id, "defelem_docident", "docident_id");
    
    fi->docfrag_id = id;
    if (id != SPD_NON_ID) {
        spdDocfragIdintoArray(id);
    }
    
    /* δؿɥȤˤ뤫Ĵ٤ʤȤ
     * ɥȤˤʤΤϥȤʤ
     */
    if (flag_f.src || (!flag_f.src && id != SPD_NON_ID)) {
        func_num++;                         /* count function num*/
    }
        
    if (id == SPD_NON_ID) {
        fi->status = STATUS_NOFUNC;
        putMessage(&(fi->message), "No Document.\n");
        no_doc++;                           /* count */
    } else {
        srcelemId = getSrcElemId(fi->docfrag_id);
        id = spdGetARelObj(srcelemId, "srcelem_srcfrag", "srcelem_id");

        if (id == SPD_NON_ID) {
            /* 뤳ȤϤʤ */
            /*spdErrorExit("chkFuncInDoc(): Invalid obj Id %d.", id);*/
            spdWarning("chkFuncInDoc(): Invalid obj Id %d.\n", srcelemId);
            spdWarning("                Function Name %s \n",fi->src.funcname);
            fi->status = STATUS_NOFUNC;
            putMessage(&(fi->message), "No Document.\n");
            no_doc++;                       /* count */
        } else {
            fi->doc = getFuncSet(id);
            fi->status = STATUS_EXISTFUNC;
            if (!flag_f.detail) {
                putMessage(&(fi->message), "Exist.\n");
                exist_func++;
            }
        }
    }
}

void checkFuncDetail(FuncInfo *fi)
{    
    int         invalid = 0;
    
    /* ؿηå */
    if(strcmp(fi->doc.functype, fi->src.functype)){
        if (!flag_w) {
            /* ƤΥ顼λ Warning! ɽ */
            flag_w = TRUE;
            putMessage(&(fi->message), "Warning! <BR />\n");
        }
        fi->status |= STATUS_INVALID_FUNCTYPE;
        putMessage(&(fi->message),"Invalid FuncType. \"%s\" <--> \"%s\"<BR />\n",
                   fi->src.functype, fi->doc.functype);
        invalid_func_type++;                /* count */
        invalid++;
    }

    if(fi->doc.arg_num != fi->src.arg_num){
        /* ο㤦 */
        if (!flag_w){
            /* ƤΥ顼λ Warning! ɽ */
            flag_w = TRUE;
            putMessage(&(fi->message), "Warning! <BR />\n");
        }
        fi->status |= STATUS_INVALID_ARGNUM;
        putMessage(&(fi->message), "Invalid ArgNum. %d <--> %d<BR />\n",
                   fi->src.arg_num, fi->doc.arg_num);
        invalid_arg_num++;                  /* count */
        invalid++;
    }else{
        /*η̾å*/
        int     i;

        for(i = 0; i < fi->src.arg_num; i++){
            if(strcmp(fi->doc.argtype[i], fi->src.argtype[i])){
                /* οƱǤ⡤type㤦 */
                if (!flag_w) {
                    /* ƤΥ顼λ Warning! ɽ */
                    flag_w = TRUE;
                    putMessage(&(fi->message), "Warning! <BR />\n");
                }
                fi->status |= STATUS_INVALID_ARGTYPE;
                putMessage(&(fi->message),
                           "Invalid Arg-%d Type. \"%s\" <--> \"%s\"<BR />\n",
                           i + 1, fi->src.argtype[i], fi->doc.argtype[i]);
                invalid_arg_type++;         /* count */
                invalid++;
            }
            if(strcmp(fi->doc.argname[i], fi->src.argname[i])){
                /* οƱǤ⡤name㤦 */
                if (!flag_w) {
                    /* ƤΥ顼λ Warning! ɽ */
                    flag_w = TRUE;
                    putMessage(&(fi->message), "Warning! <BR />\n");
                }                
                fi->status|=STATUS_INVALID_ARGNAME;
                putMessage(&(fi->message),"Invalid Arg-%d Name. \"%s\" <--> \"%s\"<BR />\n", i+1,
                           fi->src.argname[i], fi->doc.argname[i]);
                invalid_arg_name++;         /* count */
                invalid++;
            }
        }
    }
    if (!flag_w) {
        /* ٹ1ĤʤOKɽ롥 */
        putMessage(&(fi->message), "OK\n");
        valid_func++;
    }
    if (invalid) {
        invalid_func++;                     /* count */
    }

    /* 
     * 
     * DOCSTATUS_FUNCEXIST (& DOCSTATUS_INVALID_FUNCTYPE)
     * 
     * ηϤ٤̾㤦interfacewarnnig?
     * DOCSTATUS_FUNCEXIST & DOCSTATUS_INVALID_ARGNAME
     * 
     * η˴ְäʪ,뤤ϰο㤦(interface)
     * DOCSTATUS_FUNCEXIST & DOCSTATUS_INVALID_ARGTYPE
     * (ξ硤argname򸫤Ƥ⤷礦ʤ)
     */
}

void checkFuncInSrc(void)
{
    SpdCursor *docfileCsr, *docelemCsr;
    SpdObjId declId, decrId, docfileId, docfragId, docelemId;
    
    docfileCsr = spdGetObjIdInit("docfile", NULL);
    while((docfileId=spdGetObjId(docfileCsr)) != SPD_NON_ID) {
        docfragId = spdGetARelObj(docfileId, "docfile_docfrag", "docfile_id");
        
        docelemCsr = spdGetRelObjInit(docfragId,"docelem_docfrag","docelem_id");
        while((docelemId=spdGetRelObj(docelemCsr)) != SPD_NON_ID) {
            if(spdGetAttrValInt(docelemId, "sort") == DOCFRAG_DEFELEM) {
                if(!isDocfragIdinArray(docelemId)) {
                    declId = getDocDeclId(docelemId);
                    if(declId != SPD_NON_ID) {
                        decrId = spdGetARelObj(declId, "decl_decl", "declaration_id");
                        if (spdGetAttrValInt(decrId, "sort") == DECL_PROTOTYPE ||
                            spdGetAttrValInt(decrId, "sort") == DECL_FUNCDEF) {
                            FuncInfo NotExist_fi = EMPTY_FI;
                            NotExist_fi.docfrag_id = docelemId;
                            NotExist_fi.status = STATUS_NOSRC;
                            putMessage(&(NotExist_fi.message), "Not Exist.\n");
                            NotExist_fi.doc = getFuncSet(declId);
                            setFuncInfointoArraySub(&NotExistFuncArray, NotExist_fi);
                            /*freeFuncInfo(fi);*/
                            /*printNoFuncHtml(fp,docelemId);*/
                            no_func++;
                        }
                    }
                }
            }
        }
        spdFreeCursor(docelemCsr);
    }
    spdFreeCursor(docfileCsr);
}

void checkSrcProgramFuncdef(void)
{
    SpdCursor *fileCsr, *declCsr;
    SpdObjId fileId, declId;
    FuncInfo fi;

    fileCsr = spdGetObjIdInit("file", NULL);
    if(fileCsr == NULL)
        return;
    while((fileId = spdGetObjId(fileCsr)) != SPD_NON_ID) {
        declCsr = spdGetRelObjInit(fileId, "file_decl", "file_id");
        while((declId=spdGetRelObj(declCsr)) != SPD_NON_ID) {
            if(spdGetAttrValInt(declId, "sort") == DECL_FUNCDEF) {
                if (spdGetAttrValInt(declId, "storage") == STORAGE_STATIC) {
                    continue;
                }
                /* fprintf(stderr, "%d\n",declId); */
                fi = getFuncInfo(declId);
                checkFuncInDoc(&fi);
                if (flag_f.detail && (fi.status == STATUS_EXISTFUNC)) { 
                    checkFuncDetail(&fi);
                }
                setFuncInfointoArray(fi);
                /* printFuncInfoHtml(fp, fi, fi_doc); */
                /* freeFuncInfo(fi);*/
                /* freeFuncInfo(fi_doc); */
                flag_w = FALSE;             /* flag_w ν */
            }
        }
        spdFreeCursor(declCsr);
    }
    spdFreeCursor(fileCsr);

    if (flag_f.doc) {
        checkFuncInSrc();
    }
    
}

#ifdef DEBUG

void printFuncdefInfo(SpdObjId id)
{
    printf("%d:", id);
    printf("%s\n\n\n", spdStr(id));
}

#endif /* #ifdef DEBUG */
