/* 
 * Program:             $RCSfile: SrcType.c,v $  $Revision: 41.17 $
 * 
 * Purpose:             
 * 
 * Author:              K.Toita  2000/07/06
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       K.Toita and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: SrcType.c,v 41.17 2003/07/13 09:17:29 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <stdarg.h>
#include <Sapid/Sapid.h>
#include <Sapid/ImodelARcompat.h>
#include <Sapid/PmodelAR.h>
#include <Sapid/SpdStr.h>
#include "chkDoc.h"
#include "SrcElem.h"
#include "SrcType.h"
#include "funcinfo.h"

TypeInfoArray ValidTypeArray = EMPTY_TI_ARRAY;
TypeInfoArray ExistTypeArray = EMPTY_TI_ARRAY;
TypeInfoArray NoDocTypeArray = EMPTY_TI_ARRAY;
TypeInfoArray InvalidDefineTypeArray = EMPTY_TI_ARRAY;
TypeInfoArray InvalidStructMemberNumArray = EMPTY_TI_ARRAY;
TypeInfoArray InvalidStructMemberTypeArray = EMPTY_TI_ARRAY;
TypeInfoArray InvalidStructMemberNameArray = EMPTY_TI_ARRAY;
TypeInfoArray NotExistTypeArray = EMPTY_TI_ARRAY;

TypeInfoArray ValidUnionArray = EMPTY_TI_ARRAY;
TypeInfoArray ExistUnionArray = EMPTY_TI_ARRAY;
TypeInfoArray NoDocUnionArray = EMPTY_TI_ARRAY;
TypeInfoArray InvalidUnionMemberNumArray = EMPTY_TI_ARRAY;
TypeInfoArray InvalidUnionMemberTypeArray = EMPTY_TI_ARRAY;
TypeInfoArray InvalidUnionMemberNameArray = EMPTY_TI_ARRAY;
TypeInfoArray NotExistUnionArray = EMPTY_TI_ARRAY;

/* ǤˤdeclarationIdϥåƤ뤫Ĵ٤ */
SpdBoolean is_declIdinArray(SpdObjId id)
{
    int i;

    for (i = 0; i < declIdArray.size; i++) {
        if (id == declIdArray.id[i]) return TRUE;
    }
    return FALSE;
}

void spdDeclarationIdintoArray(SpdObjId id)
{
    declIdArray.id = spdRealloc(declIdArray.id, 
                                 sizeof(SpdObjId) * (declIdArray.size + 1));
    declIdArray.id[declIdArray.size] = id;
    declIdArray.size++;
}

void freeDeclIdArray(void)
{
    spdFree(declIdArray.id);
    declIdArray.id = NULL;
    declIdArray.size = 0;
}

/*  occ  system ե줿ΤɤĴ٤  */

SpdBoolean is_system(SpdOcc decl)
{
    SpdObjId block_id;
    SpdObjId pfile_id;
    
    block_id = spdGetABlockId(decl.fileId, decl.offset);
    pfile_id = spdGetARelObj(block_id, "file_block", "c-id");

    return (smuIsSystemFile(pfile_id));
}

void setTypeInfointoArraySub(TypeInfoArray *tiArray, TypeInfo ti)
{
    tiArray->ti = spdRealloc(tiArray->ti,
			     sizeof(TypeInfo) * (tiArray->size + 1));
    tiArray->ti[tiArray->size] = ti;
    tiArray->size++;
}

void setStructTypeInfointoArray(TypeInfo ti)
{
    /* ηɥȤˤ뤫Ĵ٤ʤƤ
     * 
     */
    if(ti.status == STATUS_NOTYPE){
        setTypeInfointoArraySub(&NoDocTypeArray, ti);
    } else if (!flag_t.detail && (ti.status == STATUS_EXISTTYPE)) {
        setTypeInfointoArraySub(&ExistTypeArray, ti);
    } else {
        if(ti.status&STATUS_INVALID_TYPE)
            setTypeInfointoArraySub(&InvalidDefineTypeArray, ti);
        else if(ti.status&STATUS_INVALID_MEMBER_NUM)
            setTypeInfointoArraySub(&InvalidStructMemberNumArray, ti);
        else if(ti.status&STATUS_INVALID_MEMBER_TYPE)
            setTypeInfointoArraySub(&InvalidStructMemberTypeArray, ti);
        else if(ti.status&STATUS_INVALID_MEMBER_NAME)
            setTypeInfointoArraySub(&InvalidStructMemberNameArray, ti);
        else
            setTypeInfointoArraySub(&ValidTypeArray, ti);
    }
}

void setUnionTypeInfointoArray(TypeInfo ti)
{
    if(ti.status == STATUS_NOUNION){
        setTypeInfointoArraySub(&NoDocUnionArray, ti);
    } else if (!flag_u.detail && (ti.status == STATUS_EXISTUNION)) {
        setTypeInfointoArraySub(&ExistUnionArray, ti);
    }else{
        if(ti.status&STATUS_INVALID_MEMBER_NUM)
            setTypeInfointoArraySub(&InvalidUnionMemberNumArray, ti);
        else if(ti.status&STATUS_INVALID_MEMBER_TYPE)
            setTypeInfointoArraySub(&InvalidUnionMemberTypeArray, ti);
        else if(ti.status&STATUS_INVALID_MEMBER_NAME)
            setTypeInfointoArraySub(&InvalidUnionMemberNameArray, ti);
        else
            setTypeInfointoArraySub(&ValidUnionArray, ti);
    }
}

/* η */

SpdString getType(SpdObjId decr_id)
{
    SpdString str;
    static char name[BUF_MAX];
    SpdObjId type_id;

    type_id = spdGetARelObj(decr_id, "decr_type", "declarator_id");
    str = spdStr(type_id);
    if (str) {
        strcpy(name, str);
        spdStrFree();
        return name;
    } else {
        return "";
    }
}

/* Фη */

SpdString getMemberTypename(SpdObjId decl_id)
{
    SpdString str;
    static char typename[BUF_MAX];
    SpdObjId id;
    id = spdGetARelObj(decl_id, "decl_decl", "declaration_id");
    id = spdGetARelObj(id, "decr_type", "declarator_id");
    str = spdStr(id);
    if(str) {
        strcpy(typename, str);
        spdStrFree();
        return typename;
    } else {
        return "";
    }
}

void freeTypeSet(TypeSet tset)
{
    int i;
    spdFree(tset.typename);
    spdFree(tset.type);

    for(i=0;i<tset.member_num;i++){
        spdFree(tset.member_type[i]);
        spdFree(tset.member_name[i]);
    }
    spdFree(tset.member_type);
    spdFree(tset.member_name);
}

void freeTypeInfo(TypeInfo ti)
{
    freeTypeSet(ti.src);
    freeTypeSet(ti.doc);
    if(ti.message){
        spdFree(ti.message);
    }
}
/* DEBUG */

void printTypeSet(TypeSet tset)
{
    int i;

    printf("id:%d\n",tset.decr_id);
    printf("type name:%s\n",tset.typename);
    printf("type:%s\n",tset.type);
    for(i = 0; i < tset.member_num; i++) {
        printf("member type: %s name:%s\n", 
	       tset.member_type[i], tset.member_name[i]);
    }
}

/* DEBUG */

void printTypeInfo(TypeInfo ti)
{
    printTypeSet(ti.src);
    printTypeSet(ti.doc);
}

TypeSet getTypeSet(SpdObjId declId)
{
    SpdObjId decrId, identId, optId;
    SpdCursor *decrCsr;
    TypeSet tset = EMPTY_TS;
    int i;
    
    tset.decl_id = declId;
    decrCsr = spdGetRelObjInit(declId, "decl_decl", "declaration_id");
    while((decrId = spdGetRelObj(decrCsr)) != SPD_NON_ID) {
        if(spdGetAttrValInt(decrId, "sort") == DECL_TYPE) {
            /* typedef struct ... { } ***; ***
                * typedef int ***; ***Ф
                    */
            /* ***ʣϡ */
            if(tset.decr_id != SPD_NON_ID) {
                /* ̤б */
            } else {
                tset.decr_id = decrId;
                identId = spdGetARelObj(decrId, "decl_ident", "declarator_id");
                tset.typename = spdStrdup(spdGetName(identId));
                tset.type = spdStrdup(getType(decrId));
            }
        }else if(spdGetAttrValInt(decrId, "sort") == DECL_TAG) {
            /* struct ... { } ʬФ */
            optId = spdGetARelObj(decrId, "decl_opt", "declarator_id");
            tset.memberrels = spdGetRelSortedArray(optId, "struct_decl", "optionaldecl_id",
                                                   NULL, spdCompareRelOffset);

            tset.member_num = tset.memberrels.size;
            
            tset.member_type = (char **)spdMalloc(sizeof(char *)*(tset.member_num));
            tset.member_name = (char **)spdMalloc(sizeof(char *)*(tset.member_num));
            for(i = 0; i < tset.memberrels.size; i++) {
                tset.member_type[i] = spdStrdup(getMemberTypename(tset.memberrels.rel[i].objectId));
                tset.member_name[i] = spdStrdup(getName(tset.memberrels.rel[i].objectId));
                /* getName(SpdObjId)  funcinfo.c ¸ߤ */
            }
            /* structstruct̤б */
        }
    }
    return tset;
}

TypeInfo getTypeInfo(SpdObjId declId)
{
    SpdObjId typeId;
    TypeInfo ti = EMPTY_TI;
    
    ti.pfile_id = getpfileId(declId);
    ti.src = getTypeSet(declId);

    typeId = spdGetARelObj(declId, "decl_type", "declaration_id");
    ti.sort = spdGetAttrValInt(typeId, "sort");
    return ti;
}

void checkTypeInDoc(TypeInfo *ti)
{
    SpdObjId id, identId, docidentId, defelemId, decrId;

    identId = spdGetARelObj(ti->src.decr_id, "decl_ident", "declarator_id");
    docidentId = spdGetARelObj(identId, "docident_identifier", "identifier_id");
    defelemId = spdGetARelObj(docidentId, "defelem_docident", "docident_id");
    
    ti->docfrag_id = defelemId;
    
    /* ηɥȤˤ뤫Ĵ٤ʤȤ
     * ɥȤˤʤΤϥȤʤ
     */
    if (ti->sort == TYPE_UNION_TAG) {
        if (flag_u.src || (!flag_u.src && ti->docfrag_id != SPD_NON_ID)) {
            union_num++;
        }
    } else {
        if (flag_t.src || (!flag_t.src && ti->docfrag_id != SPD_NON_ID)) {
            type_num++;
        }
    }

    if(defelemId == SPD_NON_ID){
        if (ti->sort == TYPE_UNION_TAG) {
            ti->status = STATUS_NOUNION;
            union_no_doc++;
        } else {
            ti->status = STATUS_NOTYPE;
            type_no_doc++;
        }
        putMessage(&(ti->message), "No Document.\n");
    } else {
        id = getSrcElemId(defelemId);
        id = spdGetARelObj(id, "srcelem_srcfrag", "srcelem_id");
        
        if (id == SPD_NON_ID) {
            if (ti->sort == TYPE_UNION_TAG) {
                ti->status = STATUS_NOUNION;
                union_no_doc++;
            } else {
                ti->status = STATUS_NOTYPE;
                type_no_doc++;
            }
            putMessage(&(ti->message), "No Document.\n");
        } else {
            if (ti->sort != TYPE_UNION_TAG) {
                ti->status = STATUS_EXISTTYPE;
            } else {
                ti->status = STATUS_EXISTUNION;
            }

            ti->doc = getTypeSet(id);
            
            decrId = spdGetARelObj(ti->doc.decl_id, "decl_decl", "declaration_id");  

            if (ti->sort == TYPE_DECLARATION || ti->sort == TYPE_TYPE_DEF) {
                ti->doc.type =  spdStrdup(getType(decrId));
            } else {
                /* struct union Υ̾ȤʤΤǡԡ */
                ti->doc.type = spdStrdup(ti->src.type);
            }
    
            /* ̾ϤȤʤΤǡԡƤ */ 
            ti->doc.typename = spdStrdup(ti->src.typename);
            if (!flag_t.detail && (ti->sort != TYPE_UNION_TAG)) {
                putMessage(&(ti->message), "Exist.\n");
                exist_type++;
            } else if (!flag_u.detail && (ti->sort == TYPE_UNION_TAG)) {
                putMessage(&(ti->message), "Exist.\n");
                exist_union++;
            }
        }
    }
}

void checkTypeDetail(TypeInfo *ti)
{
    int invalid = 0;
    /* printTypeSet(ti->doc); */

    /* ηå */
    if ((ti->sort == TYPE_DECLARATION || ti->sort == TYPE_TYPE_DEF) &&
        strcmp(ti->doc.type, ti->src.type)) {
        if(!flag_w){
	    /* ƤΥ顼λ Warning! ɽ */
            flag_w = TRUE;
            putMessage(&(ti->message), "Warning! <BR />\n");
        }
        ti->status |= STATUS_INVALID_TYPE;
        putMessage(&(ti->message),"Invalid Type. \"%s\" <--> \"%s\"<BR />\n",
                   ti->src.type, ti->doc.type);
        invalid_type_type++;                /* count */
        invalid++;
    }
    if (ti->doc.member_num != ti->src.member_num) {
        /* Фο㤦 */
        if (!flag_w) {
	    /* ƤΥ顼λ Warning! ɽ */
            flag_w = TRUE;
            putMessage(&(ti->message), "Warning! <BR />\n");
        }
        ti->status |= STATUS_INVALID_MEMBER_NUM;
        putMessage(&(ti->message), "Invalid MemberNum. %d <--> %d<BR />\n",
                   ti->src.member_num, ti->doc.member_num);
        if (ti->sort == TYPE_STRUCT_TAG) {
            invalid_struct_member_num++;    /* count */
        } else {
            invalid_union_member_num++;
        }
        invalid++;
    } else {
        /* Фη̾å */
        int i;
        for(i = 0; i < ti->src.member_num; i++){
            if(strcmp(ti->doc.member_type[i], ti->src.member_type[i])){
                /* ФοƱǤ⡤type㤦 */
                if (!flag_w) {
                    /* ƤΥ顼λ Warning! ɽ */
                    flag_w = TRUE;
                    putMessage(&(ti->message), "Warning! \n <BR />");
                }
                ti->status |= STATUS_INVALID_MEMBER_TYPE;
                putMessage(&(ti->message),"Invalid Member-%d Type. \"%s\" <--> \"%s\"<BR />\n", i+1,
                           ti->src.member_type[i], ti->doc.member_type[i]);
                if (ti->sort == TYPE_STRUCT_TAG) {      
                    invalid_struct_member_type++; /* count */
                } else {
                    invalid_union_member_type++;
                }
                invalid++;
            }
            if (strcmp(ti->doc.member_name[i], ti->src.member_name[i])) {
                /* ФοƱǤ⡤name㤦 */
                if (!flag_w) {
                    /* ƤΥ顼λ Warning! ɽ */
                    flag_w = TRUE;
                    putMessage(&(ti->message), "Warning! <BR />\n");
                }                
                ti->status|=STATUS_INVALID_MEMBER_NAME;
                putMessage(&(ti->message),"Invalid Member-%d Name. \"%s\" <--> \"%s\"<BR />\n",
                           i+1, ti->src.member_name[i], ti->doc.member_name[i]);
                if (ti->sort == TYPE_STRUCT_TAG) {
                    invalid_struct_member_name++; /* count */
                } else {
                    invalid_union_member_name++;
                }
                invalid++;
            }
        }
    }
    if (!flag_w) {
        putMessage(&(ti->message), "OK\n"); /* ٹ1Ĥʤ OK ɽ */
        if (ti->sort == TYPE_UNION_TAG) {
            valid_union++;
        } else {
            valid_type++;
        }
    }
    if (invalid) {
        if (ti->sort == TYPE_UNION_TAG) {
            invalid_union++;
        } else {
            invalid_type++;
        }
    }
}

void getTypedef(SpdObjId fileId)
{
    SpdRelArray decls;
    SpdCursor *csr;
    SpdOcc occ;
    TypeInfo ti;
    int storage, i;

    decls = spdGetRelArray(fileId, "file_decl", "p-id", NULL);
    
    for (i = 0; i < decls.size; i++) {
        storage = spdGetAttrValInt(decls.rel[i].objectId, "storage");
        if (storage == STORAGE_TYPEDEF) {
            csr = spdGetOffsetOfObjInit(decls.rel[i].objectId);
            occ = spdGetOffsetOfObj(csr);
            if (!is_system(occ)) { 
                /* system ե typedef ǤʤȤå */
                if (!is_declIdinArray(decls.rel[i].objectId)) {
                     /* ޤåƤʤIdλå */
                    /* printf("%d\n",decls.rel[i].objectId); */

                    /* ٥åʤ褦ϿƤ */
                    spdDeclarationIdintoArray(decls.rel[i].objectId);

                    ti = getTypeInfo(decls.rel[i].objectId);
                    checkTypeInDoc(&ti);
                    if ((flag_t.detail && (ti.status == STATUS_EXISTTYPE)) ||
                        (flag_u.detail && (ti.status == STATUS_EXISTUNION))) {
                        checkTypeDetail(&ti);
                    }
                    if (ti.sort == TYPE_UNION_TAG) {
                        setUnionTypeInfointoArray(ti);
                    } else {
                        setStructTypeInfointoArray(ti);
                    }
                    /* printTypeInfoHtml(fp, ti, ti_doc); */
                    flag_w = FALSE;         /* flag_w ν */
                }
            }
            spdFreeCursor(csr);
        }
    }
    spdFreeRelArray(decls);
}

void checkSrcProgramTypedef(void)
{
    SpdObjIdArray file_buf;
    SpdObjId progId;
    int i;

    progId = spdGetAnObjId("program",  NULL);
    file_buf = spdGetRelObjSortedArray(progId, "prog_file", "p-id", NULL,
                                       spdCompareObjIdName);
    for (i = 0; i < file_buf.size; i++) {
        getTypedef(file_buf.id[i]);
    }
    spdFreeObjIdArray(file_buf);
    freeDeclIdArray();
}
