/* 
 * Program:             $RCSfile: chkDoc.c,v $  $Revision: 41.26 $
 * 
 * Purpose:             
 * 
 * Author:              K.Toita  2000/07/06
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       K.Toita and S.Yamamoto  2000 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: chkDoc.c,v 41.26 2003/06/08 02:43:36 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/ImodelAR.h>
#include <Sapid/ImodelARcompat.h>
#include "chkDoc.h"
#include "chkFile.h"
#include "SrcFunc.h"
#include "SrcType.h"
#include "chkEnum.h"
#include "putScript.h"
#include "putHtml.h"
#include "modFunc.h"
#include "modType.h"
#include "modMacro.h"
#include "getInfo.h"

int func_num = 0;
int no_doc = 0;
int no_func = 0;
int exist_func = 0;
int valid_func = 0;
int invalid_func = 0;
int invalid_func_type = 0;
int invalid_arg_num = 0;
int invalid_arg_type = 0;
int invalid_arg_name = 0;

int type_num = 0;
int type_no_doc = 0;
int no_type = 0;
int exist_type = 0;
int valid_type = 0;
int invalid_type = 0;
int invalid_type_type = 0;
int invalid_struct_member_num = 0;
int invalid_struct_member_type = 0;
int invalid_struct_member_name = 0;

int union_num = 0;
int union_no_doc = 0;
int no_union = 0;
int exist_union = 0;
int valid_union = 0;
int invalid_union = 0;
int invalid_union_member_num = 0;
int invalid_union_member_type = 0;
int invalid_union_member_name = 0;

int macro_num = 0;
int macro_no_doc = 0;
int no_macro = 0;
int exist_macro = 0;
int valid_macro = 0;
int invalid_macro = 0;
int invalid_value = 0;
int invalid_macro_arg_num = 0;
int invalid_macro_arg_name = 0;

int enum_num = 0;
int enum_no_doc = 0;
int no_enum = 0;
int exist_enum = 0;
int valid_enum = 0;
int invalid_enum = 0;
int invalid_enum_num = 0;
int invalid_enum_name = 0;
int invalid_enum_value = 0;

int file_num = 0;
int exist_file = 0;
int no_doc_file = 0;
int no_file = 0;

Flag flag_f = INIT_FLAG;     /* functioncheckԤݤ */
Flag flag_t = INIT_FLAG;     /* typecheckԤݤ */
Flag flag_u = INIT_FLAG;     /* unionbcheckԤݤ */
Flag flag_m = INIT_FLAG;     /* MacrocheckԤݤ */
Flag flag_e = INIT_FLAG;     /* EnumcheckԤݤ */
Flag flag_file =INIT_FLAG;   /* FilecheckԤݤ */

int flag_p = FALSE;     /* ܺ٥ե졼Υȥݤ */
int flag_s = FALSE;
int flag_w = FALSE;     /* ٹ(SrcFunc.cSrcType.cǻѤ) */

ModFuncFlag modflag_f = {NON_MODIFY, FALSE, FALSE, FALSE, FALSE};
ModTypeFlag modflag_t = {NON_MODIFY, FALSE, FALSE, FALSE, FALSE};
ModUnionFlag modflag_u = {NON_MODIFY, FALSE, FALSE, FALSE};
ModMacroFlag modflag_m = {NON_MODIFY, FALSE, FALSE};

char *htmldir;
char *srcdir;
char *docdir;

SpdObjIdArray pfileIdArray = SPD_EMPTY_ARRAY;
SpdObjIdArray declIdArray = SPD_EMPTY_ARRAY;

void putStyleSheet(void);

static void parse_option(int argc, char *argv[]);
static void printUsage(SpdConstString command_name);

/* å̤Ϥ롥 */

void putResult(void)
{
    if (flag_f.main) {
        printf("Function : %d\n",func_num);
        if (flag_f.detail) {
            printf("Valid Function : %d\n", valid_func);
            printf("Invalid Function : %d\n",invalid_func);
        } else {
            printf("Exist Function : %d\n", exist_func);
        }
        if (flag_f.src) {
            printf("No Doc : %d\n",no_doc);
        }
        if (flag_f.detail) {
            printf("Invalid Func Type : %d\n",invalid_func_type);
            printf("Invalid Arg  Num : %d\n",invalid_arg_num);
            printf("Invalid Arg  Type : %d\n",invalid_arg_type);
            printf("Invalid Arg  Name : %d\n",invalid_arg_name);
        }
        if (flag_f.doc) {
            printf("No Func : %d\n",no_func);
        }
        printf("\n");
    }
    if (flag_t.main) {
        printf("Type : %d\n",type_num);
        if (flag_t.detail) {
            printf("Valid Type : %d\n", valid_type);
            printf("Invalid Type : %d\n", invalid_type);
        } else {
            printf("Exist Type : %d\n", exist_type);
        }
        if (flag_t.src) {
            printf("No Doc : %d\n",type_no_doc);
        }
        if (flag_t.detail) {
            printf("Invalid Define Type : %d\n",invalid_type_type);
            printf("Invalid Member Num : %d\n",invalid_struct_member_num);
            printf("Invalid Member Type : %d\n",invalid_struct_member_type);
            printf("Invalid Member Name : %d\n",invalid_struct_member_name);
        }
        if (flag_t.doc) {
            printf("No Type : %d\n",no_type);
        }
        printf("\n");
    }
    if (flag_u.main) {
        printf("Union : %d\n",union_num);
        if (flag_u.detail) {
            printf("Valid Union : %d\n",valid_union);
            printf("Invalid Union : %d\n",invalid_union);
        } else {
            printf("Exist Union : %d\n", exist_union);
        }
        if (flag_u.src) {
            printf("No Doc : %d\n", union_no_doc);
        }
        if (flag_u.detail) {
            printf("Invalid Member Num : %d\n",invalid_union_member_num);
            printf("Invalid Member Type : %d\n",invalid_union_member_type);
            printf("Invalid Member Name : %d\n",invalid_union_member_name);
        }
        if (flag_u.doc) {
            printf("No Union : %d\n\n",no_union);
        }
    }
    if (flag_m.main) {
        printf("Macro : %d\n",macro_num);
        if (flag_m.detail) {
            printf("Valid Macro : %d\n",valid_macro);
            printf("Invalid Macro : %d\n",invalid_macro);
        } else {
            printf("Exist Macro : %d\n",exist_macro);
        }
        if (flag_m.src) {
            printf("No Doc : %d\n", macro_no_doc);
        }
        if (flag_m.detail) {
            printf("Invalid Arg Num : %d\n",invalid_macro_arg_num);
            printf("Invalid Arg Name : %d\n",invalid_macro_arg_name);
        }
        if (flag_m.doc) {
            printf("Not Exist : %d\n\n",no_macro);
        }
    }
    if (flag_e.main) {
        printf("Enum : %d\n",enum_num);
        if (flag_e.detail) {
            printf("Valid Enum : %d\n", valid_enum);
            printf("Invalid Enum : %d\n",invalid_enum);
        } else {
            printf("Exist Enum : %d\n", exist_enum);
        }
        if (flag_e.src) {
            printf("No Doc : %d\n",enum_no_doc);
        }
        if (flag_e.detail) {
            printf("Invalid Enum Num   : %d\n",invalid_enum_num);
            printf("Invalid Enum Name  : %d\n",invalid_enum_name);
            printf("Invalid Enum Value : %d\n",invalid_enum_value);
        }
        if (flag_e.doc) {
            printf("No Enum : %d\n",no_enum);
        }
        printf("\n");
    }
    if (flag_file.main) {
        printf("File : %d\n",file_num);
        printf("Exist File : %d\n",exist_file);
        if (flag_file.src) {
            printf("No Doc : %d\n",no_doc_file);
        }
        if (flag_file.doc) {
            printf("Not Exist : %d\n",no_file);
        }
    }
}

void setpfileIdintoArray(SpdObjId pfileId)
{
    pfileIdArray.id = spdRealloc(pfileIdArray.id, sizeof(SpdObjId) * (pfileIdArray.size + 1));
    pfileIdArray.id[pfileIdArray.size] = pfileId;
    pfileIdArray.size++;
}

SpdBoolean isPfileIdInArray(SpdObjId pfileId)
{
    int i;
    for(i = 0; i < pfileIdArray.size; i++) {
        if(smuGetFileIdByName((SpdString)spdGetName(pfileId)) ==
           smuGetFileIdByName((SpdString)spdGetName(pfileIdArray.id[i])))
            return TRUE;
    }
    return FALSE;
}

void getSrcpfileId(void)
{
    SpdObjId pfileId;
    SpdCursor *pfileCsr;

    pfileCsr = spdGetObjIdInit("pfile", NULL);
    while((pfileId = spdGetObjId(pfileCsr)) != SPD_NON_ID) {
        if(!smuIsSystemFile(pfileId) && !isPfileIdInArray(pfileId)) {
            /* pfileId = smuGetFileIdByName((SpdString)spdGetName(pfileId)); */
            setpfileIdintoArray(pfileId);
        }
    }
    spdFreeCursor(pfileCsr);
}

/* check ե̾ */

SpdString getCheckFileName(void)
{
    SpdString homeDir;
    SpdString checkFile;
    
    if ((homeDir = getenv("HOME")) == NULL) {
        spdErrorExit("\"HOME\" not found.\n");
    }
    checkFile = spdCatPath(homeDir, CHECK_FILE);

    return checkFile;
}

int main(int argc, char *argv[])
{
    SpdModelId      ImodelId, PmodelId, DmodelId;
    SpdDBId         dbId;
    SpdObjId        prog_id;
    SpdConstString  prog_name;
    char            *title_name;
    SpdString       checkFile;
    SpdInfo         *checkInfo;
    
    parse_option(argc, argv);
    argc -= optind;
    argv += optind;
  
    ImodelId = spdUseModel(&I_model);
    PmodelId = spdUseModel(&P_model);
    DmodelId = spdUseModel(&D_model);
    dbId = spdOpenSDB();
    spdReadDB(ImodelId, dbId);
    spdReadDB(DmodelId, dbId);
    spdReadDB(PmodelId, dbId);              /* type checkɬפȤʤ롥 */

    prog_id = spdGetAnObjId("program", NULL);
    prog_name = spdGetName(prog_id);
    title_name = spdStrdup(prog_name);      /* !! duplicateɬפϤʤ? */
    htmldir = mkDirectory(TOP_DIR, HTML_DIR); /* HTML ѤΥǥ쥯ȥ */
    srcdir = mkDirectory(TOP_DIR, SRC_DIR); /* src ѤΥǥ쥯ȥ */
    docdir = mkDirectory(TOP_DIR, DOC_DIR); /* doc ѤΥǥ쥯ȥ */

    /* check ե̾μ */
    checkFile = getCheckFileName();
        
    /* check եβ */
    if (spdIsFile(checkFile)) {
        checkInfo = spdChkDocOpenInfo(checkFile);
        setCheckFlag(checkInfo);
        if (modflag_f.main) {
            setModifyFlag(checkInfo);
        }
    } else {
        spdMessage("\"%s\" not found. Check all.\n", checkFile);
    }
    spdFree(checkFile);
    
    /* ƥեʳƤpfile_id롥 */
    getSrcpfileId();
    
    /* spdMessage("Analyzing...\n"); */
    if (flag_f.main) {
        /* printf("Function check.\n"); */
        checkSrcProgramFuncdef();
        putFuncDetailHtml(title_name, "Function");
        if (modflag_f.main != NON_MODIFY) {
            funcModify();
        }
    }
    if (flag_t.main) {
        /* printf("Type check.\n"); */
        checkSrcProgramTypedef();
        putTypeDetailHtml(title_name, "Type");
        if (modflag_t.main != NON_MODIFY) {
            typeModify();
        }
    }
    if (flag_u.main) {
        /* printf("Union check.\n"); */
        /* åchekcSrcProgramTypedefǴλ */
        putUnionDetailHtml(title_name, "Union");
        if (modflag_u.main != NON_MODIFY) {
            unionModify();
        }
    }
    if (flag_m.main) {
        /* printf("Macro check.\n"); */
        checkSrcProgramMacro();
        putMacroDetailHtml(title_name, "Macro");
        if (modflag_m.main != NON_MODIFY) {
            macroModify();
        }
    }
    if (flag_e.main) {
        /* printf("Enum check.\n"); */
        checkSrcProgramEnum();
        putEnumDetailHtml(title_name, "Enum");
    }
    if (flag_file.main) {
        /* printf("File check.\n"); */
        checkSrcFile();
        putFileDetailHtml(title_name, "File");
    }
    if (flag_s) {
        putScript();
    }
    putHtml(title_name);
    spdFree(title_name);
    putStyleSheet();
    putResult();

    /* SDBΥץȥɥȤƽϤ */
    putSrcProgram();
    putDocument();

    spdCloseSDB(dbId);

    return (EXIT_SUCCESS);
}

/* flagǥեͤ˥å */

static void setDefaultFlag(Flag *flag)
{
    flag->main = TRUE;
    flag->src = TRUE;
    flag->doc = TRUE;
    flag->detail = TRUE;
}

static void parse_option(int argc, char *argv[])
{
    int     ch;
    SpdConstString program_name;
    
    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);

    while ((ch = getopt(argc, argv, "d:ftumeFpsM:")) != -1) {
        switch (ch) {
          case 'd':                         /* Directory for SDB. */
            spdSetSDBdir(optarg);
            break;
          case 's':                         /* Put source script. */
            flag_s = TRUE;
            break;
          case 'f':
            setDefaultFlag(&flag_f);
            break;
          case 't':
            setDefaultFlag(&flag_t);
            break;
          case 'u':
            setDefaultFlag(&flag_t);        /* θǶΤԤΤɬ */
            setDefaultFlag(&flag_u);
            break;
          case 'm':
            setDefaultFlag(&flag_m);
            flag_m.src = FALSE;
            break;
          case 'e':
            setDefaultFlag(&flag_e);
            break;
          case 'F':
            setDefaultFlag(&flag_file);
            break;
          case 'p':
            flag_p = TRUE;
            break;
          case 'M':
            setDefaultModFuncFlag(&modflag_f, optarg);
            setDefaultModTypeFlag(&modflag_t, optarg);
            setDefaultModUnionFlag(&modflag_u, optarg);
            setDefaultModMacroFlag(&modflag_m, optarg);
            break;
          default:
            printUsage(program_name);
            break;
        }
    }
    /* Default. */
    if (!flag_f.main && !flag_t.main && !flag_u.main && !flag_m.main &&
        !flag_e.main && !flag_file.main) { 
        setDefaultFlag(&flag_f);
        setDefaultFlag(&flag_t);
        setDefaultFlag(&flag_u);
        setDefaultFlag(&flag_m);
        /* 
         * ǥեȤǤϡץΥޥ
         * եȥϢʸˤ뤫ݤʤ
         */
        flag_m.src = FALSE;
        setDefaultFlag(&flag_e);
        setDefaultFlag(&flag_file);
    }
}

static void printUsage(SpdConstString command_name)
{
    const char  *usageMessage =
        "\n"
        "NAME\n"
        "    %s\n"
        "SYNOPSIS\n"
        "    %s [options] \n"
        "DESCRIPTION\n"
        "    -d directory : Directory for SDB.\n"
        "    -f           : Execute function check.\n"
        "    -m           : Execute macro check.\n"
        "    -p           : Show detail frame title\n"
        "    -s           : Output source.\n"
        "    -t           : Execute type check.\n"
        "    -u           : Execute union check.\n"
        "    -F           : Execute file check.\n"
        "    -M (src|doc) : Execute modify Src or Doc.\n"
        "VERSION\n"
        "    %d.%d.%d\n";

    spdErrorExit(usageMessage,
                 command_name, command_name,
                 SapidVersion, SapidRevision, SapidPatchLevel);
}
