/* 
 * Program:             $RCSfile: chkDoc.h,v $  $Revision: 41.20 $
 * 
 * Purpose:             
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000 - 2002
 *                      This file is a product of the project Sapid.
 */

/* 
 * "$Id: chkDoc.h,v 41.20 2002/10/27 11:41:36 yamamoto Exp yamamoto $";
 */

#ifndef _SPD_CHK_DOC_H
#define _SPD_CHK_DOC_H

typedef struct _FuncSet {
    SpdObjId decl_id;
    char *funcname;
    char *functype;
    int arg_num;
    char **argname;
    char **argtype;
    SpdRelArray argrels; 
} FuncSet;

typedef struct _FuncInfo {
    SpdObjId pfile_id;
    SpdObjId docfrag_id;
    FuncSet src;
    FuncSet doc;
    char *message;
    int status;
} FuncInfo;

typedef struct _FuncInfoArray {
    int size;
    FuncInfo *fi;
} FuncInfoArray;

typedef struct _TypeSet {
    SpdObjId decl_id;
    SpdObjId decr_id;
    char *typename; /* ̾ */
    char *type; /* μ void, int ...*/
    int member_num; /* बstructλΥп */
    char **member_name; /* 줾ΥФ̾ */
    char **member_type; /* 줾ΥФη */
    SpdRelArray memberrels; 
} TypeSet;

typedef struct _TypeInfo {
    SpdObjId pfile_id;
    SpdObjId docfrag_id; /* ɥȤTypeInfoǻ */
    int sort; /* struct  union ΤɤǤ뤫򼨤 */
    TypeSet src;
    TypeSet doc;
    char *message;
    int status;
} TypeInfo;

typedef struct _TypeInfoArray {
    int size;
    TypeInfo *ti;
} TypeInfoArray;

typedef struct _MacroSet {
    char *name;
    int arg_num;
    char **argname;
    char *body;
    int value;
} MacroSet;

typedef struct _MacroInfo {
    SpdObjId pfile_id;
    SpdObjId docfrag_id;
    SpdObjId name_id;
    MacroSet src;
    MacroSet doc;
    char *message;
    int status;
} MacroInfo;

typedef struct _MacroInfoArray {
    int size;
    MacroInfo *mi;
} MacroInfoArray;

typedef struct _EnumSet {
    SpdObjId decl_id;
    SpdObjId decr_id;
    char *name;
    int enum_num;
    char **enum_name;
    int *enum_value;
    SpdRelArray enumrels;
} EnumSet;

typedef struct _EnumInfo {
    SpdObjId pfile_id;
    SpdObjId docfrag_id; 
    EnumSet src;
    EnumSet doc;
    char *message;
    int status;
} EnumInfo;

typedef struct _EnumInfoArray {
    int size;
    EnumInfo *ei;
} EnumInfoArray;

typedef struct _FileInfo {
    SpdObjId pfile_id;
    SpdObjId docfrag_id;
    char *name;
    char *message;
    int status;
} FileInfo;

typedef struct _FileInfoArray {
    int size;
    FileInfo *fi;
} FileInfoArray;

typedef struct _Flag {
    int main;
    int src;
    int doc;
    int detail;
} Flag;

typedef struct _ModFuncFlag {
    int main;
    int functype;
    int argnum;
    int argtype;
    int argname;
} ModFuncFlag;

typedef struct _ModTypeFlag {
    int main;
    int deftype;
    int membernum;
    int membertype;
    int membername;
} ModTypeFlag;

typedef struct _ModUnionFlag {
    int main;
    int membernum;
    int membertype;
    int membername;
} ModUnionFlag;

typedef struct _ModMacroFlag {
    int main;
    int argnum;
    int argname;
} ModMacroFlag;

#define EMPTY_RS        {NULL, 0, 0}
#define EMPTY_RS_ARRAY  {0, NULL}
#define EMPTY_FS        {SPD_NON_ID, NULL, NULL, 0, NULL, NULL, SPD_EMPTY_ARRAY}
#define EMPTY_FI        {SPD_NON_ID, SPD_NON_ID, EMPTY_FS, EMPTY_FS, NULL, 0}
#define EMPTY_FI_ARRAY  {0, NULL}
#define EMPTY_TS        {SPD_NON_ID, SPD_NON_ID, NULL, NULL, 0, NULL, NULL, \
                         SPD_EMPTY_ARRAY}
#define EMPTY_TI        {SPD_NON_ID, SPD_NON_ID, 0, EMPTY_TS, EMPTY_TS, NULL, 0}
#define EMPTY_TI_ARRAY  {0, NULL}
#define EMPTY_MS        {NULL, 0, NULL, NULL, 0}
#define EMPTY_MI        {SPD_NON_ID, SPD_NON_ID, SPD_NON_ID, EMPTY_MS, \
                         EMPTY_MS, NULL, 0}
#define EMPTY_MI_ARRAY  {0, NULL}
#define EMPTY_ES        {SPD_NON_ID, SPD_NON_ID, NULL, 0, NULL, NULL, \
                         SPD_EMPTY_ARRAY}
#define EMPTY_EI        {SPD_NON_ID, SPD_NON_ID, EMPTY_ES, EMPTY_ES, NULL, 0}
#define EMPTY_EI_ARRAY  {0, NULL}
#define EMPTY_FILEI     {SPD_NON_ID, SPD_NON_ID, NULL, NULL, 0}
#define EMPTY_FILEI_ARRAY   {0, NULL}

#define STATUS_NOFUNC           0         /* ؿ̵ */
#define STATUS_EXISTFUNC        (1<<0)    /* ؿ롥 */
#define STATUS_INVALID_FUNCTYPE (1<<1)    /* ؿη㤦 */
#define STATUS_INVALID_ARGNUM   (1<<2)    /* ؿΰο㤦 */
#define STATUS_INVALID_ARGTYPE  (1<<3)    /* ؿΰη㤦 */
#define STATUS_INVALID_ARGNAME  (1<<4)    /* ؿΰ̾㤦 */

#define STATUS_NOTYPE              0      /* typedef 줿ʤ */
#define STATUS_EXISTTYPE           (1<<0) /* typedef 줿롥 */
#define STATUS_INVALID_TYPE        (1<<1) /* typedef 줿㤦 */
#define STATUS_INVALID_MEMBER_NUM  (1<<2) /* Фο㤦 */
#define STATUS_INVALID_MEMBER_TYPE (1<<3) /* Фη㤦 */
#define STATUS_INVALID_MEMBER_NAME (1<<4) /* Ф̾㤦 */

#define STATUS_NOUNION    0      /* Τʤ */ 
#define STATUS_EXISTUNION (1<<0) /* Τ롥 */
/* INVALID_MEMBER_NUM ʲ϶ͭ */

#define STATUS_NOMACRO                  0      /* ޥʤ */
#define STATUS_EXISTMACRO               (1<<0) /* ޥ롥 */
#define STATUS_INVALID_VALUE            (1<<1) /* ޥͤ㤦 */
#define STATUS_INVALID_MACRO_ARGNUM     (1<<2) /* ޥΰο㤦 */
#define STATUS_INVALID_MACRO_ARGNAME    (1<<3) /* ޥΰ̾㤦 */

#define STATUS_NOENUM             0      /* Ҥʤ */
#define STATUS_EXISTENUM          (1<<0) /* Ҥ롥 */
#define STATUS_INVALID_ENUM_NUM   (1<<1) /* Ҥο㤦 */
#define STATUS_INVALID_ENUM_NAME  (1<<2) /* Ҥ̾㤦 */
#define STATUS_INVALID_ENUM_VALUE (1<<3) /* Ҥͤ㤦 */

#define STATUS_NODOCFILE    0      /* ɥȤʤ */
#define STATUS_EXISTFILE    (1<<0) /* ե뤬롥 */
#define STATUS_NOFILE       (1<<1) /* ե뤬ʤ */

#define STATUS_NOSRC -1

#define BUF_MAX             1024

#define MACRO_START         "#define"

#define INIT_FLAG {FALSE, FALSE, FALSE, FALSE}

#define ON_VAL "on"
#define SRC "src"
#define DOC "doc"

#define PROG_NAME "spdChkDoc2"

/* check attr name */
#define CHECK_FUNCSRC "funcsrc"
#define CHECK_FUNCDOC "funcdoc"
#define CHECK_FUNCDETAIL "funcdetail"
#define CHECK_TYPESRC "typesrc"
#define CHECK_TYPEDOC "typedoc"
#define CHECK_TYPEDETAIL "typedetail"
#define CHECK_UNIONSRC "unionsrc"
#define CHECK_UNIONDOC "uniondoc"
#define CHECK_UNIONDETAIL "uniondetail"
#define CHECK_MACROSRC "macrosrc"
#define CHECK_MACRODOC "macrodoc"
#define CHECK_MACRODETAIL "macrodetail"
#define CHECK_ENUMSRC "enumsrc"
#define CHECK_ENUMDOC "enumdoc"
#define CHECK_ENUMDETAIL "enumdetail"
#define CHECK_FILESRC "filesrc"
#define CHECK_FILEDOC "filedoc"

/* modify attr name */
#define MODIFY_FUNC "modfunc"
#define MODIFY_FUNC_TYPE "modfunctype"
#define MODIFY_FUNC_ARGNUM "modargnum"
#define MODIFY_FUNC_ARGTYPE "modargtype"
#define MODIFY_FUNC_ARGNAME "modargname"
#define MODIFY_TYPE "modtype"
#define MODIFY_DEFTYPE "moddeftype"
#define MODIFY_STRUCT_MEMBERNUM "modstructmembernum"
#define MODIFY_STRUCT_MEMBERTYPE "modstructmembertype"
#define MODIFY_STRUCT_MEMBERNAME "modstructmembername"
#define MODIFY_UNION "modunion"
#define MODIFY_UNION_MEMBERNUM "modunionmembernum"
#define MODIFY_UNION_MEMBERTYPE "modunionmembertype"
#define MODIFY_UNION_MEMBERNAME "modunionmembername"
#define MODIFY_MACRO "modmacro"
#define MODIFY_MACRO_ARGNUM "modmacroargnum"
#define MODIFY_MACRO_ARGNAME "modmacroargname"

/* directory name */
#define TOP_DIR "Result"
#define HTML_DIR "HTML"
#define SRC_DIR "SRC"
#define DOC_DIR "DOC"
#define SDB_SRC_DIR "SRC"

/* file name */
#define CHECK_FILE ".spdChkDoc.check"

/* suffix name */
#define MODIFY_SUFFIX ".mod"
#define FUNC_NEWFILE_SUFFIX "_func.new"
#define TYPE_NEWFILE_SUFFIX "_type.new"
#define UNION_NEWFILE_SUFFIX "_union.new"
#define MACRO_NEWFILE_SUFFIX "_macro.new"

/* source code tag */
#define SRCCODEPREFIX "<srccode>"
#define SRCCODESUFFIX "</srccode>"

/* macrodef tag */
#define MACRODEFPREFIX "<macrodef>"
#define MACRODEFSUFFIX "</macrodef>"

/* use modify */
#define SRC_MODIFY -1
#define NON_MODIFY  0
#define DOC_MODIFY  1

/* Global variables. */
extern char *htmldir;
extern char *srcdir;
extern char *docdir;

extern char *bg_color;
extern char *text_color;
extern char *link_color;
extern char *alink_color;
extern char *vlink_color;
extern char *func_color;

extern int func_num;
extern int no_doc;
extern int no_func;
extern int exist_func;
extern int valid_func;
extern int invalid_func;
extern int invalid_func_type;
extern int invalid_arg_num;
extern int invalid_arg_type;
extern int invalid_arg_name;

extern int type_num;
extern int type_no_doc;
extern int no_type;
extern int exist_type;
extern int valid_type;
extern int invalid_type;
extern int invalid_type_type;
extern int invalid_struct_member_num;
extern int invalid_struct_member_type;
extern int invalid_struct_member_name;

extern int union_num;
extern int union_no_doc;
extern int no_union;
extern int exist_union;
extern int valid_union;
extern int invalid_union;
extern int invalid_union_member_num;
extern int invalid_union_member_type;
extern int invalid_union_member_name;

extern int macro_num;
extern int macro_no_doc;
extern int exist_macro;
extern int valid_macro;
extern int invalid_macro;
extern int invalid_macro_value;
extern int invalid_macro_arg_num;
extern int invalid_macro_arg_name;
extern int no_macro;

extern int enum_num;
extern int enum_no_doc;
extern int no_enum;
extern int exist_enum;
extern int valid_enum;
extern int invalid_enum;
extern int invalid_enum_num;
extern int invalid_enum_name;
extern int invalid_enum_value;

extern int file_num;
extern int exist_file;
extern int no_doc_file;
extern int no_file;

extern Flag flag_f;
extern Flag flag_t;
extern Flag flag_u;
extern Flag flag_m;
extern Flag flag_e;
extern Flag flag_file;

extern int flag_p;
extern int flag_s;
extern int flag_w;

extern ModFuncFlag modflag_f;
extern ModTypeFlag modflag_t;
extern ModUnionFlag modflag_u;
extern ModMacroFlag modflag_m;

extern SpdObjIdArray pfileIdArray;
extern SpdObjIdArray declIdArray;

extern FuncInfoArray ValidFuncArray;
extern FuncInfoArray ExistFuncArray;
extern FuncInfoArray NoDocFuncArray;
extern FuncInfoArray InvalidFuncTypeArray;
extern FuncInfoArray InvalidArgNumArray;
extern FuncInfoArray InvalidArgTypeArray;
extern FuncInfoArray InvalidArgNameArray;
extern FuncInfoArray NotExistFuncArray;

extern TypeInfoArray ValidTypeArray;
extern TypeInfoArray ExistTypeArray;
extern TypeInfoArray NoDocTypeArray;
extern TypeInfoArray InvalidDefineTypeArray;
extern TypeInfoArray InvalidStructMemberNumArray;
extern TypeInfoArray InvalidStructMemberTypeArray;
extern TypeInfoArray InvalidStructMemberNameArray;
extern TypeInfoArray NotExistTypeArray;

extern TypeInfoArray ValidUnionArray;
extern TypeInfoArray ExistUnionArray;
extern TypeInfoArray NoDocUnionArray;
extern TypeInfoArray InvalidUnionMemberNumArray;
extern TypeInfoArray InvalidUnionMemberTypeArray;
extern TypeInfoArray InvalidUnionMemberNameArray;
extern TypeInfoArray NotExistUnionArray;

extern MacroInfoArray ValidMacroArray;
extern MacroInfoArray ExistMacroArray;
extern MacroInfoArray NoDocMacroArray;
extern MacroInfoArray InvalidMacroArgNumArray;
extern MacroInfoArray InvalidMacroArgNameArray;
extern MacroInfoArray NotExistMacroArray;

extern EnumInfoArray ValidEnumArray;
extern EnumInfoArray ExistEnumArray;
extern EnumInfoArray NoDocEnumArray;
extern EnumInfoArray InvalidEnumNumArray;
extern EnumInfoArray InvalidEnumNameArray;
extern EnumInfoArray InvalidEnumValueArray;
extern EnumInfoArray NotExistEnumArray;

extern FileInfoArray ExistFileArray;
extern FileInfoArray NoDocFileArray;
extern FileInfoArray NotExistFileArray;

#endif /* not _SPD_CHK_DOC_H */
