/* 
 * Program:             $RCSfile: chkFile.c,v $  $Revision: 41.10 $
 * 
 * Purpose:             
 * 
 * Author:              K.Toita  2001/01/10
 *                      S.Yamamoto  2001/08/23
 * 
 * (C) Copyright:       K.Toita - S.Yamamoto  2001 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: chkFile.c,v 41.10 2003/06/22 08:42:52 yamamoto Exp yamamoto $";
#endif

#include <stdarg.h>
#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/ImodelARcompat.h>
#include <Sapid/SpdStr.h>
#include "chkDoc.h"
#include "chkFile.h"
#include "funcinfo.h"

FileInfoArray ExistFileArray = EMPTY_FILEI_ARRAY;
FileInfoArray NoDocFileArray = EMPTY_FILEI_ARRAY;
FileInfoArray NotExistFileArray = EMPTY_FILEI_ARRAY;

void setFileInfointoArray(FileInfoArray *fiArray, FileInfo fi)
{
    fiArray->fi = spdRealloc(fiArray->fi, sizeof(FileInfo) * (fiArray->size + 1));
    fiArray->fi[fiArray->size] = fi;
    fiArray->size++;
}

FileInfo getDocFileInfo(SpdObjId docidentId)
{
    FileInfo fi = EMPTY_FILEI;
    
    fi.docfrag_id = spdGetARelObj(docidentId, "defelem_docident", "docident_id");
    fi.name = spdStrdup(spdGetName(docidentId));
    
    return fi;
}

void getDocFileInfoArraySub(FileInfoArray *fiDocArray, SpdObjId docfragId)
{
    SpdRelArray docfragArray;
    int i, sort, sort2;
    FileInfo fi = EMPTY_FILEI;
    
    sort = spdGetAttrValInt(docfragId, "sort");
    if (sort & DOCFRAG_DEFELEM) {
        docfragArray = spdGetRelSortedArray(docfragId, "defelem_docident",
                                            "defelem_id", NULL, spdCompareRelOffset);
        for(i = 0; i < docfragArray.size; i++) {
            sort2 = spdGetAttrValInt(docfragArray.rel[i].objectId, "sort");
            if(sort2 == DID_FILE) {
                fi = getDocFileInfo(docfragArray.rel[i].objectId);
                /* printf("id:%d name:%s\n",fi.docfrag_id,fi.name); */
                setFileInfointoArray(fiDocArray, fi);
            }
        }
        spdFreeRelArray(docfragArray);
    }
    if (sort & DOCFRAG_DOCELEM) {
        docfragArray = spdGetRelSortedArray(docfragId, "docelem_docfrag",
                                            "docelem_id", NULL, spdCompareRelOffset);
        for(i = 0; i < docfragArray.size; i++) {
            getDocFileInfoArraySub(fiDocArray, docfragArray.rel[i].objectId);
        }
        spdFreeRelArray(docfragArray);
    }
}

void getDocFileInfoArray(FileInfoArray *fiDocArray)
{
    SpdObjId docfileId;
    SpdRelArray docfragArray;
    SpdCursor *docfileCsr;
    int i;
    
    docfileCsr = spdGetObjIdInit("docfile", NULL);
    while((docfileId = spdGetObjId(docfileCsr)) != SPD_NON_ID) {
        docfragArray = spdGetRelSortedArray(docfileId, "docfile_docfrag",
                                            "docfile_id", NULL, spdCompareRelOffset);
        for(i = 0; i < docfragArray.size; i++) {
            getDocFileInfoArraySub(fiDocArray, docfragArray.rel[i].objectId);
        }
        spdFreeRelArray(docfragArray);
    }
}

void checkSrcFileInfo(FileInfo *fi, FileInfoArray fiDocArray)
{
    int i;

    for(i = 0; i < fiDocArray.size; i++) {
        if(SPD_STREQ(fi->name, fiDocArray.fi[i].name)) { /* ˤե뤬ɥȤ¸ߤ */
            fi->docfrag_id = fiDocArray.fi[i].docfrag_id;
            fi->status = STATUS_EXISTFILE;
            putMessage(&(fi->message), "Exist.\n");
            setFileInfointoArray(&ExistFileArray, *fi);
            exist_file++;
            return;
        }
    }
    /* ˤե뤬ɥȤ¸ߤʤ */
    fi->status = STATUS_NODOCFILE;
    putMessage(&(fi->message), "No Document.\n");
    setFileInfointoArray(&NoDocFileArray, *fi);
    no_doc_file++;
}

void checkDocFileInfo(FileInfo fiDoc, FileInfoArray fiArray)
{
    int i;
    for(i = 0; i < fiArray.size; i++) {
        if(SPD_STREQ(fiDoc.name,fiArray.fi[i].name)) { /* ɥȤˤե뤬եȤ¸ߤ */
            return;
        }
    }
    /* ɥȤˤե뤬եȤ¸ߤʤ */
    fiDoc.status = STATUS_NOFILE;
    putMessage(&(fiDoc.message), "No File.\n");
    setFileInfointoArray(&NotExistFileArray, fiDoc);
    no_file++;
}

void checkSrcFile(void)
{
    int i;
    FileInfoArray fiArray = EMPTY_FILEI_ARRAY;
    FileInfoArray fiDocArray = EMPTY_FILEI_ARRAY;
    
    for(i = 0; i < pfileIdArray.size; i++) {
        FileInfo fi = EMPTY_FILEI;
        fi.name = spdStrdup(spdGetName(pfileIdArray.id[i]));
        fi.pfile_id = smuGetFileIdByName((SpdString)fi.name);
        setFileInfointoArray(&fiArray, fi);
    }

    getDocFileInfoArray(&fiDocArray);
    /* ե뤬ɥȤˤ뤫å */
    /* printf("src_size:%d doc_size:%d\n",fiArray.size,fiDocArray.size); */
    for(i = 0; i < fiArray.size; i++) {
        checkSrcFileInfo(&fiArray.fi[i], fiDocArray);
        if (flag_file.src || (!flag_file.src && (fiArray.fi[i].status == STATUS_EXISTFILE))) {
            file_num++;
        }
    }
    
    /* ɥȤˤե뤬եȤƤ뤫å */
    if (flag_file.doc) {
        for(i = 0; i < fiDocArray.size; i++) {
            checkDocFileInfo(fiDocArray.fi[i], fiArray);
        }
    }
    spdFree(fiArray.fi);
    spdFree(fiDocArray.fi);
}
