/* 
 * Program:             $RCSfile: modFunc.c,v $  $Revision: 40.13 $
 * 
 * Purpose:             
 * 
 * Author:              K.Toita  2001/11/26
 *                      S.Yamamoto  2001/11/26
 * 
 * (C) Copyright:       K.Toita and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: modFunc.c,v 40.13 2003/06/28 15:33:41 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/SpdStr.h>
#include <Sapid/ImodelARcompat.h>
#include <Sapid/ImodelAR.h>
#include <Sapid/PmodelAR.h>
#include <Sapid/DmodelAR.h>
#include "chkDoc.h"
#include "putHtml.h"
#include "putScript.h"
#include "funcinfo.h"

char *srcdir;

void setDefaultModFuncFlag(ModFuncFlag *flag_f, SpdString sort)
{
    if (SPD_STREQ(sort, SRC)) {
        flag_f->main = SRC_MODIFY;
        flag_f->functype = TRUE;
        flag_f->argnum = TRUE;
        flag_f->argtype = TRUE;
        flag_f->argname = TRUE;
    } else if (SPD_STREQ(sort, DOC)) {
        flag_f->main = DOC_MODIFY;
        flag_f->functype = TRUE;
        flag_f->argnum = TRUE;
        flag_f->argtype = TRUE;
        flag_f->argname = TRUE;
    } else {
        spdWarning ("%s is not modify option.\n",sort);
        flag_f->main = NON_MODIFY;
    }
}

/* SDBˤ륽ץȤ򥳥ԡ */
void copySrcFile(SpdObjId fileId, FILE *fpin)
{
    FILE *fpout;
    SpdString buf;
    int size = BUF_MAX;
    char *eof;
    char *filename;
    
    filename = spdCatPath(srcdir, spdGetName(fileId));
    fpout = spdFopen(filename, SPD_FOPEN_WT_MODE);

    buf = spdMalloc(sizeof(SpdString) * size);
    eof = fgets(buf, size, fpin);
    while (eof != NULL) {
        fputs(buf,fpout);
        eof = fgets(buf, size, fpin);
    }
    spdFclose(fpout);
    spdFree(buf);
}

/* SDBˤ륽ץϤ */
void putSrcProgram(void)
{
    int i;
    FILE *fpin;
    SpdString SDBsrcdir;
    char buf[BUF_MAX];
    char *filename;
    SpdObjId pfileId;
    
    SDBsrcdir = spdCatPath(spdGetSDBdir(), SDB_SRC_DIR);
    
    for (i = 0; i < pfileIdArray.size; i++) {
        pfileId = smuGetFileIdByName((SpdString)spdGetName(pfileIdArray.id[i]));
        sprintf(buf,"%d",pfileId);

        filename = spdCatPath(SDBsrcdir, buf);
        fpin = spdFopen(filename, SPD_FOPEN_RT_MODE);
        copySrcFile(pfileId,fpin);
        spdFclose(fpin);
    }
}

/* SDBˤɥȤȤ򥳥ԡ */
void copyDocFile(SpdObjId fileId, FILE *fpin)
{
    FILE *fpout;
    SpdString buf;
    int size = BUF_MAX;
    char *eof;
    char *filename;
    
    filename = spdCatPath(docdir, spdGetName(fileId));
    fpout = spdFopen(filename, SPD_FOPEN_WT_MODE);

    buf = spdMalloc(sizeof(SpdString) * size);
    eof = fgets(buf, size, fpin);
    while (eof != NULL) {
        fputs(buf,fpout);
        eof = fgets(buf, size, fpin);
    }
    spdFclose(fpout);
    spdFree(buf);
}

/* SDBˤɥȤϤ */
void putDocument(void)
{
    FILE *fpin;
    SpdString SDBsrcdir;
    char buf[BUF_MAX];
    char *filename;
    SpdCursor *docfile_csr;
    SpdObjId docfile_id;
    
    SDBsrcdir = spdCatPath(spdGetSDBdir(), SDB_SRC_DIR);

    docfile_csr = spdGetObjIdInit("docfile", NULL);

    while((docfile_id = spdGetObjId(docfile_csr)) != SPD_NON_ID) {
        sprintf(buf,"%d",docfile_id);
        filename = spdCatPath(SDBsrcdir, buf);
        fpin = spdFopen(filename, SPD_FOPEN_RT_MODE);
        copyDocFile(docfile_id,fpin);
        spdFclose(fpin);
    }
}

void printFuncSet(FuncSet fset)
{
    int i;
    printf("%s %s(",fset.functype,fset.funcname);
    for (i = 0; i < fset.arg_num; i++) {
        if (i != 0) {
            printf(",");
        }
        printf("%s %s",fset.argtype[i],fset.argname[i]);
    }
    printf(");\n");
}

int getOffset(SpdOcc occ)
{
    SpdRegion ireg,creg;
    
    ireg = spdConvOccToRegion(occ);
    creg = spdConvRegionItoC(ireg);
    return creg.offset;
}

/* FuncSet򣱤Ĥʸˤ */
SpdString FuncSetToString(FuncSet fset)
{
    int i;
    SpdString argbuf,str;
    char buf[BUF_MAX];

    sprintf(buf,"%s %s(",fset.functype,fset.funcname);
    for(i = 0; i < fset.arg_num; i++) {
        argbuf = spdMalloc(sizeof(SpdString)*(strlen(fset.argtype[i])+strlen(fset.argname[i])+1));
        sprintf(argbuf,"%s %s",fset.argtype[i],fset.argname[i]);
        strcat(buf,argbuf);
        if (i+1 != fset.arg_num) {
            strcat(buf,", ");
        }
    }
    strcat(buf,")");
    str = spdStrdup(buf);
    return str;
}

/*
 * char *  SpdString ֤褦ʤȤ
 * char *foo -> SpdStringfoo ˤʤʤ褦ˤ
 * str1:char * str2:SpdString ˤ
 */
SpdString typeCatSpace(SpdString str1, SpdString str2)
{
    int length;
    SpdString str;
    
    if (str1[strlen(str1)-1] == '*' &&
        str1[strlen(str1)-2] == ' ' &&
        str2[strlen(str2)-1] != ' ') {
        str = spdMalloc(sizeof(SpdString)*(strlen(str2)+1));
        strcpy(str, str2);
        length = strlen(str);
        str[length++] = ' ';
        str[length] = '\0';
    } else {
        str = spdStrdup(str2);
    }
    return str;
}

/* ؿη(ν) */
void SrcFuncModifyFuncType(FuncInfo fi, FILE *fp)
{
    SpdOcc occ;
    int offset;
    SpdString str;
    
    /* offset ؿ */
    occ = spdGetAnOffsetOfObj(fi.src.decl_id);
    offset = getOffset(occ);
    
    printf("offset:%d  src:%s  doc:%s\n",offset, fi.src.functype, fi.doc.functype);

    /*
     * char *  SpdString ֤褦ʤȤ
     * char *foo -> SpdStringfoo ˤʤʤ褦ˤ
     */
    str = typeCatSpace(fi.src.functype,fi.doc.functype);
    spdSedModify(fp, offset, fi.src.functype, str);
    
    spdFree(str);
}

/* η(ν) */
void SrcFuncModifyArgType(FuncInfo fi, FILE *fp)
{
    int i;
    SpdOcc occ;
    int offset;
    SpdString str;
    
    for (i = 0; i < fi.src.argrels.size; i++) {
        /* äƤȤ */
        if (strcmp(fi.src.argtype[i], fi.doc.argtype[i])) {
            /* offset  */
            occ = spdGetAnOffsetOfObj(fi.src.argrels.rel[i].objectId);
            offset = getOffset(occ);
            
            /* printf("offset:%d  src:%s  doc:%s\n",offset, fi.src.argtype[i], fi.doc.argtype[i]); */

            str = typeCatSpace(fi.src.argtype[i],fi.doc.argtype[i]);
            spdSedModify(fp, offset, fi.src.argtype[i], str);
            spdFree(str);
        }
    }
}

/* ̾(ν) */
void SrcFuncModifyArgName(FuncInfo fi, FILE *fp)
{
    int i,j;
    SpdOcc occ;
    SpdRel rel;
    SpdRelArray rels;
    int offset;

    for (i = 0; i < fi.src.argrels.size; i++) {
        /* äƤȤ */
        if (strcmp(fi.src.argname[i], fi.doc.argname[i])) {
            rel = spdGetARel(fi.src.argrels.rel[i].objectId, "decl_decl", "declaration_id");
            rel = spdGetARel(rel.objectId, "decl_ident", "declarator_id");
            occ = spdGetAnOffsetOfObj(rel.objectId);
            offset = getOffset(occ);
            
            /* printf("offset:%d  src:%s  doc:%s\n",offset, fi.src.argname[i], fi.doc.argname[i]); */
            spdSedModify(fp, offset, fi.src.argname[i], fi.doc.argname[i]);

            /* λѲսƤѹ */
            rels = spdGetRelSortedArray(rel.objectId, "ident_ref", "identifier_id",
                                        NULL, spdCompareRelOffset);
            printf("rel size:%d\n",rels.size);
            for (j = 0; j < rels.size; j++) {
                occ = spdGetAnOffsetOfObj(rels.rel[j].objectId);
                offset = getOffset(occ);
                spdSedModify(fp, offset, fi.src.argname[i], fi.doc.argname[i]);
            }
        }
    }
}

/* ȤƤĹ */
int getAllArgLength(FuncInfo fi)
{
    SpdOcc occ;
    int offset,firstOffset,lastOffset;
    int length;

    /* ǽΰƬΥեåȤ */
    occ = spdGetAnOffsetOfObj(fi.src.argrels.rel[0].objectId);
    firstOffset = getOffset(occ);

    /* ǸΰΥեåȤ */
    occ = spdGetAnOffsetOfObj(fi.src.argrels.rel[fi.src.argrels.size-1].objectId);
    offset = getOffset(occ);
    length = spdGetLength(fi.src.argrels.rel[fi.src.argrels.size-1].objectId);
    lastOffset = offset + length;
    /* printf("first:%d last:%d\n", firstOffset, lastOffset); */
    return (lastOffset - firstOffset);
}

/* Ƥ(ν) */
void SrcFuncModifyAllArg(FuncInfo fi, FILE *fp)
{
    int i;
    int length;
    int offset;
    char args[BUF_MAX];
    SpdOcc occ;
    SpdRel rel;
    
    /* ȤƤĹ */
    /* ̵Ȥɬ̵ */
    if(fi.src.arg_num !=0 ) {
        length = getAllArgLength(fi);
    }
    /* 򣱤Ĥʸˤ */
    for (i = 0; i < fi.doc.arg_num; i++) {
        if(i != 0) {
            strcat(args, ", ");
        }
        if(i == 0) {
            strcpy(args, fi.doc.argtype[i]);
        } else {
            strcat(args, fi.doc.argtype[i]);
        }
        strcat(args, " ");
        strcat(args, fi.doc.argname[i]);
    }
    /* printf("args:%s\n",args); */
    /* ƬΥեåȤ */
    if(fi.src.arg_num !=0 ) {
        occ = spdGetAnOffsetOfObj(fi.src.argrels.rel[0].objectId);
        offset = getOffset(occ);
        spdSedReplace(fp, offset, length, args);
    } else {
        /* ̵Ȥdecl_optμΥХȤȤ */
        rel = spdGetARel(fi.src.decl_id, "decl_decl", "declaration_id");
        rel = spdGetARel(rel.objectId, "decl_opt", "declarator_id");
        occ = spdGetAnOffsetOfObj(rel.objectId);
        offset = getOffset(occ);
        offset++;
        spdSedAppend(fp, offset, args);
    }
}

/* Ԥäս˥Ȥ (ץ) */
void InsertSrcFuncModifyComment(FuncInfo fi, FILE *fp)
{
    SpdOcc occ;
    int offset;
    SpdString funcstr;
    
    funcstr = FuncSetToString(fi.src);
    occ = spdGetAnOffsetOfObj(fi.src.decl_id);
    offset = getOffset(occ);
    
    spdSedAppend(fp, offset, "/* This function is modified by spdChkDoc2 */\n");
    spdSedAppend(fp, offset, "/* ");
    spdSedAppend(fp, offset, funcstr);
    spdSedAppend(fp, offset, " */\n");
    spdFree(funcstr);
}

/* Ԥäս˥Ȥ (ɥȤ) */
SpdString InsertDocFuncModifyComment(FuncInfo fi, SpdString str)
{
    char buf[BUF_MAX];
    SpdString funcstr,newstr;
    
    funcstr = FuncSetToString(fi.doc);

    sprintf(buf, "/* This function is modeified by spdChkDoc2 */\n/* %s */\n", funcstr);
    newstr = spdMalloc(sizeof(SpdString) * (strlen(buf)+strlen(str)));
    sprintf(newstr, "%s%s",buf,str);
    spdFree(str);
    return newstr;
}

/* <srccode></srccode>Ĥ */
SpdString addSrccodeTag(SpdString str)
{
    SpdString newstr;
    newstr = spdMalloc(sizeof(SpdString)* (strlen(str)+strlen(SRCCODEPREFIX)
                                           +strlen(SRCCODESUFFIX)+2));
    sprintf(newstr, "%s\n%s%s",SRCCODEPREFIX,str,SRCCODESUFFIX);
    spdFree(str);
    return newstr;
}

/* Ǹ\nĤ */
SpdString addNewLine(SpdString str)
{
    SpdString newstr;
    newstr = spdStrcatDup(str, "\n");
    spdFree(str);
    return newstr;
}

/* ؿξʬĤ */
SpdString addFuncBody(SpdObjId decl_id, SpdString str)
{
    SpdString newstr, funcbody;
    SpdObjId id;

    id = spdGetARelObj(decl_id, "decl_decl", "declaration_id");
    id = spdGetARelObj(id, "decl_opt", "declarator_id");
    if(spdGetAttrValInt(id, "sort") == DECL_FUNCDEF) {
        id = spdGetARelObj(id, "func_body", "function_id");
        funcbody = spdStrdup((SpdString)spdStr(id));
        funcbody = addNewLine(funcbody);
        str = addNewLine(str);
        newstr = spdStrcatDup(str, funcbody);
        spdFree(str);
        spdFree(funcbody);
        return newstr;
    } else {
        /* ؿǤʤ";"Ĥ */
        newstr = spdStrcatDup(str, ";");
        newstr = addNewLine(newstr);
        spdFree(str);
        return newstr;
    }
}

void funcModifySub(FuncInfoArray fiArray)
{
    int i,j;
    SpdString buf, filename;
    SpdBoolean modflag = FALSE;
    FILE *fp;
    
    for (i = 0; i < fiArray.size; i++) {
        modflag = FALSE;                    /* flag ν */
        /* SEDե̾κ ե̾.spdsed */
        if (modflag_f.main == SRC_MODIFY) { /* եν */
            filename = spdStrdup(spdGetName(fiArray.fi[i].pfile_id));
            buf = spdMalloc(sizeof(SpdString) * (strlen(filename)+strlen(SPDSED_SUFFIX)+1));
            strcpy(buf, filename);
            spdFree(filename);
            strcat(buf, SPDSED_SUFFIX);
            filename = spdCatPath(srcdir, buf);
            fp = spdFopen(filename, SPD_FOPEN_AT_MODE);
            spdFree(buf);
            spdFree(filename);

            /* printFuncSet(fiArray.fi[i].src); */
            /* printFuncSet(fiArray.fi[i].doc); */
            /* printf ("%s\n",fiArray.fi[i].message); */
            
            /* ؿη㤦 */
            if (modflag_f.functype && (fiArray.fi[i].status & STATUS_INVALID_FUNCTYPE)) {
                modflag = TRUE;
                SrcFuncModifyFuncType(fiArray.fi[i], fp);
            }
            /* ο㤦 */
            if (modflag_f.argnum && (fiArray.fi[i].status & STATUS_INVALID_ARGNUM)) {
                modflag = TRUE;
                SrcFuncModifyAllArg(fiArray.fi[i], fp);
            }
            /* η㤦 */
            if (modflag_f.argtype && (fiArray.fi[i].status & STATUS_INVALID_ARGTYPE)) {
                modflag = TRUE;
                SrcFuncModifyArgType(fiArray.fi[i], fp);
            }
            /* ̾㤦 */
            if (modflag_f.argname && (fiArray.fi[i].status & STATUS_INVALID_ARGNAME)) {
                modflag = TRUE;
                SrcFuncModifyArgName(fiArray.fi[i], fp);
            }

            /* Ԥäս꤬狼褦˥Ȥ */
            if (modflag) {
                InsertSrcFuncModifyComment(fiArray.fi[i], fp);
            }
            spdFclose(fp);
        } else if (modflag_f.main == DOC_MODIFY) { /* ɥȥեν */
            /* ץҤƽơSEDեˤ */
            SpdRel rel;
            SpdString str;
            FuncSet modfset = EMPTY_FS;
            int length, offset;
            
            /* ɥȥե */
            rel = spdGetDocfileDocfrag(fiArray.fi[i].docfrag_id);
            filename = spdStrdup(spdGetName(rel.objectId));
            buf = spdMalloc(sizeof(SpdString) * (strlen(filename)+strlen(SPDSED_SUFFIX)+1));
            strcpy(buf, filename);
            spdFree(filename);
            strcat(buf, SPDSED_SUFFIX);
            printf ("%s\n",buf);
            filename = spdCatPath(docdir, buf);
            fp = spdFopen(filename, SPD_FOPEN_AT_MODE);
            spdFree(buf);
            spdFree(filename);

            /* printFuncSet(fiArray.fi[i].src); */
            /* printFuncSet(fiArray.fi[i].doc); */
            /* printf ("%s\n",fiArray.fi[i].message); */
            
            /* ɥȤνˤĤƤFuncSetơ
             * ʸ󲽤뤳ȤǽȤ
             */
            /* ؿ̾ */
            modfset.funcname = spdStrdup(fiArray.fi[i].doc.funcname);
            
            /* ؿη */
            if (modflag_f.functype && (fiArray.fi[i].status & STATUS_INVALID_FUNCTYPE)) {
                modflag = TRUE;
                modfset.functype = spdStrdup(fiArray.fi[i].src.functype); 
            } else {
                modfset.functype = spdStrdup(fiArray.fi[i].doc.functype);
            }

            if (modflag_f.argnum && (fiArray.fi[i].status & STATUS_INVALID_ARGNUM)) {
                modflag = TRUE;
                modfset.arg_num = fiArray.fi[i].src.arg_num;
                /* ο */
                modfset.argtype = spdMalloc(sizeof(char *) * modfset.arg_num);
                modfset.argname = spdMalloc(sizeof(char *) * modfset.arg_num);
                /* ƥ¦ΤΤ */
                for(j = 0; j < modfset.arg_num; j++) {
                    modfset.argtype[j] = spdStrdup(fiArray.fi[i].src.argtype[j]);
                    modfset.argname[j] = spdStrdup(fiArray.fi[i].src.argname[j]);
                }
            } else if (!modflag_f.argnum && (fiArray.fi[i].status & STATUS_INVALID_ARGNUM)){
                /* οäƤƤ⽤ʤϥɥ¦ΤΤ򤤤 */
                modfset.arg_num = fiArray.fi[i].doc.arg_num;

                modfset.argtype = spdMalloc(sizeof(char *) * modfset.arg_num);
                modfset.argname = spdMalloc(sizeof(char *) * modfset.arg_num);

                for(j = 0; j < modfset.arg_num; j++) {
                    modfset.argtype[j] = spdStrdup(fiArray.fi[i].doc.argtype[j]);
                    modfset.argname[j] = spdStrdup(fiArray.fi[i].doc.argname[j]);
                }
            } else {
                modfset.arg_num = fiArray.fi[i].doc.arg_num;
                /* ο */
                modfset.argtype = spdMalloc(sizeof(char *) * modfset.arg_num);
                modfset.argname = spdMalloc(sizeof(char *) * modfset.arg_num);
            
                /* η̾ */
                for(j = 0; j < modfset.arg_num; j++) {
                    /* äƤʬϥΤΤ */
                    if (modflag_f.argtype && (fiArray.fi[i].status & STATUS_INVALID_ARGTYPE) &&
                        !SPD_STREQ(fiArray.fi[i].src.argtype[j], fiArray.fi[i].doc.argtype[j])) {
                        modflag = TRUE;
                        modfset.argtype[j] = spdStrdup(fiArray.fi[i].src.argtype[j]);
                    } else {
                        modfset.argtype[j] = spdStrdup(fiArray.fi[i].doc.argtype[j]);
                    }
                    if (modflag_f.argname && (fiArray.fi[i].status & STATUS_INVALID_ARGNAME) &&
                        !SPD_STREQ(fiArray.fi[i].src.argname[j], fiArray.fi[i].doc.argname[j])) {
                        modflag = TRUE;
                        modfset.argname[j] = spdStrdup(fiArray.fi[i].src.argname[j]);
                    } else {
                        modfset.argname[j] = spdStrdup(fiArray.fi[i].doc.argname[j]);
                    }
                }
            }
            
            str = FuncSetToString(modfset);
            /* ؿξʬĤ */
            str = addFuncBody(fiArray.fi[i].doc.decl_id, str);

            /* Ԥäս꤬狼褦˥Ȥ */
            if (modflag) {
                str = InsertDocFuncModifyComment(fiArray.fi[i], str);
            }
            /* Ĥ */
            str = addSrccodeTag(str);
            
            /* ɥȤΥץҤlength */
            rel = spdGetARel(fiArray.fi[i].doc.decl_id, "srcelem_srcfrag", "srcfrag_id");
            length = spdGetLength(rel.objectId);

            /* ɥȤΥץҤoffset */
            rel = spdGetARel(rel.objectId, "docfrag_docelem", "c-id");
            offset = spdGetOffset(rel.relationId);

            spdSedReplace(fp,offset,length,str);

            freeFuncSet(modfset);
            spdFree(str);
            spdFclose(fp);
        }
    }
}

/* ¸ߤʤؿ */
void makeNewFunc(FuncInfoArray fiArray)
{
    int i;
    SpdObjId prog_id;
    SpdString prog_name, str;
    char filename[BUF_MAX];
    FILE *fp;
    
    prog_id = spdGetAnObjId("program", NULL);
    prog_name = (SpdString)spdGetName(prog_id);

    if (modflag_f.main == SRC_MODIFY) {
        sprintf(filename, "%s/%s%s",srcdir,prog_name,FUNC_NEWFILE_SUFFIX);
    } else {
        sprintf(filename, "%s/%s%s",docdir,prog_name,FUNC_NEWFILE_SUFFIX);
    }
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);

    if (modflag_f.main == SRC_MODIFY) {
        for (i = 0; i < fiArray.size; i++) {
            str = FuncSetToString(fiArray.fi[i].doc);
            fprintf(fp,"%s\n{\n\n}\n\n",str);
        }
    } else {
        fprintf(fp,"<?xml version=\"1.0\"?>\n");
        fprintf(fp,"<document>\n");
        for (i = 0; i < fiArray.size; i++) {
            str = FuncSetToString(fiArray.fi[i].src);
            fprintf(fp,"<define name=\"%s\" sort=\"function\">\n",fiArray.fi[i].src.funcname);
            fprintf(fp,"<srccode>\n%s;\n</srccode>\n\n</define>\n",str);
        }
        fprintf(fp,"</document>\n");
    }
    spdFclose(fp);
    spdFree(str);
}

void funcModify(void)
{
    /* ͤη㤦 */
    funcModifySub(InvalidFuncTypeArray);

    /* ο㤦 */
    funcModifySub(InvalidArgNumArray);

    /* η㤦 */
    funcModifySub(InvalidArgTypeArray);

    /* ̾㤦 */
    funcModifySub(InvalidArgNameArray);

    /* ¸ߤʤؿ */
    if (modflag_f.main == SRC_MODIFY && NotExistFuncArray.size > 0) {
        makeNewFunc(NotExistFuncArray);
    } else if(modflag_f.main == DOC_MODIFY && NoDocFuncArray.size > 0) {
        makeNewFunc(NoDocFuncArray);
    }
}
