/* 
 * Program:             $RCSfile: modMacro.c,v $  $Revision: 40.7 $
 * 
 * Purpose:             
 * 
 * Author:              K.Toita  2002/01/18
 *                      S.Yamamoto  2002/01/18
 * 
 * (C) Copyright:       K.Toita and S.Yamamoto  2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
"$Id: modMacro.c,v 40.7 2003/06/28 15:33:42 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/ImodelARcompat.h>
#include <Sapid/ImodelAR.h>
#include <Sapid/PmodelAR.h>
#include <Sapid/DmodelAR.h>
#include "chkDoc.h"
#include "SrcType.h"
#include "putHtml.h"
#include "putScript.h"
#include "modFunc.h"

char *srcdir;

void setDefaultModMacroFlag(ModMacroFlag *flag_m, SpdString sort)
{
    if (SPD_STREQ(sort, SRC)) {
        flag_m->main = SRC_MODIFY;
        flag_m->argnum = TRUE;
        flag_m->argname = TRUE;
    } else if (SPD_STREQ(sort, DOC)) {
        flag_m->main = DOC_MODIFY;
        flag_m->argnum = TRUE;
        flag_m->argname = TRUE;
    } else {
        spdWarning ("%s is not modify option.\n",sort);
        flag_m->main = NON_MODIFY;
    }
}

/* MacroSet򣱤Ĥʸˤ롥 */

SpdString MacroSetToString(MacroSet mset)
{
    int i;
    SpdString str;
    char buf[BUF_MAX];
    
    if (mset.arg_num == 0) {
        if (mset.body != NULL) {
            sprintf(buf, "#define %s %s", mset.name, mset.body);
        } else {
            sprintf(buf, "#define %s", mset.name);
        }
        str = spdStrdup(buf);
        return str;
    } else {
        sprintf(buf, "#define %s", mset.name);
    }

    for (i = 0; i < mset.arg_num; i++) {
        if (i == 0) {
            strcat(buf, "(");
        } else {
            strcat(buf, ",");
        }
        strcat(buf, mset.argname[i]);
    }
    strcat(buf, ") ");
    strcat(buf, mset.body);
    str = spdStrdup(buf);

    return str;
}

/* Ԥäս˥Ȥ(ץ)롥 */

void InsertSrcMacroModifyComment(MacroInfo mi, FILE *fp)
{
    SpdObjId pblockId, patternId;
    SpdRel rel;
    int offset, length;
    SpdString macrostr;

    patternId = spdGetARelObj(mi.name_id, "mpatt_mname", "c-id");
    pblockId = spdGetARelObj(patternId, "def_mpatt", "c-id");
    rel = spdGetARel(pblockId, "file_block", "c-id");
    offset = spdGetOffset(rel.relationId);
    length = spdGetLength(pblockId);
    
    macrostr = MacroSetToString(mi.src);

    spdSedAppend(fp, offset, "/* This macro is modified by spdChkDoc2 */\n");
    spdSedAppend(fp, offset, "/* ");
    spdSedAppend(fp, offset, macrostr);
    spdSedAppend(fp, offset, " */\n");
    spdFree(macrostr);
}

/* Ԥäս˥Ȥ(ɥȤ)롥 */

SpdString InsertDocMacroModifyComment(MacroInfo mi, SpdString str)
{
    char buf[BUF_MAX];
    SpdString macrostr,newstr;
    
    macrostr = MacroSetToString(mi.doc);

    sprintf(buf, "/* This macro is modeified by spdChkDoc2 */\n/* %s */\n", macrostr);

    newstr = spdMalloc(sizeof(SpdString) * (strlen(buf)+strlen(str)));
    sprintf(newstr, "%s%s",buf,str);
    spdFree(str);
    return newstr;
}

/* Υޥ */

void SrcMacroModify(MacroInfo mi, FILE *fp)
{
    SpdRel rel;
    SpdString str;
    SpdObjId pblockId, patternId;
    int offset,length;
    
    str = MacroSetToString(mi.doc);
    str = addNewLine(str);
    patternId = spdGetARelObj(mi.name_id, "mpatt_mname", "c-id");
    pblockId = spdGetARelObj(patternId, "def_mpatt", "c-id");

    rel = spdGetARel(pblockId, "file_block", "c-id");
    offset = spdGetOffset(rel.relationId);
    length = spdGetLength(pblockId);

    /* printf("offset:%d length:%d\n",offset,length); */
    spdSedReplace(fp, offset, length, str);

    spdFree(str);
}

/* <macrodef></macrodef>Ĥ */
SpdString addMacrodefTag(SpdString str)
{
    SpdString newstr;
    newstr = spdMalloc(sizeof(SpdString)* (strlen(str)+strlen(MACRODEFPREFIX)
                                           +strlen(MACRODEFSUFFIX)+2));
    sprintf(newstr, "%s\n%s%s",MACRODEFPREFIX,str,MACRODEFSUFFIX);
    spdFree(str);
    return newstr;
}

void macroModifySub(MacroInfoArray miArray)
{
    int i,j;
    SpdString buf, filename;
    SpdBoolean modflag = FALSE;
    FILE *fp;

    for (i = 0; i < miArray.size; i++) {
        if (modflag_m.main == SRC_MODIFY) { /* եν */
            SpdRel rel;
            SpdString str;
            SpdObjId pblockId, patternId;
            int offset,length;
            MacroSet modmset = EMPTY_MS;
            
            filename = spdStrdup(spdGetName(miArray.mi[i].pfile_id));
            buf = spdMalloc(sizeof(SpdString) * (strlen(filename) + strlen(SPDSED_SUFFIX) + 1));
            strcpy(buf, filename);
            spdFree(filename);
            strcat(buf, SPDSED_SUFFIX);
            filename = spdCatPath(srcdir, buf);
            fp = spdFopen(filename, SPD_FOPEN_AT_MODE);
            spdFree(buf);
            spdFree(filename);

            /* ޥ̾ */
            modmset.name = spdStrdup(miArray.mi[i].doc.name);
            
            /* ν */
            if (modflag_m.argnum && (miArray.mi[i].status & STATUS_INVALID_MACRO_ARGNUM)) {
                modflag = TRUE;

                modmset.arg_num = miArray.mi[i].doc.arg_num;
                modmset.argname = spdMalloc(sizeof(char *) * modmset.arg_num);
                /* ƥɥ¦ΤΤ */
                for(j = 0; j < modmset.arg_num; j++) {
                    modmset.argname[j] = spdStrdup(miArray.mi[i].doc.argname[j]);
                }
            } else if (!modflag_m.argnum && (miArray.mi[i].status & STATUS_INVALID_MACRO_ARGNUM)) {
                /* οäƤƤ⽤ʤϥ¦ΤΤ򤤤 */
                modmset.arg_num = miArray.mi[i].src.arg_num;
                modmset.argname = spdMalloc(sizeof(char *) * modmset.arg_num);
                
                for(j = 0; j < modmset.arg_num; j++) {
                    modmset.argname[j] = spdStrdup(miArray.mi[i].src.argname[j]);
                }
            } else {
                modmset.arg_num = miArray.mi[i].src.arg_num;
                modmset.argname = spdMalloc(sizeof(char *) * modmset.arg_num);
                
                /* ̾ν */
                for(j = 0; j < modmset.arg_num; j++) {
                    /* äƤΤľ */
                    if (modflag_m.argname &&
                        (miArray.mi[i].status & STATUS_INVALID_MACRO_ARGNAME) &&
                        !SPD_STREQ(miArray.mi[i].src.argname[j],
                                     miArray.mi[i].doc.argname[j])) {
                        modflag = TRUE;
                        modmset.argname[j] = spdStrdup(miArray.mi[i].doc.argname[j]);
                    } else {
                        modmset.argname[j] = spdStrdup(miArray.mi[i].src.argname[j]);
                    }
                }
            }
            /* body */
            modmset.body = spdStrdup(miArray.mi[i].doc.body);

            str = MacroSetToString(modmset);
            str = addNewLine(str);
            patternId = spdGetARelObj(miArray.mi[i].name_id, "mpatt_mname", "c-id");
            pblockId = spdGetARelObj(patternId, "def_mpatt", "c-id");
            
            rel = spdGetARel(pblockId, "file_block", "c-id");
            offset = spdGetOffset(rel.relationId);
            length = spdGetLength(pblockId);
            
            /* printf("offset:%d length:%d\n",offset,length); */
            spdSedReplace(fp, offset, length, str);

            spdFree(str);
            
            /* Ԥäս꤬狼褦˥Ȥ */
            if (modflag) {
                InsertSrcMacroModifyComment(miArray.mi[i], fp);
            }
            
            spdFclose(fp);
        } else {
            /* ץҤƽơSEDեˤ */
            SpdRel rel;
            SpdString str;
            SpdRelArray docfragArray;
            int length, offset;
            MacroSet modmset = EMPTY_MS;
            
            /* ɥȥե */
            rel = spdGetDocfileDocfrag(miArray.mi[i].docfrag_id);
            filename = spdStrdup(spdGetName(rel.objectId));
            buf = spdMalloc(sizeof(SpdString) * (strlen(filename)+strlen(SPDSED_SUFFIX)+1));
            strcpy(buf, filename);
            spdFree(filename);
            strcat(buf, SPDSED_SUFFIX);
            filename = spdCatPath(docdir, buf);
            fp = spdFopen(filename, SPD_FOPEN_AT_MODE);
            spdFree(buf);
            spdFree(filename);

            /* ޥ̾ */
            modmset.name = spdStrdup(miArray.mi[i].src.name);

            /* ν */
            if (modflag_m.argnum && (miArray.mi[i].status & STATUS_INVALID_MACRO_ARGNUM)) {
                modflag = TRUE;

                modmset.arg_num = miArray.mi[i].src.arg_num;
                modmset.argname = spdMalloc(sizeof(char *) * modmset.arg_num);
                /* ƥ¦ΤΤ */
                for(j = 0; j < modmset.arg_num; j++) {
                    modmset.argname[j] = spdStrdup(miArray.mi[i].src.argname[j]);
                }
            } else if (!modflag_m.argnum && (miArray.mi[i].status & STATUS_INVALID_MACRO_ARGNUM)) {
                /* οäƤƤ⽤ʤϥɥ¦ΤΤ򤤤 */
                modmset.arg_num = miArray.mi[i].doc.arg_num;
                modmset.argname = spdMalloc(sizeof(char *) * modmset.arg_num);
                
                for(j = 0; j < modmset.arg_num; j++) {
                    modmset.argname[j] = spdStrdup(miArray.mi[i].doc.argname[j]);
                }
            } else {
                modmset.arg_num = miArray.mi[i].doc.arg_num;
                modmset.argname = spdMalloc(sizeof(char *) * modmset.arg_num);
                
                /* ̾ν */
                for(j = 0; j < modmset.arg_num; j++) {
                    /* äƤΤľ */
                    if (modflag_m.argname &&
                        (miArray.mi[i].status & STATUS_INVALID_MACRO_ARGNAME) &&
                        !SPD_STREQ(miArray.mi[i].src.argname[j],
                                     miArray.mi[i].doc.argname[j])) {
                        modflag = TRUE;
                        modmset.argname[j] = spdStrdup(miArray.mi[i].src.argname[j]);
                    } else {
                        modmset.argname[j] = spdStrdup(miArray.mi[i].doc.argname[j]);
                    }
                }
            }
            /* body */
            modmset.body = spdStrdup(miArray.mi[i].src.body);

            str = MacroSetToString(modmset);

            /* ʸκǸ˲Ԥ */
            str = addNewLine(str);

            /* Ԥäս꤬狼褦˥Ȥ */
            if (modflag) {
                str = InsertDocMacroModifyComment(miArray.mi[i], str);
            }
            /* Ĥ */
            str = addMacrodefTag(str);

            /* ɥȤΥץҤoffsetlength */
            docfragArray =spdGetRelSortedArray(miArray.mi[i].docfrag_id, "docfrag_docelem",
                                               "p-id", NULL, spdCompareRelOffset);
            for (j = 0; j < docfragArray.size; j++) {
                if (spdGetAttrValInt(docfragArray.rel[j].objectId, "sort") == DOCFRAG_MACROELEM) {
                    offset = spdGetOffset(docfragArray.rel[j].relationId);
                    length = spdGetLength(docfragArray.rel[j].objectId);
                    break;
                }
            }
            spdFreeRelArray(docfragArray);

            spdSedReplace(fp,offset,length,str);

            spdFree(str);
            spdFclose(fp);
        }
    }
}

/* ¸ߤʤޥ */
void makeNewMacro(MacroInfoArray miArray)
{
    int i;
    SpdObjId prog_id;
    SpdString prog_name, str;
    char filename[BUF_MAX];
    FILE *fp;
    
    prog_id = spdGetAnObjId("program", NULL);
    prog_name = (SpdString)spdGetName(prog_id);

    if (modflag_u.main == SRC_MODIFY) {
        sprintf(filename, "%s/%s%s",srcdir,prog_name,MACRO_NEWFILE_SUFFIX);
    } else {
        sprintf(filename, "%s/%s%s",docdir,prog_name,MACRO_NEWFILE_SUFFIX);
    }
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    
    if (modflag_m.main == SRC_MODIFY) {
        for (i = 0; i < miArray.size; i++) {
            str = MacroSetToString(miArray.mi[i].doc);
            fprintf(fp,"%s\n",str);
        }
    } else {
        fprintf(fp,"<?xml version=\"1.0\"?>\n");
        fprintf(fp,"<document>\n");
        for (i = 0; i < miArray.size; i++) {
            str = MacroSetToString(miArray.mi[i].src);
            fprintf(fp,"<define name=\"%s\" sort=\"macro\">\n",miArray.mi[i].src.name);
            fprintf(fp,"<macrodef>\n%s\n</macrodef>\n\n</define>\n",str);
        }
        fprintf(fp,"</document>\n");
    }
    spdFclose(fp);
    spdFree(str);
}

void macroModify(void)
{
    /* ο㤦 */
    macroModifySub(InvalidMacroArgNumArray);

    /* member̾㤦 */
    macroModifySub(InvalidMacroArgNameArray);

    /* ¸ߤʤޥ */
    if (modflag_m.main == SRC_MODIFY && NotExistMacroArray.size > 0) {
        makeNewMacro(NotExistMacroArray);
    } else if (modflag_m.main == DOC_MODIFY && NoDocMacroArray.size > 0) {
        makeNewMacro(NoDocMacroArray);
    }
}
