/* 
 * Program:             $RCSfile: modType.c,v $  $Revision: 40.12 $
 * 
 * Purpose:             
 * 
 * Author:              K.Toita  2001/12/21
 *                      S.Yamamoto  2001/12/21
 * 
 * (C) Copyright:       K.Toita and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
"$Id: modType.c,v 40.12 2003/06/28 15:33:42 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/ImodelARcompat.h>
#include <Sapid/ImodelAR.h>
#include <Sapid/PmodelAR.h>
#include <Sapid/DmodelAR.h>
#include "chkDoc.h"
#include "SrcType.h"
#include "putHtml.h"
#include "putScript.h"
#include "modFunc.h"

char *srcdir;

void setDefaultModTypeFlag(ModTypeFlag *flag_t, SpdString sort)
{
    if (SPD_STREQ(sort, SRC)) {
        flag_t->main = SRC_MODIFY;
        flag_t->deftype = TRUE;
        flag_t->membernum = TRUE;
        flag_t->membertype = TRUE;
        flag_t->membername = TRUE;
    } else if (SPD_STREQ(sort, DOC)) {
        flag_t->main = DOC_MODIFY;
        flag_t->deftype = TRUE;
        flag_t->membernum = TRUE;
        flag_t->membertype = TRUE;
        flag_t->membername = TRUE;
    } else {
        spdWarning ("%s is not modify option.\n",sort);
        flag_t->main = NON_MODIFY;
    }
}

void setDefaultModUnionFlag(ModUnionFlag *flag_u, SpdString sort)
{
    if (SPD_STREQ(sort, SRC)) {
        flag_u->main = SRC_MODIFY;
        flag_u->membernum = TRUE;
        flag_u->membertype = TRUE;
        flag_u->membername = TRUE;
    } else if (SPD_STREQ(sort, DOC)) {
        flag_u->main = DOC_MODIFY;
        flag_u->membernum = TRUE;
        flag_u->membertype = TRUE;
        flag_u->membername = TRUE;
    } else {
        spdWarning ("%s is not modify option.\n",sort);
        flag_u->main = NON_MODIFY;
    }
}

/* TypeSet1Ĥʸˤ롥 */

SpdString TypeSetToString(TypeSet tset)
{
    int i;
    SpdString memberbuf,str;
    char buf[BUF_MAX];

    if (tset.member_num == 0) {
        sprintf(buf,"typedef %s %s;",tset.type, tset.typename);
        str = spdStrdup(buf);
        return str;
    } else {
        sprintf(buf,"typedef %s{\n",tset.type);
    }
    for(i = 0; i < tset.member_num; i++) {
        memberbuf = spdMalloc(sizeof(SpdString)*(strlen(tset.member_type[i])+
                                                 strlen(tset.member_name[i])+1));
        sprintf(memberbuf, "    %s %s;\n",
                tset.member_type[i],tset.member_name[i]);
        strcat(buf,memberbuf);
    }
    memberbuf = spdMalloc(sizeof(SpdString)*(strlen(tset.typename)+2));
    sprintf(memberbuf, "}%s;", tset.typename);
    strcat(buf, memberbuf);
    str = spdStrdup(buf);
    return str;
}

/* ֤δ¸η(ν)롥 */

void SrcTypeModifyDefineType(TypeInfo ti, FILE *fp)
{
    SpdOcc occ;
    int offset;
    SpdString str;
    int length;

    /* offset 򷿤 */
    occ = spdGetAnOffsetOfObj(ti.src.decl_id);
    offset = getOffset(occ);
    length = spdGetLength(ti.src.decl_id);
    /* printf("offset:%d  length:%d  src:%s  doc:%s\n",offset, length, ti.src.type, ti.doc.type); */

    str = TypeSetToString(ti.doc);
    spdSedReplace(fp, offset, length, str);
    
    spdFree(str);
}

/* memberη(ν)롥 */

void SrcTypeModifyMemberType(TypeInfo ti, FILE *fp)
{
    int i;
    SpdOcc occ;
    int offset;
    SpdString str;
    
    for (i = 0; i < ti.src.memberrels.size; i++) {
        /* äƤȤ */
        if (strcmp(ti.src.member_type[i], ti.doc.member_type[i])) {

            /* offset member */
            occ =  spdGetAnOffsetOfObj(ti.src.memberrels.rel[i].objectId);
            offset = getOffset(occ);
            
            /* printf("offset:%d  src:%s  doc:%s\n",offset, ti.src.member_type[i],
               ti.doc.member_type[i]); */

            str = typeCatSpace(ti.src.member_type[i], ti.doc.member_type[i]);
            spdSedModify(fp, offset, ti.src.member_type[i], str);
            spdFree(str);
        }
    }
}

/* member̾(ν)롥 */

void SrcTypeModifyMemberName(TypeInfo ti, FILE *fp)
{
    int i;
    SpdOcc occ;
    SpdRel rel;
    int offset;

    for (i = 0; i < ti.src.memberrels.size; i++) {
        /* äƤȤ */
        if (strcmp(ti.src.member_name[i], ti.doc.member_name[i])) {
            rel = spdGetARel(ti.src.memberrels.rel[i].objectId, "decl_decl", "declaration_id");
            rel = spdGetARel(rel.objectId, "decl_ident", "declarator_id");
            occ = spdGetAnOffsetOfObj(rel.objectId);
            offset = getOffset(occ);
            /* printf("offset:%d  src:%s  doc:%s\n",offset, ti.src.member_name[i],
               ti.doc.member_name[i]); */
            spdSedModify(fp, offset, ti.src.member_name[i], ti.doc.member_name[i]);
        }
    }
}

/* memberȤƤĹ롥 */

int getAllMemberLength(TypeInfo ti)
{
    SpdOcc occ;
    int offset,firstOffset,lastOffset;
    int length;

    /* ǽmemberƬΥեåȤ */
    occ =  spdGetAnOffsetOfObj(ti.src.memberrels.rel[0].objectId);
    firstOffset = getOffset(occ);

    /* ǸmemberΥեåȤ */
    occ =  spdGetAnOffsetOfObj(ti.src.memberrels.rel[ti.src.memberrels.size-1].objectId);
    offset = getOffset(occ);
    length = spdGetLength(ti.src.memberrels.rel[ti.src.memberrels.size-1].objectId);
    lastOffset = offset + length;
    /* printf("first:%d last:%d\n",firstOffset,lastOffset); */
    return (lastOffset - firstOffset);
}

/* memberƤ(ν)롥 */

void SrcTypeModifyAllMember(TypeInfo ti, FILE *fp)
{
    int i;
    int length;
    int offset;
    char members[BUF_MAX];
    SpdOcc occ;
    
    /* memberȤƤĹ */
    /* Ǹmember";"ޤǤȤʤ */
    length = getAllMemberLength(ti);
    /* member򣱤Ĥʸˤ */
    for (i = 0; i < ti.doc.member_num; i++) {
        if(i != 0) {
            strcat(members, "    ");        /* ǥȤ4Ȥ */
        }
        if(i == 0) {
            strcpy(members, ti.doc.member_type[i]);
        } else {
            strcat(members, ti.doc.member_type[i]);
        }
        strcat(members, " ");
        strcat(members, ti.doc.member_name[i]);
        strcat(members, ";");
        /* ǸmemberʳϲԤ */
        if(i != ti.doc.member_num - 1) {
            strcat(members, "\n");
        }
    }
    /* printf("members:%s\n",members); */
    
    /* memberƬΥեåȤ */
    occ =  spdGetAnOffsetOfObj(ti.src.memberrels.rel[0].objectId);
    offset = getOffset(occ);

    /* printf("offset:%d length:%d\n", offset,length); */
    spdSedReplace(fp, offset, length, members);
}

/* Ԥäս˥Ȥ(ץ)롥 */

void InsertSrcTypeModifyComment(TypeInfo ti, FILE *fp)
{
    SpdOcc occ;
    SpdRel rel;
    int offset;
    SpdString typestr;
    
    occ = spdGetAnOffsetOfObj(ti.src.decl_id);
    rel = spdGetARel(ti.src.decl_id, "file_decl", "declaration_id");
    typestr = TypeSetToString(ti.src);
    offset = getOffset(occ);

    if (ti.sort == TYPE_STRUCT_TAG || ti.sort == TYPE_TYPE_DEF) {
        spdSedAppend(fp, offset, "/* This type is modified by spdChkDoc2 */\n");
    } else {
        spdSedAppend(fp, offset, "/* This union is modified by spdChkDoc2 */\n");
    }
    spdSedAppend(fp, offset, "/* ");
    spdSedAppend(fp, offset, typestr);
    spdSedAppend(fp, offset, " */\n");
    spdFree(typestr);
}

/* Ԥäս˥Ȥ(ɥȤ)롥 */

SpdString InsertDocTypeModifyComment(TypeInfo ti, SpdString str)
{
    char buf[BUF_MAX];
    SpdString typestr,newstr;
    
    typestr = TypeSetToString(ti.doc);

    if (ti.sort == TYPE_UNION_TAG) {
        sprintf(buf, "/* This union is modeified by spdChkDoc2 */\n/* %s */\n", typestr);
    } else {
        sprintf(buf, "/* This type is modeified by spdChkDoc2 */\n/* %s */\n", typestr);
    }
    newstr = spdMalloc(sizeof(SpdString) * (strlen(buf)+strlen(str)));
    sprintf(newstr, "%s%s",buf,str);
    spdFree(str);
    return newstr;
}

void typeModifySub(TypeInfoArray tiArray)
{
    int i,j;
    SpdString buf, filename;
    SpdBoolean modflag = FALSE;
    FILE *fp;
    
    for (i = 0; i < tiArray.size; i++) {
        modflag = FALSE;                    /* flag ν */
        /* SEDե̾κ ե̾.spdsed */
        if (modflag_t.main == SRC_MODIFY) { /* եν */
            filename = spdStrdup(spdGetName(tiArray.ti[i].pfile_id));
            buf = spdMalloc(sizeof(SpdString) * (strlen(filename) + strlen(SPDSED_SUFFIX) + 1));
            strcpy(buf, filename);
            spdFree(filename);
            strcat(buf, SPDSED_SUFFIX);
            filename = spdCatPath(srcdir, buf);
            fp = spdFopen(filename, SPD_FOPEN_AT_MODE);
            spdFree(buf);
            spdFree(filename);

            /* printTypeSet(tiArray.ti[i].src); */
            /* printTypeSet(tiArray.ti[i].doc); */
            /* printf ("%s\n",tiArray.ti[i].message); */
            
            /* ֤δ¸η㤦 */
            if (modflag_t.deftype && (tiArray.ti[i].status & STATUS_INVALID_TYPE)) {
                modflag = TRUE;
                SrcTypeModifyDefineType(tiArray.ti[i], fp);
            }
            /* memberο㤦 */
            if (modflag_t.membernum && (tiArray.ti[i].status & STATUS_INVALID_MEMBER_NUM)) {
                modflag = TRUE;
                SrcTypeModifyAllMember(tiArray.ti[i], fp);
            }
            /* memberη㤦 */
            if (modflag_t.membertype && (tiArray.ti[i].status & STATUS_INVALID_MEMBER_TYPE)) {
                modflag = TRUE;
                SrcTypeModifyMemberType(tiArray.ti[i], fp);
            }
            /* member̾㤦 */
            if (modflag_t.membername && (tiArray.ti[i].status & STATUS_INVALID_MEMBER_NAME)) {
                modflag = TRUE;
                SrcTypeModifyMemberName(tiArray.ti[i], fp);
            }

            /* Ԥäս꤬狼褦˥Ȥ */
            if (modflag) {
                InsertSrcTypeModifyComment(tiArray.ti[i], fp);
            }
            spdFclose(fp);
        } else if (modflag_t.main == DOC_MODIFY) { /* ɥȥեν */
            /* ץҤƽơSEDեˤ */
            SpdRel rel;
            SpdString str;
            TypeSet modtset = EMPTY_TS;
            int length, offset;

            /* ɥȥե */
            rel = spdGetDocfileDocfrag(tiArray.ti[i].docfrag_id);
            filename = spdStrdup(spdGetName(rel.objectId));
            buf = spdMalloc(sizeof(SpdString) * (strlen(filename)+strlen(SPDSED_SUFFIX)+1));
            strcpy(buf, filename);
            spdFree(filename);
            strcat(buf, SPDSED_SUFFIX);
            filename = spdCatPath(docdir, buf);
            fp = spdFopen(filename, SPD_FOPEN_AT_MODE);
            spdFree(buf);
            spdFree(filename);

            /* printTypeSet(tiArray.ti[i].src); */
            /* printTypeSet(tiArray.ti[i].doc); */
            /* printf ("%s\n",tiArray.ti[i].message); */
            
            /* ̾ */
            modtset.typename = spdStrdup(tiArray.ti[i].doc.typename);

            /* ¸η⤷ϥ̾ */
            if (modflag_t.deftype && (tiArray.ti[i].status & STATUS_INVALID_TYPE)) {
                modflag = TRUE;
                modtset.type = spdStrdup(tiArray.ti[i].src.type);
            } else {
                modtset.type = spdStrdup(tiArray.ti[i].doc.type);
            }

            /* Фγ */
            if (modflag_t.membernum && (tiArray.ti[i].status & STATUS_INVALID_MEMBER_NUM)) {
                modflag = TRUE;
                modtset.member_num = tiArray.ti[i].src.member_num;

                modtset.member_type = spdMalloc(sizeof(char *) * modtset.member_num);
                modtset.member_name = spdMalloc(sizeof(char *) * modtset.member_num);
                /* Фƥ¦ΤΤ */
                for(j = 0; j < modtset.member_num; j++) {
                    modtset.member_type[j] = spdStrdup(tiArray.ti[i].src.member_type[j]);
                    modtset.member_name[j] = spdStrdup(tiArray.ti[i].src.member_name[j]);
                }
            } else if (!modflag_t.membernum &&
                       (tiArray.ti[i].status & STATUS_INVALID_MEMBER_NUM)) {
                /* ФοäƤƤ⽤ʤϥɥ¦ΤΤ򤤤 */
                modtset.member_num = tiArray.ti[i].doc.member_num;

                modtset.member_type = spdMalloc(sizeof(char *) * modtset.member_num);
                modtset.member_name = spdMalloc(sizeof(char *) * modtset.member_num);
                for(j = 0; j < modtset.member_num; j++) {
                    modtset.member_type[j] = spdStrdup(tiArray.ti[i].doc.member_type[j]);
                    modtset.member_name[j] = spdStrdup(tiArray.ti[i].doc.member_name[j]);
                }
            } else {
                modtset.member_num = tiArray.ti[i].doc.member_num;

                modtset.member_type = spdMalloc(sizeof(char *) * modtset.member_num);
                modtset.member_name = spdMalloc(sizeof(char *) * modtset.member_num);

                /* Фη̾ν */
                for (j = 0; j < modtset.member_num; j++) {
                    /* äƤʬϥΤΤ */
                    if (modflag_t.membertype &&
                        (tiArray.ti[i].status & STATUS_INVALID_MEMBER_TYPE) &&
                        !SPD_STREQ(tiArray.ti[i].src.member_type[j],
                                     tiArray.ti[i].doc.member_type[j])) {
                        modflag = TRUE;
                        modtset.member_type[j] = spdStrdup(tiArray.ti[i].src.member_type[j]);
                    } else {
                        modtset.member_type[j] = spdStrdup(tiArray.ti[i].doc.member_type[j]);
                    }
                    if (modflag_t.membername &&
                        (tiArray.ti[i].status & STATUS_INVALID_MEMBER_NAME) &&
                        !SPD_STREQ(tiArray.ti[i].src.member_name[j],
                                     tiArray.ti[i].doc.member_name[j])) {
                        modflag = TRUE;
                        modtset.member_name[j] = spdStrdup(tiArray.ti[i].src.member_name[j]);
                    } else {
                        modtset.member_name[j] = spdStrdup(tiArray.ti[i].doc.member_name[j]);
                    }
                }
            }

            str = TypeSetToString(modtset);
            /* str = TypeSetToString(tiArray.ti[i].src); */

            /* ʸκǸ˲Ԥ */
            str = addNewLine(str);

            /* Ԥäս꤬狼褦˥Ȥ */
            if (modflag) {
                str = InsertDocTypeModifyComment(tiArray.ti[i], str);
            }
            
            /* Ĥ */
            str = addSrccodeTag(str);
            
            /* ɥȤΥץҤlength */
            rel = spdGetARel(tiArray.ti[i].doc.decl_id, "srcelem_srcfrag", "srcfrag_id");
            length = spdGetLength(rel.objectId);

            /* ɥȤΥץҤoffset */
            rel = spdGetARel(rel.objectId, "docfrag_docelem", "c-id");
            offset = spdGetOffset(rel.relationId);

            spdSedReplace(fp,offset,length,str);

            spdFree(str);
            spdFclose(fp);
        }
    }
}

void unionModifySub(TypeInfoArray tiArray)
{
    int i,j;
    SpdString buf, filename;
    SpdBoolean modflag = FALSE;
    FILE *fp;
    
    for (i = 0; i < tiArray.size; i++) {
        modflag = FALSE;                    /* flag ν */
        /* SEDե̾κ ե̾.spdsed */
        if (modflag_u.main == SRC_MODIFY) { /* եν */
            filename = spdStrdup(spdGetName(tiArray.ti[i].pfile_id));
            buf = spdMalloc(sizeof(SpdString) * (strlen(filename) + strlen(SPDSED_SUFFIX) + 1));
            strcpy(buf, filename);
            spdFree(filename);
            strcat(buf, SPDSED_SUFFIX);
            filename = spdCatPath(srcdir, buf);
            fp = spdFopen(filename, SPD_FOPEN_AT_MODE);
            spdFree(buf);
            spdFree(filename);

            /* printTypeSet(tiArray.ti[i].src); */
            /* printTypeSet(tiArray.ti[i].doc); */
            /* printf ("%s\n",tiArray.ti[i].message); */
            
            /* memberο㤦 */
            if (modflag_u.membernum && (tiArray.ti[i].status & STATUS_INVALID_MEMBER_NUM)) {
                modflag = TRUE;
                SrcTypeModifyAllMember(tiArray.ti[i], fp);
            }
            /* memberη㤦 */
            if (modflag_u.membertype && (tiArray.ti[i].status & STATUS_INVALID_MEMBER_TYPE)) {
                modflag = TRUE;
                SrcTypeModifyMemberType(tiArray.ti[i], fp);
            }
            /* member̾㤦 */
            if (modflag_u.membername && (tiArray.ti[i].status & STATUS_INVALID_MEMBER_NAME)) {
                modflag = TRUE;
                SrcTypeModifyMemberName(tiArray.ti[i], fp);
            }

            /* Ԥäս꤬狼褦˥Ȥ */
            if (modflag) {
                InsertSrcTypeModifyComment(tiArray.ti[i], fp);
            }
            spdFclose(fp);
        } else if (modflag_u.main == DOC_MODIFY) { /* ɥȥեν */
            /* ץҤƽơSEDեˤ */
            SpdRel rel;
            SpdString str;
            TypeSet modtset = EMPTY_TS;
            int length, offset;
            
            /* ɥȥե */
            rel = spdGetDocfileDocfrag(tiArray.ti[i].docfrag_id);
            filename = spdStrdup(spdGetName(rel.objectId));
            buf = spdMalloc(sizeof(SpdString) * (strlen(filename)+strlen(SPDSED_SUFFIX)+1));
            strcpy(buf, filename);
            spdFree(filename);
            strcat(buf, SPDSED_SUFFIX);
            filename = spdCatPath(docdir, buf);
            fp = spdFopen(filename, SPD_FOPEN_AT_MODE);
            spdFree(buf);
            spdFree(filename);

            /* printTypeSet(tiArray.ti[i].src); */
            /* printTypeSet(tiArray.ti[i].doc); */
            /* printf ("%s\n",tiArray.ti[i].message); */
            
            /* ̾ */
            modtset.typename = spdStrdup(tiArray.ti[i].doc.typename);

            /* ̾ */
            modtset.type = spdStrdup(tiArray.ti[i].doc.type);

            /* Фγ */
            if (modflag_u.membernum && (tiArray.ti[i].status & STATUS_INVALID_MEMBER_NUM)) {
                modflag = TRUE;
                modtset.member_num = tiArray.ti[i].src.member_num;

                modtset.member_type = spdMalloc(sizeof(char *) * modtset.member_num);
                modtset.member_name = spdMalloc(sizeof(char *) * modtset.member_num);
                /* Фƥ¦ΤΤ */
                for(j = 0; j < modtset.member_num; j++) {
                    modtset.member_type[j] = spdStrdup(tiArray.ti[i].src.member_type[j]);
                    modtset.member_name[j] = spdStrdup(tiArray.ti[i].src.member_name[j]);
                }
            } else if (!modflag_u.membernum &&
                       (tiArray.ti[i].status & STATUS_INVALID_MEMBER_NUM)) {
                /* ФοäƤƤ⽤ʤϥɥ¦ΤΤ򤤤 */
                modtset.member_num = tiArray.ti[i].doc.member_num;

                modtset.member_type = spdMalloc(sizeof(char *) * modtset.member_num);
                modtset.member_name = spdMalloc(sizeof(char *) * modtset.member_num);
                for(j = 0; j < modtset.member_num; j++) {
                    modtset.member_type[j] = spdStrdup(tiArray.ti[i].doc.member_type[j]);
                    modtset.member_name[j] = spdStrdup(tiArray.ti[i].doc.member_name[j]);
                }
            } else {
                modtset.member_num = tiArray.ti[i].doc.member_num;

                modtset.member_type = spdMalloc(sizeof(char *) * modtset.member_num);
                modtset.member_name = spdMalloc(sizeof(char *) * modtset.member_num);

                /* Фη̾ν */
                for (j = 0; j < modtset.member_num; j++) {
                    /* äƤʬϥΤΤ */
                    if (modflag_u.membertype &&
                        (tiArray.ti[i].status & STATUS_INVALID_MEMBER_TYPE) &&
                        !SPD_STREQ(tiArray.ti[i].src.member_type[j],
                                     tiArray.ti[i].doc.member_type[j])) {
                        modflag = TRUE;
                        modtset.member_type[j] = spdStrdup(tiArray.ti[i].src.member_type[j]);
                    } else {
                        modtset.member_type[j] = spdStrdup(tiArray.ti[i].doc.member_type[j]);
                    }
                    if (modflag_u.membername &&
                        (tiArray.ti[i].status & STATUS_INVALID_MEMBER_NAME) &&
                        !SPD_STREQ(tiArray.ti[i].src.member_name[j],
                                     tiArray.ti[i].doc.member_name[j])) {
                        modflag = TRUE;
                        modtset.member_name[j] = spdStrdup(tiArray.ti[i].src.member_name[j]);
                    } else {
                        modtset.member_name[j] = spdStrdup(tiArray.ti[i].doc.member_name[j]);
                    }
                }
            }

            str = TypeSetToString(modtset);
            /* str = TypeSetToString(tiArray.ti[i].src); */

            /* ʸκǸ˲Ԥ */
            str = addNewLine(str);

            /* Ԥäս꤬狼褦˥Ȥ */
            if (modflag) {
                str = InsertDocTypeModifyComment(tiArray.ti[i], str);
            }
            
            /* Ĥ */
            str = addSrccodeTag(str);
            
            /* ɥȤΥץҤlength */
            rel = spdGetARel(tiArray.ti[i].doc.decl_id, "srcelem_srcfrag", "srcfrag_id");
            length = spdGetLength(rel.objectId);

            /* ɥȤΥץҤoffset */
            rel = spdGetARel(rel.objectId, "docfrag_docelem", "c-id");
            offset = spdGetOffset(rel.relationId);

            spdSedReplace(fp,offset,length,str);

            spdFree(str);
            spdFclose(fp);
        }
    }
}

/* ¸ߤʤ */

void makeNewType(TypeInfoArray tiArray)
{
    int i;
    SpdObjId prog_id;
    SpdString prog_name, str;
    char filename[BUF_MAX];
    FILE *fp;
    
    prog_id = spdGetAnObjId("program", NULL);
    prog_name = (SpdString)spdGetName(prog_id);

    if (modflag_t.main == SRC_MODIFY) {
        sprintf(filename, "%s/%s%s",srcdir,prog_name,TYPE_NEWFILE_SUFFIX);
    } else {
        sprintf(filename, "%s/%s%s",docdir,prog_name,TYPE_NEWFILE_SUFFIX);
    }
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    
    if (modflag_t.main == SRC_MODIFY) {
        for (i = 0; i < tiArray.size; i++) {
            str = TypeSetToString(tiArray.ti[i].doc);
            fprintf(fp,"%s\n",str);
        }
    } else {
        fprintf(fp,"<?xml version=\"1.0\"?>\n");
        fprintf(fp,"<document>\n");
        for (i = 0; i < tiArray.size; i++) {
            str = TypeSetToString(tiArray.ti[i].src);
            fprintf(fp,"<define name=\"%s\" sort=\"typedef\">\n",tiArray.ti[i].src.typename);
            fprintf(fp,"<srccode>\n%s\n</srccode>\n\n</define>\n",str);
        }
        fprintf(fp,"</document>\n");
    }
    spdFclose(fp);
    spdFree(str);
}

/* ¸ߤʤΤ */

void makeNewUnion(TypeInfoArray tiArray)
{
    int i;
    SpdObjId prog_id;
    SpdString prog_name, str;
    char filename[BUF_MAX];
    FILE *fp;
    
    prog_id = spdGetAnObjId("program", NULL);
    prog_name = (SpdString)spdGetName(prog_id);

    printf("progName:%s\n",prog_name);
    if (modflag_u.main == SRC_MODIFY) {
        sprintf(filename, "%s/%s%s",srcdir,prog_name,UNION_NEWFILE_SUFFIX);
    } else {
        sprintf(filename, "%s/%s%s",docdir,prog_name,UNION_NEWFILE_SUFFIX);
    }
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    
    if (modflag_u.main == SRC_MODIFY) {
        for (i = 0; i < tiArray.size; i++) {
            str = TypeSetToString(tiArray.ti[i].doc);
            fprintf(fp,"%s\n",str);
        }
    } else {
        fprintf(fp,"<?xml version=\"1.0\"?>\n");
        fprintf(fp,"<document>\n");
        for (i = 0; i < tiArray.size; i++) {
            str = TypeSetToString(tiArray.ti[i].src);
            fprintf(fp,"<define name=\"%s\" sort=\"typedef\">\n",tiArray.ti[i].src.typename);
            fprintf(fp,"<srccode>\n%s\n</srccode>\n\n</define>\n",str);
        }
        fprintf(fp,"</document>\n");
    }
    spdFclose(fp);
    spdFree(str);
}

void typeModify(void)
{
    /* ֤δ¸η㤦 */
    typeModifySub(InvalidDefineTypeArray);

    /* memberο㤦 */
    typeModifySub(InvalidStructMemberNumArray);

    /* memberη㤦 */
    typeModifySub(InvalidStructMemberTypeArray);

    /* member̾㤦 */
    typeModifySub(InvalidStructMemberNameArray);

    /* ¸ߤʤ */
    if (modflag_t.main == SRC_MODIFY && NotExistTypeArray.size > 0) {
        makeNewType(NotExistTypeArray);
    } else if(modflag_t.main == DOC_MODIFY && NoDocTypeArray.size > 0) {
        makeNewType(NoDocTypeArray);
    }
}

void unionModify(void)
{
    /* memberο㤦 */
    unionModifySub(InvalidUnionMemberNumArray);

    /* memberη㤦 */
    unionModifySub(InvalidUnionMemberTypeArray);

    /* member̾㤦 */
    unionModifySub(InvalidUnionMemberNameArray);

    /* ¸ߤʤ */
    if (modflag_u.main == SRC_MODIFY && NotExistUnionArray.size > 0) {
        makeNewUnion(NotExistUnionArray);
    } else if(modflag_u.main == DOC_MODIFY && NoDocUnionArray.size > 0) {
        makeNewUnion(NoDocUnionArray);
    }
}
