/* 
 * Program:             $RCSfile: putHtml.c,v $  $Revision: 41.20 $
 * 
 * Purpose:             
 * 
 * Author:              K.Toita  2001/01/10
 *                      S.Yamamoto  2001/01/10
 * 
 * (C) Copyright:       K.Toita and S.Yamamoto  2001 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: putHtml.c,v 41.20 2003/08/16 12:18:37 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <sys/types.h>      /* For stat(). */
#include <sys/stat.h>       /* For stat(). */
#include <Sapid/Sapid.h>
#include "chkDoc.h"
#include "printDoc.h"
#include "putHtml.h"
#include "funcinfo.h"

char *htmldir;

/* HTML functions. */

void putHtmlBegin(FILE *fp, char *title_name)
{
    fprintf(fp, SPD_DOCTYPE_HTML_4_01);
    fprintf(fp, "<html>\n");
    fprintf(fp, "<head>\n");
    fprintf(fp, "<title>%s</title>\n", title_name);
    /* fprintf(fp,"<META http-equiv=\"Content-Type\" content=\"text/html; charset=euc-jp\">\n"); */
    fprintf(fp, "<link rel=\"stylesheet\" type=\"text/css\" href=\"./style.css\">");
    fprintf(fp, "</head>\n");
    fprintf(fp, "<body>\n");
}

void putHtmlEnd(FILE *fp)
{
    fprintf(fp, "</body>\n</html>");
}

void putDetailHtmlBegin(FILE *fp, char *title_name, char *sort_name)
{
    fprintf(fp, SPD_DOCTYPE_HTML_4_01);
    fprintf(fp, "<html>\n");
    fprintf(fp, "<head>\n");
    fprintf(fp, "<title>%s %s</title>\n", title_name, sort_name);
    /* fprintf(fp,"<META http-equiv=\"Content-Type\" content=\"text/html; charset=euc-jp\">\n"); */
    fprintf(fp, "<link rel=\"stylesheet\" type=\"text/css\" href=\"./style.css\">");
    fprintf(fp, "</head>\n");
    if (flag_p) {
        fprintf(fp, "<body onload=\"top.print_title('%s')\">\n", sort_name);
    } else {
        fprintf(fp, "<body>\n");
    }
    fprintf(fp, "<div class=\"Title\">%s</div>", sort_name);
}

void putDetailHtmlEnd(FILE *fp)
{
    int i;

    fprintf(fp, "<pre>\n");
    for(i = 0; i < 30; i++) {
        fprintf(fp, "\n");
    }
    fprintf(fp, "</pre>\n");
    putHtmlEnd(fp);
}

void printMacroPattern(FILE *fp, MacroInfo mi)
{
    static char macroArgs[BUF_MAX];
    int i;
    
    if(mi.src.arg_num != 0) {
        for (i = 0; i < mi.src.arg_num; i++) {
            if (i == 0) strcat(macroArgs, "(");
            if (i > 0) strcat(macroArgs, ", ");
            strcat(macroArgs, mi.src.argname[i]);
        }
        strcat(macroArgs, ")");
        fprintf(fp, "%s",macroArgs);
    }
}

void putDetailHtmlSub(FILE *fp, SpdString table_class, SpdString ident_name,
                      SpdString message,
                      SpdObjId pfile_id, SpdObjId decl_id, SpdObjId docfrag_id)
{
    /* 饸פǤ褦ˤ */
    if (flag_s) {
        if (decl_id != SPD_NON_ID) {
            fprintf(fp,"<a name=\"%d\"></a>\n", decl_id);
        } else {
            fprintf(fp,"<a name=\"%d\"></a>\n", pfile_id);
        }
    }
    
    /* ܺ٥ơ֥򥸥פǤ褦ˤ */
    fprintf(fp, "<a name=\"%d\"></a>\n",
            spdGetARelObj(docfrag_id, "defelem_docident", "defelem_id"));
        
    fprintf(fp, "<table border=\"1\" class=\"%s\" summary=\"\">\n",
            table_class);
    
    fprintf(fp,"<tr>\n");
    
    /* ̻Ҥ̾ν */
    fprintf(fp, "<td width=\"400\" valign=\"Top\">\n");
    fprintf(fp, "<strong>Name</strong><br />\n");
    if (flag_s && !SPD_STREQ(table_class, "TableNoSrc")) {
        fprintf(fp, "%s<br />\n", ident_name);
        if (decl_id != SPD_NON_ID) {
            fprintf(fp, "<a href=\"%d.html#%d\" class=\"Source\">Source</a>\n",
                    pfile_id, decl_id);
        } else {
            fprintf(fp, "<a href=\"%d.html\" class=\"Source\">Source</a>\n",
                    pfile_id);
        }
    } else {
        fprintf(fp, "%s\n", ident_name);
    }
    fprintf(fp,"</td>\n");

    /* åν */
    fprintf(fp, "<td width=\"500\" valign=\"Top\">\n");
    fprintf(fp, "<strong>Message</strong><br />\n");
    fprintf(fp, "<em>\n");
    fprintf(fp, "%s", message);
    fprintf(fp, "</em>\n");
    fprintf(fp, "</td>\n");
    fprintf(fp, "</tr>\n");
    
    /* ̻ΥɥȤ */
    fprintf(fp, "<tr>");
    fprintf(fp, "<td colspan=\"2\">");
    fprintf(fp, "<strong>Document</strong><br />\n");
    
    if(SPD_STREQ(table_class, "TableNoDoc")) {
        fprintf(fp, "<br/>\nNO DOCUMENT!");
    } else {
        fprintfDocfrag(fp, docfrag_id);
    }
    fprintf(fp, "</td>\n");
    fprintf(fp, "</tr>\n");
    
    fprintf(fp, "</table>\n");
    fprintf(fp, "<hr>\n");
}

void putFuncDetailHtmlSub(FILE *fp, FuncInfoArray fiArray)
{
    int i;
    
    for(i = 0; i < fiArray.size; i++) {
        /* Result饸פǤ褦ˤ */
        if(i == 0){
            if(fiArray.fi[i].status == STATUS_NOFUNC){
                fprintf(fp,"<A NAME=\"NoDoc\"></A>\n");
            } else if (fiArray.fi[i].status == STATUS_NOSRC) {
                fprintf(fp,"<A NAME=\"NoFunction\"></A>\n");
            } else if (!flag_f.detail && (fiArray.fi[i].status == STATUS_EXISTFUNC)){
                fprintf(fp,"<A NAME=\"Exist\"></A>\n");
            } else if(fiArray.fi[i].status&STATUS_INVALID_FUNCTYPE) {
                fprintf(fp,"<A NAME=\"InvalidFuncType\"></A>\n");
            } else if(fiArray.fi[i].status&STATUS_INVALID_ARGNUM) {
                fprintf(fp,"<A NAME=\"InvalidArgNum\"></A>\n");
            } else if(fiArray.fi[i].status&STATUS_INVALID_ARGTYPE) {
                fprintf(fp,"<A NAME=\"InvalidArgType\"></A>\n");
            } else if(fiArray.fi[i].status&STATUS_INVALID_ARGNAME) {
                fprintf(fp,"<A NAME=\"InvalidArgName\"></A>\n");
            } else {
                fprintf(fp,"<A NAME=\"Valid\"></A>\n");
            }
        }
        
        if(fiArray.fi[i].status == STATUS_NOFUNC) {
            putDetailHtmlSub(fp, "TableNoDoc", fiArray.fi[i].src.funcname,
                             fiArray.fi[i].message, fiArray.fi[i].pfile_id,
                             fiArray.fi[i].src.decl_id, fiArray.fi[i].docfrag_id);
        } else if (fiArray.fi[i].status == STATUS_NOSRC) {
            putDetailHtmlSub(fp, "TableNoSrc", fiArray.fi[i].doc.funcname,
                             fiArray.fi[i].message, fiArray.fi[i].pfile_id,
                             fiArray.fi[i].doc.decl_id, fiArray.fi[i].docfrag_id);
        } else if (!flag_f.detail && (fiArray.fi[i].status == STATUS_EXISTFUNC)){
            putDetailHtmlSub(fp, "TableExist", fiArray.fi[i].src.funcname,
                             fiArray.fi[i].message, fiArray.fi[i].pfile_id,
                             fiArray.fi[i].src.decl_id, fiArray.fi[i].docfrag_id);
        } else if (flag_f.detail && (fiArray.fi[i].status == STATUS_EXISTFUNC)){
            putDetailHtmlSub(fp, "TableValid", fiArray.fi[i].src.funcname,
                             fiArray.fi[i].message, fiArray.fi[i].pfile_id,
                             fiArray.fi[i].src.decl_id, fiArray.fi[i].docfrag_id);
        }else {
            putDetailHtmlSub(fp, "TableInvalid", fiArray.fi[i].src.funcname,
                             fiArray.fi[i].message, fiArray.fi[i].pfile_id,
                             fiArray.fi[i].src.decl_id, fiArray.fi[i].docfrag_id);
        }
    }
}

void putTypeDetailHtmlSub(FILE *fp, TypeInfoArray tiArray)
{
    int i;
    
    for(i = 0; i < tiArray.size; i++) {
        if(i == 0){
            if(tiArray.ti[i].status == STATUS_NOTYPE) {
                fprintf(fp,"<A NAME=\"NoDoc\"></A>");
            } else if (tiArray.ti[i].status == STATUS_NOSRC) {
                fprintf(fp,"<A NAME=\"NoType\"></A>\n");
            } else if (!flag_t.detail && (tiArray.ti[i].status == STATUS_EXISTTYPE)){
                fprintf(fp,"<A NAME=\"Exist\"></A>");
            } else if(tiArray.ti[i].status&STATUS_INVALID_TYPE) {
                fprintf(fp,"<A NAME=\"InvalidDefineType\"></A>");
            } else if(tiArray.ti[i].status&STATUS_INVALID_MEMBER_NUM) {
                fprintf(fp,"<A NAME=\"InvalidMemberNum\"></A>");
            } else if(tiArray.ti[i].status&STATUS_INVALID_MEMBER_TYPE) {
                fprintf(fp,"<A NAME=\"InvalidMemberType\"></A>");
            } else if(tiArray.ti[i].status&STATUS_INVALID_MEMBER_NAME) {
                fprintf(fp,"<A NAME=\"InvalidMemberName\"></A>");
            } else {
                fprintf(fp,"<A NAME=\"Valid\"></A>");
            }
        }
        if(tiArray.ti[i].status == STATUS_NOTYPE) {
            putDetailHtmlSub(fp, "TableNoDoc", tiArray.ti[i].src.typename,
                             tiArray.ti[i].message, tiArray.ti[i].pfile_id,
                             tiArray.ti[i].src.decl_id, tiArray.ti[i].docfrag_id);
        } else if (tiArray.ti[i].status == STATUS_NOSRC) {
            putDetailHtmlSub(fp, "TableNoSrc", tiArray.ti[i].doc.typename,
                             tiArray.ti[i].message, tiArray.ti[i].pfile_id,
                             tiArray.ti[i].doc.decl_id, tiArray.ti[i].docfrag_id);
        } else if (!flag_t.detail && (tiArray.ti[i].status == STATUS_EXISTTYPE)){
            putDetailHtmlSub(fp, "TableExist", tiArray.ti[i].src.typename,
                             tiArray.ti[i].message, tiArray.ti[i].pfile_id,
                             tiArray.ti[i].src.decl_id, tiArray.ti[i].docfrag_id);
        } else if (flag_t.detail && (tiArray.ti[i].status == STATUS_EXISTTYPE)){
            putDetailHtmlSub(fp, "TableValid", tiArray.ti[i].src.typename,
                             tiArray.ti[i].message, tiArray.ti[i].pfile_id,
                             tiArray.ti[i].src.decl_id, tiArray.ti[i].docfrag_id);
        }else {
            putDetailHtmlSub(fp, "TableInvalid", tiArray.ti[i].src.typename,
                             tiArray.ti[i].message, tiArray.ti[i].pfile_id,
                             tiArray.ti[i].src.decl_id, tiArray.ti[i].docfrag_id);
        }
    }
}

void putUnionDetailHtmlSub(FILE *fp, TypeInfoArray tiArray)
{
    int i;
    
    for(i = 0; i < tiArray.size; i++) {
        if (i == 0) {
            if(tiArray.ti[i].status == STATUS_NOUNION){
                fprintf(fp,"<A NAME=\"NoDoc\"></A>");
            } else if (tiArray.ti[i].status == STATUS_NOSRC) {
                fprintf(fp,"<A NAME=\"NoUnion\"></A>\n");
            } else if (!flag_u.detail && (tiArray.ti[i].status == STATUS_EXISTUNION)){
                fprintf(fp,"<A NAME=\"Exist\"></A>");
            } else if(tiArray.ti[i].status&STATUS_INVALID_MEMBER_NUM) {
                fprintf(fp,"<A NAME=\"InvalidMemberNum\"></A>");
            } else if(tiArray.ti[i].status&STATUS_INVALID_MEMBER_TYPE) {
                fprintf(fp,"<A NAME=\"InvalidMemberType\"></A>");
            } else if(tiArray.ti[i].status&STATUS_INVALID_MEMBER_NAME) {
                fprintf(fp,"<A NAME=\"InvalidMemberName\"></A>");
            } else {
                fprintf(fp,"<A NAME=\"Valid\"></A>");
            }
        }
        if(tiArray.ti[i].status == STATUS_NOUNION) {
            putDetailHtmlSub(fp, "TableNoDoc", tiArray.ti[i].src.typename,
                             tiArray.ti[i].message, tiArray.ti[i].pfile_id,
                             tiArray.ti[i].src.decl_id, tiArray.ti[i].docfrag_id);
        } else if (tiArray.ti[i].status == STATUS_NOSRC) {
            putDetailHtmlSub(fp, "TableNoSrc", tiArray.ti[i].doc.typename,
                             tiArray.ti[i].message, tiArray.ti[i].pfile_id,
                             tiArray.ti[i].doc.decl_id, tiArray.ti[i].docfrag_id);
        } else if (!flag_u.detail && (tiArray.ti[i].status == STATUS_EXISTUNION)){
            putDetailHtmlSub(fp, "TableExist", tiArray.ti[i].src.typename,
                             tiArray.ti[i].message, tiArray.ti[i].pfile_id,
                             tiArray.ti[i].src.decl_id, tiArray.ti[i].docfrag_id);
        } else if (flag_u.detail && (tiArray.ti[i].status == STATUS_EXISTUNION)){
            putDetailHtmlSub(fp, "TableValid", tiArray.ti[i].src.typename,
                             tiArray.ti[i].message, tiArray.ti[i].pfile_id,
                             tiArray.ti[i].src.decl_id, tiArray.ti[i].docfrag_id);
        }else {
            putDetailHtmlSub(fp, "TableInvalid", tiArray.ti[i].src.typename,
                             tiArray.ti[i].message, tiArray.ti[i].pfile_id,
                             tiArray.ti[i].src.decl_id, tiArray.ti[i].docfrag_id);
        }
    }
}

void putMacroDetailSub(FILE *fp, MacroInfoArray miArray)
{
    int i;
    
    for(i = 0; i < miArray.size; i++) {
        if(i == 0){
            if(miArray.mi[i].status == STATUS_NOMACRO){
                fprintf(fp,"<A NAME=\"NoDoc\"></A>");
            } else if (miArray.mi[i].status == STATUS_NOSRC) {
                fprintf(fp,"<A NAME=\"NoMacro\"></A>\n");
            } else if (!flag_m.detail && (miArray.mi[i].status == STATUS_EXISTMACRO)) {
                fprintf(fp,"<A NAME=\"Exist\"></A>");
            } else if(miArray.mi[i].status & STATUS_INVALID_MACRO_ARGNUM) {
                fprintf(fp,"<A NAME=\"InvalidArgNum\"></A>");
            } else if(miArray.mi[i].status & STATUS_INVALID_MACRO_ARGNAME) {
                fprintf(fp,"<A NAME=\"InvalidArgName\"></A>");
            } else {
                fprintf(fp,"<A NAME=\"Valid\"></A>");
            }
        }

        if(miArray.mi[i].status == STATUS_NOMACRO){
            putDetailHtmlSub(fp, "TableNoDoc", miArray.mi[i].src.name,
                             miArray.mi[i].message, miArray.mi[i].pfile_id,
                             miArray.mi[i].name_id, miArray.mi[i].docfrag_id);
        } else if (miArray.mi[i].status == STATUS_NOSRC) {
            putDetailHtmlSub(fp, "TableNoSrc", miArray.mi[i].doc.name,
                             miArray.mi[i].message, miArray.mi[i].pfile_id,
                             miArray.mi[i].name_id, miArray.mi[i].docfrag_id);
        } else if (!flag_m.detail && (miArray.mi[i].status == STATUS_EXISTMACRO)) {
            putDetailHtmlSub(fp, "TableExist", miArray.mi[i].src.name,
                             miArray.mi[i].message, miArray.mi[i].pfile_id,
                             miArray.mi[i].name_id, miArray.mi[i].docfrag_id);
        } else if (flag_m.detail && (miArray.mi[i].status == STATUS_EXISTMACRO)) {
            putDetailHtmlSub(fp, "TableValid", miArray.mi[i].src.name,
                             miArray.mi[i].message, miArray.mi[i].pfile_id,
                             miArray.mi[i].name_id, miArray.mi[i].docfrag_id);
        } else {
            putDetailHtmlSub(fp, "TableInvalid", miArray.mi[i].src.name,
                             miArray.mi[i].message, miArray.mi[i].pfile_id,
                             miArray.mi[i].name_id, miArray.mi[i].docfrag_id);
        }
    }
}

void putEnumDetailHtmlSub(FILE *fp, EnumInfoArray eiArray)
{
    int i;
    
    for(i = 0; i < eiArray.size; i++) {
        if (i == 0) {
            if(eiArray.ei[i].status == STATUS_NOENUM){
                fprintf(fp,"<A NAME=\"NoDoc\"></A>");
            } else if (eiArray.ei[i].status == STATUS_NOSRC) {
                fprintf(fp,"<A NAME=\"NoEnum\"></A>\n");
            } else if (!flag_e.detail && (eiArray.ei[i].status == STATUS_EXISTENUM)){
                fprintf(fp,"<A NAME=\"Exist\"></A>");
            } else if(eiArray.ei[i].status&STATUS_INVALID_ENUM_NUM) {
                fprintf(fp,"<A NAME=\"InvalidEnumNum\"></A>");
            } else if(eiArray.ei[i].status&STATUS_INVALID_ENUM_NAME) {
                fprintf(fp,"<A NAME=\"InvalidEnumName\"></A>");
            } else if(eiArray.ei[i].status&STATUS_INVALID_ENUM_VALUE) {
                fprintf(fp,"<A NAME=\"InvalidEnumValue\"></A>");
            } else {
                fprintf(fp,"<A NAME=\"Valid\"></A>");
            }
        }
        if(eiArray.ei[i].status == STATUS_NOENUM) {
            putDetailHtmlSub(fp, "TableNoDoc", eiArray.ei[i].src.name,
                             eiArray.ei[i].message, eiArray.ei[i].pfile_id,
                             eiArray.ei[i].src.decl_id, eiArray.ei[i].docfrag_id);
        } else if (eiArray.ei[i].status == STATUS_NOSRC) {
            putDetailHtmlSub(fp, "TableNoSrc", eiArray.ei[i].doc.name,
                             eiArray.ei[i].message, eiArray.ei[i].pfile_id,
                             eiArray.ei[i].doc.decl_id, eiArray.ei[i].docfrag_id);
        } else if (!flag_e.detail && (eiArray.ei[i].status == STATUS_EXISTENUM)){
            putDetailHtmlSub(fp, "TableExist", eiArray.ei[i].src.name,
                             eiArray.ei[i].message, eiArray.ei[i].pfile_id,
                             eiArray.ei[i].src.decl_id, eiArray.ei[i].docfrag_id);
        } else if (flag_e.detail && (eiArray.ei[i].status == STATUS_EXISTENUM)){
            putDetailHtmlSub(fp, "TableValid", eiArray.ei[i].src.name,
                             eiArray.ei[i].message, eiArray.ei[i].pfile_id,
                             eiArray.ei[i].src.decl_id, eiArray.ei[i].docfrag_id);
        }else {
            putDetailHtmlSub(fp, "TableInvalid", eiArray.ei[i].src.name,
                             eiArray.ei[i].message, eiArray.ei[i].pfile_id,
                             eiArray.ei[i].src.decl_id, eiArray.ei[i].docfrag_id);
        }
    }
}

void putFileDetailHtmlSub(FILE *fp, FileInfoArray fiArray)
{
    int i;
    
    for(i = 0; i < fiArray.size; i++) {
        if(i == 0){
            if(fiArray.fi[i].status == STATUS_NODOCFILE) {
                fprintf(fp,"<A NAME=\"NoDoc\"></A>");
            } else if(fiArray.fi[i].status == STATUS_EXISTFILE){
                fprintf(fp,"<A NAME=\"Exist\"></A>");
            } else {
                fprintf(fp,"<A NAME=\"NoFile\"></A>");
            }
        }
        
        if(fiArray.fi[i].status == STATUS_NODOCFILE){
            putDetailHtmlSub(fp, "TableNoDoc", fiArray.fi[i].name,
                             fiArray.fi[i].message, fiArray.fi[i].pfile_id,
                             SPD_NON_ID, fiArray.fi[i].docfrag_id);
        } else if (fiArray.fi[i].status == STATUS_NOFILE){
            putDetailHtmlSub(fp, "TableNoSrc", fiArray.fi[i].name,
                             fiArray.fi[i].message, fiArray.fi[i].pfile_id,
                             SPD_NON_ID, fiArray.fi[i].docfrag_id);
        } else {
            putDetailHtmlSub(fp, "TableExist", fiArray.fi[i].name,
                             fiArray.fi[i].message, fiArray.fi[i].pfile_id,
                             SPD_NON_ID, fiArray.fi[i].docfrag_id);
        }
    }
}

void putFuncDetailHtml(char *title_name, char *sort_name)
{
    FILE *fp;
    char *filename;

    filename = spdCatPath(htmldir, "func-detail.html");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    putDetailHtmlBegin(fp, title_name, sort_name);
    if (flag_f.detail) {
        putFuncDetailHtmlSub(fp, ValidFuncArray);
        putFuncDetailHtmlSub(fp, InvalidFuncTypeArray);
        putFuncDetailHtmlSub(fp, InvalidArgNumArray);
        putFuncDetailHtmlSub(fp, InvalidArgTypeArray);
        putFuncDetailHtmlSub(fp, InvalidArgNameArray);
    } else {
        putFuncDetailHtmlSub(fp, ExistFuncArray);
    }
    if (flag_f.src) {
        putFuncDetailHtmlSub(fp, NoDocFuncArray);
    }
    if (flag_f.doc) {
        putFuncDetailHtmlSub(fp, NotExistFuncArray);
    }
    putDetailHtmlEnd(fp);
    spdFclose(fp);
    spdFree(filename);
}

void putTypeDetailHtml(char *title_name, char *sort_name)
{
    FILE *fp;
    char *filename;

    filename = spdCatPath(htmldir, "type-detail.html");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    putDetailHtmlBegin(fp, title_name, sort_name);
    if (flag_t.detail) {
        putTypeDetailHtmlSub(fp, ValidTypeArray);
        putTypeDetailHtmlSub(fp, InvalidDefineTypeArray);
        putTypeDetailHtmlSub(fp, InvalidStructMemberNumArray);
        putTypeDetailHtmlSub(fp, InvalidStructMemberTypeArray);
        putTypeDetailHtmlSub(fp, InvalidStructMemberNameArray);
    } else {
        putTypeDetailHtmlSub(fp, ExistTypeArray);
    }
    if (flag_t.src) {
        putTypeDetailHtmlSub(fp, NoDocTypeArray);
    }
    if (flag_t.doc) {
        putTypeDetailHtmlSub(fp, NotExistTypeArray);
    }

    putDetailHtmlEnd(fp);
    spdFclose(fp);
    spdFree(filename);
}

void putUnionDetailHtml(char *title_name, char *sort_name)
{
    FILE *fp;
    char *filename;

    filename = spdCatPath(htmldir, "union-detail.html");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    putDetailHtmlBegin(fp, title_name, sort_name);
    if (flag_u.detail) {
        putUnionDetailHtmlSub(fp, ValidUnionArray);
        putUnionDetailHtmlSub(fp, InvalidUnionMemberNumArray);
        putUnionDetailHtmlSub(fp, InvalidUnionMemberTypeArray);
        putUnionDetailHtmlSub(fp, InvalidUnionMemberNameArray);
    } else {
        putUnionDetailHtmlSub(fp, ExistUnionArray);
    }
    if (flag_u.src) {
        putUnionDetailHtmlSub(fp, NoDocUnionArray);
    }
    if (flag_u.doc) {
        putUnionDetailHtmlSub(fp, NotExistUnionArray);
    }
    putDetailHtmlEnd(fp);
    spdFclose(fp);
    spdFree(filename);
}

void putMacroDetailHtml(char *title_name, char *sort_name)
{
    FILE *fp;
    char *filename;

    filename = spdCatPath(htmldir, "macro-detail.html");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    putDetailHtmlBegin(fp, title_name, sort_name);
    if (flag_m.detail) {
        putMacroDetailSub(fp, ValidMacroArray);
        putMacroDetailSub(fp, InvalidMacroArgNumArray);
        putMacroDetailSub(fp, InvalidMacroArgNameArray);
    } else {
        putMacroDetailSub(fp, ExistMacroArray);
    }
    if (flag_m.src) {
        putMacroDetailSub(fp, NoDocMacroArray);
    }
    if (flag_m.doc) {
        putMacroDetailSub(fp, NotExistMacroArray);
    }
    putDetailHtmlEnd(fp);
    spdFclose(fp);
    spdFree(filename);
}

void putEnumDetailHtml(char *title_name, char *sort_name)
{
    FILE *fp;
    char *filename;

    filename = spdCatPath(htmldir, "enum-detail.html");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    putDetailHtmlBegin(fp, title_name, sort_name);
    if (flag_u.detail) {
        putEnumDetailHtmlSub(fp, ValidEnumArray);
        putEnumDetailHtmlSub(fp, InvalidEnumNumArray);
        putEnumDetailHtmlSub(fp, InvalidEnumNameArray);
        putEnumDetailHtmlSub(fp, InvalidEnumValueArray);
    } else {
        putEnumDetailHtmlSub(fp, ExistEnumArray);
    }
    if (flag_u.src) {
        putEnumDetailHtmlSub(fp, NoDocEnumArray);
    }
    if (flag_u.doc) {
        putEnumDetailHtmlSub(fp, NotExistEnumArray);
    }
    putDetailHtmlEnd(fp);
    spdFclose(fp);
    spdFree(filename);
}

void putFileDetailHtml(char *title_name, char *sort_name)
{
    FILE *fp;
    char *filename;

    filename = spdCatPath(htmldir, "file-detail.html");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    putDetailHtmlBegin(fp, title_name, sort_name);
    putFileDetailHtmlSub(fp, ExistFileArray);
    if (flag_file.src) {
        putFileDetailHtmlSub(fp, NoDocFileArray);
    }
    if (flag_file.doc) {
        putFileDetailHtmlSub(fp, NotExistFileArray);
    }
    putDetailHtmlEnd(fp);
    spdFclose(fp);
    spdFree(filename);
}

/* spdChkDoc Ѥ˽ */
/* Result/HTML, SRC, DOC Ȥˤ */
SpdString mkDirectory(SpdString topdir, SpdString subdir)
{
    SpdString directory;
    struct stat stat_buf;                   /* ǥ쥯ȥ¸ߤȽ˻Ѥ롥 */
    
    directory = spdCatPath (topdir, subdir);
    /* ǥ쥯ȥ롥 */
    if (stat(directory, &stat_buf) != 0) {
        /* ǥ쥯ȥե¸ߤʤ硤롥 */
        spdMkdirR(directory);
        return directory;
    } else if ((stat_buf.st_mode & S_IFMT) == S_IFDIR) { 
        return directory;
        /*
         * Ʊ̾Υǥ쥯ȥ꤬¸ߤƤ硤⤷ʤ
         * ŪˤwarningϤɬפ뤫⤷ʤ 
         */
    } else {
        /*
         * ǥ쥯ȥ̾Ʊ̾Υե(ǥ쥯ȥǤϤʤ) 
         * ¸ߤ硥
         */
        spdErrorExit("File \"%s\" exists.\n", directory);
        return NULL;
    }
}

void putIndexHtml(char *title_name)
{
    FILE *fp;
    char *filename;
    
    filename = spdCatPath(htmldir, "index.html");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    fprintf(fp, SPD_DOCTYPE_HTML_4_01);
    fprintf(fp, "<HTML>\n");
    fprintf(fp, "<HEAD>\n");
    fprintf(fp, "<TITLE>%s</TITLE>\n",title_name);
    if (flag_p) {
        fprintf(fp,"<SCRIPT TYPE=\"text/javascript\" SRC=\"./title.js\"></SCRIPT>\n");
    }
    fprintf(fp,"</HEAD>\n");
    fprintf(fp,"<FRAMESET COLS=\"250pt,*\">\n");
    fprintf(fp,"<FRAMESET ROWS=\"40%%,*\">\n");
    fprintf(fp,"<FRAME SRC=\"top.html\" NAME=\"top\">\n");
    fprintf(fp,"<FRAME SRC=\"result-top.html\" NAME=\"result\">\n");
    fprintf(fp,"</FRAMESET>\n");
    if (flag_p) {
        fprintf(fp,"<FRAMESET ROWS=\"70pt,*\">\n");
        fprintf(fp,"<FRAME SRC=\"sort-top.html\" NAME=\"sort\">\n");
        fprintf(fp,"<FRAME SRC=\"detail-top.html\" NAME=\"detail\">\n");
        fprintf(fp,"</FRAMESET>\n");
    } else {
        fprintf(fp,"<FRAME SRC=\"detail-top.html\" NAME=\"detail\">\n");
    }
    fprintf(fp,"</FRAMESET>\n");
    fprintf(fp,"</HTML>\n");
    spdFclose(fp);
    spdFree(filename);
}

void putTopHtml(char *title_name)
{
    FILE *fp;
    char *filename;
    
    filename = spdCatPath(htmldir, "top.html");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);    
    putHtmlBegin(fp, title_name);

    fprintf(fp,"<DIV CLASS=\"Title\">%s</DIV>",PROG_NAME);
    fprintf(fp,"<DIV CLASS=\"Program\">Program:%s</DIV>",title_name);
    
    fprintf(fp,"<DIV CLASS=\"Top\">\n");
    if(flag_file.main) {
        fprintf(fp,"<A HREF=\"file-result.html\" CLASS=\"File\" TARGET=\"result\">File (%d)</A><BR />\n",file_num);
    }
    if(flag_f.main) {
        fprintf(fp,"<A HREF=\"func-result.html\" CLASS=\"Function\" TARGET=\"result\">Function (%d)</A><BR />\n",func_num);
    }
    if(flag_t.main) {
        fprintf(fp,"<A HREF=\"type-result.html\" CLASS=\"Type\" TARGET=\"result\">Type (%d)</A><BR />\n",type_num);
    }
    if(flag_u.main) {
        fprintf(fp,"<A HREF=\"union-result.html\" CLASS=\"Union\" TARGET=\"result\">Union (%d)</A><BR />\n",union_num);
    }
    if(flag_m.main) {
        fprintf(fp,"<A HREF=\"macro-result.html\" CLASS=\"Macro\" TARGET=\"result\">Macro (%d)</A><BR />\n",macro_num);
    }
    if(flag_e.main) {
        fprintf(fp,"<A HREF=\"enum-result.html\" CLASS=\"Enumerator\" TARGET=\"result\">Enum (%d)</A><BR />\n",enum_num);
    }
    fprintf(fp,"</DIV>\n");
    putHtmlEnd(fp);
    spdFclose(fp);
    spdFree(filename);
}

void putResultHtmlSub(FILE *fp, char *file_name, char *item_name, char *class_name,int data)
{
    fprintf(fp, "<A HREF=\"%s#%s\" CLASS=\"%s\" TARGET=\"detail\">%s (%d)</A><BR />\n",
            file_name, class_name, class_name, item_name, data);
}

void putFuncResultHtml(char *title_name)
{
    FILE *fp;
    char *filename;
    
    filename = spdCatPath(htmldir, "func-result.html");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);    
    putHtmlBegin(fp, title_name);
    
    fprintf(fp,"<DIV CLASS=\"Title\">Function</DIV>");
    fprintf(fp,"<DIV CLASS=\"Top\">\n");
    
    if (flag_f.detail) {
        putResultHtmlSub(fp, "func-detail.html", "Valid Function", "Valid", valid_func);
        putResultHtmlSub(fp, "func-detail.html", "Invalid Function", "Invalid",invalid_func);
    } else {
        putResultHtmlSub(fp, "func-detail.html", "Exist Function", "Exist", exist_func);
    }
    if (flag_f.src) {
        putResultHtmlSub(fp, "func-detail.html", "No Doc", "NoDoc",no_doc);
    }
    if (flag_f.doc) {
        putResultHtmlSub(fp, "func-detail.html", "No Function", "NoFunction" ,no_func);
    }
    if (flag_f.detail) {
        putResultHtmlSub(fp, "func-detail.html", "Invalid Func Type",
                         "InvalidFuncType",invalid_func_type);
        putResultHtmlSub(fp, "func-detail.html", "Invalid Arg Num",
                         "InvalidArgNum",invalid_arg_num);
        putResultHtmlSub(fp, "func-detail.html", "Invalid Arg Type",
                         "InvalidArgType",invalid_arg_type);
        putResultHtmlSub(fp, "func-detail.html", "Invalid Arg Name",
                         "InvalidArgName",invalid_arg_name);
    }
    fprintf(fp,"</DIV>\n");
    
    putHtmlEnd(fp);
    spdFclose(fp);
    spdFree(filename);
}

void putTypeResultHtml(char *title_name)
{
    FILE *fp;
    char *filename;
    
    filename = spdCatPath(htmldir, "type-result.html");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    putHtmlBegin(fp, title_name);
    
    fprintf(fp,"<DIV CLASS=\"Title\">Type</DIV>");
    fprintf(fp,"<DIV CLASS=\"Top\">\n");
    
    if (flag_t.detail) {
        putResultHtmlSub(fp, "type-detail.html", "Valid Type", "Valid", valid_type);
        putResultHtmlSub(fp, "type-detail.html", "Invalid Type", "Invalid",invalid_type);
    } else {
        putResultHtmlSub(fp, "type-detail.html", "Exist Type", "Exist", exist_type);
    }
    if (flag_t.src) {
        putResultHtmlSub(fp, "type-detail.html", "No Doc", "NoDoc",type_no_doc);
    }
    if (flag_t.doc) {
        putResultHtmlSub(fp, "type-detail.html", "No Type", "NoType" ,no_type);
    }
    if (flag_t.detail) {
        putResultHtmlSub(fp, "type-detail.html", "Invalid Define Type",
                         "InvalidDefineType",invalid_type_type);
        putResultHtmlSub(fp, "type-detail.html", "Invalid Member Num",
                         "InvalidMemberNum",invalid_struct_member_num);
        putResultHtmlSub(fp, "type-detail.html", "Invalid Member Type",
                         "InvalidMemberType",invalid_struct_member_type);
        putResultHtmlSub(fp, "type-detail.html", "Invalid Member Name",
                         "InvalidMemberName",invalid_struct_member_name);
    }
    fprintf(fp,"</DIV>\n");
    putHtmlEnd(fp);
    spdFclose(fp);
    spdFree(filename);
}

void putUnionResultHtml(char *title_name)
{
    FILE *fp;
    char *filename;
    
    filename = spdCatPath(htmldir, "union-result.html");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    putHtmlBegin(fp, title_name);
    
    fprintf(fp,"<DIV CLASS=\"Title\">Union</DIV>");
    fprintf(fp,"<DIV CLASS=\"Top\">\n");
    
    if (flag_u.detail) {
        putResultHtmlSub(fp, "union-detail.html", "Valid Union", "Valid", valid_union);
        putResultHtmlSub(fp, "union-detail.html", "Invalid Union", "Invalid",invalid_union);
    } else {
        putResultHtmlSub(fp, "union-detail.html", "Exist Union", "Exist", exist_union);
    }
    if (flag_u.src) {
        putResultHtmlSub(fp, "union-detail.html", "No Doc", "NoDoc",union_no_doc);
    }
    if (flag_u.doc) {
        putResultHtmlSub(fp, "union-detail.html", "No Union", "NoUnion" ,no_union);
    }
    if (flag_u.detail) {
        putResultHtmlSub(fp, "union-detail.html", "Invalid Member Num",
                         "InvalidMemberNum",invalid_union_member_num);
        putResultHtmlSub(fp, "union-detail.html", "Invalid Member Type",
                         "InvalidMemberType",invalid_union_member_type);
        putResultHtmlSub(fp, "union-detail.html", "Invalid Member Name",
                         "InvalidMemberName",invalid_union_member_name);
    }
    fprintf(fp,"</DIV>\n");
    putHtmlEnd(fp);
    spdFclose(fp);
    spdFree(filename);
}

void putMacroResultHtml(char *title_name)
{
    FILE *fp;
    char *filename;
    
    filename = spdCatPath(htmldir, "macro-result.html");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    putHtmlBegin(fp, title_name);
    
    fprintf(fp,"<DIV CLASS=\"Title\">Macro</DIV>");
    fprintf(fp,"<DIV CLASS=\"Top\">\n");
    
    fprintf(fp,"<table border=\"1\" summary=\"\">\n");
    if (flag_m.detail) {
        putResultHtmlSub(fp, "macro-detail.html", "Valid Macro", "Valid", valid_macro);
        putResultHtmlSub(fp, "macro-detail.html", "Invalid Macro", "Invalid", invalid_macro);
    } else {
        putResultHtmlSub(fp, "macro-detail.html", "Exist Macro", "Exist", exist_macro);
    }
    if (flag_m.src) {
        putResultHtmlSub(fp, "macro-detail.html", "No Doc", "NoDoc", macro_no_doc);
    }
    if (flag_m.doc) {
        putResultHtmlSub(fp, "macro-detail.html", "Not Exist", "NoMacro",no_macro);
    }
    if (flag_m.detail) {
        putResultHtmlSub(fp, "macro-detail.html", "Invalid Arg Num", "InvalidArgNum",
                         invalid_macro_arg_num);
        putResultHtmlSub(fp, "macro-detail.html", "Invalid Arg Name", "InvalidArgName",
                         invalid_macro_arg_name);
    }
    fprintf(fp,"</DIV>\n");
    
    putHtmlEnd(fp);
    spdFclose(fp);
    spdFree(filename);
}

void putEnumResultHtml(char *title_name)
{
    FILE *fp;
    char *filename;
    
    filename = spdCatPath(htmldir, "enum-result.html");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    putHtmlBegin(fp, title_name);
    
    fprintf(fp,"<DIV CLASS=\"Title\">Enum</DIV>");
    fprintf(fp,"<DIV CLASS=\"Top\">\n");
    
    if (flag_e.detail) {
        putResultHtmlSub(fp, "enum-detail.html", "Valid Enum", "Valid", valid_enum);
        putResultHtmlSub(fp, "enum-detail.html", "Invalid Enum", "Invalid",invalid_enum);
    } else {
        putResultHtmlSub(fp, "enum-detail.html", "Exist Enum", "Exist", exist_enum);
    }
    if (flag_e.src) {
        putResultHtmlSub(fp, "enum-detail.html", "No Doc", "NoDoc",enum_no_doc);
    }
    if (flag_e.doc) {
        putResultHtmlSub(fp, "enum-detail.html", "No Enum", "NoEnum" ,no_enum);
    }
    if (flag_e.detail) {
        putResultHtmlSub(fp, "enum-detail.html", "Invalid Enum Num",
                         "InvalidEnumNum",invalid_enum_num);
        putResultHtmlSub(fp, "enum-detail.html", "Invalid Enum Name",
                         "InvalidEnumName",invalid_enum_name);
        putResultHtmlSub(fp, "enum-detail.html", "Invalid Enum Value",
                         "InvalidEnumValue",invalid_enum_value);
    }
    fprintf(fp,"</DIV>\n");
    putHtmlEnd(fp);
    spdFclose(fp);
    spdFree(filename);
}

void putFileResultHtml(char *title_name)
{
    FILE *fp;
    char *filename;
    
    filename = spdCatPath(htmldir, "file-result.html");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    putHtmlBegin(fp, title_name);
    
    fprintf(fp,"<DIV CLASS=\"Title\">File</DIV>");
    fprintf(fp,"<DIV CLASS=\"Top\">\n");
    
    putResultHtmlSub(fp, "file-detail.html", "Exist File", "Exist", exist_file);
    if (flag_file.src) {
        putResultHtmlSub(fp, "file-detail.html", "Not Exist", "NoDoc",no_doc_file);
    }
    if (flag_file.doc) {
        putResultHtmlSub(fp, "file-detail.html", "No File", "NoFile",no_file);
    }
    fprintf(fp,"</DIV>\n");
    
    putHtmlEnd(fp);
    spdFclose(fp);
    spdFree(filename);
}

void putResultHtml(char *title_name)
{
    if (flag_f.main) {
        putFuncResultHtml(title_name);
    }
    if (flag_t.main) {
        putTypeResultHtml(title_name);
    }
    if (flag_u.main) {
        putUnionResultHtml(title_name);
    }
    if (flag_m.main) {
        putMacroResultHtml(title_name);
    }
    if (flag_e.main) {
        putEnumResultHtml(title_name);
    }
    if (flag_file.main) {
        putFileResultHtml(title_name);
    }
}

/* ȥåץե롥 */

void putTopFile(char *title_name, char *file_name)
{
    FILE *fp;
    char *filename;
    
    filename = spdCatPath(htmldir, file_name);
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    putHtmlBegin(fp, title_name);
    putHtmlEnd(fp);
    spdFclose(fp);
    spdFree(filename);
}

/* ɽǤ褦ˤ뤿ΥץȤϤ롥 */

void putJavaScript(void)
{
    FILE *fp;
    char *filename;
    
    filename = spdCatPath(htmldir, "title.js");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    fprintf(fp,"function print_title(str) {\n");
    fprintf(fp,"\ttop.sort.document.open();\n");
    fprintf(fp,"\ttop.sort.document.write(\"<!DOCTYPE HTML PUBLIC \\\"-//W3C//DTD HTML 3.2//EN\\\">\");\n");
    fprintf(fp,"\ttop.sort.document.write(\"<HTML>\\n\");\n");
    fprintf(fp,"\ttop.sort.document.write(\"<HEAD>\\n\");\n");
    fprintf(fp,"\ttop.sort.document.write(\"<META http-equiv=\\\"Content-Type\\\" ");
    fprintf(fp,"content=\\\"text/html; charset=euc-jp\\\">\\n\");\n");
    fprintf(fp,"\ttop.sort.document.write(\"<Link Rel=\\\"stylesheet\\\" Type=\\\"text/css\\\" ");
    fprintf(fp,"Href=\\\"./style.css\\\">\\n\");\n");
    fprintf(fp,"\ttop.sort.document.write(\"</HEAD>\\n\");\n");
    fprintf(fp,"\ttop.sort.document.write(\"<BODY>\\n\");\n");
    fprintf(fp,"\ttop.sort.document.write(\"<H2>\"+str+\"</H2>\\n\");\n");
    fprintf(fp,"\ttop.sort.document.write(\"</BODY>\\n\");\n");
    fprintf(fp,"\ttop.sort.document.write(\"</HTML>\\n\");\n");
    fprintf(fp,"\ttop.sort.document.close();\n");
    fprintf(fp,"}\n");
    spdFclose(fp);
    spdFree(filename);
}

void putHtml(char *title_name)
{
    putIndexHtml(title_name);
    
    /* ɽƤɽեΥȥå */
    if (flag_p) {
        putTopFile(title_name, "sort-top.html");
    }

    /* η̤ɽեΥȥå */
    putTopFile(title_name, "result-top.html");

    /* ξܺ٤ɽեΥȥå */
    putTopFile(title_name, "detail-top.html");

    if (flag_p) {
        putJavaScript();
    }
    putTopHtml(title_name);
    putResultHtml(title_name);
}
