/* 
 * Program:             $RCSfile: putScript.c,v $  $Revision: 41.21 $
 * 
 * Purpose:             
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: putScript.c,v 41.21 2003/08/16 12:18:36 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/ImodelAR.h>
#include <Sapid/PmodelAR.h>
#include "chkDoc.h"
#include "putScript.h"
#include "funcinfo.h"

/* spdSed Append ̿ؿ*/

void spdSedAppend(FILE *fp, int offset, char *strings)
{
    fprintf(fp, "A %d %d %s\n", offset, strlen(strings), strings);
}

/* spdSed Modify ̿ؿ*/

void spdSedModify(FILE *fp, int offset, char *strings1, char *strings2)
{
    fprintf(fp, "M %d %d %s %d %s\n", offset, strlen(strings1), strings1,
            strlen(strings2), strings2);
}

/* spdSed Replace ̿ؿ*/

void spdSedReplace(FILE *fp, int offset, int length, char *strings)
{
    fprintf(fp, "R %d %d %d %s\n",offset, length, strlen(strings), strings);
}

/* spdSed Delete ̿ؿ*/

void spdSedDelete(FILE *fp, int offset, int length)
{
    fprintf(fp, "D %d %d\n",offset, length);
}

/* idη֤(idΤ) */

int getIdLength(int id)
{
    int i;
    int pow = 1;
  
    for(i=1;;++i){
        if(id/pow==0)
            break;
        pow=pow*10;
    }
    return i;
}

void scriptLineNum(FILE *fp, SpdObjId fileId)
{
    FILE *fp_source;
    int line = 0;
    int offset = 0;
    /* SpdString file; */
    SpdConstString file;
    char line_char[LINE];
    char temp[BUF_MAX];
    int c;
    int kanji_shift_flag = 0;               /* For easy JIS-KANJI checking. */

    file = spdGetName(fileId);
    fp_source = smuOpenSrcFile(fileId);

    /* First line. */
    sprintf(line_char, "%4d", ++line);
    sprintf(temp, "%s: ", line_char);

    spdSedAppend(fp, offset, temp);

    /*
     * ե1ʸɤ߹ߡüʸȲԤ줿顤
     * Ԥ                                         
     */
    while ((c = getc(fp_source)) != EOF) {
        /*
         * Simple treating every ESC character as JIST-KANJI-IN or OUT.
         * You should check the rest sequence (2nd and 3rd characters).
         *
         * Escape sequence:
         * 033, 044, 0100 (ESC, $, @)   JIS C 6226-1978,
         * 033, 044, 0102 (ESC, $, B)   JIS X 0208-1983,
         * 033, 050, 0102 (ESC, (, B)   ASCII,
         */
        if (c == '\033') {
            kanji_shift_flag ^= 1;          /* Toggle flag. */
        }
        if ((kanji_shift_flag == 0) || (c == '\n')) {
            switch (c) {
              case ('<'):
                spdSedModify(fp, offset, "<", "&lt;");
                break;
              case ('>'):
                spdSedModify(fp, offset, ">", "&gt;");
                break;
              case('&'):
                spdSedModify(fp, offset, "&", "&amp;");
                break;
              case('"'):
                spdSedModify(fp, offset, "\"", "&quot;");
                break;
              case('\n'):
                sprintf(line_char, "%4d", ++line);
                sprintf(temp, "%s: ", line_char);
                spdSedAppend(fp, offset + 1, temp);
                break;
              default:
                break;
            }
        }
        offset++;
    }
    spdFclose(fp_source);

    spdSedAppend(fp, offset, "</PRE>\n");
    spdSedAppend(fp, offset, "</BODY>\n");
    spdSedAppend(fp, offset, "</HTML>\n");
}

void scriptBeginning(FILE *fp, SpdObjId fileId)
{
    char temp[BUF_MAX];

    spdSedAppend(fp, 0, SPD_DOCTYPE_HTML_4_01);

    /* Add comment. */
    spdSedAppend(fp, 0, "<HTML>\n");
    spdSedAppend(fp, 0, "<HEAD>\n");
    sprintf(temp, "<TITLE>%s</TITLE>\n", spdGetName(fileId));
    spdSedAppend(fp, 0, temp);
    spdSedAppend(fp, 0, "<Link Rel=\"stylesheet\" Type=\"text/css\" Href=\"./style.css\">\n");
    spdSedAppend(fp, 0, "</HEAD>\n");
    sprintf(temp, "<BODY onload=\"top.print_title('%s')\">\n", spdGetName(fileId));
    spdSedAppend(fp, 0, temp);
    if (flag_file.main) {
        sprintf(temp,
                "<DIV CLASS=\"Title\"><A HREF=\"file-detail.html#%d\" CLASS=\"File\">%s</A></DIV>\n",fileId, spdGetName(fileId));
    } else  {
        sprintf(temp, "<DIV CLASS=\"Title\">%s</DIV>\n",spdGetName(fileId));
    }
    spdSedAppend(fp, 0, temp);
    spdSedAppend(fp, 0, "<PRE>\n");
}

FuncInfo searchFuncInfo(SpdObjId decl_id)
{
    int i;
    FuncInfo fi = EMPTY_FI;
    if (flag_f.src) {
        for(i = 0; i < NoDocFuncArray.size; i++) {
            if(decl_id == NoDocFuncArray.fi[i].src.decl_id) return NoDocFuncArray.fi[i];
        }
    }
    if (!flag_f.detail) {
        for(i = 0; i < ExistFuncArray.size; i++) {
            if(decl_id == ExistFuncArray.fi[i].src.decl_id) return ExistFuncArray.fi[i];
        }
    } else {
        for(i = 0; i < ValidFuncArray.size; i++) {
            if(decl_id == ValidFuncArray.fi[i].src.decl_id) return ValidFuncArray.fi[i];
        }
        for(i = 0; i < InvalidFuncTypeArray.size; i++) {
            if(decl_id == InvalidFuncTypeArray.fi[i].src.decl_id) return InvalidFuncTypeArray.fi[i];
        }
        for(i = 0; i < InvalidArgNumArray.size; i++) {
            if(decl_id == InvalidArgNumArray.fi[i].src.decl_id) return InvalidArgNumArray.fi[i];
        }
        for(i = 0; i < InvalidArgTypeArray.size; i++) {
            if(decl_id == InvalidArgTypeArray.fi[i].src.decl_id) return InvalidArgTypeArray.fi[i];
        }
        for(i = 0; i < InvalidArgNameArray.size; i++) {
            if(decl_id == InvalidArgNameArray.fi[i].src.decl_id) return InvalidArgNameArray.fi[i];
        }
    }
    return fi;
}

TypeInfo searchStructTypeInfo(SpdObjId decl_id)
{
    int i;
    TypeInfo ti = EMPTY_TI;
    if (flag_t.src) {
        for(i = 0; i < NoDocTypeArray.size; i++) {
            if(decl_id == NoDocTypeArray.ti[i].src.decl_id) {
                return NoDocTypeArray.ti[i];
            }
        }
    }
    if (!flag_t.detail) {
        for(i = 0; i < ExistTypeArray.size; i++) {
            if(decl_id == ExistTypeArray.ti[i].src.decl_id) {
                return ExistTypeArray.ti[i];
            }
        }
    } else {
        for(i = 0; i < ValidTypeArray.size; i++) {
            if(decl_id == ValidTypeArray.ti[i].src.decl_id) {
                return ValidTypeArray.ti[i];
            }
        }
        for(i = 0; i < InvalidDefineTypeArray.size; i++) {
            if(decl_id == InvalidDefineTypeArray.ti[i].src.decl_id) {
                return InvalidDefineTypeArray.ti[i];
            }
        }
        for(i = 0; i < InvalidStructMemberNumArray.size; i++) {
            if(decl_id == InvalidStructMemberNumArray.ti[i].src.decl_id) {
                return InvalidStructMemberNumArray.ti[i];
            }
        }
        for(i = 0; i < InvalidStructMemberTypeArray.size; i++) {
            if(decl_id == InvalidStructMemberTypeArray.ti[i].src.decl_id) {
                return InvalidStructMemberTypeArray.ti[i];
            }
        }
        for(i = 0; i < InvalidStructMemberNameArray.size; i++) {
            if(decl_id == InvalidStructMemberNameArray.ti[i].src.decl_id) {
                return InvalidStructMemberNameArray.ti[i];
            }
        }
    }
    return ti;
}

TypeInfo searchUnionTypeInfo(SpdObjId decl_id)
{
    int i;
    TypeInfo ti = EMPTY_TI;

    if (flag_u.src) {
        for(i = 0; i < NoDocUnionArray.size; i++) {
            if(decl_id == NoDocUnionArray.ti[i].src.decl_id) {
                return NoDocUnionArray.ti[i];
            }
        }
    }
    if (!flag_u.detail) {
        for(i = 0; i < ExistUnionArray.size; i++) {
            if(decl_id == ExistUnionArray.ti[i].src.decl_id) {
                return ExistUnionArray.ti[i];
            }
        }
    } else {
        for(i = 0; i < ValidUnionArray.size; i++) {
            if(decl_id == ValidUnionArray.ti[i].src.decl_id) {
                return ValidUnionArray.ti[i];
            }
        }
        for(i = 0; i < InvalidUnionMemberNumArray.size; i++) {
            if(decl_id == InvalidUnionMemberNumArray.ti[i].src.decl_id) {
                return InvalidUnionMemberNumArray.ti[i];
            }
        }
        for(i = 0; i < InvalidUnionMemberTypeArray.size; i++) {
            if(decl_id == InvalidUnionMemberTypeArray.ti[i].src.decl_id) {
                return InvalidUnionMemberTypeArray.ti[i];
            }
        }
        for(i = 0; i < InvalidUnionMemberNameArray.size; i++) {
            if(decl_id == InvalidUnionMemberNameArray.ti[i].src.decl_id) {
                return InvalidUnionMemberNameArray.ti[i];
            }
        }
    }
    return ti;
}

EnumInfo searchEnumInfo(SpdObjId decl_id)
{
    int i;
    EnumInfo ei = EMPTY_EI;

    if (flag_e.src) {
        for (i = 0; i < NoDocEnumArray.size; i++) {
            if (decl_id == NoDocEnumArray.ei[i].src.decl_id) {
                return NoDocEnumArray.ei[i];
            }
        }
    }
    if (!flag_e.detail) {
        for(i = 0; i < ExistEnumArray.size; i++) {
            if(decl_id == ExistEnumArray.ei[i].src.decl_id) {
                return ExistEnumArray.ei[i];
            }
        }
    } else {
        for(i = 0; i < ValidEnumArray.size; i++) {
            if(decl_id == ValidEnumArray.ei[i].src.decl_id) {
                return ValidEnumArray.ei[i];
            }
        }
        for(i = 0; i < InvalidEnumNumArray.size; i++) {
            if(decl_id == InvalidEnumNumArray.ei[i].src.decl_id) {
                return InvalidEnumNumArray.ei[i];
            }
        }
        for(i = 0; i < InvalidEnumNameArray.size; i++) {
            if(decl_id == InvalidEnumNameArray.ei[i].src.decl_id) {
                return InvalidEnumNameArray.ei[i];
            }
        }
        for(i = 0; i < InvalidEnumValueArray.size; i++) {
            if(decl_id == InvalidEnumValueArray.ei[i].src.decl_id) {
                return InvalidEnumValueArray.ei[i];
            }
        }
    }
    return ei;
}

void putMacroScript(MacroInfoArray miArray, SpdObjId cfile_id, FILE *fp)
{
    int i;
    SpdRel rel;
    SpdRegion reg;
    char temp[BUF_MAX];
    
    for(i = 0; i < miArray.size; i++) {
        if(miArray.mi[i].pfile_id == cfile_id) {
            rel = spdGetARel(miArray.mi[i].name_id, "mpatt_mname", "macroName_id");
            reg.offset = spdGetOffset(rel.relationId);
            reg.length = spdGetLength(miArray.mi[i].name_id);
            sprintf(temp, "<A NAME=\"%d\" HREF=\"macro-detail.html#%d\" CLASS=\"Macro\"\"><!-- %s -->",
                    miArray.mi[i].name_id, miArray.mi[i].name_id,
                    spdGetName(miArray.mi[i].name_id));
            spdSedAppend(fp, reg.offset, temp);
            spdSedAppend(fp, reg.offset+reg.length, "</A>");
        }    
    }
}

SpdBoolean spdDecrIsDeclTag(const SpdObjId decrId)
{
    if (spdGetAttrValInt(decrId, "sort") == DECL_TAG) return TRUE;
    return FALSE;
}

void putScriptSub(SpdObjId ifile_id, SpdObjId cfile_id)
{
    int i;
    SpdString path;
    FILE *fp;
    char temp[BUF_MAX];
    SpdObjIdArray declArray, decrArray;

    temp[0] = '\0';

    path = spdMalloc(strlen(htmldir) + getIdLength(cfile_id) +
                     strlen(SPDSED_SUFFIX) + 2);
    sprintf(path, "%s/%d%s", htmldir, cfile_id, SPDSED_SUFFIX);

    fp = spdFopen(path, SPD_FOPEN_WT_MODE);
    scriptBeginning(fp, cfile_id);
    scriptLineNum(fp, cfile_id);    

    /* function define */

    declArray = spdGetRelObjArray(ifile_id, "file_decl", "file_id",
                                  spdObjIdIsDeclFuncdef);
    
    for (i = 0; i < declArray.size ; i++) {
        SpdRel rel;
        SpdRegion reg;
        FuncInfo fi = searchFuncInfo(declArray.id[i]);
        
        if(fi.pfile_id == cfile_id) {
            rel=spdGetARel(declArray.id[i], "decl_decl", "declaration_id");
            rel=spdGetARel(rel.objectId, "decl_ident", "declarator_id");
        
            reg.offset = spdGetAbsoluteOffset(rel.relationId, ifile_id);
            reg.fileId = ifile_id;
            reg.length = spdGetLength(rel.objectId);
            reg = spdConvRegionItoC(reg);

            sprintf(temp, "<A NAME=\"%d\" HREF=\"func-detail.html#%d\" CLASS=\"Function\"\"><!-- %s -->",
                    declArray.id[i], declArray.id[i], spdGetName(rel.objectId));
            spdSedAppend(fp, reg.offset, temp);
            spdSedAppend(fp, reg.offset+reg.length, "</A>");
        }
    }
    
    /* type define */
    declArray = spdGetRelObjArray(ifile_id, "file_decl", "file_id",
                                  spdObjIdIsDeclType);
    for (i = 0; i < declArray.size ; i++) {
        SpdRel rel;
        SpdRegion reg;
        TypeInfo structti = searchStructTypeInfo(declArray.id[i]);
        TypeInfo unionti = searchUnionTypeInfo(declArray.id[i]);
        
        /*printf("pfile_id:%d cfile_id:%d\n",pfile_id, cfile_id);*/

        if(structti.pfile_id == cfile_id || unionti.pfile_id == cfile_id) {
            if (structti.pfile_id != SPD_NON_ID) { /* struct */
                rel = spdGetARel(structti.src.decr_id, "decl_ident", "declarator_id");
            } else {                        /* union */
                rel = spdGetARel(unionti.src.decr_id, "decl_ident", "declarator_id");
            }
            reg.offset = spdGetAbsoluteOffset(rel.relationId, ifile_id);
            reg.fileId = ifile_id;
            reg.length = spdGetLength(rel.objectId);
            reg = spdConvRegionItoC(reg);
            if (structti.pfile_id != SPD_NON_ID) {
                sprintf(temp, "<A NAME=\"%d\" HREF=\"type-detail.html#%d\" CLASS=\"Type\"\"><!-- %s -->",
                        declArray.id[i], declArray.id[i], spdGetName(rel.objectId));
            } else {
                sprintf(temp, "<A NAME=\"%d\" HREF=\"union-detail.html#%d\" CLASS=\"Union\"\"><!-- %s -->",
                        declArray.id[i], declArray.id[i], spdGetName(rel.objectId));
            }
            spdSedAppend(fp, reg.offset, temp);
            spdSedAppend(fp, reg.offset+reg.length, "</A>");
        }
    }

    /* Enumerator */
    decrArray = spdGetObjIdArray("declarator", NULL, spdDecrIsDeclTag);
    for (i = 0; i < decrArray.size; i++) {
        SpdObjId declId;
        SpdRel rel;
        SpdRegion reg;
        EnumInfo ei;
        
        declId = spdGetARelObj(decrArray.id[i],"decl_decl","declarator_id");
        ei = searchEnumInfo(declId);

        if (ei.pfile_id == cfile_id) {
            rel = spdGetARel(ei.src.decr_id, "decl_ident", "declarator_id");
            reg.offset = spdGetAbsoluteOffset(rel.relationId, ifile_id);
            reg.fileId = ifile_id;
            reg.length = spdGetLength(rel.objectId);
            reg = spdConvRegionItoC(reg);
            
            sprintf(temp, "<A NAME=\"%d\" HREF=\"enum-detail.html#%d\" CLASS=\"Enumerator\"\"><!-- %s -->",
                    declId, declId, spdGetName(rel.objectId));
            spdSedAppend(fp, reg.offset, temp);
            spdSedAppend(fp, reg.offset+reg.length, "</A>");
        }
    }
    
    /* macro */

    if (flag_m.detail) {
        putMacroScript(ValidMacroArray, cfile_id, fp);
        putMacroScript(InvalidMacroArgNumArray, cfile_id, fp);
        putMacroScript(InvalidMacroArgNameArray, cfile_id, fp);
    } else {
        putMacroScript(ExistMacroArray, cfile_id, fp); 
    }
    if (flag_m.src) {
        putMacroScript(NoDocMacroArray, cfile_id, fp);
    }
    spdFreeObjIdArray(declArray);
    spdFree(path);
}

SpdObjId getHeaderFileId(SpdObjId pfile_id)
{
    SpdObjId hfile_id;
    SpdRelArray pblocks;
    SpdRel hfile_rel;
    int i;
    
    pblocks = spdGetRelSortedArray(pfile_id, "file_block", 
                                   "pfile_id", NULL, spdCompareRelOffset);
    for(i = 0; i < pblocks.size; i++) {
        if(spdGetAttrValInt(pblocks.rel[i].objectId, "sort") == PBLOCK_INCLUDE){
            hfile_rel = spdGetARel(pblocks.rel[i].objectId, "incld_hfile",
                                   "pblock_id");
            if (hfile_rel.objectId != SPD_NON_ID) {
                hfile_id = spdGetARelObj(hfile_rel.objectId, "hfile_file",
                                         "hfile_id");
                if (hfile_id != SPD_NON_ID && !smuIsSystemFile(hfile_id)) 
                    return hfile_id;
            }
        }
    }
    return SPD_NON_ID;
}

SpdObjId getifileId(SpdObjId pfile_id)
{
    SpdObjId id;
    id = spdGetARelObj(pfile_id,"hfile_file", "pfile_id");
    id = spdGetARelObj(id, "incld_hfile", "hfile_id");
    id = spdGetARelObj(id, "file_block", "pblock_id");
    id = spdGetARelObj(id, "cfile_ifile", "pfile_id"); 
    return id;
}

void putScript(void)
{
    int i;
    SpdObjId pfile_id;
    SpdObjId ifile_id;

    for (i = 0; i < pfileIdArray.size; i++) {
        ifile_id = spdGetARelObj(pfileIdArray.id[i], "cfile_ifile", "pfile_id");
        if(ifile_id != SPD_NON_ID) {
            /* ̾ΥեΥץȥեκ */
            pfile_id = smuGetFileIdByName((SpdString)spdGetName(pfileIdArray.id[i]));
            putScriptSub(ifile_id, pfile_id);
        } else {
            ifile_id = getifileId(pfileIdArray.id[i]);
            if (ifile_id == SPD_NON_ID) {
                /* ʤȻפ */
                continue;
            }
            /* إåեΥץȥեκ */
            pfile_id = smuGetFileIdByName((SpdString)spdGetName(pfileIdArray.id[i]));
            putScriptSub(ifile_id, pfile_id);
        }
    }
    /* spdFreeObjIdArray(file_id); */
}
