/* 
 * Program:             $RCSfile: putStyleSheet.c,v $  $Revision: 41.10 $
 * 
 * Purpose:             
 * 
 * Author:              K.Toita  2001/01/10
 *                      S.Yamamoto  2001/01/10
 * 
 * (C) Copyright:       K.Toita and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: putStyleSheet.c,v 41.10 2002/02/05 06:58:30 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "chkDoc.h"
#include "color.h"
#include "putHtml.h"

void putStyleSheetSub(FILE *fp, char *type_name, char *color)
{
    fprintf(fp, ".%s{\n",type_name);
    fprintf(fp, "\tcolor:%s;\n",color);
    fprintf(fp, "\ttext-decoration:none;\n");
    fprintf(fp, "}\n\n");
}

void putStyleSheet(void)
{
    FILE *fp;
    char *filename;
    
    filename = spdCatPath(htmldir, "style.css");
    fp = spdFopen(filename, SPD_FOPEN_WT_MODE);
    
    /* body */
    fprintf(fp, "BODY{\n");
    fprintf(fp, "\tcolor:%s;\n",body_color);
    fprintf(fp, "\tbackground-color:%s;\n",body_bgcolor);
    fprintf(fp, "}\n\n");
    
    /* a */
    /* 
     * fprintf(fp, "A:link{\n");
     * fprintf(fp, "\tcolor:%s;\n",link_color);
     * fprintf(fp, "}\n\n");
     *    
     * fprintf(fp, "A:visited{\n");
     * fprintf(fp, "\tcolor:%s;\n",vlink_color);
     * fprintf(fp, "}\n\n");
     *    
     * fprintf(fp, "A:active{\n");
     * fprintf(fp, "\tcolor:%s;\n",alink_color);
     * fprintf(fp, "}\n\n");
     */
    
    /* h2 */
    /* fprintf(fp, "H2,H3{\n"); */
    /* fprintf(fp, "\ttext-align:center;\n"); */
    /* fprintf(fp, "}\n\n"); */
    
    /* NoDoc */
    putStyleSheetSub(fp, "NoDoc", NoDoc_color);
    
    /* Valid */
    putStyleSheetSub(fp, "Valid", Valid_color);
    
    /* Invalid */
    putStyleSheetSub(fp, "Invalid", Invalid_color);
    
    /* NoFunction */
    putStyleSheetSub(fp, "NoFunction", NoFunction_color);
    
    /* InvalidFuncType */
    putStyleSheetSub(fp, "InvalidFuncType", InvalidFuncType_color);
    
    /* InvalidArgNum */
    putStyleSheetSub(fp, "InvalidArgNum", InvalidArgNum_color);
    
    /* InvalidArgType */
    putStyleSheetSub(fp, "InvalidArgType", InvalidArgType_color);
    
    /* InvalidArgName */
    putStyleSheetSub(fp, "InvalidArgName", InvalidArgName_color);
    
    /* NoType */
    putStyleSheetSub(fp, "NoType", NoType_color);
    
    /* InvalidDefineType */
    putStyleSheetSub(fp, "InvalidDefineType", InvalidDefineType_color);
    
    /* InvalidMemberNum */
    putStyleSheetSub(fp, "InvalidMemberNum", InvalidMemberNum_color);
    
    /* InvalidMemeberType */
    putStyleSheetSub(fp, "InvalidMemberType", InvalidMemberType_color);
    
    /* InvalidMemberName */
    putStyleSheetSub(fp, "InvalidMemberName", InvalidMemberName_color);

    /* NoUnion */
    putStyleSheetSub(fp, "NoUnion", NoUnion_color);

    /* Exist */
    putStyleSheetSub(fp, "Exist", Exist_color);
    
    /* NoMacro */
    putStyleSheetSub(fp, "NoMacro", NoMacro_color);
    
    /* NoEnum */
    putStyleSheetSub(fp, "NoEnum", NoEnum_color);
   
    /* InvalidEnumNum */
    putStyleSheetSub(fp, "InvalidEnumNum", InvalidEnumNum_color);
   
    /* InvalidEnumName */
    putStyleSheetSub(fp, "InvalidEnumName", InvalidEnumName_color);

    /* InvaildEnumValue */
    putStyleSheetSub(fp, "InvalidEnumValue", InvalidEnumValue_color);
   
    /* NoFile */
    putStyleSheetSub(fp, "NoFile", NoFile_color);
    
    /* Sort */
    putStyleSheetSub(fp, "Function", func_color);
    putStyleSheetSub(fp, "Type", type_color);
    putStyleSheetSub(fp, "Union", union_color);
    putStyleSheetSub(fp, "Macro", macro_color);
    putStyleSheetSub(fp, "Enumerator", enum_color);
    putStyleSheetSub(fp, "File", file_color);
    
    fprintf(fp, ".Source{\n");
    fprintf(fp, "\tcolor:%s;\n",source_color);
    fprintf(fp, "\ttext-decoration:none;\n");
    fprintf(fp, "}\n\n");
    
    /* result top, sort top */
    fprintf(fp, ".Top{\n");
    fprintf(fp, "\tline-height:130%%;\n");
    fprintf(fp, "\tpadding: 10pt 0pt 0pt 15pt;\n");
    fprintf(fp, "}\n\n");
    
    /* detail table */
    fprintf(fp, ".Title{\n");
    fprintf(fp, "\ttext-align:center;\n");
    fprintf(fp, "\tfont-weight:bold;\n");
    fprintf(fp, "}\n\n");
    
    fprintf(fp, ".Program{\n");
    fprintf(fp, "\ttext-align:center;\n");
    fprintf(fp, "\tfont-weight:bold;\n");
    fprintf(fp, "}\n\n");
    
    fprintf(fp, ".TableExist{\n");
    fprintf(fp, "\tbackground-color:%s\n",TableExist_color);
    fprintf(fp, "}\n\n");
    
    fprintf(fp, ".TableValid{\n");
    fprintf(fp, "\tbackground-color:%s\n",TableValid_color);
    fprintf(fp, "}\n\n");
    
    fprintf(fp, ".TableInvalid{\n");
    fprintf(fp, "\tbackground-color:%s\n",TableInvalid_color);
    fprintf(fp, "}\n\n");
    
    fprintf(fp, ".TableNoDoc{\n");
    fprintf(fp, "\tbackground-color:%s\n",TableNoDoc_color);
    fprintf(fp, "}\n\n");

    fprintf(fp, ".TableNoSrc{\n");
    fprintf(fp, "\tbackground-color:%s\n",TableNoSrc_color);
    fprintf(fp, "}\n\n");
}
