/* 
 * Program:             $RCSfile: SIP2-proto.h,v $  $Revision: 30.14 $
 * 
 * Purpose:
 * 
 * Author:              H.Suzuki  1998/11/06
 *                      S.Yamamoto  1998/11/06
 * 
 * (C) Copyright:       H.Suzuki and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

/* stack.c */
SipStack *sipCreateStack(size_t elemSize);
void sipFreeStack(SipStack *stk);
void sipPushStack(void *elem, SipStack *stk);
void *sipPopStack(SipStack *stk);
void *sipGetTopOfStack(SipStack *stk);
SipEvalStackElem *sipCreateEvalStackElem(void);

/* step.c */
SpdObjId sipGetExpressionFromFuncDecr(SpdObjId funcDecrId);

/* callstack.c */
SipCallStackElem *sipPopCallStack(void);
SipCallStackElem *getTopOfCallStack(void);
void sipFreePoppedCallStack(void);
void sipCreateCallStack(void);
void sipFreeCallStack(void);
void printStorageStack(void);

/* eval.c */
SipStack *sipCreateEvalStack(void);
void sipFreeEvalStack(void);
void sipPushEvalStack(SipEvalStackElem *esElem);
SipEvalStackElem *sipPopEvalStack(void);
SipEvalStackElem *sipGetTopOfEvalStack(void);
SipEvalStackElem *sipDupEvalStackElem(const SipEvalStackElem *elem);
SpdValueData sipGetValueDataFromESElem(SipEvalStackElem *elem);
void initSpdTrvInfo(void);
void freeSpdTrvInfo(void);
void sipSetTrvStackOfCallStack(void);
int sipGetDebugMode(void);
SpdString sipGetString(SpdObjId strAreaId);
void spdDwIndent(void);

/* system.c */
SipOpeFunc sipGetOpeFunc(int opeSort);

/* operate.c */
void sipInitOpeFunc(void);
void sipDwOpe(const char *format, ...);

/* libaccess.c */
void sipInitLibAccessTable(void);
void sipFreeLibAccessTable(void);
SipOpeFunc sipGetlibAcsFunc(SpdObjId funcId);

/* SIP2-util.c */
int sipCastValueDataInt(SpdValueData val);
void sipInitValueDataInt(void);
