/* 
 * Program:             $RCSfile: SIP2-util.c,v $  $Revision: 30.3 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  2000/12/21
 * 
 * (C) Copyright:       S.Yamamoto  2000 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: SIP2-util.c,v 30.3 2002/12/22 13:31:12 yamamoto Exp yamamoto $";
#endif

#include "SIP2.h"
#include "SIP2-proto.h"

static SpdString    str = NULL;

void sipInitValueDataInt(void)
{
    if (str != NULL) {
        spdFree(str);
        str = NULL;
    }
}

int sipCastValueDataInt(SpdValueData val)
{
    switch (val.type) {
      case SpdValue_Integer:
        return val.v.intval;
      case SpdValue_Unsigned_Integer:
        return (int)val.v.uintval;
      case SpdValue_Pointer:
        /* Modified by S.Yamamoto 2000/12/21. */
        /* 
         * tmp = sipGetString(val.v.ptr.areaId);
         * spdFree(tmp);
         * return (int)(tmp);
         */

        /* 
         * if (str != NULL) {
         *     spdFree(str);
         * }
         */
        spdSafetyFree(str);

        str = sipGetString(val.v.ptr.areaId);
        return ((int)(str));
      case SpdValue_RealPointer:
        return (int)val.v.pointerval;
      case SpdValue_FuncPointer:
        return (int)val.v.funcId;
      default:
        spdWarning("sipCastValueDataInt(): Invalid data type.\n");
        return -1;
    }
}
