/* 
 * Program:             $RCSfile: stack.c,v $  $Revision: 30.3 $
 * 
 * Purpose:
 * 
 * Author:              H.Suzuki  1998/11/06
 *                      S.Yamamoto  1998/11/06
 * 
 * (C) Copyright:       H.Suzuki and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: stack.c,v 30.3 2003/06/22 08:42:33 yamamoto Exp yamamoto $";
#endif

#include "SIP2.h"

/*** å/ ***/

SipStack *sipCreateStack(size_t elemSize)
{
    SipStack *stk = (SipStack *)spdMalloc(sizeof(SipStack));

    stk->size = 0;
    stk->elemSize = elemSize;
    stk->elem = NULL;

    return stk;
}

void sipFreeStack(SipStack *stk)
{
    int i;

    if (stk != NULL) {
        for (i = 0; i < stk->size; i++) spdFree(stk->elem[i]);
        spdFree(stk->elem);
        spdFree(stk);
    }
}

/*** å ***/

void sipPushStack(void *elem, SipStack *stk)
{
    stk->size++;
    stk->elem = (void **)spdRealloc(stk->elem, stk->elemSize * stk->size);
    stk->elem[stk->size - 1] = elem;
}

void *sipPopStack(SipStack *stk)
{
    void *retElem;

    if (stk->size == 0) return NULL;

    retElem = stk->elem[stk->size - 1];
    stk->size--;
    /* !! popΤȤrealloc()ƤϤʤ? */
    /* 
     * stk->elem = (void **)spdRealloc(stk->elem, stk->elemSize * stk->size);
     */
    return retElem;
}

void *sipGetTopOfStack(SipStack *stk)
{
    /* 
     * if (stk->size < 1) return NULL;
     * else return (stk->elem[stk->size - 1]);
     */

    return ((stk->size < 1) ? NULL : stk->elem[stk->size - 1]);
}

/*** Ǻ ***/
SipEvalStackElem *sipCreateEvalStackElem(void)
{
    SipEvalStackElem *esElem;

    esElem = (SipEvalStackElem *)spdMalloc(sizeof(SipEvalStackElem));
    return esElem;
}
