/* 
 * Program:             $RCSfile: step.c,v $  $Revision: 30.28 $
 * 
 * Purpose:
 * 
 * Author:              H.Suzuki  1998/11/06
 *                      S.Yamamoto  1998/11/06
 * Modified:            H.Ohkubo  2001/03/25
 * 
 * (C) Copyright:       H.Suzuki, H.Ohkubo and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: step.c,v 30.28 2003/07/08 06:21:46 yamamoto Exp yamamoto $";
#endif

#include <limits.h>
#include "SIP2.h"
#include "SIP2-proto.h"

/* SpdValueDataTRUE(0ʳ)ݤȽǤ롥 */

static SpdBoolean isTrue(SpdValueData val)
{
    if (spdCastValueDataInt(val) != 0) return TRUE;
    else return FALSE;
}

/* curId  statement ܤä nextId  statement 
   ˼¹Ԥ٤ expression ֤
   ̤ nextId κǽ˼¹Ԥ٤Ǥ褤
   curId  nextId δ֤ next_stmt ط NEXTSTMT_LOOPBACK Ǥ
   nextId  FOR ʸǤäϷ֤ˤʤ롥*/

static SpdObjId get1stExpressionOfStatement(SpdObjId curId, SpdObjId nextId)
{
    SpdObjId exprId;
    SpdClassId relClassId;
    SpdSet2 nextStmtSet;
    SpdRel *pRel;
    SetCursor csr;

    /* !! nextId Υ饹 SPD_CID_STATEMENT ǤʤȤϡ
      ɤƤΤ狼ʤΤǥåפƤ˼
      ... getFirstExpressionOfStatement() Ǥ⤽ʤäƤ*/

    if (spdGetClassId(nextId) != SPD_CID_STATEMENT) {
        curId = nextId;
        nextId = spdGetAChildObjId(curId, SPD_RID_NEXT_STMT);
        exprId = get1stExpressionOfStatement(curId, nextId);
        return exprId;
        /* !!  goto Ǥ񤭤Ȥ
          ѥ餬ˤƤȤ*/
    }

    /* nextIdsortʬह롥 */
    switch (spdGetAttrIntValByName(nextId, "sort")) {
      case STATE_FOR :
        /* !! LOOPBACK 褿ɤǶ̤롥*/
        relClassId = SPD_RID_FOR_EXPR;
        nextStmtSet = spdGetChildRelSet(curId, SPD_RID_NEXT_STMT);
        for (csr = spdSetCursorCreate(nextStmtSet); spdSetCursorNext(&csr);) {
            pRel = spdSetGetValueP(csr.curElem->value);
            if ( pRel->objectId == nextId &&
                spdGetAttrIntValByName(pRel->relationId, "sort") ==
                NEXTSTMT_LOOPBACK) {
                relClassId = SPD_RID_ITER_EXPR;
                break;
            }
        }
        spdFreeSet2(nextStmtSet);
        break;

      case STATE_NORMAL :
        relClassId = SPD_RID_STMT_EXPR;
        break;

      case STATE_IF :
      case STATE_WHILE :
      case STATE_SWITCH :
      case STATE_DO :
        relClassId = SPD_RID_COND_EXPR;
        break;

      case STATE_BLOCK :
      case STATE_BREAK :
      case STATE_CONTINUE :
      case STATE_GOTO :
        /* !! ѥƱɤ2ٽФȵ͡*/
        curId = nextId;
        nextId = spdGetAChildObjId(curId, SPD_RID_NEXT_STMT);
        exprId = get1stExpressionOfStatement(curId,nextId);
        return exprId;

      case STATE_RETURN :
        /* return ΤȤϤ˿ƤȤɬפꤽʤΤɲ */
        /* !! **äƤΤϲʤΤƤ ;_; */
        exprId = spdGetAChildObjId(nextId, SPD_RID_RETURN_EXPR);
        exprId = spdGetAParentObjId(exprId, SPD_RID_EXPR_EXPR);
        return exprId;

      default:
        spdErrorExit("Invalid sort of nextId: nextId %d, sort %d.\n",
                     nextId, spdGetAttrIntValByName(nextId, "sort"));
    }
    exprId = spdGetAChildObjId(nextId, relClassId);
    return exprId;
}

/* ؿƽлdeclaratorǽ˼¹Ԥ٤expression򸡺֤ */

SpdObjId sipGetExpressionFromFuncDecr(SpdObjId funcDecrId)
{
    SpdObjId declId, funcId, stmtId, exprId = SPD_NON_ID;

    if (spdGetClassId(funcDecrId) == SPD_CID_DECLARATOR) {
        declId = spdGetAParentObjId(funcDecrId, SPD_RID_DECL_DECL);
        funcId = spdGetAChildObjId(declId, SPD_RID_FUNC_SFUNC);
        stmtId = spdGetAChildObjId(funcId, SPD_RID_SFUNC_STMT);

        /* exprId = getFirstExpressionOfStatement(stmtId); */
        exprId = get1stExpressionOfStatement(SPD_NON_ID,stmtId);
        /* !! ʤȤפ*/
    }
    return exprId;
}

/* ߤμ¹ʸ while, do-while, for ξˡ˼¹Ԥʸõ */

static SpdObjId getConditionalNext(SpdObjId condStmtId, SpdBoolean cond)
{
    SpdSet2 nextStmtSet;
    SpdObjId nextStmt = SPD_NON_ID;
    SpdRel *pRel;
    int sort;
    SetCursor csr;

    /* next_stmtν롥ǿġ */
    nextStmtSet = spdGetChildRelSet(condStmtId, SPD_RID_NEXT_STMT);

    /* (cond)ξϴطsortNEXTSTMT_CONTROL
       (!cond)ξϤǤʤ֡ */
    for (csr = spdSetCursorCreate(nextStmtSet); spdSetCursorNext(&csr);) {
        pRel = spdSetGetValueP(csr.curElem->value);
        sort = spdGetAttrIntValByName(pRel->relationId, "sort");
        if (cond ^ sort != NEXTSTMT_CONTROL) {
            /*
             * ((cond && sort == NEXTSTMT_CONTROL) ||
             *  (!cond && sort != NEXTSTMT_CONTROL)) ƱäƤ狼?
             */
                nextStmt = pRel->objectId;
                break;
            }
    }

    /* Ȥޤġ*/
    spdFreeSet2(nextStmtSet);

    return nextStmt;
}

/* ifʸthenelseΡ˼¹Ԥʸõ */

static SpdObjId getIfTrueFalseNext(SpdObjId ifStmtId, SpdObjId bodyBlock)
{
    SpdObjId nextStmt = SPD_NON_ID, nextBlock;
    SpdSet2 nextStmtSet;
    SetCursor csr;
  
    /* next_stmt ν ǿ */
    nextStmtSet = spdGetChildRelSet(ifStmtId, SPD_RID_NEXT_STMT);
  
    /* 줫ǤϤ block_stmt ʿƤ bodyBlock ʤϤ
       줬᤿ statement Ǥ롥*/
    for (csr = spdSetCursorCreate(nextStmtSet); spdSetCursorNext(&csr);) {
        nextStmt = ((SpdRel *)spdSetGetValueP(csr.curElem->value))->objectId;
        nextBlock = spdGetAParentObjId(nextStmt, SPD_RID_BLOCK_STMT);
        if (nextBlock == bodyBlock) break;
        if (nextStmt == bodyBlock) break;   /* !! ʤǤ㡥*/
    }
  
    /* Ȥޤġ*/
    spdFreeSet2(nextStmtSet);
  
    return nextStmt;
}

/* ߤμ¹ʸif true ξˡ˼¹Ԥʸõ */

static SpdObjId getIfTrueNext(SpdObjId ifStmtId)
{
    SpdObjId controlBodyBlock;

    /* control_body  block 롥ʤ餺롥*/
    controlBodyBlock = spdGetAChildObjId(ifStmtId, SPD_RID_CONTROL_BODY);

    /* next_stmt ǤäƤΤõ*/
    return getIfTrueFalseNext(ifStmtId, controlBodyBlock);
}

/* ߤμ¹ʸif false ξˡ˼¹Ԥʸõ */

static SpdObjId getIfFalseNext(SpdObjId ifStmtId)
{
    SpdObjId elseBodyBlock;

    /* else_body  block 롥1ġ*/
    elseBodyBlock = spdGetAChildObjId(ifStmtId, SPD_RID_ELSE_BODY);

    /* 줬ʤ顤next_stmt ǤäƤΤõ*/
    if (elseBodyBlock != SPD_NON_ID) {
        return getIfTrueFalseNext(ifStmtId, elseBodyBlock);
    } else {
        /* ʤä顤val = 0 Ȥ while, do-while, for ξƱ*/
        return getConditionalNext(ifStmtId, FALSE);
    }
}

/* 2ĤSpdValueDataӤ == (0), > (1), < (-1)֤ */

static int compareValueDataInt(SpdValueData val1, SpdValueData val2)
{
    if (val1.type == SpdValue_NonValue || val2.type == SpdValue_NonValue)
        return -1;
    else
        return (sipCastValueDataInt(val1) - sipCastValueDataInt(val2));
}

/* Switch statement. */

static SpdObjId getSwitchNext(SpdObjId condStmtId, SpdValueData val)
{
    SpdSet2 nextStmtSet;
    SetCursor csr;
    SpdObjId cexprId;
    SpdObjId nextStmtId = SPD_NON_ID, tmpStmtId;
    SpdValueData caseVal;

    nextStmtSet = spdGetChildRelSet(condStmtId, SPD_RID_NEXT_STMT);

    for (csr = spdSetCursorCreate(nextStmtSet); spdSetCursorNext(&csr);) {
        tmpStmtId = ((SpdRel *)spdSetGetValueP(csr.curElem->value))->objectId;
        /* 
         * !! ʤȤΤ补
         * if (pNextStmtId == NULL) {
         *     continue;
         * }
         */
        if (spdGetClassId(tmpStmtId) == SPD_CID_LABEL &&
            spdGetAttrIntValByName(tmpStmtId, "sort") == LABEL_CASE) {
            cexprId = spdGetAChildObjId(tmpStmtId, SPD_RID_CASE_CEXPR);
            caseVal = sipEvalExpression(cexprId);
            if (compareValueDataInt(val, caseVal) == 0) {
                nextStmtId = tmpStmtId;
                break;
            }
        } else {
            /* default / ʸΤȤϲꤷƤ */
            /* default٥ȼʸξNEXT_STMT뤳ȤϤꤨʤ */
            nextStmtId = tmpStmtId;
        }
    }
    spdFreeSet2(nextStmtSet);
    return nextStmtId;
}

/* exprIdμ˼¹Ԥ뼰롥 */

static SpdObjId sipGetNextExpression(SpdObjId exprId, SpdValueData val)
{
    SpdObjId parentId;
    int parentSort;
    SpdObjId nextExprId = SPD_NON_ID, nextStmtId = SPD_NON_ID;

    do {                                    /* break 뤿 */
        /* ʸ   */
        parentId = spdGetAParentObjId(exprId, SPD_RID_STMT_EXPR);
        if (parentId != SPD_NON_ID) {
            nextStmtId = spdGetAChildObjId(parentId, SPD_RID_NEXT_STMT);
            break;
        }

        /* Ｐ  ̤ˤäѤ뤷ʸˤäƤ㤦 */
        parentId = spdGetAParentObjId(exprId, SPD_RID_COND_EXPR);
        if (parentId != SPD_NON_ID) {
            parentSort = spdGetAttrIntValByName(parentId, "sort");
            switch (parentSort) {
              case STATE_IF :
                if (isTrue(val))
                    nextStmtId = getIfTrueNext(parentId);
                else
                    nextStmtId = getIfFalseNext(parentId);
                break;
              case STATE_SWITCH :
                nextStmtId = getSwitchNext(parentId, val);
                break;
              default :
                nextStmtId = getConditionalNext(parentId, isTrue(val));
                break;
            }
            break;
        }

        /* FOR  Ｐ */
        parentId = spdGetAParentObjId(exprId, SPD_RID_FOR_EXPR);

        if (parentId != SPD_NON_ID) {
            nextExprId = spdGetAChildObjId(parentId, SPD_RID_COND_EXPR);
            break;
        }

        /* FOR ֤  Ｐ */ 
        parentId = spdGetAParentObjId(exprId, SPD_RID_ITER_EXPR);
        if (parentId != SPD_NON_ID) {
            nextExprId = spdGetAChildObjId(parentId, SPD_RID_COND_EXPR);
            break;
        }

        /* ɤǤʤϤȤꤢ */
        /* !! äơꥸʥΤ stmtId  SPD_NON_ID ʤɡ*/
        exit(1);                            /* !! sapid-emergency-break äƤɤʴؿʤ? */
        /*      nextStmtId = spdGetAChildObjId(stmtId, SPD_RID_NEXT_STMT);
         *      break;
         */
    } while (0);                            /* break Τ */

    /* ФڤȤä˷̤κǽå */
    /* !! ȤΤ⡤ޤǤν nextStmtId ׻ˤ⤫餺
      ̤ SPD_NON_ID Ǥ⤢ꤦΤɤ狼ʤä顥
      ϤȤäƤ⤤褦ˤʤäƤ롥
      ⤷ȤϤʤȤˤʤäƤʤ顤sentinel ʤȤ鷺
      goto Фƥȥ졼Ȥ˽ۤ褤*/

    if (nextExprId == SPD_NON_ID) {
        if (nextStmtId == SPD_NON_ID) {   /* ǸޤǤɤ⻻ФǤʤäȤϡؿƽФνλ */
            sipFreePoppedCallStack();
            sipSetTrvStackOfCallStack();
            return (sipGetProgramPtr());
            /* !! Ǥʤ֤sipGoStep() Ǥ᤿!? */
        } else {
            /* expr Ϸޤʤ stmt Ϸޤäʤ顤˿ʤࡥ*/
            /* !! ΤȤparentId ɬ exprId ޤʸǤꡤ
              parentId  nextStmtId δ֤ˤ next_stmt ط롥
              ǡδط° NEXTSTMT_LOOPBACK Ǥ꤫褬 for ʸǤ
              ȤϡƬǤϤʤ֤˹Ԥ
              ȤޤǴޤ getFirstExpressionOfStatement() ¤Τᤤ*/
            nextExprId = get1stExpressionOfStatement(parentId,nextStmtId);
        }
    }

    return nextExprId;
}

/* Step execution. */

void sipGoStep(void)
{
    SpdObjId        prgPtr;
    SpdValueData    val;

    prgPtr = sipGetProgramPtr();
    val = sipEvalExpression(prgPtr);

    /* stepư(ؿƽФɾƤɾprgPtrۤʤ) */
    if (sipGetProgramPtr() == prgPtr) {
        sipSetProgramPtr(sipGetNextExpression(prgPtr, val));
    }
}

/* Next execution (Commented by S.Yamamoto 2000/12/17). */
/* 
 * void sipGoNext(void)
 * {
 * }
 */
