/* 
 * Program:             $RCSfile: system.c,v $  $Revision: 30.5 $
 * 
 * Purpose:
 * 
 * Author:              H.Suzuki  1998/11/06
 *                      S.Yamamoto  1998/11/06
 * 
 * (C) Copyright:       H.Suzuki and S.Yamamoto  1998 - 2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: system.c,v 30.5 2000/12/21 09:54:51 yamamoto Exp yamamoto $";
#endif

#include "SIP2.h"
#include "SIP2-proto.h"

static SipFuncSet opeFuncs;

void sipSetOpeFunc(int opeSort, SipOpeFunc func)
{
    SipOpeFunc oldFunc;

    oldFunc = (SipOpeFunc)spdSearchElem(opeFuncs, opeSort);
    if (oldFunc) spdDelElem(opeFuncs, opeSort);
    spdAddElem(opeFuncs, opeSort, (Contents)&func);
}

SipOpeFunc sipGetOpeFunc(int opeSort)
{
    SipOpeFunc *retFunc;

    retFunc = (SipOpeFunc *)spdSearchElem(opeFuncs, opeSort);
    if (retFunc) return *retFunc;
    else return NULL;
}

void sipBegin(void)
{
    sipCreateCallStack();
    sipCreateEvalStack();
    opeFuncs = spdCreateSet(sizeof(SipOpeFunc));
    sipInitOpeFunc();
    sipInitLibAccessTable();
    sipInitValueDataInt();
    initSpdTrvInfo();
}

void sipEnd(void)
{
    sipFreeCallStack();
    sipFreeEvalStack();
    spdFreeSet(opeFuncs);
    sipFreeLibAccessTable();
    sipInitValueDataInt();
    freeSpdTrvInfo();
}
