/* 
 * Program:             $RCSfile: methods.c,v $  $Revision: 30.4 $
 * 
 * Purpose:             "Imakefile" of Sapid/tool/SIP/sip.
 *
 * Author:              N.Kurauchi  1997/02/08
 *                      S.Yamamoto  1996/02/08
 *
 * (C) Copyright:       N.Kurauchi and S.Yamamoto  1997 - 1998
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: methods.c,v 30.4 2002/10/21 07:28:29 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "SaQuLa.h"

extern SpdBoolean first_appear;

SymTable *
getOcc(SymTable *arg1, SpdString arg2)
{
    SymTable *sp;
    int i;
    char *buf;

    buf = spdMalloc(strlen(arg1->name)+strlen(arg2)+2);
    sprintf(buf,"%s.%s",arg1->name, arg2);
    sp = symlook(buf);
    if(first_appear == FALSE) return(sp);
    
    sp->type = OCCTABLE;
    sp->meta_type = STRUCTURE;

    for(i=0;i<arg1->value.objid_table.size;i++){
        sp->value.occ_struct.master
            = spdRealloc(sp->value.occ_struct.master,
                         sizeof(SpdObjId)*i+1);
        sp->value.occ_struct.master[i] = arg1->value.objid_table.oiv[i].id;
        sp->value.occ_struct.occ_table
            = spdRealloc(sp->value.occ_struct.occ_table,
                         sizeof(SpdOccArray)*(i+1));
        sp->value.occ_struct.occ_table[i]
            = spdGetIncludedOccArray(arg1->value.objid_table.oiv[i].id,
                                     arg2, SPD_NON_ID, NULL);
    }
    sp->value.occ_struct.size = i;
    return(sp);
}

SymTable *
convItoC(SymTable *arg1)
{
    SymTable *sp;
    int i;
    char *buf;

    SpdCursor *csr;
    SpdOcc occ;

    buf = spdMalloc(strlen(arg1->name)+strlen("ConvItoC")+2);
    sprintf(buf, "%s.ConvItoC", arg1->name);
    sp = symlook(buf);
    if(first_appear == FALSE) return(sp);

    sp->type = OBJIDTABLE;
    sp->meta_type = SET;

    if(arg1->msp == NULL) sp->msp = arg1;
    else sp->msp = arg1->msp;

    sp->value.objid_table.oiv = NULL;
    sp->value.objid_table.size = 0;

    for(i=0;i<arg1->value.objid_table.size;i++){
        if(arg1->value.objid_table.oiv[i].offset == SPD_NON_OFFSET){
            csr = spdGetOffsetOfObjInit(arg1->value.objid_table.oiv[i].id);
            while((occ=spdGetOffsetOfObj(csr)).objectId != SPD_NON_ID){
                if(spdIsInHeaderFile(occ.fileId,occ.offset)==FALSE){
                    sp->value.objid_table.oiv
                        = spdRealloc(sp->value.objid_table.oiv,
                                     sizeof(ObjIdValue)*(sp->value.objid_table.size+1));
                    sp->value.objid_table.oiv[sp->value.objid_table.size].id
                        = occ.objectId;
                    sp->value.objid_table.oiv[sp->value.objid_table.size].offset
                        = occ.offset;
                    sp->value.objid_table.oiv[sp->value.objid_table.size].rel_id
                        = occ.relationId;
                    if(arg1->value.objid_table.oiv[i].masternum == UNSUBORDINARY)
                        sp->value.objid_table.oiv[sp->value.objid_table.size].masternum
                            = i;
                    else
                        sp->value.objid_table.oiv[sp->value.objid_table.size].masternum
                            = arg1->value.objid_table.oiv[i].masternum;
                    sp->value.objid_table.size++;
                }
            }
            spdFreeCursor(csr);
        }
        else{
            csr = spdGetOffsetOfObjInit(arg1->value.objid_table.oiv[i].id);
            while((occ=spdGetOffsetOfObj(csr)).objectId != SPD_NON_ID){
                if(occ.relationId==arg1->value.objid_table.oiv[i].rel_id){
                    if(spdIsInHeaderFile(occ.fileId,occ.offset)==FALSE){
                        sp->value.objid_table.oiv
                            = spdRealloc(sp->value.objid_table.oiv,
                                         sizeof(ObjIdValue)*(sp->value.objid_table.size+1));
                        sp->value.objid_table.oiv[sp->value.objid_table.size].id
                            = arg1->value.objid_table.oiv[i].id;
                        sp->value.objid_table.oiv[sp->value.objid_table.size].offset
                            = occ.offset;
                        sp->value.objid_table.oiv[sp->value.objid_table.size].rel_id
                            = occ.relationId;
                        if(arg1->value.objid_table.oiv[i].masternum == UNSUBORDINARY)
                            sp->value.objid_table.oiv[sp->value.objid_table.size].masternum
                                = i;
                        else
                            sp->value.objid_table.oiv[sp->value.objid_table.size].masternum
                                = arg1->value.objid_table.oiv[i].masternum;
                        sp->value.objid_table.size++;
                    }
                }
            }
            spdFreeCursor(csr);
        }
    }
    return(sp);
}
