/* 
 * Program:             $RCSfile: where.c,v $  $Revision: 30.5 $
 * 
 * Purpose:
 *
 * Author:              N.Kurauchi  1997/02/08
 *                      S.Yamamoto  1996/02/08
 *
 * (C) Copyright:       N.Kurauchi and S.Yamamoto  1997 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: where.c,v 30.5 2003/06/28 15:33:47 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "SaQuLa.h"

SufTable presuftable = SUF_SPD_EMPTY_ARRAY, nsuftable = SUF_SPD_EMPTY_ARRAY,
postsuftable = SUF_SPD_EMPTY_ARRAY, suftable = SUF_SPD_EMPTY_ARRAY;

extern BddTable bddtable[];
extern int val_num;

extern ReserveTable reservetable;

BddTable *bddlook(Ope ope, void *rs, void *ls)
{
    BddTable *bp;

    for(bp = bddtable; bp < &bddtable[BDDTABLE_MAX]; bp++){
        if(bp->ope && (bp->ope==ope) && (bp->rs==rs) && (bp->ls==ls)){
            return bp;
        }
        if(!bp->ope){
            bp->ope = ope;
            bp->rs = rs;
            bp->ls = ls;
            if(ope == EQUAL || ope == NOTEQUAL){
                bp->val_num = val_num; val_num++;
                bp->bddp = bddprime(bp->val_num);
            }
            return bp;
        }
    }
    spdErrorExit("Too many boolean expressions\n");
    SPD_DUMMY_RETURN(NULL);
}

SpdBooleanArrayArray getSufResult(BddTable *btp)
{
    SpdBooleanArrayArray return_value = SPD_EMPTY_ARRAY;
    SpdBooleanArray ba = SPD_EMPTY_ARRAY;
    int i, j, n = 1, m;
    bddp f;
    
    for(i=0;i<val_num-1;i++){
        n *= 2;
        ba.value = spdRealloc(ba.value, sizeof(SpdBoolean)*(i+1));
        ba.value[i] = FALSE;
    }
    ba.size = i;
    
    for(i=0;i<n;i++){
        m=i;
        for(j=0;j<val_num-1;j++){
            if((m & 1) == 1) ba.value[j] = TRUE;
            else ba.value[j] = FALSE;
            m >>= 1;
        }
        f = btp->bddp;
        for(j=1;j<val_num;j++){
            /*      printf("%d,",ba.value[j-1]);*/
            f = bddrstr(f, j, ba.value[j-1]);
        }
        if(f == bddtrue()){
            return_value.array
                = spdRealloc(return_value.array,
                             sizeof(SpdBooleanArray)*(return_value.size+1));
            return_value.array[return_value.size].value = NULL;
            for(j=0;j<ba.size;j++){
                return_value.array[return_value.size].value
                    = spdRealloc(return_value.array[return_value.size].value,
                                 sizeof(SpdBoolean)*(j+1));
                return_value.array[return_value.size].value[j] = ba.value[j];
            }
            return_value.array[return_value.size].size = ba.size;
            return_value.size++;
            /*      printf("true\n");*/
        }
        /*  else printf("false\n");*/
    }
    /*    for(i=0;i<return_value.size;i++){
          for(j=0;j<return_value.array[i].size;j++){
          printf("%d,",return_value.array[i].value[j]);
          }
          printf("\n");
          }*/
    return return_value;
}

void checkBddTable(SpdBooleanArrayArray table)
{
    int i, j, pre, n, k, l;
    BddTable *bp;

    for(i=0;i<table.size;i++){
        for(j=0;j<table.array[i].size;j++){
            bp = getBddTable(j+1);
            switch(table.array[i].value[j]) {
              case TRUE:
                checkCom(bp->ope, (SymTable *)bp->rs, (SymTable *)bp->ls);
                break;
              case FALSE:
                if(bp->ope == EQUAL)
                    checkCom(NOTEQUAL, (SymTable *)bp->rs, (SymTable *)bp->ls);
                else
                    checkCom(EQUAL, (SymTable *)bp->rs, (SymTable *)bp->ls);
                break;
            }
            if(presuftable.sp)
                for(pre=0;pre<presuftable.size;pre++){
                    for(n=0;n<nsuftable.size;n++){
            
                        if(presuftable.sp[pre] == nsuftable.sp[n])
            
                            for(k=0;k<presuftable.num[pre].size;k++){
                                for(l=0;l<nsuftable.num[n].size;l++){
                                    if(presuftable.num[pre].num[k]
                                       == nsuftable.num[n].num[l]){
                                        putSufSpToPost(nsuftable.sp[n],
                                                       nsuftable.num[n].num[l]);
                                    }
                                }
                            }
                    }
                }
            if(j != 0){
                presuftable.size = postsuftable.size;
                presuftable.sp = postsuftable.sp;
                presuftable.num = postsuftable.num;
            }
            else{
                presuftable.size = nsuftable.size;
                presuftable.sp = nsuftable.sp;
                presuftable.num = nsuftable.num;
            }
            nsuftable.size = 0;postsuftable.size = 0;
            nsuftable.sp = NULL;postsuftable.sp = NULL;
            nsuftable.num = NULL;postsuftable.num = NULL;
        }
        setSufResult();
        presuftable.size = 0;
        presuftable.sp = NULL;
        presuftable.num = NULL;
    }
    return;
}

BddTable *getBddTable(int arg)
{
    BddTable *bp;

    for(bp = bddtable; bp < &bddtable[BDDTABLE_MAX]; bp++){
        if(bp->val_num == arg){
            return bp;
        }
    }
    spdErrorExit("bddtable error\n");
    SPD_DUMMY_RETURN(NULL);
}

void checkCom(Ope ope, SymTable *rs, SymTable *ls)
{
    int r,l;

    if(rs->type != ls->type) return;
    
    switch(rs->type) {
      case INTTABLE:
        for(l=0;l<ls->value.int_table.size;l++){
            for(r=0;r<rs->value.int_table.size;r++){
                if(ope == EQUAL &&
                   rs->value.int_table.iv[r].value
                   == ls->value.int_table.iv[l].value){
                    if(rs->msp)
                        putSufSp(rs->msp, rs->value.int_table.iv[r].masternum);
                    if(ls->msp)
                        putSufSp(ls->msp, ls->value.int_table.iv[l].masternum);
                } else if(ope == NOTEQUAL &&
                          rs->value.int_table.iv[r].value
                          != ls->value.int_table.iv[l].value){
                    if(rs->msp)
                        putSufSp(rs->msp, rs->value.int_table.iv[r].masternum);
                    if(ls->msp)
                        putSufSp(ls->msp, ls->value.int_table.iv[l].masternum);
                }
            }
        }
        break;
      case STRINGTABLE:
        for(l=0;l<ls->value.string_table.size;l++){
            for(r=0;r<rs->value.string_table.size;r++){
                if(ope == EQUAL &&
                   SPD_STREQ(rs->value.string_table.sv[r].value,
                             ls->value.string_table.sv[l].value)){
                    if(rs->msp)
                        putSufSp(rs->msp, rs->value.string_table.sv[r].masternum);
                    if(ls->msp)
                        putSufSp(ls->msp, ls->value.string_table.sv[l].masternum);
                } else if(ope == NOTEQUAL &&
                          strcmp(rs->value.string_table.sv[r].value,
                                 ls->value.string_table.sv[l].value)){
                    if(rs->msp)
                        putSufSp(rs->msp, rs->value.string_table.sv[r].masternum);
                    if(ls->msp)
                        putSufSp(ls->msp, ls->value.string_table.sv[l].masternum);
                }
            }
        }
        break;
      case OBJIDTABLE:
        for(l=0;l<ls->value.objid_table.size;l++){
            for(r=0;r<rs->value.objid_table.size;r++){
                if(ope == EQUAL &&
                   rs->value.objid_table.oiv[r].id
                   == ls->value.objid_table.oiv[l].id){
                    if(rs->msp)
                        putSufSp(rs->msp, rs->value.objid_table.oiv[r].masternum);
                    if(ls->msp)
                        putSufSp(ls->msp, ls->value.objid_table.oiv[r].masternum);
                }
                else if(ope == NOTEQUAL &&
                        rs->value.objid_table.oiv[r].id
                        != ls->value.objid_table.oiv[l].id){
                    putSufSp(rs->msp, rs->value.objid_table.oiv[r].masternum);
                    if(ls->msp)
                        putSufSp(ls->msp, ls->value.objid_table.oiv[r].masternum);
                }
            }
        }
        break;
    }
}

void putSufSp(SymTable *msp, int num)
{
    int i;
    SpdBoolean flag;

    flag = FALSE;
    for(i=0;i<nsuftable.size;i++){
        if(nsuftable.sp[i] &&
           nsuftable.sp[i] == msp){
            flag = TRUE;
            break;
        }
        if(!nsuftable.sp[i]) break;
    }
    
    if(flag == FALSE){
        nsuftable.size++;
        nsuftable.sp
            = (SymTable **)spdRealloc(nsuftable.sp,
                                      sizeof(SymTable *)*(i+1));
        nsuftable.sp[i] = msp;
        nsuftable.num
            = (SufNumArray *)spdRealloc(nsuftable.num,
                                        sizeof(SufNumArray)*(i+1));
        nsuftable.num[i].num = NULL;
        nsuftable.num[i].num
            = (int *)spdRealloc(nsuftable.num[i].num,
                                sizeof(int));
        nsuftable.num[i].num[0] = num;
        nsuftable.num[i].size = 1;
        return;
    }
    else{
        nsuftable.num[i].num
            = (int *)spdRealloc(nsuftable.num[i].num,
                                sizeof(int)*(nsuftable.num[i].size+1));
        nsuftable.num[i].num[nsuftable.num[i].size] = num;
        nsuftable.num[i].size++;
        return;
    }
}

void putSufSpToPost(SymTable *msp, int num)
{
    int i;
    SpdBoolean flag;

    flag = FALSE;
    for(i=0;i<postsuftable.size;i++){
        if(postsuftable.sp[i] &&
           postsuftable.sp[i] == msp){
            flag = TRUE;
            break;
        }
        if(!postsuftable.sp[i]) break;
    }
    
    if(flag == FALSE){
        postsuftable.size++;
        postsuftable.sp
            = (SymTable **)spdRealloc(postsuftable.sp,
                                      sizeof(SymTable *)*(i+1));
        postsuftable.sp[i] = msp;
        postsuftable.num
            = (SufNumArray *)spdRealloc(postsuftable.num,
                                        sizeof(SufNumArray)*(i+1));
        postsuftable.num[i].num = NULL;
        postsuftable.num[i].num
            = (int *)spdRealloc(postsuftable.num[i].num,
                                sizeof(int));
        postsuftable.num[i].num[0] = num;
        postsuftable.num[i].size = 1;
        return;
    }
    else{
        postsuftable.num[i].num
            = (int *)spdRealloc(postsuftable.num[i].num,
                                sizeof(int)*(postsuftable.num[i].size+1));
        postsuftable.num[i].num[postsuftable.num[i].size] = num;
        postsuftable.num[i].size++;
        return;
    }
}

void setSufResult(void)
{
    int i,j,k;
    SpdBoolean flag;

    for(i=0;i<presuftable.size;i++){
        flag = FALSE;
        for(k=0;k<suftable.size;k++){
            if(suftable.sp[k] &&
               suftable.sp[k] == presuftable.sp[i]){
                flag = TRUE;
                break;
            }
            if(!suftable.sp[k]) break;
        }

        if(flag == FALSE){
            suftable.size++;
            suftable.sp
                = (SymTable **)spdRealloc(suftable.sp,
                                          sizeof(SymTable *)*(k+1));
            suftable.sp[k] = presuftable.sp[i];
            suftable.num
                = (SufNumArray *)spdRealloc(suftable.num,
                                            sizeof(SufNumArray)*(k+1));
            suftable.num[k].num = NULL;
            suftable.num[k].size = 0;
        }
    
        for(j=0;j<presuftable.num[i].size;j++){
            suftable.num[k].num
                = (int *)spdRealloc(suftable.num[k].num,
                                    sizeof(int)*(suftable.num[k].size+1));
            suftable.num[k].num[suftable.num[k].size]
                = presuftable.num[i].num[j];
            suftable.num[k].size++;
        }
    }
}

SymTable *getSufQuery(void)
{
    SymTableArray rv = SPD_EMPTY_ARRAY;
    SymTable *sp, *bsp;
    char *buf;
    int i, j;
    SpdBoolean flag;
    
    for(i=0;i<suftable.size;i++){
        buf = (char *)spdMalloc(strlen(suftable.sp[i]->name)+3);
        sprintf(buf,"%s%d",suftable.sp[i]->name,i);
        sp = symlook(buf);
        spdFree(buf);
        sp->type = suftable.sp[i]->type;
        sp->value.objid_table.oiv = NULL;

        for(j=0;j<suftable.num[i].size;j++){
            sp->value.objid_table.oiv
                = spdRealloc(sp->value.objid_table.oiv,
                             sizeof(ObjIdValue)*(j+1));
            sp->value.objid_table.oiv[j].id
                = suftable.sp[i]->value.objid_table.oiv[suftable.num[i].num[j]].id;
            sp->value.objid_table.oiv[j].masternum
                = UNSUBORDINARY;
        }
        sp->value.objid_table.size = j;

        for(j=0;j<reservetable.size;j++){
            if(reservetable.arglist[j].symtablearg == suftable.sp[i]){
                bsp = sp;
                flag = TRUE;
            }
            else if(reservetable.arglist[j].symtablearg->msp
                    == suftable.sp[i]){
                bsp = reservetable.arglist[j].symtablearg;
                flag = TRUE;
            }
            else flag = FALSE;
            if(flag == TRUE){
                switch(reservetable.funcnum[j])
                    {
                      case GET_STRING_ATTRIBUTE:
                        rv.sp
                            = (SymTable **)spdRealloc(rv.sp,
                                                      sizeof(SymTable *)*(rv.size+1));
                        rv.sp[rv.size] 
                            = get_string_attribute(bsp,
                                                   reservetable.arglist[j].stringarg[0]);
                        rv.size++;
                        break;

                      case GET_INT_ATTRIBUTE:
                        rv.sp
                            = (SymTable **)spdRealloc(rv.sp,
                                                      sizeof(SymTable *)*(rv.size+1));
                        rv.sp[rv.size]
                            = get_int_attribute(bsp,
                                                reservetable.arglist[j].stringarg[0]);
                        rv.size++;
                        break;

                      case GET_BY_REL:
                        rv.sp
                            = (SymTable **)spdRealloc(rv.sp,
                                                      sizeof(SymTable *)*(rv.size+1));
                        rv.sp[rv.size]
                            = get_by_rel(bsp,
                                         reservetable.arglist[j].stringarg[0],
                                         reservetable.arglist[j].stringarg[1]);
                        rv.size++;
                        break;
            
                    }
                setValueToSp(reservetable.arglist[j].resultsp,
                             rv.sp[rv.size-1]);
            }
        }
        spdFree(sp);
    }
    if(rv.size == 0) return NULL;
    else return rv.sp[rv.size-1];
}

void setValueToSp(SymTable *arg1, SymTable *arg2)
{
    arg1->type = arg2->type;
    arg1->meta_type = arg2->meta_type;
    arg1->value = arg2->value;
}
