/* 
 * Program:             $RCSfile: main.c,v $  $Revision: 30.4 $
 * 
 * Purpose:             "Imakefile" of Sapid/tool/SIP/sip.
 *
 * Author:              N.Kurauchi  1997/02/08
 *                      S.Yamamoto  1996/02/08
 *
 * (C) Copyright:       N.Kurauchi and S.Yamamoto  1997 - 2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: main.c,v 30.4 2001/08/14 11:42:18 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "lib/SaQuLa.h"

#ifdef HAVE_UNISTD_H
#include <unistd.h>             /* For isatty(). */
#endif

extern SpdBoolean   p_option;

int main(int argc, char *argv[])
{
    FILE            *fp;
    char            *buf = NULL;
    SaqulaResult    *sp;
    int             c, i, j;
    SpdString       prog_name;
    
    while ((c = getopt(argc, argv, "P")) != EOF) {
        switch (c) {
          case 'P':
            /* Variable p_option should be defined as SpdBoolean. */
            p_option = 1;
            break;
          default:
            spdErrorExit("Invalid options '%c'.\n", c);
            break;
        }
    }
    if (optind == argc) {
        fp = stdin;

#ifdef HAVE_ISATTY
        if (isatty(fileno(stdout)) == 1) {
            spdMessage("input query >");
        }
#endif
    
    } else if (optind == (argc - 1)) {
        fp = spdFopen(argv[optind], SPD_FOPEN_RT_MODE);
    } else {
        spdErrorExit("Usage: %s [filename]\n", argv[0]);
    }

    buf = (char *)spdMalloc(sizeof(char)*INPUT_FILE_MAX_SIZE);
    buf[0] = '\0';
    while(fgets(&buf[strlen(buf)], INPUT_FILE_MAX_SIZE, fp)!=NULL);

    if ((fp == stdin) && (isatty(fileno(stdout)) == 1)) {
        spdMessage("Searching.\n");
    }
    saqulaInit();
    prog_name = smuGetAProgramName();
    sp = saqula(prog_name, buf);
    /* spdFree(prog_name); */
    spdFree(buf);

    if (sp->meta_type != STRUCTURE) {
        switch(sp->type) {
          case OBJIDTABLE:
            for(i=0; i < sp->value.objid_table.size; i++) {
                printf("%d\n",sp->value.objid_table.oiv[i].id);
            }
            break;
          case STRINGTABLE:
            for(i=0; i < sp->value.string_table.size; i++) {
                printf("%s\n",sp->value.string_table.sv[i].value);
            }
            break;
          case INTTABLE:
            for(i=0; i < sp->value.int_table.size; i++) {
                printf("%d\n",sp->value.int_table.iv[i].value);
            }
            break;
          case OCCTABLE:
            for(i=0; i < sp->value.occ_table.size; i++){
                printf("%d: %d: %d\n",
                       sp->value.occ_table.occ[i].objectId,
                       sp->value.occ_table.occ[i].fileId,
                       sp->value.occ_table.occ[i].offset);
            }
            break;
        }
    } else {
        switch(sp->type) {
          case OCCTABLE:
            for(j=0;j<sp->value.occ_struct.size;j++) {
                for(i=0;i<sp->value.occ_struct.occ_table[j].size; i++) {
                    /* Modified by S.Yamamoto 1998/04/25. */
                    /* printf("%d: %d: %d: %d\n", */
                    printf("%d: %d: %s: %d\n",
                           sp->value.occ_struct.master[j],
                           sp->value.occ_struct.occ_table[j].occ[i].objectId,
                           spdGetName(sp->value.occ_struct.occ_table[j].occ[i].fileId),
                           sp->value.occ_struct.occ_table[j].occ[i].offset);
                }
            }
            break;
          case OBJIDTABLE:
            for(j=0;j<sp->value.id_struct.size;j++) {
                for(i=0;i<sp->value.id_struct.objid_table[j].size; i++) {
                    printf("%d: %d\n",
                           sp->value.id_struct.master[j],
                           sp->value.id_struct.objid_table[j].id[i]);
                }
            }
            break;
        }
    }
    saqulaQuit();
    spdFclose(fp);

    return (EXIT_SUCCESS);
}
