/* 
 * Program:             $RCSfile: ARattr.c,v $  $Revision: 30.4 $
 * 
 * Purpose:             °ͤμ˴ؤؿ
 *
 * Author:              T.Hidaka  1997/06/27
 * Modified:            S.Yamamoto  1997/09/05
 *
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1997
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: ARattr.c,v 30.4 2002/10/21 07:28:06 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <tcl.h>
#include "tclAR.h"
#include "tclARSub.h"

int tcl_spdGetName(ClientData clientData, Tcl_Interp *interp,
                   int argc, char *argv[])
{
    SpdObjId id;
    
    /*  : oid */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &id) != TCL_OK) {
        return TCL_ERROR;
    }
    
    Tcl_SetResultString(spdGetName(id));

    return TCL_OK;
}

int tcl_spdGetLength(ClientData clientData, Tcl_Interp *interp,
                     int argc, char *argv[])
{
    SpdObjId id;
    
    /*  : oid */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &id) != TCL_OK) {
        return TCL_ERROR;
    }

    Tcl_SetResultInt(spdGetLength(id));

    return TCL_OK;
}

int tcl_spdGetOffset(ClientData clientData, Tcl_Interp *interp,
                     int argc, char *argv[])
{
    SpdObjId id;

    /*  : rid */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &id) != TCL_OK) {
        return TCL_ERROR;
    }

    Tcl_SetResultInt(spdGetOffset(id));

    return TCL_OK;
}

int tcl_spdGetAttrVal(ClientData clientData, Tcl_Interp *interp,
                      int argc, char *argv[])
{
    SpdObjId id;
    int intRes;
    
    /*  : oid °̾ */
    if (argc != 3) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &id) != TCL_OK) {
        return TCL_ERROR;
    }

    intRes = spdGetAttrValInt(id, argv[2]);
    if (intRes != SPD_NON_ID) {
        Tcl_SetResultInt(intRes);
    } else {
        Tcl_SetResultString(spdGetAttrValString(id, argv[2]));
    }

    return TCL_OK;
}

int tcl_spdGetClassId(ClientData clientData, Tcl_Interp *interp,
                      int argc, char *argv[])
{
    SpdObjId id;

    /*  : oid */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &id) != TCL_OK) {
        return TCL_ERROR;
    }

    Tcl_SetResultInt(spdGetClassId(id));

    return TCL_OK;
}

int tcl_spdGetClassName(ClientData clientData, Tcl_Interp *interp,
                        int argc, char *argv[])
{
    SpdObjId id;

    /*  : oid */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &id) != TCL_OK) {
        return TCL_ERROR;
    }

    Tcl_SetResultString(spdGetClassName(id));

    return TCL_OK;
}
