/* 
 * Program:             $RCSfile: ARinit.c,v $  $Revision: 30.13 $
 * 
 * Purpose:             AR4ν˴ؤ륳ޥɷ
 *
 * Author:              T.Hidaka  1997/06/27
 * Modified:            S.Yamamoto  1997/09/05
 *
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1997 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: ARinit.c,v 30.13 2003/06/28 15:33:25 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <tcl.h>
#include "tclAR.h"
#include "tclARSub.h"

int tcl_spdTarget(ClientData clientData, Tcl_Interp *interp,
                  int argc, char *argv[])
{
    /* : 饹̾, ̾ */

    if (argc == 3) {
        Tcl_SetResultInt(spdTarget(argv[1], argv[2]));
    } else if (argc == 2) {
        Tcl_SetResultInt(spdTarget(argv[1], smuGetAProgramName()));
    } else {
#if defined(SAPID_TCLAR4)       
        Tcl_SetResultInt(spdTarget("P-model", smuGetAProgramName()));
#else
        Tcl_SetResultInt(spdTarget("program", smuGetAProgramName()));
#endif
    }
    return TCL_OK;
}

int tcl_spdUseModel(ClientData clientData, Tcl_Interp *interp,
                    int argc, char *argv[])
{
    SpdModelId id;
    /* : ǥ̾ */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &id) != TCL_OK) {
        return TCL_ERROR;
    }

/*     if (SPD_STREQ(argv[1], "I-model")) { */
/*         Tcl_SetResultInt(spdUseModel(&I_model)); */
/*     } else if (SPD_STREQ(argv[1], "P-model")) { */
/*         Tcl_SetResultInt(spdUseModel(&P_model)); */
/*     } else if (SPD_STREQ(argv[1], "D-model")) { */
/*         Tcl_SetResultInt(spdUseModel(&D_model)); */
/*     } else if (SPD_STREQ(argv[1], "Comment-view")) { */
/*         Tcl_SetResultInt(spdUseModel(&Comment_view)); */
/*     } else if (SPD_STREQ(argv[1], "Flow-view")) { */
/*         Tcl_SetResultInt(spdUseModel(&Flow_view)); */
/*     } else if (SPD_STREQ(argv[1], "FCD-view")) { */
/*         Tcl_SetResultInt(spdUseModel(&FCD_view)); */
/*     } else { */
/*         return TCL_ERROR; */
/*     } */

    if ((id >= SPD_FIRST_MID) && (id <= SPD_LAST_MID)) {
        Tcl_SetResultInt(spdUseModel(&spdModels[id]));
    } else {
        return TCL_ERROR;
    }
    return TCL_OK;
}

int tcl_spdOpenSDB(ClientData clientData, Tcl_Interp *interp,
                   int argc, char *argv[])
{
    /* : ʤ */
    if (argc != 1) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    Tcl_SetResultInt(spdOpenSDB());
    return TCL_OK;
}

int tcl_spdReadDB(ClientData clientData, Tcl_Interp *interp,
                  int argc, char *argv[])
{
    SpdModelId modelId;
    SpdDBId dbId;
    
    /* : modelId DBId */
    if (argc != 3) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &modelId) != TCL_OK) {
        return TCL_ERROR;
    }
    if (tclAR_GetInt(interp, argv[2], &dbId) != TCL_OK) {
        return TCL_ERROR;
    }
    spdReadDB(modelId, dbId);
    return TCL_OK;
}
