/* 
 * Program:             $RCSfile: ARrel.c,v $  $Revision: 30.6 $
 * 
 * Purpose:             Ϣθ˴ؤؿ
 *
 * Author:              T.Hidaka  1997/06/27
 * Modified:            S.Yamamoto  1997/09/05
 *
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1997 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: ARrel.c,v 30.6 2003/06/22 07:27:55 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <tcl.h>
#include "tclAR.h"
#include "tclARSub.h"

int tcl_spdGetObjId(ClientData clientData, Tcl_Interp *interp,
                    int argc, char *argv[])
{
    SpdObjId id;
    SpdCursor *csr;
    char buf[40];
    
    /*  : classname, name */
    if (argc != 3) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (SPD_STREQ(argv[2], "*NULL*")) {
        csr = spdGetObjIdInit(argv[1], NULL);
    } else {
        csr = spdGetObjIdInit(argv[1], argv[2]);
    }
    while ((id = spdGetObjId(csr)) != SPD_NON_ID) {
        sprintf(buf, "%d", id);
        Tcl_AppendElement(interp, buf);
    }
    spdFreeCursor(csr);
    
    return TCL_OK;
}

int tcl_spdGetRel(ClientData clientData, Tcl_Interp *interp,
                  int argc, char *argv[])
{
    SpdObjId id;
    SpdCursor *csr;
    SpdRel rel;
    char buf[40];
    
    /*  : oid, relname, attrname */
    if (argc != 4) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &id) != TCL_OK) {
        return TCL_ERROR;
    }

    csr = spdGetRelInit(id, argv[2], argv[3]);
    while ((rel = spdGetRel(csr)).relationId != SPD_NON_ID) {
        sprintf(buf, "%d %d", rel.relationId, rel.objectId);
        Tcl_AppendElement(interp, buf);
    }
    spdFreeCursor(csr);
    
    return TCL_OK;
}

int tcl_spdGetRelObj(ClientData clientData, Tcl_Interp *interp,
                     int argc, char *argv[])
{
    SpdObjId id;
    SpdCursor *csr;
    SpdObjId relobj;
    char buf[40];
    
    /*  : oid, relname, attrname */
    if (argc != 4) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &id) != TCL_OK) {
        return TCL_ERROR;
    }

    csr = spdGetRelObjInit(id, argv[2], argv[3]);
    while ((relobj = spdGetRelObj(csr)) != SPD_NON_ID) {
        sprintf(buf, "%d", relobj);
        Tcl_AppendElement(interp, buf);
    }
    spdFreeCursor(csr);
    
    return TCL_OK;
}

int tcl_spdGetRelId(ClientData clientData, Tcl_Interp *interp,
                    int argc, char *argv[])
{
    SpdObjId id1, id2;
    SpdCursor *csr;
    SpdRelId relid;
    char buf[40];
    
    /*  : oid, relname, attrname */
    if (argc != 4) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &id1) != TCL_OK) {
        return TCL_ERROR;
    }
    if (tclAR_GetInt(interp, argv[2], &id2) != TCL_OK) {
        return TCL_ERROR;
    }

    csr = spdGetRelIdInit(id1, id2, argv[3]);
    while ((relid = spdGetRelId(csr)) != SPD_NON_ID) {
        sprintf(buf, "%d", relid);
        Tcl_AppendElement(interp, buf);
    }
    spdFreeCursor(csr);
    
    return TCL_OK;
}

int tcl_spdGetABlockId(ClientData clientData, Tcl_Interp *interp,
                    int argc, char *argv[])
{
    SpdObjId fileId;
    int offset;
    char buf[40];
    
    /*  : fileId offset */
    if (argc != 3) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &fileId) != TCL_OK) {
        return TCL_ERROR;
    }
    if (tclAR_GetInt(interp, argv[2], &offset) != TCL_OK) {
        return TCL_ERROR;
    }

    sprintf(buf, "%d", spdGetABlockId(fileId, offset));
    Tcl_AppendElement(interp, buf);

    return TCL_OK;
}
