/* 
 * Program:             $RCSfile: ARscheme.c,v $  $Revision: 30.14 $
 * 
 * Purpose:             饹̾/°̾ʤɤΥǡ١
 *                      ޤ˴ؤؿ
 *
 * Author:              T.Hidaka  1997/06/27
 * Modified:            S.Yamamoto  1997/09/05
 *
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1997 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: ARscheme.c,v 30.14 2003/06/28 15:33:26 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <tcl.h>
#include "tclAR.h"
#include "tclARSub.h"
#include "tclfilemap.h"

int tcl_spdGetClassNameById(ClientData clientData, Tcl_Interp *interp,
                            int argc, char *argv[])
{
    SpdId classId;

    /*  : class-id */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &classId) != TCL_OK) {
        return TCL_ERROR;
    }
    Tcl_SetResultString(spdGetClassNameById(classId));
    return TCL_OK;
}

int tcl_spdGetClassIdByName(ClientData clientData, Tcl_Interp *interp,
                            int argc, char *argv[])
{
    /*  : className */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    Tcl_SetResultInt(spdGetClassIdByName(argv[1]));
    return TCL_OK;
}

int tcl_spdGetAttrIdByName(ClientData clientData, Tcl_Interp *interp,
                           int argc, char *argv[])
{
    /*  : className attrName */
    if (argc != 3) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    Tcl_SetResultInt(spdGetAttrIdByName(argv[1], argv[2]));
    return TCL_OK;
}

/*
 * I-model  P-model 饹̾ (μ)
 */

int tcl_spdGetAllClasses(ClientData clientData, Tcl_Interp *interp,
                         int argc, char *argv[])
{
    SpdModelId modelId;
    SpdClassId classId;

    /*  : ModelId */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &modelId) != TCL_OK) {
        return TCL_ERROR;
    }
    for (classId = spdGetFirstCid(modelId);
         classId <= spdGetLastCid(modelId); classId++) {
        Tcl_AppendElement(interp, spdGetClassNameById(classId));
    }
    return TCL_OK;
}

/*
 * I-model Ϣ̾ (μ)
 */

int tcl_spdGetAllRelations(ClientData clientData, Tcl_Interp *interp,
                           int argc, char *argv[])
{
    SpdId relId;

    /*  : ʤ */
    if (argc != 1) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    for (relId = SPD_FIRST_RID_I_MODEL;
         relId <= SPD_LAST_RID_I_MODEL; relId++) {
        Tcl_AppendElement(interp, spdGetClassNameById(relId));
    }
    return TCL_OK;
}

/*
 * 饹°ΥꥹȤ (μ)
 */

static SpdSet attrnames;

static SpdString makeAttrNameListOfClass(SpdClassId classId)
{
    int         i;
    SpdString   res;
    int         l = 0;
    
    res = spdMalloc(1);
    *res = '\0';

    for (i = 0; i < SPD_MAX(SpdObjIValN, SpdRelIValN); i++) {
        if (class_table[classId].iattr[i] != NULL) {
            l += strlen(class_table[classId].iattr[i]) + 1;
            res = spdRealloc(res, l+1);
            strcat(res, class_table[classId].iattr[i]);
            strcat(res, " ");
        }
    }
    for (i = 0; i < SpdObjSValN; i++) {
        if (class_table[classId].sattr[i] != NULL) {
            l += strlen(class_table[classId].sattr[i]) + 1;
            res = spdRealloc(res, l+1);
            strcat(res, class_table[classId].sattr[i]);
            strcat(res, " ");
        }
    }
    res[l] = 0;
    return res;
}

static void makeAttrNameListFromModel(SpdModelId modelId)
{
    SpdClassId  classId;
    SpdString   names;

    for (classId = spdGetFirstCid(modelId);
         classId <= spdGetLastCid(modelId); classId++) {
        names = makeAttrNameListOfClass(classId);
        spdAddElem(attrnames, classId, &names);
    }
}

void makeAttrNameTable(void)
{
/*     SpdModelId  IModelId, PModelId, AreaModelId, BModelId, DModelId, SDAModelId; */
/*     SpdModelId  StmtModelId, SareaModelId, TypeViewId, CommentViewId; */
/*     SpdModelId  FlowViewId, FCDViewId; */
    SpdModelId modelId;
    int i;

    if (attrnames) {
        spdFreeSet(attrnames);
    }
    attrnames = spdCreateSet(sizeof(SpdString));

    for (i = SPD_FIRST_MID; i <= SPD_LAST_MID; i++) {
        modelId = spdUseModel(&spdModels[i]);
        makeAttrNameListFromModel(modelId);
    }
/*     IModelId = spdUseModel(&I_model); */
/*     PModelId = spdUseModel(&P_model); */
/*     AreaModelId = spdUseModel(&Area_model); */
/*     BModelId = spdUseModel(&B_model); */
/*     DModelId = spdUseModel(&D_model); */
/*     SDAModelId = spdUseModel(&SDA_model); */
/*     StmtModelId = spdUseModel(&Stmt_model); */
/*     SareaModelId = spdUseModel(&SDAarea_model); */
/*     TypeViewId = spdUseModel(&TypeView_model); */
/*     CommentViewId = spdUseModel(&Comment_view); */
/*     FlowViewId = spdUseModel(&Flow_view); */
/*     FCDViewId = spdUseModel(&FCD_view); */

/*     makeAttrNameListFromModel(IModelId); */
/*     makeAttrNameListFromModel(PModelId); */
/*     makeAttrNameListFromModel(AreaModelId); */
/*     makeAttrNameListFromModel(BModelId); */
/*     makeAttrNameListFromModel(DModelId); */
/*     makeAttrNameListFromModel(SDAModelId); */
/*     makeAttrNameListFromModel(StmtModelId); */
/*     makeAttrNameListFromModel(SareaModelId); */
/*     makeAttrNameListFromModel(TypeViewId); */
/*     makeAttrNameListFromModel(CommentViewId); */
/*     makeAttrNameListFromModel(FlowViewId); */
/*     makeAttrNameListFromModel(FCDViewId); */
}

void freeAttrNameTable(void)
{
    int         i;

    if (attrnames) {
        for (i = 0; i < attrnames->elemNum; i++) {
            spdFree(*(SpdString *)spdGetAElem(attrnames, NULL));
        }
        spdFreeSet(attrnames);
        attrnames = NULL;
    }
}

int tcl_spdGetAllAttrs(ClientData clientData, Tcl_Interp *interp,
                       int argc, char *argv[])
{
    SpdId       classId;
    SpdString   *res;
    
    /*  : 饹ID */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &classId) != TCL_OK) {
        return TCL_ERROR;
    }
    res = (SpdString *)spdSearchElem(attrnames, classId);
    if (res) {
        Tcl_SetResultString(*res);
    } else {
        interp->result = "wrong classId";
        return TCL_ERROR;
    }
    return TCL_OK;
}

int tcl_spdGetModelNameById(ClientData clientData, Tcl_Interp *interp,
                            int argc, char *argv[])
{
    SpdModelId modelId;
    
    /*  : modelId */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &modelId) != TCL_OK) {
        return TCL_ERROR;
    }
    Tcl_SetResultString((SpdString)spdGetModelNameById(modelId));
    return TCL_OK;
}

int tcl_spdGetModelIdByName(ClientData clientData, Tcl_Interp *interp,
                            int argc, char *argv[])
{
    /*  : ǥ̾ */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    Tcl_SetResultInt(spdGetModelIdByName(argv[1]));
    return TCL_OK;
}

int tcl_spdGetModelId(ClientData clientData, Tcl_Interp *interp,
                      int argc, char *argv[])
{
    SpdClassId classId;
    
    /*  : classId */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &classId) != TCL_OK) {
        return TCL_ERROR;
    }
    Tcl_SetResultInt(spdGetModelId(classId));
    return TCL_OK;
}
