/* 
 * Program:             $RCSfile: ARtext.c,v $  $Revision: 30.5 $
 * 
 * Purpose:             ɤ˴ؤؿ
 *
 * Author:              T.Hidaka  1997/06/27
 * Modified:            S.Yamamoto  1997/09/05
 *
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1997 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: ARtext.c,v 30.5 2003/06/22 07:27:55 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <tcl.h>
#include "tclAR.h"
#include "tclARSub.h"

#ifdef DELETED_980131

/* Deleted by S.Yamamoto 1998/01/31. */

int tcl_spdSetSearchFlag(ClientData clientData, Tcl_Interp *interp,
                         int argc, char *argv[])
{
    int mode;
    
    /*  : mode */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    mode = SPD_SEARCH_ANY;

    if (SPD_STREQ(argv[1], "SPD_SEARCH_ANY")) {
        mode = SPD_SEARCH_ANY;
    } else if (SPD_STREQ(argv[1], "SPD_SEARCH_HAS_LOCATION")) {
        mode = SPD_SEARCH_HAS_LOCATION;
    }
    
    /* spdSetSearchFlag(mode); */

    return TCL_OK;
}

#endif /* DELETED_980131 */

int tcl_spdGetObjText(ClientData clientData, Tcl_Interp *interp,
                      int argc, char *argv[])
{
    SpdObjId id;

    /*  : oid */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &id) != TCL_OK) {
        return TCL_ERROR;
    }
    
    Tcl_SetResultString(spdGetObjText(id));

    return TCL_OK;
}

int tcl_spdGetOffsetOfObj(ClientData clientData, Tcl_Interp *interp,
                          int argc, char *argv[])
{
    SpdObjId id;
    SpdCursor *csr;
    SpdOcc occ;
    char buf[100];
    
    /*  : oid */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &id) != TCL_OK) {
        return TCL_ERROR;
    }

    csr = spdGetOffsetOfObjInit(id);
    while ((occ = spdGetOffsetOfObj(csr)).relationId != SPD_NON_ID) {
        sprintf(buf, "%d %d %d %d", occ.objectId, occ.fileId,
                occ.offset, occ.relationId);
        Tcl_AppendElement(interp, buf);
    }
    spdFreeCursor(csr);

    return TCL_OK;
}

int tcl_spdGetLengthOfObj(ClientData clientData, Tcl_Interp *interp,
                          int argc, char *argv[])
{
    SpdObjId id;

    /*  : oid */
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &id) != TCL_OK) {
        return TCL_ERROR;
    }
    
    Tcl_SetResultInt(spdGetLengthOfObj(id));

    return TCL_OK;
}

int tcl_spdGetIncludedOcc(ClientData clientData, Tcl_Interp *interp,
                          int argc, char *argv[])
{
    SpdObjId id, fileId;
    SpdCursor *csr;
    SpdOcc occ;
    char buf[100];
    
    /*  : oid, classname, fileId */
    if (argc != 4) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (tclAR_GetInt(interp, argv[1], &id) != TCL_OK) {
        return TCL_ERROR;
    }
    if (tclAR_GetInt(interp, argv[3], &fileId) != TCL_OK) {
        return TCL_ERROR;
    }

    /* Modified by H.Ohhashi 1998/05/09. */
    /* csr = spdGetIncludedOccInit(id, argv[2]); */
    csr = spdGetIncludedOccInit(id, argv[2], fileId); 
    while ((occ = spdGetIncludedOcc(csr)).relationId != SPD_NON_ID) {
        sprintf(buf, "%d %d %d %d", occ.objectId, occ.fileId,
                occ.offset, occ.relationId);
        Tcl_AppendElement(interp, buf);
    }
    spdFreeCursor(csr);

    return TCL_OK;
}
