/* 
 * Program:             $RCSfile: tclAR.c,v $  $Revision: 30.17 $
 * 
 * Purpose:             Tclޥ̾CؿȤбɽ
 *
 * Author:              T.Hidaka  1997/06/27
 * Modified:            S.Yamamoto  1997/09/05
 *
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1997 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: tclAR.c,v 30.17 2003/06/28 15:33:27 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <tcl.h>
#include "tclAR.h"
#include "tclARSub.h"

static struct {
    char *name;
    Tcl_CmdProc *func;
} cmdtable[] = {
    {"spdTarget", tcl_spdTarget},
    {"spdGetClassNameById", tcl_spdGetClassNameById},
    {"spdGetClassIdByName", tcl_spdGetClassIdByName},
    {"spdGetAttrIdByName", tcl_spdGetAttrIdByName},
    {"spdGetName", tcl_spdGetName},
    {"spdGetLength", tcl_spdGetLength},
    {"spdGetOffset", tcl_spdGetOffset},
    {"spdGetAttrVal", tcl_spdGetAttrVal},
    {"spdGetAttrValInt", tcl_spdGetAttrVal},
    {"spdGetAttrValString", tcl_spdGetAttrVal},
    {"spdGetClassId", tcl_spdGetClassId},
    {"spdGetClassName", tcl_spdGetClassName},
    {"spdGetObjId", tcl_spdGetObjId},
    {"spdGetRel", tcl_spdGetRel},
    {"spdGetRelObj", tcl_spdGetRelObj},
    {"spdGetRelId", tcl_spdGetRelId},
    {"spdGetObjText", tcl_spdGetObjText},
    {"spdGetOffsetOfObj", tcl_spdGetOffsetOfObj},
    {"spdGetLengthOfObj", tcl_spdGetLengthOfObj},
    {"spdGetIncludedOcc", tcl_spdGetIncludedOcc},
    {"spdGetABlockId", tcl_spdGetABlockId},

    {"spdUseModel", tcl_spdUseModel},
    {"spdOpenSDB", tcl_spdOpenSDB},
    {"spdReadDB", tcl_spdReadDB},

    {"spdGetModelNameById", tcl_spdGetModelNameById},
    {"spdGetModelIdByName", tcl_spdGetModelIdByName},
    {"spdGetModelId", tcl_spdGetModelId},

#if defined(SAPID_TCLAR4)
    {"spdConvOffsetItoC", tcl_spdConvOffsetItoC},
    {"spdConvOffsetCtoI", tcl_spdConvOffsetCtoI},
    {"spdConvRegionItoC", tcl_spdConvRegionItoC},
    {"spdConvRegionCtoI", tcl_spdConvRegionCtoI},
    {"spdConvOccToRegion", tcl_spdConvOccToRegion},
    {"spdConvRegionToOcc", tcl_spdConvRegionToOcc},
#endif

    /* SpdUtil. */
    {"spdSetSDBdir", tcl_spdSetSDBdir},
    {"spdGetSDBdir", tcl_spdGetSDBdir},

    /* {"spdSetSearchFlag", tcl_spdSetSearchFlag}, */
    {"smuGetAProgramName", tcl_smuGetAProgramName},
    {"smuGetObjAttr", tcl_smuGetObjAttr},
    {"smuGetClassAttr", tcl_smuGetClassAttr},
    {"smuMakeXrefTables", tcl_smuMakeXrefTables},
    {"spdConvIdPfileToFile", tcl_spdConvIdPfileToFile},
    {"smuIsSystemFile", tcl_smuIsSystemFile},
    {"smuIsSystemObject", tcl_smuIsSystemObject},
    
    /* ĥͽꥳޥ */
    {"spdGetAllClasses", tcl_spdGetAllClasses},
    {"spdGetAllRelations", tcl_spdGetAllRelations},
    {"spdGetAllAttrs", tcl_spdGetAllAttrs},
    
    /* SpdStr ޥ */
    {"spdStr", tcl_spdStr},
    
    /* Tcl ѥޥ */
#if defined(SAPID_TCLAR4)
    {"spdGetRegionText", tcl_spdGetRegionText},
    
    {"spdConvRegionTclToSpd", tcl_spdConvRegionTclToSpd},
    {"spdConvRegionSpdToTcl", tcl_spdConvRegionSpdToTcl},
#endif

    {"getMid", tcl_getMid},

    {NULL, NULL}
};

void Sapidtclar_Cleanup(void)
{
    /* °̾ơ֥γ */
    freeAttrNameTable();
}

/* libTclAR ν (Tcl ޥɤϿ) */
void Sapidtclar_Init(Tcl_Interp *interp)
{
    int i;
    
    if (interp == NULL) {
        return;
    }

    for (i = 0; cmdtable[i].name != NULL; i++) {
        Tcl_CreateCommand(interp, cmdtable[i].name, cmdtable[i].func,
                          (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    }

    /* °̾ơ֥ν */
    makeAttrNameTable();

    atexit(Sapidtclar_Cleanup);
}

/* tclAR ѤѴؿ */
/* SPD_NON_ID 򥵥ݡ */

int tclAR_GetInt(Tcl_Interp *interp, char *string, int *intPtr)
{
    if (SPD_STREQ(string, "SPD_NON_ID")) {
        *intPtr = SPD_NON_ID;
        return TCL_OK;
    } else {
        return Tcl_GetInt(interp, string, intPtr);
    }
}

int tcl_getMid(ClientData clientData, Tcl_Interp *interp,
                          int argc, char *argv[])
{
    if (argc != 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }

    if (SPD_STREQ(argv[1], "SPD_FIRST_MID")) {
        Tcl_SetResultInt(SPD_FIRST_MID);
    } else if (SPD_STREQ(argv[1], "SPD_LAST_MID")) {
        Tcl_SetResultInt(SPD_LAST_MID);
    } else {
        return TCL_ERROR;
    }
    return TCL_OK;
}
