/* 
 * Program:             $RCSfile: tclfilemap.h,v $  $Revision: 30.2 $
 * 
 * Purpose:
 *
 * Author:              T.Hidaka  1997/06/27
 * Modified:            S.Yamamoto  1997/09/05
 *
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1997
 *                      This file is a product of the project Sapid.
 */

#define MAP_ALLOC_STEP_SIZE     256

struct region {
    int offset;
    int length;
};

struct offsetmap_node {
    struct region from;
    struct region to;
};

struct offsetmap {
    int mapsize;
    int mapallocsize;
    struct offsetmap_node *mapnode;
};

struct offsetmap *createMap(void);
int deleteMap(struct offsetmap *map);
int clearMap(struct offsetmap *map);

int addMap(struct offsetmap *map, struct region from, struct region to);

struct region convRegion(struct offsetmap *map, struct region from);
struct region convRegionRev(struct offsetmap *map, struct region to);

struct offsetmap *makeFile2TkMap(Tcl_Interp *interp, SpdObjId fileId);
int deleteFile2TkMap(void);
