# 
# Program:              $RCSfile: tclAR.tcl,v $  $Revision: 30.1 $
# 
# Purpose:              tclAR4饤֥ꡥ
#
# Author:               T.Hidaka  1997/06/27
# Modified:             S.Yamamoto  1997/09/05
#
# (C) Copyright:        T.Hidaka and S.Yamamoto  1997
#                       This file is a product of the project Sapid.
# 

# 
# "$Id: tclAR.tcl,v 30.1 1998/09/24 11:27:25 yamamoto Exp yamamoto $";
# 

# Ϣ

proc emptySet {} {
    return ""
}

proc isSetContain {set item} {
    if {[lsearch -exact $set $item] != -1} {
	return 1
    } else {
	return 0
    }
}

proc addSet {set item} {
    upvar $set Set

    if {![isSetContain $Set $item]} {
	lappend Set $item
    }
}

proc delSet {set item} {
    upvar $set Set

    while {[set pos [lsearch -exact $Set $item]] != -1} {
	set Set [lreplace $Set $pos $pos]
    }
}

proc mkSet {list} {
    set Set [emptySet]

    foreach l $list {
	addSet Set $l
    }

    return $Set
}

# C ΥإåեΥ󥯥롼
# ʤޥμ
# CIncludeMacros   :: Ÿѥޥ
# CIncludeMacrosIn :: Ÿޥ
# CIncludePath     :: إåեɤ߹ߥѥΥꥹ

# إåեΥѥ򥻥å
proc setCIncludePath {path} {
    global CIncludePath

    set CIncludePath [split $path ": "]
}

# macro ͤ
proc getCIncludeMacroValue {macroname} {
    global CIncludeMacros

    set keys [array names CIncludeMacros]

    if {[lsearch $keys $macroname] != -1} {
	return $CIncludeMacros($macroname)
    } else {
	return ""
    }
}

# macro ͤ򥻥å
proc defineCIncludeMacro {macroname value} {
    global CIncludeMacros
    global CIncludeMacrosIn
    
    if {[catch {set res [expr $value]}] == 0} {
	set CIncludeMacros($macroname) $res
    } else {
	set CIncludeMacrosIn($macroname) $value
    }
}

#  \ ɤå
proc isContinueLine {line} {
    #  \ Ĥз³ԡĤʤ³ԤǤϤʤ
    set n [expr [string length $line] - [string length [string trimright $line "\\"]]]
    return [expr $n % 2]
}

# #if μɾ
proc CInclude_IfExpr {cond} {
    global CIncludeMacros
    global CIncludeMacrosIn
    global CIncludePath


    # ̻Ҥ餷ʪ˥ڡ
    regsub -all "(\[a-zA-Z0-9_\]+)" $cond { \1 } cond
    
    # ֤䥹ڡϢ³ƥڡ1Ĥ֤
    regsub -all "(\[ \t\])+" $cond " " cond

    set macros [concat [array names CIncludeMacrosIn] \
	    [array names CIncludeMacros]]
    
    # defined(macro)  1 ޤ 0 Ѵ
    while {[regexp "defined ?\\\( ?(\[a-zA-Z_]\[a-zA-Z_0-9\]*) ?\\\)" $cond match mc]} {
	if {[lsearch $macros $mc] != -1} {
	    set res 1
	} else {
	    set res 0
	}
	regsub "defined ?\\\( ?$mc ?\\\)" $cond $res cond
    }
    
    # macro ŬڤͤѴ
    while {[regexp " (\[a-zA-Z_\]\[a-zA-Z_0-9\]*) " $cond match mc]} {
	if {[lsearch $macros $mc] != -1} {
	    regsub " $mc " $cond " $CIncludeMacros($mc) " cond
	} else {
	    return 0
	}
    }

    return [expr $cond]
}

# C ΥإåեΥ󥯥롼
proc CInclude {filename} {
    global CIncludeMacros
    global CIncludeMacrosIn
    global CIncludePath

    set sysflag [expr [string compare [string index $filename 0] "<"] == 0]
    
    if {$sysflag && [file isfile $filename]} {
	# եѥǤФΤޤ
	set fname $filename
    } else {
	if {$sysflag} {
	    regexp "<(\[^>\]+)>" $filename dummy filename
	}
	# CIncludePath ˥ե̾ղäƽĴ٤
	foreach dir $CIncludePath {
	    set fname [file join $dir $filename]
	    if {[file isfile $fname]} {
		break
	    }
	}
    }

    # ɥե뤬¸ߤʤϤʤˤ⤷ʤ
    if {![file isfile $fname]} {
	return
    }
    
    set fd [open $fname r]

    #  #if ξＰΥå
    set ifstack {1}
    
    while {![eof $fd]} {
	set line [gets $fd]

	#  \ ʤ1ԤȤư
	while {[isContinueLine $line]} {
	    # 1ʸ(\)塢ιԤϢ
	    set line [string range $line 0 [expr [string length $line] - 2]]
	    set line "$line [gets $fd]"
	}

	set line [string trim $line]

	if {[string index $line 0] != "#"} {
	    # ץץåǤʤΤ̵
	    continue
	} else {
	    # Ƭ # ϺƤ
	    set line [string range $line 1 end]
	}

	# { , } , ; ޤޤƤ̵
	if {[regexp "\[\{\};\]" $line]} {
	    continue
	}

	# ֤䥹ڡϢ³ƥڡ1Ĥ֤
	regsub -all "(\[ \t\])+" $line " " line

	# Ȥ
	regsub -all "/\\\*.*(\\\*/)?" $line " " line

	# ץץåФ
	# ꥹȤȤߤʤ cmd  param ʬ
	set cmd [lindex $line 0]
	set param [string trim [lrange $line 1 end]]

	# ץץåᤴȤν
	switch -exact $cmd {
	define {
	    if {[lindex $ifstack 0] == 1} {
		set macro [lindex $param 0]
		set macrovalue [string trim [lrange $param 1 end]]
		
		# ̻Ҥ餷ʪ˥ڡ
		regsub -all "(\[a-zA-Z0-9_\]+)" $macrovalue { \1 } macrovalue
		
		# ֤䥹ڡϢ³ƥڡ1Ĥ֤
		regsub -all "(\[ \t\])+" $macrovalue " " macrovalue
		
		# Ĥޥ̵
		if {[string first "(" $macro] == -1} {
		    defineCIncludeMacro $macro $macrovalue
		}
	    }
	}
	include {
	    if {[lindex $ifstack 0] == 1} {
		# <filename>  "filename" ڤФơƵ
		set fname ""
		set delim [string index $param 0]
		
		if {[string compare $delim <] == 0} {
		    regexp "^<\[^>\]+>" $param fname
		} else {
		    if {[string compare $delim \"] == 0} {
			regexp "^\"\[^\"\]+\"" $param fname
		    }
		}
		
		CInclude $fname
	    }
	}
	if {
	    if {[lindex $ifstack 0] == 1} {
		set ifstack [concat [list [CInclude_IfExpr $param]] $ifstack]
	    } else {
		set ifstack [concat {-1} $ifstack]
	    }
	}
	ifdef {
	    if {[lindex $ifstack 0] == 1} {
		if {[lsearch -exact [concat [array names CIncludeMacro] \
			[array names CIncludeMacroIn]] $param] != -1} {
		    set ifstack [concat {1} $ifstack]
		} else {
		    set ifstack [concat {0} $ifstack]
		}
	    } else {
		set ifstack [concat {-1} $ifstack]
	    }
	}
	ifndef {
	    if {[lindex $ifstack 0] == 1} {
		if {[lsearch -exact [concat [array names CIncludeMacro] \
			[array names CIncludeMacroIn]] $param] != -1} {
		    set ifstack [concat {0} $ifstack]
		} else {
		    set ifstack [concat {1} $ifstack]
		}
	    } else {
		set ifstack [concat {-1} $ifstack]
	    }
	}
	else {
	    if {[lindex $ifstack 0] == 0} {
		set ifstack [lreplace $ifstack 0 0 1]
	    } else {
		if {[lindex $ifstack 0] == 1} {
		    set ifstack [lreplace $ifstack 0 0 0]
		}
	    }
	}
	elif {
	    if {[lindex $ifstack 0]} {
		# 0  : ޤǤ˿ˤʤäＰ¸ߤʤ
		# ΤȤ Ｐå
		set ifstack [concat [list [CInclude_IfExpr $param]] [lrange $ifstack 1 end]]
	    } else {
		# 1 or -1  : ޤǤ˿ˤʤäＰ¸ߤ
		# ΤȤϾＰϤ⤦åɬפϤʤ
		set ifstack [concat {-1} [lrange $ifstack 1 end]]
	    }
	}
	endif {
	    set ifstack [lrange $ifstack 1 end]
	}
	}
    }

    # macro Ÿ
    set size 0
    while {$size != [array size CIncludeMacrosIn]} {
	set size [array size CIncludeMacrosIn]
	set macros [array names CIncludeMacros]

	foreach expand $macros {
	    set macrosin [array names CIncludeMacrosIn]
	    
	    foreach mc $macrosin {
		regsub -all " $expand " $CIncludeMacrosIn($mc) " $CIncludeMacros($expand) " tmp

		if {$CIncludeMacrosIn($mc) != $tmp} {
		    unset CIncludeMacrosIn($mc)
		
		    defineCIncludeMacro $mc $tmp
		}
	    }
	}
    }
}

# ȤꤢɸŪʥޥ(̾ Imakefile )
setCIncludePath "/usr/local/Sapid/include:/usr/local/Sapid/include3"
defineCIncludeMacro SAPID_AR4 ""
defineCIncludeMacro SAPID_FAST_ATTR_VAL ""
defineCIncludeMacro SAPID_FAST_CLASS_ID ""
defineCIncludeMacro SAPID_FAST_SET ""

# ¾ɬפʤ
CInclude <Sapid/version.h>
