# 
# Program:              $RCSfile: tkAR4.tcl,v $  $Revision: 30.5 $
# 
# Purpose:              tkAR4 饤֥ꡥ
#
# Author:               T.Hidaka  1997/06/27
# Modified:             S.Yamamoto  1997/09/05
#
# (C) Copyright:        T.Hidaka and S.Yamamoto  1997 - 2001
#                       This file is a product of the project Sapid.
# 

# 
# "$Id: tkAR4.tcl,v 30.5 2001/12/03 16:35:40 yamamoto Exp yamamoto $";
# 

source "$env(SAPID_TCLAR_LIBDIR)/tclAR.tcl"

# ƥƥȥåɤ߹ߥե̾
set spdtclar4_filenames(.) ""
set spdtclar4_fileids(.) ""

# .c ΥեѤ뤫ɤ
set cfile_mode 1

#  array  key ¸ߤ뤫ɤĴ٤
proc isValidKey {array key} {
    upvar $array a
    
    if {[lsearch -exact [array names a] $key] == -1} {
	return 0
    } else {
	return 1
    }
}

proc spdGetSourceFilename {text} {
    global spdtclar4_filenames
    
    if {[isValidKey spdtclar4_filenames $text]} {
	return $spdtclar4_filenames($text)
    } else {
	return ""
    }
}

proc spdGetSourceFileId {text} {
    global spdtclar4_fileids
    
    if {[isValidKey spdtclar4_fileids $text]} {
	return $spdtclar4_fileids($text)
    } else {
	return ""
    }
}

# fileId Ǽե text åȤɤ߹
proc spdLoadSource {text fileId} {
    global spdtclar4_filenames
    global spdtclar4_fileids

    if {$fileId < 0} {
	return
    }
    
    set filename [spdGetName $fileId]

    if {![isValidKey spdtclar4_filenames $text] ||
        $spdtclar4_filenames($text) != $filename} {
	$text configure -state normal

	$text delete 1.0 end
    
	# եɤ߹
	# Modified by H.Ohhashi 1999/04/09.
	set target_file [spdConvIdPfileToFile $fileId]
	set target_path [format "%s/SRC/%d" [spdGetSDBdir] $target_file]
	set fd [open $target_path r]
	while { ![eof $fd] } {
	    set str [gets $fd]
	    $text insert end "$str\n"
	}
	close $fd
    }

    $text configure -state disabled
    set spdtclar4_filenames($text) $filename
    set spdtclar4_fileids($text) $fileId
}

# text åȤƤ
proc spdDeleteSource {text} {
    global spdtclar4_filenames
    global spdtclar4_fileids

    $text delete 1.0 end

    if {[isValidKey spdtclar4_filenames $text]} {
	unset spdtclar4_filenames($text)
	unset spdtclar4_fileids($text)
    }
}

# text åȤ creg ʬ args ΥץǶĴɽ 
proc spdMarkupRegion {text tag flag creg args} {
    global spdtclar4_fileids

    if {$flag == "forceload"} {
	spdDeleteSource $text
    }

    if {![isValidKey spdtclar4_fileids $text] ||
        ($flag != "noload" && 
	 $spdtclar4_fileids($text) != [lindex $creg 0])} {
 	if {[spdGetClassName [lindex $creg 0]] != "docfile"} {
	    spdLoadSource $text [lindex $creg 0]
	} else {
	    spdLoadDocument $text [lindex $creg 0]
	}
    }

    if {[isValidKey spdtclar4_fileids $text] && 
        $spdtclar4_fileids($text) == [lindex $creg 0]} {
	set tclreg [spdConvRegionSpdToTcl $creg]
    
	set from "1.0 + [lindex $tclreg 1] chars"
	set to "$from + [lindex $tclreg 2] chars"

	$text tag add $tag $from $to
	eval "$text tag configure $tag $args"

        $text see $from
    }
}

proc spdMarkupOccs {text tag flag occs args} {
    global cfile_mode
    
    if {$occs == ""} {
	return
    }
    foreach occ $occs {
	set ireg [spdConvOccToRegion $occ]
	
        if {[lindex $ireg 0] != -1} {
	    if {$cfile_mode} {
		set creg [spdConvRegionItoC $ireg]
	    } else {
		set creg $ireg
	    }
	} else {
	    set creg "-1 -1 -1"
	}

#	puts "{$occ} {$ireg} {$creg}"
	eval "spdMarkupRegion $text $tag $flag {$creg} $args"
    }
}

proc setFileMode {mode} {
    global cfile_mode
    
    if {$mode == "I"} {
	set cfile_mode 0
    } else {
	set cfile_mode 1
    }

    return $cfile_mode
}

# ɥȥեID
proc getDocfileId {objectId} {
    set className [spdGetClassName $objectId]
    
    if {$className == "software" || $className == "document"} {
	return -1
    } elseif {$className == "docfile"} {
	return $objectId
    } else {
	set prels [spdGetRel $objectId any c-id]
	foreach rel $prels {
	    return [getDocfileId [lindex $rel 1]]
	}
    }
}

# fileId Ǽɥȥե text åȤɤ߹
proc spdLoadDocument {text fileId} {
    global spdtclar4_filenames
    global spdtclar4_fileids

    set filename [spdGetName $fileId]

    set target_path [format "%s/SRC/%d" [spdGetSDBdir] $fileId]
    set fd [open $target_path r]
    while { ![eof $fd] } {
	set str [gets $fd]
	$text insert end "$str\n"
    }
    close $fd

    $text configure -state disabled
    set spdtclar4_filenames($text) $filename
    set spdtclar4_fileids($text) $fileId
}
