/* $Id: funcdef.c,v 30.9 2003/05/29 04:21:19 yamamoto Exp yamamoto $ */

#include <stdio.h>
#include <Sapid/Sapid.h>

static SpdBoolean       spdOccIsDeclFuncdef(SpdOcc occ);

int main(int argc, char *argv[])
{
    SpdConstString  this_program_name;
    SpdModelId      i_mid, p_mid;
    SpdDBId         db_id;
    SpdObjIdArray   prog_buf, file_buf;
    SpdOccArray     decln_buf;
    SpdObjId        declr_id, ident_id;
    int             i, j, k;

    /* Initialyze. */
    this_program_name = spdBasename(argv[0]);
    spdInitialize(this_program_name);

    /* I-modelP-modeȤ */
    i_mid = spdUseModel(&spdModels[SPD_MID_I_MODEL]);
    p_mid = spdUseModel(&spdModels[SPD_MID_P_MODEL]);

    /* SDB򳫤 */
    db_id = spdOpenSDB();

    /* I-modelP-modelɤ߹ࡥ */
    spdReadDB(i_mid, db_id);
    spdReadDB(p_mid, db_id);

    /* SDB ˳ǼƤprog_idơ̾󤹤롥 */
    prog_buf = spdGetObjIdSortedArray("program", NULL, NULL,
                                      spdCompareObjIdName);
    for (i = 0; i < prog_buf.size; i++) {
        /* file_idơ̾󤹤롥 */
        file_buf = spdGetRelObjSortedArray(prog_buf.id[i], "prog_file", "any",
                                           NULL, spdCompareObjIdName);
        for (j = 0; j < file_buf.size; j++) {
            /* ե̾ɽ롥 */
            printf("FILE: %s\n", spdGetName(file_buf.id[j]));
            /* ؿơեƬΰ֤󤹤롥 */
            decln_buf = spdGetIncludedOccSortedArray(file_buf.id[j],
                                                     "declaration",
                                                     file_buf.id[j],
                                                     spdOccIsDeclFuncdef,
                                                     spdCompareOccOffset);
            for (k = 0; k < decln_buf.size; k++) {
                /* ؿ̾ɽ롥 */
                declr_id = spdGetARelObj(decln_buf.occ[k].objectId,
                                         "decl_decl", "any");
                ident_id = spdGetARelObj(declr_id, "decl_ident", "any");
                printf("    FUNCDEF: %s\n", spdGetName(ident_id));

            }
            spdFreeOccArray(decln_buf);
        }
        spdFreeObjIdArray(file_buf);
    }
    spdFreeObjIdArray(prog_buf);
    spdCloseSDB(db_id);

    return (EXIT_SUCCESS);
}

static SpdBoolean spdOccIsDeclFuncdef(SpdOcc occ)
{
    return (spdGetAttrValInt(occ.objectId, "sort") == DECL_FUNCDEF);
}
