/* $Id: decl-funcdef.c,v 40.11 2003/05/29 04:21:17 yamamoto Exp yamamoto $ */

#include <stdio.h>
#include <Sapid/Sapid.h>

int main(int argc, char *argv[])
{
    SpdConstString  this_program_name;
    SpdDBId         db_id;
    SpdModelId      i_mid;
    SpdObjId        prog_id;
    SpdTargetObjSet Declarations, Identifiers;
    int             i, j;

    /* Initialyze. */
    this_program_name = spdBasename(argv[0]);
    spdInitialize(this_program_name);
    
    i_mid = spdUseModel(&I_model);
    db_id = spdOpenSDB();
    spdReadDB(i_mid, db_id);

    prog_id = spdGetAnObjId("program", NULL);

    /* program -> declaration. */
    Declarations = spdGetDescendedObjs(prog_id, "declaration");
    for (i = 0; i < Declarations.TargetObjNum; i++) {
        /* Declaration is funcdef. */
        if (spdGetAttrValInt(Declarations.TargetObjIds[i], "sort") ==
            DECL_FUNCDEF) {
            /* declaration <-> identifier. */
            Identifiers = spdGetDescendedObjs(Declarations.TargetObjIds[i],
                                              "identifier");
            for (j = 0; j <Identifiers.TargetObjNum; j ++) {
                printf("FUNCTION: %s\n",
                       spdGetName(Identifiers.TargetObjIds[j]));
            }
            spdFreeSpdTargetObjSet(Identifiers);
        }
    }
    spdFreeSpdTargetObjSet(Declarations);

    return (EXIT_SUCCESS);
}
