/* $Id: smuXrefTester.c,v 30.7 2003/05/29 04:21:18 yamamoto Exp yamamoto $ */ 

#include <stdio.h>
#include <Sapid/Sapid.h>

static SmuXrefTables xreftables;

int main(int argc, char *argv[])
{
    SpdConstString  this_program_name;
    SpdModelId      i_mid, p_mid;
    SpdDBId         db_id;
    SpdObjIdArray   prog_buf;
    SmuXrefTable    table;
    int             i, j;

    /* Initialyze. */
    this_program_name = spdBasename(argv[0]);
    spdInitialize(this_program_name);

    /* I-modelP-modeȤ */
    i_mid = spdUseModel(&spdModels[SPD_MID_I_MODEL]);
    p_mid = spdUseModel(&spdModels[SPD_MID_P_MODEL]);

    /* SDB򳫤 */
    db_id = spdOpenSDB();

    /* I-modelP-modelɤ߹ࡥ */
    spdReadDB(i_mid, db_id);
    spdReadDB(p_mid, db_id);

    /* SDB  prog_id ̾󤹤 */
    prog_buf = spdGetObjIdSortedArray("program", NULL, NULL,
                                      spdCompareObjIdName);
    for (i = 0; i < prog_buf.size; i++) {
        /* եɽ롥 */
        xreftables = smuMakeXrefTables(prog_buf.id[i], smuXrefEachObj);

        printf("FUNCCALL:\n");
        /* ؿƽФϤ롥 */
        table = xreftables.funcCallTable;
        for (j = 0; j < table.size; j++) {
            printf("\t%s -> %s\n", spdGetName(table.elem[j].callerId),
                   spdGetName(table.elem[j].calleeId));
        }
        /* ХѿϤ롥 */
        printf("GLOBAL VARIABLE:\n");
        table = xreftables.globalVariableTable;
        for (j = 0; j < table.size; j++) {
            printf("\t%s -> %s\n", spdGetName(table.elem[j].callerId),
                   spdGetName(table.elem[j].calleeId));
        }
        /* ѿϤ롥 */
        printf("LOCAL VARIABLE:\n");
        table = xreftables.localVariableTable;
        for (j = 0; j < table.size; j++) {
            printf("\t%s -> %s\n", spdGetName(table.elem[j].callerId),
                   spdGetName(table.elem[j].calleeId));
        }
        /* ޥϤ롥 */
        printf("MACRO:\n");
        table = xreftables.macroCallTable;
        for (j = 0; j < table.size; j++) {
            printf("\t%s -> %s\n", spdGetName(table.elem[j].callerId),
                   spdGetName(table.elem[j].calleeId));
        }
        smuFreeXrefTables(xreftables);
    }
    spdFreeObjIdArray(prog_buf);
    spdCloseSDB(db_id);

    return (EXIT_SUCCESS);
}
