/* 
 * Program:             $RCSfile: test-fread.c,v $  $Revision: 30.8 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  2000/06/15
 * 
 * (C) Copyright:       S.Yamamoto  2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: test-fread.c,v 30.8 2003/05/29 04:20:17 yamamoto Exp yamamoto $";
#endif

#include <ctype.h>
#include <stdio.h>
#include <Sapid/Sapid.h>

int main(int argc, char *argv[])
{
    int         count;
    SpdConstString   program_name;               /* This program name. */
    SpdObjId    prog_id;
    char        *buf;
    char        *cp;

    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);
    if (argc != 2) {
        spdErrorExit("Usage: %s fileId\n", program_name);
    }

    if ((prog_id = spdTarget("I-model",
                             smuGetAProgramName())) == SPD_NON_ID) {
        spdErrorExit("Error in spdTarget().\n");
    }

    spdReadFileInBufByName(argv[1], &buf);
    count = 0;
    for (cp = buf; *cp != '\0'; cp++) {
        printf("%03d: getc() = 0x%02x", count, *cp);
        if (isgraph(*cp)) {
            printf(", '%c'.\n", *cp);
        } else if (*cp == '\n') {
            printf(", NL.\n");
        } else if (*cp == '\r') {
            printf(", CR.\n");
        } else {
            printf(".\n");
        }
        count++ ;
    }
    printf("count = %d.\n", count) ;

    return (EXIT_SUCCESS);
}
