/* 
 * Program:             $RCSfile: test-fseek.c,v $  $Revision: 30.11 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  2000/06/15
 * 
 * (C) Copyright:       S.Yamamoto  2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: test-fseek.c,v 30.11 2003/05/29 04:20:18 yamamoto Exp yamamoto $";
#endif

#include <ctype.h>
#include <stdio.h>
#include <Sapid/Sapid.h>

#define OFFSET      6

int myFseek(FILE *stream, long int offset, int whence);
static void sub(FILE *fp);

int main(int argc, char *argv[])
{
    FILE        *fp;
    SpdConstString program_name;              /* This program name. */

    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);
    if (argc != 2) {
        spdErrorExit("Usage: %s inputFile\n", program_name);
    }

    fp = spdFopen(argv[1], SPD_FOPEN_RT_MODE);

    sub(fp);

    SPD_FSEEK(fp, OFFSET, SEEK_SET);
    sub(fp); 
      
    SPD_FSEEK(fp, 0, SEEK_SET);
    sub(fp); 

    spdFclose(fp);
    return (EXIT_SUCCESS);
}

static void sub(FILE *fp)
{
    int     c, offset;

    offset = ftell(fp);
    while ((c = fgetc(fp)) != EOF) {
        printf("%03d: getc() = 0x%02x", offset, c);
        if (isgraph(c)) {
            printf(", '%c'.\n", c);
        } else if (c == '\n') {
            printf(", NL.\n");
        } else if (c == '\r') {
            printf(", CR.\n");
        } else {
            printf(", UNKNOWN.\n");
        }
        offset++ ;
    }
    printf("\n");
}

/******************************************************************************/

#ifdef OBSOLETE

#include <fcntl.h>

int myFseek(FILE *stream, long int offset, int whence)
{
    int     c, savedMode;

    /* SEEK_SETSEEK_CURݡȤƤ*/
    if (whence != SEEK_SET && whence != SEEK_CUR) {
        spdErrorExit("spdFseekCygwin(): whence %d: Not support yet.\n");
    }

    /* setbuf(stream, NULL); */
    /* setvbuf(stream, NULL, _IONBF, 0); */

    /* SEEK_SETΤȤƬ˰ư롥 */
    if (whence == SEEK_SET && fseek(stream, 0, SEEK_SET)) {
        return (-1);
    }
    /* Хʥ⡼ɤѹ롥 */
    if ((savedMode = setmode(fileno(stream), O_BINARY)) == -1) {
        return (-1);
    }

    /* Modified by S.Yamamoto 1998/11/22. */
    while (0 < offset--) {
        if ((c = getc(stream)) == EOF) {
            /* Too big offset. */
            return (-1);
        } else if (c == '\r') {
            /* '\r'ΤȤoffsetǥȤʤ */
            offset++;
        }
    }

    {
        long int pos;

        pos = ftell(stream);

        /* Υ⡼ɤ᤹ */
        if (setmode(fileno(stream), savedMode) == -1) {
            return (-1);
        }

        fseek(stream, 0, SEEK_END);
        fseek(stream, pos, SEEK_SET);
    }

    return (0);
}

#endif /* OBSOLETE */
