/* 
 * Program:             $RCSfile: test-getc.c,v $  $Revision: 30.6 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  2000/06/15
 * 
 * (C) Copyright:       S.Yamamoto  2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: test-getc.c,v 30.6 2003/05/29 04:20:17 yamamoto Exp yamamoto $";
#endif

#include <ctype.h>
#include <stdio.h>
#include <Sapid/Sapid.h>

int main(int argc, char *argv[])
{
    int         c, count;
    FILE        *fp;
    SpdConstString program_name;              /* This program name. */

    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);
    if (argc != 2) {
        spdErrorExit("Usage: %s inputFile\n", program_name);
    }

    fp = spdFopen(argv[1], SPD_FOPEN_RB_MODE);
    count = 0;
    while ((c = fgetc(fp)) != EOF) {
        printf("%03d: getc() = 0x%02x", count, c);
        if (isgraph(c)) {
            printf(", '%c'.\n", c);
        } else if (c == '\n') {
            printf(", NL.\n");
        } else if (c == '\r') {
           printf(", CR.\n");
        } else {
            printf(".\n");
        }
        count++ ;
    }
    printf("count = %d.\n", count) ;
    spdFclose(fp);

    return (EXIT_SUCCESS);
}
