/* 
 * Program:             $RCSfile: test-sip2-1.c,v $  $Revision: 30.17 $
 * 
 * Purpose:             Total test input file for SIP3.
 * 
 * Author:              S.Yamamoto  2000/12/03
 * 
 * (C) Copyright:       S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: test-sip2-1.c,v 30.17 2003/07/08 11:52:33 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>

#if !defined(EXIT_SUCCESS)
#define EXIT_SUCCESS    0
#endif

#define NUM_OF_A        5   /* Should be greater than 3. */

/* Test2. */
static void test_addr(void);
static void test_break_and_continue(void);

/* static */ int test2(void);
static int test4(void);
static int test5(void);

int main(int argc, char *argv[])
{
    int     i;

    /* Test1 (test of "argc" and "argv[]"). */
    printf("argc and argv[]: argc: %d.\n", argc);
    i = 0;
    while (i < argc) {
        printf("argc and argv[]: argv[%d]: \"%s\".\n", i, argv[i]);
        i++;
    }

    /* Test2 (test of "break" and "continue"). */
    printf("### Test2. ###\n");
    printf("test2(): %d.\n", test2());

    /* Test3 (test of "struct"). */
    /* 
     * printf("### Test3. ###\n");
     * test3();
     */
    printf("### Test3 skipped. ###\n");

    /* Test4 (test of operators). */
    printf("### Test4. ###\n");
    printf("test4(): %d.\n", test4());

    /* Test5 (test of simple control flow). */
    printf("### Test5. ###\n");
    printf("test5(): %d.\n", test5());

    /* Test6 (test of function call). */
    /* 
     * printf("### Test6. ###\n");
     * printf("test6(): %d.\n", test6());
     */

    return (EXIT_SUCCESS);
}

/******************************************************************************/

/* static */ int test2(void)
{
    test_break_and_continue();

    /* test_addr(); */
    printf("### Test2 (test_addr()) skipped. ###\n");

    return (2);
}

static void test_addr(void)
{
    int b, *p, *q;

    b = 2;
    p = &b;
    q = (p + 1) -1;
    printf("p: %p\n", p);
    printf("*p: %d\n", *p);
    printf("q: %p\n", q);
    printf("*q: %d\n", *q);
}

static void test_break_and_continue(void)
{
    int     i;

    i = NUM_OF_A;
    while (0 < i) {
        printf("WHILE: %d.\n", i);
        if (i == 3) {
            i -= 2;
            continue;
        } else if (i == 1) {
            break;
        }
        i--;
    }
}

/******************************************************************************/

typedef struct _s {
    int     x;
    int     y;
} S;

int     x3, x4, x5, y1;

static int test4(void)
{
    int     x0, x1, x2, *ip;
    int     a[NUM_OF_A];
    /* S       s, *sp; */

    /* Initialize. */
    x0 = 0;
    x1 = 1;
    x2 = 2;
    x3 = 3;
    x4 = 4;
    x5 = 5;

    /* Test of prinft(). */
    printf("printf(...): Hello.\n");
    fflush(stdout);

#if defined(__linux__) || defined(__CYGWIN__) || defined(__FreeBSD__) || \
    defined(WIN32)
    printf("stdout, stderr: Skipped.\n");
#else
    /* Test of fprinft(). */
    fprintf(stdout, "fprintf(stdout, ...): Hello stdout.\n");
    fflush(stdout);
    fprintf(stderr, "fprintf(stderr, ...): Hello stderr.\n");
    fflush(stderr);
#endif

    /* Test of OP_ARROW. */
    /* 
     * sp = &s;
     * sp->x = x1;
     * sp->y = x2;
     * printf("OP_ARROW: %d.\n", sp->x);
     * printf("OP_ARROW: %d.\n", sp->y);
     */
    printf("OP_ARROW: Skipped.\n");

    /* Test of OP_DOT. */
    /* 
     * s.x = x1;
     * s.y = x2;
     * printf("OP_DOT: %d.\n", s.x);
     * printf("OP_DOT: %d.\n", s.y);
     */
    printf("OP_DOT: Skipped.\n");

    /* Test of OP_NOT. */
    printf("OP_NOT: %d.\n", !x3);

    /* Test of OP_B_NOT. */
    printf("OP_B_NOT: %d.\n", ~x1);

    /* Test of OP_INC. */
    y1 = x1;
    y1++;
    printf("OP_INC: %d.\n", y1);
    printf("OP_INC: %d.\n", y1++);
    printf("OP_INC: %d.\n", y1);
    printf("OP_INC: %d.\n", ++y1);
    printf("OP_INC: %d.\n", y1);

    /* Test of OP_DEC. */
    y1 = x1;
    y1--;
    printf("OP_DEC: %d.\n", y1);
    printf("OP_DEC: %d.\n", y1--);
    printf("OP_DEC: %d.\n", y1);
    printf("OP_DEC: %d.\n", --y1);
    printf("OP_DEC: %d.\n", y1);

    /* Test of OP_PLUS. */
    printf("OP_PLUS: %d.\n", +x1);

    /* Test of OP_MINUS. */
    printf("OP_MINUS: %d.\n", -x1);

    /* Test of OP_POINTER and OP_ADDRESS. */
    ip = &y1;
    *ip = x1;
    printf("OP_POINTER and OP_ADDRESS: %d.\n", y1);

    /* Test of OP_MUL. */
    printf("OP_MUL: %d.\n", x1 * x2 * x3);

    /* Test of OP_DIV. */
    printf("OP_DIV: %d.\n", x3 / x2 / x1);

    /* Test of OP_MOD. */
    printf("OP_MOD: %d.\n", x3 % x2 % x1);

    /* Test of OP_ADD. */
    printf("OP_ADD: %d.\n", x1 + x2 + x3);

    /* Test of OP_MINUS. */
    printf("OP_MINUS: %d.\n", x1 - x2 - x3);

    /* Test of OP_SHL. */
    printf("OP_SHL: %d.\n", x1 << 8);

    /* Test of OP_SHR. */
    printf("OP_SHR: %d.\n", x1 >> 8);

    /* Test of OP_LT. */
    printf("OP_LT: %d.\n", x1 < x2);

    /* Test of OP_LE. */
    printf("OP_LE: %d.\n", x1 <= x2);

    /* Test of OP_GT. */
    printf("OP_GT: %d.\n", x1 > x2);

    /* Test of OP_GE. */
    printf("OP_GE: %d.\n", x1 >= x2);

    /* Test of OP_EQ. */
    printf("OP_EQ: %d.\n", x1 == x2);

    /* Test of OP_NE. */
    printf("OP_NE: %d.\n", x1 != x2);

    /* Test of OP_B_AND. */
    printf("OP_B_AND: %d.\n", x1 & x2);

    /* Test of OP_B_XOR. */
    printf("OP_B_XOR: %d.\n", x1 ^ x2);

    /* Test of OP_B_OR. */
    printf("OP_B_OR: %d.\n", x1 | x2);

    /* Test of OP_L_AND. */
    printf("OP_L_AND: %d.\n", x0 && x3);
    printf("OP_L_AND: %d.\n", x2 && x3);

    /* Test of OP_L_OR. */
    printf("OP_L_OR: %d.\n", x0 || x3);
    printf("OP_L_OR: %d.\n", x2 || x3);

    /* Test of OP_ASSIGN. */
    y1 = x1;
    printf("OP_ASSIGN: %d.\n", y1);

    /* Test of OP_A_ADD. */
    y1 = x1;
    y1 += x1;
    printf("OP_A_ADD: %d.\n", y1);

    /* Test of OP_A_SUB. */
    y1 = x1;
    y1 -= x1;
    printf("OP_A_ADD: %d.\n", y1);

    /* Test of OP_A_MUL. */
    y1 = x1;
    y1 *= x1;
    printf("OP_A_MUL: %d.\n", y1);

    /* Test of OP_A_DIV. */
    y1 = x1;
    y1 /= x1;
    printf("OP_A_DIV: %d.\n", y1);

    /* Test of OP_A_MOD. */
    y1 = x1;
    y1 %= x1;
    printf("OP_A_MOD: %d.\n", y1);

    /* Test of OP_A_AND. */
    y1 = x1;
    y1 &= x1;
    printf("OP_A_AND: %d.\n", y1);

    /* Test of OP_A_XOR. */
    y1 = x1;
    y1 ^= x1;
    printf("OP_A_XOR: %d.\n", y1);

    /* Test of OP_A_OR. */
    y1 = x1;
    y1 |= x1;
    printf("OP_A_OR: %d.\n", y1);

    /* Test of OP_A_SHL. */
    y1 = x1;
    y1 <<= x1;
    printf("OP_A_SHL: %d.\n", y1);

    /* Test of OP_A_SHR. */
    y1 = x1;
    y1 >>= x1;
    printf("OP_A_SHR: %d.\n", y1);

    /* Test of OP_COMMA. */
    y1 = (x1, x2);
    printf("OP_COMMA: %d.\n", y1);

    /* Test of OP_SIZEOF. */
    /* 
     * printf("OP_SIZEOF: %d.\n", sizeof(x1));
     */
    printf("OP_SIZEOF: Skipped.\n");

    /* Test of OP_SIZEOF_TYPE. */
    /* 
     * printf("OP_SIZEOF_TYPE: %d.\n", sizeof(char));
     * printf("OP_SIZEOF_TYPE: %d.\n", sizeof(short));
     * printf("OP_SIZEOF_TYPE: %d.\n", sizeof(int));
     * printf("OP_SIZEOF_TYPE: %d.\n", sizeof(long int));
     * printf("OP_SIZEOF_TYPE: %d.\n", sizeof(float));
     * printf("OP_SIZEOF_TYPE: %d.\n", sizeof(double));
     */
    printf("OP_SIZEOF_TYPE: Skipped.\n");

    /* Test of OP_CAST. */
    printf("OP_CAST: Skipped.\n");

    /* Test of OP_L_PAR and OP_R_PAR. */
    printf("OP_L_PAR and OP_R_PAR: %d.\n", ((x1 + x2) * x3));

    /* Test of OP_L_ARRAY and OP_R_ARRAY. */
    a[0] = 0;
    a[1] = 1;
    a[2] = 2;
    printf("OP_L_ARRAY and OP_R_ARRAY: %d.\n", a[0]);
    printf("OP_L_ARRAY and OP_R_ARRAY: %d.\n", a[1]);
    printf("OP_L_ARRAY and OP_R_ARRAY: %d.\n", a[2]);

    /* Test of OP_QUESTION and OP_COLON. */
    printf("OP_QUESTION and OP_COLON: %d.\n", x1 ? x2 : x3);
    printf("OP_QUESTION and OP_COLON: %d.\n", x0 ? x2  + x3 : x4 + x5);
    printf("OP_QUESTION and OP_COLON: %d.\n", x1 ? x2  + x3 : x4 + x5);

    return (4);
}

/******************************************************************************/

static int test5(void)
{
    int     i;

    /* Test of "if" statement. */
    i = 0;
    if (-1 < i) {
        printf("IF: TRUE: %d.\n", i);
    }
    if (0 < 1) {
        printf("IF: TRUE: %d.\n", i);
    } else {
        printf("IF: FALSE: %d.\n", i);
    }
    if (0 == 1) {
        printf("IF: TRUE: %d.\n", i);
    } else {
        printf("IF: FALSE: %d.\n", i);
    }
    if (1 + 2 == 3)
        /* Empty. */;
    if (998 != 999) {
        /* Empty. */;
    } else {
        /* Empty. */;
    }

    /* Test of "SWTICH" statement. */
    i = 1;
    switch (i) {
      case 0:
        printf("SWITCH: 0: %d.\n", i);
        break;
      case 1:
        printf("SWITCH: 1: %d.\n", i);
        break;
      case 2:
        printf("SWITCH: 2: %d.\n", i);
        break;
      default:
        printf("SWITCH: DEFAULT: %d.\n", i);
        break;
    }
    i = 3;
    switch (i) {
      case 0:
        printf("SWITCH: 0: %d.\n", i);
        break;
      case 1:
        printf("SWITCH: 1: %d.\n", i);
        break;
      case 2:
        printf("SWITCH: 2: %d.\n", i);
        break;
      default:
        printf("SWITCH: DEFAULT: %d.\n", i);
        break;
    }
        
    /* Test of "while" statement. */
    /* !! Add test of "break" and "continue". */
    i = NUM_OF_A;
    while (0 < i) {
        printf("WHILE: %d.\n", i);
        i--;
    }
    while (1 == 2) {
        /* Empty. */;
    }

    /* Test of "do" statement (buggy). */
    /* !! Add test of "break" and "continue". */
    i = NUM_OF_A;
    do {
        printf("DO: %d.\n", i);
        i--;
    } while (0 < i);

    /* Test of "for" statement (buggy). */
    /* !! Add test of "break" and "continue". */
    for (i = 0; i < NUM_OF_A; i++) {
        printf("FOR: %d.\n", i);
    }
    for (i = 0; i < NUM_OF_A; i++) {
        /* Empty. */;
    }

    /* Test of "goto" statement (buggy). */
    goto label1;
    printf("GOTO: %d.\n", i);
    return (EXIT_SUCCESS + 999);
    
  label1:

    return (5);
}
