/* 
 * Program:             $RCSfile: test-sip2-4.c,v $  $Revision: 30.26 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  2000/12/03
 * 
 * (C) Copyright:       S.Yamamoto  2000 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: test-sip2-4.c,v 30.26 2002/08/02 06:39:33 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>

#if !defined(EXIT_SUCCESS)
#define EXIT_SUCCESS    0
#endif

#define NUM_OF_A        10

static int test4(void);

int main(int argc, char *argv[])
{
    int     i;
    int     retVal;

    /* Test4 (test of operators). */
    printf("### Test4. ###\n");
    retVal = test4();
    /* printf("test4(): %d.\n", retVal); */

    return (EXIT_SUCCESS);
}

/******************************************************************************/

typedef struct _s {
    int     x;
    int     y;
} S;

int     x3, x4, x5, y1;

static int test4(void)
{
    int     x0, x1, x2, *ip;
    int     a[NUM_OF_A];
    S       s, *sp;

    /* Initialize. */
    x0 = 0;
    x1 = 1;
    x2 = 2;
    x3 = 3;
    x4 = 4;
    x5 = 5;

    /* Test of prinft(). */
    printf("printf(...): Hello.\n");
    fflush(stdout);

#if defined(__linux__) || defined(WIN32)
    printf("stdout, stderr: Skipped.\n");
#else
    /* Test of fprinft(). */
    fprintf(stdout, "fprintf(stdout, ...): Hello stdout.\n");
    fflush(stdout);
    fprintf(stderr, "fprintf(stderr, ...): Hello stderr.\n");
    fflush(stderr);
#endif

    /* Test of OP_ARROW. */
    /* 
     * sp = &s;
     * sp->x = x1;
     * sp->y = x2;
     * printf("OP_ARROW: %d.\n", sp->x);
     * printf("OP_ARROW: %d.\n", sp->y);
     */
    printf("OP_ARROW: Skipped.\n");

    /* Test of OP_DOT. */
    /* 
     * s.x = x1;
     * s.y = x2;
     * printf("OP_DOT: %d.\n", s.x);
     * printf("OP_DOT: %d.\n", s.y);
     */
    printf("OP_DOT: Skipped.\n");

    /* Test of OP_NOT. */
    printf("OP_NOT: %d.\n", !x3);

    /* Test of OP_B_NOT. */
    printf("OP_B_NOT: %d.\n", ~x1);

    /* Test of OP_INC. */
    y1 = x1;
    y1++;
    printf("OP_INC: %d.\n", y1);
    printf("OP_INC: %d.\n", y1++);
    printf("OP_INC: %d.\n", y1);
    printf("OP_INC: %d.\n", ++y1);
    printf("OP_INC: %d.\n", y1);

    /* Test of OP_DEC. */
    y1 = x1;
    y1--;
    printf("OP_DEC: %d.\n", y1);
    printf("OP_DEC: %d.\n", y1--);
    printf("OP_DEC: %d.\n", y1);
    printf("OP_DEC: %d.\n", --y1);
    printf("OP_DEC: %d.\n", y1);

    /* Test of OP_PLUS. */
    printf("OP_PLUS: %d.\n", +x1);

    /* Test of OP_MINUS. */
    printf("OP_MINUS: %d.\n", -x1);

    /* Test of OP_POINTER and OP_ADDRESS. */
    ip = &y1;
    *ip = x1;
    printf("OP_POINTER and OP_ADDRESS: %d.\n", y1);

    /* Test of OP_MUL. */
    printf("OP_MUL: %d.\n", x1 * x2 * x3);

    /* Test of OP_DIV. */
    printf("OP_DIV: %d.\n", x3 / x2 / x1);

    /* Test of OP_MOD. */
    printf("OP_MOD: %d.\n", x3 % x2 % x1);

    /* Test of OP_ADD. */
    printf("OP_ADD: %d.\n", x1 + x2 + x3);

    /* Test of OP_MINUS. */
    printf("OP_MINUS: %d.\n", x1 - x2 - x3);

    /* Test of OP_SHL. */
    printf("OP_SHL: %d.\n", x1 << 8);

    /* Test of OP_SHR. */
    printf("OP_SHR: %d.\n", x1 >> 8);

    /* Test of OP_LT. */
    printf("OP_LT: %d.\n", x1 < x2);

    /* Test of OP_LE. */
    printf("OP_LE: %d.\n", x1 <= x2);

    /* Test of OP_GT. */
    printf("OP_GT: %d.\n", x1 > x2);

    /* Test of OP_GE. */
    printf("OP_GE: %d.\n", x1 >= x2);

    /* Test of OP_EQ. */
    printf("OP_EQ: %d.\n", x1 == x2);

    /* Test of OP_NE. */
    printf("OP_NE: %d.\n", x1 != x2);

    /* Test of OP_B_AND. */
    printf("OP_B_AND: %d.\n", x1 & x2);

    /* Test of OP_B_XOR. */
    printf("OP_B_XOR: %d.\n", x1 ^ x2);

    /* Test of OP_B_OR. */
    printf("OP_B_OR: %d.\n", x1 | x2);

    /* Test of OP_L_AND. */
    printf("OP_L_AND: %d.\n", x0 && x3);
    printf("OP_L_AND: %d.\n", x2 && x3);

    /* Test of OP_L_OR. */
    printf("OP_L_OR: %d.\n", x0 || x3);
    printf("OP_L_OR: %d.\n", x2 || x3);

    /* Test of OP_ASSIGN. */
    y1 = x1;
    printf("OP_ASSIGN: %d.\n", y1);

    /* Test of OP_A_ADD. */
    y1 = x1;
    y1 += x1;
    printf("OP_A_ADD: %d.\n", y1);

    /* Test of OP_A_SUB. */
    y1 = x1;
    y1 -= x1;
    printf("OP_A_ADD: %d.\n", y1);

    /* Test of OP_A_MUL. */
    y1 = x1;
    y1 *= x1;
    printf("OP_A_MUL: %d.\n", y1);

    /* Test of OP_A_DIV. */
    y1 = x1;
    y1 /= x1;
    printf("OP_A_DIV: %d.\n", y1);

    /* Test of OP_A_MOD. */
    y1 = x1;
    y1 %= x1;
    printf("OP_A_MOD: %d.\n", y1);

    /* Test of OP_A_AND. */
    y1 = x1;
    y1 &= x1;
    printf("OP_A_AND: %d.\n", y1);

    /* Test of OP_A_XOR. */
    y1 = x1;
    y1 ^= x1;
    printf("OP_A_XOR: %d.\n", y1);

    /* Test of OP_A_OR. */
    y1 = x1;
    y1 |= x1;
    printf("OP_A_OR: %d.\n", y1);

    /* Test of OP_A_SHL. */
    y1 = x1;
    y1 <<= x1;
    printf("OP_A_SHL: %d.\n", y1);

    /* Test of OP_A_SHR. */
    y1 = x1;
    y1 >>= x1;
    printf("OP_A_SHR: %d.\n", y1);

    /* Test of OP_COMMA. */
    y1 = x1, x2;
    printf("OP_COMMA: %d.\n", y1);

    /* Test of OP_SIZEOF. */
    /* 
     * printf("OP_SIZEOF: %d.\n", sizeof(x1));
     */
    printf("OP_SIZEOF: Skipped.\n");

    /* Test of OP_SIZEOF_TYPE. */
    /* 
     * printf("OP_SIZEOF_TYPE: %d.\n", sizeof(char));
     * printf("OP_SIZEOF_TYPE: %d.\n", sizeof(short));
     * printf("OP_SIZEOF_TYPE: %d.\n", sizeof(int));
     * printf("OP_SIZEOF_TYPE: %d.\n", sizeof(long int));
     * printf("OP_SIZEOF_TYPE: %d.\n", sizeof(float));
     * printf("OP_SIZEOF_TYPE: %d.\n", sizeof(double));
     */
    printf("OP_SIZEOF_TYPE: Skipped.\n");

    /* Test of OP_CAST. */
    printf("OP_CAST: Skipped.\n");

    /* Test of OP_L_PAR and OP_R_PAR. */
    printf("OP_L_PAR and OP_R_PAR: %d.\n", ((x1 + x2) * x3));

    /* Test of OP_L_ARRAY and OP_R_ARRAY. */
    a[0] = 0;
    a[1] = 1;
    a[2] = 2;
    printf("OP_L_ARRAY and OP_R_ARRAY: %d.\n", a[0]);
    printf("OP_L_ARRAY and OP_R_ARRAY: %d.\n", a[1]);
    printf("OP_L_ARRAY and OP_R_ARRAY: %d.\n", a[2]);

    /* Test of OP_QUESTION and OP_COLON. */
    printf("OP_QUESTION and OP_COLON: %d.\n", x1 ? x2 : x3);
    printf("OP_QUESTION and OP_COLON: %d.\n", x0 ? x2  + x3 : x4 + x5);
    printf("OP_QUESTION and OP_COLON: %d.\n", x1 ? x2  + x3 : x4 + x5);

    return (EXIT_SUCCESS);
}
