/* 
 * Program:             $RCSfile: getLine.c,v $  $Revision: 30.2 $
 * 
 * Purpose:
 * 
 * Author:              S.Matsui  2001/06/28
 *                      S.Yamamoto  2001/06/28
 * 
 * (C) Copyright:       S.Matsui and S.Yamamoto  2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: getLine.c,v 30.2 2001/06/28 14:40:12 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

#ifdef SAPID_AR5_KERNEL
#include <Sapid/ImodelARcompat.h>
#include <Sapid/PmodelAR.h>
#endif

static int spd_get_line(SpdObjId id);

int main(int argc, char *argv[])
{
    SpdDBId         dbId;
    SpdModelId      ImodelId, PmodelId;
    SpdClassId      cid;                /* Class id. */
    SpdConstString  className;
    SpdObjIdArray   objIds;
    int             i;

    ImodelId = spdUseModel(&I_model);
    PmodelId = spdUseModel(&P_model);
    dbId = spdOpenSDB();
    spdReadDB(ImodelId, dbId);
    spdReadDB(PmodelId, dbId);

    for (cid = SPD_FIRST_CID_I_MODEL; cid <= SPD_LAST_CID_I_MODEL; cid++) {
            className = spdGetClassNameById(cid);
            printf("# %s\n", className);
            objIds = spdGetObjIdArray(className, NULL, NULL);
            for (i = 0; i < objIds.size; i++) {
                int     line;

                line = spd_get_line(objIds.id[i]);
                printf("id = %d line = %d\n", objIds.id[i], line);
            }
            spdFreeObjIdArray(objIds);
    }

    return (EXIT_SUCCESS);
}

static int spd_get_line(SpdObjId id)
{
    SpdOcc      occ;                        /* Occurence in "*.i" file. */
    SpdRegion   i_region;                   /* Region in "*.i" file. */
    SpdRegion   c_region;                   /* Region in "*.c" file. */
    int         line = SPD_NON_LINENO;      /* Line no. in "*.c" file. */
    int         column = SPD_NON_COLUMN;    /* Column in "*.c" file. */

    occ = spdGetAnOffsetOfObj(id);
    if (occ.objectId != SPD_NON_ID) {
        /* "*.i"νи".i"regionѴ롥 */
        i_region = spdConvOccToRegion(occ);

        /* "*.i"region"*.c"regionѴ롥 */
        c_region = spdConvRegionItoCbyPIDB(i_region);

        /* ".c"regionlinecolumnѴ롥 */
        if(c_region.fileId != SPD_NON_ID) {
            spdCnvOffsetToLineColumn(c_region.fileId, c_region.offset,
                                     &line, &column);
        }
    }
    return (line);
}
