/* 
 * Program:             $RCSfile: ZipExtract.java,v $  $Revision: 40.1 $
 * 
 * Purpose:             
 *
 * Author:              H.Kuwabara  2001/07/18
 *                      S.Yamamoto  2001/07/18
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

import java.io.*;
import java.util.Enumeration;
import java.util.zip.*;

/**
 *  
 *  
 *  @author H.Kuwabara and S.Yamamoto.
 */

public class ZipExtract
{
    private static final int BUF_SIZE = 1024;

    public static void main(String[] args)
    {
	try{
	    // 
	    ZipFile file = new ZipFile(new File(args[0]));

	    // 
	    for(Enumeration e = file.entries(); e.hasMoreElements(); ){
		// 
		ZipEntry entry = (ZipEntry)e.nextElement();
		// 
		InputStream is = file.getInputStream(entry);
		// 
		FileOutputStream os = new FileOutputStream(entry.getName());

		System.err.println(entry.getName());

		// 
		byte[] b = new byte[BUF_SIZE];
		int size;
		for(int i = 0; i < entry.getSize(); i += size){
		    size = is.read(b, 0, b.length);
		    os.write(b, 0, size);
		}

		os.close();
		is.close();
	    }

	    file.close();
	}
	catch(Exception e){
	    e.printStackTrace();
	}
    }
}
