/* 
 * Program:             $RCSfile: ZipExtract.java,v $  $Revision: 40.3 $
 * 
 * Purpose:             ZIP$B%U%!%$%k$r2rE`$9$k!%(B
 *
 * Author:              H.Kuwabara  2001/07/18
 *                      S.Yamamoto  2001/07/18
 *
 * (C) Copyright:       H.Kuwabara and S.Yamamoto  2001 - 2002
 *                      This file is a product of the project Sapid.
 */

import java.io.*;
import java.util.Enumeration;
import java.util.zip.*;

/**
 *  ZIP$B%U%!%$%k$r2rE`$9$k!%3,AX9=B$$r;}$D(BZIP$B$r07$&$3$H$O$G$-$J$$!%(B
 *  
 *  @author H.Kuwabara and S.Yamamoto.
 */

public class ZipExtract
{
    private static final int BUF_SIZE = 1024;

    public static void main(String[] args)
    {
	try{
	    // ZIP $B%U%!%$%k$r3+$/(B
	    ZipFile file = new ZipFile(new File(args[0]));

	    // $B$9$Y$F$N%(%s%H%j$KBP$7$FA`:n(B
	    for(Enumeration e = file.entries(); e.hasMoreElements(); ){
		// $B%(%s%H%j$r0l$D<hF@(B
		ZipEntry entry = (ZipEntry)e.nextElement();
		// $BF~NO85(B
		InputStream is = file.getInputStream(entry);
		// $B=PNO@h(B
		FileOutputStream os = new FileOutputStream(entry.getName());

		System.err.println(entry.getName());

		// $B=PNO(B
		byte[] b = new byte[BUF_SIZE];
		int size;
		for(int i = 0; i < entry.getSize(); i += size){
		    size = is.read(b, 0, b.length);
		    os.write(b, 0, size);
		}

		os.close();
		is.close();
	    }

	    file.close();
	}
	catch(Exception e){
	    e.printStackTrace();
	}
    }
}
