/* 
 * Program:             $RCSfile: Constitute.c,v $  $Revision: 40.3 $
 * 
 * Purpose:             طƥѴؿ
 * 
 * Author:              N.Kaneko  2002/11/24
 *                      S.Yamamoto  2002/11/24
 * 
 * (C) Copyright:       N.Kaneko and S.Yamamoto  2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: Constitute.c,v 40.3 2002/11/24 09:12:34 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "DeclTest.h"

int testConstitute(int Test)
{
    /*
    programƥȤԤ
    ƥȤˤȤƤϡ1δطδطδطˤ
    ¹֥Ȥλ¹֥Ȥĥ֥Ȥ
    롥
    ʾλ¹˴ؤƤϡؿƵŪ˸ƤӽФƤΤǡ̤
    ƥȤˤԤƤ롥
    */
    
    SpdObjIdArray ClassObjIdArray;
    int i;
    
    /*
    programΥƥ
    library, file
    declaration
    declarator
    */
    if (Test == 0) {
        ClassObjIdArray = spdGetObjIdArray("program", NULL, NULL);
        for(i = 0; i < ClassObjIdArray.size; i++){
            /*program->library->program*/
            Test = checkConstitute(ClassObjIdArray.id[i], "program", "library", Test);
            if(Test != 0){
                break;
            }
            /*program->file->program*/
            Test = checkConstitute(ClassObjIdArray.id[i], "program", "file", Test);
            if(Test != 0){
                break;
            }
            /*program->declaration->program*/
            Test = checkConstitute(ClassObjIdArray.id[i], "program", "declaration", Test);
            if(Test != 0){
                break;
            }
            /*program->declarator->program*/
            Test = checkConstitute(ClassObjIdArray.id[i], "program", "declarator", Test);
            if(Test != 0){
                break;
            }
        }
        spdFreeObjIdArray(ClassObjIdArray);
    }
    /*
    libraryΥƥ
    file
    declaration
    declarator
    */
    if(Test == 0){
        ClassObjIdArray = spdGetObjIdArray("library", NULL, NULL);
        for(i = 0; i < ClassObjIdArray.size; i++){
            /*library->file->library*/
            Test = checkConstitute(ClassObjIdArray.id[i], "library", "file", Test);
            if(Test != 0){
                break;
            }
            /*libray->declaration->library*/
            Test = checkConstitute(ClassObjIdArray.id[i], "library", "declaration", Test);
            if(Test != 0){
                break;
            }
            /*libray->declarator->library*/
            Test = checkConstitute(ClassObjIdArray.id[i], "library", "declarator", Test);
            if(Test != 0){
                break;
            }
        }
        spdFreeObjIdArray(ClassObjIdArray);
    }
    
    /*
    fileΥƥ
    declaration
    declarator
    identifier, optionaldecl
    */
    if(Test == 0){
        ClassObjIdArray = spdGetObjIdArray("file", NULL, NULL);
        for(i = 0; i < ClassObjIdArray.size; i++){
            /*file->declaration->file*/
            Test = checkConstitute(ClassObjIdArray.id[i], "file", "declaration", Test);
            if(Test != 0){
                break;
            }
            /*file->declarator->file*/
            Test = checkConstitute(ClassObjIdArray.id[i], "file", "declarator", Test);
            if(Test != 0){
                break;
            }
            /*file->identifier->file*/
            Test = checkConstitute(ClassObjIdArray.id[i], "file", "identifier", Test);
            if(Test != 0){
                break;
            }
            /*file->optionaldecl->file*/
            Test = checkConstitute(ClassObjIdArray.id[i], "file", "optionaldecl", Test);
            if(Test != 0){
                break;
            }
        }
        spdFreeObjIdArray(ClassObjIdArray);
    }
    
    /*
    declarationΥƥ
    declarator
    identifier, optionaldecl
    ʤ#decl->optdecl->declŪAPI̤б
    */
    if(Test == 0){
        ClassObjIdArray = spdGetObjIdArray("declaration", NULL, NULL);
        for(i = 0; i < ClassObjIdArray.size; i++){
            /*declaration->declarator->declaration*/
            Test = checkConstitute(ClassObjIdArray.id[i], "declaration", "declarator", Test);
            if(Test != 0){
                break;
            }
            /*declaration->identifier->declaration*/
            Test = checkConstitute(ClassObjIdArray.id[i], "declaration", "identifier", Test);
            if(Test != 0){
                break;
            }
            /*declaration->optionaldecl->declaration*/
            Test = checkConstitute(ClassObjIdArray.id[i], "declaration", "optionaldecl", Test);
            if(Test != 0){
                break;
            }
        }
        spdFreeObjIdArray(ClassObjIdArray);
    }
    
    /*
    declaratorΥƥ
    identifier, optionaldecl
    ʤ
    ʤ
    */
    if(Test == 0){
        ClassObjIdArray = spdGetObjIdArray("declarator", NULL, NULL);
        for(i = 0; i < ClassObjIdArray.size; i++){
            /*declarator->identifier->declarator*/
            Test = checkConstitute(ClassObjIdArray.id[i], "declarator", "identifier", Test);
            if(Test != 0){
                break;
            }
            /*declarator->optionaldecl->declarator*/
            Test = checkConstitute(ClassObjIdArray.id[i], "declarator", "optionaldecl", Test);
            if(Test != 0){
                break;
            }
        }
        spdFreeObjIdArray(ClassObjIdArray);
    }
    
    /*
    optionaldeclΥƥ
    declaration
    ʤ
    ʤ
    */
    if(Test == 0){
        ClassObjIdArray = spdGetObjIdArray("optionaldecl", NULL, NULL);
        for(i = 0; i < ClassObjIdArray.size; i++){
            /*optionaldecl->declaration->optionaldecl*/
            Test = checkConstitute(ClassObjIdArray.id[i], "optionaldecl", "declaration", Test);
            if(Test != 0){
                break;
            }
        }
        spdFreeObjIdArray(ClassObjIdArray);
    }
    
    /*
    blockΥƥ
    declaration, label,expression, block
    expression, operator, block
    expression, operator, block
    */
    if(Test == 0){
        ClassObjIdArray = spdGetObjIdArray("block", NULL, NULL);
        for(i = 0; i < ClassObjIdArray.size; i++){
            /*block->block->block*/
            if(spdGetAttrValInt(ClassObjIdArray.id[i], "sort") == BLOCK_HIERACHICAL){
                Test = checkConstitute(ClassObjIdArray.id[i], "block", "block", Test);
                if(Test != 0){
                    break;
                }
            }
            /*block->declaration->block*/
            if(spdGetAttrValInt(ClassObjIdArray.id[i], "sort") == BLOCK_COMP){
                Test = checkConstitute(ClassObjIdArray.id[i], "block", "declaration", Test);
                if(Test != 0){
                    break;
                }
            }
            /*block->label->block*/
            if(spdGetAttrValInt(ClassObjIdArray.id[i], "sort") == BLOCK_HIERACHICAL){
                Test = checkConstitute(ClassObjIdArray.id[i], "block", "label", Test);
                if(Test != 0){
                    break;
                }
            }
            if(spdGetAttrValInt(ClassObjIdArray.id[i], "sort") == BLOCK_HIERACHICAL || spdGetAttrValInt(ClassObjIdArray.id[i], "sort") == BLOCK_BASIC){
                /*block->expression->block*/
                Test = checkConstitute(ClassObjIdArray.id[i], "block", "expression", Test);
                if(Test != 0){
                    break;
                }
            }
            /*block->operator->block*/
            Test = checkConstitute(ClassObjIdArray.id[i], "block", "operator", Test);
            if(Test != 0){
                break;
            }
        }
        spdFreeObjIdArray(ClassObjIdArray);
    }
    
    /*
    labelΥƥ
    expression
    expression, operator
    expression, operator
    */
    if(Test == 0){
        ClassObjIdArray = spdGetObjIdArray("label", NULL, NULL);
        for(i = 0; i < ClassObjIdArray.size; i++){
            /*label->expression->label*/
            Test = checkConstitute(ClassObjIdArray.id[i], "label", "expression", Test);
            if(Test != 0){
                break;
            }
            /*label->operator->label*/
            Test = checkConstitute(ClassObjIdArray.id[i], "label", "operator", Test);
            if(Test != 0){
                break;
            }
        }
        spdFreeObjIdArray(ClassObjIdArray);
    }
    
    /*
    expresssionΥƥ
    expression, operator
    expression, operator
    expression, operator
    */
    if(Test == 0){
        ClassObjIdArray = spdGetObjIdArray("expression", NULL, NULL);
        for(i = 0; i < ClassObjIdArray.size; i++){
            /*expression->expression->expression*/
            Test = checkConstitute(ClassObjIdArray.id[i], "expression", "expression", Test);
            if(Test != 0){
                break;
            }
            /*expression->operator->expression*/
            Test = checkConstitute(ClassObjIdArray.id[i], "expression", "operator", Test);
            if(Test != 0){
                break;
            }
        }
        spdFreeObjIdArray(ClassObjIdArray);
    }
    
    /*
    type, operator, constant ϻ¹֥ȤʤΤǥƥȤʤ
    */
    
    return(Test);
}

int checkConstitute(SpdObjId check_id, SpdString check_id_class,
                    SpdString check_class, int TestFlag)
{
    SpdTargetObjSet parent_objs, child_objs;
    int i, j;
    TestFlag = 0;/*ƥѤΥե饰 0:ƥȰ۾ʤ, 1:ƥȰ۾濫*/
    
    /*check_id_class->check_class->check_id_class*/
    child_objs = spdGetDescendedObjs(check_id, check_class);
    for(i = 0; i < child_objs.TargetObjNum; i++){
        if(TestFlag == 0){
            parent_objs = spdGetAncestralObjs(child_objs.TargetObjIds[i], check_id_class);
            TestFlag = 1;
            for(j = 0; j < parent_objs.TargetObjNum; j++){
                if(parent_objs.TargetObjIds[j] == check_id){
                    TestFlag = 0;
                }
            }
            if(TestFlag == 1){
                spdWarning("%s->%s->%s not matched.\n",check_id_class, check_class, check_id_class);
                spdWarning("Class:%s id:%d,\t Class:%s id:%d\n", check_id_class, check_id, check_class, child_objs.TargetObjIds[i]);
                break;
            }
        }
        spdFreeSpdTargetObjSet(parent_objs);
    }
    spdFreeSpdTargetObjSet(child_objs);
    return TestFlag;
}
