# 
# Program:              $RCSfile: spdGetTotalProfSub.awk,v $  $Revision: 40.5 $
# 
# Purpose:              
# 
# Author:               S.Yamamoto  2002/10/05
# 
# Copyright:            S.Yamamoto  2002
#                       This file is a product of the project Sapid.
#

# 
# $Id: spdGetTotalProfSub.awk,v 40.5 2002/10/05 07:58:05 yamamoto Exp yamamoto $
# 

BEGIN {
    for (i = 0; i < ARGC; i++) {
        if (ARGV[i] == "verbose=1") {
            is_verbose = 1;
        } 
    }
}

/^Sapid: [a-zA-Z0-9_]+: Time profile: / {
    # printf("\"%s\".\n", $0);

    # Format: 
    #     Sapid: spdGetObjId: Time profile: "0.00u 0.00s 0:00.00".
    split($0, part, ": ");
    if (is_verbose) {
        printf("%s, %s.\n", part[2], part[4]);
    }
    split(part[4], time, " ");
    # printf("    %s, %s, %s.\n", time[1], time[2], time[3]);

    # Trim double quote, "u" and "s".
    gsub("\"", "", time[1]);
    gsub("u", "", time[1]);
    gsub("s", "", time[2]);
    if (is_verbose) {
        # printf("           %f, %f, %s.\n", time[1], time[2], time[3]);
        printf("           %f, %f.\n", time[1], time[2]);
    }

    commandU[part[2]] += time[1];
    totalU += time[1]
    commandS[part[2]] += time[2];
    totalS += time[2]
    # printf("    %s\t%f\t%f\n", part[2], commandU[part[2]], commandS[part[2]]);
    if (is_verbose) {
        printf("    accum: %f, %f.\n", commandU[part[2]], commandS[part[2]]);
        printf("    total: %f, %f.\n", totalU, totalS);
    }
}

END {
    printf("# Command               u time\t%% of %.2f\n", totalU);
    for (x in commandU) {
        printf("%-16s\t%.2f\t%.2f%%\n", x, commandU[x], (commandU[x] / totalU) * 100) | "sort -t '\t' +1rn"
    }
    close("sort -t '\t' +1rn");
    printf("\n");

    printf("# Command               s time\t%% of %.2f\n", totalS);
    for (x in commandS) {
        printf("%-16s\t%.2f\t%.2f%%\n", x, commandS[x], (commandS[x] / totalS) * 100) | "sort -t '\t' +1rn"
    }
    close("sort -t '\t' +1rn");
    printf("\n");
}
