/*
 * Program:             $RCSfile: arg_type.c,v $  $Revision: 30.9 $
 *
 * Purpose:             
 *
 * Author:              K.Hayashi  1995/02/20
 * Modified:            S.Yamamoto  1995/03/13
 *
 * (C) Copyright:       K.Hayashi and S.Yamamoto  1995 - 1998
 *                      This file is a product of the project Sapid.
 */

/* 
 * ؿArgTable getFuncArgTableSub()˴ؤ(R.Miura 1997/12/09)
 * 
 * Subject: [sapid:02030]
 * Date:    Sun, 23 Nov 1997 17:59:59 +0900
 * From:    Miura Ryo <miura@agusa.nuie.nagoya-u.ac.jp>
 * 
 * ʲΥץmkSpec4ˤȡ¸ߤʤhuftϤޤ
 * 
 * ==============================
 * struct huft {
 *     int a;
 * };
 * 
 * int huft_free(struct huft *t)
 * {
 * }
 * ==============================
 * 
 * sat4ǳǧȤ
 * 
 *     decl                   decr                   ident
 * 
 * struct huft *t ---+--- huft (DECL_TAG)    --- huft (ID_TAG)
 *                   |
 *                   +--- *t (DECL_VARIABLE) --- t (ID_VARIABLE)
 * 
 * ȤʤäƤޤDECL_TAGǤdecrβˤϡID_VARIABLEǤident
 * ʤΤǡdecl_ident򤿤ɤˡDECL_TAGǤdecrϤ褦ˤ
 * ºݤˤϡdecl_decl 򤿤ɤˡDECL_VARIABLE ʤΤ
 * ǥ롼פƤ롥
 */

#ifndef lint
static char rcsid[] =
    "$Id: arg_type.c,v 30.9 2003/06/28 15:34:13 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spie.h"

#define FIX_NPR_20010217

extern SmuXrefTables xreftables;
ProtoTable prototable;

static SpdSet proto_set;

static void makeProtoTableSub(SpdObjId ident_id);
int cmp_proto_table(ProtoTableElem *a, ProtoTableElem *b);

static ArgTable getFuncArgTable(SpdObjId ident_id);
static ArgTable getFuncArgTableSub(SpdObjId decr_id);
static SpdString getProtoStr(ArgTable args);

void makeProtoTable(void)
{
    SmuXrefTable table;
    int i;

    proto_set = SAPID_EMPTY_SET;
    
    prototable.size = 0;
    prototable.elem = NULL;
    table = xreftables.funcCallTable;

    for (i = 0; i < table.size; i++) {
#ifdef FIX_NPR_20010217
        if (table.elem[i].callerId != SPD_NON_ID) {
            makeProtoTableSub(table.elem[i].callerId);
        } else {
            spdWarning("Callee \"%s\": Non caller id.\n",
                       spdGetName(table.elem[i].calleeId));
        }
#else
        makeProtoTableSub(table.elem[i].callerId);
#endif

        makeProtoTableSub(table.elem[i].calleeId);
    }
    SPD_QSORT(prototable.elem, prototable.size, sizeof(ProtoTableElem),
                cmp_proto_table);

    /* clean_set(&proto_set); */
}

static void makeProtoTableSub(SpdObjId ident_id)
{
    
    if (spdSetContains(proto_set, ident_id)) return;
    spdAddElem(proto_set, ident_id, NULL);

    /* ޤȤƳݤ褦ѹ */
    if (prototable.max_size <= prototable.size) {
        prototable.elem = spdRealloc(prototable.elem, sizeof(ProtoTableElem) * 
                                     (prototable.max_size + DEFAULT_ALLOC_SIZE));
        prototable.max_size += DEFAULT_ALLOC_SIZE;
    }

    /* prototable.elem = spdRealloc(prototable.elem,
       sizeof(ProtoTableElem) * (prototable.size +1));*/

    prototable.elem[prototable.size].identId = ident_id;
    prototable.elem[prototable.size].name = spdStrdup(spdGetName(ident_id));
    prototable.elem[prototable.size].args = getFuncArgTable(ident_id);
    prototable.elem[prototable.size].proto =
        spdStrdup(getProtoStr(prototable.elem[prototable.size].args));

    /*
     *  Modified for fixing mkSpec4-0097 by R.Miura 1997/12/28.
     *
     *  if (prototable.elem[prototable.size].args.elem == NULL) {
     *      prototable.elem[prototable.size].type = spdStrdup("");
     *  } else {
     *      ...
     *  }
     */

#ifdef BUGGY_MKSPEC3_0039       
    prototable.elem[prototable.size].type =
        spdStrdup(getTypeName0039(spdGetARelObj(ident_id, "ident_type",
                                                "identifier_id"), ident_id));
#else
    prototable.elem[prototable.size].type =
        spdStrdup(getTypeName(spdGetARelObj(ident_id, "ident_type",
                                            "identifier_id")));
#endif

    prototable.elem[prototable.size].system = is_system(ident_id);
    prototable.size++;

    return;
}

ProtoTableElem *lookUpProtoTable(SpdObjId identId)
{
    ProtoTableElem key;
    ProtoTableElem *result;

    key.identId = identId;
    result = (ProtoTableElem *)SPD_BSEARCH(&key, prototable.elem,
                                             prototable.size,
                                             sizeof(ProtoTableElem),
                                             cmp_proto_table);

    if (result == NULL) {
        /* Missing function without neither callee nor caller. */
        makeProtoTableSub(identId);
        /* 
         * Modified for fixing mkSpec4-0096 by R.Miura 1997/12/09.
         * 嵭makeProtoTableSub()ˤäƿ˥ȥ꤬ɲä졤
         * ƤӥȤԤʤɬפΤǡʲ˥ʸɲä
         * ºݤˤϿɲʬΤߤ򥵡нʬǤ롥
         */
        SPD_QSORT(prototable.elem, prototable.size,
                    sizeof(ProtoTableElem), cmp_proto_table);

        result = (ProtoTableElem *)SPD_BSEARCH(&key, prototable.elem,
                                                 prototable.size,
                                                 sizeof(ProtoTableElem),
                                                 cmp_proto_table);
        if (result == NULL) {
            spdErrorExit("Can't get prototype of \"%s\".\n",
                         spdGetName(identId));
        }
    }
    return result;
}

void freeProtoTable(void)
{
    int i;
    
    for (i = 0; i < prototable.size; i++) {
        spdFree(prototable.elem[i].name);
        spdFree(prototable.elem[i].args.elem);
        spdFree(prototable.elem[i].proto);
        spdFree(prototable.elem[i].type);
    }
    spdFree(prototable.elem);
    spdFreeSet(proto_set);

    prototable.size = 0;
    prototable.max_size = 0;
    prototable.elem = NULL;
}

static SpdString getFuncArgTypeRaw(SpdObjId decr_id)
{
    static char buf[1024];
    SpdRelArray decls, args;
    SpdObjId opt_id, ident_id;
    int i, j;
    SpdSet ident_set = SAPID_EMPTY_SET;
    
    opt_id = spdGetARelObj(decr_id, "decl_opt", "any");
    strcpy(buf, "(");
    decls = spdGetRelSortedArray(opt_id, "func_parm",
                                 "any", NULL, spdCompareRelOffset);

    for (i = 0; i < decls.size; i++) {
        args = spdGetRelSortedArray(decls.rel[i].objectId, "decl_decl",
                                    "any", NULL, spdCompareRelOffset);
        for (j = 0; j < args.size; j++) {
            ident_id = spdGetARelObj(args.rel[j].objectId, "decl_ident", "any");
            if (!spdSetContains(ident_set, ident_id)) {
                spdAddElem(ident_set, ident_id, NULL);
                strcat(buf, getDeclStr(spdGetARelObj(ident_id, "ident_type",
                                                     "any"),
                                       spdGetName(ident_id)));
                strcat(buf, ", ");
            }
        }
        spdFreeRelArray(args);
    }
    spdFreeSet(ident_set);
    spdFreeRelArray(decls);
    if (strlen(buf) == 1)
        return "(void)";
    buf[strlen(buf) - 2] = '\0';
    strcat(buf, ")");
    return buf;
}

static SpdString getProtoArgType(SpdObjId decr_id)
{
    static char buf[1024];
    SpdRelArray parms;
    SpdObjId opt_id, type_id;
    int i;
    
    opt_id = spdGetARelObj(decr_id, "decl_opt", "any");
    strcpy(buf, "(");
    parms = spdGetRelSortedArray(opt_id, "prot_parm",
                                 "any", NULL, spdCompareRelOffset);
    
    for (i = 0; i < parms.size; i++) {
        type_id = spdGetARelObj(parms.rel[i].objectId, "decl_type", "any");
        strcat(buf, getTypeName(type_id));
        if (buf[strlen(buf) - 1] == ' ')
            buf[strlen(buf) - 1] = '\0';
        strcat(buf, ", ");
    }
    spdFreeRelArray(parms);
    if (strlen(buf) == 1)
        return "(void)";
    buf[strlen(buf) - 2] = '\0';
    strcat(buf, ")");
    return buf;
}

SpdString getFuncArgType(SpdObjId ident_id)
{
    SpdObjId decr_id;
    SpdCursor *csr;
    static char buf[1024];
    
    /* strcpy(buf, ""); */
    buf[0] = '\0';
    
    csr = spdGetRelObjInit(ident_id, "decl_ident", "any");
    while ((decr_id = spdGetRelObj(csr)) != -1
           && spdGetAttrValIntOfObj(decr_id, "sort") != DECL_FUNCDEF) {
        /* Empty. */;
    }
    spdFreeCursor(csr);
    if (decr_id != -1) {
        strcat(buf, getFuncArgTypeRaw(decr_id));
    } else {
        csr = spdGetRelObjInit(ident_id, "decl_ident", "any");
        while ((decr_id = spdGetRelObj(csr)) != -1
               && spdGetAttrValInt(decr_id, "sort") != DECL_PROTOTYPE);
        spdFreeCursor(csr);
        if (decr_id != -1) {
            strcat(buf, getProtoArgType(decr_id));
        } else
            return NULL;
    }
    return buf;
}

static ArgTable getFuncArgTableSub(SpdObjId decr_id)
{
    SpdRelArray decls;
    SpdObjId opt_id, ident_id, decrId;
    SpdCursor *csr;
    int i, index;
    SpdSet ident_set = SAPID_EMPTY_SET;

    ArgTable table = {0, NULL};
    
    opt_id = spdGetARelObj(decr_id, "decl_opt", "any");
    decls = spdGetRelSortedArray(opt_id, "func_parm",
                                 "any", NULL, spdCompareRelOffset);
    table.size = decls.size;
    table.elem = spdMalloc(sizeof(ArgTableElem) * table.size);
    
    index = 0;
    for (i = 0; i < decls.size; i++) {
        /* Modify by R.Miura 1997/12/01. */
        csr = spdGetRelObjInit(decls.rel[i].objectId, "decl_decl", "any");
        while ((decrId = spdGetRelObj(csr)) != SPD_NON_ID &&
               spdGetAttrValInt(decrId, "sort") != DECL_VARIABLE) {
            /* Empty. */;   
        }
        spdFreeCursor(csr);
        ident_id = spdGetARelObj(decrId, "decl_ident", "any");
        if (!spdSetContains(ident_set, ident_id)) {
            spdAddElem(ident_set, ident_id, NULL);
            table.elem[index].ident_id = ident_id;
            if (ident_id == SPD_NON_ID) {
                table.elem[index].type_id = 
                    spdGetARelObj(decls.rel[index].objectId,
                                  "decl_type", "any");
                /* table.elem[index].type_id = spdGetARelObj(decrId,
                   "decl_type", "any"); */
            } else {
                table.elem[index].type_id  =  
                    spdGetARelObj(ident_id, "ident_type", "any");
            }
            index++;
        } else {
            /* K&R definition. */
            break;
        }
    }

    table.size = index;
    if (decls.size != table.size) {
        table.elem = spdRealloc(table.elem,
                                sizeof(ArgTableElem) * table.size);
    }
    
    spdFreeSet(ident_set);
    spdFreeRelArray(decls);

    return table;
}

static ArgTable getProtoArgTableSub(SpdObjId decr_id)
{
    SpdRelArray decls;
    SpdObjId opt_id, decrId, ident_id;
    SpdCursor *csr;
    int i, index;

    ArgTable table = {0, NULL};
    
    opt_id = spdGetARelObj(decr_id, "decl_opt", "any");
    decls = spdGetRelSortedArray(opt_id, "prot_parm",
                                 "any", NULL, spdCompareRelOffset);
    table.size = decls.size;
    table.elem = spdMalloc(sizeof(ArgTableElem) * table.size);

    index = 0;
    for (i = 0; i < decls.size; i++) {
        /* Modify by R.Miura 1997/12/01. */
        csr = spdGetRelObjInit(decls.rel[i].objectId, "decl_decl", "any");
        while ((decrId = spdGetRelObj(csr)) != SPD_NON_ID &&
               spdGetAttrValInt(decrId, "sort") != DECL_VARIABLE) {
            /* Empty. */;
        }
        spdFreeCursor(csr);
    
        ident_id = spdGetARelObj(decrId, "decl_ident", "any");
        if (ident_id == SPD_NON_ID) {
            table.elem[index].type_id = spdGetARelObj(decls.rel[i].objectId,
                                                      "decl_type", "any");
        } else {
            table.elem[index].type_id = spdGetARelObj(ident_id, "ident_type",
                                                      "any");
        }
        table.elem[index].ident_id = ident_id;
        index++;
    }

    table.size = index;
    if (decls.size != table.size) {
        table.elem = spdRealloc(table.elem,
                                sizeof(ArgTableElem) * table.size);
    }
    spdFreeRelArray(decls);
    
    return table;
}

static ArgTable getFuncArgTable(SpdObjId ident_id)
{
    SpdCursor *csr;
    SpdObjId decr_id;
    ArgTable table = {0, NULL};
    
    csr = spdGetRelObjInit(ident_id, "decl_ident", "any");
    while ((decr_id = spdGetRelObj(csr)) != -1
           && spdGetAttrValIntOfObj(decr_id, "sort") != DECL_FUNCDEF) {
        /* Empty. */;
    }
    spdFreeCursor(csr);
    
    if (decr_id != -1) {
        table = getFuncArgTableSub(decr_id);
    } else {
        csr = spdGetRelObjInit(ident_id, "decl_ident", "any");
        while ((decr_id = spdGetRelObj(csr)) != -1
               && spdGetAttrValInt(decr_id, "sort") != DECL_PROTOTYPE);
        spdFreeCursor(csr);
        if (decr_id != -1) {
            table = getProtoArgTableSub(decr_id);
            /* 
             * } else {
             *     spdWarning("function %s has no prototype.\n",
             *                spdGetName(ident_id));
             */
        }
    }
    if (flag_w && table.size == 0) {
        spdWarning("Function \"%s\" has no/invalid prototype.\n",
                   spdGetName(ident_id));
    }
    return table;
}

static SpdString getProtoStr(ArgTable args)
{
    static char buf[1024];
    int i;
    
    strcpy(buf, "(");

    for (i = 0; i < args.size; i++) {
        if (args.elem[i].ident_id == SPD_NON_ID) {
            /* "void", "..." and no name. */
            strcat(buf, getTypeName(args.elem[i].type_id));
        } else {
            strcat(buf, getDeclStr(args.elem[i].type_id,
                                   spdGetName(args.elem[i].ident_id)));
        }
        if (buf[strlen(buf) - 1] == ' ')
            buf[strlen(buf) - 1] = '\0';
        strcat(buf, ", ");
    }

    /* Added by Y.Momiyama 1997/07/24. */
    if (strlen(buf) == 1) {
        return "(void)";
    }

    buf[strlen(buf) - 2] = '\0';

    strcat(buf, ")");
    return buf;
}

int cmp_proto_table(ProtoTableElem *a, ProtoTableElem *b)
{
    return a->identId - b->identId;
}
