/*
 * Program:             $RCSfile: basic.c,v $  $Revision: 30.11 $
 *
 * Purpose:             Utility file of SPIE.
 *
 * Author:              K.Hayashi  1995/02/20
 * Modified:            S.Yamamoto  1995/03/13
 *
 * (C) Copyright:       K.Hayashi and S.Yamamoto  1995 - 2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: basic.c,v 30.11 2001/08/26 08:05:37 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spie.h"
#include "spie-proto.h"

static SpdObjId spdGetFileOfObj(SpdObjId id)
{
    SpdOcc      occ;
    SpdObjId    blockId;

    occ = spdGetAnOffsetOfObj(id);
    blockId = spdGetABlockId(occ.fileId,
                             spdGetAbsoluteOffset(occ.relationId, occ.fileId));
    return (spdGetARelObj(blockId, "file_block", "c-id"));
}

/******************************************************************************/

SpdBoolean is_system(SpdObjId ident_id)
{
    SpdObjId decr_id, decl_id;
    SpdCursor *csr;
    
    csr = spdGetRelObjInit(ident_id, "decl_ident", "any");
    while ((decr_id = spdGetRelObj(csr)) != -1) {
        decl_id = spdGetARelObj(decr_id, "decl_decl", "any");
        if (spdGetAttrValIntOfObj(decl_id, "sort") == DECL_FUNCDEF ||
            spdGetAttrValIntOfObj(decl_id, "storage") != STORAGE_EXTERN) {
            spdFreeCursor(csr);
            return (smuIsSystemFile(spdGetFileOfObj(decl_id)));
        }
    }
    spdFreeCursor(csr);
    return (TRUE);
}

SpdBoolean is_system_macro(SpdObjId macro_id)
{
    SpdRel      rel;

    rel = spdGetARel(macro_id, "mpatt_mname", "c-id");
    rel = spdGetARel(rel.objectId, "def_mpatt", "c-id");
    rel = spdGetARel(rel.objectId, "file_block", "c-id");
    return (smuIsSystemFile(rel.objectId));
}
