/* 
 * Program:             $RCSfile: const.c,v $  $Revision: 30.24 $
 * 
 * Purpose:             
 * 
 * Author:              H.Ohhashi  1997/07/01
 *                      S.Yamamoto  1998/03/14
 * 
 * (C) Copyright:       H.Ohhashi and S.Yamamoto  1997 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: const.c,v 30.24 2003/06/28 15:34:13 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spie.h"

#ifndef BUGGY_SDBLINK4_0107

#ifdef SPIE_MORE_SORT
static int compareOccId(SpdOcc *a, SpdOcc *b);
#endif

/* 
 * ƱνиǼƤʤĴ٤롥κݤˡvalue
 * constantIDդˤȤԤ
 */

static SpdBoolean containConstOcc(ConstOccElem *element, ConstOcc occ)
{
    int     i;

    for (i = 0; i < occ.size; i++) {
        /* valueconstantIDդˤ롥 */
        if (SPD_STREQ(occ.elem[i].org_value, element->value)) {
            element->const_id = occ.elem[i].const_id;
            if (occ.elem[i].offset == element->offset &&
                SPD_STREQ(spdGetName(occ.elem[i].file_id), 
                            spdGetName(element->file_id))) {
                return (TRUE);
            }
        }
    }
    return (FALSE);
}

/*
 * constantξ硤'-'ޤconstantȤưˡ
 * ñ黻'-'롥
 */

static SpdString getUnaryMinus(ConstOccElem *elem)
{
    SpdObjId    ref, p_expr;

    ref = spdGetARelObj(elem->const_id, "const_ref", "c-id");
    p_expr = spdGetARelObj(ref, "expr_expr", "c-id");
    if (p_expr != SPD_NON_ID) {
        SpdObjId    op_id;
        SpdObjIdArray expr_array;
        expr_array = spdGetRelObjArray(p_expr, "expr_expr", "p-id", NULL);
        op_id = spdGetARelObj(p_expr, "expr_op", "p-id");
        if (op_id != SPD_NON_ID && expr_array.size == 1 &&
            spdGetAttrValInt(op_id, "sort") == OP_MINUS) {
            SpdRegion   i_reg, c_reg;
            SpdOcc      occ;
            
            occ = spdGetAnOffsetOfObj(p_expr);
            i_reg = spdConvOccToRegion(occ);
            c_reg = spdConvRegionItoCbyPIDB(i_reg);
            /* ñޥʥ黻ҤoffsetlengthĴ롥 */
            elem->offset = c_reg.offset;
            elem->length = c_reg.length;
            spdFreeObjIdArray(expr_array);
            return spdStrdup("-");
        }
        spdFreeObjIdArray(expr_array);
    }
    return NULL;
}

#if defined(SPIE_TRAVERSE)

/*
 * ξ.                    
 * valueHTMLüʸäƤ硤Ѵɬפ롥
 */

void getConstant(SpdObjId file_id)
{
    SpdOccArray     const_buf;
    SpdRegion       i_reg, c_reg;
    ConstOccElem    element;
    SpdString       unary_minus, const_value;
    int             i;

    const_buf = traverse.const_buf;

#ifdef SPIE_MORE_SORT
    SPD_QSORT(const_buf.occ, const_buf.size, sizeof(SpdOcc), 
                compareOccId);
#endif

    for (i = 0; i < const_buf.size; i++) {
        if (const_buf.occ[i].fileId != file_id) {
            continue;
        }

        element.const_id = const_buf.occ[i].objectId;

        /* occ -> region Ѵ */
        i_reg = spdConvOccToRegion(const_buf.occ[i]);

        c_reg = spdConvRegionItoCbyPIDB(i_reg);
        element.file_id = spdConvIdPfileToFile(c_reg.fileId);
        element.offset = c_reg.offset;
        element.length = c_reg.length;
        /* ñޥʥ黻Ҥ롥offsetlengthĴ롥 */
        unary_minus = getUnaryMinus(&element);
        const_value = spdGetAttrValString(const_buf.occ[i].objectId, "value");
        if (unary_minus != NULL && const_value != NULL) {
            element.value = spdStrcatDup(unary_minus, const_value);
        } else {
            element.value = spdStrdup(const_value);
        }
        /* Check NULL pointer. */
        if (element.value == NULL) {
            continue;
        }

        if (c_reg.offset != SPD_NON_OFFSET && 
            !smuIsSystemFile(c_reg.fileId) &&
            !containConstOcc(&element, constant)) {

            if (constant.max_size <= constant.size) {
                constant.elem = spdRealloc(constant.elem, 
                                           sizeof(ConstOccElem) * 
                                           (constant.max_size + 
                                            DEFAULT_ALLOC_SIZE));
                constant.max_size += DEFAULT_ALLOC_SIZE;
            }

            constant.elem[constant.size].offset = element.offset;
            constant.elem[constant.size].file_id = element.file_id;
            constant.elem[constant.size].const_id = element.const_id;
            constant.elem[constant.size].length =  element.length;
            constant.elem[constant.size].org_value = spdStrdup(element.value);

            constant.elem[constant.size].value = spdStrdup(convTextToHtml(element.value, CONV_HTML));
            constant.size++;
        }
    }
}

#else /* ! defined(SPIE_TRAVERSE) */

void getConstant(SpdObjId file_id)
{
    SpdOccArray     const_buf;
    SpdRegion       i_reg, c_reg;
    ConstOccElem    element;
    SpdString       unary_minus, const_value;
    int             i;
    
    const_buf = spdGetIncludedOccArray(file_id, "constant", file_id, NULL);

#ifdef SPIE_MORE_SORT
    SPD_QSORT(const_buf.occ, const_buf.size, sizeof(SpdOcc), 
                compareOccId);
#endif

    for (i = 0; i < const_buf.size; i++) {
        element.const_id = const_buf.occ[i].objectId;

        /* occ -> region Ѵ */
        i_reg = spdConvOccToRegion(const_buf.occ[i]);

        c_reg = spdConvRegionItoCbyPIDB(i_reg);
        element.file_id = spdConvIdPfileToFile(c_reg.fileId);
        element.offset = c_reg.offset;
        element.length = c_reg.length;
        /* ñޥʥ黻Ҥ롥offsetlengthĴ롥 */
        unary_minus = getUnaryMinus(&element);
        const_value = spdGetAttrValString(const_buf.occ[i].objectId, "value");
        if (unary_minus != NULL && const_value != NULL) {
            element.value = spdStrcatDup(unary_minus, const_value);
        } else {
            element.value = spdStrdup(const_value);
        }
        /* Check NULL pointer. */
        if (element.value == NULL) {
            continue;
        }

        if (c_reg.offset != SPD_NON_OFFSET && 
            !smuIsSystemFile(c_reg.fileId) &&
            !containConstOcc(&element, constant)) {

            if (constant.max_size <= constant.size) {
                constant.elem = spdRealloc(constant.elem, 
                                           sizeof(ConstOccElem) * 
                                           (constant.max_size + 
                                            DEFAULT_ALLOC_SIZE));
                constant.max_size += DEFAULT_ALLOC_SIZE;
            }

            constant.elem[constant.size].offset = element.offset;
            constant.elem[constant.size].file_id = element.file_id;
            constant.elem[constant.size].const_id = element.const_id;
            constant.elem[constant.size].length =  element.length;
            constant.elem[constant.size].org_value = spdStrdup(element.value);

            constant.elem[constant.size].value = spdStrdup(convTextToHtml(element.value, CONV_HTML));
            constant.size++;
        }
    }

    spdFreeOccArray(const_buf);
}

#endif /* ! defined(SPIE_TRAVERSE) */

#ifdef SPIE_MORE_SORT

static int compareOccId(SpdOcc *a, SpdOcc *b)
{
    return (a->objectId - b->objectId);
}

#endif /* SPIE_MORE_SORT */

#endif /* not BUGGY_SDBLINK4_0107 */
