/* 
 * Program:             $RCSfile: document.c,v $  $Revision: 40.7 $
 * 
 * Purpose:             
 *
 * Author:              K.Toita  2002/01/09
 *                      S.Yamamoto  2002/01/09
 *
 * (C) Copyright:       K.Toita and S.Yamamoto  2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: document.c,v 40.7 2003/06/28 15:34:14 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spie.h"

/* !! DmodelAR 줿褤Ȼפ롥*/
/* 륪֥Ȥ docfile_id  */

SpdObjId spdGetDocfileId(SpdObjId id)
{
    SpdClassId classId;
    SpdModelId modelId;
    SpdRelArray rels;
    SpdObjId docfileId;
    int i;
    
    classId = spdGetClassId(id);
    modelId = spdGetModelId(classId);
    if (!SPD_STREQ(spdGetModelNameById(spdGetModelId(classId)), "D-model")) {
        return SPD_NON_ID;
    }
    switch (classId) {
        /* software 饹 document 饹 SPD_NON_ID ֤ */  
      case SPD_CID_SOFTWARE:
      case SPD_CID_DOCUMENT:
        return SPD_NON_ID;
        break;
      case SPD_CID_DOCFILE:
        return id;
        break;
    }

    if ((docfileId = spdGetARelObj(id, "docfile_docfrag", "c-id")) != SPD_NON_ID) {
        return docfileId;
    }

    rels = spdGetRelArray(id, "docelem_docfrag", "c-id", NULL);
    for ( i = 0; i < rels.size; i++) {
        docfileId = spdGetDocfileId(rels.rel[i].objectId);
        if (docfileId != SPD_NON_ID) {
            spdFreeRelArray(rels);
            return docfileId;
        }
    }

    spdFreeRelArray(rels);
    return SPD_NON_ID;
}

/*  docidentId Ͽ */

static void setMacroDocidentIdintoArraySub(SpdObjId docidentId)
{
    MacroDocidentIdArray.id = spdRealloc(MacroDocidentIdArray.id,
                                         sizeof(SpdObjId) * (MacroDocidentIdArray.size +1));
    MacroDocidentIdArray.id[MacroDocidentIdArray.size] = docidentId;
    MacroDocidentIdArray.size++;
}


/* sort  macro  docidentId Ͽ */

void setMacroDocidentIdintoArray(void)
{
    SpdObjId docidentId;
    SpdCursor *docidentCsr;

    /*   */
    MacroDocidentIdArray.size = 0;
    
    docidentCsr = spdGetObjIdInit("docident", NULL);
    while ((docidentId = spdGetObjId(docidentCsr)) != SPD_NON_ID) {
        if (spdGetAttrValInt(docidentId, "sort") == DID_MACRONAME) {
            setMacroDocidentIdintoArraySub(docidentId);
        }
    }
    spdFreeCursor(docidentCsr);
}

SpdObjId searchMacroDocidentId(DefElem element)
{
    int i;

    for (i = 0; i < MacroDocidentIdArray.size; i++) {
        if (SPD_STREQ(spdGetName(element.ident_id),
                        spdGetName(MacroDocidentIdArray.id[i]))) {
            return MacroDocidentIdArray.id[i];
        }
    }
    return SPD_NON_ID;
}

static void getDocDefineSub(SpdObjId docidentId)
{
    SpdObjId docfileId, docfragId, srcelemId;
    SpdRel rel;
    SpdRelArray rels;
    char file_name[FILENAME_MAX + 1];
    char c;
    SpdString str;
    FILE *fp;
    int i;
    int offset, length, max_len;
    
    docfragId = spdGetARelObj(docidentId, "defelem_docident", "docident_id");

    if (docfragId == SPD_NON_ID) { /* ̻һȤѤ줿 */
        return;
    }
    
    /* ΰ(DEFAULT_ALLOC_SIZEĳݤ) */
    if (doc_def.max_size <= doc_def.size) {
        doc_def.elem = spdRealloc(doc_def.elem, sizeof(DocDefElem) * 
                                  (doc_def.max_size + DEFAULT_ALLOC_SIZE));
        doc_def.max_size += DEFAULT_ALLOC_SIZE;
    }

    docfileId = spdGetDocfileId(docfragId);

    /* ץʬ򸫤Ĥ */
    srcelemId = SPD_NON_ID;
    rels = spdGetRelArray(docfragId, "docelem_docfrag", "p-id", NULL);
    for (i = 0; i < rels.size; i++) {
        if((spdGetAttrValInt(docidentId, "sort") == DID_MACRONAME &&
            spdGetAttrValInt(rels.rel[i].objectId, "sort") == DOCFRAG_MACROELEM) ||
           (spdGetAttrValInt(docidentId, "sort") != DID_MACRONAME &&
            spdGetAttrValInt(rels.rel[i].objectId, "sort") == DOCFRAG_SRCELEM)) {
            srcelemId = rels.rel[i].objectId;
            offset = spdGetOffset(rels.rel[i].relationId);
            length = spdGetLength(rels.rel[i].objectId);
        }
    }
    if (srcelemId == SPD_NON_ID) { /* file ξ */
        /* docfragId  */
        rel = spdGetARel(docfragId, "docelem_docfrag", "c-id");
        offset = spdGetOffset(rel.relationId);
        length = spdGetLength(docfragId);
    }
    spdFreeRelArray(rels);
    
    doc_def.elem[doc_def.size].docfile_id = docfileId;
    doc_def.elem[doc_def.size].docfrag_id = docfragId;
    doc_def.elem[doc_def.size].docident_id = docidentId;
    doc_def.elem[doc_def.size].srcelem_id = srcelemId;
    doc_def.elem[doc_def.size].offset = offset;
    doc_def.elem[doc_def.size].length = length;

    if (srcelemId != SPD_NON_ID) {
        sprintf(file_name, "%s/%s/%d", spdGetSDBdir(), SAPID_SRC_DIR, docfileId);
        fp = spdFopen(file_name, SPD_FOPEN_RT_MODE);

        while (offset > 0) {
            getc(fp);
            offset--;
        }

        length = 0;
        while ((c = getc(fp)) != '>') {
            length++;
        }

        max_len = doc_def.elem[doc_def.size].length - length;

        str = spdMalloc(sizeof(SpdString) * max_len + 1);

        for (i = 0; i < max_len; i++) {
            str[i] = getc(fp);
        }

        while (str[i] != '<') {
            i--;
        }
        str[i] = '\0';
        
        doc_def.elem[doc_def.size].str = spdStrdup(str);
        spdFree(str);
        spdFclose(fp);
        
    }
    doc_def.size++;
}
    
/* ɥȤǤƼ */

void getDocDefine(void)
{
    SpdObjId docidentId;
    SpdCursor *docidentCsr;

    /* ̻ҤId鼱̻Ǥ */
    docidentCsr = spdGetObjIdInit("docident", NULL);
    while ((docidentId = spdGetObjId(docidentCsr)) != SPD_NON_ID) {
        getDocDefineSub(docidentId);
    }
    spdFreeCursor(docidentCsr);
}
