/* 
 * Program:             $RCSfile: getIdent.c,v $  $Revision: 30.50 $
 * 
 * Purpose:             
 * 
 * Author:              H.Ohhashi  1997/07/01
 *                      S.Yamamoto  1998/03/14
 * 
 * (C) Copyright:       H.Ohhashi and S.Yamamoto  1997 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: getIdent.c,v 30.50 2003/08/11 10:24:47 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/SpdStr.h>
#include "spie.h"

static void delGVarFromExt(void);

#if !defined(SPIE_TRAVERSE)

/* 
 * ®Τparameterdeclarationϼʤޤץȥ
 * ƤؿΰѿȤƤޤparameter
 * declarationϼʤ
 */

static SpdBoolean declarationIs(const SpdOcc occ)
{
    int     c;

    if (flag_l) {
        return (TRUE);
    }

    c = spdGetAttrValInt(occ.objectId, "sort");
    /* return (!(c == DECL_ENUMERATOR || c == DECL_PARAMETER)); */
    return (c != DECL_PARAMETER);
}

#endif /* !defined(SPIE_TRAVERSE) */

/* ®Τparmtypedeclaratorϼʤ */

static SpdBoolean declaratorIs(const SpdRel rel)
{
    int     c;

    c = spdGetAttrValInt(rel.objectId, "sort");
    /* return (c != DECL_TAG && c != DECL_ENUMERATOR && c != DECL_PARAMETER); */
    return (c != DECL_PARMTYPE);
}

/* LaTeXϤ˻Ѥ롥 */

static SpdBoolean relobj_is_funcdef(const SpdRel rel)
{
    return (spdGetAttrValIntOfObj(rel.objectId, "sort") == DECL_FUNCDEF);
}

/* Tagѡ */

static SpdBoolean spdRelObjIsDeclTag(const SpdRel rel)
{
    return (spdGetAttrValInt(rel.objectId, "sort") == DECL_TAG);
}

/* identifierlocal variableǤ뤫ݤĴ٤롥 */

SpdBoolean isLocalVariable(const SpdObjId decln_id)
{
    int         sort, storage;
    SpdObjId    block;

    sort = spdGetAttrValInt(decln_id, "sort");
    storage = spdGetAttrValInt(decln_id, "storage");
    block = spdGetARelObj(decln_id, "blk_decl", "children_declaration_id");
    return ((block != SPD_NON_ID) && (sort == DECL_NORMAL) && 
            (storage != STORAGE_EXTERN));
}

/* иidentifierlocal variableǤ뤫ݤĴ٤롥 */

SpdBoolean spdOccIsIdVariable(const SpdOcc occ)
{
    return (smuIsLocalVariable(occ.objectId));
}

/* иidentifierargumentǤ뤫ݤĴ٤롥 */

SpdBoolean spdOccIsIdArgument(const SpdOcc occ)
{
    return (smuIsArgument(occ.objectId));
}

/* иidentifierID_MEMBERǤ뤫ɤĴ٤ؿ */

SpdBoolean spdOccIsIdMember(const SpdOcc occ)
{
    return (spdGetAttrValInt(occ.objectId, "sort") == ID_MEMBER);
}

SpdBoolean spdOccIsIdEnum(const SpdOcc occ)
{
    return (spdGetAttrValInt(occ.objectId, "sort") == ID_ENUMERATOR);
}

#if !defined(SPIE_TRAVERSE)

/*
 * expressionsortEXPR_SORT_CAST뤤ϡEXPR_SORT_SIZEOF
 * TRUE֤ؿޤŪǤϤʤ.
 */

static SpdBoolean spdOccIsCastOrSizeof(const SpdOcc occ)
{
    int c;

    c = smuGetExprSort(occ.objectId);
    if (c == EXPR_SORT_CAST || c == EXPR_SORT_SIZEOF) {
        return(TRUE);
    }
    return(FALSE);
}

#endif /* !defined(SPIE_TRAVERSE) */

/*
 * declarationstoragestaticɤ
 */

static SpdBoolean isDeclnStatic(const SpdObjId declnId)
{
    /* 
     * if (spdGetAttrValInt(declnId, "storage") == STORAGE_STATIC) {
     *     return TRUE;
     * } else {
     *     return FALSE;
     * }
     */
    return (spdGetAttrValInt(declnId, "storage") == STORAGE_STATIC);
}

/*
 * ξؿdeclaratorid 
 * ȤƼȤꡤϢdecl_ident򤿤ɤäidentifierid.    
 * offsetdecl_identrelationIdƤ롥                 
 */

static void getArgDef(SpdObjId file_id, SpdObjId declr_id)
{
    SpdRel ident_rel;
    SpdRegion region_i, region_c;
    int i;

    ident_rel = spdGetARel(declr_id, "decl_ident", "declarator_id");  

    /* ΰ(DEFAULT_ALLOC_SIZEĳݤ) */
    if (arg_def.max_size <= arg_def.size) {
        arg_def.elem = spdRealloc(arg_def.elem, sizeof(DefElem) * 
                                  (arg_def.max_size + DEFAULT_ALLOC_SIZE));
        arg_def.max_size += DEFAULT_ALLOC_SIZE;
    }

    if (language_type != LATEX_MODE) {
        /* HTML or XHTMLϤ硥 */
        region_i.fileId = file_id;
        region_i.offset = spdGetAbsoluteOffset(ident_rel.relationId, file_id);
        region_i.length = spdGetLength(ident_rel.objectId);
        region_c = spdConvRegionItoCbyPIDB(region_i);

        /* ϿѤʤ offset 礭Ǿ񤭤 */
        for (i = 0; i < arg_def.size; i++) {
            if (arg_def.elem[i].ident_id == ident_rel.objectId) {
                if (arg_def.elem[i].offset < region_c.offset) {
                    arg_def.elem[i].offset = region_c.offset;
                }
                return;
            }
        }

        if (region_c.fileId != SPD_NON_ID) {
            arg_def.elem[arg_def.size].file_id = 
                spdConvIdPfileToFile(region_c.fileId);
            arg_def.elem[arg_def.size].ident_id = ident_rel.objectId; 
            arg_def.elem[arg_def.size].offset = region_c.offset;
            arg_def.elem[arg_def.size].is_static = FALSE;
            if (flag_x) { /* 顼Τɤ */
                arg_def.elem[arg_def.size].docfrag_id = SPD_NON_ID;
            } 
            arg_def.size++;
        }
    }
}

/*
 * ؿξؿDECL_FUNCDEFǤdeclaratorid 
 * ȤƼȤꡤϢdecl_ident򤿤ɤäidentifierid.    
 * offsetdecl_identrelationIdƤ롥                 
 */

static void getFuncDef(SpdObjId file_id, SpdObjId declr_id)
{
    SpdRel ident_rel;
    SpdRegion region_i, region_c;
    SpdObjId pfile_id;
    SpdObjId decln_id;
    SpdObjId docident_id;
    SpdBoolean is_storage_static = FALSE;
    SpdObjId opt, parm_declr;
    SpdObjIdArray parm_buf;
    int i;

    decln_id = spdGetARelObj(declr_id, "decl_decl", "declarator_id");
    is_storage_static = isDeclnStatic(decln_id);

    ident_rel = spdGetARel(declr_id, "decl_ident", "declarator_id");  

    /* ΰ(DEFAULT_ALLOC_SIZEĳݤ) */
    if (func_def.max_size <= func_def.size) {
        func_def.elem = spdRealloc(func_def.elem, sizeof(DefElem) * 
                                   (func_def.max_size + DEFAULT_ALLOC_SIZE));
        func_def.max_size += DEFAULT_ALLOC_SIZE;
    }

    if (language_type != LATEX_MODE) {
        /* HTML or XHTML Ϥ硥 */
        region_i.fileId = file_id;
        region_i.offset = spdGetAbsoluteOffset(ident_rel.relationId, file_id);
        region_i.length = spdGetLength(ident_rel.objectId);
        region_c = spdConvRegionItoCbyPIDB(region_i);

        if (region_c.fileId != SPD_NON_ID) {
            func_def.elem[func_def.size].file_id = 
                spdConvIdPfileToFile(region_c.fileId);
            func_def.elem[func_def.size].ident_id = ident_rel.objectId; 
            func_def.elem[func_def.size].offset = region_c.offset;
            func_def.elem[func_def.size].is_static = is_storage_static;

            if (flag_l) {
                opt = spdGetARelObj(declr_id, "decl_opt", "declarator_id");
                parm_buf = spdGetRelObjArray(opt, "func_parm", 
                                             "optionaldecl_id", NULL);
                for (i = 0; i < parm_buf.size; i++) {
                    parm_declr = spdGetARelObj(parm_buf.id[i], "decl_decl", 
                                               "declaration_id");
                    getArgDef(file_id, parm_declr);
                }
                spdFreeObjIdArray(parm_buf);
            }

            if (flag_x) {
                docident_id = spdGetARelObj(ident_rel.objectId, "docident_identifier",
                                            "identifier_id");
                func_def.elem[func_def.size].docfrag_id =
                    spdGetARelObj(docident_id, "defelem_docident", "docident_id");
            }
            func_def.size++;
        }
    } else {
        /* LaTeXϤ  */
        pfile_id = spdGetARelObj(file_id, "cfile_ifile", "file_id");
        /* func_def.elem[func_def.size].file_id = file_id; */
        if (pfile_id != SPD_NON_ID) {
            func_def.elem[func_def.size].file_id = 
                spdConvIdPfileToFile(pfile_id);
            func_def.elem[func_def.size].ident_id = ident_rel.objectId; 
            func_def.size++;
        }
    }

    make_variable_spec_by_table(file_id, ident_rel.objectId);
    make_funccallee_spec_by_table(file_id, ident_rel.objectId);
    make_funccaller_spec_by_table(ident_rel.objectId);

    make_macro_spec(declr_id, file_id);
}

/*
 * ؿץȥξؿDECL_FUNCDEFǤ
 * declaratorIDȤƼȤꡤdecl_ident򤿤ɤä     
 * identifierIDƤ.      
 * offsetdecl_identrelationIdƤ.
 */

static void getProtoType(SpdObjId file_id, SpdObjId declr_id)
{
    SpdRel ident_rel;
    SpdRegion region_i, region_c;
    DefElem element;

    if (func_proto.max_size <= func_proto.size) {
        func_proto.elem = spdRealloc(func_proto.elem, sizeof(DefElem) * 
                                     (func_proto.max_size +
                                      DEFAULT_ALLOC_SIZE));
        func_proto.max_size += DEFAULT_ALLOC_SIZE;
    }
    
    ident_rel = spdGetARel(declr_id, "decl_ident", "declarator_id");
    region_i.fileId = file_id;  
    region_i.offset = spdGetAbsoluteOffset(ident_rel.relationId,
                                           file_id);
    region_i.length = spdGetLength(ident_rel.objectId);
    region_c = spdConvRegionItoCbyPIDB(region_i);

    if (!smuIsSystemFile(region_c.fileId) && region_c.fileId != SPD_NON_ID) {
        element.file_id = spdConvIdPfileToFile(region_c.fileId);
        element.ident_id = ident_rel.objectId;
        element.offset = region_c.offset;

        if (!isContainDefElem(element, &func_proto)) {
            func_proto.elem[func_proto.size].file_id = element.file_id;
            func_proto.elem[func_proto.size].ident_id = element.ident_id;
            func_proto.elem[func_proto.size].offset = element.offset;
            func_proto.size++;
        }
    }
}

/*
 * ѿ(externޤ)ؿDECL_VARIABLEǤ     
 * declaratorIDȤƼȤꡤdecl_ident򤿤ɤäơidentifier
 * IDƤ롥externɤȽϡdeclarationid
 * ơ°storageSTORAGE_EXTERNɤȽꤷƤ.
 */

static void getVariable(SpdObjId file_id, SpdObjId declr_id)
{
    SpdObjId decln_id;
    SpdRegion region_i, region_c;
    SpdRel ident_rel;
    DefElem element;

    /* externѿǼѿΰ */
    if (ex_def.max_size <= ex_def.size) {
        ex_def.elem = spdRealloc(ex_def.elem, sizeof(DefElem) * 
                                 (ex_def.max_size + DEFAULT_ALLOC_SIZE));
        ex_def.max_size += DEFAULT_ALLOC_SIZE;
    }    

    /* ѿǼѿΰ */
    if (var_def.max_size <= var_def.size) {
        var_def.elem = spdRealloc(var_def.elem, sizeof(DefElem) * 
                                  (var_def.max_size + DEFAULT_ALLOC_SIZE));
        var_def.max_size += DEFAULT_ALLOC_SIZE;
    }

    /* ɽѿǼѿΰ */
    if (l_var_def.max_size <= l_var_def.size) {
        l_var_def.elem = spdRealloc(l_var_def.elem, sizeof(DefElem) * 
                                    (l_var_def.max_size + DEFAULT_ALLOC_SIZE));
        l_var_def.max_size += DEFAULT_ALLOC_SIZE;
    }

    ident_rel = spdGetARel(declr_id, "decl_ident", "declarator_id");
    
    region_i.fileId = file_id;
    region_i.offset = spdGetAbsoluteOffset(ident_rel.relationId, file_id);
    region_i.length = spdGetLength(ident_rel.objectId);
    region_c = spdConvRegionItoCbyPIDB(region_i);

    if (!smuIsSystemFile(region_c.fileId) && 
        region_c.fileId != SPD_NON_ID) {

        decln_id = spdGetARelObj(declr_id, "decl_decl", "declarator_id");
        
        element.file_id = spdConvIdPfileToFile(region_c.fileId);
        element.ident_id = ident_rel.objectId;
        element.offset = region_c.offset;

        if (smuIsGlobalVariable(ident_rel.objectId)) {

            if (spdGetAttrValInt(decln_id, "storage") == STORAGE_EXTERN) {
                if (!isContainDefElem(element, &ex_def)) {
                    ex_def.elem[ex_def.size].ident_id = element.ident_id;
                    ex_def.elem[ex_def.size].file_id = element.file_id;
                    ex_def.elem[ex_def.size].offset = element.offset;
                    if (flag_x) { /* 顼Τɤ */
                        ex_def.elem[ex_def.size].docfrag_id = SPD_NON_ID;
                    } 
                    ex_def.size++;
                }
            } else if (!isContainDefElem(element, &var_def)) {
                var_def.elem[var_def.size].file_id = element.file_id;
                var_def.elem[var_def.size].ident_id = element.ident_id;
                var_def.elem[var_def.size].offset = element.offset;
                var_def.elem[var_def.size].is_static = isDeclnStatic(decln_id);
                if (flag_x) { /* 顼Τɤ */
                    ex_def.elem[ex_def.size].docfrag_id = SPD_NON_ID;
                } 
                var_def.size++;
            }
        } else if (flag_l && smuIsLocalVariable(ident_rel.objectId) &&
                   isLocalVariable(decln_id)) {
            l_var_def.elem[l_var_def.size].file_id = element.file_id;
            l_var_def.elem[l_var_def.size].ident_id = element.ident_id;
            l_var_def.elem[l_var_def.size].offset = element.offset;
            l_var_def.elem[l_var_def.size].is_static = isDeclnStatic(decln_id);
            if (flag_x) { /* 顼Τɤ */
                l_var_def.elem[l_var_def.size].docfrag_id = SPD_NON_ID;
            } 
            l_var_def.size++;
        }
    }
}

/*
 * ѿ, , 
 */

static void getDefine(SpdObjId file_id, SpdObjId declr_id, Define *def)
{
    SpdObjId docident_id, id;
    SpdRel ident_rel;
    SpdRegion region_i, region_c;
    DefElem element;

    if (def->max_size <= def->size) {
        def->elem = spdRealloc(def->elem, sizeof(DefElem) * 
                               (def->max_size + 
                                DEFAULT_ALLOC_SIZE));
        def->max_size += DEFAULT_ALLOC_SIZE;
    }

    ident_rel = spdGetARel(declr_id, "decl_ident", "declarator_id");
    region_i.fileId = file_id;
    region_i.offset = spdGetAbsoluteOffset(ident_rel.relationId, file_id);
    region_i.length = spdGetLength(ident_rel.objectId);

    region_c = spdConvRegionItoCbyPIDB(region_i);

    if (!smuIsSystemFile(region_c.fileId) && region_c.fileId != SPD_NON_ID) {
        element.file_id = spdConvIdPfileToFile(region_c.fileId);
        element.ident_id = ident_rel.objectId;
        element.offset = region_c.offset;

        if (!isContainDefElem(element, def)) {
            def->elem[def->size].ident_id = element.ident_id;
            def->elem[def->size].file_id = element.file_id;
            def->elem[def->size].offset = element.offset;
            def->elem[def->size].is_static = FALSE;

            if (flag_x) {
                /*
                 * enumϥɥȤȥ̾ǴϢĥƤ뤿
                 * ̾ɬפ롥
                 */
                if (spdGetAttrValInt(declr_id, "sort") == DECL_ENUMERATOR) {
                    id = spdGetARelObj(declr_id, "decl_decl", "declarator_id");
                    id = spdGetARelObj(id, "struct_decl", "declaration_id");
                    id = spdGetARelObj(id, "decl_opt", "optionaldecl_id");
                    id = spdGetARelObj(id, "decl_ident", "declarator_id");
                    docident_id = spdGetARelObj(id, "docident_identifier", "identifier_id");
                } else {
                    docident_id = spdGetARelObj(element.ident_id, "docident_identifier",
                                                "identifier_id");
                }
                def->elem[def->size].docfrag_id =
                    spdGetARelObj(docident_id, "defelem_docident", "docident_id");
            } 
            def->size++;
        }
    }
}

/*
 * ¤ΥФҤνиؿ
 * иե뤬狼ʤʤΤǡե˽Ƥ롥     
 * ident_ref򤿤ɤäơǤ褦ˤ
 */

#if defined(SPIE_TRAVERSE)

void getOcc(SpdObjId file_id, Define *occur, SpdCondOccFunc cond)
{
    SpdOccArray ident_buf;
    SpdRegion region_i, region_c;
    DefElem element;
    int i;
    
    ident_buf = traverse.ident_buf;
    
    for (i = 0; i < ident_buf.size; i++) {
        /* νиʳ̵뤹 */
        if ((ident_buf.occ[i].fileId != file_id) ||
            (spdGetClassId(ident_buf.occ[i].relationId) != SPD_RID_IDENT_REF) ||
            !cond(ident_buf.occ[i])) {
            continue;
        }

        if (occur->max_size <= occur->size) {
            occur->elem = spdRealloc(occur->elem, sizeof(DefElem) * 
                                     (occur->max_size + 
                                      DEFAULT_ALLOC_SIZE));
            occur->max_size += DEFAULT_ALLOC_SIZE;
        }

        region_i.fileId = ident_buf.occ[i].fileId;
        region_i.offset = ident_buf.occ[i].offset;
        region_i.length = spdGetLength(ident_buf.occ[i].objectId);
    
        region_c = spdConvRegionItoCbyPIDB(region_i);

        if (region_c.fileId == SPD_NON_ID || 
            region_c.offset == SPD_NON_OFFSET ||
            smuIsSystemFile(region_c.fileId)) continue;

        element.ident_id = ident_buf.occ[i].objectId;
        element.file_id = spdConvIdPfileToFile(region_c.fileId);
        element.offset = region_c.offset;

        if (isContainDefElem(element, occur)) continue;    
    
        occur->elem[occur->size].ident_id = element.ident_id;
        occur->elem[occur->size].file_id = element.file_id;
        occur->elem[occur->size].offset = element.offset;
        occur->elem[occur->size].length = 
            spdGetLength(element.ident_id);
        occur->elem[occur->size].lr_type = 
            spdGetLrtypeByOcc(ident_buf.occ[i]);
        occur->size++;
    }
}

#else /* !defined(SPIE_TRAVERSE) */

void getOcc(SpdObjId file_id, Define *occur, SpdCondOccFunc cond)
{
    SpdOccArray ident_buf;
    SpdRegion region_i, region_c;
    DefElem element;
    int i;

    ident_buf = spdGetIncludedOccArray(file_id, "identifier", file_id, cond);

    for (i = 0; i < ident_buf.size; i++) {
        /* νиʳ̵뤹 */
        if (spdGetClassId(ident_buf.occ[i].relationId) != SPD_RID_IDENT_REF) {
            continue;
        }

        if (occur->max_size <= occur->size) {
            occur->elem = spdRealloc(occur->elem, sizeof(DefElem) * 
                                     (occur->max_size + 
                                      DEFAULT_ALLOC_SIZE));
            occur->max_size += DEFAULT_ALLOC_SIZE;
        }

        region_i.fileId = ident_buf.occ[i].fileId;
        region_i.offset = ident_buf.occ[i].offset;
        region_i.length = spdGetLength(ident_buf.occ[i].objectId);
    
        region_c = spdConvRegionItoCbyPIDB(region_i);

        if (region_c.fileId == SPD_NON_ID || 
            region_c.offset == SPD_NON_OFFSET ||
            smuIsSystemFile(region_c.fileId)) continue;

        element.ident_id = ident_buf.occ[i].objectId;
        element.file_id = spdConvIdPfileToFile(region_c.fileId);
        element.offset = region_c.offset;

        if (isContainDefElem(element, occur)) continue;    
    
        occur->elem[occur->size].ident_id = element.ident_id;
        occur->elem[occur->size].file_id = element.file_id;
        occur->elem[occur->size].offset = element.offset;
        occur->elem[occur->size].length = 
            spdGetLength(element.ident_id);
        occur->elem[occur->size].lr_type = 
            spdGetLrtypeByOcc(ident_buf.occ[i]);
        occur->size++;
    }
    spdFreeOccArray(ident_buf);
}

#endif /* !defined(SPIE_TRAVERSE) */

/*
 * cast, sizeof˽иtypedef줿ξؿ.   
 * sizeofsizeofΤ˥󥫡ĥ뤷ˡϤʤ褦Ǥ
 * (sizeof()()offsetǤʤ)
 * ưפ뤿ᡤcastexpressionΤ˥󥫡ĥäƤ.
 *
 * 1999/10/06: ʸޥå󥰤ˤŪ˲褷(BUGGY_SDBIN4_0122)
 */

#if defined(SPIE_TRAVERSE)

void getTypeOccInExpression(SpdObjId file_id)
{
    SpdOccArray expr_buf;   
    SpdRel expr_op;
    SpdObjId type_id, type_is;
    SpdRegion region_i, region_c;
    int i;
    DefElem element;

#ifdef BUGGY_SDBIN4_0122
    SpdString reg_text, type_name;
#endif

    expr_buf = traverse.expr_buf;
    
    for (i = 0; i < expr_buf.size; ++i) {
        if (expr_buf.occ[i].fileId != file_id) {
            continue;
        }
        if (type_occ.max_size <= type_occ.size) {
            type_occ.elem = spdRealloc(type_occ.elem, sizeof(DefElem) * 
                                       (type_occ.max_size + 
                                        DEFAULT_ALLOC_SIZE));
            type_occ.max_size += DEFAULT_ALLOC_SIZE;
        }

        expr_op = spdGetARel(expr_buf.occ[i].objectId, "expr_op", 
                             "expression_id");
        type_id = spdGetARelObj(expr_op.objectId, "op_type", 
                                "operator_id");
        type_is = spdGetARelObj(type_id, "type_is", "type_id");

        if (spdGetAttrValInt(type_id, "sort") == TYPE_TYPE_DEF) {
            /* occ -> region Ѵ */
            region_i = spdConvOccToRegion(expr_buf.occ[i]);
            region_c = spdConvRegionItoCbyPIDB(region_i);
            if (region_c.fileId == SPD_NON_ID ||
                region_c.offset == SPD_NON_OFFSET ||
                smuIsSystemFile(region_c.fileId)) continue;

            element.file_id = spdConvIdPfileToFile(region_c.fileId);
            element.ident_id = type_is;

#ifdef BUGGY_SDBIN4_0122
            reg_text = spdGetTextByRegion(region_c);
            type_name = spdGetName(type_is);
            element.length = spdGetLength(type_is);
            element.offset = region_c.offset + spdMatchStr(reg_text,type_name);
            spdFree(reg_text);
#else
            element.length = region_c.length;
            element.offset = region_c.offset;
#endif
        
            if (!isContainDefElem(element, &type_occ)) {
                type_occ.elem[type_occ.size].ident_id = element.ident_id;
                type_occ.elem[type_occ.size].file_id = element.file_id;
                type_occ.elem[type_occ.size].length = element.length;
                type_occ.elem[type_occ.size].offset = element.offset;
                type_occ.size++;
            }
        }
    }
}

#else /* !defined(SPIE_TRAVERSE) */

void getTypeOccInExpression(SpdObjId file_id)
{
    SpdOccArray expr_buf;   
    SpdRel expr_op;
    SpdObjId type_id, type_is;
    SpdRegion region_i, region_c;
    int i;
    DefElem element;

#ifdef BUGGY_SDBIN4_0122
    SpdString reg_text, type_name;
#endif

    expr_buf = spdGetIncludedOccArray(file_id, "expression", file_id,
                                      spdOccIsCastOrSizeof);

    for (i = 0; i < expr_buf.size; ++i) {
        if (type_occ.max_size <= type_occ.size) {
            type_occ.elem = spdRealloc(type_occ.elem, sizeof(DefElem) * 
                                       (type_occ.max_size + 
                                        DEFAULT_ALLOC_SIZE));
            type_occ.max_size += DEFAULT_ALLOC_SIZE;
        }

        expr_op = spdGetARel(expr_buf.occ[i].objectId, "expr_op", 
                             "expression_id");
        type_id = spdGetARelObj(expr_op.objectId, "op_type", 
                                "operator_id");
        type_is = spdGetARelObj(type_id, "type_is", "type_id");

        if (spdGetAttrValInt(type_id, "sort") == TYPE_TYPE_DEF) {
            /* occ -> region Ѵ */
            region_i = spdConvOccToRegion(expr_buf.occ[i]);
            region_c = spdConvRegionItoCbyPIDB(region_i);
            if (region_c.fileId == SPD_NON_ID ||
                region_c.offset == SPD_NON_OFFSET ||
                smuIsSystemFile(region_c.fileId)) continue;

            element.file_id = spdConvIdPfileToFile(region_c.fileId);
            element.ident_id = type_is;

#ifdef BUGGY_SDBIN4_0122
            reg_text = spdGetTextByRegion(region_c);
            type_name = spdGetName(type_is);
            element.length = spdGetLength(type_is);
            element.offset = region_c.offset + spdMatchStr(reg_text,type_name);
            spdFree(reg_text);
#else
            element.length = region_c.length;
            element.offset = region_c.offset;
#endif
        
            if (!isContainDefElem(element, &type_occ)) {
                type_occ.elem[type_occ.size].ident_id = element.ident_id;
                type_occ.elem[type_occ.size].file_id = element.file_id;
                type_occ.elem[type_occ.size].length = element.length;
                type_occ.elem[type_occ.size].offset = element.offset;
                type_occ.size++;
            }
        }
    }
    spdFreeOccArray(expr_buf);
}

#endif /* !defined(SPIE_TRAVERSE) */

/*
 * ؿѿʤɤ˽иtag̾ξؿ
 */  

static void getTagOccInDeclaration(SpdObjId file_id, SpdOcc decln_occ)
{
    SpdObjId tag_is;
    SpdRel decl_tag;
    SpdRegion region_i, region_c;
    DefElem element;
    SpdRelArray declr_buf;
    int j;

#ifdef BUGGY_SDBIN4_0121
    SpdString tag_name, tag_str;
#endif

    if (tag_occ.max_size <= tag_occ.size) {
        tag_occ.elem = spdRealloc(tag_occ.elem, sizeof(DefElem) * 
                                  (tag_occ.max_size + DEFAULT_ALLOC_SIZE));
        tag_occ.max_size += DEFAULT_ALLOC_SIZE;
    }
    
    /* optionaldecl( {....} )ΤϥȤߤʤΤǡ
       иȤƤϼʤ */ 

    declr_buf = spdGetRelArray(decln_occ.objectId, "decl_decl", 
                               "declaration_id", spdRelObjIsDeclTag);

    for (j = 0; j < declr_buf.size; ++j) {
        if (spdGetARelObj(declr_buf.rel[j].objectId , "decl_opt" , "any") 
            != SPD_NON_ID) continue;

        decl_tag = spdGetARel(decln_occ.objectId, "decl_type", 
                              "declaration_id");
    
        if (spdGetAttrValInt(decl_tag.objectId, "sort") == TYPE_STRUCT_TAG ||
            spdGetAttrValInt(decl_tag.objectId, "sort") == TYPE_UNION_TAG || 
            spdGetAttrValInt(decl_tag.objectId, "sort") == TYPE_ENUM_SPECIFIER) {
            tag_is = spdGetARelObj(decl_tag.objectId, "type_is", "type_id");
            if (tag_is == SPD_NON_ID) return;
      
            region_i.fileId = file_id;
      
#ifdef BUGGY_SDBIN4_0106
            if (spdGetAttrValInt(decln_occ.objectId, "sort") == DECL_FUNCDEF) {
                region_i.offset = decln_occ.offset;
            } else {
                region_i.offset = spdGetAbsoluteOffset(decl_tag.relationId, 
                                                       file_id);
            }
#else
            region_i.offset = spdGetAbsoluteOffset(decl_tag.relationId, file_id);
#endif
            region_i.length = spdGetLength(tag_is);
          
            region_c = spdConvRegionItoCbyPIDB(region_i);
      
            if (region_c.fileId != SPD_NON_ID && 
                !smuIsSystemFile(region_c.fileId)) {
                element.file_id = spdConvIdPfileToFile(region_c.fileId);
                element.ident_id = tag_is;
                element.length = spdGetLength(tag_is);
        
#ifdef BUGGY_SDBIN4_0121
                tag_str = spdStr(decl_tag.objectId);
                tag_name = spdGetName(tag_is);
                /* fprintf(stderr,"%s - %s(%d)",tag_str,tag_name,tag_is); */
                element.offset = region_c.offset + spdMatchStr(tag_str,tag_name);
#else
                element.offset = region_c.offset;
#endif
        
                if (!isContainDefElem(element, &tag_occ)) {
                    tag_occ.elem[tag_occ.size].ident_id = element.ident_id;
                    tag_occ.elem[tag_occ.size].file_id = element.file_id;
                    tag_occ.elem[tag_occ.size].length = element.length;
                    tag_occ.elem[tag_occ.size].offset = element.offset;
                    tag_occ.size++;
                }
            }
        }
    }
    spdFreeRelArray(declr_buf);
}

/*
 * ؿѿʤɤ˽и뷿ξؿ
 */  

static void getTypeOccInDeclaration(SpdObjId file_id, SpdOcc decln_occ)
{
    SpdObjId type_is;
    SpdRel decl_type;
    SpdRegion region_i, region_c;
    DefElem element;

#ifdef BUGGY_SDBIN4_0121
    SpdString type_name, type_str;
#endif

    if (type_occ.max_size <= type_occ.size) {
        type_occ.elem = spdRealloc(type_occ.elem, sizeof(DefElem) * 
                                   (type_occ.max_size + DEFAULT_ALLOC_SIZE));
        type_occ.max_size += DEFAULT_ALLOC_SIZE;
    }
    
    decl_type = spdGetARel(decln_occ.objectId, "decl_type", "declaration_id");

    if (spdGetAttrValInt(decl_type.objectId, "sort") == TYPE_TYPE_DEF) {
        type_is = spdGetARelObj(decl_type.objectId, "type_is", "type_id");
        
        region_i.fileId = file_id;

#ifdef BUGGY_SDBIN4_0106
        if (spdGetAttrValInt(decln_occ.objectId, "sort") == DECL_FUNCDEF) {
            region_i.offset = decln_occ.offset;
        } else {
            region_i.offset = spdGetAbsoluteOffset(decl_type.relationId, 
                                                   file_id);
        }
#else
        region_i.offset = spdGetAbsoluteOffset(decl_type.relationId, file_id);
#endif
        region_i.length = spdGetLength(type_is);

        region_c = spdConvRegionItoCbyPIDB(region_i);

        if (region_c.fileId != SPD_NON_ID && 
            !smuIsSystemFile(region_c.fileId)) {
            element.file_id = spdConvIdPfileToFile(region_c.fileId);
            element.ident_id = type_is;
            element.length = spdGetLength(type_is);

#ifdef BUGGY_SDBIN4_0121
            type_str = spdStr(decl_type.objectId);
            type_name = spdGetName(type_is);
            element.offset = region_c.offset + spdMatchStr(type_str,type_name);
#else
            element.offset = region_c.offset;
#endif

            if (!isContainDefElem(element, &type_occ)) {
                type_occ.elem[type_occ.size].ident_id = element.ident_id;
                type_occ.elem[type_occ.size].file_id = element.file_id;
                type_occ.elem[type_occ.size].length = element.length;
                type_occ.elem[type_occ.size].offset = element.offset;
                type_occ.size++;
            }
        }    
    }
}

/* 
 * externǥ󥫡Ťˤʤͥ褹(2001/02/21)
 * 
 * === test.h ===== 
 * #ifdef GLOBAL_DEFINE
 * #define GLOBAL
 * #else
 * #define GLOBAL extern
 * #endif
 * 
 * GLOBAL int test;
 * ================
 * === test1.c===== 
 * #include <stdio.h>
 * #define GLOBAL_DEFINE
 * #include "test.h"
 * 
 * ...
 * ================
 * === test2.c===== 
 * #include <stdio.h>
 * #include "test.h"
 * 
 * ...
 * ================
 */

static void delGVarFromExt(void)
{
    int     i, j;

    for (i = 0; i < ex_def.size; i++) {
        for (j = 0; j < var_def.size; j++) {
            if (ex_def.elem[i].offset == var_def.elem[j].offset)
                ex_def.elem[i].offset = SPD_NON_OFFSET;
        }
    }
}

#if defined(SPIE_TRAVERSE)

void getDeclaration(SpdObjId file_id)
{
    SpdRelArray declr_buf, decln_buf_tex;
    SpdOccArray decln_buf;
    SpdObjId declr_id;
    int i, j;

    /* LaTeXϤ뤫 HTML (XHTMl)Ϥ뤫ʬ롥(®Τ) */
    if (language_type != LATEX_MODE) {
    
        decln_buf = traverse.decln_buf;
    
        for (i = 0; i < decln_buf.size; ++i) {
            if (decln_buf.occ[i].fileId != file_id) {
                continue;
            }
            /*
             * declarationʣdeclaratorθɬפ
             * Τǡηdeclarator롥
             * : "int i, j;"
             */
            declr_buf = spdGetRelArray(decln_buf.occ[i].objectId, 
                                       "decl_decl","declaration_id", declaratorIs);
            for (j = 0; j < declr_buf.size; ++j) {
                switch (spdGetAttrValInt(declr_buf.rel[j].objectId, "sort")) {
                  case DECL_FUNCDEF:
                    getFuncDef(file_id, declr_buf.rel[j].objectId);
                    break;
                  case DECL_PROTOTYPE:
                    getProtoType(file_id, declr_buf.rel[j].objectId);
                    break;
                  case DECL_VARIABLE:
                    getVariable(file_id, declr_buf.rel[j].objectId);
                    break;
                  case DECL_MEMBER:
                    getDefine(file_id, declr_buf.rel[j].objectId, &member_def);
                    break;
                  case DECL_ENUMERATOR:
                    getDefine(file_id, declr_buf.rel[j].objectId, &enum_def);
                    break;
                  case DECL_TYPE:
                    getDefine(file_id, declr_buf.rel[j].objectId, &type_def);
                    break;
                  case DECL_TAG:
                    /* optionaldecl( {....} )̵ΤϡѤȤߤʤΤǡ
                       ȤƤϤȤäʤ */
                    if (spdGetARelObj(declr_buf.rel[j].objectId , "decl_opt", 
                                      "declarator_id") != SPD_NON_ID) {
                        getDefine(file_id, declr_buf.rel[j].objectId, &tag_def);
                    }
                    break;
                  default:
                    break;
                }
            }
            spdFreeRelArray(declr_buf);
            getTagOccInDeclaration(file_id, decln_buf.occ[i]);
            getTypeOccInDeclaration(file_id, decln_buf.occ[i]);
        }
        delGVarFromExt();
    } else {
        if (flag_b) {
            decln_buf_tex = spdGetRelSortedArray(file_id, "file_decl",
                                                 "file_id", 
                                                 relobj_is_funcdef,
                                                 spdCompareRelOffset);
        } else {
            decln_buf_tex = spdGetRelArray(file_id, "file_decl", "file_id", 
                                           relobj_is_funcdef);
        }
        for (i = 0; i < decln_buf_tex.size; ++i) {
            declr_id = spdGetARelObj(decln_buf_tex.rel[i].objectId,
                                     "decl_decl", "declaration_id");
            getFuncDef(file_id, declr_id);
        }
        spdFreeRelArray(decln_buf_tex);
    }
}

#else /* !defined(SPIE_TRAVERSE) */

/*
 * declarationؿ
 * Modified by H.Ohhashi 1998/11/18.
 */

void getDeclaration(SpdObjId file_id)
{
    SpdOccArray decln_buf_html;
    SpdRelArray declr_buf, decln_buf_tex;
    SpdObjId declr_id;
    int i, j;

    /* LaTeXϤ뤫 HTML (XHTMl)Ϥ뤫ʬ롥(®Τ) */
    if (language_type != LATEX_MODE) {
        decln_buf_html = spdGetIncludedOccArray(file_id, "declaration", 
                                                file_id, declarationIs);

        for (i = 0; i < decln_buf_html.size; ++i) {
            /*
             * declarationʣdeclaratorθɬפ
             * Τǡηdeclarator롥
             * : "int i, j;"
             */
            declr_buf = spdGetRelArray(decln_buf_html.occ[i].objectId, 
                                       "decl_decl","declaration_id", declaratorIs);

            for (j = 0; j < declr_buf.size; ++j) {
                switch (spdGetAttrValInt(declr_buf.rel[j].objectId, "sort")) {
                  case DECL_FUNCDEF:
                    getFuncDef(file_id, declr_buf.rel[j].objectId);
                    break;
                  case DECL_PROTOTYPE:
                    getProtoType(file_id, declr_buf.rel[j].objectId);
                    break;
                  case DECL_VARIABLE:
                    getVariable(file_id, declr_buf.rel[j].objectId);
                    break;
                  case DECL_MEMBER:
                    getDefine(file_id, declr_buf.rel[j].objectId, &member_def);
                    break;
                  case DECL_ENUMERATOR:
                    getDefine(file_id, declr_buf.rel[j].objectId, &enum_def);
                    break;
                  case DECL_TYPE:
                    getDefine(file_id, declr_buf.rel[j].objectId, &type_def);
                    break;
                  case DECL_TAG:
                    /* optionaldecl( {....} )̵ΤϡѤȤߤʤΤǡ
                       ȤƤϤȤäʤ */
                    if (spdGetARelObj(declr_buf.rel[j].objectId , "decl_opt", 
                                      "declarator_id") != SPD_NON_ID) {
                        getDefine(file_id, declr_buf.rel[j].objectId, &tag_def);
                    }
                    break;
                  default:
                    break;
                }
            }
            spdFreeRelArray(declr_buf);
            getTagOccInDeclaration(file_id, decln_buf_html.occ[i]);
            getTypeOccInDeclaration(file_id, decln_buf_html.occ[i]);
        }
        spdFreeOccArray(decln_buf_html);
        delGVarFromExt();
    } else {
        if (flag_b) {
            decln_buf_tex = spdGetRelSortedArray(file_id, "file_decl",
                                                 "file_id", 
                                                 relobj_is_funcdef,
                                                 spdCompareRelOffset);
        } else {
            decln_buf_tex = spdGetRelArray(file_id, "file_decl", "file_id", 
                                           relobj_is_funcdef);
        }
        for (i = 0; i < decln_buf_tex.size; ++i) {
            declr_id = spdGetARelObj(decln_buf_tex.rel[i].objectId,
                                     "decl_decl", "declaration_id");
            getFuncDef(file_id, declr_id);
        }
        spdFreeRelArray(decln_buf_tex);
    }
}

#endif /* !defined(SPIE_TRAVERSE) */
