/* 
 * Program:             $RCSfile: latex.c,v $  $Revision: 30.3 $
 * 
 * Purpose:             
 * 
 * Author:              K.Hayashi  1995/02/20
 * Modified:            S.Yamamoto  1995/02/24
 * 
 * (C) Copyright:       K.Hayashi and S.Yamamoto  1995 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: latex.c,v 30.3 2001/02/20 06:27:19 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spie.h"

/* Added by S.Yamamoto 1997/12/02. */
#define BUGGY_MACRO_SPEC

void document_style(void)
{
    /* Output header. */
    if (!flag_n) {
        time_t  now = time(NULL);

        printf("%%\n");
        printf("%% %s", asctime(localtime(&now)));
        printf("%% This file is Generated by %s in Sapid-%d.%d.%d.\n",
                PROG_NAME, SapidVersion, SapidRevision, SapidPatchLevel);
        printf("%% Don't modify this file.\n");
        printf("%%\n");
    }

    printf("\\ifx\\gtfam\\undefined\n");
    if (flag_s) { 
        printf("\\documentstyle[supertabular,specmac-st]{jarticle}\n");
    } else {
        printf("\\documentstyle[specmac3]{jarticle}\n");
    }
    printf("\\else\n");
    if (flag_s) { 
        printf("\\documentstyle[a4j,supertabular,specmac-st]{jarticle}\n");
    } else {
        printf("\\documentstyle[a4j,specmac3]{jarticle}\n");
    }
    printf("\\fi\n");
}

void begin_document(void)
{
    printf("\\begin{document}\n");
}

void end_document(void)
{
    printf("\\end{document}\n");
}

void begin_specification(char *name, char *type)
{
    printf("  \\begin{specification}{%s}{%s}\n", name, type);
}

void end_specification(void)
{
    printf("  \\end{specification}\n");
}

void file_name(char *name)
{
    printf("    \\filename{%s}\n", name);
}

void firstproduced_time(char *date)
{
    printf("    \\firstproducedtime{%s}\n", date);
}

/* 
 * Function name first_produced_time(), last_modified_time() and
 * manual_author() are better.
 */

void lastmodified_time(char *date)
{
    printf("    \\lastmodifiedtime{%s}\n", date);
}

void manual_author(char *user)
{
    printf("    \\manualauthor{%s}\n", user);
}

void argument(char *name, char *type)
{
    printf("    \\argument{%s}{%s}\n", name, type);
}

void global_var(char *name, char *type)
{
    printf("    \\globalvar{%s}{%s}\n", name, type);
}

void global_var_sys(char *name, char *type)
{
    printf("    \\globalvarsys{%s}{%s}\n", name, type);
}

void local_var(char *name, char *type)
{
    printf("    \\localvar{%s}{%s}\n", name, type);
}

void function_callee(char *name, char *args, char *type)
{
    printf("    \\calleefunc{%s%s}{%s}\n", name, args, type);
}

void function_callee_sys(char *name, char *args, char *type)
{
    printf("    \\calleefuncsys{%s%s}{%s}\n", name, args, type);
}

void function_caller(char *name, char *args, char *type)
{
    printf("    \\callerfunc{%s%s}{%s}\n", name, args, type);
}

void function_caller_sys(char *name, char *args, char *type)
{
    printf("    \\callerfuncsys{%s%s}{%s}\n", name, args, type);
}

/* 
 * : Τʤޥ򥳥ѥ-DץͿȡ*argsȤNULL
 * Ϳ뤳Ȥ롥SolarisǤprintf()NULLϤsegmentation fault
 * (1997/12/02)
 */

void macro(char *name, char *args)
{
#ifdef BUGGY_MACRO_SPEC
    printf("    \\callmacro{%s%s}\n", name, (args == NULL ? "" : args));
#else
    printf("    \\callmacro{%s%s}\n", name, args);
#endif  
}

void macro_sys(char *name, char *args)
{
#ifdef BUGGY_MACRO_SPEC
    printf("    \\callmacrosys{%s%s}\n", name, (args == NULL ? "" : args));
#else
    printf("    \\callmacrosys{%s%s}\n", name, args);
#endif  
}
