/*
 * Program:             $RCSfile: macro-AR4-SPIE.c,v $  $Revision: 30.9 $
 *
 * Purpose:             
 *
 * Author:              K.Hayashi  1995/02/20
 * Modified:            S.Yamamoto  1995/03/13
 *                      A.Watanabe  1997/03/26
 *
 * (C) Copyright:       K.Hayashi, A.Watanabe and S.Yamamoto  1995 - 1999
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: macro-AR4-SPIE.c,v 30.9 2002/12/16 12:12:04 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spie.h"

SpdString spdGetMacroArgs(SpdObjId objectId)
{
    static char     macro_args[SPD_STRING_LEN + 1];
    SpdRel          name_rel, mopt_rel;
    SpdRelArray     mopt_buf;
    int             i;
    SpdString       marg_str;

    macro_args[0] = '\0';
    name_rel = spdGetARel(objectId, "mpatt_mname", "c-id");
    mopt_rel = spdGetARel(name_rel.objectId, "mpatt_mopt", "p-id");
    if (mopt_rel.objectId == SPD_NON_ID) {
        return ("");
    } else {
        mopt_buf = spdGetRelSortedArray(mopt_rel.objectId, "mopt_mdecla",
                                        "p-id", NULL, spdCompareRelOffset);

        for (i = 0; i < mopt_buf.size; i++) {
            if (i == 0) strcat(macro_args, "(");
            if (i > 0) strcat(macro_args, ", ");
            marg_str = removeBlankString(spdGetName(mopt_buf.rel[i].objectId));
            strcat(macro_args, marg_str);
        }
        spdFreeRelArray(mopt_buf);
        if (i > 0) strcat(macro_args, ")");
        return macro_args;
    }
}

/*
 * ؿǡɤΥޥѤƤ뤫Ĵ٤ؿ.
 * ؿdeclaratorˤޥƤӽФФƤ롥
 */

void make_macro_spec(SpdObjId declr_id, SpdObjId file_id)
{
    SpdRel ident_rel;
    SpdRel call_rel;
    SpdObjId pfile_id;
    int i, j;
    SpdRegion i_reg;
    SpdObjIdArray pblockArray;
    int offset;

    ident_rel = spdGetARel(declr_id, "decl_ident", "declarator_id");
    
    i_reg.fileId = file_id;
    i_reg.offset = spdGetAbsoluteOffset(ident_rel.relationId, file_id);
    i_reg.length = spdGetLength(declr_id);
    pblockArray = spdGetBlockIdArrayOfMcall(i_reg);


    /*
     * LaTeXϤξ硤ǤϤƥޥ롥
     * HTMLϤξϴ˼macro_callfunc_idɲä롥
     */
    if (language_type == LATEX_MODE) {
        for (i = 0; i < pblockArray.size; i++) {
            call_rel = spdGetARel(pblockArray.id[i], "call_mcall", "p-id");

            if (macro_call.max_size <= macro_call.size) {
                macro_call.elem = spdRealloc(macro_call.elem, 
                                             sizeof(MacroCallElem) * 
                                             (macro_call.max_size + 
                                              DEFAULT_ALLOC_SIZE));
                macro_call.max_size += DEFAULT_ALLOC_SIZE;
            }

            macro_call.elem[macro_call.size].name_id = 
                spdGetARelObj(call_rel.objectId, "mcall_mname",
                              "macroCall_id");
            macro_call.elem[macro_call.size].func_id = ident_rel.objectId;
            macro_call.size++;
        }
    } else {
        for (i = 0; i < pblockArray.size; i++) {
            call_rel = spdGetARel(pblockArray.id[i], "call_mcall", "p-id");
            pfile_id = spdGetARelObj(pblockArray.id[i], "file_block", 
                                     "pblock_id");
            pfile_id = spdConvIdPfileToFile(pfile_id);
            offset = spdGetOffset(call_rel.relationId);

            if (offset == SPD_NON_OFFSET) continue;

            for (j = 0 ; j < macro_call.size; j++) {
                if (macro_call.elem[j].call_offset == offset &&
                    macro_call.elem[j].call_file == pfile_id) {
                    /* func_idǼ */
                    macro_call.elem[j].func_id = ident_rel.objectId;
                    break;
                }
            }
        }
    }
    spdFreeObjIdArray(pblockArray);
}
