/*
 * Program:             $RCSfile: others.c,v $  $Revision: 30.51 $
 *
 * Purpose:             
 *
 * Author:              H.Ohhashi  1998/02/12
 *                      S.Yamamoto  1998/02/13
 *
 * (C) Copyright:       H.Ohhashi and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
"$Id: others.c,v 30.51 2003/10/03 14:56:25 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spie.h"
#include "style.h"

#ifdef ADD_MACRO_TO_LRTYPE

/* Sapid/AR3Attr.h  EXPR_*_VALUE ȾͤʤͤĤ  */
#define EXPR_M_VALUE (1 << 5)

/* ܺѤʤ style.h  */
#define LR_STR_MACRO "in macro"

#endif

/*
 * lrType (expression°)ʸ֤
 */

SpdString spdGetLrtypeString(int lrType)
{
    switch (lrType) {
      case EXPR_R_VALUE:
      case EXPR_PR_VALUE:
        return LR_STR_RIGHT;
        break;
      case EXPR_L_VALUE:
      case EXPR_PL_VALUE:
        return LR_STR_LEFT;
        break;
      case EXPR_LR_VALUE:
      case EXPR_PLR_VALUE:
        return LR_STR_LEFT_RIGHT;
        break;
      case EXPR_P_REF:
        return LR_STR_REFERENCE;
        break;
#ifdef ADD_MACRO_TO_LRTYPE
      case EXPR_M_VALUE:
        return LR_STR_MACRO;
        break;
#endif
      default:
#ifdef DEBUG
        spdWarning("spdGetLrtypeString(): Invalid argument.\n");
#endif
        return ("");
        break;
    }
}

/*
 * occurenceˤƱͤ͡Ĵ٤
 * ǳexpressionIDᡤ1¦expressionlrtype
 * Ĵ٤롥줬 unknown ξϺǳ expression lrtype֤
 */

int spdGetLrtypeByOcc(SpdOcc occ)
{
    SpdObjId inner_expr_id, outer_expr_id, tmp_id;
    int ret;

    /* occ.objectId  identifier Υ֥Ȥ */
    if (spdGetClassId(occ.objectId) != SPD_CID_IDENTIFIER) {
#ifdef DEBUG
        spdWarning("spdGetLrtypeByOcc(): Invalid argument.\n");
#endif
        return (-1);
    }

#ifdef ADD_MACRO_TO_LRTYPE
    {
      SpdObjId block_id;

      block_id = spdGetABlockId(occ.fileId, occ.offset);
      if (spdGetAttrValInt(block_id, "sort") == PBLOCK_MACROCALL) {
        ret =  EXPR_M_VALUE;
        return ret;
      }
    }
#endif

    /* initialization */
    inner_expr_id = spdGetAttrValIntOfRel(occ.relationId, "expression_id");
    outer_expr_id = inner_expr_id;

    /* get the outest expression */
    while (TRUE) {
        tmp_id = spdGetARelObj(outer_expr_id, "expr_expr", "inner_expression_id");
        if (tmp_id == SPD_NON_ID) break;
      
        inner_expr_id = outer_expr_id;
        outer_expr_id = tmp_id;
    }

    ret = spdGetAttrValIntOfObj(inner_expr_id, "lrtype");

    if (ret == EXPR_LR_UNKNOWN) {
        ret = spdGetAttrValIntOfObj(outer_expr_id, "lrtype");
    }

    return ret;
}

/* Ǥդʸ󤫤顤Υڡ֡Ԥ */

char *removeBlankString(char *org_line)
{
    char *head;                             /* ʳʸǽ˽и֡ */
    char *tail;                             /* ʳʸǸ˽и֡ */

    head = org_line;
    while (*head == ' ' || *head == '\t') {
        head++;
    }

    tail = org_line + strlen(org_line) - 1;
    while (*tail == '\n' || *tail == ' ' || *tail == '\t') {
        tail--;
    }
    tail++;
    *tail = '\0';

    return head;
}

/*
 * ʸ text椫ʸpat뤫ȽꤷƬΰ֤֤
 * textƬΰ֤0Ȥ롥ʤ-1֤
 * ʣޥåϡƬǤᤤ֤֤
 * ȤꤢǤ⥷ץʥ르ꥺǼ
 * 
 * 1999/10/08: ststr()Ѥѹ
 */

int spdMatchStr(SpdString text, SpdString pat)
{
    char *pchar;

    /* Checking arguments. */
    if (pat == NULL || text == NULL) {
        if (flag_v) {
            spdWarning("spdMatchStr(): String is NULL.\n");
        }
        return (-1);
    }

    if ((pchar = strstr(text, pat)) == NULL) {
        if (flag_v) {
            spdWarning("spdMatchStr(): \"%s\" isn't found in \"%s\".",
                       pat, text);
        }
        return (-1);
    }
    return (pchar - text);
}

/*
 * ʸHTML(XHTML)üʸ'"', '<', '>', '&', ' '
 * (XHTMLξ'\'')Ѵ롥
 * ؿgetConstant()putMacroSpec()ƤФ롥 
 */

SpdString convTextToHtml(SpdString str, int mode)
{
    int             i, j;

    /* 뤤ϥޥܥǥŸ */
    static char     ret[BUF_MAX];

    j = 0;
    for (i = 0; i < strlen(str); i++) {
        switch (str[i]) {
          case '"':
            ret[j++] = '&';
            ret[j++] = 'q';
            ret[j++] = 'u';
            ret[j++] = 'o';
            ret[j++] = 't';
            ret[j++] = ';';
            break;
          case '<':
            ret[j++] = '&';
            ret[j++] = 'l';
            ret[j++] = 't';
            ret[j++] = ';';
            break;
          case '>':
            ret[j++] = '&';
            ret[j++] = 'g';
            ret[j++] = 't';
            ret[j++] = ';';
            break;
          case '&':
            ret[j++] = '&';
            ret[j++] = 'a';
            ret[j++] = 'm';
            ret[j++] = 'p';
            ret[j++] = ';';
            break;
          case ' ':
            if (mode == CONV_HTML) {
                ret[j++] = '&';
                ret[j++] = 'n';
                ret[j++] = 'b';
                ret[j++] = 's';
                ret[j++] = 'p';
                ret[j++] = ';';
            } else {
                ret[j++] = str[i];
            }
            break;
          case '\\':
            if (mode == CONV_JAVASCRIPT) {
                ret[j++] = '\\';
                ret[j++] = '\\';
            } else {
                ret[j++] = str[i];
            }
            break;
          case '\'':
            if (mode == CONV_JAVASCRIPT) {
                ret[j++] = '\\';
                ret[j++] = '\'';
            } else {
                ret[j++] = str[i];
            }
            break;
          default:
            ret[j++] = str[i];
            break;
        }
    }
    if (BUF_MAX <= j) {
        spdErrorExit("Too long string.\n");
    }
    ret[j] = '\0';

    return (ret);
}

/*
 * objectIdǤ˳Ǽ¸ߤƤ뤫Ĵ٤롥
 */

SpdBoolean isContainDefElem(DefElem element, Define *def)
{
    int i;
    
    for (i = 0; i < def->size; i++) {
        if (element.offset == def->elem[i].offset &&
            element.ident_id == def->elem[i].ident_id &&
            element.file_id == def->elem[i].file_id) {
            return TRUE;
        }
    }
    return FALSE;
}

/*
 * objectIdǤ˳Ǽ¸ߤƤ뤫Ĵ٤(ޥ)
 * ƱobjectIdǾͤˤ
 * ¸ߤź֤¸ߤʤ -1 ֤
 */

int searchMacroDefElem(DefElem element)
{
    int i;
    
    for (i = 0; i < macro_def.size; i++) {
        if (SPD_STREQ(spdGetName(element.ident_id), 
                        spdGetName(macro_def.elem[i].ident_id)) &&
            element.offset == macro_def.elem[i].offset &&
            element.file_id == macro_def.elem[i].file_id) {
            
            if (element.ident_id < macro_def.elem[i].ident_id) {
                macro_def.elem[i].ident_id = element.ident_id;
            }
            return i;
        }
    }
    return -1;
}

/*
 * objectIdǤ˳Ǽ¸ߤƤ뤫Ĵ٤(ޥƽ)
 * ƱobjectIdǾͤˤ
 */

SpdBoolean isContainMacroCallElem(MacroCallElem element)
{
    int i;
    
    for (i = 0; i < macro_call.size; i++) {
        if (SPD_STREQ(spdGetName(element.name_id), 
                        spdGetName(macro_call.elem[i].name_id)) &&
            element.call_offset == macro_call.elem[i].call_offset &&
            element.call_file == macro_call.elem[i].call_file) {
            
            if (element.name_id < macro_call.elem[i].name_id) {
                macro_call.elem[i].name_id = element.name_id;
            }
            return TRUE;
        }
    }
    return FALSE;
}

SpdBoolean isContainOccForVarTable(VarTableElem element, VarTable table)
{
    int i;

    for (i = 0; i < table.size; i++) {
        if (table.elem[i].offset == element.offset &&
            table.elem[i].var_id == element.var_id &&
            table.elem[i].func_id == element.func_id) {
            return TRUE;
        }
    }
    return FALSE;
}

/****************************************************************/
/* Ʊ̾Υޥ˽ɤĴ٤ؿ                 */
/****************************************************************/

SpdBoolean isContainMacroDefine(SpdObjId macro_id, int number)
{
    int i;

    for (i = 0; i < number; i++) {
        if (SPD_STREQ(spdGetName(macro_id),
                        spdGetName(macro_call.elem[i].name_id))) {
            return TRUE;
        }
    }
    return FALSE;
}

/******************************************************************************/

#ifndef BUGGY_SDBLINK4_0107

/****************************************************************/
/* ˽ɤĴ٤ؿ                         */
/* Ʊ˾ơ֥Υ٥դԤ                           */
/****************************************************************/

SpdBoolean isContainConst(SpdString value, int num)
{
    int i;

    for (i = 0; i < num; i++) {
        if (SPD_STREQ(value, constant.elem[i].value)) {
            constant.elem[num].label = constant.elem[i].label;
            return TRUE;
        }
    }
    return FALSE;
}

#endif /* BUGGY_SDBLINK4_0107 */

/******************************************************************************/

#ifdef DEBUG

void elementDump(void)
{
    int i;

    printf("func_def size=%d\n", func_def.size);
    for (i = 0; i < func_def.size; i++) {
        printf("fileId:%d identId:%d length:%d offset:%d\n",
               func_def.elem[i].file_id, func_def.elem[i].ident_id,
               func_def.elem[i].length, func_def.elem[i].offset);
    }
    printf("\n");

    printf("func_proto size=%d\n", func_proto.size);
    for (i = 0; i < func_proto.size; i++) {
        printf("fileId:%d identId:%d length:%d offset:%d\n",
               func_proto.elem[i].file_id, func_proto.elem[i].ident_id,
               func_proto.elem[i].length, func_proto.elem[i].offset);
    }
    printf("\n");

    printf("ex_def size=%d\n", ex_def.size);
    for (i = 0; i < ex_def.size; i++) {
        printf("fileId:%d identId:%d length:%d offset:%d\n",
               ex_def.elem[i].file_id, ex_def.elem[i].ident_id,
               ex_def.elem[i].length, ex_def.elem[i].offset);
    }
    printf("\n");

    printf("var_def size=%d\n", var_def.size);
    for (i = 0; i < var_def.size; i++) {
        printf("fileId:%d identId:%d length:%d offset:%d\n",
               var_def.elem[i].file_id, var_def.elem[i].ident_id,
               var_def.elem[i].length, var_def.elem[i].offset);
    }
    printf("\n");

    printf("l_var_def size=%d\n", l_var_def.size);
    for (i = 0; i < l_var_def.size; i++) {
        printf("fileId:%d identId:%d length:%d offset:%d\n",
               l_var_def.elem[i].file_id, l_var_def.elem[i].ident_id,
               l_var_def.elem[i].length, l_var_def.elem[i].offset);
    }
    printf("\n");

    printf("arg_def size=%d\n", arg_def.size);
    for (i = 0; i < arg_def.size; i++) {
        printf("fileId:%d identId:%d length:%d offset:%d\n",
               arg_def.elem[i].file_id, arg_def.elem[i].ident_id,
               arg_def.elem[i].length, arg_def.elem[i].offset);
    }
    printf("\n");

    printf("member_def size=%d\n", member_def.size);
    for (i = 0; i < member_def.size; i++) {
        printf("fileId:%d identId:%d length:%d offset:%d\n",
               member_def.elem[i].file_id, member_def.elem[i].ident_id,
               member_def.elem[i].length, member_def.elem[i].offset);
    }
    printf("\n");

    printf("enum_def size=%d\n", enum_def.size);
    for (i = 0; i < enum_def.size; i++) {
        printf("fileId:%d identId:%d length:%d offset:%d\n",
               enum_def.elem[i].file_id, enum_def.elem[i].ident_id,
               enum_def.elem[i].length, enum_def.elem[i].offset);
    }
    printf("\n");

    printf("type_def size=%d\n", type_def.size);
    for (i = 0; i < type_def.size; i++) {
        printf("fileId:%d identId:%d length:%d offset:%d\n",
               type_def.elem[i].file_id, type_def.elem[i].ident_id,
               type_def.elem[i].length, type_def.elem[i].offset);
    }
    printf("\n");

    printf("l_var_occ size=%d\n", l_var_occ.size);
    for (i = 0; i < l_var_occ.size; i++) {
        printf("fileId:%d identId:%d length:%d offset:%d\n",
               l_var_occ.elem[i].file_id, l_var_occ.elem[i].ident_id,
               l_var_occ.elem[i].length, l_var_occ.elem[i].offset);
    }
    printf("\n");

    printf("arg_occ size=%d\n", arg_occ.size);
    for (i = 0; i < arg_occ.size; i++) {
        printf("fileId:%d identId:%d length:%d offset:%d\n",
               arg_occ.elem[i].file_id, arg_occ.elem[i].ident_id,
               arg_occ.elem[i].length, arg_occ.elem[i].offset);
    }
    printf("\n");

    printf("member_occ size=%d\n", member_occ.size);
    for (i = 0; i < member_occ.size; i++) {
        printf("fileId:%d identId:%d length:%d offset:%d\n",
               member_occ.elem[i].file_id, member_occ.elem[i].ident_id,
               member_occ.elem[i].length, member_occ.elem[i].offset);
    }
    printf("\n");

    printf("enum_occ size=%d\n", enum_occ.size);
    for (i = 0; i < enum_occ.size; i++) {
        printf("fileId:%d identId:%d length:%d offset:%d\n",
               enum_occ.elem[i].file_id, enum_occ.elem[i].ident_id,
               enum_occ.elem[i].length, enum_occ.elem[i].offset);
    }
    printf("\n");


    printf("type_occ size=%d\n", type_occ.size);
    for (i = 0; i < type_occ.size; i++) {
        printf("fileId:%d identId:%d length:%d offset:%d\n",
               type_occ.elem[i].file_id, type_occ.elem[i].ident_id,
               type_occ.elem[i].length, type_occ.elem[i].offset);
    }
    printf("\n");

    printf("var_table size=%d\n", var_table.size);
    for (i = 0; i < var_table.size; i++) {
        printf("fileId:%d varId:%d funcId:%d offset:%d\n",
               var_table.elem[i].file_id, var_table.elem[i].var_id,
               var_table.elem[i].func_id, var_table.elem[i].offset);
    }
    printf("\n");

    printf("callee size=%d\n", callee.size);
    for (i = 0; i < callee.size; i++) {
        printf("fileId:%d calleeId:%d funcId:%d offset:%d\n",
               callee.elem[i].file_id, callee.elem[i].callee_id,
               callee.elem[i].func_id, callee.elem[i].offset);
    }
    printf("\n");

    printf("caller size=%d\n", caller.size);
    for (i = 0; i < caller.size; i++) {
        printf("callerId:%d funcId:%d\n",
               caller.elem[i].caller_id,
               caller.elem[i].func_id);
    }
    printf("\n");

    printf("macrocall size=%d\n", macro_call.size);
    for (i = 0; i < macro_call.size; i++) {
        printf("name:%s(%d) bodyId:%d defFile:%d defOffset:%d calFile:%d calOffset:%d func_id:%d\n",
               spdGetName(macro_call.elem[i].name_id),
               macro_call.elem[i].name_id, macro_call.elem[i].body_id,
               macro_call.elem[i].define_file, 
               macro_call.elem[i].define_offset,
               macro_call.elem[i].call_file, macro_call.elem[i].call_offset,
               macro_call.elem[i].func_id);        
    }
    printf("\n");

    printf("tag_occ size=%d\n", tag_occ.size);
    for (i = 0; i < tag_occ.size; i++) {
        printf("fileId:%d identId:%d length:%d offset:%d\n",
               tag_occ.elem[i].file_id, tag_occ.elem[i].ident_id,
               tag_occ.elem[i].length, tag_occ.elem[i].offset);
    }
    printf("\n");

    printf("header_occ size=%d\n", header_occ.size);
    for (i = 0; i < header_occ.size; i++) {
        printf("file_id:%d hfile_id:%d offset:%d\n",
               header_occ.elem[i].file_id, header_occ.elem[i].hfile_id,
               header_occ.elem[i].offset);
    }
    printf("\n");

    printf("header size=%d\n", header.size);
    for (i = 0; i < header.size; i++) {
        printf("id: %d name:%s\n", header.elem[i].id,
               header.elem[i].name);
    }
    printf("\n");


    printf("comment size=%d\n", comment_block.size);
    for (i = 0; i < comment_block.size; i++) {
        printf("fileId:%d length:%d offset:%d\n",
               comment_block.elem[i].file_id, comment_block.elem[i].length,
               comment_block.elem[i].offset);
    }
    printf("\n");

    printf("pp_block size=%d\n", pp_block.size);
    for (i = 0; i < pp_block.size; i++) {
        printf("fileId:%d length:%d offset:%d\n",
               pp_block.elem[i].file_id, pp_block.elem[i].length,
               pp_block.elem[i].offset);
    }
    printf("\n");

    printf("define_block size=%d\n", define_block.size);
    for (i = 0; i < define_block.size; i++) {
        printf("fileId:%d length:%d offset:%d\n",
               define_block.elem[i].file_id, define_block.elem[i].length,
               define_block.elem[i].offset);
    }
    printf("\n");

    printf("include_block size=%d\n", include_block.size);
    for (i = 0; i < include_block.size; i++) {
        printf("fileId:%d length:%d offset:%d\n",
               include_block.elem[i].file_id, include_block.elem[i].length,
               include_block.elem[i].offset);
    }
    printf("\n");

    printf("constant size=%d\n", constant.size);
    for (i = 0; i < constant.size; i++) {
        printf("fileId:%d constId:%d value:%s org_value:%s length %d offset %d\n",
               constant.elem[i].file_id, constant.elem[i].const_id,
               constant.elem[i].value, constant.elem[i].org_value,
               constant.elem[i].length, constant.elem[i].offset);
    }
    printf("\n");    
}

#endif /* DEBUG */

static void spieFreeDefine(Define *tbl)
{
    if (tbl->size != 0) {
        spdFree(tbl->elem);
        tbl->size = 0;
        tbl->max_size = 0;
        tbl->elem = NULL;
    }
}

#ifndef BUGGY_SDBLINK4_0107

static void spieFreeConstOcc(ConstOcc *tbl)
{
    int i;

    for (i = 0; i < tbl->size; i++) {
        spdFree(tbl->elem[i].value);
        spdFree(tbl->elem[i].org_value);
    }

    if (tbl->size != 0) {
        spdFree(tbl->elem);
        tbl->size = 0;
        tbl->max_size = 0;
        tbl->elem = NULL;
    }
}

#endif /* BUGGY_SDBLINK4_107 */

static void spieFreeVarTable(VarTable *tbl)
{
    if (tbl->size != 0) {
        spdFree(tbl->elem);
        tbl->size = 0;
        tbl->max_size = 0;
        tbl->elem = NULL;
    }
}

static void spieFreeMacroCall(MacroCall *tbl)
{
    if (tbl->size != 0) {
        spdFree(tbl->elem);
        tbl->size = 0;
        tbl->max_size = 0;
        tbl->elem = NULL;
    }
}

static void spieFreeCallee(Callee *tbl)
{
    if (tbl->size != 0) {
        spdFree(tbl->elem);
        tbl->size = 0;
        tbl->max_size = 0;
        tbl->elem = NULL;
    }
}

static void spieFreeCaller(Caller *tbl)
{
    if (tbl->size != 0) {
        spdFree(tbl->elem);
        tbl->size = 0;
        tbl->max_size = 0;
        tbl->elem = NULL;
    }
}

static void spieFreePblock(P_Block *tbl)
{
    if (tbl->size != 0) {
        spdFree(tbl->elem);
        tbl->size = 0;
        tbl->max_size = 0;
        tbl->elem = NULL;
    }
}

static void spieFreeHeaderFiles(HeaderFiles *tbl)
{
    if (tbl->size != 0) {
        spdFree(tbl->elem);
        tbl->size = 0;
        tbl->max_size = 0;
        tbl->elem = NULL;
    }
}

static void spieFreeHeaderOcc(HeaderOcc *tbl)
{
    if (tbl->size != 0) {
        spdFree(tbl->elem);
        tbl->size = 0;
        tbl->max_size = 0;
        tbl->elem = NULL;
    }
}


/*
 * spdMalloc, spdReallocǳݤؿ. 
 */

void elementFree(void)
{
    spieFreeDefine(&func_def);
    spieFreeDefine(&func_proto);
    spieFreeDefine(&ex_def);
    spieFreeDefine(&var_def);
    spieFreeDefine(&l_var_def);
    spieFreeDefine(&arg_def);
    spieFreeDefine(&member_def);
    spieFreeDefine(&type_def);
    spieFreeDefine(&enum_def);
    spieFreeDefine(&tag_def);
    spieFreeDefine(&l_var_occ);
    spieFreeDefine(&arg_occ);
    spieFreeDefine(&tag_occ);
    spieFreeDefine(&member_occ);
    spieFreeDefine(&enum_occ);
    spieFreeDefine(&type_occ);
    spieFreeDefine(&macro_def);

    spieFreeConstOcc(&constant);
    spieFreeVarTable(&var_table);
    spieFreeMacroCall(&macro_call);
    spieFreeCallee(&callee);
    spieFreeCaller(&caller);

    spieFreePblock(&no_expand_block);
    spieFreePblock(&comment_block);
    spieFreePblock(&define_block);
    spieFreePblock(&pp_block);
    spieFreePblock(&include_block);

    spieFreeHeaderFiles(&header);
    spieFreeHeaderOcc(&header_occ);

    spdFree(bg_color);
    spdFree(text_color);
    spdFree(link_color);
    spdFree(alink_color);
    spdFree(vlink_color);
}

/* label id μ  */
int getLabelId(SpdObjId ident, Define *def)
{
    int i;
    for (i = 0; i < def->size; i++) {
        if (ident == def->elem[i].ident_id)
            return def->elem[i].label;
    }
    return -1;
}
