/* 
 * Program:             $RCSfile: pblock.c,v $  $Revision: 30.32 $
 * 
 * Purpose:             
 *
 * Author:              H.Ohhashi  1997/07/01
 *                      S.Yamamoto  1997/10/17
 *
 * (C) Copyright:       H.Ohhashi and S.Yamamoto  1997 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: pblock.c,v 30.32 2003/10/09 08:29:29 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spie.h"

static void getMacroCall(SpdObjId pblock_id);

/* ®Τnormalpblockϼʤ */
/* 
 * static SpdBoolean pblockIsNotNormal(const SpdRel rel)
 * {
 *     if (spdGetAttrValInt(rel.objectId, "sort") == PBLOCK_NORMAL)
 *         return FALSE;
 * 
 *     return TRUE;
 * }
 */

/*
 * إåեǼ˳ǼƤ뤫Ĵ٤ؿ         
 * ˳ǼƤ顤TRUE֤˳ǼFALSE֤.
 * դ⡩                                       
 */

static SpdBoolean getHeaderFileName(SpdObjId pfile_id)
{
    int i;
    SpdString name;
    
    name = spdGetName(pfile_id);

    /* NULL֤äƤfalse */
    if (name == NULL) {
        return FALSE;
    }

    for (i = 0; i < header.size; i++) {
        if (SPD_STREQ(header.elem[i].name, name)) {
            /*
             * if (header.elem[i].id > pfile_id) {
             * header.elem[i].id = pfile_id;
             * }
             */
            return TRUE;
        }
    }

    if (header.max_size <= header.size) {
        header.elem = spdRealloc(header.elem, sizeof(HeaderFileElem) * 
                                 (header.max_size + DEFAULT_ALLOC_SIZE));
        header.max_size += DEFAULT_ALLOC_SIZE;
    }

    header.elem[header.size].name = name;
    header.elem[header.size].id = spdConvIdPfileToFile(pfile_id);
    header.size++;
    return FALSE;
}

#ifdef COMMENTED

/*
 * إåեνи󤬴˳ǼƤ뤫ɤĴ٤ؿ
 * ե뤴ȤĴ٤ƤΤǡɬŪ˽иϾ˰ۤʤΤǡ 
 * ɬפʤ⤷ʤ                                   
 */

SpdBoolean isHeaderContain(HeaderOccElem element)
{
    int i;

    for (i = 0; i < header_occ.size; i++) {
        if (element.offset == header_occ.elem[i].offset &&
            SPD_STREQ(spdGetName(element.hfile_id),
                        spdGetName(header_occ.elem[i].hfile_id)) &&
            SPD_STREQ(spdGetName(element.file_id),
                        spdGetName(header_occ.elem[i].file_id))) {
            return TRUE;
        }
    }
    return FALSE;
}

#endif /* COMMENTED */

/*--------------------------------------------------------------*/
/* ޥξ                                       */
/*--------------------------------------------------------------*/

static void getMacroDef(SpdObjId pblock_id)
{
    SpdObjId pfile_id;
    SpdObjId mpatt_id;
    SpdObjId docident_id;
    SpdRel mpatt_mname;
    DefElem elem;
    int elemNum;

    pfile_id = spdGetARelObj(pblock_id, "file_block", "pblock_id");
    mpatt_id = spdGetARelObj(pblock_id, "def_mpatt", "pblock_id");
    mpatt_mname = spdGetARel(mpatt_id, "mpatt_mname", "macroPattern_id");

    if (pfile_id != SPD_NON_ID && mpatt_id != SPD_NON_ID) {
        if (macro_def.max_size <= macro_def.size) {
            macro_def.elem = spdRealloc(macro_def.elem, sizeof(DefElem) * 
                                        (macro_def.max_size + 
                                         DEFAULT_ALLOC_SIZE));
            macro_def.max_size += DEFAULT_ALLOC_SIZE;
        }

        elem.ident_id = mpatt_mname.objectId;
        elem.file_id = spdConvIdPfileToFile(pfile_id);
        elem.offset = spdGetOffset(mpatt_mname.relationId);

        if ((elemNum = searchMacroDefElem(elem)) == -1) {
            macro_def.elem[macro_def.size].ident_id = elem.ident_id;
            macro_def.elem[macro_def.size].file_id =  elem.file_id;
            macro_def.elem[macro_def.size].offset = elem.offset;
            macro_def.elem[macro_def.size].is_static = FALSE;

            if (flag_x) {
                docident_id = searchMacroDocidentId(elem);
                macro_def.elem[macro_def.size].docfrag_id =
                    spdGetARelObj(docident_id, "defelem_docident", "docident_id");
            }
            
            macro_def.size++;
        }
    }   
}

/*
 * ޥƤӽФξؿ
 */

static void getMacroCall(SpdObjId pblock_id)
{
    int i, j;
    SpdObjId mname_id, docident_id, pfile_id;
    SpdRel mcall_rel;
    SpdOcc mdef_occ;
    int offset, elemNum;
    DefElem def_elem;
    MacroCallElem call_elem;

    mcall_rel = spdGetARel(pblock_id, "call_mcall", "p-id");
    mname_id = spdGetARelObj(mcall_rel.objectId, "mcall_mname", "p-id");
    mdef_occ = spdGetAnOffsetOfObj(mname_id);

    def_elem.ident_id = mname_id;
    def_elem.file_id = spdConvIdPfileToFile(mdef_occ.fileId);
    def_elem.offset = mdef_occ.offset;

    /* ϿƤ macro def ID  index id  */
    /* ϿƤʤ macro def Ͽ */
    if ((elemNum = searchMacroDefElem(def_elem)) == -1) {
        if (macro_def.max_size <= macro_def.size) {
            macro_def.elem = spdRealloc(macro_def.elem, sizeof(DefElem) * 
                                        (macro_def.max_size + 
                                         DEFAULT_ALLOC_SIZE));
            macro_def.max_size += DEFAULT_ALLOC_SIZE;
        }

        elemNum = macro_def.size;
        macro_def.elem[elemNum].ident_id = def_elem.ident_id;
        macro_def.elem[elemNum].file_id =  def_elem.file_id;
        macro_def.elem[elemNum].offset = def_elem.offset;
        macro_def.elem[elemNum].is_static = FALSE;
        if (flag_x) {
            docident_id = searchMacroDocidentId(def_elem);
            macro_def.elem[macro_def.size].docfrag_id =
                spdGetARelObj(docident_id, "defelem_docident", "docident_id");
        }

        macro_def.size++;
    }

    pfile_id = spdGetARelObj(pblock_id, "file_block", "c-id");
    call_elem.name_id = macro_def.elem[elemNum].ident_id;
    call_elem.call_offset = spdGetOffset(mcall_rel.relationId);
    call_elem.call_file = spdConvIdPfileToFile(pfile_id);

    /* macro ƤӽФϿ */
    if (macro_call.max_size <= macro_call.size) {
        macro_call.elem = 
            spdRealloc(macro_call.elem, sizeof(MacroCallElem) * 
                       (macro_call.max_size + 
                        DEFAULT_ALLOC_SIZE));
        macro_call.max_size += DEFAULT_ALLOC_SIZE;
    }
    if (!isContainMacroCallElem(call_elem)) {
        macro_call.elem[macro_call.size].name_id = call_elem.name_id;
        macro_call.elem[macro_call.size].call_offset = call_elem.call_offset;
        macro_call.elem[macro_call.size].call_file = call_elem.call_file;
        /* ͤȤfunc_idSPD_NON_IDƤ */
        macro_call.elem[macro_call.size].func_id = SPD_NON_ID;
        macro_call.size++;
    }
}


/*
 * إåեΥץνиؿ. 
 * 饹 hfile° nameˤ'"'ޤޤ뤿ᡤ          
 * إåե̾μӹԤäƤ.
 * ()  file_id pfile饹IDǤ롥
 */

static void getHeaderFileOcc(SpdObjId file_id, SpdObjId pblock_id)
{
    SpdRel hfile_rel;
    SpdObjId pfile_id;
    /* HeaderOccElem element; */

    if (header_occ.max_size <= header_occ.size) {
        header_occ.elem = spdRealloc(header_occ.elem, 
                                     sizeof(HeaderOccElem) * 
                                     (header_occ.max_size + 
                                      DEFAULT_ALLOC_SIZE));
        header_occ.max_size += DEFAULT_ALLOC_SIZE;
    }

    hfile_rel = spdGetARel(pblock_id, "incld_hfile", "pblock_id");
    
    if (hfile_rel.objectId != SPD_NON_ID) {
        pfile_id = spdGetARelObj(hfile_rel.objectId, "hfile_file", "hfile_id");

        if (pfile_id != SPD_NON_ID && !smuIsSystemFile(pfile_id)) {
            /* element.file_id = file_id;                           */
            /* element.hfile_id = hfile_rel.objectId;               */
            /* element.offset = spdGetOffset(hfile_rel.relationId); */

            header_occ.elem[header_occ.size].file_id = 
                spdConvIdPfileToFile(file_id);
            header_occ.elem[header_occ.size].hfile_id = hfile_rel.objectId;
            header_occ.elem[header_occ.size].offset = 
                spdGetOffset(hfile_rel.relationId);
            header_occ.elem[header_occ.size].h_pfile_id = 
                spdConvIdPfileToFile(pfile_id);
            header_occ.size++;

            /* إåե̾롥 */
            /* if (!getHeaderFileName(hfile_rel.objectId)) { */
            if (!getHeaderFileName(pfile_id)) { 
                /* إåե뼫ΤβϤԤ   */
                getPBlock(pfile_id);
            }
        }
    }
}

/*
 * pblockǤǼ
 */

static void addPBlockElem(P_Block *buf, SpdObjId pfileId, SpdRel rel)
{
    SpdRegion region;
    SpdString reg_text;

    if (buf->max_size <= buf->size) {
        buf->elem = spdRealloc(buf->elem, sizeof(P_BlockElem) * 
                               (buf->max_size + DEFAULT_ALLOC_SIZE));
        buf->max_size += DEFAULT_ALLOC_SIZE;
    }


    /* pblockκǸʸ '\n' ʤ length 1餹 */
    /* '\n'Τߤ pblockʤϿʤ */

    region.fileId = pfileId;
    region.length = spdGetLength(rel.objectId);
    region.offset = spdGetOffset(rel.relationId);

    reg_text = spdGetTextByRegion(region);

    if (reg_text == NULL) {
        spdErrorExit("Invalid region(fileId: %d offset: %d length: %d\n", 
                     region.fileId, region.offset, region.length);
    } 

    if (reg_text[strlen(reg_text)-1] == '\n') {
        if (region.length == 1) {
            spdFree(reg_text);
            return;
        } else {
            buf->elem[buf->size].file_id = spdConvIdPfileToFile(pfileId);
            buf->elem[buf->size].offset = region.offset;
            buf->elem[buf->size].length = region.length - 1;
            buf->size++;
        }
    } else {
        buf->elem[buf->size].file_id = spdConvIdPfileToFile(pfileId);
        buf->elem[buf->size].offset = region.offset;
        buf->elem[buf->size].length = region.length;
        buf->size++;
    }
    spdFree(reg_text);
}


/*
 * pblockŸƤ뤫Ƚ
 */

static SpdBoolean isPBlockExpand(SpdObjId pblockId)
{
    SpdBoolean is_expand = FALSE;

    switch (spdGetAttrValInt(pblockId, "sort")) {
      case PBLOCK_NORMAL:
      case PBLOCK_COMMENT:
        if (spdGetARelObj(pblockId, "pblock_iblock", "pblock_id")
            != SPD_NON_ID)
            is_expand = TRUE;
        break;
      case PBLOCK_DEFINE_FILE:
        if (spdGetARelObj(pblockId, "def_mpatt", "pblock_id")
            != SPD_NON_ID)
            is_expand = TRUE;
        break;
      case PBLOCK_INCLUDE:
        if (spdGetARelObj(spdGetARelObj(pblockId, "incld_hfile", "pblock_id"),
                          "hfile_file", "hfile_id") != SPD_NON_ID)
            is_expand = TRUE;
        break;
      default:
        break;
    }
  
    return is_expand;
}

/*
 * ե pblockΰ־ؿ.                 
 * եݤ˻Ѥ롥                       
 */

void getPBlock(SpdObjId pfile_id)
{
    int i;
    SpdRelArray pblock_buf;

    pblock_buf = spdGetRelSortedArray(pfile_id, "file_block", 
                                      "pfile_id", NULL,
                                      spdCompareRelOffset);

    for (i = 0; i < pblock_buf.size; i++) {
        switch (spdGetAttrValInt(pblock_buf.rel[i].objectId, "sort")) {
          case PBLOCK_NORMAL:
            if (!isPBlockExpand(pblock_buf.rel[i].objectId)) {
                addPBlockElem(&no_expand_block, pfile_id, pblock_buf.rel[i]);
            }
            break;
          case PBLOCK_INCLUDE:
            if (!isPBlockExpand(pblock_buf.rel[i].objectId)) {
                addPBlockElem(&no_expand_block, pfile_id, pblock_buf.rel[i]);
            } else {
                getHeaderFileOcc(pfile_id, pblock_buf.rel[i].objectId);
                addPBlockElem(&include_block, pfile_id, pblock_buf.rel[i]);
            }
            break;
          case PBLOCK_DEFINE_FILE:
            if (!isPBlockExpand(pblock_buf.rel[i].objectId)) {
                addPBlockElem(&no_expand_block, pfile_id, pblock_buf.rel[i]);
            } else {
                getMacroDef(pblock_buf.rel[i].objectId);
                addPBlockElem(&define_block, pfile_id, pblock_buf.rel[i]);
            }
            break;
          case PBLOCK_COMMENT:
            if (!isPBlockExpand(pblock_buf.rel[i].objectId)) {
                addPBlockElem(&no_expand_block, pfile_id, pblock_buf.rel[i]);
            } else { 
                addPBlockElem(&comment_block, pfile_id, pblock_buf.rel[i]);
            }
            break;
          case PBLOCK_DEFINE_OPTION:
            break;
          case PBLOCK_DEFINE_INIT:
            break;
          case PBLOCK_MACROCALL:
            getMacroCall(pblock_buf.rel[i].objectId);
            break;
          default:
            addPBlockElem(&pp_block, pfile_id, pblock_buf.rel[i]);
            break;
        }
    }
    spdFreeRelArray(pblock_buf);
}
