/* 
 * Program:             $RCSfile: putHtml.c,v $  $Revision: 30.140 $
 * 
 * Purpose:             
 *
 * Author:              H.Ohhashi  1997/07/01
 *                      S.Yamamoto  1997/10/17
 *
 * (C) Copyright:       H.Ohhashi and S.Yamamoto  1997 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: putHtml.c,v 30.140 2003/11/04 03:39:44 yamamoto Exp yamamoto $";
#endif

/****************************************************************/
/* ϤHTMLեؿ                       */
/* ǽ餫˽ϤƤʤΤǸΨ               */
/****************************************************************/  

#include <stdarg.h>
#include <stdio.h>
#include <sys/stat.h>
#include <Sapid/Sapid.h>
#include <Sapid/SpdStr.h>
#include "spie.h"
#include "style.h"
#include "JavaScript.h"

/*
 * <table>summary°ʤȡTidywarningФ
 * !! summary°ͤȤơľ<a>name°ͤѤ뤳ȡ
 */
#define TABLE_ELEMENT   "<table border=\"1\" width=\"100%%\" summary=\"\">\n"

static int getLineColumn(SpdObjId fileId, int offset, int *line, int *column);
static int putConstList(void);
static void putDocList(void);
static void putVariableSpec(void);
static void putL_VariableSpec(void);
static void putDocument(void);
static void putRightFrame(FILE *);
static void putCommentForSearch(FILE *fp);
static void putCommentForSearchOcc(FILE *fp);

/*--------------------------------------------------------------*/
/* "-v"ץΥå                                 */
/*--------------------------------------------------------------*/

static void printMessage(SpdString file)
{
    spdMessage("Writing file \"%s\".\n", file);
}

/*--------------------------------------------------------------*/
/* եopen롥                                         */
/*--------------------------------------------------------------*/

FILE *spieFileOpen(SpdString file_name)
{
    FILE    *fp;

    fp = spdFopen(file_name, SPD_FOPEN_WT_MODE);
    if (flag_v) {
        printMessage(file_name);
    }    
    return (fp);
}

/******************************************************************************/

/*--------------------------------------------------------------*/
/*  ˤϤޤ줿ʸ롥                        */
/*  ϥ°°ͤϲѰϤ                */
/*  Ѱ°̾°ͤνǡǸNULLϤȡ      */
/*  ⡼(HTML, XHTML)ˤǽλɬפݤȽꤹ롥   */
/*  ŪˤϤ٤ƤΥ򤳤δؿ              */
/*  ߤHTMLXHTMLǽλ̵ͭۤʤ륿Τ롥 */
/*--------------------------------------------------------------*/

SpdString genTagStr(SpdString tagName, SpdString text, ...)
{
    va_list         ap;
    SpdString       attrName, attrValue;
    static char     ret_str[SPD_STRING_LEN + 1];

    /* ϥʸ롥 */
    sprintf(ret_str, "<%s", tagName);

    va_start(ap, text);
    while ((attrName = va_arg(ap, char *)) != NULL) {
        sprintf(ret_str, "%s %s", ret_str, attrName);
        if ((attrValue = va_arg(ap, char *)) == NULL) {
            break;
        }
        /* °ͤdouble quoteǰϤࡥ */
        sprintf(ret_str, "%s=\"%s\"", ret_str, attrValue);
    }
    va_end(ap);

    /* ˰ϤޤƥȤɲä롥NULLξɲäʤ */
    if (text != NULL) {
        strcat(ret_str, ">");
        strcat(ret_str, text);
        /* λɲä롥 */
        if (language_type != HTML_MODE) {
            sprintf(ret_str, "%s</%s>\n", ret_str, tagName);
        } else {
            strcat(ret_str, "\n");
        }
    } else {
        strcat(ret_str, " />");
    }
    return (ret_str);
}

/*
 * <A><FONT>...</FONT></A>ηΥϤ
 */

static void putElementA(FILE *fp, SpdString href,
                        SpdString target, SpdCss style_no,
                        SpdString text, SpdString js_text, SpdString tips) 
{

    fprintf(fp, "<a");
    if (flag_q) {
        fprintf(fp, " onClick=\"top.tool.disp_history('");
        if (js_text) {
            fprintf(fp, "%s", convTextToHtml(js_text, CONV_JAVASCRIPT));
        } else {
            fprintf(fp, "%s", text);
        }
        fprintf(fp, "');\"");
    }
    if (flag_T) {
        if (tips != NULL) {
            fprintf(fp, " onMouseOver=\"top.used_tips('");
            fprintf(fp, "%s/%s');\"", tipsHtmlDir, tips);
        }
    }
    if (href) {
        fprintf(fp, " href=\"");
        fprintf(fp, "%s", href);
        fprintf(fp, "\"");
    }
    if (target) {
        fprintf(fp, " target=\"");
        fprintf(fp, "%s", target);
        fprintf(fp, "\"");
    }
    if (flag_c && style_no != NON_STYLE) {
        fprintf(fp, " class=\"%s\"", color_style[style_no].style);
    }
    fprintf(fp, ">");

    if (!flag_c && style_no != NON_STYLE) {
        fprintf(fp, "<font color=\"%s\">", color_style[style_no].color);
    }

    if (text) {
        fprintf(fp, "%s", text);
    }
    if (!flag_c) {
        fprintf(fp, "</font>");
    }
    fprintf(fp, "</a>");
}

/*
 * Ԥɲä롥
 */

static void addNewLine(FILE *fp)
{
    int i;

    for (i = 0; i < TRAILING_LINE_NUM; i++) {
        fprintf(fp, genTagStr("br", NULL, NULL));
    }
}

/*
 * ʸɲ(ޥΤۤ?)
 */

static void addBlankString(FILE *fp)
{
    fprintf(fp, "&nbsp;&nbsp;");
}

/*--------------------------------------------------------------*/   
/*  HTMLեƬνϴؿ                                */
/*--------------------------------------------------------------*/

void beginHtml(FILE *fp, SpdString title)
{
    if (language_type == HTML_MODE) {
        fprintf(fp, SPD_DOCTYPE_HTML_4_01_F);
    } else if (language_type == XHTML_MODE) {
        fprintf(fp, SPD_XML_DECL_1_0);
        fprintf(fp, SPD_DOCTYPE_XHTML_1_0_F);
    }

    /* Output header. */
    if (!flag_n) {
        time_t  now = time(NULL);

        fprintf(fp, "<!--\n");
        fprintf(fp, "#\n");
        fprintf(fp, "# %s", asctime(localtime(&now)));
        fprintf(fp, "# This file is Generated by %s in Sapid-%d.%d.%d.\n",
                PROG_NAME, SapidVersion, SapidRevision, SapidPatchLevel);
        fprintf(fp, "# Don't modify this file.\n");
        fprintf(fp, "#\n");
        fprintf(fp, "-->\n");
    }

    fprintf(fp, "<html>\n<head>\n<title>%s: %s</title>\n", 
            PROG_NAME, target_program_name);
    if (title != NULL && SPD_STREQ("TOP", title)) {
        fprintf(fp, HTML_META_ELEMENT "\n");
        if (flag_p)
            fprintf(fp, JS_HEADER(JS_TITLE_FILE));
        if (flag_T)
            fprintf(fp, JS_HEADER(JS_TIPS_FILE));
    }
    if (title != NULL && SPD_STREQ(QUICK_JUMP, title)) {
        if (flag_q)
            fprintf(fp, JS_HEADER(JS_QJ_FILE));
    }
    if (flag_c) {
        fprintf(fp, HTML_LINK_ELEMENT "\n");
    }
    fprintf(fp, "</head>\n");
}

/*--------------------------------------------------------------*/   
/*  HTMLեνϴؿ                                */
/*--------------------------------------------------------------*/

void endHtml(FILE *fp)
{
    fprintf(fp, "</body>\n</html>\n");
}

/*--------------------------------------------------------------*/
/* HTMLեbodyƬνϴؿ                           */
/*--------------------------------------------------------------*/

void bodyHtml(FILE *fp, SpdString title, SpdString js_title)
{
    fprintf(fp, "<body");
    if (!flag_c) {
        fprintf(fp, BODY_STYLE, bg_color, text_color, link_color, alink_color,
                vlink_color);
    }
    if (flag_p && (js_title != NULL)) {
        fprintf(fp, " onload=\"top.print_title('%s')\"", js_title);
    }
    fprintf(fp, ">\n");
    if (title != NULL) {
        fprintf(fp, "<center><b>%s</b></center>\n", title);
    }
}

/*--------------------------------------------------------------*/
/* ե                                                 */
/*--------------------------------------------------------------*/

static void putMemoTemplate(SpdString file)
{
    FILE *fp;
    SpdString path;

    path = spdCatPath(directory, file);
    fp = spieFileOpen(path);

    beginHtml(fp, NULL);
    bodyHtml(fp, MEMO_TITLE, NULL);

    fprintf(fp, "<!-- %s -->\n\n", CGI_BEGIN);
    fprintf(fp, "<!-- %s -->\n", CGI_END);

    endHtml(fp);

    spdFclose(fp);
    spdFree(path);
}

/*--------------------------------------------------------------*/
/* Υǡեʺǽ϶ե                     */
/*--------------------------------------------------------------*/

static void putMemoData(void)
{
    FILE *fp;
    SpdString path;

    path = spdCatPath(directory, MEMO_DAT_FILE);
    fp = spieFileOpen(path);
    spdFclose(fp);
    spdFree(path);
}

/*--------------------------------------------------------------*/
/* ꥹȤǤ                                           */
/*--------------------------------------------------------------*/

static void putListElem(FILE *fp, SpdString href, SpdString target,
                        SpdCss style_no, SpdString link, 
                        SpdString description, SpdString js_text)
{
    putElementA(fp, href, target, style_no, link, js_text, NULL);
    
    /* "(static)"Τ褦Ūʸɲ */
    if (description != NULL) {
        fprintf(fp, " %s", description);
    }

    fprintf(fp, "%s\n", genTagStr("br", NULL, NULL));
}

/*--------------------------------------------------------------*/
/* right, leftΤΥåܥåκ                    */
/*--------------------------------------------------------------*/

static void putLrChkBox(FILE *fp, SpdString var, SpdString text)
{
    fprintf(fp, "%s", genTagStr("input", NULL, "type", "checkbox", 
                                "name", var, "checked", "1", NULL));
    fprintf(fp, " %s", text);
    fprintf(fp, "%s", genTagStr("br",NULL,NULL));
}

/*--------------------------------------------------------------*/
/* ѥե                                         */
/*--------------------------------------------------------------*/

static void putSearchForm(FILE *fp)
{
    fprintf(fp, "%s", genTagStr("input", NULL, "type", "text", 
                                "name", "expr", "value", "", 
                                "size","15", NULL));
    if (flag_q)
        fprintf(fp, "%s", genTagStr("input", NULL, "type", "submit", 
                                    "value", "Search!", "onClick",
                                    "top.tool.disp_history('Search:Index');",
                                    NULL));
    else
        fprintf(fp, "%s", genTagStr("input", NULL, "type", "submit", 
                                    "value", "Search!", NULL));

    fprintf(fp, "%s", genTagStr("hr",NULL,NULL));
    fprintf(fp, "Search Option");
    fprintf(fp, "%s", genTagStr("br",NULL,NULL));

    putLrChkBox(fp, "sw_left", LR_STR_LEFT);
    putLrChkBox(fp, "sw_right", LR_STR_RIGHT);
    putLrChkBox(fp, "sw_left_right", LR_STR_LEFT_RIGHT);
    putLrChkBox(fp, "sw_ref", LR_STR_REFERENCE);

    fprintf(fp, "%s", genTagStr("hr",NULL,NULL));
    fprintf(fp, "</form>\n");  
}

/*-------------------------------------------------------------*/
/*   tipsѤΥץΤΥåܥå        */
/*-------------------------------------------------------------*/

static void putTipsOpt(FILE *fp)
{
    fprintf(fp, "<form name=tips>");
    fprintf(fp, "Tips Option");
    fprintf(fp, "%s", genTagStr("br", NULL, NULL));
    putLrChkBox(fp, "sw_tips", "Use Tips");
    putLrChkBox(fp, "sw_fix", "Not Fix Tips");
    fprintf(fp, "</form>");
}

/*--------------------------------------------------------------*/
/*   ¦ե졼ե                           */
/*--------------------------------------------------------------*/

static void putFrame(void)
{
    FILE *fp;
    SpdString path;
    char src_file[FILENAME_MAX + 1];

    /* ǥ쥯ȥ̾ȥե̾Ĥʤ */
    path = spdCatPath(directory, FRAME_LEFT_FILE);

    fp = spieFileOpen(path);

    beginHtml(fp, "TOP");

    if(flag_q) {
        fprintf(fp, "<frameset rows=\"%s,*\">\n" , TOOL_ROWS_PERCENT);
        fprintf(fp, "%s", genTagStr("frame", NULL, "src", TOOL_FILE,
                                    "name", "tool", NULL));
    }

    fprintf(fp, "<frameset cols=\"%s,*\">\n\n", COLS_PERCENT);
    fprintf(fp, "<frameset rows=\"%s,*\">\n", LEFT_ROWS_PERCENT);

    fprintf(fp, "%s", genTagStr("frame", NULL, "src", INDEX_FILE,
                                "name", "lefttop", NULL));

    fprintf(fp, "%s", genTagStr("frame", NULL, "src", LIST_FILE_FILE,
                                "name", "leftbottom", NULL));
    fprintf(fp, "</frameset>\n");

    if (flag_p || flag_m) {
        putRightFrame(fp);
    } else {
        sprintf(src_file, "1-%s", SPEC_FUNC_FILE);
        fprintf(fp, "%s", genTagStr("frame", NULL, "src", src_file,
                                    "name", "righttop", NULL));
    }

    fprintf(fp, "</frameset>\n");
    if (flag_q) fprintf(fp, "</frameset>\n");
    fprintf(fp, "</html>\n");

    spdFclose(fp);
    spdFree(path);
}

/*--------------------------------------------------*/
/* JavaScriptξαΥե                 */
/*--------------------------------------------------*/

static void putLogoFile(void)
{
    FILE *fp;
    SpdString path;

    path = spdCatPath(directory, LOGO_FILE);
    fp = spieFileOpen(path);

    beginHtml(fp, NULL);
    bodyHtml(fp, NULL, NULL);
    endHtml(fp);

    spdFclose(fp);
    spdFree(path);
}

/*--------------------------------------------------*/
/* ¦Υե졼                               */
/*--------------------------------------------------*/

static void putRightFrame(FILE *fp)
{
    char src_file[FILENAME_MAX + 1];

    if (flag_p && flag_m) {
        fprintf(fp, "<frameset rows=\"%s, %s, *\">\n", 
                JAVASCRIPT_ROWS_PERCENT, MEMO_ROWS_PERCENT);
    } else if (flag_p) {
        fprintf(fp, "<frameset rows=\"%s, *\">\n", JAVASCRIPT_ROWS_PERCENT);
    } else if (flag_m) {
        fprintf(fp, "<frameset rows=\"%s, *\">\n", MEMO_ROWS_PERCENT);
    }
    if (flag_p) {
        fprintf(fp, "%s", genTagStr("frame", NULL, "src", LOGO_FILE,
                                    "name", "right_js", NULL));
        putLogoFile();
    }
    sprintf(src_file, "1-%s", SPEC_FUNC_FILE);
    fprintf(fp, "%s", genTagStr("frame", NULL, "src", src_file,
                                "name", "righttop", NULL));
    if (flag_m) {
        fprintf(fp, "%s", genTagStr("frame", NULL, "src", SPEC_MEMO_FILE,
                                    "name", "rightbottom", NULL));
        putMemoTemplate(LIST_MEMO_FILE);
        putMemoTemplate(SPEC_MEMO_FILE);
        putMemoData();
    }    
    fprintf(fp, "</frameset>\n");
}

/*--------------------------------------------------------------*/
/*  Υإåƥץ졼ȥե                            */
/*--------------------------------------------------------------*/

static void putSearchHeader(SpdString file)
{
    FILE *fp;
    SpdString path;

    path = spdCatPath(directory, file);
    fp = spieFileOpen(path);

    beginHtml(fp, SEARCH);
    bodyHtml(fp, SEARCH, NULL);

    spdFclose(fp);
    spdFree(path);
}

/*--------------------------------------------------------------*/
/* TOP PAGEHTMLե롥                           */
/*--------------------------------------------------------------*/

static void putIndex(int file_num, int const_num)
{
    FILE *fp;
    SpdString path;
    SpdObjIdArray docfileid_array;
    char temp[TEMP_MAX];
    char js_text[TEMP_MAX];

    path = spdCatPath(directory, INDEX_FILE);
    fp = spieFileOpen(path);

    beginHtml(fp, INDEX_TITLE);
    bodyHtml(fp, PROG_NAME, NULL);

    fprintf(fp, "<center><b>Program: %s</b></center>\n", target_program_name);

    fprintf(fp, "<form target=\"%s\" method=\"get\" action=\"%s\">\n", 
            LEFTBOTTOM, SEARCH_CGI);

    fprintf(fp, genTagStr("input", NULL, "type", "checkbox", 
                          "name", "sw_file", "checked", "1", NULL));
    sprintf(temp, "%s (%d)", FILE_TITLE, file_num + header.size);
    sprintf(js_text, "%s:Index", FILE_TITLE);
    putListElem(fp, LIST_FILE_FILE, LEFTBOTTOM, FILE_STYLE, temp, NULL,
                js_text);

    fprintf(fp, genTagStr("input", NULL, "type", "checkbox", 
                          "name", "sw_func", "checked", "1", NULL));
    sprintf(temp, "%s (%d)", FUNC_TITLE, func_def.size);
    sprintf(js_text, "%s:Index", FUNC_TITLE);
    putListElem(fp, LIST_FUNC_FILE, LEFTBOTTOM, FUNC_STYLE, temp, NULL, 
                js_text);

    fprintf(fp, genTagStr("input", NULL, "type", "checkbox", 
                          "name", "sw_var", "checked", "1", NULL));
    sprintf(temp, "%s (%d)", G_VAR_TITLE, var_def.size);
    sprintf(js_text, "%s:Index", G_VAR_TITLE);
    putListElem(fp, LIST_VAR_FILE, LEFTBOTTOM, VAR_STYLE, temp, NULL,
                js_text);

    if (flag_l) {
        fprintf(fp, genTagStr("input", NULL, "type", "checkbox", 
                              "name", "sw_l_var", "checked", "1", NULL));
        sprintf(temp, "%s (%d)", L_VAR_TITLE, l_var_def.size);
        sprintf(js_text, "%s:Index", L_VAR_TITLE);
        putListElem(fp, LIST_L_VAR_FILE, LEFTBOTTOM, L_VAR_STYLE, temp, 
                    NULL, js_text);

        fprintf(fp, genTagStr("input", NULL, "type", "checkbox", 
                              "name", "sw_arg", "checked", "1", NULL));
        sprintf(temp, "%s (%d)", ARGUMENT_TITLE, arg_def.size);
        sprintf(js_text, "%s:Index", ARGUMENT_TITLE);
        putListElem(fp, LIST_ARG_FILE, LEFTBOTTOM, ARG_STYLE, temp, NULL, 
                    js_text);
    }

    fprintf(fp, genTagStr("input", NULL, "type", "checkbox", 
                          "name", "sw_type", "checked", "1", NULL));
    sprintf(temp, "%s (%d)", TYPE_TITLE, type_def.size);
    sprintf(js_text, "%s:Index", TYPE_TITLE);
    putListElem(fp, LIST_TYPE_FILE, LEFTBOTTOM, TYPE_STYLE, temp, NULL,
                js_text);

    fprintf(fp, genTagStr("input", NULL, "type", "checkbox", 
                          "name", "sw_member", "checked", "1", NULL));
    sprintf(temp, "%s (%d)", MEMBER_TITLE, member_def.size);
    sprintf(js_text, "%s:Index", MEMBER_TITLE);
    putListElem(fp, LIST_MEMBER_FILE, LEFTBOTTOM, MEMBER_STYLE, temp, NULL, 
                js_text);

    fprintf(fp, genTagStr("input", NULL, "type", "checkbox", 
                          "name", "sw_enum", "checked", "1", NULL));
    sprintf(temp, "%s (%d)", ENUM_TITLE, enum_def.size);
    sprintf(js_text, "%s:Index", ENUM_TITLE);
    putListElem(fp, LIST_ENUM_FILE, LEFTBOTTOM, ENUM_STYLE, temp, NULL,
                js_text);

    fprintf(fp, genTagStr("input", NULL, "type", "checkbox", 
                          "name", "sw_macro", "checked", "1", NULL));
    sprintf(temp, "%s (%d)", MACRO_TITLE, macro_def.size);
    sprintf(js_text, "%s:Index", MACRO_TITLE);
    putListElem(fp, LIST_MACRO_FILE, LEFTBOTTOM, MACRO_STYLE, temp, NULL,
                js_text);

#ifndef BUGGY_SDBLINK4_0107
    fprintf(fp, genTagStr("input", NULL, "type", "checkbox", 
                          "name", "sw_const", "checked", "1", NULL));
    sprintf(temp, "%s (%d)", CONST_TITLE, const_num);
    sprintf(js_text, "%s:Index", CONST_TITLE);
    putListElem(fp, LIST_CONST_FILE, LEFTBOTTOM, CONST_STYLE, temp, NULL,
                js_text);
#endif

    fprintf(fp, genTagStr("input", NULL, "type", "checkbox", 
                          "name", "sw_tag", "checked", "1", NULL));
    sprintf(temp, "%s (%d)", TAG_TITLE, tag_def.size);
    sprintf(js_text, "%s:Index", TAG_TITLE);
    putListElem(fp, LIST_TAG_FILE, LEFTBOTTOM, TAG_STYLE, temp, NULL,
                js_text);
    if (flag_x) {
        docfileid_array = spdGetObjIdArray("docfile", NULL, NULL);
        fprintf(fp, genTagStr("input", NULL, "type", "checkbox", 
                              "name", "sw_doc", "checked", "1", NULL));
        sprintf(temp, "%s (%d)", DOCUMENT_TITLE, docfileid_array.size);
        sprintf(js_text, "%s:Index", DOCUMENT_TITLE);
        putListElem(fp, LIST_DOC_FILE, LEFTBOTTOM, DOC_STYLE, temp, NULL,
                    js_text);
        spdFreeObjIdArray(docfileid_array);
    }
    if (flag_m == ON) {
        sprintf(temp, "%s?CMD=LIST", MEMO_CGI_FILE);
        sprintf(js_text, "%s:Index", MEMO_TITLE);
        putListElem(fp, temp, LEFTBOTTOM, MEMO_STYLE, MEMO_TITLE, NULL,
                    js_text);
    }

    putSearchForm(fp);

    if (flag_T) {
        putTipsOpt(fp);
    }

    endHtml(fp);

    spdFclose(fp);
    spdFree(path);
}

/*
 * declaratorǤ뤫.
 */

SpdBoolean spdDeclrIsDeclTag(const SpdObjId declrId)
{
    if (spdGetAttrValInt(declrId, "sort") == DECL_TAG) return TRUE;
    return FALSE;
}

/*
 * ident_iddef󤫤õindex֤¸ߤʤ -1 ֤
 */

int searchIdentId(SpdObjId ident_id, Define *def)
{
    int i;

    /* !! ñ㥵. Ϲ®ˤ뤳ȡ */
    for (i = 0; i < def->size; i++) {
        if (ident_id == def->elem[i].ident_id) {
            return (i);
        }
    }

    return (-1);
}

/*
 * ¤ΤΥѿҤϤ롥declr_idϥdeclarator.
 */

static void _putTargetStructMemberList(FILE *fp, SpdObjId declr_id,
                                       SpdString title)
{
    int i;
    char link_text[TEMP_MAX];
    char temp[TEMP_MAX];
    char js_text[TEMP_MAX];
    SpdObjId opt_id, member_ident_id;
    SpdRelArray struct_buf;
    int idx;

    opt_id = spdGetARelObj(declr_id, "decl_opt", "declarator_id");
    /* memberoffset˥ȤƼ*/
    struct_buf = spdGetRelSortedArray(opt_id, "struct_decl", 
                                      "optionaldecl_id", NULL,
                                      spdCompareRelOffset);

    for (i = 0; i < struct_buf.size; i++) {
        member_ident_id = 
            spdGetARelObj(spdGetARelObj(struct_buf.rel[i].objectId,
                                        "decl_decl", "declaration_id"),
                          "decl_ident", "declarator_id");

        /* ѿǤ뤫ǧ*/
        if (spdGetAttrValInt(member_ident_id, "sort") == ID_MEMBER){
            /*
             *### idx -1 ˤʤäƤޤ array bounds readȯ롥
             *### , -1ˤʤ뤳ȤϤäƤϤʤʤΤ...
             */
            if ((idx = searchIdentId(member_ident_id, &member_def)) == -1)
                continue;
      
            /* ѿϡ*/
            fprintf(fp, "&nbsp; - &nbsp; ");
            sprintf(temp, "%d-%s#s%d", member_def.elem[idx].label, SPEC_MEMBER_FILE,
                    member_def.elem[idx].ident_id);
            sprintf(link_text, "%s", spdGetName(member_def.elem[idx].ident_id));
            sprintf(js_text, "%s:%s Index", link_text, title);
            putListElem(fp, temp, RIGHTTOP, MEMBER_STYLE, link_text, NULL,
                        js_text);
        }
        /* ҤǤ뤫ǧ*/
        else if(spdGetAttrValInt(member_ident_id, "sort") == ID_ENUMERATOR){
            if ((idx = searchIdentId(member_ident_id, &enum_def)) == -1)
                continue;
      
            /* Ҥϡ*/
            fprintf(fp, "&nbsp; - &nbsp; ");
            sprintf(temp, "%d-%s#s%d", enum_def.elem[idx].label, SPEC_ENUM_FILE,
                    enum_def.elem[idx].ident_id);
            sprintf(link_text, "%s", spdGetName(enum_def.elem[idx].ident_id));
            sprintf(js_text, "%s:%s Index", link_text, title);
            putListElem(fp, temp, RIGHTTOP, ENUM_STYLE, link_text, NULL,
                        js_text);
        }
    }
    spdFreeRelArray(struct_buf);
}

/*
 * ӥ¤Τξ硤ѿΥꥹȤϤ롥
 */

static void _putStructList(FILE *fp, SpdObjId struct_id, SpdString title)
{
    SpdObjId declr_id, decln_id;
    SpdObjIdArray declr_buf;

    switch (spdGetAttrValInt(struct_id, "sort")) {
      case ID_TYPENAME:
        /* ¤ΤΥ롥*/
        declr_id = spdGetARelObj(struct_id, "decl_ident",
                                 "identifier_id");
        decln_id = spdGetARelObj(declr_id, "decl_decl", "declarator_id");
        declr_buf = spdGetRelObjArray(decln_id, "decl_decl", "declaration_id",
                                      spdDeclrIsDeclTag);
        /* ¤ΤηǤϤʤ̵뤹롥*/
        if (declr_buf.size == 0) return;
        /*  declarator 1ĤǤȲꡥ*/
        declr_id = declr_buf.id[0];
        spdFreeObjIdArray(declr_buf);
        _putTargetStructMemberList(fp, declr_id, title);
        break;
      case ID_TAG:
        /* Υ롥*/
        declr_id = spdGetARelObj(struct_id, "decl_ident", "identifier_id");
        _putTargetStructMemberList(fp, declr_id, title);
        break;
      default:
        break;
    }
}   

static void putListIndex(Define *define, FILE *fp)
{
    int     i;
    char    cur_init = '\0', tmp;

    fputs("<b>", fp);
    for (i = 0; i < define->size; i++) {
        tmp = *spdGetName(define->elem[i].ident_id);
        if (cur_init == '\0' || cur_init != tmp) {
            fprintf(fp, "[<a href=\"#%c\">%c</a>]", tmp, tmp);
            cur_init = tmp;
        }
    }
    fprintf(fp, "</b>%s\n", genTagStr("br", NULL, NULL));
}

/*--------------------------------------------------------------*/
/*  CGI ѤΥȽ                                    */
/*--------------------------------------------------------------*/

static void putCommentForSearch(FILE *fp)
{
    fprintf(fp, "<!-- Comment for search CGI (don't modify).\n");
    fprintf(fp, "search_elem=<a href=\"([^\"]*)\" target=\"([^\"]*)\"");
    if (flag_c) {
        fprintf(fp, " class=\"([^\"]*)\">");
    } else {
        fprintf(fp, "><font color=\"([^\"]*)\">");
    }
    fprintf(fp, "([^<]*)");
    if (!flag_c) {
        fprintf(fp, "<\\/font>");
    }
    fprintf(fp, "<\\/a>.*\n");
    if (flag_c) {
        fputs("use_css=yes\n", fp);
    } else {
        fputs("use_css=no\n", fp);
    }
    fprintf(fp, "-->\n");
}

/*--------------------------------------------------------------*/
/*  CGI ѤΥȽ (и)                           */
/*--------------------------------------------------------------*/

static void putCommentForSearchOcc(FILE *fp)
{
    fprintf(fp, "<!-- Comment for search CGI (don't modify).\n");
    fprintf(fp, "occ_elem=([^,]*), <a href=\"([^\"]*)\"");
    if (flag_c) {
        fprintf(fp, " class=\"([^\"]*)\">");
    } else {
        fprintf(fp, "><font color=\"([^\"]*)\">");
    }
    fprintf(fp, "(l.[^<]*)");
    if (!flag_c) {
        fprintf(fp, "<\\/font>");
    }
    fprintf(fp, "<\\/a>(.*)\n");
    fprintf(fp, "-->\n");
}

/*--------------------------------------------------------------*/
/* ɽեϤ                                     */
/*--------------------------------------------------------------*/

static void putListSub(Define *define, SpdString output_file, SpdString title, 
                       SpdString href_file, SpdCss style_no,
                       SpdString index_title)
{
    int i;
    FILE *fp;
    SpdString path, name;
    char temp_init, cur_init = '\0';
    char link_text[TEMP_MAX];
    char temp[TEMP_MAX];
    char js_text[TEMP_MAX];
    int label = 0;                          /* ơ֥եΤΥ٥롥 */

    path = spdCatPath(directory, output_file);
    fp = spieFileOpen(path);

    beginHtml(fp, index_title);
    bodyHtml(fp, title, NULL);
    putCommentForSearch(fp);

    if (flag_i)
        putListIndex(define, fp);

    for (i = 0; i < define->size; ++i) {
        if ((i % TABLE_SIZE) == 0) ++label;
        define->elem[i].label = label;
        name = spdGetName(define->elem[i].ident_id);

        temp_init = *name;
        if (flag_i && (cur_init == '\0' || cur_init != temp_init)) {
            fprintf(fp, "<b><a name=\"%c\">%c</a></b><br>\n", temp_init, temp_init);
            cur_init = temp_init;
        }
            
        /* ǤϤ */
        sprintf(temp, "%d-%s#s%d", define->elem[i].label, href_file, 
                define->elem[i].ident_id);
        sprintf(link_text, "%s", name);
        sprintf(js_text, "%s:%s Index", link_text, title);

        if (define->elem[i].is_static) {
            putListElem(fp, temp, RIGHTTOP, style_no, link_text, "(static)",
                        js_text);
        } else {
            putListElem(fp, temp, RIGHTTOP, style_no, link_text, NULL,
                        js_text);
        }

        if (SPD_STREQ(title, TYPEDEF_TITLE) || 
            SPD_STREQ(title, TAG_TITLE)) {
            /* ξν*/
            _putStructList(fp, define->elem[i].ident_id, title);
        }
    }

    endHtml(fp);
    spdFclose(fp);
    spdFree(path);
}   

#ifndef BUGGY_SDBLINK4_0107

/*--------------------------------------------------------------*/
/* ΰɽؿ. ο֤.                  */
/*--------------------------------------------------------------*/

static int putConstList(void)
{
    int i;
    FILE *fp;
    SpdString path;
    char temp[SPD_STRING_LEN + 1];
    char js_text[TEMP_MAX];
    int const_num = 0;
    int label = 0;                          /* ơ֥եΤΥ٥롥 */

    path = spdCatPath(directory, LIST_CONST_FILE);

    fp = spieFileOpen(path);

    beginHtml(fp, CONST_INDEX_TITLE);
    bodyHtml(fp, CONST_TITLE, NULL);
    putCommentForSearch(fp);

    for (i = 0; i < constant.size; ++i) {
        if (!isContainConst(constant.elem[i].value, i)) {
            if ((const_num % TABLE_SIZE) == 0) ++label;
            constant.elem[i].label = label;
            ++const_num;

            sprintf(temp, "%d-%s#s%d", constant.elem[i].label, SPEC_CONST_FILE, 
                    constant.elem[i].const_id);
            sprintf(js_text, "%s:%s Index", constant.elem[i].org_value,
                    CONST_TITLE);
            putListElem(fp, temp, RIGHTTOP, CONST_STYLE, 
                        constant.elem[i].value, NULL, js_text);
        }
    }

    endHtml(fp);

    spdFclose(fp);
    spdFree(path);
  
    return(const_num);
}

#endif /* not BUGGY_SDBLINK4_0107 */

/*--------------------------------------------------------------*/
/* եHTMLեؿ                     */
/*--------------------------------------------------------------*/

static void putFileList(SpdObjId *file_id, int file_num)
{
    FILE *fp;
    int i;
    SpdObjId cfileId;
    SpdString path;
    char temp[TEMP_MAX];
    SpdString file_name;
    char js_text[TEMP_MAX];

    path = spdCatPath(directory, LIST_FILE_FILE);
    fp = spieFileOpen(path);

    beginHtml(fp, FILE_INDEX_TITLE);
    bodyHtml(fp, FILE_TITLE, NULL);
    putCommentForSearch(fp);

    /* إåե̾Ϥ롥 */  
    for (i = 0; i < header.size; ++i) {
        sprintf(temp, "%d%s", header.elem[i].id, HTML_SUFFIX);
        sprintf(js_text, "%s:%s Index", header.elem[i].name, FILE_TITLE);
        putListElem(fp, temp, RIGHTTOP, FILE_STYLE, 
                    header.elem[i].name, NULL, js_text);   
    }

    /* *.c ե̾Ϥ롥   */
    for (i = 0; i < file_num; ++i) {
        cfileId = spdConvFileIdItoC(file_id[i]);
        file_name = spdGetName(cfileId);
        sprintf(temp, "%d%s", cfileId, HTML_SUFFIX);
        sprintf(js_text, "%s:File Index", file_name);
        putListElem(fp, temp, RIGHTTOP, FILE_STYLE, 
                    file_name, NULL, js_text);
    }
    
    endHtml(fp);

    spdFclose(fp);
    spdFree(path);
}

/*--------------------------------------------------------------*/
/* ɥȰHTMLեؿ               */
/*--------------------------------------------------------------*/

static void putDocList(void)
{
    FILE *fp;
    SpdString path;
    SpdCursor *docfile_csr;
    SpdObjId docfile_id;
    char link_text[TEMP_MAX];
    char temp[TEMP_MAX];
    char js_text[TEMP_MAX];
    int i;
    
    path = spdCatPath(directory, LIST_DOC_FILE);
    fp = spieFileOpen(path);
    
    beginHtml(fp, DOC_INDEX_TITLE);
    bodyHtml(fp, DOCUMENT_TITLE, NULL);

    docfile_csr = spdGetObjIdInit("docfile", NULL);
    while ((docfile_id = spdGetObjId(docfile_csr)) != SPD_NON_ID) {
        /* ե̾ */
        sprintf(temp, "%d%s", docfile_id, HTML_SUFFIX);
        sprintf(link_text, "%s", spdGetName(docfile_id));
        sprintf(js_text, "%s:%s Index", link_text, DOCUMENT_TITLE);

        putListElem(fp, temp, RIGHTTOP, DOC_STYLE, link_text, NULL, js_text);

        for (i = 0; i < doc_def.size; i++) {
            /* Υեˤ뼱̻ҤΤ߽ */
            if (doc_def.elem[i].docfile_id == docfile_id) {
                fprintf(fp, "&nbsp; - &nbsp; ");
                sprintf(temp, "%d%s#s%d", doc_def.elem[i].docfile_id, HTML_SUFFIX
                        , doc_def.elem[i].docfrag_id);
                sprintf(link_text, "%s", spdGetName(doc_def.elem[i].docident_id));
                sprintf(js_text, "%s:%s Index", link_text, DOCUMENT_TITLE);

                /* ̻Ҥμˤäƿʬ */
                switch(spdGetAttrValInt(doc_def.elem[i].docident_id, "sort")) {
                    case DID_FUNCTION:
                        putListElem(fp, temp, RIGHTTOP, FUNC_STYLE, link_text,
                                    NULL, js_text);
                        break;
                    case DID_TYPENAME:
                        putListElem(fp, temp, RIGHTTOP, TYPE_STYLE, link_text,
                                    NULL, js_text);
                        break;
                    case DID_TAG:
                        putListElem(fp, temp, RIGHTTOP, TAG_STYLE, link_text,
                                    NULL, js_text);
                        break;
                    case DID_MACRONAME:
                        putListElem(fp, temp, RIGHTTOP, MACRO_STYLE,
                                    link_text, NULL, js_text);
                        break;
                    case DID_FILE:
                        putListElem(fp, temp, RIGHTTOP, FILE_STYLE, link_text,
                                    NULL, js_text);
                        break;
                }
            }
        }
    }       
    spdFreeCursor(docfile_csr);
    endHtml(fp);
    spdFclose(fp);
    spdFree(path);
}

static void putTypedefTips(SpdObjId type_id)
{
    SpdObjId declr, decln;
    SpdString path, buf;
    SpdRegion region_c, region_i;
    SpdOcc occ;
    char temp[TEMP_MAX];
    FILE *fp;

    sprintf(temp, "%d-%s", type_id, TIPS_TYPEDEF_FILE);
    path = spdCatPath(tips_dir, temp);
    /* TipsѤtypedefHTML롥 */
    /* ե뤬¸ߤƤ硤񤭤롥 */
    /* ϥե뤬¸ߤƤ硤⤷ʤΤ⤷ʤ */
    fp = spieFileOpen(path);
    declr = spdGetARelObj(type_id, "decl_ident", "identifier_id");
    decln = spdGetARelObj(declr, "decl_decl", "declarator_id");
    occ = spdGetAnOffsetOfObj(decln);
    region_i.fileId = occ.fileId;
    region_i.offset = occ.offset;
    region_i.length = spdGetLength(occ.objectId);
    region_c = spdConvRegionItoC(region_i);
    if (region_c.fileId != SPD_NON_ID) {
        fprintf(fp, "<html>\n");
        bodyHtml(fp, "typedef information", NULL);
        fprintf(fp, "<pre>\n");
        buf = spdGetTextByRegion(region_c);
        fprintf(fp, "%s\n", buf);
        fprintf(fp, "</pre>\n");
        spdFree(buf);
        endHtml(fp);
    }
    spdFclose(fp);
    spdFree(path);
}

static SpdRegion getOuterExpr(SpdObjId expr)
{
    SpdObjId outer_expr;
    SpdRegion region_i, region_c;
    SpdOcc occ;

    while ((outer_expr = 
            spdGetARelObj(expr, "expr_expr", "inner_expression_id")) !=
           SPD_NON_ID) {
        expr = outer_expr;
    }
    occ = spdGetAnOffsetOfObj(expr);
    region_i = spdConvOccToRegion(occ);
    region_c = spdConvRegionItoC(region_i);
    return region_c;
}

static void putVariableUsedTips(VarTableElem elem)
{
    SpdCursor *expr_csr;
    SpdOcc occ;
    SpdRegion region_c, region_i;
    SpdObjId expr_id;
    SpdRegion expr_region;
    SpdString path;
    char temp[TEMP_MAX];
    char *expr;
    FILE *fp;

    expr_csr = spdGetRelObjInit(elem.var_id, "ident_ref", "identifier_id");
    while ((expr_id = spdGetRelObj(expr_csr)) != SPD_NON_ID) {
        if ((occ = spdGetAnOffsetOfObj(expr_id)).objectId != SPD_NON_ID) {
            region_i = spdConvOccToRegion(occ);
            region_c = spdConvRegionItoCbyPIDB(region_i);
            if (elem.offset == region_c.offset) {
                expr_region = getOuterExpr(occ.objectId);
                sprintf(temp, "%d-%s.html", region_c.offset,
                        spdGetName(elem.var_id));
                path = spdCatPath(tips_dir, temp);
                fp = spieFileOpen(path);
                beginHtml(fp, NULL);
                bodyHtml(fp, "used information", NULL);
                fprintf(fp, "In Function : %s\n", spdGetName(elem.func_id));
                fprintf(fp, "<pre>\n");
                expr = spdGetTextByRegion(expr_region);
                fprintf(fp, "%s\n", expr);
                spdFree(expr);
                fprintf(fp, "</pre>\n");
                endHtml(fp);
                spdFclose(fp);
                spdFree(path);
            }
        }
    }
    spdFreeCursor(expr_csr);
}

/*--------------------------------------------------------------*/
/* ͽμ̻̾Υ                                     */
/*--------------------------------------------------------------*/

static void putFuncSpecNameColumn(FILE *fp, DefElem elem)
{
    SpdObjId type_id;
    SpdString name;
    SpdString type;
    char temp[TEMP_MAX];
    char js_text[TEMP_MAX];

    type_id = spdGetARelObj(elem.ident_id, "ident_type", "identifier_id");
    name = spdGetName(elem.ident_id);

#ifdef BUGGY_MKSPEC3_0039   
    type = getTypeName0039(type_id, elem.ident_id);
#else
    type = getTypeName(type_id);
#endif

    fprintf(fp, "<td rowspan=\"3\" valign=\"top\">\n");

    /* Don't modify Style for search CGI */
    /* "<b>xxx</b>xxx<br /><!-- xxx -->\n" */
    fprintf(fp, "<b>%s</b>", NAME_TITLE);
    fprintf(fp, "%s", genTagStr("br", NULL, NULL));
    fprintf(fp, "<!-- %d -->\n", elem.ident_id);

    /* fprintf(fp, "<A NAME=\"%d\">%s</A>", elem.ident_id, name); */
    fprintf(fp, "%s", name);

    if (elem.is_static) {
        fprintf(fp, " : static %s", type);
    } else {
        fprintf(fp, " : %s", type);
    }
    fprintf(fp, "%s\n", genTagStr("br", NULL, NULL));

    sprintf(temp, "%d%s#s%d", elem.file_id, HTML_SUFFIX, elem.ident_id);
    sprintf(js_text, "%s:%s:%s:%s", TO_SOURCE, NAME_TITLE, name,
            FUNC_TABLE_TITLE);
    putElementA(fp, temp, NULL, FUNC_STYLE, TO_SOURCE, js_text, NULL);
    fprintf(fp, "</td>\n");
}

/*--------------------------------------------------------------*/
/* եΥ                                             */
/*--------------------------------------------------------------*/

static void putFuncSpecFileColumn(FILE *fp, DefElem elem)
{
    SpdString file_name;
    char temp[TEMP_MAX];
    SpdString name;
    char js_text[TEMP_MAX];

    /* ե̾Υ   */
    file_name = spdGetName(elem.file_id);
    fprintf(fp, "<td><b>%s</b></td>\n", FILE_TITLE); 

    fprintf(fp, "<td>");
    sprintf(temp, "%d%s", elem.file_id, HTML_SUFFIX);
    name = spdGetName(elem.ident_id);
    sprintf(js_text, "%s:%s:%s:%s", file_name, FILE_TITLE, name,
            FUNC_TABLE_TITLE);
    putElementA(fp, temp, NULL, FILE_STYLE, file_name, js_text, NULL);
    fprintf(fp, "</td>\n");
}

/*--------------------------------------------------------------*/
/* ؿͽΥեΥ                             */
/*--------------------------------------------------------------*/

static void putFuncSpecFileInfoColumn(FILE *fp, SpdObjId file_id)
{
    char file_name[FILENAME_MAX + 1];
    /* SpdString owner; */
    SpdString modify_time;
 
    sprintf(file_name, "%s/%s/%d", spdGetSDBdir(), SAPID_SRC_DIR, file_id);
    /* ԤΥ   */
    if (author == NULL) {
        author = get_owner(file_name);
    }
    /* owner = get_owner(file_name); */
    /* spdMessage("putFuncSpecFileInfoColumn(): Author: \"%s\".\n", author); */
    fprintf(fp, "<tr><td><b>%s</b></td><td>%s</td></tr>\n", AUTHOR_TITLE, 
            author);

    /* ǯΥࡥ*/
    modify_time = get_m_time(file_name);
    fprintf(fp, "<tr><td><b>%s</b></td><td>%s</td></tr>\n", 
            MODIFIED_DAY_TITLE, modify_time);
}

/*--------------------------------------------------------------*/
/* ؿͽΰΥ                                     */
/*--------------------------------------------------------------*/

static void putFuncSpecArgColumn(FILE *fp, SpdObjId func_id)
{
    ProtoTableElem *proto;
    SpdString arg_name;
    SpdString type;
    int i;

    fprintf(fp, "<td valign=\"top\"><b>%s</b>", ARGUMENT_TITLE);
    fprintf(fp, "%s", genTagStr("br", NULL, NULL));

    proto = lookUpProtoTable(func_id);

    for (i = 0; i < proto->args.size; ++i) {
        arg_name = spdGetName(proto->args.elem[i].ident_id);

        if (arg_name == NULL) {
            arg_name = "";
        }

#ifdef BUGGY_MKSPEC3_0039
        type = getTypeName0039(proto->args.elem[i].type_id,
                               proto->args.elem[i].ident_id);
#else
        type = getTypeName(proto->args.elem[i].type_id);
#endif

        fprintf(fp, "%s: %s", arg_name, type);
        fputs(genTagStr("br", NULL, NULL), fp);
        if (flag_C) {
            putOneLineComment(fp, proto->args.elem[i].ident_id);
        }
    }
    fprintf(fp, "</td>\n");
}

/*--------------------------------------------------------------*/
/* ؿͽѿΥ                                 */
/*--------------------------------------------------------------*/

static void putFuncSpecG_VarColumn(FILE *fp, DefElem elem)
{
    char buf_system[BUF_MAX];
    char temp[TEMP_MAX];
    SpdBoolean contain;
    SpdObjId type_id;
    SpdString type_str;
    int i;
    int j;
    int label = 0;
    char js_text[TEMP_MAX];
    SpdString name;

    buf_system[0] = '\0';
    fprintf(fp, "<td colspan=\"2\" valign=\"top\"><b>%s</b>", G_VAR_TITLE);
    fprintf(fp, "%s", genTagStr("br", NULL, NULL));

    name = spdGetName(elem.ident_id);
        
    for (i = 0; i  < var_table.size; ++i) {
        if (elem.ident_id == var_table.elem[i].func_id &&
            smuIsGlobalVariable(var_table.elem[i].var_id)) {

            /* ˽ɤȽꡥؿˤ٤ */
            contain = FALSE;
            for (j = 0; j < i; j++) {
                if (var_table.elem[j].func_id == elem.ident_id && 
                    var_table.elem[j].var_id == var_table.elem[i].var_id){
                    contain = TRUE;
                    break;
                }
            }

            if (!contain) {
                type_id = spdGetARelObj(var_table.elem[i].var_id, 
                                        "ident_type", "identifier_id"); 
#ifdef BUGGY_MKSPEC3_0039
                type_str = getTypeName0039(type_id, elem.ident_id);
#else
                type_str = getTypeName(type_id);
#endif
                if (is_system(var_table.elem[i].var_id)) {
                    sprintf(temp, "%s: %s", 
                            spdGetName(var_table.elem[i].var_id), type_str);

                    strcat(temp, genTagStr("br", NULL, NULL));
                    strcat(buf_system, temp);
                } else {
                    /* бѿΥ٥Ĵ٤. ϥåˤ٤?  */
                    for (j = 0; j < var_def.size; ++j) {
                        if (var_def.elem[j].ident_id == var_table.elem[i].var_id) {
                            label = var_def.elem[j].label;
                            break;
                        }
                    }
                    
                    sprintf(temp, "%d-%s#s%d", label, SPEC_VAR_FILE, 
                            var_table.elem[i].var_id);
                    sprintf(js_text, "%s:%s:%s:%s",
                            spdGetName(var_table.elem[i].var_id),
                            G_VAR_TITLE, name, FUNC_TABLE_TITLE);
                    putElementA(fp, temp, NULL, VAR_STYLE,
                                spdGetName(var_table.elem[i].var_id), 
                                js_text, NULL);
                    fprintf(fp, ": %s", type_str);
                    fputs(genTagStr("br", NULL, NULL), fp);
                    if (flag_C) {
                        putOneLineComment(fp, var_table.elem[i].var_id);
                    }
                }
            }
        }
    }
    fprintf(fp, "%s\n</td>\n", buf_system);  
}

/*--------------------------------------------------------------*/
/* ؿͽζɽѿΥ                                 */
/*--------------------------------------------------------------*/

static void putFuncSpecL_VarColumn(FILE *fp, DefElem elem)
{
    SpdObjId type_id;
    SpdBoolean contain;
    int i;
    int j;

    /* ɽѿΥ */
    fprintf(fp, "<td valign=\"top\"><b>%s</b>", L_VAR_TITLE);
    fprintf(fp, "%s", genTagStr("br", NULL, NULL));

    for (i = 0; i < var_table.size; ++i) {
        if (elem.ident_id == var_table.elem[i].func_id && 
            smuIsLocalVariable(var_table.elem[i].var_id)) {

            /* Ƚ */
            contain = FALSE;
            for (j = 0; j < i; ++j) {
                if (var_table.elem[j].func_id == elem.ident_id &&
                    var_table.elem[j].var_id == var_table.elem[i].var_id){
                    contain = TRUE;
                    break;
                }
            }

            if (!contain) {
                type_id = spdGetARelObj(var_table.elem[i].var_id, 
                                        "ident_type", "identifier_id");

#ifdef BUGGY_MKSPEC3_0039
                fprintf(fp, "%s: %s", spdGetName(var_table.elem[i].var_id), 
                        getTypeName0039(type_id, elem.ident_id));
#else
                fprintf(fp, "%s: %s", spdGetName(var_table.elem[i].var_id), 
                        getTypeName(type_id));
#endif
                fputs(genTagStr("br", NULL, NULL), fp);
                if (flag_C) {
                    putOneLineComment(fp, var_table.elem[i].var_id);
                }
            }
        }
    }
    fprintf(fp, "</td>\n");
}

/*--------------------------------------------------------------*/
/*  ؿͽΥޥΥ                                  */
/*--------------------------------------------------------------*/

static void putFuncSpecMacroColumn(FILE *fp, SpdObjId func_id)
{ 
    SpdBoolean contain;
    SpdString macro_name;
    SpdString macro_args;
    char buf_macro[BUF_MAX];
    char temp[TEMP_MAX];
    int i;
    int j;
    SpdString name;
    char js_text[TEMP_MAX];

    fprintf(fp, "<td colspan=\"2\" valign=\"top\"><b>%s</b>",
            MACRO_TITLE);
    fprintf(fp, "%s", genTagStr("br", NULL, NULL));

    name = spdGetName(func_id);

    buf_macro[0] = '\0';
    for (i = 0; i < macro_call.size; ++i) {
        if (macro_call.elem[i].func_id ==  func_id) {
            contain = FALSE;
            for (j = 0; j < i; ++j) {
                if (macro_call.elem[j].func_id == macro_call.elem[i].func_id &&
                    macro_call.elem[j].name_id == macro_call.elem[i].name_id) {
                    contain = TRUE;
                    break;
                }
            }
   
            if (!contain) {
                macro_name = spdGetName(macro_call.elem[i].name_id);
                macro_args = spdGetMacroArgs(macro_call.elem[i].name_id);

                if (!is_system_macro(macro_call.elem[i].name_id)) {
                    for (j = 0; j < macro_def.size; j++) {
                        if (macro_call.elem[i].name_id ==
                            macro_def.elem[j].ident_id) break;
                    }
                    sprintf(temp, "%d-%s#s%d",
                            macro_def.elem[j].label, SPEC_MACRO_FILE, 
                            macro_call.elem[i].name_id);
                    sprintf(js_text, "%s:%s:%s:%s", macro_name, MACRO_TITLE,
                            name, FUNC_TABLE_TITLE);
                    putElementA(fp, temp, NULL, MACRO_STYLE,
                                macro_name, js_text, NULL);
                    fprintf(fp, "%s%s\n", macro_args, genTagStr("br", NULL, NULL));
                    if (flag_C) {
                        putOneLineCommentForMacro(fp, macro_call.elem[i].name_id);
                    }
                } else {
                    sprintf(temp, "%s%s", macro_name, macro_args);
                    strcat(buf_macro, temp);
                }
            }
        }
    }
    fprintf(fp, "%s", buf_macro);
    fprintf(fp, "</td>\n");
}

/*--------------------------------------------------------------*/
/*  ؿͽθƽдؿΥ                                */
/*--------------------------------------------------------------*/

static void putFuncSpecCallColumn(FILE *fp, SpdObjId func_id)
{
    SpdBoolean contain;
    int i, j, line, column;
    char buf_system[BUF_MAX];
    char temp[TEMP_MAX], temp2[TEMP_MAX];
    ProtoTableElem *proto;
    SpdString name, call_file;
    char js_text[TEMP_MAX];

    /* ƤӤؿΥ */
    fprintf(fp, "<td colspan=\"3\" valign=\"top\">\n<b>%s</b>", 
            CALL_TITLE);
    fprintf(fp, "%s\n", genTagStr("br", NULL, NULL));

    name = spdGetName(func_id);

    /* ƥؿǼν */
    buf_system[0] = '\0';
    for (i = 0; i < callee.size; ++i) {
        /* ؿIDפƤ뤫ǧ */
        if (func_id != callee.elem[i].func_id) continue;
    
        /* ˽Ϥɤγǧ */
        contain = FALSE;
        for (j = 0; j < i; ++j) {
            if (callee.elem[j].func_id == func_id &&
                callee.elem[j].callee_id == callee.elem[i].callee_id){
                contain = TRUE;
                break;
            }
        }
        /* ˽ϤƤ롼פ³ */
        if (contain) continue;

        proto = lookUpProtoTable(callee.elem[i].callee_id);
        
        if (proto->system) {
            /* ƥؿǤХХåե˳Ǽ */
            sprintf(temp, "%s%s: %s", proto->name, 
                    proto->proto, proto->type);

            strcat(temp, genTagStr("br",NULL,NULL));
            strcat(buf_system, temp);
        } else {
            /*
             * ƤӽФؿɤΥեˤ뤫Τ뤿
             * func_defĴ٤
             */
            for (j = 0; j < func_def.size; ++j) {
                if (func_def.elem[j].ident_id == callee.elem[i].callee_id) {
                    break;
                }
            }

            /* jؿοۤƤ롼פ³ */
            if (j >= func_def.size) continue;

            /* Convert offset into line and column. */
            if (getLineColumn(func_def.elem[j].file_id,
                              func_def.elem[j].offset, &line, &column) == -1) {
                continue;
            }

            /* Don't modify Style for search CGI. */
            /* xxx, <a href="xxx">xxx</a>\n */
            fprintf(fp, "%s, ", spdGetName(func_def.elem[j].file_id));
            sprintf(temp, "%d%s#s%d", func_def.elem[j].file_id, HTML_SUFFIX,
                    func_def.elem[j].ident_id);
            sprintf(temp2, "l.%d", line);
            sprintf(js_text, "%s:%s:%s:%s", TO_SOURCE, CALL_TITLE, name,
                    FUNC_TABLE_TITLE);
            putElementA(fp, temp, NULL, FUNC_STYLE, temp2, js_text, NULL);

            fputs("\n, ", fp);

            /* ɬפʤ (search CGI Ѥ뤿ˡʰײ)
             *   addBlankString(fp);
             */

            sprintf(temp, "%d-%s#s%d", func_def.elem[j].label, SPEC_FUNC_FILE,
                    func_def.elem[j].ident_id);
            sprintf(js_text, "%s:%s:%s:%s", TO_SPEC, CALL_TITLE, name,
                    FUNC_TABLE_TITLE);
            putElementA(fp, temp, NULL, FUNC_STYLE,
                        spdGetName(func_def.elem[j].ident_id), js_text, NULL);
            fprintf(fp, "\n: %s%s: %s", proto->name, proto->proto,
                    proto->type);
            fprintf(fp, "%s\n", genTagStr("br", NULL, NULL));
            if (flag_C) {
                putOneLineComment(fp, callee.elem[i].callee_id);
            }
        }
    }
    /* ƥؿϤ롥 */
    fprintf(fp, "%s", buf_system);
    fprintf(fp, "</td>\n");
}

/*--------------------------------------------------------------*/
/* ؿͽθƽиؿΥ                               */
/*--------------------------------------------------------------*/

static void putFuncSpecCalledColumn(FILE *fp, SpdObjId func_id)
{
    SpdBoolean contain;
    int i, j, line, column;
    char buf_system[BUF_MAX];
    char temp[TEMP_MAX], temp2[TEMP_MAX];
    ProtoTableElem *proto;
    SpdString name;
    char js_text[TEMP_MAX];

    /* ƤӤؿΥ   */
    fprintf(fp, "<td colspan=\"3\" valign=\"top\">\n<b>%s</b>", CALLED_TITLE);
    fprintf(fp, "%s\n", genTagStr("br", NULL, NULL));

    name = spdGetName(func_id);
    buf_system[0] = '\0';

    for (i = 0; i < caller.size; ++i) {
        if (func_id != caller.elem[i].func_id) continue;

        contain = FALSE;
        for (j = 0; j < i; ++j) {
            if (caller.elem[j].func_id == func_id &&
                caller.elem[j].caller_id == caller.elem[i].caller_id){
                contain = TRUE;
                break;
            }
        }

        if (contain) continue;

        proto = lookUpProtoTable(caller.elem[i].caller_id);
        
        if (proto->system) {
            sprintf(temp, "%s%s: %s",proto->name, 
                    proto->proto, proto->type);
            strcat(temp, genTagStr("br", NULL, NULL));
            strcat(buf_system, temp);
        } else {
            for (j = 0; j < func_def.size; ++j) {
                if (func_def.elem[j].ident_id == caller.elem[i].caller_id) {
                    break;
                }
            }
          
            if (j >= func_def.size) continue;

            /* Convert offset into line and column. */
            if (getLineColumn(func_def.elem[j].file_id,
                              func_def.elem[j].offset, &line, &column) == -1) {
                continue;
            }

            /* Don't modify Style for search CGI. */
            /* xxx, <a href="xxx">xxx</a>\n */
            fprintf(fp, "%s, ", spdGetName(func_def.elem[j].file_id));
            sprintf(temp, "%d%s#s%d", func_def.elem[j].file_id, HTML_SUFFIX,
                    func_def.elem[j].ident_id);
            sprintf(temp2, "l.%d", line);
            sprintf(js_text, "%s:%s:%s:%s", TO_SOURCE, CALLED_TITLE, name,
                    FUNC_TABLE_TITLE);
            putElementA(fp, temp, NULL, FUNC_STYLE, temp2, js_text, NULL);

            /* ɬפʤ (search CGI Ѥ뤿ˡʰײ)
             * addBlankString(fp);
             */
            fputs("\n, ", fp);

            sprintf(temp, "%d-%s#s%d", func_def.elem[j].label, SPEC_FUNC_FILE,
                    func_def.elem[j].ident_id);
            sprintf(js_text, "%s:%s:%s:%s", TO_SPEC, CALLED_TITLE, name,
                    FUNC_TABLE_TITLE);
            putElementA(fp, temp, NULL, FUNC_STYLE,
                        spdGetName(func_def.elem[j].ident_id), js_text, NULL);

            fprintf(fp, "\n: %s%s: %s", proto->name, proto->proto,
                    proto->type);
            fprintf(fp, "%s\n", genTagStr("br", NULL, NULL));
            if (flag_C) {
                putOneLineComment(fp, caller.elem[i].caller_id);
            }
        }
    }
    /* ƥؿ */
    fprintf(fp, "%s", buf_system);
    fprintf(fp, "</td>\n");
}

/*--------------------------------------------------------------*/
/* ؿͽ񤫤ɥȤؤΥ󥯤                             */
/*--------------------------------------------------------------*/

static void putFuncSpecDocumentColumn(FILE *fp, SpdObjId docfrag_id)
{
    SpdObjId docfile_id;
    SpdString docfile_name;
    char temp[TEMP_MAX];
    
    fprintf(fp, "<td colspan=\"3\" valign=\"top\"><b>%s</b>", 
            DOCUMENT_TITLE);
    fprintf(fp, "%s", genTagStr("br", NULL, NULL));

    docfile_id = spdGetDocfileId(docfrag_id);

    if (docfile_id != SPD_NON_ID) {
        docfile_name = spdStrdup(spdGetName(docfile_id));
        sprintf(temp, "%d%s#s%d", docfile_id, HTML_SUFFIX, docfrag_id);
        putElementA(fp, temp, NULL, DOC_STYLE, docfile_name, NULL, NULL);
    }
    fprintf(fp, "</td>\n");
}


/*--------------------------------------------------------------*/
/* ؿͽ                                         */
/*--------------------------------------------------------------*/

static void putFuncSpec(void)
{
    FILE *fp;
    SpdString path;
    int i;
    int table_num = 0;                      /* եδؿο */
    char temp[TEMP_MAX];

    for (i = 0; i < func_def.size; ++i) {
        if ((i % TABLE_SIZE) == 0) {
            /* ե򿷵˳ */
            sprintf(temp, "%d-%s", func_def.elem[i].label, SPEC_FUNC_FILE);
            path = spdCatPath(directory, temp);
            fp = spieFileOpen(path);
            beginHtml(fp, FUNC_TABLE_TITLE);
            bodyHtml(fp, FUNC_TITLE, FUNC_TITLE);
            putCommentForSearchOcc(fp);
        }
        ++table_num;

        fprintf(fp, "<a name=\"s%d\"></a>\n", func_def.elem[i].ident_id);
        fprintf(fp, TABLE_ELEMENT);

        fprintf(fp, "<tr>\n");
        putFuncSpecNameColumn(fp, func_def.elem[i]);
        putFuncSpecFileColumn(fp, func_def.elem[i]);
        fprintf(fp, "</tr>\n");

        putFuncSpecFileInfoColumn(fp, func_def.elem[i].file_id);
    
        fprintf(fp, "<tr>\n");
        putFuncSpecArgColumn(fp, func_def.elem[i].ident_id);
        putFuncSpecG_VarColumn(fp, func_def.elem[i]);
        fprintf(fp, "</tr>\n");  

        fprintf(fp, "<tr>\n");
        putFuncSpecL_VarColumn(fp, func_def.elem[i]);
        putFuncSpecMacroColumn(fp, func_def.elem[i].ident_id);
        fprintf(fp, "</tr>\n");

        fprintf(fp, "<tr>\n");
        putFuncSpecCallColumn(fp, func_def.elem[i].ident_id);
        fprintf(fp, "</tr>\n");

        fprintf(fp, "<tr>\n");
        putFuncSpecCalledColumn(fp, func_def.elem[i].ident_id);
        fprintf(fp, "</tr>\n");

        if (flag_x) {
            fprintf(fp, "<tr>\n");
            putFuncSpecDocumentColumn(fp, func_def.elem[i].docfrag_id);
            fprintf(fp, "</tr>\n");
        }
        
        if (flag_C) {
            fprintf(fp, "<tr>\n");
            putSpecComment(fp, func_def.elem[i].ident_id);
            fprintf(fp, "</tr>\n");
        }

        fprintf(fp, "</table>\n");
        fprintf(fp, "%s", genTagStr("hr", NULL, NULL));

        /* եǿTABLE_SIZEˤʤäեclose롥 */
        if ((table_num % TABLE_SIZE) == 0) {
            addNewLine(fp);
            endHtml(fp);
            spdFclose(fp);
            spdFree(path);
        }
    }

    /* 
     * "index.html"ǽ˳ڡʤΤǡؿ1Ĥʤ
     * Υեɬפ롥
     */
    if (!func_def.size) {
        sprintf(temp, "%d-%s", 1, SPEC_FUNC_FILE);
        path = spdCatPath(directory, temp);
        fp = spieFileOpen(path);

        beginHtml(fp, FUNC_TABLE_TITLE);
        bodyHtml(fp, FUNC_TITLE, FUNC_TITLE);
        ++table_num;
    }

    /* ޤե뤬closeƤʤϡclose롥 */
    if ((table_num % TABLE_SIZE) != 0) {
        addNewLine(fp);
        endHtml(fp);
        spdFclose(fp);
        spdFree(path);
    }
}

/******************************************************************************/

static SpdObjId getTypeId(SpdObjId type_id)
{
    SpdObjId type, temp;

    type = spdGetARelObj(type_id, "type_st", "type_pointer_id");
    while (TRUE) {
        temp = type;
        type = spdGetARelObj(temp, "type_st", "type_pointer_id");
        if (type == SPD_NON_ID) {
            temp = spdGetARelObj(temp, "type_is", "type_id");
            return(temp);
        }
    }
}

#ifdef OBSOLETE

/* ƥեƤ뤫ݤ */

static SpdBoolean isInHeaderDefType(SpdObjId type_ident)
{
    SpdCursor   *offset_csr;
    SpdOcc      type_occ;
    int         length;
    SpdRegion   region_i, region_c;

    offset_csr = spdGetOffsetOfObjInit(type_ident);
    type_occ = spdGetOffsetOfObj(offset_csr);
    length = spdGetLength(type_ident);
    region_i.fileId = type_occ.fileId;
    region_i.offset = type_occ.offset;
    region_i.length = length;
    region_c = spdConvRegionItoCbyPIDB(region_i);
    return (is_system_file(region_c.fileId));
}

#endif /* OBSOLETE */

/*--------------------------------------------------------------*/
/* ѿ, ɽѿ, ѿ, ξơ֥ */
/*--------------------------------------------------------------*/

static void putIdentSpecDefine(FILE *fp, DefElem elem, SpdCss style_no,
                               SpdString title)
{
    SpdString ident_name;
    SpdString type_name;
    SpdObjId type_id, type_sort, type_is;
    char temp[TEMP_MAX];
    SpdString file_name;
    char js_text[TEMP_MAX];
    char tips_temp[TEMP_MAX] = "\0";
    int idx;

    ident_name = spdGetName(elem.ident_id);
    type_id = spdGetARelObj(elem.ident_id, "ident_type", 
                            "identifier_id");
    if(type_id == SPD_NON_ID) {
        type_id = spdGetARelObj(elem.ident_id, "type_is", "identifier_id");
        type_is = elem.ident_id;
    } else {
        type_is = spdGetARelObj(type_id, "type_is", "type_id");
        if (type_is == SPD_NON_ID) {
            type_is = getTypeId(type_id);
        }
    }
    type_sort = spdGetAttrValInt(type_is, "sort");
    type_name = getTypeName0039(type_id, elem.ident_id);

    /* ̾Υ */
    /* Don't modify Style for search CGI */
    /* "<b>xxx</b>xxx<br /><!-- xxx -->\n" */
    fprintf(fp, "<td>\n<b>%s</b>", NAME_TITLE);
    fprintf(fp, "%s", genTagStr("br", NULL, NULL));
    fprintf(fp, "<!-- %d -->\n%s</td>\n", elem.ident_id, ident_name);

    /* Υ */
    fprintf(fp, "<td><b>%s</b>", TYPE_TITLE);
    fprintf(fp, "%s\n", genTagStr("br", NULL, NULL));

    if (elem.is_static)
        fprintf(fp, "static ");
    if ((type_sort == ID_TYPENAME) && !is_system(type_is) && 
        ((idx = searchIdentId(type_is, &type_def)) != -1)) {
        if (flag_T) {
            putTypedefTips(type_is);
            sprintf(tips_temp, "%d-%s", type_is, TIPS_TYPEDEF_FILE);
        }
        sprintf(temp, "%d-spec-type.html#s%d",
                type_def.elem[idx].label, type_is);
        sprintf(js_text, "%s:%s", type_name, title);
        putElementA(fp, temp, NULL, TYPE_STYLE, type_name, js_text, tips_temp);
    } else {
        fprintf(fp, "%s", type_name);
    }
    fprintf(fp, "</td>\n");

    /* եΥ */

    file_name = spdGetName(elem.file_id);
    fprintf(fp, "<td><b>%s</b>", FILE_TITLE);
    fprintf(fp, genTagStr("br", NULL, NULL));

    sprintf(temp, "%d%s", elem.file_id, HTML_SUFFIX);
    sprintf(js_text, "%s:%s:%s:%s", file_name, FILE_TITLE, ident_name, title);
    putElementA(fp, temp, NULL, FILE_STYLE, file_name, js_text, NULL);

    addBlankString(fp);

    sprintf(temp, "%d%s#s%d_%d", elem.file_id, HTML_SUFFIX, elem.ident_id,
            elem.offset);
    sprintf(js_text, "%s:%s:%s", TO_DECL, ident_name, title);
    putElementA(fp, temp, NULL, style_no, TO_DECL, js_text, NULL);
    fprintf(fp, "</td>\n");
}

/*--------------------------------------------------------------*/
/* ѿơ֥뤪ӶɽѿλѾΥ         */
/*--------------------------------------------------------------*/

static void putVariableSpecUsed(FILE *fp, DefElem elem, SpdString title)
{
    int i, line, column;
    SpdString call_file, lr_type, func_name;
    char temp[SPD_STRING_LEN + 1];
    char temp2[SPD_STRING_LEN + 1];
    SpdString name;
    char js_text[TEMP_MAX];
    char tips_temp[TEMP_MAX] = "\0";
    SpdBoolean local;

    int num = 0;

    for (i = 0; i < var_table.size; ++i) {
        if (var_table.elem[i].var_id == elem.ident_id)  num++;
    }
    
    /* Don't modify for search CGI */
    /* <b>USED_TITLE</b> (USED_NUM)<br />\n */
    fprintf(fp, "<td colspan=\"3\">\n<b>%s</b> (%d)", USED_TITLE, num);
    fprintf(fp, "%s\n", genTagStr("br", NULL, NULL));

    name = spdGetName(elem.ident_id);

    local = smuIsLocalVariable(elem.ident_id);

    for (i = 0; i < var_table.size; ++i) {
        if ((var_table.elem[i].var_id == elem.ident_id) && 
            (var_table.elem[i].offset != elem.offset)) {
            call_file = spdGetName(var_table.elem[i].file_id);

            /* Convert offset into line and column. */
            if (getLineColumn(var_table.elem[i].file_id,
                              var_table.elem[i].offset, &line, &column) == -1) {
                continue;
            }

            if (flag_T) {
                putVariableUsedTips(var_table.elem[i]);
                sprintf(tips_temp, "%d-%s.html", var_table.elem[i].offset,
                        spdGetName(var_table.elem[i].var_id));
            }

            /* Don't modify Style for search CGI. */
            /* xxx, <a href="xxx">xxx</a> (L or R)\n */
            fprintf(fp, "%s, ", call_file);
            sprintf(temp, "%d%s#s%d_%d", var_table.elem[i].file_id,
                    HTML_SUFFIX, var_table.elem[i].var_id,
                    var_table.elem[i].offset);
            sprintf(temp2, "l.%d", line);
            sprintf(js_text, "%s:%s:%s:%s:%s", call_file, temp2, USED_TITLE,
                    name, title);
            putElementA(fp, temp, NULL, VAR_STYLE, temp2, js_text, tips_temp);
            lr_type = spdGetLrtypeString(var_table.elem[i].lr_type);
            fprintf(fp, " (%s)\n", lr_type);

            func_name = spdGetName(var_table.elem[i].func_id);
            if (func_name) {
                sprintf(temp, "%d-%s#s%d",
                        getLabelId(var_table.elem[i].func_id, &func_def),
                        SPEC_FUNC_FILE, var_table.elem[i].func_id);
                putElementA(fp, temp, NULL, FUNC_STYLE, func_name, NULL, NULL);
                fputs(", ", fp);
            }
            fprintf(fp, "%s\n", genTagStr("br", NULL, NULL));
        }
    }
    fprintf(fp, "</td>\n");
}

/*--------------------------------------------------------------*/
/* ѿơ֥롥                             */
/*--------------------------------------------------------------*/

static void putVariableSpec(void)
{
    SpdString path;
    FILE *fp;
    int i;
    char temp[TEMP_MAX];
    int table_num = 0;

    for (i = 0; i < var_def.size; i++) {
        if ((i % TABLE_SIZE) == 0) {
            sprintf(temp, "%d-%s", var_def.elem[i].label, SPEC_VAR_FILE);
            path = spdCatPath(directory, temp);
            fp = spieFileOpen(path);
            beginHtml(fp, G_VAR_TABLE_TITLE);
            bodyHtml(fp, G_VAR_TITLE, G_VAR_TITLE);
            putCommentForSearchOcc(fp);
       }
        ++table_num;
    
        fprintf(fp, "<a name=\"s%d\"></A>\n", var_def.elem[i].ident_id);
        fprintf(fp, TABLE_ELEMENT);

        fprintf(fp, "<tr>");
        putIdentSpecDefine(fp, var_def.elem[i], VAR_STYLE, G_VAR_TABLE_TITLE);
        fprintf(fp, "</tr>\n");

        fprintf(fp, "<tr>\n");
        putVariableSpecUsed(fp, var_def.elem[i], G_VAR_TABLE_TITLE);
        fprintf(fp, "</tr>\n");

        if (flag_C) {
            fprintf(fp, "<tr>\n");
            putSpecComment(fp, var_def.elem[i].ident_id);
            fprintf(fp, "</tr>\n");
        }
        fprintf(fp, "</table>\n");
        fprintf(fp, "%s", genTagStr("hr", NULL, NULL));

        if ((table_num % TABLE_SIZE) == 0) {
            addNewLine(fp);
            endHtml(fp);
            spdFclose(fp);
            spdFree(path);
        }
    }

    /* Ǹξơ֥եν */
    if ((table_num % TABLE_SIZE) != 0) {
        addNewLine(fp);
        endHtml(fp);
        spdFclose(fp);
        spdFree(path);
    }
}

/*--------------------------------------------------------------*/
/* ɽѿơ֥롥                             */
/*--------------------------------------------------------------*/

static void putL_VariableSpec(void)
{
    SpdString path;
    FILE *fp;
    int i;
    char temp[TEMP_MAX];
    int table_num = 0;

    for (i = 0; i < l_var_def.size; i++) {
        if ((i % TABLE_SIZE) == 0) {
            sprintf(temp, "%d-%s", l_var_def.elem[i].label, SPEC_L_VAR_FILE);
            path = spdCatPath(directory, temp);
            fp = spieFileOpen(path);
            beginHtml(fp, L_VAR_TABLE_TITLE);
            bodyHtml(fp, L_VAR_TITLE, L_VAR_TITLE);
            putCommentForSearchOcc(fp);
        }
        ++table_num;

        fprintf(fp, "<a name=\"s%d\"></a>\n", l_var_def.elem[i].ident_id);
        fprintf(fp, TABLE_ELEMENT);

        fprintf(fp, "<tr>");
        putIdentSpecDefine(fp, l_var_def.elem[i], L_VAR_STYLE,
                           L_VAR_TABLE_TITLE);
        fprintf(fp, "</tr>\n");

        fprintf(fp, "<tr>\n");
        putVariableSpecUsed(fp, l_var_def.elem[i], L_VAR_TABLE_TITLE);
        fprintf(fp, "</tr>\n");

        if (flag_C) {
            fprintf(fp, "<tr>\n");
            putSpecComment(fp, l_var_def.elem[i].ident_id);
            fprintf(fp, "</tr>\n");
        }

        fprintf(fp, "</table>\n");
        fprintf(fp, "%s", genTagStr("hr", NULL, NULL));

        if ((table_num % TABLE_SIZE) == 0) {
            addNewLine(fp);
            endHtml(fp);
            spdFclose(fp);
            spdFree(path);
        }
    }

    /* Ǹξơ֥եν */
    if ((table_num % TABLE_SIZE) != 0) {
        addNewLine(fp);
        endHtml(fp);
        spdFclose(fp);
        spdFree(path);
    }
}

/*--------------------------------------------------------------*/
/* ޥơ֥뤫ɥȤؤΥ󥯤       */
/*--------------------------------------------------------------*/

static void putMacroSpecDocumentColumn(FILE *fp, SpdObjId docfrag_id)
{
    SpdObjId docfile_id;
    SpdString docfile_name;
    char temp[TEMP_MAX];
    
    fprintf(fp, "<td>\n<b>%s</b>\n", DOCUMENT_TITLE);
    fprintf(fp, "%s", genTagStr("br", NULL, NULL));

    docfile_id = spdGetDocfileId(docfrag_id);

    if (docfile_id != SPD_NON_ID) {
        docfile_name = spdStrdup(spdGetName(docfile_id));
        sprintf(temp, "%d%s#s%d", docfile_id, HTML_SUFFIX, docfrag_id);
        putElementA(fp, temp, NULL, DOC_STYLE, docfile_name, NULL, NULL);
    }
    fprintf(fp, "</td>\n");
}

/*--------------------------------------------------------------*/
/* ޥơ֥롥                               */
/*--------------------------------------------------------------*/

/* !! ޥNAME, HREF°ͤ̾ˤʤäƤΤIDˤ */

static void putMacroSpec(void)
{
    char temp1[TEMP_MAX];
    SpdString path, func_name;
    FILE *fp;
    int i, j;
    int line, column;
    SpdString call_file, define_file, macro_name, macro_body, macro_args;
    int table_num = 0;
    char temp[TEMP_MAX];
    SpdObjId mpatt_id, body_id;
    char js_text[TEMP_MAX];

    for (i = 0; i < macro_def.size; ++i) {
        macro_name = spdGetName(macro_def.elem[i].ident_id);

        if ((table_num % TABLE_SIZE) == 0) {
            sprintf(temp, "%d-%s", macro_def.elem[i].label, SPEC_MACRO_FILE);
            path = spdCatPath(directory, temp);
            fp = spieFileOpen(path);
            beginHtml(fp, MACRO_TABLE_TITLE);
            bodyHtml(fp, MACRO_TITLE, MACRO_TITLE);
            putCommentForSearchOcc(fp);
        }
        ++table_num;

        fprintf(fp, "<a name=\"s%d\"></a>\n", macro_def.elem[i].ident_id);
        fprintf(fp, TABLE_ELEMENT);

        /* ޥ̾Υ */

        /* ޥΰ */
        macro_args = spdGetMacroArgs(macro_def.elem[i].ident_id);

        /* Don't modify Style for search CGI */
        /* "<b>xxx</b>xxx<br /><!-- xxx -->\n" */
        fprintf(fp, "<tr><td>\n<b>%s</b>", NAME_TITLE);
        fprintf(fp, "%s", genTagStr("br", NULL, NULL));
        fprintf(fp, "<!-- %d -->\n", macro_def.elem[i].ident_id);

        fprintf(fp, "%s%s\n</td></tr>\n", macro_name, macro_args);
        
        /* ޥܥǥΥ */
        fprintf(fp, "<tr><td><b>%s</b>", BODY_TITLE);
        fprintf(fp, "%s", genTagStr("br", NULL, NULL));

        /* macroBodyID */
        mpatt_id = spdGetARelObj(macro_def.elem[i].ident_id, "mpatt_mname",
                                 "macroName_id");
        body_id = spdGetARelObj(spdGetARelObj(mpatt_id, "def_mpatt", 
                                              "macroPattern_id"),
                                "def_mbody", "pblock_id");

        if (body_id == SPD_NON_ID) {
            fprintf(fp, "</td></tr>\n");
        } else {
            macro_body = spdStrdup(convTextToHtml(spdStr(body_id), CONV_HTML));
            fprintf(fp, "%s</td></tr>\n", macro_body);
            spdFree(macro_body);
        }

        /* եΥ */
        fprintf(fp, "<tr><td>\n<b>%s</b>", FILE_TITLE);
        fprintf(fp, genTagStr("br", NULL, NULL));

        /* Τʤޥ⤢ */
        /* -DXXX ʤɤˤ */
        if (macro_def.elem[i].file_id != SPD_NON_ID) {
            define_file = spdGetName(macro_def.elem[i].file_id);
            sprintf(temp, "%d%s", macro_def.elem[i].file_id, HTML_SUFFIX);
            sprintf(js_text, "%s:%s:%s:%s", define_file, FILE_TITLE,
                    macro_name, MACRO_TABLE_TITLE);
            putElementA(fp, temp, NULL, FILE_STYLE, define_file,
                        js_text, NULL);
            addBlankString(fp);

            sprintf(temp, "%d%s#s%d_%d", macro_def.elem[i].file_id,
                    HTML_SUFFIX, macro_def.elem[i].ident_id,
                    macro_def.elem[i].offset);
            sprintf(js_text, "%s:%s:%s", TO_DECL, macro_name,
                    MACRO_TABLE_TITLE);
            putElementA(fp, temp, NULL, MACRO_STYLE, TO_DECL, js_text, NULL);
        }
        fprintf(fp, "</td></tr>\n");
          
        /* ѾΥ */
        /* Don't modify for search CGI */
        /* <b>USED_TITLE</b><br />\n */
        fprintf(fp, "<tr><td>\n<b>%s</b>", USED_TITLE);
        fprintf(fp, "%s\n", genTagStr("br", NULL, NULL));
        for (j = 0; j < macro_call.size; j++) {
            if (macro_def.elem[i].ident_id != macro_call.elem[j].name_id) {
                continue;
            }
            call_file = spdGetName(macro_call.elem[j].call_file);
            
            /* Convert offset into line and column. */
            if (getLineColumn(macro_call.elem[j].call_file,
                              macro_call.elem[j].call_offset,
                              &line, &column) == -1) {
                continue;
            }

            /* Don't modify Style for search CGI. */
            /* xxx, <a href="xxx">xxx</a>\n */
            fprintf(fp, "%s, ", call_file);
            sprintf(temp1, "%d%s#s%d_%d", macro_call.elem[j].call_file,
                    HTML_SUFFIX, macro_call.elem[j].name_id,
                    macro_call.elem[j].call_offset);
            sprintf(temp, "l.%d", line);
            sprintf(js_text, "%s:%s:%s:%s:%s", call_file, temp, USED_TITLE,
                    macro_name, MACRO_TABLE_TITLE);
            putElementA(fp, temp1, NULL, MACRO_STYLE, temp, js_text, NULL);
            fputs("\n, ", fp);

            func_name = spdGetName(macro_call.elem[i].func_id);
            if (func_name != NULL) {
                sprintf(temp1, "%d-%s#s%d",
                        getLabelId(macro_call.elem[j].func_id, &func_def),
                        SPEC_FUNC_FILE, macro_call.elem[i].func_id);
                putElementA(fp, temp1, NULL, FUNC_STYLE, func_name, NULL,
                            NULL);
            }
            fprintf(fp, "%s\n", genTagStr("br", NULL, NULL));
            if (flag_C) {
                putOneLineCommentForMacro(fp, macro_call.elem[j].name_id);
            }
        }
        fprintf(fp, "</td></tr>\n");

        if (flag_x) {
            fprintf(fp, "<tr>\n");
            putMacroSpecDocumentColumn(fp, macro_def.elem[i].docfrag_id);
            fprintf(fp, "</tr>\n");
        }
        if (flag_C) {
            fprintf(fp, "<tr>\n");
            putSpecCommentForMacro(fp, macro_def.elem[i].ident_id);
            fprintf(fp, "</tr>\n");
        }
        fprintf(fp, "</table>\n");
        fprintf(fp, genTagStr("hr", NULL, NULL));

        if ((table_num % TABLE_SIZE) == 0) {
            addNewLine(fp);
            endHtml(fp);
            spdFclose(fp);
            spdFree(path);
        }
    }

    /* Ǹξơ֥եν */
    if ((table_num % TABLE_SIZE) != 0) {
        addNewLine(fp);
        endHtml(fp);
        spdFclose(fp);
        spdFree(path);
    }   
}

/*-------------------------------------------------------------------*/
/* ѿͽ񡤷ͽ񤫤ɥȤؤΥ󥯤    */
/*-------------------------------------------------------------------*/

static void putSpecDocumentColumn(FILE *fp, SpdObjId docfrag_id)
{
    SpdObjId docfile_id;
    SpdString docfile_name;
    char temp[TEMP_MAX];
    
    fprintf(fp, "<td colspan=\"3\" valign=\"top\"><b>%s</b>", 
            DOCUMENT_TITLE);
    fprintf(fp, "%s", genTagStr("br", NULL, NULL));

    docfile_id = spdGetDocfileId(docfrag_id);

    if (docfile_id != SPD_NON_ID) {
        docfile_name = spdStrdup(spdGetName(docfile_id));
        sprintf(temp, "%d%s#s%d", docfile_id, HTML_SUFFIX, docfrag_id);
        putElementA(fp, temp, NULL, DOC_STYLE, docfile_name, NULL, NULL);
    }
    fprintf(fp, "</td>\n");
}

/* ѿͽ񡤷ͽؿ*/

static void putSpec(SpdString file, SpdString title, Define def, Define occ,
                    SpdCss style_no, SpdString table_title)
{
    SpdString path, call_file, lr_type_str;
    FILE *fp;
    int i, j;
    int line, column;
    int table_num = 0;
    char temp[TEMP_MAX];
    char temp2[TEMP_MAX];
    SpdBoolean is_member = FALSE;
    SpdString name;
    char js_text[TEMP_MAX];

    /* Ǥ¸ߤʤϲ⤷ʤ */
    if (def.size == 0) {
        return;
    }

    /* κǽǤɽͤȤƥѿȽꤹ롥 */
    if (spdGetAttrValIntOfObj(def.elem[0].ident_id, "sort") == ID_MEMBER) {
        is_member = TRUE;
    }
    for (i = 0; i < def.size; ++i) {
        if ((i % TABLE_SIZE) == 0) {
            sprintf(temp, "%d-%s", def.elem[i].label, file);
            path = spdCatPath(directory, temp);
            fp = spieFileOpen(path);
            beginHtml(fp, table_title);
            bodyHtml(fp, title, title);
            putCommentForSearchOcc(fp);
        }
        ++table_num;

        fprintf(fp, "<a name=\"s%d\"></a>\n", def.elem[i].ident_id);
        fprintf(fp, TABLE_ELEMENT);

        fprintf(fp, "<tr>");
        putIdentSpecDefine(fp, def.elem[i], style_no, table_title);
        fprintf(fp, "</tr>\n");
        /* ѾΥ */
        fprintf(fp, "<tr>\n");
        /* Don't modify for search CGI */
        /* <b>USED_TITLE</b><br />\n */
        fprintf(fp, "<td colspan=\"3\">\n<b>%s</b>", USED_TITLE,
                occ.size + 1);
        fprintf(fp, "%s\n", genTagStr("br", NULL, NULL));

        name = spdGetName(def.elem[i].ident_id);

        for (j = 0; j < occ.size; j++) {
            if (occ.elem[j].ident_id != def.elem[i].ident_id) continue;
      
            call_file = spdGetName(occ.elem[j].file_id);

            /* Convert offset into line and column. */
            if (getLineColumn(occ.elem[j].file_id, occ.elem[j].offset,
                              &line, &column) == -1) {
                continue;
            }

            /* Don't modify Style for search CGI. */
            /* xxx, <a href="xxx">xxx</a> (L or R)\n */
            fprintf(fp, "%s, ", call_file);
            sprintf(temp, "%d%s#s%d_%d", occ.elem[j].file_id, HTML_SUFFIX, 
                    occ.elem[j].ident_id, occ.elem[j].offset);
            sprintf(temp2, "l.%d", line);
            sprintf(js_text, "%s:%s:%s:%s", temp2, USED_TITLE, name,
                    table_title);
            putElementA(fp, temp, NULL, style_no, temp2, js_text, NULL);

            /* ѿоݤξleft value, right valueȽԤ */
            if (is_member) {
                lr_type_str = spdGetLrtypeString(occ.elem[j].lr_type);
                fprintf(fp, " (%s)\n", lr_type_str);
            }/* ץҤϤ */
            fprintf(fp, "\n%s\n", genTagStr("br", NULL, NULL));
        }

        fprintf(fp, "</td></tr>\n");
        
        if (flag_x) {
            fprintf(fp, "<tr>\n");
            putSpecDocumentColumn(fp, def.elem[i].docfrag_id);
            fprintf(fp, "</tr>\n");
        }

        if (flag_C) {
            fprintf(fp, "<tr>\n");
            putSpecComment(fp, def.elem[i].ident_id);
            fprintf(fp, "</tr>\n");
        }
        
        fprintf(fp, "</table>\n");
        fprintf(fp, "%s", genTagStr("hr", NULL, NULL));
        
        if ((table_num % TABLE_SIZE) == 0) {
            addNewLine(fp);
            endHtml(fp);
            spdFclose(fp);
            spdFree(path);
        }
    }

    /* Ǹξơ֥եν */
    if ((table_num % TABLE_SIZE) != 0) {
        addNewLine(fp);
        endHtml(fp);
        spdFclose(fp);
        spdFree(path);
    }
}

#ifndef BUGGY_SDBLINK4_0107

/* λͽ   */

static void putConstSpec(void)
{
    char type_name[10];
    SpdString path, call_file;
    FILE *fp;
    int i, j;
    int line, column;
    int table_num = 0;
    char temp[TEMP_MAX];
    char temp2[TEMP_MAX];
    char js_text[TEMP_MAX];

    for (i = 0; i < constant.size; i++) {
        if (isContainConst(constant.elem[i].value, i)) {
            continue;
        }
    
        if ((table_num % TABLE_SIZE) == 0) {
            sprintf(temp, "%d-%s", constant.elem[i].label, SPEC_CONST_FILE);
            path = spdCatPath(directory, temp);
            fp = spieFileOpen(path);
            beginHtml(fp, CONST_TABLE_TITLE);
            bodyHtml(fp, CONST_TITLE, CONST_TITLE);
            putCommentForSearchOcc(fp);
        }
        ++table_num;

        switch (spdGetAttrValInt(constant.elem[i].const_id, "type")) {
          case CONST_INT:
            strcpy(type_name, "int");
            break;
          case CONST_FLOAT:
            strcpy(type_name, "float");
            break;
          case CONST_CHAR:
            strcpy(type_name, "char");
            break;
          case CONST_STRING:
            strcpy(type_name, "char *");
            break;
          default:
            type_name[0] = '\0';
        }

        fprintf(fp, "<a name=\"s%d\"></a>\n", constant.elem[i].const_id);
        fprintf(fp, TABLE_ELEMENT);

        fprintf(fp, "<tr><td>\n");

        /* Don't modify Style for search CGI */
        /* "<b>xxx</b>xxx<br /><!-- xxx -->\n" */
        fprintf(fp, "<b>%s</b>", NAME_TITLE);
        fprintf(fp, "%s", genTagStr("br", NULL, NULL));
        fprintf(fp, "<!-- %d -->\n", constant.elem[i].const_id);

        fprintf(fp, "%s</td>\n", constant.elem[i].value);
        fprintf(fp, "<td><b>%s</b>", TYPE_TITLE);
        fprintf(fp, "%s", genTagStr("br", NULL, NULL));
        fprintf(fp, "%s</td>\n", type_name);
        fprintf(fp, "</tr>\n");

        fprintf(fp, "<tr>\n");
        /* Ѿ */
        /* Don't modify for search CGI */
        /* <b>USED_TITLE</b><br />\n */
        fprintf(fp, "<td colspan=\"2\">\n<b>%s</b>", USED_TITLE);
        fprintf(fp, "%s\n", genTagStr("br", NULL, NULL));
        for (j = 0; j < constant.size; j++) {
            if (constant.elem[j].const_id != constant.elem[i].const_id) {
                continue;
            }
            call_file = spdGetName(constant.elem[j].file_id);
      
            /* Convert offset into line and column. */
            if (getLineColumn(constant.elem[j].file_id, constant.elem[j].offset,
                              &line, &column) == -1) {
                continue;
            }

            /* Don't modify Style for search CGI. */
            /* xxx, <a href="xxx">xxx</a>\n */
            fprintf(fp, "%s, ", call_file);
            sprintf(temp, "%d%s#s%d_%d", constant.elem[j].file_id, 
                    HTML_SUFFIX, constant.elem[j].const_id, 
                    constant.elem[j].offset);
            sprintf(temp2, "l.%d", line);
            sprintf(js_text, "%s:%s:%s:%s", temp2, USED_TITLE,
                    constant.elem[i].org_value, CONST_TABLE_TITLE);
            putElementA(fp, temp, NULL, CONST_STYLE, temp2, js_text, NULL);

            fprintf(fp, "\n%s\n", genTagStr("br", NULL, NULL));
        }
        fprintf(fp, "</td></tr>\n");
        if (flag_C) {
            fprintf(fp, "<tr>\n");
            putSpecComment(fp, constant.elem[i].const_id);
            fprintf(fp, "</tr>\n");
        }
        fprintf(fp, "</table>\n");
        fprintf(fp, "%s", genTagStr("hr", NULL, NULL));

        if ((table_num % TABLE_SIZE) == 0) {
            addNewLine(fp);
            endHtml(fp);
            spdFclose(fp);
            spdFree(path);
        }
    }

    /* Ǹξơ֥եν */
    if ((table_num % TABLE_SIZE) != 0) {
        addNewLine(fp);
        endHtml(fp);
        spdFclose(fp);
        spdFree(path);
    }   
}

#endif /* not BUGGY_SDBLINK4_0107 */

/* ƥȤϤ */

static void fprintfTextfrag(FILE *fp, SpdObjId textfrag_id)
{
    int i;
    SpdRelArray text_array;
    
    text_array = spdGetRelSortedArray(textfrag_id, "textfrag_textstring",
                                      "textfrag_id", NULL, spdCompareRelOffset);
    for (i = 0; i < text_array.size; i++) {
        fprintf(fp, "%s",convTextToHtml((SpdString)spdGetAttrValString(text_array.rel[i].objectId,"text"), CONV_HTML));
    }
    spdFreeRelArray(text_array);
}

/* ̻ҤϤ */

static void fprintfIdentelem(FILE *fp, SpdObjId identelem_id)
{
    char        temp[TEMP_MAX];
    SpdObjId    docident_id, defelem_id, docfile_id;
    int         sort;
    
    docident_id = spdGetARelObj(identelem_id,"identelem_docident",
                                "identelem_id");
    defelem_id = spdGetARelObj(docident_id, "defelem_docident", "docident_id");
    
    if(defelem_id == SPD_NON_ID) {
        fprintf(fp, "<b>%s</b>",spdGetName(docident_id));
    } else {
        docfile_id = spdGetDocfileId(defelem_id);
        sprintf(temp, "%d%s#s%d", docfile_id, HTML_SUFFIX, defelem_id);
        sort = spdGetAttrValInt(docident_id, "sort");
        switch (sort) {
          case DID_FUNCTION:
              putElementA(fp, temp, NULL, FUNC_STYLE,
                          spdGetName(docident_id), NULL, NULL);
              break;
          case DID_TYPENAME:
              putElementA(fp, temp, NULL, TYPE_STYLE,
                          spdGetName(docident_id), NULL, NULL);
              break;
          case DID_MACRONAME:
              putElementA(fp, temp, NULL, MACRO_STYLE,
                          spdGetName(docident_id), NULL, NULL);
              break;
          case DID_FILE:
              putElementA(fp, temp, NULL, FILE_STYLE,
                          spdGetName(docident_id), NULL, NULL);
              break;
          default:
              fprintf(fp, "<b>%s</b>,", spdGetName(docident_id));
              break;
        }
    }
}

/* ץҤϤ */

static void fprintfSrcelem(FILE *fp, SpdObjId srcelem_id)
{
    SpdOcc      occ;
    SpdRelArray rels;
    int         i, j;
    
    fprintf(fp, "<pre>");
    for (i = 0; i < doc_def.size; i++) {
        if (doc_def.elem[i].srcelem_id == srcelem_id) {
            rels = spdGetRelArray(doc_def.elem[i].docident_id,
                                  "docident_identifier", "docident_id", NULL);
            for (j = 0; j < rels.size; j++) {
                occ = spdGetAnOffsetOfObj(rels.rel[j].objectId);
                if (occ.fileId == SPD_NON_ID) {
                    int offset;
                    SpdRel rel;
                    rel = spdGetARel(rels.rel[j].objectId, "decl_ident", "c-id");
                    offset = spdGetOffset(rel.relationId);
                    if (offset == SPD_NON_OFFSET) {
                        rel = spdGetARel(rels.rel[j].objectId, "type_is", "c-id");
                        offset = spdGetOffset(rel.relationId);
                    }
                    
                    printf("name:%s\n",spdGetName(rels.rel[j].objectId));
                    printf("offset:%d\n",offset);
                }
            }
            fprintf(fp, "%s", doc_def.elem[i].str);
        }
    }
    fprintf(fp, "</pre>");
}

/* ޥΥץҤϤ */

static void fprintfMacroelem(FILE *fp, SpdObjId docfrag_id)
{
    SpdObjId textfrag_id;
    
    textfrag_id = spdGetARelObj(docfrag_id, "docelem_docfrag", "p-id");
    fprintf(fp, "<pre>\n");
    fprintfTextfrag(fp, textfrag_id);
    fprintf(fp, "</pre>\n");
}

/* docfrag ֥ȤϤ */

static void fprintfDocfrag(FILE *fp, SpdObjId docfrag_id)
{
    SpdRelArray frag_array;
    SpdString tag_name;
    int sort;
    int i;

    sort = spdGetAttrValInt(docfrag_id, "sort");

    if (sort & DOCFRAG_TEXTFRAG) {
        fprintfTextfrag(fp, docfrag_id);
    } else if (sort & DOCFRAG_IDENTELEM) {
        fprintfIdentelem(fp, docfrag_id);
    } else if (sort & DOCFRAG_SRCELEM) {
        fprintfSrcelem(fp, docfrag_id);
    } else if(sort & DOCFRAG_MACROELEM){
        fprintfMacroelem(fp, docfrag_id); 
    } else if (sort & DOCFRAG_DOCELEM) {
        if (sort & DOCFRAG_BASICELEM) {
            tag_name = spdGetName(docfrag_id);
            /* ߤΤȤƤΥ<...> </...>ηǽϤ롥 */
            fprintf(fp, "<%s>", tag_name);
        } else if (sort & DOCFRAG_DEFELEM) {
            fprintf(fp, "<br>\n");
            fprintf(fp ,"<a name=\"s%d\"></a>\n",docfrag_id);
        }
        frag_array = spdGetRelSortedArray(docfrag_id, "docelem_docfrag",
                                          "p-id", NULL, spdCompareRelOffset);
        for (i = 0; i < frag_array.size; i++){
            fprintfDocfrag(fp, frag_array.rel[i].objectId);
        }
        spdFreeRelArray(frag_array);

        if (sort & DOCFRAG_BASICELEM) {
            fprintf(fp, "</%s>\n", tag_name);
        } else if (sort & DOCFRAG_DEFELEM) {
            fprintf(fp, "<br>\n");
        }
    }
}

static void putDocumentSub(SpdObjId docfile_id)
{
    SpdString path;
    SpdObjId docfrag_id;
    SpdRelArray docfrag_array;
    FILE *fp;
    int i;
    
    path = spdMalloc(strlen(directory) + ID_LENGTH + strlen(HTML_SUFFIX) + 2);
    sprintf(path, "%s/%d%s", directory, docfile_id, HTML_SUFFIX);
    fp = spdFopen(path, SPD_FOPEN_WT_MODE);

    beginHtml(fp, NULL);
    bodyHtml(fp, NULL, NULL);

    /* ֳ¦Υ document  */
    docfrag_id = spdGetARelObj(docfile_id, "docfile_docfrag", "p-id");

    docfrag_array = spdGetRelSortedArray(docfrag_id, "docelem_docfrag",
                                         "docelem_id", NULL, spdCompareRelOffset);
    for (i = 0; i < docfrag_array.size; i++) {
        fprintfDocfrag(fp, docfrag_array.rel[i].objectId);
    }

    addNewLine(fp);
    endHtml(fp);

    spdFclose(fp);
    spdFree(path);
}

/* ɥȥեϤ */

static void putDocument(void)
{
    SpdCursor *docfile_csr;
    SpdObjId docfile_id;

    docfile_csr = spdGetObjIdInit("docfile", NULL);
    while((docfile_id = spdGetObjId(docfile_csr)) != SPD_NON_ID) {
        putDocumentSub(docfile_id);
    }
    spdFreeCursor(docfile_csr);
}

void putHtml(SpdObjId *file_id, int file_num)
{
    int const_num;                          /* ο */

    putFrame();
    putSearchHeader(SEARCH_HEADER);

    putFileList(file_id, file_num);
    putListSub(&func_def, LIST_FUNC_FILE, FUNC_TITLE, SPEC_FUNC_FILE, 
               FUNC_STYLE, FUNC_INDEX_TITLE);
    putListSub(&var_def, LIST_VAR_FILE, G_VAR_TITLE, SPEC_VAR_FILE,
               VAR_STYLE, G_VAR_INDEX_TITLE);
    if (flag_l) {
        putListSub(&l_var_def, LIST_L_VAR_FILE, L_VAR_TITLE, SPEC_L_VAR_FILE,
                   L_VAR_STYLE, L_VAR_INDEX_TITLE);
        putListSub(&arg_def, LIST_ARG_FILE, ARGUMENT_TITLE, SPEC_ARG_FILE,
                   ARG_STYLE, ARG_INDEX_TITLE);
    }
    putListSub(&member_def, LIST_MEMBER_FILE, MEMBER_TITLE, SPEC_MEMBER_FILE, 
               MEMBER_STYLE, MEMBER_INDEX_TITLE);
    putListSub(&enum_def, LIST_ENUM_FILE, ENUM_TITLE, SPEC_ENUM_FILE,
               ENUM_STYLE, ENUM_INDEX_TITLE);
    putListSub(&macro_def, LIST_MACRO_FILE, MACRO_TITLE, SPEC_MACRO_FILE, 
               MACRO_STYLE, MACRO_INDEX_TITLE);
    /* typetagΥꥹȤmemberǺ*/
    putListSub(&type_def, LIST_TYPE_FILE, TYPEDEF_TITLE, SPEC_TYPE_FILE, 
               TYPE_STYLE, TYPEDEF_INDEX_TITLE);
    putListSub(&tag_def, LIST_TAG_FILE, TAG_TITLE, SPEC_TAG_FILE, 
               TAG_STYLE, TAG_INDEX_TITLE);

    if (flag_x) {
        putDocList();
    }
        
    /* putListSubMember(); */
#ifndef BUGGY_SDBLINK4_0107    
    const_num = putConstList();
#endif

    putFuncSpec();
    putVariableSpec();
    if (flag_l) {
        putL_VariableSpec();
    }
    putMacroSpec();
    if (flag_l) {
        putSpec(SPEC_ARG_FILE, ARGUMENT_TITLE, arg_def, arg_occ,
                ARG_STYLE, ARG_TABLE_TITLE);
    }
    putSpec(SPEC_MEMBER_FILE, MEMBER_TITLE, member_def, member_occ,
            MEMBER_STYLE, MEMBER_TABLE_TITLE);
    putSpec(SPEC_ENUM_FILE, ENUM_TITLE, enum_def, enum_occ,
            ENUM_STYLE, ENUM_TABLE_TITLE);
    putSpec(SPEC_TYPE_FILE, TYPE_TITLE, type_def, type_occ,
            TYPE_STYLE, TYPE_TABLE_TITLE);
    putSpec(SPEC_TAG_FILE, TAG_TITLE, tag_def, tag_occ,
            TAG_STYLE, TAG_TABLE_TITLE);

#ifndef BUGGY_SDBLINK4_0107
    putConstSpec();
#endif

    putIndex(file_num, const_num);
    putDocument();
}

/******************************************************************************/

/* եȥեåȤԤȥ롥 */

static int getLineColumn(SpdObjId fileId, int offset, int *line, int *column)
{
    return (fileId == SPD_NON_ID ? -1 :
            spdCnvOffsetToLineColumn(fileId, offset, line, column));
}
