/* 
 * Program:             $RCSfile: putJavaScript.c,v $  $Revision: 50.3 $
 * 
 * Purpose:             
 *
 * Author:              N.Atsumi  2003/07/22
 *                      S.Yamamoto  2003/07/22
 *
 * (C) Copyright:       N.Atsumi and S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: putJavaScript.c,v 50.3 2003/07/28 04:16:42 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spie.h"
#include "style.h"
#include "JavaScript.h"

/*
 * JavaScriptδؿϤ롥
 */

void putJSTipsFunc(void)
{
    FILE        *fp;
    SpdString   path;

    path = spdCatPath(directory, JS_TIPS_FILE);
    fp = spieFileOpen(path);

    fprintf(fp, "subwin_width = 400;\n");
    fprintf(fp, "subwin_height = 50;\n");
    fprintf(fp, "var open_check;\n");
    fprintf(fp, "var fix_check;\n");
    fprintf(fp, "var win_stat;\n");
    fprintf(fp, "function check_tips() {\n");  
    fprintf(fp, "    open_check = top.lefttop.document.tips.sw_tips.checked? 1 : 0; \n");
    fprintf(fp, "    fix_check = top.lefttop.document.tips.sw_fix.checked? 0 : 1; \n");
    fprintf(fp, "    if (win_stat != null && !win_stat.closed && open_check == 0) {\n");
    fprintf(fp, "        win_stat.close(); \n");
    fprintf(fp, "    }\n");
    fprintf(fp, "}\n");
    fprintf(fp, "function used_tips(page) {\n");
    fprintf(fp, "     check_tips();\n");
    fprintf(fp, "     if ((win_stat == null || win_stat.closed) && open_check == 1) {\n");
    fprintf(fp, "        win_stat=window.open(\"\",\"tips\",");
    fprintf(fp, "\"scrollbars=1,resizable=1,toolbar=0,menubar=0,");
    fprintf(fp, "location=0,directories=0,status=0,width=\"");
    fprintf(fp, "+subwin_width+\",height=\"+subwin_height+\"\");\n");
    fprintf(fp, "    }\n");
    fprintf(fp, "    if (win_stat != null && !win_stat.closed && fix_check == 0) {\n");
    fprintf(fp, "        win_stat.location.href = \"\"+page+\"\";\n");
    fprintf(fp, "    }\n");
    fprintf(fp, "}\n");
    fprintf(fp, "\n");
    spdFree(path);
    spdFclose(fp);
}

void putJSTitleFunc(void)
{
    FILE        *fp;
    SpdString   path;

    path = spdCatPath(directory, JS_TITLE_FILE);
    fp = spieFileOpen(path);

    fprintf(fp, "function print_title(str) {\n");
    fprintf(fp, "    top.right_js.document.open();\n");
    if (flag_c) {
        fprintf(fp, "    top.right_js.document.write(\"<html>"
                "<head>\");\n");
        fprintf(fp, "    top.right_js.document.write('"
                HTML_LINK_ELEMENT "');\n");
        fprintf(fp, "    top.right_js.document.write(\"</head>\");\n");
        fprintf(fp, "    top.right_js.document.write(\"<body>"
                "<center>\");\n");
    } else {
        fprintf(fp, "    top.right_js.document.write(\"<html>"
                "<body bgcolor=\\\"%s\\\"><center>\");\n", bg_color);
    }
    fprintf(fp, "    top.right_js.document.write(str);\n");
    fprintf(fp, "    top.right_js.document.write(\"</center></body></html>\");\n");
    fprintf(fp, "    top.right_js.document.close();\n");
    fprintf(fp, "}\n");
    spdFree(path);
    spdFclose(fp);
}

void putQuickJumpHtml(void)
{
    FILE        *fp;
    SpdString   path;
    int         i;

    path = spdCatPath(directory, TOOL_FILE);
    fp = spieFileOpen(path);
    beginHtml(fp, QUICK_JUMP);
    bodyHtml(fp, QUICK_JUMP, NULL);
    fprintf(fp, "<form name=\"CHECKER\">\n");
    for (i = 0; i < MAX_CHECKER_NUM; i++) {
        fprintf(fp, "<a href=\"#\" ");
        fprintf(fp, " onClick=\"reset_checker(%d)\"", i+1);
        fprintf(fp, " onMouseOver=\"checker_over(%d)\"", i+1);
        fprintf(fp, " onMouseOut=\"checker_out(%d)\">", i+1);
        fprintf(fp, "<img src=\"ch-gray.gif\" align=\"top\" alt=\"gray\"");
        fprintf(fp, " border=0 name=\"chimg%d\"></a>\n", i+1);
        fprintf(fp, "<span style=\"position:relative\"");
        fprintf(fp, " id=\"checker%d\">", i+1);
        fprintf(fp, "<a href=\"#checker%d\"", i+1);
        fprintf(fp, " onClick=\"select_checker(%d);\"", i+1);
        fprintf(fp, " onMouseOver=\"checker_over(%d)\"", i+1);
        fprintf(fp, " onMouseOut=\"checker_out(%d)\">", i+1);
        fprintf(fp, "CHECKER%d</a></span>&nbsp;", i+1);
        if (i+1 == MAX_CHECKER_NUM) {
            fprintf(fp, "</form>\n");
        } else {
            fprintf(fp, "\n");
        }
    }
    fprintf(fp, "<form name=\"HISTORY_LIST\">\n");
    fprintf(fp, "<input type=\"button\" value=\"BACK\"" \
            " onClick=\"top.tool.back_history()\">\n");
    fprintf(fp, "<input type=\"button\" value=\"FORWARD\"" \
            "onClick=\"top.tool.forward_history()\">\n");
    fprintf(fp, "<input type=\"button\" value=\"RELOAD\"" \
            "onClick=\"top.tool.f_reload()\">\n");
    fprintf(fp, "<input type=\"button\" value=\"JUMP\"" \
            "onClick=\"top.tool.jump_history()\">\n");
    fprintf(fp, "<select name=\"history_list\" size=\"1\">\n");
    fprintf(fp, "<option>SPIE -- Source Program Information Explorer</option>\n");
    fprintf(fp, "</select>\n");
    fprintf(fp, "</form>\n");

    endHtml(fp);
    spdFree(path);
    spdFclose(fp);
}
