/*
 * Program:             $RCSfile: putScript.c,v $  $Revision: 30.91 $
 *
 * Purpose:
 *
 * Author:              H.Ohhashi  1997/07/01
 *                      S.Yamamoto  1997/10/17
 *
 * (C) Copyright:       H.Ohhashi and S.Yamamoto  1997 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: putScript.c,v 30.91 2003/10/07 07:15:18 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spie.h"
#include "style.h"

/* spdSedappend̿ؿ*/

static void spdSedAppend(FILE *fp, int offset, char *strings)
{
    fprintf(fp, "A %d %d %s\n", offset, strlen(strings), strings);
}

/* spdSedmodify̿ؿ*/

static void spdSedModify(FILE *fp, int offset, char *strings1, char *strings2)
{
    fprintf(fp, "M %d %d %s %d %s\n", offset, strlen(strings1), strings1,
            strlen(strings2), strings2);
}

/*
 * <A><FONT>...</FONT></A>ηspdSedץȤϤ
 */

static void scriptElementA(FILE *fp, SpdString name, SpdString href,
                           SpdString target, SpdCss style_no, int offset,
                           int textLength, SpdObjId objid, SpdString type,
                           SpdString file_name)
{
    char startStr[SPD_STRING_LEN + 1];
    char temp[TEMP_MAX];

    /* ϥɲ̿ */
    startStr[0] = '\0';
    strcat(startStr, "<a");
    if (flag_q) {
        strcat(startStr, " onClick=\"top.tool.disp_history('");
        strcpy(temp, spdGetObjText(objid));
        sprintf(temp, "%s",convTextToHtml(temp, CONV_JAVASCRIPT));
        strcat(startStr, temp);
        strcat(startStr, ":");
        strcat(startStr, type);
        strcat(startStr, ":");
        strcat(startStr, file_name);
        strcat(startStr, "');\"");
    }
    if (name) {
        strcat(startStr, " name=\"");
        strcat(startStr, name);
        strcat(startStr, "\"");
    }
    if (href) {
        strcat(startStr, " href=\"");
        strcat(startStr, href);
        strcat(startStr, "\"");
    }
    if (target) {
        strcat(startStr, " target=\"");
        strcat(startStr, target);
        strcat(startStr, "\"");
    }
    if (flag_c) {
        strcat(startStr, " class=\"");
        strcat(startStr, color_style[style_no].style);
        strcat(startStr, "\"");
    }
    strcat(startStr, ">");

    if (!flag_c) {
        strcat(startStr, "<font color=\"");
        strcat(startStr, color_style[style_no].color);
        strcat(startStr, "\">");
    }

    spdSedAppend(fp, offset, startStr);

    /* λɲ̿ */
    /* <FONT>ˤΤȲ */
    if (!flag_c) {
        spdSedAppend(fp, offset+textLength, "</font></a>");
    } else {
        spdSedAppend(fp, offset+textLength, "</a>");
    }
}

/* ץȥ˴ؤ spdSed̿롥*/

static void scriptPrototype(FILE *fp, SpdObjId fileId)
{
    char temp[TEMP_MAX];
    int i, j;
    int length;

    for (i = 0; i < func_proto.size; i++) {
        if (fileId == func_proto.elem[i].file_id &&
            func_proto.elem[i].offset != SPD_NON_OFFSET) {
            for (j = 0; j < func_def.size; j++) {
                if (func_def.elem[j].ident_id == func_proto.elem[i].ident_id) {
                    length = spdGetLength(func_def.elem[j].ident_id);

                    sprintf(temp, "%d%s#s%d", func_def.elem[j].file_id,
                            HTML_SUFFIX, func_proto.elem[i].ident_id);
                    scriptElementA(fp, NULL, temp, NULL, FUNC_STYLE,
                                   func_proto.elem[i].offset, length,
                                   func_proto.elem[i].ident_id,
                                   "prototype declaration",
                                   spdGetName(fileId));
                    break;
                }
            }
        }
    }
}

/* extern˴ؤ spdSed̿롥*/

static void scriptExtern(FILE *fp, SpdObjId fileId)
{
    char temp[TEMP_MAX];
    int i, j;
    int length;
    int label;

    for (i = 0; i < ex_def.size; i++) {
        if (fileId == ex_def.elem[i].file_id &&
            ex_def.elem[i].offset != SPD_NON_OFFSET) {
            length = spdGetLength(ex_def.elem[i].ident_id);
            label = 0;                      /*  */

            /* бơ֥Υ٥դ */
            for (j = 0; j < var_def.size; j++) {
                if (var_def.elem[j].ident_id == ex_def.elem[i].ident_id) {
                    label = var_def.elem[j].label;
                    break;
                }
            }

            if (label == 0) continue;

            sprintf(temp, "%d-%s#s%d", label, SPEC_VAR_FILE,
                    ex_def.elem[i].ident_id);
            scriptElementA(fp, NULL, temp, NULL, VAR_STYLE,
                           ex_def.elem[i].offset, length,
                           ex_def.elem[i].ident_id, "extern",
                           spdGetName(fileId));
        }
    }
}

/* Ǥʬ˴ؤ spdSed̿롥*/

static void scriptDefine(FILE *fp, Define def, SpdObjId fileId,
                         SpdString target_file, SpdCss style_no)
{
    char name[TEMP_MAX];
    char href[TEMP_MAX];
    char temp[TEMP_MAX];
    int i;
    int length;

    /* target_file 饿åȤĴ٤ */
    if (SPD_STREQ(target_file, SPEC_MEMBER_FILE)) {
        strcpy(temp, "member define");
    } else if (SPD_STREQ(target_file, SPEC_ENUM_FILE)) {
        strcpy(temp, "enum define");
    } else if (SPD_STREQ(target_file, SPEC_TYPE_FILE)) {
        strcpy(temp, "type define");
    } else if (SPD_STREQ(target_file, SPEC_MACRO_FILE)) {
        strcpy(temp, "macro define");
    } else if (SPD_STREQ(target_file, SPEC_TAG_FILE)) {
        strcpy(temp, "tag define");
    } else {
        strcpy(temp, "");
    }

    for (i = 0; i < def.size; i++) {
        if (fileId == def.elem[i].file_id &&
            def.elem[i].offset != SPD_NON_ID) {
            length = spdGetLength(def.elem[i].ident_id);

            sprintf(name, "s%d_%d", def.elem[i].ident_id, def.elem[i].offset);
            sprintf(href, "%d-%s#s%d", def.elem[i].label,
                    target_file, def.elem[i].ident_id);
            scriptElementA(fp, name, href, NULL, style_no, def.elem[i].offset,
                           length, def.elem[i].ident_id, temp,
                           spdGetName(fileId));
        }
    }
}

/* Ǥνиʬ˴ؤ spdSed̿롥*/

static void scriptOcc(FILE *fp, Define occ, Define def,  SpdObjId fileId,
                      SpdString target_file, SpdCss style_no)
{
    int i, j, length;
    char name[TEMP_MAX];
    char href[TEMP_MAX];
    char temp[TEMP_MAX];

    /* target_file 饿åȤĴ٤ */
    if (SPD_STREQ(target_file, SPEC_MEMBER_FILE)) {
        strcpy(temp, "member");
    } else if (SPD_STREQ(target_file, SPEC_ENUM_FILE)) {
        strcpy(temp, "enum");
    } else if (SPD_STREQ(target_file, SPEC_TYPE_FILE)) {
        strcpy(temp, "type");
    } else if (SPD_STREQ(target_file, SPEC_TAG_FILE)) {
        strcpy(temp, "tag");
    } else {
        strcpy(temp, "");
    }

    for (i = 0; i < occ.size; i++) {
        if (fileId == occ.elem[i].file_id &&
            occ.elem[i].offset != SPD_NON_ID) {

            /*
             * иμˡȤбĴ٤ƤΤǡɬפʤ
             * .
             */
            for (j = 0; j < def.size; j++) {
                if (occ.elem[i].file_id == def.elem[j].file_id &&
                    occ.elem[i].offset == def.elem[j].offset) continue;


                length = occ.elem[i].length;
                if (def.elem[j].ident_id == occ.elem[i].ident_id) {

                    sprintf(name, "s%d_%d",
                            occ.elem[i].ident_id, occ.elem[i].offset);
                    sprintf(href, "%d-%s#s%d", def.elem[j].label,
                            target_file, occ.elem[i].ident_id);
                    scriptElementA(fp, name, href, NULL, style_no,
                                   occ.elem[i].offset, length,
                                   occ.elem[i].ident_id, temp,
                                   spdGetName(fileId));
                    break;
                }
            }
        }
    }
}

#ifndef BUGGY_SDBLINK4_0107

/* 2ĤʹߤƱ󥯤񤭹(NAMEʤ) */

static void _writeConstScript(FILE *fp, int num, int offset, int length,
                              SpdObjId fileId)
{
    char href[TEMP_MAX];

    sprintf(href, "%d-%s#s%d", constant.elem[num].label,
            SPEC_CONST_FILE, constant.elem[num].const_id);
    scriptElementA(fp, NULL, href, NULL, CONST_STYLE, offset, length,
                   constant.elem[num].const_id, "constant",
                   spdGetName(fileId));
}

/* ǽΥ󥯤񤭹(NAME) */

static void _writeConstScriptFirst(FILE *fp, int num, int offset, int length,
                                   SpdObjId fileId)
{
    char name[TEMP_MAX];
    char href[TEMP_MAX];

    sprintf(name, "s%d_%d",
            constant.elem[num].const_id, constant.elem[num].offset);
    sprintf(href, "%d-%s#s%d", constant.elem[num].label,
            SPEC_CONST_FILE, constant.elem[num].const_id);
    scriptElementA(fp, name, href, NULL, CONST_STYLE, offset, length,
                   constant.elem[num].const_id, "constant",
                   spdGetName(fileId));
}

/* ˴ؤ spdSed̿롥*/

static void scriptConstant(FILE *fp, SpdObjId fileId)
{
    int i, j;
    FILE *fp_src;
    SpdString src_str;
    int offset, length;
    SpdBoolean is_first_link;

    for (i = 0; i < constant.size; i++) {
        if (fileId == constant.elem[i].file_id &&
            constant.elem[i].offset != SPD_NON_OFFSET) {

            is_first_link = TRUE;

            /* μºݤʸ */
            src_str = spdMalloc(constant.elem[i].length + 1);
            fp_src = smuOpenSrcFile(fileId);
            SPD_FSEEK(fp_src, constant.elem[i].offset, SEEK_SET);
            spdFreadChar(src_str, constant.elem[i].length, fp_src);
            spdFclose(fp_src);

            /* ԤȤ˥󥯤ʬ䤹 */
            offset = constant.elem[i].offset;
            length = 0;
            for (j = 0; j < constant.elem[i].length; j++) {
                if (src_str[j] == '\n') {
                    if (is_first_link) {
                        _writeConstScriptFirst(fp, i, offset, length, fileId);
                        is_first_link = FALSE;
                    } else {
                        _writeConstScript(fp, i, offset, length, fileId);
                    }
                    offset = offset + length + 1;
                    length = 0;
                } else {
                    length++;
                }
            }

            if (is_first_link) {
                _writeConstScriptFirst(fp, i, offset, length, fileId);
            } else {
                _writeConstScript(fp, i, offset, length, fileId);
            }
            spdFree(src_str);
        }
    }
}

#endif /* not BUGGY_SDBLINK4_0107 */

/*
 * ץ˹ֹղäHTMLüʸѴspdSed
 * ̿롥
 */

static void scriptLineNum(FILE *fp, SpdObjId fileId)
{
    FILE *fp_source;
    int line = 0;
    int offset = 0;
    SpdString file;
    char line_char[LINE + 2];
    char temp[TEMP_MAX];
    char temp2[TEMP_MAX];
    char temp3[TEMP_MAX];
    int c, i;
    int kanji_shift_flag = 0;               /* For easy JIS-KANJI checking. */
    SpdBoolean is_first_column;

    file = spdGetName(fileId);
    fp_source = smuOpenSrcFile(fileId);

    /*
     * ե1ʸɤ߹ߡüʸȲԤ줿顤
     * Ԥ
     */
    is_first_column = TRUE;
    while ((c = getc(fp_source)) != EOF) {
        /*
         * Simple treating every ESC character as JIST-KANJI-IN or OUT.
         * You should check the rest sequence (2nd and 3rd characters).
         *
         * Escape sequence:
         * 033, 044, 0100 (ESC, $, @)   JIS C 6226-1978,
         * 033, 044, 0102 (ESC, $, B)   JIS X 0208-1983,
         * 033, 050, 0102 (ESC, (, B)   ASCII,
         */
        if (c == '\033') {
            kanji_shift_flag ^= 1;          /* Toggle flag. */
        }
        if (kanji_shift_flag == 0 || c == '\n') {
            if (is_first_column) {
                sprintf(line_char, "%4d: ", ++line);
                if (flag_c) {
                    sprintf(temp, "<span class=\"%s\">%s</span>",
                            color_style[LINE_STYLE].style, line_char);
                } else {
                    sprintf(temp, "<font color=\"%s\">%s</font>",
                            color_style[LINE_STYLE].color, line_char);
                }
                if (flag_m || flag_q) {
                    sprintf(temp2, "<a name=\"s%d\"", line);
                    if (flag_m) {
                        sprintf(temp3, " href=\"%s?SRCFILENAME=%s&LINE=%d\""
                                " target=\"rightbottom\"", MEMO_CGI_FILE,
                                file, line);
                        strcat(temp2, temp3);
                    }
                    if (flag_q) {
                        sprintf(temp3, " class=\"nl\""
                                " onClick=\"top.tool.check_line('%d', '%s')\" "
                                " onMouseOver=\"window.status=''\"",
                                line, file);
                        strcat(temp2, temp3);
                    }
                    strcat(temp2, ">");
                    strcpy(temp3, temp);
                    sprintf(temp, "%s%s</a>", temp2, temp3);
                }
                spdSedAppend(fp, offset, temp);
                if (flag_q) {
                    sprintf(temp, "<span id=\"line%d\">", line);
                    spdSedAppend(fp, offset, temp);
                }
                is_first_column = FALSE;
            }    
            switch (c) {
              case ('<'):
                spdSedModify(fp, offset, "<", "&lt;");
                break;
              case ('>'):
                spdSedModify(fp, offset, ">", "&gt;");
                break;
              case('&'):
                spdSedModify(fp, offset, "&", "&amp;");
                break;
              case('"'):
                spdSedModify(fp, offset, "\"", "&quot;");
                break;
              case('\n'):
                is_first_column = TRUE;
                break;
              default:
                break;
            }
        }
        offset++;
    }
    spdFclose(fp_source);

    /* Ԥɲá */
    for (i = 0; i < TRAILING_LINE_NUM; i++) {
        spdSedAppend(fp, offset, "\n");
    }

    spdSedAppend(fp, offset, "</pre>\n");
    spdSedAppend(fp, offset, "</body>\n");
    spdSedAppend(fp, offset, "</html>\n");
}

/* ץβԥľ"</SPAN>"ղä롥 */

static void scriptSpanTag(FILE *fp, SpdObjId fileId)
{
    FILE *fp_source;
    int offset = 0;
    char span_tag[8] = "</span>";
    int c;

    if (flag_m == ON) {
        return;
    }
    fp_source = smuOpenSrcFile(fileId);
    while ((c = getc(fp_source)) != EOF) {
        if (c == '\n')
            spdSedAppend(fp, offset, span_tag);
        offset++;
    }
    spdFclose(fp_source);
}

/* ץ˿Ĥ̿(ԤȤʬ) */

static void drawColorDivide(P_Block block, SpdObjId fileId, FILE *fp,
                            SpdCss style_no)
{
    int         i, j;
    FILE        *fp_src;
    SpdString   src_str;
    int         start_offset, end_offset, length;
    char        font_start[TEMP_MAX], font_end[TEMP_MAX];

    if (flag_c) {
        sprintf(font_start, "<span class=\"%s\">", color_style[style_no].style);
        sprintf(font_end, "</span>");
    }
    if (!flag_c) {
        sprintf(font_start, "<font color=\"%s\">", color_style[style_no].color);
        sprintf(font_end, "</font>");
    }
    for (i = 0; i < block.size; i++) {
        if (fileId == block.elem[i].file_id) {
            /* μºݤʸ롥 */
            src_str = spdMalloc(block.elem[i].length + 1);
            fp_src = smuOpenSrcFile(fileId);
            SPD_FSEEK(fp_src, block.elem[i].offset, SEEK_SET);
            fread(src_str, sizeof(char), block.elem[i].length, fp_src);
            src_str[block.elem[i].length] = '\0';
            spdFclose(fp_src);

            /* ԤȤʬ䤹롥 */
            start_offset = block.elem[i].offset;
            end_offset = start_offset;
            length = 0;
            for (j = 0; j < block.elem[i].length; j++) {
                if (src_str[j] == '\n') {
                    if (length) {
                        end_offset = start_offset + length;
                        spdSedAppend(fp, start_offset, font_start);
                        spdSedAppend(fp, end_offset, font_end);
                        start_offset = end_offset + 1;
                    } else {
                        /* ԤΤߤιԤϥʤ */
                        start_offset++;
                        end_offset++;
                    }
                    length = 0;
                } else {
                    length++;
                }
            }
            if (length) {
                spdSedAppend(fp, start_offset, font_start);
                spdSedAppend(fp, start_offset + length, font_end);
            }
            spdFree(src_str);
        }
    }
}

/* HTMLƬʬղä̿롥 */

static void scriptBeginning(FILE *fp, SpdObjId fileId)
{
    char        temp[TEMP_MAX], temp2[TEMP_MAX];
    SpdString   file;

    if (language_type == HTML_MODE) {
        spdSedAppend(fp, 0, SPD_DOCTYPE_HTML_4_01_F);
    } else if (language_type == XHTML_MODE) {
        spdSedAppend(fp, 0, SPD_XML_DECL_1_0);
        spdSedAppend(fp, 0, SPD_DOCTYPE_XHTML_1_0_F);
    }

    /* Output header. */
    file = spdGetName(fileId);
    if (!flag_n) {
        time_t  now = time(NULL);

        spdSedAppend(fp, 0, "<!--\n#\n");
        sprintf(temp, "# %s", asctime(localtime(&now)));
        spdSedAppend(fp, 0, temp);
        sprintf(temp, "# This file is Generated by %s in Sapid-%d.%d.%d.\n",
                PROG_NAME, SapidVersion, SapidRevision, SapidPatchLevel);
        spdSedAppend(fp, 0, temp);
        spdSedAppend(fp, 0, "# Don't modify this file.\n");
        sprintf(temp, "# Source file is \"%s\"\n#\n-->\n", file);
        spdSedAppend(fp, 0, temp);
    }

    spdSedAppend(fp, 0, "<html>\n");
    spdSedAppend(fp, 0, "<head>\n");
    sprintf(temp, "<title>%s: %s</title>\n", PROG_NAME, file);
    spdSedAppend(fp, 0, temp);

    if (flag_c) {
        sprintf(temp2, "%s\n", HTML_LINK_ELEMENT);
        spdSedAppend(fp, 0, temp2);
    }

    spdSedAppend(fp, 0, "</head>\n<body");
    if (!flag_c) {
        sprintf(temp2, BODY_STYLE, bg_color, text_color, link_color,
                alink_color, vlink_color);
        spdSedAppend(fp, 0, temp2);
    }
    if (flag_q) {
        sprintf(temp, " onload=\"top.tool.load_checker();");
        if (flag_p) {
            sprintf(temp2, "top.print_title('%s');", file);
            strcat(temp, temp2);
        }
        strcat(temp, "\">");
    } else if (flag_p) {
        file = spdGetName(fileId);
        sprintf(temp, " onload=\"top.print_title('%s');\">", file);
    } else {
        sprintf(temp, ">");
    }
    strcat(temp, "\n<pre>\n");
    spdSedAppend(fp, 0, temp);
}

/* spdSedΥץȥեؿե˽Ԥ*/

static void putScriptSub(SpdObjId fileId)
{
    char temp[TEMP_MAX];
    int i, j;
    SpdString path;
    int length;
    FILE *fp;
    char name[TEMP_MAX];
    char href[TEMP_MAX];

    temp[0] = '\0';

    path = spdMalloc(strlen(directory) + ID_LENGTH + strlen(SPDSED_SUFFIX) + 2);
    sprintf(path, "%s/%d%s", directory, fileId, SPDSED_SUFFIX);
    fp = spdFopen(path, SPD_FOPEN_WT_MODE);

    scriptBeginning(fp, fileId);
    scriptLineNum(fp, fileId);

    /* function define */
    for (i = 0; i < func_def.size ; i++) {
        if (fileId == func_def.elem[i].file_id &&
            func_def.elem[i].offset != SPD_NON_OFFSET) {
            length = spdGetLength(func_def.elem[i].ident_id);

            sprintf(name, "s%d", func_def.elem[i].ident_id);
            sprintf(href, "%d-%s#s%d", func_def.elem[i].label,
                    SPEC_FUNC_FILE, func_def.elem[i].ident_id);
            scriptElementA(fp, name, href, NULL, FUNC_STYLE,
                           func_def.elem[i].offset, length,
                           func_def.elem[i].ident_id,
                           "function define", spdGetName(fileId));
        }
    }

    /* global variable define */
    for (i = 0; i < var_def.size; i++) {
        if (fileId == var_def.elem[i].file_id &&
            var_def.elem[i].offset != SPD_NON_OFFSET) {
            length = spdGetLength(var_def.elem[i].ident_id);

            sprintf(name, "s%d_%d", var_def.elem[i].ident_id,
                    var_def.elem[i].offset);
            sprintf(href, "%d-%s#s%d", var_def.elem[i].label,
                    SPEC_VAR_FILE, var_def.elem[i].ident_id);
            scriptElementA(fp, name, href, NULL, VAR_STYLE,
                           var_def.elem[i].offset, length,
                           var_def.elem[i].ident_id, "gloval variable",
                           spdGetName(fileId));
        }
    }

    /* function call */
    for (i = 0; i < callee.size; i++) {
        if (fileId == callee.elem[i].file_id &&
            !is_system(callee.elem[i].callee_id) &&
            callee.elem[i].offset != SPD_NON_OFFSET) {
            for (j = 0; j < func_def.size; j++) {
                if (func_def.elem[j].ident_id ==
                    callee.elem[i].callee_id) {
                    length = spdGetLength(callee.elem[i].callee_id);

                    sprintf(href, "%d%s#s%d", func_def.elem[j].file_id,
                            HTML_SUFFIX, func_def.elem[j].ident_id);
                    scriptElementA(fp, NULL, href, NULL, FUNC_STYLE,
                                   callee.elem[i].offset, length,
                                   func_def.elem[j].ident_id,
                                   "function call", spdGetName(fileId));
                    break;
                }
            }
        }
    }

    scriptPrototype(fp, fileId);
    scriptExtern(fp, fileId);
    if (flag_l) {
        scriptDefine(fp, l_var_def, fileId, SPEC_L_VAR_FILE, L_VAR_STYLE);
        scriptDefine(fp, arg_def, fileId, SPEC_ARG_FILE, ARG_STYLE);
    }
    scriptDefine(fp, member_def, fileId, SPEC_MEMBER_FILE, MEMBER_STYLE);
    scriptDefine(fp, enum_def, fileId, SPEC_ENUM_FILE, ENUM_STYLE);
    scriptDefine(fp, type_def, fileId, SPEC_TYPE_FILE, TYPE_STYLE);
    scriptDefine(fp, macro_def, fileId, SPEC_MACRO_FILE, MACRO_STYLE);
    scriptDefine(fp, tag_def, fileId, SPEC_TAG_FILE, TAG_STYLE);

    if (flag_l) {
        scriptOcc(fp, l_var_occ, l_var_def, fileId, 
                  SPEC_L_VAR_FILE, L_VAR_STYLE);
        scriptOcc(fp, arg_occ, arg_def, fileId, 
                  SPEC_ARG_FILE, ARG_STYLE);
    }
    scriptOcc(fp, member_occ, member_def, fileId,
              SPEC_MEMBER_FILE, MEMBER_STYLE);
    scriptOcc(fp, enum_occ, enum_def, fileId,
              SPEC_ENUM_FILE, ENUM_STYLE);
    scriptOcc(fp, type_occ, type_def, fileId,
              SPEC_TYPE_FILE, TYPE_STYLE);
    scriptOcc(fp, tag_occ, tag_def, fileId,
              SPEC_TAG_FILE, TAG_STYLE);

#ifndef BUGGY_SDBLINK4_0107
    scriptConstant(fp, fileId);
#endif

    /* global variable refer */
    for (i = 0; i < var_table.size; i++) {
        if (fileId == var_table.elem[i].file_id &&
            !is_system(var_table.elem[i].var_id) &&
            var_table.elem[i].offset != SPD_NON_OFFSET) {
            for (j = 0; j < var_def.size; j++) {
                if (var_def.elem[j].ident_id == var_table.elem[i].var_id) {
                    length = spdGetLength(var_table.elem[i].var_id);

                    sprintf(name, "s%d_%d", var_table.elem[i].var_id,
                            var_table.elem[i].offset);
                    sprintf(href, "%d-%s#s%d", var_def.elem[j].label,
                            SPEC_VAR_FILE, var_table.elem[i].var_id);
                    scriptElementA(fp, name, href, NULL, VAR_STYLE,
                                   var_table.elem[i].offset, length,
                                   var_table.elem[i].var_id,
                                   "global variable", spdGetName(fileId));
                    break;
                }
            }
        }
    }

    /* macro call */
    for (i = 0; i < macro_call.size; i++) {
        if (fileId == macro_call.elem[i].call_file &&
            !is_system_macro(macro_call.elem[i].name_id)) {

            for (j = 0; j < macro_def.size; j++) {
                if (macro_def.elem[j].ident_id == macro_call.elem[i].name_id) {
                    break;
                }
            }

            length = spdGetLength(macro_call.elem[i].name_id);
            sprintf(name, "s%d_%d", macro_call.elem[i].name_id,
                    macro_call.elem[i].call_offset);
            sprintf(href, "%d-%s#s%d", macro_def.elem[j].label,
                    SPEC_MACRO_FILE, macro_call.elem[i].name_id);
            scriptElementA(fp, name, href, NULL, MACRO_STYLE,
                           macro_call.elem[i].call_offset, length,
                           macro_call.elem[i].name_id, "macro call",
                           spdGetName(fileId));
        }
    }

    /*
     * ץ˸ץΥ󥯥롼ɥե
     * 󥫡Ĥ.
     */

    for (i = 0; i < header_occ.size; i++) {
        if (fileId == header_occ.elem[i].file_id &&
            header_occ.elem[i].offset != SPD_NON_OFFSET) {
            /*
             * spdGetLength(hfile_id) != strlen(hfile_name)餷
             * spdGetLength(hfile_id) '"'ʬĹäƤ
             */
            length = spdGetLength(header_occ.elem[i].hfile_id);

            sprintf(href, "%d%s", header_occ.elem[i].h_pfile_id, HTML_SUFFIX);
            scriptElementA(fp, NULL, href, NULL, FILE_STYLE,
                           header_occ.elem[i].offset, length,
                           header_occ.elem[i].hfile_id, "include file",
                           spdGetName(fileId));
        }
    }

    drawColorDivide(no_expand_block, fileId, fp, NO_EXPAND_STYLE);
    drawColorDivide(include_block, fileId, fp, PP_STYLE);
    drawColorDivide(define_block, fileId, fp, DEFINE_STYLE);
    drawColorDivide(pp_block, fileId, fp, PP_STYLE);
    drawColorDivide(comment_block, fileId, fp, COMMENT_STYLE);
    if (flag_q) {
        scriptSpanTag(fp, fileId);
    }

    spdFclose(fp);
    spdFree(path);
}

/*
 * spdSedΥץȥե롥
 * إåեǤʤ*.c򥤥󥯥롼ɤ⤢Τǡ
 * 줷ƽ褦ˤ
 */

void putScript(SpdObjId *file_id, int file_num)
{
    int i;
    SpdObjId cfile_id;

    /* 󥯥롼ɥեΥץȥե */
    for (i = 0; i < header.size; i++) {
        putScriptSub(header.elem[i].id);
    }

    /* ̾ΥեΥץȥեκ */
    for (i = 0; i < file_num; i++) {
        cfile_id = spdConvFileIdItoC(file_id[i]);
        putScriptSub(cfile_id);
    }
}
