/* 
 * Program:             $RCSfile: putSpecLatex.c,v $  $Revision: 30.10 $
 * 
 * Purpose:             
 *
 * Author:              H.Ohhashi  1998/04/08
 *                      S.Yamamoto  1998/04/08
 *
 * (C) Copyright:       H.Ohhashi and S.Yamamoto  1998 - 1999
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: putSpecLatex.c,v 30.10 2003/06/28 15:34:15 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spie.h"
#include "spie-proto.h"

/* ؿͽΰʬϤؿ */

static void putSpecLatexArgument(SpdObjId func_id)
{
    ProtoTableElem *proto;
    SpdString name;
    int i;

    proto = lookUpProtoTable(func_id);

    for (i = 0; i < proto->args.size; i++) {
        name = spdGetName(proto->args.elem[i].ident_id);
        if (name == NULL)
            name = "";

#ifdef BUGGY_MKSPEC3_0039
        argument(name, getTypeName0039(proto->args.elem[i].type_id,
                                       proto->args.elem[i].ident_id));
#else
        argument(name,  getTypeName(proto->args.elem[i].type_id));
#endif
    }
}

/* ؿͽѿʬϤؿ */

static void putSpecLatexVariable(SpdObjId func_id)
{
    SpdObjId type_id;
    SpdString name;
    SpdBoolean contain;
    int i, j;

    for (i = 0; i  < var_table.size; i++) {
        if (func_id != var_table.elem[i].func_id) continue;
    
        /* ˽ϤɤȽꡥ   */
        contain = FALSE;
        for (j = 0; j < i; j++) {
            if (var_table.elem[j].var_id == var_table.elem[i].var_id &&
                var_table.elem[j].func_id == func_id) {
                contain = TRUE;
                break;
            }
        }

        if (contain) continue;
 
        type_id = spdGetARelObj(var_table.elem[i].var_id, "ident_type",
                                "identifier_id");
        name = spdGetName(var_table.elem[i].var_id);

#ifdef BUGGY_MKSPEC3_0039
        if (smuIsGlobalVariable(var_table.elem[i].var_id)) {
            if (is_system(var_table.elem[i].var_id)) {
                global_var_sys(name, 
                               getTypeName0039(type_id, 
                                               var_table.elem[i].var_id));
            } else {
                global_var(name,
                           getTypeName0039(type_id, 
                                           var_table.elem[i].var_id));
            } 
        } else if (smuIsLocalVariable(var_table.elem[i].var_id)) {
            local_var(name,
                      getTypeName0039(type_id,
                                      var_table.elem[i].var_id));
        }
#else
        if (smuIsGlobalVariable(var_table.elem[i].var_id)) {
            if (is_system(var_table.elem[i].var_id)) {
                global_var_sys(name, getTypeName(type_id)); 
            } else {
                global_var(name, getTypeName(type_id));
            } 
        } else if (smuIsLocalVariable(var_table.elem[i].var_id)) {
            local_var(name, getTypeName(type_id));

        }
#endif
    }
}

/* ؿͽθƤӤؿʬϤؿ */

static void putSpecLatexFuncCallee(SpdObjId func_id)
{
    SpdBoolean contain;
    ProtoTableElem *proto;
    int i, j;

    for (i = 0; i < callee.size; i++) {
        if (func_id != callee.elem[i].func_id) continue;
        
        /* ˽ϤɤȽꡥ   */
        contain = FALSE;
        for (j = 0; j < i; j++) {
            if (callee.elem[j].callee_id == callee.elem[i].callee_id &&
                func_id == callee.elem[j].func_id) {
                contain = TRUE;
                break;
            }
        }

        if (contain) continue;

        proto = lookUpProtoTable(callee.elem[i].callee_id);
        
        if (proto->system) {
            function_callee_sys(proto->name, proto->proto, proto->type);
        } else {
            function_callee(proto->name, proto->proto, proto->type);
        }
    }
}

/* ؿͽθƤӤʬϤؿ */

static void putSpecLatexFuncCaller(SpdObjId func_id)
{
    SpdBoolean contain;
    ProtoTableElem *proto;
    int i, j;

    for (i = 0; i < caller.size; i++) {
        if (func_id != caller.elem[i].func_id) continue;
        
        /* ˽ϤɤȽꡥ */
        contain = FALSE;
        for (j = 0; j < i; j++) {
            if (caller.elem[j].caller_id == caller.elem[i].caller_id &&
                caller.elem[j].func_id == func_id) {
                contain = TRUE;
                break;
            }
        }

        if (contain) continue;

        proto = lookUpProtoTable(caller.elem[i].caller_id);       
        if (proto->system) {
            function_caller_sys(proto->name, proto->proto, proto->type);
        } else {
            function_caller(proto->name, proto->proto, proto->type);
        }
    }
}

/* ؿͽΥޥʬϤؿ*/

static void putSpecLatexMacro(SpdObjId func_id)
{
    SpdBoolean contain;
    SpdString name;
    int i, j;

    for (i = 0; i < macro_call.size; i++) {
        if (func_id != macro_call.elem[i].func_id) continue;

        name = spdGetName(macro_call.elem[i].name_id);

        contain = FALSE;
        for (j = 0; j < i; j++) {
            if (macro_call.elem[j].func_id == macro_call.elem[i].func_id &&
                SPD_STREQ(name, spdGetName(macro_call.elem[j].name_id))) {
                contain = TRUE;
                break;
            }
        }

        if (contain) continue;

        /*
         * -Dץޥϡե̾
         * SPD_NON_IDˤʤ롥                 
         */

        if (is_system_macro(macro_call.elem[i].name_id)) {
            macro_sys(name, spdGetMacroArgs(macro_call.elem[i].name_id));
        } else {
            macro(name, spdGetMacroArgs(macro_call.elem[i].name_id));
        }
    }
}

/* LaTeXǡɸϤ˽Ϥؿ */

void putSpecLatex(void)
{
    SpdObjId type_id;
    /* file_nameϴؿμ̻ҤȤƻȤƤΤǻȤʤ */
    SpdString fileName, funcName;
    int i;
    char target_file[FILENAME_MAX];
    
    document_style();
    begin_document();

    for (i = 0; i < func_def.size; i++) {

        fileName = spdGetName(func_def.elem[i].file_id);
    
        /* ؿ̾ */
        funcName = spdGetName(func_def.elem[i].ident_id);

        type_id = spdGetARelObj(func_def.elem[i].ident_id, "ident_type",
                                "identifier_id");

#ifdef BUGGY_MKSPEC3_0039
        begin_specification(funcName,
                            getTypeName0039(type_id,
                                            func_def.elem[i].ident_id));
#else  /* not BUGGY_MKSPEC3_0039 */
        begin_specification(funcName,
                            getTypeName(type_id));
#endif /* not BUGGY_MKSPEC3_0039 */

        file_name(fileName);

        sprintf(target_file, "%s/%s/%d", spdGetSDBdir(), SAPID_SRC_DIR, 
                func_def.elem[i].file_id);
        firstproduced_time(get_m_time(target_file));
        lastmodified_time(get_m_time(target_file));

        if (author == NULL) {
            author = get_owner(target_file);
        }
        manual_author(author);

        putSpecLatexArgument(func_def.elem[i].ident_id);
        putSpecLatexVariable(func_def.elem[i].ident_id);
        putSpecLatexFuncCallee(func_def.elem[i].ident_id);
        putSpecLatexFuncCaller(func_def.elem[i].ident_id);
        putSpecLatexMacro(func_def.elem[i].ident_id);

        end_specification();
    }
    end_document();
}
