/* 
 * Program:             $RCSfile: spie.h,v $  $Revision: 30.54 $
 * 
 * Purpose:             Header file of spieSub.
 * 
 * Author:              K.Hayashi  1995/02/20
 * Modified:            S.Yamamoto  1995/02/24
 *                      A.Watanabe  1997/03/26
 * 
 * (C) Copyright:       K.Hayashi, A.Watanabe and S.Yamamoto  1995 - 2003
 *                      This file is a product of the project Sapid.
 */

/*
 * Macro definitions.
 */

#ifdef GLOBAL_DEFINE
#define GLOBAL
#define GLOBAL_INIT(value)      = (value)
#else
#define GLOBAL                  extern          
#define GLOBAL_INIT(value)
#endif

/* 
 * #ifdef SPIE_NOT_USE_PIDB
 * #define spdConvRegionItoCbyPIDB spdConvRegionItoC
 * #endif
 */

#define ADD_MACRO_TO_LRTYPE

/* Default system path. */ 
#define SYSTEM_PATHS        "/usr/include:/usr/local/include" 

#define BUF_MAX             65536
#define TEMP_MAX            2048
#define LINE                7
#define CONFIG_FILE         ".spie"

#define OUTPUT_TYPE_LATEX   "latex"
#define OUTPUT_TYPE_HTML    "html"
#define OUTPUT_TYPE_XHTML   "xhtml"

#define LATEX_MODE          0
#define HTML_MODE           1
#define XHTML_MODE          2

/* Second argument for convTextToHtml(). */
#define CONV_HTML           0
#define CONV_JAVASCRIPT     1

#define DEFAULT_ALLOC_SIZE  1024

/* objectIdĹ"Sapid.h"Ʊͤʥޥ뤫⤷ʤ */
#define ID_LENGTH           8

/* ץ̾(륹ץȲˤꡤޥɬפ) */
#define PROG_NAME           "SPIE"

/* ơ֥κǿ */
#define TABLE_SIZE          20

/*
 * Type definision.
 */

typedef struct {
     SpdObjId ident_id;
     SpdObjId type_id;
} ArgTableElem;

typedef struct {
    size_t size;
    ArgTableElem *elem;
} ArgTable;

typedef struct {
    SpdObjId identId;
    SpdString name;
    ArgTable args;
    SpdString proto;
    SpdString type;
    SpdBoolean system;
} ProtoTableElem;

typedef struct {
    size_t size;
    size_t max_size;
    ProtoTableElem *elem;
} ProtoTable;

typedef struct {
    SpdObjId file_id;
    SpdObjId ident_id;
    SpdObjId docfrag_id;      /* ɥȤʬID */
    int length;
    int offset;
    int label;                /* Ϥơ֥λѤ롥 */
    SpdBoolean is_static;     /* staticݤ*/
    int lr_type;              /* lr_type Фνиξ礷Ѥʤ...*/
} DefElem;

typedef struct{
    size_t size;
    size_t max_size;
    DefElem *elem;
} Define;

typedef struct{
    SpdObjId file_id;
    SpdObjId var_id;
    SpdObjId func_id;
    int lr_type;
    int offset;
} VarTableElem;

typedef struct {
    size_t size;
    size_t max_size;
    VarTableElem *elem;
} VarTable;

typedef struct{
    SpdObjId name_id;
    SpdObjId call_file;
    int call_offset;
    SpdObjId func_id;
} MacroCallElem;

typedef struct {
    size_t size;
    size_t max_size;
    MacroCallElem *elem;
} MacroCall;

typedef struct{
    SpdObjId file_id;
    SpdObjId callee_id;
    SpdObjId func_id;
    int offset;
} CalleeElem;

typedef struct {
    size_t size;
    size_t max_size;
    CalleeElem *elem;
} Callee;

typedef struct{
    SpdObjId caller_id;
    SpdObjId func_id;
} CallerElem;

typedef struct{
    size_t  size;
    size_t max_size;
    CallerElem *elem;
} Caller;

typedef struct {
    SpdObjId file_id;
    SpdObjId hfile_id;
    SpdObjId h_pfile_id;
    int offset;
} HeaderOccElem;

typedef struct {
    size_t size;
    size_t max_size;
    HeaderOccElem *elem;
} HeaderOcc;

typedef struct {
    SpdObjId file_id;
    int offset;
    int length;
} P_BlockElem;

typedef struct {
    size_t size;
    size_t max_size;
    P_BlockElem *elem;
} P_Block;

typedef struct {
    SpdString name;
    SpdObjId id;
} HeaderFileElem;

typedef struct {
    size_t size;
    size_t max_size;
    HeaderFileElem *elem;
} HeaderFiles;

typedef struct {
    SpdObjId const_id;
    SpdObjId file_id;
    SpdString value;
    SpdString org_value;
    int length;
    int offset;
    int label;  /* Ϥơ֥λѤ롥 */
} ConstOccElem;

typedef struct {
    size_t size;
    size_t max_size;
    ConstOccElem *elem;
} ConstOcc;

typedef struct {
    SpdObjId docfile_id;
    SpdObjId docfrag_id;
    SpdObjId docident_id;
    SpdObjId srcelem_id;
    int offset; /* ץҤγoffset */
    int length; /* ץҤĹ(ޤ) */
    SpdString str; /* ץҤʸ */
} DocDefElem;

typedef struct {
    size_t size;
    size_t max_size;
    DocDefElem *elem;
} DocDefine;

/* Global variable declaration. */

GLOBAL SmuXrefTables    xreftables;

GLOBAL SpdConstString   program_name;           /* This program name. */
GLOBAL SpdString        target_program_name;    /* Target program name. */

/* HTMLΥȥåץǥ쥯ȥꡥ*/
GLOBAL SpdString htmlTopDir     GLOBAL_INIT("SPEC");
GLOBAL SpdString tipsHtmlDir    GLOBAL_INIT("TIPS");

/* HTMLե뤬Ǽǥ쥯ȥꡥ"./htmlTopDir/progId"*/
/* !! ѿ̾*/
GLOBAL SpdString directory      GLOBAL_INIT(NULL);

GLOBAL SpdString tips_dir       GLOBAL_INIT(NULL);
GLOBAL SpdString author         GLOBAL_INIT(NULL);      /* Author name. */
GLOBAL SpdBoolean language_type GLOBAL_INIT(LATEX_MODE);/* LATEX or HTML or XHTML */
GLOBAL SpdBoolean flag_b        GLOBAL_INIT(OFF);       /* Compatibilty with mkSpec4. */
GLOBAL SpdBoolean flag_c        GLOBAL_INIT(OFF);       /* Use CSS. */
GLOBAL SpdBoolean flag_w        GLOBAL_INIT(OFF);       /* Output warning message. */
GLOBAL SpdBoolean flag_s        GLOBAL_INIT(OFF);       /* Supertabular option. */
GLOBAL SpdBoolean flag_l        GLOBAL_INIT(OFF);       /* Add local variable and argument list. */
GLOBAL SpdBoolean flag_T        GLOBAL_INIT(OFF);       /* Tips option. */
GLOBAL SpdBoolean flag_v        GLOBAL_INIT(OFF);       /* Vervose option. */
GLOBAL SpdBoolean flag_m        GLOBAL_INIT(OFF);       /* Add memo function. */
GLOBAL SpdBoolean flag_n        GLOBAL_INIT(OFF);       /* Don't print header. */
GLOBAL SpdBoolean flag_p        GLOBAL_INIT(OFF);       /* Print left frame title. */
GLOBAL SpdBoolean flag_q        GLOBAL_INIT(OFF);
GLOBAL SpdBoolean flag_x        GLOBAL_INIT(OFF);       /* Make document link */
GLOBAL SpdBoolean flag_i        GLOBAL_INIT(OFF);       /* Print index into left bottom frame. */
GLOBAL SpdBoolean flag_C        GLOBAL_INIT(OFF);       /* Enable comment information. */
GLOBAL SpdString lib_directory  GLOBAL_INIT(NULL);

/******************************************************************************/

/* CSS colors. */

GLOBAL SpdString bg_color;          /* طʿ */
GLOBAL SpdString text_color;        /* ƥȤο */
GLOBAL SpdString link_color;        /* 󥫡ο */
GLOBAL SpdString alink_color;       /* ڡɤ߹Ǥ֤ο */
GLOBAL SpdString vlink_color;       /* ɤ߹ڡؤΥ󥫡ο */

#define MAX_STYLE_NUM       18

#define NON_STYLE           (-1)
#define COMMENT_STYLE       0       /* ץΥȤο */
#define DEFINE_STYLE        1       /* ץ#defineԤο */
#define PP_STYLE            2       /* ץ#defineʳ
                                       ץץåο */
#define NO_EXPAND_STYLE     3       /* ŸʤƥȤο */
#define FILE_STYLE          4       /* եΥ󥯤ο */
#define FUNC_STYLE          5       /* ؿΥ󥯤ο */
#define VAR_STYLE           6       /* ѿΥ󥯤ο */
#define L_VAR_STYLE         7       /* ɽѿΥ󥯤ο */
#define ARG_STYLE           8       /* Υ󥯤ο */
#define MACRO_STYLE         9       /* ޥΥ󥯤ο */
#define MEMBER_STYLE       10       /* ѿΥ󥯤ο */
#define ENUM_STYLE         11       /* ҤΥ󥯤ο */
#define TYPE_STYLE         12       /* Υ󥯤ο */
#define CONST_STYLE        13       /* Υ󥯤ο */
#define TAG_STYLE          14       /* Υ󥯤ο */
#define DOC_STYLE          15       /* ɥȤΥ󥯤ο */
#define LINE_STYLE         16       /* ֹο */
#define MEMO_STYLE         17       /* ο */

#define COLOR_LENGTH        8       /* 16ɽʸĹ */

#define BODY_STYLE \
        " bgcolor=\"%s\" text=\"%s\" link=\"%s\" alink=\"%s\" vlink=\"%s\""

typedef struct _ColorStyle {
    SpdString   name;
    char        color[COLOR_LENGTH];    /* .spie ɤ߹Ǿ񤭤뤿
                                            */
    SpdString   style;
} ColorStyle;

typedef int SpdCss;

GLOBAL Define func_def;
GLOBAL Define func_proto;

GLOBAL Define var_def;              /* ѿǼ */
GLOBAL Define l_var_def;            /* ɽѿǼ */
GLOBAL Define arg_def;              /* Ǽ */
GLOBAL Define ex_def;               /* externǼ */
GLOBAL Define member_def;           /* ѿǼ */
GLOBAL Define enum_def;             /* Ǽ */
GLOBAL Define type_def;             /* Ǽ */
GLOBAL Define l_var_occ;            /* иǼ */
GLOBAL Define arg_occ;              /* ѿиǼ */
GLOBAL Define member_occ;           /* ѿиǼ */
GLOBAL Define enum_occ;             /* ҽиǼ */
GLOBAL Define type_occ;             /* νиǼ */
GLOBAL Define macro_def;            /* ޥ */
GLOBAL Define tag_def;              /*  */
GLOBAL Define tag_occ;              /* и */

/******************************************************************************/

#ifndef BUGGY_SDBLINK4_0107
GLOBAL ConstOcc constant;
#endif

GLOBAL VarTable var_table;
GLOBAL MacroCall macro_call;
GLOBAL Callee callee;
GLOBAL Caller caller;
GLOBAL ProtoTable prototable;
GLOBAL P_Block no_expand_block;
GLOBAL P_Block comment_block;
GLOBAL P_Block pp_block;
GLOBAL P_Block define_block;
GLOBAL P_Block include_block;
GLOBAL HeaderFiles header;
GLOBAL HeaderOcc header_occ;
GLOBAL DocDefine doc_def;
GLOBAL SpdObjIdArray MacroDocidentIdArray;

#if defined(SPIE_TRAVERSE)
#include "traverse.h"
#endif

/*
 * Prototype declarations.
 */

/* Include prototype header file. */
#include "spie-proto.h"

/* "arg_type.c". */
void makeProtoTable(void);
ProtoTableElem *lookUpProtoTable(SpdObjId identId);
void freeProtoTable(void);
SpdString getFuncArgType(SpdObjId ident_id);

/* 
 * char   *getFuncArgTypeRaw(int decr_id);
 * char   *getProtoArgType(int decr_id);
 */

/* "file_stat.c" */
char *get_m_time(char *fname);
char *get_owner(char *fname);

/* "latex.c" */
/* void document_style(int ver, int rev); */
void document_style(void);
void begin_document(void);
void end_document(void);
void begin_specification(char *name, char *type);
void end_specification(void);
void file_name(char *name);
void firstproduced_time(char *date);
void lastmodified_time(char *date);
void manual_author(char *user);
void argument(char *name, char *type);
void global_var(char *name, char *type);
void global_var_sys(char *name, char *type);
void local_var(char *name, char *type);
void function_callee(char *name, char *args, char *type);
void function_callee_sys(char *name, char *args, char *type);
void function_caller(char *name, char *args, char *type);
void function_caller_sys(char *name, char *args, char *type);
void macro(char *name, char *args);
void macro_sys(char *name, char *args);
FILE *spieFileOpen(SpdString path);
void beginHtml(FILE *fp, SpdString title);
void bodyHtml(FILE *fp, SpdString title, SpdString js_title);
void endHtml(FILE *fp);
SpdString genTagStr(SpdString tagName, SpdString text, ...);

/* "type-0039.c" */
#ifdef BUGGY_MKSPEC3_0039
SpdString getTypeName0039(SpdObjId type_id, SpdObjId ident_id);
#endif

/* "type.c" */
SpdString getTypeName(SpdObjId type_id);
SpdString getDeclStr(SpdObjId type_id, SpdString decl);

/* "document.c" */
SpdObjId spdGetDocumentId(SpdObjId id);
void setMacroDocidentIdintoArray(void);
void getDocDefine(void);

/* "comment.c" */
void putComment(FILE *fp, SpdString str, int column);
SpdObjIdArray getCommentIds(SpdObjId ident);
SpdObjIdArray getMacroComment(SpdObjId mname_id);
void putOneLineComment(FILE *fp, SpdObjId ident);
void putOneLineCommentForMacro(FILE *fp, SpdObjId mname_id);
void putSpecCommentForMacro(FILE *fp, SpdObjId mname_id);
void putSpecComment(FILE *fp, SpdObjId id);

#undef GLOBAL
#undef GLOBAL_INIT
