/* 
 * Program:             $RCSfile: table_lookup.c,v $  $Revision: 30.16 $
 * 
 * Purpose:             
 * 
 * Author:              K.Hayashi  1995/02/20
 *                      S.Yamamoto  1995/02/24
 * 
 * (C) Copyright:       K.Hayashi and S.Yamamoto  1995 - 1999
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: table_lookup.c,v 30.16 2002/10/21 07:28:53 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spie.h"

/*
 * calleeؿ(ؿƤӽФƤؿ)ξ롥
 * ؿͽκȡ˥󥯤ĥݤɬס           
 */

void make_funccallee_spec_by_table(SpdObjId file_id, SpdObjId caller_identId)
{
    SmuXrefTable table;
    SpdRegion region_i, region_c;
    int i;

    table = xreftables.funcCallTable;

    if (language_type != LATEX_MODE) {
        /* HTML or XHTML Ϥξ */
        for (i = 0; i < table.size; i++) {
            if (caller_identId != table.elem[i].callerId ||
                table.elem[i].calleeId == SPD_NON_ID) continue;

            if (callee.max_size <= callee.size) {
                callee.elem = spdRealloc(callee.elem, sizeof(CalleeElem) * 
                                         (callee.max_size + 
                                          DEFAULT_ALLOC_SIZE));
                callee.max_size += DEFAULT_ALLOC_SIZE;
            }

            region_i.fileId = file_id;
            region_i.offset = spdGetAbsoluteOffset(table.elem[i].relationId, 
                                                   file_id);
            region_i.length = spdGetLength(table.elem[i].calleeId);

            region_c = spdConvRegionItoCbyPIDB(region_i);

            if (region_c.fileId == SPD_NON_ID ||
                region_c.offset == SPD_NON_OFFSET) continue;

            callee.elem[callee.size].file_id = 
                spdConvIdPfileToFile(region_c.fileId);
            callee.elem[callee.size].callee_id = table.elem[i].calleeId;
            callee.elem[callee.size].func_id = table.elem[i].callerId;
            callee.elem[callee.size].offset = region_c.offset;
            callee.size++;
        }
    } else {
        /* LaTeXϤξ */
        for (i = 0; i < table.size; i++) {
            if (caller_identId != table.elem[i].callerId ||
                table.elem[i].calleeId == SPD_NON_ID) continue;

            if (callee.max_size <= callee.size) {
                callee.elem = spdRealloc(callee.elem, sizeof(CalleeElem) * 
                                         (callee.max_size + 
                                          DEFAULT_ALLOC_SIZE));
                callee.max_size += DEFAULT_ALLOC_SIZE;
            }

            /* callee.elem[callee.size].file_id = file_id; */
            callee.elem[callee.size].callee_id = table.elem[i].calleeId;
            callee.elem[callee.size].func_id = table.elem[i].callerId;
            callee.size++;
        }   
    }
}

/*
 * callerؿ(ؿƤӽФƤؿ)ξ롥
 * ؿͽκ˻ѤʤΤǡ                 
 * ѿ˳ǼɬפϤʤ⤷ʤ               
 */

void make_funccaller_spec_by_table(SpdObjId callee_identId)
{
    SmuXrefTable table;
    int i;

    table = xreftables.funcCallTable;
    
    for (i = 0; i < table.size; i++) {
        if (callee_identId != table.elem[i].calleeId ||
            table.elem[i].callerId == SPD_NON_ID) continue;

        if (caller.max_size <= caller.size) {
            caller.elem = spdRealloc(caller.elem, sizeof(CallerElem) * 
                                     (caller.max_size + DEFAULT_ALLOC_SIZE));
            caller.max_size += DEFAULT_ALLOC_SIZE;
        }

        caller.elem[caller.size].caller_id = table.elem[i].callerId;
        caller.elem[caller.size].func_id = callee_identId;
        caller.size++;
    }
}

/* ؿǻѤƤѿξؿ */

void make_variable_spec_by_table(SpdObjId file_id, SpdObjId func_id)
{
    SmuXrefTable table;
    SpdRegion region_i, region_c;
    VarTableElem element;
    SpdOcc occ;
    int i;

    table = xreftables.variableTable;

    if (language_type != LATEX_MODE) {
        for (i = 0; i < table.size; i++) {
            if (func_id != table.elem[i].callerId ||
                table.elem[i].calleeId == SPD_NON_ID) continue;

            if (var_table.max_size <= var_table.size) {
                var_table.elem = spdRealloc(var_table.elem, 
                                            sizeof(VarTableElem) * 
                                            (var_table.max_size + 
                                             DEFAULT_ALLOC_SIZE));
                var_table.max_size += DEFAULT_ALLOC_SIZE;
            }

            region_i.fileId = file_id;
            region_i.offset = 
                spdGetAbsoluteOffset(table.elem[i].relationId, file_id);
            region_i.length = spdGetLength(table.elem[i].calleeId);
        
            region_c = spdConvRegionItoCbyPIDB(region_i);

            if (region_c.fileId == SPD_NON_ID ||
                region_c.offset == SPD_NON_OFFSET) continue;

            element.file_id = spdConvIdPfileToFile(region_c.fileId);
            element.func_id = func_id;
            element.var_id = table.elem[i].calleeId;
            element.offset = region_c.offset;

            if (!isContainOccForVarTable(element, var_table)) {
                var_table.elem[var_table.size].var_id = element.var_id;
                var_table.elem[var_table.size].func_id = element.func_id;
                var_table.elem[var_table.size].file_id = element.file_id;
                var_table.elem[var_table.size].offset = element.offset;

#ifdef OBSOLETE_991122
                /* SPIEȤƤĤʤ٤ʤä */
                /* ".i"regionocc롥 */
                occ = spdConvRegionToOcc(region_i);
#endif

                occ.objectId = table.elem[i].calleeId;
                occ.relationId = table.elem[i].relationId;
                occ.fileId = file_id;
#ifdef ADD_MACRO_TO_LRTYPE
                occ.offset = region_i.offset;
#endif
                var_table.elem[var_table.size].lr_type = 
                    spdGetLrtypeByOcc(occ);
                var_table.size++;
            }
        }
    } else {
        for (i = 0; i < table.size; i++) {
            if (func_id != table.elem[i].callerId ||
                table.elem[i].calleeId == SPD_NON_ID) continue;

            if (var_table.max_size <= var_table.size) {
                var_table.elem = spdRealloc(var_table.elem, 
                                            sizeof(VarTableElem) * 
                                            (var_table.max_size + 
                                             DEFAULT_ALLOC_SIZE));
                var_table.max_size += DEFAULT_ALLOC_SIZE;
            }

            var_table.elem[var_table.size].var_id = table.elem[i].calleeId;
            var_table.elem[var_table.size].func_id = func_id;
            var_table.size++;
        }
    }
}
