/* 
 * Program:             $RCSfile: type-0039.c,v $  $Revision: 30.7 $
 * 
 * Purpose:             
 * 
 * Author:              K.Hayashi  1995/02/20
 * Modified:            A.Watanabe  1995/02/24
 *                      S.Yamamoto  1995/02/24
 * 
 * (C) Copyright:       K.Hayashi, A.Watanabe and S.Yamamoto  1995 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: type-0039.c,v 30.7 2002/12/16 12:12:05 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/SpdStr.h>
#include "spie.h"

#ifdef BUGGY_MKSPEC3_0039

#ifndef SPIE_SPDSTR

typedef struct {
    int storage;
    char *cexp;
} cexp_ent;

static int          old_id = -1;
static int          dimension = 0;

static SpdString    getTypeName_raw0039(SpdObjId type_id, SpdObjId ident_id);
static SpdString    buggy_type_cexp(SpdObjId type_id, SpdObjId ident_id);

static SpdString getTypeName_raw0039(SpdObjId type_id, SpdObjId ident_id)
{
    static char buf[SPD_LINE_LEN + 1];

    strcpy(buf, "");
    switch (spdGetAttrValInt(type_id, "qualifier")) {
      case TYPE_CONST:
        strcat(buf, "const ");
        break;
      case TYPE_VOLATILE:
        strcat(buf, "volatile ");
        break;
    }
    switch (spdGetAttrValInt(type_id, "sign")) {
      case TYPE_SIGNED:
        strcat(buf, "signed ");
        break;
      case TYPE_UNSIGNED:
        strcat(buf, "unsigned ");
        break;
    }
    switch (spdGetAttrValInt(type_id, "size")) {
      case TYPE_SHORT:
        strcat(buf, "short ");
        break;
      case TYPE_LONG:
        strcat(buf, "long ");
        break;
    }
    switch (spdGetAttrValInt(type_id, "type")) {
      case TYPE_VOID:
        strcat(buf, "void ");
        break;
      case TYPE_INT:
        strcat(buf, "int ");
        break;
      case TYPE_CHAR:
        strcat(buf, "char ");
        break;
      case TYPE_FLOAT:
        strcat(buf, "float ");
        break;
      case TYPE_DOUBLE:
        strcat(buf, "double ");
        break;
      case TYPE_DOTS:
        strcat(buf, "... ");
        break;
    }
    switch (spdGetAttrValInt(type_id, "sort")) {
      case TYPE_TYPE_DEF:
        strcat(buf, spdGetName(type_id));
        strcat(buf, " ");
        break;
      case TYPE_STRUCT_TAG:
        strcat(buf, "struct ");
        strcat(buf, spdGetName(type_id));
        strcat(buf, " ");
        break;
      case TYPE_DECLARATION:
        break;
      case TYPE_POINTER:
        strcat(buf, "*");
        break;
      case TYPE_ARRAY:
        dimension++;
        strcat(buf, buggy_type_cexp(type_id, ident_id));
        break;
      case TYPE_FUNC:
        strcat(buf, "()");
        break;
      case TYPE_ENUM_SPECIFIER:
        strcat(buf, "enum ");
        strcat(buf, spdGetName(type_id));
        strcat(buf, " ");
        break;
    }
    return buf;
}

static SpdString buggy_type_cexp(SpdObjId type_id, SpdObjId ident_id)
{
    int declr_buf_n = 0;
    SpdObjId *declr_buf = NULL;
    cexp_ent *cexp_buf = NULL;
    SpdCursor *csr;
    int declr_id, i, j;
    char *buf;
    char *top_ptr, *end_ptr;
    
    csr = spdGetRelObjInit(ident_id, "decl_ident", "any");
    while ((declr_id = spdGetRelObj(csr)) != -1) {
        declr_buf = spdRealloc(declr_buf, sizeof(SpdObjId) * (declr_buf_n + 1));
        cexp_buf = spdRealloc(cexp_buf, sizeof(cexp_ent) * (declr_buf_n + 1));

        declr_buf[declr_buf_n] = declr_id;
        cexp_buf[declr_buf_n].storage = spdGetAttrValIntOfObj(declr_id,
                                                              "storage");

        /* j = dimension; */

        /* Modified by S.Yamamoto 1997/08/15. */
        /* buf = spdStrdup(spdGetObjText(declr_id)); */
        if ((buf = spdGetObjText(declr_id)) == NULL) {
            /* Problem of "# line" directive. */
            spdWarning("Can't get source text of \"%s\".\n", 
                       spdGetName(ident_id));
            buf = spdStrdup("");
        } else {
            buf = spdStrdup(buf);
        }

        top_ptr = buf;
        if (strchr(top_ptr, '[') == NULL) {
            /*
             * K&R style argument(array) declaration.
             * such as:
             *
             * int f(arg)
             *     int arg[];
             * {
             * ...
             * }
             */
            cexp_buf[declr_buf_n].cexp = spdStrdup("[]");
        } else {
            /* 
             * do {
             *     top_ptr = strchr(top_ptr, '[');
             *     top_ptr++;
             * } while (--j > 0);
             */
            for (j = dimension; j > 0; j--) {
                top_ptr = strchr(top_ptr, '[');
                top_ptr++;
            }
            top_ptr--;
            end_ptr = strchr(top_ptr, ']');
            if (end_ptr == NULL) {
                /* spdWarning("%s(%d): źμ˼Ԥޤ\n", */
                /*            spdGetName(ident_id), dimension);       */
                spdWarning("%s(%d): Can't get array index.\n",
                           spdGetName(ident_id), dimension);
                spdWarning("0x%x: \"%s\", top: 0x%x, end: 0x%x.\n",
                           buf, buf, top_ptr, end_ptr);
                cexp_buf[declr_buf_n].cexp = spdStrdup("[]");
            } else {
                *(end_ptr + 1) = '\0';
                cexp_buf[declr_buf_n].cexp = spdStrdup(top_ptr);
            }
            declr_buf_n++;
        }
        spdFree(buf);
    }
    spdFreeCursor(csr);

    for (i = 0; i < declr_buf_n; i++) {
        if ((cexp_buf[i].storage != STORAGE_EXTERN) &&
            (cexp_buf[i].cexp[1] != ']')) {
            return cexp_buf[i].cexp;
        }
    }
    for (i = 0; i < declr_buf_n; i++) {
        if (cexp_buf[i].cexp[1] != ']') {
            return cexp_buf[i].cexp;
        }
    }
    return "[]";
}

#endif /* not SPIE_SPDSTR */

/******************************************************************************/

SpdString getTypeName0039(SpdObjId type_id, SpdObjId ident_id)
{
#ifdef SPIE_SPDSTR

    char        *buf = NULL;
    static char *save = NULL;
    if (save != NULL) {
        spdFree(save);
        save = NULL;
    }

    buf = spdStrdup(spdStr(type_id));
    save = buf;
    return buf;

#else  /* not SPIE_SPDSTR */

    char        buf[1024];
    int         inner_type_id;
    static char res[1024];
    
    strcpy(buf, "");

    if (ident_id != old_id) {
        old_id = ident_id;
        dimension = 0;
    }
    
    if ((inner_type_id = spdGetARelObj(type_id, "type_st", "type_pointer_id"))
        != -1) {
        strcat(buf, getTypeName0039(inner_type_id, ident_id));
    }
    strcat(buf, getTypeName_raw0039(type_id, ident_id));
    strcpy(res, buf);
    return res;

#endif /* not SPIE_SPDSTR */
}

#endif /* BUGGY_MKSPEC3_0039 */
