/* 
 * Program:             $RCSfile: traverse.h,v $  $Revision: 90.1 $
 * 
 * Purpose:             Header file of spieSub with spdTraverse.
 * 
 * Author:              A.Watanabe  2001/01/29
 *                      S.Yamamoto  2001/01/29
 * 
 * (C) Copyright:       A.Watanabe and S.Yamamoto  2001
 *                      This file is a product of the project Sapid.
 */

typedef struct _CalleeBufElem {
    SpdObjId        fileId;    
    SpdObjId        callerId;
    SpdObjId        calleeId;
    SpdRelId        relationId;
} CalleeBufElem;

typedef struct _CalleeBuf {
    int             size;
    CalleeBufElem   *elem;
} CalleeBuf;

typedef struct _SpieTraverse {
    SpdObjId        fileId;
    SpdObjId        funcId;
    
    SpdOccArray     decln_buf;
    SpdOccArray     ident_buf;
    SpdOccArray     expr_buf;
    SpdOccArray     const_buf;

    CalleeBuf       callee;
} SpieTraverse;

GLOBAL SpieTraverse traverse;

SpieTraverse spieTraverse(SpdObjId prog_id);
SmuXrefTables  spieMakeXrefTables(SpdObjId prog_id, SpieTraverse trav,
                                  SmuXrefFlag flag);
void spieFreeTraverse(SpieTraverse trav);
