/* 
 * Program:             $RCSfile: tree.c,v $  $Revision: 30.12 $
 * 
 * Purpose:             treeLץ
 *                          argv[1]: treeǡǼե̾ ("DATA/tree.dat").
 *                          argv[2]: SDB ǥ쥯ȥ
 *
 * Author:              K.Yasuhara  1998/07/01
 *                      S.Yamamoto  1999/10/28
 *
 * (C) Copyright:       K.Yasuhara and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: tree.c,v 30.12 2003/06/15 04:47:56 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

void out_func_gv(SpdObjId file_id);
void out_ilv(SpdObjId func_id);
void out_lv(SpdObjId func_id);

SpdObjIdArray file_buf, gv_buf, func_buf, lv_buf, ilv_buf;

int main(int argc, char *argv[])
{
    int i,j,k,l;
    int ch_ex;
    char *filename = argv[1];
    char *name;
    FILE *file;
    SpdString       target_program_name;    /* оݤΥץ̾ */
    SpdObjId        prog_id, temp_id;
    SpdObjIdArray   temp_buf;

    spdSetSDBdir(argv[2]);

    /* ϤоݤȤʤץ̾   */
    target_program_name = smuGetAProgramName();
    if ((prog_id=spdTarget("P-model", target_program_name)) == SPD_NON_ID) {
        spdErrorExit("Program \"%s\" not found.\n", target_program_name);
    }

    file = spdFopen(filename, SPD_FOPEN_WT_MODE);

    /* ץ̾ */ 
    fprintf(file,"1 %s %d 0\n",target_program_name,prog_id);
    file_buf = spdGetRelObjSortedArray(prog_id,"prog_file","p-id"
                                       ,NULL,spdCompareObjIdName);

    /* ե̾ */
    for (i=0; i<file_buf.size; i++) {
        name = spdGetName(spdGetARelObj(file_buf.id[i],"cfile_ifile","file_id"));
        fprintf(file,"2 %s %d 0\n",name,file_buf.id[i]);
        /* ѿؿ */
        out_func_gv(file_buf.id[i]);
        /* ѿ̾ */
        for (j=0; j<gv_buf.size; j++) {
            ch_ex = spdGetAttrValInt(gv_buf.id[j],"storage");
            temp_buf = spdGetRelObjSortedArray(gv_buf.id[j],"decl_decl","declaration_id"
                                               ,NULL,spdCompareObjIdName);
            for (k=0; k<temp_buf.size; k++) {
                temp_id = spdGetARelObj(temp_buf.id[k],"decl_ident","declarator_id");
                if (ch_ex == STORAGE_STATIC) {
                    fprintf(file,"3 %s %d 3\n",spdGetName(temp_id), temp_buf.id[k]);
                }else if (ch_ex == STORAGE_EXTERN) {
                    fprintf(file,"3 %s %d 2\n",spdGetName(temp_id), temp_buf.id[k]);
                }else {
                    fprintf(file,"3 %s %d 1\n",spdGetName(temp_id), temp_buf.id[k]);
                }
            }
            spdFreeObjIdArray(temp_buf);
        }
        /* ؿ̾ */
        for (j=0; j<func_buf.size; j++) {
            temp_buf = spdGetRelObjSortedArray(func_buf.id[j],"decl_decl","declaration_id"
                                               ,NULL,spdCompareObjIdName);
            for (k=0; k<temp_buf.size; k++) {
                temp_id = spdGetARelObj(temp_buf.id[k],"decl_ident","declarator_id");
                fprintf(file,"3 %s %d 0\n",spdGetName(temp_id), temp_buf.id[k]);
            }
            spdFreeObjIdArray(temp_buf);

            /* ѿ */
            out_ilv(func_buf.id[j]);
            /* ѿ̾ */
            for (k=0; k<ilv_buf.size; k++) {
                temp_buf = spdGetRelObjSortedArray(ilv_buf.id[k],"decl_decl","declaration_id"
                                                   ,NULL,spdCompareObjIdName);
                for (l=0; l<temp_buf.size; l++) {
                    temp_id = spdGetARelObj(temp_buf.id[l],"decl_ident","declarator_id");
                    fprintf(file,"4 %s %d 1\n",spdGetName(temp_id), temp_buf.id[l]);
                }
                spdFreeObjIdArray(temp_buf);
            }

            /* ѿ̾ */
            out_lv(func_buf.id[j]);
            for (k=0; k<lv_buf.size; k++) {
                temp_buf = spdGetRelObjSortedArray(lv_buf.id[k],"decl_decl","declaration_id"
                                                   ,NULL,spdCompareObjIdName);
                for (l=0; l<temp_buf.size; l++) {
                    temp_id = spdGetARelObj(temp_buf.id[l],"decl_ident","declarator_id");
                    fprintf(file,"4 %s %d 0\n",spdGetName(temp_id), temp_buf.id[l]);
                }
                spdFreeObjIdArray(temp_buf);
            }
        }
    }
    fprintf(file,"0 end 0 0\n");
    spdFclose(file);

    /* ѿΰ */
    spdFreeObjIdArray(file_buf);
    spdFreeObjIdArray(gv_buf);
    spdFreeObjIdArray(func_buf);
    spdFreeObjIdArray(lv_buf);
    spdFreeObjIdArray(ilv_buf);
    return (0);
}
