/* 
 * Program:             $RCSfile: tree1.c,v $  $Revision: 30.5 $
 * 
 * Purpose:             treeץࡥ
 *                          argv[1]: target program name.
 *                          argv[2]: treeǡǼե̾ ("DATA/tree.dat").
 *
 * Author:              K.Yasuhara  1998/07/01
 *                      S.Yamamoto  1999/10/28
 *
 * (C) Copyright:       K.Yasuhara and S.Yamamoto  1998 - 1999
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: tree1.c,v 30.5 2003/06/15 07:49:12 yamamoto Exp yamamoto $";
#endif

/******************************************************************************/
/* ѿؿ                                                             */
/******************************************************************************/

#include <stdio.h>
#include <Sapid/Sapid.h>

void out_func_gv(SpdObjId file_id);             /* ؿѿФ */
void out_lv(SpdObjId func_id);                  /* ѿФ */
void out_ilv(SpdObjId func_id);                 /* ѿФ */

extern SpdObjIdArray gv_buf, func_buf, lv_buf, ilv_buf;

/******************************************************************************/
/* ؿѿХ⥸塼                                               */
/* !! 2ż(Ȥʤʤ)                                       */
/******************************************************************************/

/* file_id 餽Υե˴ޤޤؿѿArray             */
/*  : file_id (եdeclaration_id)                                 */
/*  : func_buf (ؿdeclaration_id), gv_buf (ѿdeclaration_id) */

void out_func_gv(SpdObjId file_id)
{
    int i,j;
    SpdRel ident_rel;
    int offset;
    int count_func = 0;
    int count_gv   = 0;
    SpdObjIdArray decl_buf, decr_buf;

    /* file  declaration Ф */
    decl_buf = spdGetRelObjSortedArray(file_id,"file_decl","file_id"
                                       ,NULL,spdCompareObjIdName);  
    /* ؿѿο */
    for(i=0; i<decl_buf.size; i++){
        if(spdGetAttrValInt(decl_buf.id[i],"sort") == DECL_FUNCDEF){
            count_func++;
        }
        else if(spdGetAttrValInt(decl_buf.id[i],"sort") == DECL_NORMAL){
            decr_buf = spdGetRelObjSortedArray(decl_buf.id[i],"decl_decl","declaration_id"
                                               ,NULL,spdCompareObjIdName);
            for(j=0; j<decr_buf.size; j++){
                if(spdGetAttrValInt(decr_buf.id[j],"sort") == DECL_VARIABLE){
                    /* include ѿν */
                    ident_rel = spdGetARel(decr_buf.id[j], "decl_ident", "declarator_id");
                    offset = spdGetAbsoluteOffset(ident_rel.relationId,file_id);
                    if(!spdIsInHeaderFile(file_id,offset)){
                        count_gv++;
                        break;
                    }
                }
            }
            spdFreeObjIdArray(decr_buf);
        }
    }

    /* ΰ & */
    spdFreeObjIdArray(func_buf);
    func_buf.id   = (SpdObjId*)spdMalloc(count_func * sizeof(SpdObjId));
    func_buf.size = count_func;
    spdFreeObjIdArray(gv_buf);
    gv_buf.id   = (SpdObjId*)spdMalloc(count_gv * sizeof(SpdObjId));
    gv_buf.size = count_gv;

    count_func = 0;
    count_gv   = 0;
    for(i=0; i<decl_buf.size; i++){
        if(spdGetAttrValInt(decl_buf.id[i],"sort") == DECL_FUNCDEF){
            func_buf.id[count_func] = decl_buf.id[i];
            count_func++;
        }
        else if(spdGetAttrValInt(decl_buf.id[i],"sort") == DECL_NORMAL){
            decr_buf = spdGetRelObjSortedArray(decl_buf.id[i],"decl_decl","declaration_id"
                                               ,NULL,spdCompareObjIdName);
            for(j=0; j<decr_buf.size; j++){
                if(spdGetAttrValInt(decr_buf.id[j],"sort") == DECL_VARIABLE){
                    /* include ѿν */
                    ident_rel = spdGetARel(decr_buf.id[j], "decl_ident", "declarator_id");
                    offset = spdGetAbsoluteOffset(ident_rel.relationId,file_id);
                    if(!spdIsInHeaderFile(file_id,offset)){
                        gv_buf.id[count_gv] = decl_buf.id[i];
                        count_gv++;
                        break;
                    }
                }
            }
            spdFreeObjIdArray(decr_buf);
        }
    }
    spdFreeObjIdArray(decl_buf);
}

/******************************************************************************/
/* ѿХ⥸塼                                                 */
/* !! 2ż(Ȥʤʤ)                                       */
/******************************************************************************/

/* func_id 餽ǻȤѿArray */
/*  : func_id (ؿdeclaration_id)               */
/*  : lv_buf (ѿdeclaration_id)        */

void out_lv(SpdObjId func_id)
{
    int i,j;
    int count = 0;
    SpdObjId      decr_id, opt_id, body_id;
    SpdObjIdArray decl_buf, decr_buf;

    /* declation  declarator Ф */
    decr_id = spdGetARelObj(func_id,"decl_decl","declaration_id");
    /* ؿĴ */
    opt_id   = spdGetARelObj(decr_id, "decl_opt", "declarator_id");
    body_id  = spdGetARelObj(opt_id, "func_body", "function_id");
    decl_buf = spdGetRelObjSortedArray(body_id,"blk_decl","parent_block_id"
                                       ,NULL,spdCompareObjIdName);
    /* ѿο */
    for(i=0; i<decl_buf.size; i++){
        /* declaration Τѿ,ץȥ״ؿФ */
        if(spdGetAttrValInt(decl_buf.id[i],"sort") == DECL_NORMAL){
            decr_buf = spdGetRelObjSortedArray(decl_buf.id[i],"decl_decl","declaration_id"
                                               ,NULL,spdCompareObjIdName);
            for(j=0; j<decr_buf.size; j++){
                /* declaration ΤѿФ (ѿ)*/
                if(spdGetAttrValInt(decr_buf.id[j],"sort") == DECL_VARIABLE){
                    count++;
                    break;
                }
            }
            spdFreeObjIdArray(decr_buf);
        }
    }

    /* ΰ & */
    spdFreeObjIdArray(lv_buf);
    lv_buf.id = (SpdObjId*)spdMalloc(count * sizeof(SpdObjId));
    lv_buf.size = count;

    count = 0;
    for(i=0; i<decl_buf.size; i++){
        /* declaration Τѿ,ץȥ״ؿФ */
        if(spdGetAttrValInt(decl_buf.id[i],"sort") == DECL_NORMAL){
            decr_buf = spdGetRelObjSortedArray(decl_buf.id[i],"decl_decl","declaration_id"
                                               ,NULL,spdCompareObjIdName);
            for(j=0; j<decr_buf.size; j++){
                /* declaration ΤѿФ (ѿ)*/
                if(spdGetAttrValInt(decr_buf.id[j],"sort") == DECL_VARIABLE){
                    lv_buf.id[count] = decl_buf.id[i];
                    count++;
                    break;
                }
            }
            spdFreeObjIdArray(decr_buf);
        }
    }
    spdFreeObjIdArray(decl_buf);
}

/******************************************************************************/
/* ѿХ⥸塼                                                     */
/******************************************************************************/

/* func_id 餽ǻȤѿArray */
/*  : func_id (ؿdeclaration_id)           */
/*  : ilv_buf (ѿdeclaration_id)       */

void out_ilv(SpdObjId func_id)
{
    SpdObjId decr_id, opt_id;

    /* declation  declarator Ф */
    decr_id = spdGetARelObj(func_id,"decl_decl","declaration_id");

    /* ؿĴ */
    opt_id  = spdGetARelObj(decr_id, "decl_opt", "declarator_id");
    ilv_buf = spdGetRelObjSortedArray(opt_id,"func_parm","optionaldecl_id"
                                      ,NULL,spdCompareObjIdName);
}
