/* 
 * Program:         $RCSfile: funcdata.c,v $  $Revision: 30.9 $
 * 
 * Purpose:         ץࡥ֤ηԤ
 *
 * Author:          K.Yasuhara  2000/07/01
 *                  S.Yamamoto  2000/07/01
 *
 * (C) Copyright:   K.Yasuhara and S.Yamamoto  2000 - 2003
 *                  This file is a product of the project Sapid.
 */

#include <math.h>
#include <stdio.h>
#include <Sapid/Sapid.h>
#include "my.h"

void out_func_gv(SpdObjId file_id);                /* SDBؿѿξ */
void MakeEdgeGv(void);                             /* Ʊѿõ */
void MakeEdgeData(void);                           /* åΥǡ */
int  expr2func(int expr_id);                       /* expr_id  func_id  */
int  CheckGvUse(SpdObjId func_id, SpdObjId gv_id); /* ؿѿȤäƤ뤫 */

SpdObjIdArray gv_buf, func_buf;

/* ᥤؿ */

void MakeGraphData(void)
{
    int i,j,k,l,temp;
    int *have_num,*have_lan,num;          /* ƥե뤬äƤؿο */
    int tmp = -1;                         /* warningɻѽ */
    int *use_gv;
    double r,sita,z;                      /* Ⱦ,,Zɸ */
    double ds;                            /* ե˳٤򤺤餹 */
    double ds2;
    SpdString       target_program_name;  /* оݤΥץ̾ */
    SpdObjId        temp_id;
    SpdObjIdArray   file_buf, temp_buf;

    /* ϤоݤȤʤץ̾   */
    target_program_name = smuGetAProgramName();
    if ((temp_id=spdTarget("P-model", target_program_name)) == SPD_NON_ID) {
        spdErrorExit("Program \"%s\" not found.\n", target_program_name);
    }

    /* ץ̾ */ 
    file_buf = spdGetRelObjSortedArray(temp_id,"prog_file","p-id"
                                       ,NULL,spdCompareObjIdName);


    /********** ؿ/ѿο (ΰ) **********/
    /* ե */
    f_info   = spdMalloc(file_buf.size * sizeof(FILEINFO));
    file_num = file_buf.size;
    /* ؿŪ˳Ǽ */
    have_num = spdMalloc(file_buf.size * sizeof(int)); /* ؿο */
    have_lan = spdMalloc(file_buf.size * sizeof(int)); /* ؿ¿ */
    /* ؿ/ѿον */
    func_num = 0;
    gv_num   = 0;
    /* եĴ */
    for (i=0; i<file_buf.size; i++) {
        /* ؿο */
        out_func_gv(file_buf.id[i]);
        func_num += func_buf.size;
        have_num[i] = func_buf.size;
        have_lan[i] = 0;
        temp = 0;

        /* ѿο */
        for (j=0; j<gv_buf.size; j++){
            temp_buf = spdGetRelObjSortedArray(gv_buf.id[j],"decl_decl","declaration_id"
                                               ,NULL,spdCompareObjIdName);
            temp += temp_buf.size;
        }
        gv_num += temp;

        /* ե */
        f_info[i].f_num = func_buf.size;
        f_info[i].f     = spdMalloc(func_buf.size * sizeof(int));
        f_info[i].g_num = temp;
        f_info[i].g     = spdMalloc(temp * sizeof(int));
    }
    /* ؿ/ѿγǼݤ */
    func = spdMalloc(func_num * sizeof(FUNC));
    gv   = spdMalloc(gv_num * sizeof(GV));
    func_num = 0;
    gv_num = 0;
    /***********************************************/


    /******** ؿ¿˥ ********/
    for (i=0; i<file_buf.size; i++) {
        num=0;
        for (j=0; j<file_buf.size; j++) {
            if(have_lan[j]!=0) continue;
            if(num<have_num[j]) {
                num=have_num[j];
                tmp = j;
            }
        }
        have_lan[tmp]=i+1;
    }
    /**************************************/

      
    /*********** ƼǼ ***********/
    for (i=0; i<file_buf.size; i++) {
        /* ѿؿ */
        out_func_gv(file_buf.id[i]);

        /* ؿְ֤ */
        r = sqrt(func_buf.size)+0.5;        /* Ⱦ· */
        sita = 2*PI/func_buf.size;          /* Ǵֳٷ */
        ds = i*0.3+PI/2;                    /* ե˾餹 */
        /* ɽZɸ */
        if (have_lan[i]%2==1) z =  1.5*(have_lan[i]-1)/2;
        else                  z = -1.5* have_lan[i]   /2;
        /* z = 1.5 * (have_lan[i]-1); */ /* ߿ɽΤȤ */

        /* ե */
        f_info[i].id    = file_buf.id[i];
        f_info[i].z     = z;
        f_info[i].r     = r;
        f_info[i].name  = spdGetName(spdGetARelObj(file_buf.id[i],"cfile_ifile","file_id"));

        for (j=0; j<func_buf.size; j++) {
            /* ե */
            f_info[i].f[j] = func_num;

            /*** ؿ ***/
            /* եID */
            func[func_num].file_id = i;
            /* ؿID */
            temp_id = spdGetARelObj(func_buf.id[j],"decl_decl","declaration_id");
            func[func_num].id = temp_id;
            /* ؿĹ */
            func[func_num].length = spdGetLength(temp_id);
            /* ؿ̾ */
            temp_id = spdGetARelObj(temp_id,"decl_ident","declarator_id");
            func[func_num].name = spdGetName(temp_id);
            /* Ⱦ */
            func[func_num].r = 0.1f;
            /* Ĺ(׻ƤɤΤǤ?) */
            func[func_num].h = (double)func[func_num].length / func_scale;
            /* ɽɸ */
            func[func_num].pos = SetPos(r*cos(sita*j+ds) ,r*sin(sita*j+ds) ,z);
            func[func_num].ds  = sita*j+ds;
            func[func_num].l   = r;

            /* Ϥ main 򤷤Ƥ */
            if(SPD_STREQ(func[func_num].name, "main")) {
                func_main = func_num;
                select_func = func_num;
                func_old_pos = func[func_num].pos;
                func[func_num].pos = SetPos(0,0,z);
            }
            func_num++;
        }

        /* ѿְ֤ */
        r = r - 1;                          /* Ⱦ· */
        sita = 2*PI/gv_buf.size;            /* Ǵֳٷ */

        temp = 0;
        use_gv = spdMalloc(func_buf.size*sizeof(int)); /* ؿο */
        for (j=0; j<gv_buf.size; j++) {
            temp_buf = spdGetRelObjSortedArray(gv_buf.id[j],"decl_decl","declaration_id"
                                               ,NULL,spdCompareObjIdName);
            ds2 = sita/temp_buf.size;
            for (k=0; k<temp_buf.size; k++) {
                /* ե */
                f_info[i].g[temp] = gv_num;
                temp++;

                /*** ѿ ***/
                /* ɽɸ */
                gv[gv_num].pos = SetPos(r*cos(sita*j + ds + ds2*k),
                                        r*sin(sita*j + ds + ds2*k),
                                        z+0.25);
                /* ident_id */
                gv[gv_num].iid = spdGetARelObj(temp_buf.id[k],"decl_ident","declarator_id");
                /* declarator_id */
                gv[gv_num].id   = temp_buf.id[k];
                /* ѿ̾ */
                gv[gv_num].name = spdGetName(gv[gv_num].iid);
                /* ɽ */
                gv[gv_num].view = FALSE;
                /* file_id */
                gv[gv_num].file_id = i;
        
                /* Ȥؿ */
                gv[gv_num].f_num = 0;
                for(l=0; l<f_info[i].f_num; l++){
                    if(CheckGvUse(func[f_info[i].f[l]].id,temp_buf.id[k])){
                        use_gv[gv[gv_num].f_num] = f_info[i].f[l];
                        gv[gv_num].f_num++;
                    }
                }
                /* Ȥؿֹ */
                gv[gv_num].f = spdMalloc(gv[gv_num].f_num*sizeof(int));
                for(l=0; l<gv[gv_num].f_num; l++){
                    gv[gv_num].f[l] = use_gv[l];
                }

                gv_num++;
            }
            spdFreeObjIdArray(temp_buf);
        }
        spdFree(use_gv);
    }

    select_gv = -1;                         /* ѿϻϤ򤵤Ƥʤ */

    MakeEdgeGv();                           /* Ʊѿõ */
    MakeEdgeData();                         /* ؿθƤӽФطĴ */

    ChangeDrawFunc();                       /* ؿɽ뤫ɤ */
    ChangeDrawGv();                         /* ѿɽ뤫ɤ */
    ChangeDrawName();                       /* ؿ̾ɽ */
    ChangeDrawFile();                       /* ɤΥե̾ */


    /* ΰ賫 */
    spdFree(have_num);
    spdFree(have_lan);
    /* ѿΰ */
    spdFreeObjIdArray(file_buf);
    spdFreeObjIdArray(gv_buf);
    spdFreeObjIdArray(func_buf);
    
    return;
}

/* Ʊѿõ */

void MakeEdgeGv(void)
{
    int i,j;
    int count;

    for(i=0; i<gv_num; i++){
        /* 夲 */
        count = 0;                          /* Ʊѿο */
        for(j=0; j<gv_num; j++){
            if(gv[i].iid == gv[j].iid){
                count++;
            }
        }

        /* ΰ */
        gv[i].g_num = count;
        gv[i].g = spdMalloc(count*sizeof(int));

        /* ͤγǼ */
        count = 0;
        for(j=0; j<gv_num; j++){
            if(gv[i].iid == gv[j].iid){
                gv[i].g[count] = j;
                count++;
            }
        }
    }
}

/* ʬƤӽФƤؿõ */

void MakeEdgeData(void)
{
    int i,j,k;
    SpdObjId      temp_id;
    SpdObjIdArray expr_buf;
    int fromID;

    /* åο */
    edge_num = 0;
    for (i=0; i<func_num;i++) {
        for (j=0; j<func_num; j++) {
            if (j == i) continue;
            temp_id  = spdGetARelObj(func[j].id,"decl_ident","declarator_id");
            expr_buf = spdGetRelObjSortedArray(temp_id,"ident_ref","identifier_id"
                                               ,NULL,spdCompareObjIdName);
            /* expr_idäƤʤн񤭽Ф */
            for (k=0; k<expr_buf.size; k++) {
                if (func[i].id == expr2func(expr_buf.id[k])) {
                    edge_num++;
                    /* break; */  /* 󥯤ϰļФ */
                }
            }
            spdFreeObjIdArray(expr_buf);
        }
    }

    /*  */
    edge = spdMalloc(sizeof(EDGE)*edge_num);
    edge_num = 0;

    /* å */
    for (i=0; i<func_num;i++) {
        fromID = i;
        for (j=0; j<func_num; j++) {
            if (j == i) continue;
            temp_id  = spdGetARelObj(func[j].id,"decl_ident","declarator_id");
            expr_buf = spdGetRelObjSortedArray(temp_id,"ident_ref","identifier_id"
                                               ,NULL,spdCompareObjIdName);
            /* expr_idäƤʤн񤭽Ф */
            for (k=0; k<expr_buf.size; k++) {
                if (func[i].id == expr2func(expr_buf.id[k])) {
                    edge[edge_num].from   = fromID;
                    edge[edge_num].to     = j;
                    /* ХեåȤ */
                    temp_id = spdGetARelObj(expr_buf.id[k],"expr_expr","inner_expression_id");
                    edge[edge_num].offset = spdGetOffset(spdGetARelId(temp_id,expr_buf.id[k],"expr_expr"));
                    edge_num++;
                    /* break; */  /* 󥯤ϰļФ */
                }
            }
            spdFreeObjIdArray(expr_buf);
        }
    }

    return;
}

/* ؿѿȤäƤ뤫 */

int CheckGvUse (SpdObjId func_id, SpdObjId gv_id)
{
    int i;
    SpdObjId decr_id  = gv_id;
    SpdObjId ident_id = spdGetARelObj(decr_id,"decl_ident","declarator_id");
    SpdObjIdArray expr_buf;

    expr_buf = spdGetRelObjSortedArray(ident_id,"ident_ref","identifier_id"
                                       ,NULL,spdCompareObjIdName);
    for(i=0;i<expr_buf.size;i++){
        if(func_id == expr2func(expr_buf.id[i])) {
            spdFreeObjIdArray(expr_buf);
            return TRUE;                    /* սǤȤäƤɤ */
        }
    }
    spdFreeObjIdArray(expr_buf);
    return FALSE;
}

/* expression Τؿ declarator ID ֤ */

int expr2func (int expr_id)
{
    int tmp_id,tmp2_id;
    tmp_id = expr_id;
    for (;;){
        tmp2_id = spdGetARelObj(tmp_id,"expr_expr","inner_expression_id");
        if (tmp2_id == -1) { break; }
        tmp_id = tmp2_id;
    }
    tmp_id = spdGetARelObj(tmp_id,"blk_expr","children_expression_id");
    for (;;){
        tmp2_id = spdGetARelObj(tmp_id,"blk_blk","children_block_id");
        if (tmp2_id == -1) { break; }
        tmp_id = tmp2_id;
    }
    tmp_id = spdGetARelObj(tmp_id,"func_body","block_id");
    tmp_id = spdGetARelObj(tmp_id,"decl_opt","optionaldecl_id");
    return tmp_id;
}

/******************************************************************************/
/* ؿѿХ⥸塼                                               */
/* !! 2ż(Ȥʤʤ)                                       */
/******************************************************************************/
/* file_id 餽Υե˴ޤޤؿѿArray              */
/*  : file_id (եdeclaration_id)                                  */
/*  : func_buf (ؿdeclaration_id), gv_buf (ѿdeclaration_id)  */

void out_func_gv(SpdObjId file_id)
{
    int i,j;
    SpdRel ident_rel;
    int offset;
    int count_func = 0;
    int count_gv   = 0;
    SpdObjIdArray decl_buf, decr_buf;

    /* file  declaration Ф */
    decl_buf = spdGetRelObjSortedArray(file_id,"file_decl","file_id"
                                       ,NULL,spdCompareObjIdName);  
    /* ؿѿο */
    for(i=0; i<decl_buf.size; i++){
        if(spdGetAttrValInt(decl_buf.id[i],"sort") == DECL_FUNCDEF){
            count_func++;
        }
        else if(spdGetAttrValInt(decl_buf.id[i],"sort") == DECL_NORMAL){
            decr_buf = spdGetRelObjSortedArray(decl_buf.id[i],"decl_decl","declaration_id"
                                               ,NULL,spdCompareObjIdName);
            for(j=0; j<decr_buf.size; j++){
                if(spdGetAttrValInt(decr_buf.id[j],"sort") == DECL_VARIABLE){
                    /* include ѿν */
                    ident_rel = spdGetARel(decr_buf.id[j], "decl_ident", "declarator_id");
                    offset = spdGetAbsoluteOffset(ident_rel.relationId,file_id);
                    if(!spdIsInHeaderFile(file_id,offset)){
                        count_gv++;
                        break;
                    }
                }
            }
            spdFreeObjIdArray(decr_buf);
        }
    }

    /* ΰ & */
    spdFreeObjIdArray(func_buf);
    func_buf.id   = (SpdObjId*)spdMalloc(count_func * sizeof(SpdObjId));
    func_buf.size = count_func;
    spdFreeObjIdArray(gv_buf);
    gv_buf.id   = (SpdObjId*)spdMalloc(count_gv * sizeof(SpdObjId));
    gv_buf.size = count_gv;

    count_func = 0;
    count_gv   = 0;
    for(i=0; i<decl_buf.size; i++){
        if(spdGetAttrValInt(decl_buf.id[i],"sort") == DECL_FUNCDEF){
            func_buf.id[count_func] = decl_buf.id[i];
            count_func++;
        }
        else if(spdGetAttrValInt(decl_buf.id[i],"sort") == DECL_NORMAL){
            decr_buf = spdGetRelObjSortedArray(decl_buf.id[i],"decl_decl","declaration_id"
                                               ,NULL,spdCompareObjIdName);
            for(j=0; j<decr_buf.size; j++){
                if(spdGetAttrValInt(decr_buf.id[j],"sort") == DECL_VARIABLE){
                    /* include ѿν */
                    ident_rel = spdGetARel(decr_buf.id[j], "decl_ident", "declarator_id");
                    offset = spdGetAbsoluteOffset(ident_rel.relationId,file_id);
                    if(!spdIsInHeaderFile(file_id,offset)){
                        gv_buf.id[count_gv] = decl_buf.id[i];
                        count_gv++;
                        break;
                    }
                }
            }
            spdFreeObjIdArray(decr_buf);
        }
    }
    spdFreeObjIdArray(decl_buf);
}
