/* 
 * Program:         $RCSfile: main.c,v $  $Revision: 30.9 $
 * 
 * Purpose:         OpenGL & Tcl/Tk main program.
 *
 * Author:          K.Yasuhara  2000/07/01
 *                  S.Yamamoto  2000/07/01
 *
 * (C) Copyright:   K.Yasuhara and S.Yamamoto  2000 - 2003
 *                  This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: main.c,v 30.9 2003/06/15 04:47:58 yamamoto Exp yamamoto $";
#endif

#include <math.h>
#include <stdio.h>
#include <Sapid/Sapid.h>
#include "my.h"

#ifndef VCRGL_TCL_LIB_DIR   
#define VCRGL_TCL_LIB_DIR           "/usr/local/Sapid/lib"
#endif

/* ᥤؿ */

int main(int argc, char *argv[])
{
    Tk_Main( argc, argv, my_init );
    return 0;
}

/*  */

int my_init(Tcl_Interp *interp)
{
    /* Ķå */
    if (Tcl_Init(interp)  == TCL_ERROR) return TCL_ERROR;
    if (Tk_Init(interp)   == TCL_ERROR) return TCL_ERROR;
    if (Togl_Init(interp) == TCL_ERROR) return TCL_ERROR;

    /* ٥ȴؿ */
    Togl_CreateFunc ( create_cb  );         /* Widget */
    Togl_DisplayFunc( display_cb );         /* ̳ */
    Togl_ReshapeFunc( reshape_cb );         /* ̥ѹ */
    Togl_DestroyFunc( destroy_cb );         /* λ */

    /* TclȤΥ󥿥ե */
    Tcl_CreateCommand(interp, "GetZ", GetZ,
                      (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateCommand(interp, "SetSita", SetSita,
                      (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateCommand(interp, "GetClickedObjId", GetClickedObjId,
                      (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateCommand(interp, "GetIdSort_tcl", GetIdSort_tcl,
                      (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateCommand(interp, "FindFunc_tcl", FindFunc_tcl,
                      (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateCommand(interp, "GetFuncNum_tcl", GetFuncNum_tcl,
                      (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateCommand(interp, "GetFileName_tcl", GetFileName_tcl,
                      (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    Tcl_CreateCommand(interp, "IdToFuncNum_tcl", IdToFuncNum_tcl,
                      (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
    /* OpenGL åѴؿ */
    Togl_CreateCommand("SetObjPos", SetObjPos);
    Togl_CreateCommand("ChangeFont", ChangeFont);
    Togl_CreateCommand("ChangeMode", ChangeMode);
    Togl_CreateCommand("ChangeDrawFunc_From", ChangeDrawFunc_From);
    Togl_CreateCommand("ChangeDrawFunc_To", ChangeDrawFunc_To);
    Togl_CreateCommand("ChangeDrawFunc_uAll", ChangeDrawFunc_uAll);
    Togl_CreateCommand("ChangeDrawFunc_dAll", ChangeDrawFunc_dAll);
    Togl_CreateCommand("ChangeDrawFunc_NOTUSE", ChangeDrawFunc_NOTUSE);
    Togl_CreateCommand("ChangeDrawFunc_Reset", ChangeDrawFunc_Reset);
    Togl_CreateCommand("ChangeViewObj", ChangeViewObj);
    Togl_CreateCommand("ChangeViewName", ChangeViewName);
    Togl_CreateCommand("DstMove", DstMove);
    Togl_CreateCommand("ChangeScale", ChangeScale);
    Togl_CreateCommand("ChangeViewMode", ChangeViewMode);

    Togl_CreateCommand("Mouse1_on",     Mouse1_on);
    Togl_CreateCommand("Mouse1_motion", Mouse1_motion);
    Togl_CreateCommand("Mouse1_double", Mouse1_double);
    Togl_CreateCommand("Mouse2_on",     Mouse2_on);
    Togl_CreateCommand("Mouse2_motion", Mouse2_motion);
    Togl_CreateCommand("Mouse4_on",     Mouse4_on);
    Togl_CreateCommand("Mouse5_on",     Mouse5_on);

    Togl_CreateCommand("SelectFunc_tcl", SelectFunc_tcl);

    Togl_CreateCommand("ChangeViewGv", ChangeViewGv);
    Togl_CreateCommand("MoveFile", MoveFile);
    Togl_CreateCommand("MoveFileRight", MoveFileRight);
    Togl_CreateCommand("MoveFileLeft", MoveFileLeft);
    Togl_CreateCommand("MoveTOP", MoveTOP);

    /* Tclץλ */
    Tcl_SetVar(interp, "tcl_rcFileName", VCRGL_TCL_LIB_DIR "/face.tcl",
               TCL_GLOBAL_ONLY);
    return TCL_OK;
}

/*
 * ٥ȴؿ
 */

/* Widget˰٤ƤФ롥 */

void create_cb(struct Togl *togl)
{
    /* ȿ͸̵ */
    GLfloat materialDiffuse[] = {0.0f, 0.0f, 0.0f, 1.0f};
    glMaterialfv(GL_FRONT, GL_DIFFUSE, materialDiffuse);
    /* طʿ */
    glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    /* ǥ */
    glShadeModel(GL_SMOOTH);
    /* ǥץƥȤԤ */
    glEnable(GL_DEPTH_TEST);
    /* ͭˤ(Ʃˤ) */
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    /* Ȥ */
    initLight();

    /* Υѥ */
    glLineStipple(1,0x0003);

    /* ѿ */
    win_w = Togl_Width( togl );             /* åȤ */
    win_h = Togl_Height( togl );            /* åȤι⤵ */

    eye.x = 10.0f; eye.y = 1.0f;  eye.z = 1.0f; /* ܤΰ */
    dst.x = 0.0f;  dst.y = 0.0f;  dst.z = 0.0f; /*  */
    top.x = 0.0f;  top.y = 0.0f;  top.z = 1.0f; /* 볦ξ٥ȥ */
    zoom  = 60.0f; aspect= 1.0f;            /*  */
    near  = 0.5f;  far   = 30.0f;           /* /󥯥å */
    sita  = asin((eye.y-dst.y)/PosDiff_XY(eye,dst));

    scale = 1.0;                            /* Ψ */
    func_scale = 1000;                      /* ؿν̾Ψ */

    viewmode = NORMAL;                      /* ӥ塼⡼ */
    drawmode = FIRST;                       /* ⡼ */
    drawfunc = NEAR;                        /* ɽʪ */
    drawname = NEAR;                        /* ̾ɽ */
    fontsize = MIDIUM;                      /* եȥ */
    drawgv   = NOTHING;                     /* ѿɽ */

    /* ؿ/åɤ߽Ф */
    MakeGraphData();
}

/* ꡥ */

void initLight(void)
{
    GLfloat ambientLight0[] = {1.0f, 1.0f, 1.0f, 1.0f}; /* Ķ */
    GLfloat positionLight0[]= {10.0f, 10.0f, 20.0f, 1.0f}; /*  */
    /*  */
    glLightfv(GL_LIGHT0, GL_AMBIENT, ambientLight0);
    glLightfv(GL_LIGHT0, GL_POSITION, positionLight0);
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
}

/* OpenGL  */
void display_cb(struct Togl *togl)
 {
    /* ̤Υꥢ */
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    /* (̤ξˤ) */
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(zoom, aspect, near, far);
    gluLookAt(eye.x, eye.y, eye.z, dst.x, dst.y, dst.z, top.x, top.y, top.z);
    /* ʪΤ */
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    MakeView();                             /*  */
    Togl_SwapBuffers( togl );
}

/* ̥ѹ˸ƤФ롥 */

void reshape_cb(struct Togl *togl)
{
    int w = Togl_Width( togl );             /* åȤ */
    int h = Togl_Height( togl );            /* åȤι⤵ */

    glViewport(0, 0, (GLsizei)w, (GLsizei)h);
    /* ֥Ȥ礭Ѥʤι */
    zoom = 360.0/PI * atan(tan(zoom/360*PI) * (double)h/win_h);
    aspect = (double)w / h;
    win_w = w;
    win_h = h;
}

/* λ */

void destroy_cb(struct Togl *togl)
{
    spdFree(func);
    spdFree(gv);
    spdFree(edge);
    spdFree(f_info);
}

/*
 * ֥Ȥμ/补
 */

/* SDBɤ߹ */

void ReadFuncData(void)
{
    MakeGraphData();  /*  */
}

/* ߤξ󤫤鳨ؿƤӽФ */

void MakeView(void)
{
    /*****************************    *******************************/
    /* ƩƸʪΤȾƩʪΤƤʤФʤʤ */
    /* ȾƩʪΤ GL_AMBIENT_AND_DIFFUSE ǿ򤹤               */
    /*   ( DIFFUSE ᤹ͤ)                                  */
    /********************************************************************/

    DrawXYZ();                              /* ɽ */
    DrawPoint(dst, 5.0f);                   /* ɽ */

    if(viewmode == NORMAL){
        DrawEdge();                         /* ؿ֥åɽ */

        if(drawgv != NOTHING)
            DrawGv();                       /* ѿɽ */
        DrawFunc();                         /* ؿɽ */

        DrawFileName();                     /* ե̾+פɽ */
    } else {
        DrawEdge();                         /* ؿ֥åɽ */
        DrawFuncTOP();                      /* ؿɽ */
    }
}

/******************************************************************************/

#ifdef TEST_initDisplayList

/*
 * ǥץ쥤ꥹ ѤѴؿ(ƥ)
 */

#define D_XYZ   1
#define D_DST   2
#define D_EDGE  4
#define D_GV    8
#define D_FUNC  16
#define D_LAST  32
#define D_OBJ   24
#define D_ALL   63

/* ǥץ쥤ꥹȽ */

void initDisplayList(void)
{
    /*  */
    glNewList(D_ALL,GL_COMPILE);
    /*  */
    glNewList(D_XYZ,GL_COMPILE);    DrawXYZ();            glEndList();

    /*  (饤/ɥå) */
    glNewList(D_DST,GL_COMPILE);    DrawPoint(dst, 5.0f); glEndList();

    /* ؿ֥å */
    glNewList(D_EDGE,GL_COMPILE);   DrawEdge();           glEndList();
    /* ֥ (ޥȽ) */
    glNewList(D_OBJ,GL_COMPILE);
    /* ѿ */
    glNewList(D_GV,GL_COMPILE);   DrawGv();             glEndList();
    /* ؿ */
    glNewList(D_FUNC,GL_COMPILE); DrawFunc();           glEndList();
    glEndList();
    /* ե̾/ */
    glNewList(D_LAST,GL_COMPILE);   DrawFileName();       glEndList();
    glEndList();
}

#endif /* TEST_initDisplayList */
