/* 
 * Program:         $RCSfile: my.h,v $  $Revision: 30.5 $
 * 
 * Purpose:         OpenGL & Tcl/Tk main program.
 *
 * Author:          K.Yasuhara  2000/07/01
 *                  S.Yamamoto  2000/07/01
 *
 * (C) Copyright:   K.Yasuhara and S.Yamamoto  2000 - 2003
 *                  This file is a product of the project Sapid.
 */

#include <GL/glut.h>
#include "togl.h"
#include <string.h>
#include <tcl.h>
#include <tk.h>

/****************************************************************************
  
 ****************************************************************************/
/* 3ɸ */
typedef struct {
    GLdouble x;
    GLdouble y;
    GLdouble z;
} POS;

/* ؿ */
typedef struct {
    POS      pos;                           /* ɽ(X,Y,Z) */
    double   ds;                            /* XZ˺ɸ()  */
    double   l;                             /* XZ˺ɸ(Ĺ)  */

    GLdouble h;                             /* Ĺ(ؿιԿ/100) */
    GLdouble r;                             /*  */
    GLbyte   *name;                         /* ؿ̾ */
    GLint    id;                            /* ؿID */
    int      file_id;                       /* եֹ */
    int      length;                        /* ؿĹ */

    int      near;                          /* 򤵤줿ؿܤƤ뤫ɤ */
    int      view;                          /* δؿɽ뤫ɤ */
    int      label;                         /* ̾ɽ뤫ɤ */
} FUNC;

/* ѿ */
typedef struct {
    POS    pos;                             /* ɽ */
    GLbyte *name;                           /* ѿ̾ */
    GLint  id;                              /* ѿID */
    int    iid;                             /* ident_id */
    int    file_id;                         /* եֹ */

    int    view;                            /* ɽ뤫ɤ */

    int    *f;                              /* ȤäƤؿؤΥ(ֹ) */
    int    f_num;                           /* ȤäƤؿο */
    int    *g;                              /* ƱѿؤΥ */
    int    g_num;                           /* Ʊѿο */
} GV;

/* å */
typedef struct {
    GLint from;                             /* ƤӽФֹ */
    GLint to;                               /* ƤФֹ */
    int   offset;                           /* а */
} EDGE;

/* ե */
typedef struct {
    GLbyte *name;                           /* ե̾ */
    int id;                                 /* եID */
    int view;                               /* ɽƤ뤫ɤ */
    double z;                               /* Zɸ */
    double r;                               /* Ⱦ */

    int *f;                                 /* ؿֹ */
    int f_num;                              /* ؿο */
    int *g;                                 /* ѿֹ */
    int g_num;                              /* ѿο */
} FILEINFO;

/****************************************************************************
  ޥ
  ****************************************************************************/

#define NORMAL   0  /* Ρޥӥ塼 */
#define TOP      1  /* ȥåץӥ塼 */

#define DETAIL   0  /* ܺ٥⡼ */
#define FIRST    1  /* ⡼ */
#define TINY     2  /* ʰץ⡼ */

#define ALL      0  /* ֥ɽ */
#define NEAR     1  /* ܤΤɽ */
#define SAMEFILE 2  /* ƱեΤɽ */
#define USEING   3  /* ΤΤΤɽ */
#define NOTHING  4  /* ɽʤ */

#define CATCH    1  /* ޥʪΤϤǤ  */
#define NO_CATCH 0  /*               ϤǤʤ*/

#define SPEED    5  /* ˥᡼󥹥ԡ(®) */
#define SLICES   8  /* ߤʬ */

#define SMALL    10 /* եȡ */
#define MIDIUM   12 /* եȡ */
#define LARGE    18 /* եȡ */

/* 
 * #define TRUE     1
 * #define FALSE    0
 */

#define PI       3.1415926535       /* "math.h"ƤϤ */ 
#define SIN5     0.0871557427
#define COS5     0.9961946981

/****************************************************************************
  ֥ ѿ
 ****************************************************************************/
FUNC *func;       /* ؿ */
int func_num;     /* ؿο */
POS func_old_pos; /* 濴عԤκɸ */
int func_main;    /* Main ؿֹ */

GV *gv;           /* ѿ */
int gv_num;       /* ѿο */

EDGE *edge;       /* ؿ֤Υå */
int edge_num;     /* åο */

FILEINFO *f_info; /* ե */
int file_num;     /* եο */

/****************************************************************************
  ѿ
 ****************************************************************************/
int viewmode;                   /* ӥ塼⡼(ޥ) */
int drawmode;                   /* ⡼(ޥ) */
int drawfunc;                   /* ɽʪ(ޥ) */
int drawname;                   /* ̾ɽ(ޥ) */
int drawgv;                     /* ѿɽ/ɽ(Bool) */
int fontsize;                   /* եȥ */

int win_w;                      /* ɥ */
int win_h;                      /* ɥι⤵ */

int select_func;                /* 򤵤Ƥؿֹ */
int select_gv;                  /* 򤵤Ƥѿֹ */

POS eye;                        /* ΰ */
POS dst;                        /*  */
POS top;                        /* 볦ξ٥ȥ */
GLdouble zoom,aspect;           /*  */
GLdouble near,far;              /* /󥯥å */
GLdouble sita;                  /* ˺ɸγ */

GLdouble scale;                 /* Ψ */
int      func_scale;            /* ؿν̾Ψ: length/func_scale=ؿĹ */

GLint mouse_on_x,  mouse_on_y;  /* ޥ򥯥å */
int   mouse_catch;              /* ޥʪΤϤǤ뤫ɤ(ޥ) */
int   mouse_catch_id;           /* ޥϤǤʪΤObjectID */

/****************************************************************************
  ץȥ
 ****************************************************************************/

/* Tcl/Tk Ϣ */
int SetSita(ClientData clientData, Tcl_Interp *interp,
            int argc, char *argv[]);
int GetZ(ClientData clientData, Tcl_Interp *interp,
         int argc, char *argv[]);
int GetClickedObjId(ClientData clientData, Tcl_Interp *interp,
                    int argc, char *argv[]);
int GetIdSort_tcl(ClientData clientData, Tcl_Interp *interp,
                  int argc, char *argv[]);
int FindFunc_tcl(ClientData clientData, Tcl_Interp *interp,
                 int argc, char *argv[]);
int GetFuncNum_tcl(ClientData clientData, Tcl_Interp *interp,
                   int argc, char *argv[]);
int GetFileName_tcl(ClientData clientData, Tcl_Interp *interp,
                    int argc, char *argv[]);
int IdToFuncNum_tcl(ClientData clientData, Tcl_Interp *interp,
                    int argc, char *argv[]);

int SetObjPos(struct Togl *togl, int argc, char *argv[]);
int ChangeFont(struct Togl *togl, int argc, char *argv[]);
int ChangeMode(struct Togl *togl, int argc, char *argv[]);

int ChangeDrawFunc_From(struct Togl *togl, int argc, char *argv[]);
int ChangeDrawFunc_To(struct Togl *togl, int argc, char *argv[]);
int ChangeDrawFunc_uAll(struct Togl *togl, int argc, char *argv[]);
int ChangeDrawFunc_dAll(struct Togl *togl, int argc, char *argv[]);
int ChangeDrawFunc_NOTUSE(struct Togl *togl, int argc, char *argv[]);
int ChangeDrawFunc_Reset(struct Togl *togl, int argc, char *argv[]);

int ChangeViewObj(struct Togl *togl, int argc, char *argv[]);
int ChangeViewName(struct Togl *togl, int argc, char *argv[]);
int DstMove(struct Togl *togl, int argc, char *argv[]);
int ChangeScale(struct Togl *togl, int argc, char *argv[]);
int ChangeViewMode(struct Togl *togl, int argc, char *argv[]);

int Mouse1_on(struct Togl *togl, int argc, char *argv[]);
int Mouse1_motion(struct Togl *togl, int argc, char *argv[]);
int Mouse1_double(struct Togl *togl, int argc, char *argv[]);
int Mouse2_on(struct Togl *togl, int argc, char *argv[]);
int Mouse2_motion(struct Togl *togl, int argc, char *argv[]);
int Mouse4_on(struct Togl *togl, int argc, char *argv[]);
int Mouse5_on(struct Togl *togl, int argc, char *argv[]);

int SelectFunc_tcl(struct Togl *togl, int argc, char *argv[]);

int ChangeViewGv(struct Togl *togl, int argc, char *argv[]);
int MoveFile(struct Togl *togl, int argc, char *argv[]);
int MoveFileRight(struct Togl *togl, int argc, char *argv[]);
int MoveFileLeft(struct Togl *togl, int argc, char *argv[]);
int MoveTOP(struct Togl *togl, int argc, char *argv[]);

/* main.c */
int  my_init(Tcl_Interp *interp);    /* ؿ */
void create_cb (struct Togl *togl);  /* åȺ */
void display_cb(struct Togl *togl);  /*  */
void reshape_cb(struct Togl *togl);  /* ɥѹ */
void destroy_cb(struct Togl *togl);  /* λ */
void initLight(void);                    /* ν */
void MakeView(void);                     /* ̳ */

/* view.c */
void ChangeDrawGv(void);                    /* ѿɽʪ */
void ChangeDrawFunc(void);                  /* ɽʪѹ */
void SerchNear(void);                       /* ܴطĴ */
void ChangeDrawFile(void);                  /* ե̾ɽѹ */
void ChangeDrawName(void);                  /* ̾ɽѹ */

/* parts.c */
void DrawFunc(void);                       /* ؿ(NORMAL) */
void DrawFuncTOP(void);                    /* ؿ(TOP) */
void DrawEdge(void);                       /* ؿ֤Υå */
void DrawGv(void);                         /* ѿ */
void DrawFileName(void);                   /* ե̾ */

void DrawXYZ(void);                        /* XYZ  */
void DrawPoint (POS pos, GLdouble r);  /*  */
void DrawTitle(void);                      /* ȥ */

/* etc.c */
GLdouble PosDiff (POS from, POS to);    /* 2֤εΥ֤*/
GLdouble PosDiff_XY (POS from, POS to); /* XYʿ̾εΥ֤ */
POS PosPlus (POS pos1, POS pos2);       /* ٥ȥ */
POS PosMinus (POS pos1, POS pos2);      /* ٥ȥκ */
POS PosMult (POS pos, double c);        /* ٥ȥ */
GLdouble MakeAlpha (FUNC func);         /* ͤꤹ */
int IdToFuncNum(int id);                /* ObjectID  ؿ֤̾ */
int IdToGvNum(int id);                  /* ObjectID  ѿ֤̾ */
POS  SetPos(GLdouble x, GLdouble y, GLdouble z); 
                                        /* ɸ POS  */

/* funcdata.c */
void MakeGraphData(void);  /* ΡɤȥåΥǡ() */
