/* 
 * Program:             $RCSfile: appli1.c,v $  $Revision: 30.16 $
 * 
 * Purpose:             ޥθƤӽФŸбĴ٤롥
 * 
 * Author:              T.Mimura  1993/12/01
 *                      S.Yamamoto  1994/09/01
 * 
 * (C) Copyright:       T.Mimura and S.Yamamoto  1994 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
"$Id: appli1.c,v 30.16 2003/05/29 04:21:21 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "appli1.h"

SpdConstString programName;

char    *usagemes = "\
USAGE\n\
    %s [option][source file][preprocessed file][char|line,column]\n\
SYNOPSIS\n\
    -v: Verbose mode.\n\
    -V: More verbose mode.\n";

char    *srcFname = NULL;           /* ե̾ */
char    *preFname = NULL;           /* ץץåϥե̾ */
int     srcLine = 0, srcColumn = 0; /* Ĵ٤ʸΰ֡ */
int     srcChar = 0;                /* ʸʸܤ */
FBUF    srcBuf;                     /* եΥХåե */
FBUF    preBuf;                     /* ץץåϤΥХåե */

SpdBoolean  verbose;

char *putToNewline(FILE *fp, char *str);

void usage(void)
{
    spdErrorExit(usagemes, programName);
}

void analyzeOption(int argc, char *argv[])
{
    int     i;
    
    srcFname = NULL;
    preFname = NULL;
    if (argc < 2) {
        usage();
    }
    for (i = 1; i < argc; i++) {
        if (*argv[i] == '-')  {
            switch (*(argv[i] + 1)) {
              case 'v':
                verbose = TRUE;
                break;
              case 'V':
                verbose = TRUE;
                CPPinfoVerbose = TRUE;
                break;
              default:
                spdErrorExit("Wrong option.\n");
            }
        } else {
            if (srcFname == NULL) {
                srcFname = argv[i];
                if (verbose == TRUE) {
                    fprintf(stderr, "Source file: \"%s\".\n", srcFname);
                }
                continue;
            } else if (preFname == NULL) {
                preFname = argv[i];
                if (verbose == TRUE) {
                    fprintf(stderr, "Preprocessed file: \"%s\".\n", preFname);
                }   
                continue;   
            } else if (srcLine == 0 && srcColumn == 0) {
                int     n, a1, a2;

                n = sscanf(argv[i], "%d,%d", &a1, &a2);
                switch (n) {
                  case 1:
                    if (a1<1) spdErrorExit("Wrong char.\n");
                    srcChar = a1;
                    if (verbose == TRUE) {
                        fprintf(stderr, "Char: %d.\n", srcChar);
                    }
                    break;
                  case 2:
                    if (a1 < 1 || a2 < 1) {
                        spdErrorExit("Invalid line or column.\n");
                    }
                    srcLine = a1;
                    srcColumn = a2;
                    if (verbose == TRUE) {
                        fprintf(stderr, "Line %d, Column %d.\n",
                                srcLine, srcColumn);
                    }
                    break;
                  default:
                    usage();
                    break;
                }
                continue;
            } else {
                usage();
            }
        }
    }
    if (srcFname == NULL || preFname == NULL ||
        (srcLine == 0 && srcColumn == 0 && srcChar == 0)) {
        usage();
    }
}

int dotCtoDotI(void)
{
    int                     i, r;
    MacroCallRegion         pos;
    MacroExpandRegionQueue  equeue;
    
    pos.type = CALL_FILE;
    pos.fname = srcFname;

#ifdef PIDB_USE_FILENAME_INDEX
    pos.fname_idx = pidbConvFileId(srcFname);
#endif

    pos.start = pos.end = srcChar;
    createMacroExpandRegionQueue(&equeue, CPPinfoQueueExtent);
    
    r = completeMacroExpand(&pos, &equeue);
    if (verbose != TRUE) {
        printf("%d\n", r);
    }
    for (i = 0; i < r; i++) {
        MacroExpandRegion   a;
        int                 l, c;
        
        a = popMacroExpandRegionQueue(&equeue);
        charToLineColumn(preBuf.buf, preBuf.size, a.start, &l, &c);
        if (verbose == TRUE) {
            fprintf(stderr,
                    "%d: File \"%s\", line %d, column %d, offset %d.\n",
                    i + 1, a.fname, l, c, a.start);
        } else {
            printf("%s %d %d %d\n", a.fname, l, c, a.start); 
        }
    }
    return (r);
}

int main(int argc, char *argv[])
{
    programName = spdBasename(argv[0]);
    analyzeOption(argc, argv);

    if (spdInitializePidbCache(smuGetFileIdByName(preFname)) != 0) {
        spdErrorExit("\"%s\": Can't initialize.", preFname);
    }

    /* ƥեɤ߹ߡ */
    srcBuf.size = spdReadFileInBufByName(srcFname, &(srcBuf.buf));
    preBuf.size = spdReadFileInBufByName(preFname, &(preBuf.buf));
    
    if (srcChar != 0) {
        if (charToLineColumn(srcBuf.buf, srcBuf.size,
                             srcChar, &srcLine, &srcColumn) < 0) {
            spdErrorExit("Invalid char.\n");
        }
    } else {
        srcChar = lineColumnToChar(srcBuf.buf, srcBuf.size, srcLine, srcColumn);
        if (srcChar < 0) {
            spdErrorExit("Invalid line or column.\n");
        }
    }
    if (verbose == TRUE) {
        fprintf(stderr, "Character (offset %d).\n", srcChar);
        putToNewline(stderr, getHeadOfLine(srcBuf.buf, srcBuf.size, srcLine));
    }
    dotCtoDotI();

    return (EXIT_SUCCESS);
}
