/* 
 * Program:             $RCSfile: appli2.c,v $  $Revision: 30.15 $
 * 
 * Purpose:             ױѥץࡥ
 * 
 * Author:              T.Mimura  1993/12/01
 *                      S.Yamamoto  1994/09/01
 * 
 * (C) Copyright:       T.Mimura and S.Yamamoto  1994 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: appli2.c,v 30.15 2003/05/29 04:21:21 yamamoto Exp yamamoto $";
#endif

/* 
 * ".i"ΥޥŸ̤˴ޤޤ롤
 * ʸб".i"ʸ򸫤Ĥ롥
 * 
 * (1) 1993/12/13 
 * ¹Ի".c"ե̾ꤷʤƤư褦ѹ
 */

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "appli2.h"

SpdConstString programname;

char    *usageMes = "\
USAGE\n\
    %s [option] ifile line,column\n\
SYNOPSIS\n\
    -v: Verbose mode.\n\
    -V: More verbose mode.\n";

SpdConstString srcFname = NULL;   /* ".c"ե̾ */
char    *preFname = NULL;   /* ".i"ե̾ */
int     preLine, preColumn; /* ʸιԤȥࡥ */
int     preChar;            /* ʸoffset */
FBUF    srcBuf;             /* ".c"եɤ߹ߥХåե */
FBUF    preBuf;             /* ".i"եɤ߹ߥХåե */

SpdBoolean verbose = FALSE; /* verbose mode. */

char *putToNewline(FILE *fp, char *str);

void usage(void)
{
    spdErrorExit(usageMes, programname);
}

void analyzeOption(int argc, char *argv[])
{
    int     i;
    
    srcFname = NULL;
    preFname = NULL;
    preLine = preColumn = 0;
    if (argc < 3) usage();
    
    for (i = 1; i < argc; i++) {
        if (*argv[i] == '-') {
            switch (*(argv[i] + 1)) {
              case 'v':
              case 'V':
                verbose = TRUE;
                CPPinfoVerbose = TRUE;
                break;
              default:
                spdErrorExit("Invalid option.\n");
            }
        } else {
            if (preFname == NULL) {
                preFname = argv[i];
                continue;
            } else if (preLine == 0 && preColumn == 0) {
                int n;
                n=sscanf(argv[i], "%d,%d", &preLine, &preColumn);
                if (n != 2 || preLine < 1 || preColumn < 1) {
                    spdErrorExit("%d %d: Invalid line and/or column.\n",
                                 preLine, preColumn);
                }
                continue;
            } else {
                usage();
            }
        }
    }
    if (preFname==NULL || preLine==0 || preColumn==0) {
        usage();
    }
}

int dotItoDotC(void)
{
    int                 r;
    MacroExpandRegion   target;
    MacroCallRegion     result;
    int                 line, column;
    
    target.type  = EXPAND_FILE;
    target.start = preChar;
    target.end   = preChar;
    target.fname = preFname;

#ifdef PIDB_USE_FILENAME_INDEX
    target.fname_idx = pidbConvFileId(preFname);
#endif

    r = reverseParseAnOutputText(&target, &result);
    if ( r == SAPID_CPP_NOT_SUPPORTED ) {
        CPPinfoMessage("RESULT: бʸϡ̤ݡȤǤ\n" );
        printf(" %d\n", SAPID_CPP_NOT_SUPPORTED);
        return 0;
    } else if (r < 0) {
        CPPinfoMessage("RESULT: бʸϡˤ¸ߤޤ\n");
        printf(" -2\n");
        return 0;
    } else if ( r == 1 ) {
        CPPinfoMessage( "RESULT:бʸϡޥ˴ޤޤޤ\n" );
        printf(" -1\n" );
        return 0;
    } else {
        srcFname = result.fname;
        srcBuf.size = spdReadFileInBufByName(srcFname, &(srcBuf.buf));
        charToLineColumn(srcBuf.buf, srcBuf.size, result.start, &line, &column);
        CPPinfoMessage("RESULT: '%s' line %d  column %d  char %d\n",
                       result.fname, line, column, result.start);
        if (CPPinfoVerbose == FALSE) {
            printf("%s %d %d %d\n", result.fname, line, column, result.start);
        }
    }
    return (0);
}

int main(int argc, char *argv[])
{
    programname = spdBasename(argv[0]);
    analyzeOption(argc, argv);

    if (spdInitializePidbCache(smuGetFileIdByName(preFname)) != 0) {
        spdErrorExit("Can't initialize: \"%s\".", preFname);
    }

    preBuf.size = spdReadFileInBufByName(preFname, &(preBuf.buf));
    preChar = lineColumnToChar(preBuf.buf, preBuf.size, preLine, preColumn);
    if (verbose == TRUE) {
        fprintf(stderr, "%dʸܤǤ\n", preChar);
        putToNewline(stderr, getHeadOfLine(preBuf.buf, preBuf.size, preLine));
    }
    dotItoDotC();

    return (EXIT_SUCCESS);
}
