/* 
 * Program:             $RCSfile: cppchar.c,v $  $Revision: 30.14 $
 * 
 * Purpose:             "charConv.c"饤֥λѥץࡥ
 * 
 * 
 * Author:              T.Mimura  1993/12/01
 *                      S.Yamamoto  1994/09/01
 * 
 * (C) Copyright:       T.Mimura and S.Yamamoto  1994 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: cppchar.c,v 30.14 2003/05/29 04:21:22 yamamoto Exp yamamoto $";
#endif

/* 
 * ޥ˴ޤޤʤȤʬäƤ .c ʸб
 * .i ʸΰ֤Ĵ٤롥
 */

#include <stdio.h>
#include <Sapid/Sapid.h>

#define QUEUE_EXTENT    200

SpdConstString programname;
char    *usageMes =
    "Usage: %s *.c *.i line,column\n"
    "  *.cλΰ֤ʸб*.iʸΰ֤ĴٽϤ롥\n"
    "ϥեޥå\n"
    "    line column char\n"
    "顼Ĵ٤ʤä\n"
    "    -1\n";

int     line, column;
char    *cname = NULL, *iname = NULL;
int     iline, icolumn;
char    *cbuf, *ibuf;
int     clen, ilen;

SpdBoolean verbose;

void usage(void)
{
    spdErrorExit(usageMes, programname);
}

void    analyzeOption(int argc, char *argv[])
{
    int     i;
    
    cname = NULL;
    iname = NULL;
    line = column = 0;
    if (argc < 4) usage();
    
    for (i=1; i<argc; i++) {
        if (*argv[i] == '-') {
            switch (*(argv[i]+1)) {
              case 'v':
              case 'V':
                verbose = TRUE;
                CPPinfoVerbose = TRUE;
                break;
              default:
                spdErrorExit("Invalid option.\n");
            }
        } else {
            if (cname == NULL) {
                cname = argv[i];
                continue;
            } else if (iname == NULL) {
                iname = argv[i];
                continue;
            } else if (line == 0 && column == 0) {
                int     n;

                n = sscanf(argv[i], "%d,%d", &line, &column);
                if (n != 2 || line < 1 || column < 1) {
                    spdErrorExit("%d %d: Invalid line and/or column.\n",
                                 line, column);
                }
                continue;
            } else {
                usage();
            }
        }
    }
    if (cname == NULL || iname == NULL || line == 0 || column == 0) {
        usage();
    }
    return;
}

void convCtoI(void)
{
    int                     c, r, i;
    MacroExpandRegionQueue  qu;

    createMacroExpandRegionQueue(&qu, QUEUE_EXTENT);
    spdWarning("convCtoI(): cname \"%s\".\n", cname);
    clen = spdReadFileInBufByName(cname, &cbuf);
    spdWarning("convCtoI(): iname \"%s\".\n", cname);
    ilen = spdReadFileInBufByName(iname, &ibuf);
    c = lineColumnToChar(cbuf, clen, line, column);

    /* Ĵ٤ʸϡƬ鲿ʸܤ? */
    r = cppCharConvCtoI(cname, c, &qu, cbuf, clen, iname, ibuf, ilen);
    if (r == -2) {
        printf(" -1\n");
    } else if (r == -1) {
        r = 1;
    }
    printf("%d\n", r);
    if  (r == 0) {
        return;
    }
    for (i = 0; i < r; i++) {
        MacroExpandRegion   e;

        e = popMacroExpandRegionQueue(&qu);
        charToLineColumn(ibuf, ilen, e.start, &iline, &icolumn);
        printf("%d %d %d\n", iline, icolumn, e.start);
    }
}

int main(int argc, char *argv[])
{
    programname = spdBasename(argv[0]);
    analyzeOption(argc, argv);

    if (spdInitializePidbCache(smuGetFileIdByName(iname)) != 0) {
        spdErrorExit("Can't initialize: \"%s\".", iname);
    }
    convCtoI();

    return (EXIT_SUCCESS);
}
