/* 
 * Program:             $RCSfile: rcppchar.c,v $  $Revision: 30.13 $
 * 
 * Purpose:
 * 
 * Author:              T.Mimura  1993/12/01
 *                      S.Yamamoto  1994/09/01
 * 
 * (C) Copyright:       T.Mimura and S.Yamamoto  1994 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: rcppchar.c,v 30.13 2003/05/29 04:21:22 yamamoto Exp yamamoto $";
#endif

/* 
 *  "cppcharconv.c" Υ饤֥λѥץǤ
 * ޥ˴ޤޤʤȤʬäƤ "*.i" ʸбʸ
 * ɤΥե(إåޤ)Τɤΰ֤ˤΤĴ٤ޤ
 */

#include <stdio.h>
#include <Sapid/Sapid.h>

SpdConstString programname;
char    *usageMes =
    "Usage: %s *.i line,column\n"
    "  *.i λΰ֤ʸбʸɤΥ(إåޤ)"
    "ɤΰ֤ˤΤĴ٤ޤ\n"
    "ϥեޥå\n"
    "    filename line column char\n"
    "顼Ĵ٤ʤä\n"
    "    -1\n"
    "ʸ̤ݡȤä\n"
    "    (SAPID_CPP_NOT_SUPPORTED)\n";

static int      line, column;
static char     cname[FILENAME_MAX + 1], *iname = NULL;
static int      cline, ccolumn;
static char     *cbuf, *ibuf;
static int      clen, ilen;

void usage(void)
{
    spdErrorExit(usageMes, programname);
}

void analyzeOption(int argc, char *argv[])
{
    int     i;
    
    iname = NULL;
    line = column = 0;
    if (argc < 3) {
        usage();
    }
    for (i=1; i<argc; i++) {
        if (*argv[i] == '-') {
            switch (*(argv[i]+1)) {
              case 'v':
              case 'V':
                CPPinfoVerbose = TRUE;
                break;
              default:
                spdErrorExit("Wrong option.\n");
            }
        } else {
            if (iname == NULL) {
                iname = argv[i];
                continue;
            } else if (line == 0 && column == 0) {
                int n;
                n=sscanf(argv[i], "%d,%d", &line, &column);
                if (n!=2 || line<1 || column<1) {
                    spdErrorExit("%d %d: Invalid line and/or column.\n",
                                 line, column);
                }
                continue;
            } else {
                usage();
            }
        }
    }
    if (iname == NULL || line == 0 || column == 0) {
        usage();
    }
    return;
}

void convItoC(void)
{
    int     c, r;
    
    ilen = spdReadFileInBufByName(iname, &ibuf);
    c = lineColumnToChar(ibuf, ilen, line, column);
    /* Ĵ٤ʸƬ鲿ʸܤ */
    r = cppCharConvItoC(iname, c, ibuf, ilen, cname);
    /* ǽ".c"Υե̾ʬ롥 */
    if (r == SAPID_CPP_NOT_SUPPORTED) {
        printf("%d\n", SAPID_CPP_NOT_SUPPORTED);
    } else if (r < 0) {
        printf(" -1\n");
    } else {
        clen = spdReadFileInBufByName(cname, &cbuf);
        charToLineColumn(cbuf, clen, r, &cline, &ccolumn);
        printf("%s %d %d %d\n", cname, cline, ccolumn, r);
    }
}

int main(int argc, char *argv[])
{
    programname = spdBasename(argv[0]);
    analyzeOption(argc, argv);

    if (spdInitializePidbCache(smuGetFileIdByName(iname)) != 0) {
        spdErrorExit("Can't initialize: \"%s\".", iname);
    }
    convItoC();

    return (EXIT_SUCCESS);
}
