/* 
 * Program:             $RCSfile: rtester.c,v $  $Revision: 30.11 $
 * 
 * Purpose:             ƥȥץࡥ
 * 
 * Author:              T.Mimura  1993/12/01
 *                      S.Yamamoto  1994/09/01
 * 
 * (C) Copyright:       T.Mimura and S.Yamamoto  1994 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: rtester.c,v 30.11 2003/06/28 15:33:55 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "tester.h"

#define FIX_PIDB_TESTER_960820

static char     *usage =
    "USAGE\n"
    "     pidbRevTester filename\n"
    "SYNOPSIS\n"
    "     -o output_file: Specify output file.\n"
    "     -h:             Check also included file.\n"
    "     -v:             Verbose mode.\n";

char        *cname, *iname;
char        *cbuf, *ibuf;
int         clen, ilen;
SpdBoolean  verbose = FALSE;
FILE        *output;

SpdBoolean  checkIncluded = FALSE;

MacroExpandRegionQueue queue;

void print_usage(void)
{
    spdErrorExit(usage);
}

void setTestFileName(char *name)
{
    cname = spdStrcatDup(name, ".c");
    iname = spdStrcatDup(name, ".i");
    clen = spdReadFileInBufByName(cname, &cbuf);
    ilen = spdReadFileInBufByName(iname, &ibuf);
    if (verbose == TRUE) {
        fprintf(stderr, ".c file :\"%s\".\n.i file :\"%s\".\n", cname, iname);
    }
}

/* 
 * .c -> .i (ޥŸ)Ĵη̤Ȱפ뤫Υå
 * : ְ㤤ä
 * ʳ: ְ㤤ʤä
 */

int comparison(int ioffset, char *name, int coffset)
{
    MacroExpandRegion mac;
    int n, r, i;
    
    n = cppCharConvCtoI(name, coffset, &queue, cbuf, clen, iname, ibuf, ilen);
    
    /* Ĵ٤ .c ʸбʸ .i ե˲ʸΤ */
    if (n == -2) {
        /* бʸʤפȽФ ϴְ㤤 */
        return (-1);
    }
    if (n == -1) {
        n = 1;
    }
    /* n ʸ1ʸ .i ʸȰפ OK */
    r = -1;
    for (i = 0; i < n; i++) {
        mac = popMacroExpandRegionQueue(&queue);
        if (r != 1 && SPD_STREQ(mac.fname, iname) && (mac.start == ioffset)) {
            r = 1;
        }
    }   
    return (r);
}

/* 
 * бʸ include 줿եˤäΥå
 * (Υեɤ߹Ǥå롥 .c եϾ
 * ˤΤǡɬפϤʤ)
 * 
 * :      ְ㤤ä
 * ʳ: ְ㤤ʤä
 */

int checkIncludedFile(int ioffset, char *hname, int hoffset)
{
    char    *hbuf;
    int     r;
    
    if (checkIncluded != TRUE) {
        return (1);
    }
    spdReadFileInBufByName(hname, &hbuf);
    r = comparison(ioffset, hname, hoffset);
    spdFree(hbuf);
    return (r);
}

/* 
 * .c  .i ؤѴ 1ʸˤĤ
 * .i  .c ؤѴפ뤫å롥
 * :
 *     : ְ㤤ä
 *     ʳ: ְ㤤ʤä
 */

int check(int ioffset, char *name, int coffset)
{
    int r;
    
    /*
     * бʸ.c եˤȡinclude 줿ե
     * ˤȤǡ򿶤ʬ(®٤夵뤿)
     */
    if (!SPD_STREQ(cname, name)) {
        r = checkIncludedFile(ioffset, name, coffset);
        /* бʸΤե̾ .c ե̾˰פʤ
           (include줿ե) */
    } else {
        r = comparison(ioffset, cname, coffset);
    }
    return (r);
}

/* 
 * 1ʸˤĤƥå롥
 * :
 *     1: бʸְ㤤ʤ
 *     0: бʸʤ
 *     -1: бʸְ㤤
 */

int testACharacter(int ioffset)
{
    char    fname[FILENAME_MAX + 1];
    int     coffset;
    
#ifdef FIX_PIDB_TESTER_960820
    fname[0] = '\0';
#endif

    coffset = cppCharConvItoC(iname, ioffset, ibuf, ilen, fname);
    if (coffset == -1 || coffset == SAPID_CPP_NOT_SUPPORTED) {
        return (0);
    }
    if (check(ioffset, fname, coffset) < 0) {
        return (-1);
    }
    return (1);
}

/* 
 * եΤˤĤƥå
 */

void testWholeFile(void)
{
    int     i, linehead = TRUE, sharp = FALSE;
    
    i = 0;
    while (i < ilen) {
        if (linehead == TRUE) {
            linehead = FALSE;
            if (*(ibuf + i) == '#') {
                sharp = TRUE;
            } else {
                sharp = FALSE;
            }
        }
        if (*(ibuf + i) != '\n') {
            if (sharp == FALSE) {
                if (testACharacter(i) <0) {
                    int line, column;
                    charToLineColumn(ibuf, ilen, i, &line, &column);
                    fprintf(output, "miss %s  line %d  column %d\n",
                            iname, line, column);
                }
            }
        } else {
            linehead = TRUE;
        }
        fprintf(stderr, "%c", *(ibuf+i));
        i++;
    }
    return;
}

int main(int argc, char *argv[])
{
    int     i;
    
    output = stderr;
    if (argc<2) {
        print_usage();
    }
    
    for (i=1; i<argc; i++) {
        if (*argv[i] == '-') {
            switch (*(argv[i]+1)) {
              case 'h':
                checkIncluded = TRUE;
                break;
              case 'o':
                if (i+1 >= argc)
                    spdErrorExit("No output filename.\n");
                if (verbose == TRUE)
                    fprintf(stderr, "Output file \"%s\".\n", argv[i+1]);
                output = spdFopen(argv[i+1], SPD_FOPEN_WT_MODE);
                i++;
                break;
              case 'v':
                verbose = TRUE;
                break;
              default:
                print_usage();
                break;
            }
        } else {
            setTestFileName(argv[i]);
            continue;
        }
    }

    if (spdInitializePidbCache(smuGetFileIdByName(iname)) != 0) {
        spdErrorExit("Can't initialize: \"%s\".", iname);
    }

    createMacroExpandRegionQueue(&queue, MAXQUEUE);
    testWholeFile();
    freeMacroExpandRegionQueue(&queue);

    return(EXIT_SUCCESS);
}
