/* 
 * Program:             $RCSfile: tester.c,v $  $Revision: 30.12 $
 * 
 * Purpose:             ƥȥץࡥ
 * 
 * Author:              T.Mimura  1993/12/01
 *                      S.Yamamoto  1994/09/01
 * 
 * (C) Copyright:       T.Mimura and S.Yamamoto  1994 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: tester.c,v 30.12 2003/06/28 15:33:55 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "tester.h"

static char     *usage =
    "USAGE\n"
    "     pidbTester filename\n"
    "SYNOPSIS\n"
    "     -o output_file: Specify output file.\n"
    "     -v            : Verbose mode.\n";
    
char        *cname, *iname;
char        *cbuf, *ibuf;
int         clen, ilen;
SpdBoolean  verbose = FALSE;
FILE        *output;

MacroExpandRegionQueue queue;

void print_usage(void)
{
    spdErrorExit(usage);
}

void setTestFileName(char *name)
{
    cname = spdStrcatDup(name, ".c");
    iname = spdStrcatDup(name, ".i");
    clen = spdReadFileInBufByName(cname, &cbuf);
    ilen = spdReadFileInBufByName(iname, &ibuf);
    if (verbose == TRUE) {
        fprintf(stderr, ".c file :\"%s\".\n.i file :\"%s\".\n", cname, iname);
    }
}

/* 
 * .c  .i ؤѴ 1ʸˤĤơ
 * .i  .c ؤѴפ뤫å
 * :
 *     : ְ㤤ä
 *     : 
 */

int check(int coffset, SpdConstString name, int ioffset)
{
    char    fname[FILENAME_MAX + 1];
    int     offset;
    
    if (!SPD_STREQ(iname, name)) {
        return (-1);
    }
    offset = cppCharConvItoC(name, ioffset, ibuf, ilen, fname);
    if (offset == SAPID_CPP_NOT_SUPPORTED) {
        return 0;
    }
    if (SPD_STREQ(fname, cname) && offset == coffset) {
        return (0);
    }
    return (-1);
}

/* 
 * 1ʸˤĤƥå
 * :
 *     1: бʸꡤְ㤤ʤ
 *     0: бʸʤ
 *     -1: бʸꡤְ㤤롥
 */

int testACharacter(int coffset)
{
    int     n, i, r;
    MacroExpandRegion mac;
    
    n = cppCharConvCtoI(cname, coffset, &queue, cbuf, clen, iname, ibuf, ilen);
    if (n == -2) {
        return (0);
    }
    if (n == -1) {
        n = 1;
    }
    r = 1;
    for (i = 0; i < n; i++) {
        mac = popMacroExpandRegionQueue(&queue);
        if (r == 1 && check(coffset, mac.fname, mac.start) < 0) {
            r = -1;
        }
    }
    return (r);
}

/*
 * եΤˤĤƥå
 */

void testWholeFile(void)
{
    int     i, linehead = TRUE, sharp = FALSE;
    
    i = 0;
    while (i < clen) {
        if (linehead == TRUE) {
            linehead = FALSE;
            if (*(cbuf + i) == '#') {
                sharp = TRUE;
            } else {
                sharp = FALSE;
            }
        }
        if (*(cbuf + i) != '\n') {
            if (sharp == FALSE) {
                if (testACharacter(i) < 0) {
                    int line, column;
                    charToLineColumn(cbuf, clen, i, &line, &column);
                    fprintf(output, "miss %s  line %d  column %d\n",
                            cname, line, column);
                }
            }
        } else {
            linehead = TRUE;
        }
        fputc(*(cbuf + i), stderr);
        i++;
    }
    return;
}

int main(int argc, char *argv[])
{
    int     i;
    
    output = stderr;
    if (argc < 2) {
        print_usage();
    }
    
    for (i=1; i<argc; i++) {
        if (*argv[i] == '-') {
            switch (*(argv[i]+1)) {
              case 'o':
                if (i+1 >= argc)
                    spdErrorExit("No output filename.\n");
                if (verbose == TRUE) {
                    fprintf(stderr, "Output file \"%s\".\n", argv[i+1]);
                }
                output = spdFopen(argv[i+1], SPD_FOPEN_WT_MODE);
                i++;
                break;
              case 'v':
                verbose = TRUE;
                break;
              default:
                print_usage();
                break;
            }
        } else {
            setTestFileName(argv[i]);
            continue;
        }
    }

    if (spdInitializePidbCache(smuGetFileIdByName(iname)) != 0) {
        spdErrorExit("Can't initialize: \"%s\".", iname);
    }

    createMacroExpandRegionQueue(&queue, MAXQUEUE);
    testWholeFile();
    freeMacroExpandRegionQueue(&queue);

    return (EXIT_SUCCESS);
}
