/* 
 * Program:             $RCSfile: spdCmpVersion.h,v $  $Revision: 30.3 $
 * 
 * Purpose:
 * 
 * Author:              H.Ohhashi  2000/01/21
 *                      S.Yamamoto  2000/01/21
 * 
 * (C) Copyright:       H.Ohhashi and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef _SPD_CMP_VERSION_H
#define _SPD_CMP_VERSION_H

/*
 * Include files.
 */

/* !! Sapid/Sapid.hǥ󥯥롼ɤ褦ˤʤä뤳ȡ*/
#include <Sapid/SpdStr.h>

/*
 * Macro definitions.
 */

#ifdef GLOBAL_DEFINE
#define GLOBAL
#define GLOBAL_INIT(value)      = (value)
#else
#define GLOBAL                  extern          
#define GLOBAL_INIT(value)
#endif

#define DEFAULT_OUTPUT_DIR      "SPEC"

#define OUTPUT_SORT_FUNCTION    "func"
#define OUTPUT_SORT_VARIABLE    "var"
#define OUTPUT_SORT_TYPENAME    "type"
#define OUTPUT_SORT_TAG         "tag"

#define HTML_SUFFIX             ".html"
#define VERSION_TABLE_NAME      "version"

#define MODIFY_INTERFACE        1
#define MODIFY_BODY             (MODIFY_INTERFACE + 1)

/*
 * Type definitions.
 */

typedef struct {
  SpdObjId      identId;
  SpdObjId      programId;
} VerIdent;

typedef struct {
  size_t        arraySize;
  VerIdent      *idArray;
  SpdString     name;
} IdentTblElem;

typedef struct {
  size_t        size;
  IdentTblElem  *elem;
} IdentTbl;

typedef struct {
  SpdObjId      typeId;
  SpdObjId      identId;
} ArgInfo;

typedef struct {
  SpdObjId      rtnTypeId;
  size_t        argNum;
  ArgInfo       *argInfo;
} FuncInfo;

/*
 * Global variables.
 */

GLOBAL SpdString    outputDir       GLOBAL_INIT(DEFAULT_OUTPUT_DIR);

/* !! Ϥ򥪥ץǤ褦ˤͽꡥ */
#ifdef TO_DO_OUTPUT_SELECTION
GLOBAL SpdString    outputSort  GLOBAL_INIT(OUTPUT_SORT_FUNCTION);
#endif

GLOBAL IdentTbl     funcTbl;
GLOBAL IdentTbl     variableTbl;
GLOBAL IdentTbl     typenameTbl;
GLOBAL IdentTbl     tagTbl;

/*
 * Function prototypes.
 */

/* lib_version.c */
SpdBoolean spdDeclrIsDeclFuncDef(const SpdObjId declrId);
SpdBoolean spdDeclnIsDeclParm(SpdRel rel);
SpdBoolean spdRelIsDeclFuncDef(SpdRel rel);
SpdBoolean spdRelIsDeclVariable(SpdRel rel);
SpdBoolean spdRelIsDeclType(SpdRel rel);
SpdBoolean spdRelIsDeclTag(SpdRel rel);
SpdRegion  spdGetRegionC(SpdRel rel);
SpdRel     spdGetDefRel(SpdObjId identId);
SpdRegion  spdGetDefRegion(SpdObjId identId);
SpdBoolean spdIsGlobalIdent(SpdObjId ident_id);
SpdObjId   spdGetProgramIdByRelId(SpdRelId relationId);
SpdObjId   spdGetIdentIdWithVersion(SpdObjId ident_id, 
                                    SpdObjId program_id);
SpdObjId   spdGetDefDeclnIdByIdentId(SpdObjId identId);
SpdBoolean spdIsSameDecln(SpdObjId declr_a, SpdObjId declr_b);
int        spdGetFuncModifySort(SpdObjId pre_decln_id, 
                                SpdObjId cur_decln_id);

/* mkVersionTbl.c */
#ifdef DEBUG
void dumpAllTables(void)
#endif
void mkVersionTable(IdentTbl *tbl, SpdRel rel, 
                    SpdObjIdArray *prog_list, int idx);
void freeAllTables(void);
void sortAllTables(void);

/* writeHtml.c */
void writeAllTables(void);

#undef GLOBAL
#undef GLOBAL_INIT_STR

#endif /* _SPD_CMP_VERSION_H */
