/* 
 * Program:             $RCSfile: writeHtml.c,v $  $Revision: 30.11 $
 * 
 * Purpose:
 * 
 * Author:              H.Ohhashi  2000/01/21
 *                      S.Yamamoto  2000/01/21
 * 
 * (C) Copyright:       H.Ohhashi and S.Yamamoto  2000 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: writeHtml.c,v 30.11 2003/08/26 12:50:16 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spdCmpVersion.h"

/*
 * <a>ˤ󥯤ʸ롥
 */

static SpdString makeLinkText(SpdString text, SpdObjId identId, 
                              SpdObjId progId)
{
    SpdRegion regionC;
    SpdObjId fileId;

    static char temp[SPD_STRING_LEN + 1];
  
    temp[0] = '\0';

    regionC = spdGetDefRegion(identId);
    fileId = spdConvIdPfileToFile(regionC.fileId);

    /*### ؿNAME°η㤦*/
    if (spdGetAttrValInt(identId, "sort") == ID_FUNCTION) {
        sprintf(temp, "<a href=\"%d/%d%s#s%d\">%s</a>",
                progId, fileId, HTML_SUFFIX, identId, text);
    } else {
        sprintf(temp, "<a href=\"%d/%d%s#s%d_%d\">%s</a>",
                progId, fileId, HTML_SUFFIX, identId,
                regionC.offset, text);
    }
    return temp;
}

/*
 * <DOCTYPE>Ϥ롥
 */

static void _writeDocType(FILE *fp)
{  
    fprintf(fp, SPD_DOCTYPE_HTML_4_01);
}

/*
 * <title>Ϥ롥
 */

static void _writeTitle(FILE *fp, SpdString sortStr)
{
    fprintf(fp, "<title>");
    fprintf(fp, "Version Report");

    if (SPD_STREQ(sortStr, OUTPUT_SORT_FUNCTION)) {
        fprintf(fp, "(Function)");
    } else if (SPD_STREQ(sortStr, OUTPUT_SORT_VARIABLE)) {
        fprintf(fp, "(Global variable)");
    } else if (SPD_STREQ(sortStr, OUTPUT_SORT_TYPENAME)) {
        fprintf(fp, "(Typename)");
    } else if (SPD_STREQ(sortStr, OUTPUT_SORT_TAG)) {
        fprintf(fp, "(Tag)");
    }
    fprintf(fp, "</title>\n");
}

/*
 * <head>Ϥ롥
 */

static void _writeHead(FILE *fp, SpdString sortStr)
{
    fprintf(fp, "<head>\n");
    _writeTitle(fp, sortStr);
    fprintf(fp, "</head>\n");
}

/*
 * <h1>Ϥ롥
 */

static void _writeH(FILE *fp, SpdString sortStr)
{
    SpdString prog_name = smuGetAProgramName();

    fprintf(fp, "<h1>");
    fprintf(fp, "%s Version Report", prog_name);

    if (SPD_STREQ(sortStr, OUTPUT_SORT_FUNCTION)) {
        fprintf(fp, "(Function)");
    } else if (SPD_STREQ(sortStr, OUTPUT_SORT_VARIABLE)) {
        fprintf(fp, "(Global variable)");
    } else if (SPD_STREQ(sortStr, OUTPUT_SORT_TYPENAME)) {
        fprintf(fp, "(Typename)");
    } else if (SPD_STREQ(sortStr, OUTPUT_SORT_TAG)) {
        fprintf(fp, "(Tag)");
    }
    fprintf(fp, "</h1>\n");
}

/*
 * <td>Ϥ롥
 */

static void _writeTd(FILE *fp, SpdString bgcolor, SpdString str)
{
    /* ǥȡ*/
    fprintf(fp, "  ");

    fprintf(fp, "<td");
    fprintf(fp, " align=\"center\"");

    if (bgcolor != NULL) 
        fprintf(fp, " bgcolor=\"%s\"", bgcolor);

    fprintf(fp, ">");

    fprintf(fp, "%s", str);
    fprintf(fp, "</td>\n");
}

/*
 * <tr>Ϥ롥ѹ̵ͭˤϤϰۤʤ롥
 */

static void _writeTr(FILE *fp, IdentTbl *tbl, int idx)
{
    int i;
    SpdString linkText;
    SpdObjId cur_define_id, pre_define_id;

    fprintf(fp, "<tr>\n");

    /* ̾ϡ*/
    _writeTd(fp, NULL, tbl->elem[idx].name);

    for (i = 0; i < tbl->elem[idx].arraySize; i++) {
        if (i == 0) {
            /* ǽΥС*/
            if (tbl->elem[idx].idArray[i].identId == SPD_NON_ID) {
                _writeTd(fp, NULL, "-");
            } else {
                linkText = makeLinkText("added", 
                                        tbl->elem[idx].idArray[i].identId,
                                        tbl->elem[idx].idArray[i].programId);
                /* _writeTd(fp, "salmon", linkText); */
                _writeTd(fp, "#E9967A", linkText);
            }
        } else {
            if (tbl->elem[idx].idArray[i].identId == SPD_NON_ID) {
                if (tbl->elem[idx].idArray[i-1].identId == SPD_NON_ID) {
                    _writeTd(fp, NULL, "-");
                } else {
                    _writeTd(fp, "red", "deleted");
                }
            } else {
                if (tbl->elem[idx].idArray[i-1].identId == SPD_NON_ID) {
                    linkText = makeLinkText("added", 
                                            tbl->elem[idx].idArray[i].identId,
                                            tbl->elem[idx].idArray[i].programId);
                    /* _writeTd(fp, "salmon", linkText); */
                    _writeTd(fp, "#E9967A", linkText);
                } else {
                    cur_define_id = 
                        spdGetDefDeclnIdByIdentId(tbl->elem[idx].idArray[i].identId);
                    pre_define_id = 
                        spdGetDefDeclnIdByIdentId(tbl->elem[idx].idArray[i-1].identId);
                    /* СӤ롥*/
                    if (spdIsSameDecln(pre_define_id, cur_define_id)) {
                        linkText = makeLinkText("same", 
                                                tbl->elem[idx].idArray[i].identId,
                                                tbl->elem[idx].idArray[i].programId);
                        _writeTd(fp, NULL, linkText);
                    } else {
                        if (spdGetAttrValInt(cur_define_id, "sort") == ID_FUNCTION) {
                            /* ؿξ̤ʽ*/
                            switch (spdGetFuncModifySort(pre_define_id, cur_define_id)) {
                              case MODIFY_INTERFACE:
                                linkText = makeLinkText("interface modified", 
                                                        tbl->elem[idx].idArray[i].identId,
                                                        tbl->elem[idx].idArray[i].programId);
                                _writeTd(fp, "blue", linkText);
                                break;
                              case MODIFY_BODY:
                                linkText = makeLinkText("body modified", 
                                                        tbl->elem[idx].idArray[i].identId,
                                                        tbl->elem[idx].idArray[i].programId);
                                _writeTd(fp, "yellow", linkText);
                                break;
                              default:
                                break;
                            }
                        } else {
                            linkText = makeLinkText("modified", 
                                                    tbl->elem[idx].idArray[i].identId,
                                                    tbl->elem[idx].idArray[i].programId);
                            _writeTd(fp, "yellow", linkText);
                        }
                    }
                }
            }
        }
    }
    fprintf(fp, "</tr>\n");
}

/*
 * <table>Ϥ롥
 */

static void _writeTable(FILE *fp, IdentTbl *tbl)
{
    int i;
    char idStr[SPD_STRING_LEN + 1];

    fprintf(fp, "<table border=\"1\" summary=\"\">\n");

    /* ǽtrľԽ*/
    fprintf(fp, "<tr>\n");
    _writeTd(fp, NULL, "Name");
    /* tbl->elem[0].arraySize ϥץɽ͡*/
    for (i = 0; i < tbl->elem[0].arraySize; i++) {
        sprintf(idStr, "%d", i);
        _writeTd(fp, NULL, idStr);
    }
    fprintf(fp, "</tr>\n");

    for (i = 0; i < tbl->size; i++) {
        _writeTr(fp, tbl, i);
    }

    fprintf(fp, "</table>\n");
}

/*
 * <body>Ϥ롥
 */

static void _writeBody(FILE *fp, IdentTbl *tbl, SpdString sortStr)
{
    fprintf(fp, "<body>\n");
    _writeH(fp, sortStr);
    _writeTable(fp, tbl);
    fprintf(fp, "</body>\n");
}

/*
 * <html>Ϥ롥
 */

static void _writeHtml(FILE *fp, IdentTbl *tbl, SpdString sortStr)
{
    fprintf(fp, "<html>\n");
    _writeHead(fp, sortStr);
    _writeBody(fp, tbl, sortStr);
    fprintf(fp, "</html>\n");
}

/*
 * СɽHTMLΥơ֥Ϥ롥
 */

static void writeVersionTable(IdentTbl *tbl, SpdString sortStr)
{
    FILE    *fp;
    char    out_path[SPD_STRING_LEN + 1];

    sprintf(out_path, "%s/%s-%s%s", outputDir, sortStr,
            VERSION_TABLE_NAME, HTML_SUFFIX);
    fp = spdFopen(out_path, SPD_FOPEN_WT_MODE);
    _writeDocType(fp);
    _writeHtml(fp, tbl, sortStr);
    spdFclose(fp);
}

/*
 * ٤ƤΥСơ֥Ϥ롥
 */

void writeAllTables(void)
{
    writeVersionTable(&funcTbl, OUTPUT_SORT_FUNCTION);
    writeVersionTable(&variableTbl, OUTPUT_SORT_VARIABLE);
    writeVersionTable(&typenameTbl, OUTPUT_SORT_TYPENAME);
    writeVersionTable(&tagTbl, OUTPUT_SORT_TAG);
}
