/* 
 * Program:             $RCSfile: common.h,v $  $Revision: 30.5 $
 * 
 * Purpose:
 * 
 * Author:              N.Iwamoto  1996/12/15
 *                      S.Yamamoto  1997/01/16
 * 
 * (C) Copyright:       N.Iwamoto and S.Yamamoto  1996 - 2002
 *                      This file is a product of the project Sapid.
 */

#define PATTERN         "#include"

extern int flag_u, flag_d, flag_t;
extern char *dir;
extern char *cwd;

typedef struct _SpdStringArray {
    size_t        size;
    SpdString     *str;
} SpdStringArray;

typedef struct _SpdRegionArray {
    size_t        size;
    SpdRegion     *reg;
} SpdRegionArray;

extern SpdStringArray include_array;

/* util.c */
void getFileSet(SpdObjId, SpdSet *);
SpdBoolean spdOccIsIdFunction(SpdOcc);
void getFuncIdSet(SpdSet *, SpdStringArray, SpdSet *);
SpdStringArray addStrToArray(SpdStringArray, SpdString);
void freeStringArray(SpdStringArray);
SpdBoolean checkStor(SpdObjId, int);
SpdString strCat(SpdString, SpdString);
SpdRelArray getSortedRelArray(SpdSet *);
SpdObjId getIdOfStatic(SpdObjId);

/* decl.c */
SpdBoolean isStatic(SpdObjId);
SpdBoolean isExtern(SpdObjId);
void enqueueDeclnId(SpdSet *, SpdQueue *);
SpdBoolean isSetContain(SpdOcc);
void getNeededDeclSet(SpdSet *);

/* macro.c */
SpdRegion makeSpdRegion(SpdObjId, int, int);
SpdString strCatHeader(SpdObjId);
void makeUsrHeader(SpdString);
SpdObjId getNeededInclude(SpdObjId);
SpdStringArray getNeededMacro(SpdSet *);

/* file.c */
SpdObjId getIdOfExtern(SpdObjId);
SpdBoolean isOptionalDecl(SpdObjIdArray);
SpdRegion makeRegionFromObj(SpdObjId);
SpdString getText(SpdObjId);
void makeIncludeFile(SpdString, SpdStringArray, SpdStringArray, SpdStringArray);
