/* 
 * Program:             $RCSfile: decl.c,v $  $Revision: 30.3 $
 * 
 * Purpose:
 * 
 * Author:              N.Iwamoto  1996/12/15
 *                      S.Yamamoto  1997/01/16
 * 
 * (C) Copyright:       N.Iwamoto and S.Yamamoto  1996 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: decl.c,v 30.3 2002/11/22 13:44:46 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h> 
#include <Sapid/SpdStr.h>
#include "common.h"

static SpdSet ident_set;

/* ꤷidentifierstaticݤ֤ */

SpdBoolean isStatic(SpdObjId ident_id)
{
    SpdObjIdArray declr_array;
    SpdObjId decln_id;
    int i;

    declr_array = spdGetRelObjArray(ident_id, "decl_ident", "identifier_id",
                                    NULL);
    for (i = 0; i < declr_array.size; i++){
        decln_id = spdGetARelObj(declr_array.id[i], "decl_decl", "declarator_id");
        if (!checkStor(decln_id, STORAGE_STATIC)){
            return FALSE;
        }
    }
    spdFreeObjIdArray(declr_array);
    return TRUE;
}

/* ꤷidentifierexternݤ֤ */ 

SpdBoolean isExtern(SpdObjId ident_id)
{
    SpdObjIdArray declr_array;
    SpdObjId decln_id;
    int i;

    declr_array = spdGetRelObjArray(ident_id, "decl_ident", "identifier_id",
                                    NULL);
    for (i = 0; i < declr_array.size; i++){
        decln_id = spdGetARelObj(declr_array.id[i], "decl_decl", "declarator_id");
        if (!checkStor(decln_id, STORAGE_EXTERN)){
            return FALSE;
        }
    }
    spdFreeObjIdArray(declr_array);
    return TRUE;
}

/* Ǥ򥭥塼롥 */

void enqueueDeclnId(SpdSet *decln_set, SpdQueue *decln_queue)
{
    SpdObjId decln_id;
    int i;
    
    for(i = 0; i < (*decln_set)->elemNum; i++){
        spdGetAElem(*decln_set, &decln_id);
        spdQueueEnqueue(decln_queue, decln_id);
    }
    return;
}

SpdBoolean isSetContain(SpdOcc occ)
{
    if (spdAddElem(ident_set, occ.objectId, NULL) == NULL){
        return FALSE;
    }
    return TRUE;
}

void getNeededDeclSet(SpdSet *decln_set)
{
    SpdOccArray     ident_array;
    SpdObjIdArray   declr_array;
    SpdObjId        decl_id, decln_id, declr_id, ident_id;
    SpdQueue        decln_queue = SPD_EMPTY_QUEUE;
    int             i, j, flag;

    enqueueDeclnId(decln_set, &decln_queue);
    
    ident_set = spdCreateSet(DEFAULT_INT_SET);
    
    while ((decl_id = spdQueueDequeue(&decln_queue)) != -1){
        ident_array = spdGetIncludedOccArray(decl_id, "identifier", 
                                             SPD_NON_ID, isSetContain);
        for (i = 0; i < ident_array.size; i++){
            ident_id = ident_array.occ[i].objectId;
            if (isExtern(ident_id) || isStatic(ident_id)){
                flag = ON;
            } else{
                flag = OFF;
            }
            declr_array = spdGetRelObjArray(ident_id, "decl_ident", 
                                            "identifier_id", NULL);
            for (j = 0; j < declr_array.size; j++){
                declr_id = declr_array.id[j];
                decln_id = spdGetARelObj(declr_id, "decl_decl", 
                                         "declarator_id");
                if (((!flag && (!checkStor(decln_id, STORAGE_EXTERN) &&
                                !checkStor(decln_id, STORAGE_STATIC))) || flag) && 
                    !spdSetContains(*decln_set, decln_id)){
                    if ((spdGetAttrValInt(declr_id, "sort") != DECL_MEMBER && 
                         spdGetAttrValInt(ident_id, "sort") != ID_TAG) ||
                        spdGetARelObj(declr_id, "decl_opt", "any") != 
                        SPD_NON_ID){
                        if (spdGetARelObj(decln_id, "file_decl", "any") != 
                            SPD_NON_ID){ 
                            spdAddElem(*decln_set, decln_id, NULL);
                            spdQueueEnqueue(&decln_queue, decln_id);
                        }
                    }
                }
            }
            spdFreeObjIdArray(declr_array);
        }
        spdFreeOccArray(ident_array);
    }
    spdFreeSet(ident_set);
    return;
}
