/* 
 * Program:             $RCSfile: file.c,v $  $Revision: 30.4 $
 * 
 * Purpose:
 * 
 * Author:              N.Iwamoto  1996/12/15
 *                      S.Yamamoto  1997/01/16
 * 
 * (C) Copyright:       N.Iwamoto and S.Yamamoto  1996 - 1997
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: file.c,v 30.4 2002/10/21 07:28:37 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h> 
#include <Sapid/SpdStr.h>
#include "common.h"

SpdObjId getIdOfExtern(SpdObjId declr_id)
{
    SpdObjIdArray declr_array;
    SpdObjId ident_id, decln_id;
    int i;

    ident_id = spdGetARelObj(declr_id, "decl_ident", "declarator_id");
    declr_array = spdGetRelObjArray(ident_id, "decl_ident", "identifier_id", NULL);
    for (i = 0; i < declr_array.size; i++){
        decln_id = spdGetARelObj(declr_array.id[i], "decl_decl", "declarator_id");
        if (checkStor(decln_id, STORAGE_EXTERN)){
            return decln_id;
        }
    }
    spdFreeObjIdArray(declr_array);
    return SPD_NON_ID;
}       

SpdBoolean isOptionalDecl(SpdObjIdArray array)
{
    int i;
    
    for (i = 0; i < array.size; i++){
        if (spdGetARelObj(array.id[i], "decl_opt", "declarator_id") 
            != SPD_NON_ID){
            return TRUE;
        }
    }
    return FALSE;
}

SpdRegion makeRegionFromObj(SpdObjId id)
{
    SpdOccArray array;
    SpdRegion regI, regC;

    array = spdGetOffsetOfObjArray(id, NULL);
    regI = spdConvOccToRegion(array.occ[0]);
    regC = spdConvRegionItoC(regI);
    spdFreeOccArray(array);

    return (regC);
}

SpdString getText(SpdObjId id)
{
    SpdRegion reg;
    SpdString text;

    reg = makeRegionFromObj(id);
    text = spdGetTextByRegion(reg);

    return (text);
}

void makeIncludeFile(SpdString file_name, SpdStringArray include_array, 
                     SpdStringArray macro_array, SpdStringArray decl_array)
{
    FILE *fp;
    int i;
    
    if (flag_d){
        chdir(cwd);
    }
    
    fp = spdFopen(file_name, SPD_FOPEN_WT_MODE);
    for (i = 0; i < include_array.size; i++){
        fprintf(fp, "%s\n", include_array.str[i]);
    }
    for (i = 0; i < macro_array.size; i++){
        fprintf(fp, "%s\n", macro_array.str[i]);
    }
    for (i = 0; i < decl_array.size; i++){
        fprintf(fp, "%s\n", decl_array.str[i]);
    }
    spdFclose(fp);

    if (flag_d){
        chdir(dir);
    }
    return;
}
