/* 
 * Program:             $RCSfile: spdDivider4.c,v $  $Revision: 30.5 $
 * 
 * Purpose:
 * 
 * Author:              N.Iwamoto  1996/12/15
 *                      S.Yamamoto  1997/01/16
 * 
 * (C) Copyright:       N.Iwamoto and S.Yamamoto  1996 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdDivider4.c,v 30.5 2003/06/03 15:28:23 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h> 

#if defined(WIN32)
#include <direct.h>             /* For getcwd(). */
#elif defined(HAVE_UNISTD_H)
#include <unistd.h>             /* For getcwd(). */
#endif

#include "common.h"
#include "spdDivider4.h"

char *dir;
char *cwd;

int flag_t = OFF;
int flag_u = OFF;
int flag_d = OFF;

#if 0
/* sort  DECL_FUNCDEF ɤĴ٤ */
SpdBoolean spdOccIsDeclFuncdef(const SpdOcc occ)
{
    return (spdGetAttrValInt(occ.objectId, "sort") == DECL_FUNCDEF);
}
#endif

/* ץδؿ objectId 򽸹ɲä */
void addFuncIdToSet(SpdOccArray func_array, SpdSet *decln_set)
{
    int i;

    for ( i = 0; i < func_array.size; i++){
        spdAddElem(*decln_set, func_array.occ[i].objectId, NULL);
    }    
    return;
}

/* ץδؿ objectId 򽸹礫 */
void delFuncIdFromSet(SpdOccArray func_array, SpdSet *decln_set)
{
    int i;

    for ( i = 0; i < func_array.size; i++){
        spdDelElem(*decln_set, func_array.occ[i].objectId);
    }    
    return;
}

void divideProgram(SpdObjId prog_id)
{
    SpdStringArray macro_array = SPD_EMPTY_ARRAY;
    SpdRelArray decln_array = SPD_EMPTY_ARRAY;
    SpdOccArray func_array = SPD_EMPTY_ARRAY;
    SpdSet file_set=spdCreateSet(DEFAULT_INT_SET), 
    decln_set=spdCreateSet(DEFAULT_INT_SET);

    getFileSet(prog_id, &file_set);

    func_array = spdGetIncludedOccArray(prog_id, "declaration", 
                                        SPD_NON_ID, spdOccIsDeclFuncdef);
    
    addFuncIdToSet(func_array, &decln_set);
    
    getNeededDeclSet(&decln_set);

    macro_array = getNeededMacro(&decln_set); 

    delFuncIdFromSet(func_array, &decln_set);

    decln_array = getSortedRelArray(&decln_set);

    spdFreeSet(decln_set);
    spdFreeSet(file_set);

    makeDividedFile(decln_array, macro_array, include_array, func_array);

    spdFreeRelArray(decln_array);
    return;
}

int main(int argc, char *argv[])
{
    SpdString   prog_name;
    SpdObjId    prog_id;
    int         c;

    while ((c = getopt(argc, argv, "d:t:")) != EOF) {
        switch (c) {
          case 'u':
            flag_u = ON;
            break;
          case 'd':
            flag_d = ON;
            dir = optarg;
            break;
          case 't':
            flag_t = ON;
            prog_name = optarg;
            break;
          default:
            spdErrorExit("Usage : %s [-d <path name>] [-t <target prog name>]\n", argv[0]);
            break;
        }
    }
    
    if (flag_d){
        if ((cwd = getcwd(NULL, FILENAME_MAX + 1)) == NULL) {
            spdErrorExit("Can't get current directory.\n");
        }
        if (chdir(dir) != 0) {
            spdErrorExit("Directory \"%s\" not found.\n", dir);
        }
    }
    
    if (!flag_t){
        prog_name = smuGetAProgramName();
    }
    
    if (optind != argc) {
        spdErrorExit("Usage : %s [-d <path name>] [-t <target prog name>]\n", argv[0]);
    }
    
    if ((prog_id = spdTarget("P-model", prog_name)) == SPD_NON_ID) {
        spdErrorExit("Program \"%s\" not found.\n", prog_name);
    }

    divideProgram(prog_id);
    
    return (EXIT_SUCCESS);
}
