/* 
 * Program:             $RCSfile: spdSlicer4.c,v $  $Revision: 30.5 $
 * 
 * Purpose:             PIDBѤspdSlicer
 * 
 * Author:              N.Iwamoto  1996/12/15
 *                      S.Yamamoto  1997/01/16
 * 
 * (C) Copyright:       N.Iwamoto and S.Yamamoto  1996 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdSlicer4.c,v 30.5 2003/06/03 15:28:25 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h> 

#if defined(WIN32)
#include <direct.h>             /* For getcwd(). */
#elif defined(HAVE_UNISTD_H)
#include <unistd.h>             /* For getcwd(). */
#endif

#include "common.h"
#include "spdSlicer4.h"

char *dir;
char *cwd;

int flag_t = OFF;
int flag_u = OFF;
int flag_d = OFF;

void sliceProgram(SpdObjId prog_id, SpdStringArray func_array)
{
    SpdStringArray macro_array = SPD_EMPTY_ARRAY;
    SpdRelArray decln_array = SPD_EMPTY_ARRAY;
    SpdSet file_set=spdCreateSet(DEFAULT_INT_SET), 
    decln_set=spdCreateSet(DEFAULT_INT_SET);
    
    getFileSet(prog_id, &file_set);
    
    getFuncIdSet(&file_set, func_array, &decln_set);
    
    getNeededDeclSet(&decln_set);
    
    macro_array = getNeededMacro(&decln_set); 
    
    decln_array = getSortedRelArray(&decln_set);
    
    spdFreeSet(decln_set);
    spdFreeSet(file_set);

    makeSlicedFile(decln_array, macro_array, include_array, func_array.str[0]);
    
    spdFreeRelArray(decln_array);
}

int main(int argc, char *argv[])
{
    SpdString       prog_name;
    SpdObjId        prog_id;
    SpdStringArray  func_array = SPD_EMPTY_ARRAY;
    int             c;

    while ((c = getopt(argc, argv, "ud:t:")) != EOF) {
        switch (c) {
          case 'u':
            flag_u = ON;
            break;
          case 'd':
            flag_d = ON;
            dir = optarg;
            break;
          case 't':
            flag_t = ON;
            prog_name = optarg;
            break;
          default:
            spdErrorExit("Usage : %s [-u] [-d <path name>] [-t <target prog name>] <func name>\n", argv[0]);
            break;
        }
    }
    
    if (flag_d){
        if ((cwd = getcwd(NULL, FILENAME_MAX + 1)) == NULL) {
            spdErrorExit("Can't get current directory.\n");
        }
        if (chdir(dir) != 0) {
            spdErrorExit("Directory \"%s\"  not found", dir);
        }
    }
    
    if (!flag_t){
        prog_name = smuGetAProgramName();
    }
    
    if (optind == argc) {
        spdErrorExit("Usage: %s [-u] [-d <path name>][-t target prog name] \
                      <func name>\n", argv[0]);
    } else {
        while (optind != argc) {
            func_array = addStrToArray(func_array, spdStrdup(argv[optind]));
            optind++;
        }
    }
    
    if ((prog_id = spdTarget("P-model", prog_name)) == SPD_NON_ID) {
        spdErrorExit("Program \"%s\" not found.\n", prog_name);
    }
    sliceProgram(prog_id, func_array);
    
    freeStringArray(func_array);

    return (EXIT_SUCCESS);
}
