#
# Program:		$RCSfile: spdSlicerView4.tcl,v $  $Revision: 30.1 $
# 
# Purpose:
# 
# Author:		N.Iwamoto  1997/11/19
# Modified:		S.Yamamoto  1998/02/06
# 
# (C) Copyright:	N.Iwamoto and S.Yamamoto  1997 - 1998
# 			This file is a product of the project Sapid.
# 

# 
# $Id: spdSlicerView4.tcl,v 30.1 1998/09/24 11:27:42 yamamoto Exp yamamoto $
# 

#
# tkAR4 饤֥ɤ߹
#

source "$env(SAPID_TCLAR_LIBDIR)/tkAR4.tcl"
source "$env(SAPID_TCLAR_LIBDIR)/tclAR.tcl"

#
# program name 
#

set program [smuGetAProgramName]

#
# spdTarget
#

set prog_id [spdTarget P-model $program]

wm title . "spdSlicerView4: $program"
wm withdraw .

#
# Sapid
#

toplevel .dd
wm title .dd "spdSlicerView4"
wm minsize .dd 300 300
wm maxsize .dd 300 300

canvas .dd.canvas
pack .dd.canvas 

wm withdraw .dd
update idletasks
set x [expr [winfo screenwidth .dd]/2 -[winfo reqwidth .dd]/2 \
    - [winfo vrootx [winfo parent .dd]]]
set y [expr [winfo screenheight .dd]/2 -[winfo reqheight .dd]/2 \
    - [winfo vrooty [winfo parent .dd]]]
wm geom .dd +$x+$y
wm deiconify .dd

.dd.canvas create bitmap 100 100 -bitmap @$env(SAPID_SAT_LIBDIR)/SapidLogo.xbm
.dd.canvas create text 100 200 -text "Please wait....."

update idletasks
update

#
# ե̾
#

proc getFileName {prog_id} {
    global filenamemenu 
    global c_files
    global i_files

    set i_files [spdGetRelObj $prog_id prog_file program_id]

    foreach i $i_files {
	set c_file_id [spdGetRelObj $i "cfile_ifile" "file_id"]
	lappend c_files $c_file_id
	lappend filenamemenu [spdGetName $c_file_id]
    }
}


getFileName $prog_id

#
# ե졼κ
#

frame .slicer
pack .slicer  -expand yes -fill both

frame .slicer.f
pack .slicer.f -side top -fill x -expand yes 

frame .slicer.source
pack .slicer.source -side top -fill both -expand yes 

frame .slicer.f.command 
pack .slicer.f.command  -side right -fill y -expand yes 

frame .slicer.f.file 
pack .slicer.f.file  -side top -fill x -padx 50 -pady 10 -expand yes 
frame .slicer.f.func 
pack .slicer.f.func  -side top -fill x -padx 50 -pady 10 -expand yes 

#
# ե̾
#

label .slicer.f.file.title -text "  File  Name  : "
button .slicer.f.file.b -width 20 -relief raised -bd 2
pack .slicer.f.file.title .slicer.f.file.b -side left
bind .slicer.f.file.b <1> ".slicer.f.file.m post %X %Y"
menu .slicer.f.file.m 

foreach i $filenamemenu {
    .slicer.f.file.m add command -label $i -command "selectFile $i"
}

#
# ؿ̾
#

label .slicer.f.func.title -text "Function name : "
button .slicer.f.func.b -width 20 -relief raised -bd 2
pack .slicer.f.func.title .slicer.f.func.b -side left
bind .slicer.f.func.b <1> ".slicer.f.func.m post %X %Y"
menu .slicer.f.func.m 

#
# declaration  objectId  ؿ̾
#

proc getFuncNameFromDecl {decl_id} {
    set ident_id [spdGetRelObj [spdGetRelObj $decl_id decl_decl declaration_id]\
	                      decl_ident declarator_id]
    return [spdGetName $ident_id]
}

proc selectFunc {i} {
    global funcs     
    global func_name

    set func_name $i
    .slicer.f.func.b configure -text $func_name

    .slicer.source.slice.header.text delete 1.0 end
    .slicer.source.slice.source.text delete 1.0 end
}


# ؿ̾
#

proc getFuncName {file_id} {
    global funcnamemenu 
    global funcs 

    set decls [spdGetRelObj $file_id file_decl file_id]
    foreach i $decls {
	if {[lindex [smuGetObjAttr  $i "sort"] 0] == "DECL_FUNCDEF"} {
	    set decl_id $i
	    
	    set func_name [getFuncNameFromDecl $decl_id]

	    lappend funcnamemenu $func_name
	    lappend funcs $decl_id
	}
    }
}

#
# ե̾ν
#

proc selectFile {file_name} {
    global funcnamemenu 
    global funcs   
    global c_files   
    global i_files   

    .slicer.f.file.b configure -text $file_name
    
    set active [expr [.slicer.f.file.m index "active"] - 1]

    set c_file_id [lindex $c_files $active]

    .slicer.source.target.text delete 1.0 end
    .slicer.source.slice.header.text delete 1.0 end
    .slicer.source.slice.source.text delete 1.0 end

    spdLoadSource .slicer.source.target.text $c_file_id

    set i_file_id [lindex $i_files $active]

    getFuncName $i_file_id
 
   .slicer.f.func.m delete 0 end
    foreach i $funcnamemenu {
        .slicer.f.func.m add command -label $i -command "selectFunc $i" 
    }
}

#
# ܥκ
#

button .slicer.f.command.quit -text "Quit" -command {destroy .} -relief raised
pack .slicer.f.command.quit -side top -fill x -padx 150 -pady 10
button .slicer.f.command.slice -text "Slice" -command {slicer}\
	-relief raised
pack .slicer.f.command.slice -side top -fill x -padx 150 -pady 10

#
# ɽե졼κ
#

frame .slicer.source.target
pack .slicer.source.target -side left -expand yes -fill both 

label .slicer.source.target.title -text "Target Program"
pack .slicer.source.target.title -side top
text .slicer.source.target.text -background white -width 50 -yscrollcommand \
     ".slicer.source.target.sb set"  
pack .slicer.source.target.text -expand yes -fill both -side left

scrollbar .slicer.source.target.sb -command ".slicer.source.target.text yview"
pack .slicer.source.target.sb -side left -fill y

frame .slicer.source.slice
pack .slicer.source.slice -side left -expand yes -fill both 

label .slicer.source.slice.title -text "Slice Program"
pack .slicer.source.slice -side top 

frame .slicer.source.slice.header
pack .slicer.source.slice.header -side top -expand yes -fill both 

label .slicer.source.slice.header.title -text "Header File"
pack .slicer.source.slice.header.title -side top
text .slicer.source.slice.header.text -background white -height 20 -width 50 -yscrollcommand \
     ".slicer.source.slice.header.sb set"  
pack .slicer.source.slice.header.text -side left -expand yes -fill both 

scrollbar .slicer.source.slice.header.sb -command ".slicer.source.slice.header.text yview"
pack .slicer.source.slice.header.sb -side left -fill y

frame .slicer.source.slice.source
pack .slicer.source.slice.source -side top -expand yes -fill both 

label .slicer.source.slice.source.title -text "Source File"
pack .slicer.source.slice.source.title -side top
text .slicer.source.slice.source.text -background white -height 35 -width 50 -yscrollcommand \
     ".slicer.source.slice.source.sb set"  
pack .slicer.source.slice.source.text -side left -expand yes -fill both 

scrollbar .slicer.source.slice.source.sb -command ".slicer.source.slice.source.text yview"
pack .slicer.source.slice.source.sb -side left -fill y

update idletasks
destroy .dd

wm deiconify .

#
# slicer ܥ򲡤ν
#

proc slicer {} {
    global prog_id
    global func_name

    set include ""
    set macro ""

    set decl ""
    set init ""
    set func ""

    spdSlicer $prog_id $func_name include macro decl init func
    .slicer.source.slice.header.text delete 1.0 end
    .slicer.source.slice.source.text delete 1.0 end

    foreach i $include {
	.slicer.source.slice.header.text insert end $i\n
    }
    .slicer.source.slice.header.text insert end \n

    foreach i $macro {
	.slicer.source.slice.header.text insert end $i\n
    }
    .slicer.source.slice.header.text insert end \n

    foreach i $decl {
	.slicer.source.slice.header.text insert end $i\n
    }

    foreach i $init {
	.slicer.source.slice.source.text insert end $i\n
    }
    .slicer.source.slice.source.text insert end \n

    foreach i $func {
	.slicer.source.slice.source.text insert end $i\n
    }

}
