/* 
 * Program:             $RCSfile: DBTable.c,v $  $Revision: 50.2 $
 * 
 * Purpose:
 *
 * Author:              Y.Hachisu  1998/06/18
 *                      S.Yamamoto  1998/06/18
 *
 * (C) Copyright:       Y.Hachisu and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: DBTable.c,v 50.2 2003/08/10 14:17:09 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include <Sapid/SapidOffsetOf.h>
#include "JB.h"

/**
 * TableƤJPD饹ν֤ϡ饹μֹν֤ȡ
 */

DBClassTable dbClassTable[] = {
    { "File", SPD_CID_J_FILE, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_INT,      "encoding", SymDataOffset(u.file),
              SPD_OFFSET_OF(JpdFile, encoding) },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },
        
    { "Class", SPD_CID_J_CLASS, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_INT,      "sort",     SymDataOffset(u.jclass),
              SPD_OFFSET_OF(JpdClass, sort) },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },

    { "Interface", SPD_CID_J_INTERFACE, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_INT,      "sort",     SymDataOffset(u.interface),
              SPD_OFFSET_OF(JpdInterface, sort) },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },

    { "Variable", SPD_CID_J_VARIABLE, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_INT,      "sort",     SymDataOffset(u.variable),
              SPD_OFFSET_OF(JpdVariable, sort) },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },

    { "Routine", SPD_CID_J_ROUTINE, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_INT,      "sort",     SymDataOffset(u.routine),
              SPD_OFFSET_OF(JpdRoutine, sort) },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },

    { "Type", SPD_CID_J_TYPE, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "sort",     SymDataOffset(u.type),  SPD_OFFSET_OF(JpdType, sort) },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_STR,   "pkgName",  SymDataOffset(u.type),
              SPD_OFFSET_OF(JpdType, pkgName) },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },

    { "Modifier", SPD_CID_J_MODIFIER, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },

    { "SBlock", SPD_CID_J_SBLOCK, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_INT,      "sort",     SymDataOffset(u.sblock),
              SPD_OFFSET_OF(JpdSBlock, sort) },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },

    { "Statement", SPD_CID_J_STATEMENT, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "sort",     SymDataOffset(u.statement), SPD_OFFSET_OF(JpdStatement, sort) },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },

    { "Expression", SPD_CID_J_EXPRESSION, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "sort",     SymDataOffset(u.expression), SPD_OFFSET_OF(JpdExpression, sort) },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_INT,      "lrsort",       SymDataOffset(u.expression),
              SPD_OFFSET_OF(JpdExpression, lrsort) },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },

    { "Literal", SPD_CID_J_LITERAL, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_INT,      "sort",     SymDataOffset(u.literal),
              SPD_OFFSET_OF(JpdLiteral, sort) },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },

    { "Operator", SPD_CID_J_OPERATOR, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "sort",     SymDataOffset(u.joperator), SPD_OFFSET_OF(JpdOperator, sort) },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },
    
    { "QName", SPD_CID_J_QNAME, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },

    { "Special", SPD_CID_J_SPECIAL, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },

    { "Label", SPD_CID_J_LABEL, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "sort",     SymDataOffset(u.label), SPD_OFFSET_OF(JpdLabel, sort) },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },

    { "Comment", SPD_CID_J_COMMENT, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_INT,      "offset",   SymDataOffset(offset),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "length",   SymDataOffset(length),  SDB_NON_OFFSET },
        { SPD_DBT_INT,      "strOffset",SymDataOffset(strOffset),SDB_NON_OFFSET },
        { SPD_DBT_STR,   "str",      SymDataOffset(str),     SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  },

    { "Wildcard", SPD_CID_J_WILDCARD, {
        { SPD_DBT_INT,      "id",       SymDataOffset(id),      SDB_NON_OFFSET },
        { SPD_DBT_NON, NULL,       SDB_NON_OFFSET,         SDB_NON_OFFSET }},
  }
};

DBRelTable dbRelTable[] = {
    { "define_package", {
        { SPD_DBT_OID,        "file",         SPD_CID_J_FILE },
        { SPD_DBT_OID,        "package",      SPD_CID_J_QNAME },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "import_package", {
        { SPD_DBT_OID,        "file",         SPD_CID_J_FILE },
        { SPD_DBT_OID,        "package",      SPD_CID_J_QNAME },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    
    { "define_class", {
        { SPD_DBT_OID,        "file",         SPD_CID_J_FILE },
        { SPD_DBT_OID,        "class",        SPD_CID_J_CLASS },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "implement_interface", {
        { SPD_DBT_OID,        "class",        SPD_CID_J_CLASS },
        { SPD_DBT_OID,        "interface",    SPD_CID_J_TYPE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "extend_class", {
        { SPD_DBT_OID,        "subClass",     SPD_CID_J_CLASS },
        { SPD_DBT_OID,        "superClass",   SPD_CID_J_TYPE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "class_modifier", {
        { SPD_DBT_OID,        "class",        SPD_CID_J_CLASS },
        { SPD_DBT_OID,        "modifier",     SPD_CID_J_MODIFIER },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "class_variable", {
        { SPD_DBT_OID,        "class",        SPD_CID_J_CLASS },
        { SPD_DBT_OID,        "variable",     SPD_CID_J_VARIABLE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "class_routine", {
        { SPD_DBT_OID,        "class",        SPD_CID_J_CLASS },
        { SPD_DBT_OID,        "routine",      SPD_CID_J_ROUTINE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "class_sblock", {
        { SPD_DBT_OID,        "class",        SPD_CID_J_CLASS },
        { SPD_DBT_OID,        "sblock",       SPD_CID_J_SBLOCK },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "class_argument", {
        { SPD_DBT_OID,        "class",        SPD_CID_J_CLASS },
        { SPD_DBT_OID,        "expression",   SPD_CID_J_EXPRESSION },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "class_class", {
        { SPD_DBT_OID,        "class",        SPD_CID_J_CLASS },
        { SPD_DBT_OID,        "class",        SPD_CID_J_CLASS },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "class_interface", {
        { SPD_DBT_OID,        "class",        SPD_CID_J_CLASS },
        { SPD_DBT_OID,        "interface",    SPD_CID_J_INTERFACE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "define_interface", {
        { SPD_DBT_OID,        "file",         SPD_CID_J_FILE },
        { SPD_DBT_OID,        "interface",    SPD_CID_J_INTERFACE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "extend_interface", {
        { SPD_DBT_OID,        "subInterface", SPD_CID_J_INTERFACE },
        { SPD_DBT_OID,        "superInterface",   SPD_CID_J_TYPE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "interface_modifier", {
        { SPD_DBT_OID,        "interface",    SPD_CID_J_INTERFACE },
        { SPD_DBT_OID,        "modifier",     SPD_CID_J_MODIFIER },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "interface_variable", {
        { SPD_DBT_OID,        "interface",    SPD_CID_J_INTERFACE },
        { SPD_DBT_OID,        "variable",     SPD_CID_J_VARIABLE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "interface_routine", {
        { SPD_DBT_OID,        "interface",    SPD_CID_J_INTERFACE },
        { SPD_DBT_OID,        "routine",      SPD_CID_J_ROUTINE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "interface_class", {
        { SPD_DBT_OID,        "interface",    SPD_CID_J_INTERFACE },
        { SPD_DBT_OID,        "class",        SPD_CID_J_CLASS },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "interface_interface", {
        { SPD_DBT_OID,        "interface",    SPD_CID_J_INTERFACE },
        { SPD_DBT_OID,        "interface",    SPD_CID_J_INTERFACE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "variable_modifier", {
        { SPD_DBT_OID,        "variable",     SPD_CID_J_VARIABLE },
        { SPD_DBT_OID,        "modifier",     SPD_CID_J_MODIFIER },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "variable_type", {
        { SPD_DBT_OID,        "variable",     SPD_CID_J_VARIABLE },
        { SPD_DBT_OID,        "type",         SPD_CID_J_TYPE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "initialize_variable", {
        { SPD_DBT_OID,        "variable",     SPD_CID_J_VARIABLE },
        { SPD_DBT_OID,        "initializer",  SPD_CID_J_EXPRESSION }, /* !! ׽ */
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    
    { "parameter_variable", {
        { SPD_DBT_OID,        "routine",      SPD_CID_J_ROUTINE },
        { SPD_DBT_OID,        "variable",     SPD_CID_J_VARIABLE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "return_type", {
        { SPD_DBT_OID,        "routine",      SPD_CID_J_ROUTINE },
        { SPD_DBT_OID,        "returnType",   SPD_CID_J_TYPE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "throw_type", {
        { SPD_DBT_OID,        "routine",      SPD_CID_J_ROUTINE },
        { SPD_DBT_OID,        "throwType",    SPD_CID_J_TYPE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "routine_body", {
        { SPD_DBT_OID,        "routine",      SPD_CID_J_ROUTINE },
        { SPD_DBT_OID,        "body",         SPD_CID_J_STATEMENT },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "routine_modifier", {
        { SPD_DBT_OID,        "routine",      SPD_CID_J_ROUTINE },
        { SPD_DBT_OID,        "modifier",     SPD_CID_J_MODIFIER },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    
    { "type_class", {
        { SPD_DBT_OID,        "type",         SPD_CID_J_TYPE },
        { SPD_DBT_OID,        "class",        SPD_CID_J_CLASS },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "type_interface", {
        { SPD_DBT_OID,        "type",         SPD_CID_J_TYPE },
        { SPD_DBT_OID,        "interface",    SPD_CID_J_INTERFACE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "type_type", {
        { SPD_DBT_OID,        "parentType",   SPD_CID_J_TYPE },
        { SPD_DBT_OID,        "childType",    SPD_CID_J_TYPE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "type_qname", {
        { SPD_DBT_OID,        "type",         SPD_CID_J_TYPE },
        { SPD_DBT_OID,        "qname",        SPD_CID_J_QNAME },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    
    { "qname_qname", {
        { SPD_DBT_OID,        "parentQName",  SPD_CID_J_QNAME },
        { SPD_DBT_OID,        "chidlQName",   SPD_CID_J_QNAME },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "qname_dot", {
        { SPD_DBT_OID,        "qname",        SPD_CID_J_QNAME },
        { SPD_DBT_OID,        "dot",          SPD_CID_J_OPERATOR },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "sblock_body", {
        { SPD_DBT_OID,        "sblock",       SPD_CID_J_SBLOCK },
        { SPD_DBT_OID,        "body",         SPD_CID_J_STATEMENT },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "local_class", {
        { SPD_DBT_OID,        "statement",    SPD_CID_J_STATEMENT },
        { SPD_DBT_OID,        "class",        SPD_CID_J_CLASS },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "local_variable", {
        { SPD_DBT_OID,        "statement",    SPD_CID_J_STATEMENT },
        { SPD_DBT_OID,        "variable",     SPD_CID_J_VARIABLE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "statement_label", {
        { SPD_DBT_OID,        "statement",    SPD_CID_J_STATEMENT },
        { SPD_DBT_OID,        "label",        SPD_CID_J_LABEL },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "statement_statement", {
        { SPD_DBT_OID,        "outerStatement",   SPD_CID_J_STATEMENT },
        { SPD_DBT_OID,        "innerStatement",   SPD_CID_J_STATEMENT },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "statement_expression", {
        { SPD_DBT_OID,        "statement",    SPD_CID_J_STATEMENT },
        { SPD_DBT_OID,        "expression",   SPD_CID_J_EXPRESSION },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    
    { "refer_label", {
        { SPD_DBT_OID,        "referer",      SPD_CID_J_LABEL },
        { SPD_DBT_OID,        "referee",      SPD_CID_J_LABEL },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "case_value", {
        { SPD_DBT_OID,        "label",        SPD_CID_J_LABEL },
        { SPD_DBT_OID,        "expression",   SPD_CID_J_EXPRESSION },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    
    { "expression_operand", {
        { SPD_DBT_OID,        "expression",   SPD_CID_J_EXPRESSION },
        { SPD_DBT_OID,        "operandExpression", SPD_CID_J_EXPRESSION },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "expression_operator", {
        { SPD_DBT_OID,        "expression",   SPD_CID_J_EXPRESSION },
        { SPD_DBT_OID,        "operator",     SPD_CID_J_OPERATOR },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "expression_expression", {
        { SPD_DBT_OID,        "parentExpression", SPD_CID_J_EXPRESSION },
        { SPD_DBT_OID,        "childExpression",  SPD_CID_J_EXPRESSION },
        { SPD_DBT_NON,   NULL,               JPD_INVALID_ID }}
  },
    { "refer_variable", {
        { SPD_DBT_OID,        "expression",   SPD_CID_J_EXPRESSION },
        { SPD_DBT_OID,        "variable",     SPD_CID_J_VARIABLE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "refer_literal", {
        { SPD_DBT_OID,        "expression",   SPD_CID_J_EXPRESSION },
        { SPD_DBT_OID,        "literal",      SPD_CID_J_LITERAL },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "refer_special", {
        { SPD_DBT_OID,        "expression",   SPD_CID_J_EXPRESSION },
        { SPD_DBT_OID,        "special",      SPD_CID_J_SPECIAL },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "refer_type", {
        { SPD_DBT_OID,        "expression",   SPD_CID_J_EXPRESSION },
        { SPD_DBT_OID,        "type",         SPD_CID_J_TYPE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "refer_qname", {
        { SPD_DBT_OID,        "expression",   SPD_CID_J_EXPRESSION },
        { SPD_DBT_OID,        "qname",        SPD_CID_J_QNAME },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "has_type", {
        { SPD_DBT_OID,        "expression",   SPD_CID_J_EXPRESSION },
        { SPD_DBT_OID,        "type",         SPD_CID_J_TYPE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "invoke_routine", {
        { SPD_DBT_OID,        "expression",   SPD_CID_J_EXPRESSION },
        { SPD_DBT_OID,        "routine",      SPD_CID_J_ROUTINE },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { "symbol_comment", {
        { SPD_DBT_OID,        "symbol",       SPD_CID_J_WILDCARD },
        { SPD_DBT_OID,        "comment",      SPD_CID_J_COMMENT },
        { SPD_DBT_NON,   NULL,           JPD_INVALID_ID }}
  },
    { NULL, {                               /* sentinel */
        { SPD_DBT_NON, NULL, JPD_INVALID_ID }}
  }
};
