/* 
 * Program:             $RCSfile: spdDumpDBTable.c,v $  $Revision: 40.2 $
 * 
 * Purpose:
 * 
 * Author:              N.Koyama  2000/03/16
 *                      S.Yamamoto  2000/03/16
 * 
 * (C) Copyright:       N.Koyama and S.Yamamoto  2000 - 2001
 *                      This file is a product of the project Sapid.
 */

#include <stdio.h>
#include <Sapid/Sapid.h>

#include "JB.h"

extern DBClassTable dbClassTable[];
extern DBRelTable dbRelTable[];

static int convert_attr_type45(int x);
static char *get_SpdDBType_name(int x);

int main(int argc, char *argv[])
{
    int i, j;

    printf("    /* Classes. */\n");
    for (i = 0; i < SPD_CID_NUM_J_MODEL; i++) {
        printf("    {\n");
        printf("        \"%s\",\n", dbClassTable[i].name);
        printf("        %d,\n", dbClassTable[i].id);

        /* Attributes. */
        printf("        {\n");
        for (j = 0; dbClassTable[i].attrs[j].type != SPD_DBT_NON; j++) {
            printf("            { ");
            printf("%d, ", dbClassTable[i].attrs[j].type);
            printf("\"%s\", ", dbClassTable[i].attrs[j].name);
            printf("%d, ", dbClassTable[i].attrs[j].offset);
            printf("%d", dbClassTable[i].attrs[j].unionOffset);
            printf(" },\n");
        }
        printf("            { SPD_DBT_NON }\n");
        printf("        },\n");
    
        printf("    },\n");
    } 

#define COMMENT1
#ifdef COMMENT1

    printf("    /* Relationships. */\n");
    for (i = 0; dbRelTable[i].name != NULL; i++) {
        printf("    {\n");
        printf("        \"%s\",\n", dbRelTable[i].name);
        printf("        %d,\n", SPD_FIRST_RID_J_MODEL + i);

        /* Attributes. */
        printf("        {\n");
        for (j = 0; dbRelTable[i].attrs[j].type != SPD_DBT_NON; j++) {
            printf("            { ");
            printf("%d, ", dbRelTable[i].attrs[j].type);
            printf("\"%s\", ", dbRelTable[i].attrs[j].name);
            printf("%d", dbRelTable[i].attrs[j].classId);

            printf(" },\n");
        }
        printf("            { SPD_DBT_NON }\n");
        printf("        },\n");

        printf("    },\n");
    }

#endif

#ifdef COMMENT2

    printf("};\n");
    printf("");

#endif

    return (EXIT_SUCCESS);
}
