/* 
 * Program:             $RCSfile: spdDumpJmodel.c,v $  $Revision: 40.4 $
 * 
 * Purpose:             Convert ver.4 class table to ver.5 one.
 * 
 * Author:              S.Yamamoto  2001/03/21
 * 
 * (C) Copyright:       S.Yamamoto  2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdDumpJmodel.c,v 40.4 2003/07/20 11:48:27 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

static void dump_model_class1(void);

SpdConstString      program_name;               /* This program name. */

/* !! Dirty hacking. */
extern SpdDBClass J_model_classes[];

int main(int argc, char *argv[])
{
    SpdId       i;
    SpdModelId  JModelId;

    /* Just for debug. */
    setbuf(stdout, NULL); 

    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);
    JModelId = spdUseModel(&J_model);
    dump_model_class1();
    /* dump_model_rel(SPD_MID_J_MODEL); */

    return (EXIT_SUCCESS);
}

static void dump_model_class1(void)
{
  int           i, j;

  printf("    /* Classes. */\n");
  for (i = 0; J_model_classes[i].name != NULL; i++) {
    if (i == SPD_CID_NUM_J_MODEL) {
      printf("    /* Relationships. */\n");
    }

    printf("    {\n");
    printf("        \"%s\",\n", J_model_classes[i].name);
    printf("        %d,\n", SPD_FIRST_CID_J_MODEL + i);
    printf("        {\n");

    if (i < SPD_CID_NUM_J_MODEL) {
      /* Classes. */
      printf("            { 0, \"id\", 0, -1 },\n");
      for (j = 0; J_model_classes[i].attrs[j].name != NULL; j++) {
	printf("            { ");
	printf("%d, ", J_model_classes[i].attrs[j].type);
	printf("\"%s\", ", J_model_classes[i].attrs[j].name);
	printf("%d, ", J_model_classes[i].attrs[j].offset);
	printf("%d", J_model_classes[i].attrs[j].unionOffset);
	printf(" },\n");
      }
    } else {
      /* Relations. */
      for (j = 0; J_model_classes[i].attrs[j].name != NULL; j++) {
	printf("            { ");
	printf("%d, ", J_model_classes[i].attrs[j].type);
	printf("\"%s\", ", J_model_classes[i].attrs[j].name);
	printf("%d", J_model_classes[i].attrs[j].classId);
	printf(" },\n");
      }
    }

    printf("            { SPD_DBT_NON }\n");
    printf("        },\n");

    printf("    },\n");
  }
}
