/* 
 * Program:             $RCSfile: spdFlt.c,v $  $Revision: 30.2 $
 * 
 * Purpose:
 * 
 * Author:              T.Watanabe  1998/04/02
 *                      S.Yamamoto  1998/04/04
 * 
 * (C) Copyright:       T.Watanabe and S.Yamamoto  1998
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdFlt.c,v 30.2 2000/08/13 12:21:33 yamamoto Exp yamamoto $";
#endif

#include "SpdFlatten.h"

SpdString spdStr2(SpdObjId objectId)
{
    SpdString   res = NULL;
    SpdObjId    classId;
    Block    *block = NULL;
    int i;

    classId = spdGetClassId(objectId);
    if (classId == SPD_CID_FILE) {
        res = spdStrCat(res, spdStrFile2(objectId));
    } else if (classId == SPD_CID_DECLARATION) {
        block = spdStrDeclaration2(objectId, FALSE);
    } else if (classId == SPD_CID_DECLARATOR) {
        block = spdStrDeclarator2(objectId, FALSE);
    } else if (classId == SPD_CID_BLOCK) {
        block = spdStrBlock2(objectId); 
    } else if (classId == SPD_CID_EXPRESSION) {
        block = spdStrExpression2(objectId);
    } else {
        spdErrorExit("SpdStr2 prepare only spdStrFile2,spdStrDeclaration2, spdStrDeclarator2,spdStrBlock2,and spdStrExpression2\n");
    }

    if(block != NULL){
        for(i = block->decl.num - 1; i >= 0; i--){
            res = spdStrCat(res, "\n");
            res = spdStrCat(res, block->decl.str[i]);
        }
        for(i = block->expr.num - 1; i >= 0; i--){
            res = spdStrCat(res, "\n");
            res = spdStrCat(res, block->expr.str[i]);
        }
    }

    return res;
}
