/* 
 * Program:             $RCSfile: spdFltDecl.c,v $  $Revision: 30.6 $
 * 
 * Purpose:
 * 
 * Author:              T.Watanabe  1998/04/02
 *                      S.Yamamoto  1998/04/04
 * 
 * (C) Copyright:       T.Watanabe and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdFltDecl.c,v 30.6 2002/10/21 07:28:45 yamamoto Exp yamamoto $";
#endif

#include <ctype.h>
#include "SpdFlatten.h"

extern int indent;

Block *spdStrDeclarator2(SpdObjId objectId, SpdBoolean asProtoParm)
{
    SpdObjId obj_id, obj_type_id, decl_id, file_id;
    SpdString tmp_res = NULL, ident_str = NULL;
    SpdOccArray    opt_buf;
    int sort, i, j;
    SpdString dres = NULL, eres = NULL;
    Block *cblock = NULL, *pblock = NULL;
  
    /* objectId Υ饹 declarator ǤʤСNULL ֤ */
    if ((spdGetClassId(objectId)) != SPD_CID_DECLARATOR) {
        return NULL;
    }

    switch (sort = spdGetAttrValInt(objectId, "sort")) {
      case DECL_VARIABLE:                   /* ѿ */
        pblock = initBlock();

        decl_id = spdGetARelObj(objectId, "decl_decl", "declarator_id");
        file_id = spdGetARelObj(objectId, "file_decl", "declaration_id");
        if ((spdGetAttrValInt(decl_id, "sort") == DECL_PARAMETER) &&
            (asProtoParm || spdObjIsFuncParameter(decl_id) == FALSE)) {
            dres = spdStrDeclarator(objectId, asProtoParm);
        } else {                            /* ̤ѿ */
            obj_id = spdGetARelObj(objectId, "decl_ident", "p-id");
            /*
             * void foo(a)
             * char *a;
             * { ... }
             * ȤؿΤ a  qualifier դ뤫ɤ
             * ꤹΤ˿Ƥ declaration δϢ decl_type ̵ͭ
             * Ĵ٤롥
             */
            /* decl_id = spdGetARelObj(objectId, "decl_decl", "c-id");*/

            /* identifierdecl˵ */
            if (spdGetARelObj(decl_id, "decl_type", "p-id") != SPD_NON_ID) {
                /* obj_type_id = spdGetARelObj(obj_id, "ident_type", "any"); */
                obj_type_id = spdGetARelObj(objectId, "decr_type", "declarator_id");
                dres = spdStrCat(dres, spdStrTypeQualifier(obj_type_id,
                                                           spdStrIdentifier(obj_id), sort));
            } else {                        /* ѥ᡼ѿΤߤξ */
                dres = spdStrCat(dres, spdStrIdentifier(obj_id));
            }
            opt_buf = spdGetIncludedOccSortedArray(objectId, "optionaldecl",file_id,
                                                   NULL, spdCompareOccOffset); 

            ident_str =  spdStrCat(ident_str, spdStrIdentifier(obj_id));
            for(i = 0; i < opt_buf.size; i++){
                if(cblock != NULL) freeBlock(cblock);
                if(spdGetAttrValInt(opt_buf.occ[i].objectId, "sort") 
                   != OPT_FUNCPTR) {
                    cblock = spdStrOptionaldecl2(opt_buf.occ[i].objectId, ident_str);
                    /* νλ */
                    if(cblock->expr.num == 0){
                        dres = spdStrCat(dres, cblock->decl.str[0]);
                    } else {  /* ʳν */
                        for(j = cblock->decl.num - 1; j >= 0; j--){
                            addElementToBlock(pblock, cblock->decl.str[j], DECL);
                        }
                        for(j = cblock->expr.num - 1; j >= 0; j--){
                            addElementToBlock(pblock, cblock->expr.str[j], EXPR);
                        }
                    }
                }
            }

            spdFreeOccArray(opt_buf);
            if(dres != NULL) addElementToBlock(pblock, dres, DECL);
            if(eres != NULL) addElementToBlock(pblock, eres, EXPR);
            if(cblock != NULL) freeBlock(cblock);
            return pblock;

        }
        break;
      case DECL_FUNCDEF:                    /* ؿ */
        obj_id = spdGetARelObj(objectId, "decl_ident", "p-id");
        /* obj_type_id = spdGetARelObj(obj_id, "ident_type", "any"); */
        obj_type_id = spdGetARelObj(objectId, "decr_type", "declarator_id");
        dres = spdStrCat(dres, spdStrTypeQualifier(obj_type_id,
                                                   spdStrIdentifier(obj_id), sort));
        obj_id = spdGetARelObj(objectId, "decl_opt", "p-id");
        tmp_res = spdStrCat(tmp_res, spdStrOptionaldecl(obj_id));
        if(tmp_res != NULL){
            if(isalpha(tmp_res[0]) || tmp_res[0] == '_'){
                dres = spdStrCat(dres, " ");
            }
        }
        spdFree(tmp_res);
        cblock = spdStrOptionaldecl2(obj_id, NULL);
        for(i = cblock->decl.num - 1; i >= 0; i--){
            dres = spdStrCat(dres, cblock->decl.str[i]);
        }
        for(i = cblock->expr.num - 1; i >= 0; i--){
            eres = spdStrCat(eres, cblock->expr.str[i]);
        }
        break;
      default:
        dres = spdStrDeclarator(objectId, asProtoParm);
        break;
    }
  
    pblock = initBlock();
    if(dres != NULL) addElementToBlock(pblock, dres, DECL);
    if(eres != NULL) addElementToBlock(pblock, eres, EXPR);
    if(cblock != NULL) freeBlock(cblock);
    return pblock;
}

/* ̤ѿλΤ߸ƤФ */
Block *spdStrOptionaldecl2(SpdObjId objectId, SpdString ident_str)
{
    SpdObjId    obj_id;
    int     i, expr_sort;
    SpdRelArray decl_rel_array;
    SpdBoolean  first_parm;
    SpdString dres = NULL, eres = NULL;
    SpdString via_res = NULL;
    Block *pblock = NULL,  *cblock = NULL;

    /* objectId Υ饹 optionaldecl ǤʤСNULL ֤ */
    if ((spdGetClassId(objectId)) != SPD_CID_OPTIONALDECL) {
        return NULL;
    }

    switch (spdGetAttrValInt(objectId, "sort")) {
      case OPT_FUNCDEF:                     /* ؿΰ */
        dres = spdStrCat(dres, "(");
        /* 
         * ǼΤ褦˴Ϣ func_param 򤹤٤Ƽơ
         * declaration  sort  DECL_PARAMETER ξˤ "(" ")" ˹
         * DECL_NORMAL ξˤ ")" ȴؿΤȤδ֤˹롥
         */
        decl_rel_array = spdGetRelSortedArray(objectId, "func_parm", "p-id",
                                              NULL, spdCompareRelOffset);
        first_parm = TRUE;
        for (i = 0; i < decl_rel_array.size; i++) {
            obj_id = decl_rel_array.rel[i].objectId;
            if (spdGetAttrValInt(obj_id, "sort") == DECL_PARAMETER) {
                if (first_parm == TRUE)
                    first_parm = FALSE;
                else
                    dres = spdStrCat(dres, ", ");
                dres = spdStrCat(dres, spdStrDeclaration(obj_id, FALSE));
            }
        }
        dres = spdStrCat(dres, ")\n");
        for (i = 0; i < decl_rel_array.size; i++) {
            obj_id = decl_rel_array.rel[i].objectId;
            if (spdGetAttrValInt(obj_id, "sort") == DECL_NORMAL) {
                dres = spdStrCat(dres, spdStrDeclaration(obj_id, FALSE));
                dres = spdStrCat(dres, "\n"); 
            }
        }
        spdFreeRelArray(decl_rel_array);

        obj_id = spdGetARelObj(objectId, "func_body", "p-id");
        if(cblock != NULL) freeBlock(cblock);
        cblock = spdStrCompound2(obj_id); 
        for(i = cblock->decl.num - 1; i >= 0; i--){
            dres = spdStrCat(dres, cblock->decl.str[i]);
        }
        for(i = cblock->expr.num - 1; i >= 0; i--){
            if(i == 0) eres = spdStrCat(eres, "\n");
            eres = spdStrCat(eres, cblock->expr.str[i]);
        }
        break;
      case OPT_INITIALIZER:                 /* ѿν */
        pblock = initBlock();
        obj_id = spdGetARelObj(objectId, "init_expr", "p-id");
        expr_sort = smuGetExprSort(obj_id);
        if(cblock != NULL) freeBlock(cblock);
        cblock = spdStrExpression2(obj_id); 

        if(expr_sort == EXPR_SORT_INITLIST){
            dres = spdStrCat(dres, " = ");
            for(i = cblock->decl.num - 1; i >= 0; i--){
                dres = spdStrCat(dres, cblock->decl.str[i]);
            }    
            addElementToBlock(pblock, dres, DECL);
            return pblock;
        }

        eres = spdStrCat(eres, ident_str);
        eres = spdStrCat(eres, " = ");
        for(i = cblock->decl.num - 1; i >= 0; i--){
            if((via_res = cblock->decl.str[i]) != NULL){
                addElementToBlock(pblock, via_res, DECL);
            }
        }
        for(i = cblock->expr.num - 1; i > 0; i--){
            if((via_res = cblock->expr.str[i]) != NULL){
                addElementToBlock(pblock, via_res, EXPR);
            }
        }
        eres = spdStrCat(eres, cblock->expr.str[0]);
        addElementToBlock(pblock, eres, EXPR);
        if(cblock != NULL) freeBlock(cblock);
        return pblock;
        break;
      default:
        dres = spdStrOptionaldecl(objectId);
        break;
    }
    pblock = initBlock();
    if(dres != NULL) addElementToBlock(pblock, dres, DECL);
    if(eres != NULL) addElementToBlock(pblock, eres, EXPR);
    if(cblock != NULL) freeBlock(cblock);

    return pblock;
}
