/* 
 * Program:             $RCSfile: spdFltExpr.c,v $  $Revision: 30.4 $
 * 
 * Purpose:
 * 
 * Author:              T.Watanabe  1998/04/02
 *                      S.Yamamoto  1998/04/04
 * 
 * (C) Copyright:       T.Watanabe and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdFltExpr.c,v 30.4 2003/06/28 15:34:07 yamamoto Exp yamamoto $";
#endif

#include "SpdFlatten.h"

Block *spdStrExpression2(SpdObjId objectId) 
{
    SpdString   res = NULL;
    SpdCursor   *csr;
    SpdRel  rel, *buf = NULL;
    int     buf_n = 0, expr_sort, i;
    Block *block = NULL;

    if ((spdGetClassId(objectId)) != SPD_CID_EXPRESSION) {
        return NULL;
    }
    expr_sort = smuGetExprSort(objectId);
    switch(expr_sort){
      case EXPR_SORT_INITLIST:              /*  */
        res = spdStrCat(res, "{ ");
        csr = spdGetRelInit(objectId, "expr_expr", "p-id");
        while ((rel = spdGetRel(csr)).relationId != -1) {
            buf = spdRealloc(buf, sizeof(SpdRel) * (buf_n + 1));
            buf[buf_n++] = rel;
        }
        spdFreeCursor(csr);
        SPD_QSORT(buf, buf_n, sizeof(SpdRel), cmp_offset);
        for (i = 0; i < buf_n; i++) {
            if(i != 0) res = spdStrCat(res, ", ");
            res = spdStrCat(res, spdStrExpression(buf[i].objectId));
        }
        spdFree(buf);
        res = spdStrCat(res, " }");
        block = initBlock();
        if(res != NULL) addElementToBlock(block, res, DECL);
        break;    
      default:
        block = mkSimpleExpr(objectId);
        break;
    }
    return block;
}
