/* 
 * Program:             $RCSfile: spdFltFile.c,v $  $Revision: 30.7 $
 * 
 * Purpose:
 * 
 * Author:              T.Watanabe  1998/04/02
 *                      S.Yamamoto  1998/04/04
 * 
 * (C) Copyright:       T.Watanabe and S.Yamamoto  1998
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdFltFile.c,v 30.7 2003/06/28 15:34:07 yamamoto Exp yamamoto $";
#endif

#include "SpdFlatten.h"

SpdString spdStrFile2(SpdObjId objectId)
{
    SpdString   res = NULL;
    SpdRel      decl_rel, *decl_buf = NULL; 
    int         i, j, decl_buf_n = 0;
    SpdCursor   *csr;
    Block *cblock = NULL;

    /* objectId Υ饹 file ǤʤСNULL ֤ */
    if ((spdGetClassId(objectId)) != SPD_CID_FILE) {
        return res;
    }

    csr = spdGetRelInit(objectId, "file_decl", "p-id");
    while ((decl_rel = spdGetRel(csr)).relationId != -1) {
        decl_buf = spdRealloc(decl_buf, sizeof(SpdRel) * (decl_buf_n + 1));
        decl_buf[decl_buf_n++] = decl_rel;
    }
    spdFreeCursor(csr);
    SPD_QSORT(decl_buf, decl_buf_n, sizeof(SpdRel), cmp_offset);

    for (i = 0; i < decl_buf_n; i++) {
        if (i != 0) res = spdStrCat(res, "\n");
        cblock = spdStrDeclaration2(decl_buf[i].objectId, FALSE);
        for(j = cblock->decl.num - 1; j >= 0; j--){
            res = spdStrCat(res, cblock->decl.str[j]);
        }
        for(j = cblock->expr.num - 1; j >= 0; j--){
            res = spdStrCat(res, cblock->expr.str[j]);
        }
    }
    if (decl_buf != NULL) spdFree(decl_buf);
    return res;
}

Block *spdStrDeclaration2(SpdObjId objectId, SpdBoolean asProtoParm)
{
    SpdObjId    obj_id;
    SpdCursor   *csr;
    SpdRel      decl_rel, *decl_buf;
    SpdRelArray decl_s_buf;
    int         decl_buf_n, sort, i, j, k;
    SpdString   dres = NULL, eres = NULL, tmp_res = NULL;   
    Block *cblock = NULL, *pblock = NULL, *tmp_block = NULL;
    
    /* objectId Υ饹 declaration ǤʤСNULL ֤ */
    if ((spdGetClassId(objectId)) != SPD_CID_DECLARATION) {
        return NULL;
    }

    tmp_res = spdStrCat(tmp_res, "\n");   
    tmp_res = spdStrCat(tmp_res, spdStrIndent());
    /* 饹(storage) */
    switch (spdGetAttrValInt(objectId, "storage")) {
      case STORAGE_EXTERN:
        tmp_res = spdStrCat(tmp_res, "extern ");
        break;
      case STORAGE_STATIC:
        tmp_res = spdStrCat(tmp_res, "static ");
        break;
      case STORAGE_AUTO:
        tmp_res = spdStrCat(tmp_res, "auto ");
        break;
      case STORAGE_REGISTER:
        tmp_res = spdStrCat(tmp_res, "register ");
        break;
      case STORAGE_TYPEDEF:
        tmp_res = spdStrCat(tmp_res, "typedef ");
        break;
      default:
        break;
    }
  
    switch (sort = spdGetAttrValInt(objectId, "sort")) {
      case DECL_NORMAL:                     /* ѿΤʤؿ */
        /* ХѿϽʤ */
        if (spdGetARelObj(objectId, "file_decl", "any") != SPD_NON_ID) {
            dres = spdStrDeclaration(objectId, asProtoParm);
            break;
        }
        dres = spdStrCat(dres, tmp_res);
        spdFree(tmp_res);
        obj_id = spdGetARelObj(objectId, "decl_type", "p-id");
        /* i = 0;
           while (rel_class[i] != NULL &&
           (offset = spdGetOffset(spdGetARel(objectId, rel_class[i++],
           "c-id").relationId)) == -1);
           */
        dres = spdStrCat(dres, spdStrTypeSpecifier(obj_id));
        /* 
         * decl_type  declaration η򼨤ƤʤȤ
         * Х
         * > ϡΤ褦ˤ롥
         * > dres = spdStrCat(dres, spdStrType(obj_id));
         * >                         ^^^^^^^^^^
         * struct ηɽˡoffset ˤȽǤäΤǡ
         * spdStrType() Ѥʤ褦˻פ롥
         */
        decl_buf = NULL;
        decl_buf_n = 0;
        csr = spdGetRelInit(objectId, "decl_decl", "p-id");
        while ((decl_rel = spdGetRel(csr)).relationId != -1) {
            decl_buf = spdRealloc(decl_buf, sizeof(SpdRel) * (decl_buf_n + 1));
            decl_buf[decl_buf_n++] = decl_rel;
        }
        spdFreeCursor(csr);
        SPD_QSORT(decl_buf, decl_buf_n, sizeof(SpdRel), cmp_offset);
        /* k = 1Ϸޤ */
        if (spdGetAttrValInt(decl_buf[0].objectId, "sort") == DECL_TAG) k = 1;
        else k = 0;
    
        if (k == 1) {                       /* ȤäƤ */
            SpdObjId opt_id;
            if ((opt_id = spdGetARelObj(decl_buf[0].objectId, "decl_opt",
                                        "p-id")) != SPD_NON_ID) {
                dres = spdStrCat(dres, " ");
                dres = spdStrCat(dres, spdStrOptionaldecl(opt_id));
            }
        }

        for (i = k; i < decl_buf_n; i++) {
            if(cblock != NULL) freeBlock(cblock);
            if (i > k) {
                dres = spdStrCat(dres, ", ");
            } else {
                dres = spdStrCat(dres, " ");
            }
            cblock = spdStrDeclarator2(decl_buf[i].objectId, FALSE);
            tmp_block = initBlock();
            for(j = cblock->decl.num - 1; j >= 0; j--){
                if(cblock->decl.num - 1 == j){
                    dres = spdStrCat(dres, cblock->decl.str[j]);
                } else {
                    addElementToBlock(tmp_block, cblock->decl.str[j], DECL); 
                }   
            }
            for(j = cblock->expr.num - 1; j >= 0; j--){
                if(j != cblock->expr.num - 1) {
                    eres = spdStrCat(eres, "\n");
                    eres = spdStrCat(eres, spdStrIndent());
                }
                eres = spdStrCat(eres, cblock->expr.str[j]);
                eres = spdStrCat(eres, ";");
            }
        }
        dres = spdStrCat(dres, ";");    
        if(tmp_block != NULL){
            for(j=0; j < tmp_block->decl.num; j++){
                dres = spdStrCat(dres, "\n");
                dres = spdStrCat(dres, spdStrIndent());
                dres = spdStrCat(dres, tmp_block->decl.str[j]);
                dres = spdStrCat(dres, ";");
            }
            freeBlock(tmp_block);
        }
        spdFree(decl_buf);
        break;
      case DECL_FUNCDEF:                    /* ؿ */
        dres = spdStrCat(dres, tmp_res);
        spdFree(tmp_res);
        if ((obj_id = spdGetARelObj(objectId, "decl_type", "p-id")) !=
            SPD_NON_ID) {
            dres = spdStrCat(dres, spdStrTypeSpecifier(obj_id));
        }
        decl_s_buf = spdGetRelSortedArray(objectId, "decl_decl",
                                          "declaration_id", NULL,
                                          spdCompareRelOffset);
        if (decl_s_buf.size != 0) {  
            SpdObjId decl_id;
            decl_id = decl_s_buf.rel[decl_s_buf.size-1].objectId;
            cblock = spdStrDeclarator2(decl_id, FALSE);
            if (obj_id != SPD_NON_ID && cblock != NULL) {
                /* type specifier ¸ߤ declarator  NULL Ǥʤ */
                dres = spdStrCat(dres, " ");
                for(j = cblock->decl.num - 1; j >= 0; j--){
                    dres = spdStrCat(dres, cblock->decl.str[j]);
                }
                for(j = cblock->expr.num - 1; j >= 0; j--){
                    eres = spdStrCat(eres, cblock->expr.str[j]);
                }
            }
        }
        spdFreeRelArray(decl_s_buf);
        break;
      default:
        dres = spdStrDeclaration(objectId, asProtoParm);
        break;
    }

    pblock = initBlock();
    if(dres != NULL) addElementToBlock(pblock, dres, DECL);
    if(eres != NULL) addElementToBlock(pblock, eres, EXPR);
    if(cblock != NULL) freeBlock(cblock);

    return pblock;
}
