/* 
 * Program:             $RCSfile: spdFltMain.c,v $  $Revision: 30.10 $
 * 
 * Purpose:
 * 
 * Author:              T.Watanabe  1998/04/02
 *                      S.Yamamoto  1998/04/04
 * 
 * (C) Copyright:       T.Watanabe and S.Yamamoto  1998 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdFltMain.c,v 30.10 2003/06/28 15:34:07 yamamoto Exp yamamoto $";
#endif

#include "SpdFlatten.h"

#define DEFAULT_MODE    SAPID_I_MODE
#define ERROR_MESSAGE \
     "Usage: %s filename\n              %s programName objectId\n"

static void do_spdStr2(SpdObjId id)
{
    SpdString   result;

    if ((result = spdStr2(id)) != NULL) {
        puts(result);
    }
}

int main(int argc, char *argv[])
{
    SpdObjId   prog_id;
    SpdString  fileName = NULL;
    int        fileNameLen;
    int        modeOption = SAPID_NON_OPTION; /* Saved spdOption's mode. */
    SpdCursor  *file_csr;
    SpdBoolean foundFlag = FALSE;
  
    if (argc == 2) {
        /* program, *.c, *.i Τߤꤵ줿硥 */
        SpdString   progName = NULL;
        SpdObjId    file_id;

        fileNameLen = strlen(argv[1]);
        progName = smuGetAProgramName();        

        if (spdIsFileExtension(argv[1], ".i")) {
            modeOption = SAPID_I_MODE;
            if ((prog_id = spdTarget("I-model", progName)) == SPD_NON_ID) {
                spdErrorExit("Program \"%s\" not found.\n", progName);
            }
            spdSetOption("mode", modeOption);

            file_csr = spdGetRelObjInit(prog_id, "prog_file", "any");
            while((file_id = spdGetRelObj(file_csr)) != SPD_NON_ID){
                if(SPD_STREQ(spdGetName(file_id), argv[1])){
                    do_spdStr2(file_id);
                    spdStrFree();
                    foundFlag = TRUE;
                    break;
                }
            }
            if(foundFlag) spdFreeCursor(file_csr);
        } else if (spdIsFileExtension(argv[1], ".c")) {
            /* !! Convert suffix ".c" into ".i". */
            fileName = spdMalloc(fileNameLen + 1);
            strcpy(fileName, argv[1]);
            fileName[fileNameLen - 1] = 'i';
            
            modeOption = SAPID_I_MODE;
            if ((prog_id = spdTarget("I-model", progName)) == SPD_NON_ID) {
                spdErrorExit("Program \"%s\" not found.\n", progName);
            }
            spdSetOption("mode", modeOption);

            file_csr = spdGetRelObjInit(prog_id, "prog_file", "any");
            while((file_id = spdGetRelObj(file_csr)) != SPD_NON_ID){
                if(SPD_STREQ(spdGetName(file_id), fileName)){
                    do_spdStr2(file_id);
                    spdStrFree();
                    foundFlag = TRUE;
                    break;
                }
            }
            if(foundFlag) spdFreeCursor(file_csr);
            spdFree(fileName);
        } else {
            spdErrorExit("Invalid file name: \"%s\".\n", argv[1]);
        }
    } else if (argc == 3) {
        /* ץ̾ȥֹ֥椬ꤵ줿硥 */
        if (modeOption == SAPID_NON_OPTION) {
            modeOption = DEFAULT_MODE;
        }
        if((prog_id = spdTarget("I-model", argv[1])) == SPD_NON_ID){
            spdErrorExit("Program \"%s\" not found.\n", argv[1]);
        }
        spdSetOption("mode", modeOption);
        do_spdStr2(atoi(argv[2]));
        spdStrFree();
    } else {
        spdErrorExit(ERROR_MESSAGE, argv[0], argv[0]);
    }
  
    return (EXIT_SUCCESS);
}
