/* 
 * Program:             $RCSfile: spdHouseBlock.c,v $  $Revision: 30.2 $
 * 
 * Purpose:
 * 
 * Author:              T.Watanabe  1998/04/02
 *                      S.Yamamoto  1998/04/04
 * 
 * (C) Copyright:       T.Watanabe and S.Yamamoto  1998
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdHouseBlock.c,v 30.2 2003/06/08 02:44:01 yamamoto Exp yamamoto $";
#endif

#include "SpdFlatten.h"

Block *initBlock(void)
{
    Block *block = spdMalloc(sizeof(Block));

    block->expr.num = 0;
    block->expr.str =(SpdString *)spdMalloc(sizeof(SpdString ) *
                                            (block->expr.num + 1));
    block->decl.num = 0;
    block->decl.str = (SpdString *)spdMalloc(sizeof(SpdString ) *
                                             (block->decl.num + 1)); 
    return block;
}

void freeBlock(Block *block)
{
    int i;

    for(i=0; i < block->expr.num; i++){
        if(block->expr.str[i] != NULL) spdFree(block->expr.str[i]);
    }
    for(i=0; i < block->decl.num; i++){
        if(block->decl.str[i] != NULL) spdFree(block->decl.str[i]);
    }
    if(block->expr.str != NULL) spdFree(block->expr.str);
    if(block->expr.str != NULL) spdFree(block->decl.str);
    if(block != NULL)  spdFree(block);
}

Block *copyBlock(Block *copied)
{
    Block *block = initBlock();
    int i;

    block->expr.num = copied->expr.num;
    block->expr.str = spdMalloc(sizeof(SpdString) * (block->expr.num + 1));
    for(i = 0; i < block->expr.num; i++){
        block->expr.str[i] = spdStrCat(block->expr.str[i], copied->expr.str[i]);
    }
    block->decl.num = copied->decl.num;
    block->decl.str = spdMalloc(sizeof(SpdString) * (block->decl.num + 1));
    for(i = 0; i < block->decl.num; i++){
        block->decl.str[i] = spdStrCat(block->decl.str[i], copied->decl.str[i]);
    }
    return block;
}

void addElementToBlock(Block *block, SpdString str, int isExpr)
{
    if(isExpr == EXPR){
        block->expr.str = spdRealloc(block->expr.str, 
                                     sizeof(SpdString) * (block->expr.num + 1));
        block->expr.str[block->expr.num] = NULL;
        block->expr.str[block->expr.num++] = spdStrCat(
                                                       block->expr.str[block->expr.num], str); 
    }else if(isExpr == DECL){
        block->decl.str = spdRealloc(block->decl.str, 
                                     sizeof(SpdString) * (block->decl.num + 1));
        block->decl.str[block->decl.num] = NULL;
        block->decl.str[block->decl.num++] =
            spdStrCat(block->decl.str[block->decl.num], str); 
    }else {
        printf("isExpr is wrong!\n");
    }
}

/* 
 * SpdString appendElement(SpdString pre, SpdString sur)
 * {
 *     pre = SpdRealloc(strlen(sur)):
 * }
 */

void printBlock(Block *block)
{
    int i;


    printf("block->decl.num = %d\n",block->decl.num);
    printf("block->expr.num = %d\n",block->expr.num);
    for(i = block->decl.num -1; i >= 0; i--){
        printf("%s", block->decl.str[i]);
    }
    for(i = block->expr.num -1; i >=0; i--){
        printf("%s", block->expr.str[i]);
    }
}
