# 
# Program:              $RCSfile: Macro.pm,v $  $Revision: 30.4 $
# 
# Purpose:              Latex Macro convert routine.
# 
# Author:               T.Suzuki  1997/08/01
#                       S.Yamamoto  1997/08/01
# 
# Copyright:            T.Suzuki and S.Yamamoto  1997 - 2002
#                       This file is a product of the project Sapid.
# 

# 
# $Id: Macro.pm,v 30.4 2002/11/26 10:32:22 yamamoto Exp yamamoto $
# 

package Macro;

sub par {
    Out::putC("<p>\n");
}

$secStr = ""; # ɽѥֹ

sub sections {
    my ($hlvl, $sec_lvl, $sec_star) = @_;

    if ($hlvl <= 3) {

	&Out::secLabel();
	
	my ($dmySecStr) = "";
	$secStr = '*';
	$secStr = &Counter::seccount($sec_lvl) if ($sec_star == 0);
	$dmySecStr = &Counter::seccount2($sec_lvl);

	if ($hlvl <=1){
	    &Out::openSecPage($secStr, $dmySecStr);
	    &Out::putC( "\@\@SEC_INSERT$dmySecStr\@\@\n");
	    &Out::putC( "<HR>" );
	}
	
	&Out::putC("<H$hlvl>");
	&Out::putC("<A NAME=\"LABEL_S_$dmySecStr\">");
	&Out::putS(" $secStr ") if ($sec_star == 0);
	&Out::putC( "</A>" );
	$Out::outbuf = '';
	&main::innerLoopPut('{', '}');
	$SecCaption = $Out::outbuf;
	$Out::outbuf = '';
	&Out::putC( "</H$hlvl>\n" );

	$Out::secLblflag = 0;
    } else {
	&Out::putC( "<B>" );
	&main::innerLoopPut('{', '}');
	&Out::putC( "</B>" );
    }
}

sub section_star {
    my ($hlvl, $sec_lvl) = @_;
    sections($hlvl, $sec_lvl, 1);
}

sub section        { sections(1, 'section');1}
sub section_       { section_star(1, 'section');1}
sub subsection     { sections(2, 'subsection'); 1}
sub subsection_    { section_star(2, 'subsection'); 1}
sub subsubsection  { sections(3, 'subsubsection'); 1}
sub subsubsection_ { section_star(3, 'subsubsection'); 1}
sub paragraph      { sections(4, 'paragraph'); 1}
sub subparagraph   { sections(5, 'subparagraph'); 1}

sub item {
    my $tk;
    
    if ($TEnv::ListStack[$#TEnv::ListStack] eq 'dl'){
	# Description
	$tk = &Parser::forwRead('[', ']');
	
	if ($tk ne ''){
	    &Out::putC( "<DT> " );
	    &Parser::ungett($tk);
	    &main::innerLoopPut('[', ']');
	}
	&Out::putC( "<DD> " );
    } else {
	# itemize / enumrate
	$tk = &Parser::forwRead('[', ']');
	&Parser::ungett($tk);
	if ($tk !~ /^\[(.*)\]$/) {
	    &Out::putC( "<LI> " );
	} else {
	    &Out::putC( "<br>" );
	    &main::innerLoopPut('[', ']');
	}
    }
}

# Fonts
sub rm {&Out::putC( '<!--rm-->' );1}
sub bf {&Out::putC( '<B>' ); unshift(@TEnv::EnvCur, '</B>');1}
sub it {&Out::putC( '<I>' ); unshift(@TEnv::EnvCur, '</I>');1}
sub sl {&Out::putC( '<I>' ); unshift(@TEnv::EnvCur, '</I>');1}
sub sf {&Out::putC( '<!--sf-->' );1}
sub tt {&Out::putC( "<TT>" );unshift(@TEnv::EnvCur, "</TT>");1}
sub sc {&Out::putC( '<!--sc-->' );1}
sub dg {&Out::putC( '<B>' ); unshift(@TEnv::EnvCur, '</B>');1}
sub dm {&Out::putC( '<!--dm-->' );1}


sub input {
    my $tk;

    my ($file) = (&Parser::forwReadBrace =~ /\{(.*)\}/s);

    &Parser::openFile($file);
}

sub caption {
    &TEnv::captionPut;
    &main::innerLoopPut('{', '}');
    &Out::putC("<BR>\n");
}

$SecCaption = '';  # ߤsectionθФХåե
$FigCaption = '';  # ߤfigure/tableθФХåե

sub label {
    local $_ = &Parser::forwReadBrace;

    if (/\{(.+)\}/s){
	if ($TEnv::LblEnv[0] eq 'document'){
            #   TeX٥, ȥե, ٥, бCaption, 
	    &Out::llabel($TEnv::LblEnv[0], $1,
			"LABEL_S_".&Counter::getcount2($TEnv::LblEnv[0]),
			 &Counter::getcount2($TEnv::LblEnv[0]),
			 "$secStr  $SecCaption");
	} elsif($TEnv::LblEnv[0] eq 'FAQ') {
	    &Out::llabel($TEnv::LblEnv[0], $1,
			"LABEL_FAQ_".&Counter::getcount($TEnv::LblEnv[0]),
			&Counter::getcount($TEnv::LblEnv[0]),
			$FAQNO);
	} else {
	    &Out::llabel($TEnv::LblEnv[0], $1,
			"LABEL_F_".&Counter::getcount('NameCount'),
			&Counter::getcount($TEnv::LblEnv[0]),
			,'');
	}
    }else{
        &main::warnPut("Label not found (next :: $_)");
    }
}

sub ref {
    local $_ = &Parser::forwReadBrace;

    if (/\{(.+)\}/s){
	&Out::putC( "<A HREF=\"\@\@$1\@\@\">[ref]</A>\n" );
    }else{
        &main::warnPut("Label not found (next :: $_)");
    }
}



$AUTHOR = '{}';
$TITLE  = '{(No TITLE)}';
$DATE   = '{}';

sub author {
    $AUTHOR = &Parser::forwReadBrace;
}

sub title {
    $TITLE = &Parser::forwReadBrace;
}

sub date {
    $DATE = &Parser::forwReadBrace;
}

sub maketitle {
    &Out::putC( "<CENTER>" );
    &Out::putC( "<H1>" );
    &Out::putC($TITLE);
    &Out::putC( "</H1>\n" );
    &Parser::ungett($AUTHOR);   &main::innerLoopPut('{', '}');
    &Out::putC( "<BR>\n" );
    &Parser::ungett($DATE);	&main::innerLoopPut('{', '}');
    &Out::putC( "</CENTER>\n" );
    &Out::putC( "<HR>\n" );

    &Out::putC( "\@\@SEC_INSERT\@\@\n");
}

%scale = (           # mm 
	  'in', 25.4,
	  'mm', 1,
	  'cm', 10,
	  'pt', 0.35,
	  'em', 12*0.35,
	  'ex', 12*0.35/2,
	  '\textwidth', 360*0.35,   # 11pt
);


sub fig_conv_outp {
    my $fname = shift;
    my $format= shift;
    my $scale = shift;
    my $size  = '';

     if ($scale ne ''){
# 	$size = "-geo $scale";
     } elsif ($width ne ''){
# 	$scale = $scale{$unit} * $scale{'\textwidth'}; 
# 	$size = "-size $scale%";
     }

    if (!(-e "$fname.$format")) {
        my $output = `convert $size "$fname.eps" "$fname.$format"`;
        &Out::errLog("convert $size $fname.eps $fname.$format\n", $output);
    }
    &Out::putC("<IMG SRC=\"$fname.$format\" ALT=\"$fname\">");
}


sub epsfile {
    my $str = &Parser::forwReadBrace;
    my ($fname) = ($str =~ /file=([^,]+)[,\}]/);
    my ($scale) = ($str =~ /scale=([\d\.]+)/);
    my ($width, $unit) = ($str =~ /width=([\d\.]+)([^,]+)[,\}]/);
    my ($height) = ($str =~ /height=([\d\.]+)/);

    $fname =~ s/\.eps$//;

    if ($main::outFigFormat ne '' && $main::outFigFormat ne 'eps') {
        &fig_conv_outp($fname, $main::outFigFormat, $scale);
    } else {
        &Out::putC("<IMG SRC=\"$fname.eps\" ALT=\"$fname\">");
    }
}


sub footnote {
    my $cou = &Parser::forwRead('[', ']');
    push @Out::FOOTNOTE, &Parser::forwReadBrace;
    $cou = &Counter::count('footnote');
    
    &Out::putC("<A HREF=\"#footnote$cou\"> [$cou] </A>");
}


# TeX ޥ :: TEX.pmƤΤؤΥ󥿥ե

use TEX;

sub def { 
    my $comname;
    $comname = &TEX::def();
    if ( $comname ne '' ){ # ̾
	&Out::errLog("making 'sub $comname'\n");
	eval "sub Macro::$comname {&TEX::TeXMacro('$comname');}";
	return 1;
    }

    return 0;
}

sub newcommand { 
    my $comname;

    if ($comname = &TEX::newcom){
#	&Out::errLog("making 'sub $comname'\n");
	eval "sub Macro::$comname {&TEX::TeXMacro('$comname');}";
	return 1;
    } else {
	&main::perror("Inner Error: ERROR#1\n");
    }
    return 0;
}

# ʸ

sub TeX   { &Out::putS("TeX");}
sub LaTeX { &Out::putS("LaTeX");}

sub symbol {
    my $str = &Parser::forwReadBrace;
    $str =~ m/([\da-f]+)/i;
    &Out::putS(chr(eval "0x$1"));
}

sub verb {
    my $tk  = &Parser::getchar;
    my $str = &Parser::read($tk, '');
    chop $str;
    &Out::putS($str);
}

sub _ifnextchar {

    my $nexttok = &Parser::getchar; # '['

    my $then = &Parser::forwReadBrace;
    my $els  = &Parser::forwReadBrace;

    my $nextchr2 = &Parser::getchar;
    &Parser::ungett($nextchr2);
    if ($nextchr2 ne $nexttok){
	$then = $els;
    }

    my ($tok) = $then =~ /\{(.*)\}/s;
    &Parser::ungett($tok);
}

#
# Analyze but do Nothing.
#
#sub vspace { &TEX::ignoreMacro('{', 'vspace');}
sub vspace_ {&Parser::forwReadBrace;  &Out::ignored('vspace*');}
sub hspace {&Parser::forwReadBrace;Out::putC("  ");
	    &Out::ignored('hspace');}
sub hspace_ {&Parser::forwReadBrace;Out::putC("  ");
	     &Out::ignored('hspace*');}

sub ifx { &Parser::read('\fi', 'MACRO'); &Out::ignored('ifx');}

sub tableofcontents 
{
    &Out::putC( "\@\@SEC_INSERT\@\@\n");
}

# Tabular Environment
sub hline       {&Out::ignored('hline(May be Out of Table)'); }
sub multicolumn {&Out::ignored('multicolumn(May be Out of Table)'); }

sub fbox {
    &Out::putC("<TABLE BORDER=1><TR><TD>\n");
    &main::innerLoopPut('{', '}');
    &Out::putC("</TD></TR></TABLE>\n");
}

1
