# 
# Program:              $RCSfile: Parser.pm,v $  $Revision: 30.3 $
# 
# Purpose:
# 
# Author:               T.Suzuki  1997/08/01
#                       S.Yamamoto  1997/08/01
# 
# Copyright:            T.Suzuki and S.Yamamoto  1997 - 2002
#                       This file is a product of the project Sapid.
# 

# 
# $Id: Parser.pm,v 30.3 2002/11/26 10:32:23 yamamoto Exp yamamoto $
# 

#
# Definistion
# 

# package Mark;

# $esc = '\';
# $bgrp = '{';
# $egrp = '}';
# $mtmd = '$';
# $alin = '&';
# $parm = '#';
# $comm = '%';
# $hat  = '^';
# $ubar = '_';
# $undr = '_';
# $actv = '~';

# $alph = 'A-Za-z';


package Parser;

$token_buf = '';          # ߤʸХåե
$state = 'N';             # 
$sort  = '';              # ɤ߹ȡμ(tex)
$type  = '';              #
$EOF=0;                   # եɤ߹ߤλ

$files = 0;               # ץ󤷤Ƥեο
$fname = '';              # ߽Υե̾
@fnames = ();		  # ե̾Υꥹ

@texinputs = ();          # texinuputΥǥ쥯ȥ

$otherMk = '\!\@\*\(\)\-\+\=\|\[\]\:\;\<\>\,\.\?\/\`\"'."\\'"; #"

# TEXINPUTS directory 
# Input
#   1. ':'Ƕڤ줿ѥʸ
# Output
#   @texinuputs 
sub setInputdir {
    my ($dirs)   = @_;
    @texinputs = split(':', $dirs);
    unshift @texinputs, '.', '';
}

# եΥץ
# Input
#  1. TeX source file name (directory Ĥ, .texǤ)
# Output
#  None
#  $files, $fname, @fnames , 
sub openFile {

    push @fnames, $fname;

    ($fname) = @_;

    $fname .= ".tex" if ($fname !~ /.tex$/);

    &Out::errLog("File::$fname\n");
    $files++;

    for (@texinputs) {
	if (open("INPUT$files", "<$_/$fname")){
	    &Out::errLog("open :: $_/$fname\n");
	    return 1;
	}
    }

    &main::perror("Can't open $fname");
    return 0;
}

# ߽ΥեĤ
# Input None
# Output
#   $fname ˽٤ե̾򤤤
#   @fnames, $filesι
sub closeFile {
    close "INPUT$files";

    $fname = pop @fnames;
    $files--;
    return !$files;
}

# VerbatimĶѤϥ롼
# Input None
# Output : ʸ
#   $STR 򹹿
# Description
#   '\end{verbatim}'ߤĤޤǤʸ֤
sub getVerbatim {
    my $str = '';

    while(!($token_buf =~ m/\\end\{verbatim\}/o)) {
	$EOF = closeFile if eof("INPUT$files");
	return if ($EOF);

	$str .= $token_buf;
	$token_buf = eval "<INPUT$files>";
    }

    $str =~ s/\\/\\\\/g;

    return $str;
}

# 1ʸФ
# Input  None
# Output Фʸ
#   $token_bufѹ
sub getchar {
    my $str = '';

    $token_buf = eval "<INPUT$files>" if ($token_buf eq '');
    
    $token_buf =~ s/^(.)//;

    return $1;
}

# TeX ʸȡμ
# Input  None
# Output ɤ߹ʸ
#   $token_bufѹ $token_type
# Description
#   TeXʸȡ󤴤Ȥɤ߹
#   ǧȡϡ
#     桢ʸ󡢥ޥڡ TYPEġ
sub gettkn {

    if ($token_buf eq '') {
	$EOF = closeFile if eof("INPUT$files");
	return '' if ($EOF);
	my $rd_line = eval ("<INPUT$files>");
	$rd_line =~ s/^[ \t]*//;
	$token_buf .= $rd_line;
    }

    if ($token_buf =~ s/^([A-Za-z\.]+)//) {    # Alphabet(11)
	$type = "alph";
	$sort = 11;
	return $1;

    } elsif ($token_buf =~ s/^([\x80-\xff]+)//) { # Kanji (EUC)
	$type = "alph";
	$sort = 11;
	return $1;

    } elsif ($token_buf =~ /^\n/) {	# return(5)
	$token_buf = '';
	$sort  = 5;
	$type  = 'Ret';
	return "\n";

    } elsif ($token_buf =~ s/^([ \t\s]+)//){ # Space(10)
	$type = 'Space';
	$sort = 10;
	return $1;

    } elsif ($token_buf =~ /^\%.*\n/) { # Comment(14)
	my $ret = $token_buf;
	chop $ret;
	$token_buf = "";
	$sort = 14;
	$type = 'Comment';
	return $ret;

    } elsif ($token_buf =~ s/^(\\\@?[a-zA-Z]+\*?)//) { # Cnt'l word (0)
	$type = 'CtrlSeq';
	$sort = 0;
	return $1;

    } elsif ($token_buf =~ s/^(\\[^A-Za-z])//) {        # Cnt'l Symbol(0)
	$type = 'CtrlSeq';
	$sort = 0;
	return $1;

    } elsif ($token_buf =~ s/^(\d+)//) {	     # Number (12)
	$type = 'number';
	$sort = 12;
	return $1;

    } elsif ($token_buf =~ s/^([\{\}\$\&\#\^\_\]\~\%])//) {
	 # tex default specail Mark (1,2,3,4,5,6,7,8,13)
 	$type = 'S-Mark';
	$sort = 1;
 	return $1;

    } elsif ($token_buf =~ s/^([$otherMk])//o) {     # Other marks(12)
	$type = 'O-Mark';
	$sort = 12;
	return $1;
    }

    &main::perror("Not Match!($type:$sort)> $token_buf <\n");
    $token_buf =~ s/^.//;
}

# ʸХåեʸ᤹
sub ungett {
    $token_buf = $_[0] . $token_buf;
}

# ֤
# ϤεѹȡɲäԤʤ
# $stateѹ
# $type, $sort ѲϤʤ
# : ɤ߹ߡʸ
# tex state
#  'N': ԤƬ
#  'M': Ԥ
#  'S': ζϥå (ref. TeXBook)
sub parse {
    my $p = gettkn();
    my $envName;

    return '' if ($Parser::EOF);

    if ($sort == 5) { # "\n"
	return $p if ($state eq 'N2');
	if ($state eq 'N') {
	    &Out::putC("<P>\n");
	    $state = 'N2';
	    return $p;
	} 
	$p = ' ' if ($state eq 'M');
	$p = '' if ($state eq 'S');
	$state = 'N';
	return $p;
    }

    if ($sort == 10) { # ' '
	my $ret = $p;
	if ($state eq 'M') {
	    $ret = ' ';
	    $state = 'S';
	} else {
	    $ret = '';
	}
	$ret = $p if ($TEnv::PRE);
	return $ret;
    }

    if ($sort == 14) { # '%..'
	return '';
    }

    if ($sort == 0) {  # contrl sequence
	if (length $p == 2) { # symbol
	    $state = 'S';
	} else { # word or '\n'
	    $state = 'M';
	}
	return $p;
    }

    $state = 'M';

    if ($p eq '$') {  # delete math mode mark
       return '';
    } 

    return $p;
}

# ҤȤĤ ̤Ȥɤ߹
# Input
#   1.ϵ  2.λ
# Output
#   ɤ߹ʸ
# Description
#   Ҥ᤹롣
sub forwRead {		

    my ($s_mk, $e_mk) = @_;
    my ($tk, $buf, $lvl) = ('', '', 0);
    
    while(!$Parser::EOF){
	$tk = &Parser::gettkn();
	next if ($type eq 'Space' || $tk eq "\n"); # ¿ʬס
	last;
    }
    
    return '' if ($tk ne $s_mk && ungett($tk));

    $lvl++;
    $buf .= $tk;

    while(!$EOF){
	$tk = gettkn();
	$buf .= $tk;
	last if (($tk eq $e_mk) && ($lvl-- == 1));
	$lvl++ if ($tk eq $s_mk);
    }
    
    return $buf;
}

# ҤȤĤ '{...}'Ȥɤ߹
# Input  None
# Output ɤ߹ʸ
sub forwReadBrace {     

    my ($tk, $buf, $lvl) = ('', '', 0);
    my ($s_mk, $e_mk) = ('{', '}');
    
    while(!$Parser::EOF){
	$tk = &Parser::parse();
	next if ($type eq 'Space' || $tk eq "\n"); # ¿ʬס
	last;
    }
    
    return $tk if ($tk ne $s_mk);

    $lvl++;
    $buf .= $tk;

    while(!$EOF){
	$tk = parse();
	$buf .= $tk;
	last if (($tk eq $e_mk) && ($lvl-- == 1));
	$lvl++ if ($tk eq $s_mk);
    }
    
    return $buf;
}

#  `{...}'֤
# Input None
# Output ɤ߹ʸ
sub forwReadBraceInner {
    local $_ = forwReadBrace();
    return $1 if (/^\{(.*)\}$/);
    return $_;
}

# 뵭椬иޤɤ߹
# ɤ߹ʸ֤
# Input
#   1. λȡ  2. λTYPE
# Output
#   줿ʸ
sub read {
    my ($mark, $type) = @_;
    
    my ($tk, $buf) = ('', '');

    while(!$EOF){
	$tk = gettkn();
	$buf .= $tk;

	last if ($tk eq $mark); # && ($type eq '' || $type eq $type));
    }

    return $buf;
}

1
