# 
# Program:              $RCSfile: TEnv.pm,v $  $Revision: 30.3 $
# 
# Purpose:              Tex Environment (\begin{}\end{})˴ؤ⥸塼롥
# 
# Author:               T.Suzuki  1997/08/01
#                       S.Yamamoto  1997/08/01
# 
# Copyright:            T.Suzuki and S.Yamamoto  1997 - 2002
#                       This file is a product of the project Sapid.
# 

# 
# $Id: TEnv.pm,v 30.3 2002/11/26 10:32:25 yamamoto Exp yamamoto $
# 

package TEnv;

@ListStack = (); # \itemͭʴĶ򼨤

@EnvVar = ();    # '{','}'ǰϤޤ줿ʬθ夫Ť򵭲
@EnvCur = ();    # äϥѹ뤫

@LblEnv = ();    # ߤΥ٥뤬Ķ
		 # List of One of 'document', 'table', 'figure',...
$PRE   = 0;
$SPACE = 1;      # Spaceɽ뤫ɤΥե饰 0:Not-Put 1:Put

# Ordinary Environment
sub document {
    &Out::openTitlePage();    # printout <header>
    unshift @LblEnv, 'document';
}
sub enddocument {
    &Out::closeSecPage();
    shift @LblEnv;
}

sub itemize       { &Out::putC("<UL>\n"); push @ListStack, 'ul';}
sub enumerate     { &Out::putC("<OL>\n"); push @ListStack, 'ol';}
sub description   { &Out::putC("<DL>\n"); push @ListStack, 'dl';}
sub enditemize     { &Out::putC( "</UL>\n" ); pop @ListStack;}
sub endenumerate   { &Out::putC( "</OL>\n" ); pop @ListStack;}
sub enddescription { &Out::putC( "</DL>\n" ); pop @ListStack;}

sub verbatim      {
    &Out::putC("<TABLE><TR><TD>");
    &Out::putC("<PRE>"); $PRE = 1;
    &Out::putS(&Parser::getVerbatim);
    # &endverbatim;
}

sub endverbatim    { &Out::putC( "</PRE></TD></TR></TABLE>\n"); $PRE = 0;}
sub center        { &Out::putC("<CENTER>\n"); }
sub endcenter      { &Out::putC( "</CENTER>\n");}

sub figure { # ҤȤĤ figure/tableĶˤϤҤȤĤcaption, Բ.
    &Parser::forwRead('[', ']');
    &Out::putC("<CENTER>\n");
    &Out::putC('<A NAME="LABEL_F_',
	       &Counter::count('NameCount'), '">', "<BR></A>\n");
    unshift @LblEnv, 'figure';
}
sub endfigure      { &Out::putC( "</CENTER>\n"); shift @LblEnv;}

sub table {
    &Out::putC("<CENTER>\n");
    &Parser::forwRead('[', ']');
    &Out::putC('<A NAME="LABEL_F_',
	       &Counter::count('NameCount'), '">', "<BR></A>\n");
    unshift @LblEnv, 'table';
}
sub endtable       { &Out::putC( "</CENTER>\n"); shift @LblEnv;}

sub quote	  { &Out::putC("<BLOCKQUOTE>\n"); }
sub endquote	  { &Out::putC( "</BLOCKQUOTE>\n" );}

sub quotation	  { &Out::putC("<BLOCKQUOTE>\n"); }
sub endquotation	  { &Out::putC( "</BLOCKQUOTE>\n" );}

%scale = (           # mm 
	  'in', 25.4,
	  'mm', 1,
	  'cm', 10,
	  'pt', 0.35,
	  'em', 12*0.35,
	  'ex', 12*0.35/2
);

sub minipage {
    &Parser::forwRead('[', ']');
    &Parser::forwReadBrace;
#     $sizeStr =~ /(\d+)(.+)/;
    
#     $sz = $2 * $scale{$1} / (390*0.35) * 100;
#    &Out::putC("<table width =\"$sz%\"><tr><td>\n");
0
} # XXX
sub endminipage {
# &Out::putC( "</td></tr></table>\n");
0} # XXX


$TBL_ENV = 0;   # tabular ĶǤ뤳Ȥ򼨤
sub tabular {
    &Parser::forwRead('[', ']'); # []ɤФ
    my($str) = &Parser::forwReadBrace;

    if ($str =~ /\|/) {  # border 
	&Out::putC("<TABLE BORDER=1>");
    }else{
	&Out::putC("<TABLE>");
    }

    $TBL_ENV++;
    
    &main::tabularPut($TBL_ENV);
#	if ($TBL_ENV == 1);
}

sub endtabular {
    
    &Out::putC("</TABLE>\n"); $TBL_ENV--;
}

########################################
#
# Sapid Envirnment
# SapidƤĶ
# 

### 饹
sub SapidClassDefList    {}
sub endSapidClassDefList  {}

## Ūʥ饹
sub SapidClassDef {

    &Out::putC('<TABLE BORDER=1 WIDTH="100%">');
    &Out::putC("<TR>");
    &Out::putC( '<TH WIDTH="12%">');

    &Out::makeBraceGLabel('class');
    &Out::putC("</TH>");

    &Out::putC('<TH COLSPAN=3 ALIGN="LEFT">');
    &main::innerLoopPut('{', '}');
    &Out::putC("</TH></TR>\n");
}

sub endSapidClassDef {
    &Out::putC( "</TABLE>\n" );
}

# ŪʴϢ(ClassDefƱ)
sub SapidRelationDef {

    &Out::putC('<TABLE BORDER=1 WIDTH="100%">');
    &Out::putC("<TR>");
    &Out::putC( '<TH WIDTH="12%">');

    &Out::makeBraceGLabel('class');
    &Out::putC("</TH>");

    &Out::putC('<TH COLSPAN=3 ALIGN="LEFT">');
    &main::innerLoopPut('{', '}');
    &Out::putC("</TH></TR>\n");
}
sub endSapidRelationDef {
    &Out::putC( "</TABLE>\n" );
}

## إåĥ饹
sub SapidClassDefWithHeader {
    # 3
    # [0].Label  1.Class Name  2.Description  3.include file
    &SapidClassDef;

    &Out::putC( "<TR><TD></TD><TD COLSPAN=3><TT>" );
    &Out::putC( "#include &lt;Sapid/" );
    &main::innerLoopPut('{', '}');
    &Out::putC( "&gt;" );
    &Out::putC( "</TT></TD></TR>\n" );
}
sub endSapidClassDefWithHeader {
    &endSapidClassDef;
}

### 
sub SapidTypeDefList   { # ɤơ֥äƤʤܤ餷
    &Out::putC('<TABLE BORDER=1 WIDTH="100%">');
#    &Out::print("++SapidTypeDefList++\n");
}
sub endSapidTypeDefList {
    &Out::putC("</TABLE>\n");
#    &Out::print("++SapidTypeDefList++\n");
}

## γ
#sub SapidTypeDef   { &Out::putC('<TABLE border=1 width="100%">');}
#sub endSapidTypeDef { &Out::putC( "</TABLE>" );}


## ¤η
$StructName    = ''; # Ѥɬפʸ¸
$Comment = '';

# ¤ηζ̥롼
# 
#   1. ̾(struct/union)
sub typedef_common {
    my ($type) = (@_);

    &Out::putC("<TR>" );
    &Out::putC("<TD ROWSPAN=2><I>" );

    $tmp = &Parser::forwRead('[', ']');
    $StructName = &Parser::forwReadBrace;
    &Parser::ungett("$tmp$StructName");

    &Out::makeBraceGLabel('type');

    &Out::putC("</I></TD>" );

    my $OldStructName = &Parser::forwReadBrace; # Struct Name
    $Comment    = &Parser::forwReadBrace; # Description

    &Out::putC("<TD>");
    &Out::putC("<TT>typedef  $type");
    &Parser::ungett($OldStructName);
    &main::innerLoopPut('{', '}');
    &Out::putC(" \{</TT><TABLE>\n");
    return;
}

sub SapidTypeDefStruct { # ͥԲ
    &typedef_common("struct");
}
sub SapidTypeDefLongStruct {
    &TEnv::SapidTypeDefStruct
}

sub SapidTypeDefUnion {
    &typedef_common("union");
}

sub endSapidTypeDefStruct {

    &Out::putC( "</TABLE><TT>}</TT> <I>" );
    &Parser::ungett($StructName);
    &main::innerLoopPut('{', '}');
    &Out::putC( "</I>;</TD></TR>" );
    &Out::putC( "<TR><TD>" );
    &Parser::ungett($Comment);
    &main::inanerLoopPut('{', '}');
    $Comment = '';
    &Out::putC( "</TD></TR>" );
    &Out::putC("</A>\n");
}
sub endSapidTypeDefUnion {
    &TEnv::endSapidTypeDefStruct
}
sub endSapidTypeDefLongStruct {
    &TEnv::endSapidTypeDefStruct
}

## 󷿤η
$EnumName    = ''; # Ѥɬפʸ¸

sub SapidTypeDefEnum { # ͥԲ
    &Out::putC("<TR>" );
    &Out::putC("<TD ROWSPAN=2><I>" );
    &Out::makeBraceGLabel('type');

    &Out::putC("</I></TD>" );

    &Out::putC("<TD>");
    &Out::putC("<TT>typedef enum \{</TT><TABLE>");

    $EnumName = &Parser::forwReadBrace; # Enum Name
    $Comment  = &Parser::forwReadBrace; # Description
}
sub SapidTypeDefLongEnum {
    &TEnv::SapidTypeDefEnum
}

sub endSapidTypeDefEnum {

    &Out::putC( "</TABLE><TT>};</TT><I>" );
    &Parser::ungett($EnumName);
    &main::innerLoopPut('{', '}');
    &Out::putC( "</I></TD></TR>" );
    
    &Out::putC( "<TR><TD>" );
    &Parser::ungett($Comment);
    &main::innerLoopPut('{', '}');
    $Comment = '';
    &Out::putC( "</TD></TR>" );
}
sub endSapidTypeDefLongEnum {
    &TEnv::endSapidTypeDefEnum
}

### ؿ
$FuncArgs = 0; # Υ

sub SapidFuncDef {
    my $label = &Parser::forwRead('[', ']');
    my $type  = &Parser::forwReadBrace;
    my $name  = &Parser::forwReadBrace;

    &Parser::ungett($type);
    &Out::putC("<I>");
    &main::innerLoopPut('{', '}'); # Function type
    &Out::putC("</I>       ");

    &Parser::ungett($name);
    &Parser::ungett($label);
    &Out::makeBraceGLabel('func');

    &Out::putC('(');
    $FuncArgs = 0;
    $Comment = '';
}

sub endSapidFuncDef {
    &Out::putC( ")<BR>\n" );

    if ($Comment) {
	&Out::putC( "<BLOCKQUOTE>\n" );
	&Parser::ungett("$Comment");
	&main::innerLoopPut('{', '}');
	&Out::putC( "</BLOCKQUOTE>\n" );
    }
}


# ޥ˥奢
%CommandMan = (
	       'NAME'        => '',
	       'SYNOPSIS'    => '',
	       'DESCRIPTION' => '',
	       'OPTIONS'     => '',
	       'ENVIRONMENT' => '',
	       'EXIT STATUS' => '',
	       'FILES'       => '',
	       'SEE ALSO'    => '',
	       'NOTES'       => '',
	       'BUGS'        => '');

@CommandTitle = ('NAME', 'SYNOPSIS', 'DESCRIPTION',
		'OPTIONS', 'ENVIRONMENT', 'EXIT STATUS',
		'FILES', 'SEE ALSO', 'NOTES', 'BUGS');

sub SapidCommandManual {
    %CommandMan = ();
}

sub endSapidCommandManual {
    &Out::putC( "<DL>\n" );
    if ($CommandMan{'NAME'}) {
	&Out::putC( "<DT> NAME\n <DD><p>" );
	&Parser::ungett("$CommandMan{'NAME'}");
	&Parser::ungett("$CommandMan{'NAMELBL'}");
	&Out::makeBraceGLabel('cmd');
	$CommandMan{'NAME'} = '';
	&Out::putC( "</p>\n" );
    }

    if ($CommandMan{'SYNOPSIS'}) {
	&Out::putC( "<DT> SYNOPSIS\n <DD>\n<P>" );
	chop $CommandMan{'SYNOPSIS'};
	@synopsis = split("\x0", $CommandMan{'SYNOPSIS'});
	for (@synopsis) {
	    &Out::putC( "<PRE>" );
	    &Parser::ungett("$_");    &main::innerLoopPut('{', '}');
	    &Out::putC( "</PRE>\n" );
	}
	&Out::putC( "</P>\n" );
	$CommandMan{'SYNOPSIS'} = '';
    }
    
    for (@CommandTitle) {  # ƹܤ
	$title = $_;
	if ($CommandMan{$_}){
	    &Out::putC( "<DT> $title\n <DD><P>" );
	    &Parser::ungett("$CommandMan{$_}");
	    &main::innerLoopPut('{', '}');
	    &Out::putC( "</P>\n" );
	}
    }

    &Out::putC( "</DL>\n" );
}

sub pgrind    { &Out::putC("<PRE>"); $PRE=1;}
sub endpgrind { &Out::putC("</PRE>\n"); $PRE=0;}

# 
#sub SapidSource     { &Out::putC("<pre><tt>"); $PRE = 1; }
#sub endSapidSource   { &Out::putC( "</tt></pre>\n" ); $PRE = 0; }

# ȤꤢϤʤˤ⤷ʤ
sub SapidSource     { &Out::putC("<TABLE><TR><TD>"); }
sub endSapidSource  { &Out::putC("</TD></TR></TABLE>\n");}

sub captionPut {
    if ($LblEnv[0] eq 'figure') {
	&Out::putC("<BR>", &Counter::count('figure'), " ");
    } elsif ($LblEnv[0] eq 'table') {
	&Out::putC("<BR>ɽ", &Counter::count('table'), " ");
    } else {
	&main::perror("Current Environment($LblEnv[0]) doesn't support CAPTION.");
    }
}

sub thebibliography {
   &Out::putC("<h2>ʸ</h2>\n");
   &Parser::forwReadBrace;
}

sub endthebibliography {}
1
