#! PerlCmd
# 
# Program:              $RCSfile: trans.pl,v $  $Revision: 30.7 $
# 
# Purpose:
# 
# Author:               T.Suzuki  1997/08/01
#                       S.Yamamoto  1997/08/01
# 
# Copyright:            T.Suzuki and S.Yamamoto  1997 - 2002
#                       This file is a product of the project Sapid.
# 

# 
# $Id: trans.pl,v 30.7 2002/11/26 10:32:28 yamamoto Exp yamamoto $
# 

if (defined($ENV{SAPID_MKHTML_LIBDIR})) {
    use lib $ENV{SAPID_MKHTML_LIBDIR};
}

## Parser ##############################

use Parser;

########################################

## Env. ################################

use TEnv;

########################################

## Macros ##############################

use Macro;
use Common;

########################################

## About Reference #####################

# label˱ƶͿĶ :: document(section), table, figure,
# (cf @TEnv::LblEnv)        (equation, equarry, enumurate  supportʤ)
# figure Υ󥿤 captionǲû롥

########################################

## Counter #############################

package Counter;

# 󥿤ȸߤͤΥꥹ
%cou = ('section',       0,
	'subsection',    0,
	'subsubsection', 0,
	'paragraph',     0,
	'subparagraph',  0);

%cou1 = %cou;
%cou2 = %cou;

# sectionƻҴطˤ륫󥿤Υꥹ
@rel = ('subparagraph', 'paragraph', 'subsubsection',
	'subsection', 'section');

# θФ(2.1.3ʤ)ѵХåե
$secStr1 = $secStr2 = '';

sub seccount_in {
    # 󥫥󥿤 increment/set
    # Input
    #   1: 'section','subsection'...Τ줫
    #   2: true/false 2Υ󥿤Τ
    # Output ::
    #   ʸ ($secStr)
    my ($obj, $selct) = @_;  
    my ($flag, $str) = (0, '');
    my (%cou) = ($selct eq 0) ? %cou2 : %cou1;

    foreach (@rel) {
	if ($flag) {
	    $str = "$cou{$_}.$str";
	    next;
	} elsif ($_ eq $obj) {
	    $cou{$_}++;
	    $flag = 1;
	    $str = "$cou{$_}";
	    next;
	}
	$cou{$_} = 0;
    }

    if ($selct == 0) {
	$secStr1 = $str;
	%cou2 = %cou;
    } else {
	$secStr2 = $str;
	%cou1 = %cou;
    }
    return $str;
}

sub seccount {
    return seccount_in($_[0], 0)
}

sub seccount2 {
    return seccount_in($_[0], 1)
}

sub count {
    # ꤵ줿󥿤ͤ䤷֤ͤ
    # Input
    #   1. ̾
    # Output
    #   󥿤ο
    my ($cname) = @_; 
    $cou{$cname} = 0 if ($cname eq '');
    ++$cou{$cname};

    return $cou{$cname};
}

sub getcount_in {
    # ꤵ줿󥿤θߤɽ֤ͤ
    # documentξϡsectionֹ(2.1.3ʤ)֤
    my ($cname, $flag) = @_;
    if ($cname ne 'document') {
	return $cou{$cname};
    }

    if ($flag == 0) {
	return $secStr1;
    } else {
	return $secStr2;
    }
}

sub getcount {
    return getcount_in($_[0], 0)
}

sub getcount2 {
    return getcount_in($_[0], 1)
}

## Output ##############################

use Out;

## main ################################

package main;

# Error 
sub perror {
    my $str = join('', @_);
    print STDERR "Parse error: $Parser::fname ($.): $str\n";
    &Out::errPut("Parse error: $Parser::fname ($.): $str\n");
    return;
}

# Ķΰ('{''}')Ȥ
sub lvlUp {
    push @TEnv::EnvVar, join('@', @TEnv::EnvCur); 
    undef @TEnv::EnvCur;
}
sub lvlDown {
    my $p = join '', @TEnv::EnvCur;
    &Out::putC($p);
    @TEnv::EnvCur = split('@', pop @TEnv::EnvVar);
}


# ޥν
# Input
#   ɤ߼äޥ
# Output
#   ޥη
sub macroProc {
    my ($mnm) = @_;


    return '' if ($mnm !~ /^\\/);

    if ($mnm eq '\begin' || $mnm eq '\end') {
	# Ķξ
	my $tmp = &Parser::parse();
	if ($tmp ne '{' && &Parser::ungett($tmp)) {
	    perror("'{'<macroname>} is expected, but '$tmp'");
	    return '';
	}

	my $envName = &Parser::parse();

	$tmp = &Parser::parse();
	if ($tmp ne '}' && &Parser::ungett($tmp)) {
	    perror("{<macroname>'}' is expected, but '$tmp'");
	    return '';
	}
	
	if ($mnm eq '\end'){
	    $envName = "end$envName";
	    &lvlDown();
	} else {
	    &lvlUp();
	}

	# Ƥ뤫
	if (!eval "defined(&TEnv::$envName)"){
	    if (!eval "defined(&Macro::$envName)"){
		&main::perror("Envirnment $envName is not supported.");
		return '';
	    }
            # &Out::errLog("Use \def Macro as '$envName' Environment\n");
	    eval('&Macro::'.$envName);
	    return;
	}
	eval('&TEnv::'.$envName);
	return;

    } elsif ($mnm =~ /^\\([^A-Za-z])$/) {
	# ȥ롦ܥ
	my $mark = $1;
	if ($mark =~ /([\ \$\#\%\&\[\{\}\|\_])/) { # εˤʤ
	    return $1;
	}
	if ($mark =~ /([\'\`\"\(\*\=\.\^\~])/) {   # ȯ桦Τޤɽ"
	    return $1;
	}
	return ''   if ($mark eq ',' || $mark eq '!'); #thinspace
	return ' '  if ($mark eq '>'); # medspace
	return '  ' if ($mark eq ';'); # large space
        if ($mark eq '\\') {
	    return '\\';
	}
	
        # Not supported: \+
	return $mark;

    } else {
	# ȥ롦(ޥ)
	$mnm =~ tr/\*\@/\_\_/;
	$mnm =~ /\\(.*)/;

	if (!eval "defined(&Macro::$1)"){
	    &main::perror("Macro $1 is not supported.");
	} else {
	    eval('&Macro::'.$1);
	    return;
	}
	return '';
    }
    
    return $tk; # ʳʤ餽Τޤ֤
}


# ʬɽ
# $s_paren  $parenǰϤޤ줿ʬɽ롥
# $s_paren, $paren  '' ΤȤ EOFޤɽ
# ɽΤΤŸʤäʬʸ֤
$Lplvl = 0;
sub innerLoopPut {

    my ($s_paren, $paren, $flag) = @_;
    my ($tk, $str) = ('', '');

    if ($s_paren ne ''){
	# $s_paren ФޤɤФ¿ʬɬפϤʤ
	while(!$Parser::EOF){
	    $tk = &Parser::parse();
	    next if ($tk eq " " || $tk eq "");
	    if ($tk ne $s_paren){
		&perror( "'$s_paren' is expected.");
	    }
	    last;
	}
	if ($tk eq '{'){
	    &lvlUp();
	    $Lplvl ++;
	}
    }

    while(!$Parser::EOF) {
	$tk = &Parser::parse();

	# ޥŸ
	if ($Parser::sort == 0) {
	    my $ret_tk = &main::macroProc($tk);
	    
	    if ($ret_tk eq '\\') {
		$ret_tk = "<BR>\n";
		$ret_tk = '';
		next;
	    }
	    $tk = $ret_tk;
	}

	return '' if ($Parser::EOF);
	

	# Τޤɽ
	if ($Parser::type eq 'alph' || $Parser::type eq 'Space' ||
            $Parser::type eq 'number' || $TEnv::PRE) {

	    $tk =~ s|\\|\\\\|g if ($PRE);
	    &Out::putS($tk);

	    $str .= &Out::trans($tk);
	    next;
	}

	# 롼פȴФȽ
	if ($tk eq $paren && $paren ne '' && $Parser::type =~ /Mark$/){
	    if ($tk eq '}') {
		&lvlDown();
		-- $Lplvl;
	    }
	    last;
	}

	# ¦˥롼פ
	if ($tk eq $s_paren && $s_paren ne '' && $Parser::type =~ /Mark$/) {
	    &Parser::ungett($s_paren);
	    $str .= &innerLoopPut($s_paren, $paren, $flag);
	    next;
	}
	
	# 롼ԥ󥰤
	if (($tk eq '{' || $tk eq '}') && $Parser::type =~ /Mark$/) {
	    if ($tk eq '{') {
	        &main::lvlUp();
	    } else {
	        &main::lvlDown();
	    }
	    next;
	}

	# ꥿ξ(Τ"\n")
	if ($Parser::type eq 'Ret') {
	    if ($Parser::state eq 'N' && $tk==' ') {
		&Out::putC("\n") if (!$TEnv::Pre);
	    }
	    next;
	}

	# ޥΤۤεä
	if (($Parser::type =~ /Mark$/) || ($Parser::type == 'CtrlSeq')) {
	    $str .= "$Out::outbuf";
	    &Out::putS( $tk ); # if ($TEnv::PRE);
	    next;
	} else {
	    &perror("Unexpected Token :: $tk ($Parser::type)($Parser::str)");
	}
    }

    return $str;
}

@TBL_TOP  = ();        # ơ֥Ķκǽ餫 :: <TR>Ϥ
@TBL_CTOP = ();        # κǽ餫 :: <TD> Ϥ
$TBL_COL = '';        # colspan ѿ
@TBL_MINPAGE_LV = (); # minipage 򼨤ե饰

sub tabularMacro {
    my ($tk) = @_;

    if ($tk eq '\hline') {
	return '\hline';

    } elsif ($tk eq '\multicolumn') {
	# Ĥʤ륳
	my ($col) = (&Parser::forwReadBrace =~ /\{(\d+)\}/s);
	my ($ali) = (&Parser::forwReadBrace =~ /\{(.*)\}/s); # 饤
	$TBL_COL = " colspan=$col";
	return '';

    } elsif ($tk eq '\\\\') {
	if ($TBL_MINPAGE_LV[0] == 0) {
	    &Out::putC("<TD>") if ($TBL_CTOP[0] == 1);
	    &Out::putC("</TD></TR>\n");
	    $TBL_TOP[0] = $TBL_CTOP[0] = 1;
	} else {
	    &Out::putC("<BR>");
	}
	return '';

    } elsif ($tk eq '\end' || $tk eq '\begin') {
	my $tk2 = &Parser::forwReadBrace('{', '}');
	if ($tk2 eq '{tabular}' && $tk eq '\end') {
	    &main::lvlDown();
	    &Out::putC("</TD>") if ($main::TBL_CTOP[0] == 0);
	    &Out::putC("</TR>\n") if ($main::TBL_TOP[0] == 0);
	    $TBL_CTOP[0] = $TBL_TOP[0] = 1;
	    &TEnv::endtabular();
	    $tk = '';
	    return '';

	} elsif ($tk2 eq '{minipage}'){ # tablar  minipage Υեå
	    if ($tk eq '\begin') {
		$TBL_MINPAGE_LV[0]++;
	    } else {
		$TBL_MINPAGE_LV[0]--;
	    }
	}
	
	&Parser::ungett($tk2);
	$Parser::type = 'CtrlSeq';
    }
    
    return $tk;
}

sub tabularPut {
    my ($level) = @_;
    my $tk;

    unshift @TBL_MINPAGE_LV, 0;
    unshift @TBL_TOP, 1;
    unshift @TBL_CTOP, 1;
    
    while($TEnv::TBL_ENV >= $level){
	# ϤʬϤɽ

	$tk = &Parser::parse();

	last if ($Parser::EOF);     # Unexpected Close

	if ($Parser::type eq 'CtrlSeq') {
	    $tk = &tabularMacro($tk);
	    next if ($tk eq '\hline'); # ü
	}
	last if ($TEnv::TBL_ENV < $level);

	# ơ֥륫
	if ($TBL_TOP[0] && $Parser::type ne 'Ret'
	    && $Parser::type ne 'Space' && $tk ne '') {
	    &Out::putC("<TR>");
	    $TBL_TOP[0] = 0;
	}
	if ($TBL_CTOP[0] == 1 && $Parser::type ne 'Ret'
	    && $Parser::type ne 'Space' && $tk ne '') {
	    &Out::putC("<TD$TBL_COL>");

	    $TBL_CTOP[0] = 0;
	    $TBL_COL = '';
	}

	# ơ֥ȡν
	if ($TEnv::Pre) {                  # Τޤޤɽ
            &Out::putS($tk);
	    next;
	}

	if ($Parser::type eq 'CtrlSeq'){   # ޥŸ
	    $tk = &main::macroProc($tk) if ($tk ne '');
	    &Out::putC($tk) if ($tk ne '' && $tk ne '\\');
	    next;
	} elsif ($tk eq '&') {                  # '&'ν
	    &Out::putC("<TR>") if ($TBL_TOP[0] == 1);
	    &Out::putC("<TD>") if ($TBL_CTOP[0] == 1);
	    &Out::putC("</TD>");
	    $TBL_CTOP[0] = 1;
	    $TBL_TOP[0] = 0;
	    next;
	} elsif ($tk eq '{' || $tk eq '}') { # '{','}' ҽ
	    if ($tk eq '{') {
	        &main::lvlUp();
	    } else {
	        &main::lvlDown();
	    }
	    next;
    	}
	&Out::putS($tk);
    }

    shift @TBL_MINPAGE_LV;
    shift @TBL_TOP;
    shift @TBL_CTOP;
}


%ignoreLbl = ();     # ̵뤹٥Υꥹ
sub readIgnoreLabel {
    my ($fname) = @_;

    open(FN, "$fname") || &Out::warnPut("Can't open $fname");

    while(<FN>){
	chop;
	s/\#.*//;
	s/^Spd_//;
	$ignoreLbl{$_}++ if ($_ ne '');
    }
    close(FN);
}

########################################
# ᥤ󳫻
########################################

# TEXINPUTSɤ߹ߥǥ쥯ȥ
&Parser::setInputdir($ENV{'TEXINPUTS'});

$texroot      = $ENV{'SAPID_MKHTML_TEX_ROOT'};
$localOutDir  = $ENV{'SAPID_MKHTML_LOCAL_DIR'};
$globalOutDir = $ENV{'SAPID_MKHTML_GLOBAL_DIR'};
$filePrefix   = $ENV{'SAPID_MKHTML_PREFIX'};


$cwd = $ENV{'PWD'};
$relPath = '';

if ($texroot ne ''){
    $texroot =~ s|(.*[^/])/*$|$1/|;
    $relPath = $cwd;
    $relPath =~ s/^$texroot//o;
    $relPath =~ s|^/*([^/].*[^/])/*$|$1/|;
}

$filePrefix = 'spdMkHtml-' if ($filePrefix eq '');

# ѥ᡼
# -L <destination dir of *.tmp> *.tmp, ٥եν
#    $localOutDir;  SAPID_MKHTML_LOCAL_DIR
#     File :: "$localOutDir$fnbase-#.tmp", "$localOutDir$fnbase.llbl"
# -G <destination dir of label.glbl> Х٥եdirectory
#    $globalOutDir; SAPID_MKHTML_GLOBAL_DIR
#     File :: "${globaloutDir}label.glbl"
# -R <relative path> <SAPIDOC_TOP> Хѥ
#    $relPath;      SAPID_MKHTML_HTML_TOP
# -E <Error log dir> 
#    $logDir;
# -o <destination dir of *.html> *.html ν :: Ǥϴطʤ
# -p <file name prefix> *.tmp, *.llbl, *.logƬˤĤ
# -v verbose mode
# -g <format> ޤνϥեޥå, defaultgif
# -s, -i: dummy.  Used in Next program. 

use Getopt::Std;
getopts('L:G:o:R:E:p:g:vsi');

# ץꤪӴĶ

$fname = @ARGV[0];
if ($fname eq ''){ 
    print STDERR "Usage: $0 [option] <filename>\n";
    exit(1);
}

$fname =~ s/.tex$//;      # .texĤƤоä
($fnbase) = $fname =~ m|([^/]+)$|; # directoryä
$q_fnbase = quotemeta($fnbase);

($localOutDir)  = $fname =~ m/(.*)$q_fnbase$/o;   # get directroy
$localOutDir  .= '/' if ($localOutDir);
$outPutDir = $logDir = $localOutDir;

$globalOutDir = $localOutDir if (!$globalOutDir);

$localOutDir  = "$opt_L/" if ($opt_L);
$globalOutDir = "$opt_G/" if ($opt_G);
$relPath      = "$opt_R/" if ($opt_R);
$logDir       = "$opt_E/" if ($opt_E);
$fileprefix   = "$opt_p/" if ($opt_p);
$outFigFormat = ($opt_g) ? ("$opt_g") : "gif";
do {} if ($opt_o);		# this option is meanless in this routine
$VERBOSE_MODE = "$opt_v";

$globalOutDir = "$globalOutDir/" if ($globalOutDir);
$localOutDir  = "$localOutDir/"  if ($localOutDir);
$logDir       = "$logDir/"       if ($logDir);

$globalOutDir =~ s|/*$|/| if ($globalOutDir);
$localOutDir  =~ s|/*$|/| if ($localOutDir);
$logDir       =~ s|/*$|/| if ($logDir);

# ƽ

&main::readIgnoreLabel("${globalOutDir}ignoreLabels");
&Parser::openFile($fname);
&Out::setOutFile($fnbase, $localOutDir, $globalOutDir, $logDir, $filePrefix);
&Out::openLog();

&TEX::makeIgnoreMacro();

&Out::errLog("Global label file :: $globalOutDir\n");
&Out::errLog("Local  label file :: $localOutDir\n");

&GLabel::preSet;

# Analyze

while(!$Parser::EOF){
    &innerLoopPut('', '',0);
}

# 

&GLabel::output();
&Out::closeLabel();
&Out::closeLog();
