/* 
 * Program:             $RCSfile: spdSedSub.c,v $  $Revision: 31.26 $
 * 
 * Purpose:
 * 
 * Author:              H.Ohhashi  1997/10/25
 *                      S.Yamamoto  1997/10/29
 * 
 * (C) Copyright:       H.Ohhashi and S.Yamamoto  1997 - 2001
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdSedSub.c,v 31.26 2003/06/28 15:34:11 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spdSedSub.h"

Script      script;
SpdBoolean  v_flag = OFF;    
int         tab_length = TAB_LENGTH;

/* ޥɤλˡϤ롥 */

static void print_usage(void)
{
    spdErrorExit("Usage: [-e tabLength][-f scriptFile][-o outputFile][-v] inputFile\n");
}

/* ƥ󥰤ΤӴؿ */

static int compare_offset(OneLine *a, OneLine *b)
{
    int     c, d;
    
    c = a->offset;
    d = b->offset;
    if (c == d) {
        /* ƱoffsetξAppend̿ͥ褹롥 */
        if (a->command == 'A' && b->command != 'A') return (-1);
        if (a->command != 'A' && b->command == 'A') return (1);
        /* ν¸롥 */
        if (a->original_order < b->original_order) return (-1);
        if (a->original_order > b->original_order) return (1);
    }
    if (c < d) return(-1);
    if (c > d) return(1);
    return(0);
}

/*
 * ʸ򥹥åפ롥ʸʸǤʤϲ⤷ʤ
 */

static void spdSedSkipSpace(FILE *fp)
{
    int     c;

    c = fgetc(fp);
    if (c != ' ') {
        ungetc(c, fp);
    }
}

/*
 * (offsetlength)ɤ߹ࡥ
 */

static int spdSedParseInteger(FILE *fp)
{
    int     c;
    int     i = 0;
    char    number_str[MAX_INTEGER_LEN] = "-1";         /* ͤ򼨤ʸ */

    while ((c = fgetc(fp)) != ' ') {
        if (c == EOF) {
            spdError("spdSedParseInteger(): Parse error.\n");
        }
        number_str[i++] = c;
    }
    number_str[i] = '\0';
    ungetc(c, fp);      /* αƶθƶʸ᤹ */
    return (atoi(number_str));
}

/*
 * Ĺlengthʸɤ߹ࡥ
 */

static SpdString spdSedParseStr(FILE *fp, int length)
{
    int         i = 0;
    int         c;
    static char str[MAX_STRING_LEN];

    for (i = 0; i < length; i++) {
        if ((c = fgetc(fp)) == EOF) {
            spdError("spdSedParseStr(): Parse error.\n");
        }
        str[i] = c;
    }
    str[i] = '\0';
    return (str);
}

/*
 * ץȤparse롥
 */

static void spdSedParseScript(FILE *fp)
{
    int         character;
    SpdString   str;
    char        temp[LINE];

    while ((character = fgetc(fp)) != EOF) {
        str = NULL;
        /* Ƭ1ʸĴ٤롥 */
        if (character == '#') {
            /* ιԤɤФ */
            if (fgets(temp, LINE, fp) == NULL) {
                return;
            }
        } else {
            /* ޤȤΰݤ褦ѹ */
            if (script.max == script.line_num) {
                spdIncRegionInt((void **)&script.lines, &script.max,
                                DEFAULT_ALLOC_SIZE, sizeof(OneLine));
            }

            /* ƤΥޥɤζ̽ */
            script.lines[script.line_num].original_order = script.line_num + 1;
            script.lines[script.line_num].command = character;
            spdSedSkipSpace(fp);
            script.lines[script.line_num].offset = spdSedParseInteger(fp);
            spdSedSkipSpace(fp);
            script.lines[script.line_num].length1 = spdSedParseInteger(fp);
            spdSedSkipSpace(fp);

            switch (script.lines[script.line_num].command) {
              case 'A':
                str = spdSedParseStr(fp, script.lines[script.line_num].length1);
                script.lines[script.line_num].str1 = spdStrdup(str);
                break;
              case 'D':
                /* ʸ褿餽ιԤϤǽ */
                if ((character = fgetc(fp)) == '\n') {
                    script.lines[script.line_num].str1 = NULL;
                    break;
                } else {
                    ungetc(character, fp);
                    str = spdSedParseStr(fp, script.lines[script.line_num].length1);
                    script.lines[script.line_num].str1 = spdStrdup(str);
                    break;
                }
              case 'M':
                str = spdSedParseStr(fp, script.lines[script.line_num].length1);
                script.lines[script.line_num].str1 = spdStrdup(str);
                spdSedSkipSpace(fp);
                script.lines[script.line_num].length2 =spdSedParseInteger(fp);
                spdSedSkipSpace(fp);
                str = spdSedParseStr(fp, script.lines[script.line_num].length2);
                script.lines[script.line_num].str2 = spdStrdup(str);
                break;
              case 'R':
                script.lines[script.line_num].str1 = NULL;
                script.lines[script.line_num].length2 = spdSedParseInteger(fp);
                spdSedSkipSpace(fp);
                str = spdSedParseStr(fp, script.lines[script.line_num].length2);
                script.lines[script.line_num].str2 = spdStrdup(str);
                break;
            }
            if ((character = fgetc(fp)) != '\n') {
                spdErrorExit("l.%d, '%c': Invalid format.\n",
                             script.line_num, character);
            }
            script.line_num++;
        }
    }
}

/* ץȥեoffset򥭡ˤ󤹤롥 */

static void sort_script(SpdString script_file)
{
    FILE    *fp_script_org;

    if (v_flag == ON) {
        spdMessage("Reading script file \"%s\".\n", script_file);
    }
    script.line_num = 0;
    script.max = 0;
    fp_script_org = spdFopen(script_file, SPD_FOPEN_RT_MODE);
    spdSedParseScript(fp_script_org);
    spdFclose(fp_script_org);
    SPD_QSORT(script.lines, script.line_num, sizeof(OneLine), 
                compare_offset);
}

/* Main function. */

int main(int argc, char *argv[])
{
    int         ch, i;
    SpdBoolean  f_flag = OFF;
    SpdString   script_file;
    SpdString   input_file;
    SpdString   output_file = NULL;
    
    spdInitialize(spdBasename(argv[0]));
    while ((ch = getopt(argc, argv, "e:f:o:v")) != -1) {
        switch (ch) {
          case 'e':
            tab_length = atoi(optarg);
            break;
          case 'f':
            f_flag = ON;
            script_file = optarg;
            break;
          case 'o':
            output_file = optarg;
            break;
          case 'v':
            v_flag = ON;
            break;
          default:
            print_usage();
            break;
        }
    }
    if (argc <= 1) {
        print_usage();
    }

    if (f_flag == ON) {
        input_file = argv[optind];
        sort_script(script_file);
        exec_script(input_file, output_file);
    } else {
        print_usage();
    }

    /* ΰ롥 */
    for (i = 0; i < script.line_num; i++) {
        /* NULLξ̤ѡ */
        if (script.lines[i].str1 != NULL) {
            spdFree(script.lines[i].str1);
        }
        /* 'M', 'R'ξ2ܤʸ롥 */
        if (script.lines[i].command == 'M' || script.lines[i].command == 'R') {
            spdFree(script.lines[i].str2);
        }
    }
    spdFree(script.lines);
    
    return(EXIT_SUCCESS);
}
