/* 
 * Program:             $RCSfile: spdSedSub.h,v $  $Revision: 31.9 $
 * 
 * Purpose:
 * 
 * Author:              H.Ohhashi  1997/10/25
 *                      S.Yamamoto  1997/10/29
 * 
 * (C) Copyright:       H.Ohhashi and S.Yamamoto  1997 - 2002
 *                      This file is a product of the project Sapid.
 */

#ifndef _SPD_SED_SUB_H

#define BUFFER              65535
#define LINE                4095
#define MAX_STRING_LEN      2048
#define MAX_INTEGER_LEN     24

#define TAB_LENGTH          8           /* Length of a tab. */

#define DEFAULT_ALLOC_SIZE  1024

typedef struct {
    int         original_order;
    int         command;
    int         offset;
    int         length1;
    int         length2;
    SpdString   str1;
    SpdString   str2;
} OneLine;

typedef struct {
    int         max;                    /* Number of allocated lines. */
    int         line_num;               /* Number of lines already read. */
    OneLine     *lines;
} Script;

typedef struct {
    int         offset;                 /* Current offset. */
    int         column;                 /* Current column. */
} SpdSedCursor;

/*
 * Global variables.
 */

extern Script script;
extern SpdBoolean v_flag;
int tab_length;

/*  
 * Prototype declarations. 
 */

/* spdSed.c */

/* spdSed_command.c */
void exec_script(SpdString input_file, SpdString output_file);

#endif /* not _SPD_SED_SUB_H */
