/* 
 * Program:             $RCSfile: spdSedSub_cmd.c,v $  $Revision: 31.12 $
 * 
 * Purpose:
 * 
 * Author:              H.Ohhashi  1997/10/25
 *                      S.Yamamoto  1997/10/29
 * 
 * (C) Copyright:       H.Ohhashi and S.Yamamoto  1997 - 2000
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdSedSub_cmd.c,v 31.12 2001/12/17 15:02:00 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>
#include "spdSedSub.h"

/* The expression such as "temp[j] = '\0'" is converting string to strings. */

/*--------------------------------------------------------------*/
/*  եɤ߹                                          */
/*--------------------------------------------------------------*/

static FILE *spdSedOpenReadFile(SpdString file_name)
{
    if (v_flag == ON) {
        spdMessage("spdSed: Reading input file \"%s\".\n", file_name);
    }

    return (spdFopen(file_name, SPD_FOPEN_RT_MODE));
}

/*--------------------------------------------------------------*/
/*  񤭹ߥեΥץ                                  */
/*--------------------------------------------------------------*/

static FILE *spdSedOpenWriteFile(SpdString file_name)
{
    FILE *fp;

    /* ե̾NULLξɸϤ */
    if (file_name == NULL) {
        fp  = stdout;
    } else {
        if (v_flag == ON) {
            spdMessage("spdSed: Writing output file \"%s\".\n", file_name);
        }
        fp = spdFopen(file_name, SPD_FOPEN_WT_MODE);
    }
    return fp;
}

/*--------------------------------------------------------------*/
/* ̿¹ԤoffsetޤǤΥեȤ񤭹           */
/*--------------------------------------------------------------*/

static SpdSedCursor spdSedPutsBeforeCmd(FILE *fp_in, FILE *fp_out,
                                        OneLine cmd_line, SpdSedCursor cursor)
{
    int     i, j;
    int     add_space;                          /* TABŸĹ */
    int     character;                          /* ɤ߹ʸ */
    int     length;                             /* 񤭹ʸĹ */

    length = cmd_line.offset - cursor.offset;
    for (i = 0; i < length; i++) {
        character = fgetc(fp_in);

        /* ʸtabξŸ롥 */
        if (character == '\t') {
            add_space = tab_length - (cursor.column % tab_length);
            for (j = 0; j < add_space; j++) {
                fputc(' ', fp_out);
            }
        } else {
            fputc(character, fp_out);
        }

        /* ߤcolumn¸롥 */
        if (character == '\n') {
            cursor.column = 0;
        } else if (character == '\t') {
            cursor.column += add_space;
        } else {
            cursor.column++;
        }
    }
    return (cursor);
}

/*--------------------------------------------------------------*/
/* append ̿¹Ԥ                                        */
/*--------------------------------------------------------------*/

static SpdSedCursor spdSedExecAppend(FILE *fp_out, 
                                     OneLine cmd_line, SpdSedCursor cursor)
{
    /* ɲäʸĹΥå */
    if (strlen(cmd_line.str1) == cmd_line.length1) {
        fputs(cmd_line.str1, fp_out);
    } else {
        spdError("[A]Line %d: Invalid length.\n", cmd_line.original_order);
    }
    cursor.offset = cmd_line.offset;

    return cursor;
}

/*--------------------------------------------------------------*/
/* delete ̿¹Ԥ                                        */
/*--------------------------------------------------------------*/

static SpdSedCursor spdSedExecDelete(FILE *fp_in, 
                                     OneLine cmd_line, SpdSedCursor cursor)
{
    int i;
    char str[BUFFER];

    /* ѹʸ */
    str[0] = '\0';
    for (i = 0; i < cmd_line.length1; i++) {
        str[i] = fgetc(fp_in);
    }
    str[i] = '\0';

    /* Ƚ. NULLξȽάƽ */
    if (cmd_line.str1 != NULL) {
        if (strncmp(cmd_line.str1, str, cmd_line.length1) != 0) {
            spdError("[D]Line %d: \"%s\": \"%s\": Invalid strings.\n", 
                     cmd_line.original_order, cmd_line.str1, str);
        }
    }

    /* cursoroffsetʤ */
    cursor.offset = cmd_line.offset + cmd_line.length1;

    return cursor;
}

/*--------------------------------------------------------------*/
/* modify ̿¹Ԥ                                        */
/*--------------------------------------------------------------*/

static SpdSedCursor spdSedExecModify(FILE *fp_in, FILE *fp_out,
                                     OneLine cmd_line, SpdSedCursor cursor)
{
    int i;
    char str[BUFFER];

    /* ѹʸ */
    str[0] = '\0';
    for (i = 0; i < cmd_line.length1; i++) {
        str[i] = fgetc(fp_in);
    }
    str[i] = '\0';

    /* Modify̿ξΤȽ */
    if (cmd_line.command == 'M') {
        if (strncmp(cmd_line.str1, str, cmd_line.length1) != 0) {
            spdError("[M]Line %d: \"%s\": \"%s\": Invalid strings.\n", 
                     cmd_line.original_order, cmd_line.str1, str);
        }
    }

    /* ؤ˽񤭹ʸ */
    if (strlen(cmd_line.str2) == cmd_line.length2) {
        fputs(cmd_line.str2, fp_out);
    } else {
        spdError("[M]Line %d: Invalid length.\n", cmd_line.original_order);
    }

    /* cursor offsetʤ */
    cursor.offset = cmd_line.offset + cmd_line.length1;

    return cursor;
}

/* ץ̿¹Ԥؿ */

void exec_script(SpdString input_file, SpdString output_file)
{
    int i, j;
    int add_space;
    int character;
    FILE *fp_in;
    FILE *fp_out;
    SpdSedCursor cursor;                    /* ɤ߹Ǥ֤ξ */

    fp_in = spdSedOpenReadFile(input_file);
    fp_out = spdSedOpenWriteFile(output_file);

    /* cursorν */
    cursor.offset = 0;
    cursor.column = 0;

    for (i = 0; i < script.line_num; i++) {
        switch (script.lines[i].command) {
          case ('A'):                       /* Append */
            cursor = spdSedPutsBeforeCmd(fp_in, fp_out, script.lines[i], 
                                         cursor);
            cursor = spdSedExecAppend(fp_out, script.lines[i], cursor);
            break;
          case ('D'):                       /* Delete */
            cursor = spdSedPutsBeforeCmd(fp_in, fp_out, script.lines[i],
                                         cursor);
            cursor = spdSedExecDelete(fp_in, script.lines[i], cursor);
            break;
          case ('M'):                       /* Modify */    
            cursor = spdSedPutsBeforeCmd(fp_in, fp_out, script.lines[i], 
                                         cursor);
            cursor = spdSedExecModify(fp_in, fp_out, script.lines[i], 
                                      cursor);
            break;
          case ('R'):                       /* Replace */
            cursor = spdSedPutsBeforeCmd(fp_in, fp_out, script.lines[i], 
                                         cursor);
            cursor = spdSedExecModify(fp_in, fp_out, script.lines[i], 
                                      cursor);
            break;
          default:
            spdError("Line %d: Invalid command.\n", 
                     script.lines[i].original_order);
        }
    }

    /* ĤΥեȤ񤭹ࡥ */
    for (i = 0; (character = fgetc(fp_in)) != EOF; i++) {
        /* ʸtabξƱĹΥڡѴ롥 */
        if (character == '\t') {
            add_space = tab_length - (cursor.column % tab_length);
            for (j = 0; j < add_space; j++) {
                fputc(' ', fp_out);
            }
        } else {
            fputc(character, fp_out);
        }

        /* ߤcolumnǼ롥 */
        if (character == '\n') {
            cursor.column = 0;
        } else if (character == '\t') {
            cursor.column += add_space;
        } else {
            cursor.column++;
        }
    }

    spdFclose(fp_in);
    spdFclose(fp_out);
}
