/* 
 * Program:             $RCSfile: spdTarget4.c,v $  $Revision: 30.19 $
 * 
 * Purpose:
 * 
 * Author:              N.Fukuyasu  1997/02/01
 *                      S.Yamamoto  1997/02/08
 * 
 * (C) Copyright:       N.Fukuyasu and S.Yamamoto  1997 - 2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdTarget4.c,v 30.19 2003/09/07 04:44:19 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

#define ERROR_USAGE     "Usage: %s [-d SDB-dir][-# repeat] {I-model|P-model}\n"

int main(int argc, char *argv[])
{
    int             c;
    int             repeat_times = 1;
    char            *model;
    SpdObjId        prog_id;
    SpdConstString  program_name;
    SpdString       target_program_name;

    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);
    while ((c = getopt(argc, argv, "#:d:")) != EOF) {
        switch (c) {
          case '#':                         /* Repeat times. */
            repeat_times = atoi(optarg);
            break;
          case 'd':                         /* Directory for SDB. */
            spdSetSDBdir(optarg);
            break;
          default:
            spdErrorExit("'%c': Invalid option.\n", c);
            break; 
        }
    }
    if (argc != optind + 1) {
        spdErrorExit(ERROR_USAGE, program_name);
    }

    model = argv[optind];
    if (!(SPD_STREQ(model, "I-model") || SPD_STREQ(model, "P-model"))) {
        spdErrorExit("\"%s\": Invalid model.\n", model);
    }

    while (0 < repeat_times--) {
        target_program_name = smuGetAProgramName();
        if ((prog_id = spdTarget(model, target_program_name)) == SPD_NON_ID) {
            spdErrorExit("Error in spdTarget(\"%s\", \"%s\").\n",
                         model, target_program_name);
        }
        spdMessage("spdTarget(\"%s\", \"%s\"): %d.\n",
                   model, target_program_name, prog_id);
    }

    return (EXIT_SUCCESS);
}
