/* 
 * Program:             $RCSfile: spdTarget5.c,v $  $Revision: 50.6 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  2003/09/06
 * 
 * (C) Copyright:       S.Yamamoto  2003
 *                      This file is a product of the project Sapid.
 */

#ifndef lint
static char rcsid[] =
    "$Id: spdTarget5.c,v 50.6 2003/09/07 04:44:20 yamamoto Exp yamamoto $";
#endif

#include <stdio.h>
#include <Sapid/Sapid.h>

#define ERROR_USAGE     "Usage: %s [-d SDB-dir][-# repeat]\n"

int main(int argc, char *argv[])
{
    int             c;
    int             repeat_times = 1;
    SpdConstString  program_name;
    SpdModelId      ImodelId, PmodelId;

    program_name = spdBasename(argv[0]);
    spdInitialize(program_name);
    while ((c = getopt(argc, argv, "#:d:")) != EOF) {
        switch (c) {
          case '#':                         /* Repeat times. */
            repeat_times = atoi(optarg);
            break;
          case 'd':                         /* Directory for SDB. */
            spdSetSDBdir(optarg);
            break;
          default:
            spdErrorExit("'%c': Invalid option.\n", c);
            break; 
        }
    }
    if (argc != optind) {
        spdErrorExit(ERROR_USAGE, program_name);
    }

    ImodelId = spdUseModel(&I_model);
    PmodelId = spdUseModel(&P_model);

    while (0 < repeat_times--) {
        SpdDBId     dbId;
        SpdIdSet    progs;
        SetCursor   csr;

        dbId = spdOpenSDB();
        spdReadDB(ImodelId, dbId);
        spdReadDB(PmodelId, dbId);

        progs = spdGetClassExtent(SPD_CID_PROGRAM);
        for (csr = spdSetCursorCreate(progs); spdSetCursorNext(&csr);) { 
            spdMessage("spdTarget(\"%s\"): %d.\n",
                       spdGetName(spdSetGetValueO(csr.curElem->value)),
                       spdSetGetValueO(csr.curElem->value));
        }

        spdCloseSDB(dbId);
    }

    return (EXIT_SUCCESS);
}
