---------------------------> Sather 1.1 source file <--------------------------
-- gen.sml: generate template code
-- Author: Yoshida Atsushi <yoshida@tutkie.tut.ac.jp>
-- Copyright (C) 1998, Yoshida Atsushi
-- $Id: gen.sml,v 1.2 2002/05/01 04:12:39 yoshida Exp $
--
-- COPYRIGHT NOTICE: This code is provided WITHOUT ANY WARRANTY
-- and is subject to the terms of the SATHER LIBRARY GENERAL PUBLIC
-- LICENSE contained in the file: Sather/Doc/License of the
-- Sather distribution. The license is also available from ICSI,
-- 1947 Center St., Suite 600, Berkeley CA 94704, USA.
-------------------------------------------------------------------
-- $Log: gen.sml,v $
-- Revision 1.2  2002/05/01 04:12:39  yoshida
-- new version
--
-- Revision 1.1.1.1  2001/05/14 06:10:37  yoshida
-- Made StreamedSapid repository of CVS.
--
--
-- Revision 1.44  2001/01/07 14:43:53  yoshida
-- *** empty log message ***
--
-- Revision 1.43  2001/01/06 14:42:29  yoshida
-- *** empty log message ***
--
-- Revision 1.42  2000/09/08 07:07:00  yoshida
-- *** empty log message ***
--
-- Revision 1.41  2000/08/08 02:41:15  yoshida
-- *** empty log message ***
--
-- Revision 1.40  2000/08/07 10:32:43  yoshida
-- *** empty log message ***
--
-------------------------------------------------------------------
-- ToDo:
--   㥹ȱ黻Ҥ̤бʤΤǡΰ
--
--   typedef Ϲʸ˹碌 spec typedef ̿ϤƤ뤬
--     ¤ͤȤ˷Ѥ̿Ѱդ٤⤷ʤ
--
--   ؿؤΥݥ󥿷ΰ̤б
--   
--   礭ɽ魯̤б
--   
--  (ʲϴλ)
--
--   ߴؿѿб(ͤoptionaldecl
--     ¸ߤ뤳ȤˤʤΤǡˤн褹)
--
--   ߥۥ磻ȥڡ򥹥åפȤǥȤۥ磻ȥڡȤ
--     褦ˤ롣Ȥ򥪥֥ȤȤڤФǽ
--     ɲäǤ褦θƤȡ
--
--   ߹¤Τ󷿤ؤб
--
--   ߷(qualifier)˳̤ղäƤн褹롣
--     ̤ϡγʬ򽤾뷿Ҥɽ˴ޤࡣ()

class GEN is
   shared buffer: FSTR;
   const hole: STR := "_#";
   const idh: STR := "##";  -- Head of ID

   shared quick_mode: BOOL;
   shared cpp_mode: BOOL;
   shared idt_mode: BOOL;

   main(args: ARRAY{STR}): INT is
      protect
	 file_name: STR;
	 args := SML_INIT::analyze_args(args);
	 i ::= 1;
	 loop
	    until!(i >= args.size);
	    a ::= args[i];
	    if a[0] = '-' then
	       case a when "-quick" then
		  quick_mode := true;
	       when "-cpp" then
		  cpp_mode := true;
	       when "-idt" then
		  idt_mode := true;
--	       when "-sdbd" then
--		  SDB_DEF::sdb_file_path := args[i + 1];
--		  i := i + 1;
	       else end;
	    else
	       file_name := a;
	       break!;
	    end;  -- if
	 i := i + 1;
	 end;  -- loop

	 SML_INIT::all;

	 if cpp_mode then
	    APPEARANCE::c_mode;
	 end;  -- if

	 if void(file_name) then
	    return 0;
	 end;  -- if

	 buffer := #;

	 if ~quick_mode then
	    check_idents;
	 end;  -- if

	 src_file ::= SRC_FILE::named(file_name);
	 if void(src_file) then
	    raise "can't retrieve the source file: " + file_name + "\n";
	 end;
	 gen_src(src_file);
      when $STR then
	 #ERR + "StreamedSapid: scat: Error: " + exception.str;
	 return 1;
      else
	 #ERR + "StreamedSapid: scat: Error: Unknown Internal Error\n";
	 return 1;
      end;
      #OUT + "## |Sapid| Ver." + STREAMED_SAPID_VERSION::ver
	    + ", Sapid Ver." + SAPID_INFO::map["SapidVersion"]
	    + "." + SAPID_INFO::map["SapidRevision"]
	    + ", SDB Format Ver." + SAPID_INFO::map["SapidSDBVersion"]
	    + "\n";
      #OUT + buffer;
      return 0;
   end;  -- main

   gen_src(sf: SRC_FILE) is
      if cpp_mode then
	 c_name ::= sf.name.str;
	 if c_name.tail(2) = ".i" then
	    c_name := c_name.replace_suffix(".i", ".c");
	 end;  -- if
	 make_code("file " + c_name, void);
      else 
	 make_code("file " + sf.name, void);
      end;  -- if
      temp ::= #FSTR;
      cur ::= 0;
      str ::= sf.str;
      decls ::= sf.declarations.array;
      decls.sort;
      loop
	 d ::= decls.elt!;
--	 #OUT + "DEBUG: gen_src d = \"" + d + "\"\n";
--	 #OUT + "DEBUG: gen_src d.appearance.pos = \"" + d.appearance.pos + "\"\n";
	 if ~(cpp_mode and expanded_by_inclusion(d)) then
	    make_temp(inout temp, str, inout cur, 0, d.appearance.pos);
	    gen_decl(d);
	 end;  -- if
      end;  -- loop
      make_temp(inout temp, str, cur);
      make_code("file end", temp.str);
   end;  -- gen_src

   gen_stmt(s: $STMT) is
      typecase s
      when EXPR_STMT then
	 gen_expr(s);
      when BLK_STMT then
	 gen_block(s)
      when LABEL_STMT then
	 gen_label(s);
      else
	 raise "Not supported: " + s + "\n";
      end;  -- typecase
   end;  -- gen_stmt

   gen_block(b: BLK_STMT) is
      if cpp_mode and expanded_by_macro(b) then
	 make_code("macro", b.appearance.str);
	 return;
      end;  -- if
      temp ::= #FSTR;
      cb ::= b.block;
      str ::= b.str;
      pos ::= b.appearance.pos;
      cur ::= 0;
      typecase cb when COMP_BLK then
	 make_code("block comp " + idh + cb.core.id, void);
	 adecl ::= cb.decls.array;
	 adecl.sort;
	 loop
	    d ::= adecl.elt!;
	    gen_decl(d);
	    make_temp(inout temp, str, inout cur, pos.ofs, d.appearance.pos);
	 end;  -- loop
	 stmts ::= b.stmts;
--	 stmts.sort;
--	 mmm ::= APPEARANCE::mode;
--	 APPEARANCE::i_mode;
--	 #OUT + "DEBUG: gen_block str(i) = " + b.appearance.str + "\n";
--	 #OUT + "DEBUG: gen_block b.pos(i) = " + b.appearance.pos + "\n";
--	 APPEARANCE::c_mode;
--	 #OUT + "DEBUG: gen_block str(c) = " + b.appearance.str + "\n";
--	 #OUT + "DEBUG: gen_block b.pos(c) = " + b.appearance.pos + "\n";
--	 APPEARANCE::mode := mmm;
	 loop
	    e ::= stmts.elt!;
	    gen_stmt(e);
--	    #OUT + "DEBUG: gen_block e = " + e.str + "\n";
--	    #OUT + "DEBUG: gen_block e.appearance.pos = " + e.appearance.pos + "\n";
--	    #OUT + "DEBUG: gen_block e.pos = " + e.pos + "\n";
--	    #OUT + "DEBUG: gen_block temp = " + temp + "\n";
--	    #OUT + "DEBUG: gen_block cur = " + cur + "\n";
	    typecase e when EXPR_STMT then
	       -- The appearance of e may not correct. Because the pos of 
	       -- EXPR_STMT depends on APPEARANCE::mode, this code works well.
	       make_temp(inout temp, str, inout cur, pos.ofs, e.pos);
	    else
	       make_temp(inout temp, str, inout cur, pos.ofs, e.appearance.pos);
	    end;  -- typecase
	 end;  -- loop
      when BRANCH_BLK then
	 case cb.sort when BLOCK::sort_if then
	    make_code("block if " + idh + cb.core.id, void);
	    cond ::= cb.cond.first_elt;
	    gen_expr(cond);
	    make_temp(inout temp, str, inout cur, pos.ofs, cond.appearance.pos);
	    make_code("block cond " + idh + cb.core.id, void);
	    then_part ::= cb.then_part;
	    typecase then_part when BASIC_BLK then
	       exprs ::= then_part.exprs.array;
	       exprs.sort;
	       loop
--		  e ::= then_part.exprs.elt!;
		  e ::= exprs.elt!;
		  es ::= #EXPR_STMT(e);
		  gen_stmt(es);
		  make_temp(inout temp, str, inout cur, pos.ofs,
			    es.pos); -- not es.appearance, because of EXPR_STMT
	       end;  -- loop
	    when $HI_BLK then
	       gen_block(#BLK_STMT(then_part));
	       make_temp(inout temp, str, inout cur, pos.ofs,
			 then_part.appearance.pos);
	    else end;  -- typecase
	    else_part ::= cb.else_part;
	    if ~void(else_part) then
	       make_code("block else " + idh + cb.core.id, void);
	       typecase else_part when BASIC_BLK then
		  exprs ::= else_part.exprs.array;
		  exprs.sort;
		  loop
--		     e ::= else_part.exprs.elt!;
		     e ::= exprs.elt!;
		     es ::= #EXPR_STMT(e);
		     gen_stmt(es);
		     make_temp(inout temp, str, inout cur, pos.ofs,
			       es.pos); -- not es.appearance, because of EXPR_STMT
		  end;  -- loop
	       when $HI_BLK then
		  gen_block(#BLK_STMT(else_part));
		  make_temp(inout temp, str, inout cur, pos.ofs,
			    else_part.appearance.pos);
	       else end;  -- typecase
	    end;  -- if
	 when BLOCK::sort_while then
	    make_code("block while " + idh + cb.core.id, void);
	    cond ::= cb.cond.first_elt;
	    gen_expr(cond);
	    make_temp(inout temp, str, inout cur, pos.ofs, cond.appearance.pos);
	    make_code("block cond " + idh + cb.core.id, void);
	    body ::= cb.blocks.first_elt;
	    typecase body when BASIC_BLK then
	       exprs ::= body.exprs.array;
	       exprs.sort;
	       loop
--		  e ::= body.exprs.elt!;
		  e ::= exprs.elt!;
		  es ::= #EXPR_STMT(e);
		  gen_stmt(es);
		  make_temp(inout temp, str, inout cur, pos.ofs,
			    es.pos);  -- not es.appearance, because of EXPR_STMT
	       end;  -- loop
	    when $HI_BLK then
	       gen_block(#BLK_STMT(body));
	       make_temp(inout temp, str, inout cur, pos.ofs,
			 body.appearance.pos);
	    else end;  -- typecase
	 when BLOCK::sort_do_while then
	    make_code("block do " + idh + cb.core.id, void);
	    cond ::= cb.cond.first_elt;
	    body ::= cb.blocks.first_elt;
	    typecase body when $HI_BLK then
	       gen_block(#BLK_STMT(body));
	       make_temp(inout temp, str, inout cur, pos.ofs,
			 body.appearance.pos);
	    else end;  -- typecase
	    gen_expr(cond);
	    make_code("block cond " + idh + cb.core.id, void);
	    make_temp(inout temp, str, inout cur, pos.ofs,
		      cond.appearance.pos);
	 when BLOCK::sort_switch then
	    make_code("block switch " + idh + cb.core.id, void);
	    cond ::= cb.cond.first_elt;
	    gen_expr(cond);
	    make_temp(inout temp, str, inout cur, pos.ofs, cond.appearance.pos);
	    make_code("block cond " + idh + cb.core.id, void);
	    body ::= cb.blocks.first_elt;
	    typecase body when $HI_BLK then
	       gen_block(#BLK_STMT(body));
	       make_temp(inout temp, str, inout cur, pos.ofs,
			 body.appearance.pos);
	    else end;  -- typecase
	 when BLOCK::sort_for then
	    make_code("block for " + idh + cb.core.id, void);
	    cond ::= cb.cond.array;
	    cond.sort;
	    assert cond.size = 3;
	    gen_expr(cond[0]);
	    make_code("block init " + idh + cb.core.id, void);
	    make_temp(inout temp, str, inout cur, pos.ofs,
		      cond[0].appearance.pos);
	    gen_expr(cond[1]);
	    make_code("block cond " + idh + cb.core.id, void);
	    make_temp(inout temp, str, inout cur, pos.ofs,
		      cond[1].appearance.pos);
	    gen_expr(cond[2]);
	    make_code("block succ " + idh + cb.core.id, void);
	    make_temp(inout temp, str, inout cur, pos.ofs,
		      cond[2].appearance.pos);
	    body ::= cb.blocks.first_elt;
	    typecase body when BASIC_BLK then
	       exprs ::= body.exprs.array;
	       exprs.sort;
	       loop
--		  e ::= body.exprs.elt!;
		  e ::= exprs.elt!;
		  es ::= #EXPR_STMT(e);
		  gen_stmt(es);
		  make_temp(inout temp, str, inout cur, pos.ofs,
			    es.pos); -- not es.appearance.pos, because of EXPR_STMT
	       end;  -- loop
	    when $HI_BLK then
	       gen_block(#BLK_STMT(body));
	       make_temp(inout temp, str, inout cur, pos.ofs,
			 body.appearance.pos);
	    else end;  -- typecase
	 else
	    raise "Unknown type of block: " + cb.core.id;
	 end;  -- case
      else
	 loop
	    e ::= b.stmts.elt!;
	    gen_stmt(e);
	    make_temp(inout temp, str, inout cur, pos.ofs, e.appearance.pos);
	 end;  -- loop
      end;  -- typecase
      make_temp(inout temp, str, cur);
      make_code("block end " + idh + cb.core.id, temp.str);
   end; 

   gen_decl(decl: DECLARATION) is
      if cpp_mode and expanded_by_macro(decl) then
	 make_code("macro", decl.appearance.str);
	 make_code("decl", hole);
	 return;
      end;  -- if
      is_func ::= false;
      func_id: STR;
      temp ::= #FSTR;
      str ::= decl.str;
      pos ::= decl.appearance.pos;
      cur ::= 0;
      decr ::= decl.declarators.array;
      if decr.size > 0 then
	 if decr.size = 1 then
	    d ::= decr[0];
	    typecase d when FUNC_DECL then
	       func_id := ident2ident(d.ident);
	       make_code("func " + func_id, void);
	       is_func := true;
	    else end;  -- typecase
	 end;  -- if
	 decr.sort;
--	 #OUT + "DEBUG: decr[0].pos = " + decr[0].pos
--	       + ", pos = " + pos + "\n";
--	 #OUT + "DEBUG: decr[0] = " + decr[0] + "\n";
--	 #OUT + "DEBUG: decr[0].id = " + decr[0].id + "\n";
	 make_spec_temp(inout temp, str, inout cur,
			decr[0].appearance.pos.ofs - pos.ofs, decl.a_type);
	 loop
	    e ::= decr.elt!;
	    gen_decr(e);
	    make_temp(inout temp, str, inout cur, pos.ofs, e.appearance.pos);
	 end;  -- loop
	 make_temp(inout temp, str, cur);
	 make_code("decl", temp.str);
      else
	 -- no declarator, i.e. arguments of prototype
	 make_spec_temp(inout temp, str, inout cur, pos.len, decl.a_type);
	 make_code("ident " + ident2ident(void), "");
	 make_code("decr", hole);
	 make_code("decl", temp.str + hole);
      end;  -- if
      if is_func then
	 make_code("func end " + func_id, void);
      end;  -- if
   end;  -- gen_decl

   make_spec_temp(inout temp: FSTR, str: STR, inout cur: INT, len: INT,
		  a_type: A_TYPE) is
      ident: $IDENT;
      if ~void(a_type) then
	 ident := a_type.ident;
      end;  -- if
      top ::= true;
      word ::= #FSTR;
      i ::= cur;
      loop
	 while!(i < len);
	 c ::= str[i];
	 if c.is_alphanum or c = '_' then
	    if top then
	       temp := temp + hole;
	       top := false;
	    end;  -- if
	    word := word.push(c);
	    i := i + 1;
	 else
	    top := true;
	    j ::= skip_spaces(str, i);
	    if j - i > 0 then
	       temp := temp + str.substring(i, j - i);
	       i := j;
	    else
	       temp := temp.push(c);
	       i := i + 1;
	    end;  -- if
	    if word.length > 0 then
	       if ~void(ident) and word = ident.str then
		  make_code("spec " + ident2ident(ident), ident.str);
	       else
		  make_code("spec " + word.str, word.str);
	       end;  -- if
	       word := #;
	    end;  -- if
	 end;  -- if
      end;  -- loop
      cur := cur + len;
      if word.length > 0 then
	 if ~void(ident) and word = ident.str then
	    make_code("spec " + ident2ident(ident), ident.str);
	 else
	    make_code("spec " + word.str, word.str);
	 end;  -- if
      end;  -- if
   end;  -- make_spec_temp

   gen_decr(decr: $DECLARATOR) is
      if cpp_mode and expanded_by_macro(decr) then
	 make_code("macro", decr.appearance.str);
	 return;
      end;  -- if
      typecase decr when TAG_DECL then
	 if void(decr.opt_decl) then
	    gen_decr_tag(decr);  -- decr is not a declaration really.
	    return;
	 end;  -- if
      else end;  -- typecase
      temp ::= decr.str.fstr;
      funcptr_opt: FUNCPTR_OPT;  -- pass to make_decr_temp.
      another_opt: $OPT_DECL;  -- save for later process
      opt_decls ::= decr.opt_decls;
      loop
	 -- opt_decls.size = 2 only when one of opt_decls is FUNCPTR_OPT.
	 opt_decl ::= opt_decls.elt!;
	 typecase opt_decl when FUNCPTR_OPT then
	    -- this object will be treated in make_decr_temp.
	    funcptr_opt := opt_decl;
	 else
	    another_opt := opt_decl;
	 end;  -- typecase
      end;  -- loop
      rtemp ::= "";
      if ~void(another_opt) then
	 #OUT + "#DEBUG: another_opt = " + another_opt + "\n";
	 opt_decl_str ::= another_opt.appearance.str;
	 i ::= search(temp.str, opt_decl_str);
	 head ::= #FSTR;
	 tail ::= #FSTR;
	 if i > 0 then
	    head := temp.head(i);
	 end;  -- if
	 remain ::= temp.length - (i + opt_decl_str.length);
	 if remain > 0 then
	    tail := temp.tail(remain);
	 end;  -- if
	 temp := head.copy;
	 rtemp := hole + tail;
      end;  -- if
      if ~void(funcptr_opt) then
	 #OUT + "#DEBUG: funcptr_opt = " + funcptr_opt + "\n";
	 -- remove the text of funcptr_opt from temp.
	 -- template of funcptr_opt will be made in make_decr_temp.
	 head_len ::= funcptr_opt.pos.ofs - decr.pos.ofs;
	 tail_beg ::= funcptr_opt.pos.ofs + funcptr_opt.pos.len - decr.pos.ofs;
	 temp_str ::= temp.str;
	 temp := temp_str.substring(0, head_len).fstr;
	 rtemp := temp_str.substring(tail_beg) + rtemp;
      end;  -- if
      #OUT + "#DEBUG: temp = <" + temp + ">\n";
      #OUT + "#DEBUG: rtemp = <" + rtemp + ">\n";
      a_type ::= decr.a_type;
      typecase decr when PROTOTYPE_DECL then
	 a_type := a_type.pointed_type;
      when FUNC_DECL then
	 a_type := a_type.pointed_type;
      else end;  -- typecase
      ident ::= decr.ident;
      if ~void(ident) then
	 org_temp ::= temp.copy;
	 make_temp(inout temp, ident.str);
	 if temp = org_temp then
	    -- no ident.str exists. guess the appearance of ident.
	    macro ::= "";
	    i ::= 0;
	    len ::= temp.length;
	    s ::= temp.str;
	    loop
	       i := skip_spaces(s, i);
	       if s[i] = hole[1] and
			i < len - 2 and s[i + 1] = hole[2] then
		  i := i + 2;
	       elsif s[i].is_alpha or s[i] = '_' then
		  j ::= i + 1;
		  loop
		     while!(j < len and (s[j].is_alphanum or s[j] = '_'));
		     j := j + 1;
		  end;  -- loop
		  macro := s.substring(i, j - i);
		  break!;
	       else
		  i := i + 1;
	       end;  -- if
	    end;  -- loop
	    make_temp(inout temp, macro.str);
	    make_code("macro", macro.str);
	 else
	    make_code("ident " + ident2ident(ident), ident.str);
	    make_temp(inout temp, ident.str);
	 end;  -- if
      else
	 dig_hole_for_ident(inout temp, temp.length - 1);
	 make_code("ident " + ident2ident(void), "");
      end;  -- if
      #OUT + "#DEBUG: temp (2)= <" + temp + ">\n";
      org_temp ::= temp.copy;
      loop
	 opt_decl ::= opt_decls.elt!;
	 typecase opt_decl when STRUCT_OPT then
	    -- ignore
	 when INIT_OPT then
	    -- ignore
	 when FUNCPTR_OPT then
	    -- ignore
	 else
	    -- only the optional decls related to construction of a_type
	    temp := temp + opt_decl.appearance.str;
	 end;  -- typecase
      end;  -- if
      #OUT + "#DEBUG: temp (3)= <" + temp + ">\n";
      last_pos ::= -1;
      make_decr_temp(inout temp, a_type, funcptr_opt, inout last_pos);
      #OUT + "#DEBUG: last_pos = " + last_pos + "\n";
      #OUT + "#DEBUG: org_temp = " + org_temp.length + "\n";
      #OUT + "#DEBUG: temp (4)= <" + temp + ">\n";
      
      htemp ::= #FSTR;
      if last_pos >= 0 and last_pos < org_temp.length - 1 then
	 htemp := org_temp.substring(last_pos + 1, 
				     org_temp.length - last_pos - 1);
      end;   -- if
      #OUT + "#DEBUG: htemp = <" + htemp + ">\n";
      loop
	 opt_decl ::= opt_decls.elt!;
	 typecase opt_decl when FUNCPTR_OPT then
	    -- ignore: see above.
	 else
	    gen_optd(opt_decl);
	 end;  -- typecase
      end;  -- if
      make_code("decr", hole + htemp + rtemp);
      #OUT + "#DEBUG: rtemp = <" + rtemp + ">\n";
   end;  -- gen_decr

   gen_decr_tag(decr: TAG_DECL) is
      if cpp_mode and expanded_by_macro(decr) then
	 make_code("macro", decr.appearance.str);
	 return;
      end;  -- if
      temp ::= decr.str.fstr;
      ident ::= decr.ident;
      if ~void(ident) then
	 make_temp(inout temp, ident.str);
	 make_code("spec " + ident2ident(ident), ident.str);
      else
	 dig_hole_for_ident(inout temp);
	 make_code("spec " + ident2ident(void), "");
      end;  -- if
   end;  -- gen_decr_tag

   dig_hole_for_ident(inout temp: FSTR) is
      dig_hole_for_ident(inout temp, temp.length - 1);
   end;  -- dig_hole_for_ident

   dig_hole_for_ident(inout temp: FSTR, i: INT) is
      -- temp must be a declarator without identifier.
      loop
	 i := skip_spaces_bw(temp.str, i);
	 until!(i < 0 or temp[i] = '*' or temp[i] = '(' or temp[i].is_alpha);
	 if temp[i] = ']' then
	    loop
	       i := i - 1;
	       i := skip_spaces_bw(temp.str, i);
	       until!(temp[i] = '[');
	    end;  -- loop
	 end;  -- if
	 i := i - 1;
      end;  -- loop
      i := skip_spaces(temp.str, i + 1);
      h ::= #FSTR;
      t ::= #FSTR;
      if i > 0 then
	 h := temp.head(i);
      end;  -- if
      if i < temp.length then
	 t := temp.tail(temp.length - i);
      end;  -- if
      temp := h + hole + t;
   end;  -- dig_hole_for_ident

   make_decr_temp(inout temp: FSTR, t: A_TYPE, fo: FUNCPTR_OPT, 
		  inout last_pos: INT) is
      if void(t) then return end;  -- in cases of struct, enum, ...
      make_decr_specifier_temp(inout temp, t, inout last_pos);
      qtemp: FSTR;

      case t.sort
      when A_TYPE::sort_array then
	 temp_str ::= temp.str;
	 h ::= search(temp_str, hole);
	 j ::= search(temp_str, '[', h);
	 i ::= search(temp_str, ']', j);
	 num ::= exists_between(temp_str, ')',  h, j);
	 loop
	    num.times!;
	    h := search_backwards(temp_str, '(', h - 1);
	 end;  -- loop
	 qtemp := temp.substring(h, i - h + 1);
	 temp_head ::= #FSTR;
	 temp_tail ::= #FSTR;
	 if h > 0 then
	    temp_head := temp.head(h);
	 end;  -- if
	 if temp.length - i > 1 then
	    temp_tail := temp.tail(temp.length - i - 1);
	 end;  -- if
	 temp := temp_head + hole + temp_tail;
         c ::= t.const_exp;  -- constant
	 if ~void(c) then
	    if c.appearance.str = "" then
	       -- ignore, because there is no way to know exact position of c.
	    else
	       gen_expr(c);
	       make_temp(inout qtemp, c.str);
	    end;  -- if
	 end;  -- if
	 last_pos_guess ::= i;
	 if last_pos_guess > last_pos then
	    last_pos := last_pos_guess;
	 end;  -- if
	 make_code("qual []", qtemp.str);
      when A_TYPE::sort_function then
	 -- Here, generate code for type arguements. 
	 if ~void(fo) then  -- FUNCTION_OPT exits.
	    str ::= fo.str;
	    args ::= fo.args.array;
	    args.sort;
	    cur ::= 0;
	    if args.size > 0 then
	       loop
		  a ::= args.elt!;
		  make_temp(inout temp, str, inout cur, 
			    fo.appearance.pos.ofs,
			    a.appearance.pos);
		  gen_decl(a);
	       end;  -- loop
	       make_temp(inout temp, str, cur);
	    else
	       temp := temp + fo.str;
	    end;  -- if
	    fo := void;
	 end;  -- if
	 qtemp := temp;
	 last_pos := INT::maxint; -- lock this func;
	 make_code("qual ()", qtemp.str);
      else
	 qstr: STR;
	 if t.sort = A_TYPE::sort_pointer then
	    qstr := "*";
	 end;  -- if
	 if ~void(qstr) then
	    r_qstr ::= qstr.reverse;
	    r_temp ::= temp.str.reverse;
	    r_h ::= search(r_temp, hole.reverse); -- reverse index of hole
	    if r_h < 0 then
	       -- no hole, which means no identifier, such like parameters 
	       -- without identifier in prototype declarators
	       r_h := 0;	-- leftmost position
	    end; -- if
	    r_i ::= search(r_temp, r_qstr, r_h);
	    -- reverse index of the rightmost qstr
	    num ::= exists_between(r_temp, '(',  r_h, r_i);
	    loop
	       num.times!;
	       r_h := search_backwards(r_temp, ')', r_h - 1);
	    end; -- loop
	    r_i := r_i + r_qstr.length;
	    qtemp := r_temp.substring(r_h, r_i - r_h).fstr;
	    qtemp.to_reverse;
	    temp_head ::= #FSTR;
	    temp_tail ::= #FSTR;
	    if r_h > 0 then
	       temp_head := r_temp.head(r_h).fstr;
	       temp_head.to_reverse;
	    end; -- if
	    if r_temp.length - r_i > 0 then
	       temp_tail := r_temp.tail(r_temp.length - r_i).fstr;
	       temp_tail.to_reverse;
	    end; -- if
	    last_pos_guess ::= temp.length - r_h - 1;
	    if (last_pos_guess > last_pos) then
	       last_pos := last_pos_guess;
	    end;  -- if
	    temp := temp_tail + hole + temp_head;
	    make_code("qual " + qstr, qtemp.str);
	 else
	    last_pos_guess ::= temp.str.search(hole);
	    if last_pos_guess >= 0 then
	       last_pos_guess := last_pos_guess + hole.length - 1;
	    end;  -- if
	    if (last_pos_guess > last_pos) then
	       last_pos := last_pos_guess;
	    end;  -- if
	 end; -- if
      end; -- case
      if ~void(qtemp) then
	 make_decr_temp(inout temp, t.pointed_type, fo, inout last_pos);
      end; -- if
   end; -- make_decr_temp

   make_decr_specifier_temp(inout temp: FSTR, t: A_TYPE, inout last_pos: INT) is
      -- const and volatile
      --      #ERR + "DEBUG: make_decr_specifier_temp(" + temp + ", " + t + ")\n";

      qstr: STR;
      case t.qualifier
      when A_TYPE::qualifier_const then
	 qstr := "const";
      when A_TYPE::qualifier_volatile then
	 qstr := "volatile";
      else 
	 return;
      end;
      r_qstr ::= qstr.reverse;
      r_temp ::= temp.str.reverse;
      r_h ::= search(r_temp, hole.reverse); -- reverse index of hole
      if r_h < 0 then
	 -- no hole, which means no identifier, such like parameters 
	 -- without identifier of prototype declarators
	 r_h := 0;		-- leftmost position
      end; -- if
      r_i ::= search(r_temp, r_qstr, r_h);
      -- reverse index of the rightmost qstr
      if r_i < 0 then
	 -- no qstr exits, because cost or volatile belongs to declaration
	 return;
      end; -- if
      num ::= exists_between(r_temp, '(',  r_h, r_i);
      loop
	 num.times!;
	 r_h := search_backwards(r_temp, ')', r_h - 1);
      end; -- loop
      r_i := r_i + r_qstr.length;
      qtemp ::= r_temp.substring(r_h, r_i - r_h).fstr;
      qtemp.to_reverse;
      temp_head ::= #FSTR;
      temp_tail ::= #FSTR;
      if r_h > 0 then
	 temp_head := r_temp.head(r_h).fstr;
	 temp_head.to_reverse;
      end; -- if
      if r_temp.length - r_i > 0 then
	 temp_tail := r_temp.tail(r_temp.length - r_i).fstr;
	 temp_tail.to_reverse;
      end; -- if
      last_pos_guess ::= temp.length - r_h - 1;
      if (last_pos_guess > last_pos) then
	 last_pos := last_pos_guess;
      end;  -- if
      temp := temp_tail + hole + temp_head;
      make_code("qual " + qstr, qtemp.str);
   end; -- make_decr_specifier_temp

   private exists_between(str: STR, c: CHAR,  beg: INT, en: INT): INT
      pre 0 <= beg  and en < str.length and beg <= en is
      res ::= 0;
      i ::= beg;
      loop
	 while!(i <= en);
	 x ::= str[i];
	 --	 x ::= str.elt!(beg, en - beg + 1);
	 if x = '/' and i < en and  str[i + 1] = '*' then
	    i := i + 2;
	    loop
	       until!(str[i] = '*' and i < en and str[i + 1] = '/');
	       i := i + 1;
	    end; -- oop
	    i := i + 2;
	 end; -- if
	 if x = c then
	    res := res + 1;
	 end; -- if
	 i := i + 1;
      end; -- loop
      return res;
   end; -- exists_between

   gen_optd(optd: $OPT_DECL) is
      if cpp_mode and expanded_by_macro(optd) then
	 make_code("macro", optd.appearance.str);
	 return;
      end; -- if
      typecase optd
      when INIT_OPT then
	 str ::= optd.str;
	 cur ::= 0;
	 expr ::= optd.expr;
	 gen_expr(expr);
	 temp ::= #FSTR;
	 make_temp(inout temp, str, inout cur, optd.appearance.pos.ofs,
		   expr.appearance.pos);
	 make_code("init", temp.str);
      when FUNC_OPT then
	 str ::= optd.str;
	 args ::= optd.args.array;
	 args.sort;
	 cur ::= 0;
	 temp ::= #FSTR;
	 loop
	    a ::= args.elt!;
	    make_temp(inout temp, str, inout cur, optd.appearance.pos.ofs,
		      a.appearance.pos);
	    gen_decl(a);
	 end; -- loop
	 body ::= optd.body;
	 make_temp(inout temp, str, inout cur, optd.appearance.pos.ofs,
		   body.appearance.pos);
	 gen_block(#BLK_STMT(body));
	 make_code("fbody", temp.str);
      when ARGTYPE_OPT then
	 str ::= optd.str;
	 args ::= optd.args.array;
	 args.sort;
	 cur ::= 0;
	 temp ::= #FSTR;
	 if args.size > 0 then
	    loop
	       a ::= args.elt!;
	       make_temp(inout temp, str, inout cur, optd.appearance.pos.ofs,
			 a.appearance.pos);
	       gen_decl(a);
	    end; -- loop
	    make_temp(inout temp, str, cur);
	    make_code("proto " + args.size, temp.str);
	 else
	    make_code("proto 0", str);
	 end; -- if
      when STRUCT_OPT then
	 str ::= optd.str;
	 members ::= optd.members.array;
	 members.sort;
	 cur ::= 0;
	 temp ::= #FSTR;
	 make_code("member " + idh + optd.core.id, void);
	 loop
	    m ::= members.elt!;
	    make_temp(inout temp, str, inout cur, optd.appearance.pos.ofs,
		      m.appearance.pos);
	    gen_decl(m);
	 end; -- loop
	 make_temp(inout temp, str, cur);
	 make_code("member end " + idh + optd.core.id, temp.str);
      when FUNCPTR_OPT then
	 #ERR + "WARNING: unsupported optional declaration: " + optd + "\n";
	 --	 make_code("opt", optd.str);
      else
	 #ERR + "WARNING: unsupported optional declaration: " + optd + "\n";
	 make_code("opt", "..OPT..");
      end; -- typecase
   end; -- gen_optd

   gen_expr(stmt: EXPR_STMT) is
      if cpp_mode and expanded_by_macro(stmt) then
	 make_code("macro", stmt.str); -- NOTE: not appearance in this case.
	 make_code("stmt", hole);
	 return;
      end; -- if
      expr ::= stmt.expr;
      gen_expr(expr);
      str ::= stmt.str;
      make_code("stmt", hole + str.tail(str.length - expr.appearance.pos.len))
   end; -- gen_expr

   gen_expr(expr: $EXPR) is
      -- #OUT + "DEBUG: gen_expr expr = " + expr + "[" + expr.id + "]\n";
      -- if cpp_mode and expanded_by_macro(expr) then
      --     make_code("macro", expr.appearance.str);
      --    return;
      -- end;  -- if
      str ::= expr.str;
      -- #OUT + "DEBUG: gen_expr str = " + str + "\n";
      temp ::= #FSTR;
      pos ::= expr.appearance.pos;
      cur ::= 0;
      if ~(cpp_mode and expanded_by_macro(expr)) then
	 loop
	    e ::= expr.ordered_exprs.elt!;
	    gen_expr(e);
	    --	 #OUT + "DEBUG: gen_expr temp = " + temp + "\n";
	    --	 #OUT + "DEBUG: gen_expr e = " + e + "[" + e.id + "]\n";
	    make_temp(inout temp, str, inout cur, pos.ofs, e.appearance.pos);
	 end; -- loop
      else
	 --	 #OUT + "TEST: gen_expr expr = " + expr + "[" + expr.id + "]" 
	 --	       + expr.pos + "\n";
	 iexprs ::= ident_expr(expr);
	 loop
--	    ei ::= {i: IDENT_EXPR inside expr}.ordered_elt!;
	    ei ::= iexprs.ordered_elt!;
	    --	    #OUT + "TEST: ei = " + ei.ident + "(" + ei.id + ")" 
	    --		  + ei.appearance.pos + "\n";
	    --	    #OUT + "TEST: ei.appearance = " + ei.appearance.str 
	    --		  + ", pos.ofs = " + pos.ofs + ", cur = " + cur + "\n";
	    --	    #OUT + "TEST: pos.ofs + cur < ei.appearance.pos.ofs = "
	    --		  + (pos.ofs + cur < ei.appearance.pos.ofs) + "\n";
	    --	    #OUT + "TEST: ei.ident = ei.appearance.str = "
	    --		  + (ei.ident = ei.appearance.str) + "\n";
	    if pos.ofs + cur < ei.appearance.pos.ofs 
		     and ei.ident.str = ei.appearance.str then
	       --	       #OUT + "TEST:     .....(gen)\n";
	       --	       gen_expr(ei);
	       op ::= "";
	       if ei.is_LEFT_type then
		  op := "push &" + ident2ident(ei.ident);
	       else
		  op := "push " + ident2ident(ei.ident);
	       end;
	       make_code(op, ei.appearance.str);
	       make_temp(inout temp, str, inout cur, pos.ofs, ei.appearance.pos);
	    end; -- if
	 end; -- loop
      end; -- if
      make_temp(inout temp, str, cur);

      op: STR;
      typecase expr
      when EXPR then
	 if ~void(expr.op) then
	    op := "op " + expr.op.str;
	    -- How should cast operaters be expressed?
	 else
	    case expr.sort when EXPR::sort_funccall then
	       op := "call " + (expr.exprs.size - 1);
	    when EXPR::sort_break then
	       op := "jump break";
	    when EXPR::sort_continue then
	       op := "jump continue";
	    when EXPR::sort_return then
	       op := "return " + expr.exprs.size;
	    when EXPR::sort_goto then
	       op := "jump " + idh + expr.label.core.id;
	    when EXPR::sort_empty then
	       op := "nop ";
	    when EXPR::sort_initlist then
	       op := "list ";
	    when EXPR::sort_arithmetic then
	       -- concatnation of adjacent strings
	       op := "op c";
	    else 
	       raise "gen_expr(): Illegal Expression: \""
		     + expr
		     + "\" (sort = " + expr.sort
		     + " id = " + expr.core.id
		     + ", offset = " + expr.appearance.pos.ofs + ")\n";
	    end; -- case
	 end; -- if
      when IDENT_EXPR then
	 if expr.is_LEFT_type then
	    op := "push &" + ident2ident(expr.ident);
	 else
	    op := "push " + ident2ident(expr.ident);
	 end;
      when CONST_EXPR then
	 -- CONST_EXPR
	 mode ::= APPEARANCE::mode;
	 APPEARANCE::i_mode;
	 string ::= expr.str;
	 APPEARANCE::mode(mode);
	 if expr.cons.a_type = CONST::type_string and string.length > 1 then
	    if string[0] = '"' and string[string.length - 1] = '"' then
	       string := "<" + string.substring(1, string.length - 2) + ">";
	    end; -- if
	 end;  
	 op := "push " + string;
      else
	 raise "gen_expr(): Unknown EXPR subclass\n";
      end; -- typecase
      if cpp_mode and expanded_by_macro(expr) then
	 make_code("macro", temp.str);
	 make_code(op, hole);
	 return;
      end; -- if
      make_code(op, temp.str)
   end; -- gen_expr

   ident_expr(expr: $EXPR): AGG_IDENT_EXPR is
      res ::= #AGG_IDENT_EXPR;
      typecase expr when IDENT_EXPR then
	 res := res.insert(expr);
      else 
	 loop
	    e ::= expr.exprs.elt!;
	    res := res + ident_expr(e);
	 end;  -- loop
      end;
      return res;
   end;  -- ident_expr

   gen_label(l: LABEL_STMT) is
      if cpp_mode and expanded_by_macro(l) then
	 make_code("macro", l.appearance.str);
	 return;
      end; -- if
      temp ::= #FSTR;
      make_temp(inout temp, l.str, 0);
      make_code("label " + idh + l.core.id, temp.str)
   end; -- gen_label

   make_temp(inout temp: FSTR, str: STR, inout cur: INT, ofs: INT, p: POS) is
      num ::= (p.ofs - ofs) - cur;
      if ~(num>=0 and cur.is_bet(0,str.size-num)) then
	 raise "make_temp(): Illegal position: cur = " + cur
	       + ", ofs = " + ofs + ", p = " + p
	       + ", str = " + str.pretty + "\n";
      end; -- if
      temp := temp + str.substring(cur, num);
      temp := temp + hole;
      cur := p.ofs - ofs + p.len;
   end; -- make_temp

   make_temp(inout temp: FSTR, str: STR, cur: INT) is
      if str.length - cur > 0 then
	 temp := temp + str.tail(str.length - cur);
      end; -- if
   end; -- if

   make_temp(inout temp: FSTR, keyword: STR) is
      str ::= temp.str;
      ind ::= search_words(str, keyword);

      if ind < 0 then return; end;

      head: FSTR := #;
      if ind > 0 then
	 head := temp.head(ind);
      end; -- if
      tail ::= #FSTR;
      remain ::= temp.length - (ind + keyword.length);
      if remain > 0 then
	 tail := temp.tail(remain);
      end; -- if
      temp :=  head + hole + tail;
   end; -- make_temp

   make_code(op: STR, temp: STR) is
      if ~void(temp) then
	 buffer := buffer + op + " :" + temp.pretty + "\n";
      else
	 buffer := buffer + op + "\n";
      end; -- if
   end; -- make_code

   ident2ident(ident: $IDENT): STR is
      res ::= idh;
      if void(ident) then
	 return res;
      end; -- if
      if quick_mode then
	 res := res + ident.core.id;
      else
	 res :=  res + ident_map[ident];
      end; -- if
      if idt_mode then
	 res := res + ident_type(ident);
      end; -- f
      return res;
   end; -- ident

   ident_type(ident: $IDENT): STR is
      t ::= "";
      case ident.sort
      when IDENT::sort_variable then
	 id ::= ident;
	 typecase id when VAR_IDENT then
	    if id.is_global then
	       t := "V";
	    else
	       t := "v";
	    end; -- if
	 else
	    raise "ident_type: Illegal variable identifier.";
	 end; -- typecase
      when IDENT::sort_enum then
	 t := "E";
      when IDENT::sort_member then
	 t := "M";
      when IDENT::sort_function then
	 id ::= ident;
	 typecase id when FUNC_IDENT then
	    func ::= #FUNCTION(id);
	    if func.is_user_defined then
	       t := "F";
	    else
	       t := "f";
	    end; -- if
	 else
	    raise "ident_type: Illegal function identifier.";
	 end; -- typecase
      when IDENT::sort_tag then
	 t := "A";
      when IDENT::sort_typename then
	 t := "T";
      else end; -- case
      if ident.is_declared_in_system_file then
	 t := t + "S";
      else
	 t := t + "U";
      end; -- if
      return t;
   end; -- ident_type

   shared ident_map: MAP{$IDENT, STR};

   check_idents is
      ident_map := #;

      names ::= #MAP{STR, INT};
      idents ::= {i: IDENT};
      loop
	 i ::= idents.elt!;
	 s ::= i.str;
	 if ~names.has_ind(s) then
	    names[s] := 0;
	 end; -- if
	 names[s] := names[s] + 1;
      end; -- loop

      loop
	 i ::= idents.elt!;
	 s ::= i.str;
	 names[s] := names[s] - 1;
	 ident_map[i] := "" + names[s] + i.str;
      end; -- loop
   end; -- check_idents

   search(o, s: STR):INT is
      -- this routine is based on STR::search
      if void(s) then return 0 end;
      if void(o) then return -1 end;
      r ::= 0;
      max ::= o.size-s.size;
      loop
	 while!(r <= max);
	 if o[r] = '/' and o[r + 1] = '*' then
	    r := r + 2;
	    loop
	       until!(o[r] = '*' and o[r + 1] = '/');
	       r := r + 1;
	    end; -- oop
	    r := r + 2;
	 end; -- if
	 match ::= true;
         loop
	    if o.elt!(r)/=s.elt! then 
	       match:=false; break!
	    end; -- if
	 end; -- loop
         if match then return r; end;
	 r := r + 1;
      end; -- loop
      return -1 
   end; -- search

   search_words(o, word: STR):INT is
      -- search word, not substring of in word.
      -- this routine is based on STR::search
      if void(word) then return 0 end;
      if void(o) then return -1 end;
      --      #OUT + "o = " + o + "\nword = " + word + "\n";
      r ::= 0;
      o_size ::= o.size;
      max ::= o_size-word.size;
      word_0_alphanum ::= word[0].is_alphanum or word[0] = '_';
      word_l_alphanum ::= word[word.size - 1].is_alphanum
	    or word[word.size - 1] = '_';
      loop
	 while!(r <= max);
	 if o[r] = '/' and o[r + 1] = '*' then
	    r := r + 2;
	    loop
	       until!(o[r] = '*' and o[r + 1] = '/');
	       r := r + 1;
	    end; -- oop
	    r := r + 2;
	 end; -- if
	 match ::= true;
	 rr ::= r;
         loop
	    if o.elt!(r) /= word.elt! then 
	       match:=false; 
	       break!
	    end; -- if
	    rr := rr + 1;
	 end; -- loop
         if match then
	    if (r = 0 or  (word_0_alphanum and ~o[r - 1].is_alphanum)) and
		     (rr >= o_size - 1 or (word_l_alphanum and ~o[rr].is_alpha)) then
	       -- yes, matches to a word.
	       --	       #OUT + "r = " + r + ", rr = " + rr + "\n";
	       return r;
	    end;
	 end; -- if
	 r := r + 1;
      end; -- loop
      return -1 
   end; -- search_word

   search(o, s: STR, st: INT):INT is
      -- this routine is based on STR::search
      if void(s) then return 0 end;
      if void(o) then return -1 end;
      r ::= st;
      max ::= o.size-s.size;
      loop
	 while!(r <= max);
	 if o[r] = '/' and o[r + 1] = '*' then
	    r := r + 2;
	    loop
	       until!(o[r] = '*' and o[r + 1] = '/');
	       r := r + 1;
	    end; -- oop
	    r := r + 2;
	 end; -- if
	 match ::= true;
         loop
	    if o.elt!(r)/=s.elt! then 
	       match:=false; break!
	    end; -- if
	 end; -- loop
         if match then return r; end;
	 r := r + 1;
      end; -- loop
      return -1 
   end; -- search

   search(o: STR, c:CHAR, st:INT):INT is
      -- this routine is based on STR::search.
      r ::= st;
      len ::= o.length;
      loop
	 while!(r < len);
	 if o[r] = '/' and r < len - 1 and  o[r + 1] = '*' then
	    r := r + 2;
	    loop
	       until!(o[r] = '*' and r < len - 1 and o[r + 1] = '/');
	       r := r + 1;
	    end; -- oop
	    r := r + 2;
	 end; -- if
	 if o[r]=c then return r end;
	 r := r + 1;
      end; -- loop
      return -1;
   end; -- search
    
   search_backwards(o: STR, c:CHAR, st:INT):INT is
      -- this routine is based on STR::search.
      if void(c) then return -1; end;
      r ::= st;
      loop
	 while!(r >= 0);
	 if o[r] = '/' and r > 0 and  o[r - 1] = '*' then
	    r := r - 2;
	    loop
	       until!(o[r] = '*' and r < o.length - 1 and o[r - 1] = '/');
	       r := r - 1;
	    end; -- oop
	    r := r - 2;
	 end; -- if
	 if o[r]=c then return r end;
	 r := r - 1;
      end; -- loop
      return -1 
   end; -- search_backwards

   private skip_spaces(line: STR, i: INT): INT is
      j ::= i;
      len ::= line.length;
      loop
	 while!(j < len);
	 c ::= line[j];
	 if c = '/' and j < len - 1 and line[j + 1] = '*' then
	    -- begining of comment
	    j := j + 2;
	    loop
	       while!(j < len - 1);
	       until!(line[j] = '*' and line[j + 1] = '/');
	       j := j + 1;
	    end; -- loop
	    j := j + 2;
	 elsif ~c.is_space then
	    break!;
	 else
	    j := j + 1;
	 end; -- if
      end; -- loop
      return j;
   end; -- skip_spaces

   private skip_spaces_bw(line: STR, i: INT): INT is
      j ::= i;
      loop
	 while!(j >= 0);
	 c ::= line[j];
	 if c = '/' and j > 0 and line[j - 1] = '*' then
	    -- begining of comment
	    j := j - 2;
	    loop
	       while!(j > 0);
	       until!(line[j] = '*' and line[j - 1] = '/');
	       j := j - 1;
	    end; -- loop
	    j := j - 2;
	 elsif ~c.is_space then
	    break!;
	 else
	    j := j - 1;
	 end; -- if
      end; -- loop
      return j;
   end; -- skip_spaces_bw

   private expanded_by_inclusion(sc: $HAS_APPEARANCE): BOOL is
      p ::= sc.appearance.pos;
      if ~void(p) then
	 f ::= #SRC_FILE(p.file);
	 --	 #OUT +"DEBUG: pos = " + p + "\n";
	 --	 #OUT +"DEBUG: file = " + f.name + "\n";
	 --	 #OUT +"DEBUG: appearance \n" + sc.appearance.str + "\n";
	 if SRC_FILE::is_system_file(f.name.str) then
	    return true;
	 end; -- if
	 if f.name.str.tail(2) = ".h" then
	    return true;
	 end; -- if
      end; -- if
      return false;
   end; -- expanded_by_cpp

   private expanded_by_macro(sc: $HAS_APPEARANCE): BOOL is
      return sc.in_a_macro;
   end; -- expanded_by_macro
end; -- class GEN
-------------------------------------------------------------------
