#!/usr/bin/perl

%nametable = ();
%func_file = ();
%func_args = ();
%func_decls = ();
%func_refs = ();
@funcs = ();
@gdecls = ();
$file = "";

$item = "";

sub fetch {
    $item = <STDIN>;
#    print "fetch: \$item = $item\n";
}

@decls = ();
sub parse_decr {
    local($id, $name);
    local($qual) = "";

#    print "parse_decr()\n";

    while ($_ = $item) {
	$_ = $item;
	if (/^qual (\S+) :/) {
	    $qual .= $1;
	}
	elsif (/^ident (\S+) :"(\S*)"/) {
#	    print "IDENT: $1, $2 \n";
	    $id = $1;
	    if ($id =~ /^\D$/) {
		$id = "##_" . $no_id++; # no identifier exits.
	    }
	    $name = $2;
	}
	elsif (/^decr :/) {
	    &fetch();
#	    print "return parse_decr() = $id, $name, $qual\n";
	    return ($id, $name, $qual);
	}
	elsif (/^proto (\d+) :/) {
	    $num = $1;
	    $qual .= "(";
	    while ($num--) {
		local($d) = shift(@decls);
		local($i, $t) = split(/:\s+/, $nametable{$d});
		$qual .= "$t, ";
#		$qual .= pop(@decls) . ", ";
	    }
	    if ($1 > 0) {
		chop($qual);
		chop($qual);
		chop($qual);
	    }
	    $qual .= ")";
	}
	elsif (/^spec (\S+) :/) {
	    # may be arguments of prototype declaration
	    push(@decls, &parse_decl());
	    next;
	}
	&fetch();
    }
}

sub parse_decl {
    local ($spec) = " ";
    local (@decrs) = ();

#    print "parse_decl()\n";

    while ($_ = $item) {
	if (/^spec (\S+) :/) {
	    $spec .= "$1 ";
	}
	elsif (/^(ident|qual) /) {
	    local($id, $name, $qual) = &parse_decr();
	    local($type) = "${spec}${qual}";
	    if ($type =~ /^.*\(.*\)$/) {
		$nametable{$id} = "$name(): $type";
	    } else {
		$nametable{$id} = "$name: $type";
	    }
#	    print "nametable{$id} = $nametable{$id}\n";
	    push(@decrs, $id);
	    next;
	}
	elsif (/^decl :/) {
	    &fetch();
#	    print "return parse_decl() = @decrs\n";
	    return @decrs;
	}
	&fetch();
    }
}

sub parse_body {
    @decls = ();		# return value;
    @refs = ();			# return value;
    local(%refs) = ();

#    print "parse_body()\n";

    while ($_ = $item) {
	if (/^spec /) {
	    push(@decls, &parse_decl());
	    next;
	}
	elsif (/^push &?(##\w+) :"(\S+)"/) {
	    $refs{$1} = 0;
	    if (!$nametable{$1}) {
		$nametable{$1} = "$2: <undef>";
	    }
#	    push(@refs, $1);
	}
	elsif (/^fbody :/) {
	    &fetch();
	    @refs = keys %refs;
#	    print "return parse_body() = (@decls, @refs)\n";
	    return;
	}
	&fetch();
    }
}

sub parse_func {
#    print "parse_func()\n";

    $_ = $item;
    if (/^func (##\w+)/) {
	local($id) = $1;
	local($type, $name) = ("", "");
	local(@args) = ();
	$func_file{$id} = $file;

	&fetch();
	while ($_ = $item) {
	    if (/^(spec|qual) (\S+) :/) {
		$type .= $2;
	    }
	    elsif (/^ident \S+ :"(\S+)"/) {
		$name = $1;
		&fetch();
		last;
	    }
	    &fetch();
	}
	$nametable{$id} = "$name(): $type";

	while ($_ = $item) {
	    if (/^spec /) {
		push(@args, &parse_decl());
	    }
	    elsif (/^block /) {
		# first occurrence of block means begining of func body.
		last;
	    }
	}
	$func_args{$id} = join($;, @args);

	&parse_body();
	$func_decls{$id} = join($;, @decls);
	$func_refs{$id} = join($;, @refs);
	push(@funcs, $id);
    } else {
	die "Illegal call: parse_func()";
    }
}


sub localdate {
    $d = shift(@_);
    ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst)
	= localtime($d);

    $thisday = ("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat")[$wday];
    $month = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul",
	      "Aug", "Sep", "Oct", "Nov", "Dec")[$mon];

    return sprintf("%s %s %02d %02d:%02d:%02d 19%02d", 
	    $thisday, $month, $mday, $hour, $min, $sec, $year);
#    return "$thisday $month $mday $hour:$min:$sec $year";

}

sub modifiedtime {
    $f = shift(@_);

    local($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size,
     $atime, $mtime, $ctime, $blksize, $blocks) = stat($f);

    return &localdate($mtime);
}

sub username {
    local($name, $passwd, $uid, $gid, $quota, $comment, $gcos, $dir, $shell)
	= getpwuid($<);
    return $gcos if ($gcos);
    return $name;
}

# main

for (&fetch(); $_ = $item;) {
    if (/^spec /) {
	push(@gdecls, &parse_decl());
	next;
    }
    elsif (/^func ##/) {
	&parse_func();
	next;
    }
    elsif (/file (\S+)$/) {
	$file = $1;
    }
    &fetch();
}

foreach $id (@funcs) {
    foreach (split($;, $func_refs{$id})) {
#	print "test: nametable{$_} = $nametable{$_}\n";
	if ($nametable{$_} =~ /^\S+\(\)\s*:/) {
	    local(@caller) = split(/$;/, $func_caller{$_});
	    @caller = push(@caller, $id);
#	    print "test: $_, @caller\n";
	    $func_caller{$_} = join($;, @caller);
	}
    }
}



print <<'_HEAD_';
%
% Creator:              mkSpec.pl in |Sapid|
% CreationDate:         <not supported now>
%
\ifx\gtfam\undefined
\documentstyle[specmac3]{jarticle}
\else
\documentstyle[a4j,specmac3]{jarticle}
\fi
\begin{document}
_HEAD_


print "% [Global Declaration]:\n";
foreach (@gdecls) {
    print "%\t$nametable{$_}\n";
}
foreach $id (@funcs) {
    ($name, $type) = split(/:\s+/, $nametable{$id});
    $filename = $func_file{$id};
    $mtime = &modifiedtime($filename);
    $user = &username();
    print <<"_SPEC_";
  \\begin{specification}{$name}{$type}
    \\filename{$filename}
    \\firstproducedtime{$mtime}
    \\lastmodifiedtime{$mtime}
    \\manualauthor{$user}
_SPEC_
    # arguments
    foreach (split($;, $func_args{$id})) {
	($name, $type) = split(/:\s+/, $nametable{$_});
	print "    \\argument{$name}{$type}\n";
    }
    # Local Declaration
    foreach (split($;, $func_decls{$id})) {
	($name, $type) = split(/:\s+/, $nametable{$_});
	print "    \\localvar{$name}{$type}\n";
    }

    # References
    foreach (split($;, $func_refs{$id})) {
	($name, $type) = split(/:\s+/, $nametable{$_});
	if ($name =~ /^\S+\(\)$/) {
	    print "    \\calleefunc{$name}{$type}\n";
	}
	else {
	    print "    \\globalvar{$name}{$type}\n";
	}
    }
    # Caller]
    foreach (split($;, $func_caller{$id})) {
	($name, $type) = split(/:\s+/, $nametable{$_});
	print "\\callerfunc{$name}{$type}\n";
    }
    print "  \\end{specification}\n"
}

print "\\end{document}\n";
