#!/usr/local/bin/perl
#
# numHole.pl: numbers all holes and instructions which has text.
#
#   if you want to remove number of holes, use the option "-r".
#

while (@ARGV[0] =~ /^-/) {
    $_ = shift;
    if (/^-r$/) {		# remove hole number
	while (<>) {
	    if (/^(.* :)_#\d+(".*")$/) {
		$cmd = $1;
		$text = $2;
		$text =~ s/_#\d+/_#/g;
		print "$cmd$text\n";
	    } else {
		print;
	    }
	}
	exit;
    }
}

$_id = 0;
@txts = ();

sub new_id {
    return "_#". ++$_id;
}

while (<>) {
    if (/^(.*)\s:(".*")$/) {
	local($cmd) = $1;
	local($t) = $2;
	local(@part) = split(/_\#/, $t);
	local($top) = shift @part;
	local($n) = "";
	foreach (reverse @part) {
	    $n = pop(@txts) . $_ . $n;
	}
	$t = $top . $n;

	$t =~ s/\$\$/_\$/g;
	local($id) = &new_id();
	chop;
	print "$cmd :$id$t\n";
	push(@txts, $id);
    } else {
	print;
    }
}
