---------------------------> Sather 1.1 source file <--------------------------
-- txt.sml: TeXt Translator
-- Author: Yoshida Atsushi <yoshida@tutkie.tut.ac.jp>
-- Copyright (C) 1996, Yoshida Atsushi
-- $Id: txt.sml,v 1.1.1.1 2001/05/14 06:10:38 yoshida Exp $
--
-- COPYRIGHT NOTICE: This code is provided WITHOUT ANY WARRANTY
-- and is subject to the terms of the SATHER LIBRARY GENERAL PUBLIC
-- LICENSE contained in the file: Sather/Doc/License of the
-- Sather distribution. The license is also available from ICSI,
-- 1947 Center St., Suite 600, Berkeley CA 94704, USA.
-------------------------------------------------------------------
-- $Log: txt.sml,v $
-- Revision 1.1.1.1  2001/05/14 06:10:38  yoshida
-- Made StreamedSapid repository of CVS.
--
--
-- Revision 1.15  1998/11/27 07:45:55  yoshida
-- *** empty log message ***
--
-- Revision 1.14  1998/07/16 13:01:47  yoshida
-- *** empty log message ***
--
-- Revision 1.13  1998/07/14 16:07:42  yoshida
-- *** empty log message ***
--
-- Revision 1.12  1998/05/11 15:43:20  yoshida
-- *** empty log message ***
--
-- Revision 1.11  1998/05/11 15:06:45  yoshida
-- *** empty log message ***
--
-- Revision 1.10  1998/04/17 08:59:09  yoshida
-- *** empty log message ***
--
-------------------------------------------------------------------
class TXT is

   const hole_1st_char: CHAR := '_';
   const hole_2nd_char: CHAR := '#';
   const delimiter: STR := " :\"";  -- delimiter between instruction and template
   const id_head: CHAR := '#';
   const comment_head := '#';

   shared stack: A_STACK{FSTR};

   shared visible: BOOL;
   shared debug: BOOL;

   main(args: ARRAY{STR}): INT is
      stack := #;
      protect
	 in: FILE;
	 if args.size > 1 then
	    loop
	       a ::= args.elt!(1);
	       case a
	       when "-V" then
		  visible := true;
	       when "-d" then
		  debug := true;
	       else
		  in := FILE::open_for_read(a);
		  if in.error then
		     #ERR + "Error: can't open file '" + a + "'\n";
		     return 1;
		  end; -- if
		  construct(in);
		  in.close;
	       end; -- if
	    end; -- loop
	 end; -- if
	 if void(in) then
	    construct(FILE::stdin);
	 end; -- if
      when $STR then
	 #ERR + "StreamedSapid: Error: " + exception.str + "\n";
	 return 1;
      else
	 #ERR + "StreamedSapid: Error: unexpected error.\n";
	 return 2;
      end;  -- protect

      if ~debug then
	 loop
	    s ::= stack.reverse_elt!.str.reverse;
	    #OUT + s;
	    -- #OUT + s + "\n";
	    -- last newline is not necessary, only because of beauty 
	    -- of printing stmt list.
	 end; -- loop
      else
	 loop
	    s ::= stack.reverse_elt!.str.reverse;
	    #OUT + "%[" + s.pretty + "]%\n";
	 end; -- loop
      end; -- if
      return 0;
   end; -- main

   construct(in: FILE) is
      loop
	 until!(in.eof);
	 line ::= in.get_line;
	 if line[0] /= '#' then
	    eval(line.str);
	 end;  -- if
      end; -- loop
   end; -- construct

   eval(line: STR) is
      if debug then
	 #OUT + "DEBUG: eval() line = " + line + "\n";
      end; -- if
      temp: STR;
      beg ::= line.length - 1;
      loop  -- ignore the last double quote.
	 if beg < 0 then return end;
	 until!(line[beg] = '\"');
	 beg := beg - 1;
      end;  -- loop
      beg := beg - 1;
      loop
	 if beg <= 0 then return end;
	 until!(line[beg] = '\"' and line[beg - 1] = ':');
	 beg := beg - 1;
      end; -- loop
      assert beg >= 2 and line[beg - 2] = ' ';
      --      beg := beg + 2;
      --      beg ::= line.search(delimiter);
      --      loop
      --	 x ::= line.search(delimiter, beg + delimiter.length);
      --	 until!(x < 0);
      --	 beg := x;
      --      end;  -- loop
      --      if beg < 0 then return; end;
      --      beg := beg + 2;
      num ::= line.length - 1 - beg;
      if num > 0 then
	 temp := line.substring(beg, num).as_literal;
	 if debug then
	    #OUT + "DEBUG: eval() temp = " + temp + "\n";
	    #OUT + "DEBUG: eval() line.substr = " + line.substring(beg, num) + "\n";
	 end; -- if
      else
	 temp := "";
      end; -- if
      
      if visible then
	 if line.is_prefix("ident") or line.is_prefix("block") then
	    i ::= line.search(id_head);
	    j ::= i;
	    loop
	       until!(line[j] = ' ');
	       j := j + 1;
	    end; -- loop
	    id ::= line.substring(i, j - i);
	    temp := "/*" + id + "*/ " + temp;
	 end; -- if
      end; -- if

      res ::= #FSTR;
      ind ::= temp.length - 1;
      loop
	 while!(ind >= 0);
	 c ::= temp[ind];
	 if c = hole_2nd_char
		  and ind > 0 and temp[ind - 1] = hole_1st_char then
	    if stack.is_empty then
	       res.to_reverse;
	       #ERR + "DEBUG: res = " + res + "\n";
	       raise "empty stack\n";
	    end; -- if
	    e ::= stack.pop;
	    res := res + e;
	    ind := ind - 1;
	 else
	    res := res.push(c);
	 end; -- if
	 ind := ind - 1;
      end; -- loop
      stack.push(res);
   end; -- eval

end; -- class TXT
-------------------------------------------------------------------
